<?php
/**
	File name : cacheWriter.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	The main cache writing system :  cacheWriter::cache()
*/
class cacheWriter extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;		
		$this->rights= &$tagsFu->rights;		
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;
		
		$this->cacheR= &$tagsFu->cacheR;
		$this->cacheR->dtb= &$dtb;
		
		$this->allowCurPgCaching= true;		
	} // construct

	
	
	/**
		Actually a specialised function for forums! Other cases will have other methods
		to avoud too many parameters.
	*/
	function selectUrlVariables($fxCodeIdx=false,$rfxPage=false,$rfTGroupIdx=false){
		$curUrl= '';
		$curUrl.= $this->addUrlVarIfStr(_c_fxCodeIndx,$fxCodeIdx);
		$curUrl.= $this->addUrlVarIfStr(_c_rfxPage,$rfxPage);
		$curUrl.= $this->addUrlVarIfStr(_c_rfTGroupIdx,$rfTGroupIdx);
		return $curUrl;
	} // selectUrlVariables
	

	/**
	*/
	function addUrlVarIfStr($var,$val){
		$tools= &$this->tools;
		if ($val!==false){
			return $tools->addUrlVar($var,$val);
		}else{
			return '';
		}
	} // addUrlVarIfStr

	
	/**
		Writes the cache local constants (cacheConst.php).directly depending on the matching DTB variables.
	*/
	function writeCacheLocalConst($chgStatsUse= false){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
				
		$ersatztStr= $fls->fileToStr(_c_virginCacheDfn);
		
		$urlPgVar= $dtb->getGenVar('urlPageVar');
		$pwBxRequest= $dtb->getGenVar('pwBoxRequest');
		$defPg= $dtb->getGenVar('permanentDefPage');
		$guestReq= $dtb->getGenVar('pwBoxGuestReq');
		
		if ($chgStatsUse===false){
			$stats= _c_localStatsUseIt;
		}else{
			$stats= $chgStatsUse;
		}
		
		$searchV= array('pVarErsatzt', 'callPwErsatzt', 'defPgErsatzt', 'guestVarErsatzt','usesStatsErsatz', 
			'statsAvoidErsatz', 'rndIndexErsatz', 'uniqPfxErsatz', 'botScrErsatz', 'rndErsatzStatsSfx');
		$replaceV= array($urlPgVar, $pwBxRequest, $defPg, $guestReq, $stats, _c_statsAvoidUVar, _c_rndIndexStats, 
			_c_urlUniqEdtPfx, _c_jsBotsScary, _c_rndStatsDirNmSfx);
		$cacheCstStr= str_replace($searchV,$replaceV,$ersatztStr);
		
		$fls->strongStrToFile(_c_cacheConstantsDfn,$cacheCstStr);
	} // writeCacheLocalConst
	

	/**
		Just to test if the category of pages is cachable.
	*/
	function cacheIsPossiblyWritable($pg=false){
		$reader= &$this->cacheR;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$idZm= $tools->getVal(_c_idTextsZm);
		if ( $idZm!==false && $dtb->elementExists(_c_idTextKey, $idZm, _c_idTextsTbl, $idZm) ){
			return true;	// got a zoom (not analysed as a page name)
		}
 
 		if ($pg===false){
			$pg= $tools->curPageName();
		}
		
		return $reader->cachableCateg($pg);
	} // cacheIsPossiblyWritable

	
	/**
		Returns false if we can't cache the page and the full file path if we can.
		It's also a cacheWriter version of cache Reader::cacheCandidateDfn 
		specialised to be called by centrCl.php
	*/
	function cacheWrCandidateDfn(){
		$reader= &$this->cacheR;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$pwBR= $dtb->getGenVar('pwBoxRequest');
		if ($tools->gostVal($pwBR)!==false){
			return false;
		}
		
		if (!$this->allowCurPgCaching){
			return false;
		}
		
		$zoomId= $tools->getVal(_c_idTextsZm);		
		if ($zoomId===false){
			$b= $reader->realCachePN($okOrigPg);
			
			if ($b===false){
				return false;
			}
		}else{
			$b= '';
		}
		
		$xP= $tools->getVal(_c_fxCodeIndx);		// xpetal simple post
		$xT= $tools->getVal(_c_rfxPage);		// xpetal post threadid
		$postGrpId= $tools->getVal(_c_rfTGroupIdx);		// id of the group of post threads
		$spMode= $tools->getVal(_c_smartPhoneMode);
		
		
		$buffFinal= $b.$reader->packFileSuffx($xP,$xT,$postGrpId);
		if ($spMode===_c_ok){
			$buffTestDB= $b.$reader->packFileSuffx($xP,$xT,$postGrpId,'jump');
		}else{
			$buffTestDB= $buffFinal;	// desk top mode
		}
		
		
		if ( $xP!==false || $xT!==false || $postGrpId!==false ){
			if ($postGrpId!==false){
				if (!$dtb->elementExists(_c_fumTrLstId, $buffTestDB, _c_fumThreadList)){
					return false;	// the page does not exists
				}
			}else{
				// dealing with _c_fumXCode table
				if (!$dtb->elementExists(_c_fumXmlId, $buffTestDB, _c_fumXCode)){
					return false;	// the page does not exists
				}
			}
		}
		
		return $reader->mainFlStr($buffFinal);
	} // cacheWrCandidateDfn
	
	
	/**
		This method delete concerned caches.FROM A FORUM CONTEXT
		Input :
			$forcedPg ; the forced page.
			$fileSffxPack : the concerned suffix pack to access the correct file, given without its most left hyphen.
	*/
	function delConcernedCache($forcedPg=false, $fileSffxPack=false){
		$reader= &$this->cacheR;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ( !$this->allowToWrite() ){
			return false;
		}
		
		if ($forcedPg===false){
			$pg= $tools->curPageName();		
		}else{
			$pg= $forcedPg;
		}
		
		if ($fileSffxPack!==false && $fileSffxPack!==''){
			$fileSffxPack= '-'.$fileSffxPack;
		}
		

		$dfn= $reader->cacheCandidateDfn($pg,$fileSffxPack, 'jump');	// No Smart phone case
		$fls->secUnlink($dfn); // Must do it BEFORE file_get_contents() otherwise it just reads the cache!!
		
		$dfnSmartPh= $reader->cacheCandidateDfn($pg,$fileSffxPack, true);	// Impose Smart phone case
		$fls->secUnlink($dfnSmartPh); // Must do it BEFORE file_get_contents() ...
		
		return $dfn;	// returns the DFN for checking purposes
	} // delConcernedCache	
	
	/**
		Return true if we are allowed to write inside the cache.
	*/
	function allowToWrite(){
		$dtb= &$this->dtb;
		return _c_allowCache && $dtb->getGenVar('acceptPgCacheWriting')===_c_ok && file_exists(_c_cacheConstantsDfn);
	} // allowToWrite

	/**
		Voluntary passed by value to avoid cluttering standard output with the lambda cache.
	*/
	function debugMark(&$curStr){
		return str_replace('<title>','<title> This is a CACHE ....',$curStr);
	} // debugMark
	
} // cacheWriter
?>