<?php
/**
	File name : globVar.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To store some multiclass global variables and keep close check at them.
	Probably for user interface, so variable from Post or Get can get a straight forward access.
	
	Disactivated :
		function getLspTotStr(...)
*/
class globVar extends oTop{
	

	function __construct(){
		parent::__construct();
		
		$this->globalJsCode= '';
		$this->glbEndJsCode= '';
		$this->addGlobJsFile= '';
		$this->addGlobCssFile= '';
		$this->anyCodeInHeader= '';
		
		$this->popupErrors= '';
		$this->popFumErrors= '';
		$this->popupHelp= '';
		$this->allowsSqlErrors= true;
		$this->flagUpdateHashRecord= false;			
		
		
		$this->tagRestrictFlag=_c_ko;
		
		$this->stdMenuBeenCalculated= false;
		$this->gotActStopSmplSurf= false;	// set to true if we got an active 	tg_stopsmplsurf()
		$this->cndtWrRghts= _c_unspecified;	// Default conditional writing rights. Note _c_unspecified will NEVER just be equzivalent to true or false
		
		define('_c_genId','id');

		/**
			A table for the translation at webmaster and user (normal/forum) level sentences present inside the php code. 
			Rem : the English version is the base sentence always present inside the code.
		*/
		
		// Code Translation table name (going to changem, see languageEvolution in blackBoard.php)
		// For most identifier we try to limit the key on 4 chars : kxxx where k is there for visual recognition
		define('_c_CodeTransTbl','codeTrans');
		define('_c_CodeTransSwapTbl','codeTransSwap');
			define('_c_GenTransId',_c_genId);	
			define('_c_GenTransEn','en');
			define('_c_GenTransW','langW');
			define('_c_GenTransX','langX');
			define('_c_GenTransY','langY');
			define('_c_GenTransZ','langZ');
			define('_c_GenTransCom','comment');
		
			
		/**
			Grouped definition of the table constant names that need an explicit updating when upgrading Ataox
		*/	
		define('_c_pwKeepTN','pwKeeperTbl');
		define('_c_fumUsrMessTN','fUsrMess');
		define('_c_fumHashTbl','forumHash');
		define('_c_forumPostsTbl','forumPosts');
		define('_c_forumPgRe','fumPgRepos');
		define('_c_fumSchedTN','fumSched');
		define('_c_fumThrdAttribTN','fumThrdAttrib');
		define('_c_fumThrdGrpAcsTN','fumThrdGrpAcs');
		define('_c_fumThreadList','fumThreads');
		define('_c_fumXCode','fumXCode');
		define('_c_fumXCdLim','fumXLim');
		define('_c_wnslTbl','wnslTbl');
		
			
		define('_c_fmwMailClientAddr','fmwMailClntAddr');	// For the client mail address box definition (forum and contact form)
		
			
			
		/**
			Strategy : ids of this table are not in huge number in the code because most of the translation at destination of
			all users are directly embedded into the pages. Also these ids must be easy to manipulate by any webmaster, because manby
			will have to customize the translations to their own languages, therefore we choose to :
			
				- Have variable with semantically significant names (opposed to the _c_CodeTransTbl style which is :
												- as short as possible to maximize php code readability, make the 
												creation process automatic, leave the context marking to the abreviated 
												English sentence.)
				- Have a single translation language wehre a language suffix does the language distinction.
				- For easier distinction of this category of record ids, they :
					- all start with ks_  (Konstant (german) surf + visual separator)
					- have a moderatléy long middle sugnificatuve string
					- have a language suffix matching the ones given under genVar::possibleSurfLang
							!! languages suffixes larger than 4 chars could pass the maximum tested length of the Id field,
							so should test at the input level that suffixes do not pass 4 chars (screen later appearance can
							be much more)
							---> ks_inputTooShort_fr
		*/	
		define('_c_SurfTransTN','surfTrans');
			define('_c_srfTransId',_c_genId);	// table Id
			define('_c_srfTrans','trans');		// storage of the appropriate translation
			define('_c_srfRem','rem');		// remark
			
			
				
		
		$this->incrBkpIsOk= false;	// ok to do incremental backup
		
		
		define('_c_edtLang','edtLang');	// url variable
		
		/* 
			The language defined inside the code and appearing on the screen if 
				$dtb->getGenVar('forceHardCodedLg')===_c_ok
			or if the database english translation is empty (normal from small sentences, don't want to store it twice + concept of smart data code separation)
		*/
		define('_c_justInCodeLg','en');	// obviously can't chage it to another language because the string are hard coded in many places
		
		
		/*
			So now the recovery becomes null by default, so don't have to bother anymore with most of
			$this->stopRecv() and $this->prevRecv() (so can cancel all the one of the forum !!!)
			But WILL HAVE TO SPECIFY a startRecov() when recovery is necessary (only the main page
			interface)
		*/
		$this->recovOk= false;	// ok to do the undo / redo recovery
		
		$this->recoVectOk= array(true,true);	// initialise the recovery state checking vector.
		$this->incrBkpVectOk= array(true,true);	// initialise the incremental state checking vector.
		
		
		$this->sortOfMenus= 'def';	// default/standard
		$this->forceSrfMenuVisibility= false;
		$this->comonTime= false;
		$this->lspTotStr= '';
		
		define('_c_daySeconds', 24*3600);
		
		$this->includedJsFv= array();
		$this->globCnt= 0;
		$this->curGPostId= false;
		
		// isSpiderFrienly
		$this->isSpiderFrienly= true; // For the tag [a .. /]
		$this->isFumSpiderFrienly= false; // Used in forum::tg_listedusers(..) nofollow avoidance.
		
		$this->webmasterXRights= false;	// Vector of rights not loaded at that stage!
		
		$this->bufferedCurLg= false;
		$this->pgNbOfDynEmot= false;
		$this->inhibUniqEdtPfx= false;
		$this->forceHdCodedLang='?';
		$this->globWatchNSQ= false;		// Non SQL Sensitive --> Got to set it to true if the plugin does some modification we want to take in account with a non Sql database case		
		
		$this->gotHieraMenChildren= false;
		
		$this->errorOkToDisplay= true;	// partial
				
		define('_c_dbSep','::');		// separator between to logically related localisation element most general the leftest
		
		$this->countFormLbl= -1;	
		$this->guestDsplMess= '';
		$this->countGuestDspl= 0;
		
		$this->curGlobEditLg=false;
		$this->isaDefinedLang= 'V';	// // virgin state --> got to be determined
		
		$this->frcHardCdLg= false;
		
		$this->jsCapsulOff();
		
		$this->menButAttribV = array('pg','urlsup','dominanturl','editonly','hidebutton','clsin','clsout','in','out','conthid','fold','follow');
		
		$this->pageLevel= array();	
		
		$this->genFumXRghtV= array();
		
		$this->forumCurLogUserId= _c_userNoRight;
		
		$this->allowebSmartPhParagrIds= array();
		
		$this->tagOnlyOnce= array();	
		$this->menuElemOnlyOnce= array();	
	} // construct
	
		
	/**
		Add a supplementary style if the standard menu was parsed
	*/
	function supStyleForMenus(){
		$dtb= &$this->dtb;
		if ($this->stdMenuBeenCalculated){
			$deco= $dtb->getGenVar('decoForActiveMenus');
			if ($deco!==false && $deco!==''){
				return $deco;
			}
		}
		return '';
	} // supStyleForMenus
	
	
	function loadAcc(&$acc){
		$this->acc= &$acc;
	} // loadAcc
	
	function loadCaps(&$caps){
		$this->caps= &$caps;
	} // loadCaps

	function loadTools(&$tools){
		$this->tools= &$tools;
	} // loadTools

	function loadDtb(&$dtb){
		$this->dtb= &$dtb;
		$this->loadChgblDtb($dtb);
	} // loadDtb

	function loadRight(&$rgt){
		$this->rgt= &$rgt;
	} // loadRight

	function loadTagsFu(&$tagsFu){
		$this->tagsFu= &$tagsFu;
		$this->wmRights= &$tagsFu->wmRights;
	} // loadTagsFu


	/** 
		Loads the changeable (only for writing) database. 
	*/
	function loadChgblDtb(&$dtb){
		$this->dtbChg= &$dtb;	// changeable database. so can assign whatever data base we want on that pointer
	} // loadChgblDtb
	
	
	/*	------------------------------------------------------------------
			Translation methods 
	--------------------------------------------------------------------- */
	
	
	/**
		Editor  language transLation. Principles : shorter Englih messages appear litterally in the code, 
		longuer with their first starting words so we can do direct code search.
			Input :
				$englStr : the base English sentence, appearing fully or partially in the code.
				$id : database Id to access the translation
			Output :
				return the sentence translated into the current EDITING language.
	*/
	function el($englStr,$id=false, $useHQ=true){
		if ($id===false) return $englStr;
		return $this->getBestCodeTranslation($id, $this->edtLg(), $englStr, $useHQ);
	} // el
	

	/**
		el() or sl() depending on the context
	*/
	function es($englStr,$id=false, $useHQ=true){
		$rgt= &$this->rgt;
		if ($id===false) return $englStr;
		
		if ( $rgt->quickWMRight() ){
			return $this->el($englStr,$id, $useHQ);
		}else{
			return $this->sl($englStr,$id, $useHQ);
		}
	} // es

	
	/**
		Like sl() but not forcing the Html code! Now indispensable for some part like email title where Html characters are not
		interpreted, but soo generalised everywhere when pure Html coding will be complerly redondant !!
	*/
	function s($englStr,$id=false){
		return $this->coreSl($englStr,$id,false,false);
	} // s

	/**
		Surf Language translation to insert easily in the code. --> A short function to have a quick code acess 
		to the Surf Language translation. Uses the table row of surfTrans if available or _c_CodeTransTbl
		or $englStr in that order depending on their availability.
				
		Input ;
			$englStr : English string appearing directly in the code (to have codes easier to program).
			$id : unique Id to get the correct translation from the DTB (if not given just take $englStr)
	*/
	function sl($englStr,$id=false, $useHQ=true){
		return $this->coreSl($englStr,$id, $useHQ);
	} // sl
	
	
	/**
		Input : ($englStr, $id
			$useHQ : uses Html code for quote
			$useHT : uses Html code for accentuated characters and does not appply $useHQ (so should pass it concentionnally at false)
	*/
	function coreSl($englStr, $id=false, $useHQ=true,$useHT=true){
		$acc= &$this->acc;
		$cSL= $this->curSurfLg();
		return $this->flexTrans($cSL,$englStr,$id, $useHQ,$useHT);
	} // coreSl
	

	/**
		A very flexible translation approach with a parameter specified language. 
			1) Try the surf translation (user personal definition)
			2) Try the standard code translation
			
		Input :
			$gLg : given language
			$englStr : rescue string! Should be set at false if we want to check the main codeTrans table instead.
			$id : unique prefix Id for the familly of activated languages.
			$useHQ : uses Html code for quote
			$useHT : uses Html code for accentuated characters and does not appply $useHQ (so should pass it concentionnally at false)
	*/
	function flexTrans($gLg,$englStr, $id=false, $useHQ=true,$useHT=true){
		$acc= &$this->acc;

		if ($id!==false){
			// Get the best translation from the table _c_SurfTransTN.
			$surfTransResult= $this->st(false,$id,$gLg,$useHQ);	// $englStr <-- false is normal because codeTrans table is used!
			if ($surfTransResult===false){
				
				// Get the best translation from the table _c_CodeTransTbl
				return $this->getBestCodeTranslation($id, $gLg, $englStr, $useHQ,$useHT);	// n getBestCodeTranslation
			}
			$englStr= $surfTransResult;
		}
		
		if ($useHT){
			return $acc->toHtmlCode($englStr,$useHQ);
		}else{
			return $englStr;
		}
	} // flexTrans
	
	
	
	
	/**
		Returns the available surf translation (table _c_SurfTransTN) or the English translation.
		Input :
			$englStr : rescue string! Should be set at false if we want to check the main codeTrans table instead.
			$id : unique prefix Id for the familly of activated languages.
			$lg, $useHQ.
		Output :
			The stored string in the current language and if not available the database stored English striong
	*/
	function st($englStr,$id,$lg=false, $useHQ=true){
		$acc= &$this->acc;
		$dtb= &$this->dtb;
		
		if ($lg===false){
			$lg= $this->curSurfLg();
		}
		
		$stId= $id.'_'.$lg;	// surf translation Id
		$elem= $dtb->getElem(_c_SurfTransTN, _c_srfTransId, $stId , _c_srfTrans);
		if ($elem===false){
			$stId= $id.'_en';	// always accessible by design!
			$elem= $dtb->getElem(_c_SurfTransTN, _c_srfTransId, $stId , _c_srfTrans);
			if ($elem===false){
				$elem= $englStr;  // recup if the 1st record was not accessible after all!
			}
		}
		
		return $acc->toHtmlCode($elem,$useHQ);
	} // st	
	
	
	/**
		In a tag context, chooses the given one among the 3 possibilities : el, sl, es and RETURNS THE  DATABASE STORED STRING or the default string if nothing is defined.
		
		Inoput: $v : parameter vector; $enStr : default english string; $s : suffix to add as many 'sl','el','es' groups as we wish
			$useHQ : true if we use Html double quote conversion
		
		Explanations on how to ACCESS the translation table _c_CodeTransTbl
			sl : uses the surf languages
			el : uses the edition languages
			es : edition or surf language, with the edition language being dominant when a webmaster is logged!
	*/
	function choosEsl(&$v,$enStr, $s='', $useHQ=true){
		if ( $this->kExistVal('sl'.$s,$v) ){
			$tStr= $this->coreSl($enStr,$v['sl'.$s], $useHQ);
		}else if( $this->kExistVal('el'.$s,$v) ){
			$tStr= $this->el($enStr, $v['el'.$s], $useHQ);
		}else if( $this->kExistVal('es'.$s,$v) ){
			$tStr= $this->es($enStr, $v['es'.$s], $useHQ);
		}else{
			$tStr= $enStr;
		}
		return $tStr;
	} // choosEsl			
	
	
	/**
		Get the best code translation, so get the translation if it exists otherwise returns the English sentence.
		Input:
			$id : the id of the element to translate
				Remark 'bid' is used when we don't have the time to work on a tranlation, may work on it later
				and up to then English is used everywhere.
			$curLang : the "current" labguage being applied.
			$gStr : a reserve string (mainly specified directly in the code for clarity purpose) if the id does not exist
			$useHQ : uses Html code for quote
			$useHT : uses Html code for accentuated characters and does not appply $useHQ (so should pass it concentionnally at false)
			$prfx : a prefix string to be added to the final result (special case : fixes annoying need of newlines in front of independant paragraphs at building time)
	*/
	function getBestCodeTranslation($id, $curLang, &$gStr, $useHQ=true,$useHT=true,$prfx=''){
		$acc= &$this->acc;
		$dtb= &$this->dtb;
		
		if ($id!==false && $id!=='bid' && !$this->hardCodedLang()){
			$cfLg= $this->lgAbrevToLgField($curLang);
			$tStr= $dtb->getElem(_c_CodeTransTbl, _c_GenTransId,$id, $cfLg);
			
			if ($tStr===false || $tStr===''){
				$tStr= $dtb->getElem(_c_CodeTransTbl, _c_GenTransId,$id, _c_transMasterLg);
				if ($tStr===false || $tStr===''){
					$tStr= $gStr;
				}
			}
			
			
		}else{
			$tStr= $gStr;
		}
		
		if ($prfx!==''){
			$tStr= $prfx.$tStr;
		}
		
		if ($useHT){
			return $acc->toHtmlCode($tStr,$useHQ);
		}else{
			return $tStr;
		}
	} // getBestCodeTranslation


	/**
		Standard Ataox languages abreviation to language field.
	*/
	function lgAbrevToLgField($lg){
		if (array_key_exists($lg,$this->activeLgFieldV)){
			return $this->activeLgFieldV[$lg];
		}else{
			return _c_transMasterLg;
		}
	} // lgAbrevToLgField
	
	/**
		Returns the current language used for edition. Priority on the Url definition, then the database default languiage.
	*/
	function edtLg(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		if ($this->curGlobEditLg!==false){
			return $this->curGlobEditLg;
		}

		$lg= $tools->getVal(_c_edtLang);
		if (!$this->isaDefinedLg($lg)){
			$lg= $dtb->getGenVar('editionDefLanguage');
			if ($lg==='ersatzEditionDefLanguage'){
				$lg= 'en';
			}
		}
		
		$this->curGlobEditLg= $lg;
		return $lg;
	} // edtLg


	/**
		Returns the editing or surf language deoending on the loggin state
	*/
	function esLg(){
		$rgt= &$this->rgt;
		if ( $rgt->quickWMRight() ){
			return $this->edtLg();
		}else{
			return $this->curSurfLg();
		}
	} // esLg
	
	
	/**
		Returns true if the key $k exists inside the array $v and the value $v[$k] is not false, in a X paramater context
		it means that the key is defined and internally loaded (so mostly with a correct value).
	*/
	function kExistVal($k,&$v){
		 return array_key_exists($k,$v) && $v[$k]!==false;
	} // kExistVal
	
	
	/**
		Set a marker $this->frcHardCdLg to memorize the fact that we are inside
		a hard coded language mode! .. Eventually to force some language functions 
		for a special behavior.
	*/
	function hardCodedLang(){
		$dtb= &$this->dtb;
		if ($this->frcHardCdLg===false){
			$this->frcHardCdLg= $dtb->getGenVar('forceHardCodedLg');
		}
		return $this->frcHardCdLg===_c_ok;	// so got to use $dtb->getGenVar() only once !
	} // hardCodedLang

	/**
		Current surf language, extracted directly from the page table polyglotPN
			- Current language of the current page without any other elements, but if ...
				- If we have a mother page (forum) : takes the language of the mother page.
				- Uses a global variable to short circuit the process, so it's the same language on 
				  the whole page without more calculation.
	*/
	function curSurfLg(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$pg= $tools->gostVal(_c_mothrPage);	 // _c_fMotherPage  !! Keep the constant inside the forum folder
		if ($pg===false){
			$pg= $tools->curPageName();
		}
		
		
		if ($this->gotActStopSmplSurf){
			$pg= _c_mainHomePage;
		}else{
			if (!$dtb->elementExists(_c_pcId, $pg, _c_PolyCellPg)){
				if ($dtb->getElem(_c_PolyCellPg, _c_pcId,$pg, _c_pcType)===_c_pcTypAny){
					// the language is not defined in $pg, so takes the main home page for language model
					$pg= _c_mainHomePage;
				}
			}
		}
		
		
		if ($this->bufferedCurLg===false){
			$this->bufferedCurLg= $dtb->currentLg($pg);
		}
		return $this->bufferedCurLg;
	} // curSurfLg

	/**
		Adds a Webmaster and forum-user errors going to be displayed inside a top band (pop-up is the old intention)
		$glob->userError();
	*/
	function userError($error,$polyCode=false,$gotBrFlux=true){
		if ($gotBrFlux){
			$endLn= _c_BrFlux;
		}else{
			$endLn= '';
		}
		
		if ($this->errorOkToDisplay){
			if ($polyCode===false){
				$this->popupErrors.= $error.$endLn;
			}else{
				// $polyCode is loaded
				$this->popupErrors.= $this->el($error,$polyCode).$endLn;
			}
		}
	} // userError
	
	function userHelp($help){
		$this->popupHelp.= $help._c_;
	} // userHelp	
	
	/**
		Return the final collection of errors and help messages
	*/
	function returnUserMess(){
		$caps= &$this->caps;
	
		$popErr= $this->popupErrors;
		if ($popErr!==''){
			$popErr= $caps->span( $this->el('Error : ','katw').$popErr,'userError');
		}
		
		$popHelp= $this->popupHelp;			
		if ($popHelp!==''){
			$popHelp= $caps->span( $this->el('Help : ','katx').$popHelp,'userHelp');
		}
	
		$totErr= $popErr.$popHelp;
		if ($totErr!==''){
			// frame it
			$totErr= $caps->sDiv($totErr,' width:1100px; padding:5px; margin:5px; border:5px solid red; float:left;');
			
		}
		
		return $totErr;
	} // returnUserMess
	
	
	/**
	*/
	function popupUsrErr(){
		return $this->popupErrors;
	} // popupUsrErr


	/**
		"Forum user error" --> the logged user should be able to see it to correct its tags.
	*/
	function fumserError($error){
		$this->popFumErrors.= $error._c_;
	} // fumserError	
	
	function getFumserErr(){
		$caps= &$this->caps;
		return $this->popFumErrors;
	} // getFumserErr
	
	function gotFumserErr(){
		return $this->popFumErrors!=='';
	} // gotFumserErr
	
	
	/**
		Inclusion of global javascript code just before the <body> tag. The sort of code that changes 
		for every page or every site and because of that is not practical to define in external Js files.
	*/
	function setGlobJsCode($jsAddition){
		$this->globalJsCode.= $jsAddition;
	} // setGlobJsCode
	
	
	/**
		The head of the head !!!
	*/
	function setHeadGlobJsCd($jsAddition){
		$this->globalJsCode= $jsAddition.$this->globalJsCode;		// set the code right ahead for early execution
	} // setHeadGlobJsCd
	
	/**
	*/
	function getGlobJsCode(){
		return $this->globalJsCode;
	} // getGlobJsCode
	
	/**
		Inclusion of global javascript at the end of the html code, so can access all widgets.
	*/
	function setGlbEndJsCode($jsAddition){
		$this->glbEndJsCode.= $jsAddition;
	} // setGlbEndJsCode

	/**
		Could be interesting to compare it with onload() function! Eventually convert it!
	*/
	function getGlbEndJsCode(){
		return $this->glbEndJsCode;
	} // getGlbEndJsCode

	/**
		Inclusion of a new javascript file. Used with a setExplJs tag.
		Rem : does the inclusion only if it was not done before!
		
		May be SOON DEPRECATED !!!! replaced with inclStanceJs()
	*/
	function addJsFile($pathJS){
		$caps= &$this->caps;
		$this->addGlobJsFile.= $caps->script($pathJS)._c_R;	
	} // addJsFile
	
	/**
		Include and Instanciate the given javasctipt class (path is straight forward)
		Input :
			$jsPath : path given with the terminal /
			$jsFileN : the simple Js file name without path and without its .js extension!
			
			$instanceName : used only for non standard case
			$className : used only for non standard case
	*/
	function coreInclStanceJs($jsPath,$jsFileN, $instanceName=false,$className=false){
		$caps= &$this->caps;
		
		$jsPFN= $jsPath.$jsFileN;
		if (!array_key_exists($jsPFN, $this->includedJsFv)){
			$jsExtPFN= $jsPFN.'.js';	// with extension
			
			$this->addGlobJsFile.= $caps->script($jsExtPFN)._c_R;
			
			if ($instanceName===false){
				$this->setGlobJsCode( $caps->instanceJs($jsFileN) );
			}else{
				$this->setGlobJsCode( $caps->instanceJs($instanceName,$className) );
			}
			
			$this->includedJsFv[$jsPFN]= _c_ok;
		}
	} // coreInclStanceJs
	
	/**
		Include and Instanciate the given javasctipt class (the path is suffixed internally with the class name)
		Standard case with
	*/
	function sffxInclStanceJs($jsPath,$jsFN){
		$this->coreInclStanceJs($jsPath.$jsFN.'/', $jsFN);
	} // sffxInclStanceJs	
	
	/**
		Standard suffixed Explicit Central.
	*/
	function explCentralInclStanceJs($jsFN){
		$this->sffxInclStanceJs(_c_toDeclPlugCntr, $jsFN);
	} // explCentralInclStanceJs
	
	/**
		Standard suffixed Explicit External.
	*/
	function explExternInclStanceJs($jsFN){
		$this->sffxInclStanceJs(_c_toDeclPlugExt, $jsFN);
	} // explExternInclStanceJs
		
		
	function getAddedJsF(){
		return $this->addGlobJsFile;
	} // getAddedJsF
	

	/**
		Inclusion of a new Css file.
	*/
	function addCssFile($pathCss,$fullUrlPrfx=''){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		if ($pathCss!==null){
			if ($fullUrlPrfx===''){
				if ($tools->getVal('pushFullPath')==='ok'){	// pushFullPath got the priority on an empty $fullUrlPrfx
					$fullUrlPrfx= _c_siteUrlAccess;
				}
			}
			
			$this->addGlobCssFile.= $caps->cssCaps($pathCss,$fullUrlPrfx);
		}
	} // addCssFile
	
	/**
		Give a plugin css path for a user directory definition!
	*/
	function cssPath($plugName,$external=true){
		if ($external){
			return _c_decPlugSupCssE.$plugName.'/'.$plugName.'.css';
		}else{
			return _c_decPlugSupCssC.$plugName.'/'.$plugName.'.css';
		}
	} // cssPath
	
	/**
		Give a plugin css path for a central CODE DIRECTORY definition!
	*/
	function codeCssPath($plugName,$external=true){
		if ($external){
			return _c_toDeclPlugExt.$plugName.'/'.$plugName.'.css';
		}else{
			return _c_toDeclPlugCntr.$plugName.'/'.$plugName.'.css';
		}
	} // codeCssPath
	
		
	function getAddedCssF(){
		return $this->addGlobCssFile;
	} // getAddedCssF
	

	/**
		Visibilize an invisible variabée value.
	*/
	function viz($a){
		return gettype($a);
	} // viz
	

	/**
		Loads the translatable language abreviation into the vector $this->mainTransLgVect
	*/
	function loadsTranslatLg(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
	
		$lgList= $dtb->getGenVar('activatedLanguageList');
		$this->mainTransLgVect= $tools->trimStrToV($lgList);
		
		$lgFnL= $dtb->getGenVar('activatedLgFieldNmList');
		$this->mainTransLgFldV= $tools->trimStrToV($lgFnL);
		
		$this->activeLgFieldV= array_combine($this->mainTransLgVect,$this->mainTransLgFldV);
	} // loadsTranslatLg
	
	
	/**
		Returns true if the language is defined.
	*/
	function isaDefinedLg($lg){
		return in_array($lg,$this->mainTransLgVect);
	} // isaDefinedLg


	/**
	*/
	function loadsMediaMgPt(&$mmPt){
		$this->mediaMgPt= &$mmPt;
	} // loadsMediaMgPt


	/**
		Returns true if the recovery functions are set to true.
	*/
	function recvOk(){
		return $this->recovOk;
	} // recvOk

	/**
		Returns true if the incremental backups are set to true.
	*/
	function iBkpIsOk(){
		return $this->incrBkpIsOk;
	} // iBkpIsOk
	

	/* ---------------------------------------------------------------
		Recovery table Undo / Redo (access rights)
	*/

	/**
	*/
	function startRecv(){
		array_push ($this->recoVectOk,$this->recovOk);	// saves actual state
		$this->recovOk= true;
	} // startRecv

	/**
		Get back the previous record state. Should always use that function at the end of a couple 
		stop/start.
	*/
	function prevRecv(){
		$this->recovOk= array_pop ($this->recoVectOk);
	} // prevRecv


	/**
		Became the default situation : recovery is stopped by default so don't have to stop it explicitelly
		!!! Only used once in textEditor.php
	*/
	function stopRecv(){
		array_push ($this->recoVectOk,$this->recovOk);	// saves actual state
		$this->recovOk= false;
	} // stopRecv


	/* -------------------------------------------------------
	*/
	function stopAllRecov(){
		$this->stopIBkp();
		$this->stopRecv();
	} // stopAllRecov

	/**
	*/
	function prevAllRecov(){
		$this->prevRecv();
		$this->prevIBkp();
	} // prevAllRecov


	/* ---------------------------------------------------------------
		Incremental back-up table access rights.
		
			// this function may be necessary sometimes, so keep it !!
			function startIBkp(){
				array_push ($this->incrBkpVectOk,$this->incrBkpIsOk);	
				$this->incrBkpIsOk= true;
			} // startIBkp
	*/
	
	/**
	*/
	function stopIBkp(){
		array_push ($this->incrBkpVectOk,$this->incrBkpIsOk);	// saves actual state
		$this->incrBkpIsOk= false;
	} // stopIBkp

	/**
		Get back the previous record state. Should always use that function at the end of a couple 
		stop/start.
	*/
	function prevIBkp(){
		$this->incrBkpIsOk= array_pop ($this->incrBkpVectOk);
	} // prevIBkp
	

	/**
		Methods to manage some time parameters :
			http://www.php.net/manual/en/function.date.php
	*/
		
	/**
		A common current time to avoid time singularities (unlickely clumping in 2 basic units).
	*/	
	function getCommonTime(){
		if ($this->comonTime===false){
			$this->comonTime= time();
		}
		return $this->comonTime;
	} // getCommonTime


	/**
		Get the actual day, returns a string.
		
		Input :
			$this->comonTime
			$offset : days (default) offset
			
		Rem : $offsetDays everywhere because easier to synchronize these functions.
	*/
	function getDay($offset=0,$fact=_c_daySeconds){
		$t= $this->getCommonTime() + $offset*$fact;
		return date('j',$t);
	} // getDay
	
	/**
		Get the actual month, returns the English word.
		Input :
			$this->comonTime
			$offsetDays : days offset
	*/
	function getMonth($offset=0,$fact=_c_daySeconds){
		$t= $this->getCommonTime() + $offset*$fact;
		return date('F',$t);
	} // getMonth
	
	function getNumMonth($offset=0,$fact=_c_daySeconds){
		$t= $this->getCommonTime() + $offset*$fact;
		return date('n',$t);
	} // getNumMonth
	
	
	/**
		Get the actual year, returns a string.
		Input :
			$this->comonTime
			$offsetDays : days offset
	*/
	function getYear($offset=0,$fact=_c_daySeconds){
		$t= $this->getCommonTime() + $offset*$fact;
		return date('Y',$t);
	} // getYear
	
	
	/**
		Three functions just to parse faster when we don't have any tag restrictions.
	*/
	function tagRestriction(){
		return $this->tagRestrictFlag===_c_ok;
	} // tagRestriction
	
	function tagRstrct(){
		$this->tagRestrictFlag= _c_ok;
	} // tagRstrct
	
	function tagUnRstrct(){
		$this->tagRestrictFlag= _c_ko;
	} // tagUnRstrct
	
	
	/**
		Tags allowed for the forum users
		Note : the tg_page tag is not allowed so we don't need to do the noFollow test etc. on it too
		
		Remark : could add again the [z /] zoom tag inside this list if necessary but would need to be very careful
		about width (deprecated) and style definition, so sjould use the same strategy than tg_i() and tg_j() where
		[j ... /] got more rights than [i ... /] and is only usable with WM rights!
	*/
	function tagAllowed($tag){
		$tags= array('a','rem','code','bf','br','b','ul','ol','li','nsp','u','itc',
			'sentence','lt','gt','lb','rb','flot','icon','ic','bookmark','jumptobm',
			'email','i','imgpath','zpath','zbigimg',
			'nop','emot','gmot','deficondir','emo','dmo','badtag');
		return in_array($tag,$tags);
	} // tagAllowed
	
	
	/**
		Define a LATE STAGE SCREEN PRINTING to debug while dodging cookies!
			CAll :
				$glob->lsp();
	*/
	function lsp(&$var,$mess='',$directPrint=false){
		$t= gettype($var);
	
		$prfx=  '('.$t.')';
		$b= '';
		switch ($t){
			// Can be directly added to the string (automatical string conversion)
			case 'integer':
			case 'double':
			case 'string':
				$b.= $prfx.$mess.$var._c_;
			break;
			
			
			case 'boolean':
				if ($var===true){
					$b.= $prfx.$mess.'true'._c_;
				}else{
					$b.= $prfx.$mess.'false'._c_;
				}
			break;
			
			case 'array':
				$this->nVctStrPrevIdx= '';
				$this->nVctStrVal= '';
				reset($var);	// so sure to be on the start
				$this->nVectStr($var);
				$b.= $mess._c_.$this->nVctStrVal._c_;
				reset($var);	// so does not interfer with start assuming functions
			break;
		
		
			// Can't convert into a string
			case 'object':
				$b.= $mess.$t.' : '.get_class($var)._c_;
			break;
			
			
			case 'NULL':
				$b.= $mess.$t._c_;
			break;
			
			
			case 'resource':
				$b.= $mess.$t._c_;
			break;
			
			
			// 	Unknown behavior when converted to a string, tries anyway with the type as a prefix.	
			case 'unknown type':
				$b.= $mess.$t.$var._c_;
			break;
			
			default:
				$b.= 'Type error in globVar::lsp'._c_;
		} // switch
		
		if ($directPrint){
			print($b);
		}else{
			$this->lspTotStr.= $b;
		}
	} // lsp
	
	/**
		Like lsp(), but display constants of any types.
			CAll :
				$glob->lspC();
	*/
	function lspC($const,$mess=''){
		$this->lsp($const);
	} // lspC
	
	/**
		WARNING : not use for a while, so disactivated, to re-activate it, see centraCl.php
	*/
	function getLspTotStr(){
		return $this->lspTotStr;
	} // getLspTotStr
	

	/**
		Loads a vector of vector or just a vector visible string.
	*/
	function nVectStr(&$v,$prevIdx='',$deep=0){
		$deep++;
		if ($this->vectOfVect($v)){
			reset($v);
			foreach ($v as $k=>$subV){
				$curIdx= '['.$k.']';
				$this->nVectStr($subV,$prevIdx.$curIdx,$deep);
			}		
		}else{
			reset($v);
			foreach ($v as $k=>$val){
				// $this->nVctStrVal.= $this->dots($deep).'['.$k.']='.$val._c_;
				$this->nVctStrVal.= $prevIdx.'['.$k.']='.$val._c_;
			}		
			$this->nVctStrVal.= _c_;
		}
		$deep--;
	} // nVectStr
	
	
	/**
	*/
	function dots($n,$c='...'){
		$b= '';
		for ($i=0; $i<$n; $i++){
			$b.= $c;
		}
		return $b;
	} // dots
	
	
	/**
		Return true if $v is an array of array(s)
	*/
	function vectOfVect(&$v){
		if (!is_array($v)) return false;
		return is_array(reset($v));
	} // vectOfVect

	
	/**
	*/
	function setGuestDisplay($action,$situation='',$topDspl=true){
		$caps= &$this->caps;
		
		$this->countGuestDspl++;
		if ($this->countGuestDspl===1){
			$b= $caps->span($this->el('Congratulation!','kave'),'lnBig');
		}else{
			// $b= _c_BrFlux;
			$b= _c_;
			$b.= $caps->span('and','lnBig');
		}
		
		$b.= $caps->span($this->el(' You just run a demonstration of the action : ','kavf'),'lnThin');
		$b.= $caps->span($action,'lnBig');
		if ($situation!==''){
			$b.= $caps->span(' '.$situation,'lnBig');
		}
		$b.= _c_BrFlux;
		$b.= $caps->span($this->el('Note that it just allows...','kavg'),'lnSmall');
		
		if ($topDspl){
			$this->guestDsplMess.= $b;
		}else{
			return $b;	// for a specific display
		}
	} // setGuestDisplay

	/**
		For general display.
	*/
	function getGuestDisplay(){		
		if ($this->guestDsplMess!==''){
			$caps= &$this->caps;
			$stl= 'float:left; margin-right:0px; margin-top:4px; width:1000px; border:2px solid green; margin-left:10px; padding:5px;';
			return $caps->sDiv($this->guestDsplMess,$stl);
		}else{
			return '';
		}
	} // getGuestDisplay

	
	/**
	*/
	function jsCapsulOn($head,$tail){
		$this->jsCapsulHead= $head;
		$this->jsCapsulTail= $tail;
	} // jsCapsulOn

	
	/**
	*/
	function jsCapsulOff(){
		$this->jsCapsulHead= '';
		$this->jsCapsulTail= '';
	} // jsCapsulOff

	
	/**
		Just forbid the display of the sql error messages! Usefull at installation when oveerwriting already formated tables.
		
		$this->wmRights= &$tagsFu->wmRights;
	*/
	function forbidSqlErrors(){
		$wmR= &$this->wmRights;
		$repMin= !$wmR->erroReportMax();
		if ($repMin){
			$this->allowsSqlErrors= false;
		}
	} // forbidSqlErrors

	
	/**
		Return the current value from an array and advance the array pointor!
			--> A quick fix for the deprecated php7.2 each() in particular cases.
	*/
	function currentNext(&$a){
		$val= current($a);
		next($a);	// wasted return !!
		return $val;
	} // currentNext

} // globVar
?>