<?php
/**
	File name : localDB.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Specialised function to access the database for this project context.
	Warning, because of the access simplification of function condId($id), all table main identificators
	must be called 'id'. Chaging that would be quite easy, but is now of no interest.
	
	Remark : for compatibility with 100% Php DTB function (class simulSql) the 1st column identifier of any table should be named 'id' See simulSql::selectKernel. 
	
	localDB::maxColValue()
*/
class localDB extends oTop{
	
	function __construct(&$asa,&$aSql){
		parent::__construct();
		
		$this->aSql= &$aSql;
		$this->tagsFu= &$asa->tagsFu;
		$this->glob= &$asa->glob;
		$glob= &$this->glob;
		
		$this->acc= &$asa->acc;
		$this->fls= &$asa->fls;
		$this->caps= &$asa->caps;
		$this->tools= &$asa->tools;
		$this->rMg= &$asa->rMg;
		$this->polyglot= &$asa->polyglot;
		
		$this->globGenVarV= array();
		
		
		// currentLg()
		$this->curLanguages= array();
		$this->pageToLgShortCutV= array();
		
		$glob->currentLanguageSet= array();
		$glob->freeLanguageSet= array();
		
	
		/**
			A database table to implement polyvalent Cell for web Pages. A polyvalent set of fields to hold all the strings concerning the web site 
			(page strings, menu strings and posts in case of a forum).
			Rem : Table names get a capital letter after the _c_ when fields names don't!
		*/
		if (!defined('_c_localDB')){
			define('_c_localDB',true);
			
			
			// Common Id name for all tables (specific "cloned" constants are defined each time), but acess function don't do the difference.
			// define('_c_specTblDsplAndUrlId',_c_genId);
			
			/**
				Cells tables.
			*/
			define('_c_PolyCellPg','cellPge');		// The table for the web pages : Encompass All The Fields Below (*eatfb).
			define('_c_PolyCellPgM','cellPgeM');	// The table pages Menus (*eatfb)
				define('_c_pcId',_c_genId);			// Alphabetical index.
				define('_c_pcMainStr','mainStr');	// the string browsered display at the Main spot.
				define('_c_pcNecStr','necStr');		// Main spot conNection string, abreviation connection Main String.
			
				/* Type of the current record evolved into language abreviation (fr, en, de etc. and ok) to help to distinguish between the different
				languages when _c_PolyglotTbl is useless because the page does not belong to a polylinguistic set! Especially apparent
				when creating a page linguistically independant. neutral type === "ok" design linguistic neutral pages that construct
				information using the language of the pahe they have been called from or the language used by the editor. 
				Updated at page creation and when running the [lang] tag.  */
				define('_c_pcType','type');	
					define('_c_pcTypAny','ok');		// any language when we don't kmow for initialisation and for page that need to work in indetermined state
				
				define('_c_pcDate','date');			// creation date YearMonthDay .. so alphab sortable.
				define('_c_pcUserId','userId');		// useful in multi-user context.
			
			// to fit aMySql::sizeElement() that needs the ordinal index!
			$this->cellFieldsIdx= array(_c_pcId=>0,_c_pcMainStr=>1,_c_pcNecStr=>2,_c_pcType=>3,
				_c_pcDate=>4,_c_pcUserId=>5);				
			$this->cellFieldsV= array_flip($this->cellFieldsIdx);
			
			
			
			// A table for a quick access to UTF8 url page name.
			define('_c_ascUtfTN','asciiUtfIds');
				define('_c_auiAscId',_c_genId);
				define('_c_auiUtfId','utfId');
				
							
			/**
				Buffer table.
			*/			
			define('_c_BufferTbl','buffer');
				define('_c_bufferId',_c_genId);		// Alphabetical index, identical to _c_pcId
				define('_c_bufferStr','str');		// The string to store anything, identical to _c_pcMainStr
			
			$this->buffFieldsIdx= array(_c_bufferId =>0,_c_bufferStr =>1);

			/**
				GenVar table.
			*/							
			define('_c_GenVarTbl','genVar');		
				define('_c_genVarId',_c_genId);		// Alphabetical index, identical to _c_pcId : The variable
				define('_c_genVarStr','str');		// The value
				define('_c_genVarRem','remarks');	// Remark pointor on _c_CommentsId
				define('_c_genVarCateg','categ');	// Category			
		
			
			/**
				Special table just for the comments of _c_GenVarTbl
			*/
			define('_c_CommentsTbl','comments');
			define('_c_CommentsSwapTbl','commentsSwap');
				define('_c_CommentsId',_c_genId);							
				define('_c_CommentsEn','en');		
				define('_c_CommentsW','langW');
				define('_c_CommentsX','langX');
				define('_c_CommentsY','langY');
				define('_c_CommentsZ','langZ');
				
			
			/**
				Polyglot table to store the name of the pages corresponding to each others accross the languages.
				--> polyglot Page Names
			*/	
			define('_c_PolyglotTbl','polyglotPN');		
				define('_c_polyglotId',_c_genId);	// Alphabetical index, identical to _c_pcId
				define('_c_polyglotStr','str');		// The string to store anything, identical to _c_pcMainStr
			
			$this->glotFieldsIdx= array(_c_polyglotId =>0,_c_polyglotStr =>1);
			

			/**
				Webmaster User table.
				Remark : up to now, users are not created automatically !!!!!!!! Could implement it !!!!!!!!!!!!!!!!!!
			*/	
			define('_c_UsersTbl','usersTbl');
				define('_c_userId',_c_genId);		// The safeIdStr() of _c_userPseudo / Aunique STRING Id|paseudo
				define('_c_userPseudo','pseud');	// Displayed user pseudo
				
				define('_c_cPwServer','cpw');		// crypted password. Old constant _c_userCpw

				// Recovery circular buffer :
				define('_c_usrStrtRecId','strtRecId');			// Start (lower mark) of the recovery circular buffer
				define('_c_usrFreeRecId','freeRecId');			// Free head for the small recovery circular buffer
				define('_c_usrUndoPos','undoPos');				// Current undo position.
				
				/*
					Next free head/id of the large recovery data _c_RecDataTbl, so :
						- each user got its own zone with enough distance between them.
						- above a given value it start again at the beginning
				*/
				define('_c_recDtSmlstId','smlstDtId');		// Smallest data id.
				define('_c_recDataFreeId','freeRecDtId');	// Next free head/id of the large recovery data
					
				// User xml2 right(s), could be empty! 1st Added manually
				define('_c_usrXmlRight','xRights');	// user rights expressed with []xml
				
				define('_c_userRem','rem');		// A remark about this user account	
				
				// facultative infos ... / in case of standard post needs etc...
				define('_c_userMail','mail');		// user email				
				define('_c_userFamName','famName');	
				define('_c_userFstName','fstName');
				define('_c_userBirthD','birthD');	// Birth day date
				define('_c_userStreet','street');
				define('_c_userNmStreet','nmStreet');
				define('_c_userTown','town');
				define('_c_userCntry','country');
				define('_c_userPostNb','postNb');
				define('_c_userPoBox','postPO');
				define('_c_userTel','tel');
				define('_c_userFax','fax');
				define('_c_userMobileNb','mobileNb');
														
							
		/**	
			Top hash circular table for the couple ppH and pH before loggin recognition :
				- Deprecated flag to switch once it's used
				- Circular on about 50 positions
		*/
		define('_c_topHashTbl','topHashTbl');		// See class topHash !
			define('_c_topHashOrdId',_c_genId);		// A general circular ordinal identificator
			define('_c_topHashDate','date');		// date un seconds
			
			define('_c_topHashIdH','hashId');		// A 20 chars hash to identify a logged user (created by any, but once logged changeable only by the owner)									
			define('_c_topHashUserId','userId');	// The user Id mainly for visual identification	
			
			define('_c_topHashLog','logged');		// Logged status : ok or ko
									
			
			define('_c_topHashC2Pw','c2pw');		// Login Hash Cpw Crypted (the non traveling-alone crypt-key stored on both sides. 
			define('_c_topHashPPH','ppH');			// User primary primary hash
			define('_c_topHashOldPPH','oldPPH');	// Old valid (matching a logged user) primary primary hash
			define('_c_topHashPH','primH');			// User primary hash
			define('_c_topHashOldPH','oldPrimH');	// Old valid (matching a logged user) primary hash

			
	
				
				
		define('_c_mainCacheTbl','cacheTbl');
			define('_c_mCacheId',_c_genId);
			define('_c_mCacheStr','mainStr');
			define('_c_mCacheTime','time');
			define('_c_mCacheActv','active');


					
		define('_c_pgRedirectTbl','pgRedirect');
			define('_c_redirectPgId',_c_genId);		// start
			define('_c_redirectPgTrgt','target');
			
			
		/**
			This table is firstly used to store 
				- specialised texts for zoomed images directly on xml2 parsed xhtml form
		*/	
		define('_c_idTextsKeySz',64);
		define('_c_idTextsTbl','idTexts');
			define('_c_idTextKey',_c_genId);	
			define('_c_idTextTxt','text');
			

		define('_c_idCodeTbl','idCode');
			define('_c_ictId',_c_genId);	
			define('_c_ictCode','code');
			define('_c_ictRem','comment');	// symbolic, would not need to be declared here
										
		} // if (!defined('_c_localDB'))
	} // construct
	
	
	
	
	/*-------------------------------------------
		Class Pointor management. */
	function loadHPwC(&$hPwC){$this->hPwC= &$hPwC;}
	function setParser(&$parser){$this->parser= &$parser;}
	function loadRecov(&$rec){$this->recv= &$rec;}	
	function loadRights(&$rMg){$this->rMg= &$rMg;}	
	function loadTgFu(&$tgF){$this->tagsFu= &$tgF;}
	function setMbCrypt(&$mb){$this->mbCrypt= &$mb;}
	
	
	
		
	/**
	*/
	function loadsDefSPhoneMode(){		
		$rMg= &$this->rMg;

		// Define the default visual ergonomics mode when the smartPhone parameter is not defined
		if ($rMg->quickWMRight()){
			// A webmaster is logged, so imposed the defNectWmErgoMd predefined mode or 'dek'by default!
			$defErgoMd= $this->getGenVar('defNectWmErgoMd','dek');
		}else{
			$defErgoMd= $this->getGenVar('defSurfErgoMd','mob');
		}
		
		// Memorize the default ergo mode as a general variable on ok / ko base to minimise the use of the url variable _c_smartPhoneMode
		switch ($defErgoMd){
			case 'mob':
				$this->defltSmartPhoneMode= _c_ok;
			break;
			
			case 'dek':
			default:
				$this->defltSmartPhoneMode= _c_ko;	// desk top is the default when genVar are incomplete
			break;
		} // switch
	} // loadsDefSPhoneMode
	
	


	/* ----------------------------------------
		Returns the condition on the Id.
	*/
	function condId($id){
		$aSql= &$this->aSql;
		return $aSql->basicCond(_c_genId,$id);	
	} // condId
		
	/**
	*/
	function condStr($field,$val,$oper='='){
		$aSql= &$this->aSql;
		return $aSql->basicCond($field,$val,$oper);
	} // condStr
	
	
	/**
		A quick short hand to deal with the double possibility for the where parameter.
	*/
	function quickWhere($condField,$condVal=false){
		$aSql= &$this->aSql;
		if ($condVal===false){
			return $condField;	// shorter syntax (already a vector)
		}else{
			return $aSql->basicCond($condField,$condVal);
		}
	} // quickWhere

			
	/**
		To create a new page or menu!
	*/
	function createFullCell($tblName,$id,$mainStr,$nect='',$cellType=''){
		$fls= &$this->fls;
		$rMg= &$this->rMg;	
		
		$v= array($id,$mainStr,$nect,$cellType,$fls->timeStamp(),$rMg->realTimeUserId());		
		return $this->newRecord($tblName,$v,$this->condId($id));
	} // createFullCell
	
	
	/**
		Loads some supplement pointers at once (can do it in subsequent instenciation of
		localDB (eg : frameBuilder) because the concerned pointers are already instanciated)
	*/
	function allSupPtAtOnce(&$asa){
		$this->loadHPwC($asa->hPwC);
		$this->setParser($asa->parser);
		$this->loadRecov($asa->rec);
		$this->loadRights($asa->rMg);
		$this->loadTgFu($asa->tagsFu);	
	} // allSupPtAtOnce
	
	
	/**
		Connect to the current data base server with included password uncyphering.
		Returns the Dtb server link identifier on success or FALSE on failure.
	*/
	function dtbServerConnection(){
		$mbCrypt= &$this->mbCrypt;
		
		$dtbExtPwName= $mbCrypt->mbUnCrpt(_c_dtbExtCrpPwName,_c_softCrypKey);
		return $this->dbConnect(_c_prodDTBServerName, _c_dtbExtUsrName,$dtbExtPwName,_c_UsrDbName);
	} // dtbServerConnection
	
	
	/**
		Connect directly to the database. Returns true or false depending on success.
	*/
	function dbConnect($server,$userName,$dbPw,$defDtb=false){
		$aSql= &$this->aSql;
		return $aSql->sqlDbConnect($server, $userName, $dbPw,$defDtb);
	} // dbConnect
	
	
	/**
		Just manages the error message here.
	*/
	function createDatabase($name){
		$aSql= &$this->aSql;
		$caps= &$this->caps;
		
		if ($aSql->createDtb($name)===false){
			print $caps->efont('can\'t create the database '.$name)._c_BrFlux;
			return false;
		}else{
			return true;
		}
	} // createDatabase
		
	
	/** ------------------------------------------------------------
		Manipulation of general variables
			Input :
				$var : the variable name (anythind, even numbers)
				$val : the variable value.
				$canEcrase : ... !!!!!!!!!!!!  think about it !!!!! ,, would be easier if true by default.
			Output :
				A new record
	*/
	function newGenVar($var,$val, $canEcrase=false,$categ=''){
		$aSql= &$this->aSql;
		$acc= &$this->acc;
		
		if (!$aSql->recordExists(_c_GenVarTbl, $this->condId($var) )){
			$v= array($var,$val,'',$categ);
			return $this->newRecord(_c_GenVarTbl, $v, $this->condId($var));
		}else if($canEcrase){
			return $this->setGenVar($var,$val); // small plus, so get a "don't care" function set it anyway already there or not
		}
	} // newGenVar
	
	
	/**
		Quick to read, but not cached.
	*/
	function quickGetGenVar($var){
		$aSql= &$this->aSql;
		$rec= $aSql->selectOneRecord($r,_c_GenVarTbl,$this->condId($var));
		if ($rec!==false){
			return $rec[_c_genVarStr];
		}else{
			return false;
		}
	} // quickGetGenVar

	/**
		Get a specified general variable value!
		Input :
			$var : the name of the variable.
			$default : facultative default value.
			$tbl : name of the concerned table.
			$fieldN : ---
	*/
	function getGenVar($var,$default=false,$tbl=_c_GenVarTbl,$fieldN=_c_genVarStr){
		$aSql= &$this->aSql;
		$glob= &$this->glob;
		
		if (_c_genVarCache && array_key_exists($var,$this->globGenVarV) ){
			return $this->globGenVarV[$var];	// Speed up
		}
		
		$rec= $aSql->selectOneRecord($r,$tbl,$this->condId($var));
		if ($rec!==false){
			$val= $rec[$fieldN];
			if (_c_genVarCache){
				$this->globGenVarV[$var]= $val;
			}
			return $val;
		}else{
			return $default;
		}
	} // getGenVar
	

	/**
	*/
	function gotOkGenVar($var,$default=_c_ok){
		return $this->getGenVar($var,$default)===_c_ok;
	} // gotokGenVar
	
	
	/*
		Webmaster Personalysed getGenVar.
	*/
	function pGetGenVar($var,$default=false){
		return $this->getGenVar($var,$default,$this->pGvTblNm());
	} // pGetGenVar
	
	/*
		Webmaster Personalysed setGenVar.
	*/
	function pSetGenVar($var,$val){
		return $this->setGenVar($var,$val,$this->pGvTblNm());
	} // pSetGenVar
	
	/**
		Return the personal gen var table name.
	*/
	function pGvTblNm(){
		$rMg= &$this->rMg;
		
		$tblN= _c_genVarPrfx.$rMg->realTimeUserId();
		if ( $this->tableExists($tblN) ){
			return $tblN;
		}else{
			// Could create the table $tblN) here !!
			return _c_tblEdtDefTN;
		}
	} // pGvTblNm


	/**
	*/
	function setGenVar($var,$val,$tbl=_c_GenVarTbl,$categ='autoCreated'){
		$aSql= &$this->aSql;
		if ( $this->elementExists(_c_genVarId,$var, $tbl) ){
			return $this->chgRecord($tbl,$aSql->assignStr(_c_genVarStr,$val),$this->condId($var));
		}else{
			$v= array($var,$val,'',$categ);
			return $this->newRecord($tbl,$v);
		}
	} // setGenVar



	/* -------------------------------------------------------------------
		A general solution for numerical variables that need :
			- Getting it OR creating it from a constant in one function.
			- Increasing the value of a given unit.
	*/
		
	/*
		Get the current Free Id
	*/
	function getFreeIndx($name,$init=0){
		$freeId= $this->getGenVar($name);
		if ($freeId===false){
			$freeId= $init;
			$this->newGenVar($name,$freeId);
		}
		return $freeId;
	} // getHeadId	

	/*
		Increases the current Free Id of one position.
	*/
	function incrFreeIndx($name,$init=0){
		$freeId= (string)($this->getFreeIndx($name,$init)+1);		
		$this->setGenVar($name,$freeId);
	} // getFreeIndx


	/**
		Select the current database. For now, only used in Frame builder!
	*/
	function selectDb($dbName){
		$aSql= &$this->aSql;
		$sDtb= $aSql->sqlSelectDb($dbName);
		if ($sDtb===false){
			$mess= 'Could not connect to '.$dbName._c_;
		}
		return $sDtb;
	} // selectDb

		
	/**
		Gives the current surf language of the page! This does not invole the mother page!
		Input :
			$gPg : a facultative given page.
			$flot : got to use the flot (free for forum) tag instead of the glot tag
	*/	
	function currentLg($gPg=false,$flot=false){
		$tagsFu= &$this->tagsFu;		
		$glob= &$this->glob;		
		$glot= &$this->polyglot;
		$tools= &$this->tools;
		
	
		if ($gPg!==false){
			$curPgName= $gPg;
		}else{
			$curPgName= $tools->getUrlPageName();
		}
		
		if ($curPgName===false){
			return $this->getGenVar('surfDefLanguage');
		}
		
		
		if ( array_key_exists($curPgName,$this->pageToLgShortCutV) ){
			return $this->pageToLgShortCutV[$curPgName];	// short cut
		}
		
		if ( $flot===false && array_key_exists($curPgName,$this->curLanguages) ){
			$crLg= $this->curLanguages[$curPgName];	// acceleration for standard case $flot===false
		}else{
			$curLg= false;
	 		$pgVect= $this->languageFamVect($curPgName,$flot);
	 		if (is_array($pgVect)){
				$lgVect= array_flip($pgVect);
				if (isset($lgVect[$curPgName])){
					$curLg= $lgVect[$curPgName];
				}
			}
			
			if ($curLg===false){
				$pcType= $this->getElem(_c_PolyCellPg, _c_pcId,$curPgName, _c_pcType);
				if ($pcType===_c_pcTypAny || !in_array($pcType,$glot->lgVect) ){
					if ( $glot->isInSurfLgVect($tagsFu->globHtmlMLang) ){
						$curLg= $tagsFu->globHtmlMLang;
					}else{
						$curLg= $glob->gMasterLanguage;
					}
				}else{
					$curLg= $pcType;
				}
			}
			
			if ($flot===false){
				$this->curLanguages[$curPgName]= $curLg;
			}
			
			$crLg= $curLg;
		}
		
		$this->pageToLgShortCutV[$curPgName]= $crLg;
		return $crLg;
	} // currentLg
	

	/**
		For a given page, returns the set of page across languages.
			$v= $this->languageFamVect($curPgName);
			$currentPageFr= $v['fr'];
			
		Input :
			$curPgName : given page name
			$flot : got to use the flot tag instead of the glot tag
	*/
	function languageFamVect($curPgName,$flot=false){
		$glob= &$this->glob;		
		$tagsFu= &$this->tagsFu;
		$parser= &$this->parser;
	
		$cellStr= $this->getCllStr($curPgName,_c_PolyglotTbl,_c_polyglotStr);
		if ($cellStr===false || $cellStr===''){
			return false;
		}
		
		if ($cellStr[0]===_c_lBrk){		
			$languageSet= $cellStr;
		}else{
			// $cellStr is just the id of the current language set.
			$languageSet= $this->getCllStr($cellStr,_c_PolyglotTbl,_c_polyglotStr);
		}
	
		if ($flot){
			// For local xml evaluation, keeping $glob->currentLanguageSet untouched!
			$languageSet= str_replace('[glot','[flot',$languageSet);
		}
		
		$tagsFu->expandX($languageSet);
		if ($flot){
			return $glob->freeLanguageSet;
		}else{
			return $glob->currentLanguageSet;
		}
	} // languageFamVect

	/**
		For a given page name, returns the one matching the correct language.
	*/
	function lgCorrectPg($pg){
		$keyLg= $this->currentLg();
		$lgPgSet= $this->languageFamVect($pg);
		if ( $lgPgSet!==false && array_key_exists($keyLg,$lgPgSet) ){
			return $lgPgSet[$keyLg];
		}else{
			return $pg;
		}
	} // lgCorrectPg
	
	
	/**
		Needs to reconstruct the 2 folowing functions using more adapted functions in aMySql.
		+ Need to define here specialise access I/O functions for the values of _c_PolyCellP
	*/
	
	/** ---------------------------------------------------------------------------------------
		General fields I/O
	*/	
		
	/**
		Delete all elements matching a condition ($field,$val)
			Input:
				$tblName : table to delete elements from.
				$field,$val : to establisch the deletion condition.
			Output:
				delete the rows.	
				
		To delete a complete table :
			$this->deleteAll($tblName);
	*/
	function deleteAll($tblName, $field,$val){
		$aSql= &$this->aSql;
		
		if ($val===false){
			return;
		}
		
		$where= $this->quickWhere($field,$val);
		$query= $aSql->selectResource($tblName,$where);
		while( $row= $aSql->fetchArray($query) ){
			$idKey= key($row); // 1st key (for now 'id' for all tables), So general & don't have to pass the param.
			$id= $row[$idKey];
			$this->deleteTableRecord($tblName,$idKey,$id);
		}
	} // deleteAll


	/**
		Ancestor of getElem(...) !!!
	*/
	function selectElem($table,$condition,$elem=false){
		$aSql= &$this->aSql;
		
		$query= $aSql->selectResource($table,$condition);
		$v= $aSql->fetchArray($query);
		if ($elem===false){
			return $v;
		}else{
			return $v[$elem];
		}
	} // selectElem
		
			
	/**
		Returns the element specified by $retF or the whole record if $retF===false.
			Input :
				$tbl : table name.
				$condFNm : condition field name/Id
				$condFVl : condition field value.
				$retField : returned field or if set to false : return the whole record.
				
			Output : the value of the specified field to be returned or the whole record.
			
		Examples :
			$this->getElem(_c_pcMainStr, specifiedValue, _c_PolyCellPgM);
			
		For polyvalent cell specialised function, see : getCllStr(...) & getCellStr().
	*/
	function getElem($tbl, $condFNm,$condFVl=false, $retField=false){
		$aSql= &$this->aSql;
		
		$where= $this->quickWhere($condFNm,$condFVl);		
		$rec= $aSql->selectOneRecord($res,$tbl,$where);
		
		if ($rec!==false){
			if ($retField!==false){
				if (is_array($rec) && array_key_exists($retField,$rec)){
					return $rec[$retField];
				}else{
					return false;
				}
			}else{
				return $rec;
			}
		}else{
			return false;
		}
	} // getElem
	
	
	/**
		Increases of one unity the specified element of the specified table
	*/
	function incrElem($tbl, $condFNm,$condFVl, $field, $op='+'){
		$elem= $this->getElem($tbl,$condFNm,$condFVl,$field);
		if ($op==='+'){
			$elem= (int)$elem + 1;
		}else{
			$elem= (int)$elem - 1;
		}
		$this->setElem($tbl,  $field,$elem,  $condFNm,$condFVl);
	} // incrElem
	
	
	/**
		Decreases of one unity the specified element of the specified table
	*/
	function decrElem($tbl, $condFNm,$condFVl, $field){
		$this->incrElem($tbl, $condFNm,$condFVl,$field,'-');
	} // decrElem
	
	
	/**
		Sets the specified field. For polyvalent cell specialised function, see : chgPolyCell(...).
		(?) If using $valV useful for a !lazy approach where we don't know and don't want 
		to test externally the record existance + if it exists want to update the relevant part automatically.
			Input :
				$tbl : table name.
				$assField : assignement field.
				$assVal : assignement value.
				$condField : condition field.
				$condVal : condition value.
				$valV : vector of values (only if the actual record is empty !! )
	*/
	function setElem($tbl,  $assField,$assVal,  $condField,$condVal=false, $valV=false){
		$aSql= &$this->aSql;
		$where= $this->quickWhere($condField,$condVal);
		if ($this->elementExists($condField, $condVal, $tbl)){
			// Updating an existing record
			$set= $aSql->assignStr($assField,$assVal);
			return $this->chgRecord($tbl,$set,$where);
		}else if ($valV!==false){
			// Build a new record with $valV (! special treatment if $where is given).
			return $this->newRecFromV($tbl,$valV,$where);
		}else{
			return false;
		}
	} // setElem
	
	
	/**
		Impose a full record on a given table.
	*/
	function setFullRec($tbl, $strFields,$sep=';'){
		$tools= &$this->tools;
		$aSql= &$this->aSql;
		
		$valV= $tools->trimStrToVect($sep,$strFields);
		$condField= _c_genId;
		$condVal= $valV[0];
		$where= $this->quickWhere($condField,$condVal);
		if ($this->elementExists($where, false, $tbl)){
			// Delete the full existing record
			$this->delete($tbl,$condVal);
		}
		
		return $this->newRecord($tbl,$valV);
	} // setFullRec
	
	
	/**
		Concatenation at the end. Other : concatBeg()
	*/
	function concatEnt($tbl,  $assField,$assVal,  $condField,$condVal=false){
		$origVal= $this->getElem($tbl, $condField,$condVal, $assField);
		$this->setElem($tbl,  $assField,$origVal.$assVal,  $condField,$condVal);
	} // concatEnt
	
	
	/**
		Set the given element as setElem(), but does not save it with html code, so 
		jumps the method accents->toHtmlCode()
	*/
	function setElemNoMlCd($tbl,$assField,$assVal, $condField,$condVal=false, $valV=false){
		$acc= &$this->acc;
		if ($acc->usesHtmlCode===true){
			$acc->usesHtmlCode= false;
			$res= $this->setElem($tbl,$assField,$assVal, $condField,$condVal,$valV);
			$acc->usesHtmlCode= true;
		}else{
			$res= $this->setElem($tbl,$assField,$assVal, $condField,$condVal,$valV);
		}
		return $res;
	} // setElemNoMlCd
	
	
	
	/**
		Rename the specified record.
	*/
	function renameRec($tbl,$curId,$newId){
		return $this->setElem($tbl,  _c_genId,$newId,  _c_genId,$curId);
	} // renameRec
	
	/**
		Change the index (trim() done with the user interface). Idem as above !!!!
	*/
	function chgCellIndex($tblName,$id,$newId){
		$aSql= &$this->aSql;
		$this->chgRecord($tblName, $aSql->assignStr(_c_pcId,$newId), $this->condId($id));
	} // chgCellIndex
	
	
	/**
		Creates a new record from a vector $valV (associative array).
		Rem : $val is just there so we have the freedom to pass 2 parameter ($where=field, $val) instead
			  of an already formated $where.
		Input :
			$tbl : table name
			$valV : vector hoding all entries to the table.
			$where : used for the recovery table, can be false if we are sure the recovery table is not used.
	*/
	function newRecFromV($tbl,&$valV,$where=false,$val=false){
		if ($where!==false && $val!==false){
			$where= $this->quickWhere($where,$val); // In this case the operand $where is the field name!
		}
		
		return $this->newRecord($tbl,$valV,$where);
	} // newRecFromV
	
	
	/**
	*/		
	function newElem($tbl, $condField,$condVal=false, $valV='', $strong=false){
		$where= $this->quickWhere($condField,$condVal);			
		if ($this->elementExists($condField, $condVal, $tbl)){
			if ($strong){
				$this->deleteTableRecord($tbl,$where);
			}else{
				return false;
			}
		}
		$this->newRecord($tbl,$valV,$where);
		return true;
	} // newElem
	
	
	/**
	*/		
	function newElemRes($tbl, $condField,$condVal=false, $valV=''){
		$where= $this->quickWhere($condField,$condVal);	
		if (!$this->elementExists($condField, $condVal, $tbl)){
			$this->newRecord($tbl,$valV,$where);
			return true;
		}else{
			return false;
		}
	} // newElemRes


	/**
		Return true if the specified element exists, false otherwise.
		Input:
			$fNm: field name; 
			fVl: specified Value;
			$tblN : table name
			$givenId : If exact ID -->  Supplementary case test on the Id to short circuit the MySql laxism on cases
	*/
	function elementExists($fNm, $fVl, $tblN=_c_PolyCellPg, $givenId=false){
		$aSql= &$this->aSql;
		return $aSql->recordExists($tblN, $this->quickWhere($fNm,$fVl), '*', $givenId);
	} // elementExists
	
	/**
		So covers moost common cases with a single parameter.		
		$dtb->elExists(fVl,fNm,tblN)
	*/
	function elExists($fVl, $fNm=_c_genId, $tblN=_c_PolyCellPg){
		$res= $this->elemExistSameCase($fNm, $fVl, $tblN);
		return $res;
	} // elExists
	
	function elemExistSameCase($fNm, $fVl, $tblN=_c_PolyCellPg){
		$aSql= &$this->aSql;
		$exist= $aSql->recExistAndRetRec($concernedRec,$tblN,$this->quickWhere($fNm,$fVl));
		if ($exist){
			reset($concernedRec);
			$idVal= current($concernedRec);
			return $fVl===$idVal;
		}else{
			return false;
		}
	} // elemExistSameCase
	
	
	/**
		Return true if the record exists / belong to the specified table.
	*/
	function recordExists($table,$condition='',$column='*'){
		$aSql= &$this->aSql;
		return $aSql->recordExists($table,$condition,$column);
	} // recordExists
	

	/**
	*/
	function getPolyglotStr($id){
		return $this->getElem(_c_PolyglotTbl, _c_polyglotId,$id, _c_polyglotStr);
	} // getPolyglotStr


	/**
	*/
	function setPolyglotStr($id,$newVal){
		return $this->setElem(_c_PolyglotTbl, _c_polyglotStr,$newVal, _c_polyglotId,$id);
	} // setPolyglotStr
	

	/**
		Creates a default Poly Cell Record.
	*/
	function createPolyDefCell($newIdName,$mainStr){
		$v= $this->defCellVect($newIdName,$mainStr,_c_PolyglotTbl,'','');		
		$this->newRecord(_c_PolyglotTbl,$v,$this->condId($newIdName));
	} // createPolyDefCell	
	
	

	
	/** ---------------------------------------------------------------------------------------
		Below : broad spectrum methods.
	*/	

	
	/**
		Default: returns the whole sub-table as a full matrix! Beware of
		passing the memory limit! ... Interesting for index table where
		the full table content is small.
		
		Remark : $this->subTable($tbl)	// the full table!!
	*/
	function subTable($tbl,$field='',$val=''){
		$aSql= &$this->aSql;
		
		$q= $aSql->selectResource( $tbl, $aSql->basicCond($field,$val) );
		$i=0;
		while ($row= $aSql->fetchArray($q)) {
			$subTbl[$i]= $row;
			$i++;
		}
		
		if ($i===0){
			return false;
		}else{
			return $subTbl;
		}
	} // subTable
	

	/**
		Idem subTable(), but index with a given key that must be different for each field!
	*/
	function kSubTable($tbl,$field,$val,$key){
		$aSql= &$this->aSql;

		$q= $aSql->selectResource( $tbl, $aSql->basicCond($field,$val) );
		while ($row= $aSql->fetchArray($q)) {
			$subTbl[$row[$key]]= $row;
		}
		if (isset($subTbl)){
			return $subTbl;
		}else{
			return false;
		}
	} // kSubTable
	

	/**
		Idem vectFielDuS() ... could substitute with vectFielDuS() everywhere (better name)
	*/
	function vectIdNames($tblName,$cond='',$idField=_c_pcId){
		return $this->vectFielDuS($tblName,$cond,$idField);
	} // vectIdNames

	
	/**
		Return a vector holding the one specified field or All records
		--> FielDuS  Field or Fields ... U being the logical symb. represent. operator OU, so (d OR s) one OR all fields! .. Crypètic notation!
		Input:
			$tblName ; the table name
			$cond : the specified condition
			$idField : the field we are returning, if false --> returns all fields.
	*/
	function vectFielDuS($tblName,$cond='',$idField=false){
		$aSql= &$this->aSql;
				
		if ($idField===false){
			$selectFields= '*';
		}else{
			$selectFields= $idField;
		}
		
		$tE= $aSql->tableExists($tblName);
		if ($tE){
			$res= $aSql->selectResource($tblName,$cond,$selectFields);
			$rsr= $aSql->queryColVect($res,$idField);
			return $rsr;
		}else{
			return false;
		}
	} // vectFielDuS


	/**
		Return a vector holding the one specified field or All fields (a vector of vectors).
		(vectFields plurial by commodity singular a possibility)
		Input :
			$keyField : the field used to key the returned vector.
			$returnedField : the fiedl to eventually return..
	*/
	function vectFields($tblName,$condition,$keyField, $returnedField=false){
		$aSql= &$this->aSql;
				
		if ($returnedField===false){
			$res= $aSql->selectResource($tblName,$condition, '*');	// returns all fields
		}else{
			// specific, a bit faster don't need to scan all fields.
			$res= $aSql->selectResource($tblName,$condition, $keyField.','.$returnedField);
		}
		
		return $aSql->colKeyVect($res,$keyField,$returnedField);
	} // vectFields


	/**
		Delete the givent record for the given table
	*/
	function delete($tblName,$id){
		$this->deleteTableRecord($tblName,_c_pcId,$id);
	} // delete

	function delBuffer($id){
		$this->deleteTableRecord(_c_BufferTbl,_c_bufferId,$id);
	} // delBuffer

	
	/**
		Execute a database query with the current querry language. (now MySql)
	*/
	function dtbQuery($q){
		$aSql= &$this->aSql;
		return $aSql->localQry($q);
	} // dtbQuery

	/** ---------------------------------------------------------------------------------------
		Below methods were written as specific methods, then more or less generalised, which
		does not help for their easy undestanding.
	*/	
	
	/**	
		Returns all the fields VALUES
	*/	
	function defCellVect($newIdName, $mainStr='', $categ='cell', $nect='', $cellType=_c_pcTypAny){
		$acc= &$this->acc;
		$fls= &$this->fls;
		$rMg= &$this->rMg;
		
		switch ($categ){
			case 'cell':	// generic type for the 4 similar tables
				$fieldsVal= array($newIdName, $mainStr, $nect, $cellType, $fls->timeStamp(), $rMg->realTimeUserId());
			break;
			
			case 'buff':	// interlope type could switch to table name but annoying to do!
			case _c_PolyglotTbl:	// much clearer with table name as type
				$fieldsVal= array($newIdName,$mainStr);
			break;
		}
		
		return $fieldsVal;
	} // defCellVect


	/**
		Creates a default Poly Cell Record.
	*/
	function createDefCell($tblName,$newIdName,$mainStr='', $cellType=_c_pcTypAny){
		$v= $this->defCellVect($newIdName,$mainStr,'cell','',$cellType);		
		$this->newRecord($tblName,$v,$this->condId($newIdName));
	} // createDefCell	
		

	/**
		Change the information $str inside a Poly Cell Record.
	*/
	function chgPolyCell($tblName,$id,$str,$field=_c_pcMainStr){
		$aSql= &$this->aSql;		
 		return $this->chgRecord($tblName, $aSql->assignStr($field,$str), $this->condId($id));
	} // chgPolyCell
	
	

	/**
		Gives the ordinal index of the given field ($field) of a given table ($tblNm).
		Input :
			$tblNm : concerned table.
			$field : concerned field to extract the index (ordinal position of tha field starting at 0)
	*/
	function fieldOrder($tblNm,$field){
		switch($tblNm){
			case _c_PolyCellPg:
			case _c_PolyCellPgM:
				$idx= $this->cellFieldsIdx[$field];
			break;
		
			case _c_BufferTbl:
				$idx= $this->buffFieldsIdx[$field];
			break;
			
			case _c_PolyglotTbl:
				$idx= $this->glotFieldsIdx[$field];
			break;
		} // switch
	
		return $idx;
	} // fieldOrder


	/**
		Get the specified field of the specified table, at the specified id.
		... so the suffix Str is clearly an overgeneralisation (exageration) for all sort of types.
	*/
	function getCellStr(&$sz, $id, $tbl=_c_PolyCellPg, $field=_c_pcMainStr){
		$acc= &$this->acc;
		$aSql= &$this->aSql;
		$tools= &$this->tools;	
		
		if ( !$aSql->secureSqlId($id) ){
			return false;
		}
		
		if ($aSql->secureSqlId($id)){
			$rec= $aSql->selectOneRecord($r,$tbl,$this->condId($id));
			if ($rec!==false && $rec!==null){
				$str= $rec[$field];
				if ($sz!==_c_ko && !_c_sqlSimul){	
					$idx= $this->fieldOrder($tbl,$field);
					$sz= $aSql->sizeElement($r,$idx,$field);
				}else{
					$sz= strlen($str);
				}
				
				return $str;
			}else{
				return false;
			}
		}else{
			return false;
		}
	} // getCellStr
	
	
	/**
		Idem getCellStr(), but don't bother with the $sz param,
	*/	
	function getCllStr($id, $tbl=_c_PolyCellPg, $field=_c_pcMainStr){
		$sz= _c_ko;	
		return $this->getCellStr($sz,$id,$tbl,$field);
	} // getCllStr

	/**
	*/
	function getType($id, $tbl=_c_PolyCellPg){
		$sz= _c_ko;
		return $this->getCellStr($sz,$id,$tbl,_c_pcType);
	} // getType
	


	/**
		Returns  _c_pcMainStr from the given table at the given Id.
	*/
	function getMainStr(&$sz,$id,$tbl=_c_PolyCellPg){	
		$type= $this->getType($id);
		return $this->getCellStr($sz,$id, $tbl);
	} // getMainStr


	/* --------------------------------------------------------------------------------------
	*/
	function chgRecord($tbl,$set,$where){
		$aSql= &$this->aSql;
		$glob= &$this->glob;
		$fls= &$this->fls;
		$rec= &$this->recv;
		
		$aSql->normSetStr($set);
		$whereStr= $aSql->condKyVlToStr($where);	// makes sure $whereStr is a string, for aMysql, just a straight return		
		if ($glob->recvOk()){
			// global recovery is ON
			$aSql->splitAssignation($set,$left,$newId);	 // only simple assignation set allowed here with recovery possibility
			if ($left===_c_genId){
				$oldId= $aSql->valFromLocator($where);
				
				// Rem : need to remove the double quotes twice because each comes from a right part of an Sql assigment
				$oldNewCombined= $fls->removeExternChar($oldId) .'='. $fls->removeExternChar($newId);	// may be a trouble in non-sql mode ?
				$rec->forChgRec($tbl,$whereStr,'chgIdx',$oldNewCombined);	// Special case : rename the main index.
			}else{
				$rec->forChgRec($tbl,$whereStr,'chg',$set);
			}
		}
		
		return $aSql->chgSqlRec($tbl,$set,$where);
	} // chgRecord
		
			
	/**	
		Stores a new record given as a vector.
			Input:
				$tbl : the table name
				$valV : the full data created as a vector. --- faster to use an address.
				$where : where it's from, only for recovery purpose.
	*/
	function newRecord($tbl,&$valV,$where=false){
		$aSql= &$this->aSql;
		$tools= &$this->tools;
		$glob= &$this->glob;
		$rec= &$this->recv;
		
		$this->normHtmlVectC($valV);	// <br> + html codes
		if ($where!==false){
			$gok= $glob->recvOk();
			if ($gok){
				$this->normBckSlhStr($valV);
			}
		
			$whereStr= $aSql->condKyVlToStr($where);		
			if ($gok){
				$rec->forChgRec($tbl,$whereStr,'new',$val);
			}
		}
		
		return $aSql->newSqlRec($tbl,$valV);
	} // newRecord
	
	
	/**	
		Stores a new record given as a string.(only used in recovery classes!!!)
			Input:
				$tbl : the table name
				$val : the data string to change
				$where : where its from, only for recovery purpose.
		Rem : sort of redundant with ::newRecord(), but avoid unnecessary vectorisation of
		necessarilly monoblock strings stored inside the recovery tables. By the way 
		::newRecord() allows to demonstrate some sort of flexibility related to bringing real
		vectors as close as possible from the SQL instructions.
	*/
	function newRecordStr($tbl,$val,$where=false){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$aSql= &$this->aSql;
		$rec= &$this->recv;

		$val= $acc->normStr($val);	
		if ($where!==false){	
			$whereStr= $aSql->condKyVlToStr($where);	// just a copy in SQL cases	
			if ($glob->recvOk()){
				$rec->forChgRec($tbl,$whereStr,'new',$val);
			}
		}
		return $aSql->newSqlRec($tbl,$val,$where);
	} // newRecordStr	
		

	/**
		Normalizes and backslash the given vector of strings.
	*/
	function normBckSlhStr(&$valV){
		$acc= &$this->acc;		
		return $acc->bSlhQuoteParams($valV,true);	
	} // normBckSlhStr
	
		
	/**
		Normalizes the vector content
	*/
	function normHtmlVectC(&$v){
		$acc= &$this->acc;		
		if (is_array($v)){
			reset($v);
			foreach ($v as $key=>$val){
				$v[$key]= $acc->normStr($v[$key]);
			}
		}else{
			print('Erreur : localDB::normHtmlVectC()');
		}
	} // normHtmlVectC

		
	/**		
	*/
	function deleteTableRecord($tbl,$field,$val=false){
		$aSql= &$this->aSql;
		$glob= &$this->glob;
		$acc= &$this->acc;
		
		if ($val===false){
			$where= $field; // trick, double meaning of $field, $val is included inside in the form of the search cond, where string.
		}else{
			$where= $aSql->basicCond($field,$val);
		}
		
				
		if ($glob->recvOk()){
			$rec= &$this->recv;
			$whereStr= $aSql->condKyVlToStr($where);
			$rec->forChgRec($tbl,$whereStr,'del',$whereStr);
		}
	
		return $aSql->deleteSqlTableRec($tbl,$where);
	} // deleteTableRecord
	
		
	/*
		End Three bottleneck functions.
	-------------------------------------------------------------------------------------- */


	/**
		Delete, erases : A quick version not subject to any undo/redo  
	*/
	function delTableRecord($tbl,$field,$val=false){
		$aSql= &$this->aSql;
		
		if ($val===false){
			$where= $field; // trick, double meaning of $field, $val is included inside in the form of the search cond, where string.
		}else{
			$where= $aSql->basicCond($field,$val)	;
		}
		return $aSql->deleteSqlTableRec($tbl,$where);
	} // delTableRecord
	
	
	/**
	*/
	function truncateTable($tbl){
		$aSql= &$this->aSql;
		return $aSql->truncTbl($tbl);
	} // truncateTable
	
	
	

	/**
		Calling some of the above 3 with an automatical stop for the recovery buffer.
		Stop Recovery : StpR
	*/
	
	/**
	*/
	function delTblRecStpR($tbl,$field,$val=false){
		return $this->deleteTableRecord($tbl,$field,$val);
	} // delTblRecStpR


	/*-------	
	   DUMP
	--------*/
	
	/**
		The full string to be dumped for the given table (basically many insert instructions)
		Produces a string holding all the insert string instructions to reconstitute the table content.
		
		Input ;
			$tblName : given table name.
			$vectForbCol : vector of forbidden column name (eg: to avoid backuping crypted passwords from the user data).
	*/
	function colNamesAndValToDump($tblName,$sep,$vectForbCol=false){
		$aSql= &$this->aSql;
		$tools= &$this->tools;
		$acc= &$this->acc;
		
		$curQ= $aSql->selectResource($tblName);
		$buffDump= '';
		while ($row= $aSql->fetchArray($curQ)){			
			$buffDump.= $sep.$aSql->insertQueryStr($tblName,$row).';'._c_R;	// calculate one full line
		} // while
		return $buffDump;
	} // colNamesAndValToDump
	
	
	/**
		Gives the dump insert strings for the whole database.
		Input:
			$dbName : database name.
			$tblForbVN : vector of forbidden table names.
			$colForbVN : vector of forbiden column name vectors indexed in table names!
	*/
	function wholeDtbStr($dbName,$tblForbVN=false,$colForbVN=false){
		$aSql= &$this->aSql;
		$tools= &$this->tools;
		
		$sep= $tools->binLoads( $this->getGenVar('mySqlSeparator'), '' );
		if ($sep!==''){
			$sep= _c_R.$sep._c_R;
		}

		$v= $aSql->onlyTblNames($dbName);					
		$buff= '';
		reset($v);
		foreach ($v as $key=>$fstElem){
			if (!$tools->aIsInV($fstElem,$tblForbVN)){
				if ($tools->aIsInV($fstElem,$colForbVN)){
					$vectForbCol= $colForbVN[ $fstElem ];
				}else{
					$vectForbCol= false;
				}
				$buff.= $this->colNamesAndValToDump($fstElem,$sep,$vectForbCol)._c_R.'# Dumping data'._c_R._c_R;
			}
		} // while
		return $buff;
	} // wholeDtbStr

						
	/**
		Returns a vector holding all the column names of the table.
		Can be used to display and edit tables.
			$tbl : the concerned table name.
			$dbName : concerned database name !!! Not the classitself Couls have many
	*/	
	function tblColumnNames($tbl,$dbName){
		$aSql= &$this->aSql;
		return $aSql->tblColumnNames($tbl,$dbName);
	} // tblColumnNames
			

	/* -----------------------------------------------------------------------------------------
	*/
	function slctResource($table,$condition='',$column='*',$orderColN='',$curOrder=false){
		$aSql= &$this->aSql;
		return $aSql->selectResource($table,$condition,$column,$orderColN,$curOrder);
	} // slctResource
	
	/**
	*/
	function limitedRowSet($table,$start,$span, $condition='',$column='*',$orderColN='',$curOrder=false){
		$aSql= &$this->aSql;
		return $aSql->limitedRowSet($table,$start,$span,$condition,$column,$orderColN,$curOrder);
	} // limitedRowSet
	/*
	------------------------------------------------------------------------------------------"/
	
	/**
	*/
	function fetchAry(&$query){
		$aSql= &$this->aSql;
		return $aSql->fetchArray($query);
	} // fetchAry
	
	
	function maxColValue($tblNm,$colNm){
		$aSql= &$this->aSql;
		return $aSql->maxColValue($tblNm,$colNm);
	} // maxColValue
	
	/**
		Complete a partial [field]=value vector into a vector having all the fields
		Input:
			$fieldVect : vector of field names
			$infVect : vector of information indexed in field names.
			$storedComments : so empty values do not ecrase other language translations stored at a previous step.
	*/
	function fullFieldedV(&$fieldVect,&$infVect,&$storedComments){
		reset($fieldVect);
		foreach ($fieldVect as $i=>$field){
			if (array_key_exists($field,$infVect)){
				$newV[$field]= $infVect[$field];	
			}else{
				if (is_array($storedComments)){
					$newV[$field]= $storedComments[$field];
				}else{
					$newV[$field]= '';	// fills an empty vector gap	
				}
				
			}
		}
		return $newV;
	} // fullFieldedV


	/**
	*/
	function countNbRows($table){
		$aSql= &$this->aSql;
		return $aSql->countNbRows($table);
	} // countNbRows

	/**
	*/
	function cntNbRows($tblN,$fields,$val){
		$aSql= &$this->aSql;
		return $aSql->cntNbRows($tblN,$fields,$val);
	} // cntNbRows


	/**
	*/
	function testDTB(){
		$aSql= &$this->aSql;
		$aSql->testSQL();
	} // testDTB


	/**
		Return true if we are running a 100% Php database
	*/
	function centPcPhpDtb(){
		return _c_CurrentDtbAbstract===true;
	} // centPcPhpDtb
	
	/**
	*/
	function tableExists($tblN){
		$aSql= &$this->aSql;
		return $aSql->tableExists($tblN);
	} // tableExists
	

	/**
		To differentiate it easily from its sql inner twin
	*/
	function identity(){
		$aSql= &$this->aSql;
		return $aSql->identity();
	} // identity
	

	/**
	*/
	function pageExist($pg){
		$aSql= &$this->aSql;
		return $aSql->recordExists(_c_GenVarTbl, $this->condId($pg) );
	} // pageExist

} // localDB
?>