<?php
/**
	File name : rightsMg.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Rights manager, to manage :
		- access to the password box.
		- the password itself.
		- the hash used to send forms.
		
	Generalities :
		Everytime a password is used, a unique hash is generated, to allow the mixed combination 
		of hash&password to network-travel safely enough.
		
	Security : avoiding eviction with double click is link to an increase security risk because of an old
	cook3 laying arround! Temporised removal of the old-cook3 in this context seem out of raisonnable reach
	for now. So can let the user choose between 2 modes :
		safest : only one coo3 in the queue, uisefull for long edition session.
		fastest : 2 cook3 in the queue, usefull for quick edition spurts when old cook3s are quickly reoved by
		the new information.
	
	Important :
		$glob->cndtWrRghts
		
	Improvment :
			Look for the tag speedItUp
*/
class rightsMg extends oTop{
	

	function __construct(&$asa){
		parent::__construct();
		$this->asa= &$asa;
		
		$this->glob= &$asa->glob;
		$this->tools= &$asa->tools;
		$tools= &$this->tools;
		$this->acc= &$asa->acc;
		$this->fls= &$asa->fls;
		$this->caps= &$asa->caps;
		$this->hPwC= &$asa->hPwC;
		$this->aSql= &$asa->aSql;
		$this->dtb= &$asa->dtb;
		$dtb= &$this->dtb;
		$this->topH= &$asa->topH;
		
				
		$this->wRights= false;	// Just a short-cut
		$this->gotAWmStepIncr= false;

		/**
			Could easily be changed to be sniffer furtif with random strings.
		*/
		define('_c_passwordNm', 'passwordVBxN');	// password box name (and url variable)
		define('_c_pSubButtNm', 'submit');		// password submit button name
		define('_c_ckPwFormNm', 'passForm');	// check password form name
		define('_c_hashStdSize', 20); 			// The standard size of all the used HASHES (rem : hashes are not stored as a cookies but crypted combination are)
		define('_c_userIdCook', 'cUserName');	// user cookie name. in fact will match a value store under _c_userId
		define('_c_c2PwCook', 'c2PwdCook');		// c2PwCook : crypted password cookie name (client JS at login times)
		define('_c_c3PwCook', 'c3PwdCook');		// c3PwCook : name defined in the class hashPwCrypt comments (client JS each times)

		
		
		$this->correctCPwVal=false;
		$this->gotNervClic=false;
		$this->lazyConnected= _c_ko;
		

		/**
			Rem : these constants have _c_ckUniqPrfx added directly when on the php side, it's added via tools::spc()
		*/
		$bUniq= $this->tools->uniqueEdtStr();
		define('_c_ckUniqPrfx', $bUniq._c_UsrDbName);	// "cookie" unique prefix per database and user
		define('_c_primHashNm', _c_ckUniqPrfx.'primHashNm');	// name of the 1st successful used hash	name (used in case of password modification)	
		define('_c_c2JsPwCook', _c_ckUniqPrfx._c_c2PwCook);		// c2PwCook : crypted password cookie name (client JS at login times)
		define('_c_c3JsPwCook', _c_ckUniqPrfx._c_c3PwCook);		// c3PwCook : name defined in the class hashPwCrypt comments (client JS each times)
		
		$this->existingUID= array();	// an aray to speed the work of userIdExists() but could have loaded fully at the start!
		$this->gotFirstUnlogRqst= false;
	} // construct
	
	/**
		Seting the globalvariable $this->forceEditRights
		It can0t be set inside the constructor because the SQL daeabase is not ready, so
		set it in centraCl just after full activation.
	*/
	function setForceEditRights(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$statAvoidMode= $tools->gostVal(_c_statsAvoidUVar) !== false; // so also used to surf as a no rights user!
		$editRfaLatch= $dtb->getGenVar('editRfaLatch')==='crazy';
		$editRightForAll= $dtb->getGenVar('editRightForAll') === _c_ok;
		$this->forceEditRights= $editRightForAll && $editRfaLatch && !$statAvoidMode;
	} // setForceEditRights
	
	/**
		General function to test the two webmaster anticipated possibilities of forcing editing rights :
			#1 : url var/val couple if allowed. #2 : database values if allowed
	*/
	function frcEditRights(){
		$tools= &$this->tools;
		if (_c_allowNoPwMode===_c_ok && _c_easyRebootFromBkp===_c_ok){
			// #1 : Forcing edition rights (if explicitelly allowed) through a url specific variable and value are given
			$val= $tools->getVal(_c_nPwModeUVar);
			$result= $val===_c_nPwModeUVal;
			if ($result===true && $this->forceEditRights===false){
				$this->forceEditRights= $result;
			}
			return $result;
		}
		
		// #2 : database values if allowed
		return $this->forceEditRights;	// the hard coded option	
	} // frcEditRights
	
	
	/**
		Quick webmaster right, return a boolean!
	*/
	function quickWMRight(){
		return $this->wRights || $this->forceEditRights;
	} // quickWMRight
	
	
	/**
		Fast connection test when the connection status can't change during the same php process !!!!
		!!!!!!! quickWMRight() may replace it
	*/
	function lazyConnected(){
		if ($this->lazyConnected===_c_ko){
			$this->lazyConnected= $this->pwCheck3();
		}
		
		return $this->lazyConnected;
	} // lazyConnected
	

	
	
	/**
	*/
	function addTagsFu(&$tagsFu){
		$this->tagsFu= &$tagsFu;
	} // addTagsFu
	
	/**
		Get the auto crypted password _c_cPwServer from the database
	*/
	function getCryptedPw($userId){
		$dtb= &$this->dtb;
		return $dtb->getElem( _c_UsersTbl,_c_userId,$userId,_c_cPwServer);		
	} // getCryptedPw
	
	
	/**
		Set the session key
	*/
	function setCryptedPw($userId,$val){
		$dtb= &$this->dtb;
		$dtb->setElemNoMlCd(_c_UsersTbl, _c_cPwServer,$val, _c_userId,$userId);
	} // setCryptedPw
	
	
	/**
		Just surf mode (large meaning), includes also the display of the password form.
		This allows to accelerate password control (don't need to control because just surfing).
		Used in combination with a real password control if false, this will give THE actual
		way to be sure someone is surfing or not.
		
		So to be absolutly sure some body is surfing without edition right or interference, use :
			if (!pwCheck3()){
				// 100% surf
			}
	*/
	function justSurfMode($allowURT=true){
		return !$this->passCookIsSet($allowURT);
	} // justSurfMode
		
	/**
	*/
	function requestPwForm(){
		$tools= &$this->tools;
		return $tools->getVal(_c_pwLogBoxReqst)===_c_pwLogReqstVal;
	} // requestPwForm
	
	
	/**
		General password checker Form :
		Output :
			Returns :
				true if the password is correct, then display the whole interface.
				false if the password is not correct or not given, then display the surf mode.
				'fm' if a proper form request was done.
			$pwForm : the password html form. 
	*/
	function genPwCheck(&$pwForm){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$acc= &$this->acc;
		$caps= &$this->caps;
		$hPwC= &$this->hPwC;
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;
		$topH= &$this->topH;
		$firstLogPoss= false;	// if true ---> possibility of a 1st log
		
		
		/*
			If get same js-hash3 (nervous clicks on the same buttons) in rows, just KEEPS THE LAST GENERATED HASHj.
			Easiest way and secure enough (exceptional rows + fast + normalized on next useful click).
		*/
		$userId= $this->realTimeUserId();
		if ($userId===_c_defRegUser && _c_vaLoginRequest===false){
			return false;	// default fake user
		}
		
		if (!$this->userIdExists($userId)){
			return false;
		}
		
		if ( $userId!=='' && ( !_c_guestOnlyAccess || $userId===_c_guestUserId ) ){
			$dtbCpw= $this->getCryptedPw($userId);	// _c_cPwServer
		}else{
			$dtbCpw= false;
		}

		$userC3Pw= $tools->spcCookVal(_c_c3PwCook);	// $this->realTimeC3PwCookVal()  // do not substitutes
		$cGLB= $tools->binLoads($tools->getVal('callGuestLogBox'),_c_ko);
		$guestServerPw= $this->getCryptedPw($userId);	// in this case non crypted server password for the guest
		
		if ( $userId===_c_guestUserId && ($cGLB===_c_ko || $guestServerPw===$userC3Pw) ){
			$pwUrlVal= $tools->getVal(_c_pwBoxUrlVar);
			if ($pwUrlVal!==false){
				return false;	// must not use the standard access!
			}
			
			// short-cut for the guest
			define('_c_guestIsLogged', $guestServerPw===$userC3Pw);

			$sgRpg= $dtb->getGenVar('specGuestRightsPg');
			$specPgVect= $tools->mbExplodeAndTrim($sgRpg);
			$pgNm= $tools->getVal(_c_urlPageVar);
			if (in_array($pgNm,$specPgVect)){
				$glob->cndtWrRghts= true;	// exceptionally true for the contact form so the captcha hash can be written
			}else{
				$glob->cndtWrRghts= false;	// any writting fully forbidden)
			}
			
			if (_c_guestIsLogged){
				return true;
			} // else KEEP GOING
			
		}else{
			define('_c_guestIsLogged', false);
			$glob->cndtWrRghts= true;	// --> we are able to write if logged correctly
		}

		$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars	
		$origTopHshId= $topHshId;	// for cookies capability test
			
		
		$nbSteps= $dtb->pGetGenVar('nectWmStepsNb',0);
		if ($nbSteps>1 && $dtb->getGenVar('useBrwsrBackButton')===_c_ok){
			$primPrimHash= $this->serverPrimHash($topHshId);
			$primaryHash= $primPrimHash;
		}else{
			// CALCULATE THE NEW HASH VALUES
			$primPrimHash= $hPwC->newHashStr(_c_hashStdSize);	// Calculates the hash to crypt	
			$primaryHash= $hPwC->newHashStr(_c_hashStdSize);	// Calculates the new hash
		}
				
	
		if ($topHshId!==false && $dtb->elementExists(_c_topHashIdH, $topHshId, _c_topHashTbl)){
			// Got a cookie and the record exists			
			$hashOrdId= $topH->getOrdIdFromHash($topHshId);		
			$topH->updateHashRecord($hashOrdId,$topHshId,$userId,$primaryHash,$primPrimHash);
		}else{
			// Hasn't got a cookie, so creates a new hash record if asking for logging
			if ($tools->getVal(_c_pwLogBoxReqst)===_c_pwLogReqstVal){		
				$hashOrdId= $topH->freeOrdID();
				$tools->spcSetCook('ckSessOrdId',$hashOrdId,1);		// session ordinal id
				$topHshId= $hPwC->newHashStr(_c_hashStdSize);
				$tools->spcSetCook('ckTopHashId',$topHshId,1);	// real hash 20 chars
				$tNb= (int)$dtb->getGenVar('topHashTrialNb');
				$i= 0;
				do{
					$nhr= $topH->newHashRecord($hashOrdId,$topHshId,$userId,$primaryHash,$primPrimHash);
					$i++;
				}while ($nhr!==true && $i<$tNb);
				
				if ($i===$tNb){
					// Does a general purge, erasing the whole content of _c_topHashTbl. Could have a more subtle approch, erasing only the old ones.
					$aSql->truncTbl(_c_topHashTbl);
				}
				
				$topH->incrFreeOrdId();	
			}
		}
		
		$this->userNm= $userId;	// copy to use in function calling $this->correct..CPw()
		if ($dtbCpw!==false){
			if ($this->pwCheck3()){
				$c2PwServer= $topH->getSessionKey($topHshId);	
			}else{
				// Still unlogged --> calculates server side $c2PwServer that should match c2PwCook to be ready for crypted-comparison and storage for following crypting if a match is obtained.
				$dtb->setGenVar('chgPwVisSmplSurf',_c_ko);	// hide the password change page again.			
				$oldPPHsh= $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashOldPPH);
				$c2PwServer= $hPwC->doCrypt($oldPPHsh,$dtbCpw); // crypts $oldPPHsh with dtbCpw.
				$topH->setSessionKey($topHshId,$c2PwServer);
				$firstLogPoss= true;
			}
		}
		
		$corrCPw= $this->fuCorrectCPw($userC3Pw);
		if ($corrCPw && $firstLogPoss){
			$topH->eliminatesOneDayOld();
		}
				
		if ($this->requestPwForm() || $corrCPw){
			// Interpretation of the If :  Requesting a logging form || Got a correct crypted password.
			if ($corrCPw){
				// Client <-----------[hashI]	------- Serveur	(hpcu1)
				$sPgLoadN= $tools->spcCookVal('sPgLoadN','1');		// Read cookie value : numerical state page load Now.
				$sPgLoadN++;
				$tools->spcSetCook('sPgLoadN',$sPgLoadN);			// Writes cookie value.
				
				$jsAddition='';
				if ($this->conditionalDebug){
					$jsAddition.= _c_R.'genAsa.resetWriteLn();';	// for debugging purpose
				}
			
				// FormatJSFu : Crypts c3PwCook at the start of the page
				$jsAddition.= _c_R.$caps->jsSimpleFu('genAsa.createsC3PwCook',3,0,_c_ckUniqPrfx,$primaryHash,_c_c3JsPwCook).';'._c_R;
				$glob->setGlobJsCode($jsAddition);
			}
		}
		
		$requPwForm= $this->requestPwForm();		
		if ($requPwForm && !$corrCPw || $tools->getVal(_c_userIdNm)!==false ){
			$this->setWmSteps('0');
		
			if ($this->frcEditRights()){
				$mess= $glob->el('Sorry you are logged by default...','kboq');
				print($mess);
				return true;
			}
			
			// To display the password interface
			$arLog['forceUnqStr']= true;
			$url= $tools->urlCurPg($arLog);
			
			$url.= $tools->addUrlVar(_c_pwLogBoxReqst,_c_pwLogReqstVal);
			$url.= $tools->stdUrlStringAdd(_c_surfEdt);
			$url.= $tools->stdUrlStringAdd(_c_edtLang);
			
			$pwForm= '';
			$loginNb= $tools->getVal(_c_loginTrialVar);
			if ($origTopHshId===false && $loginNb>1){
				$pwForm= $caps->span($glob->sl('Please set your browser to allow the Cookies!','kbbk'),'userError')._c_._c_;
			}
			
			$jsUnlg= $caps->jsSimpleFu('genAsa.unlog',2,0,_c_urlUniqEdtPfx,_c_c3JsPwCook).';'._c_R;
			$pwForm.= $glob->setHeadGlobJsCd($jsUnlg);	// security unlog before asking a new password !!
			
			$cmsNm= 'Ataox';	// $cmsNm= $dtb->getGenVar('apparentCmsName');
			$cmsLnNm= $caps->hL('http://www.ataox.org',$cmsNm,'editTtl','_blank');
			$pwForm.= $caps->eLabel($glob->el('Welcome on ','kabj')._c_siteUrlStample.' / ','editTtl').$cmsLnNm._c_BrFlux._c_BrFlux;
			
			$tagsFu->title($glob->el('Welcome on ','kabj').$cmsNm,'self');
			
			
			if ($this->gotOffendingUnzipper()){
				$pwForm.= $caps->eLabel($glob->el('LAST STEP : for security reasons ... disable the unzipper!','katn'),'userError')._c_BrFlux._c_BrFlux;
			}
			
			if (_c_guestOnlyAccess){
				$guestPw= $dtb->getElem(_c_UsersTbl, _c_userId,_c_guestUserId, _c_cPwServer);	// not crypted in that case!
				$pwForm.= $caps->span($glob->el('You are using the guest interface ... enter your id','kaap').' : ','nL');
				$pwForm.= $caps->span(_c_guestUserId,'nLB');
				$pwForm.= $caps->span($glob->el(' and your password','kabh'),'nL');
				$pwForm.= $caps->span($guestPw,'nLB');
				$pwForm.= $caps->span($glob->el(' to see how this CMS works.','kabi'),'nL')._c_BrFlux._c_BrFlux;
			}
						
			$userId= $this->realTimeUserId();
			$pwForm.= $caps->eLabel($glob->el('User Id : ','kabk')).$caps->textBox(_c_userIdNm,$userId,16)._c_BrFlux;						
			$pwForm.= $caps->eLabel($glob->el('Password : ','kabe'));
			
			$defPw= $tools->binLoads($tools->getVal(_c_passwordNm),'');
			
			
			$pwForm.= $caps->div($glob->el('If you can read this message ... JAVASCRIPT is disabled!','kbbl'),'userError','divForJsTest');
			$pwBoxTxt= $caps->passwordWdg(_c_passwordNm,$defPw,16);	
			$jsSetHtml= $caps->jsSimpleFu('kk.setInnerHtml',2,0,$pwBoxTxt,'divForJsTest');
			$pwForm.= $caps->jsTag($jsSetHtml);
			
			
			
			$pwForm.= $caps->hiddenWdg(_c_gotLoginForm,_c_ok);	// not used, just a marker!
					
			/*
				FormatJSFu : onclick/submit : need to create a cookie with [hash1*cpw] JS crypted, so needs also 
				to check JS side crypting.
			*/
			$fuC2PwCook= $caps->matCss('ln');
			$fuC2PwCook.= $caps->jsFunctCallStr('onclick','genAsa.createsC2PwCook',5,0,_c_passwordNm,_c_ckUniqPrfx,$primPrimHash,$primaryHash,_c_c3JsPwCook);
			$pwForm.= _c_BrFlux._c_BrFlux.$caps->submit(_c_pSubButtNm,$glob->el('Send','kaat'), $fuC2PwCook);
			
			if (_c_guestOnlyAccess){
				$pwForm.= _c_BrFlux._c_BrFlux.$caps->span( $glob->el('Remarks : at the opposite of all other users ...','kaaq') );
			}
			
			if ($userId!==_c_guestUserId){
				$pwForm.= _c_BrFlux._c_BrFlux._c_BrFlux;
				$pwForm.=  $caps->eLabel($glob->el('Change the editor language : ','kmgo'));
				$pwForm.=  $caps->chgEditLanguage('nL');
			}
			
			$guestkk= $tools->getVal('callGuestLogBox');
			if ($guestkk===_c_ok){
				$url.= $tools->addUrlVar('callGuestLogBox',$guestkk);
			}
			
			$pwForm= $caps->form($url,_c_ckPwFormNm,$pwForm);
			
			$stl= 'float:left; padding:2%; margin:4%; min-width:250px; width:40%; border:5px solid blue; background-color:white';
			$pwForm= $caps->sDiv($pwForm,$stl);
			
			$retVal= 'fm';	// to display the pw form without any site content
		}else{
			$retVal= $this->pwCheck3();
		}
		
		return $retVal;
	} // genPwCheck
		

	/**
		True if the password is okay. MUST BE USED IN PRIORITY on the method fu..CorrectCPw(), because faster.
			Direct check of the password combined with the current hash.
			Returns true if the password is correct.
			Can speedItUp with a global variable!
			Input :
				$quickCheck : true if we want a quick check
				$allowURT : true if we allow unlog request tests.
	*/
	function pwCheck3($quickCheck=true, $allowURT=true){
		$tools= &$this->tools;	
		$dtb= &$this->dtb;	
		$dtb= &$this->dtb;	
		$topH= &$this->topH;
		
		if ($this->frcEditRights()){
			$this->wRights= true;
			return true;
		}
		
		// $cCPW : boolean state of the webmaster connection depending on crypted passwords
		
		if (!$this->wRights){
			$noR= $tools->getVal(_c_testNoRight);
			if ($noR===_c_ok){
				$cCPW= false;	// force the surf mode
			}else{
				if ($this->justSurfMode($allowURT) && $quickCheck){
					$cCPW= false;	// just the surf mode
				}else{
					// may have a correct password and therefore got to display the editing interface
					$userId= $this->realTimeUserId();					
					if ($userId===_c_forbidUserId || $userId==='ersatzid' || $userId==='idMark'){
						return false;
					}
					
					$uies= $this->userIdExists($userId);
					$userC3Pw= $this->realTimeC3PwCookVal($allowURT);
				
					if ($userId===_c_guestUserId){
						$pwUrlVal= $tools->getVal(_c_pwBoxUrlVar);
						if ($pwUrlVal!==false){
							return false;	// must not use the standard access!
						}
					
						// Short circuit for the guest
						$guestServerPw= $this->getCryptedPw($userId);	// in this case non crypted server password for the guest
						$cCPW= $userC3Pw===$guestServerPw;
						if ($cCPW){
							$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars		
							$this->setJsGestVariables();
						}
					}else{
						// not the guest Id
						$pwUrlGVal= $tools->getVal(_c_pwGuestLBoxR);
						if ($pwUrlGVal!==false){
							return false;	// only the guest Id can use the _c_pwGuestLBoxR url variable
						}
					
						$fccpw= $this->fuCorrectCPw($userC3Pw);
						$cCPW= $uies && $fccpw;
					}
				}
			}
			
			if ($cCPW){
				// could still forbid the connection
				if ($this->gotOffendingUnzipper()){
					$cCPW= false;
				}
			}
			
			$this->wRights= $cCPW;	// a "proxy"  (state of the connection, always a boolean)
			$ret= $cCPW;
		}else{
			$ret= true;
		}
		
		if ($ret===true && !$this->gotAWmStepIncr){
			$nbSteps= $dtb->pGetGenVar('nectWmStepsNb',0);
			$nbSteps++;
			$this->setWmSteps($nbSteps);
			$this->gotAWmStepIncr= true;
		}
		
		return $ret;
	} // pwCheck3
	
	/**
	*/
	function setWmSteps($nbSteps){
		$dtb= &$this->dtb;
		$dtb->pSetGenVar('nectWmStepsNb',(string)$nbSteps);
	} // setWmSteps

	
	/**
	*/
	function gotOffendingUnzipper(){
		$fls= &$this->fls;	
		return $fls->fileExist('./unzip/unzipMain.php');
	} // gotOffendingUnzipper
	

	/**
	*/
	function setJsGestVariables(){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		/*
			Rem : he guest password id not crypted because :
				not necessary public / faster / can use the back button fully on any browser / does not
				saturate the ring of hash that could eject higher users!
		*/
		$pw= $dtb->getElem(_c_UsersTbl, _c_userId,_c_guestUserId, _c_cPwServer);	
		$js= $caps->jsSimpleFu('kk.guestVarAccess',2,0,$pw,_c_guestUserId)._c_R.';';
		$glob->setHeadGlobJsCd($js);
	} // setJsGestVariables
		

	
	
	/**
		Server old primary hash, it is actually the hash to compare with what's being received from the browser.
	*/
	function serverOldPrimHash($topHshId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashOldPH);
	} // serverOldPrimHash
	
	function serverPrimHash($topHshId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashPPH);
	} // serverPrimHash
	
	
	
		
	/** 
		Returns true if _c_c3PwCook calculated on the client side matches any hash stored under _c_hashStr,
		and deduce from that that (1) the given password was correct.
		Input :
			$userC3Pw : the fully crypted & stored hash calculated on the user cookie side, compare it as it is.
	*/
	function fuCorrectCPw($userC3Pw){
		$hPwC= &$this->hPwC;
		$aSql= &$this->aSql;
		$tools= &$this->tools;	
		$dtb= &$this->dtb;
		$topH= &$this->topH;
		
		if ($this->correctCPwVal===true){
			return true;	// necessary because of the hash deletion
		}
		
		$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars		
		$curSessKey= $topH->getSessionKey($topHshId);		// Server side session key !!!!!
		if ($curSessKey===_c_ko || $curSessKey===''){
			return false;
		};		
		
		if ($this->unlogRequest()){
			// uses fresh hash because did not generate a new one and shift (no time because the call is done as early as possible)
			$selectedPrmHash= $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashPH);
		}else{
			$selectedPrmHash= $this->serverOldPrimHash($topHshId);
		}
		
		$c2PwServer= $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashC2Pw);
		$c3PwServer= $hPwC->doCrypt($selectedPrmHash,$c2PwServer);		
		if ($userC3Pw===$c3PwServer){
			$topH->flagOkStatus($topHshId);
			$this->correctCPwVal= true;
			return true;	
		}else{
			/*
				An unlog state, but managed to have an existing session cookie so it could be :
					- Someone trying to get in edition state and not managing it.
					- Someone who was loggeg and got ejected through double click, and it's only in that case
					  that cleaning up was a good idea to avoid trailing hashes! Solutions :
					  	- Just try to avoid ejection! It ejects because it asks twice+ the same order in a row, with 
					  	the same hash cookie set (the browser did not get the new hash to update), so could at the
					  	server level filter identical requests and respond fully to the 1st one + not doing any.
					  	---> When having 2 identical demands in a row (from the same page, so before), don't changes the server parameters, and
					  	send back the same thing, but just execute the 1st one do not execute order of the others -->
					  	Just got to cut the data base accesibility!
					  	---> looks like a mixing staff in the javascript part that can't follow the double click,
					  	may be building, probably starting again cookie building when the 1st one is not finished,so mixing values !!!!!
					  	hashes update for the next one. No so secure!
					  	- Could allow ejection but be stricter.
			*/
			$this->correctCPwVal= false;
			return false;
		}
	} // fuCorrectCPw
	
	/**
	*/
	function curSessKey(){
		$tools= &$this->tools;	
		$topH= &$this->topH;
		
		$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars		
		return $topH->getSessionKey($topHshId);		// Server side session key !!!!!
	} // curSessKey
	
		
	/**
		Return true if the user just unlogged !
	*/
	function unlogRequest(){
		$tools= &$this->tools;
		
		if ($this->gotFirstUnlogRqst){
			return true;
		}else{
			$Urq= $tools->getVal(_c_unlogUrlVar)===_c_ok;
			if ($Urq && $this->quickWMRight()){
				$this->gotFirstUnlogRqst= true;
				$this->unlogCleanUpCore();
				return true;
			}else{
				return false;
			}
		}
	} // unlogRequest
	
	
	/**
	*/
	function unlogCleanUpCore(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$this->setWmSteps('0');
		$this->correctCPwVal= false;
		$this->rmCurIdTopHashTbl();
		$js= $caps->jsSimpleFu('genAsa.unlog',2,0,_c_ckUniqPrfx,_c_c3JsPwCook).';'._c_R;
		$glob->setGlobJsCode($js);		
		$curOrdId= $tools->spcCookVal('ckSessOrdId');
		$this->wRights= false;	
	} // unlogCleanUpCore

	
	/**
		Removes the current Id of the topHashTbl.
	*/
	function rmCurIdTopHashTbl(){
		$dtb= &$this->dtb;
		$userId= $this->realTimeUserId();
		$dtb->deleteAll(_c_topHashTbl, _c_topHashUserId,$userId);		
	} // rmCurIdTopHashTbl

	
	/**
		Conditional unlog cleanup.
	*/
	function condUnlogClnUp(){	
		if ($this->unlogRequest()){
			if ($this->pwCheck3(true,false)){
				$this->unlogCleanUpCore();
			}
		}
	} // condUnlogClnUp
	
	
	/**
		The pure surf mode (most common) for a user who did not use or tried to use the edit mode.
	*/
	function absoluteSurfMode(){
		return $this->justSurfMode() && !$this->requestPwForm() && !$this->wRights;
	} // absoluteSurfMode
		
	
	/**
		Detects the (edit/surf) state along the following conditions :
			$tools->spcUTrigCook()
				- click on the "bottom" editor button.
				- registration of the editing state with a cookie.
			Direct true state just after a successful logging.
			
		Returns true if the editor need to be displayed.
	*/
	function gotToDsplEditor($forceSurfMd= false){
		$tools= &$this->tools;
		
		if ($forceSurfMd===true){
			return false;
		}
		
		$logged= $this->pwCheck3();	
		$surfEdt= $tools->gostVal(_c_surfEdt,_c_seSurfVal);
		return $logged && ($surfEdt===_c_bthEditVal || $surfEdt===_c_seEditVal);
	} // gotToDsplEditor


	/**
	*/
	function editorState(){
		if ($this->gotToDsplEditor()){
			return _c_seEditVal;
		}else{
			return _c_seSurfVal;		
		}
	} // editorState

		
	/**
		Returns true if a password cookie is set. So avoid expensive password testing when users are not connected.
	*/
	function passCookIsSet($allowURT=true){
		$c3PwCook= $this->realTimeC3PwCookVal($allowURT);
		if ($c3PwCook===false){
			return false;
		}else{
			return true;
		}
	} // passCookIsSet
	
	
	/**
		Real time crypted password cookie value.
		Input :
			$allowUR : allow unlog request test if true (default)
	*/
	function realTimeC3PwCookVal($allowURT=true){
		$tools= &$this->tools;
		
		if ($allowURT && $this->unlogRequest()){
			return false;
		}else{
			return $tools->spcCookVal(_c_c3PwCook);
		}
	} // realTimeC3PwCookVal
	
			
	/**	
	*/
	function realTimeUserId(){	
		$acc= &$this->acc;		
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		if ($this->forceEditRights===true){
			if ($dtb->elementExists(_c_genVarId, 'forcedAccessUsrId', _c_GenVarTbl)){
				return $dtb->getGenVar('forcedAccessUsrId');
			}else{
				return _c_reservedUserId; 	// special installation!
			}
		}

		$userNm= $tools->gostVal(_c_userIdNm);
		if ($userNm!==false){
			$userId= $acc->safeIdStr($userNm);
			$tools->spcSetCookOnce(_c_userIdCook,$userId);
			return $userId;
		}
		
		if ($userNm===false){
			$userNm= $tools->spcCookVal(_c_userIdCook);
		}

		if ($userNm===false){
			$userNm= _c_defRegUser;
		}
		
		return $userNm;
	} // realTimeUserId

	
	/**
		Returns true if the current user got Super User rights. In fact just a few more little rights 
		wmSuFrill() !! And all the rights are defined with the class cntrXRight !
	*/
	function suRights(){
		$tagsFu= &$this->tagsFu;
		$wmR= &$tagsFu->wmRights;
		
		return ($wmR->wmSuFrill() || $this->forceEditRights) && $this->pwCheck3();
	} // suRights

	
	/**
		Return true if it is at the root of the user home directory, for simple sites/configuration,
		all users root directories are identical to the all user data path === _c_UsrDataPath.
		Specific user data path --> _c_UsrDataPath.$userName
	*/
	function isAtRootUserDir($dir){
		return $dir===$this->userRootDataPath();
	} // isAtRootUserDir
	
	
	/**
		Could be completed for personal user diretories.
	*/
	function userRootDataPath(){
		return _c_UsrDataPath;
	} // userRootDataPath
	
	
	/**
		Could be atuned with the real user trash if non a common trash.
	*/
	function userDustPath(){
		return $this->userRootDataPath()._c_dustbinName;
	} // userDustPath
	

	/**
	*/
	function userIdExists($uId){
		if ( array_key_exists($uId,$this->existingUID) ){
			return $this->existingUID[$uId];
		}else{
			$dtb= &$this->dtb;
			$exist= $dtb->elementExists(_c_userId, $uId, _c_UsersTbl);
			$this->existingUID[$uId]= $exist;
			return $exist;
		}
	} // userIdExists


	/**
		User suffixed general variable
	*/
	function userSuffixed($prfx){
		return $prfx.'_'.$this->realTimeUserId();
	} // userSuffixed

	
	
	/**
		Check for different time depending action at the end-start of each script.
		Should see later to improve it :
			- general access for plugin developpers
			- use of a chron instead and/or combination!
			
		Now just checking for the class writeNowSendLater
	*/
	function checkTimeActions(){
		$dtb= &$this->dtb;
		$tagsFu= &$this->tagsFu;
		
		$varTm= $this->userSuffixed('wnslMostUTm');
		$valTm= $dtb->getGenVar($varTm);
		if ($valTm===false){
			return false;
		}
		
		$curTm= time();
		if ($valTm!==_c_ko && $curTm>=$valTm){
			$varId= $this->userSuffixed('wnslMostUrg');
			$valId= $dtb->getGenVar($varId);
			
			$clssNm= 'writeNowSendLater';
			if (array_key_exists($clssNm,$tagsFu->explicitClasses)){
				$curCls= &$tagsFu->explicitClasses[$clssNm];
			}else{
				include _c_toDeclPlugExt.$clssNm.'/'.$clssNm.'.php';
				$curCls= new $clssNm($tagsFu);
			}
		
			$curCls->justInTimeEMail($valId);
		}		
	} // checkTimeActions
	
	/**
	*/
	function chabl(){
	
	} // chabl
	
	
} // rightsMg
?>
