<?php
/**
	File name : tagsFu.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Standard xPetal tags :
		[incl ref="namedVariable" /] 
		[zm src="apple.jpg" alt="golden" /]
		[menu pg="home"] Home [/menu]
		
	General xml considerations :
		What's the point of having a body string { [tag] body [/tag] } instead of using only heads arguments :
			- Fondamental for easy tags imbrication.
			- Conventionnaly the body part is often the most important part and arguments act on it.
			- For human lisibility clear tagging arround body is easy to read.
			- The delimitation being done with [/...] there is more freedom of characters inside the body itself.
			- To avoid name conflict with internally defined tag, tags defined by third party must have the _t
			  suffix _t to avoid being overloaded by tags defined inside this method and name conflict with
			  other classes.
			
	Cascading style sheets name conventions for parameters :
		$cls : to pass a style already defined inside a separated CSS (already declared or declaration as a separated matter)
		$stl : a style fully defined within the parameter (font-family:Arial; font-style:normal; ... etc.)
			
	Bookmarks :		
		instExplitCentralCls()
		instExplitExternalCls()
		rebuildTagStr()
		checkAndNormalise()
		
		
		$this->curLocalPath='';	
		n tg_bf(
*/
class tagsFu extends oTop{
	

	function __construct(&$asa){
		parent::__construct();
		
		$this->asa= &$asa;		
		$this->glob= &$asa->glob;	// to store some global variables
		$this->tools= &$asa->tools;	// hetereogenous tools
		$this->acc= &$asa->acc;		// conversion / standardization for display and ressources management		
		$this->caps= &$asa->caps;	// to pass to easier to manage classes that don't inherit capsHtml (should dig this one too)	
		$this->fls= &$asa->fls;		// file manager
		$this->aSql= &$asa->aSql;
		$this->mainAdvertPlugIn= false;  // init here to false, but may be instantiated if necessary
		
		$this->rMg= &$asa->rMg;		// right manager
		$this->rights= &$asa->rMg;	// twin !!!
		
		$this->dtb= &$asa->dtb;		// database manager
		
		$this->dtbCmpl= null;		// complemetary DTB class used when dumping directly in 100% Php
		
		$dtb= &$this->dtb;
		$this->topH= &$asa->topH;	
		
		$this->pRnd= &$asa->pRnd;	
		$this->mbCrypt= &$asa->mbCrypt;	
		$this->hPwC= &$asa->hPwC;	// hashPwCrypt
		$this->initMT= &$asa->initMT;
		
		
		/* ----------------------------
			Class vectors
		*/
		$this->automClasses= array();		// implicit (declared implicitely/automatically) class vector
		
		/* Explicit [internal | external] (declared explicitely, rep _c_toDeclPlugins, so not automatically) class vector
		   --> Internal and External are together, should make sure new external one do not ecrase internal (diff name).
		   Actually identical names could coexist as long as they are not instanciated on the same page with expectation
		   to be accessed alternativelly which is easy to avoid.
		*/
		$this->explicitClasses= array();
		$this->libClasses= array();			// symeerical access
		$this->kernekClasses= array();			
		
		$this->libClasses['tools']= &$asa->tools;
		$this->libClasses['accents']= &$asa->acc;
		$this->libClasses['filesMg']= &$asa->fls;
		$this->libClasses['rightsMg']= &$asa->rMg;
		$this->libClasses['localDB']= &$asa->dtb;
		$this->libClasses['hashPwCrypt']= &$asa->hPwC;
		
		// Category abbreviation for relevant (need to facilitate the access and avoid redondancy) plugins or group of classes.
		define('_c_kernelKateg','kern');	// libraries
		define('_c_libClassCateg','lib');	// libraries
		define('_c_exiClassCateg','exI');	// explicit internal
		define('_c_exeClassCateg','exE');	// explicit external
		define('_c_impClassCateg','imp');	// implicit (the annoying implicit plugin category)


		/*
			Set to true if a tag is switched with another. Usefué when we want to extract tag information in a totally
			different way from the original (still in used specifications of the tag).
		*/
		$this->tagSubstActive= false;
		$this->tagSubstituteV= array();
		$this->redondanceFreeVect= array();
		
		
		// tg_setexpljs()
		$this->attribVect['setexpljs']= array('path','js');
		
		$this->attribVect['setexplcss']= array('path','css');
		
		
		
		// tg_setexplplugin()
		$inclV= array('path','name','except','flag');
		$this->attribVect['setexplplugin']= $inclV;
		$this->attribVect['extplugin']= $inclV;
		$this->attribVect['cenplugin']= $inclV;
	
		
		define('_c_tagFuPrfx','tg_');	// prefix for tag functions Call Back (php dynamic calling)
	
		/**
			Tags convention :
				- all in lower case on the programming side (so olist and not oList ... would not work)
				- free cases on the user side (oList is ok).
				- constants are define with each tag because :
					- at this level they are likely to used again internally (egt : for automatical menu building).
					- it's going to be used when building JS function for the user interface
					- it's much clearer to refer to from a long distance _c_tgUp is immediate and unique, when 'up' could be confusing.
					- uniqueness of constants give more security for uniqueness of tags.
		*/
							
		/**
			Branching between records.
		*/
		// tg_incl(), To includes a specific record to expand/parse etc. Default record taken from the cellPge table.
		define('_c_tgIncl','incl');		// [incl ref="namedRec" /]  [incl ref="namedRec" tbl="cellPge" /]
		$this->attribVect[_c_tgIncl]= array('ref','tbl');

		
		$this->attribVect['inclonce']= array('ref');
		
		$this->attribVect['onlyonce']= array('id');
		
		
		// tg_file(), To include a file from the local server directory
		define('_c_tgFile','file');	
		$this->attribVect[_c_tgFile]= array('path');
		
		$this->attribVect['sqlheaders']= false;
		
		
		// [inclCode id="" /]	n tg_inclCode
		define('_c_tgInclCd','inclcode');
		$this->attribVect[_c_tgInclCd]= array('id');
		
		
		/*
			tg_up() : Calls a surrounding record, looking for a plug tag to insert the already formated downward string.
			Could appear anywhere in the concerned page or as single value in a specific field, especially usefull when
			creators of the main information are not concerned with the hierachy. In case of competition between the 2 spots,
			the specific field (_c_pcUpCell) should win, avoïding unexperience users to scramble their hierachy of calls.
		*/
		define('_c_tgUp','up');	// [up ref="surrounding-string" /].
		$this->attribVect[_c_tgUp]= array('ref');
		
		// tg_deftgup() default _c_tgUp parameter for current page
		define('_c_defTgUp','deftgup');
		$this->attribVect[_c_defTgUp]= array('ref');		
		
		define('_c_tgPlug','plug');			// [plug /] : indicate where the calling record need to be plugged
		$this->attribVect[_c_tgPlug]= false;

			
		/**
			Menus
		*/
		
		// tg_defup()	[defUp up="topPeople" menup="rootmenu" /]
		define('_c_tgDefUp','defup');		
		$this->attribVect[_c_tgDefUp]= array('up','menup');
		
		
		// tg_divmen, divMenus : example : [divMen got="ko" cls="menuIndent" /]
		define('_c_divMenus','divmen');
		$this->attribVect[_c_divMenus]= array('got','cls');
		
		
		// tg_menufont , example : [menufont in="menuI2"  out="menuO2" /]
		define('_c_menuFont','menufont');
		$this->attribVect[_c_menuFont]= array('in','out');
		
			
		/**	
			Lists. (definition of lists, separator = '[*]' = _c_listBull).
		*/
		define('_c_tgList','list');			// [list cls="stylename"]  [*]one [*]two [/list] : given bullets = [*] 
		$this->attribVect[_c_tgList]= array('cls');
		define('_c_listBull','[*]');		// better not to have it look like a tag	
			
		define('_c_tgOList','olist');		// [oList cls="stylename"]  [*]one [*]two [/list].
		$this->attribVect[_c_tgOList]= array('cls');
		
		// tg_ul() : complement for html fan
		define('_c_tgUL','ul'); $this->attribVect[_c_tgUL]= array('cls','stl');	
		define('_c_tgOL','ol'); $this->attribVect[_c_tgOL]= array('cls','stl');
		
		$this->attribVect['li']= false;
		
		/**
			Simple html tags
		*/
		
		// tg_nbsp(),   [nbsp cls="" times="" /]
		$this->attribVect['nbsp']= array('cls','times');
		$this->attribVect['nsp']= false;
		
		// tg_var()
		$this->attribVect['var']= array('i');
		$this->attribVect['spiderf']= false;
		$this->attribVect['spideruf']= false;
		
		$this->attribVect['easypg']= array('name','cmpl','es','cls');
		
		define('_c_tgA','a');
		$aPar= array('url','insd','name','ttl','esttl','es','eb','sb','cls','fin','fout','norm','rel','follow','target','postvar','stopedit','opg');
		$this->attribVect[_c_tgA]= $aPar;	// tg_a(
		$this->attribVect['d']= $aPar;	// tg_d(
		$this->attribVect['page']= $aPar;	// tg_page
		$this->attribVect['epage']= $aPar;	// show the button only in edition mode
		$this->attribVect['pagelg']= $aPar;		
		
		$this->attribVect['tx']= array('es','expand');	// tg_tx
		$this->attribVect['surfexpand']= array('pg');
		$this->attribVect['inclspecpg']= array('pg');
		
				
		// tg_link()
		define('_c_tgLink','link');			// [link ref="thing-magic-page"]Big Things[/link] : does an hyperlink local or global.
		$this->attribVect[_c_tgLink]= $aPar;
		
		
		// tg_pwlink() 		[pwlink ttl="" cls="" ] Password Widgets [/pwlink]
		define('_c_tgPwLink','pwlink');			// [link ref="thing-magic-page"]Big Things[/link] : does an hyperlink local or global.
		$this->attribVect[_c_tgPwLink]= array('ttl','cls');
		
		
		$this->attribVect['logibox']= false;
		
		
		define('_c_tgTable','table');		// [table col="2" row="2"]  [*]one [*]two [*]three [*]four [/table] : given cells = [/] 		
		$this->attribVect[_c_tgTable]= array('col','row');
		
		// tg_div(). Basic tags.
		define('_c_tgDiv','div');	// [div cls="style"] .... [/div]
		$this->attribVect[_c_tgDiv]= array('cls','stl','id','sup', 'wcase','wmin','wmax','shunt_pg');
				
		
		$this->attribVect['headiv']= array('cls','stl','id');
		$this->attribVect['taildiv']= false;
		
						
		
		$this->attribVect['font']= array('cls','stl'); // same param as the above div for historical compatibility.
		
		
		// n tg_span()
		$spanV= array('cls','stl','ttl','x','es2','es','forcesl','lbl');
		$this->attribVect['span']= $spanV;
		$this->attribVect['label']= $spanV;
		$this->attribVect['elabel']= $spanV;
		
		// tg_pgtitle()
		$this->attribVect['pgtitle']= array('cls','stl','date','maxdeskw','bd');
		$this->attribVect['subttl']= array('cls', 'inline', 'bd');
		
		
		// tg_dat
		$this->attribVect['dat']= array('str','cls');
		
		$this->gotTitleMobBut= false;
		
		$this->attribVect['onlyedit']= false;
		$this->attribVect['onlysurf']= false;
		
		
		// Basic tags useful for forum security.
		define('_c_tgB','b');	// bold
		$this->attribVect[_c_tgB]= false;
		
		$this->attribVect['n']= false;
		
				
		define('_c_tgI','itc');	// italic
		$this->attribVect[_c_tgI]= false;
			
		define('_c_tgU','u');	// underline
		$this->attribVect[_c_tgU]= false;
	
		$this->attribVect['bf']= false; //  [bf/] tg_bf() : bf for break flux
		$this->attribVect['bg']= false;
		$this->attribVect['bfn']= array('n');
		
		$this->attribVect['btl']= false;
		$this->attribVect['btx']= array('n');
		
		
		
		$this->attribVect['br']= false; // [br/]  line break
		
		
		
		define('_c_tgLt','lt');		// < less than : [lt/], function tg_lt()
		$this->attribVect[_c_tgLt]= false;
		
		define('_c_tgGt','gt');		// > greater than [gt/], function tg_gt()
		$this->attribVect[_c_tgGt]= false;
			
	
		define('_c_tgLb','lb');		// [ left bracket : [lb/], function tg_lb()
		$this->attribVect[_c_tgLb]= false;
		
		define('_c_tgRb','rb');		// ] right bracket [rb/], function tg_rb()
		$this->attribVect[_c_tgRb]= false;
			
	
		/**
			SPECIAL TAGS
		*/
		$this->attribVect['anycodeinheader']= array('opt');		
		
		/**
			tg_Php(). [php] return('xyz'); [/php]
		*/
		define('_c_tgPhp','php');
		$this->attribVect[_c_tgPhp]= false;
		$this->attribVect['js']= false;

		/**
			tg_dtbcode().To execute directly some data base code (MySql or whatever).
			[dtbCode ret="ok"] ... [/dtbCode]
		*/		
		define('_c_tgDtbCode','dtbcode');
		$this->attribVect[_c_tgDtbCode]= array('ret');
		

		/**
			tg_newvar();
		*/
		define('_c_tgNewVar','newvar');
		$this->attribVect[_c_tgNewVar]= array('var','val','builder');


		/**
			To make Advertising less incasive and more ethical :
				the locAdvert tag pilot the globAdvert so we have the freedom to not display adberts in delicate pages,
				for example when we require the full attention of users or when adverts would be of bad taste with the 
				content of the page. + suppress ()volontary based the adverts in editing mode, so :
					- we are not distracted when working
					- or we can see what the adverts would display in a complex editing situation.
		*/
		$this->attribVect['globAdvert']= false;
		$this->attribVect['locAdvert']= array('allow');
		
		/**
			Display a smart phone image and allows the user to click it to surt the mobile version / cookie
		*/
		// $this->attribVect['mobile']= array('spectoptxt','defstl','onlymobmd','onlydekmd');
		$this->attribVect['mobile']= array('defstl','onlymobmd','onlydekmd');
		
		
		$this->attribVect['mobexpdshrk']= false;
		$this->attribVect['mobexpdshrkplus']= false;
		
		
		$this->attribVect['mobiletrim']= false;
		$this->attribVect['mobilesummary']= false;
		$this->attribVect['mobidselect']= array('hashtag','topn','botn');
		$this->attribVect['misheader']= false;

		$this->attribVect['bookmark']= array('id');
		$this->attribVect['jumptobm']= array('id','cls');
		
		$this->attribVect['slt']= array('id');


		/**
			XML META TAGS.
		*/
		
		/**
			tg_code() : Code, substitution tested example :
					[code var="##" val="[/" ]
						[b]hello[/b]
						##code]
					[/code]
					
			Standard keeper, not adding anything :	
				[code keep="ok"] ... [/code]
		*/
		$this->encapsNibbledCode= '';
		
		define('_c_tgCode','code');		// tg_code  [code var="leftBrk" val="["] ... [/code] : to define unanalysed zones between these tags.
		
		$this->attribVect[_c_tgCode]= array('cls','var','val','keep');
		define('_c_tgPrsCode','code');	// code tag for the parser, should be exactly like, except for tests!

		
				
				
		/*
			tg_nop() : No operation tag (nop), to allow a few checks a few things:
				- non interference of an embeded tag with main analysed string.
				- easy tag to try some combination with a single headed tag
		*/
		define('_c_tgNop','nop');		// [nop mess="message to display"/]
		$this->attribVect[_c_tgNop]= array('mess');
		
		$this->attribVect['tab']= false;
				
		/*
			tg_rem() : Comment
			When some code is described it should be used with th [code] tag like :
				[rem][code]    .....  [/code][/rem]
			Avoiding execution without screen output of the enclosed code!
		*/
		define('_c_tgRem','rem');		// [rem] any remark/comment except an end remark tag [/rem]
		$this->attribVect[_c_tgRem]= array('txt','r','c'); // so can add a remark like a head parameter
		$this->attribVect['_']= array('r','c');
		
		
		/**
			HTML META TAGS. (to change important values inside the html header)
			Convention : the 1st call to the tag is valid, others are ignored
			Title, Description, Keywords, NoCache, Dontindex etc.
			
			Title : tg_title(), [title] Example [/title]
		*/				
		define('_c_tgTitle','title');
		$this->globHtmlMTitle= '...';
		$this->attribVect[_c_tgTitle]=  array('prfx','genvar','slcode','elcode');
		
		// Description : tg_descr(), [descr] Example [/descr]
		define('_c_tgDescr','descr');
		$this->attribVect[_c_tgDescr]=  false;
			define('_c_defMtDescr', '...');		
			$this->globHtmlMDescr= _c_defMtDescr;
		
		// Keyword : tg_kw(), [kw] Example [/kw]
		define('_c_tgKw','kw');
		$this->attribVect[_c_tgKw]=  false;
			define('_c_defMtKw','');		
			$this->globHtmlMKw= _c_defMtKw;
		
			
		$this->attribVect['viewport']= array('content');	
		$this->tgViewportContent= false; // default not used
		
		
		// Html meta language tg_lang(). Example : [lang]fr[/lang]
		define('_c_tgLang','lang');
		$this->attribVect[_c_tgLang]=  false;
			define('_c_defMtLang', '');		
			$this->globHtmlMLang= _c_defMtLang;
			
			
			
		$this->cRobots= false;	// eventually loaded with the content of the robots tag
		$this->attribVect['robots']= false;

		// [stopSmplSurf /], tg_stopsmplsurf()			
		$this->attribVect['stopsmplsurf']= array('pg','exception');	
		$this->attribVect['fstopsmplsurf']= false;
		$this->attribVect['urlstopparser']= false;
		$this->attribVect['chgdblquotes']= array('sign');
				
		$this->goingDownMenu= false;		
		$this->initMT->setManyTgCl($this->attribVect,'tagsFu');		
		$this->botActFuName= false;	// bottom action function name defined in the class specTools
		
		$this->attribVect['postedval']= array('var','cls');
		$this->fumShrdCd= null;
		
		$this->globTtlPrfx= $dtb->getGenVar('browserGlobTtlPrfx');
		
		$this->attribVect['phpintmax']= false;
		$this->attribVect['goto']= array('pg','men');
		$this->attribVect['pushurlvar']= array('name');	
		$this->attribVect['pageattrib']= array('captcha');
		$this->attribVect['callpolyheader']= array('pfx');
		$this->attribVect['headerforall']= array('name');
		$this->attribVect['jscapsulon']= array('head','tail');
		$this->attribVect['jscapsuloff']= false;
		$this->attribVect['ataox']= array('pg','forceimg','float','cls','hideimgstar','supln');	
		// $this->attribVect['expandparam']= array('p');
		$this->attribVect['expandcodetransid']= array('id');
		$this->attribVect['expandpage']= array('name');
		
		$this->attribVect['inclxpetalcd']= array('id','forcesltoel','tagexclst');
		$this->attribVect['inclxpetaltxt']= array('id','search','replace','sep','expand');
		
		$this->forbTagAttribNmB= false;
		
		$this->curDiffPgName= false;
		$this->usesUtfUrl= false;
		
		$this->diffPgNameMdlLg= false;		
		$this->attribVect['diffpgname']= array('n','utfurl');
		$this->attribVect['diffpgnamemdllg']= array('lg');
		
		$this->attribVect['mainataoxdirn']= false;
		$this->attribVect['debugdsplay']= array('ln','cl');
		$this->attribVect['pagemode']= array('forum');
		
		$this->attribVect['surftrans']= array('helpstr','id');
		
		$this->attribVect['menuvisibility']= array('vis');
		$this->attribVect['includeforumbar']= false;
		
		
		$this->attribVect['advert']= array('sffx');
		
		
		$this->attribVect['test']= array('a');
		
		$this->callADowloadPg= false;
		$this->usingLambdaFBar= false;	// True when parsing the lambda forum bar
	} // __construct tagsFu
	
	
	/**
		Because tagsFu need to be instanciated before tagsParser, we can't pass an instance of tagsParser
		as a constructor parameter, so needs to do it after as soon as possible as a simple global pointer
		on the parser instance. Do it with a specialised function to make it more visible.
	*/
	function setParserAcces(&$parser){
		$this->parser= &$parser;
	} // setParserAcces
	

	/**
		Even if unusual for a mainly tag class, it's usefull to have a direct access.
	*/
	function setImgTags(&$iT){
		$this->imgTags= &$iT;
	} // setImgTags
	
	
	function setRecov(&$rec){
		$this->rec= &$rec;
	} // setRecov

	function setGenAssoc(&$assoc){
		$this->assoc= &$assoc;
	} // setGenAssoc

	function setImgProc(){
		$this->imgP= &$this->asa->imgP;
	} // setImgProc
	

	function setWmRights(){
		$this->wmRights= $this->instExplitCentralCls('cntrXRight');
	} // setWmRights
	
	function setCacheR(&$cacheR){
		$this->cacheR= &$cacheR;
	} // setCacheR
	
	function setCacheWr(&$cacheWr){
		$this->cacheWr= &$cacheWr;
	} // setCacheWr
	
	function setStatsWr(&$statsWr){
		$this->statsWr= &$statsWr;
	} // setStatsWr

	/**
		Classes categories to Paths and returns the concerned class array path!
		Input:
			$classdir : the local class directory (for plugins, most of the time the class name itself)
			$categ ; the category of classes
		Output :
			$clAr : give back the array of concerned class pointers
	*/
	function classCategToPath(&$clAr,$categ,$classdir){
		$tools= &$this->tools;
		
		switch ($categ){
			case _c_kernelKateg:
				$clAr= $this->kernekClasses;	// loading the address (&) does not work!!! Glob variables ?
				return _c_KernelPath;
			break;
			
			case _c_libClassCateg:
				$clAr= $this->libClasses;	// loading the address (&) does not work!!! Glob variables ?
				return _c_LibPath;
			break;
			
			case _c_exiClassCateg:
			case _c_exeClassCateg:
				$clAr= $this->explicitClasses;
				
				switch ($categ){
					case _c_exiClassCateg:
						return _c_toDeclPlugCntr.$classdir.'/';
					break;

					case _c_exeClassCateg:
						return _c_toDeclPlugExt.$classdir.'/';
					break;
				} // switch
			break;

			case _c_impClassCateg:
				$clAr= $this->automClasses;
				return _c_autoPlugins;
			break;

			
			default: 
				$clAr= array();
				return 'classCategToPath::Error '.$categ.' does not exists!';
		} // switch
	} // classCategToPath
	
	
	/**
		Return the class with optimum manipulation from a category and a class name.
		Note : classCategToPath($categ) could be redondant!
	*/
	function optimClassAccess($categ,$classNm,$classdir=''){
		$clAr= array();
		
		$path= $this->classCategToPath($clAr,$categ,$classdir);
		if (array_key_exists($classNm,$clAr)){
			return $clAr[$classNm];
		}else{
			$fullPathFN= $path.$classNm._c_phpExt;
			include $fullPathFN;
			
			/*
				Assigns the class to the general vector! 
				Keep it	 NO WAYS to do 	--->  $curCls= new $classNm($this); $clAr[$classNm]= $curCls;
			*/
			switch ($categ){
				case _c_kernelKateg:
					$this->kernekClasses[$classNm]= new $classNm($this);
					return $this->kernekClasses[$classNm];
				break;
				
				case _c_libClassCateg:
					$this->libClasses[$classNm]= new $classNm($this);
					return $this->libClasses[$classNm];
				break;
				
				case _c_exiClassCateg:
				case _c_exeClassCateg:
					$this->explicitClasses[$classNm]= new $classNm($this);
					return $this->explicitClasses[$classNm];
				break;

				case _c_impClassCateg:
					$this->automClasses[$classNm]= new $classNm($this);
					return $this->automClasses[$classNm];
				break;

				default: return null;
			} // switch			
		}
	} // optimClassAccess
	
		
	/**
		Global include and instanciation of a library (to be prefered to optimClassAccess
	*/
	function optimLibAccess($libName){
		if ( !array_key_exists($libName,$this->libClasses) ){
			include _c_LibPath.$libName._c_phpExt;
			$this->libClasses[$libName]= new $libName($this);
		}
		
		return $this->libClasses[$libName];
	} // optimLibAccess
	
	
	
	/**
		A method call for any explicit plugin class if it is already instanciated.
		Input : $clN the name of the class.
	*/
	function expliClss($clN){
		if (array_key_exists($clN,$this->explicitClasses)){
			return $this->explicitClasses[$clN];
		}else{
			return false;
		}
	} // expliClss

	/**
		Returns true if the explicit class exists and false otherwise. (not used for now)
	*/
	function explClssExist($clN){
		return array_key_exists($clN,$this->explicitClasses);
	} // explClssExist
	
	

	/**
		Pushes the concerned url variable. on the stack of url variables to be processed,
		[pushUrlVar name="" /]
	*/
	function tg_pushurlvar(&$v,&$bd){
		$tools= &$this->tools;
		$tools->suvPush($v['name']);	// Better to call it directly inside the constructor of the concerned class!!
	} // tg_pushurlvar


	/**
		[postedVal var="pluginName" /]
	*/
	function tg_postedval(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$var= $v['var'];
		$cls= $v['cls'];
		
		if ($var!==false){
			$var= $tools->postVal($var);
			if ($var!==false){
				return $caps->span($tools->fullTrim($var),$cls);
			}
		}
		
		return '';
	} // postedVal
	

	/**
		re-Create  / expand (easier than to extract it from the original string) the full tag with parameters and body.
		(Could change with a 2nd generation "xml" scanner.)
			Input : $tag, &$v, &$bd
			Output : return the full tag string with the body developped. The boddy developped is a side effect of
				the original parsing. Only problems can come from an include if the included record is changed
				but not the calling part. This is easier to avoid, especially because rebuilding is
				normally done on small tags than naturally don't include other record.
			$bSlashExtrn : back slash external double quotes (don't want any inside!!!)
			$quote: sort of quote in usage.
			$onlyHeader: returns only the header, if the body is present!
			
		Duplicata in : tools::buildSqrTag()
	*/
	function rebuildTagStr($tag, &$v,$bd='',$bSlashExtrn=false, $quote=_c_dblQ, $onlyHeader=false){
		$acc= &$this->acc;	
	
		$b= _c_lBrk.$tag._c_space;
		if ($v!==false){
			$b.= $acc->xmlAttributeStr($v,$quote,$bSlashExtrn);
		}
		
		if ($onlyHeader===false){
			if ($bd===''){
				$b.= ' '._c_slash._c_rBrk;
			}else{
				$b.= _c_rBrk.$bd._c_lBrk._c_slash.$tag._c_rBrk;	
			}
		}else{
			$b.= _c_rBrk;
		}
		
		return $b;
	} // rebuildTagStr


	/**
		Checks if the keys of $userAttribs belong to the values of $curAttribV
		and return a checked and normalised associative attrib/val array if possible.
		Input :
			$currentTag : we normalise the parameters of that tag.
			$userAttribs : parameters GIVEN BY THE USER.
			$curAttribV : reference attributes for the currrent tag.
	*/
	function checkedParVal($currentTag,&$userAttribs,&$curAttribV,$origInfo){
		$g= &$this->glob;
		$caps= &$this->caps;
		$rMg= &$this->rMg;
	
		if (is_array($userAttribs)){
			reset($userAttribs);
			foreach ($userAttribs as $key=>$val){
			
				$inArr= in_array($key,$curAttribV,true) || $key[0]==='_';
				if ($inArr){
					$newAttribVal[$key]= $val;
				}
				
				if (!$inArr && $rMg->realTimeUserId()!==_c_guestUserId){
					$this->errTagStr($currentTag,'the '.$caps->bold($key).$g->el(' parameter','kaxs'),$origInfo);
					$g->userError( $g->el('Remark for developpers, it could be a definition of attributes using upper cases.','kaxt') );
				}
			}
		}
	
		$this->normAttribVal($newAttribVal,$curAttribV);
		return $newAttribVal;	
	} // checkedParVal
	

	/**
		Normalizes the $newAttribVal associative arrays, so values that have not been given
		are set to false.
	*/
	function normAttribVal(&$newAttribVal,&$curAttribV){
		reset($curAttribV);
		foreach ($curAttribV as $key=>$val){
			if (!isset($newAttribVal[$val]) || $newAttribVal[$val]===NULL){
				$newAttribVal[$val]= false; // false means that the parameter is not used.
			}
		}	
	} // normAttribVal
	
	
	/**
		Check and normalise the parameters vector/assoc. array extracted from the tag.
		
		Input :
			$currentTag : tag currently analysed
			$userAttribs : vector of attributes FROM THE HEAD TAG.
			
		Output :
			A normalised $userAttribs vector. Non expressed attributes are set to false.
			$userAttribs['attrib']= false;
	*/
	function checkAndNormalise($currentTag,&$userAttribs,$origInfo){
		$curAttribV= $this->attribVect[$currentTag]; // Loads the associative array holding the reference attributes for the currrent tag
		if ($curAttribV!==false){
			$userAttribs= $this->checkedParVal($currentTag,$userAttribs,$curAttribV,$origInfo); // checks if the given attributes exists
		}
	} // checkAndNormalise


	/**
	*/
	function giveExternClass($className, $path=false){
		if ($path===false){
			return $this->instancAutoCl($className,true);
		}else{
			return $this->instExplitCl($path,$className,true);
		}
	} // giveExternClass
	

	/**
		Input : 
			$className : the name of the class to instanciate if not already done
			$returnClass : boolean flag to return the class or not.
		Output : 
			$this->automClasses[...]
			Boolean result.
			
		Warning : NOT to be missused as instExplitExternalCls() or instExplitCentralCls()
	*/	
	function instancAutoCl($className, $returnClass=false){
		if (!array_key_exists($className,$this->automClasses)){
			$root= _c_autoPlugins.$className;
			$phpFile= $root.'.php';
			if (is_file($phpFile)){
				include $phpFile;
				$this->automClasses[$className]= new $className($this);
			}else{
				$phpFile= $root.'/'.$className.'.php';	// style with folder
				if (is_file($phpFile)){
					include $phpFile;
					$this->automClasses[$className]= new $className($this);
				}else{
					return false;
				}
			}
		} // else --> already instanciated
		
		if ($returnClass){
			return $this->automClasses[$className];
		}else{
			return true;
		}
	} // instancAutoCl


	/**
		[setExplCss path="central/mm/" css="mm" /]
	*/
	function tg_setexplcss(&$v,&$bd){
		$this->coreSetexplCss($v['path'],$v['css']);
	} // tg_setexplcss


	function coreSetexplCss($path,$css){
		$glob= &$this->glob;
		
		$localCssPath= $path.$css.'.css';
		$supCssPfn= _c_decPlugSupCss.$localCssPath;
		if (file_exists($supCssPfn)){
			$glob->addCssFile($supCssPfn);	// Prioritary style sheet defined inside the user main user directory
		}else{
			// default style sheet for standard installations.
			$glob->addCssFile($glob->addCssFile(_c_toDeclPlugins.$localCssPath));
		}
	} // tg_coreSetexplCss


	/* ----------------------------------------------------------
	*/
	// [cenPlugin /]Set explicit-Central Plugins : [cenPlugin name="frameBuilder" /]
	function tg_cenplugin(&$v,&$bd){
		$this->explicitPlug($v,_c_plugCntrDN);
	} // tg_cenplugin
	
	function tg_setexplplugin(&$v,&$bd){
		$this->explicitPlug($v,'');
	} // tg_setexplplugin

	// Set explicit-External Plugins : [extPlugin name="frameBuilder" /]
	function tg_extplugin(&$v,&$bd){
		$asa= &$this->asa;
		$rMg= &$this->rMg;
		
		// Special forum so it does not appear when unnecessary (non editing non forum)
		if ( $v['name']==='forum' && !$rMg->quickWMRight() ){
			$asa->forumBar= $this->instExplitCl('central/forumBar/','forumBar',true);
		}
	
		$this->explicitPlug($v,_c_plugExtDN);
	} // tg_extplugin
	
	
	
	/**
		Direct explicit central||external plugin assignation.!
			Input :
				$name : name of the plugin
				$kind : kind of the plugin _c_plugCntrDN || _c_plugExtDN
				tagAssign : if false only specific tags need to be assigned outside this function.
				.......
			Output :
				Instanciates/assigns teh concerned class into $this->explicitClasses].
				Returns the concerned class by default!
	*/
	function directPlugAss($name, $kind=_c_plugCntrDN,$tagAssign=false,$returnClass=true,$path=false,$except=false){
		$v['name']= $name;
		$v['except']= $except;
		$v['path']= $path;
		$v['flag']= false;
		$this->explicitPlug($v, $kind, $returnClass, _c_toDeclPlugins, $tagAssign);
	} // directPlugAss
	
	
	
	function explicitPlug($v,$kind, $returnClass=false, $prePath=_c_toDeclPlugins, $tagAssign=true){
		$tools= &$this->tools;

		$except= $v['except'];
		if ($except!==false){
			$xV= $tools->trimStrToVect(',',$except);	// trim & explode()	
			$cPn= $tools->curPageName();
			if (in_array($cPn,$xV)){
				return '';
			}
		}
		
		$name= $v['name'];
		$path= $kind.$tools->binLoads($v['path'],$name).'/';
		$this->instExplitCl($path, $v['name'], $returnClass,$prePath,$tagAssign, $v['flag']);
	} // explicitPlug
	

	/** -----------------------------------------------------------------------------------
		Deals with the possible instanciation of an explicit given class name.
	*/
	function instExplitCl($path, $className, $returnClass=false, $prePath=_c_toDeclPlugins, $tagAssign=true,$flag=false){
		$g= &$this->glob;
		$parser= &$this->parser;
		
		if ($className===false){
			return false;
		}

		if (!array_key_exists($className,$this->explicitClasses)){
			$fn= $prePath.$path.$className.'.php';
			if (file_exists($fn)){
				include $fn;
				if ($flag===false){
					$this->explicitClasses[$className]= new $className($this);
				}else{
					$this->explicitClasses[$className]= new $className($this,$flag);
				}
			}else{
				$g->userError($fn. $g->el(' does not exists! Appear in ').$parser->globCurParsedPg._c_);
				return false;
			}
		}
		
		if ($tagAssign){
			$curCl= &$this->explicitClasses[$className];
			$this->assignTags($curCl->tags(),$className);	// Assigns each time we have an explicit installation, so other class identical tags are erased!
		}
		
		if ($returnClass){
			return $this->explicitClasses[$className];
		}else{
			return true;
		}
	} // instExplitCl

	/**
	*/
	function expliExtClassPath($clsNm){
		return _c_toDeclPlugExt.$clsNm.'/'.$clsNm.'.php';
	} // expliExtClassPath

	/**
	*/
	function expliCntrClassPath($clsNm){
		return _c_toDeclPlugCntr.$clsNm.'/'.$clsNm.'.php';
	} // expliCntrClassPath
	
		
	/**
		A quick way to declare Explit External Class/Plugins without risking double declarations.
		Note : this is the most popular/common plugin directory because :
			(1) other party can add their plugins
			(2) more flexible for partial distribution + need a polished interface.
	*/
	function instExplitExternalCls($classN,$tagAssign=true){
		return $this->instExplitCl($classN.'/',$classN,true,_c_toDeclPlugExt,$tagAssign);	// n instExplitCl(
	} // instExplitExternalCls
	
	/**
		A quick way to declare Explit Central Class/Plugins without risking double declarations.
	*/
	function instExplitCentralCls($classN,$tagAssign=true){
		return $this->instExplitCl($classN.'/',$classN,true,_c_toDeclPlugCntr,$tagAssign);
	} // instExplitCentralCls
	
	
	
	
	/**
		Instanciates any sort of plugin class.
			Input :
				$fuOrTagName : function or tag name that must be declared inside :
					$this->automClasses[...] for implicit plugins
					$this->explicitClasses[... ] for explicit plugins.
					
				$path : path of $className
				$className : given in case of explicit class to load.
					
			Output :
				instanciation of the class if necessary		
	*/
	function instancAnyPlug($fuOrTagName, $path,$className){
		$vMt= &$this->initMT;
		if (isset($vMt->tagClass[$fuOrTagName])){
			$classStr= $vMt->tagClass[$fuOrTagName];	// loads the class name string
			return $this->instancAutoCl($classStr,true);		
		}else{
			return $this->instExplitCl($path,$className,true);
		}		
	} // instancAnyPlug
	
			
	/**
		Returns true if a imethod internal in tagFu() exists.
	*/
	function internMethExists($currentTag){
		$methodName= _c_tagFuPrfx.$currentTag;
		return method_exists ($this,$methodName);
	} // internMethExists	
			
	/**
		Instanciates the current implicit tags class.
			Input :
				$currentTag
			Output :
				$classVect[$classMt] : current multi tag class.vector
	*/
	function instancAutoTag($currentTag){
		$glob= &$this->glob;
		$vMt= &$this->initMT;
		
		$classMt= $vMt->tagClass[$currentTag];	// loads the class name string
		if (!$this->instancAutoCl($classMt)){
			$this->errTagStr($currentTag,$classMt);
		}
	} // instancAutoTag
		
	/**
		[setExplJs path="" js=""/]
	*/
	function tg_setexpljs(&$v,&$bd){
		$glob= &$this->glob;
		$path= $v['path'];
		$js= $v['js'].'.js';
		$glob->addJsFile(_c_toDeclPlugins.$path.$js);
	} // tg_setexpljs
	
	
	/**
		Includes all the files (supplementary) used by the calling explicit plugin php file
	*/	
	function includeSupFiles($pluginNm, $dsplName=false, $explicitExternal=true, $supPath=false, $supJs=true){
		$glob= &$this->glob;
		$fls= &$this->fls;
		
		$curPath= _c_autoPlugins.$pluginNm;
		if (file_exists($curPath)){
			$curPath.= '/';		// priority for an implicit class with the same name if it exists. Ok because implicit class should shrink!
			$glob->addCssFile($curPath.$pluginNm.'.css');	
		}else{
			// EXPLICIT PLUGINS
			
			if ($explicitExternal){
				// explicit external
				$cssDfn= $this->fullCssDfn(_c_decPlugSupCssE,$supPath,$pluginNm);
				if (!$fls->fileExist($cssDfn)){
					$cssDfn= $this->fullCssDfn(_c_toDeclPlugExt,$supPath,$pluginNm);
				}
			}else{
				// explicit central
				$cssDfn= $this->fullCssDfn(_c_decPlugSupCssC,$supPath,$pluginNm);
				if (!$fls->fileExist($cssDfn)){
					$cssDfn= $this->fullCssDfn(_c_toDeclPlugCntr,$supPath,$pluginNm);
				}
			}
			
			$glob->addCssFile($cssDfn);	
			
			// For the javascript initialisation :
			if ($explicitExternal){
				$pfxPath= _c_toDeclPlugExt;		// explicit external
			}else{
				$pfxPath= _c_toDeclPlugCntr;	// explicit central
			}
			if ($supPath===false){
				$curPath= $pfxPath.$pluginNm.'/';
			}else{
				$curPath= $pfxPath.$supPath.$pluginNm.'/';
			}
			
		}
			
		if ($supJs){			
			$glob->coreInclStanceJs($curPath,$pluginNm);
		}
		return $curPath;
	} // includeSupFiles
	
	function supFilesExplCntr($pluginNm,$supPath=false,$supJs=false){
		$this->includeSupFiles($pluginNm,false,false,$supPath,$supJs);
	} // supFilesExplCntr
	
	

	/**
		Returns the full css path taking the possible supplementary path into account!
	*/
	function fullCssDfn($pfxPath,$supPath,$pluginNm){
		if ($supPath===false){
			$curPath= $pfxPath.$pluginNm.'/';
		}else{
			$curPath= $pfxPath.$supPath.$pluginNm.'/';
		}
		return $curPath.$pluginNm.'.css';
	} // fullCssDfn
					
	


	/**
		Assigns $this->explicitTags so it's possible to find the class name from the tag name.
		To ckeck later on tag names conflicts : array_intersect($tags,$this->initMT->tagClass)
		Probably not useful to check uniqueness, because mainly usefull inside own category (other error should be obviuos)
		+ the expplicitelly declared category can handle name conflict within the same page, because of re-initialisation.
	*/
	function assignTags($tags,$className){
		reset($tags);
		foreach ($tags as $key=>$tag){
			$this->explicitTags[$tag]= $className;
		}
	} // assignTags
	
	
	/**
		Prepares Tag Substitution : loads the $this->tagSubstituteV, so the substituted tag $substTg
		will be taken instead of the original tag $origTg.
	*/
	function tagSubstitOn($origTg,$substTg){
		$this->tagSubstActive= true;
		$this->tagSubstituteV[$origTg]= $substTg;
	} // tagSubstitOn

	function tagSubstitOff($origTg){
		$this->tagSubstActive= false;
		$this->tagSubstituteV[$origTg]= false;
	} // tagSubstitOff
	
	
	/**
		Input :
			$currentTag : the current tag matching a function name
			$userAttribs : the associative array of parameters where a parameter value:
					- needs to be indexed with its name in normal xml parameter assignation case.
			$currentBody : the eventual body to work on
			
		Action and Output :
			Call the correct function and return the computed string.
	*/
	function callFu($currentTag,&$userAttribs,&$curBody,&$scanStr){
		$g= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$vMt= &$this->initMT;
				
		$methodName= _c_tagFuPrfx.$currentTag;
		if ($this->botActFuName!==false){
			$specTools= $this->automClasses['specTools'];
			$curBotFu= $this->botActFuName;
			$curBody= $specTools->$curBotFu($curBody);
		}		

		// Checks if the tag and associated method got assigned a temporary remplacent!
		if ($this->tagSubstActive){		
			if ( isset($this->tagSubstituteV[$currentTag]) && $this->tagSubstituteV[$currentTag]!==false ){
				$methodName= _c_tagFuPrfx.$this->tagSubstituteV[$currentTag];
				$currentTag= $this->tagSubstituteV[$currentTag];
			}
		}
		
		/*
			Also working for method calls :
				call_user_func(array($this, $methodName),$userAttribs,$curBody);	 // official replacement of call_user_method()		
				$this->{$methodName}($userAttribs,$curBody);
		*/
		$origInfo= $scanStr->cellId;
		if (method_exists($this,$methodName)){
			$this->checkAndNormalise($currentTag,$userAttribs,$origInfo);
			return $this->$methodName($userAttribs,$curBody); // CALLS standardized functions defined in this file
			
		}else{
			// Checks implicits methods,
			if ( isset( $vMt->tagClass[$currentTag] ) ){
				$this->instancAutoTag($currentTag);
				$this->checkAndNormalise($currentTag,$userAttribs,$origInfo);			
				$classMt= $vMt->tagClass[$currentTag];	// loads the class name string		
				$mtCl= &$this->automClasses[$classMt];
				if ( method_exists($mtCl,$methodName) ){				
					return $mtCl->$methodName($userAttribs,$curBody); // CALLS plugins implicit standardized functions
				}else{
					return $this->errTagStr($currentTag, $methodName.'(), '. $g->el('implicit.'), $scanStr->cellId );
				}
			}else{
				// Checks explicit methods,
				if ( isset($this->explicitTags[$currentTag]) ){
					$this->checkAndNormalise($currentTag,$userAttribs,$origInfo);
					$classNm= $this->explicitTags[$currentTag];
					$curClass= $this->explicitClasses[$classNm];
					if (method_exists($curClass,$methodName)){	
						return $curClass->$methodName($userAttribs,$curBody); // CALLS plugins explicit standardized functions
					}else{
						return $this->errTagStr($currentTag, $methodName.'(), '. $g->sl('explicit.'), $scanStr->cellId );
					}
				}else{
					// Unknowed tag!
					return $this->errTagStr($currentTag, ''  , $scanStr->cellId );
				}
			}		
		}
	} // callFu
	
	
	/**
		Input:
			- $tag : concerned tag.
			- $relEnt : related entity (php file, directory or class)
			- $origInfo : probabable Id of a forum post, or page name or any other table record-Id supporting the tag!
			
		->sl langiage fu : mainly useful for forum users!
	*/
	function errTagStr($tag,$relEnt,$origInfo=false){	
		$g= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$rMg= &$this->rMg;
		
		if ($rMg->realTimeUserId()===_c_guestUserId){
			return '';
		}
		
		if ($relEnt===''){
			$relEnt= $g->el('the concerned element','kaxn');
		}
		
		$b=  $g->el('Concerned tag : ','kaxp') .$caps->bold($tag). $g->el('. Warning : ','kaxq') .$relEnt. $g->el(' is not defined!','kaxr')._c_;
		if ($origInfo!==false){
			$url= $fls->urlWithoutSignet().$tools->signet($origInfo);
			$clickPostN= $caps->hL($url,$origInfo,'genLn');
			$b.= $g->el('The concerned entity (page, post Id etc.) is : ','kaxo').$clickPostN;
		}
		$g->userError($b);
		
		if ($tools->onlyDigits($origInfo) && $this->fumShrdCd!==null){
			// check if the supposed post Id belongs to the logged user
			$fumShrdCd= &$this->fumShrdCd;
			
			$postOwnerId= $fumShrdCd->postUserId($origInfo);
			$loggedUsrId= $fumShrdCd->fumLogUserId();
		
			if ($origInfo!==false && $fumShrdCd->correctlySignedIn() && $postOwnerId===$loggedUsrId){
				$g->fumserError($b);	// message for the current user mistakes on own posts !!
			}
		}
		
		return '';	// Does not return erors, but store them in buffer !!
	} // errTagStr
	
	
	/**
		Definition of the standardized fonctions :
			Input :
				$v : normalised attributes associative array. Normalised because all the possible prameters are set, and the one that
					were not set by the xml script have been set with the false boolean value.
				$bd : the developped body of the tag, so xhtml form.
	*/
		
		
	/**
		Branching between records.
	*/
	
		
	/**
		Return a specific record from the specified table (cellPge is the default).
		---> include and parse the specified page !
		
		[incl ref="pageName" tbl="cellPge" /]
	*/		
	function tg_incl(&$v,&$bd){
		$g= &$this->glob;
		$tools= &$this->tools;
	
		$ref= $v['ref'];
		$tbl= $tools->binLoads($v['tbl'],_c_PolyCellPg);
		
		if ($ref!==false){
			return $this->includeRec($ref,$tbl,_c_pcMainStr);
		}else{
			$g->userError( $g->el('nside:[incl ref=...','kato') );
		}
	} // tg_incl


	/**
		[inclOnce ref="pageName" /]
	*/		
	function tg_inclonce(&$v,&$bd){
		return $this->incldOnce($v['ref']);
	} // tg_inclonce
	
	/**
	*/
	function incldOnce($ref){
		if (array_key_exists ($ref ,$this->redondanceFreeVect)){
			return '';
		}else{
			$this->redondanceFreeVect[$ref]= true;
			return $this->includeRec($ref,_c_PolyCellPg,_c_pcMainStr);
		}
	} // incldOnce
	
	/**
		[onlyOnce id="aaa"]    [/onlyOnce]
	*/		
	function tg_onlyOnce(&$v,&$bd){
		$glob= &$this->glob;
		
		$id= $v['id'];
		if ( array_key_exists($id,$glob->tagOnlyOnce) ){
			return '';
		}else{
			$glob->tagOnlyOnce[$id]= _c_ok;
			return $bd;
		}
	} // tg_onlyOnce
	
		
		
	/**
		Just execute the different squarred brackets specified by the given id and localisation infos 
	*/
	function executesField($id,$tbl,$field){
		$this->includeRec($id,$tbl,$field,false);
	} // executesField
	
	
	/**
		Return the file content of the givenb file!
	*/		
	function tg_file(&$v,&$bd){
		$path= $v['path'];	// full path and file name	
		return $this->retParsedFile($path);
	} // tg_file
	
	
	// [sqlHeaders /]
	function tg_sqlheaders(&$v,&$bd){
		$dtb= &$this->dtb;
		
		$kindDtb= $dtb->getGenVar('kindDtbToInstall');
		switch ($kindDtb){
			case 'simulSql':
				$xtr= $this->instExplitExternalCls('extractor');
				$xtr->wrHundrPcHeaders();
			break;
			
			case 'aMySql':
			default:
				return $this->retParsedFile(_c_sqlHeadersFile);
			break;
		} // switch
	} // tg_sqlheaders


	/**
	*/
	function retParsedFile($path){
		$fls= &$this->fls;
		$parser= &$this->parser;
		$strToParse= $fls->fileToStr($path);
		return $parser->parseStdStr($strToParse, _c_CodePath.$path);
	} // retParsedFile
	
	
	/**
		Just need to insert the already loaded ... buffPgInclusion

	*/
	function tg_plug(&$v,&$bd){
		$parser= &$this->parser;
		
		if (isset($parser->buffPgInclusion)){
			return $parser->buffPgInclusion;
		}else{
			return '';
		}
	} // tg_plug
		

	/**
		[up ref="surrounding-string" /]
		
		Algorithm : trigger a global variable so when finding a plug tag, it will be possible to plug 
		the whole string generated at this level.
			- planify at completion of the current string a jump to the up record.
			- when the plug tag is met, insert the corresponding string
	*/
	function tg_up(&$v,&$bd){
		$g= &$this->glob;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
	
		$rf= $v['ref'];
		if ($rf==='t0pMenu'){	// simplify the old redundent top imbrication strategy
			$rf= 't0pAll';	// update to the new conventions
		}
		
		if ($rf!==false){
			if ($dtb->elementExists(_c_pcId,$rf,_c_PolyCellPg)){
				$parser->gotOneUpTag= true;
				$parser->plugRecordName= $rf;
				if (!isset($g->firstUpTagVal)){
					$g->firstUpTagVal= $rf;	// default up from init record : $g->plugDefRecN
				}
				
				// loads eventual tags defined inside the connection part of $rf / _c_PolyCellPg
				$this->executesField($rf,_c_PolyCellPg,_c_pcNecStr);
			}else{
				$g->userError( $g->el('The page ') .$rf. $g->el(' specified inside an [up ref="') .$rf. $g->el('" /] does not exists!') );
				$parser->stopParser();
			}
		}else{
			$g->userError( $g->el('tagFu::tg_up : no reference inside an [up ref="page" /] tag') );
		}
	
		return ''; // this tag does not insert anything in the current string
	} // tg_up
	


	/**
		Sets default values if [up ... /]  and  [menUp  ... /] are not specified.
		[defUp up="test" menup="rootmenu" /]
	*/	
	function tg_defup(&$v,&$bd){
		$glob= &$this->glob;
	
		$up= $v['up'];			// Targets the top page including the current page info and the menu
		$menup= $v['menup'];	// Targets the above menu the current page must be included in. To appear
			// inside the menu the current page must be specified inside the above page menu list, which
			// is obviously not the case for a search result.
			
		$glob->plugDefRecN= $up;
		$glob->upDefMenRecN= $menup;
		return '';
	} // tg_defup	
	
	
	/**	
		Lists.
	*/
	
	/**
	*/
	function tg_list(&$v,&$bd){
		return $this->generalList('list',$v,$bd);
	} // tg_list

	/**
	*/
	function tg_olist(&$v,&$bd){
		return $this->generalList('olist',$v,$bd);
	} // tg_olist

	/**
	*/
	function tg_ul(&$v,&$bd){
		return $this->generalList('ul',$v,$bd);
	} // tg_ul

	/**
	*/
	function tg_ol(&$v,&$bd){
		return $this->generalList('ol',$v,$bd);
	} // tg_ol
		
	/**
	*/
	function tg_li(&$v,&$bd){
		$caps= &$this->caps;	
		return $caps->elemLi($bd);
	} // tg_li
	

	/**
		Input :
			$tag : what tag
			$v : the vector of parameter
			$bd : the body
		Output : the expanded html result.
	*/
	function generalList($tag,&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;	
	
		
		$cl= $tools->binLoads($v['cls'],'');
		if ($cl!==''){
			$cl= $caps->matCss($cl);
		}
		
		$stl= $tools->binLoads($v['stl'],'');
		if ($stl!==''){
			switch ($stl){
				case '':
					$stl= '';
				break;
				
				case 'lowAlpha':
					$stl= $caps->matStyl('list-style-type:lower-alpha;');
				break;
				
				case 'upRoman':
					$stl= $caps->matStyl('list-style-type:upper-roman;');
				break;
								
				default: 
					$stl= $caps->matStyl($stl);
			} // switch
		}
		
		
		if ($tag===_c_tgList || $tag===_c_tgUL){
			$buff= $caps->topTagUL($bd, $cl.$stl );	// standard list
		}else{
			$buff= $caps->topTagOL($bd, $cl.$stl );	// ordered list
		}
		return $buff;
	} // generalList
	
	
	/* -----------------------------------------------------------------------------------------------------------
		[a url="" ...]...[/a]	: optimized for external links
			Note, it also works with url being a page name, but does notz accept subtilities to include special page parameters!
			
		[page name="" ...]...[/page] : optimized for internal links
	*/
	
	/**
		[spiderF/] To request a spider frienfly state
	*/
	function tg_spiderf(&$v,&$b){
		$glob= &$this->glob;
		$glob->isSpiderFrienly= true;
	} // tg_spiderf
	
	/**
		[spiderUF/]  To request a spider unfrienfly state
	*/
	function tg_spideruf(&$v,&$b){
		$glob= &$this->glob;
		$glob->isSpiderFrienly= false;
	} // tg_spideruf
	
	
	/**
		Link on external (http) or local world with possible specification of title and class :
			[a url="" ttl="" fin="" fout="" norm="" ] Appearing Text or image [/a]
				--> norm : i === ok then consider url as a page name and nomalize it!
	*/
	function tg_a(&$v,&$b){
		$this->linkPreload($v,$url,$ttl,$fIn,$fOut,$norm,$target);	// n linkPreload(
		return $this->anchor($b,$url,$ttl,$fIn,$fOut,$v,$norm,$target,_c_ko); // n anchor(
	} // tg_a
	
	/**
		Special link to call the download page
			Examples :
				[d url="shortZip.zip"] short Zip [/d]			
				[d url="anyurl=http://example.org/a.zip"] a.zip [/d]
				[d url="homedirurl=shortZip.zip"] shortZip 2 [/d]
				
				Also works for the default, but unecessary :
					[d url="_download&shortZip.zip"] short Zip [/d]	
				For other pages :
					[d url="_downLD&shortZip.zip" oPg="ok"] short Zip [/d]	// oPg stands for other page, in this case the page _downLD
				
					
		Page _download considered as default.
	*/
	function tg_d(&$v,&$b){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$this->callADowloadPg= true;
		$url= $v['url'];
		
		$homedirurl= $tools->sIsInB('homedirurl',$url);
		$anyurl= $tools->sIsInB('anyurl',$url);
		$shortStandardCall= !$tools->sIsInB('&',$url) && !$homedirurl && !$anyurl;
		$absoluteCall= $tools->sIsInB('://',$url);
		if ( $shortStandardCall || $absoluteCall || $homedirurl ){	// !! does not work if & is html coded
			
			if ($shortStandardCall){
				// only the file name is given and the page is by default _download 
				$url= 'ddurl='.$url.$tools->addUrlVar('sLg',$dtb->currentLg());
			}
			
			if ($absoluteCall){
				// only the file name is given and the page is by default 
				$url= $url.$tools->addUrlVar('sLg',$dtb->currentLg());
			}
			
			if (!$tools->sIsInB('_download&',$url) && $v['opg']===false ){
				$url= '_download&'.$url;
			}
			
			$v['url']= $url;
		}
		
		if ($v['cls']===false){
			$v['cls']= 'gecStandLn';
		}
		
		$curA= $this->tg_a($v,$b);
		$this->callADowloadPg= false;
		return $curA;
	} // tg_d
		
	
	/**
		Returns a clickable link (text or image), with an adaptation for the url, depending
		of the given url content (http://, .... .ext, ...)
	*/
	function anchor(&$str,$gUrl,$title,$fIn,$fOut,&$v,$norm=false,$target='',$checkLg=_c_ko){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;	
		$acc= &$this->acc;
		$fls= &$this->fls;
		$rMg= &$this->rMg;
		
		$eb= $v['eb'];	// as es but to replace a body string !!
		if ($eb!==false){
			$str= $glob->es($str,$eb);
		}else{
			$sb= $v['sb'];
			if  ($sb!==false){
				$str= $glob->sl($str,$sb);
			}
		}
		
		$cls= $tools->binLoads($v['cls'],'');
		
		if ( $caps->externalLink($gUrl) && !$this->callADowloadPg ){
			$attS= $caps->matTtl($title);
			$attS.= $caps->matCss($cls);
			$attS.= $this->noFollRelatedStr($v);
			$attS.= $caps->target($target);
			return $caps->hLink($gUrl,$str,$attS);
		}else{
			// internal link
			$ext= $fls->extension($gUrl);
			if ($ext!==false  && !$this->callADowloadPg){
				// Got an extension --> it's a file name AND it's not a page call with a dot inside the parameters 
				$firstChar= $gUrl[0];
				if ($firstChar==='.'){
					// local file given with a full path --> don't want a prefix
					$urlPrfx= '';
				}else if ($firstChar==='+'){	// memo + --> one directory shift toward the right
					// path given as starting from within _c_asppDirN
					$gUrl= $fls->delFirstChar($gUrl);
					$urlPrfx= _c_asppRtPath;
				}else{
					// prefix it with the user data path
					if ($v['insd']===_c_ok && $rMg->quickWMRight()){
						$urlPrfx= _c_muSecretDPath;	// probably not used and would be netter in the page tag!
					}else{
						$urlPrfx= _c_UsrDataPath;
					}
				}
				return $caps->linkTC($urlPrfx.$gUrl, $str,$title,$cls,$target);
				
			}else{
				// No extension so got a page name
				return $this->page($str,$gUrl,$title,$fIn,$fOut,$v,$norm,$target); // Is a simple local page name
			}
		}			
	} // anchor
	
	
	/**
		Deals with the nofollow parameter and more general rel!
	*/
	function noFollRelatedStr(&$v){
		$glob= &$this->glob;
		$caps= &$this->caps;	
	
		$attS= ''; 
		if ( $glob->isSpiderFrienly || $glob->isFumSpiderFrienly ){
			// accept manual REL			
			$rel= $v['rel'];
			if ($rel===false){
				if ( !($v['follow']===false || $v['follow']===_c_ok) ){
					$attS.= $caps->noFollowStr();	// comprehensible value for follow="ko" or no etc. anything specified leads to _c_noFollow
				}
			}else{
				$attS.= ' rel="'.$rel.'"';
			}
		}else{
			$attS.= $caps->noFollowStr();
			$attS.= $caps->target('_blank');
		}
		
		return $attS;
	} // noFollRelatedStr	
 		
 		
	/**
		tg_page()  [page name="wysiwig" ttl="wysiwig"] ... [/page]
		tg_a(
	*/
	function tg_page(&$v,&$bd,$checkLg=_c_ko){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;

		$this->linkPreload($v,$gUrl,$title,$fIn,$fOut,$norm,$target);	// !! Preloading !!!!
		
		$es= $v['es'];
		$title= $glob->es($title,$es);		
			
		$eb= $v['eb'];	// to replace the body string !!
		if ($eb!==false){
			$bd= $glob->es($bd,$eb);
		}
		
		$sb= $v['sb'];	// to replace athebody string !!
		if ($sb!==false){
			$bd= $glob->sl($bd,$sb);
		}
		
		
		
		$var= $v['postvar'];
		if ($var!==false){
			$val= $tools->postVal($var);			
			if ($val!==false){
				if ($var==='pluginName'){
					if ($glob->cndtWrRghts===true){
						$gUrl.= $tools->addUrlVar($var,$val);
					}else{
						$gUrl.= $tools->addUrlVar($var,'myFirstPlugin');	// special guest demo for plugin creation !!
					}
				}else{
					$gUrl.= $tools->addUrlVar($var,$val);
				}
			}
		}		
		
		$cls= $v['cls'];
		$name= $v['name'];
		
		if ($name!==false){
			$c0= $name[0];
			$c1= $name[1];
			if ($c0==='&' || ($c0==='#' && $c1==='&') ){	// ... stays on the same page while adding paramneters
				if ($c0==='#'){
					$tools->rmFirstByte($name);
				}
			
				$url= $tools->urlCurPg().$name;
				return $caps->linkTC($url,$bd,$title,$cls);
			}
		}else{
			return $caps->linkTC('#',$bd,$title,$cls);		// standard html same page
		}
		
		if ($cls!==false){
			$fIn= $cls;
			$fOut= $cls;
		}
		
		return $this->page($bd,$gUrl,$title,$fIn,$fOut,$v,$norm,$target);
	} // tg_page
  
  
 	/**
 		Returns a text or an image ($str) linked on the given page ($pgNm).
 		Input :
 			$str : string or image to display
			$pgNm : page name
 	*/
	function page($str,$pgNm,$title,$fIn,$fOut,&$v,$norm,$target=''){
		$tools= &$this->tools;
		$caps= &$this->caps;	
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		$cls= $v['cls'];
		if ($this->callADowloadPg){
			$cUrl= $tools->urlGivenPage('uRlUnIqChabl');
			$cUrl= str_replace('uRlUnIqChabl',$pgNm,$cUrl);
		}else{	// Standard case
			if ($norm!==false){
				$pgNm= $fls->safIdStr($pgNm,true);	// normalize the given page name		
			}
			
			$fls->splitOnLastC($pgNm,$realPgNm,$hashTag,'#');
			if ($realPgNm==='' && $hashTag!==''){
				$realPgNm= $tools->curPageName();	// so can just use # to stay on the same page
			}
			
			$cUrl= $tools->urlGivenPage($realPgNm);
			if ($hashTag!==''){
				if ( $tools->isInSmartPM() ){
					$cUrl.= $tools->addUrlVar(_c_smartPhUniqParag,$hashTag);
				}
				$cUrl.= $tools->signet($hashTag);
			}
			
			if ($cls===false){
				if ($realPgNm===$tools->getUrlPageName()){
					$cls= $fIn;
				}else{
					$cls= $fOut;
				}
			}
		}
		
		$rel= $caps->matFollow( $v['follow'] );
		return $caps->linkTC($cUrl,$str,$title,$cls,$target,$rel);
	} // page
	
	/**
		[easyPg /]
	*/
	function tg_easypg(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
	
		$pg= $tools->binLoads( $v['name'], $tools->urlCurPg() );
		$cmpl= $tools->binLoads($v['cmpl']);
		
		$es= $v['es'];
		$cls= $tools->binLoads($v['cls'],'textOut');
		
		$url= $tools->urlGivenPage($pg).$cmpl;
		$title= $bd;
		if ($es!==false){
			$title= $glob->es('',$es);
		}
		
		return $caps->linkTC($url,$title,'',$cls);
	} // tg_easypg
	
 

	/**
		Page tag force on the correct language page (9th param _c_ok).
		[pageLg url="myPageAnyLanguage"] text or image [/pageLg]
	*/
	function tg_pageLg(&$v,&$bd){
		return $this->tg_page($v,$bd,_c_ok);	
	} // tg_pageLg

 
  	
	/**
		To manages non breakable space in $times steps.
		tg_nbsp(),   [nbsp cls="" times="3" /]
	*/
	function tg_nbsp(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;	

		$cls= $tools->binLoads($v['cls'],'nbsp');
		$times= (int)$tools->binLoads($v['times'],1);
	
		$str= '';
		for($i=0; $i<$times; $i++){
			$str.= _c_Ns;
		}
	
		return $caps->div($str,$cls);
	} // tg_nbsp
 
 	/**
 		Could have call it tg_nbsp !!
 	*/
	function tg_nsp(&$v,&$bd){
		return _c_Ns;
	} // tg_nsp
	
	/*
		Loads the value : [var i="1"] some infos [/var]
		Display the value : [var i="1"/]
	*/
	function tg_var(&$v,&$bd){
		$i= $v['i'];
		if ($bd===''){
			return $this->xml2TagVar[$i];
		}else{
			$this->xml2TagVar[$i]= $bd;
			return '';
		}
	} // tg_var
	
	
	/**
		Just an alias : [link url="" ttl="" cls="" ] Appearing Text or image [/link]	
	*/
	function tg_link(&$v,&$b){
		return $this->tg_a($v,$b);
	} // tg_link
	
	/**
	*/
	function linkPreload(&$v,&$gUrl,&$title,&$fIn,&$fOut,&$norm,&$target){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$gUrl= trim($tools->mostValid($v['name'],$v['url']));	
			
		$es= $v['esttl'];
		$ttl= $v['ttl'];
		if ($es!==false){
			$title= $glob->es($ttl,$es);
		}else{
			$title= $tools->binLoads($ttl,'');
		}
		
		$fIn= $tools->binLoads($v['fin'],'textIn');	// font button In
		$fOut= $tools->binLoads($v['fout'],'textOut'); // font button Out		
		$norm= $v['norm'];
		$target= $tools->binLoads($v['target'],'');	
	} // linkPreload	
	
	
	/**
		Example :	[div cls="menuIndent"] .... [/div]
					[div stl="margin-left: 20px;"] .... [/div]
	*/
	function tg_div(&$v,&$str){
		$tools= &$this->tools;	
		$caps= &$this->caps;	
		$wmR= &$this->wmRights;	
		
		if ( $v['shunt_pg']===_c_ok ){
			// no inside content if the current page starts with a _
			$pgN= $tools->curPageName();
			
			if ( $pgN[0]==='_' && !$wmR->wmUlnPgXess() ){
				return '';
			}
		}
		
		
		$cls= $tools->binLoads($v['cls'],'');
		$style= $tools->binLoads($v['stl'],'');	
		$id= $tools->binLoads($v['id'],'');	
		
		$wCase= $v['wcase'];
		if ($wCase!==false){
			switch ($wCase){
				case 'topB':	// top buttons ... in this case also works without width specification, but good to have the 2 possibilities
					if ($wmR->buildButtAccept()){
						$width= $v['wmax'];
					}else{
						$width= $v['wmin'];
					}
					
					$w= ' width:'.$width.'px;';
					$style.= $w;
				break;
				
				default:;
			} // switch
		}
		
		if ($cls==='' && $style===''){
			$cls= 'leftM';
		}		
		
		$sup= $tools->binLoads($v['sup'],'');
		return $caps->div($str,$cls,$id,'',$style,$sup);
	} // tg_div
	
	/**
		[heaDiv stl="" /]
	*/
	function tg_headiv(&$v,&$bd){
		$tools= &$this->tools;	
		$caps= &$this->caps;
		
		$style= $tools->binLoads($v['stl'],'');	
		$id= $tools->binLoads($v['id'],'');	
		$cls= $tools->binLoads($v['cls'],'');
	
		return $caps->heaDiv($style,$id,'',$cls);
	} // tg_headiv

	/**
		[tailDiv /]
	*/
	function tg_taildiv(&$v,&$bd){
		$caps= &$this->caps;
		return $caps->enDiv();
	} // tg_taildiv
		
		
	/**
	*/	
	function tg_font(&$v,&$str){
		return $this->tg_div($v,$str);
	} // tg_font
	
	
	/**
		Example : [span stl=""] .... [/span]
			 [span es="kaaa" stl="" /]
	*/
	function tg_span(&$v,&$str){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;	
		
		$cls= $tools->binLoads($v['cls'],'');
		$stl= $tools->binLoads($v['stl'],'');
		$ttl= $caps->htmlDQuote($tools->binLoads($v['ttl'],''));
		$x= $tools->binLoads($v['x'],'');
		
		// in the case where someone prefers to use the parameter lbl insteat of the tag body $str
		$lbl= $v['lbl'];
		if ($lbl!==false){
			$str= $lbl;
		}
		
		$frcSl= $v['forcesl']===_c_ok;	// force surf language
		$es= $v['es'];
		if ($es!==false){
			if ($frcSl){
				$str= $glob->sl($str,$es);
			}else{
				$str= $glob->es($str,$es);
			}
		}
		
		$es2= $v['es2'];
		if ($es2!==false){
			if ($frcSl){
				$ttl= $glob->sl($ttl,$es2);
			}else{
				$ttl= $glob->es($ttl,$es2);
			}
		}
		
		if ($cls==='' && $stl===''){
			$cls= 'efMb';
		}
		
		return $caps->span($str,$cls,$stl,'',$ttl,$x);
	} // tg_span
	
	
	/**
		[pgTitle /] a tag prefered to [span /] for main titles because it's build to manage webmaster advertisment! First on the right of the title, but other configurations may follow.
		$this->mainAdvertPlugIn= false;  // init here to false, but may be instatiated if necessary
		$this->advrtPlug= &$tagsFu->mainAdvertPlugIn;
		
		[pgTitle]Hello[/pgTitle] 
	*/
	function tg_pgtitle(&$v,&$str){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;	
		$advrtPlug= &$this->mainAdvertPlugIn;
		
		$date= $tools->binLoads($v['date'],'');
		if ($date!==''){
			$date= $caps->spanTtl($date,'gecDate');
		}
		
		$cls= $tools->binLoads($v['cls'],'gecDivMainTtl');
		
		$maxDeskW= $tools->binLoads($v['maxdeskw'],'500');;
		$maxDeskW= ' max-width: '.$maxDeskW.'px;';
		
		$this->gotTitleMobBut= true; // Could adapt it if the mobile button come to be facultative
		
		if ($tools->isInSmartPM()){
			$sPhBut= $this->styleMobBut('slTmImg');
		}else{
			$sPhBut= '';
		}
		
		
		$bdP= $v['bd'];
		if ($bdP!==false){
			$str= $bdP;
		}
		if ($advrtPlug!==false && $advrtPlug->gotAtLeastOneHzTtlAds){
			// Wrap the main title inside a DIV for better presentation Tittle / Ads
			$str= $caps->div($sPhBut.$date.$str,$cls,'','',$maxDeskW);
		}else{
			// No reason to wrap the title$
			$str= $caps->div($sPhBut.$date.$str,$cls);
		}
		
		if ($advrtPlug!==false){
			$str.= $advrtPlug->hzTtlBuffer;
		}
		
		return $str._c_BrFlux;
	} // tg_pgtitle
	
	/**
		Standard Sub-titles with one new line by default.
		[subTtl]Hello[/subTtl] 'cls', 'inline', 'bd'
	*/
	function tg_subttl(&$v,&$str){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;	
		$advrtPlug= &$this->mainAdvertPlugIn;
				
		$cls= $tools->binLoads($v['cls'],'gecSubTtl');
		$bdP= $v['bd'];
		if ($bdP!==false){
			$str= $bdP;
		}
		
		if ($v['inline']===_c_ok){
			return $caps->spanTtl($str,$cls);
		}else{
			return $caps->spanTtl($str,$cls)._c_BrFlux;
		}
	} // tg_subtitle	
	
	
	

	/**
		A specialised small tag management to be inserted inside a menu label to give
		some more info/data! Tha starting paradigm concern the date! [dat str="29/04/18" /]
	*/
	function tg_dat(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		$str= $v['str'].' : ';
		$cls= $tools->binLoads($v['cls'],'gecDate');
		return $caps->span($str,$cls);
	} // tg_dat

	
	/*
		[label] Middle default efMb [/label]	
		[label cls="efLb"] Large [/label]	
	*/
	function tg_label(&$v,&$str){
		return $this->tg_span($v,$str);
	} // tg_label
	
	
		
	/*
		Label for the editor only. 
	*/
	function tg_elabel(&$v,&$str){	
		$rgh= &$this->rights;
		if (!$rgh->pwCheck3()){
			return '';
		}	
		return $this->tg_span($v,$str);
	} // tg_elabel
	

	/**
		Returns the given body only when someone is logged as a webmaster.
		[onlyEdit][/onlyEdit]
	*/
	function tg_onlyedit(&$v,&$bd){
		$rg= &$this->rights;
		if ( $rg->quickWMRight() ){
			return $bd;
		}
		return '';
	} // tg_onlyedit
	
	
	/**
		Returns the given body only when someone is NOT logged as a webmaster.
		[onlySurf][/onlySurf]
	*/
	function tg_onlysurf(&$v,&$bd){
		$rg= &$this->rights;
		if ( $rg->quickWMRight() ){
			return '';
		}
		return $bd;
	} // tg_onlysurf

	
	
	
		
	
	/**
		Returns the bold taged body with the appropriated Html code.
	*/
	function tg_b(&$v,&$bd){
		$caps= &$this->caps;	
		return $caps->bold($bd);
	} // tgB

	/**
		N for do nothing.
	*/
	function tg_n(&$v,&$bd){
	} // tg_n

	/**
		Returns the italic taged body with the appropriated Html code.
	*/
	function tg_itc(&$v,&$bd){
		$caps= &$this->caps;	
		return $caps->italic($bd);
	}

	/**
		Returns the underlined taged body with the appropriated Html code.
	*/
	function tg_u(&$v,&$bd){
		$caps= &$this->caps;	
		return $caps->underline($bd);
	} // tgU
	
	
	/**
		[bf/] bf for break flux.
	*/
	function tg_bf(&$v,&$bd){
		return _c_BrFlux;
	} // tg_bf
	
	/**
		A method to calculate the optimum display on large screens by allowing the % calculated full width to take
		place naturaly. On small screens a minimum specified necessary width is there to avoid too small looking images
		ad a more natural way to display them
	*/
	function tg_bg(&$v,&$bd){
		return '';	// return nothing explicitely! Just there to be replaced by tg_bfsubstitute() at initialisation stage.
	} // tg_bg
	
	
	/**
		[bfN n="20" /] bf for break flux.
	*/
	function tg_bfn(&$v,&$bd){
		$n= $v['n'];
		
		$b= '';
		for ($i=0; $i<$n; $i++){
			$b.= _c_BrFlux;
		} // for
		
		return $b;
	} // tg_bfn
	
	
	
	

	
	/**
		Yet redundant!
	function tg_btl(&$v,&$bd){
		return _c_BrFlux;
	} // tg_btl
	*/
	
	function tg_btx(&$v,&$bd){
		$caps= &$this->caps;	
		$tools= &$this->tools;
			
		$n= $tools->binLoads($v['n'],1);
		return $caps->fluxBr($n);
	} // tg_btx
	
	
	function tg_br(&$v,&$bd){
		$caps= &$this->caps;	
		return $caps->br();
	} // tg_br
	
	
	
	/**
		_c_tgLt 
	*/
	function tg_lt (&$v,&$bd){
		return '&lt;';	// '<'
	} // tg_lt

	/**
		_c_tgGt
	*/
	function tg_gt(&$v,&$bd){
		return '&gt;';	// '>'
	} // tg_gt
		
	
	function tg_lb (&$v,&$bd){
		return _c_lBrk;
	} // tg_lb

	function tg_rb(&$v,&$bd){
		return _c_rBrk;
	} // tg_rb
	
	/**
		Html Meta tags */
	
	/**
		browserGlobTtlPrfx
	*/
	function tg_title(&$v,&$bd){
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		
		$slc= $v['slcode'];
		if ($slc!==false){
			$this->globHtmlMTitle= $glob->sl('Dynamic html title, the code is missing!',$slc);
			return;
		}
		
		$elc= $v['elcode'];
		if ($elc!==false){
			$this->globHtmlMTitle= $glob->el('Dynamic html title, the code is missing!',$elc);
			return;
		}
		
		$gVar= $v['genvar'];
		if ($gVar!==false){
			$this->globHtmlMTitle= $dtb->getGenVar($gVar);
				return;
		}
		
		$bd= trim($bd);	// so white on both sides of the code are ok
		$prfx= $v['prfx'];
		if ($this->globTtlPrfx==='' || $prfx===_c_ko){
			$this->globHtmlMTitle= $bd;
		}else{
			$this->globHtmlMTitle= $this->globTtlPrfx.$bd;
		}
	} // tg_title
	
	/**
	*/
	function title($code,$kind='el'){
		$glob= &$this->glob;
	
		switch ($kind){
			case 'el':
				$this->globHtmlMTitle= $glob->el('',$code);
			break;
			
			case 'self':
				$this->globHtmlMTitle= $code;
			break;
			
			case 'sl':
			default:
				$this->globHtmlMTitle= $glob->sl('',$code);
			
			break;
		} // switch
	} // title
	
		
	/**
	*/
	function tg_descr(&$v,&$bd){
		$bd= trim($bd);	// so can add white on both sides of the code
		$this->globHtmlMDescr= $bd;		// last tag wins
	} // tg_descr	
	
	/**
		Loads and stick on the 1st met Html Meta Title.
	*/
	function tg_kw(&$v,&$bd){
		if (trim($bd)!==''){
			$this->globHtmlMKw= $bd;	// last tag wins
		}
	} // tg_kw
	
	
	/**
		[lang]fr[/lang]
	*/
	function tg_lang(&$v,&$bd){
		$tools= &$this->tools;
		
		$sLg= $tools->getVal('sLg');
		if ($sLg!==false){
			$this->globHtmlMLang= $sLg;		
		}else{
			$this->globHtmlMLang= trim($bd);
		}
	} // tg_lang
	
	/**
		Specific the current robot tag
		[robots]index, follow[/robots]
		[robots]noindex, nofollow[/robots]
	*/
	function tg_robots(&$v,&$bd){
		$this->cRobots= trim($bd);
	} // tg_robots
	
	/**
		To specify the current viewport, example with special case no-zomm in and out case :
		[viewport content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1" /]
	*/
	function tg_viewport(&$v,&$bd){
		$this->tgViewportContent= $v['content'];
	} // tg_robots
	

	/* ------------------------------------------------------
		Special tags.
	*/
	
	/**
		To insert any code inside the header
		[anyCodeInHeader opt="css"][/anyCodeInHeader]
		<style type="text/css"></style>
	*/
	function tg_anycodeinheader(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		switch ($v['opt']){
			case 'css':
				$bd= $caps->cssTag($bd);
			break;
			
			case 'js':
				$bd= $caps->jsTag($bd);
			break;
			
			default:;
		} // switch
		
		$glob->anyCodeInHeader.= $bd;
	} // tg_anycodeinheader
	
	
	/**
		Should be allowed only in edition mode only for knonwlegeable webmasters, they should
		directly change a constant in const.php. so they know what they are up to!  ( tag : _c_tgPhp ).
		Any.
		
		[php] phpinfo(); [php/]
	*/
	function tg_php(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
	
		if (_c_evalIsAllowed===true){
			return eval($bd); // can also specify any functions/methods inside eval !!!
		}else{
			return $glob->el('Sorry, the tag ','kmep').'['. _c_tgPhp .'] ...[/'._c_tgPhp.'] '.$glob->el('is not enabled!','kmhx');
		}
	} // tg_php
	
	
	/**
		Eval at the end of the html page any javascript given
		[js]alert('Hello World')[/js]
	*/
	function tg_js(&$v,&$bd){
		$glob= &$this->glob;
		$glob->setGlbEndJsCode($bd._c_R);
	} // tg_js


	/**
		To execute directly some data base code (MySql or whatever).
		[dtbCode]  [/dtbCode]
	*/
	function tg_dtbcode(&$v,&$bd){
		$glob= &$this->glob;
		$dtb= &$glob->dtbChg;
	
		if ($v['ret']==='ok')
			return $dtb->dtbQuery($bd);
		else{
			$dtb->dtbQuery($bd);		
		}
	} // tg_dtbcode

	
	/**
		xPetal Meta tags.
	*/
	
	/**
		To avoid tag executions between 
			[code var="leftBrk" val="["]... body ... [/code]
			
		To catch some code and do something with it later on, like to execute it after something that is a priority.	
			[code keep="true" ] ... [/code]
		Note : if we surrounf tzhe whole content of a form tag, the concerned form function can expand it's body to
		execute the concerned code!
	*/
	function tg_code(&$v,&$bd){	
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$cls= $v['cls'];
		if ($cls===false){
			$cls= 'cDspl';
		}
		
		if ($v['var']!==false && $v['val']!==false){
			// Does one or many substitutions on $bd with user variable and value.
			$bd= str_replace ($v['var'],$v['val'],$bd); 
		}
		
		if ($v['keep']===false){
			// default, don't keep the exact content -->  add visual indentation formating.
			$bd= str_replace (_c_R, _c_, $bd);		// replace the carriage return with html breaks and CR	
			$bd= str_replace (_c_rT, _c_sT, $bd);	// replace real tabs with simulated tabs
			if ($cls!==_c_ko){
				$res= $caps->span($bd,$cls);
			}else{
				$res= $bd;
			}
		}else if ( $v['keep']===_c_ok ){
			/* So the encapsulatong tag can do whatever it wish with it, especially usefull for shifted execution / expansion 
			   of the xpetal code. Note that it's onéy usable if the [code] tag encompass the whole body of the encapsulating tag,
			   otherwise we can't tell the difference between the [code] encapsulated part and the rest! So for parially encapsulated
			   code we need
			*/
			$res= $bd;
		}else if ( $v['keep']==='nib' ){
			// For immediade encapsulator used of a specific part of the calling tag body (for now only available in [mainFormBd])
			$this->encapsNibbledCode= $bd;
			$res= '';	// so does not execute something directly
		}else{
			print($glob->el('[code] : unknown value for the keep parameter!','kmev'));
			$res= $bd;		
		}
		
		return $res;
	} // tg_code


	/**
		[nop mess="hello" /] A No Operation Tag (just for syntax testing) and to force a closure of % zoom calculations 
		when [bf/] is not advisable, for example to have a floating text after a thumb.--> tagsParser::$takeInvibleChars= false;
	*/
	function tg_nop(&$v,&$bd){
		if ($v['mess']!==false){
			return $v['mess'];
		}else{
			return '';
		}
	} // tg_nop
	
	function tg_tab(&$v,&$bd){
		return _c_sT;
	}


	/**
		Remarks or comments.
			Just returns '', so can put inside any tags, it executes them but do not output them !!!
			To avoid extra processing and unintentional dat base changes, tags inside [rem]
			should be surrounded by [code]  ... [/code].
	*/
	function tg_rem(&$v,&$bd){
		return '';	
	} // tg_rem
	
	function tg__(&$v,&$bd){
		return '';	
	} // tg__
		
	
	/**
		Set xml global variables.
	*/	
	
	/** ------------------------------------
		Diverse functions tag related.
	*/
	
	/**
		Calls and analyse the general initialisation record _c_initTags used to set some control variables
		as $this->glob (class globVar) instance variable.
		
		Input : the coord of the init file to process which is : _c_initTags
		Output : process the init-xml-tag file to load appropriate variables
	*/
	function tagInitialisation(){
		$parser= &$this->parser;
		$strToParse= $this->dtb->getMainStr($sz,_c_initTags);		
		$scanStr= new scanStr($this,$strToParse, $sz, 0, false, _c_initTags);	// the main string for the current record		
		$parser->callParser($scanStr);
	} // tagInitialisation
	
			/**
				Define the default top surrounding string to which pages must refer if they don't have a specific top defined.
					Example  [deftgup ref="top" /]
			*/
			function tg_deftgup(&$v,&$bd){
				$glob= &$this->glob;
				$glob->deftagUp= $v['ref'];
				return '';
			} // tg_deftgup
			
			/** -----------------------------------------------------------------
				Sets for html GENERAL DIV CAPSULATION OF MENUS with the menuIndent style.
					Example : [divMen got="ok" cls="menuIndent" /]
			*/
			function tg_divmen(&$v,&$bd){
				$glob= &$this->glob;
				$glob->divMen= $v['got'];		// define if we got a global <div>...</div> encapsulation for menus.
				return '';
			} // tg_divmen
				
			/**
				Define the general menu DEFAULT FONTS for the current menu.
				Specific fonts are defined in
			*/
			function tg_menufont(&$v,&$bd){
				$glob= &$this->glob;
				$glob->menuFontIn= $v['in'];
				$glob->menuFontOut= $v['out'];
				return '';
			} // tg_menufont


	/**
		[stopSmplSurf pg="home" /] - Stops the current parsing if not logged (stops simple surf).
		--> and jump to the home page!
	*/
	function tg_stopsmplsurf(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rgh= &$this->rights;
		$parser= &$this->parser;
		
		// Exception when we can display the page even if not connected (used in the change pw page so can display the message even if not connected any more)
		$exName= $v['exception'];
		if ($exName!==false){
			$except= $dtb->getGenVar($exName);
		}else{
			$except= _c_ko;
		}
		
		if ($rgh->pwCheck3() || $except===_c_ok){
			return '';
		}else{
			// not enough rights
			$glob->gotActStopSmplSurf= true;
			$inclPg= $this->includeRec(_c_mainHomePage);
			$parser->stopParser();
			return $inclPg;
		}
	} // tg_stopsmplsurf
	

	/**
		Full stop for anyone without a password, but just returns nothing!
	*/
	function tg_fstopsmplsurf(&$v,&$bd){
		$rgh= &$this->rights;
		$parser= &$this->parser;
		
		if (!$rgh->pwCheck3()){
			$parser->stopParser();
			return '';
		}
	} // tg_fstopsmplsurf
		
		
	/**
		Stop current file parsing on a url signal : &uStopParser=ok
		[urlStopParser /]
	*/
	function tg_urlstopparser(&$v,&$bd){
		$tools= &$this->tools;
		$parser= &$this->parser;
			
		$sp= $tools->getVal('uStopParser');
		if ($sp===_c_ok){
			$parser->stopParser();
			return '';
		} // else : nothing to do
	} // tg_urlstopparser
	
	

	/**
		(1) [ChgDblQuotes sign="#" /]
		(2) [ChgDblQuotes sign=#"# /]
	*/
	function tg_chgdblquotes(&$v,&$bd){
		$glob= &$this->glob;
		$glob->doubleQuote= $v['sign'];
	} // tg_chgDblQuotes


	/**
		[mobile /]
	*/
	function tg_mobile(&$v,&$bd){
		$tools= &$this->tools;
		
		$defStl= $tools->mostValid($v['defstl'],'slImgPhone');
		
		if ($v['onlymobmd']=== _c_ok && !$tools->isInSmartPM()){
			return '';
		}
		
		if ($v['onlydekmd']=== _c_ok && $tools->isInSmartPM()){
			return '';
		}
		
		return $this->styleMobBut($defStl);
	} // mobile

	
	/**
		[mobExpdShrk/] : Mobile functions with an expand / shrink look
	*/
	function tg_mobexpdshrk(&$v,&$bd){
		return $this->mobileButton('shrink.png','expand.png','slMobExpdShrkL');			
	} // mobexpdshrk
	
	/**
	*/
	function styleMobBut($css='slImgPhone'){
		return $this->mobileButton('smartPhone.png','smartNoPhone.png',$css);			
	} // styleMobBut

	
	/**
	*/
	function mobileButton($mobPict='smartPhone.png', $noMobPict='smartNoPhone.png', $css='slImgPhone'){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		
		$arCmd[_c_smartPhoneMode]= true; 
		$url= $tools->urlCurPg($arCmd);
		
		if ($tools->isInSmartPM()){
			if ($dtb->defltSmartPhoneMode!==_c_ko){
				$url.= $tools->addUrlVar(_c_smartPhoneMode,_c_ko);
			}
			$mob= $caps->linkImg(_c_EditorImgPath.$mobPict, $glob->sl('You are in smartphone mode ...','kaxd'), $url,$css);
		}else{
			if ($dtb->defltSmartPhoneMode!==_c_ok){
				$url.= $tools->addUrlVar(_c_smartPhoneMode,_c_ok);
			}
			$mob= $caps->linkImg(_c_EditorImgPath.$noMobPict, $glob->sl('You are in desk top mode ...','kaxe'), $url,$css);
		}
		return $mob;
	} // mobileButton
	
	/**
		[mobExpdShrkPlus/] : adds a fitting mode button to the standard shrink/expand 
		(mobile-small-screen-mode)
	*/
	function tg_mobexpdshrkplus(&$v,&$bd){
		$b= $this->tg_mobexpdshrk($v,$bd);

		$b.= $this->tryingClothesButton();			
		return $b;
	} // mobexpdshrkplus
	
	/**
		Cliquez ici pour l'essayage'
	*/
	function tryingClothesButton(){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		$arCmd= array();
		
		$arCmd[_c_catWalkMode]= true;	// true ---> we treat it directly
		$url= $tools->urlCurPg($arCmd);
		
		if ($tools->isInCatWalk()){
			$tools->noTwinReprodUVar($url,_c_catWalkMode,_c_ko);
			$mob= $caps->linkImg(_c_EditorImgPath.'yesHat.png', $glob->st('Please click here for details!','catWalkOn'), $url,'slMobExpdShrkL');
			
			$lbl= $glob->st('Please click here for details!','catWalkOn');
			$attS= $caps->matCss('vtoModeSwitchLblA');
			$mob.= $caps->hLink($url,$lbl,$attS);						
		}else{
			$url.= $tools->addUrlVar(_c_catWalkMode,_c_ok);
			$mob= $caps->linkImg(_c_EditorImgPath.'fitHat.png', $glob->st('Changing room!','catWalkOff'), $url,'slMobExpdShrkL');
			$lbl= $glob->st('Changing room!','catWalkOff');
			$attS= $caps->matCss('vtoModeSwitchLblB');
			$mob.= $caps->hLink($url,$lbl,$attS);			
		}
		return $mob;
	} // tryingClothesButton
	
	
	/**
		Trim the content for a mobile phone ---> just get rid of the information if we are in mobile mode!
		[mobiletrim] Appear only in desk top mode [/mobiletrim]
	*/
	function tg_mobiletrim(&$v,&$bd){
		$tools= &$this->tools;
		if ($tools->isInSmartPM()){
			return '';	// could be cool to have a jump at the parsing level!
		}else{
			return $bd;
		}
	} // tg_mobiletrim
	
	/*
		Return the content ()obviously a summary when most other things are not displayed) only for mobiles
		[mobiletrim] Blabla for moboles [/mobiletrim]
	*/
	function tg_mobilesummary(&$v,&$bd){
		$tools= &$this->tools;
		if ($tools->isInSmartPM()){
			return $bd;
		}else{
			return '';
		}
	} // tg_mobilesummary
	
	
	/**
		Select the given body with a bookmark, and in case of smart phone mode return it only if _c_smartPhUniqParag if given and matching!
		[mobIdSelect hashTag="" ]...[/mobIdSelect]
	*/
	function tg_mobidselect(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		/**
			Firstly used as a hash tag and secondly as _c_smartPhUniqParag, so for this last case, we need a list
			of valid tags saved under _c_PolyCellPg :: _c_pcNecStr (undirect connection in these cases)
		*/
		$hTag= $v['hashtag'];
		array_push($glob->allowebSmartPhParagrIds,$hTag);
		
		$topN= $tools->binLoads($v['topn'],1);	// top number of _c_BrFlux
		$botN= $tools->binLoads($v['botn'],1);	// bottom number of _c_BrFlux
		if ( $tools->isInSmartPM() ){
			$uParag= $tools->getVal(_c_smartPhUniqParag);
			if ($uParag===$hTag){
				// keep $bd;
			}else{
				$bd= '';
			}
		}else{
			// keep $bd;
		}
		
		if ($bd===''){
			return '';
		}else{
			return $caps->fluxBr($topN).$caps->bookMark($hTag).$caps->fluxBr($botN).$this->globMisHeader.$bd;
		}
	} // tg_mobidselect
	
	
	/**
		To include anything repating itself everytime ahead of all [mobIdSelect hashTag="" ]...[/mobIdSelect] of the page!
		[misHeader] ... [/misHeader]
	*/
	function tg_misheader(&$v,&$bd){
		$this->globMisHeader= $bd;
		return '';
	} // tg_misheader
	
	
	/**
		Html bookMark
		
		[bookMark id="aaa" /]
	*/
	function tg_bookmark(&$v,&$bd){
		$caps= &$this->caps;
		$glob= &$this->glob;
		
		if ($glob->curGPostId!==false){
			$prfx= $glob->curGPostId;
		}else{
			$prfx= '';
		}
		
		return $caps->bookMark($prfx.$v['id']);
	}
		
	/**
		[jumpToBm id="aaa" cls="aaa" ]labelABCD[/jumpToBm]
	*/
	function tg_jumptobm(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$id= $v['id'];
		$cls= $v['cls'];
		
		$url= $tools->urlForumPost();
		$url.= $tools->signet($id);
		return $caps->hL($url,$bd,$cls);
	}


	/**
		A tag to use the globVar::sl() type of translations directly within the squared brackets!
		Surf Language Translation
		Note : tha tag body is the english string and the id a parameer.
		[slt id="aaa"][/slt]
	*/
	function tg_slt(&$v,&$englStr){
		$glob= &$this->glob;
		$id= $v['id'];
		return $glob->sl($englStr,$id);
	} // tg_slt
	
	
	/**
		Set or creates a variable value inside the table _c_GenVarTbl
	*/
	function tg_newvar(&$v,&$bd){
		$glob= &$this->glob;	
		$dtb= &$this->dtb;
		
		$var= $v['var'];
		$val= $v['val'];
		$dtb->newGenVar($var,$val);
		
		if ($v['builder']!==false){
			// Builder case declared
			$glob->tagGlobVect[$var]= $val;		
		}
	} // tg_newvar
	
				
	/**
		[phpIntMax /]
	*/
	function tg_phpintmax(&$v,&$bd){
		return 'Php Int Max='.PHP_INT_MAX._c_;
	}

		
	/**
		Go to a specified page.
	*/
	function tg_goto(&$v,&$bd){
		$rMg= &$this->rMg;
		$parser= &$this->parser;
		
		if (!$rMg->quickWMRight()){
			$pg= $v['pg'];
			$men= $v['men'];
			if ($men===_c_ok){
				$result= $this->includeRec($pg,_c_PolyCellPgM,_c_pcMainStr);
			}else{
				$result= $this->includeRec($pg,_c_PolyCellPg,_c_pcMainStr);
			}
			$parser->stopParser();
			return $result;
		}
		return '';
	} // tg_goto
	

	/**
		Css Inclusion for a given plugin with user directory definition!
	*/
	function cssInclusion($plugName,$external=true){
		$glob= &$this->glob;
		$glob->addCssFile( $glob->cssPath($plugName,$external) );
	} // cssInclusion
	
	function cssExtInclusion($pN){
		$this->cssInclusion($pN);
	}
	
	function cssCntrInclusion($pN){
		$this->cssInclusion($pN,false);
	}
	
	

	/**
		To assign some page attributes on a gicen page
		[pageAttrib captcha="ok" /]
	*/
	function tg_pageattrib(&$v,&$bd){
		$this->curPgAttrib= &$v;
	} // tg_pageattrib
	

	/**
		[callPolyHeader pfx="header" /]
	*/
	function tg_callpolyheader(&$v,&$bd){
		return $this->cllPolyHeader($v);
	} // tg_callpolyheader

	/**
	*/
	function cllPolyHeader(&$v){
		$glob= &$this->glob;
		
		$lg= $glob->curSurfLg();
		$pgNm= $this->curPolyPage($v['pfx'],$lg);
		return $this->includeRec($pgNm);
	} // cllPolyHeader
	

	// [headerForAll /]
	function tg_headerforall(&$v,&$bd){
		return $this->includeRec($v['name']);
	} // tg_headerforall
	
	
	/**
		Return the simplified curent polyglot page.or Id (use for language sensitive headers creation and call)
	*/
	function curPolyPage($pfx,$lg){
		return $pfx.'-'.$lg;
	} // curPolyPage


	/**
		[jsCapsulOn /]
	*/
	function tg_jscapsulon(&$v,&$bd){
		$glob= &$this->glob;
		$glob->jsCapsulOn($v['head'],$v['tail']);
	}


	/**
		A practical Ataox signature.
		[ataox forceimg="ok" float="left" /]
	*/
	function tg_ataox(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$tools= &$this->tools;
		
		$b= '';
		$pg= $tools->binLoads($v['pg'],'t0pAll');
		$imgstar= $tools->binLoads($v['hideimgstar'],_c_ko); // ok --> force hidding and ko does not interfer!!
		$float= $v['float'];
		$float= $tools->binLoads($float,'right');
		
		if ($v['cls']===false){
			$cls= $dtb->getGenVar('ataoxLogoBotF');
		}else{
			$cls= $v['cls'];
		}
		
		$b.= '[a url="http://ataox.org" cls="'.$cls.'" target="_blank" sb="kaww"]Powered by Ataox[/a]';
		if ( $v['hideimgstar']!==_c_ok && ($v['forceimg']===_c_ok || $dtb->getGenVar('ataoxLogoBot')===_c_ok) ){
			$b.= '[i name="ataoxSmall.png " url="http://ataox.org" alt="" ttl="" cls="imgLnStlR" edt="ok" target="_blank" /]';
		}
		
		$b.= '[ePage name="'.$pg.'" ttl="Show code" es="kalp" cls="'.$cls.'"]*[/page]';		
		
		$supSign= '';
		$supLn= $v['supln'];
		if ($supLn!==false){
			$ssStr= $glob->sl('Supp. Signature','suppSignatureStr');	// Probably technical contact depend on the main webmaster
			if ($ssStr!==_c_ko && $ssStr!==''){
				$supSign= $caps->hL($supLn,$ssStr,$cls,'_blank')._c_;
			}
		}
		
		$ataoxSign= $this->expandX($b,'Ataox signature');
		return $caps->sDiv($supSign.$ataoxSign, ' margin-right:10px; width:270px; border:0px solid red; padding:2px; float:'.$float.'; background-color:white;');
	} // tg_ataox


	/**
		To edit the concerned page just clicking on the given body, originally a *
	*/
 	function tg_epage(&$v,&$bd){
 		$glob= &$this->glob;
 		$tools= &$this->tools;
		$caps= &$this->caps;
 		$rgh= &$this->rights;
		$wmR= &$this->wmRights;
		
		if ($rgh->pwCheck3() &&  ( $v['stopedit']!==_c_ok || $wmR->wmUlnPgXess() ) ){
		
			$title= $glob->el($v['ttl'],$v['es']);		
			$url= $tools->urlGivenPage($v['name']);
			$url.= $tools->addUrlVar(_c_surfEdt,_c_seEditVal);
			
 			return $caps->linkTC($url,$bd,$title,$v['cls']);	
		}else{
			return '';
		}
	} // tg_epage

	/**
		[jsCapsulOff /]
	*/
	function tg_jscapsuloff(&$v,&$bd){
		$glob= &$this->glob;
		$glob->jsCapsulOff();
	}

	/**
		[mainAtaoxDirN /]
	*/
	function tg_mainataoxdirn(){
		return _c_asppDirN;
	}
	
		
	/**
		[debugDsplay/]
	*/
	function tg_debugdsplay(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
				
		$area= _c_.$caps->span($glob->el('Supplement display :','kbbg')._c_, 'wnslStd');
			
		$ln= $tools->binLoads($v['ln'],'10');
		$cl= $tools->binLoads($v['cl'],'100');
		$area.= $caps->txArea('debugDisplay',$ln,$cl,'',$caps->matCss('wnslBox'));
		
		$glob->setGlbEndJsCode('kk.initDebugDisplay();');
		
		return $area._c_;
	} // tg_debugdsplay
	

	/**
		[diffPgName n="Training" /]
		Remark : this tag can be used in installer.php and in editTools.php
	*/
	function tg_diffpgname(&$v,&$bd){
		$fls= &$this->fls;
		$dtb= &$this->dtb;

		$this->curDiffPgName= $fls->safeIdString($v['n']);	// length tested outside
		$this->usesUtfUrl= $v['utfurl'];
		
		if ($dtb->getGenVar('builderSafeIdsLowerCases')===_c_ok){
			$this->curDiffPgName= strtolower($this->curDiffPgName);
		}
		return '';
	} // tg_diffpgname

	/**
		[diffPgNameMdlLg n="en" /]
		Remark : this tag can be used in installer.php and in editTools.php
	*/
	function tg_diffpgnamemdllg(&$v,&$bd){
		$this->diffPgNameMdlLg= trim($v['lg']);
		return '';
	} // tg_diffpgnamemdllg
	
	
	/**
		Can add any page mode we want, following 1st one syntax.
		[pageMode forum="closed" /]
		SEE fumShrdCdLgt::forumPageIsOpen()
	*/
	function tg_pagemode(&$v,&$bd){	
		$this->pgMdForumPgIsOpen= $v['forum']!=='closed';
	} // tg_pagemode
	

	/**
		[surfTrans helpstr="Sorry no translation available" id="" /]
	*/
	function tg_surftrans(&$v,&$bd){
		$glob= &$this->glob;
		
		$lg= $glob->curSurfLg(); // takes the mother page as a priority!
		
		$helpstr= $v['helpstr'];
		$id= $v['id'];
		return $glob->st($helpstr,$id,$lg);
	} // tg_surftrans



	/**
		Expand some Xpetal code
		Input :
			$Xpet : the string to parse.
			$idElem : id Element (the facultative information string)
		Output :
			returns the parsed result.
	*/
	function expand($Xpet,$idElem='',$ret=true){
		$parser= &$this->parser;
		$sz= strlen($Xpet);
		$scanStr= new scanStr($this,$Xpet,$sz,0,false, $idElem);
		if ($ret){
			return $parser->callParser($scanStr);
		}else{
			$parser->callParser($scanStr);
		}
	} // expand
	
	// Idem expand but passing the address
	function expandX(&$Xpet,$idElem='',$ret=true){
		$parser= &$this->parser;
		$sz= strlen($Xpet);
		$scanStr= new scanStr($this,$Xpet,$sz,0,false, $idElem);
		if ($ret){
			return $parser->callParser($scanStr);
		}else{
			$parser->callParser($scanStr);
		}
	} // expandX
	
	/**
		To expand a parameter for other function than simple input (no default return.)
		[expandParam p="" /]
	function tg_expandparam(&$v,&$bd){
 		$param= $v['p'];
		return $this->expandX($param,'expandParam',false);
	} // tg_expandparam
	*/

	/**
		To expand a field of codeTrans in the givem language!
		Warning : this must be exeptiobal and retrograded when possible with the Xpetal
		code purely ionisde the table idCode and pure tranlations inside the table codeTrans.
		[expandCodeTransId id="" /]
	*/
	function tg_expandcodetransid(&$v,&$bd){
		$glob= &$this->glob;
		$dtb= &$this->dtb;

 		$id= $v['id'];
 		$lg= $glob->esLg();
 		$lgField= $glob->lgAbrevToLgField($lg);
 		$param= $dtb->getElem(_c_CodeTransTbl, _c_GenTransId,$id, $lgField);
		return $this->expandX($param,'expandcodetransid');
	} // tg_expandcodetransid
	
	
	/**
		Returns the unfolded value of the specified $ref/id. The returned value can be included anywhere.
		Input :
			$ref : the concerned reference / id
			$tbl : the concerned table
			$field : the field to parse
			$ret : return or return not the infos.
		Output :
			If ($ret) then returns the expanded string.
			In all case executes the xml code which can do anything: dtb modification etc. depending on what tags are used.
	*/	
	function includeRec($ref, $tbl=_c_PolyCellPg,$field=_c_pcMainStr, $ret=true,$extractDtbSz=true){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
	
		if ($parser->countParsings <= _c_parserMaxTimes){
			if ($extractDtbSz){
				$strToParse= $dtb->getCellStr($sz,$ref,$tbl,$field);
			}else{
				$strToParse= $dtb->getElem($tbl,_c_genId,$ref,$field);
				$sz= strlen($strToParse);
			}
			
			if ($sz <= 2){
				return $strToParse; // too small to be parsed, because a tag takes at least 3 characters.
			}
						
			$scanStr= new scanStr($this,$strToParse, $sz, 0, false, $ref);	// the main string for the current record
			
			if ($ret){
				return $parser->callParser($scanStr);
			}else{
				$parser->callParser($scanStr);
			}
		}else{
			$tools->tooManyTagsMess();
			return '';
		}
	} // includeRec
	
	
	/**	
		[inclCode id="" /]
	*/
	function tg_inclcode(&$v,&$bd){
		return $this->includeRec($v['id'],_c_idCodeTbl,_c_ictCode,true,false);
	} // inclcode
	
	
	
	/**
		Expand the given polyglot pointor, only in editor context !!!
		[tx es="xxx" /]  Just output a text using the language specific globVar::es()
	*/
	function tg_tx(&$v,&$bd){
		$glob= &$this->glob;
		
		$res= $glob->es('No translation for the tx tag',$v['es'],false);
		if ($v['expand']===_c_ok){
			return $this->expandX($res,'tg_tx');
		}else{
			return $res;
		}
	} // tg_tx
	
	/**
		Expands only multi-languages pages. Compared to n tg_tx(), this is a language SURF SENSITIVE expantion 
		of a given page! [surfExpand pg="" /]
		Remark : tg_callpolyheader() is more compact because it presupose that the concerned pages are symetrically named!
				which is faster but need special pages!
		Also see localDB::lgCorrectPg() and [inclSpecPg pg="..." /]
	*/
	function tg_surfexpand(&$v,&$bd){
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		
		$keyLg= $dtb->currentLg();
		$genericPg= $v['pg'];	// can be any page of the concerned language set, but better if main language so less operations to find the $actualPg (language relevant page)
		
		$lgPgSet= $dtb->languageFamVect($genericPg);
		if ( $lgPgSet!==false && array_key_exists($keyLg,$lgPgSet) ){
			$actualPg= $lgPgSet[$keyLg];
			return $this->includeRec($actualPg);
		}else{
			return $glob->el('No translation for the tag','kmew').' [surfExpand /]';
		}
	} // tg_surfexpand
	
	/**	
		Include a specific page with a precise name (not looking for language twins)
		[inclSpecPg pg="" /]
	*/
	function tg_inclspecpg(&$v,&$bd){
		return $this->includeRec($v['pg']);
	} // inclspecpg
	
	
	
	/**	
		Include Xpetal code from the table _c_idCodeTbl, expand it and return the result.
		[inclXpetalCd id="InstallerDtbMySql" /]
		
		'search','replace','sep'
		$subject= str_replace($search,$replace,$subject);
	*/
	function tg_inclxpetalcd(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$prevTANB= $this->forbTagAttribNmB;
		
		// Tag exclusion list of "name" attributes
		$tgExcLst= $v['tagexclst'];
		if ($tgExcLst!==false){
			$this->forbTagAttribNmB= true; // Indicates that $this->forbTagAttribNmV is functional
			$this->forbTagAttribNmV= $tools->trimStrToV($tgExcLst);	// forbidden tag attributes names vector
		}
		
		
		if ($v['forcesltoel']===_c_ok){
			// Had to forceSltoEl (force a surf language interpretation into an editing language interpretation
			$curSurfLg= $this->globHtmlMLang;
			$this->globHtmlMLang= $glob->edtLg();	// Force the surf language locally so it matches the editing language.
			$ret= $this->includeRec($v['id'],_c_idCodeTbl,_c_ictCode,true,false);
			$this->globHtmlMLang= $curSurfLg;
		}else{
			$ret= $this->includeRec($v['id'],_c_idCodeTbl,_c_ictCode,true,false);
		}
		
		$this->forbTagAttribNmB= $prevTANB;
		return $ret;
	} // tg_inclxpetalcd
	
	
	/**
		Extract and return the xPetal code with possible substitution from the _c_idTextsTbl table.
		[inclXpetalTxt id="aaa" search="rrrr" replace="tralala" expand="no" /]   
			... got to give the separator sep="," for multiple search/replace
	*/
	function tg_inclxpetaltxt(&$v,&$bd){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$expand= $tools->binLoads($v['expand'],'last');	 // expantion order : xpetal --> does the substitution on the xpetal code
	
		$xPetal= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$v['id'], _c_idTextTxt);
		if ($xPetal!==false){
			if ($expand=== 'first'){
				$xPetal= $this->expandX($xPetal);	// expand first
				// The low frequency case! In this case now the $xPetal string is NOT xPetal anymore, just neen expanded
			} // else : substitute first !!!
		
			$search= $v['search'];
			$replace= $v['replace'];
			if ( $search!==false && $replace!==false ){
				$sep= $v['sep'];
				if ($sep===false){
					$xPetal= str_replace($search,$replace,$xPetal);
				}else{
					$searchVect= explode($sep,$search);
					$replaceVect= explode($sep,$replace);
					$xPetal= str_replace($searchVect,$replaceVect,$xPetal);
				}
			}
		}
		
		if ($expand=== 'last'){
			$xPetal= $this->expandX($xPetal);
		}
		
		return $xPetal;
	} // tg_inclxpetaltxt
	
	
	
	/**
		[expandPage name="" /]	Expand the current page and return the whole string!
	*/
	function tg_expandpage(&$v,&$bd){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
 		$pg= $v['name'];
 		$xPet= $dtb->getElem(_c_PolyCellPg, _c_pcId,$pg, _c_pcMainStr);
 		
 		$capsCurPgNm= $tools->curPageName();
 		$tools->theCurrentPgNm= $pg;
		$buff= $this->expandX($xPet,'tg_expandPage',true);
		$tools->theCurrentPgNm= $capsCurPgNm;
		return $buff;
	} // tg_expandpage
	
		
	/**
		Force the menu visibility or invisibility locally while in surf mode.
			[menuVisibility vis="ok" /]
	*/
	function tg_menuvisibility(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;

		$vis= $tools->binLoads($v['vis'],_c_ok);	// no param --> force the menu
		$glob->forceSrfMenuVisibility= $vis;
	} // tg_menuvisibility
	
		
	/**
		[includeForumBar /] to replace [incl ref="_forumBar" /]
		Include the forum bar for a forum page! Only called from forum pages!
	*/
	function tg_includeforumbar(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$epTools= $this->optimLibAccess('edtPlusTools');
		
		$epTools->lambdaFBarOrProxy(); // loads localStorage.fumStyleInsrtTags
		
		$js= $caps->jsSimpleFu('kk.setInnerHtml',3,1,'localStorage.lambdaForumBar','publicForumBarId','Z');
		$glob->setGlbEndJsCode($js.';'._c_R);
		
		return $caps->dv('publicForumBarId');
	} // tg_includeforumbar
	
	
	/**
		[advert sffx="Articl1" /] so adbets can be controled globally.!
		Got to test tagsFu::tg_advert
	*/
	function tg_advert(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rgh= &$this->rights;
		
		if ($rgh->quickWMRight()){
			// Do not publish adverts visible for webmasters, because risks of publisher partner confusion
			$mess= $glob->el('Adverts externally controlled are not...','kbow');
			$surfEU= '"'.$glob->el('Surf like an external user!','kagl').'"';
			$rem= '"'.$glob->el(' remark if it s still not working, pleae look at the variable DTB entry forbidenAdvertSffxes','kboy').'"';
			return $mess.$surfEU.$rem; // + cookies are praticle for edition. forum subscribers should be warned about cookies
		}
		
		$sffx= $v['sffx'];
		$fAdvertSffxes= $dtb->getGenVar('forbidenAdvertSffxes');
		if ($tools->inVString($fAdvertSffxes,$sffx) || $tools->inVString($fAdvertSffxes,'forbidAll') ){
			return ''; // the suffix is in the list of forbidden ones
		}
		
		$urlForbidenAdVar= $dtb->getGenVar('urlForbidenAdVar');
		$urlFaVal= $tools->getVal($urlForbidenAdVar);
		if ($urlFaVal!==false){
			$dtbFaVal= $dtb->getGenVar('urlForbidenAdVal');
			if ($urlFaVal===$dtbFaVal){
				$lim= (int)$dtb->getGenVar('urlForbidenAdLim');
				$cnt= (int)$dtb->getGenVar('urlForbidenAdCnt');
				$cnt++;
				$dtb->setGenVar('urlForbidenAdCnt',$cnt);
				if ($cnt<$lim){
					return ''; // add not called because of secret url value! Must b used only temporary
				}
				
			}
		}
		
		$dtbIdx= 'localAd'.$sffx;
		$advertText= $dtb->getGenVar($dtbIdx); // Advert Text / JS / Html etc defined inside the DTB
		return $advertText;
	} // advert
	
	
	/**
		[test/] Just a test function!
	*/
	function tg_test(&$v,&$bd){
		return '[i js=" onclick=\\"forumBar.txtArAct(\'bulletList\')\\"" /]';
	} // test


} // tagsFu
?>