<?php
/**
	File name : textEditor.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	The base editor class to manage the large Xm2 text boxes.
*/
class textEditor extends oTop{
	

	function __construct(&$asa){
		parent::__construct();	
		
		$this->asa= &$asa;		
		$this->tblName= _c_PolyCellPg;
		$mainStr= '';
		$nectStr= '';
		
		define('_c_standardEdit','edt');	// Standard edition action value.
		define('_c_afterActionClick','afterClick');
		
		// A name for the polyvalent insert div holding the standard editor or the forum bar style editor
		define('_c_polInserDiv','polInserDiv');
				
		$this->forumBar= &$asa->forumBar;
		
		$this->successWithNewPgFrom= false;
		$this->independantPgName= false;
	} // construct

		

	/**
		Returns false if we don't have an insertion success from a mother page, otherwise returns the mother page name.
	*/
	function successWithNewPgFrom(){
		return $this->successWithNewPgFrom;
	} // successWithNewPgFrom
		
	/**
		Returns false if we don't have an independant insertion success, otherwise returns the mother page name.
	*/
	function independantPgName(){
		return $this->independantPgName;
	} // independantPgName



	/**
		Analyses the results posted when using $this->display() and "change" (meaning update) the data base accordingly.
		Input ; posted values
		Output : 
			- Changes inside the Dtb and returns $mainStr.
			- $szM : size of $mainStr
			- $tblName : pages or menu, so the 2 following table names : _c_PolyCellPg or _c_PolyCellPgM
			- $curPage : the current page (eventually forced against the url page name to maintain edition coherance with a new posted page name (don't want to JS change the form-url))		
		>analyseAndChgDtb(
	*/
	function analyseAndChgDtb(&$szM,&$tblName,&$curPage){
		$asa= &$this->asa;				
		$glob= &$asa->glob;
		$tools= &$asa->tools;
		$acc= &$asa->acc;
		$caps= &$asa->caps;
		$fls= &$asa->fls;
		$dtb= &$asa->dtb;
		$rMg= &$asa->rMg;
		$tagsFu= &$asa->tagsFu;
		$topEdtBar= &$asa->topEdtBar;
		$editTools= &$asa->editTools;
		$parser= &$asa->parser;
		$cacheR= &$asa->cacheR;
		$cacheWr= &$asa->cacheWr;
	
	
		$tblName= $tools->gostVal(_c_tableUrlVar,_c_PolyCellPg);
		
		if (is_string($curPage) && strlen($curPage)>0){
			$okForChange= ($curPage[0]==='_' && $rMg->suRights()) || $curPage[0]!=='_';
			$gotAPage= true;
		}else{
			$okForChange= false;
			$gotAPage= false;
		}
		
		$checkForm= $tools->postVal(_c_mEdtCheckForm,_c_ko);		// The form was sent
		$actionClick= $tools->getVal(_c_actionGetVar); 		// Got an action click		
		
		$dirActClick= $tools->getVal(_c_dirActionClick); 		// Got direct action click
		if ($dirActClick!==false){
			$tblName= _c_PolyCellPg;
			return $dtb->getMainStr($szM,$curPage);
		}
		
		if ($checkForm===_c_ok && !$okForChange && $gotAPage){
			$glob->userError($glob->el('The page ','katy').$curPage.$glob->el(' is an unwritable protected system page','katz'));
		}
		
		
		$formActBut= $tools->postVal('actionBut','editCurrent');	// Form action button
		$selectedRecId= $tools->postVal('selectedRecId',$curPage);
			
		$possibleWrit= $checkForm===_c_ok && $okForChange;
		
		if ($possibleWrit && $glob->cndtWrRghts===false){
			$glob->setGuestDisplay($formActBut,$glob->el('inside the the main text editor for ','kaua').$curPage);
			return $dtb->getMainStr($szM,$curPage);
		}

		$glob->startRecv();
		
		/*
			Deals with the posted actions :
		*/			
		if ($possibleWrit && $glob->cndtWrRghts===true){
			switch ($formActBut) {
				case 'editCurrent':
					$postedMainStr= $tools->postVal(_c_taMainStNm,'');
					
					if (_c_gotWpCdAmp){
						$postedMainStr= str_replace(_c_realHtmlAmp,'&',$postedMainStr);
						$postedMainStr= str_replace('&',_c_realHtmlAmp,$postedMainStr);
					}
					
					
					if (_c_wpTrgBrdElim){
						$postedMainStr= str_replace(' border="0"','',$postedMainStr);
						$postedMainStr= str_replace(' target="_top"','',$postedMainStr);
						$postedMainStr= str_replace(' target="_blank"','',$postedMainStr);
					}
					
					
					$formActionClick= $tools->postVal(_c_actionGetVar); // 1st triggered with a clic (get) then taken within the main form (post)
					
					if ($formActionClick!==false){
						// Action on Mouse Click : Execute the action with direct page creation so the page is directly displayed inside the correct menus.
						$tblName= _c_PolyCellPg;
						
						if ($formActionClick!==_c_generalAct){
							$parentPN= $tools->curPageName();
							$surfLg= $glob->curSurfLg();
							
							$labelStr= trim($tools->postVal('labelStr',''));
							$dtb->setGenVar('lastMenuTitles',$labelStr);
							$dtb->setGenVar('lastMenuTitlesTm',time());
							
							switch ($formActionClick){
								case _c_insertDepMenAct:
									$nwPage= $editTools->finalNewPageStr($newLabel,$labelStr);
									$resNPg= $editTools->newPageInMenu($nwPage,$newLabel,$postedMainStr,$parentPN, false,$surfLg);
									
									if ($resNPg===false){
										$this->pageNameTooLongError();
										return $postedMainStr;
									}
									
									$this->successWithNewPgFrom= $curPage;
								break;
							
								//  Integration Dependant Menus N languages
								case _c_inDepMenActNLg:
									// The job of finalNewPageStr() is done inside newNLgPgInMenu()
									$resNPg= $editTools->newNLgPgInMenu($labelStr,$postedMainStr,$parentPN,$surfLg);
									if ($resNPg===false){
										$this->pageNameTooLongError();
										return $postedMainStr;
									}
									$this->successWithNewPgFrom= $curPage;
								break;
								
								case _c_insertIndAct:
									$nwPage= $editTools->finalNewPageStr($newLabel,$labelStr);
									$resNPg= $editTools->newPageInMenu($nwPage,$newLabel,$postedMainStr,false,false,$surfLg);
									
									if ($resNPg===false){
										$this->pageNameTooLongError();
										return $postedMainStr;
									}
									$this->independantPgName= $nwPage;
									$this->successWithNewPgFrom= $curPage;
								break;
							
								default;
									$this->topErr('textEditor::analyseAndChgDtb()');
							}
						}else{
							if ($curPage===_c_edtAmnesicPg){
								$mainStr= $postedMainStr;
								$szM= strlen($postedMainStr);
								$glob->prevRecv();
								return $mainStr;
							}else{						
								$dtb->chgPolyCell($tblName,$curPage,$postedMainStr); // upload the edited text in the data base
								$mainStr= $dtb->getMainStr($szM,$curPage);
							}
						}
					}else{
						if ($curPage===_c_edtAmnesicPg){
								$mainStr= $postedMainStr;
								$szM= strlen($postedMainStr);
								$glob->prevRecv();
								return $mainStr;
						}else{
							// ----- MAIN EDITOR ACTION -----
							$dtb->chgPolyCell($tblName,$curPage,$postedMainStr); // upload the edited text in the data base
							
							// User Id appropriation if original user Id is undefined
							$origUId= $dtb->getElem($tblName, _c_pcId,$curPage, _c_pcUserId);
							if ($origUId==='' || $origUId==='-'){
								$dtb->chgPolyCell($tblName,$curPage,$rMg->realTimeUserId(),_c_pcUserId);
							}							
													
							$nectStr= $tools->postVal('nectStr');
							if ($nectStr!==false && $tblName===_c_PolyCellPgM){
								$dtb->chgPolyCell($tblName,$curPage,$nectStr,_c_pcNecStr); //upload eventual connection supplement							
							}
						}
					}
					
					$mainStr= $dtb->getMainStr($szM,$curPage);
					
					$yEdtTools= $tagsFu->instExplitCentralCls('yEdtTools');
					if ($yEdtTools->cacheRewrCond()){
						$ccDfn= $cacheWr->cacheWrCandidateDfn();
						if ( $fls->fileExist($ccDfn) ){
							$fls->unLnk($ccDfn);	// delete the cache so it can be updatedx on the next surf "consultation"
						}
						
						// Try to unlink the one in the other mode
						$sPhoneVal= $tools->sPhoneKnock();
						$dfn= $cacheR->simpleCacheDfn($sPhoneVal);
						
						$dfn= $cacheR->mainFlStr($dfn);
						if ($fls->fileExist($dfn)){
							$fls->unLnk($dfn);
						}
					}
					
				break; // 'editCurrent'
														
				case 'justDisplay':	// "Open" the specified page
					$mainStr= $dtb->getMainStr($szM,$selectedRecId);
					$curPage= $selectedRecId;
				break;				
								
				case 'chgRecPgName':
					$newName= $tools->postVal('newIdName','');
					$newIdName= $acc->safeIdStr($newName);
					
					// by default without user change in the combo box, $selectedRecId matches $curPage (the standard menu,url selected page)
					$editTools->changePageId($newName,$selectedRecId);
					
					$curPage= $newIdName;								
					$mainStr= $dtb->getMainStr($szM,$newIdName);
					$tools->setShortCircUPN(true,$curPage);	// short cc to $newIdName
				break;
				
				case 'duplicate':
					$newName= $tools->postVal('newIdName','');
					$newIdName= $acc->safeIdStr($newName);
					$origName= $tools->curPageName();
					
					$glob->stopRecv();
					$cellPgV= $dtb->getElem(_c_PolyCellPg, _c_pcId,$origName);
					$cellPgV[_c_pcId]= $newIdName;
					$dtb->newRecord(_c_PolyCellPg, $cellPgV);
					
					$menPgV= $dtb->getElem(_c_PolyCellPgM, _c_pcId,$origName);
					$menPgV[_c_pcId]= $newIdName;
					$dtb->newRecord(_c_PolyCellPgM, $menPgV);
					$glob->prevRecv();
					
					$mainStr= $dtb->getMainStr($szM,$curPage);
				break;
				
				case 'deletePgRec':
					if ($curPage===$selectedRecId){
						$parentPage= $editTools->getParentPage($selectedRecId);
						$curPage= $parentPage;			// Establish $parentPage as the $curPage for display
						$glob->justMenUpVal= false;		// To stop the parser after it parses successfull the menUp val.
						$tools->setShortCircUPN(true,$curPage);		// impose the new current page everywhere
						
						$editTools->deletePolyglotPage($selectedRecId);		// FULL DELETION
						$mainStr= $dtb->getMainStr($szM,$parentPage);
					}else{
						$glob->userError($glob->el('The records/pages select...','kaub'));
						$mainStr= $dtb->getMainStr($szM,$curPage);
					}
				break;
				
				case 'createSpecifiedRec':
					$givenRecId= $tools->postVal('newIdName',_c_ko);
					$editTools->createSpecifiedRec($givenRecId,$tblName);
					$mainStr= $dtb->getMainStr($szM,$curPage);
				break;
				
				case 'renameSpecifiedRec':
					$givenRecId= $tools->postVal('newIdName',_c_ko);
					$editTools->condIdChg($givenRecId,$curPage,$tblName);
					$mainStr= $dtb->getMainStr($szM,$givenRecId);
				break;
				
				case 'deleteSpecifiedRec':
					$editTools->delSpecifiedRec($selectedRecId,$tblName);
					$mainStr= $dtb->getMainStr($szM,$curPage);
				break;
												
				default:
					$this->topErr('3 textEditor::analyseAndChgDtb()');
			} // switch
			
		}else{
			$mainStr= $dtb->getMainStr($szM,$curPage);
		}
			
		$glob->prevRecv();
		return $mainStr;
	} // analyseAndChgDtb
	
	
	/**
	*/
	function pageNameTooLongError(){
		$asa= &$this->asa;				
		$glob= &$asa->glob;

		$mess= _c_._c_.$glob->sl('Please ... name shorter or ... following tag (*1)  :  ','kmhq').
			'[diffPgName n=" '.$glob->sl('Label to create and replace','kmhh').' " /] ';
		$glob->userError($mess);
	} // pageNameTooLongError
	


	/**
		Built the different boxes and widgets for html-tag-text edition purpose and return the built string..
		Input :
			$mainStr : calculated inside analyseAndChgDtb(), so always match.
	*/
	function displayWidgets(&$mainStr,$szM,$tblName,$curPage){
		$asa= &$this->asa;
		$tagsFu= &$asa->tagsFu;
		
		$glob= &$asa->glob;
		$tools= &$asa->tools;
		$fls= &$asa->fls;
		$caps= &$asa->caps;
		$aSql= &$asa->aSql;
		$dtb= &$asa->dtb;
		$rec= &$asa->rec;
		$rMg= &$asa->rMg;
		$wmR= &$tagsFu->wmRights;
		$epTools= $tagsFu->optimLibAccess('edtPlusTools');
		
		
		$tagsFu->globHtmlMTitle= $glob->el('Ataox General Editor','kmft');
		
		$topEdtBar= &$asa->topEdtBar;
		$editTools= &$asa->editTools;
		$forumBar= &$this->forumBar;
		
		$glob->setGlobJsCode('localStorage.globCurTxtArNme=\'mainStr\';'._c_R);
		$font= 'label';
		
		$actionClick= $tools->getVal(_c_actionGetVar); // got an action click
		$dirActClick= $tools->getVal(_c_dirActionClick)!==false;			
		
		$specialClick= $actionClick!==false;
	
		$postActionClick= $tools->postVal(_c_actionGetVar);
		
		if ($tools->lastCreatedPgId!==false){
			$selectedRecId= $tools->lastCreatedPgId;
		}else{
			$selectedRecId= $tools->postVal('selectedRecId',$curPage);
		}
		
		$txa= '';
		$mTAL= $dtb->getGenVar('mainTxArrLines');	// shared between webmasters !!!
		
		$lastMenTtls= $dtb->getGenVar('lastMenuTitles');	// shared between webmasters !!!
		$lastMenTtlsTm= $dtb->getGenVar('lastMenuTitlesTm');	// shared between webmasters !!!
		
		if ($specialClick || $dirActClick){
			if ($actionClick===_c_generalAct || $dirActClick){
				$txa.= $caps->niceTextArea(_c_taMainStNm,$mTAL,'98',$mainStr,true)._c_;
			}else{
				$labelStr= $tools->postVal('labelStr','');
				
				if (time()-$lastMenTtlsTm < 300){
					// recent enough to be suggested
					$labelStr= $lastMenTtls;
				}else{
					$labelStr= '';
				}
				
				$txa.= $caps->label($glob->el('Menu Title(s) : ','kmek'),$font);
				
				// Manages the combo box.
				$pFllKeys=  $tools->trimStoV($dtb->getGenVar('newPgFillerKeys'));
				$nbKeys= count($pFllKeys);
				$pgFillers= $tools->mbExplo($glob->el('Comments, Official Comments,...','kNewPageFiller'));
				$nbTrad= count($pgFillers);
				if ($nbKeys!==$nbTrad){
					$help= $glob->el('','kmjb')._c_;
					$help.= 'count(genVar::newPgFillerKeys)!=count(codeTrans::kNewPageFiller)';
					$help.= $glob->pv($pFllKeys)._c_;
					$help.= $glob->pv($pgFillers)._c_;
					$glob->userHelp($help);
					$comboPgFllV= array_combine ($pFllKeys,$pFllKeys);	// substitute
				}else{
					$comboPgFllV= array_combine ($pFllKeys,$pgFillers); // standard
				}
				
				$comboDef= $dtb->getGenVar('pgFillerDefKey');
				if ($comboDef===_c_ko){
					$comboDef= 'pfComment';
				}
				
				$txa.= _c_Ns._c_Ns._c_Ns._c_Ns;
				$txa.= $caps->comboBox('pgFillerCb',$comboDef,$comboPgFllV,'',true)._c_;
				// Manages the combo box --- End
				
				
				$txa.= _c_Br;
				$txa.= $caps->niceTextArea('labelStr','6','98',$labelStr,true)._c_;
				
				$mainStr= $tools->postVal(_c_taMainStNm,'');
				$txa.= $caps->label($glob->el('New Page Content : ','kmel'),$font).$caps->niceTextArea(_c_taMainStNm,'15','98',$mainStr)._c_;
			}
		}else{
			$nectStr= $dtb->getCellStr($szN,$curPage,$tblName,_c_pcNecStr);
					
			if ($tblName===_c_PolyCellPg){
				$txa.= $caps->niceTextArea(_c_taMainStNm,$mTAL,'106',$mainStr,true)._c_;
				
				if ($nectStr!=='' && $dtb->getGenVar('okForSelectPAI')===_c_ok){
					$txa.= _c_.$caps->label($glob->el('Selective paragraphs allowed Ids ...','kbbp'),$font)._c_BrFlux.$caps->textarea('nectStr','3','106',$nectStr,' class="niceTextAr"')._c_;
				}
			}else{
				$mMenuStr= $dtb->getCllStr($curPage,$tblName,_c_pcMainStr);
				
				$txa.= $caps->label($glob->el('Display : ','kakz'),$font)._c_BrFlux.
					$caps->niceTextArea(_c_taMainStNm,'6','98',$mMenuStr,true)._c_;
					
				$txa.= $caps->label($glob->el('Connections : ','kala'),$font)._c_BrFlux.$caps->textarea('nectStr','15','98',$nectStr,' class="niceTextAr"')._c_;
			}		
		}
		
		$spacer1= _c_Ns.'-'._c_Ns;
		$xNs=  _c_Ns._c_Ns. _c_Ns;
		$xNs= $xNs;
		$spacer2= $xNs.'|'.$xNs;
		
		
		$fContentRec= $caps->label( $glob->el('Current Record : ','kakx').$curPage,$font );
		if ($tblName===_c_PolyCellPg){
			$pageTyp= 'linkLblIn';
			$menuTyp= 'linkLbl';
		}
		if ($tblName===_c_PolyCellPgM){
			$pageTyp= 'linkLbl';
			$menuTyp= 'linkLblIn';
		}
	
		$arCmd['shortCircAtt']= _c_tableUrlVar;
		$fContentRecPM= $caps->hL(
			$tools->urlCurPg($arCmd).$tools->addUrlVar(_c_tableUrlVar,_c_PolyCellPg), 
			$glob->es('Pages','kalq')._c_Ns,
			$pageTyp,'_top',
			$glob->es('The Page mode','kamt'));
			
		$fContentRecPM.= $caps->label($spacer1,$font).$caps->hL(
			$tools->urlCurPg($arCmd).$tools->addUrlVar(_c_tableUrlVar,_c_PolyCellPgM),
			$glob->es('Menu','kalr'),
			$menuTyp,'_top',
			$glob->es('The Menu mode','kamu'));
			
		$fContentRecPM= $caps->sDiv($fContentRecPM,'margin-right:8px; border: 4px dotted red; padding:3px; float:left; width:100px')._c_;			

		$fContentRec.= $caps->label($spacer2,$font).$fContentRecPM;	
		
		
		/*
			A call to fill the widget allowing to jump on any page!
		*/
		if (_c_CurrentDtbAbstract==='simulSql'){
			$vIdN= $aSql->allFnVect($tblName);	// Short circuit the data base system for speed!
		}else{
			$vIdN= $dtb->vectIdNames($tblName);
		}
		
		
		if (!$wmR->wmUlnPgXess()){
			$vIdN= $this->rmUnderFN($vIdN);
		}
		
		$fContentRec.= _c_.$caps->label( $glob->el('Select : ','kaky')._c_Ns,'label').
			$caps->comboBox('selectedRecId',$selectedRecId,$vIdN,$caps->matCss('widgets'));
		
		$fContentSend= $caps->label($glob->el('Diverse :','kafx')._c_Ns,'label').$caps->textBox('newIdName','',15,$caps->matCss('widgetTxt'));
		$fContentSend.= $fls->editorLinkImg($tools->urlGivenPage($curPage).$tools->addUrlVar(_c_undoDtb,'clr'),'reset.png', $glob->el('Reset/Clear the undo Tables!','kafy') );		
		$userId= $rMg->realTimeUserId();
		$pos= $rec->getUndoPos($userId);
		$freePos= $rec->freeRecovId($userId);
		$okToUndo= $rec->okToUndo($userId,$pos,$freePos);
		$okToRedo= $rec->okToRedo($userId,$pos,$freePos);
		if ($okToUndo){
			$fContentSend.= $fls->editorLinkImg($tools->urlGivenPage($curPage).$tools->addUrlVar(_c_undoDtb,'undo'),'undo.png', $glob->el('Undo!','kafz') );		
		}
		if ($okToRedo){
			$fContentSend.= $fls->editorLinkImg($tools->urlGivenPage($curPage).$tools->addUrlVar(_c_undoDtb,'redo'),'redo.png', $glob->el('Redo!','kaga') );		
		}
	
	
		// Action button ... New, Open, Save, Save as
		$vectDelstr = array( 
			'editCurrent' =>$glob->es('Edit','kals'),						// Just the specified page-record
			'justDisplay' =>$glob->es('Open','kalt'),						// The specified page-record
			'chgRecPgName' =>$glob->es('Rename (current position)','kalu'),		// change done for _c_PolyCellPg and _c_PolyCellPgM (or only one if partial existence)
			'duplicate' =>$glob->es('Duplicate (current position)','kalv'),		// change done for _c_PolyCellPg and _c_PolyCellPgM (or only one if partial existence)
			'deletePgRec' =>$glob->es('Delete specified Page','kalw'),	// deletion done in _c_PolyCellPg and _c_PolyCellPgM (or only one if partial existence)
			'createSpecifiedRec' =>$glob->es('Tech: Create Spec Rec Categ','kalx'),
			'renameSpecifiedRec' =>$glob->es('Tech: Rename Spec Combo Rec','kaly'),
			'deleteSpecifiedRec' =>$glob->es('Tech: Del Spec Combo Record','kalz') );
			
	
		$formActBut= $tools->postVal('actionBut','editCurrent');
		$fContentSend.= $caps->hiddenWdg(_c_mainEditPgId,$curPage);	
		
		if (isset($glob->firstUpTagVal)){
			$fContentSend.= $caps->hiddenWdg('firstUpTag',$glob->firstUpTagVal);	
		}
					
		$fContentSend.= $caps->hiddenWdg(_c_mEdtCheckForm,_c_ok)._c_R;
			
		if ($specialClick){
			$fContentSend.= $caps->hiddenWdg(_c_actionGetVar,$actionClick);
		}
		
		if (isset($glob->globCurrentTopic)){
			$fContentSend.= $caps->hiddenWdg(_c_tgTopic,$glob->globCurrentTopic);
		}
		
		if (isset($tagsFu->globHtmlMLang)){
			$fContentSend.= $caps->hiddenWdg(_c_tgLang,$tagsFu->globHtmlMLang);
		}
				
		$sup= $caps->matCss('labelF');
		$caps->createsNiceEdtNames($ckName,$spcCkName,_c_taMainStNm);
		$sup.= $caps->jsOnclickFuCallStr('genAsa.setUpNiceEdIfCreated',2,0,_c_taMainStNm,$spcCkName);
		$fContentSend.= $caps->submit('mainSubmitBut',$glob->el('Send','kaat'), $sup);
		
		$fContentSend.= $caps->label(_c_Ns,'label');
		$fContentSend.= $caps->comboBox('actionBut',$formActBut,$vectDelstr,$caps->matCss('widgets'),true);
		
		
		$fContentSend= $caps->sDiv($fContentSend, 'width:380px; float:left; border: 1px dashed red; 
				padding-left:5px; padding-top:5px; padding-bottom:5px;;','mainEditPanel');
				
		$fContentRec= $caps->sDiv($fContentRec, 'width:540px; float:left; border: 1px dashed red; 
				padding-left:5px; padding-top:5px; padding-bottom:5px;','mainEditPanel');
		
		$fContent= $fContentSend.$fContentRec.$tagsFu->includeRec('_small-admin');
		$fContent.= $tagsFu->includeRec('_smallAdminB');

		$tacked= $tools->tacked();
		if ($tacked){
			$savePanel= $caps->sDiv($fContent, 'width:1076px; float:left; border: 1px dashed red; 
				padding-left:5px; padding-top:5px; padding-bottom:5px; background-color:white','mainEditPanel');
			$emptyShell= '';
		}else{
			$savePanel= $caps->sDiv($fContent, 'width:1076px; float:left; border: 1px dashed red; 
				padding-left:5px; padding-top:5px; padding-bottom:5px;
				position: fixed; left:8px; top:46px; z-index:99; background-color:white','mainEditPanel');
			// Empty shell
			$emptyShell= $caps->sDiv( $caps->transpImg(0,80), 'width:1000px; float:left; border: 0px dashed red; 
				padding-left:5px; padding-top:5px; padding-bottom:5px; background-color:white');
		}

		$fContent= $emptyShell.$savePanel;
		if ($tools->tacked()){
			$insrtTagsBuff= $caps->heaDiv('width:1070px; float:left; border:1px dashed red; padding:6px; background-color:white;',_c_polInserDiv);
		}else{
			$insrtTagsBuff= $caps->heaDiv('width:1070px; float:left; border:1px dashed red; padding:5px; background-color:white; position: fixed; left:10px; top:120px; z-index:99;',_c_polInserDiv);
		}
		
		/*
			#forumBarsSpeeder
			Parsing or proxying '_forumBar' or _insert-tags'
		*/
		$epTools->insTagsExpOrProxy();
		$epTools->forumBarExpOrProxy();
		
		
		$persoWysi= $wmR->wmWysiwygOn();
		if ($persoWysi===false){
			$gotWysiwyg= $dtb->getGenVar('gvWysiwygOn')===_c_ok;
		}else{
			$gotWysiwyg= $persoWysi===_c_ok;
		}
		
		if ($gotWysiwyg){
			$caps->createsNiceEdtNames($ckName,$spcCkName,_c_taMainStNm);
			$js= $caps->jsSimpleFu('genAsa.setUpNiceEdit',2,0,_c_taMainStNm,$spcCkName);
		}else{					
			if ($dtb->getGenVar('geniForumBar')===_c_ok){
				$js= $caps->jsSimpleFu('kk.setInnerHtml',3,1,'localStorage.fumStyleInsrtTags',_c_polInserDiv,'Z');
			}else{
				$js= $caps->jsSimpleFu('kk.setInnerHtml',3,1,'localStorage.origStyleInsrtTags',_c_polInserDiv,'Z');
			}	
		}		
		$glob->setGlbEndJsCode($js.';'._c_R);	// Execute $js instead of a JS button execution

			
		$insrtTagsBuff.= $caps->enDiv();
		$insrtTagsBuff.= $caps->sDiv('', 'width:1070px; float:left; border: 1px dashed black; padding:6px; background-color:white;',_c_edtFillDivName);
		$fContent.= $insrtTagsBuff;
		
		$checkForm= $tools->postVal(_c_mEdtCheckForm);		// The form was sent
		if ($checkForm===_c_ok){
			$js= $caps->jsSimpleFu('clsInsrTag.setScrollBarPos',1,0,_c_taMainStNm).';'._c_R;
			$glob->setGlbEndJsCode($js);
		}
				
		$js= $caps->jsFunctCallStr('onsubmit','clsInsrTag.memoScrollBarPos',1,0,_c_taMainStNm);
		

		$txa.= _c_BrFlux._c_;
		$txa.= $caps->span($glob->el('Supplement display :','kbbg'), 'wnslStd');
		
		
		$txa.= _c_.$caps->textarea('debugDisplay',10,150,'');		// debug
		
		
		$mainWdgt= $caps->heaDiv('width:1080px; float:left; border: 1px dashed black; padding:6px; background-color:white;');
		$mainWdgt.= $caps->form($tools->urlGivenPage($curPage),'mainEdtForm',$fContent._c_BrFlux.$txa._c_BrFlux._c_BrFlux,$js,'hidMnEdtFormWdgt');
		$mainWdgt.= $caps->enDiv();
		$glob->setHeadGlobJsCd('kk.initCurrentDisplay("debugDisplay");'._c_R);
		return $mainWdgt;
	} // displayWidgets
	
	
	/**
		Remove the underlined file name of the vector.
	*/
	function rmUnderFN(&$v){
		$nV= array(); $i=0;
		reset($v);
		foreach ($v as $key=>$val){
			if ($val!==''){	// ==='' parasitic value
				$firstChar= $val[0];
				if ($firstChar!=='_'){
					$nV[$i]= $val;
					$i++;
				}
			}
		}
		return $nV;
	} // rmUnderFN
	


} // textEditor
?>
