<?php
/**
	File name : const.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


		Global Constants.
*/
	define('_c_szLngstTag',256);		// size of the longuest possible Xpetal tag,
	define('_c_maxRecursDeep',512);	// maximum recursion deepness inside Xpetal
	define('_c_urlUniqEdtSz', 4);	// the size of an independant editor string (randomly generated)
	define('_c_minXTagSz', 4);		// the size of the smallest possible Xpetaltag with hooks and slash [t/]

	define('_c_recoveryActions','krnlRecovAction');	// kernel recovery action url variable
	
	define('_c_constPfx','_c_');	// The Ataox constant prefix! ... used explicitely in cntrXRight::isAForbidPath() ?
	
	/**
		Maximum size in bytes of a page & menu record Id is 64 for compatibility with mariaDB and MySql 
			https://dev.mysql.com/doc/refman/8.0/en/identifiers.html
			https://mariadb.com/kb/en/library/identifier-names/
	*/
	define('_c_largestIdSz',64);
	
	define('_c_noFollow','nofollow');
	
	define('_c_multiByteCrypting',_c_ok);
		
	define('_c_transMasterLg', 'en');	// the master language suffix
	

	define('_c_anyFormSentId','anyFormSentId');	// On ALL forms to check a general post action
	define('_c_mEdtCheckForm','checkForm');	// main Edit checkForm
	define('_c_genHidWdgtFormNm','genHidWdgtFormNm');	// general hidden widget form name	
		
	define('_c_mainEditPgId','mainTextId');	// hidden widget storing the page Id (--> main text array)

	define('_c_notALanguage','-'); // for languages abreviation, when it's not a language.	
	define('_c_editorPos','editorPos');
	define('_c_hideTopEditBar','hideTEB');


	define('_c_surfEdt','surfEdt');		// the url variable
	// define('_c_surfEdit','surfEdt');		// the url variable
	
	
	define('_c_seSurfVal', 'surf');		// surf edit, surf value
	define('_c_seEditVal', 'edt');		// surf edit, edit value
	define('_c_bthEditVal', 'both');


	
	
	
	define('_c_Rs',' ');			// real space
	define('_c_Ns','&nbsp;');		// non breakable space

	define('_c_lt','&lt;');		// <
	define('_c_ltEquSpc',' &lt;= ');		// <= with spaces
	define('_c_gt','&gt;');		// >
	
		
	define('_c_Interog','?');	// just the unique url interogation mark	


	define('_c_rT',"\t");			// real tab
	define('_c_sT',_c_Ns._c_Ns._c_Ns);			// substitute tab



	define('_c_homeSlash', './');			// Both with ./ or without work, but nicer with	
	define('_c_slashHttp','http://');		// To check if a url got the http:// string within,
	define('_c_slashHttps','https://');		// To check if a url got the https:// string within,		
	define('_c_cmSlashHttp',_c_slashHttp);	// The main http access to the cms site, could be a SSL one too !!
	
	

	/**
		Significant Syntax Signs for parsing. Full use of constants, one of the goal is to test the syntax 
		on something like (code)(-code) instead of [code][/code].
	*/
	define('_c_lBrk','[');			// Left tag limit (open bracket).
	define('_c_rBrk',']');			// Right tag limit (closed bracket).
	define('_c_stopSmplSrf', _c_lBrk.'stopSmplSurf /'._c_rBrk._c_R._c_R);
	define('_c_fStopSmplSrf', _c_lBrk.'fstopSmplSurf /'._c_rBrk._c_R._c_R);


	define('_c_slash','/');			// Terminator (slash).
	define('_c_bSh','\\');	// shorter --> better got to replace the other!
	define('_c_equ','=');			// Assignator (equal).
	
	define('_c_dblQ','"');				// Values delimitation (double quote). Also uses $glob->doubleQuote to dynamically change the capsulator character
	define('_c_hDbQuote','&quot;');
	
	define('_c_space',' ');		// Tag syntax separator (space).. Do not mix with _c_Rs !!!
	define('_c_emptyStr','');		// the empty character
	define('_c_taMainStNm','mainStr');	// text area main string name
	define('_c_thumbsPathUV','thumbspath');	// The url variable to hold the path for an only thumbnails display
	define('_c_thumbsDirN','thumbs');		// The name of the thumbs directory AND the thumbs used to accelerates image display.

	define('_c_shortInfoUrlVar','urlRunable');
	define('_c_urlMethLoc','methLoc');	// url method localisation
	define('_c_urlMethPar','methPar');	// url method parameters


	define('_c_demoWidgetUvar','demoWdgtNm');	


	// Paths
	define('_c_LibPath', _c_CodePath.'lib/');
	define('_c_LibExtPath', _c_CodePath.'libExt/');	// external libraries, for facultative code


	define('_c_DtbLibPath', _c_LibPath.'dtb/');	 // the path for the database concerned libraries

	define('_c_EditorImgPath', _c_CodePath.'img/');			// To access the editor images (may have a mirror inside the user directory for durable personalization)


	define('_c_zCmsImages', _c_zCms.'images/');	// user images directory
	define('_c_3rdImgParty', _c_zCmsImages.'thirdParty/');
	define('_c_UsrEmoDir',  _c_3rdImgParty.'emoticons/');	// user emoticon directory

	define('_c_ThirdParty', _c_CodePath.'thirdParty/');
	define('_c_NicEditPath', _c_ThirdParty.'nicEdit/');


	define('_c_mainImgDfn', _c_UsrDataPath.'images/');
	define('_c_mainImgDfnSz', strlen(_c_mainImgDfn) );
	define('_c_captchaImgDir', _c_mainImgDfn.'captcha/');
	
	define('_c_mainFontDfn', _c_zCms.'fonts/');
	
	define('_c_mainDiverseDir', _c_UsrDataPath.'diverses/');
	define('_c_fumSumryDir', _c_mainDiverseDir.'forumSummary/');

	define('_c_mainCustUpDfn', _c_UsrDataPath.'customerUploads/');


	// Forum addition
	define('_c_fumVsblPostId','vsblPid');


	define('_c_mainCssDfn', _c_UsrDataPath.'styles.css');
	define('_c_mainEdtCssDfn', _c_UsrDataPath.'edtStyles.css');	

	define('_c_pluginPath', _c_CodePath.'plugins/');


	// Plugins initialised autoMaTically from the 1st tag met, so they are normally part of all distributions and have generally been programmed internally.
	define('_c_autoPlugins', _c_pluginPath.'implicit/');	// _c_PluginsMT old

	/*
		Plugins initialised at will with a special tag doing that job and a innitialisation method defined
		within the plugin class. Rem : the plugin class could also be defined inside a new directory and
		request and use its own classes.
	*/
	define('_c_toDeclPlugins', _c_pluginPath.'explicit/');


	define('_c_toDeclPlugCntr', _c_toDeclPlugins._c_plugCntrDN);
	define('_c_declPlugCntrMen', _c_toDeclPlugCntr.'menus/');
	define('_c_toDeclPlugExt', _c_toDeclPlugins._c_plugExtDN);	// ... /explicit/external/  (got indeed an end / ))



	define('_c_PlugMtInit', _c_autoPlugins.'initMultiTags.php'); // instanciated on the fly


	/**
		User constants (some are going to be transformed later in easier to change data base access)
	*/
	define('_c_initTags','_initTags');	// the name of the general initialisation record stored inside _c_pcMainStr
	define('_c_topDefaultPg','top');			// Top default page name


	/* To indicate what table (cellPge or cellPgeM) is in use, passed with the url or stored in cookies!
		----> bit confusing!! Would be better to detect what area names are posted !!!!!!!!
	*/
	define('_c_tableUrlVar','table');

	define('_c_loginTrialVar','loginNb');	// to count them

	define('_c_parserMaxTimes',50000); // Maximumm number of times we can call the parser, so we can allow self references and avoid stalking in any other circonstances
	define('_c_evalIsAllowed', true);


	/**
		General right management
	*/
	define('_c_testNoRight','noRight');		// A url variable name to force a no edition-right state
	define('_c_userNoRight',_c_ko);			// For a forum or comments user !!!
		
	
	// May become deprecated. A crypting seed for a few old fashion algo! Could re-use a few of them, but with a more resilient storage (eg :)
		
	define('_c_dustbinName', 'trash');			
		
	define('_c_undoDtb','undoDtb');

	
	// define('_c_ddMenAddJsCode',true);	// True --> adds the JS code for the drop down menus.
	define('_c_ddMenFN','ddm.js');		// Name of the drop down menu java-script code.(complement only for IE6 !!!)
	
	// Special menu
	define('_c_tgMenBut','menbut');	
	define('_c_tgMenUp','menup');	
	define('_c_tgMenTree','mtree');	
	
	
	define('_c_menKind','menuKind');	// menu Kind url variable
	
	
	
	// Substitition of " and Carriage return To pass complicated string to the JS code
	define('_c_fDblQuotSubst','dBlG');	// double guillemet (double quote)
	define('_c_fCrLnSubst','CrLn');	// unconventional ... not for this one!
	define('_c_fBsDblQtSubst','bSdG'); // back slash double guillemet
	
	
	// Also see _c_UsrDataPath
	define('_c_mFilePathPrfx', 'mFilePath');	// mediaManager file path prefix (in fact the url variable of the path minus the index)	
	
	define('_c_extZiptmp','ziptmp');		// to short circuit zip files after extreme unzipping All
											// define('_c_extZiptmp','zip');		// for no extension renaming
	
	define('_c_UvGallIFrWidth','iFrWidth');		// url variable for the gallery iFrame width	.. shared by a few others
	define('_c_locBrowsrDefNm', 'locBrowser'); 	// local html browser default name
	
	
	// EDITION ONLY CONSTANTS (many more to be categoriued here & could also define it separatly only at editing time!
	
	// Url variable to store the dirtectory path and file name to edit
	define('_c_uVarEdtDFn','fileName');	
	
	
	define('_c_dsplXmSqrFlNm','xmSqrFlNm');	
	
	define('_c_captHidHashNm','captHidHashNm');
	
		
	define('_c_genVarPrfx', 'genVar_');
	define('_c_tblEdtDefTN', _c_genVarPrfx.'def');
	
	
	/**
		General constants
	*/
	define('_c_unlogUrlVar', 'unlog');	// url variable to unlog, to have a better trace of the logout actions.
	
	define('_c_gotLoginForm', 'gotLoginForm');	// just to test if the login form was used
		
	define('_c_fixIndex', 'index');		// Standard index name	
	define('_c_fixInstallerN', 'installer');	// Standard and fix installer index name
	
	define('_c_fixPhpIndex', 'index.php');
	define('_c_fixInstIndex', 'installer.php');	
	
	define('_c_reservedUserId', 'root');	// a reserved user Id for core developpers or manual installation if really wished to!
	define('_c_guestUserId', 'guest');		// only used if allowed inside the users table
	
	// Useful when contacting people who could react negatively when exposed to the concerned adverts. ok "decom ... " ... for advert free display. 
	define('_c_okDecom', 'okdecom'); 
	define('_c_deComMasterVal', 'deComMasterVal'); 

	

	/**
		Archive constants
	*/
	define('_c_fullAsapBkpNS', 'fullAtaoxBkp');	
	define('_c_fullAsapBkp', _c_fullAsapBkpNS.'/');		// subtle usefullness when copying archives
	define('_c_cpyMnAsapDirs', _c_copyPaste.'mainAtaoxDirs/');
	define('_c_cpyFullAsapBkp', _c_cpyMnAsapDirs._c_fullAsapBkp);
	define('_c_fullAspBkpPlus', _c_fullAsapBkp._c_asppDirN.'/');
	
	
	/**
		Exportation / Installation constants 1
	*/
	define('_c_storedIcoPath',_c_zCms.'images/ico/');
	define('_c_ProjMatrixFN', 'projVirginMatrix');		// The matrix directory name (imitially in framebuilder, but more practical here, used in centraCl.php for testing)
	
	define('_c_cpyPstVirginMtxNS',_c_copyPaste._c_ProjMatrixFN);
	define('_c_cpyPstVirginMtx',_c_cpyPstVirginMtxNS.'/');
	
	// More practical to have it here because of the cache eventual updating of cacheConst.php
	define('_c_virginConnect', _c_cpyPstVirginMtx.'zCms/zPhpData/connect/');
	define('_c_virginCacheDfn', _c_virginConnect._c_cacheConsFlName);
	
	
	/**
		Exportation / Installation constants 2
	*/
	define('_c_coreInstallerDN', 'coreInstallerDN');	// Core Installer directory name
	
	define('_c_prExportPath', _c_flTchHomeSlsh.'preExportation/');
	define('_c_XportTaoxInstall', _c_prExportPath.'ataoxInstaller');
	define('_c_XportTaoxInstallWS', _c_XportTaoxInstall.'/');	// with slash
	define('_c_xTaoxInstallCode', _c_XportTaoxInstallWS.'aMainDr/code');
	
	// Situational path to have a peek into the exported data at debugging time and zip distrib !!!
	define('_c_XTaoxStallDataDir', _c_XportTaoxInstallWS.'aMainDr/projects/'._c_coreInstallerDN);
	define('_c_XportPhpDtb', _c_XTaoxStallDataDir.'/'._c_zCmsDirN.'/'._c_zPhpDataN.'/'._c_phpDtbDN.'/');	// _c_XTaoxStallDataDir.'/zCms/zPhpData/phpDtb/'
		
	
	define('_c_bigZoomPg','_bigZoom');	// the actual page to dispaly the zoomed images
		
	/**
		Name for the smart-phone menu being built automatically when installing
		... still only the vertical one, should build vertical and horizontal at some stage.
	*/
	define('_c_vertSmartPhMenName', 'verticSmartPhoneMen.css');
	define('_c_hzSmartPhMenName', 'horizSmartPhoneMen.css');
		
?>