--
--  [rem]
--  An Ataox double purpose file : (1) general backup of the table headers. (2) creation of new tables, using the
--  commented Xpetal code.
--  [/rem]

-- [dtbCode]
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `buffer` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `cacheTbl` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `mainStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  `time` tinytext CHARACTER SET ascii NOT NULL,
  `active` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `captPoly` (
  `id` bigint(20) NOT NULL DEFAULT '0',
  `quest` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `answ` tinytext CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  FULLTEXT KEY `quest` (`quest`,`answ`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `captFrench` (
  `id` bigint(20) NOT NULL DEFAULT '0',
  `quest` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `answ` tinytext CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  FULLTEXT KEY `quest` (`quest`,`answ`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `captEnglish` (
  `id` bigint(20) NOT NULL DEFAULT '0',
  `quest` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `answ` tinytext CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  FULLTEXT KEY `quest` (`quest`,`answ`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `captchAutoCateg` (
  `id` varchar(20) CHARACTER SET ascii NOT NULL,
  `en` text COLLATE utf8_unicode_ci NOT NULL,
  `labelEn` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `fr` text COLLATE utf8_unicode_ci NOT NULL,
  `labelFr` tinytext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `cellPge` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `mainStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  `necStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  `type` tinytext CHARACTER SET ascii NOT NULL,
  `date` tinytext CHARACTER SET ascii NOT NULL,
  `userId` tinytext CHARACTER SET ascii NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `asciiUtfIds` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `utfId` varchar(80) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `utfId` (`utfId`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]



-- [dtbCode]
CREATE TABLE IF NOT EXISTS `cellPgeM` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `mainStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  `necStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  `type` tinytext CHARACTER SET ascii NOT NULL,
  `date` tinytext CHARACTER SET ascii NOT NULL,
  `userId` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]



-- [dtbCode]
CREATE TABLE IF NOT EXISTS `codeTrans` (
  `id` varchar(20) CHARACTER SET ascii NOT NULL,
  `en` text COLLATE utf8_unicode_ci NOT NULL,
  `langW` text COLLATE utf8_unicode_ci NOT NULL,
  `langX` text COLLATE utf8_unicode_ci NOT NULL,
  `langY` text COLLATE utf8_unicode_ci NOT NULL,
  `langZ` text COLLATE utf8_unicode_ci NOT NULL,
  `comment` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `comments` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `en` text COLLATE utf8_unicode_ci NOT NULL,
  `langW` text COLLATE utf8_unicode_ci NOT NULL,
  `langX` text COLLATE utf8_unicode_ci NOT NULL,
  `langY` text COLLATE utf8_unicode_ci NOT NULL,
  `langZ` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]



-- [dtbCode]
CREATE TABLE IF NOT EXISTS `codeTransSwap` (
  `id` varchar(20) CHARACTER SET ascii NOT NULL,
  `en` text COLLATE utf8_unicode_ci NOT NULL,
  `langW` text COLLATE utf8_unicode_ci NOT NULL,
  `langX` text COLLATE utf8_unicode_ci NOT NULL,
  `langY` text COLLATE utf8_unicode_ci NOT NULL,
  `langZ` text COLLATE utf8_unicode_ci NOT NULL,
  `comment` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `commentsSwap` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `en` text COLLATE utf8_unicode_ci NOT NULL,
  `langW` text COLLATE utf8_unicode_ci NOT NULL,
  `langX` text COLLATE utf8_unicode_ci NOT NULL,
  `langY` text COLLATE utf8_unicode_ci NOT NULL,
  `langZ` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]











-- [dtbCode]
CREATE TABLE IF NOT EXISTS `surfTrans` (
  `id` varchar(30) CHARACTER SET ascii NOT NULL,
  `trans` text COLLATE utf8_unicode_ci NOT NULL,
  `rem` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fDumpPosts` (
  `id` varchar(8) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `fUserId` tinytext CHARACTER SET ascii NOT NULL,
  `motherId` varchar(35) CHARACTER SET ascii NOT NULL,
  `realFum` tinytext CHARACTER SET ascii NOT NULL,
  `messTtl` text COLLATE utf8_unicode_ci NOT NULL,
  `messBody` longtext COLLATE utf8_unicode_ci NOT NULL,
  `imprvFlag` tinytext CHARACTER SET ascii NOT NULL,
  `mssTtl` text COLLATE utf8_unicode_ci NOT NULL,
  `mssBdy` longtext COLLATE utf8_unicode_ci NOT NULL,
  `language` tinytext CHARACTER SET ascii NOT NULL,
  `date` tinytext CHARACTER SET ascii NOT NULL,
  `lastDate` tinytext CHARACTER SET ascii NOT NULL,
  `lateFlag` tinytext CHARACTER SET ascii NOT NULL,
  `capsId` tinytext CHARACTER SET ascii NOT NULL,
  `xIndx` tinytext CHARACTER SET ascii NOT NULL,
  `indent` tinytext CHARACTER SET ascii NOT NULL,
  `xDump` text COLLATE utf8_unicode_ci NOT NULL,
  `watchMail` tinytext CHARACTER SET ascii NOT NULL,
  `allowed` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `forumHash` (
  `id` varchar(5) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `primHash` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `curHash` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `captchaId` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `forumPosts` (
  `id` varchar(8) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `fUserId` tinytext CHARACTER SET ascii NOT NULL,
  `motherId` varchar(35) CHARACTER SET ascii NOT NULL,
  `messTtl` text COLLATE utf8_unicode_ci NOT NULL,
  `messBody` longtext COLLATE utf8_unicode_ci NOT NULL,
  `imprvFlag` tinytext CHARACTER SET ascii NOT NULL,
  `mssTtl` text COLLATE utf8_unicode_ci NOT NULL,
  `mssBdy` longtext COLLATE utf8_unicode_ci NOT NULL,
  `language` tinytext CHARACTER SET ascii NOT NULL,
  `date` tinytext CHARACTER SET ascii NOT NULL,
  `lastDate` tinytext CHARACTER SET ascii NOT NULL,
  `lateFlag` tinytext CHARACTER SET ascii NOT NULL,
  `threadNumId` tinytext CHARACTER SET ascii NOT NULL,
  `capsId` tinytext CHARACTER SET ascii NOT NULL,
  `nbAnsw` tinytext CHARACTER SET ascii NOT NULL,
  `xIndx` tinytext CHARACTER SET ascii NOT NULL,
  `indent` tinytext CHARACTER SET ascii NOT NULL,
  `xDump` text COLLATE utf8_unicode_ci NOT NULL,
  `watchMail` tinytext CHARACTER SET ascii NOT NULL,
  `allowed` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumPgRepos` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `rFum` tinytext CHARACTER SET ascii NOT NULL,
  `freeGroupT` tinytext CHARACTER SET ascii NOT NULL,
  `freeThread` tinytext CHARACTER SET ascii NOT NULL,
  `fumTreeFreeX` tinytext CHARACTER SET ascii NOT NULL,
  `xGate` tinytext CHARACTER SET ascii NOT NULL,
  `xGSetTm` tinytext CHARACTER SET ascii NOT NULL,
  `fumOk` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumSched` (
  `id` int(11) NOT NULL,
  `postId` varchar(8) CHARACTER SET ascii NOT NULL,
  `usrId` varchar(35) CHARACTER SET ascii NOT NULL,
  `action` tinytext CHARACTER SET ascii NOT NULL,
  `time` varchar(35) CHARACTER SET ascii NOT NULL,
  `hTm` tinytext CHARACTER SET ascii NOT NULL,
  `suParam` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumThrdAttrib` (
  `id` varchar(40) CHARACTER SET ascii NOT NULL,
  `answNb` bigint(20) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumThrdGrpAcs` (
  `id` varchar(40) CHARACTER SET ascii NOT NULL,
  `grpNb` tinytext CHARACTER SET ascii NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumThreads` (
  `id` varchar(40) CHARACTER SET ascii NOT NULL,
  `xSqr` longtext COLLATE utf8_unicode_ci NOT NULL,
  `supTags` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumXCode` (
  `id` varchar(45) CHARACTER SET ascii NOT NULL,
  `xCode` longtext COLLATE utf8_unicode_ci NOT NULL,
  `supTags` text COLLATE utf8_unicode_ci NOT NULL,
  `clicTitle` text COLLATE utf8_unicode_ci NOT NULL,
  `prsdSz` tinytext CHARACTER SET ascii NOT NULL,
  `gotChg` tinytext CHARACTER SET ascii NOT NULL,
  `mainPostId` varchar(8) CHARACTER SET ascii NOT NULL,
  `vsblAll` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fumXLim` (
  `id` varchar(45) CHARACTER SET ascii NOT NULL,
  `lim` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fUsrMess` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `info` text COLLATE utf8_unicode_ci NOT NULL,
  `rd` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `fUsrTbl` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `pseud` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `nbPost` int(11) NOT NULL,
  `avatar` tinytext CHARACTER SET ascii NOT NULL,
  `mail` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `mailOk` tinytext CHARACTER SET ascii NOT NULL,
  `cpw` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `primHash` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `c2pw` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `curHash` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `xRights` text CHARACTER SET ascii NOT NULL,
  `uFreeT` tinytext CHARACTER SET ascii NOT NULL,
  `dailyPosts` tinytext CHARACTER SET ascii NOT NULL,
  `rDate` tinytext CHARACTER SET ascii NOT NULL,
  `confHash` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `rIP` tinytext CHARACTER SET ascii NOT NULL,
  `secretDir` tinytext CHARACTER SET ascii NOT NULL,
  `imgWallTxt` text CHARACTER SET ascii NOT NULL,
  `postWallId` text CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genAssoc` (
  `id` varchar(8) CHARACTER SET ascii NOT NULL,
  `context` varchar(35) CHARACTER SET ascii NOT NULL,
  `subCtxt` varchar(35) CHARACTER SET ascii NOT NULL,
  `rescueCtxt` text COLLATE utf8_unicode_ci NOT NULL,
  `time` bigint(20) NOT NULL,
  `info` longtext COLLATE utf8_unicode_ci NOT NULL,
  `infSup` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genVar` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  `remarks` text COLLATE utf8_unicode_ci NOT NULL,
  `categ` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genVar_guest` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  `remarks` text COLLATE utf8_unicode_ci NOT NULL,
  `categ` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genVar_root` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  `remarks` text COLLATE utf8_unicode_ci NOT NULL,
  `categ` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genVar_def` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  `remarks` text COLLATE utf8_unicode_ci NOT NULL,
  `categ` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]

-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genVar_identification` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  `remarks` text COLLATE utf8_unicode_ci NOT NULL,
  `categ` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]




-- [dtbCode]
CREATE TABLE IF NOT EXISTS `idCode` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `code` text COLLATE utf8_unicode_ci NOT NULL,
  `comment` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `idTexts` (
  `id` varchar(64) CHARACTER SET ascii NOT NULL,
  `text` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `siteModels` (
  `id` varchar(64) CHARACTER SET ascii NOT NULL,
  `text` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `incrBackup` (
  `id` bigint(20) NOT NULL,
  `userId` tinytext CHARACTER SET ascii NOT NULL,
  `time` tinytext CHARACTER SET ascii NOT NULL,
  `action` tinytext CHARACTER SET ascii NOT NULL,
  `tblNme` tinytext CHARACTER SET ascii NOT NULL,
  `where` text CHARACTER SET ascii NOT NULL,
  `str` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `pgRedirect` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `target` varchar(35) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `polyglotPN` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `str` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `recovCirc` (
  `id` bigint(20) NOT NULL,
  `userId` varchar(35) CHARACTER SET ascii NOT NULL,
  `asaStep` tinytext CHARACTER SET ascii NOT NULL,
  `aStepSz` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `recovData` (
  `id` bigint(20) NOT NULL,
  `userId` varchar(35) CHARACTER SET ascii NOT NULL,
  `asaStep` tinytext CHARACTER SET ascii NOT NULL,
  `asaSubS` tinytext CHARACTER SET ascii NOT NULL,
  `origAction` tinytext CHARACTER SET ascii NOT NULL,
  `tableName` text CHARACTER SET ascii NOT NULL,
  `whereStr` text CHARACTER SET ascii NOT NULL,
  `valuesStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `recovC2` (
  `id` bigint(20) NOT NULL,
  `userId` varchar(35) CHARACTER SET ascii NOT NULL,
  `asaStep` tinytext CHARACTER SET ascii NOT NULL,
  `aStepSz` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `recovD2` (
  `id` bigint(20) NOT NULL,
  `userId` varchar(35) CHARACTER SET ascii NOT NULL,
  `asaStep` tinytext CHARACTER SET ascii NOT NULL,
  `asaSubS` tinytext CHARACTER SET ascii NOT NULL,
  `origAction` tinytext CHARACTER SET ascii NOT NULL,
  `tableName` text CHARACTER SET ascii NOT NULL,
  `whereStr` text CHARACTER SET ascii NOT NULL,
  `valuesStr` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `tableHeaders` (
  `id` varchar(30) CHARACTER SET ascii NOT NULL,
  `info` longtext COLLATE utf8_unicode_ci NOT NULL,
  `comment` text COLLATE utf8_unicode_ci NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `toDoFumEvents` (
  `id` varchar(6) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `mPageId` varchar(35) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `operations` text CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `topHashTbl` (
  `id` varchar(10) CHARACTER SET ascii NOT NULL,
  `date` tinytext CHARACTER SET ascii NOT NULL,
  `hashId` varchar(20) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,
  `userId` tinytext CHARACTER SET ascii NOT NULL,
  `logged` tinytext CHARACTER SET ascii NOT NULL,
  `c2pw` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `ppH` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `oldPPH` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `primH` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `oldPrimH` tinytext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `usersTbl` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `pseud` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `cpw` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `strtRecId` bigint(20) NOT NULL,
  `freeRecId` bigint(20) NOT NULL,
  `undoPos` bigint(20) NOT NULL,
  `smlstDtId` bigint(20) NOT NULL,
  `freeRecDtId` bigint(20) NOT NULL,
  `xRights` text CHARACTER SET ascii NOT NULL,
  `rem` text COLLATE utf8_unicode_ci NOT NULL,
  `mail` text COLLATE utf8_unicode_ci NOT NULL,
  `famName` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `fstName` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `birthD` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `street` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `nmStreet` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `town` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `country` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `postNb` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `postPO` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `tel` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `fax` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `mobileNb` tinytext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `wnslTbl` (
  `id` varchar(20) CHARACTER SET ascii NOT NULL,
  `title` text COLLATE utf8_unicode_ci NOT NULL,
  `email` tinytext CHARACTER SET ascii NOT NULL,
  `main` longtext COLLATE utf8_unicode_ci NOT NULL,
  `creationDate` bigint(20) NOT NULL,
  `actionDate` bigint(20) NOT NULL,
  `actionHumDate` tinytext CHARACTER SET ascii NOT NULL,
  `done` tinytext CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  UNIQUE KEY `id_2` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]


-- [dtbCode]
CREATE TABLE IF NOT EXISTS `genHash` (
  `id` int(11) NOT NULL,
  `hash` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `info` tinytext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `hash` (`hash`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]



-- [dtbCode]
CREATE TABLE IF NOT EXISTS `pwKeeperTbl` (
  `id` varchar(35) CHARACTER SET ascii NOT NULL,
  `comment` text COLLATE utf8_unicode_ci NOT NULL,
  `info` longtext COLLATE utf8_unicode_ci NOT NULL,
  `seed` text CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]




-- [dtbCode]
CREATE TABLE IF NOT EXISTS `exoUsrDtb` (
  `id` varchar(50) CHARACTER SET ascii NOT NULL,
  `crptPw` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `url` text CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
-- [/dtbCode]




