<?php
/**
	File name : example.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="example" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]	
	
	Key method for plugins instanciation used by the above tags : tagsFu::instExplitCl($path,$className, ...)
*/
class example extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;	// access to some global values, sometimes methods.
		$this->caps= &$tagsFu->caps;	// access many html methods.
		$this->tools= &$tagsFu->tools;	// many small npractical methods.
		$this->fls= &$tagsFu->fls;		// different file access.
		$this->dtb= &$tagsFu->dtb;		// many abstracted database methods
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('example','debugDisplay',true);	
		$tagsFu->attribVect['testplug']= array('display');
	} // construct


	/**
		This associative array must hold all the class's tags names, so the cms can declare them
	*/
	function tags(){
		return array('testplug');
	} // tags

	
	/**
		The method used to test this plugin and call with 
			[testPlug display="Plugin trial of : " /]
	*/
	function tg_testplug(&$v,&$bd){
		$caps= &$this->caps;
				
		$dspl= '<h1>'.$v['display'].' example </h1>';		
		$dspl.= '<span class="someMoreFont" onClick="example.writeThreeTimes(\'example \')">One More Line !!!</span>';
		$dspl.= _c_sT;
		$dspl.= '<span class="someMoreFont" onClick="example.clearWrite(\'\')"> Clear !!!</span>';
		$dspl.= _c_;
		
		
		
		$dspl.= '<a href="#" class="someMoreFont" onClick="kk.writeLn(example.pubGV)"> pubGV </a>';
		$dspl.=_c_sT;
		
		$dspl.= '<a href="#" class="someMoreFont" onClick="example.writePGV()"> privGV </a>';
		$dspl.=_c_sT;
		
		$dspl.= '<a href="#" class="someMoreFont" onClick="example.writeLV()"> locV </a>';
		$dspl.=_c_sT;
		
		
		
				
		
		// An area to display any javascript messages as a supplementary debug tool
		$area= '';		
		$area.= $caps->textarea('debugDisplay',19,40,'',$caps->matCss('someFont'));
		$area= $caps->sDiv($dspl._c_.$area, 'width:445px; border:2px solid red; padding:10px; margin:2px; float:left;');		
		return $area._c_;
	} // tg_testplug
	
		
	/**
		Template for tags methods.
			Input :
				$v : associative array hoding the parameters
				$bd : tag main body, so : [theTag]$bd[/theTag]
	*/
	function tg_templatetag(&$v,&$bd){
		$caps= &$this->caps;	// encapsulation of many usefull html code.
	
		return 'test';	// this returned value is going to be displayed instead of the tags
	} // tg_templatetag

		
	/**
		Template for standard methods.
	*/
	function templateStd(){
	
	
	} // templateStd
		
} // example
?>
