<?php

/** It's possible personalize these 2 constants values to force stats generation in case of external dodging. The only part to add some standard ascii url-friendly characters is after the underline "_", please keep the left part for readability and collision avoidance!
*/

define('_c_urlUniqEdtPfx', 'uniqPfxErsatz');  // A unique url parameter used in webmaster edition context (you can add ascii characters after the "uPfx_" prefix)
define('_c_statsAvoidUVar', 'statsAvoidErsatz');  // The url variable to avoid a webmaster surf being stored as a local statistic

// -------------

define('_c_localUrlPageVar', 'pVarErsatzt');		// urlPageVar / p
define('_c_localPwBoxUrlVar', 'callPwErsatzt');		// pwBoxRequest / e
define('_c_localPermanDefPage', 'defPgErsatzt');	// permanentDefPage / welcome
define('_c_pwGuestLBoxR', 'guestVarErsatzt');	// Guest loggin url variable name / x


/**
Stats constants are in this file becauses stats also need to work when the cache is activated (php activity minimized & no data base queries).
*/
define('_c_localStatsUseIt', 'usesStatsErsatz');	// To use the local statistics facilities
define('_c_rndIndexStats', 'rndIndexErsatz');	// ok --> introduces a random part to the stats index to avoid possible concurrency between process
define('_c_jsBotsScary', 'botScrErsatz');	// ok to scare bots away with a fake huge loop
define('_c_rndStatsDirNmSfx', 'rndErsatzStatsSfx');	// Random statistics directory name suffix,it can be changed anytime for more privacy



/** 
Explanations for programmers : these constants were originally defined inside this file because the cache in reading mode need to access "values" that :
	- Must be defined early on to avoid loading 90% of the system.
	- Are independent from the data base, so we need to store them classically inside a standard file.	
	- Can change frequently from one installation to another.
	- Must be easy to change without touching the main code.
	... soon after a few other situations (statistics writing from a cached page) needed similar functionalities. _c_local prefixed constants are duplicated constants, original constant could have been defined here directly, but it would mean to have pivotal constants inside a sided file to easy to change and crash.
*/
?>