<?php
/**
	File name : capsHtml.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To encapsulate / abstract the most useful version of html, now Xhtml.
	The goal of this class is to abstract useful markup code (not JS) going to be interpreted inside a brewser.
	Mainly useful for updating the markup language at a unique coding location!
	
	Common and useful to inspect parameters :
		$attS : loaded with desired attributes, starting with a white separator.
		
		
	Strategy for numerous possible parameters of html related functions :
		(1) Couls have design a full blown object withall parameters, but this is long to write and not so efficient, so
		standard methods with most common parameters are used.
		(2) When new need appear, better to build a new function rather than to have a huge list of parameters in awkward positions.
		
	capsHtml::formatAll()
*/
class capsHtml extends oTop{
	

	function __construct(&$asa){
		parent::__construct();	
		$this->glob= &$asa->glob;
		$this->acc= &$asa->acc;
		$this->tools= &$asa->tools;
		$this->statsWr= &$asa->statsWr;
		
		$this->metaSup= '';
		$this->pgRefWaitingTm= '1';
		$this->gotPgRefreshUrl= false;
	} // construct
		
	
	function setDtbAccess(&$dtb){$this->dtb= &$dtb;}
	function setTagFu(&$tagsFu){$this->tagsFu= &$tagsFu;}
	function extraLoads(&$fls){$this->fls= &$fls;}	// just the file class with an odd name
	function loadsRMg(&$rMg){$this->rMg= &$rMg;}	// general rights pyssword crypting etc.
	function setWmRight(&$tagsFu){$this->wmR= &$tagsFu->wmRights;}	// the webmaster rights 1st def to manage the wysiwyg setting


	
		
	
	/**
		Format the Url structure.
	*/
	function htmlComment($str){
		return '<!-- '.$str.' -->';
	} // htmlComment

		
	/**
		Insures that $val is compatible for html double quotes inclusion.
		$this->htmlDQuote()
	*/
	function htmlDQuote($val){
		return str_replace('"','&quot;',$val);
	}
	
	/**
		Title & alt filling.
	*/
	function ta($t){
		return ' title="'.$this->htmlDQuote($t).'" alt="'.$this->htmlDQuote($t).'"';
	}
	
	/**
		ForMat a given Html Title attribute.
		$this->matTtl()
	*/
	function matTtl($t){
		if ($t!=='') return ' title="'.$this->htmlDQuote($t).'"';
		return '';
	}
	
	
	/**
		Format the Url structure.
	*/
	function matUrl($url){
		return ' url="'.$url.'"';
	} // matUrl
	
	
	/**
		Javascript file inclusion.
	*/
	function script($src){
		$tools= &$this->tools;
		$prfx= '';
		if ($tools->getVal('pushFullPath')==='ok'){	// pushFullPath got the priority on an empty $fullUrlPrfx
			$prfx= _c_siteUrlAccess;
		}
		return '<script src="'.$prfx.$src.'" type="text/javascript"></script>'._c_R;	// full </script>  really needed !!!
	} // script		

	
	/**
		Format an inline javascript instruction.
	*/
	function jsTag($bd){
		if ($bd===''){
			return '';
		}
	
		$b= '<script type="text/javascript">'._c_R;
		$b.= $bd._c_R.'</script>'._c_R._c_R;
		return $b;	
	} // jsTag	
	
	
	/**
		Format an inline css tag.
			Input : $s (content string);
			Output : $s with the style packaging.
		! Name similarity with matCss()
	*/
	function cssTag($s){
		if ($s==='') return '';
		return '<style type="text/css">'.$s.'</style>';
	} // cssTag
	
	/**
		Inline declared style. Could be useful with this cms for adaptive rich fonts like for link clouds.
		$s==='' || $s===false for compatibility with tags parameter style where false means no param given.
	*/
	function matStyl($s){
		if ($s==='' || $s===false){
			return '';
		}else{
			return ' style="'.$s.'"';
		}
	} // matStyl
	
	/**
		Format the CSS Element for inclusion of the returned string in other function parameter. Most often used for the FONTS
		! Name similarity with cssTag()
	*/
	function matCss($c){
		if ($c==='' || $c===false){
			return '';
		}else{
			return ' class="'.$c.'"';
		}
	} // matCss
	

	/**
		Return the complete no Follow string !
		Also see :	-- the tags [spiderF/] [spiderUF/] especially usefull inside forum posts!
					-- tagsFu::anchor(){ ... $glob->isSpiderFrienly  }
	*/
	function noFollowStr(){
		return ' rel="'._c_noFollow.'"';
	} // noFollowStr
	
		
	/**
	*/
	function matFollow($flw){
		if ($flw===_c_ko) return $this->noFollowStr();
		return '';
	} // matFollow
	
	
	function matValue($a){
		if ($a!=='' && $a!==false) return ' value="'.$a.'"';
		return '';
	} // matValue	
	
	function matId($x){
		if ($x!=='' && $x!==false) return ' id="'.$x.'"';
		return '';
	} // matId
	
	
	function matName($x){
		if ($x!=='' && $x!==false) return ' name="'.$x.'"';
		return '';
	} // matName
	
	// Specific for images, matName($x) is deprecated! So no dealing only with the Id
	function idNameStr($x){
		// return $this->matId($x) . $this->matName($x);
		return $this->matId($x);
	} // idNameStr
		
	
	function matJs($x){
		if ($x!=='') return ' js="'.$x.'"';
		return '';
	} // matJs
		
	
	function matRel($x){
		if ($x!=='') return ' rel="'.$x.'"';
		return '';
	} // matRel
		
		
	/**
	*/
	function target($tg='_blank'){
		// Easy way out of the anti target of yhtml strict, before it was : if ($tg!=='') return ' target="'.$tg.'"';
		if ($tg!=='') return ' onclick=\'target="'.$tg.'"\'';
		return '';
	} // target
		
	
	/**
		Loads the default value of a standard widget.
		Input :
			$v : standard vector of xml2-tags parameters.
			$name : name of the widget
			$gdv : given default value if none specified in the tag
	*/
	function loadDefVal(&$v,$name,$gdv){
		$tools= &$this->tools;
	
		$postedVal= $tools->postVal($name);		
		if ($postedVal===false){
			return $tools->binLoads($v['defval'],$gdv);
		}else{
			return $postedVal;				
		}
	} // loadDefVal

	
	/**
	*/
	function externalLink($s){
		$tools= &$this->tools;	
		return $tools->sIsInB(_c_slashHttp,$s) || $tools->sIsInB(_c_slashHttps,$s);
	} // externalLink
	
	
	/* ------------------------------
		Deal with global Html tags :
	-------------------------------- */
	
	/**
	*/
	function meta($name,$val){
		return '<meta name="'.$name.'"  content="'.$val.'"'._c_NdR;
	} // meta
	
	/**
	*/
	function metaRefresh(){
		$wait= $this->pgRefWaitingTm;
		$url= $this->gotPgRefreshUrl;
		if ($url!==false){
			return '<meta http-equiv="refresh" content="'.$wait.';URL='.$url.'"'._c_NdR;
		}else{
			return '';
		}
	} // metaRefresh
			
	
	
	/**
	*/
	function headerLink($rel,$type,$href){
		return '<link rel="'.$rel.'" type="'.$type.'" href="'.$href.'"'._c_NdR;
	} // headerLink	
	
	
	/**
	*/
	function instanceJs($jsFileN, $otherName=false){
		if ($otherName===false){
			return 'var '.$jsFileN.'= new '.$jsFileN.'();'._c_R;
		}else{
			return 'var '.$jsFileN.'= new '.$otherName.'();'._c_R;
		}
	} // instanceJs
	
	/**
	*/
	function cssCaps($pathCss,$fullUrlPrfx=''){
		if ($pathCss!==''){
			return $this->headerLink('stylesheet','text/css',$fullUrlPrfx.$pathCss);
		}
	} // cssCaps
	

	/**
	*/
	function gotAnHtmlBase(&$dtb){
		return _c_IndexFN!=='installer.php' && $dtb!==null && $dtb->getGenVar('htmlExplicitBase')===_c_ok;
	} // gotAnHtmlBase

	/**
	*/
	function htmlBase(&$dtb){
		if ( $this->gotAnHtmlBase($dtb) ){
			return _c_siteUrlAccess;
		}else{
			return '';
		}
	} // htmlBase
	

	/**
		Adds $sup at the end of the already existing supplementary neta tags
	*/
	function concatMetaSup($sup){
		$this->metaSup.= $sup;
	} // concatMetaSup
	

	/**
	*/
	function catNoCache(){
		$b= '<meta http-equiv="cache-control" content="no-cache, no-store, must-revalidate" '._c_NdR;
		$b.= '<meta http-equiv="pragma" content="no-cache" '._c_NdR;
		$b.= '<meta http-equiv="expires" content="0" '._c_NdR;
		// $b.= '<meta http-equiv="expires" content="Tue, 01 Jan 1980 1:00:00 GMT" '._c_NdR;
		$this->concatMetaSup($b);
	} // catNoCache
	

	/**
		Format the whole Html code
			->formatAll($mainContent,'myTitle','descr','kw','en','7 days','all','index, follow','pathCss','pathIco','pathJS');
	*/
	function formatAll($mainContent, 
		$title='', $descr='', $kw='', $lg='', $visit='', $audience='', $robot='', 
		$pathCss='', $jsWarning=true, $fullUrlPrfx= '', $gotJS=true, $std= true, $specCssPath= false){
					
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$rMg= &$this->rMg;
		$statsWr= &$this->statsWr;
		
		
		if ($lg==='' && $dtb!==null){
			$lg= $dtb->getGenVar('surfDefLanguage');
		}
		
		$b= '';
		// "most reliable doctype declaration for HTML5" : https://www.w3.org/QA/2002/04/valid-dtd-list.html
		$b.= '<!DOCTYPE html>'._c_R;
		$b.= '<html lang="'.$lg.'" dir="ltr">'._c_R;
		$b.= '<head>'._c_R;
		$b.= '<meta charset="utf-8" '._c_NdR;
		
		$b.= '<meta name="referrer" content="origin"'._c_NdR;
		if ( $this->gotAnHtmlBase($dtb) ){
			$b.= '<base href="'.$this->htmlBase($dtb).'" '._c_NdR;		// Trying to AVOID THE BASE for most sites because it compicate it, less portable compared to the simple "./"
		}
		
		if ($dtb!==null && $std){
			// standard, otherwise minimum htm capsulation
			$b.= '<title>'.$title.'</title>'._c_R;
			$b.= $this->meta('description',$descr);
			
			if ($kw!==''){
				$b.= $this->meta('keywords',$kw);
			}
			
			$b.= $this->meta('language',$lg);
			$b.= $this->meta('distribution','global');
			$b.= $this->addMobileTags();		
			$b.= $this->meta('audience',$audience);
			$b.= $this->meta('robots',$robot);
			$b.= $this->metaRefresh();
			
			
			if ($rMg->quickWMRight()){
				$this->catNoCache();	// Caching nothing when logged
			}else{			
				if ( $dtb->getGenVar('noCacheEverywhere')===_c_ok ){
					$this->catNoCache();	// No cache everywhere !!
				} // else --> called only for forums !!
			}
			
			$b.= $this->metaSup;	// META ? cache
			
			$mtCmsD= $dtb->getGenVar('mtCmsDeclared');
			if ($mtCmsD===_c_ok){
				$b.= $this->meta('generator', 'ATAOX is an Open Source CMS available at www.'._c_generatorDomNm);
			}
			
			// Owner & website technical contact
			$metaOwner= $dtb->getGenVar('metaOwner',_c_ko);
			if ( $metaOwner!==_c_ko && $metaOwner!=='' ){
				$b.= $this->meta('owner',$metaOwner);
			}
			
			$metaTC= $dtb->getGenVar('metaTechnicalContact',_c_ko);
			if ( $metaTC!==_c_ko && $metaTC!=='' ){
				$b.= $this->meta('Technical Contact',$metaTC);
			}
			
			$b.= $this->meta('revisit-after',$visit);
			
			// CSS files
			$b.= $this->cssCaps($pathCss,$fullUrlPrfx);
			$b.= $glob->getAddedCssF($fullUrlPrfx);	
			$b.= $this->headerLink('shortcut icon','image/ico', $fullUrlPrfx._c_bookMrkIconPath);		
		}
		
		if ($specCssPath!==false){
			$b.=  $this->cssCaps($specCssPath,$fullUrlPrfx);
		}
		
		if ($rMg->quickWMRight()){
			$b.=  $this->cssCaps(_c_mainEdtCssDfn,$fullUrlPrfx);
		}
		
		if ($dtb!==null && $gotJS){
			$b.= $this->script(_c_LibPath.'kk.js');		// special ubiqutous addition
			
			if (_c_multiByteCrypting===_c_ok){
				$b.= $this->script(_c_LibPath.'crypt/mb/xbCrypt.js');
			}else{
				// Simple bytes crypting deprecated! The class is kept inside the vault!
				$b.= $this->script(_c_LibPath.'crypt/sb/xbCrypt.js');
			}
			
			$b.= $this->script(_c_KernelPath.'genAsa.js');	// Path of the main JS file
			
			$b.= $glob->getAddedJsF(); 	// Eventual paths of others JS files
			if ($rMg->quickWMRight()){
				$b.= $this->script(_c_NicEditPath.'nicEdit.js');
			}
			
			$bufJs= '';
			$bufJs.= 'var kk= new kk();'._c_R;
			$bufJs.= 'var xbCrypt= new xbCrypt();'._c_R;
			$bufJs.= 'var genAsa= new genAsa();'._c_R;
			$bufJs.= 'genAsa.setSortOfInteger(\''._c_forceLargeInt.'\');'._c_R;	
			
			$userId= $rMg->realTimeUserId();
			
			$incrHdJs= 'window.winUserId= "'.$userId.'";'._c_R;
			$incrHdJs.= 'window.jsSmartPhMd= "'.$tools->boolToOk($tools->isInSmartPM()).'";'._c_R;
			$incrHdJs.= 'window.virtualTryGadget= "'.$dtb->getGenVar('virtualTryGadget').'";'._c_R;
			
			
			
			$glob->setHeadGlobJsCd($incrHdJs);
			
			$bufJs.= $glob->getGlobJsCode();
			$b.= $this->jsTag($bufJs);
		}
		
		if ($glob->anyCodeInHeader!==''){
			$b.= $glob->anyCodeInHeader._c_R;
		}
		$b.= '</head>'._c_R._c_R;
		
		if ($dtb!==null){
			$bdSty= $dtb->getGenVar('fullBodyStyle');
			if ( $statsWr!==null && !$statsWr->privateActivities() ){
				$b.= '<body'.$this->matCss('gecBody').' onload="ajaxChecker()">'._c_R;	
			}else{
				$b.= '<body'.$this->matCss('gecBody').'>'._c_R;	
			}
		}else{
			$b.= '<body>'._c_R;	
		}
		
			
		if ($gotJS && $this->condiDebug()){		
			$b.= $this->div('-------------'._c_Br.'JsDebug : ','','JsDebug');
		}
		
		$b.= $mainContent._c_R;		
		if ($gotJS){
			$b.= $this->jsTag($glob->getGlbEndJsCode());	
		}
		$b.= '</body>'._c_R.'</html>'._c_R._c_R._c_R;
		return $b;
	} // formatAll
		
		
	/**
	*/
	function internalFormat($mainContent, $pathCss='', $jsWarning=true, $fullUrlPrfx='', $gotJS=true){
		return $this->formatAll($mainContent,'','','','','','','',$pathCss,$jsWarning,$fullUrlPrfx,$gotJS);
	} // internalFormat
		
		
	/**
	*/
	function minInternalFormat($mainContent,$specCssPath){
		return $this->formatAll($mainContent,'','','','','','','','',true,_c_siteUrlAccess,false,false,$specCssPath);
	} // minInternalFormat
	
	
	/**
	*/
	function addMobileTags(){
		$tgFu= &$this->tagsFu;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$b= '';
		$b.= '<meta name="handheldFriendly" content="true"'._c_NdR;
		
		// Viewport can be ADAPTED FOR EACH PAGES :.
		if ($tgFu->tgViewportContent!==false){
			// Given from a specific tag (for specific needs, like no zoom in/out). Defined with a LOCAL PAGE TAG included into $tgFu object variables, on each concerned pages, like :
			// [viewport content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1" /]
			$b.= '<meta name="viewport" content="'.$tgFu->tgViewportContent.'"'._c_NdR;
		}else{
			// Standard value form genVar. most of the time : 	
			$catW= $tools->gostVal(_c_catWalkMode,_c_ko);
			if ($catW===_c_ok){
				$gVal= $dtb->getGenVar('viewPrtCatWalkMetaDef','width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1');
			}else{
				$gVal= $dtb->getGenVar('viewPrtMetaDef','initial-scale=1');
			}
			
			$b.= '<meta name="viewport" content="'.$gVal.'"'._c_NdR;	// initial-scale=1 and free afterward
			
			
		}
		return $b;
	} // addMobileTags
	

	/* ------------------------------
		Deal with form tags :
	-------------------------------- */
	
	/**
		Single direct call to the <form ... tag
		$attS : attribute string must be loaded with desired attributes, starting with a white separator.
		$this->form()
	*/
	function form($url,$name,$content,$attS='',$hidWdgtNm=_c_genHidWdgtFormNm, $method='post',$enctype='multipart/form-data'){
		$b= $this->hiddenWdg($hidWdgtNm,_c_ok);
		return $this->formCapsKernel($url,$name,$b.$content,$attS,$method,$enctype);
	} // form
	
	
	function formCapsKernel($url,$name,$content,$attS='',$method='POST',$enctype='multipart/form-data'){
		$b= $this->headForm($url,$name,$attS,$method,$enctype);
		$b.= $content._c_R;
		$b.= $this->endForm();
		return $b;
	} // formCapsKernel
	
	/**
		Head of the <form ..> tag
		Remark :
			$name was used for the name and the id attribute, now only the id stays becaus of xhtml restrictions.
	*/
	function headForm($url,$name,$attS='',$method='post',$enctype='multipart/form-data'){
		$glob= &$this->glob;		
		$tools= &$this->tools;
				
		if ($this->condiDebug()){
			$attS.= $this->target('_blank');
		}
		
		if ($method!==''){
			$method= ' method="'.$method.'"';
		}
		
		$url= $this->formatUrl($url);
		$b= '<form action="'.$url.'" id="'.$name.'"'.$method.' enctype="'.$enctype.'"'.$attS.'>'._c_R;
		$b.= $this->heaDiv()._c_R;
		$b.= $this->hiddenWdg(_c_anyFormSentId,_c_ok);
		return $b;
	} // headForm
	
	
	function endForm(){
		$b= $this->enDiv()._c_R;
		$b.= '</form>'._c_R;
		return $b;
	} // endForm
	
	
	
	/**
		xHtml Text Area (multi line text box)
		Input : $name : name of the text area
			$row : nb of rows.
			$col : nb of cols
			$content : the given content.
			$attS : all possible attributes.
			$gotWrap : false --> short circuit the wrapping attribute (default)
	*/
	function textarea($name,$row,$col,$content='', $attS='',$gotWrap=false,$lim=5000, $cls=''){
		$acc= &$this->acc;	
		$tools= &$this->tools;	
			
		$wrap= '';
		if ($gotWrap){
			$wrapVal= $tools->wrapped();			
			if ($wrapVal===_c_ko){
				$wrap= ' wrap="off"';
				$tools->spcSetCook('wrap',_c_ko);
			}else{
				$tools->spcSetCook('wrap',_c_ok);	// can't just delete the cookie, because need the long term memory so we don't jump back on the database default
			}
		}
		
		if ($tools->getVal('htmlentities')===_c_ok){
			$content= htmlentities($content);
		}
		return $this->txArea($name,$row,$col,$content,$attS,$wrap,$lim,$cls);
	} // textarea
	
	/**
		$caps->textAreaStl('name', $content, ' width: 10%;  height:80px;');
	*/
	function textAreaStl($name,$content='', $style='', $gotWrap=false,$lim=''){
		$styleStr= '';
		if ($style!==''){
			$styleStr= $this->matStyl($style);
		}
		return $this->textarea($name,'','',$content, $styleStr,$gotWrap,$lim);
	} // textAreaStl
	
	
	/**
		Managing a text area
		Evolution :
			$lim can't apply to xhtml strict the should do something at the post php reception
				... could supress the attribute $lim or may be transfer its value to the top ?
	*/
	function txArea($name,$row='',$col='',$content='',$attSup='',$wrap= '',$lim=5000, $cls=''){
		$totSup= $attSup.$wrap;
		if ($cls!==''){
			$totSup.= $this->matCss($cls);
		}
		
		$rowStr= '';
		if ($row!==''){
			$rowStr= ' rows="'.$row.'"';
		}
		
		$colStr= '';
		if ($col!=='' || $col!=='w'){	// 'w' historical use
			$colStr= ' cols="'.$col.'"';
		}
		
		return '<textarea name="'.$name.'" id="'.$name.'"'.$rowStr.$colStr.$totSup.'>'.$content.'</textarea>'._c_R;
	} // txArea
	
	/**
		Maximum number of chars the box is capable to held!
		Rem : valid for text boxes and for text areas !!
	*/
	function txtBxCharLim($l){
		$rMg= &$this->rMg;
		if ( $l===false || $rMg->quickWMRight() ){
			return '';	// no limit !!!!!!!!!!!
		}else{
			return ' maxlength="'.$l.'"';
		}
	} // txtBxCharLim
	
	
	/**
	*/
	function wysiwygButton($name){
		$glob= &$this->glob;	
		
		$this->createsNiceEdtNames($ckName,$spcCkName,$name);
		$fu= $this->jsFunctCallStr('onClick','genAsa.toggleNicEditor',2,0,$name,$spcCkName);

		$alt= $glob->el('Switch button between the Wysiwyg and the Xpetal mode','kbbj');
		$ttl= $this->matTtl($alt);
			
		return $this->simplestImg(_c_EditorImgPath.'wysiXpetal.png',  $alt, 
			$fu.$this->matCss('efMbAdm').$ttl );
	} // wysiwygButton
	

	/**
		Creates niceEdit related names :
			Input :
				$name : base name
			Output :
				$objName : name of the niceEdit object;
				$ckName: niceEdit cookie core name
				$spcCkName : niceEdit specific cookie name
	*/
	function createsNiceEdtNames(&$ckName,&$spcCkName,$name){
		$tools= &$this->tools;
		$ckName= 'ck'.$name;
		$spcCkName= $tools->spc($ckName);
	} // createsNiceEdtNames


	/**
	*/
	function niceTextArea($name,$row,$col,$content,$gotWrap=false,$lim=5000){
		$dtb= &$this->dtb;
		$wmR= &$this->wmR;
	
		return $this->ncTxtAreaKernel($name,$row,$col,$content,' class="niceTextAr"',$gotWrap,$lim);	
	} // niceTextArea
	
	
	/**
		Allow to swtich between a wysiwyg and a standard text area.
	
		Input :
			$name : name and Id.
			$row,$col : nb rows, col.
			$content : default content of the area.
			$attS : attributes of the textarea.
	*/
	function ncTxtAreaKernel($name,$row,$col,$content,$attS=' class="niceTextAr"',$gotWrap=false,$lim=5000){
		$acc= &$this->acc;	
		return $this->textarea($name,$row,$col,$content,$attS,$gotWrap,$lim);
	} // ncTxtAreaKernel
	
	
	/**
	*/
	function onClickImg($imgPath,$alt, $css,
		$fuN,$nbParam=0,$nbVar=0,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7=''){
	
		$sup= $this->matCss($css).$this->jsFunctCallStr('onClick',$fuN,$nbParam,$nbVar,$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7);
		return $this->simplestImg($imgPath,$alt,$sup);
	} // onClickImg
	

	/**
		Submit is conditional to the call of a javascript function.
			To use $this->jsSimpleFu()
	*/
	function onClickButton($name,$fu='',$label='Send',$attS=''){
		return $this->onClickBut($name,$label,$fu,$attS);
	} // onClickButton
	
	
	function onClickBut($name,$label='Send',$fu='',$attS=''){
		if ($fu===''){
			$strFu= '';
		}else{
			$strFu= ' onClick="'.$fu.'"';
		}
		return '<button name="'.$name.'" id="'.$name.'"'.$strFu.$attS.'>'.$label.'</button>';
	} // onClickBut
	

	/**
		Submit is conditional to the call of a javascript function.
			To use $this->jsSimpleFu()
	*/
	function onClickInput($name,$fu,$label,$attS=''){
		if ($fu!==''){
			$attS= ' onClick="'.$fu.'" '.$attS;
		}
		return $this->input('button',$name,$label,$attS);
	} // onClickInput

		
	/**
		Direct submit for forms.
	*/
	function submit($name,$value,$attS=''){
		return $this->input('submit',$name,$value,$attS)._c_R;
	} // submit
	
	
	/**
		General call for different form widget.
	*/
	function input($type,$name,$val,$attS=''){
		return '<input type="'.$type.'" name="'.$name.'" id="'.$name.'" value="'.$val.'"'.$attS._c_Nd;
	} // input
	
	
	/**
	*/
	function rangeWidget($quantityId, $minVal,$maxVal, $fuName,$elemId,$attS=''){
		$initVal= round(($minVal+$maxVal)/2);
		$attS.= ' min="'.$minVal.'" max="'.$maxVal.'"';
		$attS.= $this->jsFunctCallStr('onchange',$fuName,2,0,$elemId,$quantityId);
		$attS.= $this->jsFunctCallStr('oninput',$fuName,2,0,$elemId,$quantityId);
		return $this->input('range', $quantityId, $initVal, $attS);
	} // rangeWidget	
	
	function rgWidget($quantityId, $minVal,$maxVal,$attS=''){
		$initVal= round(($minVal+$maxVal)/2);
		$attS.= ' min="'.$minVal.'" max="'.$maxVal.'"';
		return $this->input('range', $quantityId, $initVal, $attS);
	} // rgWidget	
	
	
	
		
	/* -------------------------------------------------------------
	*/
	function corePwWdg($name,$val,$boxSize,$attS='',$lim=20){
		$lStr= $this->txtBxCharLim($lim);	// max inout length
		return $this->input('password', $name,$this->htmlDQuote($val), ' size="' . $boxSize.'"'.$attS.$lStr);
	} // corePwWdg		
		
	/**
	*/
	function passwordWdg($name,$val,$boxSize,$attS='',$lim=20){
		return $this->corePwWdg($name,$val,$boxSize,$attS,$lim);
	} // passwordWdg		
				
	/**
		breaked password widget. Breack bug when introduced into a JS function
	*/
	function brPasswordWdg($name,$val,$boxSize,$attS='',$lim=20){
		return $this->corePwWdg($name,$val,$boxSize,$attS,$lim)._c_R;
	} // brPasswordWdg		
		
	/**
		xHtml Text box
	*/
	function textBox($name,$val,$boxSize="20",$attS='',$lim='200'){
		if ($boxSize!=='w'){
			$bxsStr= ' size="'.$boxSize.'"';
		}else{
			$bxsStr= '';
		}
		return $this->input('text', $name, $this->htmlDQuote($val), $bxsStr.$attS.$this->txtBxCharLim($lim))._c_R;
	} // textBox	

	function textBxStl($n,$val,$stl='',$lim='200'){
		if ($stl!=='') $stl= $this->matStyl($stl);
		return $this->textBox($n,$val,'w',$stl,$lim);
	} // textBx	

	function textBx($n,$val,$sz,$c='',$lim='200'){
		if ($c!=='') $c= $this->matCss($c);
		return $this->textBox($n,$val,$sz,$c,$lim);
	} // textBx	
	
	
	/* -------------------------------------------------------------
	*/
	function hiddenWdg($name,$val){
		// n input(
		return $this->input('hidden',$name,$this->htmlDQuote($val))._c_R;
	} // hiddenWdg		

			
	/**
		A simple Form with a TextArea and a Send button. A call example :
			$this->simpleFormTextA(_c_IndexFN,'myForm', 'myTable','10','80','Hello!', 'myButton','Send');
	*/
	function simpleFormTextA($fUrl,$fName,  $tName,$tRow,$tCol,$tContent,  $sName,$sValue){
		$fContent= $this->textarea($tName,$tRow,$tCol,$tContent)._c_;
		$fContent.= $this->submit($sName,$sValue);
		return $this->form($fUrl,$fName,$fContent);
	} // simpleFormTextA	
	
		
	/**
		Just for comboBox(...)
	*/	
	function selectIfEqual($a,$b){
		if ($a==$b){
			return ' selected';
		}else
			return '';
	} // selectIfEqual
	
	
	/**
		$lbl : is option Group Start. (s1)
	*/
	function isOGS($val){
		$tools= &$this->tools;
		$isOGS= $val[0]==='s' && $tools->isSimpleNumber($val[1]);
		return $isOGS;
	} // isOGS
	
	/**
		$lbl : is option Group End.	(e1)
	*/
	function isOGE($val){
		$tools= &$this->tools;	
		return $val[0]==='e' && $tools->isSimpleNumber($val[1]);
	} // isOGE
	
	/**
	*/
	function isOGSE($s){
		return $this->isOGS($s) || $this->isOGE($s);
	} // isOGSE
	
	
	/**
		Abrev : s(i)
	*/
	function oGroupStart($lbl){
		return '<optgroup label="'.$this->htmlDQuote($lbl).'">';
	} // oGroupStart
	
	/**
		Abrev : e(i)
	*/
	function oGroupEnd(){
		return '</optgroup>';
	} // oGroupEnd
	
	
	/**
		General combo Box.
			$wId : widget id	// $wName : widget name
			$defVal : default value to choose the position of the select box.
			
			$vSelect : ----> $vSelect[ selected Value ] === string to display
				Associative array to define the select box with : foreach returnedValue => displayValue
				
			$attS : loaded with desired html attributes of the <select ...> tag, starting with a white separator (suplementary parameters)
			$biVal : false --> the values of $vSelect are used for the displays and for the values to be returned.
					 true --> keys == selected values and the values of the assoc array are displayed.
			$acceptOptGrp : must be set to true to accept optgroup (group labelling).
			$defRank : to impose a default rank.
			
			Test :		 
				$this->comboBox('testCombo','st',array('st'=>'Standard','navFiles'=>'Navig.Fichiers'));
	*/
	function comboBox($wId,$defVal,&$vSelect,$attS='',$biVal=false,$acceptOptGrp=false,$defRank=false){
		$b= _c_R.'<select name="'. $wId.'" id="'.$wId.'"'.$attS.'>'._c_R; // name attrib is necessary!
		reset($vSelect);
		$rank= 1;	// start at one so it's really an ordinal rank and easier for outsider to understand!
		foreach ($vSelect as $selectVal => $dsplStr){
			if ($biVal){
				$b.= $this->option($defVal,$selectVal,$dsplStr,$acceptOptGrp,$defRank,$rank);
			}else{
				$b.= $this->option($defVal,$dsplStr,$dsplStr,$acceptOptGrp,$defRank,$rank);
			}
			
			$rank++;
		}
		$b.= _c_R.'</select>'._c_R;
		return $b;
	} // comboBox

	/**
		A more practical position of parameters in some cases.
	*/
	function cmbBox($wName,&$vSelect,$defVal=false, $biVal=false,$attS='',$acceptOptGrp=true){
		return $this->comboBox($wName,$defVal,$vSelect,$attS,$biVal,$acceptOptGrp);
	} // cmbBox


	/**
	*/
	function numVect($min,$max,$incr=1){
		$v= array();
		$j= 0;
		for ($i=$min; $i<=$max; $i=$i+$incr){
			$v[$j]= $i;
			$j++;
		} // for
		return $v;
	} // numVect
	
	
	
	/**
		To control one option of $this->comboBox().		
			Input :
				$defVal : the default current value (chosen by default)
				$selectVal : the value chosen if this option is selected
				$dsplStr : the string to display
			Remark : $selectVal starting with e or s and having a second position digit are group labels
	*/
	function option($defVal,$selectVal,$dsplStr,$acceptOptGrp,$defRank,$rank){
		if ($acceptOptGrp===true && $this->isOGSE($selectVal)){
			if ($this->isOGS($selectVal)){
				return $this->oGroupStart($dsplStr);
			}else{
				return $this->oGroupEnd();
			}
		}else{
			if ($defRank===false){
				$selectedStr= $this->selectIfEqual($defVal,$selectVal);
			}else{
				$selectedStr= $this->selectIfEqual($defRank,$rank);				
			}
		
			return '<option'.$selectedStr.' value="'.$selectVal.'">'.$dsplStr.'</option>'._c_R;
		}
	} // option
	

	
	/** --------------------------------------------------------------------------------
		Anchor TAG
	*/
		
	/**
		Title & Class convenient hyperlink.
			Input :
				$url : concerned url.
				$content : content to display.
				$t : title, mainly to replace/complete the image alt parameter in a way that does not trigger a
					 spamdexing defense from searchengines.
				$s : the used inline style.
	*/
	function linkTS($url,$content,$t='',$s='',$target=''){
		$b= $this->matTtl($t);
		$b.= $this->matStyl($s);
		return $this->hLink($url,$content,$b,$target);
	} // linkTS
	
	function linkTC($url,$content,$t='',$c='',$target='',$rel=''){
		$b= $this->matTtl($t);
		$b.= $this->matCss($c);
		return $this->hLink($url, $content, $b.$rel, $target);
	} // linkTC
	
	/**
		Link with Class manip : Url formatting the Class is taken in charge.
	*/
	function linkC($url,$content,$c='',$target=''){
		$c= $this->matCss($c);
		return $this->hLink($url,$content,$c,$target);
	}
	
	function linkT($url,$content,$s='',$target=''){
		$s= $this->matStyl($s);
		return $this->hLink($url,$content,$s,$target);
	} // linkT
	
	function linkCS($url,$content, $c='',$s='', $target=''){
		$c= $this->matCss($c);
		$s= $this->matStyl($s);
		return $this->hLink($url, $content, $c.$s, $target);
	} // linkCS
	
	
		
	/**
		Class Link almost Total number of parameters
	*/
	function cLinkTot($url,$content,$class, $id='', $title='',$target='_top',$js='',$rel='',$lang=''){
		$b= $this->linkParam($id,$js,$title,$rel,$lang);
		$b.= $this->matCss($class);
		return $this->hLink($url,$content,$b,$target);
	} // cLinkTot
	
	function jsLink($content,$class, $js, $url='#', $title='',$id='',$target='_top'){
		$b= $this->linkParam($id,$js);
		$b.= $this->matCss($class);
		return $this->hLink($url,$content,$b,$target);
	} // jsLink
	

	/**
		Style Link almost Total number of parameters.
		$js used for javascript and stack all other param!
	*/
	function sLinkTot($url,$content,$style,  $id,$title,$target='_top',$js='',$rel='',$lang=''){
		$b= $this->linkParam($id,$js,$title,$rel,$lang);
		$b.= $this->matStyl($style);
		return $this->hLink($url,$content,$b,$target);
	} // sLinkTot
		
	/**
		Link/Anchor important facultaive parameters.
	*/		
	function linkParam($id,$js,$title='',$rel='',$lang=''){
		$b= '';
		$b.= $this->matId($id);
		$b.= $this->matJs($js);
		$b.= $this->matTtl($title);
		$b.= $this->matRel($rel);
		if ($lang!=='') $b.= ' lang="'.$lang.'"';
		return $b;
	} // linkParam
		
		
	/**
		Basic hyperlink
		$this->aSpan($a,$b)
		See n spanA
	*/
	function hLink($url,$lbl,$attS='',$target=''){
		$tools= &$this->tools;
		
		if ($target!==''){
			$target= $this->target($target);
		}
		
		$url= $this->formatUrl($url);
		return '<a href="'.$url.'"'.$attS.$target.'>'.$lbl.'</a>';
	} // hLink
	
	/**
	*/
	function formatUrl($url){
		$tools= &$this->tools;
		
		if ($url===''){
			return '';
		}
		
		if (_c_gotRealHtmlAmp){
			/*
				Need to have this preliminary step because raw ampersand can be present by user addition 
				even if strict at the  1st level, therefore it's more economical to generate raw urls and 
				formalize them later on, therefore here!
			*/
			$url= str_replace(_c_realHtmlAmp,'&',$url);
			
			// Main step
			$url= str_replace('&',_c_realHtmlAmp,$url);
		}
		
		$c0= $url[0];
		if ($c0==='#'){
			// because # in first position does not work in a browser when the <base> tag is specified.
			$szUrl= strlen($url);
			
			// Other parameters follow --> add all the parameters of $_GET that are not in $url)
			$forbVect= $tools->urlVarArray($url);	// forbiden vector
			$urlSup= substr($url,1);
			$urlKept= $tools->urlFromGet($forbVect);
			$url= $urlKept.$urlSup;
		}
		return $url;
	} // formatUrl
	
	
	function hL($url, $content, $cls='', $target='', $ttl=''){
		$cls= $this->matCss($cls);
		$ttl= $this->matTtl($ttl);
		return $this->hLink($url,$content, $cls.$ttl, $target);
	} // hL
		
	
	/**
	*/
	function pageLink($content,$pg,$cls,$target){
		$tools= &$this->tools;
		$url= $tools->urlGivenPage($pg);
		return $this->hL($url,$content,$cls,$target);
	} // pageLink
		
		
	/**
		Url bookmark
	*/
	function urlBm($id){
		return '#'.$id;
	}
		
	/**
		Anchor bookmark
	*/
	function bookMark($id){
		return '<a name="'.$id.'"></a>';
	}
			
	/* 
		End Anchor TAG
	-------------------------------------------------------------------------------- */

	
	/**
		Div familly
	*/
	
	/**
		Display a message with the default error Font.
	*/
	function eFont($str){
		return $this->font($str,'errFont');
	} // eFont	

	function font($str,$c=''){
		return $this->div($str,$c);	
	} // font
		
	/**
		Styled <div ...> more practical for inline dimentions.
	*/
	function sDiv($str,$stl='',$id=''){
		return $this->div($str,'',$id,'',$stl);
	} // sDiv
			
	/**
		Prefers it for font definition if other items are using div (general homogeneity).
			Input :
				$str : string to encapsulate.
				$cl : class style
				$id : identification of the current html div tag
				$js : javascript string.
				$stl : inline style.
	*/
	function div($str, $cl='', $id='', $js='', $stl='', $sup=''){
		return $this->heaDiv($stl,$id,$js,$cl,$sup).
			_c_R.$str._c_R.
			$this->enDiv();
	} // div
	
	// A DIV to setInnerHtml Fill.
	function dv($id){
		return $this->div('','',$id,'','');
	} // dv
	

	function hdDiv($cls='',$stl='',$id='',$js='',$sup=''){
		return $this->heaDiv($stl,$id,$js,$cls,$sup);
	} // hdDiv
	
	/**
		$this->heaDiv($style='',$id='',$js='',$class='')
		$this->enDiv();
	*/
	function heaDiv($style='',$id='',$js='',$class='',$sup=''){
		$s='';
		if ($class!=='') $s= $this->matCss($class);
		
		if ($id!==''){
			$s.= ' id="'.$id.'"';
			$s.= ' name="'.$id.'"';			
		}
			
		if ($js!=='') $s.= $js;
		if ($style!=='') $s.= $this->matStyl($style);
		$s.= $sup;
		return _c_R.'<div'.$s.'>';
	} // heaDiv
	
	function enDiv(){
		return '</div>';
	} // enDiv
	
	/**
		A general horizontal center alignment :
			- External div to occupy the 100% available room
			- Next div to th especify the with and the centering (margin:auto) and the $frameStyle
			- The 3rd most centered div to define the general margins
			- And last style definition : the information string! No it's not generally possible to define margins on this element
			  because they are applied lineary, so for a left margin, like a tab before the 1st character.
			  
			 A great improvment (ironic) compared to tables / cells definition were all that was possible just within the <table><tr><td> structure.
	*/
	function alignCenter($str,$width, $rightLeft,$topBottom,$frameStyle=''){
		// defining the 4 margins
		$top= $topBottom;
		$r= $rightLeft;
		$b= $topBottom;
		$l= $rightLeft;
		
		return $this->sDiv( $this->sDiv($this->sDiv($str,'margin: '.$top.'px '.$r.'px '.$b.'px '.$l.'px'), 'margin:auto; width:'.$width.'px;'.$frameStyle) ,'width:100%;');
	} // alignCenter
		

	/**
		"Span" familly
	*/
	
	/**
		Userlabel. ..... Div are too restrictive! ,,, Should have easy calls for span tag +
		useful in many cases can have a <a .../ >
	*/
	function uLabel($str,$c='usrLbl'){
		return $this->eLabel($str,$c);
	} // uLabel	
		
	/**
		Edit label.
	*/
	function eLabel($str,$c='editLbl'){
		return $this->div($str,$c);
	} // eLabel	
		
	/**
	*/
	function label($str,$c=''){
		return $this->div($str,$c);
	} // label	
	
	
	/**
	*/
	function span($str,$c='',$s='',$id='',$ttl='',$x=''){
		$c= $this->matCss($c);
		$s= $this->matStyl($s);
		if ($x!=='') $s.= $x;
		
		if ($id!=='') $id= ' id="'.$id.'" name="'.$id.'"';
		$ttl= $this->matTtl($ttl);	// if included
		return $this->aSpan($c.$s.$id.$ttl, $str);
	} // span
	
	function spanClId($str,$c,$id){
		return $this->span($str,$c,'',$id);
	} // spanClId
	
	
	

	/**
	*/
	function aSpan($param,$label){
		return '<span'.$param.'>'.$label.'</span>';	
	} // aSpan
	
	function rawSpan($label,$param){
		return '<span'.$param.'>'.$label.'</span>';	
	} // rawSpan
	
	
	

	// reversed parameters
	function spanA($b,$a){
		return $this->aSpan($a,$b);	
	} // aSpan

	
	/**
	*/
	function spanJs($str,$js, $c='ln',$x=''){
		$js.= $x;
		return $this->span($str,$c,'','','',$js);
	} // spanJs

	
	/**
	*/
	function spanTtl($str,$c,$ttl=''){
		return $this->span($str,$c,'','',$ttl);
	} // spanTtl
	
		
	/**
	*/
	function br($attS=''){
		return '<br'.$attS._c_Nd;	
	} // br
	
	/**
	*/
	function fluxBr($step=1){
		$s= '';
		for ($i=0; $i<$step ;$i++){
			$s.= _c_BrFlux;
		}
		return $s;
	} // fluxBr
	
	
	/**
	*/
	function bold($s){
		return '<b>'.$s.'</b>';
	} // bold
	
	/**
	*/
	function italic($s){
		return '<i>'.$s.'</i>';
	} // italic	
	
	/**
	*/
	function underline($s){
		return '<u>'.$s.'</u>';
	} // underline
	
	
	/**
	*/
	function topTagOList($s,$c=''){
		if ($c===''){
			return $this->topTagOL($s);		
		}else{
			return $this->topTagOL($s,$this->matCss($c));
		}
	} // topTagOList

	function topTagOL($s,$attS=''){
		return '<ol'.$attS.'>'._c_R.$s.'</ol>'._c_R;
	} // topTagOL
	
	
	/**
	*/
	function topTagList($s,$c){
		if ($c===''){
			return $this->topTagUL($s);		
		}else{
			return $this->topTagUL($s,$this->matCss($c));
		}
	} // topTagList
	
	function topTagUL($s,$attS=''){
		return _c_R.'<ul'.$attS.'>'.$s.'</ul>';
	} // topTagUL
	
	function elemLi($s){
		return _c_R.'<li>'.$s.'</li>';
	} // elemLi
	
	function monoList($s,$attS=''){
		return $this->topTagUL(  $this->elemLi($s), $attS);
	}
	
	

	/** --------------------------------------------------------------------------------
		IMAGE TAG
			Main functions : $this->image($src,$alt,$class,$id);
			With inline style functions : $this->styleImg($src,$alt,$class,$id);
	*/
		
	/**
		$caps->imgSrc($givenSrc,_c_ok);
	*/
	function imgSrc($givenSrc,$edt='ko'){
		$tools= &$this->tools;	
		$prfx= '';
		if ($tools->getVal('pushFullPath')==='ok'){	// pushFullPath got the priority on an empty $fullUrlPrfx
			$prfx= _c_siteUrlAccess;
		}
		
		if ($edt==='ko'){
			return $prfx._c_UsrImagePath.$givenSrc;	// local image inside the user directory.
		}else{
			$fls= &$this->fls;
			return $prfx.$fls->editorImage($givenSrc);	// local image inside the editor directory.
		}
	} // imgSrc				
	
	/**
	*/
	function stdImage($givenSrc,$edt,$alt='',$cls='',$id='',$js='',$stl='',$alttl=''){
		$tools= &$this->tools;	
		$fls= &$this->fls;	
		
		if ($this->externalLink($givenSrc)){
			$src= $givenSrc;	// considers it as a self standing http(s)://
		}else{
			$src= $this->imgSrc($givenSrc,$edt);
			if (!file_exists($src)){
				return '';
			}
		}
		
		$ttl= '';
		if ($alttl==='ok'){
			$ttl= $alt;
		}
		return $this->ttlImage($src,$alt,$ttl,$cls,$id,$js,$stl);		
	} // stdImage
	
	
	/**
		Main facultative Image param
	*/
	function fImgParam($cls,$id,$js,$style,$width='',$height='',$ismap='',$usemap=''){
		$b= '';
		$b.= $this->matCss($cls);
		$b.= $this->idNameStr($id);
		
		if ($js!=='') $b.= $js;
		$b.= $this->matStyl($style);
		if ($width!=='') $b.= ' width="'.$width.'"';
		if ($height!=='') $b.= ' height="'.$height.'"';
		if ($ismap!=='') $b.= ' ismap="'.$ismap.'"';
		if ($usemap!=='') $b.= ' usemap="'.$usemap.'"';
		return $b;
	} // fImgParam	
		
	
	/**
		Standard image with class type of styles.
		$js : javascript and eventual supplementary attributes.
	*/
	function image($src, $alt='', $cls='', $id='',  $js='', $style='', $width='', $height='',$ismap='',$usemap=''){
		$b= $this->fImgParam($cls,$id,$js,$style,$width,$height,$ismap,$usemap);
		return $this->simplestImg($src,$alt,$b);
	} // image
	
	function ttlImage($src, $alt='', $ttl='', $cls='', $id='',  $js='', $style='', $width='',$height=''){
		$b= $this->fImgParam($cls,$id,$js,$style,$width,$height);
		if ($ttl!==''){
			if ($ttl==='#'){
				$b.= ' title="'.$this->htmlDQuote($alt).'"';
			}else{
				$b.= ' title="'.$this->htmlDQuote($ttl).'"';
			}
		}
		return $this->simplestImg($src,$alt,$b);
	} // ttlImage
	
	// Economic way to impose a title similar to the alt when call to function image(...) are alredy written
	function ttlImg($src, $alt='', $cls='', $id='',  $js='', $style='', $width='', $height=''){
		return $this->ttlImage($src, $alt, '#', $cls, $id,  $js, $style, $width,$height);
	} // ttlImg
	
	/**
	*/
	function img($src, $alt='', $cls='slImg', $sup=''){
		return '<img src="'.$src.'" alt="'.$this->htmlDQuote($alt).'" class="'.$cls.'"'.$sup._c_Nd;	
	} // img
	
	/**
		Smallest form with compulsory attributes.
	*/
	function simplestImg($src,$alt='',$sup=''){
		return '<img src="'.$src.'" alt="'.$this->htmlDQuote($alt).'"'.$sup._c_Nd;	
	} // simplestImg
	
	function smpltImg($src,$sup=''){
		return '<img src="'.$src.'"'.$sup._c_Nd;	
	} // smpltImg
	
	
	/**
	*/
	function imageWh($src,$alt,$class,$width='',$height='',$stl=''){
		return $this->image($src,$alt,$class,'',$stl,'',$width,$height);
	} // imageWh
	
	/**
		$caps->transpImg(0,60);
	*/
	function transpImg($width='',$height=''){
		$src= _c_EditorImgPath.'stop/t.png';
		$alt='';
		$class='';
		return $this->imageWh($src,$alt,$class, $width,$height);
	} // transpImg
	
	/**
		Flexible (Linked) image function and familly below. Can also be used without any link!!
	*/
	function lnImg($imgDFn, $alt='', $ttl='', $cls='sImg', $jsEtc='', $url=false, $target='_top', $follow=_c_ok, $stl=false){
		if ($ttl===''){
			$ttl= $alt;
		}
		
		if ($stl){
			$estet= $this->matStyl($cls);
		}else{
			$estet= $this->matCss($cls);
		}
	
		$retImg= $this->simplestImg($imgDFn, $alt, $this->matTtl($ttl).$estet.$jsEtc);
		if ($url!==false){
			$attS= $this->matTtl($ttl);
			$attS.= $this->matCss($cls);
			$attS.= $this->matFollow($follow);
			$retImg= $this->hLink($url,$retImg,$attS,$target);
		}	
	
		return $retImg;
	} // lnImg

	function linkImg($imgDFn, $alt, $url=false, $cls='sImg', $target='_top', $follow=_c_ok){
		return $this->lnImg($imgDFn,$alt,$alt,$cls,'',$url,$target,$follow);
	} // linkImg

	function linkImgStl($imgDFn, $alt, $url=false, $stl=' margin-left:20px; border-style:none; text-decoration:none; cursor:pointer;',$target='_top',$follow=_c_ok){
		return $this->lnImg($imgDFn,$alt,$alt,$stl,'',$url,$target,$follow,true);
	} // linkImgStl
	
	/**
		More link flexible (easier for non-limked image).
		$stlSffx is especially usefull to specify and added width height etc. in addition of more shared image style
	*/
	function flexImgStl($imgDFn, $alt, $stlSfx='', $stl=' margin-right:10px; border-style:none; text-decoration:none;',$url=false,$target='_top',$follow=_c_ok){
		return $this->lnImg($imgDFn,$alt,$alt, $stl.$stlSfx, '',$url,$target,$follow,true);
	} // flexImgStl

	/* --
		End IMAGE TAG
	-------------------------------------------------------------------------------- */
	
	
	/**
	*/	
	function checkIfEqual($val1,$val2){
		if ($val1==$val2)
			return ' checked';
		else
			return '';
	} // checkIfEqual
	
	
	/**
		Checked box. Input :
			$wName
			$val1 : returned value
			$val2 --> if $val1 == $val2 then check
			$sup : supplementary parameters.
	*/
	function checkBox($wName,$val1=_c_ok,$val2='',$sup=''){
		return '<input id="'. $wName .'" name="'.$wName.'" type="checkbox" value="'.$val1.'"'.$this->checkIfEqual($val1,$val2).$sup._c_Nd;
	} // checkBox
	

	/**
		Radio Button. Input :
			$wName
			$val1 : value returned when the radio button is pressed
			$val2 : optional comparison value, if $val1 == $val2 then check the radio button !! only one checked button/group
	*/
	function radioBut($wName,$val1,$val2='',$sup=''){
		return '<input name="'. $wName . '" type="radio" value="' . $val1 . '"' . $this->checkIfEqual($val1,$val2).$sup._c_Nd;
	} // radioBut
	
	
	/**
		To be used in association with localFileBrowser() for a Php environment.
	*/
	function maxUploadSize($max='30000'){
		return $this->hiddenWdg('MAX_FILE_SIZE',$max);
	} // maxUploadSize
	
	
	/**
		A local file browser for uploads.
			 <input type="file" name="Datei" size="50" accept="text/*">
			 Example : $this->localFileBrowser($name,10);
	*/
	function localFileBrowser($name,$szDspl,$sup='',$accept=''){
		if ($accept!==''){
			$accept= ' accept="'.$accept.'"';
		}
		
		if ($szDspl!=='w'){
			$sup.= ' size="'.$szDspl.'"';
		}
		
		return '<input type="file" name="'. $name . '" id="'. $name .'" '.$sup.$accept._c_Nd;
	} // localFileBrowser
	
	
	/**
		A local file browser for uploads capable to impose a css-class ($cls) and its own label ($lbl not the browser default)
		Ref : "Styling file inputs is notoriously difficult ..."  https://stackoverflow.com/questions/572768/styling-an-input-type-file-button
	*/
	function cssFileBrowser($name,$cls='',$lbl='',$accept='',$sup=''){
		if ($accept!==''){
			$accept= ' accept="'.$accept.'"';
		}
		
		$buff= '';
		if ($cls!==''){
			$buff.= '<label for="'.$name.'" class="'.$cls.'">'._c_R;
			$buff.= $lbl._c_R;
			$buff.= '</label>'._c_R;			
		}
		
		return $buff.'<input type="file" name="'. $name . '" id="'. $name .'" '.$sup.$accept._c_Nd;
	} // cssFileBrowser
	

	/**
		Rem : parameters $name,$id,$style,$title left out for now
		((h) html prefix because the xml tag class is called iframe so conflict of methof & constructor).
		MicroFrame :
			$this->hIframe($src,10,10,'none');
	*/			
	function hIframe($src,$height='150',$scrolling='auto', $id='',
		$warning='', $frameborder=1, $marginheight=5, $marginwidth=5){			
				
		$glob= &$this->glob;	
		
		if ($height===_c_ko){
			$heightStr= '';
		}else{
			$heightStr= ' height="'.$height.'"';
		}
		
		if ($id!==''){
			$id= ' id="'.$id.'" name="'.$id.'"';
		}
		
		if ($warning===''){
			$warning= $glob->es('Your browser does not support iframes.','kmez');	// would appear if this string was not properly removed with JS
		}
		
		$curStyle= $this->matStyl('width:97%; padding-left:0.5%; margin-right:0.5%; margin-top:5px; margin-bottom:5px; border:1px solid black; padding:0px;');
		return '<iframe src="'.$src.'"'.$heightStr.' scrolling="'.$scrolling
			.'" '.$id.' frameborder="'.$frameborder.'" '.$curStyle
			.' >'.$warning.'</iframe>';
	} // hIframe


	/**
		Written through javascript so only written if JS is activated!
	*/
	function jsDocWrite($txt,$jsVar=false){
		$tools= &$this->tools;
		$body= $this->jsDocWr($txt);
		return $this->jsTag($body);
	} // jsDocWrite

	/**
	*/
	function jsDocWr($txt,$jsVar=false){
		$tools= &$this->tools;	
		if ($jsVar){
			return 'document.write('.$txt.');';
		}else{
			return 'document.write(\''.$tools->bsOneQ($txt).'\');';
		}
	} // jsDocWr
	
	
	/**
		Passes a Php vector into a javascript vector.
			input :
				$vect : given vector
				$jsVN : given name of the javascript vector.
			Output :
				return the javascript expression.
	*/
	function loadsJsVect($vect,$jsVN, $objName=''){
		$sz= sizeof($vect);
		
		if ($objName===''){
			$b= 'var '.$jsVN.'= new Array('.$sz.');'._c_R;
		}else{
			$b= $objName.$jsVN.'= new Array('.$sz.');'._c_R;
		}
		
		reset($vect);
		foreach ($vect as $k=>$val){
			$b.= $objName.$jsVN.'['.$k.']=\''.$val.'\';'._c_R;
		}
		return $b;
	} // loadsJsVect
	

	/* ---------------------------------------------------------------------------------------------
		Building strings for javascript calls to avoid too complicated php-js-strings hand writîngs 
		like : ' onclick="fuName(\''.$p1.'\',\''.$p2.'\',\''.$p3.'\');" '
	*/

	/**
	*/
	function formatJsVarOrConst(&$v,$i,$nbVar){
		$tools= &$this->tools;
	
		if ($i<$nbVar){
			return $v[$i];	// variable case
		}else{
			$s= $tools->bsOneQ($v[$i]);
			return '\''.$s.'\'';	// constant case
		}
	} // formatJsVarOrConst
	
		
	/**
		A function to create a Javascript function calling string, such as :
			onclick="chgSamePgImg('param1','param2');" 
		Input :
			$event : name of the event ex : onclick.
			$fuName : JS function name.
			$nbParam : total number of used parameters (variables and constants from left to right up to the total number of formal parameter)
			$nbVar : number of javascript variables (always coming 1st and $nbVar<=$nbParam ).
			$ai : parameters variables : needs to be recognised as a JS variable, so no quotes arround it.
						  or constants : needs to have quotes arround it.
			
		$caps->jsFunctCallStr($event,$fuName,$nbParam,$nbVar,$a0);
		
		Rem : mainly 'onclick' event everywhere, so could swap $event and $fuName to have a default 'onclick' event.
	*/
	function jsOnclickFuCallStr($fuName,$nbParam=0,$nbVar=0,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7='',$a8='',$a9='',$a10='',$a11=''){
		return $this->jsFunctCallStr('onclick',$fuName,$nbParam,$nbVar,$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11);
	} // jsOnclickFuCallStr
	
	function jsFunctCallStr($event,$fuName,$nbParam=0,$nbVar=0,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7='',$a8='',$a9='',$a10='',$a11=''){
		$tools= &$this->tools;
	
		if ($nbParam>0){
			$v= $tools->pactToRay($nbParam,$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11);
			
			$pmStr= '';	// parameters string
			for($i=0;$i<$nbParam-1;$i++){
				$pmStr.= $this->formatJsVarOrConst($v,$i,$nbVar).',';
			}

			$pmStr.= $this->formatJsVarOrConst($v,$nbParam-1,$nbVar);
		}else{
			$pmStr= '';
		}
		
		$pmStr= '('.$pmStr.')';
		if ($event===''){
			return $fuName.$pmStr;				
		}else{
			return ' '.$event.'="'.$fuName.$pmStr.'"';		
		}
	} // jsFunctCallStr
	
	/**
		For simple function calls within included event.
	*/
	function jsSimpleFu($fuName,$nbParam=0,$nbVar=0,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7='',$a8='',$a9='',$a10='',$a11=''){
		if ($fuName!==false){
			return $this->jsFunctCallStr('',$fuName,$nbParam,$nbVar,$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$a10,$a11);
		}else{
			return '';
		}
	} // jsSimpleFu
	
	/* 
		End Building strings for javascript calls.
	--------------------------------------------------------------------------------------------- */


	/**
		For vertical alignement, simulates an html cell table with style sheet.
		Idea from http://www.w3.org/Style/Examples/007/center
		
		Input :
			$str : main string to center vertivcally
			$cssH : other styles applied to the inside cell
			
		Remark : the two inner div must stay quite unchanged or high risk to interfer with the vertical alignment
	*/
	function simTCellSml($str, $cssHz){
		return $this->div( $this->div($this->div($str,'cllSimShort'),'tblSim'), $cssHz );
	} // simTCell
		
	function simTCellLrg($str, $cssHz){
		return $this->div( $this->div($this->div($str,'cllSimTall'),'tblSim'), $cssHz );
	} // simTCellLrg
		
	function simTCellXL($str, $cssHz){
		return $this->div( $this->div($this->div($str,'cllSimXL'),'tblSim'), $cssHz );
	} // simTCellXL
		
			
	/**
		Just used once in smallVT.php .......  could find another way.
	*/
	function oneTblCell($str,$align='center',$valign="top"){
		$b='<table style="width: 0%;" border="0" cellpadding="0" cellspacing="0">';
		$b.='<tbody><tr><td align="'.$align.'" valign="'.$valign.'"">';
		$b.=$str;
		$b.='</td></tr></tbody>';
		$b.='</table>';
		return $b;
	} // oneTblCell
	
	
	/**
	*/
	function tblTag($content,$sup=''){
		$b='<table ' . $sup . '><tbody>';
		$b.=$content;
		$b.='</tbody></table>';
		return $b;
	} // tblTag
		
	function tblHeadTag($sup=''){
		return '<table ' . $sup . '><tbody>'._c_R;
	} // tblHeadTag
		
	function tblEndTag(){
		return '</tbody></table>'._c_R;
	} // tblEndTag
		
		
	/**
	*/
	function tblTr($x,$sup=''){
		return '<tr '.$sup.'>'.$x.'</tr>';
	} // tblTr

	/**
	*/
	function tblTd($x,$sup=''){
		return '<td '.$sup.'>'.$x.'</td>';
	} // tblTr

	/**
	*/
	function trTd($x,$supTd='',$supTr=''){
		return $this->tblTr( $this->tblTd($x,$supTd), $supTr );
	} // trTd


	/**
	*/
	function chgEditLanguage($font='nL'){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$ar[_c_edtLang]= true;
		$curUrl= $tools->urlCurPg($ar);
		$curUrl.= $tools->reprodUrlVar(_c_pwLogBoxReqst);
		$curUrl.= $tools->reprodUrlVar(_c_tedTblChunkId);
		
		$upv1= $tools->urlPathVar(1);
		$curUrl.= $tools->reprodUrlVar($upv1);
		$upv2= $tools->urlPathVar(2);
		$curUrl.= $tools->reprodUrlVar($upv2);
		
		$defLg= $glob->edtLg();
		$js= $this->jsFunctCallStr('onChange','genAsa.changeEdtLanguage', 3,0, 'chgEditLg',$curUrl,_c_edtLang);
		
		$ttl= $this->matTtl($glob->el('To choose the Editor language','kadc'));
		return $this->comboBox( 'chgEditLg', $defLg, $glob->mainTransLgVect, $this->matCss($font).$js.$ttl);
	} // chgEditLanguage

	
	/**
		Input :
			$url : given url
			$alt, $imgName
	*/
	function drawGenButton($url, $alt, $imgName,$css='eImgMargin'){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$rMg= &$this->rMg;
	
		$imgEdt=_c_ok;
		$pg=false;
		
		if ($imgEdt===_c_ok){
			$imgPath= $fls->editorImage($imgName);
		}else{
			$imgPath= _c_mainImgDfn.$imgName;
		}
		$img= $this->imageWh($imgPath,$alt,'topBarImgIcon');
		return $this->linkTC($url,$img,$alt,$css);
	} // drawGenButton
	
	
	/**
		Build and return the javascript independant complete code of a javascript "class" 
		to do whatever would be useful with that code. 
	*/
	function jsClassCode($jsClsNm,$jsFuNm,$jsData,$jsParam=''){
		$fuChab= '
		function ersatzClassNm(){
			this.ersatzFuNm= ersatzFuNm;	
			function ersatzFuNm(ersatzParam){ersatzData}
		}'; // $fuChab
		
		// substitute in less invasive order
		$fuChab= str_replace('ersatzClassNm',$jsClsNm,$fuChab);
		$fuChab= str_replace('ersatzFuNm',$jsFuNm,$fuChab);
		$fuChab= str_replace('ersatzParam',$jsParam,$fuChab);
		$fuChab= str_replace('ersatzData',$jsData,$fuChab);
		
		return $fuChab;
	} // jsClassCode
	

} // capsHtml
?>