<?php
/**
	File name : captcha.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



*/
class captcha extends oTop{
	

	function __construct(&$tagsFu,$capTN){
		parent::__construct();
		
		$this->shrdCd= &$tagsFu->shrdCd;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->hPwC= &$tagsFu->hPwC;
		$this->dtb= &$tagsFu->dtb;
		
		$this->globCaptchTblNm= $capTN;		// the captcha table name
		
		if (!defined('_c_CaptchaId')){
			define('_c_CaptchaId',_c_genId);
			define('_c_CaptchaQuest','quest');
			define('_c_CaptchaAnsw','answ');
		
		
			define('_c_captHidIdNm','captHidIdNm');
			define('_c_captchaTxtNm','captchaTxtNm');
		}
	} // construct


	/**
		Return a random record field (in practical cases a random captcha Id)
			Input :
				$tblN : the name of the captcha table.
				$field : the field we have to return the random value
			Output :
				$chosenId : the randomly chosen id
	*/
	function rndRecordField(&$chosenId,$tblN,$field){
		$dtb= &$this->dtb;
		
		$nbRows= $dtb->countNbRows($tblN);
		$chosenId= mt_rand (0,$nbRows-1);
		return $dtb->getElem($tblN, _c_CaptchaId,$chosenId,$field);
	} // rndRecordField
	

	/**
		To return a random captcha question.
			Input :
				$tblName : the name of the captcha table
			Output :
				$chosenCaptchaId : literally.
				returns thes text of the captcha question.
	*/
	function captchaQuest(&$chosenCaptchaId,$tblName){
		$captchQuestion= $this->rndRecordField($chosenCaptchaId, $tblName, _c_CaptchaQuest);
		$this->curCaptchaId= $chosenCaptchaId;		
		return $captchQuestion;
	} // captchaQuest
		
	
	/**
		To manage simple complete captcha with hash.
		--> Partly deprecated method using the general associated class $shrdCd->assoc (ok for forum,
		but should not use it anywhere else) .
		Input :
			$ctx : context (exmpl : userId)
			$subCtx : sub context (exmpl : mailBetwUsrCaptcha)
	*/
	function completeCaptcha($ctx,$subCtx,$captHidIdNm=_c_captHidIdNm,$captHidHashNm=_c_captHidHashNm,
			$captTxtNm=_c_captchaTxtNm,$captFont='fCaptcha',$captTxtBoxFt='fumUsrMgStd'){
			
		$shrdCd= &$this->shrdCd;
		$caps= &$this->caps;
		$hPwC= &$this->hPwC;
		$assoc= &$shrdCd->assoc;	// associative table class : genAssoc.php
		
		$buff= '';
		$captchaTxt= $this->captchaQuest($captId,$this->globCaptchTblNm)._c_R;
		
		$buff.= $caps->span($captchaTxt,$captFont);
		$buff.= $caps->	textBx($captTxtNm,'','10',$captTxtBoxFt);
		
		// Got to generate $curHash
		$curHash= $hPwC->newHashStr(20);
		$assocIdx= $assoc->store($ctx,$subCtx,$curHash,$captId);	// stores the hash !!
		
		$buff.= $caps->hiddenWdg($captHidIdNm,$assocIdx)._c_R;
		$buff.= $caps->hiddenWdg($captHidHashNm,$curHash)._c_R;
		return $buff;
	} // completeCaptcha
	

} // captcha
?>