<?php
/**
	File name : xbCrypt.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Multi-byte encryption to be called inside hashPwCrypt.php 
*/
class xbCrypt extends oTop{
	

	function __construct(&$asa){
		parent::__construct();
		$this->mbCrypt= &$asa->mbCrypt;
	} // construct


	/**
		Multi-byte encryption.
		Input :
			$mbStr : a multi byte string to crypt, in fact any string protocol that can be directly split into bytes
			$crptK : the given crypting key, (format : as above any string that can be split into bytes) with substr() or $crptK[index]
		Output :
			return an hexadecimal crypted string.
	*/
	function xbCrpt($mbStr,$crptK,$sortOfInt='def'){
		$mbCrypt= &$this->mbCrypt;
		
		$hxInfo= $mbCrypt->utfStrToHexStr($mbStr);
		$hxKey= $mbCrypt->utfStrToHexStr($crptK);
		return $mbCrypt->cryptHxToHx($hxInfo,$hxKey, $sortOfInt);
	} // xbCrpt	
	

	/**
		Multi-byte decyphering.:
		Input :
			$mbStr : a hexadecimal string to decipher (ascii and parent or utf-8) eg : 'af12dce45', internally transformed
				into a real hexadecimal string.
			$crptK : the given crypting key, (format : utf-8 etc]
		Output :
			return a utf-8 readable string..
	*/
	function xbUnCrpt($hxInfo,$crptK,$sortOfInt='def'){
		$mbCrypt= &$this->mbCrypt;
		$hxKey= $mbCrypt->utfStrToHexStr($crptK);
	    $hxResult= $mbCrypt->cryptHxToHx($hxInfo,$hxKey, $sortOfInt);
	    return $mbCrypt->hexStrToUtfStr($hxResult);
	} // xbUnCrpt
		
} // xbCrypt
?>