<?php
/**
	File name : edtPlusTools.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	A class to store tools used on the editing side as well as on other complex process intensice side 
	like forum processing!
*/
class edtPlusTools extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
	} // construct


	/**
		Expand the xPetal code of the page _forumBar or use a proxy depending on the context write 
		loading javascript instructions to get an expand or an expand proxy of the page _forumBar. 
		
	*/
	function forumBarExpOrProxy(){
		$tagsFu= &$this->tagsFu;
		$asa= &$tagsFu->asa;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$forumBar= &$asa->forumBar;
		
		$jsChunkDFn= _c_pathAutoCode.'forumBarMData.js'; // !! Main Data associated to the page '_forumBar'
		$isTheForumBar= $this->isForumRelatedBar();
		if ( $fls->fileExist($jsChunkDFn) && !$isTheForumBar){
			// Can use the file directly because it exists and we are likely to change it
			$glob->addJsFile($jsChunkDFn);
			$glob->setHeadGlobJsCd('localStorage.fumStyleInsrtTags= forumBarMData.fuBarMData();'._c_nL);
			$glob->setHeadGlobJsCd('var forumBarMData= new forumBarMData();'._c_nL);
		}else{
			$tmpCode= $tagsFu->includeRec('_forumBar');	// expand the page xpetal code
			$tmpCode.= $forumBar->areaSetFumBar(_c_taMainStNm,'edtGallDivNm');	// add the display JS button
			$tmpCode= $tools->jsStorageStr($tmpCode,'Z');
			$glob->setGlobJsCode('localStorage.fumStyleInsrtTags="'.$tmpCode.'";'); // General Memo of XPetal Bars
			
			// Create or change the chunky file
			$jsData= 'return \''.$tmpCode.'\';';
			$jsFlData= $caps->jsClassCode('forumBarMData','fuBarMData',$jsData);
			$fls->strngStrToFile($jsChunkDFn,$jsFlData);
		}
	} // forumBarExpOrProxy
	
	/**
		Adapted from forumBarExpOrProxy() to the need of a non webmaster user (lambda users)
	*/
	function lambdaFBarOrProxy(){
		$tagsFu= &$this->tagsFu;
		$asa= &$tagsFu->asa;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$forumBar= &$asa->forumBar;
		
		$tagsFu->usingLambdaFBar= true;
		$jsChunkDFn= _c_pathAutoCode.'lambdaFumBar.js'; // !! Main Data associated to the page '_forumBar'
		$isTheForumBar= $this->isForumRelatedBar();
		if ( $fls->fileExist($jsChunkDFn) && !$isTheForumBar){
			// Can use the file directly because it exists and we are likely to change it
			$glob->addJsFile($jsChunkDFn);
			$glob->setHeadGlobJsCd('localStorage.lambdaForumBar= lambdaFumBar.lambdaFBar();'._c_nL);
			$glob->setHeadGlobJsCd('var lambdaFumBar= new lambdaFumBar();'._c_nL);
		}else{
			$tmpCode= $tagsFu->includeRec('_forumBar');	// expand the page xpetal code
			
			$tmpCode= $tools->jsStorageStr($tmpCode,'Z');
			$glob->setGlobJsCode('localStorage.lambdaForumBar="'.$tmpCode.'";'); // Memo of the lamdba bar
			
			// Create or change the chunky file
			$jsData= 'return \''.$tmpCode.'\';';
			$jsFlData= $caps->jsClassCode('lambdaFumBar','lambdaFBar',$jsData);
			$fls->strngStrToFile($jsChunkDFn,$jsFlData);
		}
		$tagsFu->usingLambdaFBar= false;
	} // lambdaFBarOrProxy
	
	
	
	
	
	
	

	/**
		Expand the xPetal code of the page _forumBar or use a proxy depending on the context write 
		loading javascript instructions to get an expand or an expand proxy of the page _insert-tags. 
	*/
	function insTagsExpOrProxy(){
		$tagsFu= &$this->tagsFu;
		$asa= &$tagsFu->asa;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$forumBar= &$asa->forumBar;
		
		$jsChunkDFn= _c_pathAutoCode.'forumBarData.js';	// !! Associated to the page '_insert-tags'
		$isTheInsertBar= $this->isForumRelatedBar();
		if ( $fls->fileExist($jsChunkDFn) && !$isTheInsertBar ){
			// Can use the file directly because it exists and we are not changing it
			$glob->addJsFile($jsChunkDFn);
			$glob->setHeadGlobJsCd('localStorage.origStyleInsrtTags= forumBarData.fuBarData();'._c_nL);
			$glob->setHeadGlobJsCd('var forumBarData= new forumBarData();'._c_nL);
		}else{
			$tmpCode= $tagsFu->includeRec('_insert-tags');	// expand the page xpetal code
			$tmpCode= $tools->jsStorageStr($tmpCode,'Z');
			$glob->setGlobJsCode('localStorage.origStyleInsrtTags="'.$tmpCode.'";');
			
			// Create or change the chunky file
			$jsData= 'return \''.$tmpCode.'\';';
			$jsFlData= $caps->jsClassCode('forumBarData','fuBarData',$jsData);
			$fls->strngStrToFile($jsChunkDFn,$jsFlData);
		}
	} // insTagsExpOrProxy
	
	/**
	*/
	function isForumRelatedBar(){
		$tools= &$this->tools;
		
		$cPN= $tools->curPageName();
		$isTheForumBar= $cPN==='_forumBar';
		$isTheInsertBar= $cPN==='_insert-tags';
		return $isTheForumBar || $isTheInsertBar;
	} // isForumRelatedBar
	
} // edtPlusTools
?>