<?php
/**
	File name : email.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	General eMail functions
	
	email::sendEMail()
*/
class email extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;	// access many html methods
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
	} // construct


	/**
	*/
	function buildHeader($titleFrom,$emailFrom){
		$headers= '';
		// $headers= 'MIME-Version: 1.0' . _c_rNl;
		$headers.= 'Content-type: text/html; charset=UTF-8' . _c_rNl;
		// $headers.= 'To: '.$emailTo._c_rNl; // If added explicitely combined with 1st param of mail() and deliver the mail twice!
		$headers.= 'From: '.$titleFrom.' <'.$emailFrom.'>' . _c_rNl;
		return $headers;
	} // buildHeader
	
	function trivialHeader($titleFrom,$emailFrom){
		return 'From: '.$titleFrom.' <'.$emailFrom.'>' . _c_rNl;
	} // trivialHeader
	
	


	/**
		Truncate if $str greater than $maxSz (bytes)
	*/
	function truncateAboveMaxSz(&$str,$maxSz){
		$sz= strlen($str);
		if ($sz>$maxSz){
			$str= substr($str, 0,$maxSz);
		}
		return $str;
	} // truncateAboveMaxSz
		

	/**
		Send an emai to the client (non webmaster) and to the web master
	*/
	function toClientAndWebmaster(&$formMainWdgt){
		$tools= &$this->tools;	

		$okForClient= $tools->postVal(_c_fmwSendMailChkBoxNm);
		if ($okForClient!==false){
			$clientAddr= $tools->postVal(_c_fmwMailClientAddr);
			$this->sendFmwEMail($formMainWdgt, $clientAddr);
		}
		
		$webMastAddr= $formMainWdgt->webmasterEMail;
		if ($tools->sIsInB(',',$webMastAddr)){
			// we got a list of email .. to send separatly
			$wmV= $tools->trimStrToV($webMastAddr);
			reset($wmV);
			foreach ($wmV as $key=>$curMailAddr){
				$this->sendFmwEMail($formMainWdgt, $curMailAddr);
			}
		}else{
			$this->sendFmwEMail($formMainWdgt, $webMastAddr);
		}
	} // toClientAndWebmaster


	/**
		Send an email from a normalised html form harmonised with the class formMainWdgt.php (Fmw)
	*/
	function sendFmwEMail(&$formMainWdgt,$emailTo){
		$tools= &$this->tools;
		$fls= &$this->fls;
	
		$mailSubject= $fls->domainName().' : '.$tools->postVal(_c_fmwMailSubject);
		$titleFrom= $tools->postVal($formMainWdgt->MailTitleFrom);
		
		$emailFrom= $tools->postVal(_c_fmwMailClientAddr); // avoid auto-referencing emails && allows direct answer
		$this->sendEMail($emailTo,$mailSubject,$formMainWdgt->sentWdgtStr, $titleFrom,$emailFrom);
	} // sendFmwEMail
	
	
	
	

	/**
		Send an e-mail holding all the given parameters and manage the display of the information sent.
		Input :
			$emailTo : the destination mail address
			$origMailSubject ; the standard mail subject
			$mailBody : the mail body
			$titleFrom : title from the from par of the mail.
			$emailFrom : email from, so in most case the admin e-mail.
	*/
	function sendEMail($emailTo,$origMailSubject,$mailBody, $titleFrom,$emailFrom){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		$mFormat= $dtb->getGenVar('kindOfMailFormat');
		
		$maxBdSz= $dtb->getGenVar('eMailMaxBodySz');
		$maxSfSz= $dtb->getGenVar('eMailMaxSmallFieldSz');

		/**
			Caution to avoid default of service through huge data
		*/
		$this->truncateAboveMaxSz($mailBody,$maxBdSz);
		$this->truncateAboveMaxSz($emailTo,$maxSfSz);
		$this->truncateAboveMaxSz($origMailSubject,$maxSfSz);
		$this->truncateAboveMaxSz($titleFrom,$maxSfSz);
		$this->truncateAboveMaxSz($emailFrom,$maxSfSz);
		
		$ssPath= $glob->codeCssPath('formMainWdgt',false);
		
		// rem ; formpManager.php has a primitive way of doing that!
		$smos= $dtb->getGenVar('saveMailsOnServer')===_c_ok;
		if ($smos){
			$dfn= _c_UsrMailStorPath.$fls->rndTmStamp().'.htm';
	
			$b= '';
			$b.= $glob->el('Date and time : ','kayg').$fls->dateAtom()._c_;
			$b.= $glob->el('From : ','kayh')._c_lt.$emailFrom._c_gt._c_;		// instead of buildHeader ($titleFrom,$emailFrom)
			$b.= $glob->el('Mailed to : ','kayi').$emailTo._c_;
			$b.= $glob->el('Subject : ','kayj').$origMailSubject._c_._c_;
			$b.= $mailBody;
			
			$b= $caps->div($b,'eMailDivFrame');
			
			$b= $caps->minInternalFormat($b,$ssPath);
			$fls->strToFile($dfn,$b);
		}
		
		if ( $dtb->getGenVar('reallySendEMails')===_c_ok ){
			$headers= $this->buildHeader($titleFrom,$emailFrom);			
			$mailSubject='=?UTF-8?B?'.base64_encode($origMailSubject).'?=';	// otherwise smtp complains about the subject !!
			$mailBody= $caps->div($mailBody,'eMailDivFrame');	// some mailer need a full reset to reload a style sheet!
			$finalMailBody= $caps->minInternalFormat($mailBody,$ssPath);	// html formating just for the smtp part!
			return mail($emailTo, $mailSubject, $finalMailBody, $headers);
		}
	} // sendEMail

} // email
?>
