<?php
/**
	File name : hallOfFame.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	A class to conserve interesting methods that are NOT USED ANYMORE but could be usefull again.
*/
class hallOfFame extends oTop{
	

	function __construct(){
		parent::__construct();
	} // construct


	/**
		Return a string kernel along the following parameters.
		Input :
			$str : the string to extract a kernel from.
			$agregPos : the agregation starting position and taking alternatively form left and right. If a side is
				off limit, keep going only with the side within limits.
			$kernelSz : the size of the desired kernel
			
		Algo : 	<<<< agregate from $agregPos >>>>
	*/
	function strKernel($str,$agregPos,$kernelSz){
		$strSz= strlen($str);
		$kern= $str[$agregPos];	// kern central character
		$left= true;
		
		$l= $agregPos-1;
		$r= $agregPos+1;
		for ($i=0;$i<$kernelSz;$i++){
			if ($left){
				if ($l>0){
					$kern= $str[$l].$kern;
				}
				$l--;
			}else{
				if ($r<$strSz){
					$kern= $kern.$str[$r];
				}
				$r++;
			}			
		
			if($l>0 || $r<$strSz){
				// still got something to grind
				if ($l<0){
					$left= false;	// force the grinder on the right
				}else if ($r>=$strSz){
					$left= true;	// force the grinder on the left
				}else{
					$left= !$left;	// alternate grinded sides
				}
			}else{
				// nothing left to grind a limit case that should not happend (means entry limits are too soft)
				break;
			}
		} // for
	
		return $kern;
	} // strKernel

} // hallOfFame
?>
