<?php
/**
	File name : hashPwCrypt.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	hashPwCrypt.php (Hash Password Crypt & Decipher).
	
	All the necessary elements for password and the server hash.encryption
		
	- hpcu : Secure enough (up to the existing technology) interaction for most users :
	- hpcu1 & hpcu2 : code marker in the rightsMg class.

		Client <-----------[hash1]	------- Serveur				// hpcu1
			(1) On client side : Calculates : c2PwCook= hashI*cpw and send it to the server.
			(2) The server does the same with its cpw version and the last hash.
			(3) The edition connection is established when c2PwCook from the client
			matches the c2PwCook from the server using a stored non travelling cpw.
				
				
			Then :
				On the client side c2PwCook (session secret encrypting key) is 
						stored inside a JS cookie :		_c_c2PwCook === 'c2PwCook'
				On the server side c2PwCook is 
						stored inside the topHashTbl	_c_topHashC2Pw === 'c2pw'
			
			

		Client [c3PwCook= hash1*c2PwCook] ------>	Serveur		// hpcu2
		Client <-----------[hash2]	------- Serveur				// hpcu1
		Client [c3PwCook= hash2*c2PwCook] -->	Serveur			// ... 2
		Client <-----------[hash3]	------- Serveur				// ... 1
		Client [c3PwCook= hash3*c2PwCook] -->	Serveur			// ... 2
		................................						// ....
		Client <-----------[hashI]	------- Serveur				// ... 1
		Client [c3PwCook= hashI*c2PwCook] -->	Serveur			// hpcu2
		etc ...

		Communication :
			# <-hpcu1-- Standard way to send [hashI] to the client : embed a javascrit value in Js tags :
				<script type="text/javascript"> document.onload( ... ) </script>
			# --hpcu2-> Standard way to return a crypt to the server : load a local JS cookie with :
				<script type="text/javascript"> document.onload( createCookie(name,value,days) ) </script> 
			Other : 1st cookie storage c2PwCook : JS onclick on password form button.


		Definitions :
			x * y : x is crypted by y To uncrypt :
				knowing : x*y & x ---> y obtained by brute force
				knowing : x*y & y ---> x obtained by reversing the crypt.
			cpw : autocrypted password (just held in ram at loggin time, a copy of it exists permanently on the server, until
				the user changes its password)
			c2PwCook : hash1*cpw (a cookie js-stored for the whole session, original password is CRYPTED TWICE, by itself so can
			compare with the server stored password + with the 1st hash so can be stored locally as a cookie without
			fearing a later un-enrcyption), and used to generate all the following cookies.

			c3PwCook : hashI*c2PwCook (c3PwCook used each time for right checking after the 1st logged in), could call it
			rightCook, because it's the only crypted cookie used to check the logged state. Crypting should be only oneway algo,
			otherwise from

				Client <-----------[hashI]	------- Serveur
				Client [c3PwCook= chashI*c2PwCook] -->	Serveur


		Caution : hashI and c3PwCook can just be captured, then nothing because shift-crypting-operations 
		are not commutative (check!), even so will obtain c2PwCook*c2PwCook that does not gives ways into knowing c2PwCook
		
		As more safety mesures :
			- Introduce one way only crypting (2 ways very useful for checking purpose.), for example using
			  a greater char table to pick the chars of the crypt with possible overlapping (two original char
			  may end up with the same corresponding crypt, along the same idea two different clear could 
			  theorically have the same crypt, making reversal inpossible because of many solutions).
			- Introduce a variable crypting algorithm, depending on one more variable, could
			  have millions more algoes, and chosing the algo could just depend on a JS cookie variable,
			  that does not travel on the network, but is just used on the spot (synchronization
			  server -- user memory just done once).
			
			
		More Agreable to use :
			- some browsers (Firefox + ?, not Opera), have a back button history for cookies too, therefore
			bringing back to the server a c3PwCook that is not valid anymore, here are the possible solutions :
				- Use a browser that don't mess with cookies (easy because it's just in edition and not for general users).
				- Don't use the back button (could be disactivated for non complient browsers).
				- Instead of getting the hash with each page, the JS could ask the hash before asking another page or sending a form,
				--->	- a general onclick(... asking a new hash )
						- ... calling actual createsC3Pw(...)
						- don't want to send a hash when loading the page.
				Can implement that at any stage, so wait until undispensable stages are done !!!!!!
				
			
		Configuration for optimum http / httpS usage :
			- http used in surf only mode :
				- The http directory holds all the php-cms files.
			- https used everytime a user is logged (because the logging state is memorised with a local cookie,
				testing the real surf mode without unlogging imply to force it explicitelly, eg : with another cookie,
				but without forgetting the logged-cookie to allow fast switching in the same browser.).
				- The httpS directory just holds an index.php file calling the index.pho of the http directory through
				the http://localhost/~user/index.php which imply a noncrypted but local on server communication! 
				This is actually a weakness as security goes, because the server could be sniffed internally by
				an intruder. The other way arround is more secure because of direct https, but slowing down unnecessarilly
				the network transactions for stabdard http, it follows from that that the more secure and efficient
				implementation is to duplicate the CMS in http and https, a duplication that could also be used 
				as a local backup. Otherwise reconfiguration of .htaccess or some other init file could be possible but
				imply some more expertise (possibly also on the b user) as it's another subdivision of data processing.

*/
class hashPwCrypt extends oTop{
	

	function __construct(&$asa){
		parent::__construct();	
		$this->mbCrypt= &$asa->mbCrypt;	// more direct
		$this->xbCrp= &$asa->xbCrp;
		
		/**
			Consonnance and numbers for random generation strings to avoid unlucky apparition of rude words,	*/
		$this->zArrCons= array(
		'C','j','k','l','m','T','V','W','X','B','3','h','r','2','Z','p','q',
		'G','H','N','0','1','9','F','P','J','K','L','M','n','Q','R','S','D', 
		'b','c','d','f','g','4','8','s','t','6','7','v','w','5','x','z');
		$this->zLnArrCons= sizeof($this->zArrCons);
		
		// Pure consons
		$this->zArrC= array(
		'C','j','k','l','m','T','V','W','X','B','h','r','Z','p','q',
		'G','H','N','F','P','J','K','L','M','n','Q','R','S','D', 
		'b','c','d','f','g','s','t','v','w','x','z');
		$this->zLnArrC= sizeof($this->zArrC);
	} // construct
	
	
	function doCrypt($str,$crptK,$sortOfInt='def'){
		$xbCrp= &$this->xbCrp;
		return $xbCrp->xbCrpt($str,$crptK,$sortOfInt);
	} // doCrypt
	
	
	function doUnCrypt($str,$crptK,$sortOfInt='def'){
		$xbCrp= &$this->xbCrp;
		return $xbCrp->xbUnCrpt($str,$crptK,$sortOfInt);
	} // doUnCrypt
	
		
	/*
		Creates a new random hash using only the chars $this->zArr. $hashPwCrypt->newHashStr($hSz);
			Input:
				$hSz : hash size.
	*/
	function newHashStr($hSz){
		return $this->consonStr($hSz);
	} // newHashStr

	/**
		Generates a consonances string with numbers! $sz
	*/
	function consonStr($sz){
		$hash='';
		for($i=0;$i<$sz;$i++){
			$idx= rand(0,$this->zLnArrCons-1);
			$hash.= $this->zArrCons[$idx];
		}
		return $hash;
	} // consonStr
	
	/**
		Generates a PURE consonances string.
	*/
	function consStr($sz){
		$hash='';
		for($i=0;$i<$sz;$i++){
			$idx= rand(0,$this->zLnArrC-1);
			$hash.= $this->zArrC[$idx];
		}
		return $hash;
	} // consStr
	
	
	/*
		Not dedicated to hashes, but placed here for convenience. Crypting into hexadecimal  
		with storage resilience and speed in mind (prime goal search engines obfuscation).
	*/
	
	
	/**
		To be used in synergy with genAsa.doMbUnCrpt()
	*/
	function doMbCrpt($str,$crptK){
		$mbCrypt= &$this->mbCrypt;
		return $mbCrypt->mbCrpt($str,$crptK);
	} // doMbCrpt

	
	/**
		To be used in synergy with genAsa.hexDecode()
	*/
	function utf8to16toHx($str){
		$mbCrypt= &$this->mbCrypt;
		return $mbCrypt->utf8to16toHx($str);
	} // utf8to16toHx

	


} // hashPwCrypt
?>