<?php
/**
	File name : recoveryActions.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To recover in one click without password if the migration from 100% php to MySql fails
*/
class recoveryActions extends oTop{
	

	function __construct(&$asa){
		parent::__construct();
		
		$this->glob= &$asa->glob;
		$this->tools= &$asa->tools;	
		$this->acc= &$asa->acc;			
		$this->caps= &$asa->caps;	
		$this->fls= &$asa->fls;	
		
		if ($glob->cndtWrRghts===_c_unspecified){
			$glob->cndtWrRghts===true;
		}
	} // construct


	/**
		_c_recovDtbMigrFail
	*/
	function go(){
		$caps= &$this->caps;
		$tools= &$this->tools;

		$action= $tools->getVal(_c_recoveryActions);

		$b= '';
		switch ($action){
			// Call : ?krnlRecovAction=badMySqlMigration
			case 'badMySqlMigration':
				$this->recoverFromBadMySqlMigration();
				$b.= '';
				$b.= $caps->span('The site was retrograded to its previous state')._c_;
				$b.= ''._c_;
				$b.= $caps->span('Le site a été rétrogradé à l\'état précédant')._c_;
				$b.= ''._c_;
				$b.= $caps->hLink(_c_IndexFN,'Please click here to view the site / Merci de cliquer ici pour visionner le site');
				$b.= _c_;
				$b.= _c_;
			break;
			
			default:;
		} // switch
		
		return $caps->formatAll($b);
	} // go
	

	/**
		To recover a bad MySql Migration action
	*/
	function recoverFromBadMySqlMigration(){
		$fls= &$this->fls;

		$bufferNctDtbDfn= _c_phpChooseDtb.'cstDtbNectBuffer.php';
		$bufferChooseDtbDFN= _c_phpChooseDtb.'aboveDtbBuffer.php';
		if ( !$fls->fileExist($bufferNctDtbDfn) || !$fls->fileExist($bufferChooseDtbDFN) ){
			return false;
		}
		
		$hourPluCurTm= 3600 + time();
		$fTmA= filemtime($bufferNctDtbDfn);
		$fTmB= filemtime($bufferChooseDtbDFN);
		if ($fTmA>$hourPluCurTm || $fTmB>$hourPluCurTm){
			return false;	// too late fopr automatical modification
		}
		
		
		
		$targetNctDtbDfn= _c_phpChooseDtb.'cstDtbNect.php';
		$gStr= $fls->fileToStr($bufferNctDtbDfn);
		$fls->strongStrToFile($targetNctDtbDfn,$gStr);
		$fls->secUnlink($bufferNctDtbDfn);


		$targetChooseDtbDFN= _c_chooseDtbDFN;
		$gStr= $fls->fileToStr($bufferChooseDtbDFN);
		$fls->strongStrToFile($targetChooseDtbDFN,$gStr);
		$fls->secUnlink($bufferChooseDtbDFN);
	} // recoverFromBadMySqlMigration

} // recoveryActions
?>
