<?php
/**
	File name : specArray.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Special array functions that are quite rarely used, so a special class to save some room inside tools.php
	that already has many array functions.
*/
class specArray extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();
		
		$this->tools= &$tagsFu->tools;
	} // construct




	/**
		Returns an array with $n random elements of $v.
	*/
	function nElemOfV($v,$n){
		$this->rndMixArray($v);
		return array_slice($v,0,$n);
	} // nElemOfV
	


	/**
		Mix an array randomly! Useful to randomly pop easilly stricly different elements
		Input :
			$v : the array
			$n : the number of random values exchange
			
		$this->rndMixArray($v);
	*/
	function rndMixArray(&$v,$n=false){
		$sz= count($v);
		if ($n===false){
			if ($n<50){
				$n= $sz*10;
			}else{
				$n= $sz*5;
			}
		}
		
		for ($i=0; $i<$n; $i++){
			$pos1= rand(0,$sz-1);
			$incr= rand(1,$sz-2);
			$pos2= $this->incrCirc(0,$sz-1,$pos1,$incr);
		
			$buff= $v[$pos1];
			$v[$pos1]= $v[$pos2];
			$v[$pos2]= $buff;
		} // for
	} // rndMixArray
	
	
	/**
		Does a circular incrementation of $incr from $pos on a given integer space 
		$min --- $max (inclusive) and returns the chosen index.
	*/
	function incrCirc($min,$max,$pos,$incr){
		$i= 0;
		do{	
			$newPos= $pos+$incr;
			if ($newPos>$max){
				$offset= $newPos-$max;
				$newPos= $min+$offset-1;	// -1 so if offset===1 is just on $min
			}
			$i++;
		}while ( ($newPos<$min || $newPos>$max) && $i<10 );
		
		if ($i===10){
			return $max;
		}else{
			return $newPos;
		}
	} // incrCirc

	
	/**
		Return a vector of length $sz to pick randomly inside a given range.
			Input :
				$sz : size of the vector.
				$rangeMax : superior range of the vector.element
	*/
	function rangeRndVector($sz,$rangeMax,$rangeMin=1){
		for ($i=0; $i<$sz; $i++){
			$v[$i]= rand($rangeMin,$rangeMax);
		} // for
		return $v;
	} // rangeRndVector


	/**
	*/
	function arrToNLinesStr($v,$N=2){
		$sz= count($v);
		$cntCell= 0;
		$nbCell= (int)floor($sz/$N);	// nb of cells on a line
		$buff= '';
		reset($v);
		foreach ($v as $key=>$val){
			if ($cntCell<$nbCell){
				$cntCell++;
			}else{
				$buff.= _c_R;
				$cntCell= 0;
			}
			
			$buff.= $val.' ';
		}
		return $buff;
	} // arrToNLinesStr


	/**
		Transform a numeric ordinal vector into a litteral ordinal vector.
	*/
	function ordNumToLitV($v){
		$tools= &$this->tools;
		
		$b= '';
		reset($v);
		foreach ($v as $key=>$nb){
			switch ( $tools->curLgOnce() ){
				case 'fr':
					$b.= $this->nbToFrOrdinal($nb).' ';
				break;
				
				case 'en':
				default:
					$b.= $this->nbToEnOrdinal($nb).' ';
				break;
			} // switch
		}
		
		return $b;
	} // ordNumToLitV


	/**
		May relocate the ordinal functions!
	*/

	/**
		Transform a one digit non null number into an english ordinal litterate representation.
	*/
	function nbToEnOrdinal($nb){
	
		switch ($nb){
			case 1:
				$s= 'First';
			break;
			
			case 2:
				$s= 'Second';
			break;
			
			case 3:
				$s= 'Third';
			break;
			
			case 4:
				$s= 'Fourth';
			break;
			
			case 5:
				$s= 'Fifth';
			break;
			
			case 6:
				$s= 'Sixth';
			break;
			
			case 7:
				$s= 'Seventh';
			break;
			
			case 8:
				$s= 'Eighth';
			break;
			
			case 9:
				$s= 'Ninth';
			break;
			
			default:
				$s= 'tooBig';
		} // switch
	
		return $s;
	} // nbToEnOrdinal

	/**
		Transform a one digit non null number into an english ordinal litterate representation.
	*/
	function nbToFrOrdinal($nb){
	
		switch ($nb){
			case 1:
				$s= 'Premier';
			break;
			
			case 2:
				$s= 'Deuxième';
			break;
			
			case 3:
				$s= 'Troisième';
			break;
			
			case 4:
				$s= 'Quatrième';
			break;
			
			case 5:
				$s= 'Cinquième';
			break;
			
			case 6:
				$s= 'Sixième';
			break;
			
			case 7:
				$s= 'Septième';
			break;
			
			case 8:
				$s= 'Huitième';
			break;
			
			case 9:
				$s= 'Neuvième';
			break;
			
			default:
				$s= 'tooBig';
		} // switch
	
		return $s;
	} // nbToFrOrdinal
	
	
	


	/**
	*/
	function chabl(){
	} // chabl

} // specArray
?>
