/**
	File name : tinyXorShift.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/*
	Adapted from https://gist.github.com/ne-sachirou/852327
*/
function strXorShift(){
	
	var x= 0; var y= 0; var z= 0; var w= 0;
	
	this.init= init;
	this.next= next;

	/**
		For real random, each paramneter can be initialised with for exmpl :
			Math.floor(1000000000*Math.random())
			
		For crypting problems, each paramneter can be initialised with a numerisation of the password
	*/
	function init(a,b,c,d){
		x= a; y= b; z= c; w= d;		
	} // init

	/**
		Returns the next step.
	*/
	function next(){	
		var r = x;
		var s = w;
		var t = r ^ (r << 11);
	  	x= y; y= z; z= w;	
		return w = (s ^ (s >> 19)) ^ (t ^ (t >> 8));
	} // next
} // strXorShift
