/**
	File name : xorShift.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/*
	Adapted from https://gist.github.com/ne-sachirou/852327
*/
function xorShift(){
	
	var x= 0;
	var y= 0;
	var z= 0;
	var w= 0;
	
	
	/* ---------------------------------------------------------
		Public Methods 
	*/	
	this.init= init;
	this.smplNxtScaled= smplNxtScaled;
	
	
	/* ---------------------------------------------------------
		Body Methods 
	*/	
		 
	/**
		For real random, each paramneter can be initialised with for exmpl :
			Math.floor(1000000000*Math.random())
			
		For crypting problems, each paramneter can be initialised with a numerisation of the password
	*/
	function init(a,b,c,d){
		x= a; y= b; z= c; w= d;		
	} // init

	/**
		Return the next scaled number
		Input :
			scale : magnitude of the demanded random number
	*/
	function smplNxtScaled(scale){
		var nb= nextCore();
		return nb % scale;
	} // smplNxtScaled
	
	/**
		Input :
			v ; large binary vector of 128 bits.
		Output :
			Loads the 4 global shift registries.
	*/
	function iniwBigBin(v){
		x= v.slice(0,31);
		y= v.slice(32,63);
		z= v.slice(64,95);
		w= v.slice(96,127);
	} // iniwBigBin
			
			
	/**
		Returns the next step.
	*/
	function nextCore(){	
		var r = x;
		var s = w;
		var t = r ^ (r << 11);
				
	  	x= y; y= z; z= w;	
		return w = (s ^ (s >> 19)) ^ (t ^ (t >> 8));
	} // next
	



	/* ---------------------------------------------------------------------
	*/

		
	/**
		Return a binary vector of size sz. Especially useful for xoring strings.
		Remark : could go by chunk of 32 bits instead of one by one !!!
	*/
	function binaryVect(sz){
		var vect= new Array();
		for (var i=0; i<sz; i++){
			vect[i]= smplNxtScaled(2);
		}
		return vect;
	} // binaryVect



	function write(s){kk.write(s);}
	function writeLn(s){kk.writeLn(s);}
		
		
	/**
	*/
	function chablon(){
	
	} // chablon


} // xorShift
