<?php
/**
	File name : addHeaderJS.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Adds the javascript text or file (*1) given between the [addjs ...] tags to the header or end 
	(or almost the end! A better title for this class would have been addJsTo an html file extremities) of the htmlfile concerned by the squarred brackets addition, so its a good way
	to try abstractfunctions given almost everywhere as examples.
	(*1) in the case of files, it extracts the file content, so just a cleaner way to use not so short programs.

	Example :
	
	[cenPlugin name="addHeaderJS" /]
	[addJsFromFile dfn="virtualTryOn/jsSuplem.js" /]
*/
class addHeaderJS extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
																
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('addHeaderJS',false,false);
		
		
		$tagsFu->attribVect['addheadjsfromfile']= array('dfn');
		$tagsFu->attribVect['addheadjsfrombd']= false;
		
		$tagsFu->attribVect['addtailjsfromfile']= array('dfn');
		$tagsFu->attribVect['addtailjsfrombd']= false;
		
		$tagsFu->attribVect['addjsfromhomefile']= array('dfn');
	} // construct


	/**
	*/
	function tags(){
		return array('addheadjsfromfile','addheadjsfrombd', 'addtailjsfromfile','addtailjsfrombd', 'addjsfromhomefile');
	} // tags

	
		
	/**
		Adds the javascript from the folder of an explicit/external/ plugin
		the local path being defined from there!
		
		[addHeadJsFromFile dfn="virtualTryOn/jsSuplem.js" /]
			... example used in 1st trials!
	*/
	function tg_addheadjsfromfile(&$v,&$bd){
		$glob= &$this->glob;
		$fls= &$this->fls;
		
		$fullDFN= _c_toDeclPlugExt.$v['dfn'];
		$jsAddition= $fls->fileToStr($fullDFN);
		$glob->setHeadGlobJsCd($jsAddition);
	} // addheadjsfromfile
	
		
	/**
		Adds the head javascript from $bd.
	*/
	function tg_addheadjsfrombd(&$v,&$bd){
		$glob= &$this->glob;
		$glob->setHeadGlobJsCd($bd);
	} // tg_addheadjsfrombd

	
	
	/**
		[addTailJsFromFile dfn="virtualTryOn/jsSuplem.js" /]
			... example used in 1st trials!
	*/
	function tg_addtailjsfromfile(&$v,&$bd){
		$glob= &$this->glob;
		$fls= &$this->fls;
		
		$fullDFN= _c_toDeclPlugExt.$v['dfn'];
		$jsAddition= $fls->fileToStr($fullDFN);		
		$glob->setGlbEndJsCode($jsAddition);
	} // addtailjsfromfile
				
	
	/**
		Adds the tail javascript from $bd.
	*/
	function tg_addtailjsfrombd(&$v,&$bd){
		$glob= &$this->glob;
		$glob->setGlbEndJsCode($bd);
	} // tg_addtailjsfrombd

	
	
	
	/**
		[addTailJsFile dfn="virtualTryOn/polyDrag.js" /]
			... example used in 1st trials!
	function tg_addtailjsfile(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		$fullDFN= _c_toDeclPlugExt.$v['dfn'];
		$caps->script($fullDFN)
		
		$glob->setGlbEndJsCode($jsAddition);
	} // addtailjsfile
	*/
	
	
	
	
	/**
		Adds a javascript file from the user home directory
		the local path being defined from there!
	*/
	function tg_addjsfromhomefile(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		// please propose some code
	
	} // tg_addJsFromHomeFile
	
	
	
	

		
	/**
	*/
	function tmp(){
	} // tmp
		
} // addHeaderJS
?>