<?php
/**
	File name : admTools.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[cenPlugin name="admTools" /]					[_ r="PLUGIN DECLARATION"/]
	
	admin / admTools / topAdmin : could examine some merging.
*/
class admTools extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->hPwC= &$tagsFu->hPwC;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->parser= &$tagsFu->parser;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('admTools','debugDisplay',false);	
		$tagsFu->attribVect['dsplunixtime']= false;
		$tagsFu->attribVect['dsplxmsqrfile']= false;
		$tagsFu->attribVect['randomstr']= false;
	} // construct


	/**
	*/
	function tags(){
		return array('dsplunixtime','dsplxmsqrfile','randomstr');
	} // tags
	
	
	/**
		[dsplUnixTime /]
	*/
	function tg_dsplunixtime(&$v,&$bd){
		$caps= &$this->caps;
		
		$actualTm= time();
		$yesterdayTm= $actualTm-3600*24;
		$lastYearTm= $actualTm-3600*24*365;
		
		
		$buff= $caps->span(_c_._c_.'Actual Unix date in seconds : ', 'adminBoldFont');
		$buff.= $caps->span($actualTm._c_, 'adminUTmFont');
		
		$buff.= $caps->span(_c_.'Yesterday Unix date in seconds : ', 'adminBoldFont');
		$buff.= $caps->span($yesterdayTm._c_, 'adminUTmFont');
		
		$buff.= $caps->span(_c_.'Last year Unix date in seconds : ', 'adminBoldFont');
		$buff.= $caps->span($lastYearTm._c_, 'adminUTmFont');
		
		return $buff;
	} // tg_dsplunixtime
	
		
	/**
		Used inside the page _displayXmSqrFile to do just that!
		[dsplXmSqrFile /]
	*/
	function tg_dsplxmsqrfile(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$parser= &$this->parser;
	
		$xmDfn= $tools->getVal(_c_dsplXmSqrFlNm);
		if ($xmDfn!==false){
			$xmStr= $fls->fileToStr($xmDfn);
			$curBdy= $parser->addrParseStdStr($xmStr);
			return $curBdy;
		}else{
			return $caps->span($glob->el('Error:','katw').' '._c_dsplXmSqrFlNm.' '.$glob->el('must be passed with the Url ...','kmhj'),'userError');
		}
	} // tg_dsplxmsqrfile

	
	/**
		[jsPhpCryptCompatible str="Hello 人女 !!" key="tra人ala" /]
	*/
	function tg_jsphpcryptcompatible(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$crypt= &$this->crypt;
		
		$buff= '';
		$clickMe= $glob->el('Please click here to display the encryption','kazj');
		
		$wdgtId= 'jsPhpCrCpt';
		$congratStr= $glob->el('Congratulation your browser','kazh');;
		$sorryStr= $glob->el('Sorry incompatibilities have been detected','kazi');
		$infoStr= $v['str'];
		$keyStr= $v['key'];
		$phpHxCrypt= $crypt->mbCrpt($infoStr,$keyStr);
		
		
		$js= $caps->jsFunctCallStr('onclick','tstMbCrypt.jsPhpCryptCompatible',6,0, $wdgtId,$congratStr,$sorryStr,$infoStr,$keyStr,$phpHxCrypt);
		
		$buff.= $caps->span($clickMe,'ln','',$wdgtId,'',$js);
		return $buff;
	} // tg_jsphpcryptcompatible
	
	
	/**
		[randomstr /] Generate a random string for cms visualisation testing as part of forcing lazy browsers to completly load a page
	*/
	function tg_randomstr(&$v,&$bd){
		$hPwC= &$this->hPwC;
		
		$buff= '';
		for ($i=0; $i<160; $i++){
			$buff.= $hPwC->consonStr( rand(2,10) ).' ';
		}
		return $buff;
	} // tg_randomstr

	
		
} // admTools
?>
