<?php
/**
	File name : bkp.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Tags in charge of backuping the database (standard back-ups on different datas).
*/
class bkp extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$tools= &$tagsFu->tools;
		$this->tools= &$tools;
		$this->acc= &$tagsFu->acc;
		$this->hPwC= &$tagsFu->hPwC;
		
		$this->fls= &$tagsFu->fls;
		$fls= &$this->fls;
		
		$this->dtb= &$tagsFu->dtb;
		$this->parser= &$tagsFu->parser;
		$this->editTools= &$tagsFu->editTools;
		
		define('_c_zCmsTestArchPath', _c_zCms.'testArchives/');
					
		/* -----------------------------------------------------------------
			Calls :
				Initialisation before calling the 1st tag ;
					[setExplPlugin path="bkp/" name="bkp" /]
					
				[backup /]
		*/
		$tagsFu->attribVect['backup']= array('maxfilesz','rmdircpy');
		$tagsFu->attribVect['testdirarch']= false;
		
		$safeUrlStamp= substr($fls->safIdStr(_c_siteUrlStample),0,10);
		define('_c_safeUrlStamp', $safeUrlStamp);
		
		
		// $this->archChgPwFiles= $fls->archChgPwFiles;
	} // construct


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('backup','testdirarch');
	} // tags

	
	/**
		[backup /]
	*/
	function tg_backup(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		$mess= '';
		
		if (!$fls->fileExist(_c_archiveDirPathNS)){
			$fls->makeDir(_c_archiveDirPathNS);
		}
		
		$this->archChgPwFiles= $fls->setArchChgPwFiles();
		
				
		/*	
			Just got to calls :
				localDB::wholeDtbStr($dbName,$tblForbVN=false,$colForbVN=false)
				
			As a trigger uses url parameter : &fullDtbArch=ok
		*/	
		$anyZipFN= false;
		$fullDtbArch= $tools->getVal('fullDtbArch');
		$projectArch= $tools->getVal('projectArch');
		$codeArch= $tools->getVal('codeArch');
		$globalArch= $tools->getVal('globalArch');
		
		$maxFileSz= $v['maxfilesz'];
		$rmDirCpy= $tools->binLoads($v['rmdircpy'],_c_ok);

		
		if ($glob->cndtWrRghts===false){
			if ($fullDtbArch===_c_ok || $projectArch===_c_ok || $codeArch===_c_ok || $globalArch===_c_ok){
				if ($fullDtbArch===_c_ok){$action='fullDtbArch';};
				if ($projectArch===_c_ok){$action='projectArch';};
				if ($codeArch===_c_ok){$action='codeArch';};
				if ($globalArch===_c_ok){$action='globalArch';};
				$curMess= $glob->el('A simplified view of an archive action', 'kazs');
				$glob->setGuestDisplay($action,$curMess);
			}
			return '';
		}
		
		$tmStamp= _c_UsrDbName.'-'.$fls->timeStamp();
		// Simple data base
		if (!$this->archChgPwFiles){
			if ($fullDtbArch===_c_ok || $globalArch===_c_ok){
				// tables forbidden to save
				$tblForbVN= array(_c_mainCacheTbl,_c_RecCircTbl,_c_RecDataTbl);
				
				// For a given table : columns forbidden to save
				$colForbVN[0]= _c_UsersTbl;	// stored at any unused numerical index
				$colForbVN[_c_UsersTbl]= array(_c_cPwServer,_c_recDataFreeId);	// other recov data wont have any relevance!!
				
				$wDtbStr= $dtb->wholeDtbStr(_c_UsrDbName,$tblForbVN,$colForbVN);	// whole Dtb Str !!!
				$smplFn= 'dtb'.$tmStamp;
				$fn= _c_archiveDirPath.$smplFn.'.sql';
							
				$headers= $fls->fileToStr(_c_sqlHeadersFile);
				$fls->strToFile($fn, $headers.$wDtbStr);
				$stripedSz= strlen(_c_archiveDirPath);


				$locDtbZipFN= _c_safeUrlStamp.$smplFn.'.zip';
				$anyLocZip= $locDtbZipFN;
				$curDtbZipFN= _c_archiveDirPath.$locDtbZipFN;
				$anyZipFN= $curDtbZipFN;
				
				$fls->smplArchCreation($fn,  $curDtbZipFN,  $stripedSz, false);
				if ($fls->fileExist($curDtbZipFN)){
					$fls->chgMode($curDtbZipFN);
				}else{
					$mess.= $glob->el('Error archiving the database itself!','kmgf')._c_;
				}
				
				if ($rmDirCpy===_c_ok){
					$fls->unLnk($fn);
				}
			}
		}
		
		
		// Just directories
		if ($projectArch===_c_ok || $globalArch===_c_ok){
			$smplFn= _c_safeUrlStamp.'dir'.$tmStamp;
			$stripedSz= strlen(_c_nsUsrDataPath);
			$locDirZipFN= $smplFn.'.zip';
			$anyLocZip= $locDirZipFN;
			$curDirZipFN= _c_archiveDirPath.$locDirZipFN;
			$anyZipFN= $curDirZipFN;
			
			$fls->smplArchCreation(_c_nsUsrDataPath,  $curDirZipFN,  $stripedSz, $maxFileSz);
			if ($fls->fileExist($curDirZipFN)){
				$fls->chgMode($curDirZipFN);
			}else{
				$mess.= $glob->el('Error archiving the main data directory!','kmgg')._c_;
			}
		}
		
		// just the code		
		if ($codeArch===_c_ok || $globalArch===_c_ok){
			$smplFn= _c_safeUrlStamp.'code'.$tmStamp;
			
			$nsCodePath= $fls->removeLastChar(_c_CodePath);	// non slash code path
			$stripedSz= strlen($nsCodePath);
			
			$locCodeZipFN= $smplFn.'.zip';
			$anyLocZip= $locCodeZipFN;
			$curCodeZipFN= _c_archiveDirPath.$locCodeZipFN;
			$anyZipFN= $curCodeZipFN;
			$fls->smplArchCreation($nsCodePath, $curCodeZipFN, $stripedSz, $maxFileSz);
			if ($fls->fileExist($curCodeZipFN)){
				$fls->chgMode($curCodeZipFN);
			}else{
				$mess.= $glob->el('Error archiving the code directory!','kmgh')._c_;
			}
		}
		
		// Everythings
		if ($globalArch===_c_ok){
			$fls->copyDirectories( $fls->rmLC(_c_cpyMnAsapDirs), $fls->rmLC(_c_archiveDirPath) );
			
			// Replace the general index (general because usefull for the builder where the main directory name need to be changed)
			$mainArchIndexDfn= _c_archiveDirPath._c_fullAsapBkp._c_IndexFN;
			if (file_exists($mainArchIndexDfn)){
				$fls->unLnk($mainArchIndexDfn);
			}
			
			$fls->copyFile(_c_IndexDFN,$mainArchIndexDfn);
			// add the current directory name of the archive project
			$projPathDir= _c_archiveDirPthPlus.'projects';
			if (file_exists($projPathDir)){
				// Conventional compatibility : Adds a dont delete flag-file so the index can starts directly when clicking on it for verification.
				$dDelDfn= $projPathDir.'/doNotDelete.txt';
				$fls->strToFile($dDelDfn,'dontDelete');
			}else{
				$mess.= $glob->el('Warning ','kmgi').'$projPathDir : '.$projPathDir.$glob->el(' does not exist!','kmgj')._c_;
			}
			
			$projDataPathDir= $projPathDir.'/'._c_userDataDirName;
			$fls->wMkDir($projDataPathDir);
			if (!file_exists($projDataPathDir)){
				$mess.= $glob->el('Warning','kmgi').'$projDataPathDir : '.$projDataPathDir.$glob->el(' does not exist!','kmgj')._c_;
			}
			
			
			if (!$this->archChgPwFiles){
				$sqlBkpPathDir= _c_archiveDirPthPlus.'sqlBkp';
				if (!file_exists($sqlBkpPathDir)){
					$mess.= $glob->el('Warning','kmgi').'$sqlBkpPathDir : '.$sqlBkpPathDir.$glob->el(' does not exist!','kmgj')._c_;
				}
				
				$targetSqlFN= $sqlBkpPathDir.'/'.$locDtbZipFN;
				if (file_exists($curDtbZipFN)){
					rename($curDtbZipFN, $targetSqlFN);
				}else{
					$mess.= $glob->el('Warning','kmgi').'$sqlBkpPathDir : '.$curDtbZipFN.$glob->el(' does not exist!','kmgj')._c_;
				}
			}
			
			
			$targetProjFN= $projDataPathDir.'/'.$locDirZipFN;
			if (file_exists($curDirZipFN)){
				rename($curDirZipFN, $targetProjFN);
			}else{
				$mess.= $glob->el('Warning','kmgi').'$curDirZipFN : '.$curDirZipFN.$glob->el(' does not exist!','kmgj')._c_;
			}
			
			$archCodeDir= _c_archiveDirPthPlus.'code';
			if (!file_exists($archCodeDir)){
				$mess.= $glob->el('Warning','kmgi').'$archCodeDir : '.$archCodeDir.$glob->el(' does not exist!','kmgj')._c_;
			}
			
			$targetCodeFN=  $archCodeDir.'/'.$locCodeZipFN;			
			if (file_exists($curCodeZipFN)){
				rename($curCodeZipFN, $targetCodeFN);
			}else{
				$mess.= $glob->el('Warning','kmgi').'$curCodeZipFN : '.$curCodeZipFN.$glob->el(' does not exist!','kmgj')._c_;
			}
				
			// Archive the whole things
			$anyLocZip= _c_safeUrlStamp.$tmStamp.'.zip';	// a simpler form for the whole archive name
			$totalArchiveZipFN= _c_archiveDirPath.$anyLocZip;
			$fullBkpDFN= _c_archiveDirPath._c_fullAsapBkpNS;
			
			/*
				Important note : the php zipper seems to be more flexible than zip executables of some Linux distribution,
				 eg : Impossible with Linux::Arch to unzip an archive if $stripedSz is set on the full length of $fullBkpDFN.
				Shortening the trim [$stripedSz] by LEAVING ON THE INSIDEST DIRECTORY [ with splitOnLastC() or $stripedSz] 
				solves the problem.
			*/
			$stripedSz= strlen(_c_archiveDirPath)-1;
			
			
			$anyZipFN= $totalArchiveZipFN;
			$fls->smplArchCreation($fullBkpDFN, $totalArchiveZipFN, $stripedSz);			
			if ($fls->fileExist($totalArchiveZipFN)){
				$fls->chgMode($totalArchiveZipFN);
			}else{
				$mess.= $glob->el('Error archiving the whole site and incorporating sub-archives!','kmgk')._c_;
			}
			
			
			if ($rmDirCpy===_c_ok){
				$fls->lRmoveDir($fullBkpDFN);
			}
		}
	
		$url= $tools->urlGivenPage('_file-manager');
		$url.= $tools->addUrlVar(_c_mFilePathPrfx.'1',_c_archiveDirPath);
		$url.= $tools->addUrlVar(_c_mFilePathPrfx.'2',_c_archiveDirPath);
		$mess.= _c_._c_;	
		$mess.= $caps->linkC($url, $glob->el('Click here for a global view...','kazp'),'nL');
		$mess.= _c_._c_;	
	
		if ($anyZipFN!==false){
			// proposes the file for download
			$mess.= $caps->linkC($anyZipFN,
					$glob->el('Please download the current archive ','kazq').$anyLocZip.
					$glob->el(' on your local computer.','kazr')._c_._c_, 'nL');
		}
		
		return $mess;		
	} // tg_backup
	
		
	/**
		Test the directory archiving capabilities!
		[testDirArch /]
	*/
	function tg_testdirarch(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;

		$buff= '';
		$zip = new ZipArchive();	// #
		$fileToZip= _c_zCmsTestArchPath.'fileToZip.txt';
		
		if (!$fls->fileExist($fileToZip)){
			$buff= $fileToZip.' : '.$glob->el('this file to test archiving capabilities does not exists!','kmja');
			return $buff;
		}
		
		$destination= _c_zCmsTestArchPath.'oneFileArc.zip';
				
		if ($fls->fileExist($destination)){
			$fls->chgMode($destination);
			unlink($destination);
			if ($fls->fileExist($destination)){
				$buff.= $glob->el('Warning, we were not able to delete the file ','kmgl').$destination.$glob->el(' so we can\'t perform a test of directory archiving capabilities!','kmgm');
				return $buff;
			}
		}
		
		$res= $zip->open($destination, ZipArchive::CREATE);	// #
		$buff.= $this->catchArchError($res,'open');
		
		$res= $zip->addFile($fileToZip);	// #
		$buff.= $this->catchArchError($res,'addFile');
		
		$res= $zip->close();	// #
		$buff.= $this->catchArchError($res,'close');

		if ($fls->fileExist($destination)){
			$fls->chgMode($destination);
			unlink($destination);
			return ''; // the file was created nothing to add, Testing : 'The archive test on a directory is ok'._c_
		}else{
				$buff.= '$destination='.$destination._c_;
				$buff.= $glob->el('Warning, we were not able to archive a single directory','kbaw');				
				$buff= $caps->sDiv($buff._c_._c_,'width:800px; border: 0px solid black; margin-left:60px; color: red;');
		}

		return $buff;
	} // tg_testdirarch


	function catchArchError($res,$callStr){
		if ($res!==true){
			if ($res===false){
				return $callStr.'=false'._c_;
			}else{
				return $callStr.' error code'.$res._c_;
			}
		}else{
			return $callStr.' is OK'._c_;
		}
	} // catchArchError
	
} // bkp
?>
