<?php
/**
	File name : cntrXRight.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Central X (xpetal) rights for Webmasters!
	[cenPlugin name="cntrXRight" /]					[_ r="PLUGIN DECLARATION"/]
*/
class cntrXRight extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;	// access to some global values, sometimes methods.
		$this->caps= &$tagsFu->caps;	// access many html methods.
		$this->tools= &$tagsFu->tools;	// many small npractical methods.
		$this->fls= &$tagsFu->fls;		// different file access.
		$this->dtb= &$tagsFu->dtb;		// many abstracted database methods
		$this->rMg= &$tagsFu->rMg;
		$this->parser= &$tagsFu->parser;
		
		/**
			Computes a given flag status for a registered webmaster. 
			---> central x rights or webmaster x rights.			
			suFrill : 	small super user security priviledges (especially touching anything and removing some sucurity :
						strong delete, changing file and directories anywhere) ( _prefix etc.).
						Was created to recover the many little function used by : rightsMg::suRights()
						
			genvarAllowCat ; set the concerned allowed categories inside the genVar  table,
			
			Warning : allowbuildb is dangerous and need to be manipulated only by specialists, because it allows to change the data base with a single click! Only use to pass from Sql to 100% Php, if one is not defined the website wil not work anymore!
				--> used in topBarTags::switchDtb() with buildButtAccept()
		*/
		$tagsFu->attribVect['cxrights']= array('sufrill','techaccess','ulnaccess','genvarallowcat','undotwo','chgrights','allowedtbl',
			'allowed','forbidspecid','forbidpaths','compulspaths','prgmertools','allowbuildb','erroreportmax','wysiwygon','forbidpage');
		
		$tagsFu->attribVect['wmfilter']= array('filter');
		
		
		$this->forbPathV= false;
		$this->isInGlobForbList= array();
	} // construct

	/**
	*/
	function tags(){
		return array('cxrights','wmfilter');
	} // tags

	/**
		A tag to define the webmaster rights. Default -- no rights
	*/
	function tg_cxrights(&$v,&$bd){
		$glob= &$this->glob;
		// Just loads the current flag vector for later access through incode probing of current webmaster rights.
		$glob->webmasterXRights= $v;	// Could be more logical to store it here as $this->webmasterXRights ?
	} // tg_cxrights

		
	/**
		A tag surrounding some information and allowing only the one matching the given condition --> A web master filter depending on their rights !
	*/
	function tg_wmfilter(&$v,&$bd){
		$caps= &$this->caps;
		
		$filter= $v['filter'];
		if ($this->genFlag($filter)){
			return $bd;		// allowed
		}else{
			return '';		// a bit wastefull because $bd was still computed, but very practical for bunch of tags we ahven't any time to reprogram internally
		}
	} // tg_wmfilter
	

	/**
		Central User Rights : Set and Gives the central webmaster user rights vector. --> 
		Scans the string to apply the tag [cXRights /]
	*/
	function cntrUsrXRghtV(){
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
		$rMg= &$this->rMg;
			
		if ($glob->webmasterXRights===false){
			$usrId= $rMg->realTimeUserId();
			if ($usrId!==_c_ko){
				$xRight= $dtb->getElem(_c_UsersTbl, _c_userId,$usrId, _c_usrXmlRight);
				$parser->addrParseStdStr($xRight,$usrId);	// Loads $glob->webmasterXRights VECTOR of rights!
			}
		}
		return $glob->webmasterXRights;
	} // cntrUsrXRghtV
	

	/**
		Computes a given flag status!.
		Input :
			$flag : the concerned attribute.
	*/
	function genFlag($flag){
		// return true;	// to get out of a rights denial following an eventual programming mistake!
		$v= $this->cntrUsrXRghtV();
		if ($v===false){
			return false;
		}else{
			if (isset($v[$flag])){
				return $v[$flag]===_c_ok;
			}else{
				return false;
			}
		}
	} // genFlag
	
	/**
		When the real flag is necessary, so in most case can return : false, ok, ko.
	*/
	function realFlag($flag){
		$v= $this->cntrUsrXRghtV();
		if ($v===false){
			return false;
		}else{
			if (isset($v[$flag])){
				return $v[$flag];
			}else{
				return false;
			}
		}
	} // realFlag
	
	
	/**
		If set to ok --> adds some information / buttons necessary for the core programmers, 
		especially to produce zipped packages.
	*/
	function wmSuFrill(){
		return $this->genFlag('sufrill');
	} // wmSuFrill

	/**
		If set to ok --> allows technical access, for now :
			- Displays the code bookmarks of the file manager.
			- Following programation could avoid access with explicit file browser too!
	*/
	function wmTechAcess(){
		return $this->genFlag('techaccess');
	} // wmTechAcess

	/**
		Underlined page named access= ok  ... allows the visualization of underline prefixed pages.
	*/
	function wmUlnPgXess(){
		return $this->genFlag('ulnaccess');
	} // wmUlnPgXess
	
	
	
	/**
		So programmers can see all errors and lambda installers are spared form their own errors generating
		php interpretor blob but treated internally in a more user friendly way.
	*/
	function erroReportMax(){
		return $this->genFlag('erroreportmax');
	} // erroReportMax
	

	/**
		Return true if the builder buttons are accepted! This is especially valid for th edatabase switcher!
	*/
	function buildButtAccept(){
		return $this->genFlag('allowbuildb');
	} // buildButtAccept
	
	function accptPrgmerTools(){
		return $this->genFlag('prgmertools');
	} // accptPrgmerTools
	

	/**
		True if we use the second set of undo redo tables.
	*/
	function wmUndoTwo(){
		return $this->genFlag('undotwo');
	} // wmUndoTwo


	/**
		To determine the right to change the rights!
		For absolute rights rights see  $glob->cndtWrRghts (most secure option for guest users)
	*/
	function wmChgRights(){
		return $this->genFlag('chgrights');
	} // wmChgRights


	/**
		To set the default wysiwyg state at starting time, should be overloaded by the genvar variable.
	*/
	function wmWysiwygOn(){
		return $this->realFlag('wysiwygon');
	} // wmWysiwygOn


	/**
		Extract the specified vector.
	*/
	function extractSpecVect($specV){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$alCats= $glob->webmasterXRights[$specV];
		if ($alCats===false){
			return false;
		}
		return $tools->trimStrToVect(',',$alCats);
	} // extractSpecVect	


	/**
		The attribute genVarAllowCat set the concerned allowed categories inside the genVar  table,
		Just creates the array of allowed attributes to be displayed.
		Connected too :  [cXRights  ....  genVarAllowCat=.....categX, categX etc " /]		
	*/
	function allowedCategVect(){
		return $this->extractSpecVect('genvarallowcat');
	} // allowedCategVect	


	/**
		To return a vector of allowed database tables for a given user.
		Warning permissive strategy : if the allowedtbl parameter is not defined we return false abd that means tha all tables are allowed !!
	*/
	function allowedTblVect(){
		return $this->extractSpecVect('allowedtbl');
	} // allowedTblVect
	
	
	/**
		Always allowed table :  return true if the given table name belong to the general allowed table vectir
		and isn't the category picky genVar table, and false otherwise!
	*/
	function alwyAllowedTbl($tNm){
		if ($tNm===_c_GenVarTbl){
			return false;
		}
		$v= $this->allowedTblVect();
		return in_array($tNm,$v);
	} // alwyAllowedTbl
	
	
	/**
		Return true if the page $pgNm is forbidden to the currently logged user. Uses forbidpage.
	*/
	function forbiddenPage($pgNm){
		$v= $this->extractSpecVect('forbidpage');
		if ($v===false){
			return false;
		}
		
		return in_array($pgNm,$v);
	} // forbiddenPage


	/**
		To forbid specific table Ids! Creates a double indexed array to quickly access the forbidden id
		Example of input : forbidspecid="usersTbl:root, genVar:formAdminEmail, pwBoxRequest, pwRequestVal, tblEdtDefTblName_, forbiddenUserId, allowNoPassWordMode, nPwModeUVar, nPwModeUVal"
		Rem :	- if the concerned table is not specified the last one is used!
				- Ids finishing by "_" are considered not allowed substrings of Ids for the whole table
				
		Input :
			$concernedTbl : the only table we need to worry about (the displayed table)
	*/
	function forbidSpecTblId($concernedTbl){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$fbSpecIds= $glob->webmasterXRights['forbidspecid'];
		$fbIdsVect= $tools->trimStrToV($fbSpecIds,',');
		if ($fbIdsVect!==false){
			$concernedIdVect= array();
			reset($fbIdsVect);
			foreach ($fbIdsVect as $key=>$tblAndId){
				// $tblAndId === table:id     but the table may not be there, therefore taking the last one.
				$gotIt= $fls->splitOnLastC($tblAndId,$curTbl,$forbId,':');
				if ($gotIt){
					$prevTbl= $curTbl;
				}else{
					$curTbl= $prevTbl;
					$forbId= $tblAndId;
				}
				
				if ($curTbl===$concernedTbl){
					$concernedIdVect[]= $forbId;
				}
			}
			return $concernedIdVect;
		}else{
			return array();
		}
	} // forbidSpecTblId
	

	/**
		To set a list of forbidden paths.
	*/
	function forbiddenPaths(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$forbP= $glob->webmasterXRights['forbidpaths'];
		if ($forbP===false){
			return false;
		}
		return $tools->trimStrToVect(',',$forbP);
	} // forbiddenPaths

	
	
	/**
		Screen the given path in case a forbidden bit of strings would appear and access should be denied!
		--> return true if we got an offending path and false otherwise
		
		Input :
			$givPath : the partial given path given from the index position
	*/
	function isAForbidPath($givPath){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
	
		if ($this->forbiddenPaths()===false){
			return false;	// not a single forbidden path defined. FULL ACCESS (don't need to have an acceleration vector)
		}
	
		if ($this->forbPathV===false){
			$this->forbPathV= $this->forbiddenPaths();	// single loadings
		}
		
		if (array_key_exists($givPath,$this->isInGlobForbList)){
			return $this->isInGlobForbList[$givPath];		// ARRAY extraction (already calculated)
		}
		
		$result= false;
		reset($this->forbPathV);
		reset($this->forbPathV);
		foreach ($this->forbPathV as $key=>$fbPath){
			if ($tools->sIsPrefixB(_c_constPfx,$fbPath)){
				$fPth= constant($fbPath);
			}else{
				$fPth= $fbPath;
			}

			$this->addSlash($givPath);
			if ($tools->sIsInB($fPth,$givPath)){
				$result= true; // got it the path is forbidden
			}
		}	// foreach
		
		
		$this->isInGlobForbList[$givPath]= $result;		// ARRAY storage for shortcut
		return $result;
	} // isAForbidPath
	
	
	/**
		Add a slash to have a slahed path if not already done and the path is compatible
	*/
	function addSlash(&$p){
		$i= strlen($p)-1;
		$c= $p[$i];
		if ($c!=='/' && $c!=='.'){
			$p.= '/';
		}
	} // addSlash

		
	/**
	*/
	function isInCompulsePath($givPath){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$comPaths= $glob->webmasterXRights['compulspaths'];
		if ($comPaths===false){
			// no compulsory path defined, so alwasy allowed for what ever if nothing is forbidden (computed in isAForbidPath() )
			return true;
		}else{
			if ($tools->sIsPrefixB(_c_constPfx,$comPaths)){
				$cPth= constant($comPaths);
			}else{
				$cPth= $comPaths;
			}
		
			if ($tools->sIsPrefixB($cPth,$givPath)){
				return true;
			}else{
				return false;
			}
		}
	} // isInCompulsePath

		
	/**
	*/
	function globallyForbidPath($givPath){
		$f= $this->isAForbidPath($givPath);
		$c= $this->isInCompulsePath($givPath);
		$allowed= $c && !$f;
		return !$allowed;
	} // globallyForbidPath
		
	/**
	*/
	function globAllowedPath($givPath){
		$f= $this->isAForbidPath($givPath);
		$c= $this->isInCompulsePath($givPath);
		return $c && !$f;
	} // globAllowedPath

		
	/**
	*/
	function tg_templatetag(&$v,&$bd){
		$caps= &$this->caps;
	
	} // tg_templatetag

		
	/**
	*/
	function tmp(){
	
	
	} // tmp
		
} // cntrXRight
?>
