<?php
/**
	File name : extremeFeedback.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[cenPlugin name="extremeFeedback" /]			[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	A class to use when in need of extreme feed back, created 1st for the needs of the Ataox.com demonstration for 
	possibly new clueless users where everythings need to be specified explicitely. So extreme on the pedantic scale.
	
	[efbOnlySurf] : used inisde ataox.com to specify the logged user Id on most pages to make it more personal!
	
	[noDefaultContent /] : when _c_replaceMostPgWithDef is true it avoids replacing the whole page content with a general default 
			text defined under table surfTrans::generalDefText
	
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class extremeFeedback extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->rights= &$tagsFu->rights;
		
		
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('extremeFeedback','debugDisplay',false);
				
		$tagsFu->attribVect['efbonlyedit']= array('restrict','substvar');
		$tagsFu->attribVect['efbonlysurf']= false;
		
		$tagsFu->attribVect['nodefaultcontent']= false;
		
		$tagsFu->attribVect['curpagestring']= array('ttl','noquotes');
		
		
	} // construct


	/**
	*/
	function tags(){
		return array('efbonlyedit','efbonlysurf','nodefaultcontent','curpagestring');
	} // tags

	
	
		
	/**
		Returns the given body only when someone is logged as a webmaster.or Guest 
		and substitute 
			"curUser" with the current user name and add the value of the string parameter 'restrict' if we are dealing with a Guest.
		
		[efbOnlyEdit restrict=""with writing capabilities disabled"] blabla [/efbOnlyEdit]
	*/
	function tg_efbonlyedit(&$v,&$bd){
		$tools= &$this->tools;
		$rg= &$this->rights;
		if ( $rg->quickWMRight() ){
		
			$substVar= $tools->binLoads($v['substvar'],'curUserSubst');
		
			$userId= _c_dblQ.$rg->realTimeUserId()._c_dblQ;
			
			$replace= $userId;
			$restr= $v['restrict'];
			if ( $userId===_c_guestUserId && $restr!==false ){
				$replace.= _c_Rs.$restr._c_Rs;
			}
			
			return str_replace($substVar,$replace,$bd);
		}
		return '';
	} // tg_efbonlyedit
	
	
	/**
		Returns the given body only when someone is NOT logged as a webmaster.
		[efbOnlySurf][/efbOnlySurf]
	*/
	function tg_efbonlysurf(&$v,&$bd){
		$rg= &$this->rights;
		if ( $rg->quickWMRight() ){
			return '';
		}
		return $bd;
	} // tg_efbonlysurf
	
		
	/**
		[noDefaultContent /]
	*/
	function tg_nodefaultcontent(&$v,&$bd){
		define('_c_noDefContent',_c_ok);
	} // tg_nodefaultcontent
	
		
	/**
		[curPageString /] ... displays the current page name in arial style, but integrated inside the text with
		an alt / title to describe it ! 
	*/
	function tg_curpagestring(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$pg= $tools->curPageName();
		$xButtonStr= $dtb->getElem(_c_PolyCellPgM, _c_pcId,$pg, _c_pcMainStr);
		
		$origClass= $tagsFu->explicitTags['menbut'];
		
		$tagsFu->explicitTags['menbut']= 'extremeFeedback';
		
		$buttonLabel= $tagsFu->expandX($xButtonStr,'extremeFeedback::curPageString');
		if ( $v['noquotes']===false ){
			$buttonLabel= _c_dblQ.$buttonLabel._c_dblQ;
		}
		
		
		$tagsFu->explicitTags['menbut']= $origClass;
		
		return $caps->spanTtl($buttonLabel,'bigVisibleMenuStr',$v['ttl']);
	} // tg_curpagestring
	

	/**
		Loaded temporarily to take the place of the main one and recover the body
	*/
	function tg_menbut(&$v,&$bd){
		return $bd;	// just to get rid of the tag
	} // tg_menbut

		
} // extremeFeedback
?>
