<?php
/**
	File name : fbBookM.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	File Browser Book Marks.
	[cenPlugin name="fbBookM" /]				[_ r="PLUGIN DECLARATION"/]
*/
class fbBookM extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->wmRights= &$tagsFu->wmRights;
																
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('fbBookM','debugDisplay',false);	
		
		$tagsFu->attribVect['leftorrightfmcol']= array('imgleft','imgright','addr','alt','el','categ','suonly','techonly','rem');
	} // construct


	/**
	*/
	function tags(){
		return array('leftorrightfmcol');
	} // tags

		
	/**
		A tag to present twice the same image with a left and a right click to load the left or the right column of the file manager.
		
		[leftOrRightFmCol imgleft="codeL.png" imgright="codeR.png " addr="./spp/code/plugins/explicit/external" alt="Code plugins" /]
	*/
	function tg_leftorrightfmcol(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$wmR= &$this->wmRights;
		
		
		$su= $v['suonly'];	// button allowed for super user "frill" only
		if ($su===_c_ok && !$wmR->wmSuFrill()){
			return '';
		}
		
		$tech= $v['techonly'];	// button allowed for users with technical access
		if ($tech===_c_ok && !$wmR->wmTechAcess()){
			return '';	// suppress technical file manager bookmarks
		}
		
		
		$path= _c_decPlugSupCss.'central/mm/';
		
		$imgLeftPath= $path.$v['imgleft'];
		if (!file_exists($imgLeftPath)){
			return ''; // easy way to avoid confusing bM by supressing the image!
		}
		
		$imgRightPath= $path.$v['imgright'];
		
		
		
		$addrColumns= $v['addr'];
		
		$alt= $v['alt'];
		$el= $v['el'];
		$altStr= $glob->el($alt,$el);
		
		$categ= $v['categ'];
		switch ($categ){
			case 'cd':	// code
				$addrColumns= _c_CodePath.$addrColumns;
			break;
			
			case 'ud':	// user directory
				$addrColumns= _c_UsrDataPath.$addrColumns;
			break;
						
			case 'stats':
				$addrColumns= _c_curStatsPathNS;
			break;
						
			case 'cache':
				$addrColumns= _c_curCachePathNS;
			break;
						
			case 'bkp':	// exportation package
				$addrColumns= _c_archiveDirPath;
			break;
						
			case 'export':	// exportation package
				$addrColumns= $fls->rmLC(_c_prExportPath);
			break;
			
			case 'secretDir':	// secret directory
				$addrColumns= _c_zCms._c_mainUsrSecretDir;
			break;
			
			case 'full':
			default:;	// full or nothing --> $addrColumns is given fully!
		} // switch

		$vPathI= _c_mFilePathPrfx.'1';
		$valPathI= $tools->gostVal($vPathI,_c_nsUsrDataPath);
		
		$vPathII= _c_mFilePathPrfx.'2';
		$valPathII= $tools->gostVal($vPathII,_c_nsUsrDataPath);
		
		
		$ar['mmDFChunkPos1']= _c_ko;
		$ar['mmDFChunkPos2']= _c_ko;
		$urlLeft= $tools->urlCurPg($ar);
		$urlLeft.= $tools->addUrlVar($vPathI, $addrColumns);
		$urlLeft.= $tools->addUrlVar($vPathII, $valPathII);

		
		$urlRight= $tools->urlCurPg($ar);
		$urlRight.= $tools->addUrlVar($vPathI, $valPathI);
		$urlRight.= $tools->addUrlVar($vPathII, $addrColumns);
		
		
		$leftImg= $caps->linkImg($imgLeftPath,$altStr,$urlLeft);
		$rightImg= $caps->linkImg($imgRightPath,$altStr,$urlRight,'mmBm');
		
		return $leftImg.$rightImg;
	} // tg_leftorrightfmcol

		
	/**
	*/
	function tg_tmptag(&$v,&$bd){
		$caps= &$this->caps;
	
	} // tg_tmptag

		
	/**
		Template for standard methods.
	*/
	function templateStd(){
	
	
	} // templateStd
		
} // fbBookM
?>
