<?php
/**
	File name : formMainWdgt.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Automatical form widget ideal when we concatenate the results of the user widget to do something with 
	the concatenation (sending a mail, storage) When we need to do other things that concatenation 
	with a widget just use a specific compulsory widget name and catch it with it.
	
	----------------------------------------------------------------------------------------------------
	IMPROVMENT : formMainWdgt holds only the most basic form functions, but any can easilly be added
	by defining an explicit external class, like it's done with formYmdWdgt.php
	----------------------------------------------------------------------------------------------------
		

	[cenPlugin name="formMainWdgt" /]				[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
			
	formMainWdgt::tg_mhidden(&$v,&$bd){
	
	formMainWdgt::tg_mainformbd()
*/
class formMainWdgt extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		
		$this->asa= &$tagsFu->asa;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;

		$this->hPwC= &$tagsFu->hPwC;
		$this->rMg= &$tagsFu->rMg;
		$this->cacheR= &$tagsFu->cacheR;
		$this->cacheWr= &$tagsFu->cacheWr;
				
		
		$this->genHash= $tagsFu->instExplitCentralCls('genHash');
		
		if ($dtb->getGenVar('simpleCaptchaCpy')===_c_ok){
			$this->genCaptcha= $tagsFu->instExplitCentralCls('gen2Captcha');
		}else{
			$this->genCaptcha= $tagsFu->instExplitCentralCls('genCaptcha');
		}

		
		/**
			Instance variables for easy indexing of :
		*/
		$this->easyAreaIdx= 0;		// Text area index.
		$this->easyTxtBxIdx= 0;		// Text box index.
		$this->easyChkBxIdx= 0;		// Check box index.
		$this->easyHidFieldIdx= 0;		// Hidden field index.	easyHidFieldIdx
		$this->easyHidParsdInfIdx= 0;	// Hidden parsed info index.
		
		
		/**
			Global concatenation Buffer : they are to be loaded fully each time, because we know if a posted
			form is fully correct only after having been through all the widgets. And to do a special scan just
			to save a concatenation would not make any sense (harder to code and more CPU time).
		*/
		$this->activeWdgtStr= '';
		$this->sentWdgtStr= '';
		$this->successForAllWdgt= true;
	
		
		/**
			Global constants used for identification/name of eMail parameters
			---> sendEMail($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom){
			
			Form Manager Widgets names :
				Need to distinguish between constant to access specific widgets and use of genVar variables ..
				directly accesses by the relevant functions! By the way : the webmaster email address could be
				define centrally genVar or ---> locally with a specific tag!! Easier to adapt different language or 
				different webmaster depending on topics!! Best choice!!
		*/
		define('_c_fmwMailTitleFrom','fmwMailTtlFrom');
		define('_c_fmwEmailFrom','fmwEmlFrom');
		
		define('_c_fmwMailSubject','fmwMailSbj');
		
		define('_c_fmwMailWebMasterAddr','fmwMailWebMstrAddr');	// ---> locally with a specific tag!!
		
		define('_c_fmwSendMailChkBoxNm','sendMailChkBxNm');
		
		define('_c_fmwDefCkWgtCls','forMnSimpleCB');		// default form check widget class	

		
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('formMainWdgt','debugDisplay',false);	
		
		/*
				name : facultative name of the form widget
				url : the facultative url parameter :
				classc : class category to infer the path
				classn : name of the class holding the action fun
				fun : the name of the action function.
				
				n tg_mainform		
		*/
		$tagsFu->attribVect['mainform']= array('name','onlyactiw', 'url','arcmdkey','arcmdval', 'classc', 'classdir','classn','fun','nbparam','br','code','return');
		
		
		$tagsFu->attribVect['mainformbd']= array('name','url','surl', 'classc', 'classdir','classn','fu','actioncateg','js');
		
		
		/*
				lbl : label string
				lblcr : label carriage returm / new line : got it by default except if $lbl==='' (if want text area on same line as label, just add lblcr="" )
				
				name : facultative name of the form widget
				row : number of rows displayed inside the text area.
				col : number of columns displayed inside the text area.
				serverMin : minimum size of the sent string to be accepted.by the server.
				serverMax : maximum size of the sent string to be accepted.by the server.
		*/
		$tagsFu->attribVect['mtxtarea']= array('lbl','lblcr', 'name','nofeedback','row','col', 'gvinitn', 'servermin','servermax','cls','content','br','ret');
		
		// homeonly --> flexindex
		$arrTB= array('test','incr', 'lbl', 'lblfont', 'name','sz', 'min','max','cls','content','br','sl','el','es','ret','def',
			'flexindex', 'defindtb', 'dtbinitn', 'onlyactive', 'jstored', 'pwrealtxt', 'random', 'rndsz');
		$tagsFu->attribVect['mtextbox']= $arrTB;
		$tagsFu->attribVect['memailbox']= $arrTB;
		$tagsFu->attribVect['msubjectbox']= $arrTB;
		$tagsFu->attribVect['mpassword']= $arrTB;	// jstored only for the password

		$tagsFu->attribVect['mspace']= array('margin');
			
			
		$xBut= array('name','str','cls','js','br','sl','el','es','br','ttl','slttl');
		$tagsFu->attribVect['mretbutton']= $xBut;
		$tagsFu->attribVect['mbutton']= $xBut;
		
		$tagsFu->attribVect['thankyou']= array('str','cls','br');
		
		$tagsFu->attribVect['mhiddenbox']= array('name','content','ret');
		
		$tagsFu->attribVect['setwebmastermail']= array('mail');
		$tagsFu->attribVect['setmailsubject']= array('str');
		$tagsFu->attribVect['setmailtitlefrom']= array('str');
		
		
		$arrayCB= array('name','prfx','pfxtrad','sffx','sfxtrad','cls','js','br','ret'); 
		$tagsFu->attribVect['mchkbox']= $arrayCB;
		$tagsFu->attribVect['mailokchekbox']= $arrayCB;
		
	
		/**
			Full widget captcha with the 3 elements :
				--> (Explanation),(Captcha question),(TextBox)
				
			[widgtCaptcha tblNm="captcha1" intro="Merci de résoudre ce Captcha :" /]
				tblnm : the captcha table name.
				intro : the introduction text.
				introfont : indication font.
			Important remark : 	checking the validity of the captcha from the user answer and companion hash
								is done inside -------->  form..Kernel::formSucceeded().
		*/
		$tagsFu->attribVect['mwgtcaptcha']= array('imgcaptch','width','height','autocaptch','tblnm','intro','sl','introfont','br','ret');
		
		$tagsFu->attribVect['captautoquest']= false;		
		$tagsFu->attribVect['mhidden']= array('name','val','ret');
		
		$tagsFu->attribVect['mselect']= array('onlyactive','lbl','br','name','valfeedb','cls','defval','defvgv','listval','gotdq','listdspl','sep','specval',
			'flexindex','sl','el','es', 'sl2','el2','es2', 'sl3','el3','es3', 'sl4','el4','es4','expand','targetb','defrank','defindtb','dtbinitn','speclrgint');														
		
		$tagsFu->attribVect['langdsplval']= array('dspl', 'codeneutral' ,'sl','el','es');			
			
		$tagsFu->attribVect['mlabel']= array('lbl', 'css', 'sl','el','es','br','onlyactive','fixedir');	
		$tagsFu->attribVect['frombdtodblvect']= false;
		$tagsFu->attribVect['fromdblvecttobd']= false;
	
			
		$tagsFu->attribVect['mheadiv']= array('style', 'id', 'js','cls');	
		$tagsFu->attribVect['mendiv']= false;		
			
		$tagsFu->attribVect['mbr']= array('name');		// got a name so we can avoid execution of this tag
		
		$tagsFu->attribVect['displayfuvalue']= array('cl','fu','categ','css');	
		$tagsFu->attribVect['displayfuvaltb']= array('name','cl','fu','categ','css','tbval');	
		
		$tagsFu->attribVect['integerinfotag']= false;	
		$tagsFu->attribVect['likelymysqlstr']= false;	
		$tagsFu->attribVect['geninfotag']= array('str','ttl', 'sl','el','es');	
		$tagsFu->attribVect['mdatadirname']= array('css','fixedir');	
		
		$tagsFu->attribVect['incldtbsensitcode']= array('idmysql','idsimul');
		$tagsFu->attribVect['inclxpetalcode']= array('id','forcesltoel','tagexclst');
		
								
		$this->silentWidgets= false; // if true the concerned widgets get out straight away and return ''
		
		
		/**
			⬤ Constant used for the delimitation of the combo box examples inside the widget group :
				Menus / Pages definition and hierachy
				
				Need separators unlikely to be needed inside the example code + visible enough and accessible on all browsers
					Actual field separator : $ (defined in Xpetal, replaced with ▆)
					Actual language separator : ◯
		*/
		define('_c_mDefBtweExmplSep','▆');	// separation between examples separator : CV ▆ Blog ▆ Etc...
		define('_c_mDefDblQtSubst','╬');	// double quote substitute so the double quote information can be stored inside a standard html select box
	} // construct
	

	/**
	*/
	function tags(){
		return array('captautoquest','mainform','mainformbd','mhiddenbox','setwebmastermail','setmailsubject','setmailtitlefrom',
			'mtxtarea', 'mtextbox','memailbox','msubjectbox', 'mpassword', 'mspace', 'frombdtodblvect','fromdblvecttobd', 'mheadiv', 'mendiv',
			'mbutton','mretbutton','thankyou','mwgtcaptcha','mchkbox','mailokchekbox','mhidden','mselect','langdsplval','integerinfotag',
			'mlabel','mbr','displayfuvalue','displayfuvaltb','likelymysqlstr','geninfotag','mdatadirname','incldtbsensitcode','inclxpetalcode');
	} // tags
	

	/**	
		[inclXpetalCode id="InstallerDtbMySql" /]
	*/
	function tg_inclxpetalcode(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		return $tagsFu->tg_inclxpetalcd($v,$bd);
	} // inclxpetalcode

	
	/**
	*/
	function postedAndSuccess(){
		return $this->theFormWasPosted() && $this->successForAllWdgt;
	} // postedAndSuccess
	

	/**
		[fromBdToDblVect] ... [/fromBdToDblVect]
		
		Convert from a strict body return to the double vectors standard to this class! 
		
		Remark : can't always do that in the other direction (eg with a tag called [fromDblVectToBd]), because 
		it may also take loads of tags external to the current encapsulation. So tags must be foreced individually
		to for a direct return, for example with the parameter ret="ok"
	*/
	function tg_frombdtodblvect(&$v,&$bd){
		$this->activeWdgtStr.= $bd;
		$this->sentWdgtStr.= $bd;
	}

	/**
		[fromDblVectToBd]
		[/fromDblVectToBd]
	*/
	function tg_fromdblvecttobd(&$v,&$bd){
		if ($this->postedAndSuccess()){
			return $this->sentWdgtStr;
		}else{
			return $this->activeWdgtStr;
		}
	} // fromdblvecttobd

	
	
	/**
		A speciality for the forum multipurpose form (could be undone at some stage)
	*/
	function silentTheWidgets(){
		$this->silentWidgets= true;
	} // silentTheWidgets
	
		
	/**
		Success of the main widgets (the widgets of this class) after sending the form) (mainly called externally)
	*/
	function successMainWdgts(){
		return $this->successForAllWdgt;
	} // successMainWdgts

	
	/**
		[captAutoQuest /]
	*/
	function tg_captautoquest(&$v,&$bd){
		$genC= &$this->genCaptcha;
		$this->activeWdgtStr.= $genC->captchaAutoQuest();
	} // tg_captautoquest


	/**
		Return true if the form was posted (button clicked) with final success or not!
	*/
	function theFormWasPosted(){
		$tools= &$this->tools;
		return $tools->postVal(_c_genHidWdgtFormNm)===_c_ok;	// true if the supporting form was posted
	} // theFormWasPosted

		
	/**
		Assign a new widget test
		Input :
			$bool : the boolean variable to indicate if the widget was filled correctly
			$wdgtName : to test if the widget was really sent and not just generated (case of javascript dependant display)
			$orig : to localise the origin of the call.
	*/
	function assignWdgTest($bool,$wdgtName,$orig=''){
		if ( $this->theFormWasPosted() && isset($_POST[$wdgtName]) ){
			$this->successForAllWdgt= $this->successForAllWdgt && $bool;
		}
	} // assignWdgTest
	
	/**
		As assignWdgTest(), but without bothering about $wdgtName
	*/
	function serieBoolTest($bool,$orig=''){
		if ( $this->theFormWasPosted() ){
			$this->successForAllWdgt= $this->successForAllWdgt && $bool;
		}
	} // serieBoolTest
	

	/**
		A general form to execute parameters specified action with the content of the widgets specified in $bd
		Major simplification compared to previous version :
			- Widgets expanded inside $bd are auto-managing ---> they :
					- are capable of displaying errors.
					- display differently if the form was successfull (also need thankYou widget that display only
					  when the form is successful).
					- the result sent or processed is by default the concatenation of all widgets in 
					  successfully sent display mode.
					- special functions are free to catch widgets with specific names -->
						- names should always been given explicitelly.
						- because the widget itself reads the matching post, it can find easilly its own information!
							- a js menu could attribute random names (with a push for the user to add some significance),
									--> much easier than trying to generate significant unique names (would not know
									easilly what names are already used).
	*/
	function tg_mainform(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		$dspl= '';	
		$name= $tools->binLoads($v['name'],'easyForm');
		
		// arCmdKey  arCmdVal
		$arCmdKey= $v['arcmdkey'];
		if ($arCmdKey!==false){
			$arCmdVal= $v['arcmdval'];
			$arCmd[$arCmdKey]= $arCmdVal;
			
			$u= $v['url']; // page name or #
			if ($u==='#'){
				$url= $tools->urlCurPg($arCmd);
			}else{
				$url= $tools->urlGivenPage($u,$arCmd);
			}
		}else{
			$url= $tools->binLoads($v['url'],'#');
		}
		
		$classc= $tools->binLoads($v['classc'],_c_libClassCateg);
		if ($this->postedAndSuccess()){
			// Concerned class and method. Default --> emails context.
			$classn= $tools->binLoads($v['classn'],'email');
			$fun= $tools->binLoads($v['fun'],'toClientAndWebmaster');		
		
			if ($classn!==_c_ko && $fun!==_c_ko){	// redondant for confort
				$classdir= $tools->binLoads($v['classdir'],$classn);
				$curCls= $tagsFu->optimClassAccess($classc,$classn,$classdir);
				
				$nbParam= $tools->binLoads($v['nbparam'],'1');
				switch ($nbParam){
					case '0':
						$fuRes= $curCls->$fun();
					break;
					
					case '1':
						$fuRes= $curCls->$fun($this);
					break;
					
					case '2':
						$fuRes= $curCls->$fun($this,$dspl);
					break;
				} // switch
				
				if ($v['return']===_c_ok){
					// Direct return of the information and placing at the natural place
					$this->activeWdgtStr.= $fuRes;
					$this->sentWdgtStr.= $fuRes;
				}
				
				if ($fuRes!==false){
					$content= $this->activeWidgetFilter($v);
				}else{
					$content= $this->activeWdgtStr;
				}
				
			}else{
				// successful but didn't bother with a function
				$content= $this->activeWidgetFilter($v);
			}
		}else{
			$content= $this->activeWdgtStr;
		}
		
		if ($v['code']===_c_ok){
			$bd= $tagsFu->expand($bd);	// the "xml" in $bd was delayed and must be executed now (after the execution of $curCls->$fun($this))
		}

		return $caps->form($url,$name, $dspl.$bd.$content);
	} // tg_mainform
	
	
	/**
		[mainFormBd] [/mainFormBd]
		This method needs all its included tags to be :
			- In Natural return mode
			- Or Forced in natural returned mode
	*/
	function tg_mainformbd(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		$name= $tools->binLoads($v['name'],'easyForm');
		
		$url= $tools->binLoads($v['url'],'#');
		$supUrl= '';
		
		$classC= $v['classc'];	// class category

		$js= $tools->binLoads($v['js'],'');		
		if ($this->postedAndSuccess()){
			$classN= $v['classn'];
			$fu= $v['fu'];		
		
			$classDir= $tools->binLoads($v['classdir'],$classN);
			$curCls= $tagsFu->optimClassAccess($classC,$classN,$classDir);
			
			$aCateg= $v['actioncateg'];
			$bd= $curCls->$fu($bd, $this,$aCateg);
			
			// Supplementary url signal in case of success
			$surl= $v['surl'];
			if ($surl!==false){
				switch ($surl){
					// improve stage of a forum Post
					case 'iPost':
						if ($glob->lastCreatedPostIndx!==false){
							$supUrl= $tools->addUrlVar(_c_fImprovePId,$glob->lastCreatedPostIndx);
						}
					break;
				} // switch
			}
		}
		
		if ( $tagsFu->encapsNibbledCode!=='' ){
			$nibRes= $tagsFu->expandX($tagsFu->encapsNibbledCode);
			$tagsFu->encapsNibbledCode= '';	// formal reset to avoid further interfering
			$bd= $nibRes.$bd;
		}
		
		return $caps->form($url.$supUrl, $name, $bd, $js);	// Display whatever the function returns, and it could include the full form
	} // tg_mainformbd2	
	
	
	
	/**
		Successful and choose the sort of feed back active or passive!
	*/
	function activeWidgetFilter(&$v){
		if ($v['onlyactiw']===_c_ok){
			return $this->activeWdgtStr;
		}else{
			return $this->sentWdgtStr;
		}
	} // activeWidgetFilter
		
		
		
	/* -------------------------------------------------------------------------------------------------
		[mTxtArea lbl="Direct SQL : " row="20" col="90" name="directSqlTxtArea" /]
			
		If no local error here and before --> need to produce the alternative fully done /sent etc. equivalent!
		So probably best to return nothing, but instead pack it inside 2 global variables
		
		Minimal optimum c
		all :
			[mTxtArea lbl="Message name="" row=""3:col="60"  /]
	*/
	function tg_mtxtarea(&$v,&$bd){
		return $this->coreTxtArea($v);
	} // tg_mtxtarea
	
	
	function coreTxtArea(&$v, $hardCodedName=false){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		if ($this->silentWidgets){
			return '';
		}
		
		$lbl= $tools->binLoads($v['lbl'],'');
		// label carriage returm / new line : got it by default except if $lbl==='' (if want text area on same line as label, just add lblcr="" )
		$lblcr= $tools->binLoads($v['lblcr'],_c_);
		if ($lbl===''){
			$lblcr= '';
			$labelStr= '';
		}else{
			$labelStr= $caps->span($lbl,'forMnWdgtTaLbl').$lblcr;
		}

		/* TextArea parameters!
		*/
		if ($hardCodedName===false){
			$name= $v['name'];
			if ($name===false){
				$name= 'easyArea'.$this->easyAreaIdx;
				$this->easyAreaIdx++;
			}
		}else{
			$name= $hardCodedName;
		}
		
		$row= $tools->binLoads($v['row'],'8');
		$col= $tools->binLoads($v['col'],'90');
		
		$min= $tools->binLoads($v['servermin'],'1');
		$max= $tools->binLoads($v['servermax'],'500000');
		$boxMaxLim= $max;
		
		$cls= $tools->binLoads($v['cls'],'forMnWdgtTA');

		/* Formating the global result for the 2 possibilities : success or asking again!
		*/
		$gvInitN= $v['gvinitn'];	// general variable init name
		$wasPosted= $this->theFormWasPosted();	
		if ($wasPosted){
			$areaContent= $tools->postVal($name);
			if ( $gvInitN!==false ){
				$dtb->setGenVar($gvInitN,$areaContent);
			}
		}else{
			if ( $gvInitN!==false ){
				$areaContent= $dtb->getGenVar($gvInitN);
			}else{
				$areaContent= $tools->binLoads($v['content'],'');
			}
		}
		
		$errMess= $this->errorMess($szIsOk,$areaContent, $min,$max);
		if ($errMess!==''){
			$gotLnf= _c_;
		}else{
			$gotLnf= '';
		}
		$this->assignWdgTest($szIsOk,$name,'coreTxtArea');
			
		$activeWdgtStr= $this->wdgtBreaks($v).$labelStr.$errMess.$gotLnf.$caps->textarea($name,$row,$col,$areaContent,'',false,$boxMaxLim, $cls);
		$sentWdgtStr= $this->wdgtBreaks($v).$labelStr.$caps->span($areaContent,$cls);
		
		$this->activeWdgtStr.= $activeWdgtStr;
		
		// noFeedBack after succesful action --> do not display what was sent !!
		if ($v['nofeedback']===false){
			$this->sentWdgtStr.= $sentWdgtStr;
		}
		
		if ($v['ret']===_c_ok){
			return $activeWdgtStr;
		}else{
			return '';
		}
	} // coreTxtArea
	
	
	/* -------------------------------------------------------------------------------------------------
		Standard Text Box.
			[mTextBox name="" lbl="Tetxbox Label :" /]
	*/
	function tg_mtextbox(&$v,&$bd){
		return $this->generalTextBox($v);
	} // tg_mtextbox
	
	/**
		Standard EMail Text Box.
			[mEmailBox lbl="EMail :" /]
	*/
	function tg_memailbox(&$v,&$bd){
		return $this->generalTextBox($v, _c_fmwMailClientAddr);
	} // tg_memailbox
	
	/**
		Standard EMail Subject Text Box.
			[mSubjectBox lbl="Congratulation message :" /]
	*/
	function tg_msubjectbox(&$v,&$bd){
		return $this->generalTextBox($v, _c_fmwMailSubject);
	} // tg_msubjectbox
	
	/**
		Input :
			&$v : clasical tag param.
			$hardCodedName : a hard coded name of the text box, so it's not up to the user to stick on a particular name!
	*/
	function generalTextBox(&$v, $hardCodedName=false){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;

		if ($this->silentWidgets){
			return '';
		}
		
		if ($v['flexindex']===_c_ok && !$fls->polyvalentIndex()){
			return '';
		}
		
		
		// Label parameters :
		$labelStr= $tools->binLoads($v['lbl'],'');
		$labelStr= $glob->choosEsl($v,$labelStr);
		if ($labelStr!==''){
			$lblfont= $tools->binLoads($v['lblfont'],'forMnWdgtTbLbl');
			$labelStr= $caps->span($labelStr,$lblfont);
		}
		
		/*	TextBox parameters!
		*/
		if ($hardCodedName===false){
			$name= $tools->binLoads($v['name'], 'easyTBx'.$this->easyTxtBxIdx);
			$this->easyTxtBxIdx++;
		}else{
			$name= $hardCodedName;
		}

		$wasPosted= $this->theFormWasPosted();	
		if ($wasPosted){
			$tbContent= $tools->postVal($name);	
		}else{
			$tbContent= $tools->binLoads($v['def'],'');
		}	
		
		
		$sz= $tools->binLoads($v['sz'],'50');
		$min= $tools->binLoads($v['min'],'1');
		$max= $tools->binLoads($v['max'],'200');
		$boxMaxLim= $max;
		
		$cls= $tools->binLoads($v['cls'],'forMnWdgtTB');
		$cls= $caps->matCss($cls);
	
	
		$gotDefInDtb= $v['defindtb']===_c_ok;
		$dtbInitN= $v['dtbinitn'];	// direct Dtb default value (same function as 'defindtb' but more intuitive
		if ($gotDefInDtb || $dtbInitN!==false){
			// defined In Dtb
			if ( $dtbInitN!==false ){
				$def= $dtb->getGenVar($dtbInitN);
			}else{
				$def= $dtb->getGenVar($name);		// the name must match the entry of the table!
			}
			
		}else{
			$def= $tools->binLoads($v['def'],$tbContent);
		}

		
		/* Formating the global result for the 2 possibilities : success or asking again!
		*/
		if (!$wasPosted){
			$rnd= $v['random'];
			switch ($rnd){
				case false:
					$locContent= $tools->binLoads($v['content'],$def);
					if ($name==='installerMainDirName'){
						$suggestDir= $dtb->getGenVar('mainDirForStdAtaoxInstall');
						// special installation !!!!!
						if ($suggestDir==='ersatztSuggestDirName'){
							$tbContent= $locContent;	// when the ersatzt not taken because the long ersatz string is still waitimg!
						}else{
							$tbContent= $suggestDir;
						}
					}else{
						$tbContent= $locContent;
					}
				break;
				
				case 'all':
					$rndSz= $tools->binLoads($v['rndsz'],4);
					$tbContent= $hPwC->consStr($rndSz);
				break;
				
				case 'usrNameSfx':
					$rndSz= $tools->binLoads($v['rndsz'],4);
					$tbContent= $glob->sl('Anonym_','kbnl').$hPwC->consStr($rndSz);
				break;
				
				default: $glob->userError('formMainWdgt::generalTextBox');
			} // switch
		}
		
		$errMess= $this->errorMess($contentIsOk,$tbContent, $min,$max, $hardCodedName);
		$this->assignWdgTest($contentIsOk,$name,'generalTextBox');
		
		// ### textBox() ####
		$activeWdgtStr= $this->wdgtBreaks($v).$labelStr.$errMess.$caps->textBox($name, $tbContent, $sz, $cls, $boxMaxLim);
		$sentWdgtStr= $this->wdgtBreaks($v).$labelStr.$caps->span($tbContent,$cls);

		if ($wasPosted && $gotDefInDtb){
			$incr= $v['incr']===_c_ok;
			if ($incr){
				$tbContent= $tbContent + 1;
			}
			$dtb->setGenVar($name,$tbContent);
		}
		
		
		if ($v['onlyactive']===false){
			$this->sentWdgtStr.= $sentWdgtStr;
		} // else (eg. value to ok) $this->sentWdgtStr is ignored so does not appear as a result!
		
		if ($v['ret']===_c_ok){
			return $activeWdgtStr;
		}else{
			$this->activeWdgtStr.= $activeWdgtStr;
			return '';
		}		
	} // generalTextBox
	
	
	/**
		Password box
		[mPassword /]
	*/
	function tg_mpassword(&$v, &$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$hPwC= &$this->hPwC;

		if ($this->silentWidgets){
			return '';
		}

		// Label parameters :
		$labelStr= $tools->binLoads($v['lbl'],'');
		$labelStr= $glob->choosEsl($v,$labelStr);
		$labelStr= $glob->choosEsl($v,$labelStr);
		if ($labelStr!==''){
			$labelStr= $caps->spanTtl($labelStr,'forMnPwLbl',$glob->sl('This password widget is used sometime to define a new password','kmiy'));
		}

		/* Box parameters!
		*/
		$name= $tools->binLoads($v['name'], 'easyPWrd'.$this->easyTxtBxIdx);
		$this->easyTxtBxIdx++;
		
		$sz= $tools->binLoads($v['sz'],'10');
		$min= $tools->binLoads($v['min'],'4');
		$max= $tools->binLoads($v['max'],'12');
		
		$cls= $tools->binLoads($v['cls'],'forMnWdgtTB');
		$cls= $caps->matCss($cls);

		$tbContent= $tools->postVal($name);
		
		$errMess= $this->errorMess($contentIsOk,$tbContent, $min,$max, false);
		$this->assignWdgTest($contentIsOk,$name,'tg_mpassword');
		
		
		if ($v['jstored']===_c_ok){
			$js= $caps->jsSimpleFu('formMainWdgt.recoverPassword',1,0,$name).';';
			$glob->setGlbEndJsCode($js);
		}
		
		if ($v['pwrealtxt']===_c_ok){
			$rnd= $v['random'];
			switch ($rnd){
				case false:
					$activeWdgtStr= $this->wdgtBreaks($v).$labelStr.$errMess.$caps->textBox($name,'',$sz,$cls,$max);
				break;
				
				case 'all':
					$rndSz= $tools->binLoads($v['rndsz'],4);
					$rndPw= $hPwC->consStr($rndSz);
					$activeWdgtStr= $this->wdgtBreaks($v).$labelStr.$errMess.$caps->textBox($name,$rndPw,$sz,$cls,$max);
				break;
				
				default: $glob->userError('formMainWdgt::generalTextBox');
			} // switch
		}else{
			$activeWdgtStr= $this->wdgtBreaks($v).$labelStr.$errMess.$caps->corePwWdg($name,'',$sz,$cls,$max);
		}
		
		
		if ($v['ret']===_c_ok){
			return $activeWdgtStr;
		}else{
			$this->activeWdgtStr.= $activeWdgtStr;
			return '';
		}		
	} // tg_mpassword
	
		
	/**
		[mSpace margin="25" /] Returns a space with a specified left margin in pixel!
	*/
	function tg_mspace(&$v,&$bd){
		$caps= &$this->caps;
		
		$m= $v['margin'];
		$res= $caps->span('&nbsp;','','margin-left:'.$m.'px;');
		$this->activeWdgtStr.= $res;
		$this->sentWdgtStr.= $res;
	} // tg_mspace
	
		
	/* -------------------------------------------------------------------------------------------------
		[mHiddenBox /]
	*/
	function tg_mhiddenbox(&$v,&$bd){
		$this->generalHiddenField($v,$bd);
		return '';
	} // tg_mhiddenbox
	

	/**
		A hidden text box kernel function! Remark hidden box support should be avoided when possible !!!!!!!!!!!
		because the transmitted value can be tempered of with on the client side. 
		Typical indispensable use : client hash.
	
		Input :
			&$v,&$bd : clasical tag params.
			$hardCodedName : a hard coded name of the text box, so it's not up to the user to stick on a particular name!
	*/
	function generalHiddenField(&$v,&$bd, $hardCodedName=false){
		$tools= &$this->tools;
		$caps= &$this->caps;

		if ($this->silentWidgets){
			return '';
		}

		/*	Hidden parameters!
		*/
		if ($hardCodedName===false){
			$name= $tools->binLoads($v['name'], 'easyHid'.$this->easyHidFieldIdx);
			$this->easyHidFieldIdx++;
		}else{
			$name= $hardCodedName;
		}

		/* Formating the global result for the 2 possibilities : success or asking again!
		*/
		$wasPosted= $this->theFormWasPosted();	
		if ($wasPosted){
			$hbContent= $tools->postVal($name);
		}else{
			$hbContent= $tools->binLoads($v['content'],'');
		}
		
		$messWdgt= $errMess.$caps->hiddenWdg($name,$hbContent);
		if ($v['ret']===_c_ok){
			return $messWdgt;
		}else{
			$this->activeWdgtStr.= $messWdgt;
		}		
	} // generalHiddenField
	
		
	/* -------------------------------------------------------------------------------------------------
		Set the webmaster email for the current parser and dependant methods.
		[setWebmasterMail mail="" /]
	*/
	function tg_setwebmastermail(&$v,&$bd){
		$this->generalHidParsedInfo($this->webmasterEMail, $v['mail']);
	}
	
	// [setMailSubject str="" /]
	function tg_setmailsubject(&$v,&$bd){
		$this->generalHidParsedInfo($this->mailSubject, $v['str']);
	}
	
	// [setMailTitleFrom str="" /]
	function tg_setmailtitlefrom(&$v,&$bd){
		$this->generalHidParsedInfo($this->MailTitleFrom, $v['str']);
	}

	/**
		A parsed infprmation allows any method (called after this tag parsing) througn an instance variable	
		to access a specific value eventually unique for the parsed text! This can replace advantageously
		a hidden field that could be tempered with on the client side.
		
		Input :
			$instanceVar : instance variable (for this class).
			$instanceVal : the value we want to assign to $instanceVar.
	*/
	function generalHidParsedInfo(&$instanceVar, $instanceVal){
		$instanceVar= $instanceVal;
	} // generalHidParsedInfo



	/**
		Numerical evaluation of the string!
	*/
	function sizeIsOk(&$sz, &$str,$min,$max){
		$sz= strlen($str);
		return $sz>=$min && $sz<=$max;
	} // sizeIsOk


	/**
		Return an error message if out of limits!
		$this->errorMess($contentIsOk,$str, $min,$max);
		
		Inout :
			$str : string to check for errors
			$min,$max : limits allowed
			$spcName : if given --> a specific name for specific control.added on top of $min,$max
	*/
	function errorMess(&$contentIsOk,&$str, $min,$max, $spcName=false){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$min= (int)$min;
		$max= (int)$max;
		
		$errStr= '';
		if ( $this->theFormWasPosted() ){
			$contentIsOk= $this->sizeIsOk($sz,$str,$min,$max);
			if (!$contentIsOk){
			
				if ($sz<$min){
					$errStr= $glob->st('You need at least','stNeedAtLeast').' '.$min.' '.$glob->st('character(s)','stOneOrManyChar');	
				}else{
					$errStr= $glob->st('Maximum size is','stMaxSizeIs').' '.$max.' '.$glob->sl('character(s)','stOneOrManyChar');			//  or abrev !
				}
			}
			
			if ($spcName!==false){
				switch ($spcName){
					case _c_fmwMailClientAddr:		// dealing with an email content!
						if (!$tools->isValidEmail($str)){
							if ($contentIsOk){
								$errStr= $glob->st('The email is not correct! ','stEmailNotOk');
							}else{
								$errStr.= $glob->st(' and the email is not correct : ','stAndEmailNotOk');
							}
							$contentIsOk= false;
						}
					break;
					
					case _c_fmwMailSubject:
						// nothing to do, checking size is enough!
					break;
					
					
					default: print('Error in formMainWdgt::errorMess()'._c_);
				} // switch
			}
			
			return $caps->span($errStr,'forMnWdgtTaError');
		}else{
			$contentIsOk= true; 	// so don't write an error 1st time when it was not posted!
			return '';
		}
	} // errorMess

	
	
	/**
		[mRetButton str="Send" /]
	*/
	function tg_mretbutton(&$v,&$bd){
		return $this->coreMButton($v,$bd,false);
	} // tg_mretbutton
	
	
	/**
		[mButton str="Send" /]
	*/
	function tg_mbutton(&$v,&$bd){
		return $this->coreMButton($v,$bd,true);
	} // tg_mbutton
	
	
	/**
	*/
	function coreMButton(&$v,&$bd, $activePassiveProcStyle){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
	
		if ($this->silentWidgets){
			return '';
		}
		
		$name= $tools->binLoads($v['name'],'mSendBut');
		$label= $tools->postVal($name,$v['str']);
		
		$labelStr= $glob->choosEsl($v,$label);
		
		$cls= $tools->binLoads($v['cls'],'forMnWdgtSendBut');		
		$js= $tools->binLoads($v['js'],'');	
		
		$js= str_replace('_c_ckUniqPrfx',_c_ckUniqPrfx,$js);	// rem : the string of the constant is used as a searched string to actualise the constant value iniste the JS code
		
		
		$slttl= $v['slttl'];
		$ttl= $caps->ta($glob->sl($v['ttl'],$slttl));
		
		
		$curWdgts= $caps->submit($name,$labelStr,$caps->matCss($cls).$js.$ttl);
		
		if ($activePassiveProcStyle){
			$this->activeWdgtStr.= $curWdgts;	// only fills the active one in that case !!
		}else{
			return $curWdgts;
		}
	} // coreMButton

	
	/**
		[thankYou str="Tahnk you very much for your enquiry!" /]
	*/
	function tg_thankyou(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
	
		$str= $tools->binLoads($v['str'],'Thank you!');
		$cls= $tools->binLoads($v['cls'],'forMnWdgtThankYou');
		$this->sentWdgtStr.= $caps->span($str,$cls).$this->wdgtBreaks($v);
		return '';
	} // tg_thankyou
	
	
	/**
		Display a new captcha to solve!
			Example : [mWgtCaptcha tblNm="captcha1" intro="A Captcha to solve :" /]
			Check the user input with plugins/explicit/central/ ---> genHash::captchaIsCorrect()
	*/
	function tg_mwgtcaptcha(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$tools= &$this->tools;
		$cacheR= &$this->cacheR;
		$cacheWr= &$this->cacheWr;
		$genHash= &$this->genHash;
		$genCaptcha= &$this->genCaptcha;
		

		if ($this->silentWidgets){
			return '';
		}
		
		$cacheWr->allowCurPgCaching= false;	// This line would be enough by itself !!
		
		// ------> Start the cache FRILL		
		$motherPg= $tools->curPageName();
		$dfn= $cacheR->cacheCandidateDfn($motherPg);

		$cacheDfn= $cacheR->cacheCandidateDfn();	// the file should not be there (cause naïve webmaster caching a page holding a captcha)
		$fls->secUnlink($cacheDfn);
		// <------ End the cache FRILL
		
		$smplCaptCpy= $dtb->getGenVar('simpleCaptchaCpy')===_c_ok;
		if ($smplCaptCpy){
			$captCorrect= $genHash->captchaIsCorrect(true);
		}else{
			$captCorrect= $genHash->captchaIsCorrect();
		}
		
		$this->assignWdgTest($captCorrect,_c_captHidHashNm,'tg_mwgtcaptcha');
		
		$imgCaptch= $tools->binLoads($v['imgcaptch'],_c_ok);
		$imgCaptch= $tools->okToBool($imgCaptch);
		
		$autoCaptch= $tools->binLoads($v['autocaptch'],_c_ok);
		$autoCaptch= $tools->okToBool($autoCaptch);
		
		// ################################################
		if ($smplCaptCpy){
			$captBdy= $genCaptcha->coreWgtCaptcha($v,$bd);
		}else{
			$captBdy= $genCaptcha->coreWgtCaptcha($v,$bd,$imgCaptch,$autoCaptch);
		}
		
		
		if ($v['ret']===_c_ok){
			return $captBdy;
		}else{
			$this->activeWdgtStr.= $this->wdgtBreaks($v).$captBdy;
			return '';
		}
	} // tg_mwgtcaptcha
	
	
		
	/**
		[mailOkChekBox prfx="Please check here" sffx="to get an email copy." /]
	*/
	function tg_mailokchekbox(&$v,&$bd){
		return $this->coreChkbox($v,_c_fmwSendMailChkBoxNm);
	} // tg_mailokchekbox
			
	/**
		A general check box with a label that follows its result for the email content.
		[mChkBox prfx="Please check here" sffx="to get an email copy." /]
	*/
	function tg_mchkbox(&$v,&$bd){
		return $this->coreChkbox($v);
	} // tg_mchkbox
	
	
	function coreChkbox(&$v,$specCbName=false){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		if ($this->silentWidgets){
			return '';
		}

		/*	Check Box name definition!
		*/
		if ($specCbName===false){
			$name= $tools->binLoads($v['name'], 'easyChkBx'.$this->easyChkBxIdx);
			$this->easyChkBxIdx++;
		}else{
			$name= $specCbName;
		}
		
		
		$prfx= $v['prfx'];
		if ($prfx!==false){
			$pfxtrad= $v['pfxtrad'];
			if ($pfxtrad===false){
				$prfx= $caps->span($prfx.' ','forMnCBLabel');
			}else{
				$prfx= $caps->span($glob->sl($prfx,$pfxtrad).' ','forMnCBLabel');
			}
		}else{
			$prfx= '';
		}
		
		$sffx= $v['sffx'];
		if ($sffx!==false){
			$sfxtrad= $v['sfxtrad'];
			if ($sfxtrad===false){
				$sffx= $caps->span($sffx.' ','forMnCBLabel');
			}else{
				$sffx= $caps->span($glob->sl($sffx,$sfxtrad).' ','forMnCBLabel');
			}
		}else{
			$sffx= '';
		}
		
		$val= _c_ok;
		$sentVal= $tools->postVal($name);
		if ($sentVal!==false){
			$setval= $sentVal;
			$displVal= _c_ok;
		}else{
			$setval= '';
			$displVal= _c_ko;
		}	
		
				
		$cls= $tools->binLoads($v['cls'],_c_fmwDefCkWgtCls);
		if ($cls!==''){
			$cls= $caps->matCss($cls);
		}
		$js= $tools->binLoads($v['js'],'');
		
		
		$this->activeWdgtStr.= $this->wdgtBreaks($v).$prfx.$caps->checkBox($name,$val,$setval,$cls.$js).$sffx;
		$this->sentWdgtStr.= $this->wdgtBreaks($v).$prfx.$sffx.$caps->span($displVal,'forMnCBLabel');
		if ($v['ret']===_c_ok){
			return $this->activeWdgtStr;
		}else{
			return '';
		}
	} // coreChkbox
	
		
	/**
		Specify the widget breaks.
	*/
	function wdgtBreaks(&$v){
		$tools= &$this->tools;
	
		if ($this->silentWidgets){
			return '';
		}

		$br= $tools->binLoads($v['br'],'2');
		switch ($br){
			case '0':
				$b= ' ';	// suppose something is before on the same line, so if mailer htmnl display is not active, it looks better with a space!
			break;
			
			
			case '1':
				$b= _c_BrFlux;
			break;
			
			
			case '2':
			default:
				$b= _c_BrFlux._c_BrFlux;
		} // switch

		return $b;
	} // wdgtBreaks
		
		
	/**
		[mHidden name="" val="" ret="ok" /]
	*/
	function tg_mhidden(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$name= $v['name'];
		$val= $tools->binLoads($v['val'],_c_ok);
		
		if ($v['ret']===_c_ok){
			// $this->activeWdgtStr.= $caps->hiddenWdg($name,$val);	// !
			return $caps->hiddenWdg($name,$val);
		}else{
			$this->activeWdgtStr.= $caps->hiddenWdg($name,$val);
		}
	} // tg_mhidden


	/**
		[mSelect name="selectLang" defval="aaa" listval="fr,em; fr,de,it; fr,de,it,en; en,fr; fr,de,it,en,cn" sep=";" /]
		
		Specific attributes :
			defrank : to specify a default rank / value, very usefull or indispensable when the values are very large or language dependant!
	*/
	function tg_mselect(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		
		if ($v['flexindex']===_c_ok && !$fls->polyvalentIndex()){
			return '';
		}
				
		// Label parameters :
		$labelStr= $tools->binLoads($v['lbl'],'');
		$labelStr= $glob->choosEsl($v,$labelStr,'3');
		if ($labelStr!==''){
			$labelStr= $caps->span($labelStr,'forMnWdgtTbLbl');
		}
		
		// Select		
		$listVal= $v['listval'];	// list of values
		$listDspl= $v['listdspl'];	// list to display
				
		if ($listDspl===false){
			$listDspl= $listVal;
		}
		
		if ($v['expand']===_c_ok){
			$specVal= $glob->choosEsl($v,$listVal,'2',false);
			if ($specVal!==false){
				// got at least one 'sl','el','es' with the index 2
				$this->langDVJustDisplay= true;
				
				$listDspl= $tagsFu->expand($specVal);
			
				$this->langDVJustDisplay= false;
				$listVal= $tagsFu->expand($specVal);
			}
		}else{
			$listVal= $glob->choosEsl($v,$listVal,'2',false);
			$listDspl= $glob->choosEsl($v,$listDspl,'4',false);
		}
		
		$sep= $tools->binLoads($v['sep'],',');
		
		/*
			define('_c_mDefDblQtSubst','╬');	// double quote substitute so the double quote information can be stored inside a standard html select box
		*/
		
		$substDQ= $v['gotdq']===_c_ok;
		if ($substDQ){
			// got " inside,$listVal so substitute c_mDefDblQtSubst
			$valVect= $tools->mbExplodeAndTrim($listVal,$sep,true, '"',_c_mDefDblQtSubst);
		}else{
			$valVect= $tools->trimStrToVect($sep,$listVal);		// list value vector
		}
		
		$dsplVect= $tools->trimStrToVect($sep,$listDspl);	// list display vector
				
		$cls= $tools->binLoads($v['cls'],'');
		if ($cls!==''){
			$cls= $caps->matCss($cls);
		}
		
		$combiV= array_combine($valVect,$dsplVect);
		$br= $this->wdgtBreaks($v);
		
		$specLrgInt= $v['speclrgint'];	// to detect large int availability and impose ok as default value if available!
		if ($specLrgInt===_c_ok){
			$defval= $tools->corePhpGotLrgeInt();
		}else{
			$defvgv= $v['defvgv'];	// default value General Variables got the priority if defined!
			if ($defvgv!==false){
				$defval= $dtb->getGenVar($defvgv);
			}else{
				$defval= $v['defval'];	// STANDARD default value
			}
		}
		
		
		$name= $v['name'];
		$chosenVal= $tools->postVal($name,$defval);
		
		$defDtbValue= $v['defindtb']!==false;
		$dtbInitN= $v['dtbinitn'];	// direct Dtb default value (same use as 'defindtb' but more intuitive
		
		$defRank= $v['defrank'];
		if ($defRank!==false){
			if ($chosenVal===false){
				if ($defDtbValue || $dtbInitN!==false){
					// need to use a dtb stored def rank 
					
					if ($dtbInitN!==false){
						$defval= $dtb->getGenVar($dtbInitN);
						$defRank= false;
					}else{
						$defRank= $dtb->getGenVar($name);
						$defval= $this->keyFromRank($combiV,$defRank);
					}
					
				}else{
					$defRank= $v['defrank'];
					$defval= $this->keyFromRank($combiV,$defRank);
				}
			}else{
				// got posted
				$defRank= $this->keyRank($combiV,$chosenVal);
				
				if ($defDtbValue){
					$dtb->setGenVar($name,$defRank);
				}				
				$defval= $this->keyFromRank($combiV,$defRank);
			}
		}else{
			$defval= $chosenVal;
		}
		
		$defInDtb= $v['defindtb']===_c_ok;
		$targeTB= $v['targetb'];
		if ($targeTB!==false){
			/*
				Need to make sure we don't bother the html beowser storage & javascript with double quotes
				---> mbReplace()
			*/
			if ($substDQ){
				$js= $caps->jsFunctCallStr('onchange','formMainWdgt.fromSlctToQtSubstTxtBx',3,0,$name,$targeTB,_c_mDefDblQtSubst);
			}else{
				$js= $caps->jsFunctCallStr('onchange','formMainWdgt.fromSelectToTextBox',2,0,$name,$targeTB);
			}
		}else{
			$js= '';
		}
				
		$bAct= $br.$labelStr.$caps->comboBox($name, $defval, $combiV,  $cls.$js,  true,true, $defRank);
		if ($v['onlyactive']===_c_ok){
			$this->activeWdgtStr.= $bAct;
		}else{
			$this->activeWdgtStr.= $bAct;
			
			// valfeedb
			$feedB= $tools->binLoads($v['valfeedb'],_c_ok);	 //  defauklt ok --> display a fedd back value
			if ($feedB===_c_ok){
				$this->sentWdgtStr.= $br.$labelStr.$chosenVal;
			}else{
				$this->sentWdgtStr.= $br.$labelStr;
			}
		}
	} // tg_mselect

	
	/**
		For the given vector, gives back the rank [1 .. sz] of the given key if it it exists, false otherwise.
		In case of multiple identical values returns the 1st one
	*/
	function keyRank(&$v,$k){
		if (array_key_exists($k,$v)){
			$i= 0;
			reset($v);
			foreach ($v as $key=>$val){
				if ($key===$k){
					return $i+1;	// +1 --> ordinal rank
				}
				$i++;
			}
		}else{
			return false;
		}
	} // keyRank

	
		
	/**
		For the given vector, gives back the key matching the rank.
	*/
	function keyFromRank(&$v,$rank){
		$rank--;	// from ordinal rank to array index convention -1
	
		$i= 0;
		reset($v);
		foreach ($v as $key=>$val){
			if ($rank===$i){
				return $key;
			}
			$i++;
		}
		return false;
	} // keyFromRank
	
		
	/**
		KEEP IT, will become deprecated, probably not used! If used will bug explicitely !!!
	
		[langDsplVal dspl="Europeen languages" codeNeutral="kapf" /]
		----> display the value matching the _c_CodeTransTbl tag valg or codeNeutral depending which one is available!
		To be used inisde _c_CodeTransTbl, so $v[dspl] already got the correct language!
	*/
	function tg_langdsplval(&$v,&$bd){
		$dtb= &$this->dtb;
		
		if ($this->langDVJustDisplay){
			return $v['dspl'];	// to be displayed
		}else{
			$codeNeutral= $v['codeneutral'];
			return $dtb->getElem(_c_SurfTransTN, _c_srfTransId,$codeNeutral, _c_srfTrans);	// the values
		}
	} // tg_langdsplval

		
	/**
		[mlabel lbl="aaaa" css="" /]
	*/
	function tg_mlabel(&$v,&$bd){
		$fls= &$this->fls;
	
		$fixeDir= $v['fixedir'];
		$fixedMess= $fixeDir===_c_ok && !$fls->polyvalentIndex();
		if ($fixeDir===false || $fixedMess){
			$lbl= $this->labelCore($v);
			
			if ($v['onlyactive']===_c_ok){
				$this->activeWdgtStr.= $lbl;
			}else{
				$this->activeWdgtStr.= $lbl;
				$this->sentWdgtStr.= $lbl;		
			}
		}
	} // tg_mlabel


	/**
	*/
	function tg_mdatadirname(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
	
		if ($v['fixedir']===_c_ok && !$fls->polyvalentIndex()){
			$css= $tools->binLoads($v['css'],'forMnWdgtTbLbl');
			// $lbl= $caps->span(_c_usrStandardDirN,$css);
			$lbl= $caps->span(_c_userDataDirName,$css);
			
			// if ( file_exists(_c_taoxStanDataDir) ){
			if ( file_exists(_c_nsUsrDataPath) ){
				$lbl.= $caps->span(' '.$glob->el('Warning the previous mentioned directory already exists ...','kbln'),'forMnWdgtNwSiteErr');
			}
			
			$this->activeWdgtStr.= $lbl;
			$this->sentWdgtStr.= $lbl;
		}
	} // tg_mdatadirname

		
	/**
		Could be used at other spots !!
	*/
	function labelCore(&$v){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$br= $this->wdgtBreaks($v);
		
		// Label parameters :
		$lbl= $tools->binLoads($v['lbl'],'');
		$lbl= $glob->choosEsl($v,$lbl);
		if ($lbl!==''){
			$css= $tools->binLoads($v['css'],'forMnWdgtTbLbl');
			$lbl= $caps->span($lbl,$css);
		}
		return $br.$lbl;
	} // labelCore


	/**
		[mHeaDiv style="width:900px; border:1px solid blue;" /]
	*/
	function tg_mheadiv(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		
		$style= $tools->binLoads($v['style'],'');
		$id= $tools->binLoads($v['id'],'');
		$js= $tools->binLoads($v['js'],'');
		$cls= $tools->binLoads($v['cls'],'');
	
		$hd= $caps->heaDiv($style,$id,$js,$cls);
		
		$this->activeWdgtStr.= $hd;
		$this->sentWdgtStr.= $hd;
	} // tg_mheadiv


	/**
		[mEnDiv /]
	*/
	function tg_mendiv(&$v,&$bd){
		$caps= &$this->caps;
		$this->activeWdgtStr.= $caps->enDiv();
		$this->sentWdgtStr.= $caps->enDiv();
	} // tg_mendiv


	/**
		[mBr /]
	*/
	function tg_mbr(&$v,&$bd){
		$this->activeWdgtStr.= _c_BrFlux;
		$this->sentWdgtStr.= _c_BrFlux;
	} // tg_mbr


	/**
		[displayFuValue fu="lastGeneratedDtbNm" css="forMnWdgtTaLbl" /]
		To display a value calculated by a specified function. (simplification, on)
		May add a param to the function later on!
	*/
	function tg_displayfuvalue(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$caps= &$this->caps;
	
		$fu= $v['fu']; 		// to do somnething with the chosen style generally subtitute it inside a css
		$cl= $tools->binLoads($v['cl'],'extractor');	// class name! Rem can short circuit to $this in case of self refenrence to 'installer'
		$categ= $tools->binLoads($v['categ'],_c_exeClassCateg);
		
		$cl= $tagsFu->optimClassAccess($categ,$cl,$cl);		// from the class name to the class instance
		$css= $v['css']; 
		$fuVal= $cl->$fu();
		$fuFormatStr= $caps->span($fuVal,$css);
		
		$this->activeWdgtStr.= $fuFormatStr;
		$this->sentWdgtStr.= $fuFormatStr;
	} // tg_displayfuvalue


	/**
		to associate a text box value with a given function.
		[displayFuValTB fu="lastGeneratedDtbNm" css="forMnWdgtTaLbl" /]
	*/
	function tg_displayfuvaltb(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$caps= &$this->caps;
	
	
		$name= $v['name'];
		$clName= $tools->binLoads($v['cl'],'extractor');	// class name! Rem can short circuit to $this in case of self refenrence to 'installer'
		$categ= $tools->binLoads($v['categ'],_c_exeClassCateg);
		
		$cl= $tagsFu->optimClassAccess($categ,$clName,$clName);		// from the class name to the class instance
		$css= $v['css'];
		
		
		$fu= $v['fu']; 		// to do somnething with the chosen style generally subtitute it inside a css
		if ($fu!==false){
			$tbVal= $v['tbval'];
			if ($tbVal===false){
				$fuVal= $cl->$fu();
			}else{
				$fuVal= $tbVal;
			}
		}else{
			$fuVal= 'The method '.$clName.'::'.$fu.' is not declared!'; // private use!
		}
		
		$postedVal= $tools->postVal($name,$fuVal);
		$fuFormatStr= $caps->textBx($name,$postedVal,20,$css);
		
		$this->activeWdgtStr.= $fuFormatStr;
		$this->sentWdgtStr.= $postedVal;
	} // tg_displayfuvaltb
	


	/**
		[integerInfoTag /]
	*/
	function tg_integerinfotag(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
	
		$str= '?';
		if ($tools->corePhpGotLrgeInt()===_c_ok){
			$ttl= $glob->sl('Large integers capabilities...','kaxa');
		}else{
			$ttl= $glob->sl('Only small integers capabilities...','kaxb');
		}
	
		$mainStr= $caps->spanTtl($str,'forMnWdgtInfo',$ttl);
		$this->activeWdgtStr.= $mainStr;
		$this->sentWdgtStr.= $mainStr;
	} // tg_integerinfotag


	/**
		[likelyMySqlStr /]
	*/
	function tg_likelymysqlstr(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
	
		$str= $glob->sl('Probably "localhost" but could be something like : ','kapv').'"sql.'.$fls->domainName().'"';
		$ttl= $glob->sl('Url to access a website database','kapw');
		
		$mainStr= $caps->spanTtl($str,'forMnWdgtInfo',$ttl);
		$this->activeWdgtStr.= $mainStr;
		$this->sentWdgtStr.= $mainStr;
	} // tg_likelymysqlstr


	/**
		[genInfoTag /]
	*/
	function tg_geninfotag(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
	
		$str= $tools->binLoads($v['str'],'?');
		$ttl= $glob->choosEsl($v,$v['ttl']);
		
		$mainStr= $caps->spanTtl($str,'forMnWdgtInfo',$ttl);
		$this->activeWdgtStr.= $mainStr;
		$this->sentWdgtStr.= $mainStr;
	} // tg_geninfotag


		
	/**	
		[inclDtbSensitCode id="InstallerDtbMySql" /]
		
		Incluude the database-kind sensiitive given code ($v['id']) if contextually correct and adapt the genVar::kindDtbToInstall value on the url eponyme!
	*/
	function tg_incldtbsensitcode(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$keyStr= 'kindDtbToInstall';
		$urlKd= $tools->getVal($keyStr);	// url kind
		$dtbKd= $dtb->quickGetGenVar($keyStr);		// dtb kind
		switch ($urlKd){
			case 'aMySql':
				if ($urlKd!==false && $urlKd!==$dtbKd){
					$dtb->setGenVar($keyStr,$urlKd);
				}
				$dtbKd= $urlKd;
			break;
			
			case 'simulSql':
				if ($urlKd!==false && $urlKd!==$dtbKd){
					$dtb->setGenVar($keyStr,$urlKd);
				}
				$dtbKd= $urlKd;
			break;
			
			default:;	// uses the current $dtbKd
		} // switch


		switch ($dtbKd){
			case 'aMySql':
				return $tagsFu->includeRec($v['idmysql'],_c_idCodeTbl,_c_ictCode,true,false);
			break;
			
			case 'simulSql':
				return $tagsFu->includeRec($v['idsimul'],_c_idCodeTbl,_c_ictCode,true,false);
			break;
			
			default:
				return 'Error in formMainWdgt::tg_incldtbsensitcode';
		} // switch
	} // incldtbsensitcode
	
		
} // formMainWdgt
?>
