<?php
/**
	File name : formpKernel.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="formpKernel" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class formpKernel extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->dtb= &$tagsFu->dtb;		
		$this->acc= &$tagsFu->acc;		
		$this->rights= &$tagsFu->rights;		
		$this->glob= &$tagsFu->glob;		
		$this->fls= &$tagsFu->fls;		
		$this->initMT= &$tagsFu->initMT;		
		
		
		$this->resetCountFormLbl();
		
			
		define('_c_defLblCls','formLbl');			// default form label class	
		define('_c_defCkWgtCls','checkWidget');		// default form check widget class	
		define('_c_defSelWgtCls','selectWidget');	// default form select class	
		
		define('_c_chkFormState','hidWidgetResNm');		// to check if the form was sent
		
		
		/*
			To format the text on the form receiving side.
		*/
		define('_c_mgCouplePos','couplePos');	// General prefix for the following values ... manage widg/val couple position
		define('_c_formLabelCrNl','newLn');		// A new line, on the form side and on the message reception side.
		define('_c_formIncrNop','cBuff');		// A no special operation increase, so can increase the counter of 
			// form results (get a bit of space) and does not imply an operation, but other tags could use the current step for their operation.
			
		/* Remark for the 2 following tags : why not a single xml2 tag? Because it does not seems practicle, because
		the result to display is not during xml2 execution, but jut for the form results that are dealt with  the 
		formatFormRes() function. */
		define('_c_formGotHeadDiv','headDiv');	// To define a <div> when displaying the results of the form		
		define('_c_formGotEndDiv','endDiv');	// To define the corresponding end : </div>
		
		
		define('_c_lblValSameLn','lblVal');		// One couple label value follows on the same line
		define('_c_valLblSameLn','valLbl');		// One couple value label follows on the same line
		define('_c_valLblCrNl','valLblLn');		// One couple value label follows on the same line
		

		define('_c_condBuffDep','condBuffDep');		
		define('_c_condBuffCond','condBuffCond');
		
		
	
		/*
			Generated automatically associated with an index and used to store the widget name. Wigets names
			can be given a name manually, so it's easier to assign actions to their values on the server side.
		*/
		define('_c_hWdgtNamePfx','hWdgtName');	// hidden widget name prefix
		define('_c_autoWdgtNmPrfx','autoWdgtNmPrfx');	// automatic widget name prefix used if a specific name is not given
		define('_c_formResNbSp','formResNbSp');	// to manage nbsp on the result side.		
		
		
		define('_c_hiFormLbl','hFormLbl');		// to pass the label to the server with a hidden widget
		
		define('_c_formHeadDivPfx','hDivPfx');	
		define('_c_formEndDivPfx','eDivPfx');		
		
		$this->vectError= array();
		


		/*
			Default Ares Box initialisation
				[formDefTA str="text content" width="60" height="8" cls="ln" min="1" max="1000" /]
		*/
		$tagsFu->attribVect['formdefta']= array('str','width','height','cls','min','max');
		
		/*
			Default text box initialisation :
				[formDefTB str="write here" sz="20" cls="" min="3" max="50" /]
		*/
		$tagsFu->attribVect['formdeftb']= array('str','sz','cls','min','max');
		
		
		
		/*
			tg_eform(...)  [eForm .... ].... [/eForm]
			Automatical electronic form (Form).
			Parameters :
				name : the name of the form widget
				url : the facultative url parameter :
							if given {
								if (first char === #){
									---> concatenation of the following part of the string onto the current page address.
								}else{
									---> uses the url directly
								}
							}else{
								--> uses the url coming from the function.
							}
				
				specpath : specification class.	 (specpath), ONLY FOR NON PLUGINS
				path :	the path to access classn with end slash (only used for explicit functions).
				classn : the name of the class holding the action function "action".
				action : the name of the action function called by the form.				
				
				
				widgets : name of some widgets (used by the action function) inside the form separated by spaces.
								
				
				stl : inline style applyed to the font tag.
				cls ; class applyed to the font tag.
				font : (facultaive) font used for the display ... passed to the widgets inside the form tag!
				
				sep : (facultaive) separator for the displayed elements..
				delayxml : to delay the xml execution, this must be used with a code balise to not execute the xml the first time.
					Then when we want to execute it, it has been returned by the tg_code() method, therefore the code balise
					disapeared and does not stop execution anymore.
				method : the html form method (almost "POST" all the time).
		*/
		$tagsFu->attribVect['eform']= array('name','url','js','rem', 'specpath','path','classn','action', 'widgets','stl','cls','font','sep','delayxml','method');
		
		
		
		// [justform] ... tg_justform()
		$tagsFu->attribVect['justform']= false;
		
		// [justFormResult] ... tg_justresult()
		$tagsFu->attribVect['justformresult']= array('wgtck');	// wgtck : widgetCheck


		
		
		// tg_lblwgt(). [lblWgt /] Label only for widgets / boxes		
		$tagsFu->attribVect['l']= array('cls');	// Special div for the form with memorisation of the label.
		$tagsFu->attribVect['lblwgt']= array('cls');	// Special div for the form with memorisation of the label.
		
		// tg_lbl(). Label. !!! hid == ok == default --> add an hidden widget!
		$tagsFu->attribVect['lbl']= array('cls','rem','hid','eb','sb');	// Special div for the form with memorisation of the label.
		
		
		$tagsFu->attribVect['checkbox']= array('name','val','setval','cls','js');
		$tagsFu->attribVect['radiobut']= array('name','val','setval','cls');
		
		/*
			tg_textbox() : [textBox name="x" str="write here" sz="20" cls="" min="3" max="50" /]
				str : the default string.
				sz : the size of the box.
				sccstr : short circuit the displayed value with $v['str']
		*/
		$tagsFu->attribVect['textbox']= array('name','str','sz','cls','min','max','lim','pwbx','email','sccstr');
		$tagsFu->attribVect['txtbox']= array('name','str','sz','cls','min','max','lim','pwbx','email','sccstr');
		
		
		/*
			[textArea name="x" str="text content" width="60" height="8" cls="ln" min="1" max="1000" /]
				str : the default string.
				sz : the size of the box.
		*/
		$tagsFu->attribVect['textarea']= array('name','str','width','height','wysi','nice','cls','min','max','sccstr');
		
		
		// tg_button() : [button name="but" str="SEND" cls="" /]
		$tagsFu->attribVect['button']= array('name','str','cls','js');
		
		
		$tagsFu->attribVect['jsbutton']= array('name','str','es','cls','min','max','fu');
		
		
		// Reserved suffix for hidden field going along with the checkanswer Tag
		// define('_c_checkerSffx','_rsvChk');				
		// Could use a general tag for the form, passed as a global variable to avoid multi param.		
		$tagsFu->attribVect['checkanswer']= array('name','hidname','mess');
		
				
		// 	[oneInManyW widgetList="" name="sortOfService" mess="Please fill the left field." /]
		$tagsFu->attribVect['oneinmanyw']= array('widgetlist','name','mess','hidname');
		
		
		$tagsFu->attribVect['selectnumbers']= array('name','defval','min','max','cls','filler','sccdef');
		$tagsFu->attribVect['selectwhatever']= array('name','cls','defval','listval','listdspl');														
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('formpKernel','debugDisplay',false);	
		$tagsFu->attribVect['testplug']= array('display');
		
		$this->globalInitTbTa();
	} // construct


	/**
	*/
	function tags(){
		return array('testplug', 'lbl', 'lblwgt', 'l', 'eform', 'justform', 'justformresult', 'form', 'txtbox', 
		'textbox', 'textarea', 'checkbox', 'radiobut', 'button', 'jsbutton', 'formdefta', 'formdeftb', 'checkanswer', 
		'oneinmanyw', 'selectnumbers', 'selectwhatever');
	} // tags


	/**
		Define an html form with associated actions defined in class variable functions
		having the parameter-value name.
			Note :
				$this->vectError : is the condition to treat user input errors (loaded by the error tags themself)
	*/
	function tg_eform(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$tagsFu= &$this->tagsFu;
		
		$vUrl='';
		$combinedUrl= false;
		$url= $v['url']; // hard & || soft Url
		$urlSz= strlen($url);
		if ($url!==false){
			// $combinedUrl is there to avoid having to fill a full local url, so adds the root automatically
			// note : $combinedUrl encompass the full information of $url without any lost!
			if ($url[0]==='#'){
				// standard same page meaning + correct concatenation of the string after #)
				if ($urlSz===1){
					$combinedUrl= '#';
				}else{
					$combinedUrl= $tools->urlCurPg().$fls->delFirstChar($url);
				}
			}else{
				$combinedUrl= $url;
			}
		}
		
		$name= $this->autoOrGivenName($v);
		$action= $v['action'];
		$widgetNames= $v['widgets'];	// widget names eventually used in the variable functions
		
		$stlStr= '';	// total style + class + ? string
		if ($v['stl']!==false){
			$stlStr.= $caps->matStyl($v['stl']);
		}		
		
		if ($v['cls']!==false){
			$stlStr.= $caps->matCss($v['cls']);
		}
				
		$method= $tools->binLoads($v['method'],'POST');
		$font= $tools->binLoads($v['font'],'ln');
		$sep= $tools->binLoads($v['sep'],' --- ');	
		$delayxml= $v['delayxml'];
				
		$actionResults='';
		$fSccd= $this->formSucceeded();
		
		if ($fSccd && $action!==false ){
			// the form was sent without any error
			$path= $tools->binLoads($v['path'],'');		// path of the class name
			$specPath= $v['specpath'];
			$classN= $v['classn'];
			
			if ($specPath===false){
				// Plugins ONLY
				$curClass= $tagsFu->instancAnyPlug($action,$path,$classN);
				if ($curClass!==false){
					// Input parameters of $action() come from the $_POST array
					$actionResults= $curClass->$action($vUrl);	// VARIABLE FUNCTION (Input : posted.params, $vUrl to feed the form)
				}else{
					$glob->userError($action.' does not exists!'._c_);
				}
			}else{
				// Not a plugin, so got a path specification to allow a global reach, 
				if (array_key_exists($classN,$tagsFu->explicitClasses)){
					$curClass= &$tagsFu->explicitClasses[$classN];				
				}else{
					// but don't want to specify the full hierarchy, so uses categories.
					switch ($specPath){
						case 'external':
							$pathPrfx= _c_toDeclPlugExt;
						break;
										
						case 'plugins':
							$pathPrfx= _c_pluginPath;
						break;
						
						default:
							$pathPrfx= _c_CodePath;	// the root
					} // switch
								
					include $pathPrfx.$path.$classN.'.php';
					$curClass= new $classN($tagsFu);
					$tagsFu->explicitClasses[$classN]= &$curClass;
				}
				
				$actionResults= $curClass->$action($vUrl);	// VARIABLE FUNCTION (Input : posted.params, $vUrl to feed the form)
			}
		}
	
		if ($delayxml===_c_ok){
			// Rem : special case of ->mediaManager()
			$bd= $tagsFu->expand($bd,'eform');	// the "xml" in $bd was delayed and must be executed now
		}
			
		$content= $caps->hiddenWdg(_c_chkFormState,_c_ok).$bd;
		if ($combinedUrl!==false){
			$vUrl= $combinedUrl;
		}
		
		$js= $v['js'];
		
		return $caps->form( $vUrl,
			$name,
			$content.$actionResults,
			$stlStr.$js,
			_c_genHidWdgtFormNm,
			$method );
	} // tg_eform

	
	/**
		[justForm]...[/justForm]
		
		This tag pair should be placed around the form widgets to allow
		them to appear until the form is successfully sent!
	*/
	function tg_justform(&$v,&$bd){
		if ( $this->formSucceeded() ){
			return '';
		}else{
			return $bd;
		}	
	} // tg_justform


	/**
		[justFormResult]...[/justFormResult]
		
		This tag pair should be placed around the form result tags to allow
		them to appear only when the form was successfully sent!
	*/
	function tg_justformresult(&$v,&$bd){
		$tools= &$this->tools;
	
		$wgtCk= $tools->binLoads($v['wgtck'],_c_ok);
		if ( $this->formSucceeded($wgtCk) ){
			return $bd;
		}else{
			return '';		
		}	
	} // tg_justformresult


	/**
		True if the form was sent without any error.
		Input:
			$wgtCk : ok --> got to check the widgets vectError.
	*/
	function formSucceeded($wgtCk=_c_ok){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$ctrlSent= $tools->postVal(_c_chkFormState,_c_ko);
		if ($ctrlSent!==_c_ok){
			return false;
		}
		
		if ( defined('_c_genCaptchaIsOn')  ){
			$genCptchCls= &$tagsFu->explicitClasses['genCaptcha'];
			$genHash= &$genCptchCls->genHash;
			
			if ( $genHash->captchaIsCorrect() ){
				// ok, nothing more to do, just go to the next steps
			}else{
				return false;	// false, so stop looking for errors
			}
		}
		
		
		if ($wgtCk===_c_ok){
			// Checks other fields
			return $this->onlyFalse($this->vectError);
		}else{			
			// don't need to check the widgets at the php level
			return true;
		}
	} // formSucceeded


	/**
		$init : -1 by default because numerotation of widgets starts at 0 and increase is done before
			defining the widgets. But can pass 0 before scanning for result display.
	*/
	function resetCountFormLbl($init=-1){
		$this->countFormLbl= $init;	// count form labels.
	} // resetCountFormLbl
	
	
	/**
		Return the automatic or the xml2 user formated name.
	*/
	function autoOrGivenName(&$v){
		if ($v['name']===false){
			return _c_autoWdgtNmPrfx.$this->countFormLbl;
		}else{
			return $v['name'];
		}
	} // autoOrGivenName
	
	/**
		Checks if the given vector holds only false values.
	*/	
	function onlyFalse(&$v){
		reset($v);
		foreach ($v as $key=>$val){
			if ($val!==false){
				return false;
			}
		}
		return true;
	} // onlyFalse	


	/**
		Label only on the widgets side.
	*/
	function tg_lblwgt(&$v,&$str){
		return $this->tg_l($v,$str);
	} // tg_lblwgt
	
	
	function tg_l(&$v,&$str){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$cls= $tools->binLoads($v['cls'],_c_defLblCls);
		return $caps->span($str,$cls);
	} // tg_l
		
	
	/**
		Dynamic Form Label with associated hidden widget to recover the label itself.
		Example : [lbl cls="menuIndent"] .... [/lbl]
			[lbl] .... [/lbl]
	*/		
	function tg_lbl(&$v,&$str){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$eb= $v['eb'];
		if ($eb!==false){
			$str= $glob->es($str,$eb);
		}else{
			$sb= $v['sb'];
			if ($sb!==false){
				$str= $glob->st($str,$sb);
			}
		}
		
		$cls= $tools->binLoads($v['cls'],_c_defLblCls);
		$rem= $v['rem'];
		if ($rem!==false){
			$str= $caps->linkTC('#',$str,$rem,$cls);
		}		
	
		$hid= $tools->binLoads($v['hid'],_c_ok);
		if ($hid===_c_ok){
			$hd= $caps->hiddenWdg(_c_hiFormLbl.$this->countFormLbl, $str);
		}else{
			$hd= '';
		}
		
		return $hd.$caps->div($str,$cls);
	} // tg_lbl
	


	/**
		Set the default value for tg_textbox()
		[formDefTB  sz="10" cls="formTB" min="1" max="50" /]
	*/
	function tg_formdeftb(&$v,&$bd){
		$tools= &$this->tools;
		
		$this->formTBoxDefSz= $tools->binLoads($v['sz'],'10');
		$this->formTBoxDefCss= $tools->binLoads($v['cls'],'formTB');
		$this->formTBoxDefMin= $tools->binLoads($v['min'],'1');
		$this->formTBoxDefMax= $tools->binLoads($v['max'],'50');
	} // tg_formdeftb
	
	/**
		Set the default value for tg_textarea()	
		[formDefTa str="" width="60" height="5" cls="formTA" min="1" max="5000" /]
	*/
	function tg_formdefta(&$v,&$bd){
		$tools= &$this->tools;
		
		$this->formTaDefStr= $tools->binLoads($v['str'],'');
		$this->formTaDefW= $tools->binLoads($v['width'],'60');
		$this->formTaDefH= $tools->binLoads($v['height'],'5');
		$this->formTaDefMin= $tools->binLoads($v['min'],'1');
		$this->formTaDefMax= $tools->binLoads($v['max'],'5000');
	} // tg_formdefta
	
	
	/**
	*/
	function globalInitTbTa(){
		$this->formTBoxDefSz= '10';
		$this->formTBoxDefCss= 'formTB';
		$this->formTBoxDefMin= '1';
		$this->formTBoxDefMax= '50';
		
		$this->formTaDefStr= '';
		$this->formTaDefW= '60';
		$this->formTaDefH= '5';
		$this->formTaDefMin= '1';
		$this->formTaDefMax= '5000';
	} // globalInitTbTa
	
	

	
	/**
	*/
	function tg_txtbox(&$v,&$bd){
		return $this->textboxFu($v,$bd,false);
	} // tg_txtbox

	
	/**
	*/
	function tg_textbox(&$v,&$bd){
		return $this->textboxFu($v,$bd);
	} // tg_textbox

	/**
		So it's more intuitive to call it from another function widget.
	*/
	function textboxFu(&$v,&$bd, $autoName=true){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;

		if ($autoName){
			$name= $this->autoOrGivenName($v);
			$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$this->countFormLbl, $name);
		}else{
			$name= $v['name'];
			$hd= '';
		}
		
		if ($v['sccstr']===_c_ok){
			$content= $v['str'];
		}else{
			$content= $tools->postVal($name,  $tools->binLoads($v['str'],$bd) );
		}
		
		$boxSize= $tools->binLoads($v['sz'],$this->formTBoxDefSz);
		
		$attS= $tools->binLoads($v['cls'],'formTB');
		
		// conditions
		$min= $tools->binLoads($v['min'],$this->formTBoxDefMin);	
		$max= $tools->binLoads($v['max'],$this->formTBoxDefMax);
		
		if ($min===_c_ko){
			$errMess= '';
		}else{
			$errMess= $this->tbTaErrorMessage($content,$min,$max,$name,$v,true);
		}
		
		$lim= $tools->binLoads($v['lim'],'200');
		$pwBx= $v['pwbx'];
		$sty= $caps->matCss($attS);
		if ($pwBx===false){
			$box= $caps->textBox($name,$content,$boxSize,$sty,$lim);
		}else{
			// pwBx==="ok" 
			$box= $caps->brPasswordWdg($name,$content,$boxSize,$sty,$lim);
		}
				
		return _c_R.$hd.$box.$errMess;
	} // textboxFu

	/**
	*/
	function tg_textarea(&$v,&$bd){
		return $this->textarea($v,$bd);
	} // tg_textarea

	/**
	cls
	*/
	function textarea(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;

		$name= $this->autoOrGivenName($v);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$this->countFormLbl, $name);
		
		if ($v['sccstr']===_c_ok){
			$content= $v['str'];
		}else{
			$content= $tools->postVal($name, $tools->binLoads($v['str'],$this->formTaDefStr) );
		}
		
		$width= $tools->binLoads($v['width'],$this->formTaDefW);
		$height= $tools->binLoads($v['height'],$this->formTaDefH);
				
		// conditions
		$min= $tools->binLoads($v['min'],$this->formTaDefMin);	
		$max= $tools->binLoads($v['max'],$this->formTaDefMax);
		
		
		$cls= $tools->binLoads($v['cls'],'');
		if ($cls!==''){
			$cls= $caps->matCss($cls);
		}
		
		$errMess= $this->tbTaErrorMessage($content,$min,$max,$name,$v,false);
		$wysi= $tools->binLoads($v['wysi'],'ok');
		switch ($wysi){
			case 'ok':
				return _c_R.$hd.$errMess.$caps->ncTxtAreaKernel($name,$height,$width,$content,$cls,false,$max);
			break;
			
			case 'pureTA':
				return _c_R.$hd.$errMess.$caps->txArea($name,$height,$width,$content,$cls,'',$max);
			break;
			
			// a pseudo default because of the initialisaton of $wysi, so it's anything given explicitely for $v['wysi'] that is not 'ok' or 'pureTA'
			default:
				return _c_R.$hd.$errMess.$caps->textarea($name,$height,$width,$content,$cls,false,$max);
		}
	} // textarea
	
	
	/**
		[checkBox name="" val="ok" setval="ko" cls="" /]
	*/
	function tg_checkbox(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		$name= $this->autoOrGivenName($v);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$this->countFormLbl, $name);
		
		$val= $tools->binLoads($v['val'],_c_ok);
		$sentVal= $tools->postVal($name);
		if ($sentVal!==false){
			$setval= $sentVal;
		}else{
			$setval= $tools->binLoads($v['setval'],'');
		}	
				
		$cls= $tools->binLoads($v['cls'],_c_defCkWgtCls);
		if ($cls!==''){
			$cls= $caps->matCss($cls);
		}
		
		$js= $tools->binLoads($v['js'],'');
		return $hd.$caps->checkBox($name,$val,$setval,$cls.$js);
	} // tg_checkbox

	/**
		[radioBut name="" val="" setval="" stl="" /]
	*/
	function tg_radiobut(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		$name= $this->autoOrGivenName($v);
		$nameHidWgt= _c_hWdgtNamePfx.$this->countFormLbl;
		$hd= $caps->hiddenWdg($nameHidWgt, $name);
		
		$val= $tools->binLoads($v['val'],'');
		$postedVal= $tools->postVal($name);
		if ($postedVal===false){
			$setval= $tools->binLoads($v['setval'],_c_ko);	// 1st time
		}else{
			$setval= $postedVal;
		}
		
		$cls= $tools->binLoads($v['cls'],_c_defCkWgtCls);		
		if ($cls!==''){
			$cls= $caps->matCss($cls);
		}
		
		return $hd.$caps->radioBut($name,$val,$setval,$cls);
	} // tg_radiobut
	
	
	/**
		[checkAnswer name="" mess="Please fill the left field." /]
		Checks if the widget was answered to, and display a given message if it's not the case!
	*/
	function tg_checkanswer(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		
		$name= $v['name'];
		$mess= $v['mess'];		
		$hidName= $tools->binLoads($v['hidname'],_c_genHidWdgtFormNm);
		
		if ( $tools->postVal($hidName)===_c_ok // posted !
				&& $tools->postVal($name)===false ){
				
			$this->vectError[$name]= true;
			return $caps->font( $mess , 'errForm');
		}		
	} // tg_checkanswer

	
	/**
		[oneInManyW widgetlist="" name="sortOfService" mess="Please fill the left field." /]
		Checks if at least one in many widgets is answered.
	*/
	function tg_oneinmanyw(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		
		$name= $v['name'];
		$mess= $v['mess'];		
		$commaStr= $v['widgetlist'];
				
		$hidName= $tools->binLoads($v['hidname'],_c_genHidWdgtFormNm);
		
		if ( $tools->postVal($hidName)===_c_ok // posted !
				&& !$this->atLeastOneCheckB($commaStr) ){
				
			$this->vectError[$name]= true;
			return $caps->font( $mess , 'errForm');
		}		
	} // tg_oneinmanyw

	
	/**
		True if at least one widget CheckBox was checked and passed.
	*/
	function atLeastOneCheckB($commaStr){
		$tools= &$this->tools;
	
		$v= $tools->trimStrToVect(',',$commaStr);
		reset($v);
		foreach ($v as $key=>$nameWdgt){
			$valWdgt= $tools->postVal(trim($nameWdgt));
			if ($valWdgt!==false){
				return true;
			}
		}
		return false;
	} // atLeastOneCheckB

		
	/**
		Computes the error message for the text boxes and the text areas.
		Input :
			$content : widget content
			$min,$max : extreme values
			$name : the widget name!
			&$v : the concerned habitual widget vector
			$textBox : true if it's a text box!
	*/
	function tbTaErrorMessage($content,$min,$max,$name,&$v,$textBox){
		$g= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$rights= &$this->rights;
		
		$errorSize= false;
		$errorMail= false;
		
		$wdgtSent= $tools->postVal($name)!==false;
		if ($wdgtSent){
			$szCnt= strlen($content);
			
			if (!$rights->wRights){
				if ($szCnt<$min || $szCnt>$max){
					$errorSize= true;
				}
			}
			
			if ($textBox){
				$email= $v['email'];
				if ($email!==false){
					$errorMail= !$tools->isValidEmail(trim($content));
				}
			}
		}
		
		
		if ($wdgtSent && ($errorSize || $errorMail)){
			if ($errorMail){
				$errMess= $caps->font( $g->sl('! e-mail') , 'errForm');
			}else{
				$errMess= $caps->font($g->sl('The nb of characters','kayc').' '.$min.' & '.$max.$g->sl('.Actually ','kayd').$szCnt.$g->sl(' chars.','kaye'), 'errForm');
			}
			
			if (!$textBox){
				$errMess.= _c_R;
			}
			
			$this->vectError[$name]= true;
		}else{
			$errMess= '';
			$this->vectError[$name]= false;			// no error on that specific widget
			$this->vectContent[$name]= $content;	// so can manage that content in the form layer
		}		
		
		return $errMess;
	} // tbTaErrorMessage


	/**
		Javascript controlled button (the sent is JS made).
	*/
	function tg_jsbutton(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$rights= &$this->rights;
		
		
		$userId= $rights->realTimeUserId();
		
		$name= $this->autoOrGivenName($v);
		
		$label= $v['str'];
		$es= $v['es'];
		if ($es!==false){
			$label= $glob->es($label,$es);
		}
		
		$cls= $v['cls'];
		
		$min= $tools->binLoads($v['min'],6);
		$max= $tools->binLoads($v['max'],20);
		
		$fuName= $v['fu'];	
		switch ($fuName) {
			case 'genAsa.cryptPwBoxes':
				$smplFu= $caps->jsSimpleFu($fuName,9,0, $userId,_c_ckUniqPrfx,_c_c2JsPwCook,_c_c3JsPwCook,'oldPw','newPw1','newPw2',$min,$max);
			break;

			default:
				$smplFu= $caps->jsSimpleFu($fuName,0,0);
		}
						
		return _c_R.$caps->onClickButton($name,$smplFu,$label,$caps->matCss($cls));
	} // tg_jsbutton
	
	
	/**
	*/
	function tg_button(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
	
		$name= $this->autoOrGivenName($v);
		$butLbl= $glob->el($v['str'],'kaat');
		$label= $tools->postVal($name,$butLbl);
		$attS= $v['cls'];
		$js= $tools->binLoads($v['js'],'');
		return _c_R.$caps->submit($name,$label,$caps->matCss($attS).$js);
	} // tg_button
	

	/**
	*/
	function monthVector(){
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$lg= $dtb->currentLg();
		return $fls->monthVector($lg);
	} // monthVector
	
	
	/**
		[selectNumbers name="" defval="" min="1" max="10" /]
	*/
	function tg_selectnumbers(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$name= $this->autoOrGivenName($v);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$this->countFormLbl, $name);	
		
		
		if ($v['sccdef']!==false){
			$defval= $v['sccdef'];
		}else{
			$defval= $caps->loadDefVal($v,$name,'0');
		}	
		
		$min= $tools->binLoads($v['min'],1);	// smallest value
		$filler= $v['filler'];		
		if ($filler!==false){
			$vSelect[$min-1]= $filler;
		}
		
		$max= $tools->binLoads($v['max'],10);	// maximum value
		for ($i=$min; $i<=$max; $i++){
			$vSelect[$i]= $i;
		}
		
		$cls= $tools->binLoads($v['cls'],_c_defSelWgtCls);
		return $hd.$caps->comboBox($name,$defval,$vSelect,$caps->matCss($cls));
	} // tg_selectnumbers


	/**
		[selectWhatever name="aaa" defval="aaa" listval="png, jpg"  /]
	*/
	function tg_selectwhatever(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$name= $v['name'];
		$chosenVal= $tools->postVal($name);
		if ($chosenVal===false){
			$defval= $v['defval'];
		}else{
			$defval= $chosenVal;
		}
		
		$listVal= $v['listval'];	// list of values
		$listDspl= $v['listdspl'];	// list to display
		if ($listDspl===false){
			$listDspl= $listVal;
		}
		
		$listVV= $tools->trimStrToVect(',',$listVal);
		$listDV= $tools->trimStrToVect(',',$listDspl);
		
				
		$cls= $tools->binLoads($v['cls'],'');
		if ($cls!==''){
			$cls= $caps->matCss($cls);
		}
		
		$combiV= array_combine($listVV,$listDV);		
		return $caps->comboBox($name, $defval, $combiV,$cls ,true,true);		
	} // tg_selectwhatever

	
	/**
		The method used to test this plugin and call with 
			[testPlug display="Plugin trial of : " /]
	*/
	function tg_testplug(&$v,&$bd){
		$caps= &$this->caps;
				
		$dspl= '<h1>'.$v['display'].' formpKernel </h1>';		
		$dspl.= '<a href="#" class="someMoreFont" onClick="formpKernel.writeThreeTimes(\'formpKernel \')">One More Line !!! </a>';
		$dspl.= _c_sT;
		$dspl.= '<a href="#" class="someMoreFont" onClick="formpKernel.clearWrite(\'\')"> Clear !!! </a>';
		$dspl.= _c_;				
		
		// An area to display any javascript messages as a supplementary debug tool
		$area= '';		
		$area.= $caps->textarea('debugDisplay',19,40,'',$caps->matCss('someFont'));
		$area= $caps->sDiv($dspl._c_.$area, 'width:445px; border:2px solid red; padding:10px; margin:2px; float:left;');		
		return $area._c_;
	} // tg_testplug
		
} // formpKernel
?>
