<?php
/**
	File name : formpManager.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="formpManager" /]			[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
			
			
	Form Prety-Hard Manager : to have a non intrusive access to the primitive form manager before slowly 
	trying to get rid of it!
	
	formpManager::sendEMail()
*/
class formpManager extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		
		$this->tagsFu= &$tagsFu;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->dtb= &$tagsFu->dtb;	
		$dtb= &$this->dtb;
		
			
		$this->acc= &$tagsFu->acc;		
		$this->rights= &$tagsFu->rights;		
		$this->glob= &$tagsFu->glob;		
		$this->fls= &$tagsFu->fls;
		
		
		$this->fKern= $tagsFu->instExplitCentralCls('formpKernel');
		$fKern= &$this->fKern;
				
		// tg_r()  [r/]
		$tagsFu->attribVect['r']= false;
		
		// tg_formcount()  [formCount /]
		$tagsFu->attribVect['formcount']= false;
		
		// tg_matone()  [matOne/]
		$tagsFu->attribVect['matone']= false;
		
		// tg_matwo()  [maTwo /]
		$tagsFu->attribVect['matwo']= false;
	
		// tg_rtwo()  [rTwo /]
		$tagsFu->attribVect['rtwo']= false;
			
		// tg_formcondbuff() [formCondBuff dependant="eatingNb" cond="gZero" /]
		$tagsFu->attribVect['formcondbuff']= array('dependant','cond');
		
		// tg_nbs(),   [nbs cls="" times="3" /]
		$tagsFu->attribVect['nbs']= array('cls','times');
	
		
		
		// [selectMonth name="" defval="/" filler="/" cls="" /]
		$tagsFu->attribVect['selectmonth']= array('name','offsetdays','defval','cls','filler');

		// [selectYear name="" span="" defval="/" filler="/" cls="" /]
		$tagsFu->attribVect['selectyear']= array('name','offsetdays','cls','span','defval','filler');

		// [selectDay name="" /]
		$tagsFu->attribVect['selectday']= array('name','offsetdays','cls','defval','filler');
		
		
		
		// [selectTime name="" timestart="8:00" timeend="23:00" increment="10" /]
		$tagsFu->attribVect['selecttime']= array('name','timestart','timeend','increment','defval','cls');

		
		// [headD margin="20" /]
		$tagsFu->attribVect['headd']= array('margin','width');
		
		// [endD /]
		$tagsFu->attribVect['endd']= false;
		
		$tagsFu->attribVect['isvaliddate']=  array('name','errmess','warnmess','pastmess','daywn','monthwn','yearwn','deltat');
				
		// [arrivDepart .../]
		$tagsFu->attribVect['arrivdepart']=  array('name',
			'errank',								// ranking error arrival after departure!
			'dayarwn','montharwn','yeararwn',		// t..Arrival Widget Name
			'daydpwn','monthdpwn','yeardpwn');		// t..Departure Widget Name
		
			
		$tagsFu->attribVect['hiddenwdgt']=  array('name','val');
		
		$this->adminTitle= $dtb->getGenVar('formAdminTitle');
		$this->adminEmail= $dtb->getGenVar('formAdminEmail');		
		
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('formpManager','debugDisplay',false);	
	} // construct


	/**
	*/
	function tags(){
		return array('r', 'rtwo', 'formcount', 'matone', 'matwo', 'formcondbuff', 'headd', 'endd', 
		'nbs', 'selectmonth', 'selectyear', 'selectday', 'selecttime', 'isvaliddate', 'arrivdepart', 
		'hiddenwdgt', 'sendEMail');
	} // tags



	/* -----------------------------------------------------------------
		Start : Special format tags for the user feed-back
	*/
	
	/**
		Format style one : to associate first a Label and then a Couple.
		[matOne/]  : ---> a label-value couple follows on the same line.
	*/
	function tg_matone(&$v,&$str){
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;
		return $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl, _c_lblValSameLn);
	} // tg_matOne
	
	
	/**
		Format style two : to associate first a Couple and then a Label.
		[maTwo/]  : ---> a value-label couple follows on the same line.
	*/
	function tg_matwo(&$v,&$str){
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;
		return $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl, _c_valLblSameLn);
	} // tg_matwo
	

	/**
		[r/] : r a short hand for an html CR NL with effects on the display of the form results!
		The only widget mastering new line and $fKern->countFormLbl incrementation,
	*/
	function tg_r(&$v,&$str){
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;
		$hd= $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl, _c_formLabelCrNl);
		
		return $hd._c_BrFlux;
	} // tg_r
	
		
	/**
		[rTwo /]  : ---> a value-label couple follows on the same line.
	*/
	function tg_rtwo(&$v,&$str){
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;
		$hd= $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl,  _c_valLblCrNl);
		return $hd._c_BrFlux;
	} // tg_rtwo
		
	
	
	/**
		To set a head Div to format the user datas. Rem : sort of more intuitive to do it with 2 tags 
		associated in a pair rather with one single tag, and also more efficient.
			Example : [headD margin="20" width="580" /] 
	*/
	function tg_headd(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;	// increase the countor so don't need to add a [r/] in between to avoid interferences between tags.
		$hid= $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl, _c_formGotHeadDiv);
		
		
		$margin= $tools->binLoads($v['margin'],'20');
		$width= $tools->binLoads($v['width'],'500');
		$style= 'margin-left:'.$margin.'px; width:'.$width.'px; float:left;';
		
		
		return $hid . $caps->hiddenWdg(_c_formHeadDivPfx.$fKern->countFormLbl,$style).
			_c_R.$caps->heaDiv($style);
	} // tg_headd
	
		
	/**
		To finish the [headD ... /]
		Example : [endD/]
	*/
	function tg_endd(&$v,&$bd){
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;	// increase the countor so don't need to add a [r/] in between to avoid interferences between tags.
		$hd= $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl, _c_formGotEndDiv);
		
		return $hd.$caps->hiddenWdg(_c_formEndDivPfx.$fKern->countFormLbl,_c_ok).
			_c_R.$caps->enDiv();
	} // tg_endd


	
	function tg_formcount(&$v,&$str){
		$fKern= &$this->fKern;
		
		$fKern->countFormLbl++;
		return '';
	} // tg_formcount
	
	/*
		End : Special format tags for the user feed-back
	------------------------------------------------------------------ */

	
	/**
	*/
	function formFont($curCrLn,$str,$c,$hml){
		$caps= &$this->caps;
		if ($hml){
			return $curCrLn.$caps->font($str,$c);
		}else{
			return $curCrLn.$str;
		}
	} // formFont

	
	/**
		In fact only using the html part! So could deconstruct it
	*/
	function formCrLn($hml){
		if ($hml){
			return _c_BrFlux;
		}else{
			return _c_R;
		}
	} // formCrLn
	
	
	/**
		tg_nbs(),   [nbs cls="" times="3" /]
	*/
	function tg_nbs(&$v,&$bd){
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		$fKern= &$this->fKern;
			
		$fill= $tagsFu->tg_nbsp($v,$bd);
		$hd= $caps->hiddenWdg(_c_formResNbSp.$fKern->countFormLbl, $fill);	
		return $hd.$fill;
	} // tg_nbs
 	
	
	

	/**
		tg_formcondbuff() [formCondBuff dependant="eatingNb" cond="gZero" /]
		
		form Conditional Buffering : to allow the creation of a temporary buffer on the receiving side of the 
					form to display it or not depending on the given condition.
	*/
	function tg_formcondbuff(&$v,&$bd){		
		$caps= &$this->caps;
		$fKern= &$this->fKern;

		$dependant= $v['dependant'];
		$cond= $v['cond'];
		$fKern->countFormLbl++;
		$hd= $caps->hiddenWdg(_c_mgCouplePos.$fKern->countFormLbl, _c_formIncrNop);
		$hd.= $caps->hiddenWdg(_c_condBuffDep.$fKern->countFormLbl,  $dependant);
		if ($cond!==false){
			$hd.= $caps->hiddenWdg(_c_condBuffCond.$fKern->countFormLbl,  $cond);
		}
		return $hd;
	} // tg_formcondbuff



	/**
		Does the bufferization for formatFormRes(). Was extracted by brute force from the formatFormRes() so
		it explains the long param list.
		
		Call example :
			$this->bufferize($buffer,$headDiv,$curNbSp,$curCrLn,$formLbl,$wdgtVal,$font,$hml,$endDiv,$gotFormDiv,$lblFirst);
	*/
	function bufferize(&$buffer,$headDiv,$curNbSp,$curCrLn,
			$formLbl,$wdgtVal,$font,$hml,$endDiv,$gotFormDiv,$lblFirst){
			
		$caps= &$this->caps;
		$buffer.= $headDiv.$curNbSp;
		
		if (!$gotFormDiv && $wdgtVal != '0'){
			if ($formLbl.$wdgtVal !== ''){
				if ($lblFirst){
					$buffer.= $this->formFont($curCrLn, $formLbl.' '.$wdgtVal, $font,$hml);
				}else{
					$buffer.= $this->formFont($curCrLn, $wdgtVal.' '.$formLbl, $font,$hml);
				}
			}else{
				$buffer.= $curCrLn;
			}
		}
		$buffer.= $endDiv;
	} // bufferize


	/**
		Format the Form Results String to have a correct display for the user. Especially built for external
		users when we want to force them to follow specific patterns.
			Notes :
				The names of the main widgets countaining the user information are grabbed because of the hidden
				widgets _c_hiFormLbl.$i having autimatically generated names and countaining the name of their
				associated widget.
	*/
	function formatFormRes($font,$hml=true){
		$tools= &$this->tools;	
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fKern= &$this->fKern;
		
		$fKern->resetCountFormLbl(0);	
	
		// Scans the given widgets and build the full list
		$totDspl= '';
		$tempDspl= '';
		$endTmpBuffer= false;
		$tmpBufferOn= false;
		
		/* ------------------------------------------------------------------------------
			Scan through the list of ordered pair of labels and widgets to accumulate 
			a buffer of results or errors to display.
		*/
		$i= 0;
		while ($tools->postVal(_c_mgCouplePos.$i)!==false){
		
			$formLbl= $tools->postVal(_c_hiFormLbl.$i,'');			// current hidden widget name for the label
			$wdgtName= $tools->postVal(_c_hWdgtNamePfx.$i,'');		// CURRENT WIDGET NAME
			$curNbSp= $tools->postVal(_c_formResNbSp.$i,'');		// current non breakable space
			
			$headDivStl= $tools->postVal(_c_formHeadDivPfx.$i,'');
			if ($headDivStl!==''){
				$headDiv= $caps->heaDiv($headDivStl.' float:left;');
			}else{
				$headDiv= '';
			}
		
			$gotEndDiv= $tools->postVal(_c_formEndDivPfx.$i,'');
			if ($gotEndDiv!==''){
				$endDiv=  $caps->enDiv();
			}else{
				$endDiv= '';
			}

			$buffDep= $tools->postVal(_c_condBuffDep.$i);
			$buffCond= $tools->postVal(_c_condBuffCond.$i);
			if ($buffDep!==false){
				if ($buffCond!==false){
					// got a buffer start
					$tmpBufferOn= true;
					
					$buffDependancy= $buffDep;	// to have the value until the end of the operation
					$buffCondition= $buffCond;
				}else{
					// got a buffer end
					$endTmpBuffer= true;
					$tmpBufferOn= false;
				}
			}else{
			}

			/* ----------------------------------------------------------
				Current management of couple (label-value) position
			*/
			$gotFormDiv= false;
			$couplePos= $tools->postVal(_c_mgCouplePos.$i);
			switch ($couplePos) {
				case _c_formLabelCrNl:
					$curCrLn= $this->formCrLn($hml);	// previously : $curCrLn= _c_BrFlux;
					$lblFirst= true;
				break;
				
				case _c_valLblSameLn:
					$curCrLn= '';
					$lblFirst= false;
				break;
				
				case _c_valLblCrNl:
					$curCrLn= $this->formCrLn($hml);;
					$lblFirst= false;
				break;

				case _c_formGotHeadDiv:
				case _c_formGotEndDiv:
					$gotFormDiv= true;
				break;
				
				case _c_formIncrNop:
					// no operation
				break;
						
				case _c_lblValSameLn:
				default:
					$curCrLn= '';
					$lblFirst= true;
				break;
			}			
			
						
			// Get the CURRENT WIDGET VALUE + Special action for special widgets
			$wdgtVal= $tools->postVal($wdgtName);
			switch ($wdgtName) {
				case 'mailCopy':
					if ($wdgtVal===false){
						$wdgtVal= 'no!';	// special check box display (otherwise no display at all)
					}
				break;
				
				
				case 'arrivalMth':
				case 'departureMth':
				case 'eatingMth':
					$mVect= $fKern->monthVector();
					$wdgtVal= $mVect[$wdgtVal-1];
				break;
				
				
				default:
					$wdgtVal= $tools->postVal($wdgtName,'');
			
			} // switch
						
			if ($endTmpBuffer){
				$cVal= $tools->postVal($buffDependancy);	// recovers the value we depend on to bufferize or not
							
				switch ($buffCondition) {
					case 'gZero':
						if ($cVal>=1){
							$okToBuff= true;
						}else{
							$okToBuff= false;
						}
					break;
					
					case 'ok':
						if ($cVal===_c_ok){
							$okToBuff= true;
						}else{
							$okToBuff= false;
						}
					break;
					
					default:
						// no conditions given, should not happend
						$glob->userError('Condition forgotten for the formCondBuff tag!');
					break;
				}			
			
			
				if ($okToBuff){
					$totDspl.= $tempDspl;
				}
				
				$tempDspl= '';
				$endTmpBuffer= false;
			}
			
						
			if ($tmpBufferOn){
				$this->bufferize($tempDspl,$headDiv,$curNbSp,$curCrLn,$formLbl,$wdgtVal,$font,$hml,$endDiv,$gotFormDiv,$lblFirst);
			}else{
				$this->bufferize($totDspl,$headDiv,$curNbSp,$curCrLn,$formLbl,$wdgtVal,$font,$hml,$endDiv,$gotFormDiv,$lblFirst);
			}
						
			$i++;
		} // while
		
		return $totDspl;
	} // formatFormRes
	
	
	/**
		$this->buildHeader($writerEMail,$this->adminTitle,$this->adminEmail)
	*/
	function buildHeader($emailTo,$titleFrom,$emailFrom){
		$headers  = 'MIME-Version: 1.0' . _c_R;
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . _c_R;
		// $headers .= 'To: '.$emailTo._c_R; // If added explicitely combined with 1st param of mail() et deliver th email twice!
		$headers .= 'From: '.$titleFrom.' <'.$emailFrom.'>' . _c_R;
		return $headers;
	} // buildHeader	
	
	/**
		Send an e-mail holding all the given parameters and manage the display of the information sent.
	*/
	function sendEMail(&$url){
		$tools= &$this->tools;	
		$acc= &$this->acc;
		$fls= &$this->fls;	
		$caps= &$this->caps;
		
		$font= 'formLbl';
		$writerEMail= $tools->postVal('email');
				
		$subject= $tools->postVal('infoWebmasterTtl','Webmail');				
		
		$totDspl= $acc->toHtmlCode( $this->formatFormRes($font) );
		
		// Saves the user data as a file.
		$htmlChronFN= $fls->hybridChronoFN(_c_UsrMailStorPath);	// file access
		$htmlChronUrl= _c_siteUrlAccess.$htmlChronFN;			// url access to the file (http protocol prefix)
		
		
		$htmlChronUrl= $caps->hLink($htmlChronUrl,$htmlChronFN);

		$htmlCapsTotDspl= $caps->internalFormat($totDspl,_c_mainCssDfn,false,_c_siteUrlAccess,false);
		$fls->strToFile($htmlChronFN,$htmlCapsTotDspl);


		$mailBody= $tools->postVal('infoWebmasterMain','Information:')._c_._c_;
		$mailBody.= $htmlChronUrl._c_._c_;
		$mailBody.= '<b>Message</b>'._c_._c_;
		$mailBody.= $totDspl;
		$htmlCapsMailBody= $caps->internalFormat($mailBody,_c_mainCssDfn,false,_c_siteUrlAccess,false);
		
		$headers= $this->buildHeader($this->adminEmail,$this->adminTitle,$this->adminEmail);		
		mail($this->adminEmail, $subject, $htmlCapsMailBody, $headers);
		if ($tools->postVal('mailCopy')===_c_ok){
			// Self copy email for prospect email archives.
			$headers= $this->buildHeader($writerEMail,$this->adminTitle,$this->adminEmail);
			mail($writerEMail, _c_siteUrlStample, $htmlCapsMailBody, $headers);
		}
		
		$url= $tools->urlCurPg(); // same page
		return $totDspl;
	} // sendEMail
	

	/**
		Combine and supplement conditionaly with the filler : $this->combineAndSup($v1,$v2,$filler)
	*/
	function combineAndSup($v1,$v2,$filler='ko'){
		$tools= &$this->tools;
		
		$v= array_combine($v1,$v2);
		if ($filler!=='ko'){
			$v= $tools->arrayFoulp($v,$filler,$filler);
		}
		return $v;
	} // combineAndSup


	/**
		From the hour minutes format to only minutes.
	*/
	function mixToMinutes($mix){
		$v= explode(':',$mix);
		$h= $v[0];
		$m= $v[1];
		return $h*60 + $m;
	} // mixToMinutes
	
	function minutesToMix($min){
		$m= (string)($min % 60);
		if (strlen($m)===1){
			$m= '0'.$m;
		}
		
		$h= floor($min / 60);
		return $h.':'.$m;
	} // minutesToMix
	
	/**
	*/
	function timeVector($tStart,$tEnd,$inc){
		for($t=$tStart; $t<$tEnd; $t=$t+$inc){
			$mix= $this->minutesToMix($t);
			$v[$mix]= $mix;
		}
		
		$mix= $this->minutesToMix($tEnd);
		$v[$mix]= $mix;
		return $v;
	} // timeVector

	
	/**
		Select specific hours between 00:00 and 24:00.
			Algo time in minutes, minimum increment of 1 minute.
			Parameters : hours:minutes
		[selecttime /]
	*/
	function tg_selecttime(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		$fKern= &$this->fKern;
		
		$name= $fKern->autoOrGivenName($v);
		$timeStart= $this->mixToMinutes($v['timestart']);
		$timeEnd= $this->mixToMinutes($v['timeend']);
		$inc= $tools->binLoads($v['increment'],'10');

		$defval= $caps->loadDefVal($v,$name,'');		
		
		$cls= $tools->binLoads($v['cls'],_c_defSelWgtCls);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$fKern->countFormLbl, $name);
		
		$timeVect= $this->timeVector($timeStart,$timeEnd,$inc);
		return $hd.$caps->comboBox($name,$defval,$timeVect,$caps->matCss($cls),true);		
	} // tg_selecttime


	/**
		Could shrink the 3 following functions!
	*/
			
	/**
	*/
	function tg_selectday(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		$fKern= &$this->fKern;

		
		$name= $fKern->autoOrGivenName($v);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$fKern->countFormLbl, $name);

		$offsetDays= $tools->binLoads($v['offsetdays'],0);
		$curDay= $glob->getDay($offsetDays);		
		$defval= $caps->loadDefVal($v,$name,$curDay);				
		
		$filler= $tools->binLoads($v['filler'],'ko');
		
		$cls= $tools->binLoads($v['cls'],_c_defSelWgtCls);
		
		$vDay= $tools->numStrVect(1,31);
		$dayssAssArr= $this->combineAndSup($vDay,$vDay,$filler);
		
		return $hd.$caps->comboBox($name, $defval, $dayssAssArr, $caps->matCss($cls),true);		
	} // tg_selectday


	/**
		[selectMonth name="" defval="/" filler="/" cls="" /]
		Obviously as a filler. could use the current month
	*/
	function tg_selectmonth(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$fKern= &$this->fKern;

		
		$name= $fKern->autoOrGivenName($v);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$fKern->countFormLbl, $name);
		
		$offsetDays= $tools->binLoads($v['offsetdays'],0);
		$m= $glob->getNumMonth($offsetDays);
		$defval= $caps->loadDefVal($v,$name,$m);
		
		$filler= $tools->binLoads($v['filler'],'ko');	// a prefix for the list if 'ko' --> don't use a filler
		
		$lg= $tools->currentLg();
		
		// Should later on define that as a general data in the data base, for example initialised from the builder.
		
		// the array keys
		$monthsVal= $tools->numStrVect(1,12);
		$monthsDspl= $fKern->monthVector();		
		
		$cls= $tools->binLoads($v['cls'],_c_defSelWgtCls);
		$monthsAssArr= $this->combineAndSup($monthsVal,$monthsDspl,$filler);
		return $hd.$caps->comboBox($name, $defval, $monthsAssArr, $caps->matCss($cls),true);		
	} // tg_selectmonth

	/**
	*/
	function tg_selectyear(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		$fKern= &$this->fKern;

		
		$name= $fKern->autoOrGivenName($v);
		$hd= $caps->hiddenWdg(_c_hWdgtNamePfx.$fKern->countFormLbl, $name);

		$offsetDays= $tools->binLoads($v['offsetdays'],0);
		$y= $glob->getYear($offsetDays);
		$defval= $caps->loadDefVal($v,$name,$y);						
		
		$filler= $tools->binLoads($v['filler'],'ko');
		
		$ySpan= $tools->binLoads($v['span'],1);		// number of years from now
		$cls= $tools->binLoads($v['cls'],_c_defSelWgtCls);
		
		$vY= $tools->numStrVect($y,$ySpan);
		$yearsAssArr= $this->combineAndSup($vY,$vY,$filler);
		
		return $hd.$caps->comboBox($name, $defval, $yearsAssArr, $caps->matCss($cls),true);		
	} // tg_selectyear



	/**
		Check the date validity, leap years included.
	*/
	function wellFormatedDate($gDay,$gMonth,$gYear){
		return checkdate($gMonth,$gDay,$gYear);
	} // wellFormatedDate
	
	/**
		Returns true if $gX === future date id compatible with $curX=== avctual date, so not already in the past.
		Note : true for a validity taken with full 31 days months! So non existing dates must be discarded before!
	*/
	function presentOrFutDate($gDay,$curDay, $gMonth,$curMonth, $gYear,$curYear){
		$ok1= $gDay>=$curDay && $gMonth>=$curMonth && $gYear>=$curYear; 
		$ok2= $gMonth>$curMonth && $gYear>=$curYear; 
		$ok3= $gYear>$curYear;
		return $ok1 || $ok2 || $ok3;
	} // presentOrFutDate		

	/**
		Checks if a triple time widgets respect the given detla-time with the present.
		Example :	
			[isValidDate name="arivalGroup" 
			errmess="The chosen date is not valid!"
			pastmess="Passed date!"
			warnmess="For today, please contact us directly!"			
			dayWN="arrivalDay" monthWN="arrivalMth" yearWN="arrivalYear" deltaT="24" /]
	*/
	function tg_isvaliddate(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fKern= &$this->fKern;
	
		$name= $v['name'];
			
		$gDay= $tools->postVal($v['daywn']);
		$gMonth= $tools->postVal($v['monthwn']);
		$gYear= $tools->postVal($v['yearwn']);
		
		
		// Defined time limit sticked on the present.
		$deltaT= $v['deltat'];
		$f= 3600; // Factor associated with the hour param --> nb sec in 1 hour.
		
		$curYear= $glob->getYear($deltaT,$f);
		$curMonth= $glob->getNumMonth($deltaT,$f);
		$curDay= $glob->getDay($deltaT,$f);
		
		
		$nowYear= $glob->getYear();
		$nowMonth= $glob->getNumMonth();
		$nowDay= $glob->getDay();
		
		// past ...
		$pYear= $glob->getYear(-1);
		$pMonth= $glob->getNumMonth(-1);
		$pDay= $glob->getDay(-1);
		

		$fromPresent= $this->presentOrFutDate($gDay,$nowDay, $gMonth,$nowMonth, $gYear,$nowYear);	// from present to future		
		$nearFuture= $this->presentOrFutDate($gDay,$curDay, $gMonth,$curMonth, $gYear,$curYear);
		
		if ($gDay!==false){		// The send button was pushed
			$genErrMess= $tools->binLoads($v['errmess'],'error!');
		
			$wellFormDate= $this->wellFormatedDate($gDay,$gMonth,$gYear);
			if ($wellFormDate){
				if ($fromPresent){
					if ($fromPresent && !$nearFuture){
						$fKern->vectError[$name]= true;
						$errM= $tools->binLoads($v['warnmess'],$genErrMess);
						return $caps->font($errM,'errForm');	// Too little warning
					}else{
						// ok at last! Nothing to do just let it go!
					}
				}else{
					$fKern->vectError[$name]= true;
					$errM= $tools->binLoads($v['pastmess'],$genErrMess);
					return $caps->font($errM,'errForm');		// Time deprecated date
				}
			}else{
				$fKern->vectError[$name]= true;
				return $caps->font($genErrMess,'errForm');		// Not Well formed date, exmpl 30 feb.
			}
		}
	} // isvaliddate


	/**
		Checks if 2 triples time widgets are in a specific relation toward each others
		---> 1st time     ----> 2nd time ----> left to right order
		--> check the ordinality of a couple of triples
		
		Example :	
			[arrivDepart name="arivalDep" 
			erRank="Arrival is set after departure!"
			dayArWN="arrivalDay" monthArWN="arrivalMth" yearArWN="arrivalYear"
			dayDpWN="departureDay" monthDpWN="departureMth" yearDpWN="departureYear" /]
	*/
	function tg_arrivdepart(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fKern= &$this->fKern;
	
		$name= $v['name'];
			
		$arDay= $tools->postVal($v['dayarwn']);
		$arMonth= $tools->postVal($v['montharwn']);
		$arYear= $tools->postVal($v['yeararwn']);
	
		$dpDay= $tools->postVal($v['daydpwn']);
		$dpMonth= $tools->postVal($v['monthdpwn']);
		$dpYear= $tools->postVal($v['yeardpwn']);
	
		$okRank= $this->presentOrFutDate($dpDay,$arDay, $dpMonth,$arMonth, $dpYear,$arYear);
		if (!$okRank){
			$fKern->vectError[$name]= true;
			$errM= $tools->binLoads($v['errank'],'Wrong Order!');
			return $caps->font($errM,'errForm');
		}
	} // tg_arrivaldeparture
	
	
	/**
		[hiddenWdgt name="flagFumNR" val="ok" /]
	*/
	function tg_hiddenwdgt(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		
		$name= $v['name'];
		$val= $v['val'];
		return $caps->hiddenWdg($name,$val);
	} // tg_hiddenwdgt
			
} // formpManager
?>
