<?php
/**
	File name : fumShrdCdLgt.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Shared code light to regroup the most basic definition and fonctions of this forum.
	
			Main full forumn parameters from the most general to the most precise (Rem : the partial forum or comments based
				forum just uses less of these same parameters):
				- pageName : the name / id of the supporting page (there is always a classical supporting page, mother page).
				- threadGroupId : index each group stored inside  _c_fumThreadList as xml2 calls
				- threadId :  index of a concerned thread.
				- capsThreadId :  index of a the capsulating thread.
				- xCodeId : index the group of posts stored in a specific x code space (the main xml2 code 
						to call/visualise the posts). Stored in table _c_fumXCode.
				- postId : the index of the post. Post that are stored in _c_forumPostsTbl
				
			Situation : posts are groupped into xPage as a way to use xml2 squarred bracket facilities for the
			indentation, so using xPage index is enough for navigation! As used in first implementation! So :
				- A post record points on its xPage with an xPage Id.
				- xPages point on its thread (ko if it's just an xPage of post comments) so :
					- for a given thread or a given page, post are accessible through a geometrical list of xPages.
				- A thread points on its group of thread.
				- xPosts, threads and group of threads have a unique name prefixed and numerotation such as
				  knowing how many of them allow a complete scanning.
				
			Conventions : 
				- First index start at 0 / zero.
				- Each post got a direct access to all six parameters. Could be stored in a ;;; format (note,
					in that case changing only one param is a bit annoying : explode, change, format, store, but
					it happens only if we move the post somewhere else (rare).
				- Create the post as soon as possible, and then track it only with its Id.
				

	Bookmarks :
		fumShrdCdLgt::urlUserId()

*/
include_once _c_toDeclPlugCntr.'forum/fumSuperLight.php';

class fumShrdCdLgt extends fumSuperLight{
	

	function __construct(&$tagsFu,&$imgP){
		parent::__construct($tagsFu);
		
		$tagsFu->shrdCd= &$this;
		$this->tagsFu= &$tagsFu;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->fls= &$tagsFu->fls;
		$this->tools= &$tagsFu->tools;
		$this->hPwC= &$tagsFu->hPwC;
		
		$this->aSql= &$tagsFu->aSql;	
		$this->dtb= &$tagsFu->dtb;	
		$dtb= &$this->dtb;
		
		$this->rights= &$tagsFu->rights;
		$this->parser= &$tagsFu->parser;
		$this->globSchedlr= false;
		

		define('_c_fUsersTbl', 'forumUsrTbl');	// inquisitive user large table
			// Facultative infos for large table 
			define('_c_fUserFamName','famName');	
			define('_c_fUserFstName','fstName');
			define('_c_fUserBirthD','birthD');	// Birth day
			define('_c_fUserstreet','street');
			define('_c_fUserNmStreet','nmStreet');
			define('_c_fUserTown','town');
			define('_c_fUserCntry','country');
			define('_c_fUserPostNb','postNb');
			define('_c_fUserPoBox','postPO');
			define('_c_fUserTel','tel');
			define('_c_fUserFax','fax');
			define('_c_fUserMobileNb','mobileNb');
	
			define('_c_fUserGroup','usrGroup');		// user group (a group of users the current user is responsable for = allowed to accept, change etc.)										// --> just stores usersIds separated by a semicolon (variable-abstracted group, eventual relation table for speed dealt with when occasion arises)
			define('_c_fUserRem','rem');		// A remark about this user account	

		
		
		
		/* --------------------------------------------------------------------
			forumPosts table
		*/			
		// define('_c_forumPostsTbl','forumPosts');		// The table for the web pages : Encompass All The Fields Below (*eatfb).
		define('_c_fDumpPostsTbl','fDumpPosts');		// The dump post table, to keep a while the deleted posts.
			define('_c_fumPostId',_c_genId);			// Alphabetical index.
			define('_c_fumFUserId','fUserId');
			
			define('_c_fumMotherId','motherId');	// In fact the mother name (standard page / text id)
			
			// Public group
			define('_c_fumMessTtl','messTtl');
			define('_c_fumMessBody','messBody');
			define('_c_fGotFreeImprove','imprvFlag');	// ko initial state then ok if we got a free improvment from the post owner
						
			// Private group : Special set of title & body to register user modification subject to the webmaster approval
			define('_c_fumMssTtl','mssTtl');
			define('_c_fumMssBdy','mssBdy');
			
			define('_c_fumMssLg','language');		// The supposed language of the post (takes the language of the mother page)
						
			define('_c_fumDate','date');			// The 1st creation date. Unix date of creation in seconds (uses a translator if a readable format become necessary when scanning the database)
			define('_c_fumLastDate','lastDate');	// The last creation date to check the modification rights
			
			// Ultra late modification flag --> ko or '' === (migration) still no email sent). ok === sent an email (so don't need to send the 40x others)
			define('_c_fLateMdiFlag','lateFlag');
			

			define('_c_fumThreadId','threadNumId');	// The thread numerical Id.
			define('_c_fumCapsId','capsId');		// The id of the capsulating post.
			define('_c_fumNbAns','nbAnsw');			// The number of answers.

			define('_c_fumXIndx','xIndx');			// Current X index (just the X index, the thread index is not included)
			define('_c_fumCurIndent','indent');		// Current indentation
			
			
			// To dump the xpetal tree code when deleting a post + used to store an authorization hash	
			define('_c_fumXDump','xDump');
			
			
			define('_c_fumWatchMail','watchMail');	
			define('_c_fumOkPost','allowed');		// Value ok if the post is allowed/visible and 'ko' by default.
			
		
		define('_c_fumGSupTagFldN','supTags');		// general supplementary tags field name, especiaolly used to specify index-local-meta-tags

		/**
			Table to hold the XPetal code to group many posts (up to genVar..fumPrsdXmlSz bytes) in pages :
				The main Id is generally calculated with the method :
					forumAlgo::anyXPage(){ fumShrdCdLgt::rfXCdPgNm() || fumShrdCdLgt::xCdPgNm() }
		*/			
		// define('_c_fumXCode','fumXCode');
			define('_c_fumXmlId',_c_genId);		// Standard page Id + 5 chars = 40 chars
			define('_c_fumXmlCode','xCode');	// xml2 === xpetal code
			
			define('_c_fXSupTags',_c_fumGSupTagFldN);	// full page metag (any tags in fact, but mainly useful for meta)
			define('_c_fXClickTtl','clicTitle');	// Clickable title
			
			define('_c_fXParsedSz','prsdSz');	// parsed size
			define('_c_fXGotChg','gotChg');	// set to ok when got a change, send back to ko when _c_fXParsedSz is updated	
			define('_c_fXMainPostId','mainPostId');	// main post Id
			define('_c_fXVisiblAll','vsblAll');		// Set to _c_ok when at least one post is visible for all


		/**
			X limits / thread for the real forum :
				pageName.'-'.idThread : To access the limit of navigation on a single thread.
				pageName.: to access the navigation limit of all the threads of the pointed page.
		*/			
		// define('_c_fumXCdLim','fumXLim');
			define('_c_fumXLimId',_c_genId);	// Standard page Id + 5 chars = 40 chars
			define('_c_fumXLimNb','lim');		// Last free index / limit. Symetric to _c_fumTreeFreeX, but for real forum.
			

		/**
			Table to hold threads list / group, Starts numeroration with pageId-0
			then increases after a large length.
		*/			
		// define('_c_fumThreadList','fumThreads');
			define('_c_fumTrLstId',_c_genId);	// Standard page Id + 5 chars = 40 chars
			define('_c_fumTrLst','xSqr');		// Square code matching new threads
			define('_c_fumTrLsSupTg',_c_fumGSupTagFldN);
			
		
		/* --------------------------------------------------------------------
			forumHash table : to manage the secure login of a forum user.
			Note : 
				- forum user login hashes with opional captcha Id).
				- Quickly run out of space (fumHashMinId ... fumHashMaxId) in busy environment 
			Could keep a rotational with selective deletion on own rows! And using empty space in priority
			to busy one!
			
		*/			
		// define('_c_fumHashTbl','forumHash');
			define('_c_fumHashId',_c_genId);
			define('_c_fumHashPrim','primHash');
			define('_c_fumHashCur','curHash');
			define('_c_fumHashCaptId','captchaId');
					

		/**
			Main posts repository (to store diverse informations for the concerned forum) for the forum.
		*/			
		// define('_c_forumPgRe','fumPgRepos'); .. ireally pages repository for forum information
			define('_c_fumRepId',_c_genId);				// Standard posts Id ( _c_pcId )
			define('_c_fumRlFum','rFum');				// ok if it's a real forum, ko otherwise! 
			define('_c_fumFreeGroupT','freeGroupT');	// Forum xpetal  free group of thread index
			define('_c_fumFreeThread','freeThread');	// Forum xpetal  free thread index
			define('_c_fumTreeFreeX','fumTreeFreeX');	// Forum xpetal trees free X index
			
			/*
				Gate for synchronisation for the whole page X family. The xGate is either "ok" open
				or reserved (choked) by a webmaster of forum user Id.
				
				Remark ; the methof bookedXGate with _c_waitsMicrooSec indicates 
					> A total number of slots/seconds of $slot= 10⁶/_c_waitsMicrooSec  (time of closed surrounding operation counted as negligeable)
					> An individual anoying probability of collision when the sum of implicated probabilities 
					  (0 + 1/$slot + 2/$slot + 3/$slot) + ... +  $x/$slot = 1, posing $N= $x+1, we have ($x*($x+1))/2 = $slot
					  ---> $x² + $x - 2$slots = 0 ---> $x aproximate sqrt(2$slots) = 141 posts / seconds, taking in account
					  the time necessary for extra code directy related into the concurrency, we can approximate _c_waitsMicrooSec
					  time increase, so we get $x aproximate sqrt($slots) = 100 posts / seconds before having frequent collisions,
					  this value being largelly about most forum expectations and server capabilities!
			*/
			define('_c_fumXGate','xGate');				// gate ownership  ok (everybody) or the user name
			define('_c_fumXGSetTm','xGSetTm');			// gate set time
			
			define('_c_fumAllowed','fumOk');			// ko if a forum is blocked and ok or anything otherwise



		// Forum scheduler table (note visualisation infos are taken directly from the post table
		// ... extra long bodies are trukated, got to click to see the whole).
		// Remark : ids are generated in a linear fashion up to a maximum number where ut start again from
		// the beginning (highest ones are high enough to avoid any scratch.)
		
		// define('_c_fumSchedTN','fumSched');
			define('_c_fumSchedId',_c_genId);	
			define('_c_fumSchedPostId','postId');		
			define('_c_fumSchedUsrId','usrId');	
			
			define('_c_fumSchedAction','action');		// The sort of scheduled action
				define('_c_fumSchedActPost','post');		// Accept the concerned post
				define('_c_fumSchedActTrans','actualise');	// Accept the concerned transfer
				define('_c_fumSchedActImg','img');			// Accept the user concerned image bunch
				
			define('_c_fumSchedAcceptTm','time');		// Action time.
			define('_c_fumSchedHumanTm','hTm');			// Readable time stamp.

			define('_c_fumSchedSuParam','suParam');		// supplementary parameters


		/**
			To manage the thread attributes.
		*/			
		// define('_c_fumThrdAttribTN','fumThrdAttrib');
			define('_c_fThrdAttId',_c_genId);		// Thread name
			define('_c_fThrdAttAwNb','answNb');		// Number of answers for a given thread



		/**
			To memorize what group of threads is connected to the current X page.
			fumThrdGrpAcs : forum threads groups access
		*/			
		// define('_c_fumThrdGrpAcsTN','fumThrdGrpAcs');
			define('_c_fThrdGrpAcsId',_c_genId);	// Name of the concerned X record without the last local suffix (x)
			define('_c_fThrdGrpNb','grpNb');		// Thread group Number



		/**
			To inform specific users about some private matters.
			
			Instruction to publish inside the control panel :
			
			To set a general message for a user : go into the fUsrMess table add or change an existing 
			field, with : userId(not pseudo); Message; ko
			
		*/			
		// define('_c_fumUsrMessTN','fUsrMess');
			define('_c_fumUsrMessId',_c_genId);
			define('_c_fumUsrMessInfo','info');
			define('_c_fumUsrMessRead','rd');		// read status! If the word read is used, mess up!! Probably interfering with an SQL instruction!!!



		/* --------------------------------------------------------------------
			Important url and/or  posted parameters
		*/	
		define('_c_fCurPostIdx','curPostIdx');	// Variable name for the current post index/Id
		define('_c_fumUrlPostId','uPostId');	// Parent !! (May change it to parentPostId) Variable name to memorize the post index we answer to! First in the Url.
		

		// ---------------------------------------------------------
		define('_c_fMotherPage',_c_mothrPage);		// mother page url/post variable name for the current post
		// ---> Could use only _c_mothrPage
		// Suppressed, difference betwen real forum and comments is done solely with _c_rfxPage !!
		
		
		define('_c_fJustClickedOnLR','clickedOnLR');	// to detect a click on the "Login or register!" link.
		
		
					
		// To pass the info that we got a new thread, numbered from 0 to y
		// Note : each new thread got its own X page (_c_fumXCode) serie
		define('_c_rfNewThread','newThread');	// ok --> don't know the index yet, need to create it
		
		
		define('_c_rfTGrpMaxSz',$dtb->getGenVar('fumGroupMaxSz'));	// Thread group maximum size, later on got to use a general variable!
		


		// ---------------------------------------------------------
		
		define('_c_fcbNewReg','cbNewReg');	// check box _c_ok if it's a new registration
		
		
		define('_c_fumOnlyReg','onlyRegister');	// url variable name for only registering
		define('_c_fImprovePId','improveId');	// the Id of a post being improved
		define('_c_emailWatcher','emailWatcher');// email widget name
		define('_c_fumReloads','fReloads');
		
		
		// Email confirmation.
		define('_c_fMailConfAction','action');
		define('_c_fMailConfUserId','userId');
		define('_c_fMailConfPostId','cPostId');
		define('_c_fMailConfHash','hash');
		
		define('_c_fumAvatarSzX',$dtb->getGenVar('avatarSzX'));
		define('_c_fumAvatarSzY',$dtb->getGenVar('avatarSzY'));
		
		define('_c_tMenCateg','tMenCateg');		// should logically be in textMenu.php for it to be fully independanmt
		
		/*
			General constants.
		*/
		define('_c_fDelSpecPost','delSpecPost');
		define('_c_fVisSpecPost','visSpecPost');
		define('_c_fPrivToPub','privToPub');
		define('_c_fVisAction','visAction');
		
		define('_c_fIconSetName','iconSetNm');
		
		
		/* Times laps for forum users between each others before considering that a reservation is not valid anymore.
		*/
		define('_c_fumReservTmSlot',2);	// in seconds for forum users automatical booking time. Need more thatn one second, because
		// of the limit situation when in changes to the next second! It's the maximum booked time because it's normally freed
		// by the process having done the booking
		
		define('_c_waitsMicrooSec',100);
		
		define('_c_fumWmResTmSlot',300);	// in seconds for webmasters
		define('_c_fumNoBookingTm',0);	// conventional time to indicate that there is no reservation $this->leftBookedTm($pg) must be smaller
			
		
		/* ------------------------------------------------------------------------------
			Reservation / temporary blockage of the concerned forum page.
		*/
		define('_c_fReservedPgN','reservedPgN');		// Reserved page name (for quick webmaster modification)
		
		
		$glob->explExternInclStanceJs('forum');
				
		$this->globCurNewThreadIdx= _c_ko;
		$this->justGotCorrectLogin= false;
		
			
		
		if (array_key_exists('captcha',$tagsFu->libClasses)){
			$this->captCo= &$tagsFu->libClasses['captcha'];
		}else{
			include_once _c_LibPath.'captcha.php';
			$curCaptSet= $dtb->getGenVar('fumCaptchaSet');
			$this->captcha= new captcha($tagsFu,$curCaptSet);
		}
		
		
		include_once _c_LibPath.'email.php';
		$this->email= new email($tagsFu);	// The Basic Email function!
		
		
		include _c_toDeclPlugCntr.'fumXRights/fumXRights.php';
		$this->xRgt= new fumXRights($tagsFu,$this);
		
		$this->isSignedIn= $this->correctlySignedIn();
				
		$this->imgP= &$imgP;
		
		$this->assoc= &$tagsFu->assoc;
		
		
		
		$this->gotForumThreadTag= false;
		$this->globUsrMess= '';	// global user message (now just for bottle neck issues)
		
		// Forum Summary
		define('_c_fumFrcSumryCalc','forceSumryCalc');	// url variable to force the summary calculation.
		define('_c_fumSumryPrfx','fSummary_');	// gen variable summary storage prefix
		define('_c_fumTimeSmryPfx','fSmry_');	// gen variable storage prefix for last time modif in second Unix time.
		define('_c_fumSmryDsplMode','fSmryDsplMd');	// gen variable used display mode
		define('_c_fumSmryFlagPrfx','fSumryFlag_');	
		define('_c_fSmryIdleHours','fSummaryIdleHours');
	} // construct
	
	
	/**
		Returns true if the default forum user is correctly Signed In
	*/
	function correctlySignedIn($rejectSubUsr=true){
		$tools= &$this->tools;
		$xRgt= &$this->xRgt;
		
		if ($this->justGotCorrectLogin){
			return true;
		}		

		$usrId= $this->fumLogUserId();
		if ($usrId===_c_userNoRight){
			return false;
		}

		if ($rejectSubUsr && $xRgt->subUserStatus()){
			return false;	// a subuser was detected
		}
		
		return true;
	} // correctlySignedIn
	
	
	/**
		Complex differentiation for the eturning Id because used inisde a few tables having 
		an Id dependant on the 2 or 3 parameters.
	*/
	function rfXCdPgNm($mp,$threadIdx,$idx){
		if ($mp===''){
			return $threadIdx.'-'.$idx;
		}else{
			return $mp.'-'.$threadIdx.'-'.$idx;	// also see function xPgUr()
		}
	} // rfXCdPgNm
	
	/**
		Name for the the X pages : Comments (xCdPgNm()) and Real forum (rfXCdPgNm())
	*/
	function xCdPgNm($mp,$idx){
		return $mp.'-'.$idx;
	} // xCdPgNm

	
	/**
		Adapted contextual X page name.
		Also see realForumState() to set the $thread parameter
	*/
	function anyXPage($mp,$thread,$idx){
		if ($thread===false){
			return $this->xCdPgNm($mp,$idx);
		}else{
			return $this->rfXCdPgNm($mp,$thread,$idx);
		}
	} // anyXPage
	
		
	function xPgUr($thrIdx,$idx){
		return $thrIdx.'-'.$idx;
	} // xPgUr
	
		
	/**
		Name of the thread, not the X pages
	*/
	function threadName($mpName,$idx){
		return $mpName.'-'.$idx;
	} // threadName
	

	/**
		Get the real forum "page" in fact the numerical values of threadId.'-'.xId as it is in the url
	*/
	function getRfxPage(){
		$tools= &$this->tools;
		return $tools->gostVal(_c_rfxPage);
	} // getRfxPage

	/**
		Get the real forum first "page"  (the initiant thread displayed)
	*/
	function getRfxFirstPg(){
		$fls= &$this->fls;
	
		$fullRx= $this->getRfxPage();
		$fls->splitOnFirstC($fullRx,$thrdIdx,$xIdx,'-');
		return $this->xPgUr($thrdIdx,'0');
	} // getRfxFirstPg
	
	
	/**
		Extract the components from the real forum X page.
			$xPage holds $mp only when it's a full record Id _c_fumTrLstId
		Output :
			$mp	: mother page
			$thrdIdx : thread index
			$xIdx : x (last) index
	*/
	function splitRfXpg(&$mp,&$thrdIdx,&$xIdx, $xPage){
		$tools= &$this->tools;
		$fls= &$this->fls;		
	
		$fls->splitOnLastC($xPage,$buff,$xIdx,'-');		
		if ($tools->sIsInB('-',$buff)){
			$fls->splitOnLastC($buff,$mp,$thrdIdx,'-');
		}else{
			$mp= $tools->getVal(_c_fMotherPage);
			if ($mp===false){
				$mp= $tools->curPageName();
			}
			
			$thrdIdx= $buff;
		}
	} // splitRfXpg

	/**
		Extract the components from the real forum X page.
		Idem above but don't take the case of the incrusted morther page, such as it appear in field names.
		So just for reading url variables.	
	*/
	function splitRXpg(&$thrdIdx,&$xIdx, $xPage){
		$fls= &$this->fls;		
		$fls->splitOnLastC($xPage,$thrdIdx,$xIdx,'-');		
	} // splitRXpg
	
	/**
	*/
	function threadIdxFromRXpg($xPage){
		$fls= &$this->fls;		
		$fls->splitOnLastC($xPage,$thrdIdx,$xIdx,'-');	
		return 	$thrdIdx;
	} // threadIdxFromRXpg
	

	/**
		Forum Stopped globally or on the Current Page $pg
	*/
	function stopped($pg){
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->wRights){
			return false; // the forum is never stopped for the webmaster so it's still possible to improve visible posts
		}
						
		$fumStop= $dtb->getGenVar('fumStop');
		if ($fumStop===_c_ok){
			return true;
		}

		$localMode= $dtb->getElem(_c_forumPgRe, _c_fumRepId,$pg, _c_fumAllowed);
		if ($localMode===_c_ko){
			return true;
		}else{
			return false;
		}
	} // stopped


	/**
	*/
	function avatPath($userId){
		return $this->avatDir($userId).'/';
	} // avatPath

	/**
	*/
	function avatDir($userId){
		return _c_UsrImagePath.'forum/users/avatars/'.$userId;
	} // avatDir
	

	/**
	*/
	function persoPath($userId,$short=false){
		return _c_UsrImagePath.$this->corePersoPath($userId,$short);
	} // persoPath
	
	
	/**
	*/
	function newFumUser(&$uV){
		$dtb= &$this->dtb;
		$userId= $uV[0];
		$dtb->newElem(_c_fsmplUsersTbl, _c_fUserId,$userId, $uV);	// REGISTER THE USER
	} // newFumUser
	
		
	/**
	*/
	function getPostLg($pId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$pId, _c_fumMssLg);
	} // getPostLg
			
	/**
		Get the forum user Id from the post Id.
	*/
	function postUserId($pId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$pId, _c_fumFUserId);
	} // postUserId
	
	/**
		Get the mother page Id from the post Id.
	*/
	function motherName($pId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$pId, _c_fumMotherId);
	} // motherName
	
	
	
	/**
	*/
	function postExists($postId){
		$dtb= &$this->dtb;
		return $dtb->elementExists(_c_fumPostId,$postId, _c_forumPostsTbl);
	} // postExists
				
						
	/**
	*/
	function getCurAvatar($userId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fAvatar);
	} // getCurAvatar


	/**
		set Glob Post Title Date Format
	*/
	function setGlobPTDF($d){
		if ($d!==false){
			$this->gPostDateFmat= $d;
		}else{
			$this->gPostDateFmat= 'd n Y';	// standard english format
		}
	} // setGlobPTDF
	
	function getGlobPTDF($d){
		return $this->gPostDateFmat;
	} // getGlobPTDF
	
	/**
	*/
	function facultativeDateStamp($time,$addFrill){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;		
		
		if ($addFrill){
			$suprDate= $dtb->getGenVar('fumSupressOldDateDspl');
			if ($suprDate!==_c_ko){
				$curTime= time();
				$limForDateDspl= $curTime - $suprDate*24*3600;
			}else{
				$limForDateDspl= 0;
			}
		
			$wRights= $rights->wRights;
			if ($time>$limForDateDspl || $suprDate===_c_ko || $wRights){
				$dStr= date('d n Y',$time);
				$dStr= str_replace(' ','-',$dStr);
				$dateStamp= $caps->span(' '.$dStr,'fumDateStamp');
			}else{
				$dateStamp= '';
			}
			
		}else{
			$dateStamp= '';
		}
		
		return $dateStamp;
	} // facultativeDateStamp


	/**
		Group the different items of the post title.
			$curTtl : simple title string as a string or class/link formatted as a main title.
			$postId : id of the concerned post.
			$xIndx : X index, a single number to indicate the position in the numerical menus and to build url strings and field names (simple or prefixed with the thread index)
			$addFrill : true normal state many buttons and false === main title mode.
			$dsplMode : in paragraphs or inline
			$arCmd : array commands to tools::urlGivenPage()
			
		Also see : TrashAndSmiley
	*/
	function postTitle($curTtl,$postId, $xIndx='',$addFrill=true,$dsplMode='paragr',$arCmd=false){		
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		$wRights= $rights->wRights;
	
		$postRec= $this->getPostRec($postId);
		$userId= $postRec[_c_fumFUserId];
		$pseudo= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserPseudo);
		if ($xIndx===''){
			$avatarSty= 'fSmAvatar';	// small avatar! --> is a threadtitle !!
			$isThreadTtl= true;
		}else{
			$avatarSty= 'fAvatar';
			$isThreadTtl= false;
		}
	
		$time= (int)$postRec[_c_fumDate];
		$dateStamp= $this->facultativeDateStamp($time,true);
				
		$eye= '';
		$visibility= '';
		$trash= '';
		$privToPub= '';
		
		$watch= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId, _c_fumWatchMail);
		if ($watch===_c_ok && $addFrill){
			$eye= $caps->ttlImage($caps->imgSrc('eye.png',_c_ok), $glob->el('Answers are E-mail probed by author.','kmcu'), '#','fumImgBtt');
		}
		
		// TrashAndSmiley
		if ($wRights && $addFrill){
			if (!$isThreadTtl){
				$url= $this->curPgAndXCodeUrl($xIndx);
				$url.= $tools->addUrlVar(_c_fDelSpecPost, $postId);
				$trash= $caps->span(' ','fumStd').$this->trashButton($url);
			}else{
				$trash= '';
			}
			
			$arr[_c_tedCurDtbTblNm]= _c_ko;	
			$urlSB= $tools->urlGivenPage('_dtb_edit_line',$arr).
				$tools->addUrlVar(_c_tedCurDtbTblNm,_c_forumPostsTbl).
				$tools->addUrlVar(_c_tedCurDtbRowId,$postId);
				
			$visibility= $caps->span(' ','fumStd').$this->showButton($urlSB);
			$visibility.= $caps->span(' ','fumStd').$this->visiblButton($postRec, $xIndx,$postId);			
		}
		
		// Button to transfers the private content into the public
		if ( $wRights && $postRec[_c_fumMssTtl]!=='' ){
			$privToPub= $this->privToPuBut($postRec,$xIndx,$postId);
		}
		
		// Mark and title
		if ($this->coreSignedIn($userId)){
			$vsblPseudo= $this->linkedPseudo($userId,$pseudo,'fumStdFlash');
		}else{
			$vsblPseudo= $this->linkedPseudo($userId,$pseudo,'fumPostTtl');
		}
		
		$vsblPseudStr= ' / '.$vsblPseudo.' ';
		$idStamp= $this->postIdStamp($userId,$pseudo,$avatarSty,$postId,$arCmd);
		
		$pNb= '';
		$computeAndStore= $tools->getVAl(_c_fumFrcSumryCalc);
		if ($computeAndStore!==_c_ok){
			if ($isThreadTtl){
				$pNb= $this->threadPostNb($postRec);
				if ($pNb!==false && $pNb!==''){	// $pNb!=='' keep chrono-compatibility
					$nbAnswStr= $pNb. $glob->sl(' answers for this thread!','kmcv');
					$pNb= $caps->spanTtl('('.$pNb.') ','fumCountStamp', $nbAnswStr);
				}else{
					$pNb= '';
				}
			}
		}
		
		switch ($dsplMode){
			case 'paragr':
				$curStyl= 'fumPostTtl';
			break;
			
			case 'inline':
				$curStyl= 'fumSpanPostTtl';
			break;
			
			// A sub display mode of 'inline'
			case 'firstInline':
				$curStyl= 'firstInlinePostTtl';
			break;
			
			default:
				$curStyl= 'fumPostTtl';
		} // switch
		
		
		if ($computeAndStore===_c_ok){
			$bookMarkStr= '';
		}else{
			$bookMarkStr= $caps->bookMark($postId)._c_R;
		}

		switch ($dsplMode){
			case 'paragr':
				return $bookMarkStr.$caps->div($idStamp.$pNb.$curTtl.$vsblPseudStr.$eye.$visibility.$privToPub.$dateStamp.$trash,$curStyl);
			break;
		
			default:
				return $bookMarkStr.$caps->span($idStamp.$pNb.$curTtl.$vsblPseudStr.$eye.$visibility.$privToPub.$dateStamp.$trash,$curStyl);
		} // switch
	} // postTitle
	

	/**
		To display the number of post under each thread.
		
		Return false when threads are not accountable, such in the case of just comments instead of full blown forum.
	*/
	function threadPostNb($postRec){
		$dtb= &$this->dtb;
		
		$thrdId= $postRec[_c_fumThreadId];
		if ($thrdId!=='' && $thrdId!==_c_ko){
			$motherId= $postRec[_c_fumMotherId];
			$fullThrdId= $motherId.'-'.$thrdId;
			return $dtb->getElem(_c_fumThrdAttribTN, _c_fThrdAttId,$fullThrdId, _c_fThrdAttAwNb);
		}else{
			return false;
		}
	} // threadPostNb
	
	
	/**
		Transfer of image for users with partial rights.
		Remark : 
			if $secretDir === true --> don't bother checking, just uses $dtbSecretDir
	*/
	function usrImgTranfer($userId,$secretDir=true){
		$fls= &$this->fls;
		$imgP= &$this->imgP;
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;
		
		$dtbSecretDir= $dtb->getElem(_c_fsmplUsersTbl,_c_fUserId,$userId,_c_fUsrSecretDir);
		if ($secretDir===true || $secretDir===$dtbSecretDir){
			$persoPath= $this->persoPath($userId);
		
			// The given directory _c_piuSecretDir name is exact, ---> does the TRANSFER
			$secretPath= $persoPath.$dtbSecretDir.'/';
			
			$thbSecrtPth= $secretPath._c_thumbsDirN.'/';
		
			$fls->firstLevelFiles($secrFileV,$secretPath);
			reset($secrFileV);
			foreach ($secrFileV as $key=>$fileName){
				$srcPF= $secretPath.$fileName;
				$destPF= $persoPath.$fileName;
				
				$fls->secUnlink($destPF);	// preventive inlink of the gimmik
				$fls->copyFile($srcPF,$destPF);
				
				// Update the thumb
				$thumbUrl= $persoPath._c_thumbsDirN.'/'.$fileName;
				$imgP->resizeProc($srcPF,$thumbUrl,_c_thumbsWidth,_c_thumbsHeight);
				
				$fls->secUnlink($srcPF);	// one less (big image) inside the secret directory
				$fls->secUnlink($thbSecrtPth.$fileName);	// remove the secret thumbs
			}
			
			/**
				Delete the matching scheduler event.
			*/
			$condImgAction= $aSql->basicCond(_c_fumSchedAction,_c_fumSchedActImg);
			$condUsrId= $aSql->basicCond(_c_fumSchedUsrId,$userId);
			$aSql->andCondition($condImgAction, $condUsrId);
			$scheDelId= $dtb->getElem(_c_fumSchedTN, $condImgAction,false, _c_fumSchedId);
			$this->sDelInScheduler($scheDelId);
		}
	} // usrImgTranfer
	

	/**
		Post Id given and delete in scheduler
	*/
	function pDelInScheduler($delPId){
		$dtb= &$this->dtb;
		
		$scheDelId= $dtb->getElem(_c_fumSchedTN, _c_fumSchedPostId,$delPId, _c_fumSchedId);
		$this->sDelInScheduler($scheDelId);
	} // pDelInScheduler
	
	/**
		Scheduler Id given and delete in scheduler
	*/
	function sDelInScheduler($scheDelId){
		$dtb= &$this->dtb;
	
		if ( $dtb->elementExists(_c_fumSchedId,$scheDelId,_c_fumSchedTN) ){
			$dtb->delete(_c_fumSchedTN,$scheDelId);		// Deletion inside the scheduler list
		}
	} // sDelInScheduler
			
	
	/**
		Creates the personal directories for a given forum user
	*/
	function createForumUsrDir($userId){
		$fls= &$this->fls;		

		$avaP= $this->avatDir($userId);
		$fls->wMkDir($avaP);
		
		$peP= $this->persoPath($userId,true);
		$fls->wMkDir($peP);
	} // createForumUsrDir
	

	/**
	*/
	function diversePath(){
		return _c_UsrImagePath.'forum/diverse/';
	} // diversePath	

	/**
	*/
	function createAvatar($tagsFu,$avatarPathFN){	
		$dtb= &$this->dtb;
		$imgP= &$this->imgP;
		
		$kind= $dtb->getGenVar('avatarKind');
		switch ($kind){
			case 'matrix':
				return $imgP->createRandomGridImg(3,3, $avatarPathFN,_c_fumAvatarSzX,_c_fumAvatarSzY,4);	
			break;
			
			case 'balloons':
				return $imgP->createRandomElipse(_c_fumAvatarSzX,_c_fumAvatarSzY, $avatarPathFN);
			break;
			
			default:;
		} // switch		
	} // createAvatar
	
	
	/**
		Returns whatever the full x suffix is if available.or only the thread index if $getThread===true
	*/
	function whateverX($getThread=false){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$sff= $tools->getVal(_c_rfxPage);
		if ($sff===false){
			$sff= $tools->getVal(_c_fxCodeIndx);
			if ($sff===false){
				return false;
			}
			return $sff;	// also directly the thread index of value 0  (single conventional thread)
		}else{
			if ($getThread){
				// Wants only the thread index
				$fls->splitOnFirstC($sff,$thrdIdx,$r,'-');
				return $thrdIdx;
			}else{
				return $sff;
			}
		}
	} // whateverX
	
	/**
		Returns the current thread INDEX in character(s) for real forum situation as for comments situations.
		Also see realForumState()
	*/
	function currentThread(){
		$tools= &$this->tools;
	
		$newT= $tools->getVal(_c_rfNewThread);
		if ($newT!==false){
			return $this->globCurNewThreadIdx;
		}else{
			return $this->whateverX(true);
		}
	} // currentThread
	
	/**
		Return true if we got a real forum mother page instead of a comment mother page. Can't use it 
		for main page minimum url, but does not matter because uses specialised real-forum tag!.
		
		Works only on the page displaying the full information, define('_c_rfxPage','xPage')
	*/
	function realForumState(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		// instead of url testing could also access _c_forumPgRe !!!!!!!!!!!!!!!!!
		$rFsFromUrl= $this->gotForumThreadTag || 
				$this->getRfxPage()!==false || 
				$tools->getVal(_c_rfNewThread)!==false || 
				$tools->getVal(_c_rfTGroupIdx)!==false;
		
		if ($rFsFromUrl){
			return true;
		}else{
		
			$mPg= $tools->gostVal(_c_mothrPage);
			if ($mPg!==false){
				$mpFumState= $dtb->getElem(_c_forumPgRe, _c_fumRepId,$mPg, _c_fumRlFum)===_c_ok;
			}else{
				$mpFumState= false;
			}
			
			return $mpFumState;
		}
	} // realForumState
	
	
	/**
		Returns the full URL matching the current page with the X-code ($xIndx).
		Input :
			$xIndx : complex x code (to take in priority to url one)
			$postId
			$forcedPage
			$urlCommandAr
		Output : return full access url.
	*/
	function curPgAndXCodeUrl($xIndx,$postId=false,$forcedPage=false,$urlCommandAr=false,$fxCI=true){
		$tools= &$this->tools;
	
		$xUrl= '';
		if ($xIndx!==false){
			// n realForumState
			$rfState= $this->realForumState();
			if ($rfState){
				// full forum
				$xPage= $this->getRfxPage();
				if ($xPage!==false){
					$this->splitRfXpg($mp,$thrdIdx,$xIdx, $xPage);
					if ($tools->sIsInB('-',$xIndx)){
						$combiX= $xIndx;
					}else{
						$combiX= $this->rfXCdPgNm('',$thrdIdx,$xIndx);
					}
					
					$xUrl= $tools->addUrlVar(_c_rfxPage,$combiX);
				}else{
					$grpIdx= $tools->getVal(_c_rfTGroupIdx);
					if ($grpIdx!==false){
						$xUrl= $tools->addUrlVar(_c_rfTGroupIdx,$grpIdx);
					}else{
						$xUrl= '';
					}
				}
			}else{
				// Simple posts
				if ($fxCI){
					$xUrl= $tools->addUrlVar(_c_fxCodeIndx,$xIndx);
				}
			}
		}
			
		$urlTail= $xUrl.$tools->signet($postId);
		if ($forcedPage===false){
			return $tools->urlCurPg($urlCommandAr).$urlTail;
		}else{
			return $tools->urlGivenPage($forcedPage,$urlCommandAr).$urlTail;
		}
	} // curPgAndXCodeUrl
	

	/**
		General Post Link (indirectly from the Post Record, .. could pass the post recod array as parameter)
		Almost like curPgAndXCodeUrl(), but was programmed independently for the forum user manager
		Input :
			$genXIdx : a general x index --> ['threadNumber'.'-'].'xIndex'
			$postId : classic post Id.
			$mPg : mother page name
			
		Output : the url to read the post within it's contect..
	*/
	function generalLinkFromPR($genXIdx,$postId,$mPg, $arCmd=false){
		$tools= &$this->tools;
	
		$gotHyphen= $tools->sIsInB('-',$genXIdx);		
		if ($gotHyphen){
			$xUrl= $tools->addUrlVar(_c_rfxPage,$genXIdx);
		}else{
			$xUrl= $tools->addUrlVar(_c_fxCodeIndx,$genXIdx);
		}
				
		$urlTail= $xUrl.$tools->signet($postId);
		return $tools->urlGivenPage($mPg,$arCmd).$urlTail;
	} // generalLinkFromPR

		
	/**
		Used to extract the user Id from the pseudo!
	*/
	function safeStr($str){
		return strtolower($this->safeKamelStr($str));
	} // safeStr
	
	
	function safeKamelStr(&$str,$limSz=false){
		$tools= &$this->tools;
		
		$allowedIdChars= 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
		$buff= '';
		
		$sz= strlen($str);
		if ($limSz!==false){
			if ($sz>$limSz){
				$sz= $limSz;
			}
		}
		
		for ($i=0; $i<$sz; $i++){
			$c= $str[$i];
			$belongs= $tools->sIsInB($c,$allowedIdChars);
			if ($belongs){
				$buff.= $c;
			}
		}
		return $buff;
	} // safeKamelStr
	

	/**
		Get the x code index and the x code url to add.
		$this->getXCodeParams($xCodeIndx,$xCodeUrl);
	*/
	function getXCodeParams(&$xCodeIndx,&$xCodeUrl,$rFxPg=''){
		$tools= &$this->tools;

		if ($rFxPg===''){
			$xCodeIndx= $tools->getVal(_c_fxCodeIndx);
			$xCodeUrl= '';
			if ($xCodeIndx!==false){
				$xCodeUrl= $tools->addUrlVar(_c_fxCodeIndx,$xCodeIndx);
			}
		}else{
			$this->splitRfXpg($mp,$thrdIdx,$xCodeIndx, $rFxPg);	// so goet formal value for $xCodeIndx, so passes comments tests correctly	
			$xCodeUrl= $tools->addUrlVar(_c_rfxPage,$rFxPg);
		}
	} // getXCodeParams	
	
	
	/**
	*/
	function lnPseudoUrl($userId,$arCmd=false,$addMotherPg=true){
		$tools= &$this->tools;
		$url= $tools->urlGivenPage('_4umUsrMg',$arCmd);
		$url.= $tools->addUrlVar(_c_fumUserId,$userId);
		
		if ($addMotherPg){
			$mthrPg= $tools->gostVal(_c_mothrPage);
			if ($mthrPg===false){
				$curPg= $tools->curPageName();
				$url.= $tools->addUrlVar(_c_mothrPage,$curPg);
			}
		}
		
		return $url;
	} // lnPseudoUrl
				
	/**
	*/
	function linkedPseudo($userId,$pseudo,$font='fumStdFlash'){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$xRgt= &$this->xRgt;
		
		if ($xRgt->subUserStatus($userId)){
			return $caps->spanTtl( $pseudo._c_sT, $font, $pseudo.$glob->sl('s informations','kbet') );
		}else{
			$usrMgUrl= $this->lnPseudoUrl($userId);
			return $caps->hL( $usrMgUrl, $pseudo._c_sT, $font, '', $pseudo.$glob->sl('s informations','kbet') );
		}
	} // linkedPseudo	
	
	
	/**
		Return true (Boolean) if the page allows registration for a new user.
		---------> Follow the lead of publicPostsFPV  motherPage
		$this->allowNewUserRegistrB()
	*/
	function allowNewUserRegistrB(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$regPrivateFumPg= $dtb->gotOkGenVar('regForPrivateFumPg');
		
		$concernedPg= $tools->gostVal(_c_mothrPage);
		if ($concernedPg===false){
			$concernedPg= $tools->curPageName();	
		}
		
		$userListId= 'usrList_'.$concernedPg;
		$userList= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$userListId);
		if ($userList===false){
			// the page hasn't got a special list of users, therefore we always got registration possibilities
			return true;
		}else{
			return $regPrivateFumPg; // got a user list so abide the general rule!
		}
	} // allowNewUserRegistrB
	
	/**
		Return true if the forum page is open and always true for webmasters.
		----> [pageMode forum="closed" /] <-----  Just add it inside the main page body when necessary
		Rem :			
			*** The fumThreads table could be used for thread specific definition.
			Used as a soft closure : only removing the access buttons but not the background saving methods,
			so people still editing their post can still save them !!
			
		fumShrdCdLgt::forumPageIsOpen()
	*/
	function forumPageIsOpen(){
		$tagsFu= &$this->tagsFu;
		
		if (isset($tagsFu->pgMdForumPgIsOpen)){
			$rMg= &$tagsFu->rMg;
			return $tagsFu->pgMdForumPgIsOpen  || $rMg->quickWMRight();
		}else{
			return true; 	// default
		}
	} // forumPageIsOpen
	
	
	
	/**
		Dynamic label for login, unlogin and reloading.
	*/
	function loginDynLabel($rootUrl,$xCodeSup){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$jsUnlog= $caps->jsFunctCallStr('onclick','forum.unlog');
		
		if ( $this->correctlySignedIn(false) ){
			// Accept subuser here because buttons are just informative!
		
			$this->getPostedUserIds($userId,$pseudo);
			
			$logMess= '';
			if (!$this->forumPageIsOpen()){
				$logMess.= $glob->sl('Comments of this page are closed : ', 'kbbr');
			}
			
			$logMess.= $glob->sl('Logged as ', 'kaai');
			
			$logReg= $caps->span(_c_sT.$logMess._c_sT, 'fumStd');
			$logReg.= $this->linkedPseudo($userId,$pseudo);
			
			$url= $tools->urlCurPg().$xCodeSup.$tools->addUrlVar('fumUnlog',_c_ok);
			$url.= $tools->addUrlVar(_c_fumUserId,$userId);	// keeps the user Id in url memo
			$logReg.= $caps->hLink($url,$glob->sl('Unlog!', 'kbbz'),$jsUnlog.$caps->matCss('fumUnlogSty') );
		}else{
			$curPgN= $tools->curPageName();
			
			$urlAdd= $tools->addUrlVar(_c_fumOnlyReg,_c_ok);				
			$urlAdd.= $tools->addUrlVar(_c_fMotherPage,$curPgN);				
			$urlAdd.= $tools->addUrlVar(_c_fJustClickedOnLR,_c_ok).$xCodeSup;
			
			
			if ($rootUrl==='_4um_registration'){
				// special case where we just got the page name to diversify the links!
				$baseUrl1= $tools->urlGivenPage($rootUrl);
			}else{
				$baseUrl1= $rootUrl;
			}
			
			if ( $dtb->gotOkGenVar('publicPostsFPV') && $this->allowNewUserRegistrB() ){
				
				$logReg= $caps->span($glob->sl('To comment : ','kbni'),'gecSubTtl');
				
				$label= $caps->span($glob->sl('Login / register','kani'),'fumStd');
				$logReg.= $caps->hLink($baseUrl1.$urlAdd, $label, $caps->matCss('fumStd').$caps->noFollowStr().$jsUnlog);
				
				if (!$this->subUsRegitrPg){
					$logReg.= $caps->span($glob->sl(' or ','kbnj'),'gecSubTtl');
				
					$label= $caps->span($glob->sl('Easiest Way / Anonym','kbnk'),'fumStd');
					$baseUrl2= $tools->urlGivenPage('_4um_anonyme');
					$logReg.= $caps->hLink($baseUrl2.$urlAdd, $label, $caps->matCss('fumStd').$caps->noFollowStr().$jsUnlog);
				}
				
				$logReg.= $caps->span($glob->sl(' or ','kbnj'),'gecSubTtl');
				
			}else{
				$label= $caps->span($glob->sl('Login','kmia'),'fumStd');
				$logReg= $caps->hLink($baseUrl1.$urlAdd, $label, $caps->matCss('fumStd').$caps->noFollowStr().$jsUnlog);
			}
			
			$label= _c_Ns.$glob->sl('(Reload !!)','kaak');
			$altStr= $glob->sl('cant log, click here ..','kaal');
			
			$attS= $jsUnlog.$caps->matCss('fumStds').$caps->matTtl($altStr);
			$url= $tools->urlCurPg();	// no .$xCodeSup because x index 0 effect when possibly not existing. Further this is a more complete reset
			$url.= $tools->addUrlVar(_c_fumReloads,_c_ok);
			
			$userId= $this->smartUserId();		
			if ($userId!==false){
				$url.= $tools->addUrlVar(_c_fumUserId,$userId);	// keeps the user Id in url memo	
			}					
			$logReg.= $caps->hLink($url,$label,$attS);
		}
		
		$attS= $caps->matCss('fumStds');
		$stpEmot= $tools->getVal(_c_fumStopEmotMoves);
		if ($stpEmot===_c_ok){
			$attS.= $caps->matTtl( $glob->sl('Restart the dynamic emoticons!','kmcw') );
			$url= $tools->urlCurPg().$xCodeSup;
			$logReg.= $caps->hLink($url, $glob->sl(' ----- (Restart!)','kmcx'), $attS);
		}else{
			// Display the stop emot link only if dynamic emoticons have been met
			if ($glob->pgNbOfDynEmot > 0){
				$pgMaxDynEmot= $dtb->getGenVar('pgMaxDynEmot',10);
			
				$attS.= $caps->matTtl( $glob->sl('Stop Emoticons ','kmcy').$pgMaxDynEmot.$glob->sl(' dynamic emoticons','kmcz') );
				$url= $tools->urlCurPg().$xCodeSup;
				$url.= $tools->addUrlVar(_c_fumStopEmotMoves,_c_ok);
				$logReg.= $caps->hLink($url, $glob->sl(' ----- (Stop Dynamic Emoticons!)','kmda'),$attS);
			}
		}
		return $logReg;
	} // loginDynLabel
	
	
	/**
		Outside 1st posted time, Get the pseudo from the database. 
	*/
	function getPostedUserIds(&$userId,&$pseudo){
		$acc= &$this->acc;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$pseudo= strip_tags($tools->postVal('usrNm',_c_ko));
		if ($pseudo!==_c_ko){
			$userId= $this->safeStr($pseudo);	// first step after registration
		}else{
			$userId= $this->fumLogUserId();
			$pseudo= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserPseudo);
		}
	} // getPostedUserIds
	

	/**
		Returns the scheduler class.
	*/
	function schedulerClass(){
		$tagsFu= &$this->tagsFu;
		
		if ($this->globSchedlr===false){
			include _c_toDeclPlugExt.'forum/scheduler.php';
			$this->globSchedlr= new scheduler($tagsFu,$this);
		}
		return $this->globSchedlr;
	} // schedulerClass
	
	
	/**
		Returns true if we need to execute a scheduled action.
		The most urgent time is stored into a variable and a call is done only when this time is reached.
	*/
	function gotSchedAction(){
		$dtb= &$this->dtb;

		if ($dtb->getGenVar('fumSchedInUse')===_c_ko){
			// The scheduler is not active, everything is done by hand so quit here !!!
			return false;
		}

		$curTm= time();
		$nxTm= $dtb->getGenVar('fumSchedNexTm');
		
		if ($nxTm!==_c_ko && $curTm>=$nxTm){
			return true;	// got at least one action ready to be executed
		}else{
			return false;
		}
	} // gotSchedAction

	/**
	*/
	function gostMotherPage($directVal=true){
		$tools= &$this->tools;
		
		$mp= $tools->gostVal(_c_fMotherPage);		
		if ($mp===false){
			$xPage= $this->getRfxPage();
			$this->splitRfXpg($mp,$thrdIdx,$xIdx,$xPage);
		}
		
		if ($directVal===true){
			return $mp;
		}else{
			return $tools->binLoads($mp,_c_ko);
		}
	} // gostMotherPage
	
	
	/**
		Return true if the ressource (_c_fumXCode::_c_fumXmlCode) is booked from the specified Id couple 
		($userId,$mpName) or if attempted booking was successful and false otherwise. Storage is done inside the
		supporting page mirror (_c_forumPgRe::_c_fumXGate) for the full stream of comments of the page 
		independently of the local x index.
	
		Make sure the bottle neck is free before writting in common memory.
						
		Inoput :
			$userId : the userId (webmaster userId or forum userId) in relation with the given ressource. Important
				forum user Id and webmaster userId must always be different, so check actual allocation before 
				new attribution.
			$mpName : if given, the name of the page concerned by the concurrent ressource.
					
		Constants passed to $addTm :
			Webmaster booking : _c_fumWmResTmSlot
			Forum user booking : _c_fumReservTmSlot
			Un-booking : _c_fumNoBookingTm
	*/
	function bookedXGate($userId,$mpName, $addTm){
		$gateVal= $this->getXGate($mpName);	
		$bTm= $this->pageReposTm($mpName);	// booked time
		$cTm= time();	// curent time
		
		// Try to book it with its $userId
		if ( $gateVal===_c_ok || $gateVal===$userId || $gateVal!==$userId && $cTm>$bTm ){
			/* Is free or already booked by itself so book one slot! If another process does that simultaneously 
			 got to chexk before writing to separate simultaneous situations. */
			$this->reserveXGate($userId,$mpName, $addTm);
			
			/*
				OS/processor steps separator to make sure that the values tested by xgIsBooked() are not changed just after
				by a concurrent process getting into this space simultaneously! If "simultaneouslness" happend this loop makes 
				sure that one (in fact the last one) get the priority over the other.
					define('_c_processSepSteps',100);
					for ($i=0; $i<_c_processSepSteps $i++){}; 
				Not necessatry to have an active steps "waiter" because what counts is that the other process advance
				to a stable state and if it get also stack at the same time inside usleep() the necessary discriminebt writings
				are already done!
				
				Passive steps "waiter" (saves computer ressources) compared to an active one. _c_waitsMicrooSec is set
				as it is as an estimation, but it could be ajusted on specific servers in demanding situation.
			*/
			usleep(_c_waitsMicrooSec);
			
			if ($this->xgIsBooked($userId,$mpName)){
				// Really really booked! A concurrent thread ...
				return true;
			}else{
				return false;
			}
		}else{
			return false;	//  Can't book it, the user get a message and send the request again!
		}
	} // bookedXGate
	
	
	function freeXGate($pg){		
		$this->setXGate($pg, _c_ok);
		$this->setXTm($pg,0);
	} // freeXGate
	
	
	

	/**
		Returns true if the xGate is booked by the given user at the specified page and fals other wise.
		$shrdCd->xgIsBooked(&leftTime, $userId, $pg)
	*/
	function xgIsBooked($userId, $pg){
		$gateVal= $this->getXGate($pg);
		if ($gateVal===$userId){
			$leftTime= $this->pageReposTm($pg)-time();
			return $leftTime>0;
		}else{
			return false;
		}
	} // xgIsBooked
	
	
	/** ---------------------------------------------------------------------------------------------
		Does the X gate reservation for the specified couple ($userId,$pg) with a time depending 
		on the  "booking action $action :
		
		$action : possible booking actions : wmBook, fuBook, reset
		
		Constants :
			Webmaster booking : _c_fumWmResTmSlot
			Forum user booking : _c_fumReservTmSlot
			Un-booking : _c_fumNoBookingTm
	*/
	function reserveXGate($userId,$pg, $addTm){		
		$this->setXGate($pg, $userId);
		$this->setXTm($pg, time() + $addTm);
	} // reserveXGate	
		
	function setXGate($pgId,$id){
		$this->setPageRepos(_c_fumXGate,$id, $pgId);
	} // setXGate
	
	function setXTm($pgId,$tm){
		$this->setPageRepos(_c_fumXGSetTm,$tm, $pgId);
	} // setXTm
	
	
	/**
		Extract the page name from the _c_fumXCode Id
	*/
	function xCodePN($xCodeId){
		$dtb= &$this->dtb;
		
		$postId= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$xCodeId, _c_fXMainPostId);
		$pageId= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId, _c_fumMotherId);
		if ($pageId!==false){
			return $pageId;
		}else{
			return false;
		}
	} // xCodePN
		

	/**
		Return true if the xGate is long term booked
	*/
	function xGLongBooked($pg){
		return $this->leftBookedTm($pg) > _c_fumReservTmSlot;
	} // xGLongBooked
	
	/**
		Return the booking time left for the given page.
	*/
	function leftBookedTm($pg){
		$actualTm= time();
		$futureTm= $this->pageReposTm($pg);	 // was for sure a future time when the booking was done!
		return $futureTm-$actualTm;
	} // leftBookedTm	
	
	/**
	*/
	function pageReposTm($pg){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_forumPgRe, _c_fumRepId,$pg, _c_fumXGSetTm);
	} // pageReposTm
	
	
	/**
		Get the X gate value on the whole X code pages belonging to the page $pgId. 
		Probably the best compromise between a global unique gate (risk of too many colision) 
		and a fully specific gate (too difficult to extract : current, last or new? ... anyway
		most of the times the same!) to the modified X page.
	*/
	function getXGate($pgId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_forumPgRe, _c_fumRepId,$pgId, _c_fumXGate);
	} // getXGate
			

	/**
		Creates a new forum page repository.
		
		Input :
			$pgName : standard page name
			$curXId : to determine the free X Id (0 for initialisation step)
	*/
	function createPageRepos($pgName,$realForum=_c_ok){
		$dtb= &$this->dtb;	
		$valV= array($pgName,$realForum,'0','0','1',_c_ok,time(),_c_ok);
		$dtb->newElem(_c_forumPgRe, _c_fumRepId,$pgName, $valV);
	} // createPageRepos	
		
	/**
	*/
	function setPageRepos($fieldName,$fieldVal, $pgId){
		$dtb= &$this->dtb;
		if ($pgId[0]!=='_'){
			$dtb->setElem(_c_forumPgRe,  $fieldName,$fieldVal,  _c_fumRepId,$pgId);
		}
	} // setPageRepos
		

	/**
	*/
	function trashButton($url,$alt=false,$bImg='trashS.png'){
		$caps= &$this->caps;		
		if ($alt===false){
			$alt= 'Trash the concerned post!';
		}
		$img= $caps->image($caps->imgSrc($bImg,_c_ok),$alt,'fumImgBtt');
		return $caps->linkTC($url,$img,$alt,'fumImgBtt').$caps->span(' ','fumStd');			
	} // trashButton
	
	
	/**
		Display a personal forum user message for a given user until it's red!
		Stores it inside genAssoc until it's red, then dump it on a heap of infos!
		Could use the same heap for emails.
		Implementation : 
			Active storage : genAssoc, with user Id and hash  (need one more field in genAssoc infSup2)
			Archive storage : new heap/dump table.
			!!! easier to use a specific table, so can keep it there for archives + directly have the 
			necessary fields !!!
			
			The user can delete it with a click (url hash value).
			Need a message editor :
				- Use [eform ... ] tagjust the fields with explanation + generation of the hash.
				- ? use the occasion to build a general contact form 
					+ at some stage, would be nice to have a form generator ? ... just store many models!!!
			May send a webmaster email when the message was acknoledge.
	*/
	function persoWarning(){
		$glob= &$this->glob;		
		$tools= &$this->tools;		
		$caps= &$this->caps;		
		$dtb= &$this->dtb;
		$xRgt= &$this->xRgt;
		
		
		// Just some infos
		$justInfo= '';
		if ($this->globUsrMess!==''){
			$justInfo= _c_BrFlux.$caps->span($this->globUsrMess,'fumPersoMess')._c_BrFlux;
		}
		
		$moderMess= '';
		$lambdaMess= '';
		$userId= $this->fumLogUserId();
		$coreSignIn= $this->coreSignedIn($userId);
		$bigWarning= '';
		
		if ($coreSignIn){
			$pseudo= $this->curUserPseudo($userId);
			$aknowPW= $tools->getVal('aknowledgePW');
			
			if ( $aknowPW===_c_ok){
				$dtb->setElem(_c_fumUsrMessTN, _c_fumUsrMessRead,_c_ok,  _c_fumUsrMessId,$userId);
			}
			
			$read= trim($dtb->getElem(_c_fumUsrMessTN, _c_fumUsrMessId,$userId, _c_fumUsrMessRead));
			if ($read===_c_ko){
				$usrMess= $dtb->getElem(_c_fumUsrMessTN, _c_fumUsrMessId,$userId, _c_fumUsrMessInfo);
				$usrMess= trim($usrMess);
				if ($usrMess!==''){
					$usrMess= $caps->span($usrMess,'fumPersoMess');
					
					$url= $tools->urlCurPg();
					$url.= $tools->addUrlVar('aknowledgePW',_c_ok);
					$content= $pseudo.$glob->sl(' : Please click here to confirm that you have read this message.','kmgs');
					$agreeLink= _c_BrFlux._c_BrFlux.$caps->hL($url,$content,'fumPersoMess');
					$bigWarning= _c_BrFlux._c_BrFlux.$caps->sDiv($usrMess.$agreeLink,'width:800px; float:left; border: 4px solid red; padding: 10px; margin:0px;')._c_BrFlux._c_BrFlux;
				}
			}
						
			$lambdaMess= $glob->getFumserErr();
			if ($lambdaMess!=='' && $this->correctlySignedIn()){
				$lambdaMess= $caps->span($lambdaMess, 'userError')._c_BrFlux;
				$intro= $caps->span($glob->sl('Dear ','kmgq').$pseudo.$glob->sl(' you can correct the following error(s) : ','kmgr')._c_,'genLn');
				$lambdaMess= _c_BrFlux._c_BrFlux.$caps->sDiv($intro.$lambdaMess,'width:800px; float:left; border: 4px solid green; padding: 10px; margin:0px;')._c_BrFlux._c_BrFlux;
			}
		}
		
		return $justInfo.$bigWarning.$lambdaMess;
	} // persoWarning
	
	
	/**
		Trigger/Loads the server too busy message
	*/
	function loadsSTB(){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$this->globUsrMess.= $caps->span(_c_BrFlux._c_BrFlux.$glob->es('The server is too busy, try again in a few seconds!','kmgt')._c_,'fumError');
	} // loadsSTB
	
	
	/**
		Straight summary saving.
		Return the computed string for eventual display.
	*/
	function summarySaving(){
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		$dsplMode= $dtb->getGenVar(_c_fumSmryDsplMode);
		$curLg= $this->currentPageLg();

		$smryStr= $this->computePostSumry($curLg,$dsplMode);	// Compute the summary !!
		
		$curSumryName= _c_fumSumryPrfx.$curLg;
		$dtb->setGenVar($curSumryName, $smryStr);		// Saves it !!
		
		$extSumryStr= $smryStr;	// external summary string
		
		// Uses hard address for file stored summary
		$search= _c_IndexFN.'?';
		$replace= _c_siteUrlAccess.$search;
		$extSumryStr= str_replace($search,$replace,$extSumryStr);
		
		
		$totalStr= _c_R._c_R;
		$totalStr.= '<style type="text/css">'._c_R;
		$totalStr.= $dtb->getGenVar('fSummaryInlineCSS')._c_R;
		$totalStr.= '</style>'._c_R._c_R;
		$totalStr.= $extSumryStr._c_R._c_R;	
				
		
		$fName= _c_fumSumryDir.$curSumryName.'.txt';
		$fls->secUnlink($fName);
		$fls->strToFile($fName,$totalStr);
		
		
		$dtb->setGenVar(_c_fumTimeSmryPfx.$curLg, time());
		$dtb->setGenVar(_c_fumSmryFlagPrfx.$curLg, _c_ko);
		return $smryStr;	// Returns it in case of needs !!
	} // summarySaving
	
	
	/**
		Computes the summary of last posts
	*/
	function computePostSumry($curLg, $dsplMode){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		$lastTopId= $dtb->getGenVar('fumFreeId')-1;
		$bottomId= $dtb->getGenVar('fumFirstId');
		$dsplNb= $dtb->getGenVar('fumLastPostQty');		// number of posts to display

		// Algo : Just loop with decreasing index until we get X accepted posts or until we reach the smallest valid index fumFirstId
		$accptV= array();	// to be loaded with the past accepted posts
		$detectedNb= 0;
		$curId= $lastTopId;	
		while ($detectedNb<$dsplNb && $curId>=$bottomId){
			$curPostRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$curId);
			if ($curPostRec!==false){
				if ($curPostRec[_c_fumOkPost]===_c_ok && $curPostRec[_c_fumMssLg]===$curLg){
					$accptV[$detectedNb]= $curPostRec;
					$detectedNb++;
				}
			}
			$curId--;
		}

		$glob->inhibUniqEdtPfx= true;
	
		// Format the posts stored in $accptV[]
		$arCmd['shortCircAtt']= _c_surfEdt;
		$bDspl= '';
		$indx= 0;
		reset($accptV);
		foreach ($accptV as $key=>$postRec){
			$genXIdx= $postRec[_c_fumXIndx];
			$postId= $postRec[_c_fumPostId];
			$motherPg= $postRec[_c_fumMotherId];
			$ttl= $postRec[_c_fumMessTtl];
			
			$url= $this->generalLinkFromPR($genXIdx,$postId,$motherPg,$arCmd);
			$lnTtl= $caps->hL($url,$ttl,'fumPostTtl');
			
			if ($indx===0 && $dsplMode==='inline'){
				$bDspl.= $this->postTitle($lnTtl,$postId,'',false,'firstInline',$arCmd);
			}else{
				$bDspl.= $this->postTitle($lnTtl,$postId,'',false,$dsplMode,$arCmd);
			}
			$indx++;
		}	
		$glob->inhibUniqEdtPfx= false;
	
		return $bDspl;
	} // computePostSumry

	
	/**
		Return true if we are allowed to save/update the summary --> 2 conditions :
			(1) the necessary time has gone fSummaryIdleHours
			(2) new information came in in the concerned language --> need a flag
	*/
	function timeToSaveSumry(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$curLg= $this->currentPageLg();
		$actionFlag= $dtb->getGenVar(_c_fumSmryFlagPrfx.$curLg);
				
		$savedTm= $dtb->getGenVar(_c_fumTimeSmryPfx.$curLg);
		$deltaTm= time() - (int)$savedTm;
		
		$hours= $dtb->getGenVar(_c_fSmryIdleHours);
		$sec= $hours*3600;
		
		return $actionFlag===_c_ok && $deltaTm>$sec;
	} // timeToSaveSumry	

	
	/**
	*/
	function currentPageLg(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$pg= $tools->curPageName();		// only ok when we are on the summary page!
		return $dtb->currentLg($pg);
	} // currentPageLg
		

	/**
		Send an email form to a Crypted (default) or clear address email --> last param to false.
	*/
	function sendEMailFCA($cryptedEmailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom,$uncrypt=true){
		$hPwC= &$this->hPwC;
		$dtb= &$this->dtb;
		$email= &$this->email;
	
		if ($uncrypt){
			$seed= $dtb->getGenVar('fPolyCrypt');		
			$emailTo= $hPwC->doUnCrypt($cryptedEmailTo,$seed);	// does not check multibytes, but fine for emails!!
		}else{
			$emailTo= $cryptedEmailTo;	// in fact not crypted
		}
		
		return $email->sendEMail($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom);
	} // sendEMailFCA
	

} // fumShrdCdLgt
?>