<?php
/**
	File name : fumSuperLight.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Just to define a few forum constants common to other plugins.
*/
class fumSuperLight extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();
		
		$this->glob= &$tagsFu->glob;
		$this->aSql= &$tagsFu->aSql;
		$this->dtb= &$tagsFu->dtb;
		$this->parser= &$tagsFu->parser;
		$this->hPwC= &$tagsFu->hPwC;
		
		
		$this->tools= &$tagsFu->tools;
		if (!defined ('_c_fsmplUsersTbl')){		// usefull before super light creation?? Check
		
			/* --------------------------------------------------------------------
				Forum User table.  See $dtb->newElem(_c_fsmplUsersTbl  ..
				See ->newFumUser()..
			*/	
			define('_c_fsmplUsersTbl', 'fUsrTbl');	// simple === short user table (the default, 1st paragraph)			
				define('_c_fUserId',_c_genId);		// The safeIdStr() of _c_fUserPseudo / A unique STRING Id|paseudo	
				define('_c_fUserPseudo','pseud');	// Displayed user pseudo
				define('_c_fUserNbPost','nbPost');	// number of  posts / user
				
				define('_c_fAvatar','avatar');		// avatar image name
				
				define('_c_fUserMail','mail');		// user email							
				define('_c_fUserMok','mailOk');		// user email verified : ok or ko
				define('_c_fHashConf','confHash');	// email confirmation hash
				
				// define('_c_fUserNewMail','newMail');		// user email							
				define('_c_fUserCpw','cpw');		// auto-crypted password.				
				define('_c_fPrimHash','primHash');	// Hash used to crypt the password once for the whole session
				define('_c_fUserC2pw','c2pw');		// primHash*cpw password.
				define('_c_fCurHash','curHash');	// current Hash for this user
				
				
				// User xpetal right(s), could be empty! 1st Added manually
				define('_c_fUsrXmlRight','xRights');	// forum user xpetal rights
				
				
				// In case of minOwn status, how long in hours to still improve the messages after message acceptation
				define('_c_fUFreeTime','uFreeT');
				
				
				// To count the current post on the current day. Format : 13d65/1   ... (year 2 digits + 'd' + day ordinal + '/' + countor)   
				define('_c_fDailyPosts','dailyPosts');	

				
				define('_c_fRgstrDate','rDate');	// registration date
				define('_c_fRgstrIP','rIP');		// registration IP
				
				// secret directory name to store image that need manual review! Start with _ so it does not creates thumbs
				define('_c_fUsrSecretDir','secretDir');	
				
				define('_c_fUsrImgWallTxt','imgWallTxt');	// text to interprete for the image wall
				define('_c_fUsrPostWallId','postWallId');	// Id of the post used for the post wall
				
					
		
			// Special to get the emoticons and small picts
			define('_c_fFillerDivName','emoticonFiller');		// original
			define('_c_edtFillDivName','edtGallDivNm');			// new one for the editior
			
			define('_c_fIconsPgName','_icons');
			
			define('_c_fMessageBodyTxtArNm','bdyNm');			// "original" : _c_taMainStNm = 'mainStr'
			
			// Category of JS filler : cpcJs (100% javascript), CllIFrmPg (call an iframe with the correct page name is forced into the filler)
			define('_c_fJsFillerCateg','iconSetNm');
				define('_c_fCpcJs','CpcJs');
				define('_c_fCllIFrmPg','CllIFrmPg');
			
			define('_c_fumStopEmotMoves','stopEmotMoves');
			define('_c_fumUserId','fumUserId');
			define('_c_fumMainUsrId','fumUsrId');		// The main user id/cookies-name, also hard coded into forum.js
			
			// A prefix for the forum summary to be used inside the genVar table!
			// ...better visual access and quicker than with genAssoc ...
			// as a start : declares the record in advance.
			define('_c_fumSumPrfx','fSummmary_');
		}
		
		$this->subUsRegitrPg= false;	// ()only local to this class True when we call the subuser registration widget
	} // construct
	
	
	function corePersoPath($userId,$short=false){
		$base= 'forum/users/perso/'.$userId;
		if ($short){
			return $base;
		}else{
			return $base.'/';
		}
	} // corePersoPath
	
	
	/**
		WARNING : only used it for general display and never for sensitive data !!!!!!!!!
		Get it from the url if not available with fumLogUserId() !!!
		
		In fact mainly useful for cases where the web master is interested to examine the state of different
		forum users data.
	*/
	function smartUserId(){
		$tools= &$this->tools;
		return $tools->getVal(_c_fumUserId, $this->fumLogUserId());
	} // smartUserId	

	/**
		A tenporary ersatz for some smartUserId() calls! 
	*/
	function curErsatzLogUser(){
		return $this->fumLogUserId();
	} // curErsatzLogUser	
	
	
	/**
		Return true if the logged user is equal from the watched user
	*/
	function uIdLogWatch(){
		$lId= $this->fumLogUserId();
		return $this->smartUserId()===$lId && $lId!==_c_userNoRight;
	} // uIdLogWatch
	
	
	/**
		Returns the current user pseudo (for now underused).
	*/
	function curUserPseudo($userId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserPseudo);
	} // curUserPseudo
	
	
	
	/**
		Currently logged user Id
			---> coreSignedIn($usrId)
		Input :
			The cokie variable _c_fumMainUsrId
		Output :
			Returns the currently logged user Id
	*/
	function fumLogUserId(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		if ($glob->forumCurLogUserId!==_c_userNoRight){
			return $glob->forumCurLogUserId;	// keeps its logged status at least till the next click
		}
		
		$uId= $tools->ckVal(_c_fumMainUsrId,_c_userNoRight);
		if ( $this->coreSignedIn($uId) ){
			$glob->forumCurLogUserId= $uId;
			return $uId;
		}else{
			return _c_userNoRight;
		}
	} // fumLogUserId

		
	/**
		Return true if the GIVEN USER is correctly Signed / logged In.
		$this->coreSignedIn(this->fumLogUserId())
	*/
	function coreSignedIn($usrId){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		
		$usrRec= $dtb->getElem(_c_fsmplUsersTbl,_c_fUserId,$usrId);
		if ($usrRec===false){
			return false;
		}
		
		$cem= $dtb->getGenVar('compulsEMailVerif');
		if ($cem===_c_ok){
			// Insist on Email verification
			$mailVerif= $usrRec[_c_fUserMok]===_c_ok;
			if (!$mailVerif){
				return false;
			}
		}
		
		$c2pw= $usrRec[_c_fUserC2pw];
		if ($c2pw===_c_ko){
			return false;
		}
				
		// CURRENT HASH
		$curHash= $tools->postVal('curHash');
		if ($curHash===false){
			$curHash= $usrRec[_c_fCurHash];
		}
		
		$cryptHashPw= $tools->ckVal('fumUsrRight');
		$phpCryptRes= $hPwC->doCrypt($curHash,$c2pw);
		$isSignIn= $cryptHashPw===$phpCryptRes;
		if ($isSignIn){
			// so parasitic url from unlogged user do not return false positive	
				
			$fumUnlog= $tools->getVal('fumUnlog');
			if ($fumUnlog===_c_ok){
				// just unlog
				$userId= $tools->ckVal(_c_fumMainUsrId,_c_userNoRight);
				$dtb->setElem(_c_fsmplUsersTbl,  _c_fUserC2pw,_c_ko,  _c_fUserId,$userId);
				$dtb->setElem(_c_fsmplUsersTbl,  _c_fPrimHash,_c_ko,  _c_fUserId,$userId);
				$dtb->setElem(_c_fsmplUsersTbl,  _c_fCurHash,_c_ko,  _c_fUserId,$userId);
				$dtb->setElem(_c_fsmplUsersTbl,  _c_fHashConf,_c_ko,  _c_fUserId,$userId);
				$this->initSessNb();
				$glob->setGlobJsCode('forum.unlog();'._c_R);	// unlog
				return false;
			}else{
				return true;	// ON GOING SIGNED IN
			}
		}else{
			return false;
		}		
	} // coreSignedIn
	
	/**
	*/
	function initSessNb(){
		$dtb= &$this->dtb;
		$dtb->setGenVar('fSessCallNb','0');
	} // initSessNb
	
				
				
	/**
		$mailOk= $this->mailIsOk($userId);
	*/
	function mailIsOk($userId){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserMok)===_c_ok;
	} // mailIsOk
	
		
	

} // fumSuperLight
?>
