/**
	File name : forumBar.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/*
	Tag insertion for forum.
	
	Note : we have a small overlapp with JS insertion buttons while in editing mode, 
	even if many of these insert directly some html. Some basic text processing are commun, 
	so at some stage should extract the basic string manips and use them in common.
	
	forumBar::atStartSetFmBar()

*/
function forumBar(){

	var txagStartVN= new Array(39);	
	var txagEndVN= new Array(39);			

	var nLn= "\n";

	// Pseudo constants Forum bar user side text area and div capsulating	
	var cglobUserTAStr= 'bdyNm';
	var cglobUserDivStr= 'emoticonFiller';
	
	// Forum bar editor side text area and div capsulating	
	var cglobEdtTAStr= 'mainStr';
	var cglobEdtDivStr= 'edtGallDivNm';

	// Active forum bar Area Div current values Initialised with the origibal forum area name.
	var globTxtAreaNm= 'none';
	var globGalleryDivName= 'none';
	

	/* ---
		Compulsory interface for all methods called from outside !!!!!!!!!!
	*/
	this.txtArAct= txtArAct;
	this.txtAActParent= txtAActParent;
	
	this.memoScrollBarPos= memoScrollBarPos;
	this.setScrollBarPos= setScrollBarPos;
	
	this.emoSwitchOn= emoSwitchOn;
	this.setFiller= setFiller;
	this.fumBarTxt= fumBarTxt;
	
	this.emoSwitchOff= emoSwitchOff;
	
	
	this.setSelFontVal= setSelFontVal;
	this.setSelWeightVal= setSelWeightVal;
	this.setSelSizeVal= setSelSizeVal;
	this.setSelColorVal= setSelColorVal;
	
	this.setFumBar= setFumBar;
	this.atStartSetFmBar= atStartSetFmBar;
	
	this.setInnerHtml= setInnerHtml;
	this.biMdBut= biMdBut;
	this.jsBarBiMdBut= jsBarBiMdBut;

	this.techBarButtton= techBarButtton;
	this.fumBarButtton= fumBarButtton;


	var countJbbbCalls= 0;

	/* ---
		Methods bodies :
			gTgName : given tag name
	*/

	/*
		forumBar.setFumBar('bdyNm','emoticonFiller');	// strict forum case
		forumBar.setFumBar('mainStr','edtGallDivNm');	// general edition case
	*/
	function setFumBar(areaNm,galNm){
		globTxtAreaNm= areaNm;
		globGalleryDivName= galNm;
		localStorage.globalTxtAreaNm= areaNm;
	}; // setFumBar


	/*
		At the starting of a php thread : set the forum bar among the 2 given couple area/div-Capsul (test only the area):
			- on the one available if only one couple is available.
			- on the editor side if the 2 couples are available
			- does not set the forum bar if none are available
		Need to be call at the end of the code
		
		Input :
			mainEditFumBar: forum bar from the start on the main editor ok or ko
	*/
	function atStartSetFmBar(mainEditFumBar){
		var userTA= document.getElementById('bdyNm');
		var edtTA= document.getElementById('mainStr');
		
		if (userTA===null && edtTA===null){
			return '';
		}else{
			if (userTA!==null && edtTA!==null){
				if (mainEditFumBar==='ok'){
					setFumBar(cglobEdtTAStr,cglobEdtDivStr);	// preference on edition side
				}else{
					setFumBar(cglobUserTAStr,cglobUserDivStr);	// preference on surf side
				}
			}else{
				// one or the other case
				if (edtTA!==null){
					setFumBar('mainStr',cglobEdtDivStr);	// only editor
				}else{
					setFumBar(cglobUserTAStr,cglobUserDivStr);	// only user case
				}
			}
		}
	}; // atStartSetFmBar

		
	/**
		Text area action, does a tag action at the clicked place.
		
		Input :
			gTgName ; tag name.
			jump : (facultative, default === ko) insertion jumps to the end of the tag after the action if ok, otherwise ko
			// txtArNm :(facultative, default === bdyNm)
	*/
	function txtArAct(gTgName,jump,xmlStr){	
		// Action button and targeted area are on the same page.
		txtArActCore (gTgName,jump,xmlStr, globTxtAreaNm, 'ko');
	} // txtArAct
	
	
	function txtAActParent(gTgName,jump,xmlStr){	
		// Action buttons is inside an IFrame in the parent page that hold the targeted area.
		txtArActCore (gTgName,jump,xmlStr, localStorage.globalTxtAreaNm, 'ok');
	} // txtAActParent
	
	
	function txtArActCore(gTgName,jump,xmlStr, txtArNm, prnt){	
        if (kk.isUndef(xmlStr)){
        	xmlStr= '';	// so it's obviuously not used!
        }
        
		if (prnt==='ok'){
			var txtArea= parent.document.getElementById(txtArNm);
		}else{
			if (document.getElementById(txtArNm) === null){
				txtArNm= 'mainStr';		// _c_taMainStNm;	Case of direct forum bar webmaster edition. Adaptation at calling time is harder
			}
			var txtArea= document.getElementById(txtArNm);
		}
		
		if (txtArea===null){
			txtArea= document.getElementById('debugDisplay');
			var ren= 'This is a test-TextArea, if you wish to have an effect on the text area of the parent window, you need to click the purple bottom arrow of the parent window. Otherwise the clicked image was : ';
			kk.writeNl( ren + kk.replaceCodedChar(xmlStr) );
			kk.writeNl('');
			return '';
		}
		
		var tagStart= '';
		var tagEnd= '';
		var tagName= gTgName;
		var taST= txtArea.scrollTop;	// memorise the current vertical position in the textares
		
		if (txtArea.value.length == txtArea.selectionStart){
			/* The cursor is likely to have been set artificially to the end of the area, so correct it
			   Drawback : cant't insert at the tip end, rearly happens + easy to avoid + a push is not
			   really an insertion. */
			txtArea.selectionStart= this.txtArrEndInsertPos;
			txtArea.selectionEnd= this.txtArrEndInsertPos;
		}

		var startPos = txtArea.selectionStart;
		var endPos = txtArea.selectionEnd;		
		var slTxt = txtArea.value.substring(startPos, endPos);
				
		this.txtArrEndInsertPos= endPos + tagStart.length + tagEnd.length;	

		var transformedStr= transformSelStr(tagName,slTxt,xmlStr);
		var deltaTransformSz= transformedStr.length - slTxt.length;
	
		txtArea.value = txtArea.value.substring(0, startPos)
			+ transformedStr
			+ txtArea.value.substring(endPos, txtArea.value.length);

        if (kk.isUndef(jump)){
        	jump= 'ko';
        }

        if (jump==='ko'){
	        txtArea.selectionStart = startPos;
	        txtArea.selectionEnd = endPos + deltaTransformSz;
	        
	        var lastPos= transformedStr.length - 1;
	        var lastChar= transformedStr.charAt(lastPos);
	        if (lastChar === nLn){
	        	txtArea.selectionEnd--;
	        }
        }else{
			var cursorPos= endPos + deltaTransformSz;
	        txtArea.selectionStart = cursorPos;
	        txtArea.selectionEnd = cursorPos;			
        } 

        txtArea.scrollTop = taST;  // to stay on current position, max --> txtArea.scrollHeight;
        txtArea.focus();
 	} // txtArActCore
 	
	/*
		A function to call just before posting to memorize the scroll bar position.
		 js=" onsubmit=\"forumBar.memoScrollBarPos('bdyNm')\""
	*/
	function memoScrollBarPos(txtArNm){
		var txtArea= document.getElementById(txtArNm);
		if (txtArea!==null){
			localStorage.fumScrollBarPosY= txtArea.scrollTop;
		}
	}; // memoScrollBarPos

	/*
		A function to recover and set the scroll bar position.
	*/
	function setScrollBarPos(txtArNm){
		var txtArea= document.getElementById(txtArNm);
		txtArea.scrollTop = localStorage.fumScrollBarPosY;
        txtArea.focus();
	}; // setScrollBarPos

 	
	/*
		Erases squared Tags
	*/
	function erasesSqrtTg(str){
		var inTag= false;
		var stripped=''
		var sz= str.length;
		
		for (var i=0; i<sz; i++){
			//--- var cn= str[i];
			var cn= str.charAt(i);
			var delay= false;

			switch (cn){
				case '[':
					inTag= true;
				break;
				
				
				case ']':
					inTag= false;
					delay= true;
				break;							
			} // switch

			if (!inTag && !delay){
				stripped+= cn;
			}
		} // for	
		return stripped;
	}; // erasesSqrtTg


	/*
		Transforms the selected string, deal with the clicked position depending on what tag was clicked.
		... Or just button only functions.
		Input :
			tagName : the chosen input.
			slTxt : the selected text.
			xmlStr : the given xml2 string (the final tag string)		
	*/
	function transformSelStr(tagName,slTxt,xmlStr){
		switch(tagName){
			case 'emot':
			case 'gmot':
				var xStr= kk.replaceCodedChar(xmlStr,'Z');
				xStr= kk.strReplace('bSYdG', '"', xStr);	// 3rd level, part of kk.replaceCodedChar(xmlStr,'Y') but faster
				return xStr;
			break;
			
			case 'icon':
				var xStr= kk.replaceCodedChar(xmlStr);
				return xStr;
			break;
			
			case 'upper':
				return slTxt.toUpperCase();
			break;
			
			case 'lower':
				return slTxt.toLowerCase();
			break;

			case 'change':
				return toOtherCase(slTxt);
			break;

			case 'bold':
				return bold(slTxt);
			break;

			case 'underline':
				return underline(slTxt);
			break;

			case 'italic':
				return italic(slTxt);
			break;

			case 'indent':
				return indent(slTxt);
			break;

			case 'unindent':
				return unindent(slTxt);
			break;
			
			case 'fullUndnt':
				return fullUndnt(slTxt);
			break;

			case 'bulletList':
				return orderedList(slTxt,'bull');
			break;

			case 'numList':
				return orderedList(slTxt,'num');
			break;

			case 'alphaList':
				return orderedList(slTxt,'alpha');
			break;

			case 'romanList':
				return orderedList(slTxt,'roman');
			break;
			
			case 'erasesSqrtTg':
				return erasesSqrtTg(slTxt);
			break;


			case 'leftHook':
				return '[lb/]';
			break;
			
			// nbsp
			case 'nsp':
				return '[nsp/]';
			break;
			
			
			case 'rightHook':
				return '[rb/]';
			break;
			
			case 'lessThan':
				return '[lt/]';
			break;
			
			case 'greaterThan':
				return '[gt/]';
			break;			

			// Html tags
			case 'mainMeta':
				return mainMeta(slTxt);
			break;

			case 'title':
				return htTitle(slTxt);
			break;

			case 'descript':
				return htDescript(slTxt);
			break;

			case 'kWord':
				return htKWord(slTxt);
			break;


			case 'softBreak':
				return softBreak('softBreak');
			break;

			case 'hardBreak':
				return hardBreak('hardBreak');
			break;


			case 'at':
				return emailObfuscation(slTxt);
			break;
			
			case 'atWm':
				return emailObfuscationWm(slTxt);
			break;


			
			case 'bookMark':
				return bookMark(slTxt);
			break;

			case 'jumpToBm':
				return jumpToBm(slTxt);
			break;

			case 'jumpToBmWm':
				return jumpToBmWm(slTxt);
			break;


			case 'localLink':
				return localLink(slTxt);
			break;

			case 'localLinkWm':
				return localLinkWm(slTxt);
			break;
			
			
		
			case 'globalLink':
				return globalLink(slTxt);
			break;
		
			case 'globalLinkTrgt':
				return globalLinkTrgt(slTxt);
			break;
			
						
			case 'smplImage':
				return smplImage(slTxt);
			break;
						
			case 'smplImgJ':
				return smplImgJ(slTxt);
			break;
			
			
			case 'editorImage':
				return editorImage(slTxt);
			break;
			
			case 'linkedImage':
				return linkedImage(slTxt);
			break;
			
			case 'linkedImgJ':
				return linkedImgJ(slTxt);
			break;
			
			case 'zoomedImg':
				return zoomedImg(slTxt);
			break;
			
			case 'zoomHLn':
				return zoomHLn(slTxt);
			break;
			
			case 'transpImg':
				return transpImg(slTxt);
			break;
			
			case 'useSpan':
				return formatSentence(slTxt);
			break;
			
			
			default:
				alert('Error : forumBar::transfSelStr');
		}	
	}; // transformSelStr


	/*
		Secure font formating
	*/
	function formatSentence(str){
		var cFont= kk.getSelVal('comboFumFomt');
		if (cFont!=='ko'){
			var cFontStr= ' font="'+cFont+'"';
		}else{
			var cFontStr= '';
		}
				
		var wght= kk.getSelVal('comboFumWeight');
		if (wght!=='ko'){
			var wStr= ' weight="'+wght+'"';
		}else{
			var wStr= '';
		}
		
		var sz= kk.getSelVal('comboFumSz');
		if (sz!=='ko'){
			var szStr= ' size="'+sz+'"';
		}else{
			var szStr= '';
		}
		
		var colorVal= kk.getSelVal('comboFumColor');
		if (colorVal!=='ko'){
			var colorStr= ' color="'+colorVal+'"';
		}else{
			var colorStr= '';
		}
		
		if (cFontStr!=='' || wStr!=='' || szStr!=='' || colorStr!==''){
			return '[sentence'+ cFontStr + wStr + szStr + colorStr +']'+str+'[/sentence]';
		}else{
			return str;
		}
	}; // formatSentence


	/*
	*/
	function smplImage(str){
		if (str===''){
			return '[i name="imageName" alt="" cls="imgLnStl" /]';
		}else{
			return '[i name="'+str+'" alt="" cls="imgLnStl" /]';
		}
	}; // smplImage
	
	function smplImgJ(str){
		if (str===''){
			return '[j name="imageName" alt="" supStl="width:50%" /]';
		}else{
			return '[j name="'+str+'" alt="" supStl="width:50%" /]';
		}
	}; // smplImgJ
	
	
	

	function editorImage(str){
		if (str===''){
			return '[i name="imageName" edt="ok" alt="" ttl="" cls="imgLnStl" /]';
		}else{
			return '[i name="'+str+'" edt="ok" alt="" ttl="" cls="imgLnStl" /]';
		}
	};

	/*
	*/
	function linkedImage(str){
		if (str===''){
			return '[i name="imageName" url="" alt="" ttl="" cls="imgLnStl" /]';
		}else{
			return '[i name="'+str+'" url="" alt="" ttl="" cls="imgLnStl" /]';
		}
	};
	
	function linkedImgJ(str){
		if (str===''){
			return '[j name="imageName" url="" alt="" ttl="" cls="imgLnStl" supStl="width:50%" /]';
		}else{
			return '[j name="'+str+'" url="" alt="" ttl="" cls="imgLnStl" supStl="width:50%" /]';
		}
	};
	
	
	/*
		'name','alt','cls','p'
	*/
	function zoomedImg(str){
		if (str===''){
			return '[z name="imageName" alt="" ttl="" cls="imgLnStl"][/z]';
		}else{
			return '[z name="'+str+'" alt="" ttl="" cls="imgLnStl"][/z]';
		}
	};
	
	/**
	*/
	function zoomHLn(str){
		if (str===''){
			return '[za pfx="aaa" imgN="imageName" cls="gecStandLn"] VisibleText [/za]';
		}else{
			return '[za pfx="aaa" imgN="imageName" cls="gecStandLn"]'+str+'[/za]';
		}
	};


	/*
		('width','height','cls','stl'
	*/
	function transpImg(str){
		return '[transp width="200" height="1" cls="imgLnStl" /]';
	};


	/*
	*/
	function globalLink(str){
		return '[a url="httpWwwExampleDotOrg" target="blank" cls="fumLink"]'+str+'[/a]';
	};

	/*
		globalLink(str) version slightly more flexible for webmasters
	*/
	function globalLinkTrgt(str){
		return '[a url="httpWwwExampleDotOrg" target="blank" cls="gecStandLn"]'+str+'[/a]';
	};


	/*
	*/
	function bookMark(str){
		return '[bookMark id="OnlyChosenName"/]';	// The postId is added automatically
	};


	function jumpToBm(str){
		return '[jumpToBm id="postId + ChosenName" cls="fumLink" ]'+str+'[/jumpToBm]';
	};

	function jumpToBmWm(str){
		return '[jumpToBm id="postId + ChosenName" cls="gecStandLn" ]'+str+'[/jumpToBm]';
	};


	/*
	*/
	function localLink(str){
		return '[a url="pageName" cls="fumLink"]'+str+'[/a]';
	};
	
	function localLinkWm(str){
		return '[a url="pageName" cls="gecStandLn"]'+str+'[/a]';
	};

	/*
		Simple javascript email obfuscation.
	*/
	function emailObfuscation(str){
		return '[email addr="'+str+'" cls="fumLink"]'+str+'[/email]';
	};

	function emailObfuscationWm(str){
		return '[email addr="'+str+'" cls="gecStandLn"]'+str+'[/email]';
	};


	/*
	*/
	function softBreak(){
		return '[br/]';
	};

	function hardBreak(){
		return '[bf/]';
	};


	/*
	*/
	function htTitle(str){
		return '[title]'+str+'[/title]';
	}; // htTitle

	/*
	*/
	function htDescript(str){
		return '[descr]'+str+'[/descr]';
	}; // htDescript

	/*
	*/
	function htKWord(str){
		return '[kw]'+str+'[/kw]';
	}; // htKWord


	/*
	*/
	function mainMeta(str){
		return htTitle('MyOptimizedTitle') + nLn + htDescript('MyOptimizedDescription') + nLn + htKWord('MyOptimizedKeyWords. Note : this field is the least important');
	}; // mainMeta


	/*
		Input :
			str : selected string.
			kind : of list.
	*/
	function orderedList(str, kind){
		var v= str.split(nLn);
		var sz= v.length;
		var sum= '';
		
		for (var i=0; i<sz; i++){
			var info= kk.trim(v[i]);
			if (info!==''){
				sum+= "\t" + '[li]' + kk.trim(v[i]) + '[/li]';
				sum+= nLn;
			}
		}
				
		switch (kind){
			case 'bull':
				var prfxTg= '[ul]';
			break;
						
			case 'num':
				var prfxTg= '[ol]';
			break;			
			
			case 'alpha':
				var prfxTg= '[ol stl="lowAlpha"]';
			break;
			
			case 'roman':
				var prfxTg= '[ol stl="upRoman"]';
			break;
			
			default:
				alert('Error:orderedList 1');
		} // switch

			
		if (kind==='bull'){
			return prfxTg +nLn + sum + '[/ul]'+nLn;
		}else{
			return prfxTg +nLn + sum + '[/ol]'+nLn;
		}
	}; // orderedList

	/*
		Indent a paragraph with tabs!
	*/
	function indent(str){
		var v= str.split("\n");
		var sz= v.length;
		var sum= '';
		
		for (var i=0; i<sz; i++){
			var curStr= v[i];
			if (curStr!==""){
				sum+= "\t" + curStr;
			}
			
			if (i<sz-1){
				sum+= "\n";
			}
		}
		return sum;
	}; // indent
	
	
	/*
		Extract the char code of a character by comparison with the 256 1st characters
			Input :
				c : given character
	*/
	function charOrd(c){
		for (var i=0; i<256; i++){
			if (String.fromCharCode(i) === c){
				return i;
			}
		} // for
		
		return 'Not found';
	}; // charOrd


	function unindent(str){
		var v= str.split("\n");
		var sz= v.length;
		var sum= '';
		for (var i=0; i<sz; i++){
			var curStr= v[i];
			var szCurStr= curStr.length;
			var fc= curStr.charAt(0);	// first char
			var nlPrfx= '';	// new line prefix
			if (i!==0){
				nlPrfx= "\n";
			}
									
			if ( kk.isTabable(fc) ){
				sum+= nlPrfx + curStr.substring(1);
			}else{
				sum+= nlPrfx + curStr;
			}			
		}
		return sum;
	}; // unindent


	/*
	*/
	function bold(str){
		return '[b]'+str+'[/b]';
	}; // bold

	function underline(str){
		return '[u]'+str+'[/u]';
	};

	function italic(str){
		return '[itc]'+str+'[/itc]';
	};


	/*
	*/
	function fullUndnt(str){
		var v= str.split("\n");
		var sz= v.length;
		var sum= '';
		for (var i=0; i<sz; i++){
			if (i!==0){
				sum+= "\n";
			}			
			sum+= kk.trim( v[i] );			
		}
		return sum;
	}; // fullUndnt


	/*
		Invert the case of the given string.
	*/
	function toOtherCase(s){
		var sz= s.length;
		var c= '';
		var d= '';
		var e= '';
		for (var i=0; i<sz; i++){
			c= s.charAt(i);		
			d= c.toLowerCase();
			if (d==c){
				d= c.toUpperCase();	// so changes it this time!
			}
			e= e+d;
		}
		return e;
	}; // toOtherCase

	/*
	*/
	function emoSwitchOn(){
		var sbjct= localStorage.emotStore;
		
		sbjct= kk.replaceCodedChar(sbjct,'');
		document.getElementById(globGalleryDivName).innerHTML= sbjct;
	}; // emoSwitchOn

	/*
	*/
	function emoSwitchOff(){
		document.getElementById(globGalleryDivName).innerHTML= '';
	}; // emoSwitchOff

	/**
		Loads / set the proper iFrame fully fetched (correct page etc.)
		inside the <div ...>  to fill.
		Input :
			iframeStr : iframe full string (need to rebuild the ")
	*/
	function setFiller(iFrSmall, iFrLarge){
		if (globGalleryDivName==='emoticonFiller'){
			var iframeStr= iFrSmall;	// ---> on the forum users side!
		}else{
			var iframeStr= iFrLarge;
		}
	
		iframeStr= kk.strReplace('dBlG','"', iframeStr);
		iframeStr= kk.strReplace('CrLn', kk.crLn, iframeStr);
		
		var pt= document.getElementById(globGalleryDivName);
		if (pt===null){
			globGalleryDivName= 'edtGallDivNm';	// default webmaster editor!
			pt= document.getElementById('edtGallDivNm');
		}
		pt.innerHTML= iframeStr;
	} // setFiller
	
	
	/*
		Loads a text instead of the standard Iframe. A forum bar information text!
	*/
	function fumBarTxt(info){	
		info= kk.replaceCodedChar(info);
		document.getElementById(globGalleryDivName).innerHTML= info;
	}; // fumBarTxt
	

	/**
	*/
	function setSelFontVal(){
		kk.setSelVal('comboFumFomt',localStorage.comboFumFomt);
	}

	/**
	*/
	function setSelWeightVal(){
		kk.setSelVal('comboFumWeight',localStorage.comboFumWeight);
	}

	/**
	*/
	function setSelSizeVal(){
		kk.setSelVal('comboFumSz',localStorage.comboFumSz);
	}

	/**
	*/
	function setSelColorVal(){
		kk.setSelVal('comboFumColor',localStorage.comboFumColor);
	}
	
	/*
		Set the general Html object tagName with the given content
		Input:
			content : the subject string to strReplace and store
			tagName : the name of the tag to change its content.
			sffx : suffix for complex multi levels, by default sffx becomes '' and only the prefixed constants count.
	*/
	function setInnerHtml(content,tagName,sffx){
		setFumBar('mainStr','edtGallDivNm');
		kk.setInnerHtml(content,tagName,sffx);
	}; // setInnerHtml
	

	/*
		A specialised bi mode javascript button for the forum bar. 
		Remark : the two variable values/names are there to pass the data to be used 
		
		Could also HAVE BEEN SIMPLER TO PASS A FUNCTION IN "PARAMETER" to deal with that
		problem! So this biMdBut function stay just specialiszed for the switch of the forum bar.
	
		Strategy : set the innerHTML of a specified div (divNm given), with a choice between 2 images and 2 matching actions.
		Input :
			Just passed as real variables
				varA
				varB
		
			Just passed as strings
				varNmA ; a preloaded javascript variable used to load the div : divInfoNm.innerHTML= varNmA
				varNmB ; a preloaded javascript variable used to load the div : divInfoNm.innerHTML= varNmB
			
			divInfoNm : name of the capsulating div tag arround the main information to change..
			divButNm : name of the capsulating div tag arround the button.
			imgDfnA : image A (default).
			imgDfnB ; second image.
			cond : a variable indicating the condition of the button and its loaded state so we don't have to test 
				the actual full content, especially practicle at the beginning when the content may not be there.
				--> ok===A  ko===B  (for convention compatibility with php),
				
		Called with: [biMdBut .../].
	*/
	function biMdBut(varA,varB,varNmA,varNmB,divInfoNm,divButNm,imgDfnA,imgDfnB,cond,altA,altB){
		coreBiMdBut(varA,varB,varNmA,varNmB,divInfoNm,divButNm,imgDfnA,imgDfnB,cond,altA,altB,'biMdBut');
	}; // biMdBut
	
	
	/*
		A special bi-mode button for the edition JS bar.
	*/
	function jsBarBiMdBut(varA,varB,varNmA,varNmB,divInfoNm,divButNm,imgDfnA,imgDfnB,cond,altA,altB){
	
		coreBiMdBut(varA,varB,varNmA,varNmB,divInfoNm,divButNm,imgDfnA,imgDfnB,cond,altA,altB,'jsBarBiMdBut');
				
		if (countJbbbCalls>0){
			var gName= 'mainStr ';
			var spcCkName= genAsa.globUniqPrefix + 'ckmainStr';
			
			genAsa.removeNicEditor(gName,spcCkName,'ko');
		}
		countJbbbCalls++;
		
	}; // jsBarBiMdBut
	
	
	function coreBiMdBut(varA,varB,varNmA,varNmB,divInfoNm,divButNm,imgDfnA,imgDfnB,cond,altA,altB, parentFuNm){
		var ptDivInf= document.getElementById(divInfoNm);
		if (cond==='ok'){
			// A state, with a B image displayed, so changes it!
			if (ptDivInf!==null){
				var purgedB= kk.replaceCodedChar(varB,'Z');
				document.getElementById(divInfoNm).innerHTML= purgedB;
			}
			
			cond= 'ko';
			var imgDfn= imgDfnA;
			var alt= altA;
		}else{
			if (ptDivInf!==null){
				var purgedA= kk.replaceCodedChar(varA,'Z');
				document.getElementById(divInfoNm).innerHTML= purgedA;
			}
			
			cond= 'ok';
			var imgDfn= imgDfnB;
			var alt= altB;
		}
		
		var jsAction= 'forumBar.'+parentFuNm+'('+varNmA+','+varNmB+',\''+varNmA+'\',\''+varNmB+'\',\''+divInfoNm+'\',\''+divButNm+'\',\''+imgDfnA+'\',\''+imgDfnB+'\',\''+cond+'\',\''+altA+'\',\''+altB+'\')';
		var totBut= '<img src="'+imgDfn+'" alt="'+alt+'" title="'+alt+'" class="eImg" onclick="'+jsAction+'" />';	// update the button
		totBut= kk.replaceCodedChar(totBut,'Zq');
		document.getElementById(divButNm).innerHTML= totBut;
	}; // coreBiMdBut
	
	
	/*
		Imposes the technical bar button over the other
	*/
	function techBarButtton(){
		kk.setInnerHtml(localStorage.origStyleInsrtTags, 'polInserDiv', 'Z');
	}; // techBarButtton
	
	/*
		Imposes the forum bar button over the other
	*/
	function fumBarButtton(){
		kk.setInnerHtml(localStorage.fumStyleInsrtTags, 'polInserDiv', 'Z');
	}; // fumBarButtton

} // forumBar
