<?php
/**
	File name : forumBar.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="forumBar" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]	
*/
class forumBar extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		
		include_once _c_toDeclPlugCntr.'forum/fumSuperLight.php';		
		$this->sLightF= new fumSuperLight($tagsFu);
		$sLightF= &$this->sLightF;

		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
				
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$caps= &$this->caps;
		
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
		
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;
		
		$this->rMg= &$tagsFu->rMg;
		$this->parser= &$tagsFu->parser;

		$this->rights= &$tagsFu->rights;					
				
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('forumBar','debugDisplay',false);	
		
		$sentV= array('alt','es','es2','font','weight','size','color','float');
		$tagsFu->attribVect['sentence']= $sentV;
		$tagsFu->attribVect['paragraph']= $sentV;
		
		$tagsFu->attribVect['fumfontkind']= array('name');
		$tagsFu->attribVect['fumfontsize']= array('name');
		$tagsFu->attribVect['fumfontcolor']= array('name');
		$tagsFu->attribVect['fumfontweigh']= array('name');

		
		$tagsFu->attribVect['emoswitchon']= false;	
		$tagsFu->attribVect['emoswitchoff']= false;	
		
		$tagsFu->attribVect['emo']= array('n','js','alt','ttl');
		$tagsFu->attribVect['dmo']= array('n','js','alt','ttl');
				
		$iconColV= array('name','alt','es','ttl','pathdir','dircateg','finaldirdspl','cls','p','pg','edt','js','url','target');
		$tagsFu->attribVect['calliconcollect']= $iconColV;
		$tagsFu->attribVect['callicollimpr']= $iconColV;
		$tagsFu->attribVect['webmasteronlyicon']= $iconColV;	
		
		$tagsFu->attribVect['fumbarinfotxt']= array('name','es','alt','info');
		
		
		// Standard icon display
		// d for directory, can set a default --> at least one directory got small tags
		$tagsFu->attribVect['ic']= array('s','d','p','cls','alt','ttl');	// s for name string
		$tagsFu->attribVect['icon']= array('s','d','p','cls','alt','ttl');	// s for name string
		
		$tagsFu->attribVect['deficondir']= array('p','d');	// s for name string
		
		$tagsFu->attribVect['areasetfumbar']= array('areanm','supdivnm','alt');
		
		/*
			src : full path and image from the code img directory.
			event : name of the event ex : onclick.
			fu : JS function name.
			nbp : total number of used parameters (variables and constants from left to right up to the total number of formal parameter)
			nbv : number of javascript variables (always coming 1st and nbv<=nbp ).
			ai : parameters variables : needs to be recognised as a JS variable, so no quotes arround it.
		*/
		$tagsFu->attribVect['imgcallsjs']= array('src','event','fu','nbp','nbv','a','b','c');
		
		
		// 	Example	[defIconDir p="thirdParty" d="parc" inCode="ok" /]
		$this->globIconDefaultPath= 'zCms/images/thirdParty';
		$this->globIconDefaultDir= 'park';
		
		// pure Php bi mode button
		$tagsFu->attribVect['bimodbut']= array('imga','imgb','var','e','alta','f','altb','statea','stateb','onlyfor','exceptfor','forcedspl');
		
		// To call a pure javascript bimode button
		$tagsFu->attribVect['bimdbut']= array('vara','varb','wysipurge','divinfonm','divbutnm','imga','imgb','cond','w','f','altb','e','alta');
		
		$tagsFu->attribVect['wygbutton']= false;
		
		$tagsFu->attribVect['techbarbut']= false;
		$tagsFu->attribVect['fumbarbut']= false;
		
		
		// Forum bar start initialisation !!
		$gFumBar= $dtb->getGenVar('geniForumBar');
		
		if ($glob->wRights || $tools->curPageName()==='_4um_message_form'){
			$js= $caps->jsSimpleFu('forumBar.atStartSetFmBar',1,0,$gFumBar);
			$glob->setGlbEndJsCode($js.';'._c_R);	// Set visibility on main editor
		}
		
		
		include_once _c_toDeclPlugCntr.'fumXRights/fumXRLight.php';
		$this->xRght= new fumXRLight($tagsFu,$sLightF);
		
		$this->lastIconeDfn= false;
		$this->isAnEmotIcon= false;
	} // construct

	
	/**
	*/
	function tags(){
		return array('sentence', 'paragraph', 'fumfontkind', 'fumfontsize', 'fumfontcolor', 'fumfontweigh', 
		'emoswitchon', 'emoswitchoff', 'emo', 'dmo','calliconcollect','callicollimpr','webmasteronlyicon',
		'fumbarinfotxt', 'ic', 'icon', 'deficondir', 'areasetfumbar', 'imgcallsjs', 
		'bimodbut', 'bimdbut', 'wygbutton','techbarbut','fumbarbut');
	} // tags
	
	
	/**
		[sentence ...]	'font','weight','size','color'
		So it's a secure span tag for anybody to use!
	*/
	function tg_sentence(&$v,&$bd){
		return $this->sentenceCore($v,$bd);
	} // tg_sentence
	
		
	/**
		[paragraph ...]	using a div !
	*/
	function tg_paragraph(&$v,&$bd){
		return $this->sentenceCore($v,$bd,false);
	} // tg_paragraph
	
		
	/**
	*/
	function sentenceCore(&$v,&$bd,$span=true){	
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;	
				
		$es= $v['es'];
		$es2= $v['es2'];
		$alt= $tools->binLoads($v['alt'],'');
		
		
		$font= $v['font'];
		$weight= $v['weight'];		// --> sending widget written only in xml2
		$size= $v['size'];
		$color= $v['color'];
		$float= $v['float'];
		
		$stl= $this->sentenceStyle($font,$weight,$size,$color,$float);
		
		$bd= $glob->es($bd,$es);
		$alt= $glob->es($alt,$es2);
		
		if ($span){
			return $caps->span($bd,'',$stl,'',$alt);
		}else{
			return $caps->sDiv($bd,$stl);	// can't add an alt on div!!
		}
	} // sentenceCore
	
	
	
	/**
		Template for standard methods.
	*/
	function sentenceStyle($font,$weight,$size,$color,$float='none',$free=''){
		// Bo build the inline style from the 4 prev. var.
		
		$font= $this->persoToCssFont($font);
		if ($font!==false){
			$fontStr= 'font-family:'.$font.';'.' font-style:normal;';
		}else{
			$fontStr= '';
		}
		
		$weight= $this->persoToCssWeight($weight);
		if ($weight!==false){
			$weightStr= ' font-weight:'.$weight.';';
		}else{
			$weightStr= '';
		}
		
		$size= $this->persoToCssSize($size);
		if ($size!==false){
			$sizeStr= 'font-size:'.$size.'px;';
		}else{
			$sizeStr= '';
		}
				
		$color= $this->persoToCssColor($color);
		if ($color!==false){
			$colorStr= ' color:#'.$color.';';
		}else{
			$colorStr= '';
		}
				
		$float= $this->persoToCssFloat($float);
		if ($float!==false){
			$floatStr= ' float:'.$float.';';
		}else{
			$floatStr= '';
		}
		
		return $fontStr.$weightStr.$colorStr.$sizeStr.' text-decoration: none;'.$floatStr.$free;	
	} // sentenceStyle
	

	function persoToCssFloat($f){
		switch ($f){
			case 'left':
				return 'left';
			break;
			
			case 'right':
				return 'right';
			break;
			
			case 'none':
			default:;
				return false;
			break;
		} // switch
	} // persoToCssWeight
	
	
	
	/**
		Font Widget definition :
			[fumFontKind name="comboFumFomt" /]
			To choose and maintain a STATE for the lists.
	*/
	function tg_fumfontkind(&$v,&$bd){
		return $this->coreFontKind($v['name']);
	} // tg_fumfontkind
	
	function coreFontKind($comboName,$defVal='arial'){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		// preparing combobox javascript defaults	localStorage
		$glob->setGlbEndJsCode('forumBar.setSelFontVal();'._c_R);
		$glob->setGlbEndJsCode('forumBar.setSelWeightVal();'._c_R);
		$glob->setGlbEndJsCode('forumBar.setSelSizeVal();'._c_R);
		$glob->setGlbEndJsCode('forumBar.setSelColorVal();'._c_R);
				
		// definition of the combo box comments.
		$vSelect= array(
			's1' =>'Fonts'
			,_c_ko =>'None'			
			,'arial' =>'Arial'
			,'times' =>'Times'
			,'courier' =>'Courier'
			,'verdana' =>'Verdana'
			,'impact' =>'Impact'
			,'comic' =>'Comic'
			,'lucida' =>'Lucida Console'
			,'URW' =>'URW Chancery'
			,'e1' =>''
		);
						
		$defCmboVal= $tools->inptVal($comboName,$tools->postVal($comboName,$defVal));		
		return $caps->comboBox($comboName,$defCmboVal,$vSelect,'',true,true);
	} // coreFontKind
	
	
	
	/**
		Font data convertor :
			Translate the personal font code into the font css code.
			Uses a switch conversion to avoid risk of sql injection!
	*/
	function persoToCssFont($f){
		switch ($f){
			case 'arial':
				return 'Arial';
			break;
			
			case 'times':
				return 'Times';
			break;
			
			case 'courier':
				return 'Courier New';
			break;
			
			case 'verdana':
				return 'Verdana';
			break;
			
			case 'impact':
				return 'Impact';
			break;
			
			case 'comic':
				return '\'Comic Sans MS\', cursive, sans-serif';
			break;
						
			case 'lucida':
				return 'Lucida Console';
			break;
			
			case 'URW':
				return 'URW Chancery L';
			break;
			
			case _c_ko:
			default: return false;
		} // switch
	} // persoToCssFont
			

	/**
		[fumFontSize name="comboFumFomt" /]
		To choose and maintain a STATE for the lists.
	*/
	function tg_fumfontsize(&$v,&$bd){
		return $this->coreFontSize($v['name']);
	} // tg_fumfontsize
	
	
	function coreFontSize($comboName,$defVal='12'){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		// definition of the combo box comments.
		$vSelect= array(			
			's1' =>'FontSize'
			,_c_ko =>'None'			
			,'8' =>'8'			
			,'10' =>'10'			
			,'12' =>'12'			
			,'14' =>'14'			
			,'16' =>'16'			
			,'18' =>'18'			
			,'20' =>'20'			
			,'24' =>'24'			
			,'36' =>'36'			
			,'48' =>'48'			
			,'64' =>'64'			
			,'e1' =>''
		);
						
		$defCmboVal= $tools->inptVal($comboName,$tools->postVal($comboName,$defVal));		
		return $caps->comboBox($comboName,$defCmboVal,$vSelect,'',true,true);
	} // coreFontSize
	
	
	/**
		Translate the personal font code into the font css code.
		Use a switch conversion with exact match to avoid risk of sql injection!
	*/
	function persoToCssSize($s){	
		switch ($s){			
			case '8':
				return '8';
			break;
			
			case '10':
				return '10';
			break;
			
			case '12':
				return '12';
			break;
			
			case '14':
				return '14';
			break;
			
			case '16':
				return '16';
			break;
			
			case '18':
				return '18';
			break;
			
			case '20':
				return '20';
			break;
			
			case '24':
				return '24';
			break;
			
			case '36':
				return '36';
			break;
			
			case '48':
				return '48';
			break;
			
			case '64':
				return '64';
			break;
			
			case _c_ko:
			default:
				return false;
			break;
		} // switch
	} // persoToCssSize


	/**
		[fumFontColor name="comboFumFomt" /]
		To choose and maintain a STATE for the lists.
	*/
	function tg_fumfontcolor(&$v,&$bd){
		return $this->fumFontColor($v['name']);
	} // tg_fumfontcolor
	
	
	function fumFontColor($comboName,$defVal='black'){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		// definition of the combo box comments.
		$vSelect= array(			
			's1' =>'Colors'
			,_c_ko =>'None'
			,'lGrey' =>'Light Grey'
			,'dGrey' =>'Dark Grey'
			,'black' =>'Black'
			,'white' =>'White'
			,'cream' =>'Cream'
			
			,'red' =>'Red'
			,'orange' =>'Orange'
			,'yellow' =>'Yellow'
			,'green' =>'Green'
			,'pink' =>'Pink'
			,'blue' =>'Blue'
			,'purple' =>'Purple'
			
			,'lRed' =>'Light Red'
			,'lOrange' =>'Light Orange'
			,'lYellow' =>'Light Yellow'
			,'lGreen' =>'Light Green'
			,'lPink' =>'Light Pink'
			,'lBlue' =>'Light Blue'
			,'lPurple' =>'Light Purple'
			
			,'dRed' =>'Dark Red'
			,'dOrange' =>'Dark Orange'
			,'dYellow' =>'Dark Yellow'
			,'dGreen' =>'Dark Green'
			,'dPink' =>'Dark Pink'
			,'dBlue' =>'Dark Blue'
			,'dPurple' =>'Dark Purple'
			,'e1' =>''
			

			,'s2' =>'Red dark to light'	
			,'red1' =>'Red 1'
			,'red2' =>'Red 2'
			,'red3' =>'Red 3'
			,'red4' =>'Red 4'
			,'red5' =>'Red 5'
			,'e2' =>''

			,'s3' =>'Blue dark to light'			
			,'blue1' =>'Blue 1'
			,'blue2' =>'Blue 2'
			,'blue3' =>'Blue 3'
			,'blue4' =>'Blue 4'
			,'blue5' =>'Blue 5'
			,'e3' =>''

			,'s4' =>'Brown dark to light'			
			,'brown1' =>'Brown 1'
			,'brown2' =>'Brown 2'
			,'brown3' =>'Brown 3'
			,'brown4' =>'Brown 4'
			,'brown5' =>'Brown 5'
			,'e4' =>''

			,'s5' =>'Green dark to light'			
			,'green1' =>'Green 1'
			,'green2' =>'Green 2'
			,'green3' =>'Green 3'
			,'green4' =>'Green 4'
			,'green5' =>'Green 5'
			,'e5' =>''

			,'s6' =>'Grey mild to light'			
			,'grey1' =>'Grey 1'
			,'grey2' =>'Grey 2'
			,'grey3' =>'Grey 3'
			,'grey4' =>'Grey 4'
			,'grey5' =>'Grey 5'
			,'e6' =>''
		);
						
		$defCmboVal= $tools->inptVal($comboName, $tools->postVal($comboName,$defVal));	
		return $caps->comboBox($comboName,$defCmboVal,$vSelect,'',true,true);
	} // fumFontColor	
	
	
	/**
		Translate the personal color code into the color css code.
		Got to use a switch conversion to avoid risk of sql injection!
	*/
	function persoToCssColor($c){
		switch ($c){
			case 'red':
				return 'FF0000';
			break;
			
			case 'orange':
				return 'FF8022';
			break;
			
			case 'yellow':
				return 'FFFF00';
			break;
			
			case 'green':
				return '00FF00';
			break;
			
			case 'pink':
				return 'ff5676';
			break;
			
			case 'blue':
				return '0000FF';
			break;
			
			case 'purple':
				return '973397';
			break;

			case 'lRed':
				return 'FF6A6A';
			break;
			
			case 'lOrange':
				return 'FFD687';
			break;
			
			case 'lYellow':
				return 'FFFF7D';
			break;
			
			case 'lGreen':
				return 'ABFF9D';
			break;
			
			case 'lPink':
				return 'ffcbe0';
			break;
			
			case 'lBlue':
				return '8282ff';
			break;
			
			case 'lPurple':
				return 'FF56FF';
			break;

			case 'dRed':
				return '840000';
			break;
			
			case 'dOrange':
				return 'DE9200';
			break;
			
			case 'dYellow':
				return 'E2E200';
			break;
			
			case 'dGreen':
				return '128000';
			break;
			
			case 'dPink':
				return 'be0046';
			break;
			
			case 'dBlue':
				return '000091';
			break;
			
			case 'dPurple':
				return '6C256C';
			break;
		
			case 'lGrey':
				return 'BCBCBC';
			break;
			
			case 'dGrey':
				return '626262';
			break;

			case 'black':
				return '000000';
			break;

			case 'white':
				return 'FFFFFF';
			break;

			case 'cream':
				return 'FFFFF0';
			break;



			case 'red1':
				return 'ff6f6f';
			break;

			case 'red2':
				return 'ff9999';
			break;

			case 'red3':
				return 'ffbdbd';
			break;

			case 'red4':
				return 'ffdfdf';
			break;

			case 'red5':
				return 'fff3f3';
			break;



			case 'blue1':
				return '008dfe';
			break;

			case 'blue2':
				return '51affe';
			break;

			case 'blue3':
				return '85c6fe';
			break;

			case 'blue4':
				return 'd4eafe';
			break;

			case 'blue5':
				return 'e3e5ff';
			break;



			case 'brown1':
				return 'cd5700';
			break;

			case 'brown2':
				return 'd0854e';
			break;

			case 'brown3':
				return 'f4b180';
			break;

			case 'brown4':
				return 'f6d5bd';
			break;

			case 'brown5':
				return 'ffedd9';
			break;



			case 'green1':
				return '69e572';
			break;

			case 'green2':
				return '90f897';
			break;

			case 'green3':
				return 'c0ffc4';
			break;

			case 'green4':
				return 'dfffe1';
			break;

			case 'green5':
				return 'e9ffeb';
			break;



			case 'grey1':
				return 'aaaaaa';
			break;

			case 'grey2':
				return 'bbbbbb';
			break;

			case 'grey3':
				return 'cccccc';
			break;

			case 'grey4':
				return 'dddddd';
			break;

			case 'grey5':
				return 'eeeeee';
			break;
			
					
			
			case _c_ko:
			default:;
				return false;
			break;
		} // switch
	} // persoToCssColor

	/**
		Weight Widget definition :
		
			[selectWhatever name="fontWeight" defval="normal" 
				listval="s1, ko, normal, bold, e1"  
				listdspl="Weight, None, Normal, Bold, ."  
			/]
			
		[fumFontWeigh /]
	*/
	function tg_fumfontweigh(&$v,&$bd){
		return $this->coreFontweigh($v['name']);
	} // tg_fumfontweigh
	
	
	/**
	*/
	function coreFontweigh($name,$defVal='normal'){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		// definition of the combo box comments.
		$vSelect= array(
			's1' =>'Weight'
			,_c_ko =>'None'			
			,'normal' =>'Normal'
			,'bold' =>'Bold'
			,'e1' =>''
		);
						
		$defCmboVal= $tools->inptVal($name,$tools->postVal($name,$defVal));		
		return $caps->comboBox($name,$defCmboVal,$vSelect,'',true,true);
	} // coreFontweigh
	

	/**
		Widget used : [selectWhatever .../]
		Data safe convertor below.
		
		Translate the personal font code into the font css code.
		Got to use a switch conversion to avoid risk of sql injection!
	*/
	function persoToCssWeight($w){
		switch ($w){
			case _c_ko:
				return false;
			break;
			
			case 'bold':
				return 'bold';
			break;
			
			case 'normal':
				return 'normal';
			break;
			
			default:;
				return false;
			break;
		} // switch
	} // persoToCssWeight



	/**
		Convert the user emoticon input in secured emoticon canonical string output,
		Input :
			$s : emoticon string given by the user
			
		Output :
			returns the secured string!
	*/
	function bCanonEmotStr($s){
		return strip_tags($s);		// perfect id strip_tags is sure enough.		
	} // bCanonEmotStr

	
	/**
		[emoSwitchOn /]  Switch the full emoticon panel to On!
	*/
	function tg_emoswitchon(&$v,&$bd){
		$caps= &$this->caps;
		$js= $caps->jsFunctCallStr('onclick','forumBar.emoSwitchOn');
		return $caps->lnImg(_c_EditorImgPath.'emotOn.png','','','sImg', $js);
	} // tg_emoswitchon
	
	
	/**
		[emoSwitchOff /]  Switch the full emoticon panel to Off!
	*/
	function tg_emoswitchoff(&$v,&$bd){
		$caps= &$this->caps;
			
		$js= $caps->jsFunctCallStr('onclick','forumBar.emoSwitchOff');
		return $caps->lnImg(_c_EditorImgPath.'emotOff.png', 'Close the current gallery!','','sImg', $js);
	} // tg_emoswitchoff
	
		
	/**
		Calls Icon Collection.  Display a given icon and link on the current X page, 
		addding one more url variable to load the proposed images.
	*/
	function tg_calliconcollect(&$v,&$bd){	
		return $this->callIconCollect($v);
	} // tg_calliconcollect
	
		
	/**
		To call an IFrame with a Collection of Images depending on some Publication Rights : [fumXRights img="ok" /]
		Idem tg_calliconcollect(), but only for user with image publication rights.
		[callIcollImPR /]
	*/
	function tg_callicollimpr(&$v,&$bd){	
		$xRght= &$this->xRght;
		$rMg= &$this->rMg;
		
		if ( $xRght->fUsrImgRght() || $rMg->quickWMRight() ){
			return $this->callIconCollect($v);
		}else{
			return '';
		}
	} // tg_callicollimpr	
	
	/**
		[webmasterOnlyIcon /]
	*/
	function tg_webmasteronlyicon(&$v,&$bd){	
		$xRght= &$this->xRght;
		$rMg= &$this->rMg;
		
		if ($rMg->quickWMRight()){
			if ( $xRght->fUsrImgRght() || $rMg->quickWMRight() ){
				return $this->callIconCollect($v);
			}else{
				return '';
			}
		}else{
			return '';
		}
	} // tg_webmasteronlyicon
	
	
	/**
		To set an icon/button inside the forumbar that can call an image collection.
	*/
	function callIconCollect(&$v){
		$sLightF= &$this->sLightF;
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		include_once _c_toDeclPlugCntr.'imGallery/imGallCpml.php';
		$iGal= new imGallCpml($tagsFu);
		
		// Fills the JS part
		$arCmd['justsrf']= _c_ok;
		$iFrameUrl= $tools->urlGivenPage(_c_fIconsPgName,$arCmd);
		
		$dircateg= $v['dircateg'];
		switch ($dircateg){
			// Get the images somewhere in the project (root)directory
			case 'usrRoot':
				// pathdir starts from the real root because image can be stored outsude the img directory for strategical reaosons (easier to distribute lighter version etc.)
				$fullPathDir= _c_UsrDataPath.$v['pathdir'];
			break;
			
			// Get the images somewhere in the project image directory
			case 'prj':
				// pathdir starts from the images/ path (imposed to users, much more simple)
				$fullPathDir= _c_UsrImagePath.$v['pathdir'];
			break;
			
			// Get the images somewhere in the forum-user personal directory
			case 'fumUsrPerso':
				$userId= $sLightF->fumLogUserId();
				$fullPathDir= $sLightF->corePersoPath($userId);
			break;
			
			// Get the images from where the user chooses it from the popup file browser.
			case 'fumFreelySet':
				$fullPathDir= $dtb->getGenVar('fumFreeSetGallPath');
			break;
			
			case 'statEmot':
				$fullPathDir= _c_UsrEmoDir.'static/';
			break;
			
			case 'dynEmot':
				$fullPathDir= _c_UsrEmoDir.'anim/';
			break;
			
			default:
				print('Error in forum::tg_callIconCollect'._c_);
		} // switch

		$noSlashFllPD= $iGal->getFinalNoSlashFlPD($fullPathDir,$dircateg);
		if ( $noSlashFllPD!==false && is_dir($noSlashFllPD) ){
			$files= scandir($noSlashFllPD);
			$nbFiles= count($files)-2;
		}else{
			$nbFiles= 0;
		}
		
		if ($nbFiles<35){
			$height= 130;
		}else if ($nbFiles<80){
			$height= 180;
		}else{
			$height= 300;
		}
		
		$iFrameUrl.= $tools->addUrlVar('fullPathDir',$fullPathDir);
		$iFrameUrl.= $tools->addUrlVar('dircateg',$dircateg);
		
		$finaldirdspl= $v['finaldirdspl'];
		$iFrameUrl.= $tools->addUrlVar('finaldirdspl',$finaldirdspl);
		
		
		$smlIfrUrl= $iFrameUrl;
		$smlIfrUrl.= $tools->addUrlVar(_c_UvGallIFrWidth,'935');
		$iFrSmall= $caps->hIframe($smlIfrUrl,$height);
		$iFrSmall= str_replace('"',_c_fDblQuotSubst,$iFrSmall);		// encode the double quotes
		$iFrSmall= str_replace(_c_R,_c_fCrLnSubst,$iFrSmall);		// encode the _c_R
		
		
		$lrgIfrUrl= $iFrameUrl;
		$lrgIfrUrl.= $tools->addUrlVar(_c_UvGallIFrWidth,'1070');
		$iFrLarge= $caps->hIframe($lrgIfrUrl,$height);
		$iFrLarge= str_replace('"',_c_fDblQuotSubst,$iFrLarge);		// encode the double quotes
		$iFrLarge= str_replace(_c_R,_c_fCrLnSubst,$iFrLarge);		// encode the _c_R
		
		
		$js= $caps->jsFunctCallStr('onclick','forumBar.setFiller',2,0,$iFrSmall,$iFrLarge);
		
		$imgDFn= _c_zCmsImages.$v['name'];
		
		$alt= $v['alt'];
		$es= $v['es'];
		
		$alt= $glob->el($alt,$es);
		
		if (substr($alt, 0, 4)==='kakc'){
			print('$alt='.$alt._c_);
		}
		
		return $caps->lnImg($imgDFn,$alt,'','eImg', $js);
	} // callIconCollect
	

	/**
		A forum bar information text!
		[fumBarInfoTxt name="info.png" alt="Contextuel information" /]These buttons are ...[/fumBarInfoTxt]
	*/
	function tg_fumbarinfotxt(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
	
		$info= $tools->jsSafeString($bd);
		$info= $tools->jsStorageStr($info);
		
		$js= $caps->jsFunctCallStr('onclick','forumBar.fumBarTxt',1,0,$info);
		$imgDFn= _c_zCmsImages.$v['name'];
		$alt= $v['alt'];
		return $caps->lnImg($imgDFn,$alt,'','eImg', $js);
	} // tg_fumbarinfotxt

	
	/**
		[defIconDir p="thirdParty" d="parc" inCode="ok" /]
		[icon s="bicycle" /]
	*/
	function tg_deficondir(&$v,&$bd){	
		$this->globIconDefaultPath= $v['p'];
		$this->globIconDefaultDir= $v['d'];
		// $this->globIconDefInCode= $v['incode'];	// ok ---> in the code directory / ko ---> inside the projects directory
	} // tg_deficondir

		
	/**
		New kind of static emoticons, easier to change.
		[emo n="smiley" /]
	*/
	function tg_emo(&$v,&$bd){
		$caps= &$this->caps;
		return $this->coreUsrEmoticon($v,'static');
	} // tg_emo

	/**
		[icon d="parc" s="bicycle" /]
		d . last directory name
		s : file name without extension
			extension is tested for file existance (png, jpg, ico), dont want any twins on main name!
			At 1st just png !!
		p : path given with the image name starting from within the image directory (full DFN)
	*/
	function tg_icon(&$v,&$bd){	
		return $this->iconeCore($v,_c_zCmsImages,false);
	} // icon
	
	function tg_ic(&$v,&$bd){
		return $this->iconeCore($v);
	} // tg_ic
	
	/**
		Template for standard methods! ... Many similarities with coreUsrEmoticon()
	*/
	function iconeCore(&$v,$iconDefPath=false,$earlyIconMode=true){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;
		
		if ($iconDefPath===false){
			$iconDefPath= $this->globIconDefaultPath;
		}
		
		$d= false;
		$p= $v['p'];
		$s= $v['s'];
		if ($p!==false){
			// full DFN from within the user image directory
			$imgDFn= _c_UsrImagePath.$p;
		}else{
			// Separated icon mode.
			
			$d= $v['d'];
			if ($d===false){
				$d= $this->globIconDefaultDir;
			}
		
			if ($earlyIconMode){
				$imgDFn= _c_UsrDataPath.$iconDefPath.'/'.$d.'/'.$s.'.png';
			}else{
				$imgDFn= $iconDefPath.$d.'/'.$s;
			}
		}
		
		$this->isAnEmotIcon= false;
		$this->lastIconeDfn= $imgDFn;	// global memo to access the image for other purpose than just display it (eg: installation choice of image menu tracker)
		
		$cls= $v['cls'];
		if ($d==='freepikCom' && $cls===false){
			$cls= 'fumImgBtt';
		}else{
			$cls= $tools->binLoads($cls,'fumSmplImg');
		}
		
		
		$this->altTtl($v,$alt,$ttl);		
		return $caps->ttlImage($imgDFn, $alt,$ttl, $cls);
	} // iconeCore	

	
	/**
		Return the string of an emoticon icon or an emoticon button, or just do a JS localStorage for later use.
		pop (User side emoticons)
	*/
	function coreUsrEmoticon(&$v,$lastRep){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
	
		$s= $v['n'];	// chosen emoticon name
		if ($s===false){
			return '';
		}	
		
		$stopEmot= $tools->getVal(_c_fumStopEmotMoves);	
		if ($stopEmot===_c_ok){
			$lastRep= 'static';
			$fls->splitOnLastC($s,$left,$right,'.');
			$s= $left.'.png';
		}
		
		$s= $this->bCanonEmotStr($s);			// security canonisation of user input
		$dpF= _c_UsrEmoDir.$lastRep.'/'.$s;		// directory . path - file
		
		$js= $v['js'];
		if ($js!==false){
			// Display the emoticon with an onclick event that write its xml string inside the clicked main area spot.
			$smallV['n']= $s;
			$xmlStr= $tagsFu->rebuildTagStr('emo', $smallV,'',true);
			
			$xmlStr= str_replace('\\"','bS'.'Y'.'dG',$xmlStr);	// soecial 3rd imbrication level
			
			$xmlStr= $tools->jsStorageStr($xmlStr,'Z');
			$js= $caps->jsFunctCallStr('onclick','forumBar.txtArAct',3,0,'emot',_c_ok,$xmlStr);
		}else{
			$js= '';	// To directly display the emoticon
		}
		
		$this->isAnEmotIcon= true;	// dynamic or not, so we don't have to resize it in lateral image processing
		$this->lastIconeDfn= $dpF;		
		
		$this->altTtl($v,$alt,$ttl);		
		return $caps->ttlImage($dpF,$alt,$ttl, 'fumImgBtt','', $js);
	} // coreUsrEmoticon	
	
	
	/**
		Lopads the alternative text and the image title in an optimum way, also leaving the possibility
		to define an external title on a link without redundancy with the image title!
	*/
	function altTtl(&$v,&$alt,&$ttl){
		$tools= &$this->tools;
		
		$ttl= $this->bCanonEmotStr($tools->binLoads($v['ttl'],''));
		$alt= $v['alt'];
		if ($alt===false){
			$alt= $ttl;
		}else{
			$alt= $this->bCanonEmotStr($alt);
		}
	} // altTtl
	

	/**
		Assign/Set the forum bar to a given area (a javascriot button to click)
		$this->areaSetFumBar('mainStr').
		Input :
			$areaNm : name of the text area
			$supDivNm : mainly name of galleries
			$alt : alternative text or title
	*/
	function areaSetFumBar($areaNm,$supDivNm,$alt=false){
		$tagsFu= &$this->tagsFu;
		$caps= &$this->caps;
		$glob= &$this->glob;
		$rMg= &$this->rMg;
		
		if ($tagsFu->usingLambdaFBar){
			$areaNm= _c_fMessageBodyTxtArNm;	// force it! Could 
		}
		
		if ($rMg->quickWMRight()){
			if ($alt===false){
				$alTtl= $glob->es('Assign the forum bar to the local area.','kmey');
			}else{
				$alTtl= $alt;
			}
		
			$js= $caps->jsFunctCallStr('onclick','forumBar.setFumBar',2,0,$areaNm,$supDivNm);
			return $caps->lnImg(_c_EditorImgPath.'setFumBar.png',$alTtl,'','sImg', $js);
		}else{
			return '';
		}
	} // areaSetFumBar

	/**
		[areaSetFumBar areaNm="bdyNm" /]
	*/
	function tg_areasetfumbar(&$v,&$bd){
		return $this->areaSetFumBar($v['areanm'],$v['supdivnm'],$v['alt']);
	}
		
	/**
		To define an image calling a javascript function with an onclick event with all parameter specified individually.
		Param : 'src','event','fu','nbp','nbv','a','b','c'
		[imgCallsJs src="smiley.png" event="onclick" fu="kk.setInnerHtml" nbp="3" nbv="1" a="" b="" c="" /]
	*/
	function tg_imgCallsJs(&$v,&$bd){
		$caps= &$this->caps;
		
		$js= $caps->jsFunctCallStr('kk.setInnerHtml',3,1,'localStorage.fumStyleInsrtTags',_c_polInserDiv,'Z');
		return $caps->lnImg(_c_EditorImgPath.'smiley.png','Call the forum bar!','','sImg', $js);
	} // tg_imgCallsJs
	
	
	/**
		[biModBut imgA="" imgB="" var="" stateA="" stateB="" /]
		To manage a php bimode button without cookies and with also other values than ok & ko.
		Note	(1) interesting for more than 2 values, so for exmpl 3 ort 4 values taken in charge with 2 buttons. 
				(2) aoparented inserTags::bimodeButton() is cookie dependant
		Rem :	
			--> onlyfor : if !== false ---> appear only for the specified states onlyFor="surf, edt"
			stateA=, stateB : could have been labeled actionA actionB instead!
		forcedspl
	*/
	function tg_bimodbut(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$rMg= &$this->rMg;


		$var= $v['var'];	// url variable
		$curState= $tools->getVal($var);	// need to detect the false state at the reverse of next "twin"
		
		$forceDspl= $v['forcedspl'];
		
		if ($forceDspl===_c_ok && !$rMg->quickWMRight()){
			return '';	// the forced display is acceptable only if logged
		}
		
		if ( $forceDspl!==_c_ok){
			$exceptFor= $v['exceptfor'];
			if ($exceptFor!==false){		
				$forbidV= $tools->trimStrToVect(',',$exceptFor);	// array of forbidden values
				if (in_array($curState ,$forbidV)){
					return '';	// invisible button state because the specified states $compulsV are not on
				}
			}		
			
			$onlyFor= $v['onlyfor'];
			if ($onlyFor!==false){
				if ($curState===false){
					return '';
				}
			
				$compulsV= $tools->trimStrToVect(',',$onlyFor);	// array of compulsory values
				if (!in_array($curState ,$compulsV)){
					return '';	// invisible button state because the specified states $compulsV are not on
				}
			}
		}
		
		$imgA= $v['imga'];
		$imgB= $tools->binLoads($v['imgb'],$imgA);
		
		$e= $v['e'];
		$altA= $glob->el($v['alta'],$e);
		
		$f= $v['f'];
		$altB= $glob->el($v['altb'],$f);
		
		$stateA= $tools->binLoads( $v['statea'], _c_ok );
		$stateB= $tools->binLoads( $v['stateb'], _c_ko );
				
		$stdImgA= $caps->stdImage($imgA,_c_ok,$altA,'eImg');
		$stdImgB= $caps->stdImage($imgB,_c_ok,$altB,'eImg');
		
		$arCmd['shortCircAtt']= $var;
		$url= $tools->genUrlCurPage($arCmd);
		
		$path= $tools->gostVal(_c_mFilePathPrfx.'1',false);
		if ($path!==false){
			$url.= $tools->addUrlVar(_c_mFilePathPrfx.'1',$path);
		}
		
		$path= $tools->gostVal(_c_mFilePathPrfx.'2',false);
		if ($path!==false){
			$url.= $tools->addUrlVar(_c_mFilePathPrfx.'2',$path);
		}
		
		$curState= $tools->getVal($var, $stateB);
		if ($curState===$stateA){
			$url.= $tools->addUrlVar($var,$stateB);
			$fullBut= $caps->linkTC($url,$stdImgB,$altB,'eImg');
		}else{
			$url.= $tools->addUrlVar($var,$stateA);
			$fullBut= $caps->linkTC($url,$stdImgA,$altA,'eImg');
		}
				
		return $fullBut;
	} // tg_bimodbut	
	
		
	/**
		Just to call the javascript forumBar.biMdBut() method.
		localStorage.fumStyleInsrtTags
		localStorage.origStyleInsrtTags
	*/
	function tg_bimdbut(&$v,&$bd){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$origAltA= $glob->es( $v['alta'],$v['e']);
		$origAltA= $acc->noAppostroph($origAltA);
		$origAltA= $tools->jsStorageStr($origAltA,'Zq');	// sym js === kk.replaceCodedChar()
		
		$origAltB= $glob->es( $v['altb'],$v['f']);
		$origAltB= $acc->noAppostroph($origAltB);
		$origAltB= $tools->jsStorageStr($origAltB,'Zq');	// sym js === kk.replaceCodedChar()
		
		// permutes depending on geniForumBar
		if ($dtb->getGenVar('geniForumBar')!==_c_ok){
			// most common case, starting with the standard bar and the forumbar is an option.
			// Just strings at this stage
			$varA= $v['vara'];
			$varNmA= $varA;
			$varB= $v['varb'];
			$varNmB= $varB;
			$imgDfnA= _c_EditorImgPath.$v['imga'];
			$imgDfnB= _c_EditorImgPath.$v['imgb'];
			$cond= $v['cond'];
			
			$altA= $origAltB;	// inverted at the start
			$altB= $origAltA;
		}else{
			// inverted !!
			$varA= $v['varb'];
			$varNmA= $varA;
			$varB= $v['vara'];
			$varNmB= $varB;
			$imgDfnA= _c_EditorImgPath.$v['imgb'];
			$imgDfnB= _c_EditorImgPath.$v['imga'];
			$cond= $v['cond'];
			
			$altA= $origAltA;	// inverted at the start
			$altB= $origAltB;
		}
		
		$divInfoNm= $v['divinfonm'];
		$divButNm= $v['divbutnm'];
		
		if ($v['wysipurge']===_c_ok){
			$js= $caps->jsSimpleFu('forumBar.jsBarBiMdBut',12,2,$varA,$varB,$varNmA,$varNmB,$divInfoNm,$divButNm,$imgDfnA,$imgDfnB,$cond,$altA,$altB);
		}else{
			$js= $caps->jsSimpleFu('forumBar.biMdBut',12,2,$varA,$varB,$varNmA,$varNmB,$divInfoNm,$divButNm,$imgDfnA,$imgDfnB,$cond,$altA,$altB);
		}
		
		$glob->setGlbEndJsCode($js.';'._c_R);	// Add a js to load the button at the end of uploading
		
		$w= $tools->binLoads($v['w'],'20');
		
		return $caps->sDiv('','width:'.$w.'px; border:0px solid red; float:right;',$divButNm);
	} // tg_bimdbut
	
		
	/**
		[wygbutton /]
	*/
	function tg_wygbutton(&$v,&$bd){
		$caps= &$this->caps;
		return $caps->wysiwygButton(_c_taMainStNm);
	} // tg_wygbutton
	
	/**
		Dynamic emoticons, easier to change.
		[dmo n="smiley" /]
	*/
	function tg_dmo(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		$glob->pgNbOfDynEmot= $glob->pgNbOfDynEmot+1;	// ++ does not work on global variables !!
		$pgMaxDynEmot= $dtb->getGenVar('pgMaxDynEmot',10);
		
		if ($glob->pgNbOfDynEmot<=$pgMaxDynEmot){
			return $this->coreUsrEmoticon($v,'anim');
		}else{
			$fn= $v['n'];
			$fls->splitOnLastC($fn,$bodyFl,$extFl,'.');
			$newFl= $bodyFl.'.png';
			$v['n']= $newFl;
			
			return $this->coreUsrEmoticon($v,'static');
		}
	} // tg_dmo
	
			
	/**
		A button to call the technical bar
		[techBarBut /]
	*/
	function tg_techbarbut(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$rights= &$this->rights;
		
		if ($tagsFu->usingLambdaFBar){
			return '';
		}
		
		if ( !$rights->quickWMRight() ){
			return ''; // not a webmaster --> not allowed
		}
		
		$js= $caps->jsOnclickFuCallStr('forumBar.techBarButtton');
		$ttl= $caps->matTtl($glob->el('Call the technical edition bar!','kbbh'));
		return $caps->spanJs('Tbar',$js,'fumBarSwitch',$ttl);
	} // tg_techbarbit
	
	/**
		A button to call the technical bar
		[fumBarBut /]
	*/
	function tg_fumbarbut(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$js= $caps->jsOnclickFuCallStr('forumBar.fumBarButtton');
		$ttl= $caps->matTtl($glob->el('Call the forum style edition bar!','kbbi'));
		return $caps->spanJs('Fbar',$js,'fumBarSwitch',$ttl);
	} // tg_fumbarbut
		
} // forumBar
?>