<?php
/**
	File name : fumXRLight.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	The basic user rights computation for the forum.
*/
class fumXRLight extends oTop{
	

	function __construct(&$tagsFu,&$sLightF){
		parent::__construct();
		
		$this->tagsFu= &$tagsFu;
		$this->sLightF= &$sLightF;		// fumShrdCdLgt --> about 52kb !!
		
		$this->glob= &$tagsFu->glob;	// access to some global values, sometimes methods
		$glob= &$this->glob;
		
		$this->tools= &$tagsFu->tools;
		$this->dtb= &$tagsFu->dtb;
		$this->parser= &$tagsFu->parser;
		
		
		/**
			Positionned here because it's first used was to avoid image forum-bar-tags in unauthorized 
			situation! But it's more general for the forum, but defining it in fumSuperLight is not
			suoer light and above make the access difficult here! So the most logical position is here!
			Knowing that if the forum bar is not necessary anymore it could be relocated.
			
			img : gives the right to upload images.
			subuser : sub user attribute to be used with the [onlySpecifiedUser] tag
			moder : moderation rights
			pcown : permanent changing rights on own posts
			spdrl : ok --> right to have external links followed by spiders !!!			
		*/
		$tagsFu->attribVect['fumxrights']= array('img','subuser','moder','pcown','spdrl');		
		
		
		$tagsFu->assignTags($this->tags(), 'fumXRLight');	// explicit
		
		$tagsFu->explicitClasses['fumXRLight']= $this;
		
		$this->curFumXRghtV= array();	// !!!! MUST use $glob and not this. otherwise get misxed up for some initialisations (probably because of interfering inheritance)
	} // construct


	/**
	*/
	function tags(){
		return array('fumxrights');
	} // tags

			
	/**
		A tag to define the forum user right. Default -- no rights
		[fumXRights img="ok" /]
		[fumXRights subuser="ok" /]
		
		Typical webmaster rights for her/his forum Id
			[fumXRights img="ok" pcown="ok" spdrl="ok" /]
	*/
	function tg_fumxrights(&$v,&$bd){
		$glob= &$this->glob;
		$this->curFumXRghtV= $v;
	} // tg_fumxrights


	/**
		The ONLY PLACE where we end up parsing the tag [fumXRights ... ]
			$usrId : the Id of the user we are analysing the rights from
	*/
	function prsFumXRights($usrId){
		$glob= &$this->glob;
		
		if ( !array_key_exists ($usrId,$glob->genFumXRghtV) ){
			$tools= &$this->tools;
			$dtb= &$this->dtb;
			$parser= &$this->parser;

			$xRight= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$usrId, _c_fUsrXmlRight);
			
			$this->curFumXRghtV= array();
			$parser->addrParseStdStr($xRight,$usrId);	// PARSE [fumXRights img="ok" /]
			
			$cpAr= $tools->cpyArray($this->curFumXRghtV);
			if ($cpAr===array()){
				$cpAr= false;	// because no rights at all better expressed by false than array()
			}
			$glob->genFumXRghtV[$usrId]= $cpAr;
			$this->curFumXRghtV= array();
		}
		
		return $glob->genFumXRghtV[$usrId];	// in this case clearer with a return and then a local variable
	} // prsFumXRights
	


	/**
		Set and Gives the current forum user rights vector. --> Scans the string to apply the tag [fumXRights /]
	*/
	function curFUsrXRghtV($usrId=_c_userNoRight){
		$glob= &$this->glob;
		$sLightF= &$this->sLightF;
			
		if ($usrId===_c_userNoRight){
			$usrId= $sLightF->fumLogUserId();
		}
		
		if ($usrId!==_c_userNoRight){
			return $this->prsFumXRights($usrId);
		}else{
			return false;
		}
	} // curFUsrXRghtV


	/**
		Computes a given flag status for the actually connected user!
		Input :
			$flag : the concerned attribute.
	*/
	function genFlag($flag,$usrId=_c_userNoRight){
		$v= $this->curFUsrXRghtV($usrId);
		if ($v===false){
			return false;
		}else{
			return $v[$flag]===_c_ok;
		}
	} // genFlag
	

	/**
		Give the current forum user an image right status as a boolean.
	*/
	function fUsrImgRght(){
		return $this->genFlag('img');
	} // fUsrImgRght
	
	
	/**
		If true --> got the right to have anchr-links <a ...> to be followed by spiders !
		For the given forum user : $usrId !! Returns true if he/she is spiders friendly!
	*/
	function spiderLinks($usrId){
		$xRgtV= $this->prsFumXRights($usrId);
		if ($xRgtV!==false && array_key_exists('spdrl',$xRgtV)){
			return $xRgtV['spdrl']===_c_ok;
		}else{
			return false;
		}
	} // spiderLinks
	

} // fumXRLight
?>