<?php
/**
	File name : fumXRights.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	The general user rights computation for the forum.
*/
include_once _c_toDeclPlugCntr.'fumXRights/fumXRLight.php';
class fumXRights extends fumXRLight{
	

	function __construct(&$tagsFu,&$sLightF){
		parent::__construct($tagsFu,$sLightF);
		
		$tagsFu->explicitClasses['fumXRights']= $this;
	} // construct

	/**
		Moderator right. Not implemented!! Moderation needs to be done with full webmaster access.
	*/
	function fUsrModerRght(){
		return $this->genFlag('moder');
	} // fUsrModerRght
	
	/**
		Subuser status : don't have the right to post anything, but like any forum member can be selected with the tag :
			[onlySpecifiedUser usrlist="guest"]
				to see some privately encapsulated data.
			[/onlySpecifiedUser]
		Note this method was created to forbid the apparition of edition buttons.
	*/
	function subUserStatus(){
		return $this->genFlag('subuser');
	} // subUserStatus
	
	/**
		Return true if the current forum user got permanent changing rights on own posts.
	*/
	function ownPostChgRght(){
		$sLightF= &$this->sLightF;
	
		$usrId= $sLightF->fumLogUserId();		// default logged user		
		if ($sLightF->correctlySignedIn()){	// also uses the same default logged user
			return $this->genFlag('pcown',$usrId);
		}else{
			return false;
		}
	} // ownPostChgRght
} // fumXRights

?>
