<?php
/**
	File name : gen2Captcha.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Second generation of captcha with random consonnances.

	[cenPlugin name="gen2Captcha" /]				[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class gen2Captcha extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->acc= &$tagsFu->acc;
		$this->hPwC= &$tagsFu->hPwC;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		$this->textIm= $tagsFu->instExplitCentralCls('textOnImages');		
		$this->genHash= $tagsFu->instExplitCentralCls('genHash');
	} // construct

		
	/**
		Define the core widget captcha, mainly to be called by
		[mWgtCaptcha /] --> formMainWdgt::tg_mwgtcaptcha(&$v,&$bd)
	*/
	function coreWgtCaptcha($v,$bd){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$hPwC= &$this->hPwC;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$genHash= &$this->genHash;
		$textIm= &$this->textIm;
		
		
		$buff= '';
		$tblnm= $v['tblnm'];
		$this->curCaptchTblNm= $tblnm;
		
		
		$sl= $v['sl'];
		if ($sl!==false){
			$intro= $glob->sl('',$sl);
		}else{
			$intro= $v['intro'];
		}
		
		$introfont= $tools->binLoads($v['introfont'],'gCaptchIntroFont');

		$st= 'width:90px; float:left; border:0px solid red; margin-right: 30px;';
		$stBox= 'width:85px; float:left; border: 4px solid green; margin-right: 30px; font-size:24px;';
		
		$leftBlock= $caps->span($intro,$introfont);
		
		$leftBlock.= _c_._c_;
		$leftBlock.= $caps->textBxStl(_c_captchaTxtNm,'',$stBox);
		$leftBlock.= _c_;
		$leftBlock.= $bd;
		$buff.= $caps->sDiv($leftBlock,$st);
		
		// --------------- image size --------------
		$width= (int) $tools->binLoads($v['width'],'300');
		$height= (int) $tools->binLoads($v['height'],'120');
		
		
		$nbChars= (int)$dtb->getGenVar('simpleCaptchaSz');
		$captchaTxt= $hPwC->consStr($nbChars);
		$imgDfn= $textIm->textToImage($captchaTxt, $width,$height,true); // ######
		$serverAnswer= $captchaTxt; // Same text, just ask to read and copy, nothing to solve!
				

		$alt= $glob->sl('A captcha to solve','kati');
		$alt= $alt.' ('.$glob->sl('upper case or lower ...','katiPlus').')';
		
		$captchaWidget= $caps->ttlImage($imgDfn,$alt,$alt,'sImg');
		$buff.= $caps->sDiv($captchaWidget);
		
		// Extract the server stored answer to store it with the hash
		$curHash= $genHash->setNewHash($serverAnswer);	// stores the new hash with its info inside the circular queue.
		
		$buff.= _c_R.$caps->hiddenWdg(_c_genCaptHidHashNm,$curHash)._c_R;

		$st= 'width:100%; max-width:440px; float:left; border:2px solid green; padding:10px; margin:5px; margin-left:0px;';
		$buff= $caps->sDiv($buff,$st);
		return $buff;
	} // coreWgtCaptcha

	/**
	*/
	function tags(){
		return array();
	} // tags
		
} // gen2Captcha
?>