<?php
/**
	File name : genCaptcha.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt




	A general capctha definition with an associated circular hash and a basic captcha class (captcha.php)

	[cenPlugin name="genCaptcha" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
			
	
	Also see : 	formp Kernel::formSucceeded()
	
*/
class genCaptcha extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();
		$this->glob= &$tagsFu->glob;
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		
	
		if (array_key_exists('captcha',$tagsFu->libClasses)){
			$this->captCo= &$tagsFu->libClasses['captcha'];
		}else{
			include_once _c_LibPath.'captcha.php';
			$this->captCo= new captcha($tagsFu,_c_ko);	// captcha core	
			$tagsFu->libClasses['captcha']= &$this->captCo;
		}
		
		$this->sArr= $tagsFu->optimClassAccess(_c_libClassCateg,'specArray','');
		$this->textIm= $tagsFu->instExplitCentralCls('textOnImages');		
		
		define('_c_genCaptHidHashNm',_c_captHidHashNm);	// could substitute !!
		

		/**
			Automated tables for captcha creation.
		*/
		define('_c_captAutoTN','captchAutoCateg');
			define('_c_captAutoId',_c_genId);
			define('_c_captAutoEn','en');
			define('_c_captAutLblEn','labelEn');
			define('_c_captAutoFr','fr');
			define('_c_captAutLblFr','labelFr');
		
		$this->genHash= $tagsFu->instExplitCentralCls('genHash');
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('genCaptcha','debugDisplay',false);	
	} // construct

	
	/**
		To return a random auto captcha question from _c_captAutoTN
			Creates the correct sentence for picking up characters inside
			a specific category of words at specific positions.
	*/
	function captchaAutoQuest(&$strSol){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$sArr= &$this->sArr;


		$indexV= $dtb->vectFielDuS(_c_captAutoTN,'',_c_captAutoId);

		/* Select 2 random values of $indexV
		*/
		$sz= count($indexV);
		$pos1= rand(0,$sz-1);
		$categ1= $indexV[$pos1];
		
		$incr= rand(1,$sz-2);
		$pos2= $sArr->incrCirc(0,$sz-1,$pos1,$incr);
		$categ2= $indexV[$pos2];
		
		/* Select a 4 chars vector to catch the 1st, 2nd ... 4th chars of the correct category of words.
		*/
		$rangeV= $sArr->rangeRndVector(4,4)	;	// Build the range vector
	
	
		/*	Creates the correct mix of array elements
		*/
		switch ( $tools->curLgOnce() ){
			case 'fr':
				$str1= $dtb->getElem(_c_captAutoTN,_c_captAutoId,$categ1,_c_captAutoFr); // + fu to be language specific
				$str2= $dtb->getElem(_c_captAutoTN,_c_captAutoId,$categ2,_c_captAutoFr);
				$label1= $dtb->getElem(_c_captAutoTN,_c_captAutoId,$categ1,_c_captAutLblFr);
			break;
			
			case 'en':
			default:
				$str1= $dtb->getElem(_c_captAutoTN,_c_captAutoId,$categ1,_c_captAutoEn); // + fu to be language specific
				$str2= $dtb->getElem(_c_captAutoTN,_c_captAutoId,$categ2,_c_captAutoEn);
				$label1= $dtb->getElem(_c_captAutoTN,_c_captAutoId,$categ1,_c_captAutLblEn);
			break;
		} // switch
		
		
		$v1= $tools->trimStrToV($str1);
		$slice1= $sArr->nElemOfV($v1,4);
		
		$v2= $tools->trimStrToV($str2);
		$slice2= $sArr->nElemOfV($v2,2);
		
		$arrQuiz= array_merge($slice1,$slice2);
		$sArr->rndMixArray($arrQuiz);	// Associate it with the main captcha display !!!
		
		
		
		/*	Calculates and store the solution
			Algo :
				- remove $slice2 elements from $arrQuiz
				- Uses $rangeV to take the matching characters
				- passes it in param so we can store it inside the circular hash buffer !!!
		*/
		
		$strSol= $this->autoCaptSol($arrQuiz,$slice2,$rangeV);
		
		/*	Build the full sentence.
		*/
		$text= '';
		$text.= $sArr->ordNumToLitV($rangeV);
		
		switch ( $tools->curLgOnce() ){
			case 'fr':
				$text.= ' caractères catég'._c_R;
				$text.= $label1.' ';		// !!!!!!!!!!!!!!!!!!!
				$text.= 'à écrire dans l\'ordre :'._c_R;
				$text.= $sArr->arrToNLinesStr($arrQuiz);
			break;
			
			case 'en':
			default:
				$text.= 'chars of the ';
				$text.= $label1._c_R;		// !!!!!!!!!!!!!!!!!!!
				$text.= 'category in order to write inside the text box :'._c_R;
				$text.= $sArr->arrToNLinesStr($arrQuiz);
			break;
		} // switch
		
		
		
		return $text;
	} // captchaAutoQuest
	
	
	/**
		Calculates the auto captcha solution.
	*/
	function autoCaptSol($arrQuiz,$arrSub,$rangeV){
		$chosenCateg= array_diff($arrQuiz,$arrSub);
		$solStr= '';
		$i=0;
		reset($chosenCateg);
		foreach ($chosenCateg as $key=>$categ){
			$pos= $rangeV[$i];
			$chosChar= $categ[$pos-1];
			
			$solStr.= $chosChar;
			$i++;
		}
		return $solStr;
	} // autoCaptSol
	
	
	/**
	*/
	function captchAutQuestImg(&$strSol,$width){
		$textIm= &$this->textIm;
		
		$text= $this->captchaAutoQuest($strSol);
		return $textIm->textToImage($text,$width);
	} // captchAutQuestImg
	

	/**
	*/
	function coreWgtCaptcha($v,$bd, $imgCaptch=true,$autoCaptch=true){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$textIm= &$this->textIm;
		$genHash= &$this->genHash;
		$captCo= &$this->captCo;
		
		
		$buff= '';
		$tblnm= $v['tblnm'];
		$this->curCaptchTblNm= $tblnm;
		
		$intro= $v['intro'];
		$introfont= $tools->binLoads($v['introfont'],'gCaptchIntroFont');
		
		$st= 'width:100px; float:left; border: 0px solid red;';
		$stBox= 'width:80px; float:left; border: 2px solid red;';
		
		$txbxfont= $tools->binLoads($v['txbxfont'],'gCaptchFont');	// must be courier & must be for the text box too
		
		$leftBlock= $caps->span($intro,$introfont);
		$leftBlock.= _c_._c_;
		$leftBlock.= $caps->sDiv($caps->textBx(_c_captchaTxtNm,'','6',$txbxfont),$stBox);
		$leftBlock.= _c_;
		$leftBlock.= $bd;
		$buff.= $caps->sDiv($leftBlock,$st);
		
		
		// --------------- image size --------------
		$width= (int) $tools->binLoads($v['width'],'300');
		$height= (int) $tools->binLoads($v['height'],'120');
		
		if ($imgCaptch){
			if ($autoCaptch){
				$imgDfn= $this->captchAutQuestImg($strSol,$width);
				$serverAnswer=$strSol;
			}else{
				$coTxt= $captCo->captchaQuest($captId,$tblnm);
				$captchaTxt= $acc->fromHtmlToAccents($coTxt);
				$captchaTxt= str_replace(_c_Br, _c_R, $captchaTxt);
				$captchaTxt= $this->splitString($captchaTxt,22);
				$imgDfn= $textIm->textToImage($captchaTxt, $width,$height);
				$serverAnswer= $dtb->getElem($tblnm, _c_CaptchaId,$captId, _c_CaptchaAnsw);
			}
			
			$flexImgStyle= $caps->matStyl('width:100%; max-width:'.$width.'px; min-width:200px');
			$captchaWidget= $caps->img($imgDfn, $glob->sl('A captcha to solve','kati'), 'sImg', $flexImgStyle);
		}else{
			if ($autoCaptch){
				$captchaTxt= $this->captchaAutoQuest()._c_R;
			}else{
				$captchaTxt= $captCo->captchaQuest($captId,$tblnm)._c_R;
				$serverAnswer= $dtb->getElem($tblnm, _c_CaptchaId,$captId, _c_CaptchaAnsw);
			}
			$captchaWidget= $caps->span($captchaTxt,$txbxfont);
		}
		
		$buff.= $caps->sDiv($captchaWidget);
		
		// Extract the server stored answer to store it with the hash
		$curHash= $genHash->setNewHash($serverAnswer);	// stores the new hash with its info inside the circular queue.
		
		$buff.= _c_R.$caps->hiddenWdg(_c_genCaptHidHashNm,$curHash)._c_R;
		return $buff;
	} // coreWgtCaptcha
	
	
	/**
		Split the text at the correct length with _c_R
	*/
	function splitString($s,$l){
		$tools= &$this->tools;
	
		$v= $tools->mbStrToAry($s,$sz);
		$b= '';
		$i= 0;
		reset($v);
		foreach ($v as $key=>$char){
			if ($char===_c_carRet){
				$i= 0;
			}
		
			if ($i<$l){
				$i++;
			}else{
				$b.= _c_R;
				$i= 1;
			}
			$b.= $char;
		}
		
		return $b;
	} // splitString
		
	function tags(){
		return array();
	} // tags
		
} // genCaptcha
?>