<?php
/**
	File name : ifram.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Supplementary iframe object.
*/
class ifram extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->asa= &$tagsFu->asa;		
		$this->tools= &$tagsFu->tools;
		$this->caps= &$tagsFu->caps;
		$this->fls= &$tagsFu->fls;
			
				
		$tagsFu->attribVect['pagifram']= array('page','width','height','scrol','cls','id');
		$tagsFu->attribVect['iifram']= array('methloc','methparam','path','width','height','scrolling','cls');
		$tagsFu->attribVect['ifram']= array('page','src','width','height','scrolling','cls');
	} // construct

		
	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('pagifram','iifram','ifram');
	} // tags


	/**
		[pagifram page="_avataFileMg" width="600" height="150" cls="ln" /]	
	
		Calling a standard page through an iframe.
	*/
	function tg_pagifram(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;

		$pg= $v['page'];
		$src= $tools->urlGivenPage($pg);
		$src.= $tools->addUrlVar('uStopParser',_c_ok);
		
		$width= $v['width'];
		$height= $v['height'];
		
		$scrolling= $tools->binLoads($v['scrol'],'auto');
		$cls= $tools->binLoads($v['cls'],'');
		$id= $tools->binLoads($v['id'],'defaultPageFrame');
		
		return $caps->hIframe($src,$height,$scrolling,$id,'',0,0,0);	// uses default message.
	} // tg_pagifram


	/**	
	*/
	function displayThumbs(){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$caps= &$this->caps;

		$thumbspath= $tools->getVal(_c_urlMethPar);	
		if ($thumbspath!==false){
			// Returns a formatted thumbnails gallery (to be used with the image projector) :
			$pathCss= _c_toDeclPlugins.'central/ifram/ifram.css';
			return $caps->internalFormat( $fls->jsChgParentZoom($thumbspath,'framedThumbs'), $pathCss );
		}
	} // displayThumbs


	/**
		Internal naked call iframe : calling an internal url base on some explicit plugins -->
			---> method localisation = method specification : methspec
			pluginPath + className + MethodName : must travel with the url and be checked as safe.
			
		[iifram methloc="central/.ifram.displayThumbs" methparam="testzoom/thumbs"  width="600" height="150" scrolling="auto" cls="ln" /]
	*/
	function tg_iifram(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
	
	
		$methloc= $v['methloc'];
		$methparam= $v['methparam'];	// path for the thumbs inside the image default directory
		$src= $tools->urlMethodDef($methloc,$methparam);
				
		
		// eg ,,, ?methloc=explicit/central/.iframe.displayThumbs 
		//			&methparam="param1"
		
		$width= $v['width'];
		$height= $v['height'];
		$scrolling= $v['scrolling'];
		$cls= $v['cls'];
		
		return $caps->hIframe($src,$height,$scrolling);	// uses default message.
	} // tg_iifram


	/**
		Tag management of an iframe for EXTERNAL URL
			Input :
				The most basic parameters of an iframe
				$bd a message for iframe disable browsers
				
		[iframe src="" width="600" height="150" scrolling="auto" cls="ln" /]
		[iframe src="" width="600" height="150" scrolling="auto" cls="ln"] iframe disable browser [iframe/]
		
		Exmpl :
			page="_live-tags&shortInfo=demo"		...
	*/
	function tg_ifram(&$v,&$bd){
		$t= &$this->tools;
		$caps= &$this->caps;
	
		$page= $v['page'];	// also extended page
		if ($page===false){
			$src= $v['src'];
		}else{
			$src= $t->urlGivenPage($page);
		}
		
		$width= $v['width'];
		$height= $v['height'];
		$scrolling= $v['scrolling'];
		$cls= $v['cls'];
		
		return $caps->hIframe($src,$height,$scrolling);	// uses default message.
	} // tg_ifram

} // ifram
?>
