<?php
/**
	File name : imgTags.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To define tags directly related with images managment.Outside standard tag declaration, 
	php code instanciation is usallly done with $imgTags= $tagsFu->instExplitCentralCls('imgTags');
	Note : most php image display is doen directly using the class capsHtml.php

	For the thumbs page :
		[cenPlugin name="imgTags" /]	
		[zPage p="bigZoom" /]
		
		[zPath p="testzoom" /]
		[z name="bouquetin.jpg" alt="un bouquetin" lblBig="bla bla bouquetin." /]
				
	For the zoom page :
		[cenPlugin name="imgTags" /]		
		[zBigImg /]
		
	So needs a centralisation to avoid too many identical specifications for :
		[cenPlugin name="imgTags" /]	
		[zPage p="bigZoom" /]
		
	
	Note about restricted parsing, in all cases, parsing is restricted on allowed tags for :
		- The post content, see $glob->tagRstrct().
		
		- For the text content of a zoom on an image :
			To avoid some xml2 injection through forum posts, so 
				(1) the webmaster also got the same tags as general user,this is important otherwise xml2 injection could
				be achieve with the involontary participation of a webmaster.
				(2) the _c_idTextsTbl is filled during this execution of the z tag / tg_ z() when the webmaster is logged twice,
				as webmaster and with a relevant forum Id, saving are done only for posts concerned by this forum id, so avoiding 
				too many unnecessary savings.
				
	imgTags::tg_zbigimg()
	imgTags::tg_z()
	
	$this->buildIdTextPg(...)
	$fls->splitOnLastC($this->zmPrtImgPath,$left,$zmImgName);
	define('_c_idTextsZm','z');
*/
class imgTags extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$this->asa= &$tagsFu->asa;
		
		$this->glob= &$tagsFu->glob;
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
		$this->caps= &$tagsFu->caps;
		$this->fls= &$tagsFu->fls;
		
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;
		
		$this->rMg= &$tagsFu->rMg;
		$this->rights= &$tagsFu->rights;
		$rights= &$this->rights;
		$this->parser= &$tagsFu->parser;
		$this->polyglot= &$tagsFu->polyglot;
		
		$this->gotBigImgXpetXpand= false;	// not done now
		$this->mainAdvertPlugIn= false;  // init here to false, but may be instantiated if necessary
				
				
		define('_c_zmImgPostId','imgPostId');				
		
		/**
			Special parameters for managing zooms in webmaster mode! Why that :
				- The "idTexts" table record may not be created or may be rewritten therefore we can't count on it 
				  for the complex navigation of the zoomed images.
				- _c_partialZImgPath give a direct access to the image file. Should not be mixed with _c_idTextsZm === z
				  that is the compact form for when not logged and trying to please search engines.
		*/
		define('_c_zmOrigPg','origPg');	// url variable name to memorize the zoom original page
		define('_c_partialZImgPath','zm');	// to link and get the image name with its partial localised path
		
		define('_c_zmIdTxtPfx','zmIdTxtPfx');	// zoom IdTexts table prefix
		
		$tagsFu->includeSupFiles('imgTags',false,false);

		/*
			[zBigImg /] : Plug to insert inside the zoom page eg : "oneZoomPage" so we can assopciate text with the image
			Holds : the big image and an eventual (large) label
			it looks for its text inside the idTexts table depending on the image name+lg or url passed parameter.
			'cls', 'maxTtlWidth'
		*/
		$tagsFu->attribVect['zbigimg']= array('cls','maxttlwidth');


		/*
			Compulsory attributes
				name : name of the image (with eventual local path) of the main/big image. The small image is deduced as p.'thumbs/'.name
				
				id : identificator of the image html-assigned as id and name !!
				
				alt : for the small image, text alternatif and title of the link.
			
			Facultaive attributes :			
				$bd : (the tag body so can insert other formatings) label used to de displayed along with the big image
					Note : if this text is just added to the url, the search engines are likely to shunt the large image
						because the text is just a duplicata of what is published on the main page, so the easiest way is to
						store that text into a specialised table (idTexts) where any sort of text can be stored and retrieved
						without appearing directly inside the html of the page (save space + search engine effeicient).
						
						Format : "labelXY#This is the main text" and labelXY is used in the url.
						if # is not specified, the image name with the current language abreviation is used.
					A corresponding plug tag [zText /] must be present inside the zooming page
				
				
				cls : class
				p : facultative path if we don't want to use [zPath p="" /]
				pg : for a simple local link on a page!
				cp : complementary path if we want to use [zPath p="" /] as a prefix.
				
				tg_i(), tg_j()
		*/	
		$imgVect= array('name', 'id', 'alt', 'supstl', 'stl', 'onlywm', 'onlyfu', 'ttl', 'cls', 'width', 'height', 'es', 'p', 'pg', 'noduplicate', 'edt', 'location', 'js', 'search', 'replace', 'url','rel','follow','target');
		$tagsFu->attribVect['i']= $imgVect;
		$tagsFu->attribVect['j']= $imgVect;
		
		/*
			name : nom du répertoire d'images
			jsvar : if set to ok ---> adds a global js variable holding the random image
			rndtype : type d'image (jpg / png) quand il est demandé de piquer une image aléatoirement.
			pfx : prefix unique pour différencier les créations spécifiques de texte dans la table idTexts
			maxtext : ok or ko, to allow or not the creation of full independant description in table idTexts. 
					By the way it's also useful to have shorter url access
			stl : style
			supstl : supplement style
			invisintg : if ok does a trim to remove invisible chars (spaces, tabs etc) from the tg_z() tag body.
			globstl : to set $this->globZoomStyle
			defbr : default line break friendly for page fit calculations.
			trunkafter :  apparently not used !!!!
			
			awrite : aWrite="ok" ---> always rewrites/ecrases the idTexts verbosed part, so the idTexts part is just kept
			   because of shorter urls access. Full control of infos inside the [z tag body.... Also force $this->alwayRewrVerbose to true.
			
			tg_setzlocalpath(...
				...n setXTaglocalPath(...
		*/
		$tagsFu->attribVect['setzlocalpath']= array('name','jsvar','rndtype','pfx','maxtext','stl','supstl','invisintg','globstl','defbr','trunkafter','awrite');
		
		
		$tagsFu->attribVect['setjlocalpath']= array('name','pfx','maxtext','stl','supstl');
		$tagsFu->attribVect['unsetpercautofit']= false;
		
		$tagsFu->attribVect['transp']= array('width','height','cls','stl');
		
		$this->curLocalPath='';	
		$this->extractSpecificBigLbl= false;
		$this->currentGalleryBigLbl= 'none';
		
		// n tg_z(
		$tagsFu->attribVect['z']= array('name','stay','alt','ttl','supstl','target', 'stl','cls','url','justtxt','mode','trunkafter');
		$tagsFu->attribVect['zsubstitute']= $tagsFu->attribVect['z'];
		
		$tagsFu->attribVect['bfsubstitute']= false;

		
		$tagsFu->attribVect['thumbssupstyle']= array('supstl','stl');
		$tagsFu->attribVect['imgsupstyle']= array('supstl','stl');
		$tagsFu->attribVect['cancelimgspsty']= false;
		
		
		$tagsFu->attribVect['zmaintitle']= false;
		$tagsFu->attribVect['zmalt']= false;
		$tagsFu->attribVect['zmlnttl']= false;
		$tagsFu->attribVect['zmparag']= false;
		
		$tagsFu->attribVect['zmorigpg']= false;
		$tagsFu->attribVect['zmimgpath']= false;
		
		$tagsFu->attribVect['za']= array('imgn','pfx','cls','stl');
		
		
		$this->galleryPfx= false;
		$this->curGalleryImgNames= array();		// for % calculations and related storage
		
		// See function getZLockVal()
		define('_c_zLockSffx','zzLock');		// suffix to add onto a page name to designate a locker for large image text coming from the main page xm2
		define('_c_zLockOk','ok');		// Ok full lock (edition is only possible with the table editor)
		
		$this->suplImThumbsStyle= '';	// standard image and thumbs style
		$this->allowBfSubstitute= false;
		$this->percentVector= array();
		$this->allowPercentVector= false;
		$this->gotFirstBfSubst= false;
		
		$this->zmMaxText= _c_ko;
		
		
		$pms= $dtb->getGenVar('galleryPfxMaxSz',5);
		define('_c_galleryPfxMaxSz',$pms);
		
		$this->buildetZmSeq= '';
		$this->fnList= '';
		$this->globZoomStyle= false;
		$this->usedImTgBreak= 'bg';	// Pseudo Break flux for the Gallery. Set for the last gallery trend (for mobile adaptation) --> to replace tg_bf
		
		$this->alwayRewrVerbose= false;
	} // construct


	/**
	*/
	function tags(){
		return array('zbigimg', 'i','j', 'transp', 'setzlocalpath', 'setjlocalpath', 'unsetpercautofit'
			,'z', 'zsubstitute', 'bfsubstitute', 'thumbssupstyle', 'imgsupstyle', 'cancelimgspsty', 'zmaintitle','zmalt','zmlnttl','zmparag'
			,'zmorigpg','zmimgpath','za');
	} // tags
	
	
	function setAds(&$adsCls){
		$this->mainAdvertPlugIn= &$adsCls;
	} // setAds
	
	/**
	*/
	function setGlobSupStyle(&$v){
		$tools= &$this->tools;

		$stl= $tools->binLoads($v['supstl'],$v['stl']);
		if ($stl===false || $stl===''){
			$this->suplImThumbsStyle= ''; // redondant but explicative!
			return;
		}
		
		$this->suplImThumbsStyle= $stl;
		if ($stl[0]!==_c_Rs){
			$this->suplImThumbsStyle= _c_Rs.$stl;	// adds the real space !!
		}
	} // setGlobSupStyle
	

	// [cancelImgSpSty /]
	function tg_cancelimgspsty(&$v,&$bd){
		$this->cancelImgSupStyle();
	} // tg_cancelimgspsty
	
	function cancelImgSupStyle(){
		$this->suplImThumbsStyle= '';
		$this->curLocalPath= '';
	} // cancelImgSupStyle
	
		
	
	/**
		Chooses between an image inside the personal directory or inside the editor /img/ central directory 
			Input : string of the image name.
			Output : full image string with personal settings having priority over standard settings
	*/
	function persoOrEdtImg($iStr){
		if ( file_exists( _c_ataoxPersImgPath.$iStr) ){
			$dfn= _c_ataoxPersImgPath.$iStr;		// a user defined shrink button
		}else{
			$dfn= _c_EditorImgPath.$iStr;		// the default shrink button
		}
		
		return $dfn;
	} // persoOrEdtImg
	

	
	/* ----------------------------------------------------------------
		New tags specific to text-populate the zoomed images
		
		$this->zmOriginPg
		$this->zmPrtImgPath
	*/
	
	/**
		[zmOrigPg]
	*/
	function tg_zmorigpg(&$v,&$bd){
		$this->zmOriginPg= $bd;
	} // tg_zmorigpg

	/**
		[zmImgPath]
	*/
	function tg_zmimgpath(&$v,&$bd){
		$this->zmPrtImgPath= $bd;	// partial image path
	} // tg_zmimgpath
	
	
	/**
		The compulsory tag, the following tags are free to set or not.
		[zMainTitle] TT [/zMainTitle]
	*/
	function tg_zmaintitle(&$v,&$bd){
		$this->zMainTitle= $bd;
	} // tg_zmaintitle
	
	/**
		[zmAlt]
	*/
	function tg_zmalt(&$v,&$bd){
		$this->zmAlt= $bd;
	} // tg_zmalt
	
	/**
		[zmLnTtl]
	*/
	function tg_zmlnttl(&$v,&$bd){
		$this->zmLnTtl= $bd;
	} // tg_zmlnttl
	
	/**
		[zmParag]
	*/
	function tg_zmparag(&$v,&$bd){
		$this->zmParag= $bd._c_._c_._c_;
	} // tg_zmparag


	/**
		Returns the gallery lock string/Id. So we do NOT ecrase the fields holding
		specific zoom information written by hand.
	*/
	function galleryLockId($pg,$pfx=false,$cLg=false){
		$dtb= &$this->dtb;
		
		if ($cLg===false){
			$cLg= $dtb->currentLg($pg);
		}
		
		$lrgSffx= '-'._c_zLockSffx.'-'.$cLg;
		if ($pfx===false){
			return $this->galleryPfx.$lrgSffx;
		}else{
			return $pfx.$lrgSffx;
		}
	} // galleryLockId
			
	/**
		Get the value held by the zoom/text locking file.
		Input :
			$dtb : passed in parameter because different DTBs can be consulted together
			$lockId : the name of the dtb row.
	*/
	function getZLockVal(&$dtb, $lockId){
		return $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$lockId, _c_idTextTxt);
	} // getZLockVal
	
		
	/**
		Get the text/zoom lock value from the 2 basic variables of the record name.
	*/
	function tzLockVal($galleryPfx,$cLg){
		$dtb= &$this->dtb;
		$lockId= $galleryPfx.'-'._c_zLockSffx.'-'.$cLg;
		return $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$lockId, _c_idTextTxt);
	} // getZLockValFromPfx
	
	
	
	/**
		Computes the key to access the big image labels
		Input :
			$givenImgName : image name given with or without its type.
			$gPfx : given and forced prefix also loads it globally.
	*/
	function bigImgLabelKey($givenImgName, $gPfx=false){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		
		if ($tools->sIsInB('.',$givenImgName)){
			$fls->splitOnLastC($givenImgName,$imageName,$ext,'.');
		}else{
			$imageName= $givenImgName;
		}
		
		$imageName= str_replace('.','-',$imageName);
		
		$origPg= $tools->getVal(_c_zmOrigPg);
		if ($origPg===false){
			// on the original page -->
			$origPg= $tools->curPageName();
		}
		$lgSffx= $dtb->currentLg($origPg,true);	// language suffix
		

		/* Add a post (forum message) prefix for posts so can't interfer with other posts label for the same image and with 
		   main pages + but main pages got only one definition / specific image / language (seems ok, if not
		   would need a short compressed page prefix (short to have a manageable key length)). */
		$postprfx= '';
		$zmImgPostId= $tools->getVal(_c_zmImgPostId);
		if ($zmImgPostId!==false){
			// inside the zoom windows case
			$postprfx= $zmImgPostId;
		}else{
			if ($glob->curGPostId!==false){
				$postprfx= $glob->curGPostId;	// state of computing the concerned post for display
			}
		}
		
		
		if ($gPfx!==false){
			$this->galleryPfx= $gPfx; // happens only with special actions of the file manager
		}		
		
		if ($this->galleryPfx===false){
			// normal case of next or prev zoom
			$pZimgP= $tools->getVal(_c_idTextsZm);
			$fls->splitOnLastC($pZimgP,$path,$imageNm);
			$fls->splitOnFirstC($pZimgP,$this->galleryPfx,$right,'-');
		}
		
		
		if ($this->specificPost()){
			$key= $postprfx.$imageName;
		}else{
			if ($this->galleryPfx===''){
				/*
					The Xpetal code is not defined for this ID, the user can't be bored with explicit text writing.
					--> we need to find navigating clues directly with the zoomed image
				*/
				$key= false;	
			}else{
				$key= $this->galleryPfx.'-'.$imageName.'-'.$lgSffx;
			}
		}
		
		return $key;
	} // bigImgLabelKey	

	/* 
	---------------------------------------------------------------- */
	
	
	/**
		[unsetPercAutoFit /]		Unset the automatical % fitting
	*/
	function tg_unsetpercautofit(&$v,&$bd){
		$this->percentVector= array();
		$this->allowPercentVector= false;
	} // tg_unsetpercautofit
	
	
	
	
	/**
		the  [z ,,/] or [j ,,/] tag is really parsed but this method is called instead to set some special formattings on request.
		See tagSubstitOn() and tagSubstitOff() for more information.
		
		Calculation with the substitute should be done with a button associated with tg_setZLocalPath()
	*/
	function tg_zsubstitute(&$v,&$bd){
		$caps= &$this->caps;
		// $this->curLocalPath; stored ones inside DTB at the END of the process
		array_push($this->curGalleryImgNames, $v['name']);	// so can have them all at the bfSubstitute stage
		$this->allowBfSubstitute= true;
	} // tg_zsubstitute
	
	/**
	*/
	function listId($pfx=false){
		$glob= &$this->glob;
		if ($pfx===false){
			return $this->galleryPfx.'-list-'.$glob->curSurfLg();
		}else{
			return $pfx.'-list-'.$glob->curSurfLg();
		}
	} // listId
	
	/**
	*/
	function weightingId(){
		$glob= &$this->glob;
		return $this->galleryPfx.$glob->curSurfLg();
	} // weightingId
	
	
	/**
		The  [bf/] or [bg/] tag is really parsed but this method is called instead to separate groups of images.
	*/
	function tg_bfsubstitute(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		
		if (!$this->allowBfSubstitute){
			return;
		}
		
		$condVal= $this->weightingId();
		if ($this->gotFirstBfSubst===false){
			$valV= array($condVal,'');
			$this->setIdTextsTbl('',$condVal,$valV);	// erases
			$this->gotFirstBfSubst= true;
		}
		
		$whishedH= (int)$dtb->getGenVar('gallThumbHeight');	// whished height real or at least visible for lazy updates
		
		$curLP= $this->curLocalPath;
		if ($curLP!==''){
			$curLP.= '/';
		}
		
		$widthV= array();
		$heightV= array();

		$totImg= '';
		if ($curLP!==''){
			$totImg.= $curLP;
			$totImg.= '; ';
		}
		
		$totWidth= 0;
		reset($this->curGalleryImgNames);
		foreach ($this->curGalleryImgNames as $key=>$cFileN){
			// Access images for dimensions and stores H & W in eponyme vectors + totalisation of width
			$imSzV= getimagesize(_c_UsrImagePath.$curLP.$cFileN);
			$curW= $imSzV[0];
			$curH= $imSzV[1];
			
			$ratioH= $whishedH / $curH;		// ratio [1]
			$adaptedW= $curW * $ratioH;		// pixels
			
			$totWidth= $totWidth + $adaptedW;
			
			$widthV[$key]= $adaptedW;
			$heightV[$key]= $curH;
		
			// Stores image names
			$fls->splitOnLastC($cFileN,$imgVal,$ext,'.');
			$totImg.= $imgVal;
			$totImg.= '; ';
		}
		$totImg.= '*';	// end punctuation to avoid ; removal or test or fussy while loop
		
		$totPerc= '';
		if ($curLP!==''){
			$totPerc.= '0';
			$totPerc.= '; ';
		}
		
		// Calculates allowed exclusive width for images
		$rMargin= $dtb->getGenVar('thumbsRightMargin');		// right margin in %
		$nbImg= count($this->curGalleryImgNames);
		
		$percentCovert= $dtb->getGenVar('galleryPercentWidth'); // 100;
		$widthForImg= $percentCovert - $nbImg*$rMargin;
		
		reset($this->curGalleryImgNames);
		foreach ($this->curGalleryImgNames as $key=>$val){
			$curW= $widthV[$key];
			$curH= $heightV[$key];
			
			// oustide the loop : need to calculate the allowed % for the images considering thumbsRightMargin
			if ($totWidth>0){
				$curPerc= $widthForImg * $curW / $totWidth;
				$curPerc= floor(100000*$curPerc)/100000;	// calculates 5 decimals after the dot!
			}else{
				$curPerc= 100;
			}
					
			$totPerc.= $curPerc;
			$totPerc.= '; ';
		}
		$totPerc.= '0';	// end punctuation (%value) to avoid ; removal or test or fussy while loop
		
		/* DTB store the string $totImg ? $totPerc  and explode it twice (?;) for retrieval ---
		--- uses these % values inside the standard tg_ z()
		*/
		$assVal= $totImg.' ? '.$totPerc;
		
		$valV[0]= $condVal;
		
		$txt= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$condVal, _c_idTextTxt);
		if ($txt!==false){
			$txt= _c_R . $txt;
		}else{
			$txt= '';
		}
		
		$assVal= $assVal.$txt;
		$valV[1]= $assVal;
		$this->setIdTextsTbl($assVal,$condVal,$valV);
		
		$this->storeZmSequence();
		
		$this->allowBfSubstitute= false;	// --> at least one image and no other [bf/] before.
		$this->curGalleryImgNames= array();	
	} // tg_bfsubstitute
	

	/**
		Stores the sequence of zooms "$this->curGalleryImgNames", just using the natural order of the [z ...] tags ...
	*/
	function storeZmSequence(){
		$glob= &$this->glob;
		$tools= &$this->tools;

		if ( count($this->curGalleryImgNames)!==0 ){
			$condVal= $this->listId();
			
			if ($this->fnList===''){
				$this->fnList.= $tools->arrayToStr($this->curGalleryImgNames,', ');
			}else{
				$this->fnList.= ', '.$tools->arrayToStr($this->curGalleryImgNames,', ');
			}
			
			$valV= array($condVal,$this->fnList);
			$this->setIdTextsTbl($this->fnList,$condVal,$valV);
		}
	} // storeZmSequence
	
	/**
		Gives the next image considering a given gallery prefix.
	*/
	function nextImageName(&$gallPfx, $imgN){
		return $this->nextOrPrevImageName($gallPfx, $imgN);
	} // nextImageName
	
	/**
		Gives the previous image, considering a given gallery prefix
	*/
	function prevImageName(&$gallPfx, $imgN){
		$npName= $this->nextOrPrevImageName($gallPfx, $imgN,false);
		return $npName;
	} // prevImageName
	
	
	function nextOrPrevImageName(&$gallPfx, $imgN, $next=true){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;

		$gallPfx= $tools->getVal(_c_zmIdTxtPfx);
		if ($gallPfx===false){
			$idTextsZm= $tools->getVal(_c_idTextsZm);
			$fls->splitOnFirstC($idTextsZm,$gallPfx,$right,'-');
		}
		
		$condVal= $this->listId($gallPfx);
		$list= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$condVal, _c_idTextTxt);
		if ($list===false || $list===''){
			return false;
		}

		/**
			Looks like a complicated way instead of next()  prev() and test on false for extremities, but 
			only apparently if we look at unfinished trial in code/copyPaste/diverse/blackBoard.php #nextOrPrevImageName
		*/
		$lstV= $tools->trimStrToV($list);
		$lastIdx= count($lstV)-1;
		$flippedLV= array_flip ($lstV);
		$curIdx= $flippedLV[$imgN];
		if ($next){
			if ($curIdx<$lastIdx){
				$nextIdx= $curIdx+1;
			}else{
				$nextIdx= 0; // loop
			}
		}else{
			if ($curIdx>0){
				$nextIdx= $curIdx-1;
			}else{
				$nextIdx= $lastIdx; // loop
			}
		}
		
		return $lstV[$nextIdx];
	} // nextOrPrevImageName
			
	
	/**
		A method to get the concerned percentage of the current group where the image belongs. [ called from n tg_z () ]
	*/
	function loadPercentVect(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		if (!$this->allowPercentVector){
			return false;
		}
		
		if (count($this->percentVector)===0){
			$condVal= $this->weightingId();
			$totStr= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$condVal, _c_idTextTxt);
			if ($totStr!==false){
				$lineV= $tools->mbExplode($totStr,_c_R);
				reset($lineV);
				foreach ($lineV as $key=>$line){
					$dblStrV= $tools->mbExplode($line,'?');
					$imageNames= $tools->mbExplodeAndTrim($dblStrV[0],';');	// image names vector except for 1st and last element that are just indicative
					$percentNames= $tools->mbExplodeAndTrim($dblStrV[1],';');	// % values vector except for 1st and last element that are just indicative
					$currentVect= array_combine($imageNames,$percentNames);
					$this->percentVector= array_merge($this->percentVector,$currentVect);
				}
				
				return true;
			}else{
				return false;
			}
		}
		return true;
	} // loadPercentVect
	
	
	
		
	/**
		$this->zBigImInit($key,$zm,$xPet)
	*/
	function zBigImInit(&$key,&$zm,&$imgName,&$xPet){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;

		$key= $tools->getVal(_c_idTextsZm);
		if ($key===false){
			$zm= $tools->getVal(_c_partialZImgPath);
			$fls->splitOnLastC($zm,$path,$imgName);		// Split the given image name
						
			// Get the gallery prefix, this is the second way for loading $this->galleryPfx when we don't have access to the xPetal code
			$this->galleryPfx= $tools->getVal(_c_zmIdTxtPfx,'');
			$key= $this->bigImgLabelKey($imgName);
		}
		
		
		if (!$this->gotBigImgXpetXpand){
			$xPet= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$key, _c_idTextTxt);	// xPetal text to parse
			if ($xPet!==false){
				$tagsFu->expand($xPet);
				$this->gotBigImgXpetXpand= true;
			}
		}else{
			$xPet= true;
		}
	} // zBigImInit
		
	/**
		Used when returned variables are useless except for the job done by $tagsFu->expand($xPet);
	*/
	function blindZBigImInit(){
		$this->zBigImInit($key,$zm,$imgName,$xPet);
	} // blindZBigImInit


	/**
		Plug to display the big image and insert some text inside the zoom page.
			Input :
				$v : vector of parameters, none for now
				$bd : body not used 
			$url.= $tools->addUrlVar('zMode',$mode);
	*/
	function tg_zbigimg(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$rMg= &$this->rMg;
		$parser= &$this->parser;
		$advrtPlug= &$this->mainAdvertPlugIn;
		
		$zMode= $tools->getVal('zMode');
		$zmPrtImgPath= false;
		$zMainTitle= '';
		$zmAlt= '';
		$zmLnTtl= '';
		$zmParag= '';
		$zmOriginPg= '';
		
		$this->zBigImInit($key,$zm,$imgName,$xPet);
		if ($xPet!==false){
			$zMainTitle= $this->zMainTitle;
			
			if (isset($this->zmAlt)){
				$zmAlt= $this->zmAlt;
			}
			
			if (isset($this->zmLnTtl)){
				$zmLnTtl= $this->zmLnTtl;
			}else{
				$zmLnTtl= $zmAlt;
			}
			
			if (isset($this->zmParag)){
				$zmParag= $this->zmParag;
			}
			
			if (isset($this->zmOriginPg)){
				$zmOriginPg= $this->zmOriginPg;
			}else{
				$this->zmOriginPg=false;
			}
			
			if (isset($this->zmPrtImgPath)){
				$zmPrtImgPath= $this->zmPrtImgPath;
			}
		}else{
			if (isset($imgName)){
				$fls->splitOnLastC($imgName,$tagsFu->globHtmlMTitle,$ext,'.');
				$zMainTitle= $imgName;
			}else{
				/*
					Error : was a likely non existing zoom id. But because the test (#gotZoomKey) is now done at 
					the beginning of the process this error should not appear anymore.
				*/
				return 'Error imgTags::tg_zbigimg';
			}
		}

		$zm= $tools->getVal(_c_partialZImgPath,$zmPrtImgPath);
		if ($zm===false){
			return '';
		}
		
		
		$xmUvarDfn= $tools->getVal(_c_dsplXmSqrFlNm);	// !false ---> artificial execution of the matching square code (just [zBigImg /] in this case!)
		if ($xmUvarDfn!==false){
			// Is in a gallery building situation, so force the Current Page text extraction from $xmUvarDfn
			
			$this->extractSpecificBigLbl= true;
			
			// We are looking for $zm single image name
			$gotASlash= $fls->splitOnLastC($zm,$left,$right,'/');
			if ($gotASlash){
				$fnWExt= $right;
			}else{
				$fnWExt= $zm;
			}
			
			// Got to look for the [z  .../] tag that got $fnWExt for image file name
			$xmStr= $fls->fileToStr($xmUvarDfn);
			$this->lookingForFn= $fnWExt;
			$parser->addrParseStdStr($xmStr);		// to load $this->globV that got the correct order
			
			$zmParag= $this->currentGalleryBigLbl; // !!
			$this->extractSpecificBigLbl= false;
			
			$zMainTitle= $zmParag;
			$zmAlt= $zmParag;
			$zmLnTtl= $zmParag;
		}
		
		if ($zmParag===false || $zmParag===_c_ko){
			$zmParag= '';
		}else{
			$zmParag= $caps->span($zmParag,'lrgImgTxtStl');
		}
		
		$origPg= $tools->getVal(_c_zmOrigPg,$zmOriginPg);
		$curLg= $dtb->currentLg($origPg,true);	// language suffix
		
		// $oPgUrl= $tools->addUrlVar(_c_zoomOriginePage,$origPg);
		$oPgUrl= $tools->addUrlVar(_c_zmOrigPg,$origPg);
		// _c_zmOrigPg
		
		$pencil= $tools->toEditSpecificTblElem(_c_idTextsTbl,$key,_c_idTextTxt,$oPgUrl,'_blank');
		$zmParag= $pencil.$zmParag;
				
		// Manages the zoom (BIG IMAGE)
		$bigImgPFN= _c_UsrImagePath.$zm;
		$soz= $tools->getVal(_c_sortOfZoom, $dtb->getGenVar('galSortOfZoom'));
		switch ($soz){
			case 'full':
				$bigImg= $caps->simplestImg($bigImgPFN,$zmAlt, $caps->idNameStr('zmmedImgName').$caps->matCss('imgLnPercStl') );
			break;
			
			case 'real':
				$bigImg= $caps->simplestImg($bigImgPFN,$zmAlt, $caps->idNameStr('zmmedImgName').$caps->matCss('imgLnNaturalStl') );
			break;
			
			default:
			if ($tools->isInSmartPM()){
				// full
				$bigImg= $caps->simplestImg($bigImgPFN,$zmAlt, $caps->idNameStr('zmmedImgName').$caps->matCss('imgLnPercStl') );
			}else{
				// real
				$bigImg= $caps->simplestImg($bigImgPFN,$zmAlt, $caps->idNameStr('zmmedImgName').$caps->matCss('imgLnNaturalStl') );				
			}
				
			// $bigImg= $caps->simplestImg($bigImgPFN,$zmAlt, $caps->idNameStr('zmmedImgName').$caps->matCss('imgLnNaturalStl') );
		} // switch
		
		$urlOrigPg= $tools->urlGivenPage($origPg).$this->addXUrl(false).$tools->signet($tools->getVal(_c_zmImgPostId));
		$xSqrFn= $tools->getVal(_c_dsplXmSqrFlNm);
		if ($xSqrFn!==false){
			$urlOrigPg.= $tools->addUrlVar(_c_dsplXmSqrFlNm,$xSqrFn);
		}
		

		$imSzV= getimagesize($bigImgPFN);
		$divWidth= $imSzV[0];
		if ($rMg->quickWMRight()){
			$frmZoomImg= $dtb->getGenVar('edtFrmeAroundZmImg');
			
				// temporary checking old genvar frameArroundZoomImg !!
				$deprecFrame= $dtb->getGenVar('frameArroundZoomImg');
				if ($deprecFrame!==false){
					print('The genVar variable frameArroundZoomImg is deprecated!!! Must define and use frmeAroundZmImg ');
				}
				
		}else{
			$frmZoomImg= $dtb->getGenVar('srfFrmeAroundZmImg');
		}

		$cls= $tools->binLoads($v['cls'],'lrgImgMainTtl');
		$tagsFu->globHtmlMLang= $curLg;
		$css= $caps->matCss('imgFlexZoom');
		
		$smallButtons= $caps->linkImg(_c_UsrImagePath.'userBack.png', $glob->sl('Top gallery page!','kmjc'),$urlOrigPg, 'imgFlexZoom');
		
		$expandBtnPath= $this->persoOrEdtImg('realSz.png');
		$shrinkBtnPath= $this->persoOrEdtImg('screenSz.png');		
		
		// backArrow and other manipulation buttons
		if (!isset($this->zmPrtImgPath)){
			$this->zmPrtImgPath= $tools->getVal(_c_partialZImgPath);
		}
		$fls->splitOnLastC($this->zmPrtImgPath,$left,$zmImgName);
		
		$ta= $caps->ta( $glob->sl('Force the real image size.','kmic') );
		$cImg= $caps->smpltImg($expandBtnPath, $css.$ta);
		
		$arCmd[_c_sortOfZoom]= true;	// true ---> we treat it directly
		$url= $this->standardZmUrl($zmImgName,true,$arCmd);
		$url.= $tools->addUrlVar(_c_sortOfZoom,'real');
		$smallButtons.= $caps->hLink($url,$cImg);
		
		
		$ta= $caps->ta( $glob->sl('Forces the image inside the screen.','kmid') );
		$cImg= $caps->smpltImg($shrinkBtnPath, $css.$ta);
		
		$arCmd[_c_sortOfZoom]= true;	// true ---> we treat it directly
		$url= $this->standardZmUrl($zmImgName,true,$arCmd);
		$url.= $tools->addUrlVar(_c_sortOfZoom,'full');
		$smallButtons.= $caps->hLink($url,$cImg);
		
		
		$imgName= $zmImgName;	// convention same name
		$prevImgName= $this->prevImageName($gallPfx,$zmImgName);
		if ($prevImgName!==false){
			$prevUrl= $this->pnArrowStdPlusZmUrl($prevImgName);
			
			$prevBtnPath= $this->persoOrEdtImg('prevPict.png');		
			$smallButtons.= $caps->linkImg($prevBtnPath,$glob->sl('Previous Image','kmil'),$prevUrl,'leftGalZoomArw');
			
			$nextImgName= $this->nextImageName($gallPfx,$zmImgName);
			$nextUrl= $this->pnArrowStdPlusZmUrl($nextImgName);
			$nextBtnPath= $this->persoOrEdtImg('nextPict.png');		
			$smallButtons.= $caps->linkImg($nextBtnPath,$glob->sl('Next Image','kmik'),$nextUrl,'rightGalZoomArw');
		}else{
			$urlOrigPg.= $tools->reprodUrlVar(_c_statsAvoidUVar);
		}
		
		// #bmandAdvertQ
		$pictBm= $dtb->getGenVar('galPictRowBm');
		if ($pictBm!==false && $pictBm===_c_ok){
			$urlOrigPg.= $caps->urlBm($fls->fNmeNoExt($imgName));
		}
		
		$buff= $caps->linkTC($urlOrigPg,$bigImg,$zmLnTtl,'imgLnStl');
		$buff.= _c_BrFlux.$zmParag;
		
		
		$maxTtlW= $tools->binLoads($v['maxttlwidth'],'500');
		$maxTtlW= ' max-width:'.$maxTtlW.'px;';
		
		if ($advrtPlug!==false && $advrtPlug->gotAtLeastOneHzTtlAds){
			// Wrap the main title inside a DIV for better presentation Tittle / Ads
			$mtl= $caps->div($smallButtons.$zMainTitle,$cls,'','',$maxTtlW);
		}else{
			// No reason to wrap the title
			$mtl= $caps->span($smallButtons.$zMainTitle,$cls);
		}
		
		if ($advrtPlug!==false){
			$mtl.= $advrtPlug->hzZmTtlBuffer;
		}
		
		$mtl.= _c_BrFlux;
		
		return $caps->sDiv($mtl.$buff, $frmZoomImg);
	} // tg_zbigimg	
	
	
	/**
		Returns the minimal url to access a zoomed image.
		Input :
			$key : compound key for image access inside the table idTexts
			$acceptEdt : ...
			$arCmd : ...
			$pnArrowCase : true if we try to calculate a previous or next arrow without the local specific $key record
				but iuse the generaly positional record (would be wasreful to parse everytime the Xpetal of the main gallery)
			$imgName : only passed in case of non existing $key record
				
	*/
	function minimalZmUrl($key, $acceptEdt=true, $arCmd=false, $pnArrowCase=false, $imgName='',  $unrecordedKey=''){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$rMg= &$this->rMg;
		
		if ($key===false ){
			// can't build a minimal url because of not having the descriptive xPetal file! Back on the long one!
			if ($pnArrowCase){
				// Calculate prev and next arrows in the no specific middle record situation,
				$xLeftPath= '';
				$zmPrtImgPath= false;	
				
				
				$url= $tools->urlGivenPage(_c_bigZoomPg,$arCmd);
				
				$gallPfx= $tools->getVal(_c_zmIdTxtPfx);
				if ($gallPfx===false){
					$gallPfx= $this->galleryPfx;
				}
				$url.= $tools->addUrlVar(_c_zmIdTxtPfx,$gallPfx);
				
				$originPDfn= $tools->getVal(_c_partialZImgPath);
				if ($originPDfn===false){
					// The record of the original image is defined but not its neighbor! Need to find it inside the record
					if (isset($this->zmPrtImgPath)){
						$zmPrtImgPath= $this->zmPrtImgPath;
						// x ---> parsed from the xPetal code
						// $fls->splitOnLastC($zmPrtImgPath,$xLeftPath,$xOriginImage);
					}
					$originPDfn= $zmPrtImgPath;
				}
				
				
				$fls->splitOnLastC($originPDfn,$leftPath,$originImage);
				
				if ($leftPath==='' || $leftPath===false){
					$partImgPath=  $imgName;
				}else{
					$partImgPath=  $leftPath.'/'.$imgName;
				}
				
				$buffPPh= $tools->addUrlVar(_c_partialZImgPath,$partImgPath);
				$url.= $buffPPh;
				
				if (isset($this->zmOriginPg)){
					$url.= $tools->addUrlVar(_c_zmOrigPg,$this->zmOriginPg);
				}else{
					$url.= $tools->reprodUrlVar(_c_zmOrigPg);
				}
			}else{
				// For real or screen size adaptation
				$url= $tools->urlGivenPage(_c_bigZoomPg,$arCmd);
				$url.= $tools->reprodUrlVar(_c_partialZImgPath);
				$url.= $tools->reprodUrlVar(_c_zmIdTxtPfx);
				$url.= $tools->reprodUrlVar(_c_zmOrigPg);
			}
			
			return $url;
		}
		
		if ($rMg->quickWMRight() && $acceptEdt){
			$b= $tools->urlGivenPage(_c_bigZoomPg,$arCmd) . $tools->addUrlVar(_c_idTextsZm,$key);
		}else{
			$b= _c_IndexFN._c_Interog._c_idTextsZm.'='.$key;
			if  ($tools->aay(_c_catWalkMode)===false){
				$b.= $tools->reprodUrlVar(_c_catWalkMode);	// keep an eventual cat walk state
			}
			
			if ( $tools->validOkDecomUrlVal() ){
				$tools->noTwinReprodUVar($b,_c_okDecom);
			}
		}
		return $b;
	} // minimalZmUrl
	

	/**
	*/
	function standardZmUrl($imgName, $acceptEdt=true, $arCmd=false, $pnArrowCase=false){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$key= $this->bigImgLabelKey($imgName);
		$keyExists= $dtb->elementExists(_c_idTextKey,$key,_c_idTextsTbl);
		if ($keyExists){
			$b= $this->minimalZmUrl($key,$acceptEdt,$arCmd);
 		}else{
 			// The key record does not exist ---> need to url build the missing pieces.
 			$b= $this->minimalZmUrl(false,$acceptEdt,$arCmd,$pnArrowCase,$imgName);
 		}
 		 		
		$b.= $tools->reprodUrlVar(_c_smartPhoneMode);
		$b.= $tools->reprodUrlVar(_c_statsAvoidUVar);
		return $b;
	} // standardZmUrl	
	
	/**
		previous or next arrow case
	*/
	function pnArrowStdPlusZmUrl($imgName){
		$tools= &$this->tools;
		$arCmd[_c_sortOfZoom]= true;	// true ---> we treat it directly
 		$b= $this->standardZmUrl($imgName,true,$arCmd,true);
		$b.= $tools->reprodUrlVar(_c_sortOfZoom);
		return $b;
	} // pnArrowStdPlusZmUrl

	

	/**
		Used in tg_setzlocalpath() for image ponderation
		Rem : tg_cancelImgSpSty() is the tag for end block reinitialisation
	*/
	function setXTaglocalPath(&$v,$activeTgN='z'){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$rght= &$this->rights;

		$this->curLocalPath= $tools->binLoads($v['name'],'');
		$this->zmPrtImgPath= $this->curLocalPath;
		$this->galleryPfx= substr($tools->binLoads($v['pfx'],''), 0,_c_galleryPfxMaxSz); // _c_galleryPfxMaxSz char maximum for the gallery prefix
		
		$this->zmMaxText= $tools->binLoads($v['maxtext'],_c_ok); // if oh --> use _c_idTextsTbl for large zoom description
		$this->setGlobSupStyle($v);
		
		// Empty and mark the percent Vector before using it
		$this->allowPercentVector= true;
		$this->percentVector= array();
		
		if ($rght->quickWMRight()){
			if ($this->zoomOnRealPage()){			
				if ($tools->getVal('galleryAdaptation')===_c_ok){
					$tagsFu->tagSubstitOn($activeTgN,'zsubstitute');
					$tagsFu->tagSubstitOn($this->usedImTgBreak,'bfsubstitute');
				}
			
				$helpFont= $caps->matCss('userHelpBold');
				$buff= '';
				$galAdaptUrl= $tools->urlCurPg().$tools->addUrlVar('galleryAdaptation',_c_ok);
				$imgDFn= $caps->imgSrc('gallPrcCalcul.png',_c_ok);
				$buff.= $caps->linkImg($imgDFn,$glob->el('Gallery adaptation in %','kmem'),$galAdaptUrl)._c_Ns;
				
				$galBTT= $tools->urlCurPg().$tools->addUrlVar('buildTextTmplts',_c_ok);
				$imgDFn= $caps->imgSrc('buildTextTemplates.png',_c_ok);
				$buff.= $caps->linkImg($imgDFn,$glob->el('Build the text templates','kbpa'),$galBTT)._c_BrFlux;
				
				$bGAn= $tools->getVal('galleryAdaptation');
				if ($bGAn===_c_ok){
					$url= $tools->urlCurPg();
					$buff.= _c_BrFlux;
					$buff.= $caps->hLink($url,$glob->el('Congratulation computed current gallery % adaptation','kbpb'),$helpFont);
					$buff.= _c_BrFlux;
					$buff.= _c_BrFlux;
				}
				
				$bTTs= $tools->getVal('buildTextTmplts');
				if ($bTTs===_c_ok){
					$cLg= $tools->curLgOnce();
					$lockVal= $this->tzLockVal($this->galleryPfx,$cLg);
					$url= $tools->urlCurPg();
					$buff.= _c_BrFlux;
					
					if ( $lockVal===_c_ok && !$this->alwayRewrVerbose ){
						$buff.= $caps->hLink($url,$glob->el('Not generated because of conflict with manually edited text','kbpd'),$helpFont);
					}else{
						$buff.= $caps->hLink($url,$glob->el('Congratulation you just built the text templates','kbpc'),$helpFont);
					}
					$buff.= _c_BrFlux;
					$buff.= _c_BrFlux;
				}
				
				return $buff;
			}else{
				return $caps->span($glob->el('This is the raw virtual gallery ...','kmhc'), 'imgTagsExplain')._c_BrFlux._c_BrFlux;
			}
		}
	} // setXTaglocalPath
	
	/**
		[setZLocalPath name="" /]	Sets the local path for zoomed images.
		Best to work in synergy with [cancelImgSpSty /]
	*/
	function tg_setzlocalpath(&$v,&$bd){
		$glob= &$this->glob;
		$fls= &$this->fls;
		$tools= &$this->tools;
		$parser= &$this->parser;
		
		if ($v['awrite']===_c_ok){
			$this->alwayRewrVerbose= true;
		}
		
		
		if ($v['jsvar']===_c_ok){
			// Adds a global js variable holding a random image selected inside the image directory path.
			$localPath= _c_UsrImagePath.$v['name'].'/';
			$mPath= $localPath.'micro';
			if ($fls->fileExist($mPath)){
				$rndImgPath= $mPath.'/';
			}else{
				$rndImgPath= $localPath;
			}
			
			
			$rndtype= $tools->binLoads($v['rndtype'],'png');
			$fls->firstLevelFiles($vChosenImages, $rndImgPath, true, false, $rndtype);
			$sz= sizeof($vChosenImages);
			if ($sz>=1){
				$rndIdx= rand(0,$sz-1);
				$chosenDfn= $localPath.$vChosenImages[$rndIdx];
				$jsAddition= 'var randomImageDfn=\''.$chosenDfn.'\';'._c_R;
				$glob->setHeadGlobJsCd($jsAddition);
			}
			
		}
		
		
		$this->usedImTgBreak= $tools->binLoads($v['defbr'],'bf'); // default set on old tg_bf usage.

		if ($v['invisintg']===_c_ok){	// invisInTg
			$parser->setAiiiTgZtoFalse();
		}
				
		$this->globZoomStyle= $v['globstl'];	// globStl
		return $this->setXTaglocalPath($v);
	} // tg_setzlocalpath
	
	/**
		[setJLocalPath name="" /]	Sets the local path for linked images.
	*/
	function tg_setjlocalpath(&$v,&$bd){
		return $this->setXTaglocalPath($v,'j');
	} // tg_setjlocalpath
	

	/**
		[z name="" alt="" lblBig="" /]
	*/
	function tg_z(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		$parser= &$this->parser;
		$polyglot= &$this->polyglot;
		
		
		$name= $v['name'];	// image name with extension
		$mode= $v['mode'];	// image mode
		if ($this->extractSpecificBigLbl){
			// A specific paragraph for a quick scan to extract the large label during the gallery creation mode.
			if ($this->lookingForFn===$name){
				// got it
				$this->currentGalleryBigLbl= $bd;
				$parser->stopParser();
				return '';
			}
		}

		$p= $this->curLocalPath;
		if ($p!==''){
			$p.= '/';
		}
		$dirFlName= $name;	// image name possibly given with local path from the image directory
		
		$gotPerctV= $this->loadPercentVect();
		if ($gotPerctV){
			$fls->splitOnLastC($dirFlName,$imgVal,$ext,'.');
			$curPercent= $this->percentVector[$imgVal];	// current % width
		}
		
		// Extract a possible path from the image name
		$splitState= $fls->splitOnLastC($dirFlName,$pathName,$imgName);
		if ($splitState!==false){
			$p.= $pathName.'/';
			$dFlName= $imgName;
		}else{
			$dFlName= $dirFlName;
		}
		
		$splitState= $fls->splitOnLastC($dFlName,$imgLeftDfN,$imgExt,'.');
		if ($splitState===false){
			$dFlName= $imgLeftDfN.'.jpg';	// did not find the . (dot), assumes it's a jpg
		}
		
		
		$thumbsDFn= _c_UsrImagePath.$p._c_thumbsDirN.'/'.$dFlName;
		if (!$fls->fileExist($thumbsDFn)){
			$thumbsDFn= _c_UsrImagePath.$p.$dFlName;
		}
		
		$alt= $tools->binLoads($v['alt'],$bd);
		$ttl= $tools->binLoads($v['ttl'],$alt);
		if ($ttl===''){
			$ttl= $alt;
		}
		
		$curPgName= $tools->curPageName();
		$lockId= $this->galleryLockId($curPgName);
		$lockValue= $this->getZLockVal($dtb, $lockId);
		
		if ($this->specificPost()){
			$fls->splitOnLastC($dirFlName, $path,$fileNm,'/');
		}else{
			$fileNm= $dirFlName;
		}
		
		$key= $this->bigImgLabelKey($fileNm);
		$zmOrigPgUrl= $tools->addUrlVar(_c_zmOrigPg,$curPgName);
		$largePartialDFn= $p.$dFlName;
		
		$tmplLegalClick= $tools->getVal('buildTextTmplts')===_c_ok && $rights->quickWMRight();
		$stdConditions=  $tmplLegalClick && $this->zmMaxText===_c_ok  &&  ($lockValue!==_c_zLockOk || $this->alwayRewrVerbose);
		$LegitAndDosntExist= $tmplLegalClick && !$dtb->elExists($key,_c_idTextKey,_c_idTextsTbl); // cant delete it if it does not exists
		
		if ( $stdConditions || $LegitAndDosntExist ){			
			$this->buildIdTextPg($v,$bd,$curPgName,$largePartialDFn,$key);
			
			if ($LegitAndDosntExist){
				$glob->userHelp( $glob->el('Has just created : ','kbpg').$key);
			}
			
			return '';
		}
		
		$stl= $v['stl'];
		if ($stl===false){
			$stl= $this->globZoomStyle;
		}
		
		$jsCT= '';
		if ($tools->isInCatWalk()){
			$largeDFn= _c_UsrImagePath.$p.$dFlName;
			$jsCT= $caps->jsOnclickFuCallStr('virtualTryOn.changeObjectSrc',1,0,$largeDFn);
		}
		
		$cls= $v['cls'];
		if ($stl===false && $cls===false){		
			$supStl= $v['supstl'];	// local substitute style
			if ($gotPerctV){
				$strBff= ' width:'.$curPercent.'%;'.$this->suplImThumbsStyle;
				if ($supStl===false){
					$supStl= $strBff;
				}else{
					$supStl.= $strBff;
				}
			}else{
				if ($supStl===false){
					$supStl= $this->suplImThumbsStyle;
				}else{
					$supStl.= $this->suplImThumbsStyle;
				}
			}
			
			$thumbsStyle= $caps->matStyl($dtb->getGenVar('galThbCoreStyle').$supStl);
			$smlImg= $caps->simplestImg($thumbsDFn,$alt,$thumbsStyle.$jsCT); // Manages the THUMB
		}else{
			if ($stl!==false){
				$smlImg= $caps->simplestImg($thumbsDFn,$alt, $caps->matStyl($stl).$jsCT); // Manages the THUMB
			}else{
				$smlImg= $caps->simplestImg($thumbsDFn,$alt, $caps->matCss($cls).$jsCT); // Manages the THUMB
			}
		}
		
		// #bmandAdvertQ
		$pictBm= $dtb->getGenVar('galPictRowBm');
		if ($pictBm!==false && $pictBm===_c_ok){
			$bm= $caps->bookMark($fls->fNmeNoExt($name));
		}else{
			$bm= '';
		}
		
		if ($tools->isInCatWalk()){
			return $bm.$smlImg;
		}else{
			if ($v['stay']===_c_ok){
				$url= '#';
			}else{
				if ($v['url']!==false){
					$url= $v['url'];	// imposed url! If # is passed we get the above case!
				}else{
					// Proper zoomed url to calculate
					if (!$rights->quickWMRight() && $dtb->elementExists(_c_idTextKey,$key,_c_idTextsTbl) ){
						// Not logged and idTexts exists, so just use it ( n minimalZmUrl( )
						$url= $this->minimalZmUrl($key);
					}else{
						$arCmd[_c_smartPhoneMode]=_c_ko;
						$arCmd[_c_statsAvoidUVar]=_c_ko;
						$arCmd[_c_sortOfZoom]= true;	// not the same convention as above, but same effect.
						
						$supUrl= $tools->addUrlVar(_c_zmIdTxtPfx,$this->galleryPfx);	// to store the minimum key
						$url= $this->zmPageUrl($zmOrigPgUrl, $largePartialDFn, $arCmd,$supUrl);	// **********************************
					}
					
					$url.= $tools->reprodUrlVar(_c_smartPhoneMode);
				}
			}
			
			if ($mode!=='zoomSmpl' && $mode!==false){
				// Not the default mode so carry it along!
				$url.= $tools->addUrlVar('zMode',$mode);
			}
			
			$url.= $tools->reprodUrlVar(_c_statsAvoidUVar);
			$url.= $tools->reprodUrlVar(_c_sortOfZoom);
			$url.= $tools->reprodUrlVar(_c_zmOrigPg);
			
			$target= $tools->binLoads($v['target'],'');
			$jTxt= $v['justtxt'];
			if ($jTxt===false){
				return $bm.$caps->linkTS($url,$smlImg,$ttl, ' margin:0%; padding:0%;' ,$target);
			}else{
				return $caps->linkCS($url,$jTxt,$cls,$stl, $target);
			}
		}
	} // tg_z
	

	/**
		Return the zoomed url for a given image relativelly to its original page 
		(to allow navigation toward the gallery page)
		Input :
			$zmOrigPgUrl : the original page url added
			$largePartialDFn : DFN to access the image from
			$arCmd : to avoid usr redondancy
			$urlSup : to avoid usr redondancy
	*/
	function zmPageUrl($zmOrigPgUrl, $largePartialDFn, $arCmd=false,$supUrl=''){
		$tools= &$this->tools;
		$rights= &$this->rights;


		$supUrl.= $zmOrigPgUrl;
		$supUrl.= $tools->addUrlVar(_c_partialZImgPath,$largePartialDFn);
		$arCmd['supUrl']= $supUrl;	// for an late addition to $tools->urlGivenPage(...)
		$url= $tools->urlGivenPage(_c_bigZoomPg,$arCmd);
		
		
		if ( $rights->quickWMRight() ){
			$url.= $tools->addUrlVar(_c_zmIdTxtPfx,$this->galleryPfx);	// add url idTexts prefix in connected cases
		}
		
		$url.= $this->addXUrl();
		
		$xSqrFn= $tools->getVal(_c_dsplXmSqrFlNm);
		if ($xSqrFn!==false){
			$url.= $tools->addUrlVar(_c_dsplXmSqrFlNm,$xSqrFn);
		}
	
		return $url;
	} // zmPageUrl
	
	
	/**
		Build the tags for the zommed image specific pseudo page (idTexts - page)
		
		
	*/
	function buildIdTextPg(&$v,$bd,$curPgName,$largePartialDFn,$key){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$polyglot= &$this->polyglot;
		
		
		$extractInfo= $dtb->getGenVar('zBdExtractBhOk')===_c_ok;
		$keepZmParag= $dtb->getGenVar('zDelZmParag')!==_c_ok;
		
		$alt= $tools->binLoads($v['alt'],$bd);
		$ttl= $tools->binLoads($v['ttl'],$alt);
		$mainTtl= $ttl;
		
		if ($extractInfo){
			$needle= $dtb->getGenVar('zBdExtractBehind');
			$fls->splitOnLastC($ttl,$left,$right,$needle); // just want to remove the needle and what is behind
			$ttl= $left; // shrinked title
		}

		// Loads the xPetal buffer
		$xPet= '';
		$xPet.= '[rem] '.$glob->el('Meta tags :','kmcd').' [/rem]'._c_R;
		
		
		$xPet.= '[title]'.$ttl.'[/title]'._c_R;
		$xPet.= '[descr]'.$ttl.'[/descr]'._c_R;
		
		
		$xPet.= '[lang]'.$dtb->currentLg().'[/lang]'._c_R._c_R;
		
		
		$xPet.= '[rem] '.$glob->el('Main visible title :','kmix').'[/rem]'._c_R;
		$xPet.= '[zMainTitle]'.$mainTtl.'[/zMainTitle]'._c_R;			
		
		$xPet.= _c_R;				
		$xPet.= _c_R;				
		$xPet.= '[rem] '.$glob->el('Text description in and below the large image :','kmce').'[/rem]'._c_R;
		
		$xPet.= '[zmAlt]'.$alt.'[/zmAlt]'._c_R;
		$xPet.= '[rem][code][zmLnTtl][/zmLnTtl][/code][/rem]'._c_R; // load it manually if necessary to be different from [zmAlt]
		
		if ($keepZmParag){
			$xPet.= _c_R.'[zmParag]'._c_R.$bd._c_R.'[/zmParag]'._c_R;
		}
		
		$xPet.= _c_R;				
		$xPet.= _c_R;				
		$xPet.= _c_R;				
		$xPet.= '[rem] '.$glob->el('Localisation tags :','kmcm').' [/rem]'._c_R;
		$xPet.= '[zmOrigPg]'.$curPgName.'[/zmOrigPg]'._c_R;
		$xPet.= '[zmImgPath]'.$largePartialDFn.'[/zmImgPath]'._c_R;
		
		$valV= array($key,$xPet);
		$this->setIdTextsTbl($xPet,$key,$valV);
	} // buildIdTextPg		
		
	/**
	*/
	function setIdTextsTbl($assVal,$condVal,$valV){
		$dtb= &$this->dtb;
		
		if ($this->zoomOnRealPage()){
			$dtb->setElem(_c_idTextsTbl,  _c_idTextTxt,$assVal,  _c_idTextKey,$condVal, $valV);
		}
	} // setIdTextsTbl
	
				
	/**
		Adds the forum X url part if necessary
	*/
	function addXUrl($addGPostId=true){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$url= '';
		$xIndx= $tools->getVal(_c_fxCodeIndx);
		if ($xIndx!==false){
			$url.= $tools->addUrlVar(_c_fxCodeIndx,$xIndx);
		}else{
			$rfxPage= $tools->getVal(_c_rfxPage);
			if ($rfxPage!==false){
				$url.= $tools->addUrlVar(_c_rfxPage,$rfxPage);
			}else{
				return '';
			}
		}
		
		if ($addGPostId){
			// rem $glob->curGPostId is taken during tag parsing.
			return $url.$tools->addUrlVar(_c_zmImgPostId,$glob->curGPostId);
		}else{
			return $url;
		}
	} // addXUrl
	
		
	/**
		Returns true if we are on a forum specific post instead of a neutral page or central page of a forum.
	*/
	function specificPost(){
		$tools= &$this->tools;
		
		$xIndx= $tools->getVal(_c_fxCodeIndx);
		$rfxPage= $tools->getVal(_c_rfxPage);
		return $xIndx!==false || $rfxPage!==false;
	} // specificPost

	
	/**
		[imgSupStyle stl=" width:20%" /]
		
		Warning, if we use min-width, max-width  with an heterogenous gallery leveled at the same height the
		ration between image will change when reaching the limits. So to avoid too small images on a small screen,
		just got too many on a row.
	*/
	function tg_thumbssupstyle(&$v,&$bd){
		$this->tg_imgsupstyle($v,$bd);
	} // tg_thumbssupstyle

	function tg_imgsupstyle(&$v,&$bd){
		$this->setGlobSupStyle($v);
	} // tg_imgsupstyle
	
		
	/**
		[i name="combi/sunClimbing.png" alt="" edt="ok" /]
				$this->tagsFu= &$tagsFu;
	*/
	function tg_i(&$v,&$bd){
		return $this->sImCore($v,'i',false);
	} // tg_i
	
	function tg_j(&$v,&$bd){
		return $this->sImCore($v,'j',true);
	} // tg_j
	

	/**
		Simple Image Core
		Input : $v, $tagName,
			$powerfull : give more rights outside forum space tg_j() when the forum space accepts tg_i().
	*/
	function sImCore(&$v,$tagName,$powerfull=true){		
		$asa= &$this->asa;
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$forumBar= &$asa->forumBar;
		$rights= &$this->rights;
		$xRght= &$forumBar->xRght;	// fumXRLight
		$sLightF= &$forumBar->sLightF;	// fumSuperLight
				
		if ( $v['onlywm']===_c_ok && !$rights->quickWMRight() ){
			return ''; // not a webmaster --> not allowed
		}
		
		if ( $v['onlyfu']===_c_ok && $rights->quickWMRight() ){
			return ''; // not a forum user --> not allowed (--> sugest to use the previous one more powerful by avoiding too many buttons)
		}
		
		$idNnStr= $caps->matId($v['id']);	// name attribute not allowed for images.
		$es= $v['es'];
		$name= $v['name'];	// THE IMAGE NAME
		$loc= $v['location'];
		$edt= $tools->binLoads($v['edt'],$loc);
		switch ($edt){
			case _c_ok:
				$imgDFn= _c_EditorImgPath.$name;
			break;
			
			case 'mm':
				$imgDFn= _c_decPlugSupCssC.'mm/'.$name;
			break;
			
			case 'ico':
				$imgDFn= _c_zCmsImages.'ico/'.$name;
			break;
			
			case 'combi':
				$imgDFn= _c_zCmsImages.'combi/'.$name;
			break;
			
			case 'extC':
				$imgDFn= _c_decPlugSupCssC.$name;
			break;
			
			case 'menImg':
				$imgDFn= _c_decPlugSupCssC.'menus/img/'.$name;
			break;
	
			// installer directory setting only !!
			case 'menBuild':	// images for the menu builder
				$imgDFn= _c_usrCopyPaste.'plugUsrData/explicit/central/menus/img/'.$name;
			break;
			
			// default location
			default:
				$p= $this->curLocalPath;
				if ($p!==''){
					$p.= '/';
				}
				$imgDFn= _c_UsrImagePath.$p.$name;
			break;
		} // switch
		
		
		$alt= $tools->binLoads($v['alt'],'');		
		$ttl= $tools->binLoads($v['ttl'],$alt);
		if ($ttl!==''){
			$ttl= $glob->es($ttl,$es);
		}
		
		
		$jsRaw= $v['js'];
		$search= $v['search'];
		if ($search!==false){
			$fUsrId= $sLightF->fumLogUserId();
			$spiderRes= $xRght->spiderLinks($fUsrId);
			if ( $rights->quickWMRight() || $xRght->spiderLinks($fUsrId) ){
				$replace= $v['replace'];
				$jsRaw= str_replace($search,$replace,$jsRaw);
			}
		}
		$js= $glob->jsCapsulHead.$tools->binLoads($jsRaw,'').$glob->jsCapsulTail;
		
		$pg= $v['pg'];	// the pg (xml param) is prioritar on url
		if ($pg!==false){
			$noDuP= $v['noduplicate'];	// url param that must not be duplicated
			if ($noDuP!==false){
				$noDupV= $tools->trimStoV($noDuP);
				$arCmd= array();
				reset($noDupV);
				foreach ($noDupV as $key=>$val){
					$arCmd[$val]= true; 
				}
				$url= $tools->urlGivenPage($pg,$arCmd);
			}else{
				$url= $tools->urlGivenPage($pg);
			}
		}else{
			$url= $v['url'];
		}
		
		if ($powerfull){
			// The user can define its own style etc.
			$w= $v['width'];
			if ($w!==false){
				$glob->userError( $tagName.'::width : '.$glob->el('this tag attribute is deprecated...','kmhp') );
			}
			
			$h= $v['height'];
			if ($h!==false){
				$glob->userError( $tagName.'::height : '.$glob->el('this tag attribute is deprecated...','kmhp') );
			}
			
			
			
			$gotPerctV= $this->loadPercentVect();
			if ($gotPerctV){
				$fls->splitOnLastC($name,$imgVal,$ext,'.');
				
				if (array_key_exists ($imgVal,$this->percentVector )){
					$curPercent= $this->percentVector[$imgVal];	// current % width
				}else{
					$gotPerctV= false;	// but cleaner to avoid getting there with [unsetPercAutoFit /]
				}
			}
			
			$stl= $v['stl'];
			if ($stl===false){
				$supStl= $tools->binLoads($v['supstl'], $this->suplImThumbsStyle);
				
				if ($gotPerctV){
					$supStl.= ' width:'.$curPercent.'%;';
				}
				
				if ($supStl!=='' && $supStl[0]!==' '){
					$supStl= ' '.$supStl;
				}
			}else{
				if ($gotPerctV){
					$stl.= ' width:'.$curPercent.'%;';
				}
			}
			
		}else{
			$stl= false;
			$supStl= '';
		}
		
		$ttl= $caps->matTtl($ttl);
		$cls= $v['cls'];
		
		if ($url===false){
			if ($cls!==false){
				$retImg= $caps->simplestImg($imgDFn, $alt,  $idNnStr.$ttl.$caps->matCss($cls).$js);
			}else{
				if ($stl===false){
					$imgStyle= $caps->matStyl($dtb->getGenVar('stdImgCoreStyle').$supStl);
				}else{
					$imgStyle= $caps->matStyl($stl);
				}
				$retImg= $caps->simplestImg($imgDFn, $alt,  $idNnStr.$ttl.$imgStyle.$js);
			}
		}else{
			$target= $tools->binLoads($v['target'],'');
			
			if ($stl===false){
				$imgStyle= $caps->matStyl($dtb->getGenVar('stdImgLnCoreStyle').$supStl);
			}else{
				$imgStyle= $caps->matStyl($stl);
			}
			
			$curImg= $caps->simplestImg($imgDFn, $alt, $idNnStr.$imgStyle.$js);
			$attS= $ttl;
			
			$attS.= $tagsFu->noFollRelatedStr($v);
			$retImg= $caps->hLink($url,$curImg,$attS,$target);
		}	
			
		return 	$retImg;			
	} // sImCore
	

	
	/**
		Define a transparent image.
			tg_transp() :
				[transp height="20" stl="" /]
				[transp width="20" /]
	*/
	function tg_transp(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;		
				
		$src= _c_EditorImgPath.'stop/t.png';
		$width= $tools->binLoads($v['width'],'1');
		$height= $tools->binLoads($v['height'],'1');		
		$cls= $tools->binLoads($v['cls'],'imgLnStl');
		return $caps->imageWh($src,'',$cls,$width,$height);
	} // tg_transp
	
	
	/**
	*/
	function forumLoggedAndOwnPost(){
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		$tagsFu= &$this->tagsFu;		
		
		if (array_key_exists ('shrdCd',$tagsFu->explicitClasses)){
			$shrdCd= &$tagsFu->explicitClasses['shrdCd'];
			$shrdCd->getPostedUserIds($userId,$pseudo);			
			if ($shrdCd->coreSignedIn($userId)){
				$postId= $glob->curGPostId;
				$postUsrId= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId, _c_fumFUserId);
				if ($postUsrId===$userId){
					return true;
				}else{
					return false;
				}
			}else{
				return false;
			}
		}else{
			return false;
		}
	} // forumLoggedAndOwnPost
	
	/**
		Return true if the zoom is on a real page to zoom (so for the test anything except  the page _displayXmSqrFile)
	*/
	function zoomOnRealPage(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$p= $dtb->getGenVar('urlPageVar');
		$testPg= $tools->getVal($p)!=='_displayXmSqrFile';
		$testOP= $tools->getVal(_c_zmOrigPg)!=='_displayXmSqrFile';
		return $testPg && $testOP;
	} // zoomOnRealPage
	

	/**
		Zooming anchor on a large image built with the gallery builder.
		[za pfx="aaa" imgN="bbb"] goZ [/za]
	*/
	function tg_za(&$v,&$bd){
		$caps= &$this->caps;
		
		if ($this->galleryPfx!==false){
			$pfx= $this->galleryPfx;
		}else{
			$pfx= $v['pfx'];
			$this->galleryPfx= $pfx;
		}
		
		$key= $this->bigImgLabelKey($v['imgn']);
		
		$c= $v['cls'];
		$s= $v['stl'];
		
		$url= $this->minimalZmUrl($key);
	
		return $caps->linkCS($url,$bd,$c,$s);
	} // tg_za
	
		
} // imgTags
?>