/**
	File name : inserTags.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/


function clssInserTag(){

	var txagStartVN= new Array(39);	
	var txagEndVN= new Array(39);			

	var nLn= "\n";

	/* ---
		Compulsory interface for all methods call from outside !!!!!!!!!!
	*/
	this.txtAreaAction= txtAreaAction;
	this.txtAreaAction0= txtAreaAction0;
	
	this.txtArAct= txtArAct;
	this.memoScrollBarPos= memoScrollBarPos;
	this.setScrollBarPos= setScrollBarPos;	
	
	this.initSelectVect= initSelectVect;


	/* ---
		Methods bodies :
			gTgName : given tag name
	*/


	/* ----------------------------------------------------------------------------------------------
		Mainly Insert a given tag or deal with the modification imposed by a command / action +
		other sort of action on the text area.
		
		Input i
			comboId : the combo box id
			txtArId : id of the text area to change.
			gTgName : imposed tagName or command/action when not comming from the combo box itself
			
		Standard call.
	*/
	
	// Called with an xm2 tag from _edit-file
	function txtAreaAction0(comboId, txtArId, gTgName) {
		return txtAreaActiCore(comboId, txtArId, gTgName, 'ko');
	}
	

	function txtAreaAction(comboId, gTgName) {
		var txtArId= localStorage.globCurTxtArNme;
		return txtAreaActiCore(comboId, txtArId, gTgName, 'ko');
	}


	// Call with short circuit of the combo box + imposes squarred bracket all the time
	function txtArAct(gTgName,txtArNm){
		if (kk.isUndef(txtArNm)){
			txtArNm= localStorage.globCurTxtArNme;
		}
		return txtAreaActiCore('comboStags',txtArNm,gTgName,'ok');
	}; // txtArAct
	
	
	/**
		gTgName !!!!!!!!!!!!! mainStr
	*/
	function txtAreaActiCore(comboId, txtArId, gTgName, shortCircCBox) {
		var txtArea= document.getElementById(txtArId);
		var taST= txtArea.scrollTop;	// memorise the current vertical position in the textares
		
		
		if (gTgName==='ko'){
			var comboVal= document.getElementById(comboId).value;
		}else{
			var comboVal= gTgName;
		}
		
		
		if (shortCircCBox==='ko'){
			var tagStart= txagStartVN[comboVal];
			var tagEnd= txagEndVN[comboVal];
		}else{
			var tagStart= '';
			var tagEnd= '';
		}
		
		var tagName= comboVal;
		if (txtArea.value.length == txtArea.selectionStart){
			/* The cursor is likely to have been set artificially to the end of the area, so correct it
			   Drawback : cant't insert at the tip end, rearly happens + easy to avoid + a push is not
			   really an insertion. */
			txtArea.selectionStart= this.txtArrEndInsertPos;
			txtArea.selectionEnd= this.txtArrEndInsertPos;
		}

		var startPos = txtArea.selectionStart;
		var endPos = txtArea.selectionEnd;		
		var slTxt = txtArea.value.substring(startPos, endPos);
		
		this.txtArrEndInsertPos= endPos + tagStart.length + tagEnd.length;	
		
		if (specialAction(tagName)){
			var transformedStr= transformSelStr(tagName,slTxt);
			var deltaTransformSz= transformedStr.length - slTxt.length;
		
			txtArea.value = txtArea.value.substring(0, startPos)
				+ transformedStr
				+ txtArea.value.substring(endPos, txtArea.value.length);
	    	
	    	
	    	if (simpleTag(tagName)){
		    	txtArea.selectionStart = endPos + deltaTransformSz;		
		    	txtArea.selectionEnd = endPos + deltaTransformSz;		
	    	}else{
		        txtArea.selectionStart = startPos;
		    	txtArea.selectionEnd = endPos + deltaTransformSz;
	    	}
		    	
	    		
		}else{
			txtArea.value = txtArea.value.substring(0, startPos)
				+ tagStart + slTxt + tagEnd
				+ txtArea.value.substring(endPos, txtArea.value.length);
				
			var deltaTransformSz= 0;
		}
		
		
        txtArea.scrollTop = taST;  // to stay on current position, max --> txtArea.scrollHeight;
 	} // txtAreaActiCore
	
	
	/*
		A function to call just before posting to memorize the scroll bar position.
		 js=" onsubmit=\"clssInserTag.memoScrollBarPos('bdyNm')\""
	*/
	function memoScrollBarPos(txtArNm){
		var txtArea= document.getElementById(txtArNm);		
		if (txtArea!==null){
			localStorage.mainScrollBarPosY= txtArea.scrollTop;
		}
	}; // memoScrollBarPos


	/*
		A function to recover and set the scroll bar position.
	*/
	function setScrollBarPos(txtArNm){
		var txtArea= document.getElementById(txtArNm);
		if (txtArea!==null){
			txtArea.scrollTop = localStorage.mainScrollBarPosY;
		}
	}; // setScrollBarPos


	/*
		Returns true if we have a special action (not adding someting. but changing
		the highlighted zone).
	*/
	function specialAction(act){
		return act==='upper' || 
			act==='lower' || 
			act==='change' ||
			act==='indent' ||
			act==='fullUndnt' ||
			act==='bulletList' ||
			act==='numList' ||
			act==='alphaList' ||
			act==='romanList' ||
			act==='erasesHtmlTags' ||
			act==='unindent' ||
			simpleTag(act);
	}; // specialAction
	

	function simpleTag(act){
		return act==='leftHook' ||
			act==='rightHook' ||
			act==='lessThan' ||
			act==='greaterThan';
	}; // simpleTag


	/*
	*/
	function erasesHtmlTags(str){
		var inTag= false;
		var stripped=''
		var sz= str.length;
		
		for (var i=0; i<sz; i++){
			var cn= str[i];
			var delay= false;

			switch (cn){
				case '<':
					inTag= true;
				break;
				
				
				case '>':
					inTag= false;
					delay= true;
				break;							
			} // switch

			if (!inTag && !delay){
				stripped+= cn;
			}
		} // for	
		return stripped;
	}; // erasesHtmlTags


	/*
		Transforms the selected string depending on what tag was clicked.
		... Or just button onloy functions.
	*/
	function transformSelStr(tagName,slTxt){
		switch(tagName){
			case 'upper':
				return slTxt.toUpperCase();
			break;
			
			case 'lower':
				return slTxt.toLowerCase();
			break;

			case 'change':
				return toOtherCase(slTxt);
			break;

			case 'indent':
				return indent(slTxt);
			break;

			case 'unindent':
				return unindent(slTxt);
			break;
			
			case 'fullUndnt':
				return fullUndnt(slTxt);
			break;

			case 'bulletList':
				return orderedList(slTxt,'bull');
			break;

			case 'numList':
				return orderedList(slTxt,'num');
			break;

			case 'alphaList':
				return orderedList(slTxt,'alpha');
			break;

			case 'romanList':
				return orderedList(slTxt,'roman');
			break;
			
			case 'erasesHtmlTags':
				return erasesHtmlTags(slTxt);
			break;


			case 'leftHook':
				return '[lb/]';
			break;
			
			case 'rightHook':
				return '[rb/]';
			break;
			
			case 'lessThan':
				return '[lt/]';
			break;
			
			case 'greaterThan':
				return '[gt/]';
			break;			


			default:
				alert('Error : inserTags::transfSelStr');
		}	
	}; // transformSelStr



	/*
		Input :
			str : selected string.
			kind : of list.
	*/
	function orderedList(str, kind){
		var v= str.split(nLn);
		var sz= v.length;
		var sum= '';
		
		var listComboVal= document.getElementById('comboLists').value;
				
		if (listComboVal==='listWhole' || listComboVal==='listWhlSp' || listComboVal==='listMiddle'){
			for (var i=0; i<sz; i++){
				var info= kk.trim(v[i]);
				if (info!==''){
					sum+= "\t" + '<li>' + kk.trim(v[i]) + '</li>';
					if (i<sz-1){
						sum+= nLn;
					}
				}
			}
		}
		
		// header supplement
		var hdSup= '';
		var hdSp= '';
		if (listComboVal==='listWhlSp'){
			hdSup= ' style="margin-top:0.5em; line-height:0em;"';
			hdSp= ' margin-top:0.5em; line-height:0em;';
		}
		
		switch (kind){
			case 'bull':
				var prfxTg= '<ul'+hdSup+'>';
			break;
						
			case 'num':
				var prfxTg= '<ol'+hdSup+'>';
			break;			
			
			case 'alpha':
				var prfxTg= '<ol style="list-style-type:lower-alpha;'+hdSp+'">';
			break;
			
			case 'roman':
				var prfxTg= '<ol style="list-style-type:upper-roman;'+hdSp+'">';
			break;
			
			default:
				alert('Error:orderedList 1');
		} // switch

				
		switch (listComboVal){
			case 'listWhole':
			case 'listWhlSp':
				if (kind==='bull'){
					return prfxTg +nLn + sum + '</ul>';
				}else{
					return prfxTg +nLn + sum + '</ol>';
				}
			break;
			
			case 'listMiddle':
				return sum;
			break;
			
			case 'listTop':
				return prfxTg +nLn;
			break;
			
			case 'listBottom':
				if (kind==='bull'){
					return '</ul>';
				}else{
					return '</ol>';
				}
			break;
									
			default:
				alert('Error:orderedList 2');
		} // switch
		
	}; // orderedList



	/*
	*/
	function indent(str){
		var v= str.split("\n");
		var sz= v.length;
		var sum= '';
		for (var i=0; i<sz; i++){
			sum+= "\t" + v[i];
			
			if (i<sz-1){
				sum+= "\n";
			}
		}
		return sum;
	}; // indent


	/*
	*/
	function unindent(str){
		var v= str.split("\n");
		var sz= v.length;
		var sum= '';
		for (var i=0; i<sz; i++){
			var curStr= v[i];
			var szCurStr= curStr.length;
			var fc= curStr[0];	// first char
			
			var nlPrfx= '';	// new line prefix
			if (i!==0){
				nlPrfx= "\n";
			}
									
			if ( kk.isTabable(fc) ){
				sum+= nlPrfx + curStr.substring(1);
			}else{
				sum+= nlPrfx + curStr;
			}			
		}
		return sum;
	}; // unindent


	/*
	*/
	function fullUndnt(str){
		var v= str.split("\n");
		var sz= v.length;
		var sum= '';
		for (var i=0; i<sz; i++){
			if (i!==0){
				sum+= "\n";
			}			
			sum+= kk.trim( v[i] );			
		}
		return sum;
	}; // fullUndnt


	/*
		Invert the case of the given string.
	*/
	function toOtherCase(s){
		var sz= s.length;
		var c= '';
		var d= '';
		var e= '';
		
		for (var i=0; i<sz; i++){
			c= s.charAt(i);		
			d= c.toLowerCase();
			if (d==c){
				d= c.toUpperCase();	// so changes it this time!
			}
			e= e+d;
		}
		return e;
	}; // toOtherCase


	/*
	*/
	function initSelectVect(){
		/*
			As non object code, it was generated automatically in Php and stick into the main code!
			Now got a compromise! Could as well :
				 - generate a separated js file with the php code, this would assure symetry by design!
				 - would need a generate button accessible on main frame!
				 - of course would not nee the i incrememt, would use direct indexes.
		*/
				
		// START	
		txagStartVN['zm-s']='[z name=" pathAndImageName " alt=" remark " cls="imgLnStlL" ]';
		txagStartVN['img-s']='[i name=" pathAndImageName " alt=" remark " cls="imgLnStlL" /]';
		txagStartVN['a-b']='[a url="http://www.address.xyz" cls="lnLinks" target="_blank"]';
		txagStartVN['apg']='[a url="pageName" cls="lnLinks" target="_top"]';
		txagStartVN['page']='[page name="pageName" ttl="comment" cls="lnLinks"]';
		txagStartVN['lnFont1']='lnLinks';
		txagStartVN['lnIn']='langDownF';
		txagStartVN['lnOut']='langUpF';
		txagStartVN['ttlOne']='ttlOne';
		txagStartVN['ttlTwo']='ttlTwo';
		txagStartVN['bodyText']='bodyText';
		txagStartVN['div']='[div stl="margin-left:20px; width:500px; border: 1px solid red; padding:5px;"]\r\n';
		txagStartVN['span']='[span cls="lnLinks"]';
		txagStartVN['bf']='[bf/]';
		txagStartVN['br']='[br/]';
		txagStartVN['nsp']='[nsp/]';
		txagStartVN['nbsp']='[nbsp cls="nbsp" times="8" /]  [rem]WARNING : margins and padding should be prefered to multiple non breakable spaces[/rem]';			
		txagStartVN['rem']='[rem][code]\r\n';
		txagStartVN['ul']='[ul]\r\n';
		txagStartVN['ol']='[ol]\r\n';
		txagStartVN['liStar']='[*]';
		txagStartVN['title']='[title prfx="ko"]';
		txagStartVN['descr']='[descr]';
		txagStartVN['kw']='[kw]';
		txagStartVN['stopS']='[stopSmplSurf pg="home"/]';
		txagStartVN['fStopS']='[fStopSmplSurf/]';
		txagStartVN['upper']='';
		txagStartVN['lower']='';
		txagStartVN['change']='';
		txagStartVN['indent']='';
		txagStartVN['unindent']='';
		txagStartVN['fullUndnt']='';
		txagStartVN['wrap']='';
		txagStartVN['noWrap']='';
		txagStartVN['ulh']='<ul>\r\n';
		txagStartVN['olh']='<ol>\r\n';
		txagStartVN['lih']='<li>';
		txagStartVN['bfh']='<br class="flux" />';
		txagStartVN['brh']='<br/>';
		
		
		// END
		txagEndVN['zm-s']='[/z]';
		// txagEndVN['zm-b']='[/zm]';
		txagEndVN['img-s']='';
		// txagEndVN['img-b']='[/img]';
		txagEndVN['imgdir-s']='';
		txagEndVN['oz-b']='\r\n[/oz]';
		txagEndVN['iz-b']='\r\n[/iz]';
		txagEndVN['a-b']='[/a]';
		txagEndVN['apg']='[/a]';
		txagEndVN['page']='[/page]';
		txagEndVN['lnFont1']='';
		txagEndVN['lnIn']='';
		txagEndVN['lnOut']='';
		txagEndVN['ttlOne']='';
		txagEndVN['ttlTwo']='';
		txagEndVN['bodyText']='';
		txagEndVN['div']='[/div]';
		txagEndVN['span']='[/span]';
		txagEndVN['bf']='';
		txagEndVN['br']='';
		txagEndVN['nsp']='';
		txagEndVN['nbsp']='';			
		txagEndVN['rem']='[/code][/rem]';
		txagEndVN['ul']='\r\n[/ul]';
		txagEndVN['ol']='\r\n[/ol]';
		txagEndVN['liStar']='';
		txagEndVN['title']='[/title]';
		txagEndVN['descr']='[/descr]';
		txagEndVN['kw']='[/kw]';
		txagEndVN['stopS']='';
		txagEndVN['fStopS']='';
		txagEndVN['upper']='';
		txagEndVN['lower']='';
		txagEndVN['change']='';
		txagEndVN['indent']='';
		txagEndVN['unindent']='';
		txagEndVN['fullUndnt']='';
		txagEndVN['wrap']='';
		txagEndVN['noWrap']='';
		txagEndVN['ulh']='\r\n</ul>';
		txagEndVN['olh']='\r\n</ol>';
		txagEndVN['lih']='</li>';
		txagEndVN['bfh']='';
		txagEndVN['brh']='';		
	}; // initSelectVect

	/*
	*/
	function chabl(str){
	
	}; // chabl

} // clssInserTag
