<?php
/**
	File name : inserTags.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To build the insertion tag menu.
	
	+ some general system tags
*/
class inserTags extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->caps= &$tagsFu->caps;
		$tools= &$tagsFu->tools;
		$this->tools= &$tools;
		$this->acc= &$tagsFu->acc;
		$this->hPwC= &$tagsFu->hPwC;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->parser= &$tagsFu->parser;
		$this->editTools= &$tagsFu->editTools;
			
					
		/* -----------------------------------------------------------------
			Tags declaration.
			[tagSelector name="comboStags" tagStartVn="tagStartVN" tagEndVn="tagEndVN" /]
		*/
		$tagsFu->attribVect['tagselector']= array(
			'name'			// Name and id of the corresponding select / combo-box widget.
			,'tagstartvn'	// tags-Start Vector Name
			,'tagendvn'		// tags-End Vector Name
			,'nametnv'		// vector of tag names
			
			,'linkfont'		// common font for the links
			,'lnin'
			,'lnout'
			
			,'ttlone'
			,'ttltwo'
			,'bodytext'			
			);

		$tagsFu->attribVect['callfilemg']= array('label','cls','path','el');
		$tagsFu->attribVect['listmode']= array('name');
		$tagsFu->attribVect['listsubmd']= array('name');
		$tagsFu->attribVect['bimodebutton']= array('imga','imgb','var','alt','el','statea','stateb','cls');
		
		$tagsFu->attribVect['fstparamiftacked']= array('p1','p2');
		
		// General declarations		
		$curPath= _c_toDeclPlugCntr.'inserTags/';
		$glob->addCssFile($curPath.'inserTags.css');
		$glob->coreInclStanceJs($curPath,'inserTags', 'clsInsrTag','clssInserTag');
		$glob->setGlobJsCode('clsInsrTag.initSelectVect();'._c_R._c_R);
	} // construct


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('tagselector','callfilemg','listmode','listsubmd','bimodebutton','fstparamiftacked');
	} // tags
	
		
	/**
		[biModeButton imgA="" imgB="" var="" stateA="" stateB="" /]
		
		To manage a bimode button such as :
			- 2 images depending on the state
			- 1 url and one cook variable
			- 2 values (one for each state)
			
		Detection for the tack :
			$tools->spcUTrigCook('tackMenu','tackMenu',_c_ok)
	*/
	function tg_bimodebutton(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;

		$imgA= $v['imga'];
		$imgB= $tools->binLoads($v['imgb'],$imgA);
		$var= $v['var'];	// url and one cook variable
		
		$el= $v['el'];
		$alt= $v['alt'];
		if ($el!==false){
			// el is dominant and the alt is just there to comment the X code!
			$alt= $glob->el($alt,$el);
		}
		
		$stateA= $tools->binLoads( $v['statea'], _c_ok );
		$stateB= $tools->binLoads( $v['stateb'], _c_ko );
				
		$stdImgA= $caps->stdImage($imgA,_c_ok,$alt,'eImg');
		$stdImgB= $caps->stdImage($imgB,_c_ok,$alt,'eImg');
				

		$curState= $tools->spcUTrigCook($var,$var,$stateA);
		
		$url= $tools->sameUrl();
		$piN= $tools->gostVal('pluginName');
		if ($piN!==false){
			$url.= $tools->addUrlVar('pluginName',$piN);
		}
		
		$curFnVal= $tools->getVal(_c_uVarEdtDFn);
		if ($curFnVal!==false){
			$url.= $tools->addUrlVar(_c_uVarEdtDFn,$curFnVal);
		}
		
		$cls= $tools->binLoads( $v['cls'], 'eImg' );
		if ($curState===$stateA){
			$url.= $tools->addUrlVar($var,$stateB);
			$imgAndLink= $caps->linkTC($url,$stdImgB,$alt,$cls);
		}else{
			$url.= $tools->addUrlVar($var,$stateA);
			$imgAndLink= $caps->linkTC($url,$stdImgA,$alt,$cls);
		}		
		
		// set the cookie only after a url set
		$urlState= $tools->getVal($var);
		if ($urlState===$stateA){
			$tools->spcSetCook($var,$stateA);
		}else if ($urlState===$stateB){
			$tools->spcSetCook($var,$stateB);
		}
		return $imgAndLink;
	} // tg_bimodebutton	

	
	/**
		Returns the 1st parameter if the menus are tacked and the second if the menus are untacked.
		[fstParamIfTacked p1="" p2="" /]
	*/
	function tg_fstparamiftacked(&$v,&$bd){
		$tools= &$this->tools;
		
		$tacked= $tools->tacked();		
		if ($tacked){
			return $v['p1'];
		}else{
			return $v['p2'];
		}				
	} // tg_fstparamiftacked
	
		
	/* ----------------------------------------------------------------------------
		[listMode name="comboLists" /]
		To choose and maintain a STATE for the lists.
	*/
	function tg_listmode(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		// definition of the combo box comments.
		$vSelect= array(			
			's1' =>$glob->el('List Modes','kalb')
			,'listWhole' =>$glob->el('Whole','kalc')		
			,'listWhlSp' =>$glob->el('Whole + css margin','kald')		
			,'listTop' =>$glob->el('Top','kale')	
			,'listMiddle' =>$glob->el('Middle','kalf')			
			,'listBottom' =>$glob->el('Bottom','kalg')					
			,'e1' =>''
		);
						
		$comboName= $v['name'];
		$defCmboVal= $tools->inptVal($comboName,'');		
		return $caps->comboBox($comboName,$defCmboVal,$vSelect,'',true,true);
	} // tg_listmode
	
	
	/* ----------------------------------------------------------------------------
		List sub mode.
			[listSubMd name="listSub" /]
			To choose and maintain a STATE for the lists.
		........ Deprecated, directly integrated inside tg_listmode(.....)
	*/
	function tg_listsubmd(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
			
		// definition of the combo box comments.
		$vSelect= array(			
			's1' =>'List Space'
			,'std' =>'Normal'			
			,'spec' =>'Specify'			
			,'e1' =>''
		);						

		$comboName= $v['name'];
		$defCmboVal= $tools->inptVal($comboName,'');
		
		return $caps->comboBox($comboName,$defCmboVal,$vSelect,'',true,true);
	} // tg_listsubmd

	
	/**
		[tagSelector name="comboStags" /]
	*/
	function tg_tagselector(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$f= '...';	// filler to complete parameters space
		$pN= $f.'pathAndImageName'.$f;
		$rem= $f.'remark'.$f;
		$btw= $f.'content'.$f;	// in between tags, used to separate them at the JS level.
		
		
		$linkFont= $tools->binLoads($v['linkfont'],'lnLinks');
		$lnIn= $tools->binLoads($v['lnin'],'lnIn');	
		$lnOut= $tools->binLoads($v['lnout'],'lnOut');
		$ttlOne= $tools->binLoads($v['ttlone'],'ttlOne');
		$ttlTwo= $tools->binLoads($v['ttltwo'],'ttlTwo');
		$bodyText= $tools->binLoads($v['bodytext'],'bodyText');
							
		// definition of the combo box comments.
		$vSelect= array(
			's0' =>$glob->el('Current Xml2 + some Html','kagu')
			,'e0' =>''	
			,'s90' =>'*','e90' =>''	
			,'s1' =>$glob->el('Images','kagv')
			,'zm-s' =>$glob->el('[z] Image with Zoom','kagw')
			,'img-s' =>$glob->el('[i] Simple Image'	,'kagx')
			
			
			,'s91' =>'*','e91' =>''				
			,'s3' =>$glob->el('Links','kagy')
			,'a-b' =>$glob->el('[a] External Link','kagz')
			,'apg' =>$glob->el('[a] Internal Link','kaha')
			,'page' =>$glob->el('[page] Internal Link Alias','kahb')
			,'e3' =>''
	
			,'s92' =>'*','e92' =>''		
			
			,'s8' =>'Fonts'	
			,'lnFont1' =>$glob->el('General link (','kahc').$linkFont.')'
			,'lnIn' =>$glob->el('In state (','kahd').$lnIn.')'
			,'lnOut' =>$glob->el('Out state (','kahe').$lnOut.')'
			
			,'ttlOne' =>$glob->el('Title 1 (','kahf').$ttlOne.')'
			,'ttlTwo' =>$glob->el('Title 2 (','kahg').$ttlTwo.')'
			,'bodyText' =>$glob->el('Body Text (','kahh').$bodyText.')'
			,'e8' =>''
			
			,'s93' =>'*','e93' =>''	
			
			,'s9' =>$glob->el('Subdivisions','kahi')	
			,'div' =>$glob->el('[div] side shift, frame etc.','kahj')
			,'span' =>$glob->el('[span] text formatting','kahk')
			
			,'bf' =>$glob->el('[bf/] strong break','kahl')
			,'br' =>$glob->el('[br/] weak break','kahm')
			
			,'nsp' =>$glob->el('[nsp/] non breackable space','kahn')
			,'nbsp' =>$glob->el('[nbsp /] multiple non breack space','kaho')
			
			
			
			,'e9' =>''
			
			,'s98' =>'*','e98' =>''	
			
			,'s4' =>$glob->el('Remarks'	,'kahp')
			,'rem' =>$glob->el('[rem] remark with code.','kahq')	
			,'e4' =>''
			
			,'s94' =>'*','e94' =>''			
			
			,'s5' =>$glob->el('Lists','kahr')	
			,'ul' =>$glob->el('[ul] Unordered list','kahs')
			,'ol' =>$glob->el('[ol] Ordered list','kaht')
			,'liStar' =>$glob->el('[*] List item','kahu')
			,'e5' =>''
			
			,'s95' =>'*','e95' =>''				
			
			,'s7' =>$glob->el('Meta Tags','kahv')
			,'title' =>$glob->el('[title] Browser Title','kahw')
			,'descr' =>$glob->el('[descr] Meta description','kahx')
			,'kw' =>$glob->el('[kw] Meta keywords','kahy')
			,'stopS' =>$glob->el('Stop : no PW = Redirection','kahz')
			,'fStopS' =>$glob->el('Full Stop : no PW = Empty','kaia')
			,'e7' =>''
			
			,'s80' =>'*','e80' =>''	
			
			,'s81' =>$glob->el('Text Transformations','kaib')
			,'upper' =>$glob->el('Upper Cases','kaic')
			,'lower' =>$glob->el('Lower Cases','kaid')	
			,'change' =>$glob->el('Change Cases','kaie')		
			,'indent' =>$glob->el('Indent','kaif')
			,'unindent' =>$glob->el('UnIndent','kaig')
			,'fullUndnt' =>$glob->el('Full UnIndent','kaih')
			,'e81' =>''	
			
						
			,'s96' =>'*','e96' =>''	
			
			,'s6' =>$glob->el('Some Html','kaii')
			// ,'' =>''
			
			
			,'ulh' => '&lt;ul&gt; '.$glob->el('Unordered list','kaij')
			,'olh' => '&lt;ol&gt; '.$glob->el('Ordered list','kaik')
			,'lih' => '&lt;li&gt; '.$glob->el('List item','kail')
			
			,'bfh' => '&lt;br class="flux" &gt;'
			,'brh' =>'&lt;br&gt;'
			
			,'e6' =>''
		);
						

		$tagEndVN= $tools->binLoads($v['tagendvn'],'tagEndVN');
		$nameTNV= $tools->binLoads($v['nametnv'],'tagNameVect');					
		
		$comboName= $v['name'];
		$defCmboVal= $tools->inptVal($comboName,'');
		
		$sendFm= $caps->jsFunctCallStr('onChange','clsInsrTag.txtAreaAction',2,0,$comboName,'ko');
		return $caps->comboBox($comboName,$defCmboVal,$vSelect,$sendFm,true,true);
	} // tg_tagselector	
	

	/* ---------------------------------------------------------------------------------	
		Plugin copying methods.
	*/	
	
	/**
		Copy the plugin model at the desired place (Shaping the plugin). inserTags::cpyPlugModel()
	*/
	function cpyPlugModel(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;

	
		if ($glob->cndtWrRghts===false){
			$glob->setGuestDisplay($glob->el('Create a PlugIn','kaun'));
			return '';
		}
		
		$newPlugName= $fls->safIdStr($tools->postVal('pluginName'),false,_c_largestIdSz,false);	// new name
		$centralDir= $tools->postVal('centralDir') === _c_ok;		
					
		if (file_exists(_c_toDeclPlugExt.$newPlugName)){
			$glob->userError( $glob->el('A plugin with the name ','kauo').$newPlugName.$glob->el(' already exists!','kaup') );
			return false;
		}			
				
		// Copy the file at the correct place using the $fls routines
		$expertTmpl= $tools->postVal('expertTemplate') === _c_ok;	
		$pgTmp=	_c_copyPaste.'pluginTemplate/';
		if ($expertTmpl){
			$srcPath= $pgTmp.'exampleAdvanced';
		}else{
			$srcPath=$pgTmp.'example1';
		}
		
		$destPath= substr(_c_toDeclPlugExt, 0, -1);	
		$fls->copyDirectories($srcPath,$destPath);
		
		// rename all		
		if ($centralDir){
			$newDirName= _c_toDeclPlugCntr.$newPlugName;
		}else{
			$newDirName= _c_toDeclPlugExt.$newPlugName;
		}		
		
		
		rename(_c_toDeclPlugExt.'example', $newDirName);
		$newDirName.= '/';
		
		
		$nb= $newDirName.$newPlugName;	// new base
		$newPhp= $nb.'.php';
		$newCss= $nb.'.css';
		$newJs= $nb.'.js';
		rename($newDirName.'example.php', $newPhp);
		rename($newDirName.'example.css', $newCss);
		rename($newDirName.'example.js', $newJs);
		

		// change file content		
		$this->chgFileContent($newPhp,$newPlugName,'php');
		$this->chgFileContent($newCss,$newPlugName,'css');
		$this->chgFileContent($newJs,$newPlugName,'js');
		
		
		// adapt original testfile
		$srcPathTest= _c_copyPaste.'pluginTemplate';		
		$testFileStr= $fls->fileToStr($srcPathTest.'/testFileExample1.txt');
		$testFileStr= str_replace('example',$newPlugName, $testFileStr);
		
		
		if ($centralDir){
			$testFileStr= str_replace('extPlugin', 'cenPlugin', $testFileStr);
		}		
		
		$testFileStr= '[stopSmplSurf /][up ref="t0pAll" /]'._c_R._c_R.$testFileStr;
		
		// loads the test page
		$dtb->setElem(_c_PolyCellPg, _c_pcMainStr,$testFileStr,  _c_pcId,'_test_plugin');
		// --------> _testPlugin on the other side is another plugin demo, but stable, especially for a guest demonstration !!!
	} // cpyPlugModel
		
	
	/**
		Input :
			$newCurrFN : new current directory '/' file name.
			$newPlugName : new plugin trimed name.
	*/
	function chgFileContent($newCurrFN,$newPlugName,$fileType){
		$tools= &$this->tools;
		$fls= &$this->fls;
				
		$centralDir= $tools->postVal('centralDir') === _c_ok;				
		
		$newCurrStr= $fls->fileToStr($newCurrFN);
		$newCurrStr= str_replace ('example',$newPlugName, $newCurrStr);
	
		if ($centralDir){
			$newCurrStr= str_replace('extPlugin', 'cenPlugin', $newCurrStr);
			if ($fileType==='php'){
				// str_replace($search,$replace,$subject);
				$newCurrStr= str_replace('\'debugDisplay\',true', '\'debugDisplay\',false', $newCurrStr);
			}
			
		}				
		
		$fls->strToFile($newCurrFN,$newCurrStr);
	} // chgFileContent
	

	/**
		[callFileMg label="not a directory there" cls="ln" path="extPlug" /]
		Return a url to call the file manager. Set the two paths at the same given position or use a predefined code.
			extPlug : external plugin
	*/
	function tg_callfilemg(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
		
			
		$label= $v['label'];
		if ($label===false){
			$label= $bd;
		}		
		$el= $v['el'];
		if ($el!==false){
			$label= $glob->el($label,$el);
		}
				
		$path= $v['path'];
		switch ($path){
			case 'extPlug':
				$path= _c_toDeclPlugExt;
			break;
						
			case 'central':
				$path= _c_toDeclPlugCntr;
			break;
						
			default:;
		} // switch
	
		$ar['supUrl']= '&mFilePath1='.$path.'&mFilePath2='.$path;
		$url= $tools->urlGivenPage('_file-manager',$ar);
		return $caps->hLink($url, $label, $caps->matCss($v['cls']), '_blank');
	} // tg_callfilemg	
	
	function capsSingle($s){
		return '['.$s.'/]';
	} // capsSingle

	function capsBin($s){
		return '['.$s.']';
	} // capsBin
		
} // inserTags

?>