<?php
/**
	File name : genMenTg.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	General menus tags.
	
	[setExplPlugin path="central/menus/" name="genMenTg" /]		
	genMenTg::tg_mtree()
*/
class genMenTg extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$tagsFu->genMenTgCls= &$this;
		
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
		
		$this->acc= &$tagsFu->acc;
		$this->hPwC= &$tagsFu->hPwC;
		$this->fls= &$tagsFu->fls;
		
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;
		
		$this->rights= &$tagsFu->rights;
		
		$this->parser= &$tagsFu->parser;
		$parser= &$this->parser;
		
		$this->editTools= &$tagsFu->editTools;		
		$this->polyglot= &$tagsFu->polyglot;
		$this->imgTags= &$tagsFu->imgTags;
		
		$this->advrtPlug= &$tagsFu->mainAdvertPlugIn;
		
				
		$tagsFu->attribVect[_c_tgMenUp]= array('ref','pg'); // 'ref' === 'pg'
		
		/*	
			Used to define menu arborescences, in the concerned table::field : _c_PolyCellPgM::_c_pcNecStr.
			Also uses tagsParser:callParser() on these tags holding special difficulties (high number of records and high interactions).
			--> Insert the result of the current level just behind the tag having the upperMenu name! Last level just does not
			have any defined.
			Values of the down tags :
				- open : always open
				- closed : closed if not a part of the way up! The default value! (exception 1st menu always open, logical and
				  implemented because it's string is passed 1st without the down="" attribute.
					- A practical equivalent of an always closed vould be to have a hide attribute hiding the parent button
					itself, but probably easier to hide it in the button main string part, or just to remove the call.
			Function : tg_mtree()
		*/
		$tagsFu->attribVect[_c_tgMenTree]= array('pg','down','visible');
		$tagsFu->attribVect['testariane']= array('img','steps','cls','rem');
		$tagsFu->attribVect['setmenukind']= array('img','menkind','rem','sl','cls');
		$tagsFu->attribVect['setmenudefkind']= array('img','menkind','rem','es','sl','cls');
		$tagsFu->attribVect['selandplugcurmenu']= array('forcedpg','uniksubst');
		$tagsFu->attribVect['testmenuttl']= false;
		$tagsFu->attribVect['testarianettl']= false;
		$tagsFu->attribVect['cntrlfreemenbuts']= false;	
		$tagsFu->attribVect['developmenu']= array('pg');
		
			
		define('_c_plugCntrDirMenNm', 'central/menus/');
		define('_c_menuGenPath', _c_decPlugSupCssC.'menus/');
		define('_c_menDefKind','menuDefKind');	// menu default Kind url variable


		$this->hzMenStdButNb= $dtb->getGenVar('hzMenStdButtonNb',8);
		$this->menuDefKind= $dtb->getGenVar('menuDefaultKind','vStatic');
		$this->permissMnPgPrfx= $dtb->getGenVar('permissMnPgPrfx',_c_ko);
		$this->mSwitchActiv= $dtb->getGenVar('menuSwitchActiv',_c_ok);

		$this->changeMenuKind(); // changes it eventually if asked in edit mode!

		$tools->suvPush(_c_menKind);
		$tools->suvPush('arianeOn','d');

		/*
			To graphically indicate if the menu continues down or not! Implemented only for drop down/up
			menus, because not eevrythings loaded is visible. Normally the "..." ,ark indicating a possibility
			of down surfing! Not the ariadne marks that just indicate the vertical actual position.
			
			---> uses [menBut ...  contHid="ok" /] to HIDE THE MENU CONTINUATOR in specific places, like horiz drop dropdown
			when we don't want all horiz with ...
		*/
		$this->menContin= $tagsFu->expand( $dtb->getGenVar('graphMenContinuation') );
		$this->setUpDownlimits();
	} // construct


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array(_c_tgMenUp,_c_tgMenTree,'testmenuttl','testarianettl','setmenukind','cntrlfreemenbuts','setmenudefkind', 'selandplugcurmenu','testariane','developmenu');
	} // tags
					
				
	/**
		General manager (loading the tag and parsing) for the string of the current menu button --> loads it and interpret the xpetal code.
			Input : $id id of the current menu.
	*/
	function mngMenuButtonStr($id,$upStreamTrend){
		if ($upStreamTrend){
			// Always the 1st call of a pair of calls			
			return $this->includeMenButtonRec($id,'menbut');
		}else{
			// Can be a second call or a unique call,			
			return $this->includeMenButtonRec($id);
		}
	} // mngMenuButtonStr
	
	
	/**
		Include the given menu-button record :
		  Got to :
		  	Parse the [menbut ...] tag each time
		  	Parse its environment only once --> 
		  				1st time parse everything business as usual
		  				other times : parse only [menbut ...] and ignore the surounding (do no return anything)
		  				---------> act directly on the parser 
		  					--> single tag scanning mode & passes the tag in parameter
		Input :
			$ref : the concerned reference / id
	*/	
	function includeMenButtonRec($ref,$singleTag=false, $dsplStr=false){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
	
		if ($parser->countParsings <= _c_parserMaxTimes){
			$strToParse= $dtb->getCellStr($sz,$ref,_c_PolyCellPgM,_c_pcMainStr);
			$scanStr= new scanStr($this,$strToParse, $sz, 0, false, $ref);	// the main string for the current record
			$resultParser= $parser->callParser($scanStr,$singleTag);
			return $resultParser;
		}else{
			$tools->tooManyTagsMess();
			return '';
		}
	} // includeMenButtonRec	
				
	
	/**
	*/
	function initVarMen(){
		$parser= &$this->parser;
		
		$parser->upMenRecName=false;
		$this->glTotArianeBut= '';
		$this->gotACallOnArianeB= false;
		$this->firstArianePage= false;
		
		$this->lastLevFastUp= 0;
		$this->curMenuClName= _c_ko; // none !!!
	} // initVarMen

	/**
	*/
	function getMenuStepUp(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
	
		$steps= $this->getValArianeOn();
		if ($steps!==false && $steps!=='d'){
			$curStep= (int)$steps[0];	// first number of the url indication
		}else{
			if ($tools->isInSmartPM()){
				$curStep= (int)$dtb->getGenVar('menuSPhStepUp');
			}else{
				$curStep= (int)$dtb->getGenVar('menuStepUp');
			}
		}
		return $curStep+1;
	} // getMenuStepUp

	/**
	*/
	function getMenuStepDown(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
	
		$steps= $this->getValArianeOn();
		if ($steps!==false && $steps!=='d'){
			$curStep= (int)$steps[1];	// second number of the url indication
		}else{
			if ($tools->isInSmartPM()){
				$curStep= (int)$dtb->getGenVar('menuSPhStepDown');
			}else{
				$curStep= (int)$dtb->getGenVar('menuStepDown');
			}
		}
		return $curStep;
	} // getMenuStepDown
	
	
	/**
	*/
	function setUpDownlimits(){
		$this->gnMenNbStpUpInit= $this->getMenuStepUp();	// number of allowed steps up
		$this->genMenNbStepsUp= $this->gnMenNbStpUpInit;
		
		$this->gnMenNbStpDownInit= $this->getMenuStepDown();	// number of allowed steps down
		$this->genMenNbStepsDown= $this->gnMenNbStpDownInit;
	} // setUpDownlimits
	
	

	/**
	*/
	function getMnuKind(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$sPM= $tools->isInSmartPM();
		if ($sPM){
			return 'sPM';
		}
		
		$menuForceKind= $dtb->getGenVar('menuForceKind',_c_ko);
		if ($menuForceKind===_c_ko ||  $this->gotMenuPermissPgPrfx() ){
			if ($this->mSwitchActiv===_c_ok){
				$menK= $tools->getVal(_c_menKind,$this->menuDefKind);				
			}else{
				$menK= $this->menuDefKind;
			}
		}else{
			$menK= $menuForceKind;
		}
		
		return $menK;
	} // getMnuKind
	
	
	/**
		If true --> force the menu flexibility
	*/
	function gotMenuPermissPgPrfx(){
		$tools= &$this->tools;
		
		$prfx= $this->permissMnPgPrfx;
		if ($prfx===_c_ko){
			return false;
		}
		$currenPg= $tools->curPageName();
		return $tools->sIsPrefixB($prfx,$currenPg);
	} // gotMenuPermissPgPrfx
	
	
	
	/**
		Returns true if it's necessary to force a call on the ariane buttons -->
			Editor is on && did not call it once!
	*/
	function forceArianeBut(){
		$rights= &$this->rights;
		return $rights->quickWMRight() && !$this->gotACallOnArianeB;
	} // forceArianeBut
	
		
	/**
	*/
	function getTotArianeBut(){
		return $this->glTotArianeBut;
	} // getTotArianeBut
	
	/**
	*/
	function callArianeUpBut($curUpPg){
		$tagsFu= &$this->tagsFu;
		$rights= &$this->rights;
		$parser= &$this->parser;
		
		$this->gotACallOnArianeB= true;
		$edtRght= $rights->quickWMRight();
		
		// Instanciates the arianeParsing class. The tags 'menup' 'mtree' are overloaded!!
		$v['name']= 'arianeParsing';
		$v['except']= false;
		$v['path']= false;
		$v['flag']= false;
		$tagsFu->explicitPlug($v,_c_plugCntrDN);		
		
		$arianeParsing= &$tagsFu->explicitClasses['arianeParsing'];
		$tagsFu->assignTags($arianeParsing->tags(),'arianeParsing');	// usefull in case of 2+ calls, because the tag assignation was undone and the class being still there $tagsFu->explicitPlug() just avoid doing the job!
		
		// Now 'menup' 'mtree' are asociated with the arianeParsing class!
	
		// Got to write the loop
		$lastUpPg= false;	// still none calculated, but should be a string id
		$abFlag= true;
		$totArialBut= '';
		$i= 0;
		
		while($abFlag!==false && $lastUpPg!==$curUpPg){
			if (!$edtRght && $i>0){
				$totArialBut= $currentAddition.' '._c_R.$totArialBut;	// tempo shift of 1 to avoid displaying the ultra-top in surf mode
			}
			
			$abFlag= $this->arianeUpButton($curUpPg, $htmlButtonStr,$xmlNectSc);	// arianeUpButtons() just returning the current string!!
			
			if ($edtRght){
				$totArialBut= $htmlButtonStr.' '._c_R.$totArialBut;
			}else{
				$currentAddition= $htmlButtonStr;	// loads for tempo shift
			}
			
			$phoney= $parser->callParser($xmlNectSc);
			$lastUpPg= $curUpPg;
			$curUpPg= $arianeParsing->getUpTagRef();
			$i++;
		}
		
		$this->glTotArianeBut= $totArialBut;	 // the up menus
		
		// Rehabilitates the standard assignation of 'menup' 'mtree', ASAP to avoid confusing state!
		$tagsFu->assignTags($this->tags(),'genMenTg');		// rehabilitates itsefl!!
		
		/**
			Rehabilitates useless for now because the concerned tags are not use after Ariane is called,
			But that could change, and it's cleaner this way!
		*/
		$cClN= $this->curMenuClName;
		if ($cClN!==_c_ko){
			$curMenCl= $tagsFu->instExplitCl(_c_plugCntrDirMenNm.$cClN.'/', $cClN, true);
			$tagsFu->assignTags($curMenCl->tags(), $cClN);	// rehabilitates stdMenus or ulMenus 
		}
	} // callArianeUpBut
	
	
	/**
		An ariane up button chain for huge menu to avoid spending too much ressources.Goes straight up 
		(ariane thread)).		
			Input :
				$curUpPg : current up menu page id.pointing on the bext one etc.
				
			Output :
				$htmlButtonStr	: current button string
				$xmlNectSc : the string object ready to be scanned
	*/
	function arianeUpButton($curUpPg,&$htmlButtonStr,&$xmlNectSc){
		$tagsFu= &$this->tagsFu;
		$dtb= &$this->dtb;		
		$parser= &$this->parser;

		$xmlButton= $dtb->getCellStr($sz,$curUpPg,_c_PolyCellPgM,_c_pcMainStr);
		$trimXmlBut= trim($xmlButton);
	
		$xmlButtonSc= new scanStr($tagsFu,$xmlButton,$sz,0,false,$curUpPg);	// the main string for the current record
		
		$xmlNect= $dtb->getCellStr($sz,$curUpPg,_c_PolyCellPgM,_c_pcNecStr);	// loads current level CONNEXION STRING
		if ($xmlNect!==false){
			$htmlButtonStr= $parser->callParser($xmlButtonSc);			// CURRENT BUTTON STRING
			$xmlNectSc= new scanStr($tagsFu,$xmlNect,$sz,0,false,$curUpPg);	// the connect. string for the current record
			return true;
		}else{
			return false;
		}
	} // arianeUpButton
	
	
	/**
		Special last top edit button
	*/
	function arianeLastBut($curUpPg){
		$tagsFu= &$this->tagsFu;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
		
		$bClsNm= $tagsFu->explicitTags['menbut'];
		
		$tagsFu->directPlugAss('arianeParsing');
		$tagsFu->explicitTags['menbut']= 'arianeParsing';
		
		$trmXmlBut= trim($dtb->getCellStr($sz,$curUpPg,_c_PolyCellPgM,_c_pcMainStr));
		$xmlButtonSc= new scanStr($tagsFu,$trmXmlBut,$sz,0,false,$curUpPg);	// the main string for the current record
		
		$result= $parser->callParser($xmlButtonSc);
		$tagsFu->explicitTags['menbut']= $bClsNm;	// initialised auto by following call! But just do it to be on the safe side!
		return $result;
	} // arianeLastBut
	

	/**
		Sets the going up conditions when a menUp tag is met.
		[menUp ref="upper menu" /]
		Ouput :
			$parser->upMenRecName	: used inside ulMenus::parseMen()
	*/
	function tg_menup(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		$parser= &$this->parser;
		$tagsFu= &$this->tagsFu;
				

		$ref= $v['ref'];
		if ($ref===false){
			$ref= $tools->gostVal(_c_mothrPage);
			if ($ref===false){
				$ref= _c_permanDefPage;
			}
		}
		
		$abovePg= $tools->binLoads( $ref, _c_permanDefPage );
		
		$pgId= $parser->curScanStrId;	// current page name / son	
		
		
		if (array_key_exists ($pgId,$glob->pageLevel)){
			$curLevel= $glob->pageLevel[$pgId] +1;
			$glob->pageLevel[$abovePg]=  $curLevel;	// mother got +1 on the level scale				
		}else{
			$glob->pageLevel[$abovePg]= 0;					
		}
		
		if ($abovePg!==false){
			if ($parser->upMenRecName===false && !$tagsFu->goingDownMenu){
				if ($this->genMenNbStepsUp>0){
					$this->genMenNbStepsUp--;
					$parser->upMenRecName= $abovePg;
					$this->firstArianePage= $abovePg;										
				}else{
					// Goes straight up (ariane thread)
					$buffClName= $tagsFu->explicitTags['menbut'];
					$tagsFu->explicitTags['menbut']= 'arianeParsing';	// for special ariane parsing of the tag
					$this->callArianeUpBut($this->firstArianePage);
					$tagsFu->explicitTags['menbut']= $buffClName;	// back to the previous situation
				}
								
				if (isset($glob->justMenUpVal) && $glob->justMenUpVal===true){
					$parser->stopParser();
					$glob->justMenUpVal=false;
				}
			}		
		}else{
			$glob->userError( $glob->el('No reference inside a [menup ref="menu" /] tag') );
		}
		
		return '';
	} // tg_menup	
	
	
	/**
		Parse and html activate the current level fully and if open goes down into the depending level.
		!! It's a special parsing inside _c_pcNecStr of the _c_PolyCellPgM table! Getting to that tag
		is done after meeting 'mencall', so need to start with that tag.
		Example :[mtree pg="info" down="open" /]
	*/
	function tg_mtree(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;		
		$parser= &$this->parser;
		$rgh= &$this->rights;
		
		if ($v['pg']===false){
			print('Error 1 in tagsFu::tg_t()'._c_);
			return ''; // empty not calling anything tag, give up on that one.
		}else{
			$page= $v['pg'];
		}


		/**
			Indicative to fill $glob->pageLevel even in case of invisibility
		*/
		$curPgN= $parser->curScanStrId;		// name of the current page being scanned
		$currentPgLevel= $glob->pageLevel[$curPgN];
		$subPageLevel= $currentPgLevel-1;		// Level of the $page pointed with the tag
		$glob->pageLevel[$page]= $subPageLevel;	// So the mother is ready for the next bunch of daugthers

		$visible= $tools->binLoads($v['visible'],_c_ok);		
		if ( $visible===_c_ko && !$rgh->pwCheck3() ){
			return ''; // invisible if not logged
		}
	
		
		if ($v['down']===false){
			if ($parser->forceOpenMenu){
				$down= 'open'; // force open state
			}else{
				$down= 'closed'; // default
			}
		}else{
			$down= $v['down'];
		}
		
			
		$curMTree= '';			
		$buffStr= '';			
		if ($down==='open' && !isset($parser->openedWhenGoUp[$page]) ){		
			// Goes after the downward hierachy and does not activate up tag.
			$tagsFu->goingDownMenu= true;
						
			$menuNect= '';
			if ($this->genMenNbStepsDown+$subPageLevel>0){
				$curMTree= $dtb->getElem(_c_PolyCellPgM,_c_pcId,$page,_c_pcNecStr);
				$menuNect= trim($parser->addrParseStdStr($curMTree,$page,'men'));		// INDIRECT RECURSIVITY
			}
			
			
			if ($menuNect!==''){
				$glob->gotHieraMenChildren= true;
				$curBut= $this->mngMenuButtonStr($page,false);	// get the current button display string
				
				$glob->gotHieraMenChildren= false;	// default init
			
				if ($glob->sortOfMenus==='ul'){
					$menuNect.= $this->liPadStr($curMTree,_c_Ns);
					$buffStr= $caps->elemLi($curBut._c_R.$caps->topTagUL($menuNect));	// surround the sub group of buttons.
				}else{
					if ($tools->hzSmartPhoneState()){
						$buffStr= $curBut.$menuNect;
					}else{
						$buffStr= $curBut.$caps->div($menuNect,'stdMenuIndent');
					}
				}
			}
			
			$tagsFu->goingDownMenu= false;
		}		
		
		if ($buffStr===''){
			$curBut= $this->mngMenuButtonStr($page,false);
			
			if ($glob->sortOfMenus==='ul'){
				$curBut= trim($curBut);				
				if ($curBut!==''){
					$buffStr= $caps->elemLi($curBut);
				}
			}else{
				$buffStr= $curBut;
			}
		}
		
		return $buffStr;
	} // tg_mtree
					
	
	/**
		Return the Li paddings string!
		Input :
			$rawXmStr : the full menu string to count the mTree buttons.
			$pad : the char or string to fill the supplementary menus with.
	*/
	function liPadStr(&$rawXmStr,$pad){
		$caps= &$this->caps;
		
		$menK= $this->getMnuKind();
		if ($menK==='fullHzDropDown' || $menK==='bottomHzSetUp'){
			$hzNb= $this->hzMenStdButNb;					// standard number of buttons for strictly horizontal menu.
			$nbMT= substr_count($rawXmStr,_c_tgMenTree);	// number of menu tree tags
			$nbPadLi= $hzNb-$nbMT;	// numbers of Li pads to add
			
			$totPad= '';
			for ($i=0; $i<$nbPadLi; $i++){
				$totPad.= $caps->elemLi( $caps->hLink('#',$pad) )._c_R;
			} // for
			return $totPad;
		}else{
			return '';
		}
	} // liPadStr
	

	/**
		A button for users to set the menu they want to use.
		[setMenuKind img="leftStandard.png" menKind="vStatic" rem="Standard menus" /]
			
		Rem : the difference between horiz and vert drop down is done with the style sheed, but it's still
		better to have the categorisation clearly defined here.
	*/
	function tg_setmenukind(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		if ($tools->gostVal(_c_smartPhoneMode)===_c_ok){
			return '';
		}
		
		$img= $v['img'];
		$menKind= $v['menkind'];
		
		$imgDFn= _c_decPlugSupCssC.'menus/menK/'.$img;
		if ( !file_exists($imgDFn) ){
			$imgDFn= _c_EditorImgPath.'menK/'.$img;
		}
		
		
		$curMK= $tools->getVal(_c_menKind);
		$tools->suvModif(_c_menKind,$curMK);
		$url= $tools->urlCurPg();
		$tools->suvModif(_c_menKind,_c_ko);	
		
		$url.= $tools->addUrlVar(_c_menKind,$menKind);
		
		$rem= $tools->binLoads($v['rem'],'');
		$sl= $v['sl'];	// code surf language
		$rem= $glob->sl($rem,$sl);
		
		$cls= $tools->binLoads($v['cls'],'menKindImg');
		return $caps->linkImg($imgDFn,$rem,$url,$cls,'_top',_c_ko);
	} // tg_setmenukind
	
	
	/**
		[setmenuDefKind]
	*/
	function tg_setmenudefkind(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$img= $v['img'];
		$menKind= $v['menkind'];
		
		$imgDFn= _c_decPlugSupCssC.'menus/menK/'.$img;
		if ( !file_exists($imgDFn) ){
			$imgDFn= _c_EditorImgPath.'menK/'.$img;
		}
				
		$url= $tools->urlCurPg();
		$url.= $tools->addUrlVar(_c_menDefKind,$menKind);
		
		$rem= $tools->binLoads($v['rem'],'');
		
		$sl= $v['sl'];	// code surf language
		if ($sl!==false){
			$rem= $glob->sl($rem,$sl);
		}else{
			$es= $v['es'];
			$rem= $glob->es($rem,$es);
		}
		
		$cls= $tools->binLoads($v['cls'],'menKindImg');
		return $caps->linkImg($imgDFn,$rem,$url,$cls);
	} // tg_setmenukind
	

	/**
		Actualise the set default menu kind url option.
	*/
	function changeMenuKind(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		$mDK= $tools->getVal(_c_menDefKind);
		if ( $rights->quickWMRight() && $mDK!==false ){
			$mDK= $tools->getVal(_c_menDefKind);
			$dtb->setGenVar('menuForceKind',$mDK);
		}
	} // changeMenuKind
	
		
	/**
	*/
	function isHzMenu($menK){
		$tools= &$this->tools;
		
		if ($tools->getVal(_c_smartPhoneMode)===_c_ok){
			return true;
		}
		return $menK==='sPM' || $menK==='hDropDown' || $menK==='fullHzDropDown' || $menK==='bottomSetUp' || $menK==='bottomHzSetUp';
	} // isHzMenu
	

	/**
		Returns true if $pg is inside the home page set accross languages, except in the cases of horizontzal menus.
	*/
	function inNonHzHomePgSet($pg){
		$poly= &$this->polyglot;
		$menK= $this->getMnuKind();
		return $poly->inHomePgSet($pg) && !$this->isHzMenu($menK);
	} // inNonHzHomePgSet
	
	
	/**
		Select the correct menu and adapt it with the main page content.
		[selAndPlugCurMenu /]
	*/
	function tg_selandplugcurmenu(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$rght= &$this->rights;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$poly= &$this->polyglot;
		$parser= &$this->parser;
		$imgTags= &$this->imgTags;
		
		
		$pg= $tools->curPageName();
		$menK= $this->getMnuKind();
		if (_c_replaceMostPgWithDef){
			if (defined('_c_noDefContent')){
				$mainBody= $parser->buffPgInclusion;
			}else{
				$gDefTx= $glob->st('To obtain the look of a real site ...', 'generalDefText');	// demonstration
				$mainBody= $tagsFu->expandX($gDefTx,'selAndPlugCurMenu');
			}
		}else{
			$mainBody= $parser->buffPgInclusion;
		}
		
		$imgTags->cancelImgSupStyle();
		
		
		$plugD= '';	// Main body
		$notFFT= $dtb->getGenVar('fullyFlowingText')!==_c_ok;
		if ($notFFT){
			// also see mainPlugDivFs
			$plugD= $caps->hdDiv('mainPlugDiv'.$this->addFreeStyleSuffx());
		}
		
		
		if ($menK==='sPM' && !$tagsFu->gotTitleMobBut){
			$addSPh= $dtb->getGenVar('addTopSmartPhonePg');
			$addSPh= $parser->addrParseStdStr($addSPh);
			$plugD.= $addSPh.$mainBody;
		}else{
			$plugD.= $mainBody;
		}
		
		if ($notFFT){
			$plugD.= $caps->enDiv();
		}
		
		
		if ($this->usesFullMenu()){
			// accept to deal with the full menu and loads the matching class
			$this->curMenCl= $this->selCurrentMenu(true);
		}else{
			$this->selCurrentMenu(false);
			return $plugD;
		}
		
		
		$accAriane=$dtb->getGenVar('acceptAriane');
		if ($accAriane===_c_ok){
			$curMenCl= &$this->curMenCl;
			$totArnBut= $curMenCl->totArianeButt();
		}else{
			$totArnBut= '';
		}
		
		if ($totArnBut!==''){
			$arnBut= $caps->hdDiv('menuArianeDiv');
			$arnBut.= $totArnBut;
			$arnBut.= $caps->enDiv()._c_BrFlux;
		}else{
			$arnBut= '';
		}
				
		$phLgAutoBut= $dtb->gotOkGenVar('phLgAutoButtons');
		if ($phLgAutoBut){
			// Builds the sPh & language switch button
			if ($dtb->gotOkGenVar('removeThePhone')){
				$phLgBut= '';			
			}else{
				$phLgBut= $tagsFu->mobileButton();		
			}
			
			$phLgBut.= $poly->languageSwitch();
			if ($phLgBut!==''){
				if ( $this->inNonHzHomePgSet($pg) && !$tools->isInSmartPM() ){
					$phLgBut= $caps->div($phLgBut,'languageMenuDiv');
				}else{
					$phLgBut= $caps->div($phLgBut,'languageMenuDiv2');		
				}
			}
		}else{
			$phLgBut= '';
		}
		
		$fulMenBdy= $this->adaptMenuAndLgSwitch($phLgBut);
		if ( $phLgAutoBut && !$dtb->gotOkGenVar('phLgAtBottom') ){
			$phLgButTtl= $phLgBut;
			if ($this->inNonHzHomePgSet($pg)){
				if (!$dtb->gotOkGenVar('phLgNoTitle')){
					$vect['pfx']= 'header';
					$phLgButTtl.= $tagsFu->cllPolyHeader($vect);
					$phLgButTtl= $caps->div($phLgButTtl,'menAssocTopTtl');
				}
				$phLgButTtl.= _c_BrFlux;
			}else{
				$phLgButTtl= '';
			}
		}else{
			$phLgButTtl= '';
		}
		
		$buff= '';
		switch ($menK){
			case 'sPM':
				// no "ariane" buttons
				if ($tools->hzSmartPhoneState()){
					$buff.= $plugD._c_BrFlux.$fulMenBdy;
				}else{
					$buff.= $plugD.$fulMenBdy;
				}
			break;
			
			case 'vStatic':
			case 'vDropDown':
				$buff.= $arnBut.$phLgButTtl.$fulMenBdy ._c_R. $plugD;
			break;
			
			
			// Menu on the right
			case 'rvDropDown':		// right vertical drop down
			case 'rvStatic':		// right vertical static
				$buff.= $arnBut.$phLgButTtl.$plugD._c_R.$fulMenBdy;
			break;
			
			// Menu on top (rem : $phLgButTtl included inside $fulMenBdy)
			case 'hDropDown':
			case 'fullHzDropDown':
				$buff.= $arnBut.$fulMenBdy ._c_BrFlux.$plugD;
			break;
			
			// Bottom menu (rem : $phLgButTtl included inside $fulMenBdy)
			case 'bottomSetUp':
			case 'bottomHzSetUp':
				$buff.= $plugD._c_BrFlux.$fulMenBdy._c_R.$arnBut;
			break;
			
			default: print('error in tg_selandplugcurmenu'._c_);
		} // switch
		
		$glob->stdMenuBeenCalculated= true;
		return $tagsFu->hdSupParsedXPP.$buff;
	} // tg_selandplugcurmenu
	

	/**
		Returns true if we need to use a predefined menu.
	*/
	function usesFullMenu(){
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		$rght= &$this->rights;
	
		$wmRight= $rght->quickWMRight();
		$defSurfMen= $dtb->getGenVar('acceptDefSurfMenus')===_c_ok && !$wmRight;
		
		// Two cases treated here because $glob->forceSrfMenuVisibility default value is false --> does not use it!
		$surfMenFrc= $glob->forceSrfMenuVisibility===_c_ok;		
		$surfMenForbid= $glob->forceSrfMenuVisibility===_c_ko;		
		
		$defEdtMen= $dtb->getGenVar('acceptDefEdtMenus')===_c_ok && $wmRight;
		return !$surfMenForbid && $defSurfMen || $surfMenFrc || $defEdtMen;
	} // usesFullMenu
	
	
	/**
		Adapt the concerned full menu with the language switch an its smart phone button.
	*/
	function adaptMenuAndLgSwitch(&$phLgBut){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$curMenCl= &$this->curMenCl;
		$poly= &$this->polyglot;
		
		$fulMBdy= $curMenCl->menuFullBdy();
		$pg= $tools->curPageName();
		
		$menK= $this->getMnuKind();
		switch ($menK){
			case 'sPM':
				// smart phone menu, deal with the position of the phone mode & language choice
				if ($tools->hzSmartPhoneState()){
					$fulMBdy= $phLgBut.$fulMBdy;
				}else{
					$fulMBdy= $fulMBdy._c_BrFlux.$phLgBut;
				}
				
			break;
			
			// Vertical menus
			case 'vStatic':
			case 'vDropDown':
			case 'rvDropDown':		// right vertical drop down
			case 'rvStatic':		// right vertical static
				if ($dtb->gotOkGenVar('phLgAtBottom') || !$this->inNonHzHomePgSet($pg)){
					$fulMBdy= $fulMBdy._c_BrFlux.$phLgBut;
				}
			break;
			
			// Horizontal menus
			case 'hDropDown':
			case 'fullHzDropDown':
			case 'bottomSetUp':
			case 'bottomHzSetUp':
				if (!$this->inNonHzHomePgSet($pg)){
					$fulMBdy= $phLgBut.$fulMBdy;
				}
			break;
			
			default: 
				$fulMBdy= $fulMBdy;
			break;
		} // switch	

		$fulMenBdy= '';
		if ($menK==='sPM' && $tools->hzSmartPhoneState()){
			if ( $dtb->gotOkGenVar('hzBotSphMenDiv') ){
				$fulMenBdy.= $caps->hdDiv('hzBotSphMenDivStl');
				$fulMenBdy.= $fulMBdy;
				$fulMenBdy.= $caps->enDiv();
				$fulMenBdy.= $caps->htmlComment('hzBotSphMenDivStl');
			}else{
				$fulMenBdy.= $fulMBdy;
			}
		}else{
			$fulMenBdy.= $caps->hdDiv('menuMainDiv'.$this->addFreeStyleSuffx()); // or menuMainDivFs
			$fulMenBdy.= $fulMBdy;
			$fulMenBdy.= $caps->enDiv();
		}

		return $fulMenBdy;
	} // adaptMenuAndLgSwitch
	
	/**
		Calls a special tag suffix when the pages wants no adverts 
		and we are in a vertical menu paradigm (to avoid wasting place).
		$this->addFreeStyleSuffx() 
			for menuMainDivFs and mainPlugDivFs  ... til now only available with desk CSS hand addition
	*/
	function addFreeStyleSuffx(){
		$advrtPlug= &$this->advrtPlug;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			return 'Fs';
		}
		
		if ($advrtPlug===false){
			return 'Fs';
		}
		
		if ($advrtPlug!==false 
			&& ( $advrtPlug->onForbidPgVertPos() 
				|| !$advrtPlug->boolVerticalLatch() 
				|| $advrtPlug->sorryNoVerticalAds ) ){
		
		
			return 'Fs';
		}else{
			return '';
		}
	} // addFreeStyleSuffx
	

	/**
		Select the class to apply to the current menu if $instAndComp===true otherwise just declares the CSS.
			Input :
				$instAndComp : instanciates the class and computes the menu.
			Output :
				if $instAndComp===true : Instanciates $curMenCl and returns $curMenCl
	*/
	function selCurrentMenu($instAndComp){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;		
		
		
		$menK= $this->setMenKindAndCss();
		switch ($menK){
			case 'sPM':
			case 'vStatic':
			case 'rvStatic':
				if ($menK==='sPM'){
					if ($tools->hzSmartPhoneState()){
						$glob->addCssFile(_c_menuGenPath._c_hzSmartPhMenName);
					}else{
						$glob->addCssFile(_c_menuGenPath._c_vertSmartPhMenName); // original vertical
					}
				}else if ($menK==='vStatic'){
					$glob->addCssFile(_c_menuGenPath.'stdMenus/stdMenus.css');
				}else{
					$glob->addCssFile(_c_menuGenPath.'stdMenus/stdMenusRight.css');
				}

				if ($instAndComp){
					$curMenCl= $tagsFu->instExplitCl(_c_plugCntrDirMenNm.'stdMenus/', 'stdMenus', true);
					$this->curMenuClName= 'stdMenus';
					$curMenCl->stdMenuComputes();
				}
			break;

			default: 
				$glob->addCssFile(_c_menuGenPath.'ulMenus/'.$menK.'.css');
				if ($instAndComp){
					$curMenCl= $tagsFu->instExplitCl(_c_plugCntrDirMenNm.'ulMenus/', 'ulMenus', true);			
					$this->curMenuClName= 'ulMenus';
					$curMenCl->dropMenuComputes();
				}
			break;
		} // switch
		
		if ($instAndComp){
			return $curMenCl;
		}
			
	} // selCurrentMenu
	
		
	/**
	*/
	function setMenKindAndCss(){
		$glob= &$this->glob;
	
		$menK= $this->getMnuKind();
		if ($menK==='sPM' || $menK==='vStatic' || $menK==='rvStatic' || $menK==='vDropDown' || $menK==='rvDropDown'){
			$glob->addCssFile(_c_menuGenPath.'genMenus.css');
		}else{
			$glob->addCssFile(_c_menuGenPath.'genMenusHzDD.css');
		}
		
		return $menK;
	} // setMenKindAndCss
		
	


	/**
		[testAriane /]
		[testAriane img="reel.png" arianeOn="ok" /]
	*/
	function tg_testariane(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$img= $v['img'];
		$steps= $v['steps'];
		$rem= $v['rem'];
		
		$imgDFn= _c_decPlugSupCssC.'menus/menK/'.$img;
		if ( !file_exists($imgDFn) ){
			$imgDFn= _c_EditorImgPath.'menK/'.$img;
		}
		
				
		$url= $tools->urlCurPg();
		$url.= $tools->addUrlVar('arianeOn',$steps);
		
		
		$cls= $tools->binLoads($v['cls'],'menKindImg');
		return $caps->linkImg($imgDFn,'Menu up/down : '.$rem,$url,$cls);
	} // tg_testariane


	/**
	*/
	function getValArianeOn(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$frc= $dtb->getGenVar('menuFrcArianeOnD');
		if ($frc===_c_ok){
			$steps= 'd';
		}else{
			$steps= $tools->getVal('arianeOn');
		}
		return $steps;
	} // getValArianeOn


	/**
		[testMenuTtl /]
	*/
	function tg_testmenuttl(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$at= $glob->sl('Menus Test:','kacs');
		$alt= $glob->sl('Different menus tested ...','kact');
		return $caps->spanTtl($at, 'menuGenTitle', $alt);
	}

	/**
		[testArianeTtl /]
	*/
	function tg_testarianettl(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$at= $glob->sl('Ariadne Test: ','kacq');
		$alt= $glob->sl('Sets the visible part of the menu from ...','kacr');
		return $caps->spanTtl($at, 'menuGenTitle',$alt);
	}

		
	/**
		To calculate quickly with a fast up algorithm the vertical positions of each menu Ids.
			Positions are stored inside the array $glob->pageLevel[$pgId]
			The top visible layer is determined with ulMenus::isTopVisibleLevel($pgId)
		Remark : this method is not used by the class stdMenus, but is still here (genral definition) because it could
		be used in the future and because moving it into ulMenus is difficult.
	*/
	function calcUpLevel($curUpPg){
		$tagsFu= &$this->tagsFu;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
				
		$this->fastUp= $tagsFu->instExplitCentralCls('menuFastUp');
		$fastUp= &$this->fastUp;
		
		$tagsFu->assignTags($fastUp->tags(),'menuFastUp');	// usefull in case of 2+ calls, because the tag assignation was undone and the class being still there $tagsFu->explicitPlug() just avoid doing the job!
		// Now 'menup' 'mtree' are asociated with the menuFastUp class!
		
		// Start the fast Up process
		$xmlNect= $dtb->getCellStr($sz,$curUpPg,_c_PolyCellPgM,_c_pcNecStr);
		$xmlNectSc= new scanStr($tagsFu,$xmlNect,$sz,0,false,$curUpPg);
		$bid= $parser->callParser($xmlNectSc);
		
		$this->lastLevFastUp= $fastUp->lastLevelVal();		
		
		// Rehabilitates the standard assignation of 'menup' 'mtree', ASAP to avoid confusing state!
		$tagsFu->assignTags($this->tags(), 'genMenTg');			// rehabilitates itsefl!!
		
		$cClN= $this->curMenuClName;
		
		$curMenCl= $tagsFu->instExplitCl(_c_plugCntrDirMenNm.$cClN.'/', $cClN, true);
		$tagsFu->assignTags($curMenCl->tags(), $cClN);	// rehabilitates stdMenus or ulMenus
		
		return $fastUp->lastLevelVal();	// $latLvFastUp	
	} // calcUpLevel	
		
	
	/**
		To display the sort of menus buttons only they are allowed! : menuForceKind === ko
		[cntrlFreeMenButs]
		.................
		[/cntrlFreeMenButs]
	*/
	function tg_cntrlfreemenbuts(&$v,&$bd){
		$dtb= &$this->dtb;
		
		if ($dtb->getGenVar('menuForceKind')===_c_ko){
			return $bd;	// free menu switchs
		}else{
			return ''; // hides the buttons
		}
	} // tg_cntrlfreemenbuts
		
	
	/**
		[developMenu pg="" /]
	*/
	function tg_developmenu(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		
		$this->genMenNbStepsUp= 1000;	// number of allowed steps up
		$this->genMenNbStepsDown= 1000;	// number of allowed steps down
		$stdMen= $tagsFu->instExplitCl('central/menus/stdMenus/', 'stdMenus', true);
		$kindMen= $dtb->getGenVar('menuForceKind');
		if ($kindMen!=='vStatic'){
			$glob->addCssFile(_c_decPlugSupCssC.'menus/stdMenus/stdMenus.css');
		}
		
		$menuId= $v['pg'];
		return $stdMen->parseMenus($menuId,true);
	} // tg_developmenu	
	
	
} // genMenTg

?>
