<?php
/**
	File name : stdMenus.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	General menus tags.
	
	[cenPlugin path="menus/stdMenus" name="stdMenus" /]
	[menCall /]
*/
class stdMenus extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->acc= &$tagsFu->acc;
		$this->hPwC= &$tagsFu->hPwC;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->rights= &$tagsFu->rights;	// rightsMg
		$this->parser= &$tagsFu->parser;
		$parser= &$this->parser;
		
		$this->editTools= &$tagsFu->editTools;
		$this->simpleMenStr= &$tagsFu->simpleMenStr;

										
		// tg_mencall() : Calls the menu matching the current page (most of the time called from a top surrounding page)
		$tagsFu->attribVect['menucomputes']= array('pg');	// facultative argument to specify another.page	
		$tagsFu->attribVect['menufullbody']= false;
		$tagsFu->attribVect['menuarianebuttons']= false;
		
		//  tg_menbut(), Display or highlight the given text when the specified page is active (default param = current page).
		$tagsFu->attribVect[_c_tgMenBut]= $glob->menButAttribV;
		
		$this->menuStdFullBody= '';
		
		$this->genMenTg= &$tagsFu->explicitClasses['genMenTg'];	
		// $this->genMenTg= $tagsFu->instExplitCl('menus/','genMenTg',true,_c_toDeclPlugCntr);
		$parser->buttonSubTreeStr= array();
	} // construct


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('menucomputes','menufullbody','menuarianebuttons','menbut');
	} // tags
	

	/**
		Calls the FULL standard menu matching the current page. Normal calls done from a top page.
		[menuComputes /]	Calculs all and display only the ariane part
	*/
	function tg_menucomputes(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;	
		$rights= &$this->rights;
		$genMenTg= &$this->genMenTg;
		$tagsFu->genMenTgCls= &$genMenTg;
		
		if ($v!==NULL && $v['pg']!==false){
			$menuId= $v['pg'];	// an imposed name as start page for a menu (uncommon)
		}else{
			$menuId= $tools->getUrlPageName();
		}
		
		$glob->sortOfMenus= 'def';
		$this->menuStdFullBody= $this->parseMenus($menuId);		// Full Body standard menu
		
		if ($genMenTg->forceArianeBut()){
			if ($genMenTg->firstArianePage!==false){
				$htmlButtonStr= $genMenTg->arianeLastBut($genMenTg->firstArianePage);
				$this->totArianeButtons= $htmlButtonStr;
			}else{
				$this->totArianeButtons= '';	// editor only full top of menu, can't go higher, so no ariane either!
			}
		}else{
			$this->totArianeButtons= $genMenTg->getTotArianeBut();	// Full Ariane
		}
	} // tg_menucomputes
	
	/**
		list .. irelevant detail --> missed by left --> supress it!
		$this->stdMenuComputes();
	*/
	function stdMenuComputes($pg=false){
		$v['pg']= $pg; $bd= '';
		return $this->tg_menucomputes($v,$bd);
	} // stdMenuComputes
	
	
	/**
		[menuFullBody /]
	*/
	function tg_menufullbody(&$v,&$bd){
		return $this->menuFullBdy();		// Full Body
	} // tg_menufullbody

	// Just an abstraction level so it's easily called outside the tag/parsing paradygme.
	function menuFullBdy(){
		return $this->menuStdFullBody;	// Full Body
	} // menuFullBdy
	
	
	/**
		[menuArianeButtons /]
	*/
	function tg_menuarianebuttons(&$v,&$bd){
		return $this->totArianeButt();	// Full Ariane buttons
	} // tg_menuarianebuttons

	// Just an abstraction level so it's easily called outside the tag/parsing paradygme.
	function totArianeButt(){
		return $this->totArianeButtons;	// Full Ariane buttons
	} // totArianeButt


	/**
		Menu parsing with up and down parsing.
		A surrounding function to do a proper return.
	*/
	function parseMenus($menuId,$forceOpen=false){
		$glob= &$this->glob;
		$dtb= &$this->dtb;	
		$parser= &$this->parser;
		$genMenTg= &$this->genMenTg;
		
		$genMenTg->initVarMen();
		
		if ($glob->gotActStopSmplSurf || !$dtb->elementExists(_c_pcId, $menuId, _c_PolyCellPg)){
			$menuId= _c_mainHomePage;
		}
		
		// Resset the Globally defined menu variables to avoid interference when having multiple menu calls
		$parser->buttonSubTreeStr= array();
		$parser->openedWhenGoUp= array();
		$parser->upMenRecName= false;
		$parser->topSubTreeId= _c_mainHomePage;	// a formal value, but could as well be init with ''
		
		$parser->forceOpenMenu= $forceOpen;
		
		// <--- Does the job here !!! Set the level 0 matches the clicked page level (down-- up++)
		$this->parseMen($menuId,0);	
		
		return $parser->buttonSubTreeStr[$parser->topSubTreeId];	// the only returned structure !!
	} // parseMenus
	
	
	/**
		Menu parsing with up and down parsing.
		Input : 
			$menuId the menu Id where the scan starts
						
		Globally defined variables for the communication between this method and a few tags :
			$parser->but tonSubTreeStr, $parser->upMenRecName, $parser->openedWhenGoUp[$menuId], $parser->topSubTreeId
			
		>parseMen(
	*/	
	function parseMen($menuId,$level){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;		
		$dtb= &$this->dtb;		
		$parser= &$this->parser;
		$rMg= &$this->rights;
		$gTg= &$this->genMenTg;
		
		
		$parser->upMenRecName= false;
		$parser->openedWhenGoUp[$menuId]= true;
		
		// Sets the mother level for [menup ../]  and  [mtree ../] (glob var just before the call)
		$glob->pageLevel[$menuId]= $level;	// 0 on 1st call
	
		// loads current button
		$xmlNect= $dtb->getCellStr($sz,$menuId,_c_PolyCellPgM,_c_pcNecStr);	// loads CURRENT level connexion string
		if ($sz===0){
			return;
		}

		$xmlNectSc= new scanStr($tagsFu,$xmlNect,$sz,0,false,$menuId);	// the connect. string for the current record
		$buff= trim($parser->callParser($xmlNectSc));	// placed before callParser($xmlButtonSc) so can get terminal deepness information!
		
		// Build the sub-buttons level, also see $parser->upMenRecName
		$gotUpMenu= $parser->upMenRecName!==false;	// True if we got an upMenu button, used to detect the top menu pseudo button
		
		// Indent or top menu condition		
		$indentOrTopBut= ( $rMg->quickWMRight() && $tools->gostVal(_c_surfEdt)===_c_seEditVal )  || $gotUpMenu;
		if ($buff!==''){
			if($glob->divMen===_c_ok){
				if ($indentOrTopBut){
					if ($tools->hzSmartPhoneState()){
						$htmlNectStr= $buff; 
					}else{
						$htmlNectStr= $caps->div($buff,'stdMenuIndent');
					}
				}else{
					$htmlNectStr= $buff;
				}
				
			}else{
				$htmlNectStr= $buff;				
			}
		}else{
			$htmlNectStr= '';
		}
		
		/**
			If set, to be used in priority in tg_ menbut(), therefore sub-tree inclusion done with this glob
			variable, and we just have to look for the above Id and call $this->parseMen()
		*/
		if ($indentOrTopBut){
			$glob->gotHieraMenChildren= true;
			
			/*
				Either the current button or a button upstream
			*/
			$htmlButtonStr= $gTg->mngMenuButtonStr($menuId,true);	
			
			$glob->gotHieraMenChildren= false;
			$parser->buttonSubTreeStr[$menuId]= $htmlButtonStr.$htmlNectStr;
		}else{
			$parser->buttonSubTreeStr[$menuId]= $htmlNectStr;
		}
		
		if ($gotUpMenu){
			$level++;
			$this->parseMen($parser->upMenRecName,$level);		// RECURSION up from the current buttons.
		}else{
			// no more up tag, so got the top button sub-tree
			$parser->topSubTreeId= $menuId;			
		}
	} // parseMen


	/**
		[menbut /] Manages one menu button appearance + eventual subtree!!!
		Added explicit display of the full menu when editing.
	*/
	function tg_menbut(&$v,&$label){
		$gTg= &$this->genMenTg;
		$glob= &$this->glob;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
		$simpleMenStr= &$this->simpleMenStr;
		
		/**
			Important remark : precedently $newPage was set with $newPage= $v['pg']; but this introduce
			hierachical incoherence when a menu got a pg parameter that direct on another page. Note that
			$v['pg'] is always redondant except when it leads onto another page.
		*/
		$newPage= $parser->curScanStrId;
		
		
		if ( isset($parser->buttonSubTreeStr[$newPage]) && $parser->buttonSubTreeStr[$newPage]!=='' ){
			$str= $parser->buttonSubTreeStr[$newPage];	// Sub-tree inclusion
		}else{
			
			if (!$glob->gotHieraMenChildren){
				$belowLimNectStr= $dtb->getElem(_c_PolyCellPgM, _c_pcId,$newPage, _c_pcNecStr);
				
				// Function disabled parsing just to know what tags are inside the page so we can know if the button got sub-buttons or not !!
				$parser->fuCallingOn= false;
				$parser->addrParseStdStr($belowLimNectStr,$newPage,'men');
				$parser->fuCallingOn= true;
				
				if (array_key_exists(_c_tgMenTree,$parser->globMetTags)){
					$label.= $gTg->menContin;
				}
			}
			
			$str= $simpleMenStr->buttonVisStr($v,$label);
		}
		
		return $str;
	} // tg_menbut
	
	
} // stdMenus
?>