<?php
/**
	File name : ulMenus.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Used for CSS drop down menu style (bit of JS for old IE6.
	
	Some menu possibilities :
	
		Ergonomic :
			hvd : Horizontal then Vertical drop Down (classic) :
			hhd : Horizontal Horizontal drop Down (nice change but easy to get out of the screen)
			vvr : Vertical then Vertical  toward thee Right (classic) :

		Hard to build :
			rot : Rotations arround a circular/partially circular object

		Odd :		
			vvl :Vertical then Vertical  toward thee Left
			hvu : Horizontal then Vertical push Up (invisible with long pages, except if starting 
					from the bottom of the page, for people who like to look at the end of a document first! :-) ).
		
		Improvment : 
			-The sort of menu is completly defined in JS. The class ulMenus jsut does the transformation of the
			table-linked menus into the <ul><li>... </li></ul> tree. Could try to have an only div representation, but
			bit harder to build je JS file.
			- Could have a css class version with a indicated path toward the displayed page/menu, would be easier with
			div only menus.
			
			
	[setExplPlugin path="ulMenus/" name="ulMenus" /]
	[setExplCss path="ulMenus/" css="ulMenus" /]			
			
			
	ulMenus::foldableMen
	$this->latLvFastUp
	
	
	ulMenus::wordFold()
*/
class ulMenus extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
			
		$this->caps= &$tagsFu->caps;
		$this->dtb= &$tagsFu->dtb;		
		$dtb= &$this->dtb;

		$this->rights= &$tagsFu->rights;
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
			
		$this->parser= &$tagsFu->parser;		
		$this->acc= &$tagsFu->acc;		
		$this->fls= &$tagsFu->fls;		
		$fls= &$this->fls;
		
		$this->genMenTg= &$tagsFu->explicitClasses['genMenTg'];
		$genMenTg= &$this->genMenTg;
				
		$tagsFu->attribVect['ldropmenucomputes']= array('pg');
		
		$tagsFu->attribVect['ldropmenufullbody']= false;
		$tagsFu->attribVect['ldropmenuarianebut']= false;
		
		$tagsFu->attribVect[_c_tgMenBut]= $glob->menButAttribV;

		$this->onTopMenuButton= false;
		$glob->upMenRecName= '';
		$this->menuFullBody= '';
		
		if ($dtb->getGenVar('jsCmplForDdm')===_c_ok){
			$jsAddition= $fls->fileToStr(_c_ThirdParty.'ulMenus/ddm.js');
			$glob->setGlobJsCode($jsAddition);
		}
		
		$this->ariadneBmkWidth=false;	// to store the width of the ariane-menu-icon
		
		$this->iaButNm= $dtb->getGenVar('internalArianeButton');
		$this->markSrc= _c_decPlugSupCssC.'menus/ulMenus/'.$this->iaButNm;
		$this->marlImgExists= $fls->fileExist($this->markSrc);
	} // construct


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('ldropmenucomputes','ldropmenufullbody','ldropmenuarianebut','menbut');
	} // tags



	/**
		[lDropMenuComputes /] : U List drop menu Computes the full menu!
	*/
	function tg_ldropmenucomputes(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;	
		$parser= &$this->parser;
		$genMenTg= &$this->genMenTg;
		
		$curUpPg= $tools->curPageName();
		$genMenTg->calcUpLevel($curUpPg);

		$fastUp= &$genMenTg->fastUp;
		$latLvFastUp= $fastUp->lastLevelVal();
		
		$this->latLvFastUp= $latLvFastUp;
		$this->levelWidthV= $this->adaptMaxDdV($latLvFastUp);
		$parser->ignoresScanLvlOne();
		$glob->sortOfMenus= 'ul';
		if ($v!==NULL && $v['pg']!==false){
			$menuId= $v['pg'];	// an imposed name as start page for a menu (uncommon)
		}else{
			$menuId= $tools->getUrlPageName();
		}
				
		$parser->imposeScanDefLevel();
		$this->menuFullBody= $this->parseMenus($menuId);	// Full MENU Body
				
		if ($genMenTg->forceArianeBut()){
			if ($genMenTg->firstArianePage!==false){
				$htmlButtonStr= $genMenTg->arianeLastBut($genMenTg->firstArianePage);
				$this->totArianeButtons= $htmlButtonStr;
			}else{
				$this->totArianeButtons= '';	// editor only full top of menu, can't go higher, so no ariane either!
			}
		}else{
			$this->totArianeButtons= $genMenTg->getTotArianeBut();	// Full Ariane
		}
	} // tg_ldropmenucomputes
	
	/**
		list .. irelevant detail --> mised by left --> supress it!
		$this->dropMenuComputes();
	*/
	function dropMenuComputes($pg=false){
		$v['pg']= $pg; $bd= '';
		return $this->tg_ldropmenucomputes($v,$bd);
	} // dropMenuComputes
	
	
	/**
		[lDropMenuFullBody /]
	*/
	function tg_ldropmenufullbody(&$v,&$bd){
		return $this->menuFullBdy();	// Full Body!
	} // tg_ldropmenufullbody
	
	// Just an abstraction level so it's easily called outside the tag/parsing paradygme.
	function menuFullBdy(){
		return $this->menuFullBody;	// Full Body
	} // menuFullBdy
	
	
	/**
		[lDropMenuArianeBut /]
	*/
	function tg_ldropmenuarianebut(&$v,&$bd){
		return $this->totArianeButt();	// Full Ariane buttons
	} // tg_ldropmenuarianebut
	
	// Just an abstraction level so it's easily called outside the tag/parsing paradygme.
	function totArianeButt(){
		return $this->totArianeButtons;	// Full Ariane buttons
	} // totArianeButt

	
	
	/* -----------------------------------------------------------------------------------------------------
		Special menu List parsing : almost identical to the one defined under the parser, but could become 
		more different if displayed partially (so with a static complement) because iof too large number of pages.
		Note : a lot of the difference is implemented under tagsFu::tg_mtree().
	*/
	

	/**
		Menu parsing with up and down parsing.
		A surrounding function to do a proper return.
	*/
	function parseMenus($menuId,$forceOpen=false){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;	
		$parser= &$this->parser;
		$genMenTg= &$this->genMenTg;
		
		$genMenTg->initVarMen();


		if ($glob->gotActStopSmplSurf || !$dtb->elementExists(_c_pcId, $menuId, _c_PolyCellPg)){
			$menuId= _c_mainHomePage;
		}

		// Reset the Globally defined menu variables to avoid interference when having multiple menu calls
		$parser->buttonSubTreeStr= array(); // also $parser->buttonSubTreeStr= array();
		$parser->openedWhenGoUp= array();
		$parser->upMenRecName= false;
		$parser->topSubTreeId= _c_mainHomePage;	// a formal value, but could as well be init with ''
		$parser->forceOpenMenu= $forceOpen;
		
		$this->parseMen($menuId,0);		// Main Call !!
		$tId= $parser->topSubTreeId;
				
		if ( array_key_exists($tId,$parser->buttonSubTreeStr) ){
			return $parser->buttonSubTreeStr[$tId];
		}else{
			return '';
		}		
	} // parseMenus
	
	
	/**
		Menu parsing with up and down parsing.
		Input : 
			$menuId the menu Id where the scan starts
						
		Globally defined variables for the communication between this method and a few tags :
			$parser->buttonSubTreeStr
			$parser->upMenRecName
			$parser->openedWhenGoUp[$menuId]
			$parser->topSubTreeId
	*/
	function parseMen($menuId,$level){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;		
		$parser= &$this->parser;		
		$rights= &$this->rights;		
		$genMenTg= &$this->genMenTg;
				
		$glob->upMenRecName= $parser->upMenRecName;
		$parser->upMenRecName= false;
		$parser->openedWhenGoUp[$menuId]= true;
		
		$glob->pageLevel[$menuId]= $level;	// 0 on 1st call
		
		// loads current button
		$xmlButton= $dtb->getCellStr($sz,$menuId,_c_PolyCellPgM,_c_pcMainStr);
		$xmlButtonSc= new scanStr($tagsFu,$xmlButton,$sz,0,false,$menuId);	// the main string for the current record
				
		// loads connexion string
		$xmlNect= $dtb->getCellStr($sz,$menuId,_c_PolyCellPgM,_c_pcNecStr);
		if ($sz===0){
			return;
		}
		
		$buff= '';
		$htmlButtonStr= '';
		
		$xmlNectSc= new scanStr($tagsFu,$xmlNect,$sz,0,false,$menuId);	// the connect. string for the current record
		
		$gotSubMenus= $tools->sIsInB('[mtree ',$xmlNect);
		if ($gotSubMenus){
			$glob->gotHieraMenChildren= true;
		}
		$htmlButtonStr= $parser->callParser($xmlButtonSc);	// Current button
		$glob->gotHieraMenChildren= false;
		
		// Build the sub-buttons level, also see $parser->upMenRecName
		$buff= trim($parser->callParser($xmlNectSc));	// indirect RECURSION goes down
		
		$gotUpMenu= $parser->upMenRecName!==false;	// True if we got an upMenu button, used to detect the top menu pseudo button
		$totES= $rights->gotToDsplEditor();
				
		// Indent or top menu condition ---> $gotUpMenu always true for indentation (except top button), $totES always corelated with the display of the top button.
		$indentOrTopBut= $totES || $gotUpMenu;
		
		if ($buff!==''){
			if ($gotUpMenu){
				// $buff.= $caps->elemLi( $caps->hLink('#',_c_Ns) );
				$buff.= $genMenTg->liPadStr($xmlNect,_c_Ns);	// 'coucou'
				$htmlNectStr= $caps->topTagUL($buff);
			}else{
				$htmlNectStr= $caps->div( $caps->topTagUL('<!--  -->'._c_R.$buff,' id="navbar"') ,'','wrap');
				$this->onTopMenuButton= true;
			}
		}else{
			$htmlNectStr= '';
		}
				
		/**
			If set, to be used in priority in tg_menbut(), therefore sub-tree inclusion done with this glob
			variable, and we just have to look for the above Id and call $this->parseMen(()
		*/
		if ($indentOrTopBut && $gotUpMenu){
			// Goes up from the current buttons.
			$parser->buttonSubTreeStr[$menuId]= $htmlButtonStr.$htmlNectStr;
		}else{
			$parser->buttonSubTreeStr[$menuId]= $htmlNectStr;
		}
		
		if ($gotUpMenu){
			$level++;
			$this->parseMen($parser->upMenRecName,$level);		// RECURSION goes up !!
		}else{
			// no more up tag, so got the top button sub-tree
			$parser->topSubTreeId= $menuId;
		}
	} // parseMen


	/**
		Manages one menu button appearance.
		Added explicit display of the full menu when editing.
	*/
	function tg_menbut(&$v,&$label){
		$gTg= &$this->genMenTg;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rgh= &$this->rights;
		$parser= &$this->parser;
		$fastUp= &$gTg->fastUp;
				
		$gotMark= false;
				
		$contHid= $v['conthid'];	//  menu continuation hidding
		if ($glob->gotHieraMenChildren && $contHid===false){
			$label.= $gTg->menContin;
		}
		
		$newPage = $v['pg'];
		if ( isset($parser->buttonSubTreeStr[$newPage]) ){
			$str= $parser->buttonSubTreeStr[$newPage];	// Sub-tree inclusion
		}else{
			$edtOnly= $v['editonly'];	// Button active only in edition mode
			$disabledButton= $edtOnly==='ok' && !$rgh->lazyConnected();
			
			if ($disabledButton){
				$hLink= $caps->hLink('#',$label);
			}else{
				$mark='';
				if ($this->marlImgExists){
					$iaButNm= $this->iaButNm;
					if ($iaButNm!==_c_ko && $iaButNm!==false){
						$markSrc= $this->markSrc;
						if ( ($tools->isUrlPg($newPage) || $glob->upMenRecName===$newPage) ){
							$gotMark= true;
							$mark= $caps->img($markSrc,'*','arianeThreadImg');	// intern Ariane internal thread
						}
					}
					
					$curMarkWidth= $this->imgWInChars($gotMark,$markSrc);
				}else{
					$curMarkWidth= 0;
				}
				
				if ( $this->foldableMen($newPage) ){
					$fold= $tools->binLoads($v['fold'],_c_ok);
					if ($fold!==_c_ko){
						$curPgLvl= $glob->pageLevel[$newPage];
						$label= $this->splitMenuStr( $curMarkWidth, $label, $curPgLvl);
					}else{
						// print('Does not split $label='.$label._c_);
					}
				}
				
				$arCmd[_c_mothrPage]= _c_ko;
				$url= $tools->urlGivenPage($newPage,$arCmd);
				$url.= $tools->binLoads($v['urlsup'],'');
				
				$flw= $v['follow'];	// local follow got the priority if defined! Nor defined === false, other ok or ko
				$attS= '';
				if ( (_c_allMenusNoFollow && $flw===false) || $flw===_c_ko ){
					$attS.= $caps->noFollowStr();
				}
				$hLink= $caps->hLink($url, $mark.$label, $attS);
			}
			$str= $hLink;
		}
		return $str;
	} // tg_menbut
	
	
	/**
		Return true if the current menu need to be folded adding <br/>.
		Input :
			$id : menu Id
	*/
	function foldableMen($id){
		$glob= &$this->glob;
		$gTg= &$this->genMenTg;
		$menK= $gTg->getMnuKind();
				
		switch ($menK){
			case 'sPM':
			case 'vDropDown':
			case 'rvDropDown':		// right vertical drop down
				return true;
			break;
			
			case 'hDropDown':
			case 'bottomSetUp':
			case 'fullHzDropDown':
			case 'bottomHzSetUp':
				if ($this->isTopVisibleLevel($id)){
					return false;
				}else{
					return true;
				}
			break;
			
			default: return false;
		} // switch
	} // foldableMen
	
		
	/**
		Return true if $pgId is on the top visible level.
		Input : 
			$pgId : concerned page Id
	*/
	function isTopVisibleLevel($pgId){
		$glob= &$this->glob;
		$tools= &$this->tools;
		
		$pgLv= $glob->pageLevel[$pgId];
		$lstFstUp= $this->latLvFastUp;
		if ($tools->curPageName()==='_control-panel'){
			$lstFstUp++;	// Obtained pragmatically and necessary because _control-panel is not included into the menu hierachy
		}	
		
		return  $pgLv===$lstFstUp;
	} // isTopVisibleLevel


	/**
		Adapt the allowed width vector for the specific positions so we can just use the level indexes 
		in the menu as they are!
		
		Inout :
			$latLvFastUp : calculated with   genMenTg::calcUpLevel($curUpPg)    using the menuFastUp.php definition of tags
					--> typical values go from 0 (current button is at the top) to 1 or 2 (more --> this is a deep tree
					difficult to navigate with the mouse cursor)
	*/
	function adaptMaxDdV($latLvFastUp){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$maxDdVStr= $dtb->getGenVar('maxChrWDdvMenV');
		$maxDdV= $tools->trimStrToV($maxDdVStr);	// loads the original vector of sizes
		
		$newV= array();
		$i= $latLvFastUp;
		
		reset($maxDdV);
		foreach ($maxDdV as $k=>$val){
			$newV[$i]= $val;
			$i--;
		}
		
		return $newV;	// the levelWidthVector --  $this->levelWidthV
	} // adaptMaxDdV
		

	/**
		Image width in characters
	*/
	function imgWInChars($gotMark,$markSrc){
		$wInChars= 0;
		if ($gotMark){
			$wInChars= $this->ariadneBmWidth($markSrc);
		}
		return $wInChars;
	} // imgWInChars
	
		
	/**
		ariadneBmWidth
	*/
	function ariadneBmWidth($markSrc){
		$dtb= &$this->dtb;
		
		if ($this->ariadneBmkWidth===false){
			$imSzV= getimagesize($markSrc);	
			$w= $imSzV[0];	// width
			$fSz= $dtb->getGenVar('ddMenuTxtFontSz');
			$wInChars= (int)ceil($w/$fSz);
			$wInChars++; // +1 to take the margin in account
			$this->ariadneBmkWidth= $wInChars;
			return $wInChars;
		}else{
			return $this->ariadneBmkWidth;
		}
	} // ariadneBmWidth

	
			
	/**
		Split the given string (adding <br/>) to fit into the box with the given width matching the given level 
		from the top. Uses $this->levelWidthV.
		
		Input : 
			$curMarkWidth
			$label : the label with a possible suffix.
			$level : the actual level of the button.
			
		ulMenus::splitMenuStr()
	*/
	function splitMenuStr($curMarkWidth, &$label,$level){
		$markOffset= $curMarkWidth;	// image offset
		
		if ( !array_key_exists($level,$this->levelWidthV) ){
			reset($this->levelWidthV);
			$level= key($this->levelWidthV);
		}
		
		$width= $this->levelWidthV[$level];
		// print('$label='.$label.' $level='.$level.' $width='.$width._c_);
		
		return $this->wordFold($label, $markOffset,$width);
	} // splitMenuStr
	
	
	/**
		Word fold the given string to fit it inside a given width box and return the result.
		
		Warning : to save computing time, menus should be stored directly in multibyte code,
				so we don't need to use  $acc->fromHtmlToAccents($s) + could do the size test outside.
				
		Input :
			$s : the string itself
			$offS : the offset coming from the ariane image.
			$bW : the box width in current average width characters
	*/
	function wordFold(&$s,$offS,$bW){
		$acc= &$this->acc;
		$tools= &$this->tools;
		
		$s= $acc->fromHtmlToAccents($s);	// see Warning
		
		$sz= mb_strlen($s);
		$szMo= $sz-1;
		if ( ($offS+$sz)<=$bW ){
			return $s;	// nothing to do
		}else{
			// need at least one split
			$sV= $tools->mbStrToAry($s,$sz);	// computes the string vector!
			
			$istLine= true;	// First line flag (i = substitute for 1 for abbrev)
			$sI= 0;			// New  string local line index
			$wSz= 0;			// Cur Word size $wSz
			$curWord= '';	// With one trailing space if inside a sentence
			$cwBuilding= true;
			$newStr= '';
			$possLrgWrd= false;	// true if we are building a possible too large word we got to split
			$gotBr2= false;
			
			$currentMax= $bW-$offS;	// current maximum number of chars
			for ($j=0; $j<$sz; $j++){
				$char= $sV[$j];
				
				$curWord.= $char;
				$wSz++;
				
				if ($char===_c_Rs || $char==='-' || $char==='.' || $j>=$szMo){
					// got a real space OR "-" OR end of word OR ......
					$newStr.= $curWord;
					$curWord= '';
					$wSz= 0;
					$cwBuilding= false;
				}
				
				if ($sI>=$currentMax){
					if (!$gotBr2){
						$newStr.=  _c_Br;
						$gotBr2= false;
					}
					$sI= 0;
					$possLrgWrd= true;
				}
				
				if ($wSz>=$currentMax){
					$newStr.= $curWord._c_Br;
					$gotBr2= true;
					$curWord= '';
					$wSz= 0;
					$possLrgWrd= false;
				}
				
				// ----------------------------------------------------
				// Just to adapt $currentMax (jumping the image offset)
				if ($istLine){
					if ($sI>=$currentMax){
						$istLine= false;
						$currentMax= $bW;
					}
				}
				$sI++;
			} // for
			
		}
	
		return $acc->toHtmlCode($newStr);
	} // wordFold
	

} // ulMenus
?>
