<?php
/**
	File name : mediaManager.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Media Manager = Files mFilePathManager for the Server
	A class candidate for insertion in initMultiTags only on demand!
	
	Rem : also interesting infos with 
		$_SERVER['PHP_SELF']: http://www.php.net/manual/en/reserved.variables.server.php
		
	
		[setExplPlugin path="cntDev/mm/" name="mediaManager" /]

		[setExplCss path="cntDev/mm/" css="mm" /]
		
	Most inportant part for re-use else where :
	--->	$imgP->resizeProc($locUrl,$thumbUrl,_c_thumbsWidth,_c_thumbsHeight);	// BUILD THE THUMB
	--->	function fileCheckBoxLine(&$szDsplImg,$id,$motherDir,$fileName,$fileCbxName,$i,$forceMode=false){
*/
class mediaManager extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		
		$glob->explCentralInclStanceJs('mm');
		
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;		
		$this->rights= &$tagsFu->rights;		
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;
		
		$this->parser= &$tagsFu->parser;
		$this->wmRights= &$tagsFu->wmRights;	// access to the webmaster x rights class
		
		$this->declGalleryDim('gallThumbWidth','152');
		$this->declGalleryDim('gallThumbHeight','114');
		$this->declGalleryDim('gallLargeWidth','900');
		$this->declGalleryDim('gallLargeHeight','900');
		
		$glob->loadsMediaMgPt($this);
				
		define('_c_mGiantImgSz', 2000000);	// in bytes
		
		$this->imgP= &$tagsFu->imgP;
		$imgP= &$this->imgP;
		
		
		
		
		
		
		/**
			Even if used only in gallery mode, here is a general level instanciation so
			we can get rid of the too many multiple instanciations in mmTools, so basically
			get rid of the specific mmTools::instancMmGal()
		*/
		// Need to use the one already loaded by the xpetal declaration !!!!
		
		// $this->globMmGall= $tagsFu->explicitClasses['mmGallery']; // still not declared
		
		$this->globMmGall= $tagsFu->instExplitExternalCls('mmGallery');
		$this->globMmGall->loadsMmMg($mmMg);
		
		
		
		
		
		
		
		include _c_toDeclPlugCntr.'mm/mmTools.php';
		$this->mmTools= new mmTools($this,$tagsFu,$imgP);
		$mmTools= &$this->mmTools;
				
				
		include _c_toDeclPlugCntr.'mm/mmBoxes.php';
		$this->mmBoxes= new mmBoxes($tagsFu,$imgP,$mmTools);
		$mmBoxes= &$this->mmBoxes;
		$mmTools->loadsMmBoxes($mmBoxes);
		$mmTools->loadsMmMg($this);
		

		
		
		/*
			File path components. Path are never artificially terminated by /, because we :
				- We need to go up and down so avoid waste full removal.
				- We need to click-display segmented full path where "/" are just visual separators.
				- Rem this is the opposite convention than "include" path that are mainly additive.
		*/
		
		define('_c_mVisualTechHome', 'TechnicalHome');	// visual display of _c_flTechnicalHome /(of   "."  )
		define('_c_mActColGoal', 'goalPrfx');		// Radio but name : action column goal (to indicate if the action must be performed on column 1 or 2)
						
		/**
			Tags definition :
		*/	
		// tg_mpathup(&$v,&$bd) : [mPathUp id="" /]
		$tagsFu->attribVect['mpathup']= array('id');
		
		// tg_mtwins() : [mTwins id="1" /]
		$tagsFu->attribVect['mtwins']= array('id');
		
		// tg_minvert() : [mInvert /]
		$tagsFu->attribVect['minvert']= false;
		
		// tg_mreload() : [mReload /]
		$tagsFu->attribVect['mreload']= false;
		
		// tg_msdtmode() : [mSdtMode /]
		$tagsFu->attribVect['msdtmode']= false;
		$tagsFu->attribVect['msortingmode']= false;
		
		
		//tg_mfilepath : [mFilePath id="" /]
		$tagsFu->attribVect['mfilepath']= array('id');
		
		//tg_mchkdirfiles : [mChkDirFiles id="1"  /]
		$tagsFu->attribVect['mchkdirfiles']= array('id','cls','indepdspl');
		$tagsFu->attribVect['chkdirfilesdspl']= false;	// care about the indepensdant display
		
		
		//tg_msetcolrad : [msetColRad id="1" /]
		$tagsFu->attribVect['msetcolrad']= array('id');
		
		// tg_uploadsz() : [uploadSz maxsize="1000000" /]
		$tagsFu->attribVect['uploadsz']= array('maxsize');
		
		// tg_mlocalBrowser()   [mLocalBrowser name="locBrowser" size="10" /]
		$tagsFu->attribVect['mlocalbrowser']= array('name','size','cls');

		// [mAction /] tg_maction
		$tagsFu->attribVect['maction']= false;
		
		// tg_mcheckall() : [mCheckAll id="" /]
		$tagsFu->attribVect['mcheckall']= array('id','onoff');
		
		$tagsFu->attribVect['uppernohyphen']= false;
		
		// tg_dirtree()	[dirTree lim="100" /]
		$tagsFu->attribVect['dirtree']= array('lim','bfn','id','itemcls');
		
		// 	Belongs (o,g,w) ... owner, group, world
		// [mRightAtom name="selectDirOwner" belongs="o" cls="mmAtomRight" /] 
		$tagsFu->attribVect['mrightatom']= array('name','belongs','cls','default');
		
		$tagsFu->attribVect['mmavatarcond']= false;
		
		$tagsFu->attribVect['setallrights']= false;
		$tagsFu->attribVect['setnorights']= false;
		$tagsFu->attribVect['setnowriting']= false;
		$tagsFu->attribVect['setstdrights']= false;
		$tagsFu->attribVect['statinfoandsettings']= false;
		
		$tagsFu->attribVect['fmbookmarks']= false;
		
		$tagsFu->attribVect['defumbarpath']= false;
		$tagsFu->attribVect['mmsearchresult']= false;
		$tagsFu->attribVect['galleryxmcode']= false;
		$tagsFu->attribVect['mmbigchunk']= array('column','img','incr');
		
				
		// Scanning action modes on check boxes vectors
		define('_c_mmCbxFiles', 'files');	// implicitly all files (with or without path).
		define('_c_mmCbxDir', 'dir');		// implicitly all directories (with or without path).
		define('_c_mmCbxPhAll', 'phAll');	// path of/with files and directories taken separately.
		define('_c_mmCbxNmAll', 'nmAll');	// only name of files and directories. taken together.
		define('_c_mmCbxFirst', 'nm1All');	// only the 1st on all separated name the vectors.
		define('_c_mmCbxLeft', 'left');		// all left column element.
		define('_c_mmCbxRight', 'right');	// all right column element.
		
		define('_c_mmSpecialArchive', 'arch');
		define('_c_mmSpecOpenArch', 'opArch');
		define('_c_mmSpecOpenArchAll', 'opArchAll');
		
		// added prfx mm in the value to differentiate it from the function names (not done with the others)
		define('_c_mmSpecialCat', 'mmCatBuild');
		define('_c_mmSpecOpenCat', 'mmCatExtract');

		
		define('_c_mmSubSelectFile', 'f');	// sub selection of file.
		define('_c_mmSubSelectDir', 'd');	// sub selection of directories.
		
		
		define('_c_thbWidthTBN', 'thbWTBN');
		define('_c_thbWidthCbx', 'thbWCbx');
		
		define('_c_thbHeightTBN', 'thbHTBN');
		define('_c_thbHeightCbx', 'thbHCbx');
		
		$this->chkdirflMem= '';
		$this->allowChunkButtons1= false;
		$this->allowChunkButtons2= false;
		$this->memRawFlDrNb= 0;
	} // construct


	/**
	*/
	function tags(){
		return array('mpathup','mtwins','minvert','mreload','msdtmode','msortingmode','mfilepath',
			'mchkdirfiles','chkdirfilesdspl','msetcolrad','uploadsz','mlocalbrowser','maction','mcheckall', 'uppernohyphen',
			'dirtree','mrightatom','mmavatarcond','setallrights','setnorights','setnowriting','setstdrights',
			'statinfoandsettings','fmbookmarks','defumbarpath','mmsearchresult','galleryxmcode','mmbigchunk'
		);
	} // tags
	
		
	/**
		Special function to "declare" the gallery dimentions as constants (!! CONSTANTS defined in TWO PARTS) 
		Called to define : '_c_gallThumbWidth','_c_gallThumbHeight','_c_gallLargeWidth','_c_gallLargeHeight' 
	*/
	function declGalleryDim($str,$defVal){
		$dtb= &$this->dtb;
		
		$val= $dtb->getGenVar($str);
		if ($val===false){
			$val= $dtb->pGetGenVar($str,$defVal);
		}
		define('_c_'.$str, $val);
	} // declGalleryDim
	
	
	/**
		mm.setSevenRights()
	*/
	function tg_setallrights(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$attS= $caps->matCss('mmInfoLblStd');
		$attS.= $caps->jsFunctCallStr('onclick','mm.setSevenRights');
		$attS.= $caps->matTtl( $glob->es('Full rights for all','kamp') );
		return $caps->spanA('777',$attS);
	} // tg_setallrights
	
	
	function tg_setnorights(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$attS= $caps->matCss('mmInfoLblStd');
		$attS.= $caps->jsFunctCallStr('onclick','mm.setNoRights');
		$attS.= $caps->matTtl( $glob->es('No Rights!','kbng') );
		return $caps->spanA('000',$attS);
	} // tg_setnorights
	
	function tg_setnowriting(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$attS= $caps->matCss('mmInfoLblStd');
		$attS.= $caps->jsFunctCallStr('onclick','mm.setNoWrRight');
		$attS.= $caps->matTtl( $glob->es('No writing rights','katl') );
		return $caps->spanA('555',$attS);
	} // tg_setnowriting
	
	function tg_setstdrights(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$attS= $caps->matCss('mmInfoLblStd');
		$attS.= $caps->jsFunctCallStr('onclick','mm.setStdRights');
		$attS.= $caps->matTtl( $glob->es('Standard rights','kamo') );
		return $caps->spanA( $glob->es('Standard','kamq'), $attS);
	} // tg_setallrights
	
	
	
	// [statInfoAndSettings /]
	function tg_statinfoandsettings(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;

		$str= $glob->es('Stat:','kamg');
		$ttl= $glob->es('Gives some statistics','kamf');
		$x= $caps->jsFunctCallStr('onclick','mm.adaptStatAction');
		
		return $caps->span($str,'mmInfoLblVital','','',$ttl,$x);
	} // tg_statinfoandsettings


	/**
		Maximum upload size,
		tg_uploadsz() : [uploadSz maxsize="1000000" /]
	*/
	function tg_uploadsz(&$v,&$bd){
		$mmBoxes= &$this->mmBoxes;
		return $mmBoxes->uploadsz($v['maxsize']);
	} // tg_uploadsz


	/**
		tg_mlocalBrowser()   [mlocalBrowser name="locBrowser" size="10" /]
	*/
	function tg_mlocalBrowser(&$v,&$bd){
		$mmBoxes= &$this->mmBoxes;
		return $mmBoxes->mlocalBrowser($v['name'],$v['size'],$v['cls']);
	} // localBrowser


	/* --------------------------------------------------------------------------------------------------
		GENERAL TOOLS 
	*/
	
	/**	
	*/
	function fullPathStr($id){
		$mmBoxes= &$this->mmBoxes;
		return $mmBoxes->fullPathStr($id);
	} // fullPathStr
	
	
	/**
		Rem : for comparaison purpose : returns a string.
	*/
	function selectedColumnId(){
		$tools= &$this->tools;
		return (string)$tools->trimPostVal(_c_mActColGoal,'1');
	} // selectedColumnId
	
	/**
		Returns true if the first column is selected, firstColumn
	*/	
	function firstColumn(){
		return $this->selectedColumnId()==='1';
	} // firstColumn
	
	/**
		Gives the other column Id
	*/
	function otherColumnId($id){
		if ((string)$id==='1'){
			return '2';
		}else{
			return '1';
		}
	} // otherColumnId


	/**
		Media manager avatar conditions.
		[mmAvatarCond /]
	*/
	function tg_mmavatarcond(&$v,&$bd){
		$mmBoxes= &$this->mmBoxes;
		$mmBoxes->avatarConditions= true;
	} // tg_mmavatarcond
	

	function slashedFPthStr($id){
		$tools= &$this->tools;
		return $tools->fullPathStr($id).'/';
	} // slashedFPthStr

	/**
		Returns the common prefix path to the two standard directories positions.
	*/
	function commonPrfxPath(){
		$fls= &$this->fls;			
		$s= $this->slashedFPthStr(1);
		$t= $this->slashedFPthStr(2);
		return $fls->commonPrfx($s,$t);
	} // commonPrfxPath

	function sizeComPrfxPath(){
		$s= $this->commonPrfxPath();
		return strlen($s);
	} // sizeComPrfxPath

	
	/**
		Invert the url to invert the two columns.
	*/		
	function invertUrl(){
		$tools= &$this->tools;
		$mmBoxes= &$this->mmBoxes;
		$tools= &$this->tools;
		
		// path invertion
		$upv1= $tools->urlPathVar(1);
		$upv2= $tools->urlPathVar(2);
		$u= $tools->fullPathStr(1);
		$v= $tools->fullPathStr(2);
		
		$ar['mmDFChunkPos1']= _c_ko;
		$ar['mmDFChunkPos2']= _c_ko;
		$url= $tools->urlCurPg($ar).$tools->addUrlVar($upv1,$v).$tools->addUrlVar($upv2,$u);
		
		$chk2= $tools->getVal('mmDFChunkPos2');
		$url.= $tools->addUrlVar('mmDFChunkPos1',$chk2);
		$chk1= $tools->getVal('mmDFChunkPos1');
		$url.= $tools->addUrlVar('mmDFChunkPos2',$chk1);
		
		$url.= $tools->urlEnd();
		return $url;
	} // invertUrl
	

	/**
		Returns the multi url path for the given id, The path matching the given id is calculated for
		all the possibilities of the full path parts when the other path stays fix and full (because
		we can change only one path at a time).
			Input :
				$id : identification (1 or 2) of the given column.
			Output : returns the multi url path for the given id.	
	*/
	function multiUrlPath($id){
		$wmR= &$this->wmRights;	// access to the webmaster rights class
		$mmBoxes= &$this->mmBoxes;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;

		$buff= '';
		$fullPathStr= $tools->fullPathStr($id);
		
		$v= explode(_c_flPathSlash,$fullPathStr);
		$newPath= '';
		$i= 0;
		reset($v);
		foreach ($v as $key=>$dirName){
			if ($dirName===_c_flTechnicalHome){
				$newPath=  $dirName;
				$vsblSlash= '';
			}else{
				$newPath.= _c_flPathSlash.$dirName;
				$vsblSlash= $caps->font(_c_flPathSlash,'mmMultiUrlPath');
			}
				
			if ($wmR->globAllowedPath($newPath.'/')){
				$url= $mmBoxes->getNewUrl($id,$newPath);
				
				if ($dirName===_c_flTechnicalHome){
					$dsplDirName= _c_mVisualTechHome;
				}else{
					$dsplDirName= $fls->breakableFN($dirName);
				}
				
				if (file_exists($newPath)){
					$lnTtl= $fls->genFileInfos($newPath,$dsplDirName);
				}else{
					$lnTtl= '';
				}

				$buff.= $vsblSlash.$caps->linkTC($url,$dsplDirName, $lnTtl, 'mmMultiUrlPath');
			}
			$i++;
		}
		return $buff;
	} // multiUrlPath
	

	
	/**
		True if it's a gallery action
	*/
	function galleryAction($action){
		return substr($action,0,6)=== 'mmGall';
	} // galleryAction
	
	/**
		True if got to adapt the xm2.txt file
	*/
	function galleryXmSqrAdapt($action){
		return $action==='mmGallXm' || $action==='mmGallry' || $action==='mmGallryKeep';
	} // galleryXmSqrAdapt

	
	
	/* --------------------------------------------------------------------------------------------------
		MANAGES THE RESULTS of all the widgets defined inside the media manager form.
	*/
	function managesAllWidgets(&$url){
		$glob= &$this->glob;
		$mmBoxes= &$this->mmBoxes;
		$tools= &$this->tools;
		$fls= &$this->fls;		
		$rMg= &$this->rights;			
		$mmTools= &$this->mmTools;
	
	
		$action= $mmTools->mainAction();	
		if ($glob->cndtWrRghts===false){
			$glob->setGuestDisplay($action,$glob->el('inside the file browser!','kauc'));
			return '';
		}
		
		if ($action!=='browse' && !$rMg->pwCheck3()){	
			$glob->userError($glob->el('Sorry actions are actualised only...','kaud'));
			return '';
		}		
	
	
		$columnId= $this->selectedColumnId();
		$pushedPath= $tools->trimPostVal('motherDir'.$columnId);	// radio mbutton puished
		$newName= $mmTools->newNameVal('');	// looks like an empty text box sending a '' anyway, so just make it clearer.
		
		switch ($action){			
			/**
				Basic file manips
			*/
			case 'move':
				if ($this->firstColumn()){
					$mmTools->applyFuOnCbxVect('mMove',_c_mmCbxRight,'nopath');	
				}else{
					$mmTools->applyFuOnCbxVect('mMove',_c_mmCbxLeft,'nopath');					
				}							
			break;
			
			case 'copy':
				if ($this->firstColumn()){
					$mmTools->applyFuOnCbxVect('mCopy',_c_mmCbxRight,'nopath');	
				}else{
					$mmTools->applyFuOnCbxVect('mCopy',_c_mmCbxLeft,'nopath');					
				}													
			break;
		
			case 'dwnldblCpy':
				$mmTools->applyFuOnCbxVect('dwnldblCpy',_c_mmCbxFiles);		
			break;
		
			case 'rename':
				$mmTools->applyFuOnCbxVect('rename',_c_mmCbxFirst,'nopath');		
			break;
		
			case 'renameGTB':
				$mmTools->applyFuOnCbxVect('renameGTB',_c_mmCbxFiles);		
			break;			
		
			case 'duplicate':
				$mmTools->applyFuOnCbxVect('duplicate',_c_mmCbxPhAll);		
			break;
		
			case 'createTestFls':
				$mmTools->createTestFls($pushedPath);			
			break;
		
			case 'removeNLeftCh':
				$mmTools->applyFuOnCbxVect('removeNLeftCh',_c_mmCbxPhAll);		
			break;
		
			case 'removeNRightCh':
				$mmTools->applyFuOnCbxVect('removeNRightCh',_c_mmCbxPhAll);		
			break;
		
			case 'addsLeftCh':
				$mmTools->applyFuOnCbxVect('addsLeftCh',_c_mmCbxPhAll);		
			break;
		
			case 'addsRightCh':
				$mmTools->applyFuOnCbxVect('addsRightCh',_c_mmCbxPhAll);		
			break;
		
			case 'changeFlType':
				$mmTools->applyFuOnCbxVect('changeFlType',_c_mmCbxPhAll);		
			break;
	
			case 'changeReFlType':
				$mmTools->applyFuOnCbxVect('changeReFlType',_c_mmCbxPhAll);		
			break;
			
			case 'convSymbToHtml':
				$mmTools->applyFuOnCbxVect('convSymbToHtml',_c_mmCbxFiles);		
			break;
			
			case 'convHtmlToSymb':
				$mmTools->applyFuOnCbxVect('convHtmlToSymb',_c_mmCbxFiles);		
			break;
			
		
			/**
				New
			*/
			case 'newFolder':
				$mmTools->newFolder($pushedPath,$newName);			
			break;
		
			case 'newTxtFile':
				$mmTools->newTxtFile($pushedPath,$newName);			
			break;
		
			case 'newNoThumbs':
				$mmTools->newNoThumbs($pushedPath);			
			break;
	
			
			/**
				Image Gallery
			*/
			case 'mmImposejpg':
				$mmTools->applyFuOnCbxVect('mmImposejpg',_c_mmCbxFiles);
			break;
			
			case 'mmGallThmbs':
				$mmTools->applyFuOnCbxVect('mmGallThmbs',_c_mmCbxFiles);
			break;
			
			case 'mmGAllRSzLrg':
				$mmTools->applyFuOnCbxVect('mmGAllRSzLrg',_c_mmCbxFiles);
			break;
			
			case 'mmGallAdaptNm':
				$mmTools->applyFuOnCbxVect('mmGallAdaptNm',_c_mmCbxFiles);
			break;
			
			case 'mmGallXm':
				$mmTools->applyFuOnCbxVect('mmGallXm',_c_mmCbxFiles);
			break;
			
			case 'mmGallry':
				$mmTools->applyFuOnCbxVect('mmGallry',_c_mmCbxFiles);
			break;
			
			case 'mmGallryKeep':
				$mmTools->applyFuOnCbxVect('mmGallryKeep',_c_mmCbxFiles);
			break;
			
			case 'mmGallRename':
				$mmTools->applyFuOnCbxVect('mmGallRename',_c_mmCbxFiles);
			break;
			
			
			
			/**
				Search
			*/
			case 'mmSearch':
				$mmTools->applyFuOnCbxVect('mmSearch',_c_mmCbxPhAll);		
			break;
			
			case 'searchInFN':
				$mmTools->applyFuOnCbxVect('searchInFN',_c_mmCbxPhAll);		
			break;

			case 'mmShowKB':
				// nothing to do here because treated on the columns spots!
			break;
			
			
			
			/**
				Images manip
			*/
			case 'chgThumbsSz':
				$mmTools->applyFuOnCbxVect('chgThumbsSz',_c_mmCbxFiles);		
			break;
			
			case 'chgSzSelImg':
				$mmTools->applyFuOnCbxVect('chgSzSelImg',_c_mmCbxFiles);		
			break;
			
			case 'freeLeftRot':
				$mmTools->applyFuOnCbxVect('freeLeftRot',_c_mmCbxFiles);		
			break;
			
			case 'cropImage':
				$mmTools->applyFuOnCbxVect('cropImage',_c_mmCbxFiles);		
			break;
			
			case 'randomImage':
				$mmTools->randomImage($pushedPath);			
			break;

			
			
			
			/**
				Archive
			*/
			case 'archive':
				$mmTools->applyFuOnCbxVect('phoney',_c_mmSpecialArchive); // a hard coded function here						
			break;
		
			case 'opArch':
				$mmTools->applyFuOnCbxVect('opArch',_c_mmSpecOpenArch);														
			break;
		
			case 'opArchAll':
				$mmTools->applyFuOnCbxVect('opArchAll',_c_mmSpecOpenArchAll);														
			break;
			
			
			/**
				Build and extract the ataox-format TARs
			*/
			case 'catBuild':
				$mmTools->applyFuOnCbxVect('catBuild',_c_mmSpecialCat);		
			break;
			
			case 'catExtract':
				$mmTools->applyFuOnCbxVect('catExtract',_c_mmSpecOpenCat);		
			break;
	

			case 'splitFile':
				$mmTools->applyFuOnCbxVect('splitFile',_c_mmCbxFiles);		
			break;
			
			case 'glueFiles':
				$mmTools->applyFuOnCbxVect('glueFiles',_c_mmCbxFiles);		
			break;
			
			
			/**
				Programmer Tools
			*/
			case 'updateConstructor':
				$mmTools->applyFuOnCbxVect('updateConstructor',_c_mmCbxPhAll);		
			break;
			
			case 'rmCpySffxedFiles':
				$mmTools->applyFuOnCbxVect('rmCpySffxedFiles',_c_mmCbxPhAll);		
			break;
			
			case 'mmAddJsHd':
				$mmTools->applyFuOnCbxVect('mmAddJsHd',_c_mmCbxPhAll);
			break;
			
		
			/**
				Deletion
			*/
			case 'trash':
				$trashDir= $rMg->userDustPath();
				if (!is_dir($trashDir)){
					$fls->wMkDir($trashDir);
				}
				
				$newDir= $trashDir.'/'.$fls->timeStamp();
				if ($fls->wMkDir($newDir)){
					$glob->newTrashDir= $newDir; // !!
					$mmTools->applyFuOnCbxVect('trash',_c_mmCbxPhAll);
				}else{
					$glob->userError($glob->el('The trash directory ','kaue').$pathFN.$glob->el(' exists already!','kayy'));
				}
										
			break;
		
			case 'emptyTrash':
				$mmTools->emptyTrash();			
			break;
		
			case 'delete':
				$mmTools->applyFuOnCbxVect('delete',_c_mmCbxPhAll);		
			break;
		
			case 'usDelete':
				$mmTools->applyFuOnCbxVect('usDelete',_c_mmCbxPhAll);		
			break;
		
			case 'delInside':
				$mmTools->applyFuOnCbxVect('delInside',_c_mmCbxPhAll);		
			break;
		
		
			/**
				Divers
			*/
			case 'fileUpload':
				$origName= $fls->origNameUpldFile();
				$destPF= $tools->fullPathStr($columnId)._c_flPathSlash.$origName;
				$fls->saveUploadedFile($destPF);
			break;
			
		
			case 'rights':
				$mmTools->setRights();			
			break;
			
			
			default:
				$glob->userHelp( $glob->el('Got an unused action : ','kmge') .$action);
				$glob->userHelp( $glob->el('...browser or server memory saturation...','kbnw'));
			break;	// default
		}
		
		$url= $mmBoxes->getNewUrl(); // same page 	+ directory localisation
		return '';
	} // managesAllWidgets


	/* --------------------------------------------------------------------------------------------------
		FIRST & SECOND COLUMNS --> Nth (in some case possibly nice to have 3 or 4 for intensive file browsing) :
		These methods/widgets are DEPENDANT ON A SPECIFIC ID FOR THE WHOLE COLUMN OF FILES.
		
			On top of the column :
				- tg_pathup() : UpThePath button separated because could interfer with paralell presentation of fields to select.
				- tg_goalIndic(() one radio button on each column (goal indicator) to indicate witch one is active to get (defaulleftest column) :
							- some file upload.
							- files to be copied to from an other column.
							- goal of a click inside the full tree browser (only directories).
						Remark : keep with 2 columns, so the start (when moving/copying ... files) is the other column.
				- tg_sfilepath() : Sensitive (breakable) file path
				
			Column by thenself :
				- tg_chkdirfiles() : D&F : Directories and files with check boxes + Top radio buttons to determine what column we have to use for uploads.
				- tg_jsselectbar(() : Highlightable vertical bar |, in JS communication with D&F
	*/
	
	
	/**
		Goes up one level in the path.
		Input :
			$path : not terminated with / and not including a file name.
		Output :
			return $newPath
	*/
	function upPath($path){
		$fls= &$this->fls;
	
		$fls->splitOnLastC($path,$prfxPath,$lastDir,_c_flPathSlash);
		if ($path===_c_flTechnicalHome || $lastDir===_c_mPathUp){
			// can't go upper by shortening the path, so concat an upper step (_c_mPathUp)
			$newPath= $path._c_flPathSlash._c_mPathUp;
		}else{
			$newPath= $prfxPath;
		}
		return $newPath;
	} // upPath


	/**
		One step up in the directory hierachy.
		[mPathUp id="1" /]	
	*/
	function tg_mpathup(&$v,&$bd){
		return $this->pathUp($v['id']);
	} // tg_mpathup
	
	function pathUp($id){
		$wmR= &$this->wmRights;	// access to the webmaster rights class
		$mmBoxes= &$this->mmBoxes;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		$fps= $tools->fullPathStr($id);
		$newPath= $this->upPath($fps);
		if ($wmR->globAllowedPath($newPath.'/')){
			$url= $mmBoxes->getNewUrl($id,$newPath);
			$folderPath= $fls->editorImage('folderUp.png');
			$folder= $caps->simplestImg($folderPath,'',$caps->matCss('lz'));
			return $caps->linkTC($url,$folder, $glob->el('Up one level','kacc') );
		}else{
		}	return '';
	} // pathUp
		
		
	/**
		The clicked column does not change but passes its position to the other.
		tg_mtwins() : [mTwins id="1" /]
	*/
	function tg_mtwins(&$v,&$bd){
		$mmBoxes= &$this->mmBoxes;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		$id= $v['id'];
		$clickedPath= $tools->fullPathStr($id);
		$otherId= $this->otherColumnId($id);
		
		$url= $mmBoxes->getNewTwinUrl($otherId,$clickedPath);
		$imgPath= $fls->editorImage('symmetry.png');
		$img= $caps->simplestImg($imgPath,'',$caps->matCss('lz'));
		return $caps->linkTC($url,$img,$glob->el('Sets the other column like this one!','kace'));
	} // tg_mtwins

		
	/**
		Invert the columns.
		tg_minvert() : [mInvert /]
	*/
	function tg_minvert(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		$url= $this->invertUrl();
		$imgPath= $fls->editorImage('permute.png');
		$alt= $glob->el('Permutes!','kaci');
		$img= $caps->imageWh($imgPath,$alt,'noBorder');
		return $caps->linkTC($url,$img,$alt,'fltRightClick');
	} // tg_minvert
		
	
	/**
		Reload the columns.
		tg_mreload() : [mReload /]
	*/
	function tg_mreload(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		$url= $tools->sameUrl();
		$imgPath= $fls->editorImage('reload.png');
		
		$alt= $glob->el('Reloads with the same files position.','kacj');
		$img= $caps->imageWh($imgPath,$alt,'noBorder');
		return $caps->linkTC($url,$img,$alt,'fltRightClick');
	} // tg_reload
		
	
	/**
		Select menu to change the mode of the file/media manager.
		[mSdtMode /]	madiaM Simple details thumbs Mode.
	*/
	function tg_msdtmode(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$mmBoxes= &$this->mmBoxes;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$curMmMode= $mmBoxes->getMmMode();
		$cookName= $tools->spc('mSdtMode');
		$curUrl= $tools->sameUrl();
		$chgMmM= $caps->jsFunctCallStr('onChange','mm.changeMmMode',3,0,'modeSelectId',$cookName,$curUrl);
				
		$vMode= array(_c_mSmplVisMode=>$glob->el('Simple','kavh'), _c_mDetVisMode=>$glob->el('Details','kavi'), _c_mImgVisMode=>$glob->el('Thumbs','kavj'), _c_mGalVisMode=>$glob->el('Gallery','kavk'));	
		
		return $caps->comboBox('modeSelectId', $curMmMode, $vMode, $caps->matCss('fltRightClick').$chgMmM, true);
	} // tg_msdtmode
	
	/**
		[mSortingMode /]
		---> [mChkDirFiles id="1"  /]
	*/
	function tg_msortingmode(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$mmBoxes= &$this->mmBoxes;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$mmSort= $tools->gostVal('mmSort');
		if ($mmSort===false){
			$mmSort= $tools->spcCookVal('mCkSorting','alpha');
		}
		
		$cookName= $tools->spc('mCkSorting');
		$curUrl= $tools->sameUrl();
		
		$js= $caps->jsFunctCallStr('onChange','mm.changeSortingMode',3,0,'sortingSelectId',$cookName,$curUrl);
		$mmgDfn= $tagsFu->expliExtClassPath('mmGallery');
		
		$vModeAct= $tools->trimStoV('defaultTtl, alpha, rAlpha, date, rDate, size, rSize, ext, rExt, owner, rOwner, rights, rRights, raw');			
		$vModeLbl= $tools->mbExplo($glob->el('Sorting :, Alphabetical, Reverse Alphabetical','kbgm'));		
		$vMode= array_combine($vModeAct, $vModeLbl)	;
				
		return $caps->comboBox('sortingSelectId', $mmSort, $vMode, $caps->matCss('fltRightClick').$js,true);
	} // tg_msortingmode	
		
	
	/**
		Sensitive (breakable) file path
		[mFilePath id="" /]
	*/
	function tg_mfilepath(&$v,&$bd){
		$id= $v['id'];
		return $this->multiUrlPath($id);
	} // tg_mfilepath


	/**
		Goal indicator for the column (a radio button on the top of each column)
		--> Set Column goal Radio button
	*/
	function tg_msetcolrad(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$id= $v['id'];
		$valBut= $this->selectedColumnId();
		$trad= $glob->el('Select the Goal Column','kacd');
		return $caps->radioBut(_c_mActColGoal,$id,$valBut,$caps->matCss('ln').' title="'.$trad.'" style="cursor:pointer"');
	} // tg_msetcolrad

		
	/**
		tg_mcheckall() : [mCheckAll id="" /]
	*/
	function tg_mcheckall(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;		
		$tagsFu= &$this->tagsFu;
		
		$id= $v['id'];
		$onoff= $tools->binLoads($v['onoff'],_c_ok);	// default : 'ok' --> true implies to check the boxes.
		
		$baseDir= 'chkDir'.$id;
		$baseFl= 'chkFile'.$id;
		
		// The size writen as general JS variables, see $glob->setGlobJsCode(...)
		$jsFu= $caps->jsFunctCallStr('onclick','mm.checkAllColBx',4,0,$baseDir,$baseFl,$id,$onoff);
		
		if ($onoff===_c_ok){
			$imgPath= $fls->editorImage('check.png');
			$alt= $glob->el('Check all boxes','kacf');
		}else{
			$imgPath= $fls->editorImage('uncheck.png');
			$alt= $glob->el('Uncheck all boxes','kacg');			
		}
				
		$img= $caps->simplestImg($imgPath,$alt,$caps->matCss('lz'));
		return  $caps->spanA($img, $jsFu.$caps->ta($alt) );
	} // tg_mcheckall

		
	/**
		When checked, replaces all hyphens with whites and capitalize the 1st letter of words
		tg_uppernohyphen() : [upperNoHyphen /]
	*/
	function tg_uppernohyphen(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;		
		$mmBoxes= &$this->mmBoxes;
		
		$curMmMode= $mmBoxes->getMmMode();
		if ($curMmMode!==_c_mGalVisMode){
			return '';
		}
		
		$id= '1';
		$baseFl= 'chkFile'.$id;
		$jsFu= $caps->jsFunctCallStr('onclick','mm.upperNoHyphen',1,0,$baseFl);
		
		$imgPath= $fls->editorImage('lowerToUpper.png');
		$alt= $glob->el('Replaces all hyphens with whites ...','kmig'); // and capitalize the 1st character of words!
				
		$img= $caps->simplestImg($imgPath,$alt,$caps->matCss('lz'));
		return  $caps->spanA($img, $jsFu.$caps->ta($alt) );
	} // tg_uppernohyphen

	
	/** ---------------------------------------------------------------------------
		Checkable directories and files, with clickable dir & file, Check boxes.
		Generally [mChkDirFiles id="1" /] or [mChkDirFiles id="2" /]  
	*/
	function tg_mchkdirfiles(&$v,&$bd){
		$globMmGall= &$this->globMmGall;
		$mmBoxes= &$this->mmBoxes;
		$glob= &$this->glob;	
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$rMg= &$this->rights;
		$parser= &$this->parser;
		
			
		
		$this->chkdirflMem= '';
		
		$id= $v['id'];
		$cls= $v['cls'];
		$dirCbxName= 'chkDir'.$id;
		$fileCbxName= 'chkFile';
		

		$mmSort= $tools->gostVal('mmSort');
		if ($mmSort===false){
			$mmSort= $tools->spcCookVal('mCkSorting','alpha');
		}
		
		$motherDirNS= $tools->fullPathStr($id);	
		if (!file_exists($motherDirNS)){
			return $caps->span( _c_._c_Ns.$glob->el('The current path does not exists!','kawx')._c_._c_, 'userError' );
		}
		
		$motherDir= $motherDirNS._c_flPathSlash; // adds the slash for compatibility with fullPathStr() ... default '/' additive style.
		$buff= $caps->hiddenWdg('motherDir'.$id, $motherDir);
		
		$special= _c_dustbinName;
		$nbForbid= 0;
		$i=0;
		if ($fls->mmFrstLvlDir($dirV,$special,$rawFlDrNb,$motherDir,$id)){	// extracts $dirV (the directory vector)
			if (is_array($dirV)){
				$this->sortGivenVector($dirV,$motherDir,$mmSort, 'dir');
				
				reset($dirV);
				foreach ($dirV as $key=>$curSonDir){
					$buff.= $mmBoxes->dirCheckBoxLine($id,$motherDir,$curSonDir,$dirCbxName,$i,$nbForbid);
					$i++;
				}
			}
						
			if ($special!==false){
				/*	Adds the dustbin at the end : rem. the bin always got check box so the user can move it arround.
					Just got to precise that :
						- 	The bin can't be trashed (otherwise infinite recurs --> refuses to trash it.)
						- 	The bin can be move arround, emptied and deleted if access to string delete! A new
							bin will be just recreated in the main dir.
						- 	===> user must be conscious that the real bin is in the top directory.
								could also hide it inside a system directory.
				*/
				$buff.= $mmBoxes->dirCheckBoxLine($id,$motherDir,$special,$dirCbxName,$i,$nbForbid);
				$i++;
			}
			
			$buff.= $caps->hiddenWdg('chkDir'.$id.'Sz',$i);
			$glob->setGlobJsCode('chkDir'.$id.'Sz='.$i.';'._c_R);	
		}else{
			$glob->setGlobJsCode('chkDir'.$id.'Sz=0;'._c_R);	
		}
		
		
		$szChunk= $dtb->getGenVar('mmSizeDirFlsChunk','4000');
		$chunkWarn= '';
		if ($rawFlDrNb>$szChunk){
			$this->memRawFlDrNb= $rawFlDrNb;
			
			if ($id==='1'){
				$this->allowChunkButtons1= true;
			}else{
				$this->allowChunkButtons2= true;
			}
			
			
			
			$imgDFn= $fls->editorImage('info.png');
			$sfx= ' width:18px;';
			$chunkWarn= $caps->flexImgStl($imgDFn, $glob->el('directory holds more elements ..','kbob'),$sfx);
		}
				
		$nbAllowed= $i-$nbForbid;
		$dirFileNumInfos= $chunkWarn.$caps->span($nbAllowed._c_Ns.$glob->el('directorie(s)', 'kaaa'), 'mmDirFileSz');
		
		$i=0;		
		if ($fls->firstLevelFiles($dirF,$motherDir,true,$id)){	// extracts $dirF (the file vector)
			// $dirF : a vector holding all the files inside $motherDir
			$this->sortGivenVector($dirF,$motherDir,$mmSort);
			
			// Loads xm2 file infos if file exists
			$xmDfn= $globMmGall->xmFileDfn();
			if ($id==='1' && file_exists($xmDfn)){
				
				$xmStr= $fls->fileToStr($xmDfn);
				$imgTag= &$tagsFu->explicitTags['z'];
				$tagsFu->explicitTags['z']= 'mmGallery';		// so tg_z() is taken from this class !!!!!!!!!!!!!!!
				
				/**
					Basically loads mmGallery::->globV ;  mmGallery::->globBD
					---> Need to avoid interferences so need to empty the vector before and after use !!
					... other side too!!
				*/
				$globMmGall->unsetGlobVBd();
				
				
				$parser->addrParseStdStr($xmStr);
				// print('Just parsed '.$xmDfn._c_);
				// $tools->easyPrint($globMmGall->globBD);
				
				$tagsFu->explicitTags['z']= 'imgTags';	// back to standard class for tg_z()
			}
		
			$gotGiant= false;
			$forceMode= false;
			$g=0;
			reset($dirF);
			foreach ($dirF as $key=>$curFile){
				$buff.= $mmBoxes->fileCheckBoxLine($szImg,$motherDir,$curFile,$fileCbxName,$id,$i,$forceMode);
				$i++;
				
				if ( $szImg>_c_mGiantImgSz && !$fls->atHme() ){
					$gotGiant= true;
				}
				
				if ($gotGiant){
					$g++;
					if ($g===2){
						$forceMode= 'details';
						$buff.= $caps->div($caps->font($glob->el('The following images are supposed too big','kacj'),'errForm'),'linePackage');
					}
				}
			}	// foreach			
			
			$buff.= $caps->hiddenWdg('chkFile'.$id.'Sz',$i);
			$glob->setGlobJsCode('chkFile'.$id.'Sz='.$i.';'._c_R);	
		}else{
			$glob->setGlobJsCode('chkFile'.$id.'Sz=0;'._c_R);	
		}
		
		$dirFileNumInfos.= $caps->span($i.$glob->el(' file(s)','kaab'),'mmDirFileSz');
		
		$iDspl= $v['indepdspl'];
		if ($iDspl===_c_ok){
			$this->chkdirflMem= $caps->div($dirFileNumInfos.$buff,$cls);
		}else{
			return $caps->div($dirFileNumInfos.$buff,$cls);
		}
	} // tg_mchkdirfiles
	
	/**
		For an independant dispaly of the last used [mChkDirFiles /]
		[chkDirFilesDspl /]  ... the display part does not need an index
	*/
	function tg_chkdirfilesdspl(&$v,&$bd){
		return $this->chkdirflMem;
	} // tg_chkdirfilesdspl
	


	
	/** ---------------------------------------------------------------------------
		General comparison of file dimension
	*/	
	function cmpDim($fn1,$fn2){
		return strcasecmp( $this->curDimForFnIdxV[$fn1], $this->curDimForFnIdxV[$fn2] );
	} // cmpDim
	
	function revCmpDim($fn1,$fn2){
		return -$this->cmpDim($fn1,$fn2);
	} // revCmpDim
	
	
	/** ---------------------------------------------------------------------------
		General comparison of file dimension
	*/	
	function cmpNumDim($fn1,$fn2){
		$a= $this->curDimForFnIdxV[$fn1];
		$b= $this->curDimForFnIdxV[$fn2];
		
		if ($a===$b){
			return 0;
		}else if ($a < $b){
			return 1;
		}else{
			return -1;
		}
	} // cmpNumDim
	
	function revCmpNumDim($fn1,$fn2){
		return -$this->cmpNumDim($fn1,$fn2);
	} // revCmpNumDim
	
	
	/**
		Sort the given vector of files or directories (should be screened) along the sorting demand.
			Input :
				$dirF : array of files or directory names to sort
				$motherDir : the path
				$mmSort : the kind or sort.
				$kind : files or directories.
			Output :
				$dirF
	*/
	function sortGivenVector(&$dirF,$motherDir,  $mmSort, $kind='fl'){
	
		$this->curDimForFnIdxV= array();	
		switch ($mmSort){
			
			case 'alpha':
			case 'defaultTtl':
				natcasesort($dirF);
			break;

			case 'rAlpha':
				// reversed-alphabetical order
				natcasesort($dirF);
				$dirF= array_reverse($dirF);
			break;

			case 'rDate':
			case 'date':
				$this->curDimForFnIdxV= $this->fileNmIndexedV($motherDir,$dirF,'fileModTm');
				
				if ($mmSort==='date'){
					usort($dirF, array($this,'cmpDim'));
					$dirF= $this->sortInSameContext($dirF,$motherDir,'fileModTm');
				}else{
					usort($dirF, array($this,'revCmpDim'));
					$dirF= $this->sortInSameContext($dirF,$motherDir,'fileModTm');
				}
			break;
			
			case 'rSize':
			case 'size':
				if ($kind==='fl'){
					$this->curDimForFnIdxV= $this->fileNmIndexedV($motherDir,$dirF,'fileSz');
					if ($mmSort==='size'){
						usort($dirF, array($this,'cmpNumDim'));
						$dirF= $this->sortInSameContext($dirF,$motherDir,'fileSz');
					}else{
						usort($dirF, array($this,'revCmpNumDim'));
						$dirF= $this->sortInSameContext($dirF,$motherDir,'fileSz');
					}
				}
			break;

			case 'rExt':
			case 'ext':
				if ($kind==='fl'){	// only sorting files
					$this->curDimForFnIdxV= $this->fileNmIndexedV($motherDir,$dirF,'extension');
					if ($mmSort==='ext'){
						usort($dirF, array($this,'cmpDim'));
						$dirF= $this->sortInSameContext($dirF,'','extension');
					}else{
						usort($dirF, array($this,'revCmpDim'));
						$dirF= $this->sortInSameContext($dirF,'','extension');
					}
				}else{
					sort($dirF);
				}
			break;
			

			case 'owner':
			case 'rOwner':
				$this->curDimForFnIdxV= $this->fileNmIndexedV($motherDir,$dirF,'fileOwnerNm');
				if ($mmSort==='owner'){
					usort($dirF, array($this,'cmpDim'));
					$dirF= $this->sortInSameContext($dirF,$motherDir,'fileOwnerNm');
				}else{
					usort($dirF, array($this,'revCmpDim'));
					$dirF= $this->sortInSameContext($dirF,$motherDir,'fileOwnerNm');
				}
			break;
			
			case 'rights':
			case 'rRights':
				$this->curDimForFnIdxV= $this->fileNmIndexedV($motherDir,$dirF,'filepermStr');
				if ($mmSort==='rights'){
					usort($dirF, array($this,'cmpDim'));
					$dirF= $this->sortInSameContext($dirF,$motherDir,'filepermStr');
				}else{
					usort($dirF, array($this,'revCmpDim'));
					$dirF= $this->sortInSameContext($dirF,$motherDir,'filepermStr');
				}
			break;
			
			case 'raw':
				// original file position
			break;
			
			default:
				sort($dirF);
			break;
		} // switch
	} // sortGivenVector
	
	
	/**	
		Sort the same extension space of the extension-sorted-array.$flsVect :
		
			$flsVect : vector of files to do a second sort inside already sorted spaces
			$motherDir : the mother directory of these files, got to set to '' if the function $fls->$propertyFu() can
				apply to the file name alone, like for extensions!
			$propertyFu : $fls->$propertyFu()
	*/
	function sortInSameContext(&$flsVect,$motherDir,$propertyFu){
		$fls= &$this->fls;
		
		$prevExt= false;
		$accumulV= array();
		$curSegmFlV= array();
		reset($flsVect);
		foreach ($flsVect as $key=>$fName){
			$dfn= $motherDir.$fName;
			$curExt= $fls->$propertyFu($dfn);
			if ($prevExt!==$curExt){
				// got a change of extension pack -- sort the accumulated one and transfers
				$prevExt= $curExt;
				sort($curSegmFlV);
				$accumulV= array_merge($accumulV,$curSegmFlV);
				$curSegmFlV= array();
			}
			$curSegmFlV[$key]= $fName;	// accumulation
		}
		
		
		sort($curSegmFlV);
	
		return array_merge($accumulV,$curSegmFlV);
	} // sortInSameContext	
	
	
	
	/**
		Return a file name indexed  vector with values expressed with : date, size, extension etc..
	*/
	function fileNmIndexedV(&$motherDir,&$curFlVect, $flsMethodName){
		$fls= &$this->fls;
		
		$assExtV= array();
		reset($curFlVect);
		foreach ($curFlVect as $k=>$fileN){
			$assExtV[$fileN]= $fls->$flsMethodName($motherDir.$fileN);
		}
		return $assExtV;
	} // fileNmIndexedV
	
	

	/* --------------------------------------------------------------------------------------------------
		Widget belonging to the LAST COLUMN.
			Generalities : they need to access the ids of all the other columns to determine
			some parameters of their actions,
			
			- tg_maction() : Checkboxes actions :
					- Déplacer (from the default start to the default goal if nothing else is selected)
					- Copier (from the default start to the default goal if nothing else is selected)
					- Renommer
					- Dupliquer
					- Nouveau Dossier
					- Archiver
					- Ouvrir Archive
					- Copie Téléchargeable (._ext)
					- Set Permissions (should probably have one combo box with the 27 possibilities "rwx" in
					  		alphabetical order).
					- Effacement Faible
					- Effacement Fort.
					
			- tg_mlocalBrowser() : Calls local browser for hard disc file selection.
			
			- Send button (already defined in the form class).
	*/	
	
	
	/**
		Set the main actions select widget!
		[mAction /] tg_maction
	*/
	function tg_maction(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$rMg= &$this->rights;		
		$wmR= &$this->wmRights;	// access to the webmaster rights class
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$tagsFu= &$this->tagsFu;
		$mmTools= &$this->mmTools;
		
		
		
		$defVal= $mmTools->mainAction(false);
		if ($defVal==='delete'){
			$defVal= 'browse';	// otherwise too risky
		}
		
		/*
			Could add :
				- A local file splitter to upload huge files (like big archives) on fussy servers
		*/
		$vSelect['browse']= $glob->el('Action Menu ...','kadg');
		
		$vSelect['s0']= $glob->el('Basic File Manips :','kadh');
			$vSelect['fileUpload']=$glob->el('Upload a File','kadi');
			$vSelect['move']=$glob->el('Move','kadj').' <--->';
			$vSelect['copy']=$glob->el('Copy','kadk').' <--->';
			$vSelect['rename']=$glob->el('Rename','kadl');
			$vSelect['renameGTB']=$glob->el('Col 1 R. with Gall. TB','kadlNoTrad');	// Using the gallery text boxes
			$vSelect['duplicate']=$glob->el('Duplicate','kadm');
		$vSelect['e0']='';			 	

		$vSelect['s1']=$glob->el('New :','kadt');			 
			$vSelect['newFolder']=$glob->el('Folder','kaeu');
			$vSelect['newTxtFile']=$glob->el('Text File','kaev');
			$vSelect['newNoThumbs']=$glob->el('Thumbs Block','kaew');
		$vSelect['e1']='';			 	

		$vSelect['s6']=$glob->el('Search + :','kaex');
			$vSelect['mmSearch']=$glob->el('In content Fl / Dir','kaey');
			$vSelect['searchInFN']=$glob->el('In File Names','kaez');
			$vSelect['mmShowKB']=$glob->el('Show kBytes of checked Dir','kafa');
		$vSelect['e6']='';	
			
		$mmgDfn= $tagsFu->expliExtClassPath('mmGallery');
		if (file_exists($mmgDfn)){
			$vSelect['s7']=$glob->el('Gallery (left column only) :','kafb');
				$vSelect['mmImposejpg']=$glob->el('Impose .jpg ext for jpegs.','kafc');
				$vSelect['mmGallThmbs']=$glob->el('Thumbs (','kafd')._c_gallThumbWidth.' / '._c_gallThumbHeight.$glob->el(') creation','kafe');
				$vSelect['mmGAllRSzLrg']=$glob->el('Large images (','kaff')._c_gallLargeWidth.' / '._c_gallLargeHeight.$glob->el(') creation','kafg');
				$vSelect['mmGallAdaptNm']=$glob->el('Adapt names all images','kafh');
				$vSelect['mmGallXm']=$glob->el('Xpetal creation','kafi');
				$vSelect['mmGallry']=$glob->el('Gallery Creation (all above)','kafj');
				$vSelect['mmGallryKeep']=$glob->el('Gallery " + Keep originals','kmie');
				$vSelect['mmGallRename']=$glob->el('Remame zoom image','kboh');
			$vSelect['e7']='';
		}
		
		$crHDfn= $tagsFu->expliExtClassPath('setCpyRightHeaders');
		

		$vSelect['s12']=$glob->el('Images basic manips :','kmiq');
			$vSelect['randomImage']=$glob->el('Creates a random images (W,H)','kmiv');
			$vSelect['changeReFlType']=$glob->el('Chg Images Type : (new dir) (+|,| ) (type)','kads'); 
			$vSelect['chgSzSelImg']=$glob->el('Shrinks slct. images, give:(Wmax, Hmax)','kmir');
			$vSelect['chgThumbsSz']=$glob->el('Resizes thumbs of selected img : (W, H)','kmis');
			$vSelect['freeLeftRot']=$glob->el('Rotates left free (90, 180, 270 ...)','kmit');
			$vSelect['cropImage']=$glob->el('Crop x,y: % of borders to remove.','kmiu');
		$vSelect['e12']='';	

		
		

		$vSelect['s2']=$glob->el('Archive (Zip):','kafm');
			$vSelect['archive']=$glob->el('Archive (Build : same col=smaller zip)','kafn');
			$vSelect['opArch']=$glob->el('Archive (Extract)','kafo');
			$vSelect['opArchAll']=$glob->el('Archive (Extract All)','kafp');
			$vSelect['dwnldblCpy']=$glob->el('Downloadable Copy','kafq');
		$vSelect['e2']='';

		$vSelect['s10']=$glob->el('Concatenation :','kbat');
			$vSelect['catBuild']=$glob->el('Build an Ataox "Tar"','kbau');
			$vSelect['catExtract']=$glob->el('Extract an Ataox "Tar"','kbav');
			
			$vSelect['splitFile']=$glob->el('Split a File in N parts','kmhu');
			$vSelect['glueFiles']=$glob->el('Glue a files family (select the first)','kmhv');
		$vSelect['e10']='';
		
		if ( $wmR->accptPrgmerTools() ){
			$vSelect['s11']= $glob->el('Programmer Tools :','kmih');
				$vSelect['updateConstructor']= $glob->el('Update constructors to Php 7 style','kmii');
				$vSelect['rmCpySffxedFiles']= $glob->el('Remove "-cpy" files','kmiw');
		
				/*
					Deal with the most common symbols --- html Name conversion
				*/
				$vSelect['convSymbToHtml']= $glob->el('Convert Comm. Symbols to Html Names','kmhs');
				$vSelect['convHtmlToSymb']= $glob->el('Convert Comm. Html Names to Symbols','kmht');
				
				if ( file_exists($crHDfn) ){
					$vSelect['mmAddJsHd']= $glob->el('Copyrights :','kafk').$glob->el('add Php/JS Header','kafl');
				}
			$vSelect['e11']='';
		} // $wmR->accptPrgmerTools()
		

		$vSelect['s4']=$glob->el('Delete :','kafr');
			$vSelect['trash']=$glob->el('Trash','kafs');
			$vSelect['emptyTrash']=$glob->el('Empty the Trash','kaft');
			
			if ($rMg->suRights()){
				$vSelect['delete']=$glob->el('Strong!','kafu');
				$vSelect['usDelete']=$glob->el('Ultra Strong!','kbid');
				$vSelect['delInside']=$glob->el('Delete Inside directorie(s)','kbnx');
			}
		$vSelect['e4']= '';
			
			
		$vSelect['s5']=$glob->el( 'Rights :','kafv');
		$vSelect['rights']=$glob->el( 'Set Rights','kafw');
		$vSelect['e5']= '';
		
		
		$vSelect['s13']= $glob->el('Rare File Manips :','kiiadh');			
			$vSelect['createTestFls']=$glob->el('Create Test-Files','kbnv');
			$vSelect['removeNLeftCh']=$glob->el('Remove N left chars','kadn');
			$vSelect['removeNRightCh']=$glob->el('Remove N right chars','kado');
			$vSelect['addsLeftCh']=$glob->el('Adds prefix','kadp');
			$vSelect['addsRightCh']=$glob->el('Adds suffix','kadq');
			$vSelect['changeFlType']=$glob->el('Change Str File Type','kadr'); 		
		$vSelect['e13']='';			 	
		
	
		$onlyBrowseCookNm= $tools->spc(_c_mCboxAction);
		$sendFm= $caps->jsFunctCallStr('onChange','mm.sendForm',3,0,'formMM',_c_mCboxAction,$onlyBrowseCookNm); // formMM directly in the DTB user code !!
		$mainActBox= $caps->comboBox(_c_mCboxAction,$defVal,$vSelect,$caps->matCss('mmComboBox').$sendFm,true,true);
		$cmplActBox= '';
		
		switch ($defVal){
			case 'randomImage':
			case 'changeReFlType':
			case 'chgSzSelImg':
			case 'chgThumbsSz':
			case 'freeLeftRot':
			case 'cropImage':
				$vImA= array(
					'ovals' => 'Ovals',
					'stars3' => 'Stars 3',
					'stars4' => 'Stars 4',
					'stars5' => 'Stars 5',
					'stars6' => 'Stars 6',
					'stars7' => 'Stars 7',
					'starsM' => 'Stars Mix',
					'starsF' => 'S. Free (ext. B)',
					'oRect' => 'Ortho Rect',
					'aRect' => 'Any Rect',
					'text' => 'Text',
					
					'clHdTl' => 'Seg. Ln.',
					'clStarC' => 'Seg. c. Star',
					'clStar' => 'Seg. Star',
					'clMix' => 'Seg. Mix'
				);
				
				$defDim= $tools->postVal('imgManipDimTBN','');
				$rndimgDim= $caps->spanTtl('Dim: ','mmRndImgLbl','Facultative dimensions : (width, height) | (rotation) | (width, height, rotation) | (Crop%Width, Crop%Height)').$caps->textBx('imgManipDimTBN',$defDim,15,'mmTextBox');
				
				$defRndImS= $tools->postVal('imgManipStrTBN','');
				$strIter= $caps->spanTtl('Str: ','mmRndImgLbl','Input for the jumbled strings').$caps->textBx('imgManipStrTBN',$defRndImS,16,'mmTextBox');
				
				$defImgIter= $tools->postVal('imgManipIterTBN','');
				$strIter.= $caps->spanTtl('Iter: ','mmRndImgLbl','Facultative iteration specification').$caps->textBx('imgManipIterTBN',$defImgIter,8,'mmTextBox');
				
				$rndimgttl= $caps->spanTtl('Random Images console : ','mmRndImgTtl','A few specialized widgets to draw some pseudo random images. Rem : (have a backup and hit the reload browser button when unsure of the display) : names stay identical after image manipulations and files are directly worked on and compressed each times, therefore multiple operations and reversed operation will accumulate errors quickly. Also note that most browsers are reluctant to reload an image when its name stay the same so hitting the browser reload button helps.');
				
				$stdTtl= $caps->spanTtl('Standard : ','mmRndImgTtl','Standard file manager console')._c_BrFlux;
				
				$dfVal= $mmTools->mainAction(false,'rndImgAction',_c_rndImgDefAction);
				$cmplActBox= _c_BrFlux._c_BrFlux.$rndimgttl._c_BrFlux.$caps->comboBox('rndImgAction',$dfVal,$vImA,$caps->matCss('mmComboBox'),true).$rndimgDim._c_BrFlux.$strIter._c_BrFlux._c_BrFlux.$stdTtl;
			break;
						
			default:;
		} // switch
		
		return $mainActBox.$cmplActBox;
	} // tg_actionCombo
		

	/**
		Display the down directory tree of the main (receiving) column up to a limit of
		lim directories, 
			Clicking updates the receiving column.
			Got to stabilize the receiving radio-but with a cookie
		
		tg_dirtree()	[dirTree lim="100" /]
	*/
	function tg_dirtree(&$v,&$bd){
		$glob= &$this->glob;	
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;					
		$tagsFu= &$this->tagsFu;
		
		
		$id= $v['id'];
		$glob->scanDirTreeLim= $v['lim'];
		$glob->dirTreeWidthBrFn= $tools->binLoads($v['bfn'],'20');	// breaks file name
		$glob->dirTreeItemcss= $tools->binLoads($v['itemcls'],'itemMTree');
		
		
		$glob->scanDirTreeCnt= 0;
		$srcPath= $tools->fullPathStr($id);
		$dirTree= $fls->dsplDirTree($srcPath,0,'');
		if ($dirTree===''){
			return '';
		}else{
			if ($glob->scanDirTreeCnt>=$glob->scanDirTreeLim){
				$overLoad= '+';
			}else{
				$overLoad= '';
			}		
		
			$dirTreeLbl= $glob->es('Directory Tree','kams');
			$buff= $this->pathUp($id).$caps->div('(** '.$glob->scanDirTreeCnt.$overLoad.') '.$dirTreeLbl.':','mmInfoLblSt');
			$buff.= _c_.$dirTree;
		}
		
		if ($glob->scanDirTreeCnt>=$glob->scanDirTreeLim){
			$buff.= _c_.$caps->div($caps->div($glob->el('The Folders Tree is too large to be displayed completely, please zoom inside for a deeper display.','kmeg'),'userWarn'),'colMTree');
		}
		
		return $buff;
	} // tg_dirTree


	/**
		To manage the particular rights of a specified entity (o,g,w) matching the specified file(s) 
		with the specified deepness. Got to use 2 triplets (1st for directories and 2nd for files).
		[mRightAtom name="selectDirOwner" belongs="o" cls="mmAtomRight" /]
	*/
	function tg_mRightAtom(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;			
		
		$vPrfx= $fls->vectPermStr();
		$vSffx= array(
			'0'=>'|0',	// 000
			'1'=>'|1',	// 001
			'2'=>'|2',	// 010
			'3'=>'|3',	// 011
			'4'=>'|4',	// 100
			'5'=>'|5',	// 101
			'6'=>'|6',	// 110
			'7'=>'|7'	// 111
			);
			
		$vSelect= $tools->horizStrMerge($vPrfx,$vSffx);
		$name= $v['name'];
		$cls= $v['cls'];
		$ownership= $v['belongs'];	// Owner, Group or World  (o,g,w)
		
		$default= $tools->binLoads($v['default'],'7');
		$name= $v['name'];
		$default= $tools->trimPostVal($name,$default);
		return $caps->comboBox($name,$default,$vSelect,$caps->matCss($cls),true);
	} // tg_mRightAtom


	/**		
		Just get the user file manager bookmarks
	*/
	function tg_fmbookmarks(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		return $tagsFu->incldOnce('_mainFmBookM');
	} // tg_fmbookmarks


	/**
		To set the default path for the forum bar general picture examination and choice.
		Default forum bar path [deFumBarPath /]
	*/
	function tg_defumbarpath(&$v,&$bd){
		$glob= &$this->glob;
		$rights= &$this->rights;
		
		if ($rights->wRights===false){
			return '';
		}
		
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		$dFBP=$tools->getVal('deFumBarPath');
		if ($dFBP===_c_ok){
			$pathI= _c_mFilePathPrfx.'1';	// path one fully clickable
			$chosenDir= $tools->gostVal($pathI);
			$dtb->setGenVar('fumFreeSetGallPath',$chosenDir.'/');	// act on its own signal!
		}

		$url= $tools->sameUrl();
		$url.= $tools->addUrlVar('deFumBarPath',_c_ok);
		
		$imgDFn= _c_EditorImgPath.'homeFreeFiles.png';
		return $caps->lnImg($imgDFn,$glob->el('Fast browser ..','kach'),'','lz', '',$url);
	} // tg_defumbarpath


	/**
		[mmSearchResult /]
	*/
	function tg_mmsearchresult(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$mmTools= &$this->mmTools;
		
		$seWords= trim($tools->postVal('newName'));	// search word(s)
		$action= $tools->trimPostVal(_c_mCboxAction);
		if ($action==='mmSearch' || $action==='searchInFN'){
			$stl= 'width:1110px; padding:10px; margin-right:0px; margin-left:0px; margin-top:2px; border: 1px solid black;';
			if ($seWords==='' || $mmTools->searchFinalStr===''){
				$res= $caps->sDiv($caps->span($glob->el('The search did not find any match!','kmeh'),'mmSearchTtl'),$stl);
			}else{
				$nb= $mmTools->searchTotNb;
				$nbL= $mmTools->searchTotLines;
				$averLnyFl= round($nbL / $nb); 	//	nb average Lines / File
				$mess= $glob->el('Search result(s)','kblp');
				
				if ($tools->postVal('statChkBox')===_c_ok && $action==='mmSearch'){
					$statInfos= $nbL.$glob->el(' lines. Average line/file =','kmei').$averLnyFl;
				}else{
					$statInfos= '';
				}
				$res= $caps->sDiv($caps->span($mess.' ('.$nb.' files, '.$statInfos.') :','mmSearchTtl').$mmTools->searchFinalStr,$stl);
				
			}
			
			return $res;
		}
		
		return '';
	} // tg_mmsearchresult
	
	/**
	*/
	function formatRum(){
		return '';
	
	
		$glob= &$this->glob;
		
		$rum= $glob->returnUserMess();
		if ($rum!==''){
			$rum= _c_BrFlux.$rum._c_BrFlux;
		}
		return $rum;
	} // formatRum


	/**
		Display the gallery xm2 file code.
		[galleryXmCode /]
	*/
	function tg_galleryxmcode(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$mmTools= &$this->mmTools;
		
		$action= $mmTools->mainAction();	
		$mmgDfn= $tagsFu->expliExtClassPath('mmGallery');	// to test the presence of the mmGallery class!
		if ( $this->galleryXmSqrAdapt($action) && file_exists($mmgDfn) ){
			$mmGall= $mmTools->instancMmGal();
			return $mmGall->xmCode();
		}
	} // tg_galleryxmcode
	
	
	/**
		[mmBigChunk column="1" /]
		[mmBigChunk column="2" /]
		nextPict.png
	*/
	function tg_mmbigchunk(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$mmBoxes= &$this->mmBoxes;
		
		$column= $v['column']; // column index
		
		if ($column==='1' && !$this->allowChunkButtons1){
			return '';
		}
		
		if ($column==='2' && !$this->allowChunkButtons2){
			return '';
		}
		
		$edtImg= $v['img'];
		$incr= $v['incr'];	// increase or not ... ok / ko
		
		$imgDFn= $fls->editorImage($edtImg);
		
		$szChunk= $dtb->getGenVar('mmSizeDirFlsChunk','4000'); //default ... maximum cluster of $szChunk files AND directories
		
		if ($incr===_c_ok){
			$alt= $glob->el('Go on the next group of','kbny');
		}else{
			$alt= $glob->el('Go on the previous group of','kboa');
		}
		
		$alt.= ' '.$szChunk.' ';
		$alt.= $glob->el('Files or directories, the size can be adapted with ','kbnz');
		$alt.= ' mmSizeFlsChunk ';
		$alt.= $glob->el(' of the genVar table ...','kbnu');
		
		$uvChunk= 'mmDFChunkPos'.$column;
		$ar[$uvChunk]= _c_ko;	// so forget the old value!
		$url= $mmBoxes->getNewUrl('','',$ar);
		$dfChunkPos= (int)$tools->getVal($uvChunk);
		
		$szChunk= (int)$szChunk;
		if ($dfChunkPos===0){
			if ($incr===_c_ko){
				return '';	// decrease button when already at 0, so don't want to show the button
			}
			$dfChunkPos= $szChunk;	// start there because already dspl the 0th part
		}else{
			if ($incr===_c_ok){
				if ($dfChunkPos >= $this->memRawFlDrNb){
					return '';	// don't want to show the increase button
				}
				
				$dfChunkPos= $dfChunkPos + $szChunk;
			}else{
				$dfChunkPos= $dfChunkPos - $szChunk;
			}
		}
		$url.= $tools->addUrlVar($uvChunk,$dfChunkPos);
		return $caps->linkImg($imgDFn,$alt,$url,'lz');
	} // tg_mmbigchunk
	
	
} // mediaManager
?>