/**
	File name : mm.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**
*/
function mm(){

	/* ---------------------------------------------------------------
		Global variable for the "class"
	*/
	var crLn= "\r\n";
	
	/* ---------------------------------------------------------------
		Methods interface.
	*/

	this.checkCbxOnEvent= checkCbxOnEvent;
	this.checkCbx= checkCbx;
	this.checkGroup= checkGroup;
	this.checkAllColBx= checkAllColBx;
	this.upperNoHyphen= upperNoHyphen;
	this.changeMmMode= changeMmMode;
	this.changeSortingMode= changeSortingMode;
	
	
	this.adaptAction= adaptAction;
	this.adaptStatAction= adaptStatAction;
	
	this.sendForm= sendForm;
	this.setSevenRights= setSevenRights;
	this.setNoRights= setNoRights;
	this.setNoWrRight= setNoWrRight;
	this.setStdRights= setStdRights;
	
	this.write= write;
	this.writeLn= writeLn;
	this.clearWrite= clearWrite;

	/* -----------------------------------------------------------------------
		Methods definitions
	*/	

	/**
	*/
	function setSevenRights(){
		setGenRights('7','7','7','7','7','7');
		adaptAction('mCboxAction','rights');
	} // setSevenRights

	/**
	*/
	function setNoRights(){
		setGenRights('0','0','0','0','0','0');
		adaptAction('mCboxAction','rights');
	} // setNoRights

	/**
	*/
	function setNoWrRight(){
		setGenRights('5','5','5','5','5','5');
		adaptAction('mCboxAction','rights');
	} // setNoWrRight

	/**
		Set standard rights.
	*/
	function setStdRights(){
		setGenRights('7','5','5','6','4','4');
		adaptAction('mCboxAction','rights');
	} // setStdRights


	/* --------------------------------------
	*/
	function adaptStatAction(){
		adaptAction('mCboxAction','mmSearch');
		document.getElementById('statChkBox').checked= 'ok';
	}; // adaptStatAction


	/* --------------------------------------
	*/
	function adaptAction(comboId,action){
		var list= document.getElementById(comboId);
		list.value = action;
	}; // adaptAction



	/**
	*/
	function setGenRights(a,b,c,d,e,f){
		 document.getElementById('selectDirOwner').value= a;
		 document.getElementById('selectDirGroup').value= b;
		 document.getElementById('selectDirWorld').value= c;
		 
		 document.getElementById('selectFileOwner').value= d;
		 document.getElementById('selectFileGroup').value= e;
		 document.getElementById('selectFileWorld').value= f;
		 
		 document.getElementById('mmApplySubF').checked= 'ok';
	} // setGenRights



	/* ---------------------------------------------------------------------------------
	*/
	function checkCbxOnEvent(event,cId){
	   	if (event.shiftKey){
	   		checkCbx(cId,false,true);
	  	}
	}; // checkCbx


	/* ---------------------------------------------------------------------------------
	*/
	function checkCbx(cId,val1,val2){
	  	ptCid= document.getElementById(cId);
	  	if (ptCid!==null){
	  		state= ptCid.checked;
		  	if (state){
		   		document.getElementById(cId).checked=val1;
		  	}else{
		   		document.getElementById(cId).checked=val2;
		  	}
	  	}
	}; // checkCbx



	/* ---------------------------------------------------------------------------------
	*/
	function checkGroup(base,size,onOff){
		for (var i=0; i<size ;i++){
	  		var cbId= base + '_' + i;
	  		
	  		if (onOff==='ok'){
	  			checkCbx(cbId,true,true);
	  		}else{
	  			checkCbx(cbId,false,false);
	  		}
		}
	}; // checkGroup


	/* ---------------------------------------------------------------------------------
		Check/uncheck all the check boxes of the given column
	*/
	function checkAllColBx(baseDir,baseFl,colIdx,onOff){
		if (colIdx==='1'){
			sizeDir= chkDir1Sz;
			sizeFl= chkFile1Sz;
		}else{
			sizeDir= chkDir2Sz;
			sizeFl= chkFile2Sz;
		}

		checkGroup(baseDir,sizeDir,onOff);
		checkGroup(baseFl,sizeFl,onOff);
	}; // checkAllColBx
	
	
	/* ---------------------------------------------------------------------------------
	*/	
	function upperNoHyphen(baseFl){
		sizeDir= chkDir1Sz;
		sizeFl= chkFile1Sz;

		upperNoHyph(baseFl,sizeFl);
	}; // upperNoHyphen
	
	function upperNoHyph(base,size){
		for (var i=0; i<size ;i++){
	  		var cbId= base + '_' + i;
	  		
		  	ptCid= document.getElementById(cbId);
		  	if (ptCid!==null){
			   	var taName= 'ta1' + ptCid.value;
			   	
			   	taName= taName.replace(/\./g,'');	// suppress the dot to access the real name/id of the current TA box
			   	
			   	ptChange= document.getElementById(taName);
			   	if (ptChange!==null){
				   	var strToChange= ptChange.value;
				   	
				   	strToChange= strToChange.replace(/-/g,' ');
				   	// strToChange= kk.toTitleCase(strToChange);
				   	
				   	document.getElementById(taName).value= strToChange;
			   	}
		  	} // if
		} // for
	}; // upperNoHyph

	/* --------------------------------------
		Got to :
			- Reacts on the click in the select box
			- Set the cookie on the new mode.
	*/
	function changeMmMode(selId,cookName,curUrl){
		list= document.getElementById(selId);
		newMode= list.options[list.selectedIndex].value;
		genAsa.createCookie(cookName,newMode,1);
		location.href= curUrl + '&mmMode='+newMode;
	}; // changeMmMode
	
	
	function changeSortingMode(selId,cookName,curUrl){
		list= document.getElementById(selId);
		newMode= list.options[list.selectedIndex].value;
		genAsa.createCookie(cookName,newMode,1);
		location.href= curUrl + '&mmSort='+newMode;
	}; // changeSortingMode
	
	
	/* --------------------------------------
	*/
	function sendForm(frmId,comboId,onlyBrowseCookNm){
		if (document.getElementById(comboId).value!=='browse'){
			document.getElementById(frmId).submit();
		}else{
			genAsa.createCookie(onlyBrowseCookNm,'browse',1);
		}
	}; // sendForm


	/* --------------------------------------------
		"Cloned" methods for usage easiness 
	*/
	function write(s){kk.write(s);}
	function writeLn(s){kk.writeLn(s);}
	function clearWrite(s){kk.clearWrite(s);}


} // mm
