<?php
/**
	File name : mmBoxes.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Media manager boxes (group the main functions usable outside MM and in pactice most of it are "boxes"), to display
	folders, file icons, check boxes etc. Could group also some other basic MM functions usable elswhere!
	
	
		function fileCheckBoxLine(&$szDsplImg,$id,$motherDir,$fileName,$fileCbxName,$i,$forceMode=false)
			mmBoxes::fileCheckBoxLine()
		
		function dirCheckBoxLine($id,$motherDir,$sonDir,$dirCbxName,$i)
		
*/
class mmBoxes extends oTop{
	

	function __construct(&$tagsFu,&$imgP,&$mmTools){
		parent::__construct();
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;		
		$this->rights= &$tagsFu->rights;
		$this->wmRights= &$tagsFu->wmRights;	// access to the webmaster rights class
				
		$this->dtb= &$tagsFu->dtb;		
		$dtb= &$this->dtb;
		
		$this->glob->loadsMediaMgPt($this);		
		$this->imgP= &$imgP;
		$this->mmTools= &$mmTools;
		
		$this->avatarConditions= false;
		$this->globGalleryImgI= 0;
		
		define('_c_mCboxAction', 'mCboxAction');
		
		// Visibles Modes
		define('_c_mSmplVisMode', 'simple');
		define('_c_mDetVisMode', 'details');
		define('_c_mImgVisMode', 'thumbs');
		define('_c_mGalVisMode', 'gallery');
		
		
		define('_c_linuxShellPathPfxOn', $dtb->getGenVar('linuxShellPathPfxOn') );	// optim.
		
		$this->oneColumnMode= false;
		
		
		
		$this->breakableFlNmSz= $dtb->getGenVar('breakableFlNmSz',36);
		$this->breakableDrNmSz= $dtb->getGenVar('breakableDrNmSz',36);
	} // construct


	/**
	*/
	function uploadsz($sz){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;

		if ($sz!==false){
			return $caps->maxUploadSize($sz);
		}else{
			return $caps->maxUploadSize();
		}
	} // uploadsz


	/**
		Should use kk.adaptCombo() instead of mm.adaptAction()  (redondant)
	*/
	function mlocalBrowser($name, $size, $cls){
		$caps= &$this->caps;
		$jsUp= $caps->jsFunctCallStr('onclick','mm.adaptAction',2,0,_c_mCboxAction,'fileUpload');
		return $caps->localFileBrowser($name,$size,$caps->matCss($cls).$jsUp);
	} // mlocalBrowser
	

	/**
	*/
	function getMmMode(){
		$tools= &$this->tools;	
		$mmTools= &$this->mmTools;	

		$act= $mmTools->mainAction();	
		if ($this->isGalleryAction($act)){
			$mode= _c_mGalVisMode;
		}else{
			$mode= $tools->getVal('mmMode');
		}
		
		if ($mode!==false){
			$tools->spcSetCook('mSdtMode',$mode);
			return $mode;
		}else{
			return $tools->spcUTrigCook('mmMode','mSdtMode');
		}
	} // getMmMode
	
	
	/**
		return true if it's e gallery action
	*/
	function isGalleryAction($act){
		switch ($act){
			case 'mmImposejpg':
			case 'mmGallThmbs':
			case 'mmGAllRSzLrg':
			case 'mmGallAdaptNm':
			case 'mmGallXm':
			case 'mmGallry':
			case 'mmGallryKeep':
			case 'mmGallRename':
			case 'renameGTB':	// not really a gallery action but need the gallery text boxes so the fallery mode
				return true;
			break;
			
			default: 
				return false;
		}
	} // isGalleryAction

	
	/**
	*/
	function detailledInfos(&$fileLTC,$supInfo,$type,$fileName,$url,$curCkBox,$ext,$txtWidth,$insiblWarn=''){
		$caps= &$this->caps;
		$imgP= &$this->imgP;		
		$fls= &$this->fls;		
	
		$fInfos= '';
		if ($type==='f'){
			$fInfos.= $caps->font($fls->kbFileSz($url),'lz')._c_BrFlux;
		}
		
		$fInfos.= $caps->font($fls->dateStr($url),'lz')._c_BrFlux;
		$fInfos.= $caps->font($fls->ownerStr($url),'lz')._c_BrFlux;
		$fInfos.= $caps->font($fls->rightsStr($url),'lz')._c_BrFlux;
		if ($insiblWarn!==''){
			$fInfos.= $caps->font($insiblWarn,'lz')._c_BrFlux;
		}
		
						
		if ($imgP->imgOkToDspl($ext)){
			$size= getimagesize($url);
			$fInfos.= $caps->font('Size width : '.$size[0].'px, height : ' .$size[1].' px','lz');
		}
		
		$fInfos= $caps->div($fInfos,'colMFullInfo');	
		$buff= $caps->simTCellXL($supInfo.$fileLTC._c_BrFlux.$fInfos,$txtWidth)._c_R;
		$buff.= $caps->simTCellXL($curCkBox,'fltCkBxClick')._c_R;
		return $buff;
	} // detailledInfos


	/**
		Return true if we can fully use the thumbs.
	*/
	function usesThmbs($dir,$motherDir){
		$dtb= &$this->dtb;
		return $dir!==_c_thumbsDirN && !$this->gotDelAction() && $dtb->getGenVar('globStopThumbs')!==_c_ok && 
			is_writable($motherDir) && !file_exists($motherDir.'zzNoThumbsDir.txt');
	} // usesThmbs
	
	
	/**
		Return true if we have a delet action.
	*/
	function gotDelAction(){
		$tools= &$this->tools;
		$action= $tools->trimPostVal(_c_mCboxAction);
		return $action==='delete' || $action==='trash'; 
	} // gotDelAction


	/**
		Returns a html image with stretched dimentions (in all cases with correct proportions).
		Rem : for speed $imgUrl must already be about in thumbs dimentions
	*/
	function visiPlusThumbs($imgUrl,$localUrl,$alt){
		$caps= &$this->caps;
		$imgP= &$this->imgP;
		
		$iSz= getimagesize($imgUrl);
		$sDL= $imgP->scaleDownLinear($dsplWidth,$dsplHeight,$iSz[0],$iSz[1],_c_dsplThumbsW,_c_dsplThumbsH);
		if ($sDL===false){
			return false;
		}
		
		if ($localUrl===false){
			// print('$imgUrl='.$imgUrl._c_);
			return $caps->image($imgUrl,$alt,'mmThumbsCls','','','',$dsplWidth,$dsplHeight);
		}else{
			// print('$localUrl='.$localUrl._c_);
			return $caps->image($localUrl,$alt,'mmThumbsCls','','','',$dsplWidth,$dsplHeight);
		}
	} // visiPlusThumbs


	/**
		Imposes the new path (if given), on the url related to the given id.
			Input :
				$id [1|2] : identification of the "column" or element belonging to that column.
				$newPath : the newly calculated path depending on $id and some other conditions depending
					on the widget, for example jumping : up the path; down the path; anywhere; and even not moving
					in the case of a file examination.
			
			$this->getNewUrl($id,$newPath);	$this->getNewUrl();	
	*/
	function getNewUrl($id='',$newPath='',$ar=false){
		$tools= &$this->tools;	
	
		$upv1= $tools->urlPathVar(1);	// n urlPathVar
		$upv2= $tools->urlPathVar(2);
		$cstPath1= $tools->fullPathStr(1);
		$cstPath2= $tools->fullPathStr(2);
		
		if ($newPath===''){
			// status quo
			return $tools->urlCurPg($ar).$tools->addUrlVar($upv1,$cstPath1).$tools->addUrlVar($upv2,$cstPath2);
		}
		
		if ((string)$id==='1'){
			$ar['mmDFChunkPos1']= _c_ko;
			$url= $tools->urlCurPg($ar).$tools->addUrlVar($upv1,$newPath).$tools->addUrlVar($upv2,$cstPath2);
		}else{
			$ar['mmDFChunkPos2']= _c_ko;
			$url= $tools->urlCurPg($ar).$tools->addUrlVar($upv1,$cstPath1).$tools->addUrlVar($upv2,$newPath);
		}
		
		return $url.$tools->urlEnd();
	} // getNewUrl
	
	function getNewTwinUrl($id,$newPath){
		$tools= &$this->tools;	
	
		$upv1= $tools->urlPathVar(1);
		$upv2= $tools->urlPathVar(2);
		$cstPath1= $tools->fullPathStr(1);
		$cstPath2= $tools->fullPathStr(2);
				
		if ((string)$id==='1'){
			$ar['mmDFChunkPos1']= _c_ko;
			$chk2= $tools->getVal('mmDFChunkPos2');
			$url= $tools->urlCurPg($ar).$tools->addUrlVar($upv1,$newPath).$tools->addUrlVar($upv2,$cstPath2);
			$url.= $tools->addUrlVar('mmDFChunkPos1',$chk2);
		}else{
			$ar['mmDFChunkPos2']= _c_ko;
			$chk1= $tools->getVal('mmDFChunkPos1');
			$url= $tools->urlCurPg($ar).$tools->addUrlVar($upv1,$cstPath1).$tools->addUrlVar($upv2,$newPath);
			$url.= $tools->addUrlVar('mmDFChunkPos2',$chk1);
		}
		
		return $url.$tools->urlEnd();
	} // getNewTwinUrl
	
	

	/**
		Returns one line with the current directory+links + checkbox
			Input :
				$motherDir : the above full path to have a meaningfull url.
				$fileName : current file to display.
				$fileCbxName : generic name of the checkbox vector : $dirCbxName.'[]'
				$id : 1 (left column) or 2 (right column)
				$i : index of the widget from 0 to nbWidget-1
				$forceMode : force image / detailled or standard mode.
				$oC : one Column sacenario
			Output :
				$szDsplImg : current file size (only for the displayed (thumb most of the time) images).
				Returns a full line with directory to click, check box to fill and
	*/
	function fileCheckBoxLine(&$szDsplImg,$motherDir,$fileName,$fileCbxName,$id,$i,$forceMode=false){
		$tagsFu= &$this->tagsFu;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$imgP= &$this->imgP;
		$mmTools= &$this->mmTools;
		
		if ($i===0){
			// any first element --> init the gallery comptor
			$this->globGalleryImgI= 0;
		}
		
		$mManager= $tagsFu->explicitClasses['mediaManager'];
		$globMmGall= &$mManager->globMmGall;
		
		
		
		
		$szDsplImg= 0;
		$curFlCbxName= $fileCbxName.$id.'_'.$i;
		$onMO= $caps->jsFunctCallStr('onmouseover','mm.checkCbxOnEvent',2,1,'event',$curFlCbxName);	// shift-over mouse option	
		$curCkBox= $caps->checkBox($curFlCbxName, $fileName, '', $onMO.$caps->matCss('mmInCheckBx') );
		
		
		$fls->splitOnLastC($fileName,$FnLeft,$FnExt,'.');
		$url= $motherDir.$fileName;
		$codedUrl= $motherDir.rawurlencode($fileName);
		
		$locUrl= $codedUrl;	// rest of $fls->genPathAdaptation(...) now on blackboard
		if ($forceMode===false){
			$mmMode= $this->getMmMode();
		}else{
			$mmMode= $forceMode;
		}
		
		$fls->splitOnLastC($fileName,$left,$ext,'.');
		
		// Editing icon
		$txtEdtLn= $mmTools->callEditor($codedUrl);
		
		// Exec process & icon depending on a general config variable
		if (_c_linuxShellPathPfxOn===_c_ok){
			// WOULD NEED TO SHORT CIRCUIT SOME LOCAL PROTECTIONS
			$execCFN= $tools->getVal('execCurFN');
			if ($execCFN!==false && $execCFN===$fileName){
				$lsPath= $dtb->getGenVar('linuxShellPathPfx');
				$execFileDFN= $tools->getVal('execCurDFN');
				$execStr= '/usr/bin/gimp '.$lsPath.$execFileDFN._c_R;
				$output= shell_exec('/home/.../code/test/start.sh');	// To complete
			}
			
			$execUrl= $tools->sameUrl();
			$execUrl.= $tools->addUrlVar('execCurDFN',$url);
			$execUrl.= $tools->addUrlVar('execCurFN',$fileName);
			
			$rocketPth= $fls->editorImage('rocket.png');
			$rocketImg= $caps->simplestImg($rocketPth,'Launch application',$caps->matCss('mmFileChkBoxLn'));
			$lauchLn= $caps->linkTC($execUrl,$rocketImg,'Launch application','mmFileChkBoxLn');
		}else{
			$lauchLn= '';
		}
		
		$dsplFN= $this->breakAndWarn($supMess,$fileName,$this->breakableFlNmSz);
		$ttl=  $supMess.$fls->genFileInfos($url);				
		switch ($mmMode){
			default: // so keeps the simple mode as default		
			case _c_mSmplVisMode:
				$fileLTC= $caps->linkTC($locUrl,$dsplFN,$ttl,'mmFileChkBoxLn','_blank')._c_R;
				$buff= $txtEdtLn.$lauchLn.$fileLTC.$caps->div($curCkBox,'fltCkBxClick')._c_R;				
			break;
			
			case _c_mDetVisMode:
				$fileLTC= $caps->linkTC($locUrl,$dsplFN.'&nbsp;: ',$fileName,'mmFileChkBoxLn','_blank')._c_R;
				$buff= $this->detailledInfos($fileLTC,$txtEdtLn,'f',$dsplFN,$url,$curCkBox,$ext,'colMText',$supMess);
			break;
			
			case _c_mImgVisMode:			
			case _c_mGalVisMode:
				$fileLTC= $caps->linkTC($locUrl,$dsplFN,$ttl,'mmFileChkBoxLn','_blank')._c_R;
				if ($imgP->imgOkToDspl($ext)){
					$mumDir= $fls->removeLastChar($motherDir); 	// last / removed
					$fls->splitOnLastC($mumDir,$path,$dir,'/');
					
					$thumbsDir= $motherDir._c_thumbsDirN;
					$usesThumbs= $this->usesThmbs($dir,$motherDir);
					if ( $usesThumbs ){
						// We are not in the thumbs dir., so uses the thumbs for the display. + makes sure a thumb dir exists
						if (!is_dir($thumbsDir)){
							$fls->wMkDir($thumbsDir);
						}
						
						$thumbUrl= $thumbsDir.'/'.$fileName;
						if (!is_file($thumbUrl)){
							$szDsplImg= filesize($url);
							$q= $dtb->getGenVar('gallImgQuality');
							if ($mmMode===_c_mImgVisMode){
								$imgP->resizeProc($locUrl,$thumbUrl,_c_thumbsWidth,_c_thumbsHeight,$q);	// BUILD THE THUMBS
							}else{
								$imgP->resizeProc($locUrl,$thumbUrl,_c_gallThumbWidth,_c_gallThumbHeight,$q);
							}
						}else{
							$szDsplImg= filesize($thumbUrl);
						}
						
						$img= $this->visiPlusThumbs($thumbUrl,false,$ttl);
					}else{
						$img= $this->visiPlusThumbs($url,$locUrl,$ttl);
						$szDsplImg= filesize($url);
					}
					
					$imgLTC= $caps->linkTC($locUrl,$img,$ttl,'mmThumbsCls','_blank');
					$buff= $caps->simTCellLrg($imgLTC, $this->oneColAdapt('colMThumbs')) ._c_R;
					
					switch ($mmMode){
						case _c_mImgVisMode:
							$szImg= getimagesize($url);
							$thTxt= $fileLTC._c_BrFlux.
								$caps->font('Dim : '.$szImg[0].' x '.$szImg[1],'mmFileChkBoxLn')._c_BrFlux.
								$caps->font($fls->kbFileSz($url),'mmFileChkBoxLn');
							
							$buff.= $caps->simTCellLrg($thTxt, $this->oneColAdapt('colMThbText') )._c_R;
							
							$buff.= $caps->simTCellLrg($curCkBox,'fltCkBxClick')._c_R;
						break;
						
						case _c_mGalVisMode:
							$curTxNm= $this->taSafeNmForNewName($fileName,$id);
							
							$attS= $caps->matCss('mmGallTxt');
							
							$fls->splitOnLastC($fileName,$fn,$ext,'.');
							
							$xmDfn= $globMmGall->xmFileDfn();
							if ( file_exists($xmDfn) && $dtb->getGenVar('galXm2InTxtBx')===_c_ok ){
								$textBx= $caps->textarea($curTxNm,'3','27',$globMmGall->globBD[$this->globGalleryImgI],$attS);
								$this->globGalleryImgI++;
							}else{
								$boxFiller= str_replace ('-',' ',$fn);
								$textBx= $caps->textarea($curTxNm,'3','27',$boxFiller,$attS);
							}
							
							$buff.= $textBx.$caps->div($curCkBox,'mmInCheckBx')._c_R;
						break;
					}
					
				}else{
					$buff= $this->detailledInfos($fileLTC,$txtEdtLn,'f',$dsplFN,$url,$curCkBox,$ext,'colMText');
				}
				
			break;
			
		} // switch
		
		return $caps->div($buff, $this->oneColAdapt('linePackage') )._c_BrFlux._c_R;
	} // fileCheckBoxLine
				
				
	/**
		Breaks $str if too long and warn about hidden extreme invible chars. That may have appeared because of funny writing style etc.
	*/
	function breakAndWarn(&$supMess, $str, $width=31){
		$glob= &$this->glob;
		$fls= &$this->fls;
		
		$supMess= '';
		$szR= strlen($str); // raw
		$strT= trim($str);
		$szT= strlen($strT);
		
		$add= '';
		$delta= $szR-$szT;
		if ($delta!==0){
			$add= '('.$delta.')';
			$supMess= '('.$delta.' '.$glob->el('Invisible character(s) at extremitie(s).','kbnf').') ';
		}
		
		return $fls->breakableFN($add.$str,$width);
	} // breakAndWarn
	
	
	/**
		One column scenario adaptation
	*/
	function oneColAdapt($cls){
		if ($this->oneColumnMode){
			return $cls.'Oc';
		}else{
			return $cls;
		}
	} // oneColAdapt
	
	/**
	*/
	function oneColumn(){
		$this->oneColumnMode= true;
	} // oneColumn
	
	

	/**
		For the gallery text array returns a safe name.
		Input :
			$fn : file name with extension.
			$id : id of the column (1 or 2)
	*/
	function taSafeNmForNewName($fn,$id){
		$fls= &$this->fls;
		$mmTools= &$this->mmTools;
		
		/*
			if ($action==='mmGallry') .... Actually must be done in advance of the action, so just impose it !! Normally ok in all case because 
			it's a text box name and case of identical filenames with just a different jpg kind of extension can be 
			considered as non reaonable / current.
		*/
		$fn= $fls->imposeFnjpg($fn);	
		return 'ta'.$id.$fls->safeIdString($fn);
	} // taSafeNmForNewName
	

	/**
		Returns one line with the current directory+links + checkbox
			Input :
				$id : the current column identification
				$motherDir : the above full path to have a meaningfull url.
				$sonDir : current directory to display.
				$dirCbxName : generic name of the checkbox vector : $dirCbxName.'[]'
				$i : index of the widget.
			Output :
				Returns a full line with directory to click, check box to fill and
	*/
	function dirCheckBoxLine($id,$motherDir,$sonDir,$dirCbxName,$i, &$nbForbid){	
		$tagsFu= &$this->tagsFu;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$rMg= &$this->rights;	
		$wmR= &$this->wmRights;
		
			
		$dirName= $motherDir.$sonDir;
		$dirCodedName= $motherDir.rawurlencode($sonDir);
		
		if ($wmR->globallyForbidPath($dirName.'/')){
			$nbForbid++;
			return '';
		}
		
		$dsplSD= $this->breakAndWarn($supMess,$sonDir,$this->breakableDrNmSz);
		$ttl=  $supMess.$fls->genFileInfos($dirName,$sonDir);
		$url= $this->getNewUrl($id, $dirCodedName);		
		if ($sonDir===_c_dustbinName && $rMg->isAtRootUserDir($motherDir)){
			$folderPath= $fls->editorImage('trash.png');		
		}else{
			$folderPath= $fls->editorImage('folder.png');	
		}
		
		if ($this->isALink($sonDir)){
			if ($this->butLnState()){
				$fn= $dirName.'/ln.txt';
				$txtLn= $fls->fileToStr($fn);
				$folder= $tagsFu->expand($txtLn);	// pseudo folder, the link itself, font : mmFolderLink
				return $caps->div($folder,'linePackage')._c_BrFlux._c_R;
			}else{
				$folder= $caps->linkTC($url, $caps->simplestImg($folderPath,'',$caps->matCss('lz')), $ttl,'mmDirChkBoxLn');
			}	
		}else{
			$folder= $caps->linkTC($url, $caps->simplestImg($folderPath,'',$caps->matCss('lz')), $ttl,'mmDirChkBoxLn');
		}
		
		
		if ($dirCbxName!==false){
			$onMO= $caps->jsFunctCallStr('onmouseover','mm.checkCbxOnEvent',2,1,'event',$dirCbxName.'_'.$i);
			
			$chkBxNm= $dirCbxName.'_'.$i;
			$curCkBox= $caps->checkBox($chkBxNm,$sonDir,'',$onMO.$caps->matCss('inCheckBox'));
			
			$gotKbSize= false;
			$curAction= $tools->postVal(_c_mCboxAction);
			if ($curAction==='mmShowKB'){
				$curCbxVal= $tools->postVal($chkBxNm);
				if ($curCbxVal!==false){
					$this->szCurrentlyAnlFl= 0;	// size of the currently analyzed file
					$fls->scanWholeDir($dirName,$this,'sizeCurDir',false);
					$gotKbSize= true;
				}
			}
		}else{
			$curCkBox='';
		}
	
		$mmMode= $this->getMmMode();				
		switch ($mmMode){
			default:	
				$buff= $caps->simTCellSml($folder,'colMFolder')._c_R;	
				$sonDirTc= $caps->linkTC($url,$dsplSD,$ttl,'mmDirChkBoxLn')._c_R;
				
				if ($gotKbSize){
					$suppl= $caps->span( $fls->fromByteSz($this->szCurrentlyAnlFl),'mmFolderSz');
				}else{
					$suppl= '';
				}
				
				$buff.= $caps->simTCellSml($sonDirTc.$suppl,'colFoldTxt')._c_R;
				if ($curCkBox!==''){
					$buff.= $caps->simTCellSml($curCkBox,'fltCkBxClick')._c_R;
				}
			break;
		
			case 'details':
				$buff= $caps->simTCellXL($folder,'colMFolder')._c_R;				
				$fileLTC= $caps->linkTC($url,$dsplSD.'&nbsp;: ',$dirName,'mmDirChkBoxLn','_top')._c_R;
				if ($curCkBox!==''){				
					$buff.= $this->detailledInfos($fileLTC,'','d',$dsplSD,$dirName,$curCkBox,'','colFoldTxt');
				}					
			break;
		}
		
		return $caps->div($buff,'linePackage')._c_BrFlux._c_R;
	} // dirCheckBoxLine


	/**
		A parameter function : accumulates the size of the passing files!
	*/
	function sizeCurDir($curDir){
		$this->szCurrentlyAnlFl+= filesize($curDir);
	} // sizeCurDir
	
	
	/**
		Button Link states. Returns true if the link state is on!
	*/
	function butLnState(){
		$tools= &$this->tools;
		return $tools->biModeButState('linkState');
	} // butLnState

	/**
		Returns true if the folder name is a link! ___L is reserved for that!
	*/
	function isALink($dirN){
		$tools= &$this->tools;
		return $tools->sIsSuffixB('___L',$dirN);
	} // isALink
	
} // mmBoxes
?>