<?php
/**
	File name : mmTools.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Tools for the file/media manager.
	
	On going :
		n renameGTB(
*/
class mmTools extends oTop{
	

	function __construct(&$mMng,&$tagsFu,&$imgP){
		parent::__construct();	
		$this->mMng= &$mMng;
		$this->rMg= &$mMng->rights;
		
		$this->tagsFu= &$tagsFu;
		$this->imgP= &$imgP;
		
		$this->asa= &$tagsFu->asa;		
		$this->glob= &$tagsFu->glob;
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;		
		$this->fls= &$tagsFu->fls;	
		$this->dtb= &$tagsFu->dtb;	
		$this->searchFinalStr= '';
		$this->searchTotNb= 0;
		$this->searchTotLines= 0;
	} // construct
	

	/**
		Used for multiple calls of mmGallery! 
			!!! May look for a solution to call this only once ?
	*/
	function instancMmGal(){
		$tagsFu= &$this->tagsFu;
		$mmMg= &$this->mmMg;
				
		$mmGall= $tagsFu->instExplitExternalCls('mmGallery');
		$mmGall->loadsMmMg($mmMg);
		return $mmGall;
	} // instancMmGal
	
	

	/**
	*/
	function loadsMmBoxes(&$mmBoxes){
		$this->mmBoxes= &$mmBoxes;	
	} // loadsMmBoxes

	/**
	*/
	function loadsMmMg(&$mmMg){
		$this->mmMg= &$mmMg;	
	} // loadsMmBoxes



	/**
	*/
	function mainAction($onlyPost=true, $cbName=_c_mCboxAction, $defVal=false){
		$tools= &$this->tools;
	
		$defVal= $tools->trimPostVal($cbName,$defVal);
		if ($onlyPost){
			if ($defVal===false){
				return 'browse';
			}else{
				return $defVal;
			}
		}
		
		if ($defVal===false){
			// try to get the cookie
			$defVal= $tools->spcCookVal($cbName);
			if ($defVal===false){
				$defVal= 'browse';
			}
		}else{
			// set the cookie
			$tools->spcSetCook($cbName,$defVal);
		}
	
		return $defVal;
	} // mainAction


	/**
		Return the new name (or default) specified inside the media manager newName textbox.
	*/
	function returnNewName($def='defaultName'){
		$newName= $this->newNameVal('');	// '' just to make sure (avoid a false if a browser behaved differently than Firefox)
		if (trim($newName)===''){
			$newName= $def;
		}
		return $newName;	
	} // returnNewName
	
	/**
	*/
	function newNameVal($val=false){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		if ( $dtb->getGenVar('fullFileNameTrim')===_c_ok ){
			return $tools->trimPostVal('newName',$val);	
		}else{
			return $tools->postVal('newName',$val);	
		}
	} // newNameVal

	/**
	*/
	function newTxtFile($pushedPath,$newName){
		$glob= &$this->glob;
		$fls= &$this->fls;
				
		if ($newName===''){
			$newName= 'newTextFile.txt';
		}
		
		$fName= $pushedPath.'/'.$newName;		
		if ($fls->okOrNewName($fName,2)){
			$fls->strToFile($fName,'Hello World');
		}else{
			$glob->userError('Tried too many iterations to generate a file name!','kmcc');
		}
	} // newTxtFile
	

	/**
	*/
	function createTestFls($pushedPath){
		$glob= &$this->glob;
		$fls= &$this->fls;
		$dtb= &$this->dtb;

		$sz= (int)$dtb->getGenVar('createTestFlsNb',10);
		$inSz= (int)$dtb->getGenVar('createTstFlsInNb',5);
		$maxSz= (int)$dtb->getGenVar('createTestFlsMax',1000);
		if ($maxSz<($sz*$inSz+$sz)){
			$glob->userError('...greater than the allowed maximum...','kboc');
			return false;
		}
		
		for ($i=0; $i<$sz; $i++){
			$dName= $pushedPath.'/testD'.$i;		
			$fls->wMkDir($dName);
			$this->fillsTestDir($dName,$inSz);
		} // for
		
		for ($i=0; $i<$sz; $i++){
			$fName= $pushedPath.'/testF'.$i.'.txt';		
			$fls->strToFile($fName,'test');
		} // for
	} // createTestFls
	

	/**
	*/
	function fillsTestDir($dirPath,$sz){
		$fls= &$this->fls;

		for ($i=0; $i<$sz; $i++){
			$fName= $dirPath.'/inF'.$i.'.txt';		
			$fls->strToFile($fName,'tst');
		} // for
	} // createTestFls
	
	
	
	
	
	
	function newFolder($pushedPath,$newName){
		$glob= &$this->glob;
		$fls= &$this->fls;
		
		if ($newName===''){
			$newName= 'newFolder';
		}
						
		$target= $pushedPath.'/'.$newName;
		if ($fls->okOrNewDirName($target,2)){
			$fls->wMkDir($target);
		}else{
			$glob->userError('Tried too many iterations to generate a directory name!','kmcb');
		}
	} // newFolder
	
	/**
	*/
	function rename($origPath,$fdName){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		$newName= $this->newNameVal();
		$fls->secureRename($origPath,$fdName, $origPath,$newName);
	} // rename	

	function mMove($origPath,$targetPath,$fdName,$chkSide){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$newName= $tools->trimPostVal('newName');
		if (strlen($newName)>0){	// must test the length ---> can't compare with false because the box is always sent so false does not appear
			$targetN= $newName;
		}else{
			$targetN= $fdName;
		}
		
		$fls->secureRename($origPath,$fdName, $targetPath,$targetN);
	} // mMove

	/**
	*/
	function mCopy($origPath,$targetPath,$fdName,$chkSide){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$newName= $tools->trimPostVal('newName');
		if (strlen($newName)>0){
			$targetDFN= $targetPath.$newName;
		}else{
			$targetDFN= $targetPath.$fdName;
		}
		
		$fls->copyFileOrDir($origPath.$fdName, $targetDFN);
	} // mCopy


	/**
		Return a full path vector or false.
	*/
	function fullPathVect($path,$sonV){
		if (is_array($sonV)){
			$i=0;
			reset($sonV);
			foreach ($sonV as $key=>$son){
				$fullPathV[$i]= $path.$son;
				$i++;
			}
						
			return $fullPathV;
		}else{
			return false;
		}
	} // fullPathVect


	/**
		Merges the two given array if they are arrays indeed and returns as much array as possible
	*/
	function coreDefensiveMerge(&$v1,&$v2,&$info){
		if (is_array($v1)){
			if (is_array($v2)){
				$mergeV= array_merge($v1,$v2);
				$mergeV= array_unique($mergeV);	// elimination of copies
				$info='b';	// both
				return $mergeV;
			}else{
				$info='1';
				return $v1;
			}
		}else if (is_array($v2)){
			$info='2';
			return $v2;
		}else{
			$info='0';
			return false;
		}
	} // coreDefensiveMerge


	function defensiveMerge($v1,$v2){
		$info='';
		return $this->coreDefensiveMerge($v1,$v2,$info);
	} // defensiveMerge
	
	
	/**
		Builds and returns the indicated check box vector.
			Input :
				$base : 'chkDir1', 'chkFile1' etc.
				$size of the vector to retrieve.
		$this->checkBoxVector('chkDir1','chkDir1Sz');
	*/
	function checkBoxVector($baseCbx){
		$tools= &$this->tools;	
	
		$sizeName= $baseCbx.'Sz';
		$size= $tools->postVal($sizeName);
		$j=0;
		for ($i=0; $i<$size; $i++){
			$elem= $tools->postVal($baseCbx.'_'.$i);
			if ($elem!==false){
				$v[$j]=$elem;
				$j++;				
			}
		}
		
		if ($j>0){
			return $v;
		}else{
			return false;
		}
	} // checkBoxVector

	
	
	/**
		Loads the column vectors matching the checked checkboxes.
		Input : the spewcified posted values
		Output : the specified vectors
		Call :
			$this->loadChkCbxVect($vD1,$vF1,$vD2,$vF2);
			
		Remark : the full Path option is usefull for example when we want to work on all checked 
		"files" independently from the column or the type (dir or file) as in a rename case, because
		it make comparaison and elimination of duplicatas easier, basically allows to work on a single
		merged and controled vector.
	*/
	function loadOriginalCbxVect(&$vD1,&$vF1,&$vD2,&$vF2,$motherDir1='',$motherDir2=''){
		$tools= &$this->tools;
	
		$vD1= $this->checkBoxVector('chkDir1'); // chkDir1_1
		
		$vF1= $this->checkBoxVector('chkFile1');
		$vD2= $this->checkBoxVector('chkDir2');
		$vF2= $this->checkBoxVector('chkFile2');
		
		if ($motherDir1!==''){
			$vD1= $this->fullPathVect($motherDir1,$vD1);
			$vF1= $this->fullPathVect($motherDir1,$vF1);
		}
		
		if ($motherDir2!==''){		
			$vD2= $this->fullPathVect($motherDir2,$vD2);
			$vF2= $this->fullPathVect($motherDir2,$vF2);
		}
	} // loadOriginalCbxVect


	/**
		Returns directories and files with their path.
	*/
	function pathDF(&$allPhDir,&$allPhFiles){
		$tools= &$this->tools;

		$motherDir1= $tools->trimPostVal('motherDir1');
		$motherDir2= $tools->trimPostVal('motherDir2');
						
		$this->loadOriginalCbxVect($vPhD1,$vPhF1,$vPhD2,$vPhF2,$motherDir1,$motherDir2);
		$allPhDir= $this->defensiveMerge($vPhD1,$vPhD2);
		$allPhFiles= $this->defensiveMerge($vPhF1,$vPhF2);				
	} // pathDF
	
	
	/**
		Apply a variable function on a specific set of check box vvector.
		
		Names :
			$vD1 : vector directory (1) left column. (2) right column
			$vPhD1 : vector directory (1) left column with path in cluded. (2) right column with path.
			
		Input :
			$fuName : name of the method to call.
			$scanType : type of columns-checkboxes scanning.
			$vectStatus : status of the vectors to load : 
				'path' : 	Loaded with the full access path for the files and directories. (calculates only these ones)
				'nopath' : 	Does not append the paths.
				'no' : 	does not loads any vector.
				
		Note : instead of this big switch, could have defined separated scanning functions of the
		check boxes, then call them into each specific function! Possibly a good idea to migrate
		toward this cleaner approch. Could just build a new class for new functionalities and see
		how it works, could then substitute the methods when a change is necessary.
		
		today focus : renameGTB($origPath,$fdName)
	*/
	function applyFuOnCbxVect($fuName,$scanType,$vectStatus='path'){
		$glob= &$this->glob;	
		$tools= &$this->tools;
		$mMng= &$this->mMng;
		$gotOne= false;
			
			
		$motherDir1= $tools->trimPostVal('motherDir1');
		$motherDir2= $tools->trimPostVal('motherDir2');
		
		if ($mMng->firstColumn()){
			$selectedMotherDir= $motherDir1;
		}else{
			$selectedMotherDir= $motherDir2;
		}
		
		if ($vectStatus==='path'){
			$this->loadOriginalCbxVect($vPhD1,$vPhF1,$vPhD2,$vPhF2,$motherDir1,$motherDir2);
			$allPhDir= $this->defensiveMerge($vPhD1,$vPhD2);
			$allPhFiles= $this->defensiveMerge($vPhF1,$vPhF2);
		}else if ($vectStatus==='nopath'){
			$this->loadOriginalCbxVect($vD1,$vF1,$vD2,$vF2);	// path not included!
			$allLeft= $this->defensiveMerge($vD1,$vF1);
			$allRight= $this->defensiveMerge($vD2,$vF2);
		}
		
		
		switch ($scanType){
			case _c_mmCbxFiles:	// all files
				if (!is_array($allPhFiles)){
					$glob->userError('This action is done only with files!','kmbn');
					return false;
				}
				
				reset($allPhFiles);
				foreach ($allPhFiles as $key=>$val){
					$this->$fuName($val);	// eg: mmGallery
				}
			break;
		
			case _c_mmCbxDir:	// all dir
				if (!is_array($allPhDir)){
					$glob->userError('This action is done only with directories!','kmbo');
					return false;
				}			
			
				reset($allPhDir);
				foreach ($allPhDir as $key=>$val){
					$this->$fuName($val);
				}
			break;
	
			/**
			*/
			case _c_mmCbxPhAll:	// with path, all dir and files separated
				$this->onFilesAndDirs($fuName,$allPhDir,$allPhFiles,$vectStatus==='path');
			break;
				
			case _c_mmCbxNmAll:	
				$allDir= $this->defensiveMerge($vD1,$vD2);
				$allFiles= $this->defensiveMerge($vF1,$vF2);
				$this->onFilesAndDirs($fuName,$allDir,$allFiles,$vectStatus==='path');
			break;


			case _c_mmSpecialArchive:	// with path, all dir and files separated
				$this->archiveGivenDF($allPhDir,$allPhFiles,$selectedMotherDir);
			break;

			case _c_mmSpecOpenArch:
				$this->opArch($allPhFiles,$selectedMotherDir);
			break;

			case _c_mmSpecOpenArchAll:
				$this->opArch($allPhFiles,$selectedMotherDir,true);
			break;
			
			case _c_mmSpecialCat:	// with path, all dir and files separated
				$this->concatDF($allPhDir,$allPhFiles,$selectedMotherDir);
			break;

			case _c_mmSpecOpenCat:
				$this->openCat($allPhFiles,$selectedMotherDir);
			break;

			case _c_mmCbxFirst:			
				/*
					Special case : Takes only the 1st element. Not the most economical way to proceed, but if the user
					act normally and check only one element it's allright., and otherwise, they'll learn quickly.
				*/			
				$allFD= $this->coreDefensiveMerge($allLeft,$allRight,$info);
				if (is_array($allFD)){
					$sz= sizeof($allFD);
				}else{
					$sz= 0;
				}
				if ($sz===1 && $info==='1' || $info==='2'){
					if ($info==='1'){
						$this->$fuName($motherDir1,$allLeft[0]);
					}else{
						$this->$fuName($motherDir2,$allRight[0]);
					}
				}else{
					$glob->userError('Please, check a single element!','kmbp');
					return false;
				}	
			break;
		
			case _c_mmCbxLeft:	// (column 1)
				if (!is_array($allLeft)){
					$glob->userError('At least one check box of the left column must be checked!','kmbq');
					return false;
				}			
			
				$origPath= $motherDir1;
				$targetPath= $motherDir2;
				reset($allLeft);
				foreach ($allLeft as $key=>$fdName){
					$this->$fuName($origPath,$targetPath,$fdName,_c_mmCbxLeft);
				}
			break;
		
			case _c_mmCbxRight: // (column 2)
				if (!is_array($allRight)){
					$glob->userError('At least one check box of the right column must be checked!','kmbr');
					return false;
				}			
			
				$origPath= $motherDir2;
				$targetPath= $motherDir1;
				reset($allRight);
				foreach ($allRight as $key=>$fdName){
					$this->$fuName($origPath,$targetPath,$fdName,_c_mmCbxRight);
				}
			break;			
		
			default:
				$this->topErr('mmTools::applyFuOnCbxVect');	// nothing to do
		}
	} // applyFuOnCbxVect


	function concatDF(&$dirs,&$files,$selectedMotherDir){
		$asa= &$this->asa;
		$glob= &$this->glob;	

		include _c_LibPath . 'cncatFiles.php';
		$ctFl= new cncatFiles($asa);

		$iad= is_array($dirs);
		$iaf= is_array($files);
		
		if (!$iad && !$iaf){
			$glob->userError('Nothing was selected!','kmbs');
			return false;								
		}

		$newName= $this->returnNewName('newConcat');		
		$destination= $selectedMotherDir.$newName.'.tar';
		
		$ctFl->concatDirectory($dirs,$files, $selectedMotherDir,$destination);
	} // concatDF
	
			
	function openCat(&$allPhFiles,$destDir){
		$asa= &$this->asa;
		$glob= &$this->glob;	
		$fls= &$this->fls;	
		
		include _c_LibPath . 'cncatFiles.php';
		$ctFl= new cncatFiles($asa);
		
		if (!is_array($allPhFiles)){
			$glob->userError('At least one concatenated file must be selected!','kmbt');
			return false;
		}
		
		reset($allPhFiles);
		foreach ($allPhFiles as $key=>$pathFN){
			$destDir= $fls->removeLastChar($destDir);
			$ctFl->expandCatFile($pathFN,$destDir);
		}
	} // openCat			


	/**
	*/
	function trash($fullPath,$scanAction,$gotPaths){
		$glob= &$this->glob;		
		$fls= &$this->fls;
		
		$fls->splitOnLastC($fullPath,$left,$fileName);	
		$fls->secureRename($left.'/',$fileName, $glob->newTrashDir.'/',$fileName);
		
		// Delete the thumbs if it exists
		$thumb= $left.'/'._c_thumbsDirN.'/'.$fileName;
		if (file_exists($thumb)){
			$fls->unLnk($thumb);
		}
	} // trash
	
	
	/**
	*/
	function emptyTrash(){
		$fls= &$this->fls;
		$rMg= &$this->rMg;
		
		$dustPath= $rMg->userDustPath().'/';
		$fls->firstLevelDir($vDir,$dustPath);
		$fls->firstLevelFiles($vFl,$dustPath);
		$vTot= array_merge($vDir,$vFl);		
		
		reset($vTot);
		foreach ($vTot as $key=>$file){
			$fls->secureRemoveDir($dustPath.$file);
		}		
	} // emptyTrash


	/**
		Open the specified archives in simple or multiple extraction mode.
	
		$multiZipExtraction=false : keep the original zip
		$multiZipExtraction=true : :
			- Scan what was opened and try to extract further archives.
			- Remove the original zip after extraction! To avoid infinite extraction loop 
			---> extract only if got the right to remove it
	*/
	function opArch(&$allPhFiles,$destDir,$multiZipExtraction=false){
		$glob= &$this->glob;	
		$fls= &$this->fls;
		
		if (!is_array($allPhFiles)){
			$glob->userError('At least one zip file must be selected!','kmbu');
			return false;
		}
		
		$gotOneOpenAll= false;
		reset($allPhFiles);
		foreach ($allPhFiles as $key=>$pathFN){
			$fls->splitOnLastC($pathFN,$left,$extension,'.');
			if ($extension==='zip'){
				if ($multiZipExtraction){
					if ($fls->isOwner($pathFN)){
						$gotOneOpenAll= true;
						
						if ($fls->dirGotOneFile($destDir)){
							$fls->countOpArc= 0;
							$fls->opAllArchives($destDir,$pathFN);
						}else{
							$glob->userError('To open an archive, the directory must hold only the archive itself!','kmif');
						}
						
					}
				}else{
					$fls->openOneArch($destDir,$pathFN);
				}
			}else{
				$glob->userError( $glob->el('Only .zip files must be selected, so ','kmbv') .$pathFN. $glob->el(' is not of the correct type.','kmbw') );
				return false;				
			}
		}
		
		if ($gotOneOpenAll){
			$fls->renameTmpZip($destDir);
		}
	} // opArch


	/**
		Special for archive management.
			Input :
				$dirs : vector of directories to add.	
				$files : vectors of files to add.
	*/
	function archiveGivenDF(&$dirs,&$files,$selectedMotherDir){
		$fls= &$this->fls;
		$glob= &$this->glob;	
		$tools= &$this->tools;
		$mMng= &$this->mMng;
		

		$iad= is_array($dirs);
		$iaf= is_array($files);
		
		if (!$iad && !$iaf){
			$glob->userError('Nothing was selected!','kmbs');
			return false;								
		}
		

		if ($iad && sizeof($dirs)===1 && !$iaf){
			// take the name of the selected unique directory
			$fls->splitOnLastC($dirs[0],$left,$right,'/');
			$defaultName= $right;
		}else if ($iaf && sizeof($files)===1 && !$iad){
			// take the name of the selected unique file
			$fls->splitOnLastC($files[0],$left,$fnWithExt,'/');
			$fls->splitOnLastC($fnWithExt,$fn,$ext,'.');
			$defaultName= $fn;
		}else{
			$defaultName= 'newArchive';
		}

		$newName= $this->returnNewName($defaultName);
		$destination= $selectedMotherDir.$newName.'.zip';
		
		if ($fls->okOrNewName($destination,'2')){}else{
			$glob->userError( $glob->el('Too difficult to generate an archive based on ','kmbx').$newName.
				$glob->el(', please try another base for the file name.','kmby') );
			return false;
		}
					
		$fls->openCloseArch($zip,'open',$destination);
		$glob->szComPrfxArchP= $mMng->sizeComPrfxPath();	// used globally in subAddToArch	
		
		if ($iad){
			reset($dirs);
			foreach ($dirs as $key=>$dir){
				$fls->scanDirToArch($dir,$glob->szComPrfxArchP);
			}
		}
		
		if ($iaf){						
			reset($files);
			foreach ($files as $key=>$file){
				$fls->subAddToArch($file,$glob->szComPrfxArchP);
			}
		}

		$fls->openCloseArch($zip,'close');
	} // archiveGivenDF
	
	
	/**
	*/
	function delete($fullPath,$scanAction,$gotPaths){
		$fls= &$this->fls;
		$fls->secureRemoveDir($fullPath);
		
		// Delete the thumbs if it exists
		$fls->splitOnLastC($fullPath,$left,$fileName);
								
		$thumb= $left.'/'._c_thumbsDirN.'/'.$fileName;
		if (file_exists($thumb)){
			$fls->unLnk($thumb);
		}		
	} // delete

	
	/**
	*/
	function usDelete($fullPath,$scanAction,$gotPaths){
		$fls= &$this->fls;
		$fls->ultraRemoveDir($fullPath);
	} // usDelete

	
	/**
	*/
	function delInside($srcPath,$scanAction,$gotPaths){
		$glob= &$this->glob;	
		$fls= &$this->fls;
		
		$fls->coreRmDirKeepRecurs= true;
		$fls->ultraRmOn= true;
		
		if (!is_readable($srcPath)){
			$glob->userError( $glob->el('The directory ','kays').$srcPath.$glob->el(' is not readable!','kayt') );
			return false;
		}
	
		if ( $handle = $fls->locOpDir($srcPath) ){
			while (($file= readdir($handle)) !== false){
				if ($file!='.' && $file!='..'){
					$dfn= $srcPath.'/'.$file;
					$fls->coreRemoveDir($dfn);
				}
			} // while
			closedir($handle);
		}
		
	} // delInside


	/**
		Creates a downloadable copy.
			- Only applies on files.
			- If the same file is selected twice ? ... same problem with duplication, 
			  including directories, archive etc. So better to program an algo returning
			  only different global file + directrory names (better to store the whole path : easier to remove twins)
	*/
	function dwnldblCpy($pf){
		$this->duplicateFile($pf,'pseudoTar');
	} // dwnldblCpy


	/**
	*/
	function duplicate($fullPath,$scanAction,$gotPaths){
		switch ($scanAction){
			case _c_mmCbxDir:
				$this->duplicateDir($fullPath);
			break;
			
			case _c_mmCbxFiles:
				$this->duplicateFile($fullPath,'straightCopy');
			break;
			
			default: $this->topErr('mmTools::duplicate');
		}
	} // duplicate
	
	
	/**
		Direct renaming from the Gallery Text Boxes.
		called from n applyFuOnCbxVect( and then n onFilesAndDirs(  and then
		
			$this->$fuName($file,_c_mmCbxFiles,$gotPaths);
			taSafeNmForNewName($fn,$id)
			
	function renameGTB($fullPath,$scanAction,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		
		
		print('renameGTB');
		return;
		
		// $newName= $this->newNameVal();
		// $fls->secureRename($origPath,$fdName, $origPath,$newName);
	} // renameGTB
			
	*/
	
	
	/**
	*/
	function mmSearch($fullPath,$scanAction,$gotPaths){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$seWords= trim($tools->postVal('newName'));
		if ($seWords!==''){
			switch ($scanAction){
				case _c_mmCbxDir:
				case _c_mmCbxFiles:
					$fls->scanWholeDir($fullPath,$this,'treatSearFile');	// To call treatSearFile.
				break;
				
				default: $this->topErr('mmTools::mmSearch');
			}
		}
	} // mmSearch
	
	/**
		A parameter function : To apply to a single searched file $dfn, if the searched word $seWord is found in the file,
		then add the full file path and file name into an array to display later.
	*/
	function treatSearFile($dfn){
		if (is_dir($dfn)){
			return;
		}
	
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;

		$statCkBx= $tools->postVal('statChkBox');
		$extTB= trim($tools->postVal('extensionTB'));
		$gotExt= false;
		if ($extTB!=='' && $extTB!=='*'){
			$extTB= $tools->fullTrimAndSep($extTB);
			$extV= $tools->mbExplode($extTB);
			$gotExt= true;
		}
		
		$fls->splitOnLastC($dfn,$path,$fName,'/');
		$fls->splitOnLastC($fName,$fN,$ext,'.');
		if (!$gotExt || $gotExt && in_array($ext,$extV)){
		
			$seWords= trim($tools->postVal('newName'));
			if ($seWords!=='*'){
				if ($this->quotedStr($seWords)){
					$wordV[0]= $this->trimExternByte($seWords);
				}else{
					$seWords= $tools->fullTrimAndSep($seWords);
					$wordV= $tools->mbExplode($seWords);
				}
				$curFlStr= $fls->fileToStr($dfn);
			}
			
			if ($seWords==='*' || $tools->sVectIsInB($wordV,$curFlStr)){
				// Got a match for $dfn
				$edtUrl= $tools->urlGivenPage('_edit-file').$tools->addUrlVar(_c_uVarEdtDFn,$dfn);
				$curLink= $caps->hL($edtUrl,$fName.' ','mmSearchResult','_blank',$dfn);
				$this->searchFinalStr.= $curLink;
				$this->searchTotNb++;
				
				if ($statCkBx===_c_ok){
					// line count
					if ($seWords==='*'){
						$curFlStr= $fls->fileToStr($dfn);
					}
					$this->searchTotLines+= substr_count($curFlStr,_c_nL);
				}
			}
		}
	} // treatSearFile


	/**
		Return true if the given string is surounded by double quotes.
	*/
	function quotedStr($s){
		$s= trim($s);
		if ($s[0]==='"'){
			$sz= strlen($s);
			return $s[$sz-1]==='"';
		}
		return false;
	} // quotedStr

	
	/**
		To remove 2 extreme double quotes supposing they exist (for an already spaces-trimed string).
	*/
	function trimExternByte($s){
		return substr($s, 1, -1);
	} // trimExternByte


	/**
	*/
	function searchInFN($fullPath,$scanAction,$gotPaths){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$seWords= trim($tools->postVal('newName'));
		if ($seWords!==''){
			switch ($scanAction){
				case _c_mmCbxDir:
				case _c_mmCbxFiles:
					$fls->scanWholeDir($fullPath,$this,'searchInFileName');	// To call treatSearFile.
				break;
				
				default: $this->topErr('mmTools::mmSearch');
			}
		}
	} // searchInFN
	
	
	/**
		Create a new class for programmer specific tasks .......
	*/
	function updateConstructor($fullPath,$scanAction,$gotPaths){
		$tagsFu= &$this->tagsFu;
		$fls= &$this->fls;
		
		// --> false --> hasnt got any tag --> does not need the tags() function
		$tagsFu->instExplitExternalCls('programmerTools',false); 
		$progTools= new programmerTools($tagsFu);
	
		$fls->scanWholeDir($fullPath,$progTools,'updateContructorToPhpSeven');
	} // updateConstructor
	
	
	function rmCpySffxedFiles($fullPath,$scanAction,$gotPaths){
		$tagsFu= &$this->tagsFu;
		$fls= &$this->fls;
		
		$tagsFu->instExplitExternalCls('programmerTools',false);
		$progTools= new programmerTools($tagsFu);
	
		$fls->scanWholeDir($fullPath,$progTools,'rmCpySffxedFiles');
	} // rmCpySffxedFiles
	

	/**
		A parameter function : To apply to a single searched file $fl, if the searched word $seWord is found in the file,
		then add the full file path and file name into an array to display later.
	*/
	function searchInFileName($dfn){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$mmBoxes= &$this->mmBoxes;
		
		$extTB= trim($tools->postVal('extensionTB'));
		$gotExt= false;
		if ($extTB!=='' && $extTB!=='*'){
			$extTB= $tools->fullTrimAndSep($extTB);
			$extV= $tools->mbExplode($extTB);
			$gotExt= true;
		}
		
		$fls->splitOnLastC($dfn,$path,$fName,'/');
		$fls->splitOnLastC($fName,$fN,$ext,'.');
				
		if (!$gotExt || $gotExt && in_array($ext,$extV)){
			$seWords= trim($tools->postVal('newName'));
			if ($seWords!=='*'){
				$seWords= $tools->fullTrimAndSep($seWords);
				$wordV= $tools->mbExplode($seWords);
				
				if ($extTB==='' || $extTB==='*'){
					$curFlStr= $fName;	// search inside the full file name
				}else{
					// No point to also search inside the extension when the user gave a specific one!
					$curFlStr= $fN;	// search inside the file name base
				}
			}
			
			if ($seWords==='*' || $tools->sVectIsInB($wordV,$curFlStr)){
				// Got a match for $dfn
				$isAnImage= $fls->imgOkToDspl($ext);
				if (is_dir($dfn) || $isAnImage ){
					if (is_dir($dfn)){
						$fName.= '/';	// so we can see it's a directory !
						$curDfn= $dfn;
					}
					
					if ($isAnImage){
						$curDfn= $path;
					}
					
					$edtUrl= $mmBoxes->getNewUrl('1',$curDfn);	// calls the file manager for an ok access to the element
				}else{
					$edtUrl= $tools->urlGivenPage('_edit-file').$tools->addUrlVar(_c_uVarEdtDFn,$dfn);
				}
				
				$curLink= $caps->hL($edtUrl,$fName.' ','mmSearchResult','_blank',$dfn);
				$this->searchFinalStr.= $curLink;
				$this->searchTotNb++;
			}
		}
	} // searchInFileName

	
	function mmImposejpg($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmImposejpg($fileDFN);
	} // mmImposejpg

	function mmGallThmbs($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGallThmbs($fileDFN);
	} // mmGallThmbs

	function mmGAllRSzLrg($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGAllRSzLrg($fileDFN);
	} // mmGallThmbs

	function mmGallAdaptNm($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGallAdaptNm($fileDFN);
	} // mmGallThmbs

	function renameGTB($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->renameGTB($fileDFN);
	} // renameGTB

	function mmGallXm($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGallXm($fileDFN);
	} // mmGallXm

	function mmGallry($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGallry($fileDFN);
	} // mmGallry

	function mmGallryKeep($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGallryKeep($fileDFN);
	} // mmGallryKeep

	function mmGallRename($fileDFN){
		$mmGall= $this->instancMmGal();
		$mmGall->mmGallRename($fileDFN);
	} // mmGallRename
	
	
	
	
	
	/**
	*/
	function getQuality(){
		$tools= &$this->tools;	

		$quality= trim($tools->postVal('extensionTB'));
		if ($quality===''){
			return 50;
		}
		
		$quality= (int)$quality;
		if (!($quality>=0 && $quality<=100)){
			$quality= 50;
		}
		
		return $quality;
	} // getQuality
	
	/**
	*/
	function mainInputStrToVect($str){
		$tools= &$this->tools;	

		if ($tools->sIsInB(',',$str)){
			// we have a comma separator
			$v= $tools->trimStoV($str);
		}else{
			// we have a space separator
			$v= $tools->trimStoV($str,' ');
		}
		// $v===false; 	// in case of empty string		
		
		if ($v!==false && count($v)===1){
			/* So when 2 dimensions are necessary, giving only one, means for exmpl. a square
			   and avoid a major display of php errors. */
			$v[1]= $v[0];
		}
		
		return $v;
	} // mainInputStrToVect
	

	/**
	*/
	function chgSzSelImg($fileDFN){
		$glob= &$this->glob;	
		$tools= &$this->tools;	
		$imgP= &$this->imgP;
		
		$quality= $this->getQuality();
		
		$whCombi= $tools->prefPostVal('imgManipDimTBN','newName');
		if ($whCombi===false){
			$glob->userError('Nothing done! You must enter a comma (or space) separated width and height inside the below larger text box!','kmin');
			return;
		}else{
			$v= $this->mainInputStrToVect($whCombi);
			$w= $v[0];
			$h= $v[1];
		}
		
		$imgP->resizeProc($fileDFN,$fileDFN, $w,$h, $quality);
	} // chgSzSelImg


	/**
	*/
	function freeLeftRot($fileDFN){
		$glob= &$this->glob;	
		$tools= &$this->tools;	
		$fls= &$this->fls;	
		$imgP= &$this->imgP;
		
		$fls->splitOnLastC($fileDFN,$path,$fn);
		$thumsPath= $path.'/'._c_thumbsDirN;
		if ($fls->fileExist($thumsPath)){
			$thumbDFN= $thumsPath.'/'.$fn;
			$fls->secUnlink($thumbDFN);	// Get rid of the thumb !!
		}
		
		$quality= $this->getQuality();
		
		$whCombi= $tools->prefPostVal('imgManipDimTBN','newName');
		$whCombi= $tools->binLoads($whCombi,90,'');
		
		if ( $whCombi==='?' || !$tools->onlyDigits($whCombi[0]) ){
			$glob->userHelp('Input convention for the main text box : width, height, rotation or rotation alone...','kmio');
			return;
		}else{
			$v= $this->mainInputStrToVect($whCombi);
			if ($v===false){
				$v[0]= 90;
			}
			
			$sz= count($v);
			switch ($sz){
				case 1:		// just a rotation
				case 2:
					$angle= $v[0];
					$imgP->rotLeftProc($fileDFN,$quality,$angle);
				break;

				case 3:		// resizing and rotation
					$w= $v[0];
					$h= $v[1];
					$angle= $v[2];
					$rDst= $imgP->resizeProc($fileDFN,$fileDFN, $w,$h, $quality);
					$imgP->rotLeftPrc($rDst,$fileDFN,$quality,$angle);
				break;
				
				default:
					$glob->userError('Only one or three parameters please!','kmip');
					return;
				break;
			} // switch
		}
	} // freeLeftRot
	
	
	/**
	*/
	function cropImage($fileDFN){
		$glob= &$this->glob;	
		$tools= &$this->tools;	
		$fls= &$this->fls;	
		$imgP= &$this->imgP;
		
		$imSzV= getimagesize($fileDFN);
		$origW= $imSzV[0];
		$origH= $imSzV[1];
		
		$quality= $this->getQuality();
		
		$cropTuple= $tools->prefPostVal('imgManipDimTBN','newName',1);
		$v= $this->mainInputStrToVect($cropTuple);
		$prctW= $v[0]/100;
		$prctH= $v[1]/100;
		
		// calculate the rect as a function of a given relative % of lateral removal
		$rect['x']= $origW*$prctW/2;
		$rect['y']= $origH*$prctH/2;
		$rect['width']= $origW-$origW*$prctW;
		$rect['height']= $origH-$origH*$prctH;
		$imgP->cropImage($fileDFN,$quality,$rect);
	} // cropImage
	
	
	/**
	*/
	function randomImage($pushedPath){
		$tools= &$this->tools;	
		$imgP= &$this->imgP;

		$szTuple= $tools->prefPostVal('imgManipDimTBN','newName');
		if ( $szTuple===false || !$tools->onlyDigits($szTuple[0]) ){
			$dimV[0]= 800;
			$dimV[1]= 600;
		}else{
			$dimV= $this->mainInputStrToVect($szTuple);
		}
		
		$imgP->randomCmplxImage($pushedPath,$dimV);
	} // randomImage
	

	function instancCprHeader(){
		$tagsFu= &$this->tagsFu;
		$mmMg= &$this->mmMg;
				
		$cprHd= $tagsFu->instExplitExternalCls('setCpyRightHeaders');
		return $cprHd;
	} // instancCprHeader

	
	/**
		Applied on JS or Php files.
	*/
	function mmAddJsHd($fileDFN){
		$cprHd= &$this->instancCprHeader();
		$cprHd->addCprHeader($fileDFN);
	} // mmAddJsHd
	

	/**
		Apply a variable function on 2 vectors of files and directories.
	*/
	function onFilesAndDirs($fuName,&$dirs,&$files,$gotPaths=true){
		$glob= &$this->glob;	
		$gotOne= false;
	
		if (is_array($dirs)){
			reset($dirs);
			foreach ($dirs as $key=>$dir){
				$this->$fuName($dir,_c_mmCbxDir,$gotPaths);
			}
			$gotOne= true;
		}
			
		if (is_array($files)){						
			reset($files);
			foreach ($files as $key=>$file){
				$this->$fuName($file,_c_mmCbxFiles,$gotPaths);
			}
			$gotOne= true;
		}

		if (!$gotOne){
			$glob->userError('Nothing was selected!','kmbs');
			return false;					
		}
	} // onFilesAndDirs
	

	/**
	*/
	function removeNLeftCh($origPF,$fdName,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		$fls->splitOnLastC($origPF,$path,$file,'/');	$path.= '/';	// would have been better passsing DFB params with 2 params
		$lcNb= (int)$this->newNameVal();	// a number indicating how many left chars to remove.
		$newFlNm= substr($file,$lcNb);
		$fls->secureRename($path,$file, $path,$newFlNm);
	} // removeNLeftCh
	
	/**
	*/
	function removeNRightCh($origPF,$fdName,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		$fls->splitOnLastC($origPF,$path,$file,'/');	$path.= '/';	// would have been better passsing DFB params with 2 params
		$lcNb= (int)$this->newNameVal();	// a number indicating how many left chars to remove.
		
		$fls->splitOnLastC($file,$flBdy,$ext,'.');
		
		$newFlNm= substr($flBdy,0, 0-$lcNb);
		$newFlNm= $newFlNm.'.'.$ext;
		
		$fls->secureRename($path,$file, $path,$newFlNm);
	} // removeNRightCh

	
	/**
		Add a prefix.
	*/
	function addsLeftCh($origPF,$fdName,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		$fls->splitOnLastC($origPF,$path,$file,'/');
		$path.= '/';
		$prefx= $this->newNameVal();	// the string to add as a prefix
		
		$newFlNm= $prefx.$file;
		$fls->secureRename($path,$file, $path,$newFlNm);
	} // addsLeftCh
	
	/**
		Adds right characters/string... suffix!
	*/
	function addsRightCh($origPF,$fdName,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		$fls->splitOnLastC($origPF,$path,$file,'/');
		$path.= '/';
		
		$sffx= $this->newNameVal();	// the string to add as a prefix
		$fls->splitOnLastC($file,$flBdy,$ext,'.');
		$newFlNm= $flBdy.$sffx.'.'.$ext;
		$fls->secureRename($path,$file, $path,$newFlNm);
	} // addsRightCh

	
	
	/**
		Just change the file name, don't change the real file type !!!
	*/
	function changeFlType($origPF,$fdName,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		
		$fls->splitOnLastC($origPF,$path,$file,'/');	$path.= '/';
		$fls->splitOnLastC($file,$trunkFl,$ext,'.');	
		$newExt= $this->newNameVal();	// the new file type.
		
		$newFlNm= $trunkFl.'.'.$newExt;
		$fls->secureRename($path,$file, $path,$newFlNm);
	} // changeFlType

	
	/**
		Change the Real file type !!!
	*/
	function changeReFlType($imgOrigPFn,$fdName,$gotPaths){
		$tools= &$this->tools;	
		$fls= &$this->fls;
		$imgP= &$this->imgP;
		
		$combiDirExt= $this->newNameVal();	// included dirName ; fileType (no dot)
		
		// So can use ; or + as separator and can still display + inside the menu so we can see it !!!! (; is almost invisible)
		if ($tools->sIsInB(',',$combiDirExt)){
			$fls->splitOnLastC($combiDirExt, $inclDirN,$newExt,',');	
		}else{
			if ($tools->sIsInB('+',$combiDirExt)){
				$fls->splitOnLastC($combiDirExt, $inclDirN,$newExt,'+');
			}else{
				$fls->splitOnLastC($combiDirExt, $inclDirN,$newExt,' ');
			}	
		}
		
		$inclDirN= trim($inclDirN);
		$newExt= trim($newExt);
		
		$fls->splitOnLastC($imgOrigPFn,$mainPath,$origFullFn,'/');
		$fls->wMkDir($mainPath.'/'.$inclDirN);	// make the new dir if not exists !!
		
		$imgP->changeFileType($imgOrigPFn, $inclDirN.'/',$newExt);	// change the file type and copy it inside the new dir
	} // changeReFlType
	
	
	/**
		Convert common symbols accents to a string. Considers
	*/
	function convSymbToHtml($flPath){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ($tools->postVal('ecrUpload')!==false){
			$fStr= $fls->fileToStr($flPath);
			$fStr= $acc->fromAccentsToHtml($fStr);
			$res= $fls->strToFile($flPath,$fStr);
		}else{
			$glob->userError($flPath.$glob->el(' cannot be rewritten because "Ers:" is not checked!','kmhw') );
		}
	} // convSymbToHtml
	
	/**
	*/
	function convHtmlToSymb($flPath){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ($tools->postVal('ecrUpload')!==false){
			$fStr= $fls->fileToStr($flPath);
			$fStr= $acc->fromHtmlToAccents($fStr);
			$fls->strToFile($flPath,$fStr);
		}else{
			$glob->userError($flPath.$glob->el(' cannot be rewritten because "Ers:" is not checked!','kmhw') );
		}
	} // convHtmlToSymb
	
	
	/**
		Splits the $flPath file into $nb files
	*/
	function splitFile($flPath){
		$acc= &$this->acc;
		$fls= &$this->fls;
		$tools= &$this->tools;
		
		$nb= floor($tools->postVal('newName',3));
		if ($nb<2){
			$nb= 2;
		}
		
		if ($nb>100){
			$nb= 100;
		}
	
		$fd= fopen($flPath,"rb");
		$sz= filesize($flPath);
		$chunkSz= ceil($sz / $nb) + 1;	// ceil + 1, so the last chunk is always big enough!
		$fls->splitOnLastC($flPath,$bodyDfn,$ext,'.');
		
		$i= 1;
		do {
			$fileStr= fread($fd,$chunkSz);
			$curDFn= $bodyDfn.$i.'.'.$ext.'SplitG';
			$fls->strToFile($curDFn,$fileStr);
			$i++;
		} while (feof($fd)!==true && $i<$nb+2);
		
		fclose($fd);
	} // splitFile
	
	
	/**
		Glue the given files
	*/
	function glueFiles($flPath){
		$acc= &$this->acc;
		$fls= &$this->fls;
		$tools= &$this->tools;
		
		$fls->splitOnLastC($flPath,$bodyDfn,$ext,'.');
		$tools->rmLastByte($bodyDfn);
		$targetDfn= $bodyDfn.'_glued.'.$ext;
		
		$gotTarget= $fls->okOrNewName($targetDfn);
		if ($gotTarget!==false){
			$fd= fopen($targetDfn,"wb");
			$i= 1;
			do{		
				$curDfn= $bodyDfn.$i.'.'.$ext;
				$exist= $fls->fileExist($curDfn);
				
				if ($exist){
					$curStr= $fls->fileToStr($curDfn);
					$res= fwrite($fd, $curStr);
				}
			
				$i++;
			}while ($exist && $i<102);
			
			fclose($fd);
		}
	} // glueFiles
	
	/**
		Duplicate a directory.
	*/
	function duplicateDir($fullPath){
		$fls= &$this->fls;
			
		$nN= $this->newNameVal('');
		$szNN= strlen($nN);
		if ($szNN>0){
			// an explicit name is given
			$fls->splitOnLastC($fullPath,$left,$right,'/');
			$newPathName= $left.'/'.$nN;
		}else{
			$newPathName= $fullPath.'-cpy';
		}
		
		if ($fls->okOrNewDirName($newPathName)){
			$fls->copyDirectories($fullPath,$newPathName);
		}else{
			$glob->userError('Too difficult to generate a directory name, please try copy and rename.','kmbz');
		}				
	} // duplicateDir


	/**
		Duplicates the file $pf given by its full path and name.
	*/
	function duplicateFile($pf,$rules='pseudoTar'){
		$glob= &$this->glob;
		$fls= &$this->fls;

		switch ($rules){
			case 'pseudoTar':
				$fls->versatileDotSplit($pf,$pfMin,$ext);
				$newName= $pfMin.'real-'.$ext.'-psd.tar';
			break;

			case 'straightCopy':
				$nN= $this->newNameVal('');
				$szNN= strlen($nN);
				if ($szNN<1){
					// no name given inside the text box
					$fls->versatileDotSplit($pf,$pfMin,$ext);
					if ($ext===''){
						$newName= $pfMin.'-cpy';
					}else{
						$newName= $pfMin.'-cpy.'.$ext;
					}
				}else{
					// an explicit name is given
					$fls->splitOnLastC($pf,$left,$right,'/');
					$newName= $left.'/'.$nN;
				}
			break;

			default: $this->topErr('Wrong rules in mmTools::duplicateFile');
		}
		
		if ($fls->okOrNewName($newName)){
			$fls->copyFile($pf,$newName);
		}else{
			$glob->userError('Too difficult to generate a file name, please try copy and rename!','kmca');
		}				
	} // duplicateFile
	

	/**
	*/
	function newNoThumbs($path){
		$fls= &$this->fls;
		$fls->strToFile( $path.'/'.'zzNoThumbsDir.txt', '');	// Blocks useless thumbs directory
	} // newNoThumbs


	/**
	*/
	function setRights(){
		$tools= &$this->tools;
		$fls= &$this->fls;
				
		$recursInFolder= $tools->trimPostVal('mmApplySubF');
		
		$selectDirOwner= $tools->trimPostVal('selectDirOwner');
		$selectDirGroup= $tools->trimPostVal('selectDirGroup');
		$selectDirWorld= $tools->trimPostVal('selectDirWorld');
		
		$selectFileOwner= $tools->trimPostVal('selectFileOwner');
		$selectFileGroup= $tools->trimPostVal('selectFileGroup');
		$selectFileWorld= $tools->trimPostVal('selectFileWorld');
		
		$sDir= '0'.$selectDirOwner.$selectDirGroup.$selectDirWorld;
		$dirMode= intval($sDir, 8);
		
		$sFl= '0'.$selectFileOwner.$selectFileGroup.$selectFileWorld;
		$flMode= intval($sFl, 8);
		
		$this->pathDF($allPhDir,$allPhFiles);
		
		if (is_array($allPhDir)){
			reset($allPhDir);
			foreach ($allPhDir as $key=>$phDir){
				$fls->setDirRights($phDir,$recursInFolder, $dirMode,$flMode);
			}
		}	
		
		if (is_array($allPhFiles)){		
			reset($allPhFiles);
			foreach ($allPhFiles as $key=>$phFile){
				$fls->setFileRights($phFile,$flMode);
			}
		}
	} // setRights
		
	
	/**
	*/
	function callEditor($dfn,$style='lz',$str='',$img='pencil.png'){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$fls->splitOnLastC($dfn,$left,$ext,'.');
		if ( $ext==='zip' || $ext===_c_extZiptmp || $fls->imgOkToDspl($ext) ){
			$ttl= $glob->el('Warning : visualize a binary file','kaxm');
			$txtEdtPth= $fls->editorImage('interoPencil.png');
		}else{
			$txtEdtPth= $fls->editorImage($img);
			$ttl= '';
		}
		
		$edtUrl= $tools->urlGivenPage('_edit-file').$tools->addUrlVar(_c_uVarEdtDFn,$dfn);
		$txtEdtImg= $caps->simplestImg($txtEdtPth,'',$caps->matCss($style));
		
		if ($str!==''){
			$str= $caps->span($str,$style);
		}
		
		return $caps->linkTC($edtUrl, $txtEdtImg.$str, $ttl, $style, '_blank');
	} // callEditor
		
	
	/**
	*/
	function dsplXmSqrFileLn($dfn,$style='lz',$str='',$img='rocket.png'){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$edtUrl= $tools->urlGivenPage('_displayXmSqrFile').$tools->addUrlVar(_c_dsplXmSqrFlNm,$dfn);
		$txtEdtPth= $fls->editorImage($img);
		$txtEdtImg= $caps->simplestImg($txtEdtPth,'',$caps->matCss($style));
		
		if ($str!==''){
			$str= $caps->span($str,$style);
		}		
		return $caps->linkTC($edtUrl, $txtEdtImg.$str, '', $style, '_blank');
	} // dsplXmSqrFileLn
	
} // mmTools
?>
