<?php
/**
	File name : mysqlToPhp.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	A class used to transform a Mysql database into a 100% Php database having one file for each records of the original database.
	
	[setExplPlugin path="central/" name="mysqlToPhp" /]  no tag used anymore!
*/
class mysqlToPhp extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		if ( !defined('_c_sqlsColNmPrfx') ){
			define('_c_sqlsColNmPrfx', 'col_');		// sql simulation column name prefix for the php array variable
			define('_c_sqlsArrTblNms', 'tblNms');	// instance names of the tables name vector
		}
		
		/*
			Dumping part as well for standard SQL as for non-sql.
		*/
		define('_c_phpDmDbInf', _c_phpDumpDtb.'info/');
		define('_c_sqlsDmColNmDFN', _c_phpDmDbInf.'colNames'._c_phpExt); // storage directory file name for the column/fields names
	
		
		// include_once _c_DtbLibPath.'const.php';
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;	// for debug confort
		
		$this->acc= &$tagsFu->acc;
		$tools= &$tagsFu->tools;
		$this->tools= &$tools;
		$this->fls= &$tagsFu->fls;
		
		$this->aSql= &$tagsFu->aSql;
		$this->dtb= &$tagsFu->dtb;
		
		$this->adaptASql($tagsFu);
	} // construct

	
	/**
		Adapt the the aSql of this class depending on the one specified inside $tagsFu
	*/
	function adaptASql(&$tagsFu){
		$dtbCmpl= &$tagsFu->dtbCmpl;
		if ($dtbCmpl===null){
			$this->aSql= &$tagsFu->aSql;
		}else{
			$this->aSql= &$dtbCmpl->aSql;
		}
	} // adaptASql


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array();
	} // tags


	/**
		Return the column names Php strings matching the specified table..
	*/
	function colNamesPhpStr($tblName,$dbName){
		$glob= &$this->glob;
		$aSql= &$this->aSql;
		$tools= &$this->tools;
		$acc= &$this->acc;
		
		
		$colNmPhpStr= '';
		$totColNames= $aSql->tblColumnNames($tblName,$dbName);
		if ($totColNames!==false){
			$i=0;
			reset($totColNames);
			foreach ($totColNames as $key =>$value){
				$colNmPhpStr.= '$this->'._c_sqlsColNmPrfx.$tblName.'['.$i.']='._c_snglQ.$value._c_snglQ.';'._c_R;
				$i++;
			} // foreach
			
			return $colNmPhpStr._c_R;
		}else{
			$glob->userError($dbName.'::'.$tblName.$glob->el(' has no columns!','kmhm'));
			return '';
		}
	} // colNamesPhpStr
	

	/**
		Dump all the column names of all the tables of the specified database
	*/
	function dumpAllColNames($dbName,$colNmDfn=_c_sqlsDmColNmDFN){
		$glob= &$this->glob;
		$fls= &$this->fls;

		if (!file_exists ($colNmDfn)){
			$fls->strToFile( $colNmDfn, $this->allColNamesPhpStr($dbName,$colNmDfn) );
			$surfMessage= 'Creates '.$colNmDfn._c_;
		}else{
			$surfMessage= $colNmDfn.$glob->el(' exists already, you can remove it manually.','kmhn')._c_;
		}
		
		return $surfMessage;
	} // dumpAllColNames
	
	/**
		Give the strings of all column names of all the tables of the specified database
	*/
	function allColNamesPhpStr($dbName,$colNmDfn=_c_sqlsDmColNmDFN){
		$fls= &$this->fls;
		$aSql= &$this->aSql;

		$buff= '';		
		$v= $aSql->onlyTblNames($dbName);				
		reset($v);
		foreach ($v as $key=>$tblName){
			$buff.= $this->colNamesPhpStr($tblName,$dbName);
		}
		
		if (!file_exists(_c_phpDmDbInf)){
			$fls->wMkDir(_c_phpDmDbInf);
		}
		
		return $fls->phpFileCaps(_c_R.$buff);
	} // allColNamesPhpStr

	
	/**
		Copy the table structure from the given database $dbName and returns the full string in the 100% php database format..
		Separated from wholeDtbStr() because need independant calls.
			Input :
				$dbName : the database model.
			Output : 
				the 100% php file string with all the data base names.
	*/
	function onlyTblNmStr($dbName){
		$aSql= &$this->aSql;
		$fls= &$this->fls;
	
		$tblNmPhpVStr= _c_R;
		$v= $aSql->onlyTblNames($dbName);
		$i=0;
		reset($v);
		foreach ($v as $key=>$tblName){
			$tblNmPhpVStr.= '$this->'._c_sqlsArrTblNms.'['.$i.']='._c_snglQ.$tblName._c_snglQ.';'._c_R; // php sql Table Name Vector			
			$i++;
		} // foreach
		return $fls->phpFileCaps($tblNmPhpVStr);
	} // onlyTblNmStr


	/**
		Createws the atom table directories (direct creation copying the structur of the original database)
		Input :
			$dbNam : data base names
			$rootPath : local root path (already created) where to create the atom table directories.
	*/
	function createsAtomsTblDir($dbName,$rootPath){
		$aSql= &$this->aSql;
		$fls= &$this->fls;
	
		$tblNmPhpVStr= _c_R;
		$v= $aSql->onlyTblNames($dbName);
		reset($v);
		foreach ($v as $key=>$tblName){
			$curDfn= $rootPath.$tblName;
			$fls->wMkDir($curDfn);
		} // foreach
	} // createsAtomsTblDir


	/**
		Write a full table into multiple row-files !!
		
		Input ;
			$tblsPath
			$tblName : given table name.
			$vectForbCol : vector of forbidden column name (eg: to avoid backuping crypted passwords from the user data).
			
	*/
	function writeGivTblFiles($tblsPath,$tblName,$vectForbCol=false){
		$aSql= &$this->aSql;
		$tools= &$this->tools;
		$acc= &$this->acc;
		$fls= &$this->fls;
		
		$specificTblPath= $tblsPath.$tblName;

		if ( !file_exists($specificTblPath) ){
			$fls->wMkDir($specificTblPath);
		}
		$specificTblPath.= '/';		


		$curQ= $aSql->selectResource($tblName);
		$buffDump= '';
		while ($row= $aSql->fetchArray($curQ)){
			$phpStr= _c_R;
			$i= 0;
			reset($row);
			foreach ($row as $key => $value){
				if ($i===0){
					$iKey= $key;	// index key
					$iVal= $value;	// index value
				}
				
				if ($tools->aIsInV($key,$vectForbCol)){
					$value= '';	// values forbidden to display
				}
					
				$phpStr.= $fls->atomDtbCelStr($key,$value);
					
				$i++;
			} // foreach
			
			// $curDFN= $fls->atomDtbTblRowDfn($tblName,$iVal,$tblsPath);
			$curDFN= $this->atomDtbTblRowDfn($tblName,$iVal,$tblsPath);
			
			$phpStr= $fls->phpFileCaps($phpStr);
			
			if ( file_exists($curDFN) ){
				$fls->unLnk($curDFN);
			}
			$fls->strToFile($curDFN,$phpStr);
			
			
			$buffDump.= $phpStr._c_R;
		} // while
		return $buffDump;
	} // writeGivTblFiles
	
	
	/* --------------------------------------------------------------
		A patch and simplification from simulSql::atomDtbTblRowDfn()  to avoid specific instanciation.
	*/
	function atomDtbTblRowDfn($tblN, $iVal, $tblsPath){
		return $this->atomDtbTblPath($tblN, $tblsPath).$iVal._c_phpExt;
	} // atomDtbTblRowDfn

	function atomDtbTblPath($tblN,$tblsPath){
		return $tblsPath.$tblN.'/';
	} // atomDtbTblPath
	
	/*--------------------------------------------------------------*/
	
	


	/**
		Build a full 100% Php database.
		
		Must save only the table that have been loaded in memory :
			$aSql->tableLoaded[$tblNm]
			
		Remark : only callable with the simul sql context, so don't need the database name.
	*/
	function buildFullPhpDtb(&$aSql,$secondaryDtb){
		$glob= &$this->glob;	
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ($glob->cndtWrRghts===false){
			return '';
		}
		
		if (defined('_c_destZCmsPhpDtb')){
			$localDestZCmsPhpDtb= _c_destZCmsPhpDtb;
		}else{
			$localDestZCmsPhpDtb= _c_phpDtb;	// secondary Dtb right inside the main one
		}

		$i=0;
		$v= $aSql->onlyTblNames(_c_UsrDbName);		
		reset($v);
		foreach ($v as $key=>$tblName){
			if (!_c_sqlSimul || array_key_exists ($tblName,$aSql->tableLoaded)){
				if ($secondaryDtb){
					$tblPath= $localDestZCmsPhpDtb;
				}else{
					$tblPath= _c_phpDtb;
				}
			
				$this->writeGivTblFiles($tblPath,$tblName);	
			}
			$i++;
		} // foreach
		
		$tblNmDfn= $localDestZCmsPhpDtb.'info/tblNames.php';
		$fls->strToFile( $tblNmDfn, $this->onlyTblNmStr(_c_UsrDbName) );
	} // buildFullPhpDtb
} // mysqlToPhp
?>
