<?php
/**
	File name : polyAccess.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Polyvalent Access to parent functionalities.


	[cenPlugin name="polyAccess" /]				[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class polyAccess extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('polyAccess','debugDisplay',false);	
		$tagsFu->attribVect['testplug']= array('display');
		
		$tagsFu->attribVect['polaccess']= array('mode','info','elg','lbl','css','target','pg','rawurl','username');
	} // construct


	/**
	*/
	function tags(){
		return array('testplug', 'polaccess');
	} // tags
	
		
	/**
		Polyvalent Access to parent functionalities, first, may be unique group dealing with technical links
		usefull for the editor demonstration.
		
		[polAccess mode="guestlog" pg="Le-CMS-fr" rawurl="ok" lbl="log demonstration" css="ln" target="_blank" /]
	*/
	function tg_polaccess(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$mode= $v['mode'];
		$info= $v['info'];
		
		$lbl= $v['lbl'];
		$eLg= $v['elg'];	// edition language
		$css= $tools->binLoads($v['css'],'ln');
		$target= $tools->binLoads($v['target'],'_top');
		
		
		$gurPg= $tools->binLoads( $v['pg'], $tools->curPageName() );	// given or current page -- gurPg
		
		if ( $v['rawurl']===_c_ok){
			$arCmd['rawUrl']= _c_ok;
			$url= $tools->urlGivenPage($gurPg,$arCmd);
		}else{
			$url= $tools->urlGivenPage($gurPg);
		}
		
		switch ($mode){
			case 'adminlog':
				$var= $dtb->getGenVar('pwBoxRequest');
				$val= $dtb->getGenVar('pwRequestVal');
				$url.= $tools->addUrlVar($var,$val);
			break;
			
			case 'guestlog':
				$url.= $tools->addUrlVar(_c_pwGuestLBoxR,_c_pwGuestBoxRVal);
				$url.= $tools->urLangAddition($eLg);
				$url.= $tools->addUrlVar('callGuestLogBox',_c_ok);
				$forbiUserId= $dtb->getGenVar('forbiddenUserId');
				$userName= $tools->binLoads($v['username'],$forbiUserId);
				$url.= $tools->addUrlVar('userId',$userName);
			break;
			
			case 'download':
				// $info is the file name to download
				$url= _c_stdAchiveDirPath.$info;	// download Url
			break;
			
			default:;
		} // switch
	
		return $caps->linkC($url,$lbl,$css,$target);
	} // tg_polaccess

	

	
	/**
		The method used to test this plugin and call with 
			[testPlug display="Plugin trial of : " /]
	*/
	function tg_testplug(&$v,&$bd){
		$caps= &$this->caps;
				
		$dspl= '<h1>'.$v['display'].' polyAccess </h1>';		
		$dspl.= '<a href="#" class="someMoreFont" onClick="polyAccess.writeThreeTimes(\'polyAccess \')">One More Line !!! </a>';
		$dspl.= _c_sT;
		$dspl.= '<a href="#" class="someMoreFont" onClick="polyAccess.clearWrite(\'\')"> Clear !!! </a>';
		$dspl.= _c_;				
		
		// An area to display any javascript messages as a supplementary debug tool
		$area= '';		
		$area.= $caps->textarea('debugDisplay',19,40,'',$caps->matCss('someFont'));
		$area= $caps->sDiv($dspl._c_.$area, 'width:445px; border:2px solid red; padding:10px; margin:2px; float:left;');		
		return $area._c_;
	} // tg_testplug
	
		
	/**
	*/
	function tg_tmptag(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
	
	} // tg_tmptag

		
	/**
	*/
	function tmp(){
	} // tmp
		
} // polyAccess
?>
