<?php
/**
	File name : simpleMenStr.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	The standard string for a standard menu button defined here independently from the hierachy of the
	menus so can use it anywhere inside a text of the main page. It's indispensable for the class stdMenus.php
	where it's 	ALWAYS USED for the menu string, but also for special case when we want to have a decoration
	added just below a menu without that decoration being part of the button body, an empty non clicable menu is defined
	just for the hierachy and [mbut ...] manages the display. 
		Example :
			[mbut pg="welcome-en"]Welcome[/menbut]
			[bf/]A bottom string[bf/]
			[menbut pg="welcome-en"][/menbut]
*/
class simpleMenStr extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->rights= &$tagsFu->rights;
		$this->parser= &$tagsFu->parser;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('simpleMenStr','debugDisplay',false);	
		
		$tagsFu->attribVect['mbut']= $glob->menButAttribV;
	} // construct


	/**
	*/
	function tags(){
		return array('mbut');
	} // tags
	
	
	/**
		Computes the button visible string
	*/
	function buttonVisStr(&$v,&$label){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rgh= &$this->rights;
		$parser= &$this->parser;

		
		if ($v['hidebutton']===_c_ok && !$rgh->lazyConnected()){
			return '';
		};
		
		$newPage= $v['pg'];
		$clsIn= $v['clsin'];	// to eventually force $fontIn toward another look
		if ($clsIn===false){
			if ($v['in']===false){
				$fontIn= 'stdMenuIn';
			}else{
				$fontIn= $v['in'];	
			}
		}else{
			$fontIn= $clsIn;
		}
		
		
		$clsOut= $v['clsout'];	// to eventually force $fontOut toward another look
		if ($clsOut===false){
			if ($v['out']===false){
				$fontOut= 'stdMenuOut';
			}else{
				$fontOut= $v['out'];	
			}
		}else{
			$fontOut= $clsOut;
		}
			
			
		if ($glob->gotActStopSmplSurf){
			$curPage= _c_mainHomePage;
		}else{
			$curPage= $tools->getUrlPageName();
			if (!$dtb->elementExists(_c_pcId, $curPage, _c_PolyCellPg)){
				$curPage= _c_mainHomePage;
			}
		}
		
		if ($newPage===$curPage){
			$curFont= $fontIn;
		}else{
			$curFont= $fontOut;
		}
		
		/**
			$str : loads the html button string.
		*/
		$gotOrientation= $rgh->quickWMRight() && $newPage!==$parser->curScanStrId;	// true --> add an orientation star
		
		$disabledButton= $v['editonly']===_c_ok && !$rgh->lazyConnected();
		if ($disabledButton){
			if ($tools->isInSmartPM()){
				$str= $caps->span($label,'stdMenuSmPhTtl'); // #stdMenuTitle just a title without links, except with editing rights
			}else{
				$str= $caps->span($label,'stdMenuTitle'); // #stdMenuTitle just a title without links, except with editing rights
			}
		}else{
			if ($v['dominanturl']===false){
				$arCmd[_c_mothrPage]= _c_ko;
				$url= $tools->urlGivenPage($newPage,$arCmd);
				$url.= $tools->binLoads($v['urlsup'],'');
			}else{
				$url= $v['dominanturl'];
			}

			$flw= $v['follow'];	// local follow got the priority if defined! Not defied === false, other ok or ko
			
			if ($gotOrientation){
				if ($parser->curScanStrId===$tools->curPageName()){
					$extInStl= $dtb->getGenVar('menuInExtStyle');
					if ($tools->falseOrKo($extInStl)){
						$extInStl= $curFont.'Star';
					}
					$attS= $caps->matCss($extInStl);
				}else{
					$extOutStl= $dtb->getGenVar('menuOutExtStyle');
					if ($tools->falseOrKo($extOutStl)){
						$extOutStl= $curFont.'Star';
					}
					$attS= $caps->matCss($extOutStl);
				}
				
				$mainLink= $caps->hLink($url,$label,$attS);
				$orientUrl= $tools->urlGivenPage($parser->curScanStrId);
				$orientLink= $caps->hLink($orientUrl,'*', $attS.$caps->ta('To access the real page as a webmaster') );
				$str= $orientLink.$mainLink;				
			}else{
				$attS= $caps->matCss($curFont);
				if ( (_c_allMenusNoFollow && $flw===false) || $flw===_c_ko ){
					$attS.= $caps->noFollowStr();
				}
				$str= $caps->hLink($url,$label,$attS);
			}
		}
		
		return $str;
	} // buttonVisStr	


	/**
		Disintegrated button, hasn't got anything to do with the hieryachy, so can be added anywhere inside the page
		or as a comlement for the menu when the button inbricated inside the hierachy is invisible.
		[mBut pg=""] label [/mBut]
	*/
	function tg_mbut(&$v,&$label){
		return $this->buttonVisStr($v,$label);
	}
	
		
} // simpleMenStr
?>
