<?php
/**
	File name : smallEditor.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[cenPlugin name="smallEditor" /]				[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class smallEditor extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('smallEditor','debugDisplay',false);
		
		
		$tagsFu->attribVect['smalledit']= array('lbl','cls','cols','lines','max','fmwload','genvarstore');
		
		define('_c_smallEditorTAN', 'smEdTAN');		// small editor text array name
		
		// General declarations		
		$curPath= _c_toDeclPlugCntr.'inserTags/';
		$glob->addCssFile($curPath.'inserTags.css');
		$glob->coreInclStanceJs($curPath,'inserTags', 'clsInsrTag','clssInserTag');
		$glob->setGlobJsCode('clsInsrTag.initSelectVect();'._c_R._c_R);
		
	} // construct


	/**
	*/
	function tags(){
		return array('smalledit');
	} // tags
	

	/**
		Display a file given by its file name.
		[smallEdit /]
	*/
	function tg_smalledit(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		$lbl= $tools->binLoads($v['lbl'],'');
		if ($lbl!==''){
			$lbl= _c_.$lbl._c_;
		}
		
		$fmwLoad= $tools->binLoads($v['fmwload'],_c_ok)===_c_ok;	// ok ---> load this widget alonmg with other of the class formMainWdgt
		if ($fmwLoad){
			$formMW= $tagsFu->instExplitCentralCls('formMainWdgt');
		}
		
		$cls= $tools->binLoads($v['cls'],'smallEditor');
		$cls= $caps->matCss($cls);
			
		$cols= $tools->binLoads($v['cols'],'65');		// number of columns
		$lines= $tools->binLoads($v['lines'],'15');		// number of lines
		
		$max= $tools->binLoads($v['max'],500);	// maximum
		
		$str= $tools->postVal(_c_smallEditorTAN,'');
		if ( strlen($str) > $max*1000 ){
			$err= $caps->span('Sorry the string is too large! Above '.$max.'kb','ln');	// won't be processed!
		}
		
		if ($tools->wrapped()===_c_ok){
			$wrapStr= '';
		}else{
			$wrapStr= ' wrap="off"';
		}
		
		$js= 'clsInsrTag.setScrollBarPos(\''._c_smallEditorTAN.'\');'._c_R;
		$js.= 'localStorage.globCurTxtArNme="'._c_smallEditorTAN.'";'._c_R;	
		$glob->setGlbEndJsCode($js);
		
		
		
		$genVar= $v['genvarstore'];	// General Variable Storage
		if ($genVar!==false ){
			if ($str===''){
				// first display or phoney post ---> get the DTB value
				$str= $dtb->getGenVar($genVar);
			}else{
				// store the new content
				$dtb->setGenVar($genVar,$str);
			}
		}
		
		$activeWdgtStr= $caps->textarea(_c_smallEditorTAN,$lines,$cols,$str, $wrapStr.$cls);
		
		
	
		if ($fmwLoad){
			$xStr= $lbl.$caps->span($glob->sl('Tabulation buttons...','kaql'),'smallEditorLbl');
			$xStr.= '[i name="indent.png" es="kakr" alt="Add one tabulation for the selected text" edt="ok" cls="eImg" js=" onclick=\"clsInsrTag.txtAreaAction(\'comboStags\',\'indent\')\"" /]';
			$butt= $tagsFu->expand($xStr)._c_Ns;
			
			$xStr= '[i name="unIndent.png" es="kaks" alt="Suppress one tabulation" edt="ok" cls="eImg" js=" onclick=\"clsInsrTag.txtAreaAction(\'comboStags\',\'unindent\')\"" /]';
			$butt.= $tagsFu->expand($xStr);
		
			$formMW->activeWdgtStr.= $butt._c_.$activeWdgtStr;
			$formMW->sentWdgtStr.= $str;
			return '';
		}else{
			return $lbl.$caps->span($str,$cls);
		}
	} // tg_smalledit
	
		

} // smallEditor
?>
