<?php
/**
	File name : sqlEditor.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	A class to be used with the page _installerPureSql to execute  MySql instructions on the current or a specified database 
*/
class sqlEditor extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$asa= &$tagsFu->asa;
		$this->asa= &$asa;		
		$this->glob= &$tagsFu->glob;
		$this->hPwC= &$tagsFu->hPwC;
		$this->caps= &$tagsFu->caps;
		$this->dtb= &$tagsFu->dtb;
		$this->tools= &$tagsFu->tools;
		$this->aSql= &$tagsFu->aSql;
		$this->rMg= &$tagsFu->rMg;
		$this->wmRights= &$tagsFu->wmRights;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('sqlEditor','debugDisplay',false);	
		$tagsFu->attribVect['testplug']= array('display');
	} // construct


	/**
	*/
	function tags(){
		return array('testplug');
	} // tags


	/**
	*/
	function executeSqlCode(&$fMainWgt,&$messDspl){
		$asa= &$this->asa;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		$rMg= &$this->rMg;
		$wmRights= &$this->wmRights;
		
		$messDspl= '';
		if (!($glob->cndtWrRghts===true && $rMg->quickWMRight())){
			// eject the guest triyl user
			$messDspl.= $glob->el('Sorry you do not have the rights to specify SQL instructions','kbbd')._c_;
			return false;
		}
		
		$isNewDtb= $tools->postVal('specDtbWdgt')==='specDTB';	// not curDTB .. new database connection --> need to connect
		$isNewDtb= $isNewDtb || _c_CurrentDtbAbstract === 'simulSql'; // simul sql (100% php) forces a new database opening !!

		if ($isNewDtb){
			include_once _c_DtbLibPath.'aMySql.php';
			$dtbCmpl= null;
			$aSql= new aMySql($asa,$dtbCmpl);
		}else{
			$aSql= &$this->aSql;
		}
	
		$userName= $tools->postVal('eSqlDtbUsrNm');
		
		// ------------------------ managing the password ------------
		$dtbPassword= $tools->postVal('eSqlDtbPwrd');
		
		$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars
		$crptK= $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashC2Pw);	// $dtb actually running data base
		$dtbPassword= $hPwC->doUnCrypt($dtbPassword,$crptK);
		
		$server= $tools->postVal('eSqlDtbAxssUrl');
		$dtbName= $tools->postVal('eSqlDtbName');
		
		if ($isNewDtb){
			$boollNect= $aSql->sqlDbConnect($server, $userName, $dtbPassword,$dtbName);
		}else{
			$boollNect= true;
		}
		
		if ($boollNect){
			$sqlStr= $tools->postVal('directSqlTxtArea');
			$sqlSep= $tools->binLoads($tools->postVal('eSqlSeparator'),'');
			
			if ($sqlSep===''){
				$aSql->localQry($sqlStr,false);
			}else{
				$sqlVect= $tools->mbExplode($sqlStr,$sqlSep);
				reset($sqlVect);
				foreach ($sqlVect as $key=>$sqlSubStr){
					$curQuery= $aSql->localQry($sqlSubStr,false);
				}
			}
				
			if ($glob->popupUsrErr()===''){
				$messDspl.= $glob->el('The MySql intruction(s) was/were executed correctly.','kbbe')._c_._c_;
			}	
				
			// $messDspl.= $glob->returnUserMess();
			
			if ($isNewDtb){
				$aSql->close();
			}
		}	// $boollNect
	} // executeSqlCode	
		
} // sqlEditor
?>
