<?php
/**
	File name : tablesEditor-cpy.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	A class to inspect and change the current database or on other database if the connection is explicitely given.
*/
class tablesEditor extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu, $flagMultiDtb=false){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		$this->asa= &$tagsFu->asa;
		$asa= &$this->asa;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$tagsFu->glob;
		
		$this->caps= &$tagsFu->caps;
		$tools= &$tagsFu->tools;
		$this->tools= &$tools;
		$this->acc= &$tagsFu->acc;
		
		$this->fls= &$tagsFu->fls;
		$fls= &$this->fls;
		
		$this->rMg= &$tagsFu->rights;
		$this->wmRights= &$tagsFu->wmRights;	// access to the webmaster rights class
		$wmRights= &$this->wmRights;
		
		$this->hPwC= &$tagsFu->hPwC;
		$hPwC= &$this->hPwC;
		
		$this->cacheR= &$tagsFu->cacheR;
		$this->cacheWr= &$tagsFu->cacheWr;
		
		$aSql= &$tagsFu->aSql;
		$this->aSql= &$aSql;
		$dtb= &$tagsFu->dtb;
		$this->dtb= &$dtb;		
		$this->pRnd= &$asa->pRnd;
		$this->mbCrypt= &$asa->mbCrypt;
		$this->imgTags= $tagsFu->expliClss('imgTags');
		
		
		
		$this->gotPwKeeper= file_exists(_c_toDeclPlugExt.'pwKeeper'); // test if the concerned directory exists (by def. its content too)
		
		
		
		


		/* -------------------------------------------------------------------------------------
			A table to store crypted passwords with a strong master password
		*/
		// define('_c_pwKeepTN','pwKeeperTbl');		
			define('_c_pwKepId',_c_genId);		// Alphabetical index, identical to _c_pcId : The variable
			define('_c_pwKepInfo','info');		// The value
			define('_c_pwKepRem','comment');	// Remark pointor on _c_CommentsId
			define('_c_pwKepSeed','seed');	// Category			
	

		/* -------------------------------------------------------------------------------------
			A table to store External (exo-.. planet) database access only applies to data bases
			requesting a user name, so the 100% Dtb are not concerned because the access path does
			100% of the localisation.
		*/
		define('_c_exoUsrDtbTN','exoUsrDtb');		
			define('_c_exoUsrDtbId',_c_genId);	// The user Id
			define('_c_exoUDtbPw','crptPw');
			define('_c_exoUDtbUrl','url');
			// The Dtb name is selected among the one that are accessible
	
		
		/* -------------------------------------------------------------------------
			Adapt the database instanciations to the url/post pointed one
		*/
		$tools= &$this->tools;
		$this->exoDealing= false;
		
		
		/**
			A Switch to leave a step for the widgets to adapt
		*/
		$sqlWidgetsAvailable= $tools->petVal('tedExoDtbUsrId')!==false;
		$centPhpDtbWdgtAvail= $tools->petVal('exoDtbNmOrDirNm')!==false;
		$exoDtbImpl= $tools->petVal('tedExoDtbImplem',_c_CurrentDtbAbstract);
		$exoDtbWdgtReady= $exoDtbImpl==='aMySql' && $sqlWidgetsAvailable || $exoDtbImpl==='simulSql' && $centPhpDtbWdgtAvail;
		
		if ($flagMultiDtb===_c_ok && $exoDtbWdgtReady){
			/**
				tablesEditor::Deal with an exo database
			*/
			$this->exoDtbImpl= $exoDtbImpl;
			$dtbCmpl= null;
			
			switch ($exoDtbImpl){
				case 'aMySql':
					$exoDtbUsrId= $tools->petVal('tedExoDtbUsrId',_c_dtbExtUsrName);
					$exoDtbName= $tools->petVal('exoDtbNmOrDirNm');	// the currently spotted Dtb among many possible
					$this->exoDtbName= $exoDtbName;
					$loggedOnCorectDtb= _c_CurrentDtbAbstract==='aMySql' && $exoDtbUsrId===_c_dtbExtUsrName;
					
					if (!$loggedOnCorectDtb){
						// Need a new password Etc... ---> use standard interface to fill firstly an exoDtbConnect Table indexed with user name
						$exoCrptPw= $dtb->getElem(_c_exoUsrDtbTN, _c_exoUsrDtbId,$exoDtbUsrId, _c_exoUDtbPw);
						$exoPw= $hPwC->doUnCrypt($exoCrptPw,_c_softCrypKey);
						
						$exoUrl= $dtb->getElem(_c_exoUsrDtbTN, _c_exoUsrDtbId,$exoDtbUsrId, _c_exoUDtbUrl);
						include_once _c_DtbLibPath.'aMySql.php';
						$this->exoDealing= true;
						
						
						$exoASql= new aMySql($asa,$dtbCmpl,$exoDtbName);
						$resConnect= $exoASql->sqlDbConnect($exoUrl, $exoDtbUsrId, $exoPw, $exoDtbName);
						$exoASql->setTagFu($tagsFu);
					}else{
						// Already logged --> use the same password to create a new sqli object
						if ($exoDtbName!==_c_UsrDbName){
							$this->exoDealing= true;
							$exoUrl= _c_prodDTBServerName;
							$exoPw= $hPwC->doUnCrypt(_c_dtbExtCrpPwName,_c_softCrypKey);
							
							$exoASql= new aMySql($asa,$dtbCmpl,$exoDtbName);
							$resConnect= $exoASql->sqlDbConnect($exoUrl, $exoDtbUsrId, $exoPw, $exoDtbName);
							$exoASql->setTagFu($tagsFu);
						}else{
							$this->setFullySymetricalDtb();
						}
					}
				break;
				
				case 'simulSql':
					include_once _c_DtbLibPath.'simulSql.php';
					$tedExoDtbPath= $tools->petVal('tedExoDtbPath',_c_ProjectsPathNS);
					$exoDtbName= $tools->petVal('exoDtbNmOrDirNm',_c_userDataDirName);	// ok for native simul and not found in the list if we have a native Sql, but does not matter because none was chosen
										
					$this->exoDtbName= $exoDtbName;
					if ( $tools->lastByte($tedExoDtbPath)!=='/' ){
						$tedExoDtbPath.= '/';
					}
					
					$exoDataPath= $tedExoDtbPath.$exoDtbName;
					$forcedPhpDtbPath= $exoDataPath.'/zCms/zPhpData/phpDtb/';
					if ( $fls->fileExist($forcedPhpDtbPath.'info/tblNames.php') && $exoDataPath!==_c_nsUsrDataPath ){
						// At that stage we have great chances to be inside a valid Php Dtb
						$exoASql= new simulSql($asa,$dtbCmpl,$forcedPhpDtbPath);
						$exoASql->setTagFu($tagsFu);
						$this->exoDealing= true;
					}else{
						// Invalid path, no php DTB ...
						$this->setFullySymetricalDtb();
					}
				break;
				
				default: print('Unkonwn dtb implementation, $exoDtbImpl='.$exoDtbImpl);
			} // switch
			
			if ($this->exoDealing){
				$this->exoASql= &$exoASql;
				$exoDtb= new localDB($asa,$exoASql);
				$this->exoDtb= &$exoDtb;
			}
		}else{
			$this->setFullySymetricalDtb();
		}
		
		
		$tagsFu->includeSupFiles('tablesEditor',false,false);

		include_once _c_LibPath.'geomArray.php';	// need include once, otherwise clash with the forum declaration
		$this->geomArray= new geomArray($tagsFu);
		
		$this->imgP= &$tagsFu->imgP;
		$imgP= &$this->imgP;
		
		$glob->addCssFile(_c_toDeclPlugExt.'forum/forum.css');
		include _c_toDeclPlugCntr.'forum/fumShrdCdLgt.php';
		$this->shrdCd= new fumShrdCdLgt($tagsFu,$imgP);
		
		
		/* -----------------------------------------------------------------
			[tblToDisplay name="xyz" attributetwo="aaa" attributethree="bbb" /]
		*/
		$tagsFu->attribVect['tbltodisplay']= array('cls');
		$tagsFu->attribVect['categdisplay']= array('cls');
		
		$tagsFu->attribVect['editcurtbl']= array('multi');
		
		$tagsFu->attribVect['editcurline']= false;
		$tagsFu->attribVect['pwkeepersensitwdgt']= false;
		
		$tagsFu->attribVect['tedgenvarjump']= array('img','rem','el','categ','tbl','forcepg','target');
		$tagsFu->attribVect['populateinfogt']= false;
		
		define('_c_ted_secretFiller','*******');
		
		define('_c_ted_TBOX','tBox_');	// Text boxes prefix used for the boxes of the Table editor
		define('_c_ted_TA','ta_');		// Array boxes prefix used for the boxes of the Line/Row editor
		
		define('_c_tedSortColName','sortColN');
		define('_c_tedSortInOrder','sortOrd');
				
		$this->editionLg= $glob->edtLg();
		
		$this->allowDeletion= $dtb->getGenVar('allowDeletion',_c_ok);
		$this->tedAlphabOrder= $dtb->getGenVar('ted_alphabOrder','none');
		
		$tagsFu->attribVect['backdtbeditor']= array('img','page');
		
		define('_c_sqrCrptBoxPrfx','sqrBxPfx');			
	} // construct


	/**
		Used to load tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('editcurtbl','tbltodisplay','backdtbeditor','categdisplay','editcurline','pwkeepersensitwdgt','tedgenvarjump','populateinfogt');
	} // tags
	
	
	/**
		To treat the table _c_pwKeepTN in the special encryption context, the encryption code must be present, otherwise false, so will consider it externally as a normal table and manage a standard display.
		$this->onPwTbl($tblN)
	*/
	function onPwTbl($tblN){
		$gPwK= $this->gotPwKeeper;
		return ($tblN===_c_pwKeepTN) && $gPwK;
	} // onPwTbl

	/**
		Same as gotPwTblAndCode($defTbl), but to solve the original $defTbl!==_c_pwKeepTN
		$this->notPwTbl($tblN)
	*/
	function notPwTbl($tblN){
		$gPwK= $this->gotPwKeeper;
		
		if ($gPwK){
			return $tblN!==_c_pwKeepTN;
		}else{
			return false;	// no code so treat it as a standard table
		}
	} // notPwTbl

	
	/**
		In this case the Exo Dtb is equal to the original Dtb
	*/
	function setFullySymetricalDtb(){
		$this->exoDtbName= _c_UsrDbName;
		$this->exoDtbImpl= _c_CurrentDtbAbstract;
		$this->exoASql= &$this->aSql;
		$this->exoDtb= &$this->dtb;
	} // setFullySymetricalDtb
	
	
	/**
		Edit the current-table (chosen by tg_tblToDisplay() ).
		[editCurTbl /]
	*/
	function tg_editcurtbl(&$v,&$bd){
		$asa= &$this->asa;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class
		$rMg= &$this->rMg;	// general rights
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$hPwC= &$this->hPwC;
		$mbCrypt= &$this->mbCrypt;
		
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;
		$exoASql= &$this->exoASql;
		$exoDtb= &$this->exoDtb;
		

		$curTbl= $this->defTblName();
		$buff= '';
		$bMult= '';	
			
		if ($v['multi']===_c_ok){
		
			$frcCmb= $tools->getVal('forceComboImplement');
			if ($frcCmb===false){
				$exoDtbImpl= $tools->petVal('tedExoDtbImplem',_c_CurrentDtbAbstract);
			}else{
				$exoDtbImpl= $frcCmb;
			}
			
			
			$bMult.= $caps->span($glob->el('Dtb implementation : ','kbgp'),'tedTtlNM');
			$vSelect= array('aMySql'=>'MySql', 'simulSql'=>'100% Php');
			
			
			$forceSimulComboUrl= $this->pureResetUrl().$tools->addUrlVar('forceComboImplement','simulSql');
			$forceSqlComboUrl= $this->pureResetUrl().$tools->addUrlVar('forceComboImplement','aMySql');
			
			
			$js= $caps->jsFunctCallStr('onChange','tablesEditor.cleanAndChangeImplem',3,0,'tedExoDtbImplem',$forceSimulComboUrl,$forceSqlComboUrl);
			
			$bMult.= $caps->comboBox('tedExoDtbImplem',$exoDtbImpl,$vSelect,$js,true);
			
			
			switch ($exoDtbImpl){
				case 'aMySql':
					if ( $exoASql->identity()!=='aMySql' ){
						include_once _c_DtbLibPath.'aMySql.php';
						$dtbCmpl= null;
						$earlyASql= new aMySql($asa,$dtbCmpl);	// normally dtb name not available then
						
						$aSql->selectOneRecord($earlyRec,_c_exoUsrDtbTN);	// early record taken in original dtb ($aSql) for connection
						
						reset($earlyRec);
						$elyRec= current($earlyRec);
						$crptPw= $elyRec[_c_exoUDtbPw];
						$exoPw= $hPwC->doUnCrypt($crptPw,_c_softCrypKey);
						if ( $earlyASql->sqlDbConnect($elyRec[_c_exoUDtbUrl], $elyRec[_c_exoUsrDtbId],$exoPw) ){
							$vSelectDtb= $earlyASql->databasesVect();
						}
						
						$defaultUserId= $elyRec[_c_exoUsrDtbId];
					}else{
						$dtbOrDirNm= $tools->petVal('exoDtbNmOrDirNm',$exoASql->curDtbName());
						$vSelectDtb= $exoASql->databasesVect();
						$defaultUserId= _c_dtbExtUsrName;
					}
					
					$bMult.= $caps->span($glob->el('Dtb User Id : ','kbgq'),'tedTtl');
					$tbxVal= $tools->petVal('tedExoDtbUsrId',$defaultUserId);
					
					$bMult.= $caps->textBx('tedExoDtbUsrId',$tbxVal,10);
					$bMult.= $caps->span($glob->el('Current Dtb : ','kbgr'),'tedTtl');
					
					$dtbOrDirNm= $tools->petVal('exoDtbNmOrDirNm',$exoASql->curDtbName());
					$bMult.= $caps->comboBox('exoDtbNmOrDirNm',$dtbOrDirNm,$vSelectDtb);
				break;
				
				case 'simulSql':
					$bMult.= $caps->span($glob->el('Dtb Path : ','kbgs'),'tedTtl');
					$tbxVal= $tools->petVal('tedExoDtbPath', _c_ProjectsPathNS);
					$bMult.= $caps->textBx('tedExoDtbPath',$tbxVal,30);
					
					$bMult.= $caps->span($glob->el('Local Dtb : ','kbgt'),'tedTtl');
					$vSelectDtb= $exoASql->centPcPhpDtbV();
					$forceTxtBox= $exoASql->identity()!=='simulSql';
					
					$dtbOrDirNm= $tools->petVal('exoDtbNmOrDirNm',_c_userDataDirName);	// best guess = actual DTB as a srtart,, otherwisre need to chose
					
					$bMult.= $caps->comboBox('exoDtbNmOrDirNm',$dtbOrDirNm,$vSelectDtb);
				break;
				
				default: print('Error tablesEditor::tg_editcurtbl');
			} // switch
			
			$url= $this->pureResetUrl();
			$bMult.= $caps->hL($url, $glob->el('Reset!','kbgy'), 'tedTtl');			
			
			$bMult= $caps->sDiv($bMult,'width:1150px; border: 3px dashed purple; float:left; padding:5px;')	;	
			$bMult.= _c_BrFlux;
			$bMult.= _c_BrFlux;
		} // multi
		
		$buff.= $bMult;
		$buff.= $caps->submit('butTblEdt',$glob->el('Send','kaat'),$caps->matCss('tedWidgetB'));
		
		$tedSearch= $tools->petVal('tedSearch','bsc');	// search mode if any
		switch ($tedSearch){
			case 'bsc':	// Basic Display
				$tblLbl= $glob->el('Current Table to Edit :','kaas');
			break;
			
			//  Sql search etc.
			case 'sqlS':	
			case 'sqlQ':	
			case 'sqlL':	
				$tblLbl= $glob->el('Table :','kbgz');
			break;
			
			case 'gen':		// General search with boxes
				$tblLbl= $glob->el('Search the Table :','kbha');
			break;
			
			default:;
		} // switch
		
		/**
			SMALL ACTION BUTTONS -------->
		*/
		// tedSearchBut
		$ar['tedSearchBut']= _c_ok;
		
		$urlCuPg= $tools->urlCurPg($ar);
		$url= $urlCuPg.$tools->addUrlVar('tedSearch','bsc');
		$buff.= $caps->linkTC($url, 'B', $glob->el('Basic standard display and edition.','kbhb') ,'tedTinyLink');
		
		if ($this->exoDtbImpl==='aMySql'){
			$buff.= $caps->span('|','tedTinySep');
			$urlCuPg= $tools->urlCurPg($ar);
			$url= $urlCuPg.$tools->addUrlVar('tedSearch','sqlS');
			$buff.= $caps->linkTC($url, 'S', $glob->el('Sql display full table!','kbhc') ,'tedTinyLink');
			
			$urlCuPg= $tools->urlCurPg($ar);
			$url= $urlCuPg.$tools->addUrlVar('tedSearch','sqlQ');
			$buff.= $caps->linkTC($url, 'Q', $glob->el('Sql search on index condition!','kbhd') ,'tedTinyLink');
			
			$urlCuPg= $tools->urlCurPg($ar);
			$url= $urlCuPg.$tools->addUrlVar('tedSearch','sqlL');
			$buff.= $caps->linkTC($url, 'L', $glob->el('Sql search with keywords...','kbhe') ,'tedTinyLink');
		}
		
		$buff.= $caps->span('|','tedTinySep');
		
		$urlCuPg= $tools->urlCurPg($ar);
		$url= $urlCuPg.$tools->addUrlVar('tedSearch','gen');
		$buff.= $caps->linkTC($url, 'G', $glob->el('General search with widgets ..','kbhf') ,'tedTinyLink');
		/*
			<----------- SMALL ACTION BUTTONS 
		**/
		
		$buff.= $caps->span($tblLbl,'tedTtl');
		$buff.= $caps->span(' ','tedTtlNM').$caps->span($curTbl.' /','tedTtlNM');		
		$buff.= $this->coreTblToDisplay();
		if ($tedSearch==='bsc'){
			$buff.= $this->coreCategDisplay();
		}	
		
		/**
			Setting the search boxes
		*/
		switch ($tedSearch){
			//  Sql search etc.
			case 'sqlS':	
			case 'sqlQ':	
			case 'sqlL':	
				$buff.= $caps->span( $glob->el('Sql Query : ','kbhg'), 'tedTinyLink');
				
				// Get the 1st row if any to display a sensible query string
				$allRowStr= 'select * from '.$curTbl;
				$queryRes= $exoASql->localQry($allRowStr);
				$cuRow= $exoASql->fetchArray($queryRes);
				
				// Segented global instruction
				$sg1= 'SELECT * FROM '.$curTbl;
				$sg2= ' WHERE ';
				if ($cuRow!==false){
					switch ($tedSearch){
						case 'sqlS':
							$freeQueryStr= $sg1;
						break;
						
						case 'sqlQ':
							$curK= key($cuRow);
							$curVal= current($cuRow);
							$freeQueryStr= $sg1.$sg2.$curK.'="'.$curVal.'"';	// For Exact selection on Id
						break;
						
						case 'sqlL':
							$firstK= key($cuRow);
							$nextVal= next($cuRow);
							$nextK= key($cuRow);
							
							$freeQueryStr= $sg1.$sg2.$nextK.' LIKE "%NeedlE%"';		// For in text selection
							$freeQueryStr.= '  ORDER BY '.$firstK.' ASC';
						break;
					} // switch
				}else{
					$freeQueryStr= $sg1;
				}
				
				$sqlQueryStr= $tools->petVal('sqlStringTxBx',$freeQueryStr, true);
				$buff.= $caps->textBox('sqlStringTxBx',$sqlQueryStr,56, $caps->matCss('tedSearchTxt') );
			break;
			
			case 'gen':		// basic search with SUPPLEMENTARY BOXES
				$buff.= $caps->span( $glob->el('General search : ','kbhh'), 'tedTinyLink');
				
				// Set the general action text boxes
				$needle= $tools->petVal('gSearchWrdTBx1','needle');
				$buff.= $caps->textBox('gSearchWrdTBx1',$needle,15, $caps->matCss('tedSearchTxt'));
				$buff.= $caps->span( $glob->el(' In ','kbhi'), 'tedTinyLink');
				
				// menu fields combo
				$vSelect= $exoASql->tblColumnNames($curTbl,$this->exoDtbName);
				if ($vSelect!==false){
					$defGenSrcVal= $tools->petVal('curTblFieldsCombo',next($vSelect));
					reset($vSelect);
					$buff.= $caps->comboBox('curTblFieldsCombo',$defGenSrcVal,$vSelect);
				}else{
					$defGenSrcVal= '';
				}
			break;
			
			default:;
			case 'bsc':		// Basic / standard search with boxes noting to add
			break;
		} // switch
		
		
		$buff= $caps->sDiv($buff,'margin-left:1px; width:1350px; border:0px solid red; padding:3px; float:left;');
		
		if (!$this->exoDealing){
			$buff.= _c_BrFlux;
			$buff.= _c_BrFlux;
			$buff.= $bd; // the bookmarks !!
		}
		
		$buff.= _c_BrFlux;
		
		$userId= $rMg->realTimeUserId();
		
		/**
			Execution of the search boxes, straight from the start
		*/
		switch ($tedSearch){
			//  Sql search etc.
			case 'sqlS':	
			case 'sqlQ':	
			case 'sqlL':	
				$sqlQueryStr= $tools->petVal('sqlStringTxBx', $freeQueryStr, true);
				if ($sqlQueryStr!==false){
					if ($this->safeEnoughFreeQuery($sqlQueryStr)){
						if ($glob->cndtWrRghts===true && $userId!==_c_guestUserId){
							$q= $exoASql->localQry($sqlQueryStr);
							if ($q!==false){
								$qNbRows= $exoASql->queryNbRows($q);
								$vColNm= $exoASql->fetchFields($q);
								if ($vColNm!==false){
									$buff.= $this->coreEditCurTbl($vColNm,$q,false,$qNbRows,true);
								}
							}else{
								$err= $exoASql->lastDtbError();
								$buff.= $caps->span($glob->el('Following in red is the error message ... : ','kbgu'),'tedErrorTtl');
								$buff.= $caps->span($err,'tedErrorLbl');
								$buff.= _c_;
								// MySql links :
								$buff.= $caps->monoList($caps->linkC($dtb->getGenVar('tedErMssOffSqlDocUrl'), $dtb->getGenVar('tedErMssOffSqlDocLbl'),'tedExternLink','_blank'));
								$buff.= $caps->monoList($caps->linkC($dtb->getGenVar('tedErMssFrSqlDocUrl'), $dtb->getGenVar('tedErMssFrSqlDocLbl'),'tedExternLink','_blank'));
							}
						}else{
							$buff.= $caps->span($glob->el('Sorry as a guest you can...','kblt'),'tedErrorTtl');
						}
					}else{
						$buff.= $caps->span($glob->el('Sorry the query is too unsafe ...','kblu'),'tedErrorTtl');
					}
				} // else : query not sent!!
			break;
			
			// General search, works on all kind of databases (100% php and sql)
			case 'gen':
				if ($glob->cndtWrRghts===true && $userId!==_c_guestUserId){
					$needle= $tools->petVal('gSearchWrdTBx1','needle');	
					$curField= $tools->petVal('curTblFieldsCombo',$defGenSrcVal);
					$q= $exoASql->needleMatch($needle, $curTbl, $curField, $this->exoDtbName);
					$qNbRows= $exoASql->queryNbRows($q);
					$vColNm= $exoDtb->tblColumnNames($curTbl,$this->exoDtbName);
					$buff.= $this->coreEditCurTbl($vColNm,$q,false,$qNbRows,true);
				}else{
					$buff.= $caps->span($glob->el('Sorry as a guest you can\'t ... on any table','kblz'),'tedErrorTtl');
				}
			break;
			
			// Default Basic access, that works on all kind of databases (100% php and sql)
			default:
				$vColNm= $exoDtb->tblColumnNames($curTbl,$this->exoDtbName);
				$q= false;	// calculated inside
				$buff.= $this->coreEditCurTbl($vColNm,$q);
			;
		} // switch		
		
		return $buff;
	}	// tg_editcurtbl
	
	
	/**
		Edit core for the current-table (chosen by tg_tblToDisplay() ).
		[editCurTbl /]
	*/
	function coreEditCurTbl(&$vColNm,&$q, $basicMode=true, $totRelevantRow=false, $chunkOnTheSpot=false){
		$glob= &$this->glob;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class
		$rMg= &$this->rMg;	// general rights
		$tools= &$this->tools;
		$fls= &$this->fls;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$exoASql= &$this->exoASql;
		$exoDtb= &$this->exoDtb;
		
				
		$szDspl= $dtb->getGenVar('tblEdtNbBytesToDspl');
		$chunkId= $tools->getVal(_c_tedTblChunkId);		// can be 'all' too!
		$curTbl= $this->defTblName();
		
		if (!$wmRights->wmChgRights() && $curTbl===_c_UsersTbl){
				return $caps->span($glob->el('Sorry no access right to the table : ','kawy').$curTbl,'fumStd');
		}
		
		$curCateg= $this->genVarCateg($curTbl);
		$supInfo= '';
		if ($this->isAllowedGenVarCateg($curCateg) || $wmRights->alwyAllowedTbl($curTbl)){
			// either not a categ classified table or a categ table with an allowed category to display
			$gotACategTbl= $this->gotGenVarTbl($curTbl);	
			if ($gotACategTbl){
				if ($glob->cndtWrRghts===true){
					$dtb->pSetGenVar(_c_tedGvFilter,$curCateg);	// set the current category inside the webmaster personnal genVar table
				}else{
					$tools->spcSetCook('cookTedFilter',$curCateg);
				}
			}else{
				$curCateg= _c_ko;
			}
				
			if (is_array($vColNm)){
				$posted= $tools->postVal('coreEdtCurTbl')===_c_ok;
				if ($posted){
					$this->savesNewRecIfDef($vColNm);
					$this->deleteCheckedRow();
				}
				
				$dsplRows= '';
				$dsplLine= '';
				$ndOfCol= sizeof($vColNm);
				
				$tSOI= $tools->getVal(_c_tedSortInOrder);
				if ($tSOI===false){
					$inOrder= _c_ok;	// 1st time
				}else{
					$inOrder= $tools->invertCok($tSOI);
				}
			}else{
				return '';
			}
			
			
			if (is_array($vColNm)){	
				$tblNm= $tools->gostVal(_c_tedCurDtbTblNm);		
				$i=0;
				// Loop through the TABLE HEADERS
				reset($vColNm);
				foreach ($vColNm as $key=>$val){
					$sup= '';
					if ($i===0){
						if ($this->allowDeletion===_c_ok){
							$sup= $fls->editorLinkImg('#','dangerous.png',
								$glob->el('Warning : checking a box and ...','kacp'), 'tedRightImg');
						}
					}
					
					if ($chunkId!==false){
						$chunkIdUrl= $tools->addUrlVar(_c_tedTblChunkId,$chunkId);
					}else{
						$chunkIdUrl='';
					}
					
					if ($basicMode){
						$arCmd[_c_tedCurDtbTblNm]= _c_ko;
						$urlTtl= $tools->urlCurPg($arCmd).$tools->addUrlVar(_c_tedSortColName,$val)
							.$tools->addUrlVar(_c_tedSortInOrder,$inOrder);					
						$urlTtl.= $tools->addUrlVar(_c_tedCurDtbTblNm,$tblNm);
						$urlTtl.= $chunkIdUrl;
				
						$totVal= $caps->hLink($urlTtl,$val, $caps->matCss('tedTtl') );
					}else{
						$totVal= $caps->span($val,'tedTtl');
					}
					
					
					$dsplLine.= $this->tblTd($totVal.$sup,'tedTd')._c_R;			
					$i++;
				} // foreach
				
				$dsplLine= $caps->tblTr($dsplLine)._c_R;
				$dsplRows= $dsplLine._c_R.$this->newRecordFields($vColNm);
				$dsplLine= '';
			}
			
			
			$tblChunkId= $tools->getVal(_c_tedTblChunkId,1);
			$chunkLength= $dtb->getGenVar('tedTblScanSz');
		
			if ($basicMode){
				$catQ= $this->categOfQuery($totRelevantRow,$nbRowToDsol, $curTbl,$gotACategTbl,$curCateg);				
			}
			
			
			$cond='';	// method filler
			$col='*';	// method filler
			
			$orderColN= $tools->getVal(_c_tedSortColName);
			if ($orderColN===false){
				$orderColN= '';		// so do not sort
				$curOrder= false;	// inverted
			}else{
				$curOrder= $tools->getVal(_c_tedSortInOrder,_c_ok)===_c_ok; 
			}
			

			if ($basicMode){
				$q= $this->computeCategQ($catQ, $curTbl,$cond,$col,$orderColN,$curOrder,$curCateg);
			}
			
			$supInfo.= $this->coreTableRows($q,$numericMenu,$dsplRows,$indxRow, $totRelevantRow,$dsplLine, $chunkOnTheSpot);
			
		}else{
			$userId= $rMg->realTimeUserId();
			$forbidCateg= $tools->gostVal(_c_tedGvFilter);
			$supInfo.= $userId.' -- '.$caps->span($glob->el('Sorry you do not have enough rights to visuialize thie option','kaxg'),'fumStd');
			
			$supInfo.= $caps->hiddenWdg('coreEdtCurTbl',_c_ok)._c_R;
			$supInfo.= $caps->hiddenWdg('curTblName',$curTbl)._c_R;
		}
		
		return $supInfo;
	} // coreEditCurTbl
	

	/**
		Compute the query depending on the given query categors. 
	*/
	function computeCategQ($catQ, $curTbl,$cond,$col,$orderColN,$curOrder,$curCateg){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$exoDtb= &$this->exoDtb;

		$tblChunkId= $tools->getVal(_c_tedTblChunkId,1);
		$chunkLength= $dtb->getGenVar('tedTblScanSz');
		switch ($catQ){
			case 'fullTblGC':
				$q= $exoDtb->slctResource($curTbl,$cond,$col,$orderColN,$curOrder);
			break;

			case 'fullTblNC':
				$q= $exoDtb->slctResource($curTbl,$cond,$col,$orderColN,$curOrder);
			break;
			
			case 'fullCat':
				$cond= $exoDtb->condStr(_c_genVarCateg,$curCateg);
				$q= $exoDtb->slctResource($curTbl,$cond,$col,$orderColN,$curOrder);
			break;
			
			case 'oChunk':
				$cond= $exoDtb->condStr(_c_genVarCateg,$curCateg);
				$start= ($tblChunkId-1)*$chunkLength;
				$q= $exoDtb->limitedRowSet($curTbl,$start,$chunkLength,$cond, $col,$orderColN,$curOrder);			
			break;
			
			case 'oChunkAll':
			case 'oChkNC':
				$start= ($tblChunkId-1)*$chunkLength;
				$q= $exoDtb->limitedRowSet($curTbl,$start,$chunkLength,$cond, $col,$orderColN,$curOrder);			
			break;
		} // switch
		
		return $q;
	} // computeCategQ
		
	
	
	/**
	*/
	function categOfQuery(&$totRelevantRow,&$nbRowToDsol, $curTbl,$gotACategTbl,$curCateg){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$exoDtb= &$this->exoDtb;
	
		$chunkId= $tools->getVal(_c_tedTblChunkId);		// can be 'all' too!
		$chunkLength= $dtb->getGenVar('tedTblScanSz');
			
		// $totRelevantRow : total number of relevant rows matching the category condition
		if ($gotACategTbl){
			if ($curCateg==='all'){
				// No more category, so enable access to the full table (with a numeric scale access)
				
				$totRelevantRow= $exoDtb->countNbRows($curTbl);
				if ($chunkId==='all'){
					$nbRowToDsol= $totRelevantRow;
					$catQ= 'fullTblGC';	// display all ... full table got categ
				}else{
					 $nbRowToDsol= $chunkLength;
					$catQ= 'oChunkAll';	//one chunk in a all categ situation
				}
			}else if ($chunkId==='all'){
				//  Enable access to all alements INSIDE a given category (normal chunks convention) when displaying all
				$totRelevantRow= $exoDtb->cntNbRows($curTbl,_c_genVarCateg,$curCateg);
				$nbRowToDsol= $totRelevantRow;
				$catQ= 'fullCat';	// display all chunks inside a category
			}else{
				//  Enable access to all alements INSIDE a given category and displaying only the selected category chunk
				 $totRelevantRow= $exoDtb->cntNbRows($curTbl,_c_genVarCateg,$curCateg);
				 $nbRowToDsol= $chunkLength;
				$catQ= 'oChunk';	// only one chunk to display
			}
		}else{
			$totRelevantRow= $exoDtb->countNbRows($curTbl);	// no category chosen so all rows for a possible scan
			if ($chunkId==='all'){
				$nbRowToDsol= $totRelevantRow;
				$catQ= 'fullTblNC';	// full table no categ
			}else{
				$nbRowToDsol= $chunkLength;
				$catQ= 'oChkNC';	// only one chunk and No Categ to display
			}
		}	
		
		return $catQ;
	} // categOfQuery
					
	
	
	/**
		Input :
			$q : the current given query
			$totRelevantRow : all rows reachable with the geometical scale.  (default all nb of rows of the table)
			$dsplLine : in most cases irelevant frill addition, easier to leave empty
		Output :
			$numericMenu : the calculated geometrical menu
			$dsplRows :: returned rows.
	*/	
	function coreTableRows(&$q, &$numericMenu,&$dsplRows,&$indxRow, $totRelevantRow=false, $dsplLine='', $chunkOnTheSpot=false){
		$glob= &$this->glob;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class
		// $rMg= &$this->rMg;	// general rights
		$tools= &$this->tools;
		$fls= &$this->fls;
		$caps= &$this->caps;
		$geom= &$this->geomArray;
		
		$dtb= &$this->dtb;
		$exoDtb= &$this->exoDtb;
		
		
		$curTbl= $this->defTblName();
		
		$tblChunkId= $tools->getVal(_c_tedTblChunkId,1);
		$chunkLength= $dtb->getGenVar('tedTblScanSz');
		$indxRow= 0;
				
		$szDspl= $dtb->getGenVar('tblEdtNbBytesToDspl');
		$chunkId= $tools->getVal(_c_tedTblChunkId);		// can be 'all' too!
			
		$numericMenu= '';
		if ($q!==false){
			/** Calculation for the numerical menu.
			*/
			if ($totRelevantRow===false){
				$totRelevantRow= $exoDtb->countNbRows($curTbl);
			}
			
			$totNbChunks= ceil($totRelevantRow/$chunkLength);
			if ($tblChunkId>$totNbChunks){
				$tblChunkId= $totNbChunks;
			}
			if ($tblChunkId===false){
				$adaptedTCId= 1;	// not indicated --> number 1
			}else{
				$adaptedTCId= $tblChunkId;
			}
			
			
			$realChunkOnSpot= $chunkOnTheSpot && $tblChunkId!=='all';
			if ($realChunkOnSpot){
				$cnkStartIdx= ($tblChunkId-1)*$chunkLength;
				$cnkEndIdx= $tblChunkId*$chunkLength-1;	// block limit but generally less on the last block
			}
		
			/** $allRow : partial table with LIMIT need to sort it the same way !!!
			*/
			while ( $row= $exoDtb->fetchAry($q) ){
				$forbidIdVect= $wmRights->forbidSpecTblId($curTbl);
				$curIndx= current($row);
				
				if ($tools->sIsInB('_',$curIndx)){
					$fls->splitOnLastC($curIndx,$left,$right,'_');
					$needle= $left.'_';
				}else{
					$needle= $curIndx;
				}
				
				$isForbidIdx= $this->partiallyInArray($needle,$forbidIdVect);
				if (!$isForbidIdx){
					if ($realChunkOnSpot){
						if ( $indxRow>=$cnkStartIdx && $indxRow<=$cnkEndIdx ){
							$dsplLine= $this->buildCurRow($row,$indxRow,$szDspl, $dsplLine);
							$dsplRows.= $caps->tblTr($dsplLine)._c_R;
						}
					}else{
						$dsplLine= $this->buildCurRow($row,$indxRow,$szDspl, $dsplLine);
						$dsplRows.= $caps->tblTr($dsplLine)._c_R;
					}
				}
				
				$dsplLine= '';
				$indxRow++;
			} // while
			
			// uses table chunk conditions
			$origCurPos= 1;
			$gArr= $geom->contigToGeom(1,$totNbChunks, $adaptedTCId);
			$infBut= $this->curTblInfoBut();	// facultative infoirmation button
			
			$numericMenu= $infBut.$geom->dsplNumericMenu($gArr, $this,'subTableUrl',_c_tedTblChunkId)._c_._c_;
		} // $q!==false
		
		
		$buff= $numericMenu;
		$buff.= $this->tblTag($dsplRows,'tedTbl');	// full table encapsulation
		$buff.= _c_R._c_R;
		
		
		$buff.= $caps->hiddenWdg('nbOfChkBoxes',$indxRow)._c_R;
		$buff.= $caps->hiddenWdg('coreEdtCurTbl',_c_ok)._c_R;
		$buff.= $caps->hiddenWdg('curTblName',$curTbl)._c_R;
		return $buff;
	} // coreTableRows


	/**
		To indicate with the url the specific part od the table we have to display.
	*/
	function subTableUrl($i){
		$tools= &$this->tools;
	
		$arCmd[_c_tedCurDtbTblNm]= _c_ko;
		$url= $tools->urlCurPg($arCmd);
		$url.= $tools->addUrlVar(_c_tedTblChunkId,$i);
		$tblNm= $tools->gostVal(_c_tedCurDtbTblNm);		
		$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,$tblNm);
		$url.= $tools->reprodUrlVar(_c_tedGvFilter);
		return $url;
	} // subTableUrl
	
	
	/**
	*/
	function buildCurRow(&$row,$indxRow,$szDspl, $dsplLine){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		
		$curTbl= $this->defTblName();
		$i=0;
		reset($row);
		foreach ($row as $key=>$val){	
			$pncl= '';
			$ckBox= '';
			if ($i===0){
				$valId= $val;
				$img= $caps->stdImage('page.png','ok','','tedIcon');
				$arCmd[_c_tedCurDtbTblNm]= _c_ko;
				$url= $tools->urlGivenPage('_dtb_edit_line',$arCmd);
				$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,$curTbl);
				$url.= $tools->addUrlVar(_c_tedCurDtbRowId,$val);
				$url.= $tools->reprodUrlVar(_c_tedTblChunkId);
				$pncl= $caps->linkTC($url, $img, $glob->el('Edit a record','kazz'), '');
				
				$url.= $tools->addUrlVar('htmlentities',_c_ok);
				$img= $caps->stdImage('amp.png','ok','','tedIcon');
				$pncl.= $caps->linkTC($url, $img, $glob->el('Expand all html tags ...','kbnp'), '');
				
				
				if ($curTbl===_c_fumXCode){
					$url.= $tools->addUrlVar('onlyLooking',_c_ok);
					$img= $caps->stdImage('eye.png','ok','','tedIcon');
					$pncl.= $caps->linkTC($url, $img, $glob->el('Only looking, no booking!','kmhb'), '');
				
				}
				
				if ($this->allowDeletion===_c_ok){
					$ckBox= $caps->checkBox('ckbox_'.$indxRow,$valId,_c_ko,$caps->matCss('tedChkBox'));
				}else{
					$ckBox= '';
				}
			}else{
				$contentSz= strlen($val);
				if ($contentSz>$szDspl){
					// risk of muliBytes characters truncation at end of display, ok for now!
					$val= substr($val,0,$szDspl);	// avoid drowning the user with huge blocks of texts
					$val.= ' ......';
				}
			}			
							
			$tdType= 'tedTd';
			
			switch ($curTbl){
				case _c_GenVarTbl:
					switch ($key){
						case _c_genVarRem:
							$val= $this->substitComment($curTbl,$valId,$val);
							$tdType= 'tedTdL';
						break;
						
						
						case _c_cPwServer:
							$val= _c_ted_secretFiller;
						break;
						
						default:;
					} // switch
				break;
				
				case _c_fsmplUsersTbl:
					switch ($key){
						case _c_fUserMail:
							$seed= $dtb->getGenVar('fPolyCrypt');		
							$val= $hPwC->doUnCrypt($val,$seed);	// does not check multibytes, but fine for emails!!
						break;
						
						default:;
					} // switch
				break;
			
				default:;
			}
			
			
			if ($i===0){
				$tdType= 'tedTd0';	// so get more room for the icon and the Id text
			}
											
			$cellContent= $pncl.$val.$ckBox;
			if ($cellContent===''){
				$cellContent= _c_Ns;
			}
			
			$txtSz= strlen($val);
			if ($txtSz>300){
				$infoStr= $glob->el('Just a display :','kbnq');
				// name : 'extraTB'.$indxRow.'-'.$i ---> just a display!!, but specific name just in case
				$cellContent= $infoStr._c_.$caps->textAreaStl('extraTB'.$indxRow.'-'.$i, $cellContent, ' width: 400px;  height:150px;');
			}

			$dsplLine.= $this->tblTd($cellContent,$tdType)._c_R;
			$i++;							
		} // foreach
		
		return $dsplLine;
	} // buildCurRow
	
	
	/**
	*/
	function fieldBoxName($N){
		return _c_ted_TA.$N;
	} // fieldBoxName
	

	/**
		Output :
			Return the current (default / allowed) genvar category!
	*/
	function genVarCateg($curTbl){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$categ= $dtb->pGetGenVar(_c_tedGvFilter,'all');
		if ( !$this->categExists($categ,$curTbl) ){
			$categ= 'all';	// usefull for personal genVar tables
		}
		
		return $tools->petVal(_c_tedGvFilter,$categ);
	} // genVarCateg
	
	
	/**
		Return true if the given category exists insde the given table
	*/
	function categExists($categ,$tblN){
		$exoDtb= &$this->exoDtb;
		return $exoDtb->elementExists(_c_genVarCateg, $categ, $tblN);
	} // categExists
	
	
	/**
		Also see $dtb->pGvTblNm()
	*/
	function curDefVarTblName(){
		$exoDtb= &$this->exoDtb;
		return $exoDtb->pGvTblNm();
	} // curDefVarTblName
	
	
	/**
		Manages the default Main table name.
	*/
	function defTblName(){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$dtb= &$this->dtb;		
		$rMg= &$this->rMg;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class
		
		$gvN= $this->curDefVarTblName();
		$defTbFrG= $dtb->getGenVar($gvN);	// from gen var
			
		$defTbl= $tools->gostVal(_c_tedCurDtbTblNm);	// In url current-table name!
			
		if ($defTbl===false || $defTbl===''){
			if ($defTbFrG===false){
				$dtb->newGenVar($gvN,_c_GenVarTbl,false,'dtbManager');
				$defTbFrG= _c_GenVarTbl;
			}
			$defTbl= $tools->gostVal(_c_tedCurDtbTblNm,$defTbFrG);
		}
		
		if ($acc->onlyIdChars($defTbl)){
			if ($defTbl!==$defTbFrG){
				$dtb->setGenVar($gvN,$defTbl);
			}
			$dfTblNm= $defTbl;
		}else{
			// the input did not comply, so returns the default stored table name
			$dfTblNm= $defTbFrG;
		}
				
		$allowedV= $wmRights->allowedTblVect();		
		if ($allowedV!==false && !in_array($dfTblNm,$allowedV,true)){
			$dfTblNm= _c_GenVarTbl;
		}
		
		
		if ($this->exoDealing){
			$exoTblV= $this->coreTblVect();
			if (!in_array($dfTblNm ,$exoTblV)){
				$dfTblNm= current($exoTblV);
			}
		}
		
		return $dfTblNm;
	} // defTblName
	

	/**
		Saves the single posted field.
	*/
	function savesPostedField(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$exoDtb= &$this->exoDtb;
		$cacheWr= &$this->cacheWr;
		
		$snglFieldName= $tools->gostVal(_c_snglEdtFieldName);
		$textareaNm= _c_ted_TA.$snglFieldName;
		
		$curVal= $tools->postVal($textareaNm);
		if ($curVal!==false && $glob->cndtWrRghts===true){
			$curTbl= $tools->gostVal(_c_tedCurDtbTblNm);
			$curId= $tools->gostVal(_c_tedCurDtbRowId);
			$exoDtb->setElem($curTbl,  $snglFieldName,$curVal,  _c_genId,$curId);
			
			if ( $this->recDefLocalCacheVar($curTbl,$curId) ){
				$cacheWr->writeCacheLocalConst();
			}
		}
	} // savesPostedField
	
	
	/**
		Returns true if the record also define a local cache variable.
	*/
	function recDefLocalCacheVar($curTbl,$curId){
		if ($curTbl===_c_GenVarTbl){
			return $curId==='urlPageVar' || $curId==='pwBoxRequest' || $curId==='permanentDefPage';
		}
		return false;
	} // recDefLocalCacheVar
	
	
	
	/**
		[tblToDisplay /]
	*/
	function tg_tbltodisplay(&$v,&$bd){
		return $this->coreTblToDisplay();
	} // tg_tbltodisplay
	
	/**
		Displays the combo box to choose the tables from.
	*/
	function coreTblToDisplay(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$exoASql= &$this->exoASql;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class
				
		$defTbl= $this->defTblName();
		$cls= 'tedWidget';
		$names= $this->coreTblVect();
		
		$arCmd[_c_tedCurDtbTblNm]= _c_ko;
		$curUrl= $tools->urlCurPg($arCmd);
		
		$js= $caps->jsFunctCallStr('onChange','tablesEditor.changeCurTable', 2,0, _c_tedCurDtbTblNm,$curUrl);
		return $caps->comboBox( _c_tedCurDtbTblNm, $defTbl, $names, $caps->matCss($cls).$js);
	} // coreTblToDisplay
	
	function coreTblVect(){
		$exoASql= &$this->exoASql;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class
				
		$allowedV= $wmRights->allowedTblVect();
		if ($allowedV!==false){
			return $allowedV;
		}else{
			return $exoASql->onlyTblNames($this->exoDtbName);	// take all tables
		}
	} // coreTblVect
		
	
	/**
		[categDisplay /]
	*/
	function tg_categdisplay(&$v,&$bd){
		return $this->coreCategDisplay();
	}	// tg_categdisplay
	
			
	/**
		Get the category vector for the given genvar table name.
		Input :
			$curTbl : current genVar prefixed table.name
		Output :
	*/
	function getGenVarCategVect($curTbl){
		$exoDtb= &$this->exoDtb;
		$wmRights= &$this->wmRights;
		
		if ($this->gotGenVarTbl($curTbl)){
			$catV= $wmRights->allowedCategVect();
			if ($catV===false){
				$categV= $exoDtb->vectIdNames($curTbl,'',_c_genVarCateg);
				$categV['st']= 'all';	// 1st
				$catV= array_unique($categV);
			}
			
			return $catV;
		}else{
			return array();
		}
	} // getGenVarCategVect
			

	/**
		A select menu to chose the appropriated category from the genVar table.
	*/
	function coreCategDisplay(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$curTbl= $this->defTblName();
		if ($this->gotGenVarTbl($curTbl)){
			$cls= 'tedWidget';
			$catV= $this->getGenVarCategVect($curTbl);
			sort($catV);
			$defCateg= $this->genVarCateg($curTbl);
			$buff= $caps->span($glob->el('Categories:','kaau'),'tedTtl');
			
			$arCmd[_c_tedCurDtbTblNm]= _c_ko;
			$curUrl= $tools->urlCurPg($arCmd);
			$curUrl.= $tools->reprodUrlVar(_c_tedCurDtbTblNm);
			$js= $caps->jsFunctCallStr('onChange','tablesEditor.changeCurCateg', 2,0, _c_tedGvFilter,$curUrl);
			$buff.= $caps->comboBox( _c_tedGvFilter, $defCateg, $catV, $caps->matCss($cls).$js);
			return $buff;
		}else{
			return '';
		}
	} // coreCategDisplay
	

	/**
		Make sure we have a genune genVar table so we test another important field of it to b sure,
		case of an exo-database havving the same name (it also need the categ field (does not bother testing the exo type)
		so category test do not melt away !!)
	*/
	function gotGenVarTbl($tbl){
		$exoASql= &$this->exoASql;
		return $tbl===_c_GenVarTbl && $exoASql->fieldExists(_c_genVarCateg,_c_GenVarTbl,$this->exoDtbName);
	} // gotGenVarTbl
	

	/**
		Add fields to fill for a new record
	*/
	function newRecordFields(&$vColNm){
		$caps= &$this->caps;
		
		$dsplLine= '';
		if (is_array($vColNm)){
			reset($vColNm);
			foreach ($vColNm as $key=>$field){
				$width= 20;
				if ($field===_c_genVarRem){
					$width= 40;
				}
				
				$val= $caps->textBox(_c_ted_TBOX.$field,'',$width);
				$dsplLine.= $this->tblTd($val,'tedTd')._c_R;
			}
		}
		return $caps->tblTr($dsplLine)._c_R;
	} // newRecordFields


	/**
	*/
	function deleteCheckedRow(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$exoDtb= &$this->exoDtb;
		
		$curTbl= $tools->postVal('curTblName');
		$nbBoxes= $tools->postVal('nbOfChkBoxes');
		if ($glob->cndtWrRghts===true){
			for ($i=0; $i<$nbBoxes; $i++){		
				$curId= $tools->postVal('ckbox_'.$i);
				if ($curId!==false){
					$elemExists= $exoDtb->elementExists(_c_genId,$curId, $curTbl);
					if ($elemExists){
						$exoDtb->deleteTableRecord($curTbl,_c_genId,$curId);
					}
				}
			}
		}else{
			$nbChckBx= 0;
			for ($i=0; $i<$nbBoxes; $i++){		
				if ($tools->postVal('ckbox_'.$i)!==false){
					$nbChckBx++;
				}
			}
			
			if ($nbChckBx>0){
				$glob->setGuestDisplay($glob->el('Delete ','kauq').$nbChckBx.$glob->el(' selected row on the table ','kaur').$curTbl);
			}

			$newId= $tools->postVal(_c_ted_TBOX.'id','');
			if ($newId!==''){
				$glob->setGuestDisplay($glob->el('Create ','kaus').$newId.$glob->el(' in ','kaut').$curTbl);
			}
			
			return '';
		}
	} // deleteCheckedRow


	/**
		Saves the new record if it's defines.
			Input :
				$vColNm : vector of the table column names.
	*/
	function savesNewRecIfDef(&$vColNm){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$hPwC= &$this->hPwC;
		$exoASql= &$this->exoASql;
		$exoDtb= &$this->exoDtb;

		
		if ($glob->cndtWrRghts===false){
			return;
		}
				
		$defTbl= $tools->postVal('curTblName');
		if ($defTbl!==false){
			// Sent button been pushed! Hidden widget sent!
			
			$i=0;
			reset($vColNm);
			foreach ($vColNm as $key=>$field){
				$curFldVal= $tools->postVal(_c_ted_TBOX.$field,'');
				
				// if ($defTbl===_c_pwKeepTN && $field===_c_pwKepSeed && $curFldVal===''){
				if ($this->onPwTbl($defTbl) && $field===_c_pwKepSeed && $curFldVal===''){
					$curFldVal= $hPwC->consonStr(20);
				}
				
				if ($i===0){
					$curFldVal= trim($curFldVal);
				}
				
				if ($i===0){
					if ($curFldVal===''){
						return;		// nothing to save
					}else{
						$idVal= $curFldVal;
						$idField= $field;	// just the 'id' string !!
					}
				}
				
				if ($defTbl===_c_GenVarTbl && $field=== _c_genVarRem){
					if ($exoASql->fieldExists($field,$defTbl)){
						// manages the comment table
						$fieldVect= $exoASql->tblColumnNames(_c_CommentsTbl);					
						if ($fieldVect!==false){
							$valV[_c_CommentsId]= $idVal;
							$fLg= $glob->lgAbrevToLgField($this->editionLg);
							$valV[$fLg]= $curFldVal;
							
							$storedComments= $exoDtb->getElem(_c_CommentsTbl, _c_CommentsId,$idVal);
							$newV= $exoDtb->fullFieldedV($fieldVect,$valV,$storedComments);
							
							if ($exoDtb->elementExists(_c_CommentsId,$idVal,_c_CommentsTbl)){
								$exoDtb->delete(_c_CommentsTbl,$idVal);
							}
								
							$exoDtb->newRecFromV(_c_CommentsTbl,$newV);
							$vectVal[$i]= _c_emptyStr;
						}else{
							// _c_CommentsTbl not accessible (very unlikely)
							$glob->userError(_c_CommentsTbl.$glob->el(' has no columns!','kmhm'));
						}
					}
					
				}else{
					$vectVal[$i]= $curFldVal;
				}
				
				$i++;
			}		
		
			// did not return, so got something to save!
			$exoDtb->newRecFromV($defTbl,$vectVal,$idField,$idVal);
		}
	} // savesNewRecIfDef


	/**
		Substitute the correct language _c_CommentsTbl for the specified 'remarks' field.
			Input :
				$curTbl : name of the current-table.
				$valId : value of the id field.
			Output :
				return the substitute comment.
	*/
	function substitComment($curTbl,$valId,$val){
		$glob= &$this->glob;
		$exoDtb= &$this->exoDtb;
	
		switch ($curTbl){
			case _c_GenVarTbl :
				$fLg= $glob->lgAbrevToLgField($this->editionLg);
				$externalRem= $exoDtb->getElem(_c_CommentsTbl, _c_CommentsId,$valId, $fLg);
				if ($externalRem!==false){
					return $externalRem;
				}
			break;
															
			default:;
		} // switch		
		
		return $val;
	} // substitComment


	/**
		Returns the forumAlgo class or false.
	*/
	function fumAlgo(){
		$tagsFu= &$this->tagsFu;
		
		if (array_key_exists ('forumAlgo',$tagsFu->explicitClasses)){
			$fAlgo= &$tagsFu->explicitClasses['forumAlgo'];
		}else{
			$fAlgo= false;
		}
		return $fAlgo;
	} // fumAlgo

	
	/**
	*/
	function curTableName(){
		$tools= &$this->tools;

		// not the same variable get or post table name !!
		$urlTbl= $tools->getVal(_c_tedCurDtbTblNm);
		$curPostedTbl= $tools->postVal('curTbl');
		return $tools->binLoads($urlTbl,$curPostedTbl);
	} // curTableName
			
	
	/**
		[editCurLine /]
		Edit the current line for the specified table and id.
		....... &tbl=genVar&id=permanentDefPage
	*/
	function tg_editcurline(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class

		if ($glob->cndtWrRghts===true){
			$curPostedTbl= $tools->postVal('curTbl');
			$tableName= $this->curTableName();
			
			if (!$wmRights->wmChgRights() && $tableName===_c_UsersTbl){
				return $caps->span($glob->el('Sorry no access right to the table : ','kawy').$tableName,'fumStd');
			}
			
			$snglEdtF= $tools->gostVal(_c_snglEdtFieldName);	// getVal would be enough!
			if ($curPostedTbl!==false){
				if ($snglEdtF===false){
					$this->savesPostedRow();	// Saves full row except the protected _c_cPwServer field.
				}else{
					$this->savesPostedField();	// Saves the single posted field.
				}
			}
		}
		return $this->coreEditcurline();	// Display the full row or single field editor boxes
	} // tg_editcurline
	

	/**
	*/
	function coreEditcurline(){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$rMg= &$this->rMg;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$exoDtb= &$this->exoDtb;
		$shrdCd= &$this->shrdCd;
		

		$label= $glob->el('Send','kaat');
		
		$boxW= $dtb->getGenVar('asciiArtCryptorWidth');
		$boxH= $dtb->getGenVar('asciiArtCryptorHeight');
		$sendBut= _c_R.$caps->submit('but',$label,$caps->matCss('tedWidgetB'));

		$id= $tools->getVal(_c_tedCurDtbRowId,'0');	// The Id to access the current-table field
		$curTbl= $tools->getVal(_c_tedCurDtbTblNm,_c_GenVarTbl);

		if ($glob->cndtWrRghts===false && $curTbl!==_c_pwKeepTN){
			return _c_BrFlux._c_BrFlux.$glob->setGuestDisplay($glob->el('accessing a specific row of ','kauu').$curTbl,'',false);
		}
		
		$snglFieldName= $tools->gostVal(_c_snglEdtFieldName);		
		$mess= '';
		if ( !$this->exoDealing && (($curTbl===_c_fumXCode || $curTbl===_c_fumThreadList)  && $snglFieldName!==_c_fumGSupTagFldN )){
			$userId= $rMg->realTimeUserId();
			$curPgN= $shrdCd->xCodePN($id);
			
			$onlyLooking= $tools->getVal('onlyLooking');
			if ($onlyLooking!==_c_ok){
				$unbookXG= $tools->getVal('unbookXG');
				if ($unbookXG===_c_ok){
					$shrdCd->reserveXGate($userId,$curPgN,_c_fumNoBookingTm);
					$mess= $caps->span($glob->el('The reserved resource has been freed!','kmgz'),'fumStd'); 
				}else{
					$bookedAndInsist= $shrdCd->bookedXGate($userId,$curPgN,_c_fumWmResTmSlot);
					if ($bookedAndInsist){
						// Already booked by itself, so give it another slot
						$shrdCd->reserveXGate($userId,$curPgN,_c_fumWmResTmSlot);	 // BOOK THE WHOLE PAGE THREADS FOR WEBMASTER MODIFICATIONS
						
						$mess= $caps->span($glob->el('PLease do the modification...','kauv').$id.$glob->el(' of the table ','kauw')._c_fumXCode.$glob->el(' is fully booked!','kaux'),'fumStd');						
						$mess.= $this->infoChoke($curPgN);
						
						// add an unbooking button 
						$url= $tools->urlCurPg().$tools->addUrlVar('unbookXG',_c_ok);
						$lbl= $glob->el('You can click here to free the reserved resource!','kmha');
						$mess.= $caps->hLink($url,$lbl,  $caps->matCss('tedWarning') );
						
						/**
							Do not use $this->freeXGate($curPgN) Because it must be done manually by the webmaster
							to have enough time for the edition process.
						*/
					}else{
						$mess= $caps->span($glob->el('Warning : this field is booked by : ','kauy').$userId,'fumStd'); 
						$mess.= $this->infoChoke($curPgN);
					}
				}
			}			
		}
		
		$hdW= $caps->hiddenWdg('curTbl',$curTbl)._c_R;
		$hdW.= $caps->hiddenWdg('curId',$id)._c_R;
		$hdW.= $caps->hiddenWdg('xSecondSent',_c_ok)._c_R;
		
		$elemRow= $exoDtb->getElem($curTbl, _c_genId,$id);
		$vColNm= $exoDtb->tblColumnNames($curTbl,$this->exoDtbName);
		if ($vColNm===false){
			$glob->userError($this->exoDtbName.'::'.$curTbl.$glob->el(' has no columns!','kmhm'));
			return '';
		}
			
		$szDspl= $dtb->getGenVar('tedTextAreaLim', '100000');
			
		$dsplLine= '';
		if ($elemRow!==false){
			if ($snglFieldName===false){
				/* ---------------------------------------------
					Full row editor (only one row / all fields)
				*/
				$i=0;
				reset($vColNm);
				foreach ($vColNm as $key=>$colNm){
					if ( array_key_exists($colNm,$elemRow) ){
						$defaultVal= $elemRow[$colNm];
					}else{
						$defaultVal= _c_Ns;
					}
				
					$curVal= $tools->postVal(_c_ted_TA.$colNm, $defaultVal);
					if ($i===0){
						$valId= $curVal;
					}			
					switch ($colNm){
						case _c_genVarRem:
							$curVal= $this->substitComment($curTbl,$valId,$curVal);
						break;
						
						case _c_cPwServer:
							$curVal= _c_ted_secretFiller;
						break;
						
						default:;
					} // switch
								
					$nbNl= substr_count ($curVal,_c_nL);
					if ($nbNl>20 || $curTbl===_c_pwKeepTN && $colNm===_c_pwKepInfo){
						$nbNl= 20;	// -> very large chunk
					}
					
					$ta= $caps->textarea(_c_ted_TA.$colNm, 3+$nbNl,100, $curVal, false, $szDspl);
	
					$pencil= '';
					if ($glob->cndtWrRghts===true){
						$pencil= $tools->toEditSpecificTblElem($curTbl,$id,$colNm);
					}
				
					$dsplLine.= $caps->tblTr(
						$this->tblTd($pencil._c_Ns.$colNm,'tedTtl').
						$this->tblTd($ta,'tedTtl')
					)._c_R;
					
					$i++;
				} // foreach
			}else{
				/* ------------------------------------------
					Single element editor boxes (textarea) :
				*/
				$dsplLine.= $this->editSingleElem();
			}
		}
		
		$ret= $sendBut.$caps->span($glob->el('for the table : ','kazu').$curTbl._c_, 'tedTblNm');
		if ($curTbl===_c_pwKeepTN){
			$protoW= $dtb->getGenVar('pwKpProtoWarning');
			if ($protoW===_c_ok){
				$ret.= $caps->span($glob->el('Warning : this encryption system is a prototype!','kbor'), 'tedWarning');
			}
		}
		$ret.= $mess._c_.$hdW.$this->tblTag($dsplLine,'tedTbl');
		return $ret;
	} // coreEditcurline
	

	/**
		[pwKeeperSensitWdgt /]
		Relativelly to the password keeper we are grouping here the widgets directly related with multiple password 
		information more prcisely the widgets determined by : $pwKeeper->pwKeepPwManag() & $pwKeeper->tBoxRect()
		---> password keeper sensitive widgets --> pwKeeperSensitWdgt
		------> Best to integrate ouside the form html tag so if the javascript initialisation fails (JS inactivation
		in the middle of deciphering) the pw-keys are not transmitted anyway.
	*/
	function tg_pwkeepersensitwdgt(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$wmRights= &$this->wmRights;	// access to the webmaster rights class

		
		$curTbl= $tools->getVal(_c_tedCurDtbTblNm,_c_GenVarTbl);		
		$snglFieldName= $tools->gostVal(_c_snglEdtFieldName);		
		if ($curTbl===_c_pwKeepTN && $snglFieldName===false){
			
			if ( $dtb->getGenVar('noCacheOnlyForum')===_c_ok ){
				$caps->catNoCache();	// forbid an indiscrete memorisation by the browser !!
			}
			
			/**
				Adds the specific master crypting form widgets.
			*/
			$pwKeeper= $tagsFu->instExplitExternalCls('pwKeeper');
			$pwKeepWdgt= $pwKeeper->pwKeepPwManag();
			$tBoxSqrt= $pwKeeper->tBoxRect();
			
			/**
				Check the privacy of the filled widgets
			*/
			$formSent= $tools->postVal(_c_anyFormSentId);
			if ($formSent===_c_ok){
				$scsTxtBox= $tools->postVal('ta_info');
				if ( !ctype_xdigit($scsTxtBox) ){ // could insist to have only lower case characters
					// Even better, coud do the test in JS and ask an are you sure to post it!
					$glob->userError('You saved a string that is not in hexadecimal ...','kmim');
				}
			}
			
		}else{
			$pwKeepWdgt= '';
			$tBoxSqrt= '';
		}
		
		return $pwKeepWdgt.$tBoxSqrt;
	} // tg_pwkeepersensitwdgt
	
	
	/**
	*/
	function editSingleElem(){
		$tagsFu= &$this->tagsFu;
		$cacheR= &$this->cacheR;
		$glob= &$this->glob;
		$fls= &$this->fls;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$imgTags= &$this->imgTags;
		$exoDtb= &$this->exoDtb;
		
		
		if ($glob->cndtWrRghts===false){
			return '';
		}

		$warningMess= '';
		$tagsFu->instExplitCentralCls('inserTags');
				
		$curTbl= $tools->getVal(_c_tedCurDtbTblNm,_c_GenVarTbl);
		$snglFieldName= $tools->gostVal(_c_snglEdtFieldName);
		
		$textareaNm= _c_ted_TA.$snglFieldName;
		$glob->setGlobJsCode('localStorage.globCurTxtArNme=\''.$textareaNm.'\';'._c_R);
		
		$id= $tools->getVal(_c_tedCurDtbRowId,'0');	// The Id to access the current-table field
		$elemRow= $exoDtb->getElem($curTbl, _c_genId,$id);
		$defaultVal= $elemRow[$snglFieldName];
		$curVal= $tools->postVal($textareaNm, $defaultVal);
		
		$nbNl= substr_count ($curVal,_c_nL);
		
		// adds _insert-tags
		$stdEdtBar= $tagsFu->includeRec('_insert-tags');	// incude the std edit bar!
				
		// Special deal with zoom saving
		$zPHid= $tools->postVal(_c_zHidOrigPgWdgtNm);
		// print('$zPHid='.$zPHid._c_);
		if ( $zPHid!==false && $curTbl===_c_idTextsTbl ){
			/**
				The form was sent, so we can save the Lock to avoid saving encapsulated info from the origin page
				$zPHid === _c_ko --> the form was sent, otherwise ($zPHid===false) and 
				we use now the table-stored values, so we don't use the original calculated vaues from the page.
			*/
			$fls->splitOnFirstC($id,$pfxLockId,$fnAndLgSffx,'-');
			$fls->splitOnLastC($fnAndLgSffx,$trunkFn,$lgSffx,'-');	// $lgSffx need to be extracted otherwise the editing language may not match
			
			$lockId= $imgTags->galleryLockId($zPHid,$pfxLockId,$lgSffx);
			$lockValue= $imgTags->getZLockVal($exoDtb, $lockId);
			if ( $lockValue!==_c_zLockOk ){
				// Manages the 1st saving
				$valV= array($lockId,_c_zLockOk);
				$exoDtb->newRecord(_c_idTextsTbl,$valV);
				$warningMess= $caps->span( $glob->el('Warning : from now on ... with this editor! ... delete the lock :','kmcf').' '.$lockId.' '.$glob->el('but all the texts ... deleted!','kmcg'),'tedWarning') . _c_BrFlux;
			}
			
			$yEdtTools= $tagsFu->instExplitCentralCls('yEdtTools');
			if ($yEdtTools->cacheRewrCond()){
				$dfn= $cacheR->zmSmartPhoneCacheStr($id, _c_ko);
				$dfn= $cacheR->mainFlStr($dfn);
				if ($fls->fileExist($dfn)){
					$fls->unLnk($dfn);
				}
				
				$dfn= $cacheR->zmSmartPhoneCacheStr($id, _c_ok);
				$dfn= $cacheR->mainFlStr($dfn);
				if ($fls->fileExist($dfn)){
					$fls->unLnk($dfn);
				}
			}
			
		}
		
		$zHid= $tools->gostVal(_c_zHidOrigPgWdgtNm,_c_ko);
		$ta= $caps->hiddenWdg(_c_zHidOrigPgWdgtNm,$zHid)._c_R;
		
		$ta.= $stdEdtBar._c_BrFlux.$warningMess.$caps->textarea($textareaNm, 32,140, $curVal);
	
		$imgDFn= _c_EditorImgPath.'backRed.png';
		$alt= $glob->el('View all fields','kazv');
		
		$arCmd[_c_tedCurDtbTblNm]= _c_ko;
		$url= $tools->urlCurPg($arCmd);
		$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,$curTbl);
		$url.= $tools->addUrlVar(_c_tedCurDtbRowId,$id);
		
		$backBut= $caps->linkImg($imgDFn,$alt,$url);
	
		return $caps->tblTr(
			$this->tblTd($backBut._c_Ns.$snglFieldName,'tedTtl').
			$this->tblTd($ta,'tedTtl')
		)._c_R;
	} // editSingleElem
	

	/**
	*/
	function infoChoke($curPgN){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;

		$dTm= $shrdCd->leftBookedTm($curPgN);
		if ($dTm>_c_fumNoBookingTm){
			return ' '.$caps->span($glob->el(' for ','kmgw') . $dTm .$glob->el(' second(s) ','kmgx') ,'fumStd');
		}else{
			return '';
		}
	} // infoChoke


	/**
	*/
	function savesPostedRow(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$caps= &$this->caps;
		$exoASql= &$this->exoASql;
		$dtb= &$this->dtb;
		$exoDtb= &$this->exoDtb;
		$shrdCd= &$this->shrdCd;
		$cacheWr= &$this->cacheWr;


		if ($glob->cndtWrRghts===false){
			return '';
		}	
		
		$curTbl= $tools->postVal('curTbl');
		$curId= $tools->postVal('curId');
		
		$vColNm= $exoDtb->tblColumnNames($curTbl,$this->exoDtbName);
		if ($vColNm===false){
			$glob->userError($this->exoDtbName.'::'.$curTbl.$glob->el(' has no columns!','kmhm'));
			return false;
		}
		
		$totSet= $exoASql->emptyPureSet();
		$i= 0;
		$where= false;
		
		// Because of that param, it only works for a full row!
		$rowExists= false;
		reset($vColNm);
		foreach ($vColNm as $key=>$colNm){		
			$curVal= $tools->postVal(_c_ted_TA.$colNm);
						
			if ($i===0){
				$idVal= $curVal;
				if ($exoDtb->elementExists($colNm,$idVal, $curTbl)){
					$rowExists= true;
				}
			}		
			
			if ($curTbl===_c_GenVarTbl && $colNm===_c_genVarRem){	// ==='remarks'
				$eV=  array(_c_CommentsId =>'',_c_CommentsEn =>'',_c_CommentsW =>'',_c_CommentsX =>'',_c_CommentsY =>'',_c_CommentsZ =>'');	
				
				$eV[_c_CommentsId]= $idVal;
				$eV[$this->editionLg]= $curVal;
				
				// saves $curVal into the _c_CommentsTbl
				$fLg= $glob->lgAbrevToLgField($this->editionLg);
				$com= $exoDtb->setElem(_c_CommentsTbl,  $fLg,$curVal,  _c_CommentsId,$idVal, $eV);
				
				// recovers the cur value from the table
				$curVal= $exoDtb->getElem(_c_GenVarTbl, _c_genVarId,$idVal, _c_genVarRem);
			}
			
			if ($i===0){
				$where= $exoDtb->condStr($colNm,$curVal);
			}		
			
			switch ($colNm){
				case _c_cPwServer:
					// shunt the hidden element.
					$curVal= $exoDtb->getElem($curTbl, $where,false, $colNm);
				break;
								
				default:
				break;
			} // switch
			
			if ($rowExists){
				$curSet= $exoASql->assignSetElement($colNm,$curVal);
				$exoASql->buildPureSet($totSet, $curSet);
			}
			
			$i++;
		} // foreach
				
		if ($where!==false){
			// ---> has been posted			
			if ($rowExists){
				$exoDtb->chgRecord($curTbl,$totSet,$where);
			}
			
			if ( $this->recDefLocalCacheVar($curTbl,$curId) ){
				$cacheWr->writeCacheLocalConst();
			}
		}
	} // savesPostedRow


	/* ---------------------------------------------------------
		<table ...
	*/
	function tblTag($content,$sup=''){
		$caps= &$this->caps;
		return $caps->tblTag($content,$caps->matCss($sup));
	} // tblTag
	
	
	function tblTd($x,$sup=''){
		$caps= &$this->caps;
		return $caps->tblTd($x,$caps->matCss($sup));
	} // tblTr

	
	/**
		Jump from an icon click onto the correct genVar display category.
		[tedGenvarJump img="keys.png" categ="" rem="" /]
		See also genVarCateg()
	*/
	function tg_tedgenvarjump(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$tblNm= $tools->binLoads($v['tbl'],_c_GenVarTbl);
		$categ= $v['categ'];
		$imgDFn= _c_EditorImgPath.$v['img'];
		
		$forcePg= $v['forcepg'];	
		
		$arCmd['resetEdtMultiDtb']= _c_ok;
		$arCmd[_c_tedCurDtbTblNm]= _c_ko;
		if ($forcePg===false){
			$url= $tools->urlCurPg($arCmd);
		}else{
			$url= $tools->urlGivenPage($forcePg,$arCmd);
		}
		
		$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,$tblNm);
		if ($categ!==false){
			$url.= $tools->addUrlVar(_c_tedGvFilter,$categ);
		}
		
		$target= $tools->binLoads($v['target'],'_top');
		return $caps->linkImg($imgDFn,  $glob->el($v['rem'], $v['el']),  $url, 'dataBaseEditorBM',$target);
	} // tg_tedgenvarjump
	
	
	/**
		Return true if the given $needle is totally or partially found inside the array values.
	*/
	function partiallyInArray($needle,$v){
		$tools= &$this->tools;
		
		reset($v);
		$found= false;
		reset($v);
		foreach ($v as $key=>$val){
			$found= $found || $tools->sIsInB($needle,$val);
			if ($found){
				break;
			}
		}
		return $found;
	} // partiallyInArray

	
	/**
		Back to the database editor!
	*/
	function tg_backdtbeditor(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
	
		$img= $v['img'];		
		$page= $v['page'];
		if ($page===false){
			if ($this->exoDealing){
				$page= '_dtbBrowser';
			}else{
				$page= '_table_editor';
			}
		}
			
		$edt= _c_ok;
		$alt= $glob->el('Table editor','kaar');
		$stdImg= $caps->stdImage($img,$edt,$alt,'lz');
		
		$cUrl= $tools->urlGivenPage($page);
		$cUrl.= $tools->reprodUrlVar(_c_tedTblChunkId);
		
		$buff= $caps->linkTC($cUrl,$stdImg,$alt,'lz');	
		$buff.= $caps->span($glob->el('Record (Dtb line) Editor','kazt') ,'efLb');
		
		return $buff;
	} // tg_backDtbEditor

	
	/**
		Facultative information for different tables!
	*/
	function curTblInfoBut(){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$tools= &$this->tools;

		$tblN= $this->curTableName();

		$infoTxt= '?';
		switch ($tblN){
			case _c_SurfTransTN:
				$img= 'surfLg.png';
				$elRecord= 'kSurfLgInfo';	// edit language record --> in _c_CodeTransTbl infos on how to use _c_SurfTransTN table !
			break;
			
			case _c_fsmplUsersTbl:
				$img= 'rgb-people.png';
				$elRecord= 'kfUsrTbl';	// edit language record --> in _c_CodeTransTbl infos on how to use _c_SurfTransTN table !
			break;
			
			case _c_pwKeepTN:
				$img= 'pwKeeperInfo.png';
				$elRecord= 'masterPwEncryptInfo';	// edit language record --> in _c_CodeTransTbl infos on how to use _c_SurfTransTN table !
				$infoTxt= $glob->el('The information visualized when clicking...','kbma');
			break;
			
			default:
				return '';
		} // switch
	
		$url= $tools->urlGivenPage('_infoOnGivenTable');
		$url.= $tools->addUrlVar('img',$img);
		$url.= $tools->addUrlVar('tableName',$tblN);
		$url.= $tools->addUrlVar('codeTransRecord',$elRecord);
		$imgDFn= $fls->editorImage($img);
		return $caps->linkImg($imgDFn,$infoTxt,$url,'tblInfoImg','_blank');
	} // curTblInfoBut
	
	
	/**
		[populateInfoGT /]
		To populate the page _infoOnGivenTable with the passed information.
	*/
	function tg_populateinfogt(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
		
		$buff= '';
		$img= $tools->getVal('img');
		$tableName= $tools->getVal('tableName');
		$codeTransRecord= $tools->getVal('codeTransRecord');
		
		$tgImgBack= '[tedGenvarJump img="'.$img.'" tbl="'.$tableName.'" rem=""  el="kayo" forcePg="_table_editor" /]';
		$buff.= _c_BrFlux;
		$buff.= _c_BrFlux;
		$buff.= $tagsFu->expandX($tgImgBack);
		
		$buff.= _c_BrFlux;
		$buff.= _c_BrFlux;
		$errorStr= $glob->el('A polyglot table "codeTrans" explanation should be associated to the value','kblv').' ';
		$buff.= $glob->el($errorStr,$codeTransRecord);
		return $buff;
	} // tg_populateinfogt
		
		
	/**
		Easy going (*1) allowed _c_GenVarTbl category.
		(*1) everything allowed if the vector is not defined or emptzy
	*/
	function isAllowedGenVarCateg($categ){
		$wmRights= &$this->wmRights;	// access to the webmaster rights class

		$catV= $wmRights->allowedCategVect();
		if ($catV===false){
			return true;	// the easygoing part : mot define --> allowed (protection not connected word comes from the page private execution tag)
		}
		return in_array($categ,$catV);
	} // isAllowedGenVarCateg
	

	/**
		Creates a New Dtb User record if available.
	*/
	function newDatabaseUser(){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		$pRnd= &$this->pRnd;
		
		$dtbServerNm= $tools->postVal('installerDtbAccessUrl');
		$dtbUsrNn= $tools->postVal('installerExtDtbUsrNm');
		$dtbPw= $tools->postVal('dtbPassword');
		
		// Could encapsulate that inside a method and use it in frameBuilder::tg_newdtb()
		$kCode= $tools->postVal('forceLargeInt');	// kCode for ok or ko code !!
		
		$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars
		$crptK= $dtb->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashC2Pw);
		$sortOfInt= $pRnd->smalLargeIntToExplicit($kCode);
		$dtbPw= $hPwC->doUnCrypt($dtbPw,$crptK,$sortOfInt);
		
		$dtbPw= $hPwC->doCrypt($dtbPw,_c_softCrypKey,$sortOfInt);	// crypted again with the EASY key
		$usrNmExists= $dtb->elementExists(_c_exoUsrDtbId,$dtbUsrNn, _c_exoUsrDtbTN);
		if ($usrNmExists){
			$mess= $caps->span($glob->el('Sorry the given user Id is already defined inside the table','kblw').' ','smallEditorTtl').$caps->span(_c_exoUsrDtbTN,'smallEditorTtlC');
		}else{
			$valV= array($dtbUsrNn,$dtbPw,$dtbServerNm);
			$resNR= $dtb->newRecord(_c_exoUsrDtbTN,$valV);	// NEW RECORD
			
			if ($resNR!==false){
				$mess= $caps->span($glob->el('Congratulation you just created a user/MySql record  ...  table'.' ','kblx'),'smallEditorTtl').$caps->span(_c_exoUsrDtbTN,'smallEditorTtlB').$caps->span(', you can now use it with the Multi-Databases Editor.','smallEditorTtl');
			}else{
				$mess= $caps->span($glob->el('Sorry it was not possible to create the record...'.' ','kbly'),'smallEditorTtl').$caps->span(_c_exoUsrDtbTN,'smallEditorTtlC');
			}
		}
		return $mess;
	} // newDatabaseUser


	/**
		Avoid the drop and  current database truncate instructions.
	*/
	function safeEnoughFreeQuery($qStr){
		$acc= &$this->acc;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$qStr= trim($qStr);
		$sSz= strlen($qStr);
				
		$forbidTrunk= $dtb->getGenVar('tedAllowTruncate')!==_c_ok;
		if ($forbidTrunk || $this->exoDtbName===_c_UsrDbName){
			if (stripos($qStr,'truncate')===0){
				return false;
			}
		}
		
		if ( stripos($qStr,'drop')===0){
			$startDbN= strpos($qStr,_c_UsrDbName);
			if ($startDbN>0){
				$beforDtbN= $startDbN-1;
				$befCharI= $qStr[$beforDtbN];
				$befCharIsAccept= $acc->idChar($befCharI);
			}else{
				$befCharIsAccept= false;
			}
			
			$szDbN= strlen(_c_UsrDbName);
			$afterIndx= $startDbN + $szDbN;	// just after end database name position index
			
			if ($afterIndx<$sSz){
				$afterChar= $qStr[$afterIndx];
				$aftCharIsAccept= $acc->idChar($afterChar);
			}else{
				$aftCharIsAccept= false;
			}
			
			if ( $tools->sIsInB(_c_UsrDbName,$qStr) && ( $aftCharIsAccept  || $befCharIsAccept) ){
				// got a truncation on another data base prefixed with the same name!!
				return true;	// acceptable operation
			}else{
				return false;	// Forbid the trucation of the database in use 
			}
		}
		
		return true;
	} // safeEnoughFreeQuery
	
	/**
	*/
	function pureResetUrl(){
		$tools= &$this->tools;
		
		$arCmd['resetEdtMultiDtb']= _c_ok;
		$arCmd[_c_mothrPage]= _c_ko;
		return $tools->urlCurPg($arCmd);
	} // pureResetUrl
	
	/**
		./aMainDr/projects/xxxyZZestCentPP1/zCms/zPhpData/phpDtb/ 
	*/
	function chabl(){
	} // chabl

	/**
	*/
	function tg_toCopy(&$v,&$bd){
		$caps= &$this->caps;
		
	} // tg_toCopy
			
} // tablesEditor

?>