<?php
/**
	File name : testTopCrypt.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[cenPlugin name="testTopCrypt" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class testTopCrypt extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->hPwC= &$tagsFu->hPwC;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('testTopCrypt','debugDisplay',false);	
		
		$tagsFu->attribVect['autocrypt']= false;
		$tagsFu->attribVect['jstesttopcrypt']= false;
		$tagsFu->attribVect['integerinfo']= false;
	} // construct


	/**
	*/
	function tags(){
		return array('autocrypt', 'jstesttopcrypt', 'integerinfo');
	} // tags

	
	/**
		To test an external PHP general crypt
		[selectWhatever name="sortOfInt" defval="Default" listval="Default, ForceSmallInt, ForceLargeInt" /]
	*/
	function tg_autocrypt(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$hPwC= &$this->hPwC;	// Internal
	
		
		$b0= _c_.$caps->span($glob->es('Encryption results :','kawl'),'efMb')._c_;
		$b= _c_;
		
		$sortOfInt= $tools->postVal('sortOfInt');
		switch ($sortOfInt){
			case 'Default':
				$sortInt= 'def';
			break;
			
			case 'ForceSmallInt':
				$sortInt= 'small';
			break;
			
			case 'ForceLargeInt':
				$sortInt= 'large';
			break;
			
			default:
				$sortInt= 'def';
		} // switch
		
		$key= $tools->binLoads($tools->postVal('testKey'),'coucouabcd');
		$str= $tools->binLoads($tools->postVal('testStr'),'coucouabcd');
		if ($key!=='' && $str!==''){
			$b= $caps->span($glob->es('Given key : ','kawm'),'efMb').$key._c_;
			$b.= $caps->span($glob->es('Given string : ','kawn'),'efMb').$str._c_;
			
			
			$mrgn= _c_Ns._c_Ns._c_Ns._c_Ns._c_Ns._c_Ns;
			$b.= _c_.$caps->span($glob->es('Cypher a UTF-8 string first, then uncypher :','kbai'),'efMb')._c_;
			$resultCPw= $hPwC->doCrypt($str,$key,$sortInt);		
			$b.= $mrgn.$caps->span($glob->es('Calculated encryption : ','kawo'),'efMb').$caps->span($resultCPw,'efSb')._c_;
			$resultPw= $hPwC->doUnCrypt($resultCPw,$key,$sortInt);
			$b.= $mrgn.$caps->span($glob->es('Solved encryption (== Given string) : ','kawp'),'efMb').$caps->span($resultPw,'efSb')._c_;
			
			
			$b.= _c_.$caps->span($glob->es('Uncypher an hexadecimal string first then cypher it for a circular check :','kbaj'),'efMb')._c_;
			$clearStr= $hPwC->doUnCrypt($str,$key,$sortInt);		
			$b.= $mrgn.$caps->span($glob->es('Calculated original string from an hexadecimal encryption : ','kbak'),'efMb').$caps->span($clearStr,'efSb')._c_;
			$cryptedStr= $hPwC->doCrypt($clearStr,$key,$sortInt);		
			$b.= $mrgn.$caps->span($glob->es('Calculated encryption for verification : ','kbal'),'efMb').$caps->span($cryptedStr,'efSb')._c_;
			return $b;
		}else{
		}
	} // tg_autocrypt
	
		
	/**	
		A click button to do the test in Javascript.
		[jsTestTopCrypt /]
	*/
	function tg_jstesttopcrypt(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$js= $caps->jsOnclickFuCallStr('testTopCrypt.ttCrypt');
		return $caps->spanA( $glob->es('Test JS cryp','kawq'), $js.$caps->matCss('jsTestTopCrypt') );	
	} // tg_jstesttopcrypt
	
		
	/**
		[integerInfo /]
		PHP_INT_MAX=2147483647 
		PHP_INT_MAX=9223372036854775807
	*/
	function tg_integerinfo(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
	
		if (_c_forceLargeInt===_c_ok){
			$m= $caps->uLabel($glob->es('Default : large integers are used for crypting!','kawr'));
		}else{
			$m= $caps->uLabel($glob->es('Default : small integers are used for crypting!','kaws'));
		}
		
		$m.=_c_;
		
		$cGli= $tools->corePhpGotLrgeInt();
		if ($cGli===_c_ok){
			$m.= $caps->uLabel($glob->es('The php configuration uses large integers : PHP_INT_MAX=','kawt').PHP_INT_MAX);
		}else{
			$m.= $caps->uLabel($glob->es('The php configuration uses small integers : PHP_INT_MAX=','kawu').PHP_INT_MAX);
		}

		$m.=_c_;
		return $m;		
	} // tg_integerinfo

		
	/**
		Template for standard methods.
	*/
	function templateStd(){
	
	} // templateStd
		
} // testTopCrypt
?>
