<?php
/**
	File name : textMenus.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="textMenus" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]	
*/
class textMenus extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->tools= &$tagsFu->tools;
		$this->caps= &$tagsFu->caps;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('textMenus','debugDisplay',false);	
		
		$tagsFu->attribVect['textmenus']= array('urlextcl','urlfu');
		
		$this->txtMenStyle= 'width:98%; padding-left:0%; padding-right:2%; padding-top:5px; padding-bottom:5px;  border:0px solid red;';
	} // construct


	/**
		This associative array must hold all the class's tags names, so the cms can declare them
	*/
	function tags(){
		return array('textmenus');
	} // tags

	
	/**
		The method used to set the menus. The menus names given in $bd [textMenus /]
		$tagsFu->attribVect['textmenus']= array('urlextcl','urlfu');
		
		"forumUsrMg" urlFu="baseUmMenu"
	*/
	function tg_textmenus(&$v,&$bd){
		return $this->setMenus($bd,$v['urlextcl'],$v['urlfu']);
	} // tg_textmenus
	
		
	/**
		Set the Menus.
		Input :
			$menParam : string of menu parameters
	*/
	function setMenus($menPrmStr,$clStr,$urlFu){
		$tagsFu= &$this->tagsFu;
	
		$explCl= &$tagsFu->explicitClasses[$clStr];
		return $this->setMenusCore($menPrmStr,$explCl,$urlFu);
	} // setMenus
	
	
	function setMenusCore($menPrmStr,$explCl,$urlFu){
		$tools= &$this->tools;
		$caps= &$this->caps;	
			
		$baseUrl= $explCl->$urlFu();
		$buff= '';
		$buff.= $caps->heaDiv($this->txtMenStyle);
		
		$menuV= explode(';',$menPrmStr);
		$i= 0;
		
		reset($menuV);
		foreach ($menuV as $key=>$couple){
			$cplV= explode('/',$couple);
			
			$command= trim($cplV[0]);
			$label= $cplV[1];
			
			$url= $baseUrl.$tools->addUrlVar(_c_tMenCateg,$command);
			
			$curMenCateg= $tools->getVal(_c_tMenCateg);
			if ($curMenCateg===$command || $curMenCateg===false && $i===0 ){
				$cls= 'textMenIn';
			}else{
				$cls= 'textMenOut';
			}
			
			$buff.= $caps->hL($url,$label,$cls);
			$i++;
		}
		$buff.= $caps->enDiv();
		return $buff;
	} // setMenusCore	
	
	/**
		Having $menuV as an input of Menu Binomes Array
	*/
	function setMenusCoreMB($menuV,$explCl,$urlFu){
		$tools= &$this->tools;
		$caps= &$this->caps;	
			
		$baseUrl= $explCl->$urlFu();
		$buff= '';
		$buff.= $caps->heaDiv($this->txtMenStyle);
		
		$i= 0;
		reset($menuV);
		foreach ($menuV as $key=>$cplV){
			$command= key($cplV);
			$label= current($cplV);
			
			$url= $baseUrl.$tools->addUrlVar(_c_tMenCateg,$command);
			
			$curMenCateg= $tools->getVal(_c_tMenCateg);
			if ($curMenCateg===$command || $curMenCateg===false && $i===0 ){
				$cls= 'textMenIn';
			}else{
				$cls= 'textMenOut';
			}
			
			// $buff.= ' '.$caps->hL($url,$label,$cls);
			$buff.= $caps->hL($url,$label,$cls);
			$i++;
		}
		$buff.= $caps->enDiv();
		return $buff;
	} // setMenusCoreMB	
		
			
} // textMenus
?>
