<?php
/**
	File name : topBarTags.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/
class topBarTags extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->acc= &$tagsFu->acc;
		$this->rights= &$tagsFu->rights;
		$this->hPwC= &$tagsFu->hPwC;
		$this->fls= &$tagsFu->fls;
		$this->aSql= &$tagsFu->aSql;
		$this->dtb= &$tagsFu->dtb;
		$this->parser= &$tagsFu->parser;
		$this->editTools= &$tagsFu->editTools;
		$this->wmR= &$tagsFu->wmRights;	// for switchDtb
		$this->imgTags= &$tagsFu->imgTags;
					
		$tagsFu->includeSupFiles('topBarTags',false,false);

		/** Top bar sensitive button  tg_topbarbut */
		$tagsFu->attribVect['topbarbut']= array('pg','codedit','private','gvpg','defumusrid','justsrf','samepg','reload','complem',_c_okDecom,'icon','alt','altuname','urlsffx','fu','urlvar','urlval','target','el','aridx','arval');
		
		// Calling the given funtion
		$tagsFu->attribVect['futopbarbut']= array('fu','class','categcl','pg','icon','altcode');
		
		
		
		
		$tagsFu->attribVect['topwidgets']= array('path','cl','fu');
		
		/** Top bar sensitive link */
		$tagsFu->attribVect['topbarsnln']= array('lbl','el','kind','icon','alt','ealt','fontin','fontout','butcls');
		
		$tagsFu->attribVect['tbsortofdtb']= false;
		
		$tagsFu->attribVect['chgeditlg']= false;
		
		$tagsFu->attribVect['logoutbut']= false;
		$tagsFu->attribVect['dtbmgnbut']= array('icon','categ');
	} // construct
	
	
	/**
		Used to load tagsVect with all the tags used by this class. 
	*/
	function tags(){
		return array('topbarbut','futopbarbut','topbarsnln','tbsortofdtb','topwidgets','chgeditlg','logoutbut','dtbmgnbut');
	} // tags
	
	
				
	/**
		An evolution of tg_topbarbut() where we call directly the given function $v['fu']
		[fuTopbarBut icon="fast-computer.png" class="cacheWriter" fu="HW" /]
	*/
	function tg_futopbarbut(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;


		$classNm= $tools->binLoads($v['class'], 'topBarTags');
		$fu= $v['fu'];
		$actionId= $classNm.'_'.$fu;	// unique action Id
		
		if ($tools->gotVal('fuTopbarBut',$actionId)){		
			$categCl= $tools->binLoads($v['categcl'], _c_libClassCateg);
			
			// ---> just calls fu and go back on the same page When the button is clicked
			
			$curCls= $tagsFu->optimClassAccess($categCl,$classNm);
			$curCls->$fu();
		}
		
		$icon= $v['icon'];
		
		
		$altCode= $tools->binLoads($v['altcode'],_c_ko);
		$atl= $glob->el('',$altCode);
		
		
		$curBut= $caps->stdImage($icon,_c_ok,$atl,'topBarImgIcon');
		
		$pg= $tools->binLoads($v['pg'],$tools->curPageName());
		
		$urlPg= $tools->urlGivenPage($pg);
		$urlPg.= $tools->addUrlVar('fuTopbarBut',$actionId);
		
		// Add forum param if it's forum page and need then
		$urlPg.= $tools->reprodUrlVar(_c_fxCodeIndx);
		$urlPg.= $tools->reprodUrlVar(_c_rfxPage);
		$urlPg.= $tools->reprodUrlVar(_c_rfTGroupIdx);
		return $caps->linkTC($urlPg,$curBut,$atl,'tbImgMarginFL');
	} // tg_futopbarbut


	/**
		[topBarBut pg="_file-manager" icon="file-manager.png" alt="File Manager" /]
		A tag to display a top bar button to click.
		[topBarBut samepg="ok" fu="switchDtb" /]
	*/
	function tg_topbarbut(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$wmR= &$tagsFu->wmRights;
		$rMg= &$this->rights;
		$glob= &$this->glob;
		$fls= &$this->fls;
		$hPwC= &$this->hPwC;
		$caps= &$this->caps;
		$tools= &$this->tools;		
		$dtb= &$this->dtb;
		$imgTags= &$this->imgTags;
		

		$icon= $v['icon'];
		$frill= $wmR->wmSuFrill();
		$codedit= $v['codedit'];
		$private= $v['private'];
		
		if (!$frill && $codedit===_c_ok){
			return '';
		}
		
		if (!$frill && $private===_c_ok){
			return '';
		}
		
		$iconSrc= $caps->imgSrc($icon,_c_ok);
		if (!file_exists($iconSrc)){
			return '';	// so if the image does not exists, the display AND THE EXECUTION are impossible!
		}
		
		$fu= $v['fu'];
		$shortCircAtt= false;
		
		$samePg= $v['samepg'];		
		$givPg= $v['pg'];
		
		if ($givPg==='_random'){
			$givPg.= $hPwC->consonStr(10);
		}
		
		if ($samePg===_c_ok){
				$complem= $tools->binLoads($v['complem'],'');
				$pg= $tools->curPageName().$complem;
		}else{
			$pg= $tools->binLoads($givPg,_c_mainHomePage);
		}
		
		/**
			For public installation, the installer page is accessed via the standard menu, so don't have to bother with the installer button on production site!
		*/
		if ($pg==='_installer' || $pg==='_extractor' || $pg==='_installExtract' || $fu==='rmBuildPhpDtb' || $fu==='switchDtb'){
			if ( !$wmR->buildButtAccept() ){
				return '';	// building buttons not accepted
			}
		}
		
		$alt= $tools->binLoads($v['alt'],'');	
		$el= $v['el'];
		$alt= $glob->el($alt,$el);
				
		$urlSffx= $tools->binLoads($v['urlsffx'],'');
		if ( $tools->sIsInB(_c_realHtmlAmp._c_surfEdt.'=', $urlSffx) || $tools->sIsInB(_c_rawAmp._c_surfEdt.'=', $urlSffx) ){
			$ar[_c_surfEdt]= true; // manages it here
		}
		
		$justSrf= $tools->binLoads($v['justsrf'],'');				
		
		$altSup= '';
		if ($fu!==false){
			$urlSffx= $tools->addUrlVar('topBarFu',$fu);			
			$topBarFu= $tools->getVal('topBarFu');
			
			if ($fu==='switchDtb'){
				$altSup= $this->dtbToSwitchTo();
			}
			
			if ($topBarFu!==false && $fu===$topBarFu){
				$this->$topBarFu();		// CALL THE GIVEN FU !!!!!!  codeLookAtSecutityHere  !!!!!!!
			}
		}
		
		$target= $tools->binLoads($v['target'],'');
		
		// Deals with 'urlvar','urlval'
		$urlvar= $v['urlvar'];
		if ($urlvar!==false){
			$urlval= $v['urlval'];	// used if forced on
			switch ($urlvar){
				case _c_editorPos:
					$ePos= $tools->gostVal(_c_editorPos,'right');
					$newEdtPos= $tools->invertVal($ePos,'left','right');
					$urlSffx.= $tools->addUrlVar(_c_editorPos,$newEdtPos);
					$shortCircAtt= _c_editorPos;
				break;
								
				default:
					$glob->userError($glob->el('Unknown urlvar paramater...','kavb'));
			} // switch
		}
		
		if ($samePg===false && $givPg===false){
			// home page button
			$altuname= $rMg->realTimeUserId();
		}else{
			$altuname= '';
		}
		
		$fullAlt= $alt.$altSup.$altuname;
		$curBut= $caps->stdImage($icon,_c_ok,$fullAlt,'topBarImgIcon');
	
	
		$arIdx= $v['aridx'];
		if ($arIdx===false){
			$ar['shortCircAtt']= $shortCircAtt;
			if ($justSrf===_c_ok){
				$ar['justsrf']= _c_ok;
			}
			
			if ($v['reload']!==_c_ok){
				$ar['shortCircAtt']= _c_surfEdt;
				$ar['resetEdtMultiDtb']= _c_ok;	// don't want to bother all theses buttons with these 5 parameters
			}
		}else{
			// call exmpl : arIdx="curTblToDspl" arVal="ko"
			$arVal= $v['arval'];
			$ar[$arIdx]= $arVal;
		}
		
		// Just trailing chunk condition .. evt interfering with a new browsing
		$ar['mmDFChunkPos1']= _c_ko;
		$ar['mmDFChunkPos2']= _c_ko;
		
		$zm= $tools->getVal(_c_zoomCachPfx);
		$key= $tools->getVal(_c_idTextsZm);
		if ( ($zm!==false || $key!==false) && $justSrf===_c_ok){
			// simple surf on a zoom
			if ($zm!==false){
				$fls->splitOnLstC($zm,$left,$imgNameWithExt);
				$key= $imgTags->bigImgLabelKey($imgNameWithExt);
			}
			$url= $imgTags->minimalZmUrl($key,false);
			$url.= $tools->addUrlVar(_c_statsAvoidUVar,_c_ok);
		}else{
			$url= $tools->urlGivenPage($pg,$ar).$urlSffx;		// MAIN
		}
		
		$peDecom= $v[_c_okDecom];	// from xPetal param
		$dbDecom= $dtb->getGenVar(_c_deComMasterVal);	// the webmaster code by default
		if ($peDecom===_c_ok){
			$url.= $tools->addUrlVar(_c_okDecom,$dbDecom);	// add a decom for sensitive users
		}
		
		return $caps->linkTC($url,$curBut,$fullAlt,'tbImgMarginFL',$target);
	} // tg_topbarbut	


	/**
		To define top widgets in the to bar : copy paste this in fact as many as necessary (the class must already
		be instanciated in the main class). Can use as many of these tags without any overload of the system (no more
		class declared that the necessary minimum)
		
		Exmpl : [topWidgets cl="jsEncryption" fu="lineCryptWdgt" /]
			Rem : don't even ned to specify the path because the class was already declared!
	*/
	function tg_topwidgets(&$v,&$bd){
		$caps= &$this->caps;
		$tagsFu= &$this->tagsFu;

		$className= $v['cl'];
		$fu= $v['fu'];
	
		if (array_key_exists($className,$tagsFu->explicitClasses)){
			$clInst= &$tagsFu->explicitClasses[$className];
			return $clInst->$fu();
		}else{
			return '';
		}
	} // tg_templatetag

	
	/**
		Input :
			$menAction : the action / the job to do.
			$lbl : displayed button label.
			etc.
		Output :
			Passive : display the button/text.
			Clicking on it : call the server with the action and localisation parameter.		
	*/
	function actionSensitiveLink($menAction,$lbl,$actionUrlVar=_c_actionGetVar,$ttl,$fontOut='editOut',$fontIn='editIn'){
		$tools= &$this->tools;
		$caps= &$this->caps;
	
		$curPgName= $tools->getUrlPageName();
		
		$arCmd['shortCircAtt']= _c_surfEdt;
		$url= $tools->urlGivenPage($curPgName,$arCmd);
		$url.= $tools->addUrlVar(_c_surfEdt,'both');
		$url.= $tools->addUrlVar(_c_editorPos,'left');
		$url.= $tools->addUrlVar($actionUrlVar,$menAction);
				
		$urlAction= $tools->getVal($actionUrlVar);
		if ($menAction===$urlAction){
			$b= $caps->linkTC($url,$lbl,$ttl,$fontIn);
		}else{
			$b= $caps->linkTC($url,$lbl,$ttl,$fontOut);
		}
		
		return $b;
	} // actionSensitiveLink
	

	/**
	*/
	function strongSwitchDtb(){
		$this->witchDtb(false);
	} // strongSwitchDtb

	/**
	*/
	function switchDtb($carefulRights=true){
		$glob= &$this->glob;
		$fls= &$this->fls;
		$rMg= &$this->rights;
		$wmR= &$this->wmR;
		
		if ( $carefulRights && !$wmR->buildButtAccept() ){
			return '';
		}
		
		if ($glob->cndtWrRghts===false){
			// in princiople bever happens !!
			$glob->setGuestDisplay($glob->el('Change the sort of database!','kavc'), $glob->el('Mainly useful','kavd'));
			return '';
		}
		
		if (!$rMg->quickWMRight()){
			return '';
		}
		
		switch (_c_CurrentDtbAbstract){
			case  'aMySql':
				$sourceFN= 'exmplAboveDtbPhp.php';
			break;
						
			case 'simulSql':
				$sourceFN= 'exmplAboveDtbMySql.php';
			break;
		} // switch
	
		$srcDFN= _c_phpChooseDtb.$sourceFN;
		$trgDFN= _c_chooseDtbDFN;
		
		$fls->unLnk($trgDFN);
		$fls->strToFile($trgDFN,$fls->fileToStr($srcDFN));	
	} // switchDtb
	
	
	/**
	*/
	function dtbToSwitchTo(){
		switch (_c_CurrentDtbAbstract){
			case  'aMySql':
				return 'MySql Simulation';;
			break;
						
			case 'simulSql':
				return 'MySql';
			break;
		} // switch
	} // dtbToSwitchTo
	

	/**
		For ; "Insert One Page", "Insert Multi Lang Pages" etc.
	*/
	function tg_topbarsnln(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		
		$lbl= $v['lbl'];
		$el= $v['el'];
		$lbl= $glob->el($lbl,$el);

		
		$kind= $v['kind'];
		if ($kind===false){
			$glob->userError($glob->el('...you must specify the category...','kava'));
			$kind= _c_insertDepMenAct;
		}		
		
		$icon= $tools->binLoads($v['icon'],'orange-dot.png');
		
		$eAlt= $v['ealt'];
		$alt= $glob->el($v['alt'],$eAlt);
		$alt= $tools->binLoads($alt,'');
		
		$fontIn= $tools->binLoads($v['fontin'],'topBarTextIn');
		$fontOut= $tools->binLoads($v['fontout'],'topBarTextOut');
		$butLinkCls= $tools->binLoads($v['butcls'],'topBarImgBull');
		
		$buff= '';
		$curBut= $caps->stdImage($icon,_c_ok,$alt,'topBarImgSober');
		$buff= $this->actionSensitiveLink($kind,$curBut,_c_actionGetVar,$alt,$butLinkCls,$butLinkCls);
		
		return $buff.$this->actionSensitiveLink($kind,$lbl,_c_actionGetVar,$alt,$fontOut,$fontIn);
	} // tg_topbarsnln
	
		
	/**
	*/
	function tg_tbsortofdtb(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$aSql= &$this->aSql;
		
		if ($glob->cndtWrRghts===false && _c_sqlSimul){
			return '';
		}
		
		switch (_c_CurrentDtbAbstract){
			case  'aMySql':
				$lbl= 'MySql';
				$alt= $glob->el('MySql version : ','kbaa').$aSql->msqlImp->server_info;
			break;
						
			case 'simulSql':
				$lbl= '100% Php';
				$alt= $glob->el('a php partial simulation of MySql','kbab');
			break;			
			
			default:
				$lbl= 'Unknown DTB';
				$alt= 'Error unknown DTB';
			;
		} // switch
		
		$param= $caps->ta( $glob->el('The used database is ','kbac')._c_UsrDbName.$glob->el(' on ','kbad').$alt);
		$param.= $caps->matCss('topBarHelp');
		return $caps->spanA(_c_sT.$lbl,$param);				
	} // tg_tbsortofdtb
	
	/**
		[chgEditLg /]	Change the editor language.
	*/
	function tg_chgeditlg(&$v,&$bd){
		$caps= &$this->caps;
		return $caps->chgEditLanguage();
	} // tg_chgeditlg

	
	/**
		[logoutBut /]  note could have done a gteneral call, with a general tag using directly
		the parameters given as constants! But less practical in most cases!
	*/
	function tg_logoutbut(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		if ($glob->cndtWrRghts===true){
			$url= $tools->urlGivenPage(_c_permanDefPage);
		}else{
			$arCmd['justsrf']= _c_ok;
			$url= $tools->urlGivenPage(_c_permanDefPage,$arCmd);
		}
		
		$url.= $tools->addUrlVar(_c_unlogUrlVar,_c_ok);
		$url.= $tools->addUrlVar(_c_statsAvoidUVar,_c_ok);
		return $caps->drawGenButton($url,$glob->el('Session Logout','kazx'),'logout.png');
	} // tg_logoutbut


	function urlCallableUnlog(){
		$rMg= &$this->rights;
		$rMg->unlogCleanUpCore();
	} // urlCallableUnlog
		
	
	/**
		[dtbMgnBut /]  note could have done a general call, with a general tag using directly
		the parameters given as constants! But less practical in most cases!
	*/
	function tg_dtbmgnbut(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rMg= &$this->rights;
		
		$specCateg= $tools->mostValid($v['categ'],_c_df); // specific genVar category ... forces also genVar table if specified
		if ($specCateg==='editRisks' && !$rMg->frcEditRights()){
			return '';
		}
		$icon= $tools->mostValid($v['icon'],'database.png');
		
		$arCmd['shortCircAtt']= _c_surfEdt;
		$arCmd['resetEdtMultiDtb']= _c_ok;
		
		$url= $tools->urlGivenPage('_table_editor',$arCmd);
		$url.= $tools->addUrlVar(_c_surfEdt,_c_seSurfVal);
		
		if ($tools->getVal('tedExoDtbImplem')===false){
			switch ($specCateg){
				case 'editRisks':
					$tblUvv= $tools->addUrlVar(_c_tedCurDtbTblNm,_c_GenVarTbl);
					$tblUvv.= $tools->addUrlVar(_c_tedGvFilter,'accel');
				break;
				
				case _c_df:
					$tblUvv= $tools->reprodUrlVar(_c_tedCurDtbTblNm);	// current table url var val combination
					if ($tblUvv===''){
						$tblUvv= $tools->addUrlVar(_c_tedCurDtbTblNm,_c_GenVarTbl);
					}
					$gTblNm= $tools->gostVal(_c_tedCurDtbTblNm);
					if ($gTblNm===_c_GenVarTbl || $gTblNm===false){
						$tedFltr= $tools->reprodUrlVar(_c_tedGvFilter);
						if ($tedFltr===''){
							$tblUvv.= $tools->addUrlVar(_c_tedGvFilter,'ataox');
						}else{
							$tblUvv.= $tedFltr;
						}
					}
				default:
				break;
			} // switch
			
		}else{
			$tblUvv= $tools->addUrlVar(_c_tedCurDtbTblNm,_c_GenVarTbl);
		}
		
		$url.= $tblUvv;
		$url.= $tools->reprodUrlVar(_c_tedTblChunkId);
		switch ($specCateg){
			case 'editRisks':
				return $caps->drawGenButton($url,$glob->el('Warning ...','kboz'),$icon,'tbImgMarginFL');
			break;
			
			case _c_df:
			default:;
				return $caps->drawGenButton($url,$glob->el('Database Manager','kbae'),$icon,'tbImgMarginFL');
			break;
		} // switch
	} // tg_dtbmgnbut

	
	/**
		Build the strict php data base
	*/
	function rmBuildPhpDtb(){
		$tagsFu= &$this->tagsFu;
		$rMg= &$this->rights;
		$wmR= &$this->wmR;
		
		if ( !$wmR->buildButtAccept() ){
			return '';
		}
		
		$xtr= $tagsFu->instExplitExternalCls('extractor');
		$xtr->rmvBuildPhpDtb();
	} // rmBuildPhpDtb
	
				
	/**
	*/
	function tg_toCopy(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
	} // tg_toCopy
		
	
} // topBarTags

?>
