<?php
/**
	File name : adverts.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="adverts" /]				[_ r="PLUGIN DECLARATION"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
			
			imgTags::$this->zmOriginPg
			
	Diverse :
		Suffix full screen, see genMenTg::addFreeStyleSuffx()
*/
class adverts extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();
		
		$tagsFu->mainAdvertPlugIn= &$this;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->rMg= &$tagsFu->rMg;
		$this->parser= &$tagsFu->parser;
		$this->imgTags= &$tagsFu->imgTags;
		
		$this->forbidenPgStr= false;	// just an init
		$this->formalPosition= 'hz';	// just an init, the real formal menu position is given with the tag
		$this->verticalAdLatch= false;
		$this->sorryNoVerticalAds= false;
		$this->gotAtLeastOneHzTtlAds= false;
		$this->gotAL1DefinedHzTtlAds= false;
		
		
		$this->hzTtlBuffer= '';
		$this->hzZmTtlBuffer= '';
		
		$glob->advertTempBuff= 'OnlyTheConstructorGetsThrough';
		
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method 
		$tagsFu->includeSupFiles('adverts');
		
		/*
			To load the horizontal and vertical adverts identification strings :
				horzId
				vertId
			
			position : the advert position : "hz", "vt"   (for now horizontally or vertically)
						"adapt"  ---> horizontal "hz" in natel mode and vertical "vt" in desktop mode. The conversion
						"hz", "vt" is done automatically.
						"adapgttl" : adapt got the page right side of ttl in natel mode only, so like an "hz" but just afte the title
								using the title tag [pgTitle /], if the tag is not there don't display the ad.
			bd : body substitute and a priority if used!! New idea --> sometimes more compact tags especially when tag name is long.
						
			subst : an eventual Xpetal code / string to use as a substitute when the advert is declared as "ko"
					so not used with an xPetal command.
			mastercall : if many calls are done, the one with mastercall=ok imposes the menus position.
			forbidpg : given forbidden pages, separated with ,
			contighzads : number of continuous (on the same row) horizontal advertsments ads only
			contigvtads :  number of continuous (on the same column) horizontal advertsments ads only
			
			
			fix Dim HEIGHT / WIDTH : a fixed linear dimension concerning the ad(s) encapsulator
				fixdimHpx: For HORIZONTAL ADS fixdim matches a HEIGHT and is given in px (pixels).
				fixdimWpc: For VERTICAL ADS fixdim matches a WIDTH and is given in % and must be substracted to the menu CSS matching dimensions
		*/
		$tagsFu->attribVect['adv']= array('horzid','vertid','position', 'hzcellwidthpx', 'fixdimhpx', 
			'fixdimwpc', 'mindimwpx', 'forbidpg', 'contighzads', 'contigvtads', 'subst', 'mastercall', 'hzmax100pc', 'borderpx');
	} // construct

	/**
	*/
	function tags(){
		return array('adv');
	} // tags

		
	/**
		Stores in fast memory the state of $dtb->getGenVar($vertIdOk), so wont access it
		twice the slow ways. And access it afterwar undirectly on its boolean form boolVerticalLatch().
	*/
	function vertAdLatch($vertIdOk){
		$dtb= &$this->dtb;
		
		if ($this->verticalAdLatch!==false){
			return $this->verticalAdLatch;
		}
		
		$this->verticalAdLatch= $dtb->getGenVar($vertIdOk);
		return $this->verticalAdLatch;
	} // vertAdLatch
	
	/**
		Note : $this->vertAdLatch() must run before
	*/
	function boolVerticalLatch(){
		return $this->verticalAdLatch===_c_ok;
	} // boolVerticalLatch
	
	/**
		Returns true if we are on an adverts forbidden page.
	*/
	function onForbidPg($forbPgStr,$curPg=false){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
				
		if ($tools->validOkDecomUrlVal()){
			return true; // decom for to sensitive user
		}
		
		
		if ($curPg===false){
			$curPg= $tools->curPageName();
		}
		
		if ($tools->isPfxB('_',$curPg)){
			if ($curPg!==_c_bigZoomPg){
				return true; // is on an implicitly forbidden page
			}else{
				// For the rights we care about the parent page of _c_bigZoomPg, 
				// treated separatly in tg_adv(&$v,&$bd) with : $imgTags->zmOriginPg
			}
		}

		if ($forbPgStr!==false){
			$forbPgVect= $tools->trimStrToV($forbPgStr);			
			if ($tools->aIsInV($curPg,$forbPgVect)){
				return true; // is on an explicitly  forbidden page
			}
		}
		
		return false;
	} // onForbidPg
	
		
	/**
		Return true if the page forbid advertisments.
		Return true if we have the menu in a vertical position AND 
				(We are on ads forbiden page OR we have webmaster rights)
		Can only be called usefully after a mastercall of tg_adv(...)
	*/
	function onForbidPgVertPos(){
		$rMg= &$this->rMg;
		
		$pos= $this->effectiveAdsPos($this->formalPosition); 
		$onF= $this->onForbidPg($this->forbidenPgStr); 
		$wmRights= $rMg->quickWMRight();
		return $pos==='vt' && ($onF || $wmRights);
	} // onForbidPgVertPos

	
	/**			
			$this->effectiveAdvertPos= $pos;		
	*/
	function effectiveAdsPos($pos,$contAds=false){
		$tools= &$this->tools;
		
		if ($pos==='adapgttl' && $contAds!==false){
			$contAds= round($contAds);
			if ($contAds>0 && $tools->getVal(_c_idTextsZm)!==false){
				$pos= 'hzoom'; // got an ad associated with a zoomed image
				return $pos;
			}
		}
		
		if ($pos==='adapt'){
			if ($tools->isInSmartPM()){
				$pos= 'hz';
			}else{
				$pos= 'vt';
			}
		}
		
		if ($pos==='adapgttl'){			
			if ($tools->isInSmartPM()){
				$pos= 'hzttl';
			}else{
				$pos= 'vt';
			}
		}
		
		return $pos;
	} // effectiveAdsPos
		
		
	/**
		The main advert tag, General exxamle below to differentiate between horizontal and vertical ads call by this code.
		[adv horzId="wrb1" vertId="wrb2" position="adapt" fixdimHpx="50" fixdimWpc="18" forbidPg="main" mastercall="ok" contigads="10" hzmax100pc="98" borderpx="1" /]
	*/
	function tg_adv(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rMg= &$this->rMg;
		$parser= &$this->parser;
		$imgTags= &$this->imgTags;
		
		
		$horzId= $v['horzid'];
		$vertId= $v['vertid'];
		
		$horzIdOk= $horzId.'Ok';
		$vertIdOk= $vertId.'Ok';
		
		$this->vertAdLatch($vertIdOk);
		
		
		if ($rMg->quickWMRight()){
			return '';	// Do not want any distracting adverts in webmaster mode.
		}
		
		$forbidenPgStr= $v['forbidpg'];
		$formalPosition= $tools->binLoads($v['position'],'adapt');
		
		$mastercall= $v['mastercall'];
		if ($mastercall===_c_ok){
			$this->formalPosition= $formalPosition;
			$this->forbidenPgStr= $forbidenPgStr;
		}
		
		if ($this->onForbidPg($forbidenPgStr)){
			return ''; // got a forbidden page (by the way it's also fordidden for substitute, so simple '')
		}
		
		
		$idTxZ= $tools->getVal(_c_idTextsZm);
		if ($idTxZ!==false){
			$imgTags->blindZBigImInit();
			if (isset($imgTags->zmOriginPg)){
				$zmOriginPg= $imgTags->zmOriginPg;
						
				if ($this->onForbidPg($forbidenPgStr,$zmOriginPg)){
					return ''; // got a forbidden $zmOriginPg 
				}
					
			}else{
				return '';
			}
		}
		
		$contAds= $tools->binLoads($v['contighzads'],'0');
		$curPos= $this->effectiveAdsPos($formalPosition,$contAds);
		
		/**
			Horizontal adverts 
		*/
		if ($curPos==='hz' || $curPos==='hzttl' || $curPos==='hzoom'){
			$okHorz= $dtb->getGenVar($horzIdOk)===_c_ok;
			if ($okHorz){				
				if ($contAds==='0'){
					return '';
				}
				$contAds= round($contAds);
				
				if ($curPos==='hzttl' || $curPos==='hzoom'){
					$this->gotAtLeastOneHzTtlAds= true;
				}
	
				$advertCode= $dtb->getGenVar($horzId);
				$cNb= $contAds;	// to multiply the advert code horizontally as many times as requested
				if (!$tools->falseOrKo($cNb) && $cNb>=1 && $cNb<=10){
					$pixHeight= $tools->binLoads($v['fixdimhpx'],false);	// default 100 pixels
					if ($pixHeight!==false){
						$pxHhtStr= ' height:'.$pixHeight.'px;';
					}else{
						$pxHhtStr= ' height: auto;';
					}
					
					$bordPx= $tools->binLoads($v['borderpx'],'0');	// default 98%
					
					switch ($curPos){
						case 'hz':
							$hzMaxPc= $tools->binLoads($v['hzmax100pc'],'98');	// default 98%
							$cellW= $hzMaxPc/$cNb;
							$widthStr= ' width:'.$cellW.'%;';
						break;
						
						case 'hzoom':
						case 'hzttl':
							$cellW= $tools->binLoads($v['hzcellwidthpx'],'320');	// default 98%
							$widthStr= ' width:'.$cellW.'px;';
						break;
					} // switch
					
					$lnOfDivs= '';
					for ($i=0; $i<$cNb; $i++){
						// safer to have specific cells for each ads
						$lnOfDivs.= $caps->sDiv($advertCode,' float:left; border:'.$bordPx.'px solid red;'
							.$pxHhtStr.$widthStr);
					} // for
					
					switch ($curPos){
						case 'hz':
							return $lnOfDivs._c_BrFlux;
						break;
						
						case 'hzttl':
							$this->hzTtlBuffer= $lnOfDivs._c_BrFlux;
							return '';
						break;
						
						case 'hzoom':
							$this->hzZmTtlBuffer= $lnOfDivs._c_BrFlux;
							return '';
						break;
					} // switch
				}
			}else{
				$subst= $v['subst'];	// could be more precise later on with $subst= $v['substhz'];
				if ($subst!==false){
					return  $parser->parseStdStr($subst);
				}else{
					return '';
				}
			}
		}
		
		/**
			Vertical adverts
		*/
		if ($curPos==='vt'){
			if ( $this->boolVerticalLatch() ){
				$contAds= $tools->binLoads($v['contigvtads'],'0');
				if ($contAds==='0'){
					$this->sorryNoVerticalAds= true;
					return '';
				}
				$contAds= round($contAds);
				
				$advertCode= $dtb->getGenVar($vertId);
				$lNb= $contAds;
				if (!$tools->falseOrKo($lNb) && $lNb>=1 && $lNb<=10){
					$stackedAds= '';
					for ($i=0; $i<$lNb; $i++){
						// ads should stack up joyfully
						$stackedAds.= $advertCode._c_BrFlux;
					} // for
					
					$percWidth= round($tools->binLoads($v['fixdimwpc'],'18'));	// default 20%
					$mindimwpx= round($tools->binLoads($v['mindimwpx'],'120'));
					$vertDiv= $caps->sDiv($stackedAds,
						' float:left; border:0px solid red; width:'.$percWidth.'%; min-width:'.$mindimwpx.'px;');
					return $vertDiv;
				}
			}else{
				$subst= $v['subst'];	// could be more precise later on with $subst= $v['substvt'];
				if ($subst!==false){
					return  $parser->parseStdStr($subst);
				}else{
					return '';
				}
			}
		}
		
		return ''; // Nothing defined properly
	} // tg_adv
		
	
	/**
	*/
	function tg_tmptag(&$v,&$bd){
		$caps= &$this->caps;
		$tools= &$this->tools;
	
	} // tg_tmptag

		
	/**
	*/
	function tmp(){
	} // tmp
		
} // adverts
?>