<?php
/**
	File name : calcBaseN.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



*/
class calcBaseN extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;	// access to some global values, sometimes methods
		$this->caps= &$tagsFu->caps;	// access many html methods
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$glob= &$this->glob;
				
		$this->largestCryptedIndex= 0;
		$glob->coreInclStanceJs(_c_LibExtPath,'stringMath');

		if (true){
			$glob->coreInclStanceJs(_c_LibExtPath,'xorShift', 'stdXorShift','xorShift');
		}else{	
			$glob->coreInclStanceJs(_c_toDeclPlugExt.'jsEncryption/','strXorShift', 'stdXorShift','strXorShift');
		}

		$this->globCurPath= $tagsFu->includeSupFiles('calcBaseN','calcBaseNDspl'); // INCLUSION of the calcBaseN family files
				
		$tagsFu->attribVect['testencryp']= array('display','l','c');
		$tagsFu->attribVect['jscrypt']= array('i','l','c');
		
		$tagsFu->attribVect['setcryptarea']= array('l','c');
		$tagsFu->attribVect['topinlncryptbox']= false;
		
		$tagsFu->attribVect['linecrypt']= array('i');
		$tagsFu->attribVect['linecom']= array('i');
		$tagsFu->attribVect['lcryptarea']= array('i','l','c');
		$tagsFu->attribVect['testarea']= array('l','c');
	} // construct


	/**
		This associative array must hold all the class's tags names, so the cms can declare them.
	*/
	function tags(){
		return array('testencryp');
	} // tags


	/**
	*/
	function dblSpan($s1,$s2, $optTtlFont='lnCryptBut'){
		$caps= &$this->caps;
		$sep= $caps->span(' : ',$optTtlFont);
		return $caps->span($s1,$optTtlFont).$sep.$caps->span($s2,'helpExplain')._c_;
	} // dblSpan


	/**
		Return the Head tag depending on the tag name and the numerical suffix. 
	*/
	function headTg($tagNm,$sffx){
		if ($sffx===''){
			return '['.$tagNm.']';
		}else{
			return '['.$tagNm.' i=dq'.$sffx.'dq]';	// to replace dq with " !! Js does nor take \" ??
		}
	} // headTg

		
	/**
		Return the End tag depending on the tag name and the numerical suffix. 
	*/
	function endTg($tagNm,$sffx){
		if ($sffx===''){
			return '[/'.$tagNm.']';
		}else{
			return '[/'.$tagNm.$sffx.']';
		}
	} // endTg


	/**
		manages the title, the alt and the class.
	*/
	function ttlCls($t,$c){
		$caps= &$this->caps;

		return $caps->ta($t).$caps->matCss($c);
	} // ttlCls


	/**
		The method used to test this plugin and call with 
			[testPlug display="Plugin trial of : " /]
	*/
	function tg_testencryp(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$curLineNb= $tools->binLoads($v['l'],'15');
		$curColNb= $tools->binLoads($v['c'],'40');
				
		$simplAlphabStr= 'abcdefghijklmnopqrstuvwxyz';
		
		$strChar28= ' '.$simplAlphabStr.'-';
		
		// a clone (for initialisation congruence), because in JS it's easier to define it with JS
		$frAlphabStr= '(fr)@abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789©'."\r\t\n".'/\\-_,.;:~`\'´¨^°§+"*ç%&=?!(){}[]$£€¢<>¦| #¬äëïöüâêîôûàèùé«»ÊÉÈ';
		
		$baseTen= '0123456789';	// more user friendly for beginner
		
		$pseudoDecStr= 'OIUEQSGTXA';
		$storageBase= 'bcdfghjklmnopqrstvwxyzBCDFGHJKLMNOPQRSTVWXYZ0123456789+-/*?!():_';


		
		$area= '';

		$c = $this->ttlCls('(Click XorShiftIn2D for a demo) A Xorshift algo. color-hit-frequency-displayed inside a 8x8 matrix after 200 calculated pairs of values.','imgPsdRnd');
		$d = $this->ttlCls('A few more steps using the (<<< Next) button.','imgPsdRnd');
		$e = $this->ttlCls('Even more steps using the (<<< Next) button','imgPsdRnd');
		$demoImgPack1= $caps->smpltImg(_c_toDeclPlugExt.'calcBaseN/xorShiftOneGos.png',$c).
				$caps->smpltImg(_c_toDeclPlugExt.'calcBaseN/xorShiftStep2.png',$d).
				$caps->smpltImg(_c_toDeclPlugExt.'calcBaseN/xorShiftStep3.png',$e);


		$c = $this->ttlCls('Not a xorshift, in fact bad pseudo random alorithm often/always(?) generate strong graphical biais (obtained with a twisted modulo loop)','imgPsdRnd');
		$d = $this->ttlCls('Not a xorshift, see previous explanation.','imgPsdRnd');
		$e = $this->ttlCls('Not a xorshift, see previous explanation.','imgPsdRnd');
		$demoImgPack2= $caps->smpltImg(_c_toDeclPlugExt.'calcBaseN/bias1.png',$c).
				$caps->smpltImg(_c_toDeclPlugExt.'calcBaseN/bias2.png',$d).
				$caps->smpltImg(_c_toDeclPlugExt.'calcBaseN/bias3.png',$e);



		$area.= $caps->tblTr($caps->tblTd(
		
			$caps->tblTag(
			$caps->tblTr(
			$caps->tblTd(		
				$demoImgPack1,
				'align="center"'
			).
		
			$caps->tblTd(
				$caps->span('Multi Base Any Length Calculator ++','baseNTtl'),
				'align="center"'
			).
			
	
			$caps->tblTd(
				$demoImgPack2,
				'align="center"'
			)),' width="100%" border="0" cellspacing="0" cellpadding="0"'), ' colspan="2" align="center"'));

		
		
		$spec= _c_sT;
		$spec.= $caps->spanA('XorShiftIn2D', 
			$caps->ta('A xor-shift is a generator of pseudo random numbers with the two previously cited boolean operations. This example generates a colored matrix indicating the frequency of the hitted squarres, along the color scale availyble at the bottom of the page. It starts each time with a new random seed and the steps can be continuated with the button &lt;&lt;&lt;Next that adds a few new undred steps. If going for long enough this process ends up coloring the whole matrix with an almost uniform color! Thanks to the large numbers, the local differences become comparatively negligeable, while the absolute differences stay about the same and pepper arround pseudo-randomly. It\'s pseudo because the random serie is calculated and therefore predictable, which is just what is usefull for many applications where the same serie must be calculated again to cypher a text and decypher the matching crypt.').
			' class="tstEncrypt" onClick="calcBaseN.testATHT(\'ok\')"');
		
		$spec.= _c_sT;
		$spec.= $caps->spanA('&lt;&lt;&lt; Next',
			$caps->ta('A few hundred next steps to add to the color matrix. The button XorShiftIn2D must have been pushed at the start of the serie or for a new color/(random hits) initialisation. See its explanations for more information.').
			' class="tstEncrypt" onClick="calcBaseN.callXorkNext(\'ok\')"');
		
		
		$spec.= _c_sT;
		$spec.= $caps->spanA('CntCharacters',
			$caps->ta('Counts the characters inside the Operand A area.').
			' class="tstEncrypt" onClick="calcBaseN.countChars()"');
			
			
		$spec.= _c_sT;
		$spec.= $caps->spanA('Spacer',
			$caps->ta('Add one space between each character of Operand A. If Operand B is given, uses Operand B as a spacer.').
			' class="tstEncrypt" onClick="calcBaseN.spacer()"');
		
		
		$spec.= _c_sT;
		$spec.= $caps->spanA('Clear',
			$caps->ta('Clear all places, exept the base boxes.').
			' class="tstEncrypt" onClick="calcBaseN.clearAll()"');
			
		
		$area.= $caps->tblTr(
			$caps->tblTd($caps->span('Special&nbsp;Fu()&nbsp;:','baseNLabel')).
			$caps->tblTd($spec));

	
		$baseBut= _c_sT;
		$baseBut.= $caps->spanA('Bin1'._c_Ns ,
			$caps->ta('Binary base.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\'01\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Oct1'._c_Ns ,
			$caps->ta('Octal base.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\'01234567\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Decimal 1'._c_Ns ,
			$caps->ta('Standard decimal base, the fastest because don\'t do any base conversion. The decimal is the reference base because it\' easier and it can use the native Javascript math for digit to digit operartion. A reference base is necessary, otherwise special multiplication tables would be necessary for each base, or a slower approch by counting for all single digits operations, not a good idea considering the slow nature of interpreted languages and the advantage of trading memory and/or native machine code for speed.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\'0123456789\')"');
			
		// Pseudo decimal for some verification		
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('P10'._c_Ns ,
			$caps->ta('A pseudo decimal base where each digit is traded against a mnemonic character, it was first an easy way to test the litteral computation, because even ten based, it\'s not recognized as natuve and therefore forced through the whole conversion pattern, the result neing directly decimal readable, it is easy to cross-check the operations with a standard calculator.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\''.$pseudoDecStr.'\')"');
									
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('St1'._c_Ns ,
			$caps->ta('Used for a few trials with the Storable base, the idea was to find a base that would : (1) confortably fit in most text file format, (2) have as much as possible common characters (fixed at 64), so it would not take too much storage, (3)  be unpronouncable so it would minimize distraction. (in the evolving application : crypted text and non crypted texts are mixed in the same page so encryption time is minimal (small volume) and associated key-words are available for search), possibly a new context : inline text encryption or inline editor encryption with quotes.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\''.$storageBase.'\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Hex1'._c_Ns ,
			$caps->ta('Standard hexadecimal..').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\'0123456789ABCDEF\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('26Ch'._c_Ns ,
			$caps->ta('26 characters occidental alphabet.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\''.$simplAlphabStr.'\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('28Ch'._c_Ns ,
			$caps->ta('26 characters occidental alphabet + 2 useful/indispensable chars for sentences.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplOne(\''.$strChar28.'\')"');			
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Engl+Fr'._c_Ns ,
			$caps->ta('English and French set of characters.').
			' class="tstEncrypt" onClick="calcBaseN.setBaseFRDsplX(\'baseOneDspl\')"');
			
		$baseBut.= _c_;	
		
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Bin2'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\'01\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Oct2'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\'01234567\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Decimal 2'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\'0123456789\')"');
			
		// Pseudo decimal for some verification		
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('P10'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\''.$pseudoDecStr.'\')"');
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('St2'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\''.$storageBase.'\')"');
						
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Hex2'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\'0123456789ABCDEF\')"');
		
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('26Ch'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\''.$simplAlphabStr.'\')"');
		
		
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('28Ch'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseDsplTwo(\''.$strChar28.'\')"');
		
			
		$baseBut.= _c_sT;
		$baseBut.= $caps->spanA('Engl+Fr'._c_Ns ,
			' class="tstEncrypt" onClick="calcBaseN.setBaseFRDsplX(\'baseTwoDspl\')"');
			
			
		$area.= $caps->tblTr(
			$caps->tblTd($caps->span('Predefined Bases : ','baseNLabel')).
			$caps->tblTd($baseBut));
			
				
		$oprtLbl= $caps->tblTd( $caps->span('Operators : ','baseNLabel') );
			
			
		/* ------------------------------------------------
			OPERATORS BUTTONS.
		*/
		$oprt= '';
		
		$limit= array('ok'=>'Secure-Fast', 'ko'=>'Maybe Slow!');		
		$attS= $caps->matCss('smallCbsMess');
		
		$cmbLimName= 'bsCmbLimit';
		$oprt.= $caps->comboBox($cmbLimName,'ok', $limit, $attS,true);
		
			
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'+');
		$oprt.= $caps->onClickButton('addBut', $fu,'+',$caps->matCss('operatorBut').$caps->ta('String Addition'));
					
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'*');
		$oprt.= $caps->onClickButton('timesBut', $fu,'*',$caps->matCss('operatorBut').$caps->ta('String Multiplication in base A'));
							
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'-');
		$oprt.= $caps->onClickButton('subBut', $fu,'- (diff)',$caps->matCss('longOperBut').$caps->ta('Compute the difference between the 2 operands in base A'));
			
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'/');
		$oprt.= $caps->onClickButton('divBut', $fu,'/',$caps->matCss('operatorBut').$caps->ta('String Division in base A'));
			
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'^');
		$oprt.= $caps->onClickButton('divBut', $fu,'x^y',$caps->matCss('longOperBut').$caps->ta('Operand A to the power of Operand B in base A'));
			
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'!');
		$oprt.= $caps->onClickButton('divBut', $fu,'!',$caps->matCss('operatorBut').$caps->ta('Operand A factoriel in base A'));
			
		$fu= $caps->jsSimpleFu('calcBaseN.strgOperBsN',1,0,'Mx');
		$oprt.= $caps->onClickButton('divBut', $fu,'Mx',$caps->matCss('longOperBut').$caps->ta('Pseudo Matrix Multiplication, separator (anything, but , is a good idea if not a part of the base.) need to be defined inside the Base2 text field!'));
						
		$fu= $caps->jsSimpleFu('calcBaseN.baseXToBaseY',0,0);
		$oprt.= $caps->onClickButton('subBut', $fu,'Convert.Bases',$caps->matCss('longOperBut').
			$caps->ta('String Base Conversion : Operand A is considered as written in base A, then converted into base B and writtent into the result box.'));
			
		$oprt= $caps->tblTd($oprt,' align="center"');
		
		
		// An area to display any javascript messages as a supplementary debug tool
		$area.= $caps->tblTr($oprtLbl.$oprt);
		
		
		
		/**
			Html textBox cannot hold \r\n correctly! Quite normal for only one text line, so uses only textarea()
			Note for fun : with min alphsb : i*am= me	!!!!!!
		*/		
		$area.= $caps->tblTr($caps->tblTd( $caps->span('Base&nbsp;A','baseNLabel') ).
			$caps->tblTd($caps->textarea('baseOneDspl',1,$curColNb,$baseTen,$caps->matCss('encryptDspl'))));
		
		$area.= $caps->tblTr($caps->tblTd($caps->span('Operand&nbsp;A','baseNLabel') ).
			$caps->tblTd($caps->textarea('inputOne',2,$curColNb,'',$caps->matCss('encryptDspl'))));

		$area.= $caps->tblTr($caps->tblTd($caps->span('Base&nbsp;B','baseNLabel') ).
			$caps->tblTd($caps->textarea('baseTwoDspl',1,$curColNb,$baseTen,$caps->matCss('encryptDspl'))));
		
		$area.= $caps->tblTr($caps->tblTd($caps->span('Operand&nbsp;B','baseNLabel') ).
			$caps->tblTd($caps->textarea('inputTwo',2,$curColNb,'',$caps->matCss('encryptDspl'))));
					
		$area.= $caps->tblTr($caps->tblTd($caps->span('Result(s)','baseNLabel') ).
			$caps->tblTd($caps->textarea('calcBaseNDspl',20,$curColNb,'',$caps->matCss('encryptDspl'))));
		
		
		$substDiv1= $caps->sDiv('Multi Base Calculator (only in English / seulement en anglais). Warning : in standard base 10 outsider characters are not checked and can start unpredicted length loops.','width:600px; border: 0px solid black;','substDiv');
		$area= $caps->trTd($substDiv1,' colspan="2" align="center"').$area;
		$substDiv2= $caps->sDiv('----','width:400px; border: 0px solid black;','substInfDiv');
		$area.= $caps->trTd($substDiv2,' colspan="2" align="center"');

		
		
		$area= $caps->tblTag($area,' border="1" cellspacing="0" cellpadding="2"');
		
		
		$totDspl= $caps->sDiv($area, 'width:730px; border:2px solid red; padding:10px; margin:2px; float:left; background-color:white;');		
		return $totDspl._c_;
	} // tg_testplug
			
} // calcBaseN
?>
