/**
	File name : calcuLCEB.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**

	Calcul Le Compte Est Bon
	
	Instanciation :
		var calcuLCEB= new calcuLCEB();
		
	Warning about setTimeout() to manage a recursion without bothering the user, the idea was to call the recursive
	ethod with a timeout to avoid choking the browser (http://javascript.about.com/library/blrecursive.htm). This
	DOES NOT WORK with complex methods, because 1st called method just keep looping and the whole result is completly
	different! Tested code below :
			Header ;
				var globOperands= new Array();		
				var globSolStr= new String();		
				this.tmpCallSolveLCEB= tmpCallSolveLCEB;
	
			Main code :
				globOperands= newOperands;		
				globSolStr= solStr;								
				this.procTO=  setTimeout( "calcLceb.tmpCallSolveLCEB()" , 3000);
			
			General, because setTimeout is fussy about parameters :
				function tmpCallSolveLCEB(){
					solveLCEB(globOperands,globSolStr);	
				} // tmpCallSolveLCEB
				
	Style ; 
		new Array() or [] ? 
			{} saves about 2% of computation time, noz really visible!
			new Array() is much clearer to understand and easier to replace automatically if we really have to, so we keep it!
		
*/
function calcuLCEB(){

	var self = this;

	/**
		Pseudo Constants.
	*/
	var operatorNumber= 4;
	var crLn= "\r\n";
	var nbsp= 'nbsp;';
	var ap= '\'';	// appostrophy
	
	
	/**
		Global Instance variables.
	*/
	var manySlStr= '';		// String holding the best solutions
	var manyApproxStr= '';	// Approximation strings for the pure scan
	
	
	
	
	var solStr= '';		// current solution (best approach) string	
	var globalLastOprnd= -1;
	
	// group or not?
	var maxGoals= 8;
	var maxHzGoals= 100;
	var globMaxJoker= 100;
	var genCnt= 0;
	var onlyBottomBoxSol= false;
	
	
	
	var lastSolStr= '';
	
	var currentGoals= 0;
	
	var totOperation= 0;

		
	
	
	var bestSolValue= 0;	// the best value obtained up to now.
	var maxProduct= 0;
	var maxProductCase= false;
	
	
	var finalGoal= 0;		// dummy init.
	var gotGoalAndBrk= false;
	var toggleIncrease= true;
	var rarePatienceCnt= 0;
	


	var gotAGoal= false;	
	var examinedDepth= 0;
	
	
	
	var glOprtrV= Array ('*','+','-','/');
	
	
	var gTreeStChoice= '';
	var globTreeStr= '';	// Global Tree string for result display
	
	var globWkTreeStr= '';	// Global working Tree string (for the recursive proc to run on)
	var globTreeBop= new Array();
	
	var globCanonStr= '';
	var globPad= '';
	var curTreeCanoStr= ''; // forDebug
	var gotTriSol= false;
	
	
	var treeCallKind= '';
	var hshGTreeStr= '';	// hash global tree string
	
	var treeKeepGoing= false;
	
	var globCanonVect= new Array();
	var globCanonSolV= new Array();
	var writeOnceMess= new Array();
	
	var trivialSolStr= '';
	var approxAreErased= true;
	
	var oprndStr= new Array();
		
	
	
	
	/* ---------------------------------------------------------------
		Compulsory interface for all methods calls from outside.
	*/
	// this.getNumbers= getNumbers;
	this.displayResult= displayResult;
	this.toVectOfNodes= toVectOfNodes;
	this.callPureHzH= callPureHzH;
	
	this.getBestSolValue= getBestSolValue;
	this.getOprndStr= getOprndStr;	
	this.getMaxProduct= getMaxProduct;
	
	
	this.maxProdVal= maxProdVal;
	this.getMaxProductCase= getMaxProductCase;
	
	
			

	/* -----------------------------------------------------------------------
		Methods definitions
	 ----------------------------------------------------------------------- */
	 
	/**
	*/
	function getMaxProductCase(){
		return maxProductCase;
	} // getMaxProductCase
	 	 
	/**
	*/
	function getBestSolValue(){
		return bestSolValue;
	} // getBestSolValue
	 
	/**
	*/
	function getOprndStr(){
		return oprndStr;
	} // getOprndStr
	 
	/**
	*/
	function getMaxProduct(){
		return maxProduct;
	} // getMaxProduct
	 
	 


	/**
		lceb.getNumbers('tbCalcNumber')
	*/
	function getNumbers(c){
		// var nbStr= document.getElementById('tbCalcNumber').value;
		var nbStr= sop.getSmallScreenVal();
		return nbStr.split(c);
	} // getNumbers


	/**
		Returns true if a solution is directly inside the set of given numbers.
	*/
	function gotTrivialSol(finalGoal,operands){
		var gotIt= false;
		var sz= operands.length;
		for (var i=0; i<sz; i++){
			if (operands[i]===finalGoal){
				gotIt=true;
				break;
			}
		}
		return gotIt;
	} // gotTrivialSol
		
		
	// bestSolValue
	/**
		Returnn the best solution directly found in the set
	*/
	function bestPlaquette(finalGoal, operands){
		var sz= operands.length;
		var closestD= operands[0];
		for (var i=1; i<sz; i++){
			var d= operands[i];
			
			if ( Math.abs(finalGoal-operands[i]) < Math.abs(finalGoal-closestD) ){
				closestD= operands[i];
			}
		}	
		return closestD;
	} // bestPlaquette	
	
	

	/**
		Display the given array (v)
	*/
	function displayResult(kindOfSol,forceOpernds){		
		globCanonStr= '';
		globPad= '';
		manySlStr= '';			// string holding the best solutions
		manyApproxStr= '';
				
		gotGoalAndBrk= false;
		globalLastOprnd= -1;
		currentGoals= 0;
		totOperation= 0;
		rarePatienceCnt= 0;
		lastSolStr= '';
		gotAGoal= false;
		
		
		var ckBoxChecked= document.getElementById('chkBoxForAll').checked;
		if (ckBoxChecked!==true && kindOfSol==='hzAllSol'){					
			clearWrite('Attention le bouton "All Sol." qui affiche toutes les solutions peut mettre jusqu\'à 3 minutes pour trouver tous les resultats et donc BLOQUER VOTRE NAVIGATEUR pendant 3 minutes! Même les ordinateurs multi-processeurs ont en général ce problème car le Javascript ne dispatch en général son travail que sur un seul processeur! Pour continuer à surfer pendant ce temps en multi-processeur, utilisez un autre navigateur (une autre fenêtre peut ne pas suffir! Pour utiliser ce bouton, côcher la case "Max. Time. < 3 min"');
			return;
		}
		
		
		
		if (forceOpernds===''){
			var v= getNumbers(kk.trim(kc.sepOne));
		}else{
			var v= forceOpernds.split(kc.sepOne);
			
			/* We are in a set generation situation with 3 or 2 digits result adaptation, so should not
			   display anything ------------------------ */
		}


		finalGoal= parseInt(v[0]);
		oprndStr= v[1];	
		if (kk.isUndef(oprndStr)){		
			var btName= '';
			switch (kindOfSol){
				case 'hzAllSol':
					btName= '"All Sol." : génère TOUTES les solutions, peut être très long. A noter que l\'utilisation de ce bouton implique de cocher la case "Max. Time. < 3 min" pour éviter de perdre du temps par accident.';
				break;
				
				case 'hzOneStrongSol':
					btName= '"1st Sol." : affiche juste une solution.';
				break;

				case 'hzHideStrongSol':
					btName= '"Hidden" : affiche une solution mais dans la boîte de texte tout en bas de l\'écran, cachée en quelque sorte pour ne pas gâcher le jeux en divulgant la solution trop tôt, par contre cela PERMET DE SAVOIR SI UNE SOLUTION EXISTE OU NON, ce qui augmente la motivation pour la trouver.';
				break;

				case 'hzFastLuckySol':
					btName= '"Heuristic" : utilise un algorithme accéléré qui trouve une solution dans environ 90% des cas où elle existe.';
				break;				
			} // switch				
		
			clearWrite(btName + crLn+crLn+ 'Remarques générales : le bouton poussé calcule une solution au problème du Compte est Bon et de plusieures configurations dérivées qui doivent être préalablement calculées et affichées à l\'écran à l\'aide des boutons "3#6", "2#3", "3#4", "3#5", "3#6u", "4#6", "3#6x", "4#6x" seule les configurations 3#6 et 3#6x peuvent être calculée au hasard. les autres configurations n\'ont pas assez de configurations pour avoir assez souvent le résultat exact tiré au hasard, ce dernier est donc adapté en utilisant le mode de calcul "heuristic" pour qu\'il y aie toujours une solution! Ce qui implique aussi que le mode de calcul heuristique qui ne parcours pas toutes les possibilités trouvera toujours une solution pour toutes les configurations "3#6", "3#6u" vu que c\'est son algorithme qui l\'a assignée');
			return;
		}
				
		var operands= oprndStr.split(kk.trim(kc.sepTwo));
		bestSolValue= bestPlaquette(finalGoal, operands);		// the best value obtained up to now.
			
		var oprndsSz= operands.length;
		operands= intTheVector(operands);	// parseInt(
		
		globCanonVect= new Array();
		globCanonSolV= new Array();
		writeOnceMess= new Array();
		approxAreErased= true;
		clearWrite('');
				
		gotTriSol= gotTrivialSol(finalGoal,operands);
		if (gotTriSol){
			globCanonSolV[finalGoal]= true;			
			trivialSolStr= 'Trivial solution:'+crLn;
			trivialSolStr+= finalGoal+crLn;			
			globCanonSolV[globTreeStr]= true;
		}else{
			trivialSolStr= '';
		}
		
		objOprnd= new Object();
		objOprnd.d= operands;
		
		objMPV= maxProdVal(objOprnd.d);
		maxProduct= objMPV.prod;
		writeLn('Maximum number='+maxProduct);	// not always a product as with 1 # 1 # 1
				
		// special HzH
		globTreeStr= '';
		globWkTreeStr= '';					
		hshGTreeStr= '';
		genCnt= 0;
		onlyBottomBoxSol= false;
			
		var maxProductStr= '';
		maxProductCase= false;
		if (maxProduct <= finalGoal){
			maxProductCase= true;
			maxProductStr= ('The best "strategy" is the maximum product : '+ maxProduct + ' Multiply all numbers, ' +
				'except the 1 that must be added before multiplication, if possible in ' + 
				'group of 3, then 2 and singled out 1 must be added to the smallest factor ' +
				'(did not proove for all cases, but it seems correct.) :' +
				crLn + objMPV.str);	
		}
		
		switch (kindOfSol){
			case 'hzAllSol':
				// all solutions
				globMaxJoker= 1000;
				maxHzGoals= 500;
			break;
			
			case 'hzOneStrongSol':
				// one solution if exists !!
				globMaxJoker= 1000;
				writeLn('*** globMaxJoker='+globMaxJoker);
				
				maxHzGoals= 1;
			break;

			case 'hzHideStrongSol':
				globMaxJoker= 1000;
				maxHzGoals= 1;
				onlyBottomBoxSol= true;
			break;

			case 'hzFastLuckySol':
				globMaxJoker= 0;
				maxHzGoals= 1;
			break;
			
			default:
				alert('Error ');
		} // switch
		

		operands= toVectOfNodes(operands);
		callPureHzH(operands);
						
		if (gotTriSol){
			sop.clearWrite('');
			writeNl(trivialSolStr);
		}
					
		document.getElementById('timerTxtNm').value= '';
		var finalResult= 'Total Computer Operations ='+totOperation + crLn + 
			trivialSolStr +
			crLn + currentGoals +' Solution(s) for (' + sop.getSmallScreenVal() + ') :' + 
			manySlStr + crLn + 
			crLn + 'Approximations :' + 
			manyApproxStr + crLn + 
			globCanonStr + crLn + 
			maxProductStr +
			globPad;
	
		var buff= document.getElementById('calcGenDispl').value;
		document.getElementById('calcGenDispl').value= finalResult+ crLn +buff;
				
		document.getElementById('chkBoxForAll').checked= false;
	} // displayResult


	/**
		Nodes Array Sort.
		Input : n,m (two nodes of the array)
	*/
	function naSort(n,m){
		return n.res < m.res;
	} // naSort
	

	/**
		Transform a vector of integer operands to a vectors of nodes.
	*/
	function toVectOfNodes(oprs){
		var oprndV= new Array();
		sz= oprs.length;
		for(i=0; i<sz; i++){
			oprndV[i]= newStrtNd(oprs[i]);
		}
		return oprndV;
	} // toVectOfNodes
	
	
	/**
		New start node, to store one single operand with its future combinatoric association.
		Input :
			a : value of the concerned operand.
	*/
	function newStrtNd(a){
		var nd=  new Object();		// current node
		nd.res= a;	// original number == result
		nd.op= '';
		nd.leftNode= null;	// left operand Node  leftNode
		nd.rightNode= null;	// right operand Node rightNode
		nd.pos= 't';	// top by default, otherwise Left or Right
		nd.orig= 'o';	// origine (o === one of the original number), otehrwise : c for calculated.
		nd.lyr= 1;		// current layer (!! starting at 1 for additionability! Index start at 0)
		nd.bOp= newBop('+',a,a,nd,'b');
		return nd;
	} // newStrtNd
		
						
	/**
		New full node.
			Input :
				aNd : left operand node.
				op : operator
				bNd : right operand node.
	*/
	function newNode(aNd,op,bNd){
		var nd=  new Object();		// current node
		nd.leftNode= aNd;	// left operand Node
		nd.op= op;			// operator
		nd.rightNode= bNd;	// right operand Node
		
		nd.pos= 't';		// top (most of the time temporary).
		aNd.pos= 'L';		// left
		bNd.pos= 'R';		// right
		nd.orig= 'c';		// calculated origin, straight from applyOprtr()
		
		nd.lyr= aNd.lyr + bNd.lyr;
		
		nd.bOp= newBop('F','F',0,nd,'b');	// To buffer operands with operators. Init at "False"
		return nd;
	} // newNode	

		
	/**
		To buffer operands with operators.
		Input : 
			operator : the used or default operator.
			operand : the operand
			res : result of the cell element itself
			origNd : pointor on the original node 
			cbo : 
	*/
	function newBop(operator, operand, res, origNd, of){
		var b= new Array();	// To buffer operands with operators. Init at "False"
		var cell= new Object();
		cell.t= operator;	// operaTor (p) by default, but not used in calculation (all numbers are Positive) (one string character)
		cell.d= operand;	// operanD ... (string)
		cell.res= res;		// result of the cell element itself (string)
		cell.of= of;		// origin form, init default : 'b' === new bop.(one string character)
		cell.oNd= origNd;	// to access original parameters.(object)		
		b[0]= cell;
		return b;
	} // newBop
	

	/**
		Transform the given string (s) into a single bOp with a conventional + operator.
		Input:
			s : given string
			origNd : origin node.
		Origin:
			--> .of==='s'
	*/
	function stringToBop(s,origNd){
		return newBop('+', s, origNd.res, origNd,'s');
	} // stringToBop

	function oStringToBop(s,origNd){
		return newBop('+', s, origNd.res, origNd,'b');
	} // oStringToBop

								
	/**
		Display the full tree from the current node.
		Remark : all appering numbers are original numbers.
	*/
	function treeString(nd){
		if(!treeKeepGoing){
			return '';
		}
		
		// Short hands
		var nLn= nd.leftNode;
		var nRn= nd.rightNode;
		
		
		if (nLn!==null){
			treeString(nLn);	// recursive call
		}

		if (nRn!==null){
			treeString(nRn);	// recursive call
		}
		
		if (nd.op!==''){
			var leftB= '';		// left Buffer
			var rghtB= '';		// right Buffer
							
			if (nLn.orig==='o'){
				leftB= oStringToBop(nLn.res, nLn);
			}else{
				if (needBrackets(nd.op, nLn.op, nLn.bOp)){
					leftB= stringToBop( '('+ bOpVectToStr(nLn.bOp) +')', nLn );
				}else if (invisblBrackets(nd.op, nLn.op)){
					leftB= stringToBop( bOpVectToStr(nLn.bOp), nLn );
				}else{
					leftB= nLn.bOp;
				}				
			}
				
			if (nRn.orig==='o'){
				rghtB= oStringToBop(nRn.res, nRn);
			}else{
				if (needBrackets(nd.op, nRn.op, nRn.bOp)){
					rghtB= stringToBop( '('+ bOpVectToStr(nRn.bOp) +')', nRn);
				}else if (invisblBrackets(nd.op, nRn.op)){
					rghtB= stringToBop( bOpVectToStr(nRn.bOp), nRn );
				}else{
					rghtB= nRn.bOp;
				}
			}
					
			// Rem : Calling combineBufOp() only once per config : Can't do it directly, because nodes are shared and Bops too
			var curBop= combineBufOp(leftB, nLn,  nd.op,  rghtB, nRn);
			if (curBop!==null){
				switch (nd.pos){
					case 'L':
					case 'R':
						nd.bOp= curBop;
					break;
					
					case 't':	
						nd.bOp= curBop;	
						// got to add Bop directly then transform in string at the right end
						globTreeBop= concatJustBop(globTreeBop,curBop)
					break;
					
					default:
						writeLn('Error in calcuLCEB::treeString');
				} // switch
			}else{
				treeKeepGoing= false;
			}
		} // if (nd.op!=='')		
	} // treeString
	
		
	/**
		Input :
			nd : the node to analyse from.
			kind : kind of call.
				'prn' : pruning
				'fd' : final display
	*/
	function callTreeStr(nd,kind){
		treeCallKind= kind;	// global : kind of scan.
		
		globTreeBop= new Array();		
		treeKeepGoing= true;
		
		curTreeCanoStr= '';
		treeString(nd);
		if (!treeKeepGoing){
			return '';	// had to abort, so returns nothing
		}
				
		sortBopsVect(globTreeBop);									
		if (!bopIsSorted(globTreeBop)){
			bubleSort(globTreeBop);
		}
		
		return bOpVectToStr(globTreeBop);
	} // callTreeStr


	/**
		The slow buble sort
	*/
	function bubleSort(bOp){
		var sz= bOp.length;		
		do{
			var xch= false;	// exchange witness
			for (var i=0; i<sz-1; i++){
				if (bOpSort(bOp[i],bOp[i+1])){
					exchgVect(bOp,i,i+1);
					xch= true;
				}
			}
		}while(xch);
		return bOp;
	}; // bubleSort


	/**
		Exchange 2 vector cells
	*/
	function exchgVect(v,i,j){
		var a= v[i];
		v[i]= v[j];
		v[j]= a;
	}; // exchgVect


	/**
	*/
	function bopIsSorted(bOp){
		var sz= bOp.length;
		for (var i=0; i<sz-1; i++){
			if (bOpSort(bOp[i],bOp[i+1])){
				return false
			}
		}
		return true;
	}; // bopIsSorted


	/**
		Adds the curBop to mainBop in actual order. (Direct modification on mainBop)
	*/
	function concatJustBop(mainBop,curBop){
		mSz= mainBop.length;
		cSz= curBop.length;
		
		var j=0;
		for (var i=mSz; i<mSz+cSz; i++){			
			mainBop[i]= curBop[j];
			j++;
		}
		
		return mainBop;
	} // concatJstBop

	
	/**
		Convert a bOp vector to a string of operands and operator fiting within brackets.
	*/
	function bOpVectToStr(bOp){
		var sz= bOp.length;
		var b= '';
		
		if (sz>0){
			b= bOp[0].d;	// Init the buffer and do not take the 1st operator (1st op as a head of string redundant++ )
		}
		
		for (var i=1; i<sz; i++){
			b+= bOp[i].t + bOp[i].d;
		}
		return b;
	} // bOpVectToStr
	

	/**
		Combine the buffers of operands and operators
		--> just add the vector element and sort them! Adjustement of signs already done
		at () dealing stage.
		rem : must take into account the leftB and rghtB () dropping case to
			- concatenate the vectors
			- sort
			- deal efficiently with unconventional writing (conventional + (p) sign meaning the number has a positive value
				are dropped, and only remain the associated operator)
					+100 + (+4)*(+3  *  +2  /+2) --->  +100	 +   *4 *3 *2 /2
			- need to obtain a normalised form! Larger elements first, so can use it to stop unnecessary calculations.
					--> each step cointaining more than 2 permutable elements is a candidate for comparison and storing
					normalised form!
				
		Always return bOp vector, so should force parameters into bOp type! Ok!
		General level : makes sure head operators are dealt with!
		
		Input :
			leftB	: bOp of the left Node.
				leftNd : parent node of leftB.
			op : operator.
			rghtB : bOp of the right Node.
				rghtNd : parent node of rghtB.
	*/
	function combineBufOp(leftB,leftNd, op, rghtB,rghtNd){
		switch (op){
			case '-':
				leftB[0].t= '+';
				rghtB[0].t= '+';
				rghtB= adaptToSub(rghtB); 
			break;			
			
			case '/':				
				leftB[0].t= '*';
				rghtB[0].t= '*';
				rghtB= adaptToDiv(rghtB);
			break;
			
			case '*':
				leftB[0].t= '*';
				rghtB[0].t= '*';
			break;
						
			case '+':
				leftB[0].t= '+';
				rghtB[0].t= '+';
			break;
			
			default:
				writeLn('Error 1 in combineBufOp');
		} // switch
		
		// Does simplifications only for final display, otherwise gets non direct combinatoric sequences eliminating too much 		
		remvOppositeBop(leftB,rghtB);
		
		lSz= leftB.length;
		rSz= rghtB.length;
		if (lSz===0 && rSz===0){
			return null;
		}
		
		if (lSz===0){
			sortBopsVect(rghtB);
			return rghtB;
		}
		
		if (rSz===0){
			sortBopsVect(leftB);
			return leftB;
		}
				
		var totVBop= concatBopV(op, leftB,leftNd, rghtB,rghtNd);	// concatenation of vector elements into a larger bOps
		sortBopsVect(totVBop);		// Sort the bOps elements
		return totVBop;
	} // combineBufOp
		

	/**
		Adds the array y to the end of the array x.
		
		Input :
			op : operator.
			x	: bOp of the left Node.
			xNd : parent node of x.
			y : bOp of the right Node.
			yNd : parent node of y.	
	*/
	function concatBopV(op, x,xNd, y,yNd){
		szV= x.length;
		szW= y.length;
		
		var tV= new Array();	// Total array
		for (var i=0; i<szV; i++){
			tV[i]= x[i];
			tV[i].oNd= xNd;		// Trace its origin
		}
		
		for (var j=0; j<szW; j++){
			tV[szV+j]= y[j];
			tV[szV+j].oNd= yNd;	// Trace its origin
		}
		
		return tV;
	} // concatBopV


	/**
		Remove Opposite : considering to bOp arrays having potential opposing values, scan them for detection
		and deletion of opposed mutually cancelling values (appearing because of the distance between them
		in a string of similar operands).
			Note : elements that have opposite effect can be removed :
				/a && *a
				+a && -a
	*/
	function remvOppositeBop(leftB,rghtB){
		var szV= leftB.length;
		var szW= rghtB.length;
		
		var remv= false;	// flag remover.
		var inMultiplCat= multiplCateg(leftB[0].t);
		
		var i=0;
		while(i<szV){
			var j=0;
			while(j<szW && i<szV){
				if (opposedBop(leftB[i],rghtB[j])){
					if ( !inMultiplCat || inMultiplCat && (szV+szW)>2){
						// direct removing
						remv= true;
						leftB.splice(i,1);
						rghtB.splice(j,1);
					}
					
					/* splice() changes the size and smooth the indexes at i and j, so : we need to 
					   keep i and j for the nexz round and progress at the size limits. */
					szV--;
					szW--;
					
				}else{
					j++;
				}
			} // while
			
			if (remv){
				remv=false;	// init again.
			}else{
				i++;
			}
		} // while
		
	} // remvOppositeBop
	
			
	/**
		Compress (removes the holes) a sequential array with holes.
		splice() does the removal automatically!!!
	*/
	function remvHoles(v,lastIdx){
		var nV= new Array();
		var j=0;
		for (var i=0; i<lastIdx; i++){
			if ( kk.isNotUndef(v[i]) ){
				nV[j]= v[i];
				j++;
			}
		}
		return nV;
	} // remvHoles
		
		
	/**
		Returns true if bOpA is the opposite of bOpB
	*/
	function opposedBop(bOpA,bOpB){	
		return bOpA.res===bOpB.res && opposedOper(bOpA.t,bOpB.t);
	} // opposedBop
	
	
	/**
		Returns true if the operator r is in the multiplication category.
	*/
	function multiplCateg(r){		
		return r==='*' || r==='/';		
	} // multiplCateg
	
	
	/**
		Returns true if the given operators are opposite.
	*/
	function opposedOper(r,s){		
		return r==='+' && s==='-' ||
			r==='-' && s==='+' ||
			r==='*' && s==='/' ||
			r==='/' && s==='*';		
	} // opposedOper
	
		
	/**
		Adapt to - operands when dropping the brackets. (only for the right member)
	*/
	function adaptToSub(bOp){
		var sz= bOp.length;
		for (var i=0;i<sz;i++){
			if (bOp[i].t==='+'){
				bOp[i].t= '-';
			}else{
				bOp[i].t= '+';
			}
		}
		return bOp;
	} // adaptToSub
	
	
	/**
		Adapt to / operands when dropping the brackets. (only for the right member)
	*/
	function adaptToDiv(bOp){
		var sz= bOp.length;
		for (var i=0;i<sz;i++){
			if (bOp[i].t==='*'){
				bOp[i].t= '/';
			}else{
				bOp[i].t= '*';
			}
		}
		return bOp;
	} // adaptToDiv
	
		
	/* ---------------------------------------------------
		Sorting
	*/	

	/**
		Sort the bOps elements of v
		Note : the sort()
	*/
	function sortBopsVect(v){
		return v.sort(bOpSort);
	} // sortBopsVect
	
			
	/**
		Input : e,f are vector elements of bOp chosen by the sorting algo.
		Bracketed element ...
	*/
	function bOpSort(e,f){		
		eVAl= e.res + strPond(e);
		if (e.t==='-'){
			eVAl= -eVAl;
		}else if (e.t==='/'){
			eVAl= 1/eVAl;
		}
			
		fVAl= f.res + strPond(f);
		if (f.t==='-'){
			fVAl= -fVAl;
		}else if (f.t==='/'){
			fVAl= 1/fVAl;
		}
		return eVAl < fVAl;	
	} // bOpSort


	/**
		Calculates the ponderation of the given string as to be added to a bOp
		value so similar result expression like 2+2  &  2*2  are discriminated between each other.
	*/
	function strPond(bOp){
		if (bOp.of==='s'){
			// Is a bOp holding a (real or virtualy) bracketed expression.		
			var s= bOp.d;
			var sz= s.length;
			var t= 0;
			for (var i=0;i<sz;i++){
				t= t + s.charCodeAt(i);
			}
			return t + 10000000;	// 10⁷ --> makes sure bracketed statt are in a distinct category.
		}else{
			return 0;
		}
	} // strPond
	
	
	/**
		Input :
			p operator suPerior.
			q operator inferior.
			bOp : current bOp
	*/
	function needBrackets(p,q, bOp){
		return  bOp.length>1 && (
			p==='*' && q==='+' ||
			p==='*' && q==='-' ||
			p==='/' && q==='+' ||
			p==='/' && q==='-');
	} // needBrackets
	
		
	/**
	*/
	function invisblBrackets(p,q){
		var iB= p==='+' && q==='*' ||
			p==='+' && q==='/' ||
			p==='-' && q==='*' ||
			p==='-' && q==='/';
		return iB;
	} // invisblBrackets
	

	/**
		Standard display. Takes lot of room.
	*/
	function treeStrOne(nd){
		if (nd.leftNode!==null){
			treeStrOne(nd.leftNode);
		}

		if (nd.rightNode!==null){
			treeStrOne(nd.rightNode);
		}
		
		if (nd.op!==''){
			globTreeStr+= nd.leftNode.res + nd.op + nd.rightNode.res +'= '+ nd.res + crLn;
		}
	} // treeStrOne


	/**
		Heuristic sup : 
			(1) current result always closer to the solution than previous result!
			(2) got one joker then apply (1)
			(3) got X joker then apply (1)
			Algo :
				- each serie got initialised with a joker of 0
				- the joker increases (+1) when the resulting operation is not better that the best operand.
				- the joker has a capacity of X, when X is reached, it's not possible anymore to diverge from the final goal
	*/	
	function callPureHzH(operands){
		var layersNb= operands.length-1;
		
		var pt= new Object();
		pt.operands= new Array();		// current level of set of numbers to combine
		pt.operands[0]= operands;		// loads the seed set
		
		pt.joker= new Array();
		pt.joker[0]= 0;
		
		pt.lastResult= new Array();	// best result obtained in the serie
		pt.lastResult[0]= 0;			
			
		pt.sz= 1;	// Number of stored active element. (hitoric reasons .sz and do not use lenght, 
					// because though of not deleting, but new Object() does the trick).
					// Question : is length imlemented as a count ?
			
		writeNl(globTreeStr+'= '+bestSolValue);	// Writes the 1st Approximations.
					
		var arr= new Array();
		arr[0]= pt;							
		var lyr= 0;	// the layers index
		while (lyr<layersNb && !gotGoalAndBrk){
		
			// ptBuff is going to bufferise the calculations done on pt.
			var ptBuff= new Object();
			ptBuff.operands= new Array();		// current level of set of numbers to combine			
			ptBuff.joker= new Array();
			ptBuff.lastResult= new Array();
			ptBuff.sz= 0;
		
			// Scan one layer, using all the element of pt
			var i=0;			
			while (i<pt.sz && !gotGoalAndBrk){
				pureHzLCEBH(ptBuff, pt, i, lyr);
				
				if (rarePatienceCnt>300000){
					writeNl('Sorry aborted because of an excessive waiting time!');
					return '';
				}
				
				i++;
			}
			
			lyr++;
			pt= ptBuff;
			pt.operands= ptBuff.operands;
			pt.joker= ptBuff.joker;
			pt.lastResult= ptBuff.lastResult;
			pt.sz= ptBuff.sz;
		}
		
		if (!gotAGoal && !gotTriSol){
			// got only the approximation, so add a title.
			if (globMaxJoker<10){
				writeNl('Only Approximations with the fast search, but you can try the exhaustive search button "1st Sol" (up to 30 seconds) :');
			}else{
				writeNl('No solutions, only Approximations :');
			}
		}		
	} // callPureHzH
	

	/**
		Purely horizontal with heuristic.
		Input :
			ptBuff : the next generation of pt.
			pt : the current horizontal generation of calculated operands arrays.
			iPt : the index of pt (horizontal index).
			lyr : current6 layer start at 0.
	*/
	function pureHzLCEBH(ptBuff, pt,iPt, lyr){	
		var operands= pt.operands[iPt];		
		var a=0;
		var b=0;
		var r= null;
		var oprndNb= operands.length;
		
		rarePatienceDspl();		
		operands.sort();
		
		// Scan the possible "1st" operands
		var i=0;
		while (i<oprndNb && !gotGoalAndBrk){		
			i= befLastEqual(i,operands,oprndNb);	// a smart jump
			a= operands[i];
			
			// Scan the possible associated operands
			var j=i+1;
			while(j<oprndNb && !gotGoalAndBrk){
				j= befLastEqual(j,operands,oprndNb);	// a smart jump
				b= operands[j];
								
				var okToMark= markBigRep(a,b, lyr);
				var repIndep= bigRepIndep(a,b, lyr);
				
								
				// Scans the possible operators				
				var n=0;
				while (n<operatorNumber && !gotGoalAndBrk){	
					r= applyOprtr( glOprtrV[n], a,b);
													
					if (r.ok){					
						var curJoker= pt.joker[iPt];
						var increasedJok= false;
						
						var heurist= false;	// curent heuristic
						if (globMaxJoker<500){
							if ( firstIsCloser(r.nd.res, parseInt(pt.lastResult[iPt]), finalGoal)){
								// got a better result
								heurist= true;
							}else{
								curJoker++;
								increasedJok= true;
								if (curJoker<=globMaxJoker){
									// ok, keep going
									heurist= true;
								}// else{// Stop, the heuristic indicates we are going astray of the final result.}
							}
						}else{
							heurist= true;
						}
																
						// Canonical pattern
						if (heurist && !repIndep){
							var canonicStr= callTreeStr(r.nd,'prn');	// The TREE ALGORITHM to extract the local canonical pattern
							if (okToMark && globCanonVect[canonicStr]!==true){
								globCanonVect[canonicStr]= true;	// define it
							}else{
								heurist= false;	// already defined
							}
						}
						
						if (heurist){
							totOperation++;
							
							// Monitoring the best results
							var newSIB= newSolIsBest(r.nd.res, bestSolValue, finalGoal);
							if (newSIB){
								bestSolValue= r.nd.res;	// Best result obtained up to now.
							}
																		
							if (prgmtcEqual(bestSolValue,finalGoal,6)){
								gotAGoal= true;
								bestSolValue= bestSolValue-0.0001;	// so can find all the other best solutions,
							}
								
							if (newSIB){
								globTreeStr= callTreeStr(r.nd,'fd');	// The TREE ALGORITHM to extract a solution								
								if (gotAGoal){
									if (globCanonSolV[globTreeStr]!==true){
										manySlStr+= crLn + globTreeStr;
										globCanonSolV[globTreeStr]= true;									
										
										if (approxAreErased){
											clearWrite('');
											approxAreErased= false;
										}
										
										if (finalGoal===eval(globTreeStr)){
											if (onlyBottomBoxSol){
												writeLnMessOnce('Got at least one SOLUTION'+crLn+
													'(see bottom box)','');
											}else{
												writeLnMessOnce('Calculated SOLUTION(S)'+crLn+
													'(for approximations see bottom box) :'+crLn+crLn, globTreeStr);
											}
										}else{
											writeLn('Error : ' + globTreeStr);
										}
										
										currentGoals++;
										if (currentGoals >= maxHzGoals){
											gotGoalAndBrk= true;
										}
									}
									
									globTreeStr= '';
								}else{
									manyApproxStr= crLn + globTreeStr + manyApproxStr;
									writeNl(globTreeStr+'= '+bestSolValue);	// Writes the Approximations.
								}
							}
							
							
							ptBuff.operands[ptBuff.sz]= giveNewOprnds(r.nd, i, j, operands); // new calc. oprnd always at index 0 							
							if (increasedJok){
								ptBuff.lastResult[ptBuff.sz]= pt.lastResult[iPt]; // keep previous best result
							}else{
								ptBuff.lastResult[ptBuff.sz]= r.nd.res;	// improvment
							}
							
							ptBuff.joker[ptBuff.sz]= curJoker;
							
							ptBuff.sz++;
						}
					}	// if (r.ok)
					
					n++;
				} // while
				
				j++;
			} // while	
				
			i++;
		} // while
	} // pureHzLCEBH

				
	/**
		True if the conditions are met to mark the big repertory globCanonVect[...]
		
		Input :
			lNd : left node.
			rNd : right node.
			lyr : horizontal operation countor (operation layers, but not real geometrical layers)
	*/
	function markBigRep(lNd,rNd, lyr){
		return lNd.lyr + rNd.lyr === lyr + 2;
	} // atLeastOneBaseNd
	
		
	/**
		Need to be independant of the big repertory if the lyr totalisation is smaller than the maximum expected,
		because in that case the algo is not on the main stream (the only one we can trace for already seen configuration
		without bothering about what's left out)
	*/
	function bigRepIndep(lNd,rNd, lyr){
		return lNd.lyr + rNd.lyr < lyr + 2;
	} // bigRepIndep
		

	/**
		................
		- got to pass the length of operands ?
		- may have to use only the numbers that haven't been touched!
		- could be the new Array() of callPureHzH that don't init completly the vect?
		
		nd.leftNode= null
	*/
	function oprndLeftOver(operands,aNd,bNd){
		var a= aNd.res;
		var b= bNd.res;
		
		var newV=new Array();
		var sz= operands.length;
				
		var i=0;
		var j=0;
		while(i<sz){
			var op= operands[i];
					
			// if (op.res!==a && op.res!==b && op.leftNode===null){	// !=a & !=b & a value not usd up to now 
			if (op.res!==a && op.res!==b){
				newV[j]= op.res;
				j++;
			}			
			i++;
		}
		
		newV.sort();
		return newV.toString();
	} // oprndLeftOver
							
		

	/**
		Calculates the new operand vector : add r.nd and removes
		position i,j of the previous operands vector.
	*/
	function giveNewOprnds(nd, i, j, operands){
		var v= new Array();
		v[0]= nd;
		
		var l=1;	// following index for v[]
		var sz= operands.length;
		for (k=0; k<sz; k++){
			if (k!==i && k!==j){
				v[l]= operands[k];
				l++;
			}
		}
		
		return v;		
	} // giveNewOprnds


	/**
		Smart incrementation of the given index, jumps all similar numbers and get positionned (i)
		just before the last equal number serie of the given array (v). of size sz
	*/
	function befLastEqual(i,v,sz){
		var k=i;		
		while(k<sz-2   &&   v[k].res===v[k+1].res   &&   v[k].res===v[k+2].res){
			k++;
		}
		return k;		
	} // befLastEqual
	
	
	/**
		Apply operator to the couple a,b and return the result.
	*/
	function applyOprtr(operator,aNd,bNd){
		var r= new Object();		
		var a= parseInt(aNd.res);
		var b= parseInt(bNd.res);
		
		if (a===0 || b===0){
			r.ok= false;
			writeLn('applyOprtr : 0!!!');
			return r;
		}

		switch (operator){
			case '*':
				var prod=  a*b;
				if ( firstIsDifferent(prod,a,b) && a!==1 && b!==1 ){
					var nd= newNodeLS(a,b, aNd,bNd,operator);					
					nd.res= prod;	// result
					r.ok= true;
				}else{
					r.ok= false;
				}
			break;
			
			case '+':
				var nd= newNodeLS(a,b, aNd,bNd,operator);
				nd.res= a + b;
				r.ok= true;
			break;
			
			case '-': 
				l= larger(a,b);
				s= smaller(a,b);				
				if (fitForSub(a,b)){
					r.ok= true;
					var nd= newNodeLS(a,b, aNd,bNd,operator);
					nd.res= l-s;
					r.ok= true;
				}else{
					r.ok= false;
				}
			break;
			
			case '/':
				l= larger(a,b);
				s= smaller(a,b);				
				quo= new Object();	// quotient to be returned : quo.val
				if (fitForDiv(quo,l,s)){
					var nd= newNodeLS(a,b, aNd,bNd,operator);
					nd.res= quo.val;	// nd.res>=1   ... always
					r.ok= true;
				}else{
					r.ok= false;
				}	
			break;
			
			default:
				alert('Error in operator');
		} // switch
	
		r.nd = nd;
		return r;
	} // applyOprtr


	/**
		Returns a new node, the Larger 1st and the Smaller next.
	*/
	function newNodeLS (a,b, aNd,bNd,operator){
		if (isLarger(a,b)){
			return newNode(aNd,operator,bNd);
		}else{
			return newNode(bNd,operator,aNd);
		}
	} // newNodeLS

				
	/**
		Return true if the 2 parameters are fit for division.
		fitForDiv(nd.res,l,s)
		Input :
			q : result of the division (quotien)
			l : numerator (largest number)
			s : denominator (smallest number)
	*/
	function fitForDiv(q,l,s){
		// if (s!==0 && l!==s && l%s===0){
		if (s!==0 && l%s===0){
			q.val= parseInt(l/s);	// quotient
		}else{
			return false;
		}
		
		return firstIsDifferent(q.val,l,s);	
	} // fitForDiv
	

	/**
		Used for division test, so don't have a result that is equal to the operands and therefore
		leading to a dummy operation.
	*/
	function firstIsDifferent(x,a,b){
		return x!==a && x!==b;
	} // firstIsDifferent

		
	/**
		Return true if the 2 parameters are fit for substraction :
			Forbid : equality && result === one of the operand
	*/
	function fitForSub(a,b){
		return a!==b && heteroAbsDiff(a,b);
	} // fitForSub
	

	/**
		Absolute difference different from any of the parameters.
		--> Don't want a result equal to one of the 2 operands.
	*/
	function heteroAbsDiff(a,b){
		d= Math.abs(a-b);
		return a!==d && b!==d;
	} // heteroAbsDiff
					

	/**
		Write and writeln, but at the front. Important note : only the text timer is regular even with
		many calls! In comparaison the html timer just freezes, and it's 
		like we don't have a timer anymore. Probably because it could
		impact on the whole html structure of the page, which is never the
		case for a text box, so display routines of tb are faster.
	*/
	function toggleTxtTimer(s){
		p= document.getElementById('timerTxtNm');
		var str = new String(p.value);
		var sz= str.length;
				
		if (sz===0){
			toggleIncrease= true;
		}else if (sz >20) {
			toggleIncrease= false;
		}		
		
		if (toggleIncrease){
			p.value += s;
		}else{
			p.value= str.substr(0,sz-1) 
		}
	} // toggleTxtTimer
	
	
	/**
	*/
	function rarePatienceDspl(){
		if (rarePatienceCnt>100){
			toggleTxtTimer('*');
			rarePatienceCnt= 0;
		}else{
			rarePatienceCnt++;
		}
	} // rarePatienceDspl

	
	/**
		Smart incrementation of the given index, jumps all similar numbers and get positionned (i)
		just before the last equal number serie of the given array (v). of size sz
	*/
	function beforeLastEqual(i,v,sz){
		var k=i;		
		while(k<sz-2 && v[k]===v[k+1] && v[k]===v[k+2]){
			k++;
		}
		return k;		
	} // nextDifferent
			

	/**
		Return true if we got a pragmatic equality
		Input :
			n : number 1
			m : number 2
			p : precision after the comma ... best >= 4
	*/
	function prgmtcEqual(n,m,p){
		var f= Math.pow(10,p);
		return Math.abs(f*(n-m)) < 1;
	} // prgmtcEqual


	/**
		Return true if the number n is an integer
	*/
	function isOkInteger(n){
		var diff= Math.ceil(n)-Math.floor(n)
		return diff===0;
	} // isOkInteger


	/**
		Return true if the new solution is the best.
		Input :
			n : new proposed solution to compare
			o : old solution, best up to ...
			goal : ... to reach
	*/
	function newSolIsBest(n,o,goal){
		var d1= Math.abs(goal-n);
		var d2= Math.abs(goal-o);
		if (d1<d2){
			return true;
		}else{
			return false;
		}
	} // newSolIsBest


	/**
		Calculates the new operand vector : add r.nb and removes
		position i,j of the previous operands vector.
	*/
	function giveNewOperands(nb, i, j, operands){
		var v= new Array();
		v[0]= nb;
		
		var l=1;	// following index for v[]
		var sz= operands.length;
		for (k=0; k<sz; k++){
			if (k!==i && k!==j){
				v[l]= operands[k];
				l++;
			}
		}
		
		return v;		
	} // giveNewOperands


	/**
		Maximum value using * and +.
		
		Algo : folding progressibely a sorted vector on itself --->
			the last one travels left and is added on the 1st number N that maches the following conditions :
				N<3 && N is not a 1 except if no other choice.
	*/
	function maxProdVal(objOprndD){
		var v= copyVect(objOprndD);
		var result= new Object();
				
		var lim=0;
		while (!foldVect(v) &&  lim<100){
			lim++;
		}
		
		writeLn('lim='+lim);
		if (lim<100){
			// v was folded with success, so just need to multiply all factors.
			var str= '';
			var prod= 1;
			
			var sz = v.length;
			var i= 0;
			while(i<sz){
				prod= prod * v[i];				
				if (i<sz-1){
					str+= v[i] + '*';
				}else{
					str+= v[i];
				}																
				i++;
			}
		
			result.prod= prod;	// writeLn(prod);
			result.str= str;	// writeLn(str);			
			return result;
		}
	} // maxProdVal
		
	
	/**
	*/
	function foldVect(v){
		v.sort();
		v.reverse();
	
		var sz= v.length;
		if (sz===1){
			return true;
		}
		
		var i=sz-1;
		while(i>0){
			var N= v[i];
			var M= v[i-1];
		
			if (M>1 || i===1){
				// Is at the left one limit
				if (N===1){
					// Got at least one 1 to use
					if (M<3){
						// M is a compulsory candidate for addition.
						v[i-1]++;
					}else{
						// M is a last additive choice (LAC), so got to check if there is another 1 to add to N.
						if (i<sz-1){
							// already moved, so there is at least on other one!
							v[i]++;
						}else{
							// no other ones, so need to use the LAC
							v[i-1]++;
						}
					}
									
					v.splice(sz-1,1);		// remove the last one
					return false;
				}else{
					// no more ones, so the vector is folded
					return true;
				}
			}
			i--;
		} // while
	} // foldVect



	/**
	*/
	function intTheVector(v){
		var w= new Array();
		var sz= v.length;
		for (i=0;i<sz;i++){
			w[i]= parseInt(kk.trim(v[i]));
		}
		
		return w;
	} // intTheVector


	/**
	*/
	function copyVect(v){
		var w= new Array();
		var sz= v.length;
		for (i=0;i<sz;i++){
			w[i]= v[i];
		}
		
		return w;
	} // copyVect


	/**
		Returns the left over of x / a
	*/
	function leftOver(x,a){
		return parseInt((x/a - Math.floor(x/a)) * a);
	} // leftOver

	/**
		Integer division floor based.
	*/
	function inDiv(x,a){
		return parseInt(Math.floor(x/a));
	} // leftOver

	
	/**
	*/
	function isLarger(a,b){
		return a>b;
	} // isLarger
	
	/**
	*/
	function isSmaller(a,b){
		return a<b;
	} // isSmaller
	

	/**
	*/
	function larger(a,b){
		if (a>b){
			return a;
		}else{
			return b;
		}
	} // larger

	/**
	*/
	function smaller(a,b){
		if (a<b){
			return a;
		}else{
			return b;
		}
	} // smaller


	/**
		returns true if c is closer to x than b.
	*/
	function firstIsCloser(c,b,x){
		return Math.abs(x-c) < Math.abs(x-b);
	} // firstIsCloser

	/*
		Adds a message only once to writeLn(s).
	*/
	function writeLnMessOnce(m,s, rev){
		if (writeOnceMess[m]===true){
			if (rev===true){
				writeNl(s);
			}else{
				writeLn(s);
			}
		}else{
			if (rev===true){
				writeNl(m+s);
			}else{
				writeLn(m+s);
			}
		}
		writeOnceMess[m]= true;		
	} // writeLnMessOnce	
	

	function writeNl(s){
		sop.writeNl(s);
	}
	
	function clearWrite(s){
		sop.clearWrite(s);
	}
	
	function writeBefore(s){
		sop.writeBefore(s);
	}


	function sideExtScreenDsplPt(){
		return sop.sideExtScreenDsplPt();
	}
	
	function write(s){sop.write(s);}
	function writeLn(s){sop.writeLn(s);}
	
		
} // calcuLCEB
