/**
	File name : calculator.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**

Instanciation :

	var caltor= new calculator();
	
Remark : to round result is important for small calculation exercices	
	ariStack.roundXAfterComma
	... but may be it rounds too much for some precise calculations

*/
function calculator(){

	var crLn= "\r\n";
	
	// Private global "Instance" variable for the "class"
	var calcBuffNb= 0;
	var digitClearsScreen= 'ok';
	var calcBuffOp= '';
	var globalActionTime= 0; // global action time in mSec from 1970
	var globAskTimeDspl= false;
	
	
	/* ---
		Compulsory interface for all methods call from outside !!!!!!!!!!
	*/
	this.clearAll= clearAll;
	this.clearAllPlus= clearAllPlus;
	this.addDigit= addDigit;
	this.pushBinOperator= pushBinOperator;
	this.equalBut= equalBut;
	this.uniqueOper= uniqueOper;
	this.changeAngle= changeAngle;
	this.getSortOfAngle= getSortOfAngle;
	this.factToRadians= factToRadians;
	
	this.operatorFree= operatorFree;
	this.challengeLCEB= challengeLCEB;
	
	this.calcRootN= calcRootN;
	this.calcLogTen= calcLogTen;
	this.tenPowerN= tenPowerN;
	this.calcRandomN= calcRandomN;
	this.calcRndLimits= calcRndLimits;
	this.leCompteEstBon= leCompteEstBon;
	this.calcFact= calcFact;
	
	this.chgLnExtDispl= chgLnExtDispl;	
	this.chgTbCalcDispl= chgTbCalcDispl;
	this.larger= larger;
	this.smaller= smaller;
	this.firstIsCloser= firstIsCloser;
	this.firstIsDifferent= firstIsDifferent;
	
	this.closedBracket= closedBracket;	
	this.openBracket= openBracket;
	
	this.standardBills= standardBills;
	
	this.zush= zush;
	this.zop= zop;	
	

	/* ---
		Methods bodies :
	*/
	
	/**
		Sum the whole right panel
	*/
	function sigmaSum(str,o){
		str= kk.trim(str);
		o.vect= splitOnEndLn(str);	
		var sz= o.vect.length;
		
		var tStr= '';
		var sum= 0;
		for (i=0; i<sz; i++){
			tStr= kk.trim(o.vect[i]);
			if (tStr!==''){
				sum= sum + parseFloat(tStr);
			}
		}
		return ariStack.roundXAfterComma(sum);
	} // sigmaSum
	

	/**
	*/
	function equalBut(){
		digitClearsScreen= 'ok';
		var smVal= getSmallScreenVal()
		
		if ( ariStack.isAnExpression(smVal) ){
			solveExpression(smVal);
		}else{
			ariStack.pushD(smVal);	// pushes the operand
			setSmallScreenVal('');
			
			ariStack.pushT('='); // pushes the "operator"
					
			ariStack.callSolvStackTop();
		}
	} // equalBut
	
	
	/**
	*/
	function splitOnEndLn(str){
		return str.split("\n");
	} // splitOnEndLn
	
	
	/**
		Clear all		
	*/
	function clearAll(){
		setSmallScreenVal('');
		calcBuffNb= '';
		calcBuffOp= '';
		digitClearsScreen= 'ko';
		
		ariStack.setNewStack();
		sop.smllScreenBffOn= false;
		sop.smllScreenBuff= '';
		
		var pt= document.getElementById('chkBoxForAll');
		if (pt!==null){
			pt.checked= false;
		}
		
		var pu= document.getElementById('cbRealRandom');
		if (pu!==null){
			pu.checked= false;
		}
	} // clearAll

	
	function clearAllPlus(){
		clearAll();
		document.getElementById('calcLnExtDispl').value= '';
		
		var pt= document.getElementById('calcGenDispl');
		if (pt!==null){
			pt.value= '';
		}

		var pu= document.getElementById('timerTxtNm');
		if (pu!==null){
			pu.value= '';
		}
	} // clearAllPlus
	

	/**
		Return the "float" value of the screen input	
	*/
	function screenInput(){
		var val= getSmallScreenVal();
		if (val===''){
			return 0;
		}else{
			return parseFloat(val);
		}
	} // screenInput


	/**
		Unary Operators (got only one operand) : appl	
		Input :
			op : operator
	*/
	function uniqueOper(op){
		var a= screenInput();			// operand	
		var aS= getSortOfAngle();		// angle sort
		var f= factToRadians(aS);		// angle factor
		var r= 0;
		
		switch (op){
			case '-':
				r= -a;
			break;
			
			case 'invert':
				r= 1/a;
			break;
			
			case 'p2':
				r= Math.pow(a,2); ;
			break;
			
			case 'sqrt':
				r= Math.sqrt(a);
			break;
			
			case 'sin':
				r= Math.sin(a*f);
			break;
			
			case 'cos':
				r= Math.cos(a*f);
			break;
			
			case 'tan':
				r= Math.tan(a*f);
			break;
			
			case 'asin':
				r= Math.asin(a) / f;
			break;
			
			case 'acos':
				r= Math.acos(a) / f;
			break;
			
			case 'atan':
				r= Math.atan(a) / f;
			break;
			
			
			case 'ln':
				r= Math.log(a);
			break;
			
			case 'en':
				r= Math.exp(a);
			break;
			
			case 'l10':
				r= calcLogTen(a);
			break;
			
			case '10n':
				r= tenPowerN(a);
			break;
			
			case 'fact':
				r= calcFact(a);
			break;
			
			case 'sigma':
				var strNb= document.getElementById('calcLnExtDispl').value;
				var o=new Object();
				r= sigmaSum(strNb,o);
				
				// display time if asked for  (Timer : )
				if (globAskTimeDspl){
					var curDobj = new Date();
					curTime= curDobj.getTime();
				
					// display it
					document.getElementById('timerTxtNm').value= Math.round((curTime-globalActionTime)/1000);
				}
			break;
			
			case 'average':
				var strNbs= document.getElementById('calcLnExtDispl').value;
				r= average(strNbs);
			break;
			
			
			default: alert('Error uniqueOper() op='+op);
		} // switch
		
		setSmallScreenVal(r);
		calcBuffNb= r;
		digitClearsScreen= 'ok';
	} // uniqueOper
	
	
	/**
	*/
	function average(str){
		var o=new Object();
		var sum= sigmaSum(str, o);
		return sum / o.vect.length;
	} // average



	/**
		Change the angle sort we are working with (deg or radians), in fact impose the other!
	*/
	function changeAngle(){
		var elem= document.getElementById('calcAngleTyp');	// Element to display the angle type.
		var a= elem.innerHTML;	// angle type
		
		if (a==='rad'){
			var b='deg';
		}else{
			var b='rad';
		}
		
		elem.innerHTML= b;	// set/display the new value
	} // changeAngle


	/**
	*/
	function getSortOfAngle(){
		return document.getElementById('calcAngleTyp').innerHTML;
	} // getSortOfAngle

	/**
		Factor to radians : gt the factor to multiply the given angle to feed it to radian dealing functions	
	*/
	function factToRadians(sort){
		if (sort==='rad'){
			return 1;
		}else{
			return Math.PI / 180;
		}
	} // factToRadians


	/**
		No operators : so constants, random numbers etc.	
		Input :
			op : operator
	*/
	function operatorFree(k){
		switch (k){
			case 'pi':
				var r= Math.PI;
			break;
			
			case 'e':
				var r= Math.E;
			break;
			
			case 'avogadro':
				var r= '6.0221415e+23';	// http://www.americanscientist.org/issues/pub/an-exact-value-for-avogadros-number
			break;
			
			case 'G':
				var r= '6.67384e-11';	// http://physics.nist.gov/cgi-bin/cuu/Value?bg
			break;
			
			case 'g':
				var r= '9.81';			// http://en.wikipedia.org/wiki/Gravity_of_Earth
			break;
			
			case 'lspd':
				var r= '299792458';		// http://www.speed-light.info/measurement.htm
			break;
			
			
			case 'r2':
				var r= calcRandomN(2);
			break;
			
			case 'r3':
				var r= calcRandomN(3);
			break;
			
			case 'r4':
				var r= calcRandomN(4);
			break;
			
			case 'r5':
				var r= calcRandomN(5);
			break;
							
			default: alert('Error operatorFree() k='+op);
		} // switch
			
		setSmallScreenVal(r);
	} // operatorFree
	
	
	/**
		Creates a custom challenge for LCEB.
	*/
	function challengeLCEB(k){
		switch (k){
			case 'game23':
				var r= leCompteEstBon(2,3,'std');
			break;
				
			case 'game34':
				var r= leCompteEstBon(3,4,'std');
			break;

			case 'game35':
				var r= leCompteEstBon(3,5,'std');
			break;
			
			case 'game36':
				var r= leCompteEstBon(3,6,'std');
			break;
			
			case 'game36u':
				var r= leCompteEstBon(3,6,'un');	// unusual set
			break;
			
			case 'game36b':
				var r= leCompteEstBon(4,6,'std4');
			break;
			
			case 'game36i':
				var r= leCompteEstBon(4,6,'inv');	// inversed set
			break;
			
			case 'game36j':
				var r= leCompteEstBon(5,6,'inv');	// inversed set
			break;
			
			default: alert('Error operatorFree() k='+op);
		} // switch
			
		setSmallScreenVal(r);
	} // challengeLCEB


	/**
		Changes the line extension display.
		Input :
			op : operation !
	*/
	function chgLnExtDispl(op){
		var lrgScreenPt= document.getElementById('calcLnExtDispl');
	
	
		var bOp= calcBuffOp;	// eventually stored binary operator
		if (bOp===''){
			bOp= 'nop';
		}
		
		var valSmallScreen= getSmallScreenVal();	
	
		switch (op){
			case 'toTopRight':
				lrgScreenPt.value= valSmallScreen+ crLn + lrgScreenPt.value;
			break;
				
			case 'toBotRight':
				lrgScreenStr= lrgScreenPt.value;
				if (lrgScreenStr===''){
					lrgScreenPt.value= valSmallScreen;
				}else{
					lrgScreenPt.value= lrgScreenStr + crLn + valSmallScreen;
				}
			break;
				
			default: alert('Error chgLnExtDispl() k='+op);
		} // switch
		
		// setSmallScreenVal('');
	} // chgLnExtDispl


	/**
		Input :
			op : operation !
			a : whatever suppleme. param.
	*/
	function chgTbCalcDispl(op,a){
		switch (op){
			case 'toLeft':
				// a : the index of the line we got to transfer [0 ... N-1]
				var line= parseInt(a);
				var fullTxt= document.getElementById('calcLnExtDispl').value;
				var vect= splitOnEndLn(fullTxt);
				var sz= vect.length;
				
				if (line < sz){
					r= vect[line];
				}else{
					r= vect[sz-1];
				}
			break;
				
			default: alert('Error chgTbCalcDispl() k='+op);
		} // switch
			
		setSmallScreenVal(r);
	} // chgTbCalcDispl


	/**
		Calculates the nth root of x,
	*/
	function calcRootN(x,n){
		var lgx= Math.log(x);
		return Math.exp(lgx/n); 
	} // calcRootN


	/**
		log10		
	*/
	function calcLogTen(a){
		return Math.log(a) / Math.LN10;
	} // calcLogTen


	/**
		10^N		
	*/
	function tenPowerN(n){
		return Math.pow(10,n); 
	} // tenPowerN


	/**
		Random number of size n		
	*/
	function calcRandomN(n){
		var a= tenPowerN(n-1)+1;
		var b= tenPowerN(n)-1;
		return calcRndLimits(a,b);
	} // calcRandomN


	/**
		return a random number between a and b
		Input :
			a : smaller limit included.
			b : larger limit included.
	*/
	function calcRndLimits(a,b){
		var f= b+1;	// +1 because of the floor
		var delta= f-a;
		return  a + Math.floor(delta*Math.random());
	} // calcRndLimits
	

	/**
		Build the set of numbers to work with.
		Input:
			n : size of the number to guess, normally 3
			setSz : size of the set.
			kindS : kind of set.
	*/
	function leCompteEstBon(n,setSz,kindS){
		var buffGoal= calcRandomN(n);		
		switch (kindS){
			case 'std':
			case 'std4':
				var buff= stdNbSet(setSz);
			break;			
			
			case 'un':
				var buff= unusualNbSet(setSz);
			break;
			
			case 'big':
				var buff= bigNbSet(setSz);
			break;			
			
			case 'inv':
				var buff= inversedNbSet(setSz);
			break;			
			
			default:
				alert('Error in leCompteEstBon');
		} // switch
		

		var cbRealRandom= document.getElementById('cbRealRandom').checked;
		if ( cbRealRandom===true && setSz>=6 && kindS!=='big' && kindS!=='inv' && kindS!=='std4' ){
			return buffGoal+buff;
		}else{
			// pre-calculation! ---> should make sure we don't display the solution!
			sop.writeOff();
			calcLceb.displayResult('hzFastLuckySol', buffGoal+buff);
			sop.writeOn();
			var bsVal= calcLceb.getBestSolValue();
			clearAllPlus();
			if (calcLceb.getMaxProductCase()){
				return  calcLceb.getMaxProduct() + buff;
			}else{
				return Math.round(bsVal) + buff;
			}
		}
		clearAllPlus();
	} // leCompteEstBon


	/**
		Build up the inversed set of numbers
	*/
	function inversedNbSet(setSz){
		var sep= kc.sepOne;
		var buff= '';
		for (var i=0; i<setSz; i++){
			if (i===1){
				sep= ' # ';
			}
			buff+= sep + calcRndLimits(100,999);
		} // for	
		return buff;
	} // inversedNbSet
	

	/**
		Build up the unusual set of numbers
	*/
	function bigNbSet(setSz){
		var sep= kc.sepOne;
		var buff= '';
		
		for (var i=0; i<setSz; i++){
			if (i===1){
				sep= ' # ';
			}
			
			var ordRnd= calcRndLimits(1,2);
			switch (ordRnd){
				case 1:
					buff+= sep + calcRndLimits(11,99);
				break;
				
				case 2:
					buff+= sep + calcRndLimits(101,333);
				break;
			} // switch
		} // for	
		return buff;
	} // bigNbSet


	/**
		Build up the standard set of numbers
	*/
	function stdNbSet(setSz){
		var sep= kc.sepOne;
		var buff= '';
		
		for (var i=0; i<setSz; i++){
			if (i===1){
				sep= kc.sepTwo;
			}
		
			var ordRnd= calcRndLimits(1,14);
			
			if (ordRnd<11){
				 buff+= sep + ordRnd;
			}else{
				switch (ordRnd){
					case 11:
						buff+= sep + '25';
					break;
					
					case 12:
						buff+= sep + '50';
					break;
					
					case 13:
						buff+= sep + '75';
					break;
					
					case 14:
						buff+= sep + '100';
					break;
				} // switch
			} // if
		} // for	
		
		return buff;
	} // stdNbSet
	
	
	/**
		Build up the unusual set of numbers
	*/
	function unusualNbSet(setSz){
		var sep= kc.sepOne;
		var buff= '';
		
		for (var i=0; i<setSz; i++){
			if (i===1){
				sep= kc.sepTwo;
			}
		
			var ordRnd= calcRndLimits(1,14);
			
			if (ordRnd<10){
				 buff+= sep + ordRnd;
			}else{
				switch (ordRnd){
					case 10:
						buff+= sep + calcRndLimits(11,13);
					break;
					
					case 11:
						buff+= sep + calcRndLimits(27,31);
					break;
					
					case 12:
						buff+= sep + calcRndLimits(51,57);
					break;
					
					case 13:
						buff+= sep + calcRndLimits(77,91);
					break;
					
					case 14:
						buff+= sep + calcRndLimits(101,107);
					break;
				} // switch
			} // if
		} // for	
		
		return buff;
	} // stdNbSet


	/**
	*/
	function calcFact(n){
		if (n<0){
			return Number.NaN;
		}

		tot=1;
		for(i=1; i<=n && tot!==Number.POSITIVE_INFINITY; i++){
			tot= tot * i;
		}
		return tot;
	} // calcFact



	/**
	*/
	function larger(a,b){
		if (a>b){
			return a;
		}else{
			return b;
		}
	} // larger


	/**
	*/
	function smaller(a,b){
		if (a<b){
			return a;
		}else{
			return b;
		}
	} // smaller


	/**
		returns true if c is closer to x than b.
	*/
	function firstIsCloser(c,b,x){
		return Math.abs(x-c) < Math.abs(x-b);
	} // firstIsCloser


	/**
	*/
	function firstIsDifferent(x,a,b){
		return x!==a && x!==b;
	} // firstIsDifferent


	/* ------------------------------------------------------------------------------
		Dealing especially with locally stored variables, groupped to migrate to
		a stack algorithm.
	-------------------------------------------------------------------------------- */

	/**
		Adds the specified digit d	on the small screen.	
	*/
	function addDigit(d){
		if (digitClearsScreen==='ok'){
			// clears the small screen once when the operator buff is active
			setSmallScreenVal('');
		}

		setSmallScreenVal( getSmallScreenVal() + d );
		digitClearsScreen= 'ko';
	} // addDigit
		
	
	/**
		Pushes the given binary operator on the operator stack 
		and deal with the operand stack with partial resolution and display
			
		Called when pushing an operator button and :
			1) Stacks the given operator on the operator stack
			2) Stacks the number that should be define in the small screeen on the operator number.
			3) If it's possible to partially solve the stack, do it and display the top number in the small screen
	*/
	function pushBinOperator(opt){
		digitClearsScreen= 'ok';
		ariStack.pushD( getSmallScreenVal() );	// pushes the operand
		ariStack.pushT(opt);	// pushes the operator
		
		ariStack.callSolvStackTop();
	} // pushBinOperator(


	/**
	*/
	function closedBracket(){
		digitClearsScreen= 'ok';
		
		ariStack.pushD( getSmallScreenVal() );	// pushes the operand
		setSmallScreenVal('');
		
		ariStack.pushT(')'); // pushes the "operator"
				
		ariStack.callSolvStackTop();
	} // closedBracket


	/**
	*/
	function openBracket(){
		ariStack.pushT('(');
	} // openBracket
	

	/** ---------------------------------------------------------------
		Note : could use eval(), but this allow to verify the whole code!
		// Wrote a keybord entries simulator!
		// Each char --> a key stroke
	*/
	
	
	/**
		Works fine except for e+ expression + sin(x) etc ... good test for the base algo,
		just rename it solveExpression()
	*/
	function solveExpression(s){
		sop.smllScrnBffOn();
		s= s+'=';
		var sz= s.length;
		for (var i=0;i<sz;i++){
			var c= s.charAt(i);
			switch (c){
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
				case '.':
					addDigit(c);
				break;
				
				
				case '+':
				case '-':
				case '*':
				case '/':
				case '^':
				case 'r':
					pushBinOperator(c);
				break;
				
				
				case '(':
					openBracket();
				break;
				
				
				case ')':
					closedBracket();
				break;
				
				
				case '=':
					equalBut();
				break;
				
				case ' ':
				case "\t":
					// just jump
				break;
				
				default:
					alert('Forbidden char '+c+' in solveExpression');
			} // switch
		} // for
		
		var scb= sop.getSmallScreenBuff();		
		sop.smllScrnBffOff();
		setSmallScreenVal(scb);
	} // solveExpression

	
	/**
		Eval case, not Used with user input, because :
			1) if added on a complex multi-user site, a user could suggest some bad code to another that could
			block or divulgate some personal information (from screenprint to some other interferences). A single user
			acting for itself would be fine (can't steal its own informations, but could eventually interfer with
			some advertisment JS or other external JS.)
	*/
	function solveExpressionX(s){
		// Using eval
		// ok but !!! Won't solve sin(x) but Math.sin(x), so not very user friendly,
		// even so, could add a sin to Math.sin string transform etc. some days ............
		setSmallScreenVal(eval(s));
	}


	/* ------------------------------------------------------------------------------
		Test and WriteLn methods
	-------------------------------------------------------------------------------- */

	
	/**
	*/
	function zush(){
		writeLn('small screen val= '+getSmallScreenVal());
		ariStack.pushD( getSmallScreenVal() );
	} // zush
	
	/**
	*/
	function zop(){
		writeLn( ariStack.popD() );
	} // zop
	
	
	/**
		Standard bills additions. Just random 2 and 3 digits with a 2 digits cents rounded to 5
	*/
	function standardBills(nbLn){
		if (nbLn==='rnd'){
			var nbLines= calcRndLimits(5,10);
		}else{
			if (nbLn==='sixDg'){
				var nbLines= 8;
			}else{
				var nbLines= nbLn;
			}
		}
		
		var buffStr= '';
		for (var i=0; i<nbLines; i++){
		
			var bin= calcRndLimits(1,2);
		
			if (nbLn==='sixDg'){
				var curNb= calcRndLimits(100000,999999);
			}else{	
				if (nbLn==='rnd'){
					if (bin===1){
						var curNb= calcRndLimits(10,99);
					}else{
						var curNb= calcRndLimits(100,999);
					}
				}else{
					var curNb= calcRndLimits(100,999);
				}
			}
			
			if (nbLn==='sixDg'){
				buffStr+= curNb + crLn;
			}else{
				var curCents= centsFromCentsPos( calcRndLimits(0,19) );
				buffStr+= curNb +'.'+ curCents + crLn;
			}
			
		}
		
		document.getElementById('calcLnExtDispl').value= buffStr;
		
		var curDobj = new Date();
		globalActionTime= curDobj.getTime();
		globAskTimeDspl= true;
	} // standardBills


	/**
	*/
	function centsFromCentsPos(pos){
		if (pos===0){
			return '00';
		}else if (pos===1){
			return '05';
		}else{
			return 5*pos;
		}
	} // centsFromCentsPos

		
	/* --------------------------------------------
		Cloned methods for usage easiness 
	*/
	function getSmallScreenVal(){return sop.getSmallScreenVal();}	
	function setSmallScreenVal(s){sop.setSmallScreenVal(s);}	
	function write(s){sop.write(s);}
	function writeLn(s){sop.writeLn(s);}

} // calculator
