<?php
/**
	File name : calculator.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	calculator.php : this file is a FULLY FUNCTIONNING STARTING POINT TO BUILD A MORE COMPLEX PLUGIN.
		
		[setExplJs path="external/calculator/" js="calculator"/]
		[setExplCss path="external/calculator/" css="calculator" /]
		[setExplPlugin path="external/calculator/" name="calculator" /]
		[calculator mode="game" /]	... + games and training !!!
*/
class calculator extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
					
					
		/* -----------------------------------------------------------------
			Specification of the tag name and parameters.
		*/
		$tagsFu->attribVect['calculator']= array('mode');
	} // construct

	/**
		This associative array must hold all the tags used in this class, it is used externally to 
		declare these tags..
	*/
	function tags(){
		return array('calculator');
	} // tags
	
	/**
		The method used for the same name tag : [bCalculator /]
		Note the "b" prefix stands for one operation Button.
	*/
	function tg_calculator(&$v,&$bd){
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$gotGames= $v['mode']==='game';
		
		$calcPath= _c_toDeclPlugins.'external/calculator/';
		$glob->coreInclStanceJs($calcPath,'stackedOperM', 'sop','stackedOperM');
		$glob->coreInclStanceJs($calcPath,'ariStack');
		
		if ($gotGames){
			$glob->coreInclStanceJs($calcPath,'calcuLCEB', 'calcLceb','calcuLCEB');
		}
		
		$glob->coreInclStanceJs($calcPath,'kc');
		$glob->coreInclStanceJs($calcPath,'calculator', 'caltor','calculator');
		$glob->setGlbEndJsCode('caltor.clearAllPlus();'._c_R);
		$glob->setGlbEndJsCode('ariStack.newStack();'._c_R._c_R);
		
		$head= '';	
		
		$url= _c_cmSlashHttp._c_generatorDomNm;
		$head.= $caps->linkC($url,_c_generatDsplDomNm,'calcTradeMark','_blank');
			
		$head.= $caps->span('Scientific Calculator','calcTtl');
		$head.= $caps->onClickInput('nmToR','caltor.chgLnExtDispl(\'toTopRight\');',' > ', $caps->matCss('calcArrowBig'));
		$head.= $caps->onClickInput('nmToR','caltor.chgLnExtDispl(\'toBotRight\');',' > ', $caps->matCss('calcArrowBig'));
		$head.= $caps->span('deg','calcSmallChar','','calcAngleTyp');
		$head.= _c_;
		$head.= $caps->textBox('tbCalcNumber','',34,$caps->matCss('calcBigChar'));
		$head.= _c_;
		

		
		// BUTTONS BLOCK
		$dspl= '';		
		$dspl.= $caps->onClickInput('nmPlus','caltor.openBracket();',' ( ', $caps->matCss('calcBasicRator'));
		$dspl.= $caps->onClickInput('nmPlus','caltor.closedBracket();',' ) ', $caps->matCss('calcBasicRator'));
		
		$dspl.= $caps->onClickInput('nmInvert','caltor.uniqueOper(\'invert\');',' 1/x ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmfact','caltor.uniqueOper(\'fact\');',' x! ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmangle','caltor.changeAngle();',' > ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmGs','caltor.operatorFree(\'g\');',' g ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmRn2','caltor.operatorFree(\'r2\');',' rnd2 ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmRn3','caltor.operatorFree(\'r3\');',' r3 ', $caps->matCss('calcArithmBut'));
		
		
		$dspl.= _c_;						
		$dspl.= $caps->onClickInput('nm7','caltor.addDigit(\'1\');','1', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nm8','caltor.addDigit(\'2\');','2', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nm9','caltor.addDigit(\'3\');','3', $caps->matCss('calcBasicBut'));		
		$dspl.= $caps->onClickInput('nmClear','caltor.clearAll();',' C ', $caps->matCss('calcCancel'));
		$dspl.= $caps->onClickInput('nmClear','caltor.clearAllPlus();',' AC ', $caps->matCss('calcCancel'));
		$dspl.= $caps->onClickInput('nmPowN','caltor.uniqueOper(\'p2\');',' x² ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmsin','caltor.uniqueOper(\'sin\');',' sin ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmasin','caltor.uniqueOper(\'asin\');',' asin ', $caps->matCss('calcArithmBut'));
		$dspl.= _c_;								
		
		$dspl.= $caps->onClickInput('nm4','caltor.addDigit(\'4\');','4', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nm5','caltor.addDigit(\'5\');','5', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nm6','caltor.addDigit(\'6\');','6', $caps->matCss('calcBasicBut'));		
		$dspl.= $caps->onClickInput('nmMult','caltor.pushBinOperator(\'*\');',' * ', $caps->matCss('calcBasicRatC'));
		$dspl.= $caps->onClickInput('nmDiv','caltor.pushBinOperator(\'/\');',' / ', $caps->matCss('calcBasicRator'));		
		$dspl.= $caps->onClickInput('nmRootN','caltor.uniqueOper(\'sqrt\');',' √x ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmcos','caltor.uniqueOper(\'cos\');',' cos ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmacos','caltor.uniqueOper(\'acos\');',' acos ', $caps->matCss('calcArithmBut'));
		$dspl.= _c_;						
		
		$dspl.= $caps->onClickInput('nm1','caltor.addDigit(\'7\');','7', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nm2','caltor.addDigit(\'8\');','8', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nm3','caltor.addDigit(\'9\');','9', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nmPlus','caltor.pushBinOperator(\'+\');',' + ', $caps->matCss('calcBasicRator'));
		$dspl.= $caps->onClickInput('nmMin','caltor.pushBinOperator(\'-\');',' - ', $caps->matCss('calcBasicRator'));
		$dspl.= $caps->onClickInput('nmPowN','caltor.pushBinOperator(\'powN\');','x^n', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmtan','caltor.uniqueOper(\'tan\');',' tan ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmatan','caltor.uniqueOper(\'atan\');',' atan ', $caps->matCss('calcArithmBut'));	
		$dspl.= _c_;		
		
		$dspl.= $caps->onClickInput('nm0','caltor.addDigit(\'0\');','0', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nmComma','caltor.addDigit(\'.\');',' . ', $caps->matCss('calcBasicBut'));	
		$dspl.= $caps->onClickInput('nmEqual','caltor.equalBut();',' = ', $caps->matCss('calcBasicRator'));
		$dspl.= $caps->onClickInput('nmExplus','caltor.addDigit(\'e+\');','e+', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nmExmin','caltor.addDigit(\'e-\');','e-', $caps->matCss('calcBasicBut'));
		$dspl.= $caps->onClickInput('nmRootN','caltor.pushBinOperator(\'rootN\');','n√x', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmln','caltor.uniqueOper(\'ln\');',' ln ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmen','caltor.uniqueOper(\'en\');',' e^n ', $caps->matCss('calcArithmBut'));
		$dspl.= _c_;
		
		$dspl.= $caps->onClickInput('nmExplus','caltor.uniqueOper(\'-\');',' ± ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmPi','caltor.operatorFree(\'pi\');',' pi ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nme','caltor.operatorFree(\'e\');',' e ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmAv','caltor.operatorFree(\'avogadro\');',' Av ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmG','caltor.operatorFree(\'G\');',' G ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nmLsp','caltor.operatorFree(\'lspd\');',' Ls ', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nml10','caltor.uniqueOper(\'l10\');','log', $caps->matCss('calcArithmBut'));
		$dspl.= $caps->onClickInput('nm10n','caltor.uniqueOper(\'10n\');',' 10^n ', $caps->matCss('calcArithmBut'));
		$dspl.= _c_;
		
		

		$pat= '';		
		if ($gotGames){
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36\');','3#6', $caps->matCss('calcLCEBTrend'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game23\');','2#3', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game34\');','3#4', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game35\');','3#5', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36u\');','3#6b', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36b\');','4#6', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36i\');','4#6x', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36j\');','5#6x', $caps->matCss('calcLCEB'));
			$dspl.= _c_;

			$dspl.= $caps->onClickInput('nmLcebHS','calcLceb.displayResult(\'hzHideStrongSol\',\'\');','Hidden', $caps->matCss('calcLCEB2'));
			$dspl.= $caps->onClickInput('nmLcebS1','calcLceb.displayResult(\'hzOneStrongSol\',\'\');','1st Sol.', $caps->matCss('calcLCEB2'));
			$dspl.= $caps->onClickInput('nmLcebLS','calcLceb.displayResult(\'hzFastLuckySol\',\'\');','Heuristic', $caps->matCss('calcLCEBTrend2'));		
			$dspl.= $caps->onClickInput('nmLcebAS','calcLceb.displayResult(\'hzAllSol\',\'\');','All Sol.', $caps->matCss('calcLCEB2'));
			$dspl.= _c_;


			


			$dspl.= $caps->onClickInput('nmGame','caltor.standardBills(\'rnd\');','&sum;Br', $caps->matCss('calcLCEBTrend'));
			$dspl.= $caps->onClickInput('nmGame','caltor.standardBills(\'8\');','&sum;Bs', $caps->matCss('calcLCEB'));
			$dspl.= $caps->onClickInput('nmGame','caltor.standardBills(\'sixDg\');','&sum;6', $caps->matCss('calcLCEB'));

			
			
			$arCmd['shortCircAtt']= _c_surfEdt;
			$url= $tools->urlGivenPage('_multiplicationTable',$arCmd);
			$url.= $tools->addUrlVar(_c_surfEdt,'surf');
			
			/*
			$js= $caps->jsSimpleFu('kk.setPopUpWin',5,0,$url,'multiplTblWin',1200,700,'100');
			$dspl.= $caps->onClickInput('nmGame',$js,'Training Tables', $caps->matCss('trainingTbl'));
			*/
			
			// $dspl.= $caps->div($caps->cLinkTot($url,'Training Tables','trainingTbl','','','_blank'),'trainingTbl');
			$dspl.= $caps->cLinkTot($url,'Training Tables','trainingTbl','','','_blank');
			




			$dspl.= _c_;
			$dspl.= _c_;		
			
			// patience display.
			$pat.= $caps->span('Timer : ','timer');
			$pat.= $caps->textBox('timerTxtNm','',20,$caps->matCss('calcTimer'));
			$pat= $caps->sDiv($pat, 'width:220px; padding:5px; margin:5px; float:left; text-align:left;  border: 1px solid blue; ');
				
			$txtCb= $caps->span(' Max. T < 3 min :','allButComment','','','Cocher cette case pour utiliser le bouton [All Sol.] attention, attente possible jusqu\'à 3 minutes! Check this case to use the button [All Sol.] Warning, waiting time up to 3 minutes!');
			$txtCb.= $caps->checkBox('chkBoxForAll','ok',$caps->matCss('allButComment'));
		
			$txtCb.= _c_;		
			$txtCb.= $caps->span(' Real Random :','allButComment','','','Cocher cette case pour supprimer la précalculation des cas 3#6 et 3#6b. Check this box to suppress early calculation for the cases 3#6 and 3#6b.');
			$txtCb.= $caps->checkBox('cbRealRandom','ok',$caps->matCss('allButComment'));
			
			$txtCb= $caps->sDiv($txtCb, 'width:150px; text-align:right; border: 1px solid blue; 
				padding:10px; margin:2px; float:left; background-color:#e3e3e3;');
			$pat.= $txtCb;
		}
		
		// KEEP in comment
		// Can det rid of selected doted aura, using simple links and css 	outline: 0;	
		// $dspl.= '<div class="calcBasicBut"><a href="#" class="calcBasicBut">Fcs</a></div>';		
		
		$dspl= $caps->sDiv($head.$dspl.$pat, 'width:420px; border: 2px solid green; 
			padding:2px; margin:2px; float:left; background-color:#e3e3e3;');
		
		$bDspl= '';
		if ($gotGames){
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36\');','3#6', $caps->matCss('calcLCEBTrend'));
			$bDspl.= '<span class="remrk">Une version numériquement identique (un nombre de 3 chiffres à trouver avec 6 chiffres sélectionnés au hasard parmis les chiffres suivants (1,2,3,4,5,6,7,8,9,10,25,50,75,100) ) du </span>';
			$bDspl.= '<a class="remrkLn" href="http://www.france3.fr/emissions/des-chiffres-et-des-lettres" target="_blank">Compte est Bon</a>';
			$bDspl.= '<span class="remrk">, un jeu télévisé au succès exceptionnel!</span>';
			$bDspl.= _c_._c_;
						
			$bDspl.= '<span class="remrkTtl">Différentes approches pour faire varier la difficulté </span>';
			$bDspl.= '<span class="remrk">(à noter que pour les versions à 3,4, et 5 opérandes les opérandes sont tirés 
			au hasard, mais le but numérique est adaptés de manière à ce qu\'il y aie toujours une solution, 
			sans quoi les résolutions complètes seraient rares (pas assez de possibilités statistiques))</span>'._c_;
			$bDspl.= _c_;
			
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game23\');','2#3', $caps->matCss('calcLCEB'));		
			$bDspl.= '<span class="remrk">Le plus facile! Malgré tout on dépasse parfois 5 secondes de tête!</span>'._c_;
			$bDspl.= _c_;		
			
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game34\');','3#4', $caps->matCss('calcLCEB'));		
			$bDspl.= '<span class="remrk">Quatre opérandes et c\'est déjà un challenge!</span>'._c_;
			$bDspl.= _c_;		
			
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game35\');','3#5', $caps->matCss('calcLCEB'));				
			$bDspl.= '<span class="remrk">Cinq opérandes.</span>'._c_;
			$bDspl.= _c_;		
			
			
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36u\');','3#6b', $caps->matCss('calcLCEB'));
			$bDspl.= '<span class="remrk">Une augmentation de la difficulté par rapport à la version originale, spécialement en évitant les grands chiffres ronds. 
					Sans surprises, à partir de 6 opérandes le hasard suffit pour qu\'il y aie au moins une solution dans la large majorité des cas.</span>';
			$bDspl.= _c_;
			

			$bDspl.= _c_;		
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36b\');','4#6', $caps->matCss('calcLCEB'));
			$bDspl.= '<span class="remrk">Recherche d\'un résultat à 4 chiffres avec les plaquettes habituelles! Surprenant!(souvent trop difficile)</span>';
			$bDspl.= _c_;
			
			$bDspl.= _c_;		
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36i\');','4#6x', $caps->matCss('calcLCEB'));
			$bDspl.= '<span class="remrk">Recherche d\'un résultat à 4 chiffres avec 6 opérateurs dépassant tous 100 (souvent trop difficile)</span>';
			$bDspl.= _c_;
			
			$bDspl.= _c_;		
			$bDspl.= $caps->onClickInput('nmGame','caltor.challengeLCEB(\'game36j\');','5#6x', $caps->matCss('calcLCEB'));
			$bDspl.= '<span class="remrk">Recherche d\'un résultat à 5 chiffres avec 6 opérateurs dépassant tous 100 (encore plus difficile)</span>';
			$bDspl.= _c_;
			$bDspl.= _c_;

			
			
			$bDspl.= '<span class="remrk"><b>Solutions</b> (cliquez sur les boutons (plus pratique en haut) quand l\'écran de la calculette est vide pour avoir une explication plus détaillée) :</span>';
			
			$bDspl.= _c_;
			$bDspl.= $caps->onClickInput('nmLcebHS','calcLceb.displayResult(\'hzHideStrongSol\',\'\');','Hidden', $caps->matCss('calcLCEB2'));
			$bDspl.= '<span class="remrk">Un bouton donnant un résultat caché (en bas de l\'écran)  pour ne pas gâcher le jeu.</span>';
			
			
			$bDspl.= _c_;
			$bDspl.= $caps->onClickInput('nmLcebS1','calcLceb.displayResult(\'hzOneStrongSol\',\'\');','1st Sol.', $caps->matCss('calcLCEB2'));
			$bDspl.= '<span class="remrk">Une seule solution affichée en haut.</span>';
			
			
			$bDspl.= _c_;
			$bDspl.= $caps->onClickInput('nmLcebLS','calcLceb.displayResult(\'hzFastLuckySol\',\'\');','Heuristic', $caps->matCss('calcLCEBTrend2'));	
			$bDspl.= '<span class="remrk">Plus rapide mais ne trouve pas une solution dans 100% des cas quand le problème est calculé de manière totalement aléatoire (Bouton "Real Random" coché).</span>';
			
				
			$bDspl.= _c_;
			$bDspl.= $caps->onClickInput('nmLcebAS','calcLceb.displayResult(\'hzAllSol\',\'\');','All Sol.', $caps->matCss('calcLCEB2'));
			$bDspl.= '<span class="remrk">Calcule toutes les solutions, assez lent et implique de cocher la case "Max. Time."</span>';

			$bDspl.= _c_;
			$bDspl.= _c_;
			$bDspl.= _c_;
			$bDspl.= '<span class="remrkTtl">Curiosités :</span>';
			$bDspl.= '<span class="remrk">		
			<ul><li>Quand les solutions sont précalculées pour être sûr d\'avoir un tirage avec au moins une solution, il arrive que la meilleure approximation obtenue et prise ensuite comme but converge par en haut, ce qui fait que si le but choisi au hasard était proche de 999 on peut se retrouver avec un but légèrement supérieur à 1000 (cette curiosité apparaît rarement et plus souvent dans la série à 4 chiffre que dans les autres séries, pas encore constaté dans la série à 6 chiffre).</li>
			<li>Toutes les solutions sont vérifiées après leur calcul, il y a donc très peut de risque qu\'une solution erronnée apparaisse.</li>
			</ul>		
			</span>';		
			
			$bDspl.= _c_;
			$bDspl.= _c_;
			$bDspl.= '<span class="remrkTtl">Ce petit travail de programmation effleurant la probabilistique des combinaisons arithmétiques fait surgir quelques idées à creuser, par exemple :</span>';
			$bDspl.= _c_;
			$bDspl.= '<div class="remrkDiv"><ol><li>Dans la version officielle du jeu, quel est le tirage qui a le plus de solutions non triviales non directement apparentées (une solution directement apparentée peut 
				par exemple être obtenue en inversant l\'ordre d\'opérandes commutatifs). 
				Passer en revue tous les tirages possibles : (900 * 14^6) / 6! = 9411920 tirages, en comptant 100 ms (code compilé sur un bon ordinateur) par résolution, on
				obient la clé après environ 11 jours de calcul.</li>';

			$bDspl.= '<li>Comment générer un tirage (algorithmes allant de l\'heuristique approximative au théorême exact permettant de sélectionner les bonnes options) qui aie statistiquement le plus de chance de déboucher sur de nombreuses solutions?
			De nombreux tirages peuvent être éliminé d\'entrée, par exemples ceux ayant : des chiffres répétés (solutions triviales par permutations)</li>';

			$bDspl.= '<li>Quel est le nombre de tirages n\'ayant pas de solutions ?</li>';
			
			$bDspl.= '<li>Idem au point 3, mais en offrant N nombres à trouver en solutions,</li>';
			
			$bDspl.= '<li>Quel est le tirage qui permet de former le maximum de nombres différents? 
			A noter que (1,1,1,1,1,1) est celui qui en forme le plus petit vu que l\'amplitude des possibilités ne va que de 1 à 9</li>';
			
			$bDspl.= '<li>Etc.</li></ol></div>';
				
			$bDspl= _c_BrFlux.$caps->sDiv($bDspl, 'width:968px; text-align:left; border: 2px solid blue; 
				padding:4px; margin:2px; float:left; background-color:#e3e3e3;');
				
		}
		
		$lBut= '';		
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',0);','<1', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',1);','<2', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',2);','<3', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',3);','<4', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',4);','<5', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',5);','<6', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',6);','<7', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',7);','<8', $caps->matCss('calcArrowSml'));
		$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',8);','<9', $caps->matCss('calcArrowSml'));
		if ($gotGames){
			$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',9);','<0', $caps->matCss('calcArrowSml'));
			$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',10);','<1', $caps->matCss('calcArrowSml'));
			$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',11);','<2', $caps->matCss('calcArrowSml'));
			$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',12);','<3', $caps->matCss('calcArrowSml'));
			$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',13);','<4', $caps->matCss('calcArrowSml'));
			$lBut.= $caps->onClickInput('nmToR','caltor.chgTbCalcDispl(\'toLeft\',14);','<5', $caps->matCss('calcArrowSml'));
		}
		
		$lBut.= $caps->onClickInput('nmToR','caltor.uniqueOper(\'sigma\');','&sum;'._c_Ns, $caps->matCss('calcStatFont'));
		$lBut.= $caps->onClickInput('nmToR','caltor.uniqueOper(\'average\');','&sum;/n', $caps->matCss('calcStatFont'));
		
		$lBut= $caps->sDiv($lBut, 'width:45px; border: 2px solid white; 
			padding-left:2px; padding-top:7px; padding-bottom:2px; padding-right:2px;  
			margin:2px; float:left;');
		

		// Small screen area support (line extension display)
		$aspl= '';		
		if ($gotGames){
			$aspl.= $caps->textarea('calcLnExtDispl',22,45,'',$caps->matCss('calcAverChar'));
		}else{
			$aspl.= $caps->textarea('calcLnExtDispl',12,45,'',$caps->matCss('calcAverChar'));
		}
		
		$aspl= $caps->sDiv($aspl, 'width:478px; border:2px solid purple; padding:4px;  margin:2px; float:left;');
		
		if ($gotGames){
			$dbgDspl= $caps->textarea('calcDebugDspl',3,94,'',$caps->matCss('calcAverChar'));
			$dbgDspl= $caps->sDiv($dbgDspl, 'width:968px; border:2px solid black; padding:4px; margin:2px; float:left;');
			$aspl= $aspl._c_BrFlux.$dbgDspl;
		}
		
		// General display whatever (no line match for the small screen)
		$gspl= '';		
		if ($gotGames){
			$gspl.= $caps->textarea('calcGenDispl',28,94,'',$caps->matCss('calcAverChar'));
			$gspl= $caps->sDiv($gspl, 'width:968px; border: 2px solid blue; padding:4px; margin:2px; float:left;');
		}
		
		return $acc->toHtmlCode($caps->sDiv($dspl.$lBut.$aspl.$bDspl.$gspl, 'margin:auto; width:985px; border: 2px solid red; padding:5px; text-align:center; float:left;'));
	} // tg_calculator

} // calculator
?>
