<?php
/**
	File name : ctrlDownloadPg.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="ctrlDownloadPg" /]				[_ r="PLUGIN DECLARATION"/]
*/
class ctrlDownloadPg extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('ctrlDownloadPg','debugDisplay',true);	
		
		// 'ddurl' stands for : The "downloads" specific Directory passed by a Url
		$pDwld= array('ddurl','homedirurl','anyurl', 'cls', 'ext', 'txt', 'timer');
		$tagsFu->attribVect['urlpiloteddownload']= $pDwld;
		$tagsFu->attribVect['piloteddownload']= $pDwld;
		
		$this-> pilotedByUrl= false;
	} // construct


	/**
	*/
	function tags(){
		return array('urlpiloteddownload','piloteddownload');
	} // tags
	
		
	/**
		A partly by url piloted download function (the tests on 'ddurl' etc is removed), because we can't always
		call the page from the right place and we can't make all parameters "permanent"
		
		Local example :
			[extPlugin name="ctrlDownloadPg" /]			
			[urlPilotedDownLoad timer="3" ]			
		
		
		Remote url-calls examples (the page "_download" can be a default and the directory "downloads" as well) :
			[d url="shortZip.zip" cls="gecStandLn"]CLICK ONE[/d]
			[d url="_download&ddurl=shortZip.zip" cls="gecStandLn"]CLICK TWO[/d]
		
	*/
	function tg_urlpiloteddownload(&$v,&$bd){
		$this-> pilotedByUrl= true;
		$buff= $this->tg_piloteddownload($v,$bd);
		$this-> pilotedByUrl= false;
		return $buff;
	} // tg_urlpiloteddownload
	
		
	/**
		A strictly piloted by parameters download function 
		[pilotedDownLoad timer="300" ]			
	*/
	function tg_piloteddownload(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		

		$timer= $v['timer'];
		if ($timer!==false){
			$caps->pgRefWaitingTm= $timer;	// integrated into capshtml::metaRefresh() / formatAll()
		}

		$ext= $v['ext'];
		if ($ext!==false){
			$caps->dwnldExtens= $ext;	// global extension
		}
		
		$cls= $tools->mostValid($v['cls'],'gecStandLn');
		
		$txt= $v['txt']; // a locally hand crafted label
		if ($txt===false){
			$sLg= $tools->binLoads( $tools->getVal('sLg'), $dtb->currentLg() );
			$txt= $glob->flexTrans($sLg,'Please click on this link if the download did not start automatically!','kbmp');
		}
		
		$urlDriv= $tools->getVal('urlDriven');
		
		if ($this->pilotedByUrl){
			// url driven for the below $v[] values
			$v= &$_GET;
		}
		
		
		if (array_key_exists('ddurl',$v)){
			$url= _c_UsrDataPath.'downloads/'.$v['ddurl'];
		}else if (array_key_exists('homedirurl',$v)){
			$url= _c_UsrDataPath.$v['homedirurl'];
		}else if (array_key_exists('anyurl',$v)){
			$url= $v['anyurl'];
		}else if ($this->pilotedByUrl===false){
			$info= $glob->el('The tags urlPilotedDownLoad or pilotedDownLoad require a path-prefix parameter...','kbmq');
			$info.= 'ddUrl, homeDirUrl, anyUrl';
			$glob->userError($info);
			return '';
		}else{
			$info= $glob->el('The tags  ...','kbmq');
			$info.= 'ddUrl, homeDirUrl, anyUrl';
			$glob->userHelp($info);
			return '';
		}
		
		$caps->gotPgRefreshUrl= $url;	// To remote control capsHtml::metaRefresh() / formatAll()
		return $caps->linkC($url,$txt,$cls,'_blank');
	} // tg_piloteddownload
			
} // ctrlDownloadPg
?>