<?php
/**
	File name : extractor.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="extractor" /]
	[testPlug display="Plugin trial of : " /]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
			
	extractor::rSubstîtute light images! If asked for!
	extractor::extract()
	extractor::testIndex()
*/
class extractor extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		
		$this->asa= &$tagsFu->asa;
		$asa= &$this->asa;
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->aSql= &$tagsFu->aSql;
		$this->mWdgt= $tagsFu->instExplitCentralCls('formMainWdgt');
		$this->toPhp= $tagsFu->instExplitCentralCls('mysqlToPhp');
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('extractor','debugDisplay',true);	
		
		$tagsFu->attribVect['phoney']= false;
		
		define('_c_virginPhpDtb', _c_cpyPstVirginMtx._c_zCmsDirN.'/'._c_zPhpDataN.'/'._c_phpDtbDN.'/');
	} // construct


	/**
		NO REAL TAGS FOR NOW !!
	*/
	function tags(){
		return array('phoney');
	} // tags
	
	

	
		
	/**
		Get the last generated database name.
	*/
	function lastGeneratedDtbNm(){
		$dtb= &$this->dtb;		
		$dtbNm= $dtb->getGenVar('installerDtbName');
		$idx= $this->dtbDirIdx();
		return $dtbNm.$idx;
	} // lastGeneratedDtbNm
		
	/**
		Get the last generated directory name.
	*/
	function lastGeneratedDirNm(){
		$dtb= &$this->dtb;
		$dirNm= $dtb->getGenVar('installerMainDirName');
		$idx= $this->dtbDirIdx();
		return $dirNm.$idx;
	} // lastGeneratedDirNm
	
	/**
	*/
	function lastSecretArchDN(){
		$dtb= &$this->dtb;
		return $dtb->getGenVar('lastBuiltSecretArchDN');
	} // lastSecretArchDN
	
		
	/**
		Give back if there is one, the database and directory index to be concatenated.
	*/
	function dtbDirIdx(){
		$dtb= &$this->dtb;	
		$idxOk= $dtb->getGenVar('installerAcceptIdx');
		if ($idxOk===_c_ok){
			$idx= $dtb->getGenVar('installerMDirNmIdx');
			$idx= $idx-1;
		}else{
			$idx= '';	// empty string ok for concatenation
		}		
		return $idx;
	} // dtbDirIdx

		
	/**
		Loads the current mySql database directly into the strict php database spot with previous removal ofdatas if already there!
		--> Remove and Build the Php database.
	*/
	function rmvBuildPhpDtb(){
		$asa= &$this->asa;
		$fls= &$this->fls;
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;
		$toPhp= &$this->toPhp;
		
		include_once _c_DtbLibPath.'simulSql.php';
		$secondSql= new simulSql($asa,$dtb);
		$secondaryDtb= new localDB($asa,$secondSql);
		
	
		/** Build the non sql part, using available functions!
		*/
		
		/**  Clean up process of the destination directories.
		*/
		$destProdPath= $fls->removeLastChar(_c_phpDtb);
		$fls->removeDir($destProdPath);
		$srcPath= $fls->removeLastChar(_c_virginPhpDtb);
		$fls->copyDirectories($srcPath,$destProdPath);
		
		$destDumpPath= $fls->removeLastChar(_c_phpDumpDtb);
		$fls->removeDir($destDumpPath);
		$fls->copyDirectories($srcPath,$destDumpPath);
		
		/**  Php code builder copy into the dump.
		*/
		$colNmMess= $toPhp->dumpAllColNames(_c_UsrDbName);
		
		$toPhp->buildFullPhpDtb($aSql,$secondaryDtb);
		
		// Transfers from the dump to the active part
		$fls->copyDirectories($destDumpPath,$destProdPath);
		$fls->removeDir($destDumpPath);
		$fls->copyDirectories($srcPath,$destDumpPath);	// virgin dump again!
	} // rmvBuildPhpDtb
	
	
	/**
		Add the php dtb files to the just built 100% php environment using the current database _c_UsrDbName as a model
	*/
	function wrHundrPcHeaders(){
		$fls= &$this->fls;
		$toPhp= &$this->toPhp;

		$colNmDfn= _c_destZCmsPhpDtbInfo.'colNames.php';
		$colNmPhpStr= $toPhp->allColNamesPhpStr(_c_UsrDbName);
		$fls->strToFile( $colNmDfn, $colNmPhpStr );
		
		$tblNmsDfn= _c_destZCmsPhpDtbInfo.'tblNames.php';
		$tblNameStr= $toPhp->onlyTblNmStr(_c_UsrDbName);
		$fls->strToFile( $tblNmsDfn, $tblNameStr );
		
		/**
			Need to add all directories matching the table names, because can't write it otherwise when in atom mode
			--> process is broken --> don't write inside the large table either! Was fine in previous large table trials
			because was writing the atomes files just at the end from fully loaded tables
		*/
		$toPhp->createsAtomsTblDir(_c_UsrDbName,_c_destZCmsPhpDtb);
	} // wrHundrPcHeaders
	
} // extractor
?>
