<?php
/**
	File name : forum.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	The main class to deal with the forum implementation (mainly comments implementation at this stage).

	Forum apperance :
		- answer to article ---> head or tail
		- answer to other post indented below the concern post, so each post need its own button


	Strategies :
		- uses texts instead of buttons (globaly stored and language dependant)
			- Answer main article / Répondre article principal.
			- Answer commment / Répondre à ce commentaire.
			
		- uses a digest squarred bracked for the form + send button + captcha etc.
	
	-----------------------------------------------------
	 New user registration, see :  forumAlgo::newPost()
	-----------------------------------------------------
	
	forum::postbutton()
		
*/
class forum extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;	// access to some global values, sometimes methods
		$glob= &$this->glob;
		$glob->globWatchNSQ= true;
		$this->caps= &$tagsFu->caps;	// access many html methods
		$this->fls= &$tagsFu->fls;
		$this->tools= &$tagsFu->tools;
		$this->acc= &$tagsFu->acc;
		$this->dtb= &$tagsFu->dtb;
		$this->rights= &$tagsFu->rights;
		$rights= &$this->rights;
		$this->hPwC= &$tagsFu->hPwC;	// hashPwCrypt	
		$this->parser= &$tagsFu->parser;
		$this->cacheR= &$tagsFu->cacheR;
		$this->cacheWr= &$tagsFu->cacheWr;
		
		
		$this->fKern= $tagsFu->instExplitCentralCls('formpKernel');
		
		$tagsFu->attribVect['fumearlyinit']= false;
		
		// [sendPostBut /] ... a special send post button to crypt the password
		$tagsFu->attribVect['sendpostbut']= array('name','pwboxname','str','sl','cls','anonyme');
		$tagsFu->attribVect['captchaquest']= false;
		$tagsFu->attribVect['postsignreg']= false;
		$tagsFu->attribVect['watcherlogin']= false;
		$tagsFu->attribVect['appearonclick']= array('name');
		$tagsFu->attribVect['fumregistrationstr']= false;
		$tagsFu->attribVect['simulatefumregstr']= false;
		$tagsFu->attribVect['postinit']= array('pfxm','pfxc', 'fixm','fixc');
		$tagsFu->attribVect['threadtitle']= array('xpage','postid');
		
		/**
			The main forum tags :
				dateformat : to specify the look of the visible date stamp on the post titles 
						exactly along the PHP specification for the function date() : http://php.net/manual/en/function.date.php
						mainly use English format : 'dnY' and French 'ndY' with generated spaves replaced with -
		*/
		
		$tagsFu->attribVect['listedusers']= array('list');	
		$tagsFu->attribVect['allowfumlinkfollowing']= false;
		
		
		$tagsFu->attribVect['subusermanager']= false;
		$tagsFu->attribVect['commentmanager']= array('dateformat');
		
		$tagsFu->attribVect['forumthreads']= array('dateformat');		
		$tagsFu->attribVect['forumanager']= false;	// in text button !!
		
		/**
			Tags to be imbricated inside the nect part of the main page, they :
				- Display indented title/full text or extract of the title/full post
				- Parameter(s):
					- id : of the concerned post.
					- mother page is known automatically
					- mother post (if one) too complicated to be extracted so should be store in param if used, but probably no use!
					
				- Inclusion done within forumAlgo::saveMessage()
		*/
		$tagsFu->attribVect['forumpost']= array('id','frame');
		$tagsFu->cssExtInclusion('forum');
		
		$glob->addCssFile(_c_toDeclPlugExt.'imGallery/imGallery.css');
		
		$this->imgP= &$tagsFu->imgP;
		$imgP= &$this->imgP;
		
		include_once  _c_LibPath.'geomArray.php';
		$this->geomArray= new geomArray($tagsFu);
		
		include _c_toDeclPlugExt.'forum/forumShareCd.php';
		$this->shrdCd= new forumShareCd($tagsFu,$imgP);
		$shrdCd= &$this->shrdCd;
		$this->xRgt= &$shrdCd->xRgt;
		
		$tagsFu->fumShrdCd= &$shrdCd;
		
		$tagsFu->instExplitCentralCls('forumBar');
		$glob->explCentralInclStanceJs('forumBar');		// got a test to avoid multi declarations.
		
		
		$captcha= &$shrdCd->captcha;
		$this->captcha= &$captcha;
		
		$tagsFu->explicitClasses['shrdCd']= &$this->shrdCd;	// to avoid re-instantiation later on
		
		include _c_toDeclPlugExt.'forum/forumAlgo.php';
		$this->forumAlgo= new forumAlgo($tagsFu,$this);
		
		$tagsFu->explicitClasses['forumAlgo']= &$this->forumAlgo;	// to avoid red-instantiation later on
		
						
		$js= 'forum.regWgtDealer();'._c_R;
		$glob->setGlbEndJsCode($js);
		
		
		$tagsFu->attribVect['onlyregistering']= array('regttl');;
		$tagsFu->attribVect['onlyregistedfilter']= false;
		
		$tagsFu->attribVect['forumtitletbox']= array('name','str','cls','min','max','email'); // 'email' added so error process correctly
		$tagsFu->attribVect['fumbodyformttl']= false;
		
		
		$tagsFu->attribVect['forumessbox']= array('name','str','width','height','cls','min','max');
		
		$tagsFu->attribVect['forumtitlehandler']= false;
		$tagsFu->attribVect['forummessboxes']= false;
		
		$tagsFu->attribVect['pagesubstitutor']= array('title','cls');
		$tagsFu->attribVect['forumcheckuser']= array('name');
					
		
		$tagsFu->attribVect['placefiller']= false;
		$tagsFu->attribVect['lastpostsummary']= false;
		
		$tagsFu->attribVect['onlyspecifieduser']= array('usrlist');
		
		$tagsFu->attribVect['regloguserlbl']= false;
		$tagsFu->attribVect['reglogpwlbl']= false;
		
		$tagsFu->attribVect['parseonlyfrontpage']= false;
		$tagsFu->attribVect['informedonmypost']= false;
				
		$tagsFu->attribVect['infowebmaster']= array('title','main');	
	} // construct


	/**
	*/
	function tags(){
		return array('fumearlyinit','sendpostbut','forumtitlehandler','forummessboxes','captchaquest','postsignreg','watcherlogin',
			'appearonclick','fumregistrationstr','simulatefumregstr','postInit'
			,'listedusers','allowfumlinkfollowing','commentmanager','subusermanager','forumanager','forumpost','onlyregistering','onlyregistedfilter','forumtitletbox'
			,'pagesubstitutor','forumessbox','forumcheckuser','forumthreads','threadtitle','parseonlyfrontpage',
			'placefiller','lastpostsummary','onlyspecifieduser','fumbodyformttl','regloguserlbl','reglogpwlbl',
			'infowebmaster','informedonmypost');
	} // tags
		
	
	/**
		[fumEarlyInit /]	Forum early initialisation
	*/
	function tg_fumearlyinit(&$v,&$bd){	
		$shrdCd= &$this->shrdCd;
		$tools= &$this->tools;
		
		$clkLR= $tools->getVal(_c_fJustClickedOnLR);	// click on the "Login or register
		if ($clkLR===_c_ok){
			$shrdCd->initSessNb();
		}
	} // tg_fumearlyinit
	
	
	/**
		To display a captcha question with an associated hash.
		[captchaQuest /]
	*/
	function tg_captchaquest(&$v,&$bd){
		$captcha= &$this->captcha;		
		$toDisplay= $captcha->captchaQuest($chosenCaptchaId,$captcha->globCaptchTblNm);
		return $toDisplay;
	} // tg_captchaquest
		
	
	/**
		Display the content only when registering.
	*/
	function tg_onlyregistering(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;		
		$xRgt= &$this->xRgt;
		$fAlgo= &$this->forumAlgo;
		$reader= &$this->cacheR;
		$cacheWr= &$this->cacheWr;
		
		$motherPg= $shrdCd->gostMotherPage();
		$dfn= $reader->cacheCandidateDfn($motherPg);
		
		$onlyreg= $fAlgo->onlyRgister();
		if ($onlyreg===_c_ok){
			$xIndx= $shrdCd->gostXCode();
			
			if ($shrdCd->correctlySignedIn(false)){	// the substitite $shrdCd->isSignedIn	is not quick enough!
				// ok + link back to the mother page
				$shrdCd->getPostedUserIds($userId,$pseudo);
				$fAlgo->newHashes($primHash,$curHash,$userId);		
				$jsAA= $caps->jsSimpleFu('forum.cryptForAAUser',1,0,$curHash).';'._c_R;
				$glob->setGlbEndJsCode($jsAA);
				
				$mailOk= $shrdCd->mailIsOk($userId);
				if ($mailOk || $xRgt->subUserStatus()){
					$justLogIn= $glob->sl('You have just logged in','kanf');
				}else{
					$pseudo= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserPseudo);
					
					$compulsEMailVerif= $dtb->getGenVar('compulsEMailVerif')===_c_ok;
					$justLogIn= $glob->sl('Welcome ','kang').$pseudo;
					if ($compulsEMailVerif){
						$justLogIn.= $glob->sl('your inscription was successful ...','kanh');
					}else{
						$justLogIn.= $glob->sl('your inscription was successful and you can directly post some messages','kber');
					}
				}
								
				$url= $shrdCd->curPgAndXCodeUrl($xIndx,false,$motherPg);
				$url.= $tools->addUrlVar(_c_fumUserId,$userId);
				return _c_.$this->backButton($url).$caps->linkC($url,$justLogIn._c_BrFlux._c_BrFlux,'fumStd');
			}else{
				$url= $shrdCd->curPgAndXCodeUrl($xIndx,false,$motherPg,false,false);
				
				$bLink= $this->backButton($url);
				
				if ( $dtb->gotOkGenVar('publicPostsFPV') && $shrdCd->allowNewUserRegistrB() ){
					// Just the title indicating what the form is about !!!
					// 'kani' original unlikely to be used, most probable are kbnm and kbnn
					$regTtl= $tools->binLoads($v['regttl'],'kani');
					$Ttl= $caps->span($glob->sl('Comments : Login / register!',$regTtl),'fumStd');
					return _c_.$caps->sDiv($bLink.$Ttl,' width:100%; max-width:550px');
				}else{
					$Ttl= $caps->span($glob->sl('Login','kmia'),'fumStd');
				}
				
				if ($rights->wRights){
					if ($motherPg!=='_4umCreateNewUser'){
						$Ttl.= $caps->span(_c_.$glob->sl('Warning, you can\'t log as a (new) forum user if you are logged as a webmaster!','kaao'),'fumError');
					}else{
						$Ttl.= $caps->span(_c_.$glob->sl('To add a new VIP user ...','kbgo'),'fumError');
					}
				}
				
				return _c_.$bLink.$Ttl;
			}
		}else{
			return '';
		}
	} // tg_onlyregistering
	
	
	/**
		[postSignReg/] : Forum / Post to react on the widgets to sign or register (the large part).
		So basicaly : User name  |  Password  |  (captcha etc.)  |  mail watch
	*/
	function tg_postsignreg(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rgt= &$this->rights;
		$fAlgo= &$this->forumAlgo;
		
		
		$lostPwStr= '';
		$hd= '';	// hidden info
		$shrdCd->getPostedUserIds($userId,$pseudo);	
		
		if ( $shrdCd->coreSignedIn($userId) ){
			if ($tools->getVal('fumUnlog')!==_c_ok){
				$bd= '';	// Eliminates irrelevant tags!
				$imprPId= $tools->gostVal(_c_fImprovePId);
				
				if ($fAlgo->globCpIndx!==false){
					$hd.= $caps->hiddenWdg(_c_fCurPostIdx,$fAlgo->globCpIndx)._c_R;
				}

				$mailOk= $shrdCd->mailIsOk($userId);
				if ($mailOk){
					if ( $pseudo!==$userId && $rgt->quickWMRight() ){
						$complemStr= $glob->es('The internal userId','kanl').$userId;
					}else{
						$complemStr= '';
					}
					$bd.= $caps->span($glob->sl('You are connected as : ','kank').$pseudo.$complemStr,'fumLbl')._c_;
				}
				
				if ($fAlgo->onlyRgister()===_c_ko){
					$bd.= $caps->span($glob->sl('Get an email when it is answered : ','kanm'),'formLbl');
					if ($tools->getVal(_c_fImprovePId)!==false){
						// First entry, need to take the stored value.
						$eWatch= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$imprPId, _c_fumWatchMail);
					}else{
						// Already posted so takes the posted values
						$eWatch= $tools->postVal(_c_emailWatcher);
					}
					$bd.= $caps->checkBox(_c_emailWatcher,_c_ok,$eWatch);
				}
			}
		}else{
			// password recovery			
			$usrNm= $tools->postVal('usrNm');
			$lostPw= $tools->postVal('lostPassword');
			
			if ($lostPw===_c_ok){
				$successToSendNewPw= $fAlgo->createNewPwSendM($userId);
				if ($successToSendNewPw){
					$lostPwStr= _c_.$caps->span($glob->sl('We sent you a new password','kanz'),'fumUsrMgCongrat') ._c_._c_;
				}else{
					$lostPwStr= _c_.$caps->span($glob->sl('Sorry the data do not match, please try again!','kmib'),'fumUsrMgCongrat') ._c_._c_;
				}
			}else{
				$newReg= $tools->postVal(_c_fcbNewReg)!==_c_ok;
				if ( $usrNm!==false && !$fAlgo->freeUserId($userId) && $fAlgo->onlyRgister()===_c_ok && $newReg){
					// The form was sent with a wrong password.
					$lostPwStr= $caps->span($glob->sl('If you have lost your password','kaoa'),'fumLbl');
					$lostPwStr.= $caps->checkBox('lostPassword',_c_ok);
					$lostPwStr.= $caps->span($glob->sl(' and give your forum email address here : ','kaob'),'fumLbl');
					$lostPwStr.= $caps->textBox('lostPwMailAddr', '', '20', 'forMnWdgtTB');
				}
			}
		}
				
		$mp= $shrdCd->gostMotherPage();		
		if ($mp!==false){
			$hd.= $caps->hiddenWdg(_c_fMotherPage,$mp)._c_R;
		}
		
		$xSup= $shrdCd->gostXCode();
		$hd.= $caps->hiddenWdg(_c_fxCodeIndx,$xSup)._c_R;
		
		$gMess= $shrdCd->globUsrMess;
		if ($gMess!==''){
			$gMess.= _c_;
		}
				
		return $hd.$gMess.$lostPwStr.$bd;
	} // tg_postsignreg
	
	/**
		Returns true after a wrong password or Id input and false otherwise.
		Remark ;:look at the symetry with tg_postsignreg() for understanding, it's an indirect control of the above messages
		in the special case of genVar::publicPostsFPV==='ko'.
	*/
	function lostPasswordState(){
		$shrdCd= &$this->shrdCd;
		$tools= &$this->tools;
		$fAlgo= &$this->forumAlgo;
		
		
		$signedIn= $shrdCd->correctlySignedIn();
		if ($signedIn){
			return false;
		}
		
		$shrdCd->getPostedUserIds($userId,$pseudo);	
		
		// password recovery state
		$usrNm= $tools->postVal('usrNm');
		$lostPw= $tools->postVal('lostPassword');
		if ($lostPw===_c_ok){
			return true;
		}else if ( $usrNm!==false && !$fAlgo->freeUserId($userId) ){
			return true;
		}
		
		return false;
	} // lostPasswordState
	
	
	
	/**
		[watcherLogin/] : A special tag to log in a Watcher (former subuser)
		Rem : this is a watcher (subuser) specialised instance of tg_postsignreg(&$v,&$bd)
	*/
	function tg_watcherlogin(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rgt= &$this->rights;
		$fAlgo= &$this->forumAlgo;
		
		$hd= '';	// hidden info
		$shrdCd->getPostedUserIds($userId,$pseudo);	
		
		if ( $shrdCd->correctlySignedIn() ){
			if ($tools->getVal('fumUnlog')!==_c_ok){
				$bd= '';	// Eliminates irrelevant tags!
				$imprPId= $tools->gostVal(_c_fImprovePId);
				
				if ($fAlgo->globCpIndx!==false){
					$hd.= $caps->hiddenWdg(_c_fCurPostIdx,$fAlgo->globCpIndx)._c_R;
				}
			
				$motherPg= $shrdCd->gostMotherPage();
				$url= $tools->urlGivenPage($motherPg);
				$url.= $tools->addUrlVar(_c_fumUserId,$userId);
				$logStr= $glob->sl('You just connected','kanj');
				$backBut= $this->backButton($url).$caps->linkC($url,$logStr._c_BrFlux._c_BrFlux,'fumStd');
				
				$mailOk= $shrdCd->mailIsOk($userId);
				if ($mailOk){
					if ( $pseudo!==$userId && $rgt->quickWMRight() ){
						$complemStr= $glob->es('The internal userId','kanl').$userId;
					}else{
						$complemStr= '';
					}
					$bd.= $caps->span($backBut.$glob->sl('You are connected as : ','kank').$pseudo.$complemStr,'fumLbl')._c_;
				}
			}
		}
				
		$mp= $shrdCd->gostMotherPage();		
		if ($mp!==false){
			$hd.= $caps->hiddenWdg(_c_fMotherPage,$mp)._c_R;
		}
		
		$xSup= $shrdCd->gostXCode();
		$hd.= $caps->hiddenWdg(_c_fxCodeIndx,$xSup)._c_R;
		
		$gMess= $shrdCd->globUsrMess;
		if ($gMess!==''){
			$gMess.= _c_;
		}
				
		return $hd.$gMess.$bd;
	} // tg_watcherlogin	
	
	
	/**
	*/
	function backButton($url,$txt='Back'){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$img= $caps->image($caps->imgSrc('backRed.png',_c_ok),$glob->sl('Back!','kbmj'),'fumImgBtt');
		return $caps->linkTC($url,$img,$txt,'fumImgBtt').$caps->span(' ','fumStd');
	} // backButton
	
	
	/**
		Do not display the message when registering, so only for registred users
	*/
	function tg_onlyregistedfilter(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$tools= &$this->tools;
		$parser= &$this->parser;
		$fAlgo= &$this->forumAlgo;
				
		$onlyreg= $fAlgo->onlyRgister();
		$mPage= $shrdCd->gostMotherPage();	// comment
		if ($onlyreg===_c_ok || $mPage===false ){
			return '';
		}else{
			return  $this->chokingMessage($mPage)._c_.$bd;
		}
	} // tg_onlyregistedfilter
	
	
	/**
		Straight display of the post.
		Tag to be imbricated inside the nect part of the main page. Just does the display!
		Rem : works in synergy with forumAlgo::addANewForumTag()
				
		Example :
			Note : 
				- Correct indentation done at insertion time, using local tabs.
			Algo :
				- First insert ahead or intail from global comment button
				- Then insert inbetween from comment answering button. 		
	*/
	function tg_forumpost(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		return $shrdCd->forumPost($v,$bd);
	} // tg_forumpost		
	

	/**
		A specific send post button to include password encryption
		[sendPostBut  name="but" pwboxname="usrPw" str="Send" cls="sendButton" /]
	*/
	function tg_sendpostbut(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$fAlgo= &$this->forumAlgo;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$captcha= &$this->captcha;
		
		$onlyreg= $fAlgo->onlyRgister();
		if ($onlyreg===_c_ok && $shrdCd->isSignedIn){
			return '';
		}
		
		if ($onlyreg===_c_ok){
			$hdWdgt= $caps->hiddenWdg(_c_fumOnlyReg,$onlyreg)._c_R;
		}else{
			$hdWdgt= '';
		}
		
		$motherPg= $shrdCd->gostMotherPage(_c_ko);
		$hdWdgt.= $caps->hiddenWdg(_c_fMotherPage,$motherPg)._c_R;
		
		$shrdCd->getPostedUserIds($userId,$pseudo);
		
		// NEW HASHES
		$fAlgo->newHashes($primHash,$curHash,$userId);		
		
		// So can be catched in forumAlgo::newPost()
		$freeHashId= $dtb->getGenVar('fumHashTblFreeId');
				
		$hdWdgt.= $caps->hiddenWdg('freeHashId',$freeHashId)._c_R;
		$hdWdgt.= $caps->hiddenWdg('primHash',$primHash)._c_R;
		$hdWdgt.= $caps->hiddenWdg('curHash',$curHash)._c_R;
		
		// loads the current hashes and does the hashid incrementation
		if (isset($captcha->curCaptchaId)){
			$cCaptchaId= $captcha->curCaptchaId;
		}else{
			$cCaptchaId= 1;
		}
		$hashVect= array($freeHashId,$primHash,$curHash,$cCaptchaId);
		
		$dtb->newElem(_c_fumHashTbl,_c_fumHashId,$freeHashId,$hashVect,true);	// Loads the current hashes
		$fAlgo->incrFreeHashId();		// Circular increment of the free hash :
					
		$js= 'forum.genInit();'._c_R;
		$glob->setGlobJsCode($js);

			
		$name= $v['name'];
		$pwboxname= $v['pwboxname'];
		
		$str= $v['str'];
		$sl= $v['sl'];
		$str= $glob->sl($str,$sl);
		
		$label= $tools->postVal($name,$str);
		$attS= $v['cls'];
			
		$prevcryptPw= $tools->postVal($pwboxname);	// previously sent crypted password		
		
		$jsAA= $caps->jsSimpleFu('forum.cryptForAAUser',1,0,$curHash).';'._c_R;
		$glob->setGlbEndJsCode($jsAA);
		
		if ($v['anonyme']===_c_ok){
			$js= $caps->jsFunctCallStr('onclick','forum.onclickCrypt',5,0,$pwboxname,$primHash,$curHash,'anomNewUsr',$userId);
			return _c_R.$hdWdgt._c_R.$caps->submit($name, $label, $caps->matCss($attS).$js);
		}else{
			if ($shrdCd->correctlySignedIn() && $fAlgo->onlyRgister()===_c_ok){
				return _c_R.$hdWdgt._c_R;
			}else{
				$sentMode= $fAlgo->globSentMode;
				$js= $caps->jsFunctCallStr('onclick','forum.onclickCrypt',5,0,$pwboxname,$primHash,$curHash,$sentMode,$userId);
				return _c_R.$hdWdgt._c_R.$caps->submit($name, $label, $caps->matCss($attS).$js);
			}
		}

	} // tg_sendpostbut
	

	/**
		Global definition of the strings of the forum buttons.
		[postInit pfxM="" fixM="" pfxC="" fixC="" ]
	*/
	function tg_postinit(&$v,&$bd){
		$caps= &$this->caps;	// encapsulation of many usefull html code.
		
		/**
		  Prefixes for the forum answering buttons titles. If defined they are used when the local one are not defined.
		  Could also have a switch to impose them in case of a website brushup.
		*/
		$this->pfxM= $v['pfxM'];	// Would use the menu button string! Not very large + only one, so better use fixM instead!
		// if not false : only a prefix string for the main article forum button.
		
		$this->fixM= $v['fixM'];	// if not false : the full string for the article forum button
		
		$this->pfxC= $v['pfxC'];	// if not false : only a prefix for the main user comments buttons.
		$this->fixC= $v['fixC'];	// if not false : the full string for the comment forum button
	} // tg_postinit
	
		
	/**
		Request a comments interaction with the current page
		[subuserManager /]
	*/
	function tg_subusermanager(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$shrdCd->subUsRegitrPg= true;
		return $this->subUserInteractManager();
	} // tg_subusermanager
	
	
	/**
	*/
	function subUserInteractManager(){
		$tools= &$this->tools;
		
		$xCodeIndx= $tools->gostVal(_c_fxCodeIndx,'0');
		$urlsup= $tools->addUrlVar(_c_fxCodeIndx,'0');
		
		return $this->postbutton('','',true,'_4um_subUsrReg',true,$urlsup);
	} // subUserInteractManager


	/**
		Example : [listedUsers list="xx, pierre, paul, jacques" /]
		When this tag is active on the page, only the users listed directly or indirectly with the parameters list or inside the 
			Table idTexts::'usrList_'.page_name mirror can POST. 
		
		+ Clue Look at [pageMode forum="closed" /]
	*/
	function tg_listedusers(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		
		$glob->isFumSpiderFrienly= true; // so the listed users have by default links that count on SE
		
		$mirId= 'usrList_'.$tools->curPageName();	// "mirror" Id
		$list= $v['list'];
				
		if ($list===false){
			$directList= false;
			$list= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$mirId, _c_idTextTxt);
		}else{
			$directList= true;
		}
		
		// When the webmaster is connected, make sure a "mirror" is similar and accessible
		// When $directList===false the mirror is the model by default, so no need to write it.
		if ( $directList && $rights->quickWMRight() ){
			// Prepares access for the function $shrdCd->usrAllowedToWrite()
			$mirList= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$mirId, _c_idTextTxt);
			if ($mirList!==$list){
				// re/write it :
				$valV= array($mirId,$list);
				$dtb->setElem(_c_idTextsTbl, _c_idTextTxt,$list, _c_idTextKey,$mirId, $valV);
			} // else nothing to write !!
		}
	} // tg_listedusers
	
		
	/**
		[allowFumLinkFollowing /] So can add it anywhere (even inside xPages to admit links following)
	*/
	function tg_allowfumlinkfollowing(&$v,&$bd){
		$glob= &$this->glob;
		$glob->isFumSpiderFrienly= true;
	} // tg_allowfumlinkfollowing
	


	/**
		Request a comment interaction with the current page
		[commentManager /]
	*/
	function tg_commentmanager(&$v,&$bd){
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		$shrdCd= &$this->shrdCd;
		
		
		if ( $shrdCd->correctlySignedIn() && $dtb->getGenVar('noCacheOnlyForum')===_c_ok && $dtb->getGenVar('noCacheEverywhere')!==_c_ok ){
			$caps->catNoCache();
		}		
		
		$shrdCd->setGlobPTDF( $v['dateformat'] );
		$fAlgo->callCreatePgRepos(_c_ko);	// conditional creation or specific setting. Creates a new entry inside _c_forumPgRe
		return $this->commentManager();
	} // tg_commentmanager
	
	
	function commentManager(){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$shrdCd= &$this->shrdCd;
		
		$xCodeIndx= $tools->gostVal(_c_fxCodeIndx,'0');
		$urlsup= $tools->addUrlVar(_c_fxCodeIndx,'0');
		if ($shrdCd->correctlySignedIn()){
			if ($shrdCd->forumPageIsOpen()){
			
				$okToWr= $shrdCd->usrAllowedToWrite();
				if ($okToWr){
					$label= $glob->sl('To comment the main article : ', 'kaah');
				}else{
					$label= $glob->sl('Sorry you are not allowed to post on this page!', 'kmhy');
					return $this->postbutton($label,'',true,_c_ko,true,$urlsup);
				}
				
			}else{
				$label= $glob->sl('Comments of this page are closed : ', 'kbbr');
			}
			
			return $this->postbutton($label,'',true,'_4um_message_form',true,$urlsup);
		}else{
			return $this->postbutton('','',true,'_4um_registration',true,$urlsup);
		}
	} // commentManager
	

	/**
		Only Specified User can see the body. This is a private tag
			[onlySpecifiedUser usrlist="sub; host"]
			[/onlySpecifiedUser]
	*/
	function tg_onlyspecifieduser(&$v,&$bd){	
		$shrdCd= &$this->shrdCd;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		$priority= $rights->wRights;	// webmaster see it all
		if ($priority){
			return $bd;
		}
	
		$usrlist= $v['usrlist'];
		if ($usrlist!==false){
			$vect= $tools->trimStrToVect(',',$usrlist);
		}else{
			// try our luck on the mirror list
			$mirId= 'usrList_'.$tools->curPageName();	// "mirror" Id
			$mirList= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$mirId, _c_idTextTxt);
			$vect= $tools->trimStrToVect(',',$mirList);
		}

		$usrId= $shrdCd->smartUserId();
		if (!in_array ($usrId,$vect)){
			return '';
		}
		
		if ($shrdCd->coreSignedIn($usrId)){
			return $bd;	// really signed in
		}
		
		return '';
	} // tg_onlyspecifieduser


	/**
	  [forumThreads /] and specific points :
		 --> Host the new Thread button.
		 --> Added to the bottom of a normal page
		 --> List the thread heads with click possibilities to visualise the thread
		 --> visualisation of the thread posts (standard comments) --> x code table stream 
		 need to be related to motherPageName & specific thread
		 ---> X page need 5 more chars id --> 45 chars
		 	---> otherPage-threadNumber-XIndex
		 ---> A flag to know if we have a comment coding (only one suffix) or a forum coding (2 suffixes).
	*/
	function tg_forumthreads(&$v,&$bd){	
		$tagsFu= &$this->tagsFu;
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		$parser= &$this->parser;
		$fAlgo= &$this->forumAlgo;
		
		if ( $shrdCd->correctlySignedIn() && $dtb->getGenVar('noCacheOnlyForum')===_c_ok && $dtb->getGenVar('noCacheEverywhere')!==_c_ok){
			$caps->catNoCache();
		}
		
		$shrdCd->setGlobPTDF( $v['dateformat'] );
		$fAlgo->callCreatePgRepos(_c_ok);	// conditional creation or specific setting
		$shrdCd->gotForumThreadTag= true;
		$curPgN= $tools->curPageName();	
		
		$rFxPg= $tools->gostVal(_c_rfxPage,'');
		if ($rFxPg===''){
			// No x pages specified, so we are on the main page with the list of threads
			$lastGIdx= $fAlgo->lastTgFreeIdx($curPgN)-1;	// last index of the group of threads
			$accessThrdGrp= $this->invTGSwitches($lastGIdx);
				
			$rootUrl= $tools->urlGivenPage('_4um_message_form');
			$specRfButton= '';
			if ( $shrdCd->isSignedIn && $shrdCd->inPostDailyLimit() ){
				$url= $rootUrl.$tools->addUrlVar(_c_fMotherPage,$curPgN);
				$url.= $tools->addUrlVar(_c_rfNewThread,_c_ok);
				
				$okToWr= $shrdCd->usrAllowedToWrite();				
				if ( $shrdCd->forumPageIsOpen() && $shrdCd->allowNewUserRegistrB() && $okToWr ){
					// ALWAYS THE LAST THREAD full stop (free-1) !!!!!!!!!!!!
					$lbl= _c_.$glob->sl('Post a New Thread!','kaod')._c_._c_;
					$specRfButton= $caps->hLink($url, $lbl, $caps->matCss('fumStd'));
				}else{
					$lbl= $glob->sl('Sorry you are not allowed to post on this page!', 'kmhy');
					$specRfButton= $caps->span($lbl,'fumStd');
				}
			}
			
			// Recovers the threads
			$idx= $fAlgo->getTGIdx($lastGIdx);
			
			$curTN= $shrdCd->threadName($curPgN,$idx);
		
			$curXCode= $dtb->getElem(_c_fumThreadList, _c_fumTrLstId,$curTN, _c_fumTrLst);
			$theThreads= false;
			if ($curXCode!==false){
				$theThreads= $parser->parseStdStr($curXCode, $curTN);
				
				$curXSupCode= $dtb->getElem(_c_fumThreadList, _c_fumTrLstId,$curTN, _c_fumTrLsSupTg);
				if ($curXSupCode!==''){
					$tagsFu->expandX($curXSupCode);
				}
			}
			
			$buff= _c_.$accessThrdGrp._c_.$this->postbutton('',$rFxPg,false);
			$buff.= $specRfButton.$theThreads;
			$fnlRes= $buff;
		}else{
			// On the main INSIDE A SPECIFIC THREAD
			$x= (int)$fAlgo->getRealX();
			if ($x===0){
				// no direct comment button, so only answer to available, so the originbal post of the thread stay first
				$fnlRes= $this->postbutton('',$rFxPg);
			}else{
				$shrdCd->splitRXpg($thrdIdx,$xIdx, $rFxPg);
				$mainIdx= $shrdCd->xPgUr($thrdIdx,'0');
				
				$masterXPg= $shrdCd->xCdPgNm($curPgN,$mainIdx);
				$mainPostId= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$masterXPg, _c_fXMainPostId);
				
				$mainTitle= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$mainPostId, _c_fumMessTtl);
				
				$url= $shrdCd->generalLinkFromPR($mainIdx,$mainPostId,$curPgN);
				$mainTitle= $caps->hL($url,$mainTitle,'fumMainPostTtl');
				$ttlToDspl= $shrdCd->postTitle($mainTitle,$mainPostId, $mainIdx,false,'firstInline');
				
				if ($shrdCd->correctlySignedIn()){
					
					if ($shrdCd->forumPageIsOpen()){
						// the test works only for the global no comment tag if the tag is placed inside individual sub-threads
						$lblOne= $glob->sl('Comment the main suject : ','kaoe');
					}else{
						$lblOne= '';
					}
					
					$fnlRes= _c_BrFlux.$ttlToDspl.$this->postbutton($lblOne,$rFxPg,true,'_4um_message_form');
				}else{
					$fnlRes= _c_BrFlux.$ttlToDspl.$this->postbutton('',$rFxPg);
				}
			}
		}
		return $fnlRes;
	} // tg_forumthreads	
	
		
	/**
		Computes and returns the full forum Posts and button structure
			Input :
				$lblOne : specific label for comments or forum
				$rFxPg : real forum X page.
				$fullButtons : true if we want all the buttons / false --> minimal set
				$defPg : default page
				$standardUser: staqndard user true or false!
				$urlsup : supplmentary url including commecting &  // only when $xCodeSup===''
				$js : supplem.javascript
			!! date, smily, trash etc, see forumShareCd::postTitle()
			
			>postbutton(
	*/
	function postbutton($lblOne, $rFxPg='', $fullButtons=true, $defPg='_4um_registration', $standardUser=true, $urlsup='', $js=''){
		$tagsFu= &$this->tagsFu;
		$rMg= &$tagsFu->rMg;
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
		$fAlgo= &$this->forumAlgo;
		
		
		$curPgN= $tools->curPageName();
		$noStop= !$shrdCd->stopped($curPgN);	// activeForumPg
		$shrdCd->getXCodeParams($xCodeIndx,$xCodeSup,$rFxPg); // $xCodeSup may be ==='' fine for min page!
		
		$commentButton= '';
		if ($noStop){
			$arCmd[_c_mothrPage]= _c_ko;
			$rootUrl= $tools->urlGivenPage($defPg,$arCmd);	// Got to define a url
			$leftImg= $caps->image(_c_EditorImgPath.'postButton.png','','leftImg');
			
			if ( $shrdCd->whateverX()===false && !$shrdCd->realForumState() ){
				$leftImg= _c_BrFlux.$leftImg;
			}
			
			// MAIN COMMENT URL 
			if ($xCodeSup===''){
				$xCodeSup= $urlsup;
			}
			
			$url= $rootUrl.$tools->addUrlVar(_c_fMotherPage,$curPgN).$xCodeSup;
			$supParam= $caps->matCss('fumStd').$js;
			$commentButton= _c_BrFlux.$leftImg;
			
			if ($shrdCd->forumPageIsOpen() && $defPg!==_c_ko){
				if ($standardUser){
					if ($lblOne!=='' && $shrdCd->correctlySignedIn()){
						$commentButton.= $caps->hLink($url, $lblOne, $supParam);
					}
				}else{
					$commentButton.= $caps->hLink($url, $lblOne, $supParam);
				}
			}else{
				$commentButton.= $caps->span($lblOne,'fumStd');
			}
		}			
			
		$scannedPosts= '';
		$nectStr= $shrdCd->getTagsTree($curPgN);
		$prsStrRem= $curPgN;
		
		if ($xCodeIndx===false){
			// For Comment header just below the full standard page--> Got to add the next X serie if it exists. (Don't need it for real forum)
			$supCode= '';
			$lastXIdMin= (int)$shrdCd->gostXCode()-1;
			$lastXNm= $shrdCd->xCodePgNm($curPgN,$lastXIdMin);
			if ($lastXIdMin>=0){
				$supCode= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$lastXNm, _c_fumXmlCode);
			}
			
			$nectStr.= $supCode;
			$prsStrRem.= _c_dbSep.$lastXNm;
		}else{
			$curXNm= $shrdCd->xCodePgNm($curPgN,$xCodeIndx,$rFxPg);
			$supTags= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$curXNm, _c_fXSupTags);	// reserved for admin
			if ($supTags!=='' && $supTags!==_c_ko){
				$scannedPosts= $parser->parseStdStr($supTags, _c_fumXmlId._c_dbSep.$curXNm);
			}
		}
		$scannedPosts.= $parser->parseStdStr($nectStr, $prsStrRem);	

		// Writes the bottom buttons switchers from
		if ($shrdCd->realForumState()){
			$xVal= $shrdCd->getRfxPage();
			$thrdId= $fAlgo->xUrlThreadId($xVal);
			$fullPgN= $curPgN.'-'.$thrdId;
			$freeIndex= $dtb->getElem(_c_fumXCdLim, _c_fumXLimId,$fullPgN, _c_fumXLimNb);
		}else{
			$freeIndex= $dtb->getElem(_c_forumPgRe, _c_fumRepId,$curPgN, _c_fumTreeFreeX);
		}
		
		if ($freeIndex===false){
			$freeIndex= 0;
		}

		$mess= '';
		if (!$shrdCd->inPostDailyLimit()){
			$pDL= $dtb->getGenVar('fPostDailyLimit');
			$mess.= _c_BrFlux;
			$mess.= $caps->span($glob->sl('You have reached your daily limit of ','kaof').$pDL.$glob->sl(' messages!','kaog')._c_sT, 'fumError');
		}
		
		$botSwtch= _c_BrFlux.$this->invBotSwitches($freeIndex)._c_BrFlux;
		if ($noStop){		
			if ($shrdCd->isSignedIn){
				$curXPgN= $shrdCd->xCodePgNm($curPgN);
				$gotChg= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$curXPgN, _c_fXGotChg);
				
				if ($gotChg!==_c_ko){					
					// Stores a size approximation of the visible page with stripped tags.
					$cpyScannedPosts= $scannedPosts;
					$cpyScannedPosts= strip_tags($cpyScannedPosts);
											
					$szScanPosts= strlen($cpyScannedPosts);
					$dtb->setElem(_c_fumXCode,  _c_fXParsedSz,$szScanPosts,  _c_fumXmlId,$curXPgN);
					$dtb->setElem(_c_fumXCode, _c_fXGotChg,_c_ko, _c_fumXmlId,$curXPgN);
				}
			}

			$specEdtButton= $this->specialForumLinks($freeIndex);
			if ($standardUser){
				if ($defPg==='_4um_registration'){
					$logReg= $shrdCd->loginDynLabel($defPg,$xCodeSup);
				}else{
					$logReg= $shrdCd->loginDynLabel($rootUrl,$xCodeSup);
				}
				
				if ($fullButtons){
					if ($shrdCd->whateverX()===false){
						$mainInfo= $mess.$specEdtButton.$commentButton.$logReg._c_BrFlux.$scannedPosts._c_BrFlux;
					}else{
						$mainInfo= $botSwtch.$mess.$specEdtButton.$commentButton.$logReg._c_BrFlux.$scannedPosts.$botSwtch._c_BrFlux;
					}
				}else{
					$mainInfo= $mess.$specEdtButton.$commentButton.$logReg._c_BrFlux.$scannedPosts._c_BrFlux;
				}
				
			}else{
				$mainInfo= $commentButton;
			}
		}else{
			$mess.= _c_BrFlux;
			if ($dtb->getGenVar('fumStop')===_c_ok){
				$mess.= $caps->span(_c_.$glob->sl('General information : comment activity is closed','kaoh')._c_sT, 'fumStd');
			}else{
				$mess.= $caps->span(_c_.$glob->sl('Comments for this article are closed!','kaoi')._c_sT, 'fumStd');
			}
			
			if ($standardUser){
				if ($fullButtons){
					$mainInfo= $botSwtch.$mess._c_BrFlux.$scannedPosts._c_BrFlux.$botSwtch._c_BrFlux;
				}else{
					$mainInfo= $mess._c_BrFlux.$scannedPosts._c_BrFlux;
				}
			}else{
				$mainInfo= $commentButton;
			}
		}
		
		return $shrdCd->persoWarning().$mainInfo;
	} // postbutton


	/**
		Special forum links
	*/
	function specialForumLinks($freeIndex){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;

		$mp= $tools->curPageName();
		$specEdtButton='';
		if ($fAlgo->wRights){
			$arCmd[_c_tedCurDtbTblNm]= _c_ko;
			$urlTE= $tools->urlGivenPage('_table_editor',$arCmd);
			$urlEL= $tools->urlGivenPage('_dtb_edit_line',$arCmd);
			
			$xPage= $tools->getVal(_c_rfxPage);
			
			if ( $shrdCd->realForumState() && $xPage===false ){
				$tblToDisp= _c_fumThreadList;
				$label= $glob->es('Edit Thread Group','kamw');
				$rfTbNb= $tools->getVal(_c_rfTGroupIdx);
				if ($rfTbNb!==false){
					$curIndex= $rfTbNb;
				}else{
					// Case when the index is not url specified, takes the last one.
					$freeGroupId= $dtb->getElem(_c_forumPgRe, _c_fumRepId,$mp, _c_fumFreeGroupT);
					$curIndex= $freeGroupId-1;
				}
			}else{
				$tblToDisp= _c_fumXCode;
				
				$xCodeIndx= $tools->getVal(_c_fxCodeIndx);
				if ($xPage===false){
					// not a full blown forum --> explicit comment case
					if ($xCodeIndx!==false){
						// Explicit comment thread index
						$label= $glob->es('Edit Unique Thread','kane');	// Unque thread of comments on an article
						$curIndex= $xCodeIndx;
					}else{
						// Implicit (don't have to display the link)
						$curIndex= _c_ko;
					}
				
				}else{
					// an explicit thread index $xPage for a full blown forum
					$label= $glob->es('Edit Current Thread','kand');	// full blown forum
					$curIndex= $xPage;
				}
			}
			
			if ($curIndex!==_c_ko){
				$url= $urlEL.$tools->addUrlVar(_c_tedCurDtbTblNm,$tblToDisp).
					$tools->addUrlVar(_c_tedCurDtbRowId,$mp.'-'.$curIndex).
					$tools->addUrlVar(_c_fReservedPgN,$mp);
					
				$attS= $caps->matCss('fumStds').$caps->matTtl($glob->es('Edit the square code','kanc'));
				$specEdtButton= $caps->hLink($url, $label, $attS, '_blank')._c_sT;
			}
			
			$url= $urlTE.$tools->addUrlVar(_c_tedCurDtbTblNm,_c_GenVarTbl);
			$url.= $tools->addUrlVar(_c_tedGvFilter,'forumCurrent');
			
			$label= $glob->es('General Forum Variables','kamy');
			$attS= $caps->matCss('fumStds').$caps->matTtl($glob->es('Edit the general','kanb'));
			$specEdtButton.= $caps->hLink($url, $label, $attS, '_blank')._c_sT;
			
			$x= $shrdCd->gostXCode();
			if ($x!==false){
				$url= $tools->urlGivenPage('_dtb_edit_line');
				if ($shrdCd->realForumState()){
					$x= $tools->getVal(_c_rfxPage);
					if ($x!==false){
						$xPgName= $shrdCd->xCdPgNm($mp,$x);
						$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,_c_fumXCode);
					}else{
						// no _c_rfxPage index so is on a thread group!
						$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,_c_fumThreadList);
						$threadGrougIdx= $tools->getVal(_c_rfTGroupIdx,'0');
						$xPgName= $shrdCd->xCdPgNm($mp,$threadGrougIdx);
					}
				}else{
					// just page comments
					$xPgName= $shrdCd->xCdPgNm($mp,$x);
					$url.= $tools->addUrlVar(_c_tedCurDtbTblNm,_c_fumXCode);
				}
				
				$url.= $tools->addUrlVar(_c_tedCurDtbRowId,$xPgName);
				$url.= $tools->addUrlVar(_c_snglEdtFieldName, _c_fXSupTags);
				
				$label= $glob->es('SEO : Edit','kamz');
				$attS= $caps->matCss('fumStds').$caps->matTtl($glob->es('Search Engine Optimization','kana'));
				$specEdtButton.= $caps->hLink($url, $label, $attS, '_blank')._c_sT;
			}
			
			$specEdtButton.= $this->chokingMessage($mp);
		}else{
			$specEdtButton.= $this->chokingMessage($mp);
		}
		
		if ($specEdtButton!==''){
			return $specEdtButton._c_BrFlux;
		}else{
			return '';
		}
	} // specialForumLinks


	/**
		Reservation message to express the temporary time consequent blockage of the concerned forum page.
	*/
	function chokingMessage($pg){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		
		if ( $shrdCd->xGLongBooked($pg) ){
			$visualResPgN= $dtb->getGenVar('fChokedPageN');		// Retrive the webmaster reserved PN (reserved for quick modification)
			$motherId= $tools->getVal(_c_fMotherPage);
		
			if ($fAlgo->wRights){
				$url= $tools->urlCurPg();
				$x= $shrdCd->gostXCode();
				$url.= $tools->addUrlVar(_c_fxCodeIndx,$x);
				$label= $glob->sl('Urgent : click here to allow new messages for the page ','kann').$visualResPgN;
				$attS= $caps->matCss('fumStdsBright').$caps->matTtl($glob->sl('New messages for ','kaoj').$visualResPgN.$glob->sl(' need to be accepted again!','kaok'));
				return $caps->hLink($url, $label, $attS);
			}else{
				$impvPostId= $tools->getVal(_c_fImprovePId);
				if ($impvPostId===false && $motherId===$visualResPgN && $shrdCd->fumLogUserId()!==_c_ko){
					// Standard mode / everybody logged message
					return $caps->span($glob->sl('New comments on ','kanp').$visualResPgN.$glob->sl(' are blocked for a few seconds...','kano'),'fumStdsBright');
				}else{
					return '';	// Public mode
				}
			}
		}
	} // chokingMessage

		
	/**
		Inversed bottom switches : is actually a numerical menu list at the top and bottom of the post presentation.
	*/
	function invBotSwitches($sz){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		$xRgt= &$this->xRgt;
		$fAlgo= &$this->forumAlgo;
		$gmArr= &$this->geomArray;		
		
		$bUrl= '';
		$mp= $tools->curPageName();
		$wRights= $rights->quickWMRight();
		$fumUsrId= $shrdCd->smartUserId();
			
		if ($shrdCd->subUsRegitrPg){
			return '';
		}
		
		if ($fumUsrId!==_c_userNoRight){
			$gotAPostPending= $dtb->elementExists(_c_fumSchedUsrId, $fumUsrId, _c_fumSchedTN); // True if the current user got a post pending
		}else{
			$gotAPostPending= false;
		}
		
		$thrdIdx= $fAlgo->currentThread();
		
		/**
			Test if it makes sense to display the access switches
		*/
		$curXPN= $shrdCd->curXCodePgNm($mp,'0', $thrdIdx);	// This access key should exists inside the table _c_fumXCode		
		if ( !$dtb->elementExists(_c_fumXmlId, $curXPN, _c_fumXCode) ){
			return '';
		}
			
		
		$bUrl.= $caps->span($glob->sl('All Posts : ','kbbs'),'fumStd');
		$bUrl.= $this->onlyTitlesButton();
				
		$limMenSz= $dtb->getGenVar('fFullNumMenuSz');	// limit numerical menu size 
		if ($sz<$limMenSz){
			// Arithmetic progression
			$maxI= $sz-1;
			for ($i=$maxI; $i>0; $i--){
				$xGroupId= $shrdCd->anyXPage($mp,$thrdIdx,$i);
				$visiblForAll= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$xGroupId, _c_fXVisiblAll);
				if ( $visiblForAll===_c_ok  ||  $wRights  ||  $gotAPostPending ){
					$bUrl.= $this->currentXPgLink($maxI,$thrdIdx,$i);
				}
			} // for
			
			$bUrl.= $this->currentXPgLink($maxI,$thrdIdx,$i,'');
		}else{
			// Geometric progression			
			$origCurPos= (int)$shrdCd->gostXCode();
			$geomV= $gmArr->contigToGeom(0,$sz-1,$origCurPos);
			
			$szGVMo= sizeof($geomV)-1;
			
			$maxI= $geomV[$szGVMo];
			for ($i=$szGVMo; $i>0; $i--){
				$j= $geomV[$i];
				
				$xGroupId= $shrdCd->anyXPage($mp,$thrdIdx,$j);
				$visiblForAll= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$xGroupId, _c_fXVisiblAll);
				if ( $visiblForAll===_c_ok  ||  $wRights  ||  $gotAPostPending ){
					// n currentXPgLink
					$bUrl.= $this->currentXPgLink($maxI,$thrdIdx,$j);
				}
			} // for
			
			$j= $geomV[$i];
			$bUrl.= $this->currentXPgLink($szGVMo,$thrdIdx,$j,'');
		}
		
		$urlShowId= $tools->urlForumPost();
		$urlShowId.= $tools->addUrlVar(_c_fumVsblPostId,_c_ok);
		$indicId= $caps->hL($urlShowId,'* ','ln', '_top', $glob->st('Shows the numerical ids of the Posts','fumShowNumIds') );
		return _c_BrFlux.$indicId.$bUrl;		
	} // invBotSwitches
	
	
	/**
		To manage the X links number changing elements.
	*/
	function currentXPgLink($maxI,$thrdIdx,$i,$sep=' - '){
		$shrdCd= &$this->shrdCd;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		
		$mp= $tools->curPageName();
		$curXPgN= $shrdCd->anyXPage($mp,$thrdIdx,$i);
		
		$xPageContext= $tools->getVal(_c_rfxPage)!==false;
		$xCdPN= $shrdCd->xCdPgNm($mp,$i);
		
		
		if ($dtb->elementExists(_c_fumXmlId,$curXPgN, _c_fumXCode)){
			$xCode= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$curXPgN, _c_fumXmlCode);
			$xCdSz= strlen($xCode);	// compared with 4 --> conventional minimum tag size
		}else{
			$xCdSz= -1;
		}
		
		if ($xCdSz>4 || $xPageContext){
			$x= (int)$shrdCd->gostXCode();
			if ($x===$i && ($tools->getVal(_c_fxCodeIndx)!==false || $xPageContext)){
				$font= 'fumStdIn';
			}else{
				$font= 'fumStd';
			}	
			
		}else{		
			// Normal, for example for real forum on the mother page without real forum url variable
			// --> looks for sdandard comments and could not find the page!
			$font= 'fumStdEmpty';
		}
		
		$url= $shrdCd->curPgAndXCodeUrl($i);
		
		$supT= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$curXPgN, _c_fXClickTtl);
		$supTtl= '';
		if ($supT!=='' && $supT!==false){
			$supTtl= ' : '.$supT;
		}
				
		if ($dtb->getGenVar('fumFrstPostIdxAtOne')===_c_ok){
			$iDspl= $i+1;
		}else{
			$iDspl= $i;
		}
		
		return $caps->cLinkTot($url, $iDspl.$supTtl, $font).$caps->span($sep,'fumStd');
	} // currentXPgLink


	/**
	*/
	function onlyTitlesButton(){
		$shrdCd= &$this->shrdCd;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		
		
		$xCodeIndx= $tools->getVal(_c_fxCodeIndx);
		$xPage= $tools->getVal(_c_rfxPage);
		
		$in= $xCodeIndx===false && $xPage===false;
		if ($in){
			$font= 'fumStdIn';
		}else{
			$font= 'fumStd';
		}	
		
		$url= $tools->urlCurPg();
		if ( $shrdCd->realForumState() ){
			$mpName= $tools->curPageName();
			$shrdCd->splitRXpg($threadIdx,$xIdx, $xPage);
			$threadGroupId= $mpName.'-'.$threadIdx;		// truncated $lastXNm to use as group thread Id
			$groupNb= $dtb->getElem(_c_fumThrdGrpAcsTN, _c_fThrdGrpAcsId,$threadGroupId, _c_fThrdGrpNb);
			$url.= $tools->addUrlVar(_c_rfTGroupIdx,$groupNb);
		}
		
		return $caps->cLinkTot($url, ' # ', $font);
	} // onlyTitlesButton
	

	/**
		To define the new registration string that appear with a javascript click.
	*/
	function tg_appearonclick(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		
		$nReg= $caps->hiddenWdg(_c_fcbNewReg,_c_ok)._c_R;	// To store the new registration string inside the widget (!Probably not most sbtle, but ok!)
		$nqBd= str_replace (_c_snglQ, _c_bkSlash._c_snglQ, $nReg.$bd);
		$nqBd= str_replace (_c_carRet, '', $nqBd);
		$nqBd= str_replace (_c_nL, '', $nqBd);
		$nqBd= str_replace (_c_rT, '', $nqBd);
		
		$js= 'forum.newRegistrationWdgt=\''.$nqBd.'\';'._c_R;
		$glob->setGlobJsCode($js);
		$name= $tools->binLoads($v['name'],'apOnClick');
		
		return $caps->sDiv(_c_Ns,' width:98%; border:0px solid red;',$name);	// 1% for each border
	} // tg_appearonclick
	
	
	/**
		Grouping previous tags concerned with a new registration :  so replaces tg_appearonclick etc.
		[fumRegistrationStr /]
	*/
	function tg_fumregistrationstr(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$fAlgo= &$this->forumAlgo;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
				
		if ($fAlgo->silentFumWidgets){
			return '';
		}
		
		
		$jsTest= $caps->div($glob->sl('If you can read this message ... JAVASCRIPT is disabled!','kbbl'),'userError','divForJsFumTest');
		$filler= '';	
		$jsSetHtml= $caps->jsSimpleFu('kk.setInnerHtml',2,0,$filler,'divForJsFumTest');
		$jsTest.= $caps->jsTag($jsSetHtml);
		
		$mess= $jsTest;
		if ( !$dtb->gotOkGenVar('publicPostsFPV') && $shrdCd->allowNewUserRegistrB() ){
			$mess.= $caps->hiddenWdg(_c_fcbNewReg, 'nop');
			return $mess;
		}
		
		
		$gCond= $dtb->getGenVar('fAgreementGenCond');		
		if ($gCond!==_c_ok){
			$mess.= $caps->span( $glob->sl('Please check the box if you need a new registration ','kbnh'), 'fumRegStr');
		}else{
			$mess.= $caps->span( $glob->sl('...and agree with our','kanu'), 'fumRegStr');
			$fgcPN= $dtb->getGenVar('fumGenConditionsPN');		
			$mess.= $caps->pageLink($glob->sl('general conditions','kanv'),$fgcPN,'fumRegStrLn','_blank');
		}
		
		$js= $caps->jsFunctCallStr('onclick','forum.regWgtDealer');
		$defVal= $tools->postVal(_c_fcbNewReg,_c_ko);
		
		$css= $caps->matCss('fumRegStr');
		$mess.= $caps->checkBox(_c_fcbNewReg, _c_ok, $defVal, $css.$js);
		return $mess;	
	} // tg_fumregistrationstr

	
	
	/**
		[simulatefumRegStr /] : Simulate [fumRegistrationStr /]
	*/
	function tg_simulatefumregstr(&$v,&$bd){
	} // tg_fumregistrationstr		
	
	

		
	/**
		Displays the title box for editing purpose.
	*/
	function tg_forumtitletbox(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$tagsFu= &$this->tagsFu;
		$fKern= &$this->fKern;
		$fAlgo= &$this->forumAlgo;
		$rights= &$this->rights;


		$onlyreg= $fAlgo->onlyRgister();
		if ($onlyreg===_c_ok){
			return '';
		}
		
		// Deal with the parent Post Id
		$parentId= $tools->gostVal(_c_fumUrlPostId,_c_ko);
		$hdParentId= $caps->hiddenWdg(_c_fumUrlPostId,$parentId)._c_R;
		
		$rpXCode= $shrdCd->gostXCode();	// real forum or post x code depending on context
		if ($tools->gostVal(_c_fxCodeIndx)!==false){
			// simple post case
			$bXCdIndx= $caps->hiddenWdg(_c_fxCodeIndx,$rpXCode)._c_R;
		}else{
			// real multi / threaded forum
			$bXCdIndx= $caps->hiddenWdg(_c_rfxPage,$rpXCode)._c_R;
		}
		
		$imprPId= $tools->gostVal(_c_fImprovePId, _c_ko);
		$imprPost= $caps->hiddenWdg(_c_fImprovePId,$imprPId)._c_R;	// otst
		
		
		$newThread= '';
		$newThrd= $tools->postVal(_c_rfNewThread,_c_ko);
		if ($newThrd!==_c_ko || $newThrd===_c_ko && $shrdCd->globCurNewThreadIdx!==_c_ko){
			if ($newThrd!==_c_ko){
				// keep it
			}else{
				$newThrd= $shrdCd->globCurNewThreadIdx;
			}
			$newThread= $caps->hiddenWdg(_c_rfNewThread,$newThrd)._c_R;
		}
		
		$curTtl= '';
		if ($imprPId!==_c_ko){
			$curTtl= $shrdCd->getTitle($imprPId);
		}
				
		$name= $v['name'];
		$content= $tools->postVal($name,$curTtl);
		
		// Add a space if the user got the bad idea to introduce an address index in the title ... so won't be change with the summary algorythme!
		$content= str_replace(_c_IndexFN.'?',_c_IndexFN.' ?',$content);
								
		// conditions
		$min= $fAlgo->positGV('fumMinTitleSz');	
		$max= $fAlgo->positGV('fumMaxTitleSz');

		if ($min===_c_ko){
			$errMess= '';
		}else{
			$errMess= $fKern->tbTaErrorMessage($content,$min,$max,$name,$v,true);
		}
		
		$lim= $dtb->getGenVar('fumUMgMaxTitleSz');
		$cls= $caps->matCss( $tools->binLoads($v['cls'],'largeFumTxtBox') );
		
		$box= $hdParentId._c_R.$bXCdIndx._c_R.$imprPost._c_R.$newThread._c_R;
		$box.= $caps->textBox($name, strip_tags($content), 'w', $cls, $lim);
		$box.= $errMess;
		
		return $caps->span($glob->sl('Message Title :', 'kaae'),'fumStd')._c_R.$box;
	} // tg_forumtitletbox
	
	/**
		Just displays the title of the body area box.
		[fumBodyFormTtl /]
	*/
	function tg_fumbodyformttl(&$v,&$bd){	
		$glob= &$this->glob;
		$caps= &$this->caps;
		return $caps->span($glob->sl('Message Body :', 'kaaf')._c_BrFlux,'fumStd');
	} // tg_fumbodyformttl

	
	/**
	*/
	function tg_forumessbox(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$tagsFu= &$this->tagsFu;
		$fKern= &$this->fKern;
		$fAlgo= &$this->forumAlgo;


		$onlyreg= $fAlgo->onlyRgister();		
		if ($onlyreg===_c_ok){
			return '';
		}

		$imprPId= $tools->getVal(_c_fImprovePId);
		$curMess= '';
		if ($imprPId!==false){
			$curMess= $shrdCd->getBody($imprPId);
		}

		$name= $v['name'];	
		$content= $tools->postVal($name,$curMess);
		
		$width= $tools->binLoads($v['width'],'99');
		$height= $tools->binLoads($v['height'],'16');
		
		$attS= $tools->binLoads($v['cls'],'formTA');
		
		// conditions
		$min= $fAlgo->positGV('fumMinBodySz');	
		$max= $fAlgo->positGV('fumMaxBodySz');
		
		
		$js= $caps->jsSimpleFu('forumBar.setScrollBarPos',1,0,_c_fMessageBodyTxtArNm).';'._c_R;
		$glob->setGlbEndJsCode($js);
		
		$errMess= $fKern->tbTaErrorMessage($content,$min,$max,$name,$v,false);
		
		if ($errMess!==''){
			$errMess= _c_R.$errMess._c_R;
		}
		
		$attS= $caps->matCss($attS);
		$lim= $dtb->getGenVar('fumMaxBodySz');
		$ta= $caps->textarea($name, $height, $width, strip_tags($content), $attS, false, $lim);
		return $errMess.$ta;
	} // tg_forumessbox
	
	
	/**
		Forum title handler.
		_c_fImprovePId
	*/
	function tg_forumtitlehandler(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		
		$mpName= $shrdCd->gostMotherPage();
		$xCode= $shrdCd->gostXCode();
		$rfState= $shrdCd->realForumState();
		$imprPId= $tools->gostVal(_c_fImprovePId);
		
		$okToWr= $shrdCd->usrAllowedToWrite();
		$bog= $glob->sl('Back on the general display!','kaol');
		if ($imprPId===false){
			// NEW MESSAGE
			$url= $shrdCd->curPgAndXCodeUrl($xCode,false,$mpName);
			if ($okToWr){
				if ($rfState){
					$lbl= $glob->sl('To post a new message','kaom');	// implicit convention real forum --> message
				}else{
					$lbl= $glob->sl('To post a new comment','kaon');	// post to article only --> comment
				}
			}else{
				$lbl= $glob->sl('Warning unauthorized access...','kmhz');
			}
			
			$lbl= $caps->span($lbl,'fumBigStd');
			
		}else{
			// IMPROVING ALREADY CREATED MESSAGE			
			$newThreadStep= $tools->getVal(_c_rfNewThread)!==false;
			if ($rfState && $newThreadStep){
				// simplification, always come back on the last thread position (default) of the mother page
				$pageId= $tools->getVal(_c_fMotherPage);
				$url= $tools->urlGivenPage($pageId);
			}else{
				$imprPId= $tools->gostVal(_c_fImprovePId);	// current post id, during improvement.
				if ($imprPId===false || $imprPId===_c_ko){	// could test only one !!!
					$imprPId= $glob->lastCreatedPostIndx;
				}
				
				$xCode= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$imprPId, _c_fumXIndx);
				if ($xCode===false){
					$xCode= $shrdCd->whateverX();
				}				
				
				$url= $shrdCd->curPgAndXCodeUrl($xCode,$imprPId,$mpName);
			}
			
			$lbl= '';
			
			if ($okToWr){
				$lbl.= $caps->span($glob->sl('Improve the message ...', 'kaag'),'fumBigStd');
			}else{
				$lbl.= $caps->span($glob->sl('Warning unauthorized access...', 'kmhz'),'fumBigStd');
			}
			
			$lbl.= $shrdCd->globUsrMess;
		}
		
		return $this->backButton($url,$bog).$lbl;
	} // tg_forumtitlehandler
	
	
	/**
		[forumMessBoxes /] A tag to execute the content of the table record idCode::forumMessBoxes
	*/
	function tg_forummessboxes(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$rMg= &$tagsFu->rMg;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$shrdCd= &$this->shrdCd;
		
		
		$logUsrId= $shrdCd->fumLogUserId();
		
		$answerToPostId= $tools->gostVal(_c_fumUrlPostId,_c_ko);
		$answUsrId= $shrdCd->postUserId($answerToPostId);
		
		$improvPostId= $tools->gostVal(_c_fImprovePId,_c_ko);
		$imprUsrId= $shrdCd->postUserId($improvPostId);
		
		if ($rMg->quickWMRight()){
			// If the webmaster want to interfer .. still got to accept it with the scheduler!
			$val= $dtb->getElem(_c_idCodeTbl, _c_ictId,'forumMessBoxes', _c_ictCode);
			return $tagsFu->expandX($val);
		}else{
			if ($logUsrId===_c_userNoRight){
				return $glob->sl('Sorry you are not connected anymore for this forum action, please sign in again.','kmga');
				
			// Remark : the following messages only trigger if the user tinker with the url post Ids 
			}else if ($answUsrId===$logUsrId){
				return $glob->sl('Sorry you can\'t answer to your own post','kmgb');
			}else if ( $answerToPostId!==_c_ko && !$shrdCd->postExists($answerToPostId) ){
				return $glob->sl('Sorry you can only answer to an existing post','kmgc');
			}else if ($imprUsrId!==$logUsrId && $improvPostId!==_c_ko){
				return $glob->sl('Sorry you don\'t have the rights to change this post.','kmgd');
			}else{
				$val= $dtb->getElem(_c_idCodeTbl, _c_ictId,'forumMessBoxes', _c_ictCode); // also [incl ref="_forumBar" /]
				return $tagsFu->expandX($val);
			}
		}
		
	} // tg_forummessboxes
	
	
	/**
		Uses only the header of the page for xCodeIndx-ed posts.
		And uses $v['title'] if given to link on the main page and eventualy $bd
		[pageSubstitutor][/pageSubstitutor]
	*/
	function tg_pagesubstitutor(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$parser= &$this->parser;
		$tagsFu= &$this->tagsFu;
		$fAlgo= &$this->forumAlgo;
					
		$xIndx= $tools->getVal(_c_fxCodeIndx);
		if ($xIndx===false){
			// keep going for the full display
		}else{
			// xCodeIndx is specified, so summarizes the pages with a title or full body link
			$buff= '';
			$title= $v['title'];
			if ($title!==false){
				$cls= $tools->binLoads($v['cls'],'fumStd');
				$url= $tools->urlCurPg();
				$buff.= $caps->linkC($url,$title,$cls);
			}
			
			$buff.= $bd;
			$buff.= $this->commentManager();
						
			// Need to be right at the end otherwise the parsing of postbutton() restart the old s topped parsing!!
			$parser->stopParser();
			return $buff;
		}
	} // tg_pagesubstitutor

	
	/**
		Checking different user parameter with a proper hash.	[forumCheckUser /]
	*/
	function tg_forumcheckuser(&$v,&$bd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		
		$action= $tools->getVal(_c_fMailConfAction);
		$userId= $tools->getVal(_c_fMailConfUserId);
		$postId= $tools->getVal(_c_fMailConfPostId);
		$postX= $tools->getVal(_c_fumXIndx);
		$gHash= $tools->getVal(_c_fMailConfHash);		
		
		$messHashError= $caps->span($glob->sl('Sorry, the hash is not correct!','kaoo'),'fumStd');
		$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);
		switch ($action){
			case 'checkEmail':
				$hash= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fHashConf);				
				if ($gHash===$hash){
					$url= $tools->urlDefaultPg();
					$mess= $caps->linkC($url,$glob->sl('Congratulation, your e-mail has been checked','kaop'),'fumStd');
					$dtb->setElem(_c_fsmplUsersTbl, _c_fUserMok,_c_ok, _c_fUserId,$userId);
				}else{
					$mess= $messHashError;
				}
			break;			
			
			case 'makeVisible':
				if ($gHash===$postRec[_c_fumXDump]){
					$xCdPgN= $postRec[_c_fumXIndx];
					$mpName= $postRec[_c_fumMotherId];
					$jumpUrl= _c_siteUrlAccess.$shrdCd->curPgAndXCodeUrl($xCdPgN,$postId,$mpName);
					$mess= $caps->hLink($jumpUrl,$glob->el('The post is now visible, please click here to see it!','kaoq'), $caps->matCss('fumStd') );
					$dtb->setElem(_c_forumPostsTbl, _c_fumOkPost,_c_ok, _c_fumPostId,$postId);
					$shrdCd->acknowVisibilityForAll($postId);
				}else{
					$mess= $messHashError;
				}
			break;
			
			case 'activMailTrig':
				if ($gHash===$postRec[_c_fumXDump]){
					// inititialises again the flag to ko, like if no improvment where ever done, so can check again
					$dtb->setElem(_c_forumPostsTbl, _c_fGotFreeImprove,_c_ko, _c_fumPostId,$postId);
					$mess= $caps->span($glob->el('The post is mail-reactive again concerning further modifications by its owner','kaor'),'fumStd');
				}else{
					$mess= $messHashError;
				}
			break;
			
			case 'seeHiddenModif':				
				$mess= $this->actualAndNewPosts($postRec);
			break;
			
			case 'acceptHiddenModif':
				$url= _c_siteUrlAccess.$shrdCd->postPrivToPublicUrl($postId,$postX);
				$url.= $tools->addUrlVar('prToPuHashAction', _c_ok).
				$url.= $tools->addUrlVar(_c_fMailConfHash, $gHash);
				
				$mess= $caps->hLink($url,$glob->el('Accept the Queued Modifications!','kaos'), $caps->matCss('fumStd') );
				$mess.= $this->actualAndNewPosts($postRec);
				
				if ($gHash===$postRec[_c_fumXDump]){
					$shrdCd->coreTransPrToPub($postId);
				}else{
					$mess.= _c_._c_.$messHashError;
				}
			break;
						
			default:;
				$mess= $caps->span($glob->sl('This page is used for different sort of checking!','kaot'),'fumStd');
		} // switch
		
		return _c_Br._c_Br._c_Br.$mess;
	} // tg_forumcheckuser

	/**
		Give back a formatted message string for actual and new post.
	*/
	function actualAndNewPosts(&$postRec){
		$caps= &$this->caps;

		$mess= '';
		$mess.= _c_._c_._c_._c_;
		$mess.= $caps->span('Actual :'._c_, 'fumStd');
		$mess.= $postRec[_c_fumMessTtl];
		$mess.= _c_._c_;
		$mess.= $postRec[_c_fumMessBody];

		$mess.= _c_._c_._c_._c_;
		$mess.= $caps->span('New :'._c_, 'fumStd');
		$mess.= $postRec[_c_fumMssTtl];
		$mess.= _c_._c_;
		$mess.= $postRec[_c_fumMssBdy];
		
		return $mess;
	} // actualAndNewPosts


	
	/**
		Real forum supplement
	*/
		
	/**
		To show the thread header on the threads list page, from a real post.
		[threadTitle postId="" /]
		
		Each link point on a specific X code page of name :
			motherpage-firstpostIndex-threadIndex created with the firtst thread post.
	*/
	function tg_threadtitle(&$v,&$bd){	
		$tagsFu= &$this->tagsFu;
		$shrdCd= &$this->shrdCd;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
	
		$xPageIdx= $tools->binLoads($v['xpage'],_c_ko);
		
		// Extract the last X suffix within table _c_fumXCdLim
		$thrdIdx= $shrdCd->threadIdxFromRXpg($xPageIdx);
		$condFVl= $tools->curPageName().'-'.$thrdIdx;
		$lastXSffx= $dtb->getElem(_c_fumXCdLim, _c_fumXLimId, $condFVl, _c_fumXLimNb); // free one
		$lastXSffx= (int)$lastXSffx - 1;
		
		
		// When not logged as webmaster or as forum user must make sure $lastXSffx content  is visible if not take previous one!
		// could Xpetal-solve the concerned _c_fumXCode and take the previous $lastXSffx if empty, or computer-faster!! Extract concerne post Ids and look for authorization to display
		// -------> Xpetal-solve 1st ... faster to program!! if not allow to display much faster to solve!!!
		
		$xPageIdx= $thrdIdx.'-'.$lastXSffx;
		
		$trialXAccess= $tools->curPageName().'-'.$xPageIdx;
		$xmlCode= $dtb->getElem(_c_fumXCode, _c_fumXmlId, $trialXAccess, _c_fumXmlCode);	// _c_fXParsedSz not an option bec. always updated
		
		$xSzTxt= trim($tagsFu->expandX($xmlCode));
		$xTxtSz= strlen($xSzTxt);
		if ($xTxtSz===0 && (int)$lastXSffx>0){
			// Only check the last level, so a large _c_fumXCode storage with a reasonable uèdating rate is advised
			$lastXSffx= (int)$lastXSffx - 1;
			$xPageIdx= $thrdIdx.'-'.$lastXSffx;
		}
		
		$postId= $tools->binLoads($v['postid'],_c_ko);
		$curTtl= $shrdCd->getTitle($postId,true);
		if ($tools->noDisplay($curTtl)){
			return '';
		}
		
		$xUrl= $tools->urlCurPg();
		$xUrl.= $tools->addUrlVar(_c_rfxPage,$xPageIdx);
		
		$shrdCd->splitRfXpg($mp,$threadIdx,$xIdx,$xPageIdx);		
		$activeTtl= $caps->cLinkTot($xUrl, $curTtl, 'fumPostTtl');
		
		return $shrdCd->postTitle($activeTtl,$postId)._c_BrFlux;
	} // tg_threadtitle
	

	/**
		Inverse Thread Groups switches.
	*/
	function invTGSwitches($lastGIdx){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;
		$gmArr= &$this->geomArray;		
			
		$pg= $tools->curPageName();
		$sz= (int)$fAlgo->lastTgFreeIdx($pg);
		if ($sz>0){	
			$thrdIdx= (int)$fAlgo->getTGIdx($lastGIdx);	// current thread group index, coukd have defalt $sz-1 === $lastGIdx by definition
			$bUrl= $caps->span(_c_BrFlux.$glob->sl('Thread Groups : ','kamv'),'fumStd');

			$geomV= $gmArr->contigToGeom(0,$sz-1,$thrdIdx);
			$sz= sizeof($geomV);
			
			for ($i=$sz-1; $i>0; $i--){
				$bUrl.= $this->currentTGLink($thrdIdx,$geomV[$i]);
			} // for
			
			$bUrl.= $this->currentTGLink($thrdIdx,$geomV[$i],'');
			return $bUrl;
		}else{
			return '';
		}
	} // invTGSwitches


	/**
		Returns the link of the current thread group.
	*/
	function currentTGLink($thrdIdx,$i,$sep=' - '){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$fAlgo= &$this->forumAlgo;

		if ($thrdIdx===$i){
			$font= 'fumStdIn';
		}else{
			$font= 'fumStd';
		}	
		
		$url= $tools->urlCurPg().$fAlgo->urlTGIdx($i);
		
		if ($dtb->getGenVar('fumFrstPostIdxAtOne')===_c_ok){
			$iDspl= $i+1;
		}else{
			$iDspl= $i;
		}
		
		return $caps->cLinkTot($url, $iDspl, $font) . $caps->span($sep,'fumStd');
	} // currentTGLink
	
	/**
		[placeFiller /]
		Returns a <div> ...  </div> filler that can have some information forced into.
	*/
	function tg_placefiller(&$v,&$bd){	
		$caps= &$this->caps;
		return $caps->sDiv('',' width:100%; border:0px dashed blue;',_c_fFillerDivName);
	} // tg_placefiller

	
	/**
		[lastPostSummary /]
		Summary of last posts for the whole forum (_c_forumPostsTbl) so comments and real posts.
	*/
	function tg_lastpostsummary(&$v,&$bd){	
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rights= &$this->rights;

		if ($rights->quickWMRight()){
			$url= $tools->urlCurPg();
			$url.= $tools->addUrlVar(_c_fumFrcSumryCalc,_c_ok);
			$imgDFn= _c_EditorImgPath.'check.png';
			$forceCompImg= $caps->linkImg($imgDFn,$glob->el('Force the summary computation and storage!','kaou'),$url);
			$spacer= _c_Ns;
		}else{
			$forceCompImg= '';
			$spacer= '';
		}
		
		$computeAndStore= $tools->getVAl(_c_fumFrcSumryCalc);
		if ($computeAndStore===_c_ok || $shrdCd->timeToSaveSumry()){
			// manual saving or automatic saving
			$smryStr= $shrdCd->summarySaving();
		}else{
			// retrive it if different from '' otherwise conmpute it!
			$curLg= $shrdCd->currentPageLg();
			$smryStr= $dtb->getGenVar(_c_fumSumryPrfx.$curLg);
			
			if ($smryStr===''){
				$smryStr= $shrdCd->summarySaving();
			}
		}
		
		if ($rights->wRights){
			// Add the missing _c_urlUniqEdtPfx (full blown string replace much faster/easier than recalculation or special savings each time!
			$search= _c_IndexFN.'?';
			$replace= $search.$tools->uniqEdtPrfxVarEqVal()._c_Amp;
			$smryStr= str_replace($search,$replace,$smryStr);
		}
	
		$mainTitle= $forceCompImg.$caps->span($spacer.$glob->sl('Summary of last posts:','kaov'),'fumMainPostTtl')._c_;
		return $mainTitle.$caps->sDiv($smryStr,'margin-left:30px');
	} // tg_lastpostsummary

	
	/**
		Register Login User label
		[regLogUserLbl /]
	*/
	function tg_regloguserlbl(&$v,&$bd){	
		$glob= &$this->glob;
		$caps= &$this->caps;
		return _c_BrFlux.$caps->div( $glob->sl('User name :','kans'), _c_defLblCls );
	} // tg_regloguserlbl
	
	/**
		Register Login Password label
		[reglogPwLbl /]
	*/
	function tg_reglogpwlbl(&$v,&$bd){	
		$glob= &$this->glob;
		$caps= &$this->caps;
		return $caps->div( $glob->sl('Password:','kant'), _c_defLblCls );
	} // tg_reglogpwlbl
	
	
	/**
		For comments : display the content only when _c_fxCodeIndx is not url activated, so the main page text is not repeated
		when people look for comments! As a mesure of economy [code] preservation tags are added and the code is computed
		only if necessary (no _c_fxCodeIndx).
	*/
	function tg_parseonlyfrontpage(&$v,&$bd){	
		$tools= &$this->tools;

		$cd= $tools->getVal(_c_fxCodeIndx);
		if ($cd===false){
			return $bd;
		}else{
			return '';	// do not return anything
		}
	} // tg_parseonlyfrontpage

	
	/**
		To define some practical title going well with the sent emails..
	*/
	function tg_infowebmaster(&$v,&$bd){
		$caps= &$this->caps;

		$infoWebmaster= $v['title'];
		$main= $v['main'];
		
		$buff= $caps->hiddenWdg('infoWebmasterTtl',$infoWebmaster);
		$buff.= $caps->hiddenWdg('infoWebmasterMain',$main);
		
		return $buff;
	} // tg_infowebmaster
	
	
	/**
		[informedOnMyPost /] A tag to choose to be informed (if the given email was verified) about answers received to ones post.
	*/
	function tg_informedonmypost(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		
		$userId= $shrdCd->fumLogUserId();
		$mailOk= $shrdCd->mailIsOk($userId);
		
		if ($mailOk){
			$ret= $tagsFu->expand('[mChkBox ret="ok" name="emailWatcher" prfx="check here" pfxTrad="kmdf" sffx="be informed" sfxtrad="kmdg" br="1" /]');
		}else{
			$ret= _c_BrFlux.$glob->sl('choose to be informed...','kmex')._c_BrFlux;
		}
		return $ret;
	} // tg_informedonmypost
	
		
} // forum
?>
