<?php
/**
	File name : forumMail.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To regroup all the mail function of the forum
*/
class forumMail extends oTop{


	function __construct(&$shrdCd,&$tagsFu){
		parent::__construct();
		
		$this->shrdCd= &$shrdCd;
		$this->tagsFu= &$tagsFu;
		
		$this->glob= &$tagsFu->glob;
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->fls= &$tagsFu->fls;
		
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
		
		$this->dtb= &$tagsFu->dtb;	
		$dtb= &$this->dtb;
			
		$this->rights= &$tagsFu->rights;
		$rights= &$this->rights;

		$this->hPwC= &$tagsFu->hPwC;
		
		define('_c_fumMailConfirmPgN', '_forumConfirmation');
	} // construct


	/**
		Send a confirmation email to the new user.
	*/
	function eMailVerification($emailTo,$userId,$pseudo,$hashConf){
		$glob= &$this->glob;
		$shrdCd= &$this->shrdCd;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			/* Does not send forum emails from a connected webmaster. It avoids redondancy (allowing a modification,
			   then receiving the notification by mail etc.). Only exception would be a message like "Congratulation
			   your message was manually accepted", but doesn't get into extreme congratulation. */
			return;
		}
		
		$fumNm= $dtb->getGenVar('fumName');
		
		$mailSubject= $glob->s('Forum ','katc').$fumNm.$glob->s(' Registration for ','katd').$pseudo;
		
		$mailBody= '';
		$mailBody.= '------------------------------------------------------------'._c_;
		$mailBody.= $mailSubject._c_;
		$mailBody.= $glob->s('The purpose of this eMail is to confirm a forum registration,','kate')._c_.
			$glob->s('if it was send by mistake, please ignore it.','katf')._c_;
				
		$url= $this->forumConfBaseUrl().
			$tools->addUrlVar(_c_fMailConfAction,'checkEmail').$tools->addUrlVar(_c_fMailConfUserId,$userId).$tools->addUrlVar(_c_fMailConfHash,$hashConf);
		$link= $caps->hLink($url,$glob->s('Please click here to double check your eMail address!','katg'));	
		$mailBody.= $link._c_;
						
		$mailBody.= '------------------------------------------------------------'._c_._c_._c_;
		$mailBody.= $tools->postVal(_c_fMessageBodyTxtArNm);
		
		$titleFrom= $glob->s('Forum E-Mail Checker','kath');
		$emailFrom= $dtb->getGenVar('fumEMailFrom');
		$shrdCd->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom);
	} // eMailVerification

	/**
		Gives the forum confirmation base Url
	*/
	function forumConfBaseUrl(){
		$tools= &$this->tools;
		$fls= &$this->fls;
		return _c_domAndUrlAccess.$tools->urlGivenPage(_c_fumMailConfirmPgN,false,false);
	} // forumConfBaseUrl
					

	/**
		Warn a user for a new answer.
	*/
	function gotAnAnswer($emailTo,$pseudo, $mpName,$xCdPgN,$cpIndx){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			return;
		}
		
		$fumNm= $dtb->getGenVar('fumName');
		$mailSubject= $glob->s('Dear','kbml').' '.$pseudo.', '.$glob->s('you got an answer from the forum','kbmm').' '.$fumNm;
		
		$mailBody= _c_._c_;
		$urlCommandAr['justsrf']= _c_ok;	// to suppress the edit attribute !!
		$verifUrl= _c_domAndUrlAccess.$shrdCd->curPgAndXCodeUrl($xCdPgN,$cpIndx,$mpName,$urlCommandAr);	// usrl for answer verification
		
		$link= $caps->hLink($verifUrl, $glob->s('Please click here to see the answer to your post.','kbmo') );	
		$mailBody.= $link._c_;

		$mailBody.= $tools->postVal(_c_fMessageBodyTxtArNm);

		$titleFrom= $glob->s('Forum ','katc');	// Longer names tend to trigger the spam watcher !!!
		$emailFrom= $dtb->getGenVar('fumEMailFrom');

		$shrdCd->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom);
	} // gotAnAnswer
	
			
	/**
		Warn the webmaster because we got a new post and give the possibility to acknowledge the post just with a click.
		
			Input :
				$cpIndx : current post id.
				$allowed :  if true --> already visible. don't need the clicked authorisation!
	*/
	function newPostIsIn($cpIndx,$allowed){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			return;
		}
		
		$cpRecord= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$cpIndx);	// current post record
		$userId= $cpRecord[_c_fumFUserId];
		$hash= $cpRecord[_c_fumXDump];
		
		
		$usrRecord= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);	// current user record
		$pseudo= $usrRecord[_c_fUserPseudo];
		

		$fumNm= $dtb->getGenVar('fumName');
		$mailSubject= $glob->s('Forum ','katc').$fumNm.$glob->s(' a post is in from ','kmfb').$pseudo;
		
		
		$mailBody= _c_._c_;
		if (!$allowed){
			$mailBody.= $glob->s('Click the following link to allow the current post to appear :','kmfa')._c_;
						
			$url= $this->forumConfBaseUrl().
				$tools->addUrlVar(_c_fMailConfAction,'makeVisible').
				$tools->addUrlVar(_c_fMailConfPostId,$cpIndx).
				$tools->addUrlVar(_c_fMailConfHash,$hash);

			$link= $caps->hLink($url,$glob->s('To allow the current post to appear','kmfc'));
			$mailBody.= $link;										
		}else{
			$mailBody.= $glob->s('The post was accepted by default.','kmfd');
		}
			
		$mailBody.= _c_._c_;
		$mailBody.= $cpRecord[_c_fumMessTtl];
		$mailBody.= _c_._c_;
		$mailBody.= $cpRecord[_c_fumMessBody];
		$mailBody.= _c_._c_._c_;
						
		$titleFrom= $glob->s('Forum ','katc');	// Longer names tend to trigger the spam watcher !!!
		$emailFrom= $dtb->getGenVar('fumMasterEMail');
		$emailTo= $emailFrom;
		
		$shrdCd->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom,false);
	} // newPostIsIn
	
	
	function newUserIsIn($userId){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			return;
		}
		
		$usrRecord= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);	// current user record
		$pseudo= $usrRecord[_c_fUserPseudo];

		$fumNm= $dtb->getGenVar('fumName');
		$mailSubject= $glob->s('Forum ','katc').$fumNm.$glob->s(' the new user ','kmfe').$pseudo.$glob->s(' got registered!','kmff');
		
		$mailBody= _c_._c_;
		$mailBody.= $glob->s('pseudo : ','kmfg').$pseudo;
		$mailBody= _c_._c_;
		$mailBody.= 'id : '.$userId;
		$mailBody.= _c_._c_;

		$titleFrom= $glob->s('Forum ','katc');	// Longer names tend to trigger the spam watcher !!!
		$emailFrom= $dtb->getGenVar('fumMasterEMail');
		$emailTo= $emailFrom;
		
		$shrdCd->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom,false);
	} // newUserIsIn	
	

	/**
		Warn the webmaster that a free update was done.
	*/
	function warnOnFreeUpdate($cpIndx,$mode){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			return;
		}
						
		$cpRecord= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$cpIndx);	// current post record
		$userId= $cpRecord[_c_fumFUserId];
		$hash= $cpRecord[_c_fumXDump];
		$mpName= $cpRecord[_c_fumMotherId];
		$xIndx= $cpRecord[_c_fumXIndx];
		
		$usrRecord= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);	// current user record
		$pseudo= $usrRecord[_c_fUserPseudo];
		

		$fumNm= $dtb->getGenVar('fumName');
		$mailSubject= $glob->s('Forum ','katc').$fumNm.$glob->s(' a FREE UPDATE to check from ','kmfh').$pseudo;
		
		$mailBody= _c_._c_;
		
		/**
		*/
		if ($mode==='inTimeSpan'){
			$mailBody.= $glob->s('Click the following link to see the actual update :','kmfi')._c_;
			$url= _c_domAndUrlAccess.$shrdCd->curPgAndXCodeUrl($xIndx,$cpIndx,$mpName);	// url for answer verification
			$link= $caps->hLink($url,$glob->s('See actual FREE UPDATE','kmfj'));	
			$mailBody.= $link;			
			$mailBody.= _c_._c_;
		}
		
		$mailBody.= $glob->s('Click the following link to activate again the mail-trigger :','kmfk')._c_;
		$url= $this->forumConfBaseUrl().
			$tools->addUrlVar(_c_fMailConfAction,'activMailTrig').
			$tools->addUrlVar(_c_fMailConfPostId,$cpIndx).
			$tools->addUrlVar(_c_fMailConfHash,$hash);
		$link= $caps->hLink($url,$glob->s('Activate Mail-trigger','kmfm'));	
		$mailBody.= $link;			
		$mailBody.= _c_._c_;
		
		/**
		*/
		if ($mode==='outOfTimeSpan'){
			$mailBody.= $glob->s('Click the following link to see the hidden post modifications :','kmfl')._c_;
			$url= $this->forumConfBaseUrl().
				$tools->addUrlVar(_c_fMailConfAction,'seeHiddenModif').
				$tools->addUrlVar(_c_fMailConfPostId,$cpIndx);
				$tools->addUrlVar(_c_fMailConfHash,$hash);
			$link= $caps->hLink($url, $glob->s('See the Hidden Post','kmfl') );	
			$mailBody.= $link;			
			$mailBody.= _c_._c_;
			
			
			$mailBody.= $glob->s('Click the following link to publish the modifications :','kmfn')._c_;
			$url= $this->forumConfBaseUrl().
				$tools->addUrlVar(_c_fMailConfAction,'acceptHiddenModif').
				$tools->addUrlVar(_c_fMailConfPostId,$cpIndx).
				$tools->addUrlVar(_c_fMailConfHash,$hash);
			$link= $caps->hLink($url, $glob->s('ACCEPT the hidden modifications','kmfo') );	
			$mailBody.= $link;			
			$mailBody.= _c_._c_;
		}
		
		
		$mailBody.= _c_._c_;
		$mailBody.= $cpRecord[_c_fumMessTtl];
		$mailBody.= _c_._c_;
		$mailBody.= $cpRecord[_c_fumMessBody];
		$mailBody.= _c_._c_._c_;
						
		$titleFrom= $glob->s('Forum ','katc');	// Longer names tend to trigger the spam watcher !!!
		$emailFrom= $dtb->getGenVar('fumMasterEMail');
		$emailTo= $emailFrom;
		
		$shrdCd->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom,false);
	} // warnOnFreeUpdate

	/**
		Give  the concerned user his new password..
	*/
	function transmitNewPW($emailTo,$pseudo,$newPassword){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($rights->quickWMRight()){
			return;
		}
		
		$fumNm= $dtb->getGenVar('fumName');
		$mailSubject= $glob->s('Dear','kbml').' '.$pseudo.$glob->s(', a new password has been calculated...','kmfp');
		
		$mailBody= _c_._c_;
		$mailBody.= _c_._c_;
		$mailBody.= $glob->s('your new password is : ','kmfq').$newPassword;
		$mailBody.= _c_._c_;
		
		/*
			No link, so someone falling on the email does not know where to use it
		*/

		$mailBody.= $tools->postVal(_c_fMessageBodyTxtArNm);

		$titleFrom= $glob->s('Forum ','katc');	// Longer names tend to trigger the spam watcher !!!
		$emailFrom= $dtb->getGenVar('fumEMailFrom');
		$shrdCd->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom,false);
	} // transmitNewPW
				
} // forumMail
?>
