<?php
/**
	File name : forumShareCd.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Shared code to regroup different forum functions often used here and there.
	
	Cache managing/deleting : function setContextAttributes($postId)
*/
include _c_toDeclPlugCntr.'forum/fumShrdCdLgt.php';

class forumShareCd extends fumShrdCdLgt{
	
	function __construct(&$tagsFu,&$imgP){
		parent::__construct($tagsFu,$imgP);
		
		$this->tools= &$tagsFu->tools;		
		$this->rights= &$tagsFu->rights;

		$this->cacheR= &$tagsFu->cacheR;
		$this->cacheWr= &$tagsFu->cacheWr;		
		
		include _c_toDeclPlugExt.'forum/forumMail.php';
		$this->forumMail= new forumMail($this,$tagsFu);
	} // construct
	
	
	/**
	*/
	function usrAllowedToWrite($usrId=false){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;

		if ($usrId===false){
			$usrId= $this->fumLogUserId();
		}
		
		$concernedPg= $tools->gostVal(_c_fMotherPage);	
		if ($concernedPg===false){
			$concernedPg= $tools->curPageName();
		}
		
		$mirId= 'usrList_'.$concernedPg;	// "mirror" or unique Id
		$mirList= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$mirId, _c_idTextTxt);
		$listAr= $tools->trimStrToV($mirList);
		if ($listAr===false){
			return true;	// no list --> no interdiction so the logged user can post!
		}
		
		return in_array($usrId,$listAr) || $rights->quickWMRight();
	} // usrAllowedToWrite
	
	
		
	/* -------------------------------------------------------------------------------
		Starts the broad forum share code, in fact when called from forumUsrMg, only
		useful for forumUsrMg::
	*/
	
	/**
		To display a post out of any context (free, got an empty $bd)
	*/
	function freePost($postId){
		$v['id']= $postId;
		$v['frame']= _c_ko;
		$bd= '';
		return $this->forumPost($v,$bd);
	} // freePost
	

	/**
		Straight display of the post and its title.
		Tag to be imbricated inside the nect part of the main page. Just does the display!
		Rem : works in synergy with forumAlgo::addANewForumTag()
				
		Example :
			Note : 
				- Correct indentation done at insertion time, using local tabs.
			
			Algo :
				- First insert ahead or intail from global comment button
				- Then insert inbetween from comment answering button. 		
	*/
	function forumPost(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$parser= &$this->parser;
		$rights= &$this->rights;
		$xRgt= &$this->xRgt;
		
		
		$wRights= $rights->wRights;
		$postId= $v['id'];
		$menCatg= $tools->getVal(_c_tMenCateg);		// just for the possible wall!

		if (array_key_exists('imgTags',$tagsFu->automClasses)){
			$imgTags= $tagsFu->automClasses['imgTags'];
			$imgTags->resetImagePath();
		}
		
		$curTtl= $this->getTitle($postId,true);		// TITLE
		if ($curTtl===false){
			return '';	// message still not accepted, don't display anything!!
		}
		
		$capsId= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId, _c_fumCapsId);
		$rfState= $this->realForumState();
		if ($rfState){
			$xIndx1= $this->gostXCode();
		}else{
			$xIndx1= $tools->getVal(_c_fxCodeIndx);	// Don't use gostXCode() because we need a false returned value when _c_fxCodeIndx is abscent from the URL
		}
		
		$postRec= $this->getPostRec($postId);
		$userId= $postRec[_c_fumFUserId];
		$pseudo= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserPseudo);

		$time= (int)$postRec[_c_fumDate];
		$dateStamp= $this->facultativeDateStamp($time,true);
		
		$capsUserId= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$capsId, _c_fumFUserId);
		$capsPseudo= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$capsUserId, _c_fUserPseudo);
		
		if ($xIndx1===false && $menCatg===false){
			// Main page no index specified in the url (is meant to build a summary of the last 2 pages), so for the 2 last x pages, gives the title back with pointer on full post.
			// ---> also a standard comments situation (no threads)
			
			$xIndx1= $postRec[_c_fumXIndx];
			
			// STANDARD TITLES only for comments summary  :
			$avatImg= $this->postIdStamp($userId,$pseudo,'fSmAvatar',$postId);	// actually an avatar stamp!
			$xUrl= $this->curPgAndXCodeUrl($xIndx1,$postId);
			if ($capsId!==_c_ko){
				$curTtl= $avatImg.$caps->cLinkTot($xUrl, $curTtl, 'fumPostTtl','',$pseudo.' / '.$postId.$glob->sl(' is an answer to : ','kbmf').$capsPseudo.' / '.$capsId );
			}else{
				$curTtl= $avatImg.$caps->cLinkTot($xUrl, $curTtl, 'fumPostTtl','',$pseudo.' / '.$postId.$glob->sl(' is an answer on the main subject!','kbmg'));
			}
			
			$totTtl= $caps->div($curTtl.' / '.$pseudo.$dateStamp,'fumPostTtl');
			return $caps->sDiv($totTtl.$bd,'width:600px; margin-left:30px; margin-top:10px; border:0px solid red;');
		}
		
		// STANDARD TITLES for comments and real forum inside the actual thread-titles, comments-full display		
		$xIndx2= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$capsId, _c_fumXIndx);
		if ($capsId!==_c_ko){
			$xUrl= $this->curPgAndXCodeUrl($xIndx2,$capsId);
			$curTtl= $caps->cLinkTot($xUrl, $curTtl, 'fumPostTtl','',$pseudo.' / '.$postId.$glob->sl(' is an answer to : ','kbmf').$capsPseudo.' / '.$capsId );
		}else{	
			if ($rfState){
				// Real forum
				$thrdStartUrl= $tools->urlCurPg();
				$xPage= $this->getRfxFirstPg();
				$thrdStartUrl.= $tools->addUrlVar(_c_rfxPage,$xPage);
				$curTtl= $caps->cLinkTot($thrdStartUrl, $curTtl, 'fumPostTtl','',$pseudo.' / '.$postId.$glob->sl(' is an answer on the main subject!','kbmg'));
			}else{
				// comments
				$curPgUrl= $tools->urlCurPg();
				$curTtl= $caps->cLinkTot($curPgUrl, $curTtl, 'fumPostTtl','',$pseudo.' / '.$postId.$glob->sl(' is an answer on the main subject!','kbmg'));
			}
		}
		
		$totTtl= $this->postTitle($curTtl,$postId, $xIndx1);
		$usrId= $postRec[_c_fumFUserId];
		$glob->isSpiderFrienly= $xRgt->spiderLinks($usrId);
		
		// -------------------------------------------------------
		$curBdy= $this->getBody($postId,true);		// BODY
		$glob->tagRstrct();
		$glob->curGPostId= $postId;
		$parsBdy= $parser->addrParseStdStr($curBdy, $pseudo._c_dbSep.$postId);	// initialise the default path above with $imgTags->resetImagePath()
		
		$glob->isSpiderFrienly= false;	// default secure state!
		
		$glob->curGPostId= false;
		$glob->tagUnRstrct();
		
		$supParam= $caps->matCss('fumAnswer');

		$leftImg= '';
		$noStop= !$this->stopped( $postRec[_c_fumMotherId] );
		$allButts= '';
		if ( $noStop && $this->usrAllowedToWrite() ){
			// Buttons
			$csi= $this->coreSignedIn($userId);		// True if the $userId of the actual parsed post is actually logged in!
			if ($this->isSignedIn || $wRights){
				$commentButton= '';
				$xCodeIndx= $this->gostXCode();
				
				$arCmd[_c_mothrPage]= _c_ko;
				if ( $this->isSignedIn && !$csi && $this->inPostDailyLimit() ){
					// ANSWER button				
					$url= $tools->urlGivenPage('_4um_message_form',$arCmd);
					$url.= $tools->addUrlVar(_c_fumUrlPostId,$postId);
					$url.= $this->urlPartLocalistn($tools->curPageName(),$xCodeIndx);
					
					$leftImg= $caps->image(_c_EditorImgPath.'postButtSml.png','','fumAnswer');
					if ($this->forumPageIsOpen()){
						$commentButton= $caps->hLink($url, $leftImg.$glob->sl('Answer!','kaad'),$supParam);
					}
				}

				// IMPROVE button ($wRights can improve all !)
				$improveButt= '';
				if ($csi || $wRights){
					$url= $tools->urlGivenPage('_4um_message_form',$arCmd);
					$url.= $tools->addUrlVar(_c_fImprovePId,$postId);
					$url.= $this->urlPartLocalistn($tools->curPageName(),$xCodeIndx);
					
					$leftImg= $caps->image(_c_EditorImgPath.'improveButt.png','','fumAnswer');
					
					if ($postRec[_c_fumOkPost]===_c_ko){
						$supParam.= $caps->matTtl($glob->sl('Feel free to improve your post','kbbu'));
					}
					
					if ($this->forumPageIsOpen()){
						$improveButt= $caps->hLink($url, $leftImg.$glob->sl('Improve!','kaac'),$supParam);
					}
				}
				
				$sep= '';
				if ($commentButton!=='' && $improveButt!==''){
					$sep= $caps->span(' ','fumAnswer');
				}
				
				$allButts= _c_BrFlux.$commentButton.$sep.$improveButt;
			}
		}else{
			$allButts= '';
		}
		
		$curStr= $totTtl.$parsBdy.$allButts;
		
		$first= $v['frame'];
		if ($first===_c_ok){
			// A visible frame for the 1st post of a thread !!
			$curStr= $caps->sDiv($curStr,$dtb->getGenVar('fFirstPostFrame'));
		}
		
		if ($menCatg===false){
			// standard situation
			if ($v['_level']===1){
				$curCls= 'fumFirstPostTtlBdy';	// no indentation of 1st small indentation depending on whisches
			}else{
				$curCls= 'fumPostTtlBdy';	// indentation for inbricated tags
			}
		}else{
			$curCls= 'fumPostTtlBodyWall';	// wall situation
		}
		return $caps->div($curStr.$bd, $curCls);
	} // forumPost		
	

	/**
		Return the avatar with the numerical Id of the post if logged
	*/
	function postIdStamp($userId,$pseudo,$avatarSty,$postId,$arCmd=false){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$rights= &$this->rights;		
	
		$visiblePostId= $arCmd===false;		// sur-implanted definition right here
	
		$wRights= $rights->wRights;
		$idStamp= '';
		if ($tools->getVal(_c_tMenCateg)===false){		// not used for a post wall
			$curAvat= $this->avatPath($userId).$this->getCurAvatar($userId);
			// $usrMgUrl= $this->lnPseudoUrl($userId,$arCmd,false);	// do not add the mother page
			$usrMgUrl= $this->lnPseudoUrl($userId,$arCmd);
			
			$idStamp= $caps->linkImg($curAvat,$pseudo.$glob->sl('\'s Avatar + information','kbme') , $usrMgUrl,$avatarSty);
			if ($wRights && $visiblePostId || $tools->getVal(_c_fumVsblPostId)===_c_ok){
				$idStamp.= $caps->span('('.$postId.') ','fumDateStamp');
			}
		}
		return $idStamp;
	} // postIdStamp


	/**
	*/
	function showButton($url,$alt=false,$bImg='pencilWs.png'){
		$glob= &$this->glob;		
		$caps= &$this->caps;
				
		if ($alt===false){
			$alt= $glob->el('Shows the concerned post record ...','kbbt');
		}
		$img= $caps->image($caps->imgSrc($bImg,_c_ok),$alt,'fumImgBtt');
		return $caps->linkTC($url,$img,$alt,'fumImgBtt','_blank').$caps->span(' ','fumStd');			
	} // showButton
	
	
	
	/**
		Should have only one image chosen dependently on the state of the post!
	*/
	function visiblButton(&$postRec, $xIndx1,$postId){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		$url= $this->curPgAndXCodeUrl($xIndx1);
		$allowed= $postRec[_c_fumOkPost];
		if ($allowed===_c_ok){
			$url= $url.$tools->addUrlVar(_c_fVisAction, 'hide');	
			$url.= $tools->addUrlVar(_c_fVisSpecPost, $postId);
			$url.= $tools->signet($postId);
			$alt= $glob->el('Actually visible, click it to inverse!','kmcn');
			$img= $caps->image($caps->imgSrc('smiley.png',_c_ok),$alt,'fumImgBtt');
			return $caps->linkTC($url,$img,$alt,'fumImgBtt').$caps->span(' ','fumStd');
		}else{
			$url= $url.$tools->addUrlVar(_c_fVisAction, 'show');	
			$url.= $tools->addUrlVar(_c_fVisSpecPost, $postId);	
			$url.= $tools->signet($postId);
			$alt= $glob->el('Actually unvisible, click it to inverse!','kmco');
			$img= $caps->image($caps->imgSrc('make-visible.png',_c_ok),$alt,'fumImgBtt');
			return $caps->linkTC($url,$img,$alt,'fumImgBtt').$caps->span(' ','fumStd');
		}
	} // visiblButton
	

	/**
	*/
	function privToPuBut(&$postRec, $xIndx,$postId){
		$glob= &$this->glob;
		$caps= &$this->caps;
		
		$url= $this->postPrivToPublicUrl($postId,$xIndx);		
		$alt= $glob->el('Your are seeing the private post, click it to make it public...','kmcp');
		$img= $caps->image( $caps->imgSrc('lessThan.png',_c_ok),$alt,'fumImgBtt' );
		return $caps->linkTC($url,$img,$alt,'fumImgBtt').$caps->span(' ','fumStd');
	} // privToPuBut

	/**
		Post Private To Public for the current page.
	*/
	function postPrivToPublicUrl($postId,$xIndx){
		$tools= &$this->tools;
			
		$url= $this->curPgAndXCodeUrl($xIndx);
		$url.= $tools->addUrlVar(_c_fPrivToPub, _c_ok);	
		$url.= $tools->addUrlVar(_c_fCurPostIdx, $postId);	
		$url.= $tools->signet($postId);
		return $url;
	} // postPrivToPublicUrl


	/**
		Get and set the title and ...body ...
		of a message to switch automatically between  the public and private group!
	*/
	
	/**
		
		If the time span is passed --> Right now just switch completly on the sub-storage side, but instead,
		need to switch on it only for the owner of the post and the webMaster.
		Input :
			$pId : post Id.
			$pureDspl : true if it's a pure display (no edition).
	*/
	function getTitle($pId,$pureDspl=false){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		$field= $this->infoField($benefTm,$pId,'ttl','get',$pureDspl);
		if ($field!==false){
			$infoField= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$pId, $field);
			if ($field===_c_fumMssTtl){
				// Got a private title, so add a message to the title
				$mess= '';
				if ($pureDspl){
					$mess= $caps->span(' ').$caps->span($glob->sl('..message going to be checked manually..','kmcq'),'fumWarningPrivate');
				}
				return $infoField.$mess;
			}else{
				return $infoField;
			}
		}else{
			return false;
		}
	} // getTitle
	

	/**
		Get the specified post record.
	*/
	function getPostRec($id){
		$dtb= &$this->dtb;
		return $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$id);
	} // extractPostRec
	
	
	/**
		Returns the last X code (largest SINGLE valid NUMBER), that was posted, urled or defaulted!
	*/
	function gostXCode(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$xCode= $tools->gostVal(_c_fxCodeIndx);
		if ($xCode===false){
			// Real forum case!
			
			$xPage= $this->getRfxPage();
			if ($xPage===false){
				// make a new one or default 0
				$mpName= $this->gostMotherPage();
				if ($mpName===false){
					$mpName= $tools->curPageName();
				}
				
				$freeXId= $dtb->getElem(_c_forumPgRe, _c_fumRepId,$mpName, _c_fumTreeFreeX);
				if ($freeXId!==false && $freeXId>0){
					$freeXId= (int)$freeXId;
					$lastXId= $freeXId-1;
				}else{
					$lastXId= 0;	// _c_forumPgRe not initialised, so loads the default
				}
				
				return $lastXId;
			}else{
				$this->splitRfXpg($mp,$thrdIdx,$xCode,$xPage);
			}
		}
		return $xCode;
	} // gostXCode
		

	/**
	*/
	function getBody($pId,$pureDspl=false){
		$dtb= &$this->dtb;
		
		// n infoField
		$field= $this->infoField($benefTm,$pId,'bdy','get',$pureDspl);	
		return $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$pId, $field);
	} // getBody


	/**
		Returns true if the user is below its maximum daily post numbers (inside the limit)
	*/
	function inPostDailyLimit(){
		$dtb= &$this->dtb;
		$xRgt= &$this->xRgt;
			
		$this->getPostedUserIds($userId,$pseudo);
		if ($xRgt->ownPostChgRght()){
			return true;	// bypass
		}else{
			$cDPN= (int)$this->curDayPostNb($userId);
			$pDL= (int)$dtb->getGenVar('fPostDailyLimit');
			return $cDPN<=$pDL;
		}
	} // inPostDailyLimit

	/**
		Add the following url information .
			If we have simple comments : just returns the _c_fxCodeIndx url addition
			If we have a real forum returns the full related page name.url addition
		--> Url partial localisation
		
		Inout:
			$mp : mother page	(only usefull for comments)
			$xCodeIndx : given x code for comments
	*/
	function urlPartLocalistn($mp,$xCodeIndx){
		$tools= &$this->tools;
	
		if ($this->realForumState()){
			$xPage= $this->getRfxPage();
			$url= $tools->addUrlVar(_c_fMotherPage, $mp);
			$url.= $tools->addUrlVar(_c_rfxPage, $xPage);
		}else{
			$url= $tools->addUrlVar(_c_fMotherPage, $mp);
			$url.= $tools->addUrlVar(_c_fxCodeIndx, $xCodeIndx);
		}
		return $url;
	} // urlPartLocalistn
	

	/**
	*/
	function curDatePrfx(){
		$curTime= time();
		return date('y',$curTime).'d'.date('z',$curTime);
	} // curDatePrfx
			
	/**
		Returns the current daily post number.
	*/
	function curDayPostNb($userId){
		$dtb= &$this->dtb;
		$fls= &$this->fls;	
	
		$cntStr= $dtb->getElem(_c_fsmplUsersTbl,_c_fUserId,$userId,_c_fDailyPosts);
		if ($cntStr!=='' && $cntStr!=='0'){
			$curDatePrfx= $this->curDatePrfx();
			$fls->splitOnLastC($cntStr,$datePrfx,$daysCount);
			if ($curDatePrfx===$datePrfx){
				return (int)$daysCount;
			}else{
				return 0;	// just passed to another day
			}
		}else{
			return 0;	// hasn't got anything
		}
	} // curDayPostNb
	
		
	/**
		Gives the correct information field for edition or pure display purpose, depending on :
			Body or Title & Get or Set & Got-improveRights or Not
				
		Input :
			$pId : post Id
			$body : 'bdy' or 'ttl'
			$get : 'get' or 'set'
			$pureDspl : true if it's a pure display.
		Output:
			$benefTm : true if the current post benefit from the in time span direct modification.
	*/
	function infoField(&$benefTm,$pId,$body='bdy',$get='get',$pureDspl=false){
		$dtb= &$this->dtb;
				
		if ($pureDspl){
			return $this->chooseDsplField($pId,$body);
		}else{
			$body= $body==='bdy';	//  'bdy'--> true; 'ttl'--> false; 
			$get= $get==='get';
			$this->getPostedUserIds($userId,$pseudo);
			
			if ( $this->gotImproveRights($benefTm,$userId,$pId) ){
				return $this->publicBT($body);		// Never got to do a recovery inside $this->privateBT($body)
			}else{
				// lost editing rights because of time elapsing
				if ($get){
					// getting the information in, so if empty (considers it as 1st times and uses the other one)
					$content= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$pId, _c_fumMssTtl);	// does it always on the title, because empty titke implies an empty body by definition (both not unset))
					if ($content===''){
						return $this->publicBT($body);
					}else{
						return $this->privateBT($body);	// Switch on the secondary fields
					}
				}else{
					return $this->privateBT($body);
				}
			}
		}
	} // infoField	
		
	/**
	*/
	function inIdTimeSpan($postId,$userId){
		$dtb= &$this->dtb;
		$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);
		$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);
		return $this->insideTimeSpan($postRec,$userRec);
	} // inIdTimeSpan


	/**
		Chooses between a public body or a public title
	*/
	function publicBT($body){
		if ($body){
			return _c_fumMessBody;
		}else{
			return _c_fumMessTtl;	// title turn
		}
	} // publicBT
	
	/**
		Choose between a public body or a public title
	*/
	function privateBT($body){
		if ($body){
			return _c_fumMssBdy;
		}else{
			return _c_fumMssTtl;	// title turn
		}
	} // privateBT


	/**
		Chooses the post display Field and if no field is available returns false!
			Input :
				$postId : id of the post
				$body : body or title. 'bdy' or 'ttl'
	*/
	function chooseDsplField($postId,$body){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
				
		$body= $body==='bdy';	//  'bdy'--> true; 'ttl'--> false; 
		$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);		
		$postUsrId= $postRec[_c_fumFUserId];
		$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$postUsrId);
		if ($rights->wRights){
			// Webmaster logged (always display the secondary field if not empty '' )
			$fieldPr= $this->privateBT($body);
			$privateInfo= $postRec[$fieldPr];
			if ($privateInfo===''){
				return $this->publicBT($body);
			}else{
				return $fieldPr;
			}
		}else{
			// Webmaster unlogged
			if ($this->isSignedIn){
				// Forum USER LOGGED
				$logUsrId= $this->fumLogUserId();
				if ($postUsrId===$logUsrId){
					// Got a match with the current forum Id (chooses the field depending on time span)
					if ($this->insideTimeSpan($postRec,$userRec)){
						// Inside the correct time span for uncensored modifications (public case).
						return $this->publicBT($body);
					}else{
						// Outside the correct time span --> private case
						if ($postRec[_c_fumMssTtl]!==''){
							return $this->privateBT($body);
						}else{
							return $this->publicBT($body);
						}
					}
				}else{
					// Logged but no match.
					return $this->minRightsInfo($postRec,$body);	// just another user so idem anybodsy views
				}
			}else{
				return $this->minRightsInfo($postRec,$body);
			}
		}
	} // chooseDsplField	


	/**
		Returns true if the forum user specified in $userRec is still inside his time span
		to make unchecked modifications to the main information fields of $postRec.
	*/
	function insideTimeSpan(&$postRec,&$userRec, $show=false){
		$dtb= &$this->dtb;
		
		$pOk= $postRec[_c_fumOkPost];
		if ($pOk!==_c_ok){
			/*
				The post is still not approved (automatically or manually), so it's only visible for the author, 
				so the author got a right to change it as he like.
			*/
			return true;
		}
		
		
		$unit= $dtb->getGenVar('fUsrModifTmUnit');	// Units in number of seconds
		$uModifSpan= (int)$userRec[_c_fUFreeTime] * $unit;
		
		$creaTime= (int)$postRec[_c_fumLastDate];
		$ageOfThePost= time()-$creaTime;
		
		$in= $ageOfThePost < $uModifSpan;
		
		/*
			// Keep it, useful for debugging
			if ($show){
				print('$uModifSpan='.$uModifSpan._c_);
				print('$ageOfThePost='.$ageOfThePost._c_);
				
				if (!$in){
					print('We are oustide the time span'._c_);
				}
			}
		*/
		
		return $in;
	} // insideTimeSpan
	
	
	/**
		The information for the minimum right case. Forum user matching the post is unlogged so basic surf 
		case (always display the primary field if the post is accepted).
	*/
	function minRightsInfo($postRec,$body){
		if ($postRec[_c_fumOkPost]===_c_ok){
			return $this->publicBT($body);
			
		}else{
			return false;
		}
	} // minRightsInfo


	/**
		Return true if the user got the rights to improve own messages on the main fields after they were accepted.
		IO :
			Input :
				$userId,$postId
				
			Output :
				$benefInTmSpan : true if the current post benefit from the in time span direct modification
	*/
	function gotImproveRights(&$benefInTmSpan,$userId,$postId){
		$dtb= &$this->dtb;
		$xRgt= &$this->xRgt;
		
		$benefInTmSpan= false;
		$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);
		
		$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);
		$allowedPost= $postRec[_c_fumOkPost];		
		if ($allowedPost===_c_ok){
			if ($xRgt->ownPostChgRght()){
				return true;	// permanent changing rights
			}else{
				$benefInTmSpan= $this->insideTimeSpan($postRec,$userRec);	// benefit form the user time span leniency
				return $benefInTmSpan;
			}
		}else{
			// The post is still not accepted (early editing stage), so the user got obviously the right to improve it.
			return true;
		}
	} // gotImproveRights
	

	/**
	*/
	function getRfThreadId(){
		$tools= &$this->tools;

		if ($this->globCurNewThreadIdx!==_c_ko){
			return $this->globCurNewThreadIdx;
		}else{
			return $tools->postVal(_c_rfNewThread,_c_ko);
		}
	} // getRfThreadId


	/**
		Return the full code to access the fumXCode table
			Input : 
				$mp : mother page name
				$idx : eventual given x code
			Output:
				$threadIdx : the calculated or given thread..
				$calcIdx : the calculated or given x code.index
	*/
	function xCodePgName(&$threadIdx,&$calcIdx, $mp, $idx=false){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		if ($idx===false){
			$idx= $this->gostXCode();
		}
		
		if ($this->realForumState()){
			$xPage= $this->getRfxPage();			
			if ($xPage===false){
				$threadIdx= $this->getRfThreadId();
			}else{
				$askForNewT= $tools->getVal(_c_rfNewThread)===_c_ok;
				if ($askForNewT){
					$threadIdx= $this->globCurNewThreadIdx;
					$idx= '0';
				}else{
					// extract $threadIdx from $xPage ... give also $idx if the one specified is false
					if ($idx!==false &&  $idx!==''){
						$this->splitRfXpg($mp,$threadIdx,$idxPhoney,$xPage);	// So uses later the previous $idx value
					}else{
						$this->splitRfXpg($mp,$threadIdx,$idx,$xPage);
					}
				}
			}
			$res= $this->rfXCdPgNm($mp,$threadIdx,$idx);
		}else{
			$threadIdx= false;
			$res= $this->xCdPgNm($mp,$idx);
		}
		
		$calcIdx= $idx;		
		return $res;
	} // xCodePgName
	
	/*
		Idem xCodePgName but minimalistic version.
	*/
	function xCodePgNm($mp, $idx=false){
		return $this->xCodePgName($phoney,$phoney,$mp,$idx);
	} // xCodePgNm
	
	
	/**
	*/
	function curXCodePgNm($mp,$idx, $threadIdx=false){
		if ($threadIdx!==false){
			return $this->rfXCdPgNm($mp,$threadIdx,$idx);	// $this->realForumState()
		}else{
			return $this->xCdPgNm($mp,$idx);
		}
	} // curXCodePgNm	


	/**
		Get the default (1) or specified tagTree of posts
			Input :
				$mp : the mother page.
				$idx : relative index of the post
	*/
	function getTagsTree($mp){
		$dtb= &$this->dtb;
		
		$indx= $this->gostXCode();
		$curId= $this->xCodePgNm($mp,$indx);
		return $dtb->getElem(_c_fumXCode, _c_fumXmlId,$curId, _c_fumXmlCode);		// actual forum connection string
	} // getTagsTree


	/**
	*/
	function tagHead($cpIndx){
		$tools= &$this->tools;
		
		$new= $tools->getVal(_c_rfNewThread);
		if ($new===_c_ok){
			return '[forumPost frame="ok" id="'.$cpIndx.'"]';
		}else{
			return '[forumPost id="'.$cpIndx.'"]';
		}	
	} // tagHead
	
	function tagEnd($cpIndx){
		return '[/'.$cpIndx.']';
	} // tagEnd		

	/**
		Set the default (1) or specified tagTree of posts.
		Inoput
			$curXNm : X code current pg name!
			$val : current value.
			$mp : mother page name.
	*/
	function setTagsTree($curXNm,$val,$mp){
		$dtb= &$this->dtb;
		
		if ($dtb->elementExists(_c_fumXmlId,$curXNm, _c_fumXCode)){
			$dtb->setElem(_c_fumXCode,  _c_fumXmlCode,$val,  _c_fumXmlId,$curXNm);	
		}else{
			$this->newXRecord($curXNm);
			
			// Adapt the repository			
			if (!$dtb->elementExists(_c_fumRepId,$mp, _c_forumPgRe)){
				$this->createPageRepos($mp);
			}
		}
	} // setTagsTree
	
	/**
	*/
	function newXRecord($newXName,$userId=false){
		$dtb= &$this->dtb;
		$xRgt= &$this->xRgt;
		
		$vsbl= false;
		if ($userId!==false){
			if ($xRgt->ownPostChgRght()){
				$vsbl= true;
			}
		}
		if ($vsbl){
			$valV= array($newXName,'','','','0',_c_ok,'',_c_ok);
		}else{
			$valV= array($newXName,'','','','0',_c_ok,'','');
		}
		
		$dtb->newRecord(_c_fumXCode,$valV);
	} // newXRecord
	

	/**
		Delete the specified Post and saves the deleted information inside _c_fDumpPostsTbl.
		Rem : does not delete inside the scheduler list.
	*/
	function deleteSpecPost($delPId){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		if ($delPId!==false && $rights->wRights){
			$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$delPId);
			$xIndx= $postRec[_c_fumXIndx];
			$mp= $postRec[_c_fumMotherId];
			$concernedXPage= $this->xCdPgNm($mp,$xIndx);
		
			$userId= $rights->realTimeUserId();
			$booked= $this->bookedXGate($userId,$mp,_c_fumReservTmSlot);
			if ($booked){
				// The ressources are booked by now, so Removes the post data
				$victimUsrId= $postRec[_c_fumFUserId];				
				$dtb->decrElem(_c_fsmplUsersTbl, _c_fUserId,$victimUsrId, _c_fUserNbPost);
							
				if ($postRec!==false){
					if ($dtb->elementExists(_c_fumPostId,$delPId, _c_fDumpPostsTbl)){
						$dtb->delete(_c_fDumpPostsTbl,$delPId);
					}

					// So the symetric _c_fDumpPostsTbl/$delPId is free
					$dtb->newRecFromV(_c_fDumpPostsTbl,$postRec);		// creates the new DUMP record !!
				}			
				
				if ($dtb->elementExists(_c_fumPostId,$delPId, _c_forumPostsTbl)){
					$dtb->delete(_c_forumPostsTbl,$delPId);		// delete original
				}
								
				$tagsTreeStr= $dtb->getElem(_c_fumXCode, _c_fumXmlId,$concernedXPage, _c_fumXmlCode);
				// Managed to book the system
				
				/*----------------------------------------------
					Calculates and saves the new []tree.
				*/
				$head= $this->tagHead($delPId);
				$end= $this->tagEnd($delPId);
								
				$posHead= strpos($tagsTreeStr,$head);
				$pEb= strpos($tagsTreeStr,$end);	// Pos beginning end tag from beginning
				$pEET= $pEb + strlen($end); 		// Pos End end tag
				
				// position beginning end tag from the end
				$endTgNeg= $pEET-strlen($tagsTreeStr);
				$headRes= substr($tagsTreeStr, 0, $posHead);
				$endRes= substr($tagsTreeStr, $endTgNeg);
				$newXBody= $headRes.$endRes;
				
				$this->setTagsTree($concernedXPage,$newXBody,$mp);		// Saves the shrinked []tree for the new display
				
				/*----------------------------------------------
					Dump the old removed heart in case of need!
				*/
				$allTgLn = strlen($tagsTreeStr);
				$lnHeart= $allTgLn - ($posHead+1) + $endTgNeg +1;
				$heartStr= substr($tagsTreeStr, $posHead, $lnHeart);
				$dtb->setElem(_c_fDumpPostsTbl,  _c_fumXDump,$heartStr,  _c_fumPostId,$delPId);
				
				$this->pDelInScheduler($delPId);
				$this->freeXGate($mp);
			}else{
				$this->loadsSTB();
			}
		}	// $delPId!==false
	} // deleteSpecPost	

	
	/**
		To manually transfer the private info into the public info and erases the private infos!
		
		The idea is to fabricate the equivaklent of one scheduler record (the model) to treat it with the same algorithm!
		The suplementary parameters $suP are partially filled (to save programming time) consequences are that
		some part of the cache may not be updated and must also be handed manually.
	*/
	function transfPrivPub(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		
		$pToP= $tools->getVal(_c_fPrivToPub);
		if ($pToP!==false){
			$sched= $this->schedulerClass();
			
			$cpI= $tools->getVal(_c_fCurPostIdx,_c_ko);	// Current post index
			$usrId= $this->postUserId($cpI);
			
			$suP= $sched->emptySupParamV;
			$suP[_c_schedPgName]= $this->motherName($cpI);
			$suP[_c_schedNewUpdate]= _c_ok;
			
			$supCurX= $tools->getVal(_c_fxCodeIndx,_c_ko);	// x index
			if ($supCurX===_c_ko){
				$supCurX= $tools->getVal(_c_rfxPage,_c_ko);	
				if ($supCurX === _c_ko){
					$supCurX= $tools->getVal(_c_rfTGroupIdx,_c_ko);	
				}
			}
			$suP[_c_schedCurXbr]= $supCurX;
			
						
			$valuesRow= $sched->addTask($cpI,$usrId,_c_fumSchedActTrans,$suP,false); // false --> manual task
			$tasksRow= $tools->arrayCombine($sched->emptySchedParamV,$valuesRow);
			
			$cpI= $this->coreTransPrToPub($tasksRow);
			if ($cpI!==false){
				$this->pDelInScheduler($cpI);
			}
		}
	} // transfPrivPub

	/**
		Core transfer private to public!
		Input :
			$cpI : current post Id
	*/
	function coreTransPrToPub(&$curSchedRow){
		$dtb= &$this->dtb;
		
		$cpI= $curSchedRow[_c_fumSchedPostId];
		$recP= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$cpI);
		$secondTtl= $recP[_c_fumMssTtl];	// to avoid calling that twice in a row and erasing everything.
		if ($secondTtl!==''){
			$usrId= $recP[_c_fumFUserId];
			$usrImprovTime= (int)$dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$usrId, _c_fUFreeTime);

			// Transfers
			$dtb->setElem(_c_forumPostsTbl, _c_fumMessTtl,$recP[_c_fumMssTtl], _c_fumPostId,$cpI);
			$dtb->setElem(_c_forumPostsTbl, _c_fumMessBody,$recP[_c_fumMssBdy], _c_fumPostId,$cpI);

			// Assigns '' into the private fields
			$dtb->setElem(_c_forumPostsTbl, _c_fumMssTtl,'', _c_fumPostId,$cpI);
			$dtb->setElem(_c_forumPostsTbl, _c_fumMssBdy,'', _c_fumPostId,$cpI);

			// Adds the current time + span for improvment!!
			$dtb->setElem(_c_forumPostsTbl, _c_fumLastDate,time()+$usrImprovTime, _c_fumPostId,$cpI);
			
			$dtb->setElem(_c_forumPostsTbl, _c_fGotFreeImprove,_c_ko, _c_fumPostId,$cpI);	// automatical recharge of watching trigger
		}
		
		/* 	Adaptation of current sup row :
			Already done at : #changePostSchedulerSupParam 
		*/
		$this->setContextAttributes($curSchedRow);	// special _c_schedNewUpdate case !
		return 	$cpI;		
	} // coreTransPrToPub	
	
	
	/**
		Increment the number of answers.of 1.
	*/
	function incrAnswNb($capsId){
		$dtb= &$this->dtb;	
	
		$nbAnsw= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$capsId, _c_fumNbAns);
		$dtb->setElem(_c_forumPostsTbl,  _c_fumNbAns,$nbAnsw+1,  _c_fumPostId,$capsId);
	} // incrAnswNb
	
	
	/**
		Update context atributes for a new visible post (cache deletion, numerical attribute, parent warning etc.).
		
		Remark : unnecessary deletion are done because we consider the most difficult case of just creating new groups, this could
		be avoided if group creation was explicitelly available here --> would need to pass the information through the scheduler,
		or directly to this function when admin rights are used (no scheduler).
		
		The cache updating is just prepared with a full deletion of the deprecated cached pages (*1) their cache being restored
		at the first unlogged visit, likely to be done by the post writer for verification. (*1) middle x-pages de precated only by
		their geometrical list are not deleted because access is still possible by clicling at the extremity of the list, but it's
		possible to "vote" for full deletion of the concerned list either manually or automatically like every x weeks to establish again a full geom list (programming
		not done on that last part).
		
	*/
	function setContextAttributes(&$curSchedRow){
		$dtb= &$this->dtb;
		$cacheWr= &$this->cacheWr;
		$reader= &$this->cacheR;
		$sched= $this->schedulerClass();
		
		$postId= $curSchedRow[_c_fumSchedPostId];
		$curAct= $curSchedRow[_c_fumSchedAction];
		
		if ($curAct===_c_fumSchedActPost){
			$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);
			$capsId= $postRec[_c_fumCapsId];
			$userId= $postRec[_c_fumFUserId];
			
			$this->acknowVisibilityForAll($postId); // just for the numeric menu, so always visible after this sort of action.						
			$this->incrAnswNb($capsId);	// increment the number of answers to the $capsId post
			$dtb->incrElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserNbPost);	// Increment the post countor of the user
			$this->warnParentPost($postId);	// Need only one!
			
			$mpId= $postRec[_c_fumMotherId];
			$threadId= $postRec[_c_fumThreadId];
			
			/** -------------------------------------------------------------------------------------------------------------
				General cache dealing just based on the post Id, not the url parameter of the page because of the scheduler!
			*/
			$postRecord= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId, $postId);
			$postReposRec= $dtb->getElem(_c_forumPgRe, _c_fumRepId, $mpId);
					
			$forcedPg= $postRecord[_c_fumMotherId];
			$realForum= $postReposRec[_c_fumRlFum];
			
			// Deal with the threads attribute table : fumThrdAttrib (single thread only comments also concerned because it counts the number of posts with a thread)
			$thrdAttId= $this->threadName($mpId,$threadId);
			$elemExists= $dtb->elementExists(_c_fThrdAttId, $thrdAttId, _c_fumThrdAttribTN);
			if (!$elemExists){
				$dataV= array($thrdAttId,'0');
				$dtb->newElem(_c_fumThrdAttribTN, _c_fThrdAttId,$thrdAttId, $dataV);
			}
			
			$dtb->incrElem(_c_fumThrdAttribTN, _c_fThrdAttId,$thrdAttId, _c_fThrdAttAwNb);	// Increment the thread countor
		} // else (_c_fumSchedActTrans) Don't need new staff and only needs a subset of deletion for that, does not need to touch the 2nd thread etc.
		

		$supS= $curSchedRow[_c_fumSchedSuParam];
		$supRow= $sched->supStrToSupV($supS);
		
		$nU= $supRow[_c_schedNewUpdate];
		$pN= $supRow[_c_schedPgName];
				
		$cX= $supRow[_c_schedCurXbr];
		$nX= $supRow[_c_schedNewXbr];
		
		$cT= $supRow[_c_schedCurThr];
		$nT= $supRow[_c_schedNewThr];
		
		$cK= $supRow[_c_schedCurPack];
		$nK= $supRow[_c_schedNewPack];
		
		
		// X
		if ($cX!==_c_ko){
			// Classical current concerned X page should be always active (could avoid the test but keep it for formal understanding)
			$dfn= $cacheWr->delConcernedCache($pN,$cX);
		}else print('Error setContextAttributes 1'._c_);

		if ($nX!==_c_ko && $cX!==$nX){
			$dfn= $cacheWr->delConcernedCache($pN,$nX);
		}
		
		// Threads
		if ($cT!==_c_ko){
			$dfn= $cacheWr->delConcernedCache($pN,$cT);
		}

		if ($nT!==_c_ko && $cT!==$nT){
			$dfn= $cacheWr->delConcernedCache($pN,$nT);
		}
		
		// Packs
		if ($cK!==_c_ko){
			$dfn= $cacheWr->delConcernedCache($pN,$cK);
		}

		if ($nK!==_c_ko && $cK!==$nK){
			$dfn= $cacheWr->delConcernedCache($pN,$nK);
		}
		
		// Direct call on main page (2nd param must be an empty string)
		$dfn= $cacheWr->delConcernedCache($pN,'');
		
	} // setContextAttributes


	/**
		Calculate the previous X id of $id knowing that the possible forms are :
			a-b  or  c
	*/
	function prevXId($id){
		$fls= &$this->fls;
		
		$bool= $fls->splitOnLastC($id,$a,$b,'-');
		if ($bool){
			// got a complex pattern a-b
			$a.= '-';
		}else{
			// simplest pattern c === $id
			$a= '';
			$b= $id;
		}
		
		if ($b!=='0'){
			// decrement $b
			$nB= (int)$b - 1;
			$nB= (string)$nB;
		}else{
			return false;	// no prvious index .. following operations are useless
		}
		
		return $a.$nB;
	} // prevXId


	/**
		Special visibility flag.for the X page, need at least one post to set the flag on
	*/
	function acknowVisibilityForAll($postId){
		$dtb= &$this->dtb;
		
		$postRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);
		$mp= $postRec[_c_fumMotherId];
		$xId= $postRec[_c_fumXIndx];
		
		$xCdPgN= $this->xCdPgNm($mp,$xId);
		$dtb->setElem(_c_fumXCode,  _c_fXVisiblAll,_c_ok,  _c_fumXmlId,$xCdPgN);
	} // acknowVisibilityForAll


	/**
		Send an email to the parent post if it exists and if it has chosen to get these warning emails.
	*/
	function warnParentPost($cpIndx){
		$dtb= &$this->dtb;	
		$fMail= &$this->forumMail;

		$cpRecord= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$cpIndx);	// current post record
		$parentId= $cpRecord[_c_fumCapsId];
		if ($parentId !== _c_ko){
			// a parent exists so we can send it a message
			$parentPostRec= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$parentId);
			$parentUsrId= $parentPostRec[_c_fumFUserId];
			
			$watch= $parentPostRec[_c_fumWatchMail];
			if ($watch===_c_ok){
				$parUsrRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$parentUsrId);	// parent user record
				$emailTo= $parUsrRec[_c_fUserMail];
				$pseudo= $parUsrRec[_c_fUserPseudo];
				
				$mpName= $cpRecord[_c_fumMotherId];
				$calcIdx= $cpRecord[_c_fumXIndx];
				
				$fMail->gotAnAnswer($emailTo,$pseudo, $mpName,$calcIdx,$cpIndx);
			}
		}
	} // warnParentPost


	/**
		Core function to make a post visible
	*/
	function postExposed(&$curSchedRow){
		$dtb= &$this->dtb;
		
		$postId= $curSchedRow[_c_fumSchedPostId];
		
		// Count as a last creation date so the unchecked modification time span can be applyed
		$dtb->setElem(_c_forumPostsTbl,  _c_fumLastDate,time(),  _c_fumPostId,$postId);
		
		$dtb->setElem(_c_forumPostsTbl,  _c_fumOkPost,_c_ok,  _c_fumPostId,$postId);
		
		$this->setContextAttributes($curSchedRow);
	} // postExposed
	
	
} // forumShareCd
?>
