<?php
/**
	File name : scheduler.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To manage the forum posts chronologically with many automated function.
	
	Main functions :
		addTask()
		actionOnRow() ---> --->  forumShareCd::setContextAttributes()
*/
class scheduler extends oTop{
	

	function __construct(&$tagsFu,&$shrdCd){
		parent::__construct();
		
		$this->tagsFu= &$tagsFu;
		$this->shrdCd= &$shrdCd;
		$this->xRgt= &$shrdCd->xRgt;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		$glob->globWatchNSQ= true;
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->fls= &$tagsFu->fls;
		$this->tools= &$tagsFu->tools;
		$this->rMg= &$tagsFu->rMg;
		$this->aSql= &$tagsFu->aSql;
		$this->dtb= &$tagsFu->dtb;
		// $this->cacheWr= &$tagsFu->cacheWr;
		$this->cacheR= &$tagsFu->cacheR;
			
		// Limits for _c_fumSchedId
		define('_c_fumSchdIdStart','1000');
		define('_c_fumSchdIdEnd','999999');
		
		define('_c_deleteSchedId','deleteSchedId');
		define('_c_weakDelSchedId','weakDelSchedId');
		define('_c_directActSchedId','directActSchedId');
		
		
		/*	
			Specific descriptions of what was created to store inside the _c_fumSchedSuParam field
		*/
		define('_c_schedPgName','pN');		// suporting page name (so the following information are only (a-b) numerical Ids)
		
		
		define('_c_schedCurXbr','cX');		// curXBranch
		define('_c_schedNewXbr','nX');		// new XBranch
		
		/* Intersting case : When a new thread is created both threads get the same value.
				When on an already created thread the new one is at ko
			By the way this is formal information because pratically there is no need for thread-cache management because
			it's cared by at the XBranch level and at the pack level.
		*/
		define('_c_schedCurThr','cT');		// current ...previous Thread Id
		define('_c_schedNewThr','nT');		// new current Thread Id
		
		// Intersting case : when a new pack is created the previous one must have its cache deleted to maintain a geom links connection.
		define('_c_schedCurPack','cK');		// curThreadPack
		define('_c_schedNewPack','nK');		// new ThreadPack
		
		define('_c_schedNewUpdate','nU');	// simple updating
		
		define('_c_schedSuParamDescrStr',' (pN, cX, nX, cT, nT, cK, nK, nU)');		// Supplementary parameters description string (just for display)
		define('_c_schedKo',_c_ko);		// no operation for the considered slot		
				
		// One complete supplement empty row :
		$this->emptySupParamV= array(_c_schedPgName=>_c_ko, _c_schedCurXbr=>_c_ko, _c_schedNewXbr=>_c_ko, _c_schedCurThr=>_c_ko, _c_schedNewThr=>_c_ko, _c_schedCurPack=>_c_ko, _c_schedNewPack=>_c_ko, _c_schedNewUpdate=>_c_ko);

		// One full scheduling empty row (exact match of the scheduling table)
		$this->emptySchedParamV= array(_c_fumSchedId=>_c_ko, _c_fumSchedPostId=>_c_ko, _c_fumSchedUsrId=>_c_ko, 
			_c_fumSchedAction=>_c_ko, _c_fumSchedAcceptTm=>_c_ko, _c_fumSchedHumanTm=>_c_ko, _c_fumSchedSuParam=>_c_ko);

	} // construct
	
	
	/**
		Input ;
			postId,$usrId,$task
			$suP :supplementary parameters passed as strings. Can use any separation algorithm,
				so simplest first, just commas! Later may have to use tags and parse if the content is complicated,
				but ithe algorithm can stays localy adapted with the sort of action.
		Also see : function actionOnRow(&$row)
	*/
	function addTask($postId,$usrId,$task,$suP='',$realSched=true){
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$xRgt= &$this->xRgt;
		$rights= $xRgt->ownPostChgRght();
				
		if ($realSched){		
			$taskId= $this->freeId();
		}else{
			$taskId= 'manualTaskId';	// one at a time
		}
		
		$taskTm= $this->taskTime();
		$stamp= $fls->timeStamp($taskTm);
		
		// Exactly 7 fields inside _c_fumSchedTN, the post content is just added for the scheduler display.
		$row= array($taskId,$postId,$usrId,$task,$taskTm,$stamp,$suP);
		if ($realSched){
			$dtb->newRecFromV(_c_fumSchedTN,$row);	// Adds the task !!
		
			$nxTm= $dtb->getGenVar('fumSchedNexTm');
			if ($nxTm===_c_ko || $nxTm>$taskTm){
				// Specific fisrt added action == Most urgent scheduled time (because nothing else to do)
				$dtb->setGenVar('fumSchedNexTm',$taskTm);
			}
		}
		
		if ($realSched){
			return $taskId;	 // returns the current task index.
		}else{
			return $row;
		}
	} // addTask	

	/**
		Execute the action on and specified by the given row
	*/
	function actionOnRow(&$row){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$shrdCd= $this->shrdCd;
		
		$schedId= $row[_c_fumSchedId];
		$curAct= $row[_c_fumSchedAction];
		$postId= $row[_c_fumSchedPostId];
		$userId= $row[_c_fumSchedUsrId];
		$suParam= $row[_c_fumSchedSuParam];
		switch ($curAct){
			case _c_fumSchedActPost:
				// Accept the concerned post
				$shrdCd->postExposed($row);
				
				$curLg= $shrdCd->getPostLg($postId);
				$dtb->setGenVar(_c_fumSmryFlagPrfx.$curLg,_c_ok);
			break;
			
			case _c_fumSchedActTrans:
				// Accept the concerned transfer
				$shrdCd->coreTransPrToPub($row);
			break;
			
			case _c_fumSchedActImg:
				// Deal with the forum user images
				$shrdCd->usrImgTranfer($userId);
			break;
			
			default:;
		} // switch
		
		$dtb->delTableRecord(_c_fumSchedTN,_c_fumSchedId,$schedId);
	} // actionOnRow


	/**
		Complete the given sup paramer vector
			Input :
				index and value to be assigned.
				$v : the original vector
	*/
	function complSupParamV($i,$val, $vect=false){
		$tools= &$this->tools;

		if ($vect===false){
			$vect= $tools->cpyArray( $this->emptySupParamV );
		}
	
		$vect[$i]= $val;
		return $vect;
	} // complSupParamV
	

	/**
		Returns the specified task vector of supplementary parameters.from the database.
			Input : $taskId
	*/
	function getSuParam($taskId){
		$dtb= &$this->dtb;
		$supS= $dtb->getElem(_c_fumSchedTN, _c_fumSchedId,$taskId, _c_fumSchedSuParam);
		return $this->supStrToSupV($supS);
	} // getSuParam
	
	// Supplementary string to supplementary vector (array).
	function supStrToSupV(&$supS){
		$tools= &$this->tools;
		
		if (is_string($supS)){
			$supV= $tools->trimStrToV($supS);
			return $tools->arrayCombine($this->emptySupParamV,$supV);
		}else{
			return $supS; // some cases of manual interventions, $supS is already an array
		}
	} // supStrToSupV
	

	/**
		Input : $taskId, $taskV : task vector of supplementary parameters
		Output : write $paramStr at its $taskId database place.
	*/
	function setSuParam($taskId, &$taskV){
		$dtb= &$this->dtb;
		$paramStr= $this->supVToSupStr($taskV);
		$dtb->setElem(_c_fumSchedTN,  _c_fumSchedSuParam,$paramStr,  _c_fumSchedId,$taskId);
	} // setSuParam
	
	// Supplementary vector to supplementary string.
	function supVToSupStr(&$v){
		$tools= &$this->tools;
		return $tools->arrayToStr($v,', ');
	} // supVToSupStr


	/**
		Returns the current free scheduler Id and increment the freeId variable.
	*/
	function freeId(){
		$dtb= &$this->dtb;
	
		$fSI= $dtb->quickGetGenVar('fumFreeSchedId');
		$dtb->setGenVar('fumFreeSchedId',$fSI+1);
		return $fSI;
	} // freeId

	/**
	*/
	function taskTime(){
		$delay= $this->scheduledSec();
		return time()+$delay;
	} // taskTime
	
	/**
		Returns the number of second to postpone/differ the action if the scheduler is active 
		and returns false if not active = checking done manually
	*/
	function scheduledSec(){
		$dtb= &$this->dtb;
		$xRgt= &$this->xRgt;

		if ($xRgt->ownPostChgRght()){
			return $dtb->getGenVar('fumMasterPostponing');
		}else{
			return $dtb->getGenVar('fumNbScndSchdlr');
		}
	} // scheduledSec


	/**
	*/
	function okButton($url,$alt){
		$caps= &$this->caps;
		$img= $caps->image($caps->imgSrc('ok.png',_c_ok),$alt,'fumImgBtt');
		return $caps->linkTC($url,$img,$alt,'fumImgBtt').$caps->span(' ','fumStd');			
	} // okButton
	
	/**
	*/
	function rightButton($url,$alt){
		$caps= &$this->caps;
		$img= $caps->image($caps->imgSrc('right.png',_c_ok),$alt,'fumImgBtt');
		return $caps->linkTC($url,$img,$alt,'fumImgBtt','_blank').$caps->span(' ','fumStd');			
	} // rightButton
	

	/**
	*/
	function dsplActiveTbl(&$shrdCd){
		$shrdCd= &$this->shrdCd;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$rMg= &$this->rMg;
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;

		// Execute some manual action call with this graphical interface
		if ($rMg->wRights){
			$scheDelId= $tools->getVal(_c_deleteSchedId);
			if ($scheDelId!==false){
				$schedRec= $dtb->getElem(_c_fumSchedTN, _c_fumSchedId,$scheDelId);
				$postId= $schedRec[_c_fumSchedPostId];
				$shrdCd->deleteSpecPost($postId);	// Delete the post itself.and the scheduled record
			}
			
			$scheDelId= $tools->getVal(_c_weakDelSchedId);
			if ($scheDelId!==false){
				if ( $dtb->elementExists(_c_fumSchedId,$scheDelId,_c_fumSchedTN) ){
					$dtb->delete(_c_fumSchedTN,$scheDelId);		// Only deletion inside the scheduler list
				}
			}
			
			$actionId= $tools->getVal(_c_directActSchedId);
			if ($actionId!==false){
				$row= $dtb->getElem(_c_fumSchedTN, _c_fumSchedId,$actionId);
				$this->actionOnRow($row);
			}
		}

		// Display
		$dspl= $caps->heaDiv('width:1500px; border: 0px solid blue;');
		$dspl.= $caps->tblHeadTag( $caps->matCss('schedTable') );
		$curT= time();
		
		
		$cond= $aSql->fullCond(_c_fumSchedAcceptTm,$curT,'>');
		$rsr= $dtb->slctResource(_c_fumSchedTN,$cond);
		
		// To display the column title
		$cRow= '';
		$vColNm= $dtb->tblColumnNames(_c_fumSchedTN,_c_UsrDbName);
		if ($vColNm!==false){
			$ndOfCol= sizeof($vColNm);
			reset($vColNm);
			foreach ($vColNm as $key=>$val){
				if ($val===_c_fumSchedSuParam){
					$val.= _c_schedSuParamDescrStr;
				}
				
				$cRow.= $caps->tblTd($caps->span($val,'fumSched'),$caps->matCss('schedTd'))._c_R;
			}
		}else{
			$glob->userError(_c_UsrDbName.'::'._c_fumSchedTN.$glob->el(' has no columns!','kmhm'));
		}
		
		$cRow.= $caps->tblTd($caps->span('Title / Other Info','fumSched'),$caps->matCss('schedTd'))._c_R;
		$dspl.= $caps->tblTr($cRow)._c_R;
		
		while ( $schedRow=$dtb->fetchAry($rsr) ){
			$curAct= $schedRow[_c_fumSchedAction];
			$curPostId= $schedRow[_c_fumSchedPostId];
			
			$cRow= '';
			reset($schedRow);
			foreach ($schedRow as $key=>$cellInfo){
				if ($key===_c_fumSchedId){	
					$schedId= $cellInfo;
							
					$urlBase= $tools->urlCurPg().'&'._c_tMenCateg.'=schedlr&'.
						_c_fumUserId.'='.$shrdCd->smartUserId();
						
					$urlT= $urlBase.'&'._c_deleteSchedId.'='.$schedId;
					$urlWeakT= $urlBase.'&'._c_weakDelSchedId.'='.$schedId;	// weak trash, delete only the event.
					$urlA= $urlBase.'&'._c_directActSchedId.'='.$schedId;	// direct execution of the action
					
					$postId= $schedRow[_c_fumSchedPostId];
					$postRow= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$postId);
					$xIndx= $postRow[_c_fumXIndx];
					$forcedPage= $postRow[_c_fumMotherId];
					
					if ($curAct===_c_fumSchedActPost || $curAct===_c_fumSchedActTrans){
						$urlVis= $shrdCd->generalLinkFromPR($xIndx,$postId,$forcedPage);
						$visPost= $this->rightButton($urlVis,$glob->el('To visualise this post!','kbeq'));
					}else{
						$visPost= '';
					}
					
					$cellInfo= $shrdCd->trashButton($urlT,$glob->el('Trash the concerned event and associated post or image!','kben'),'warningTrash.png')._c_sT.
						$shrdCd->trashButton($urlWeakT,$glob->el('Only trash the concerned event!','kbeo'),'trash.png ').$schedId._c_sT.
						$this->okButton($urlA,$glob->el('To accept this event in advance of the schedule!','kbep'))._c_sT.
						$visPost;

					$cellInfo= $caps->span($cellInfo,'fumSchedTxt');
					$cellStr= $caps->sDiv($cellInfo,'width:200px');
				}else{
					$cellStr= $caps->span($cellInfo,'fumSchedTxt');
				}
				$cRow.= $caps->tblTd($cellStr,$caps->matCss('schedTd'))._c_R;
			}

			// Post title + general information
			switch ($curAct){
				case _c_fumSchedActPost:
					$supInfo= 'Title : '.$dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$curPostId, _c_fumMessTtl);
					
					$curBdy= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$curPostId, _c_fumMessBody);
					$supInfo.= _c_.'Body : '.$this->sumrStr($curBdy);
				break;
				
				case _c_fumSchedActTrans:
					$supInfo= 'Title : '.$dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$curPostId, _c_fumMssTtl);
					
					$curBdy= $dtb->getElem(_c_forumPostsTbl, _c_fumPostId,$curPostId, _c_fumMssBdy);
					$supInfo.= _c_.'Body : '.$this->sumrStr($curBdy);
				break;
				
				case _c_fumSchedActImg:
					$userId= $schedRow[_c_fumSchedUsrId];
					$supInfo= $this->secretThumbs($userId,$shrdCd);
				break;
				
				default: $supInfo='';
			} // switch
			
			$cRow.= $caps->tblTd($caps->span($supInfo,'fumSchedTxt'),$caps->matCss('schedTd'))._c_R;
			$dspl.= $caps->tblTr($cRow)._c_R;
		}
	
		$dspl.= $caps->tblEndTag();
		$dspl.= $caps->enDiv();
		return $dspl;
	} // dsplActiveTbl
	
	
	/**
	*/
	function secretThumbs($userId,&$shrdCd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$mmBoxes= &$this->mmBoxes;
		
		$persoPath= $shrdCd->persoPath($userId);
		$fls->firstLevelFiles($fileVect,$persoPath);
		sort($fileVect);
		
		$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);
		$secretDir= $userRec[_c_fUsrSecretDir];
		
		$curMainPath= $persoPath.$secretDir;
		$curThumbsPath= $curMainPath.'/'._c_thumbsDirN;		
		$curPath= $curThumbsPath.'/';		
		$stdSpc= $caps->span(_c_,'pubImUpBr');	// duplicated
		
		$buff= $caps->heaDiv('width:410px; float:left; border:5px solid white;');
		$i= 0;
		$gotFLF= $fls->firstLevelFiles($fileVect,$curPath);	 // compute it again in case a consequent change was done above!
		if ($gotFLF){
			sort($fileVect);
			reset($fileVect);
			foreach ($fileVect as $key=>$fileName){
				$buff.= $stdSpc;
				
				$url= $tools->urlGivenPage('_file-manager')
					.'&mFilePath1='.$curMainPath
					.'&mFilePath2='.$persoPath
					.'&mmMode=thumbs';
					

				$imgDfN= $curPath.$fileName;
				$img= $caps->ttlImage($imgDfN,$fileName,'#','fumImg');
				$buff.= $caps->hLink($url,$img,'','_blank');
				$i++;
			}
		}
		$buff.= $caps->enDiv();
		return $buff;
	} // secretThumbs


	/**
		Returns a summary of the body string for a quick visualisation
	*/
	function sumrStr($s){
		$sz= strlen($s);
		if ($sz<150){
			return $s;
		}else{
			$sep= '...//...';
			$start= substr($s,0,50);
			
			$midPos= (int)round($sz/2);
			$mid= substr($s,$midPos,50);
			
			$end= substr($s,-50);
			return $start.$sep.$mid.$sep.$end;
		}
	} // sumrStr
	

	/**
		Execute the scheduled actions.
	*/
	function fcExecutes(){
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;
		
		$curTm= time();
		$cond= $aSql->fullCond(_c_fumSchedAcceptTm,$curTm,'<');
		$rsr= $dtb->slctResource(_c_fumSchedTN,$cond);

		while ( $row=$dtb->fetchAry($rsr) ){
			$this->actionOnRow($row);
		} // while
		
		/**
			Need to set the next task time (scan the table) or ok if nothing to do!
		*/
		$taskTm= $this->smallesTime();
		$dtb->setGenVar('fumSchedNexTm',$taskTm);
	} // fcExecutes
		

	/**
		Get the smallest time stored inside the table to set the 'fumSchedNexTm' general variable.
	*/
	function smallesTime(){
		return $this->smallestElem(_c_fumSchedTN,_c_fumSchedAcceptTm);
	} // smallesTime
	
	
	/**
		Return the smallest row relatively to a given field (retrograde it at the $dtb class level if used somewhere else)
		Input :
			$table : table name.
			$orderColN : name of the column to order by.
	*/
	function smallestElem($table,$orderColN){
		$aSql= &$this->aSql;
		$dtb= &$this->dtb;
		
		$res= $aSql->selectResource($table,'','*',$orderColN,false,1);
		$row= $aSql->fetchArray($res);
		if ($row!==false){
			return $row[$orderColN];
		}else{
			return _c_ko;
		}
	} // smallestElem
	
} // scheduler
?>
