/**
	File name : forumUsrMg.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**

	forumUsrMg::cryptGivenPwBox()
	
*/
function forumUsrMg(){

	/* ---------------------------------------------------------------
		Public global "Instance" Variables.
	*/
	this.pubGV= 'Public Global Variable';
	
	
	/* ---------------------------------------------------------------
		Public Methods "class functions" Interface.
	*/
	this.changeUsr= changeUsr;
	this.cryptGivenPwBox= cryptGivenPwBox;
	this.cryptThreePwBox= cryptThreePwBox;

	
	this.write= write;
	this.writeLn= writeLn;
	this.clearWrite= clearWrite;


	/* ---------------------------------------------------------------
		Private global "Instance" variable for the "class"
	*/
	var crLn= kk.crLn		// "\r\n";	often handy/shorter to have it locally.
	var suffix= '!!!!';		// an integrated exmple of class global (instance) variable.
	
	var privGV= 'Private Global Variable';
	

	/* -----------------------------------------------------------------------
		Methods definitions
	*/

	/**
	*/
	function changeUsr(url){
		var selVal= kk.getSelVal('selectUsrId');
		window.open (url+'&fumUserId='+selVal,'_self',false)
	} // changeUsr

	/**
		Crypt the given pw box with :
			(1) an autocrypt with the box given value.
			(2) crypt with the server given hash!
			
		Uses exmpl : 
			var cpw= genAsa.doCrypt(pw,pw);		// pw crypted with pw

	*/
	function cryptGivenPwBox(pwBoxNm,givenHash){
		var ptPw= document.getElementById(pwBoxNm);
		var pw= ptPw.value;
		
		var cpw= genAsa.doCrypt(pw,pw);		// pw crypted with pw		
		var c2pw= genAsa.doCrypt(givenHash,cpw);	// the hash crypted with the server stored password (calculated).
		ptPw.value=  c2pw;	// so can send it to the server through the password box
		
		return cpw;	// to be eventually used as a crypting key for some other info to crypt.
	} // cryptGivenPwBox


	/**
		This time the given hash is really used as the crypting key, so we can uncrypt
		the crypted information on the server side!
	*/
	function cryptGPwBoxWithHash(pwBoxNm,givenHash){
		var ptPw= document.getElementById(pwBoxNm);
		var pw= ptPw.value;
		
		var cpw= genAsa.doCrypt(pw,pw);		// pw crypted with pw		
		var c2pw= genAsa.doCrypt(cpw,givenHash);	// the hash crypted with the server stored password (calculated).
		ptPw.value=  c2pw;	// so can send it to the server through the password box
	} // cryptGPwBoxWithHash



	/**
	*/
	function cryptThreePwBox(pwBxNmA,pwBxNmB,pwBxNmC,givenHash){
		var cpw= cryptGivenPwBox(pwBxNmA,givenHash);
		
		cryptGPwBoxWithHash(pwBxNmB,cpw);
		cryptGPwBoxWithHash(pwBxNmC,cpw);
	} // cryptThreePwBox



	/* --------------------------------------------
		"Cloned" methods for usage easiness 
	*/
	function write(s){kk.write(s);}
	function writeLn(s){kk.writeLn(s);}
	function clearWrite(s){kk.clearWrite(s);}



	/**
	*/
	function chabl(){
	
	} // chabl


} // forumUsrMg
