<?php
/**
	File name : forumUsrMg.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Forum User Manager : so each forum user can manage its own information (email address. password, wall-post.
	list of posts. personal images etc.)
	
	[extPlugin name="forumUsrMg" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]	
	
	
	forumUsrMg::managePostWall()
*/
class forumUsrMg extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		
		$this->tagsFu= &$tagsFu;

		$this->glob= &$tagsFu->glob;	// access to some global values, sometimes methods
		$glob= &$this->glob;
		$glob->globWatchNSQ= true;
		
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
		
		$this->fls= &$tagsFu->fls;
		$this->caps= &$tagsFu->caps;
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$this->dtb;

		$this->hPwC= &$tagsFu->hPwC;
		$this->rights= &$tagsFu->rights;
		
		$this->imgP= &$tagsFu->imgP;
		$imgP= &$this->imgP;
		
		
		// Exception : can't use the constant _c_tMenCateg because it still not declared! Could declare
		// one class common to all forum activities, but not valuable for a single constant!
		$menuCateg= $tools->getVal('tMenCateg');
		
		define('_c_tMenSinglePost','singlePost');
		$singlePost= $tools->getVal(_c_tMenSinglePost);
				
		
		if ($menuCateg==='postWall' || $singlePost!==false || $tools->curPageName()=== '_scheduler'){
			include _c_toDeclPlugExt.'forum/forumShareCd.php';
			$this->shrdCd= new forumShareCd($tagsFu,$imgP);
		}else{
			include _c_toDeclPlugCntr.'forum/fumShrdCdLgt.php';
			$this->shrdCd= new fumShrdCdLgt($tagsFu,$imgP);
		}
		$shrdCd= &$this->shrdCd;
		$this->xRgt= &$shrdCd->xRgt;
		
		$tagsFu->instExplitCentralCls('forumBar');
		$glob->explCentralInclStanceJs('forumBar');		
		
		$this->captcha= &$shrdCd->captcha;
		$this->email= &$shrdCd->email;
		$this->assoc= &$shrdCd->assoc;
		
		
		include _c_toDeclPlugExt.'pubImUp/pubImUp.php';
		$this->pubImUp= new pubImUp($tagsFu,$imgP,$shrdCd);
		$pubImUp= &$this->pubImUp;	
		$pubImUp->fUsrMg= &$this;
		
		
		
		include_once _c_LibPath.'geomArray.php';	// could need include once, otherwise clash with the forum declaration
		$this->geomArray= new geomArray($tagsFu);
		$geom= &$this->geomArray;
		
		$chunkSz= $dtb->getGenVar('postIdsChunkLength');
		$geom->setChunkLength($chunkSz);
		
		
		$this->textMenus= &$tagsFu->explicitClasses['textMenus'];	// must declare textMenus at the xml2 level
		
		$tagsFu->includeSupFiles('forumUsrMg','debugDisplay');
		
		$tagsFu->attribVect['forumusrmg']= false;
		
		$tagsFu->coreSetexplCss('external/forum/','forum');
		
		// To define the url variable used for an email change confirmation, returns the current hash
		define('_c_fumEmailChange','fumEmailChange');

		$tagsFu->attribVect['dsplscheduler']= false;
	} // construct


	/**
		This associative array must hold all the class's tags names, so the cms can declare them
	*/
	function tags(){
		return array('forumusrmg','dsplscheduler');
	} // tags
	
	
	/**
	*/
	function usrMgBaseUrl($userId){
		$tools= &$this->tools;
		
		$b= $this->usrMgKernelUrl($userId);
		$menuCateg= $tools->getVal(_c_tMenCateg);
		if ($menuCateg!==false){	
			$b.= $tools->addUrlVar(_c_tMenCateg,$menuCateg);
		}
		return $b;
	} // usrMgBaseUrl	
	
	
	/**
	*/
	function usrMgKernelUrl($userId){
		$tools= &$this->tools;
		
		$b= $tools->urlCurPg();
		$b.= $tools->addUrlVar(_c_fumUserId,$userId);
		return $b;		
	} // usrMgKernelUrl



	/**
	*/
	function selectFriendlyVect($usrV,$onlyCheckedEMail=false){
		$resultV= array();
		reset($usrV);
		foreach ($usrV as $key=>$val){
			$subV= $usrV[$key];
			$nKey= $subV[_c_fUserId];
			
			$curVal= $subV[_c_fUserPseudo].', N='.$subV[_c_fUserNbPost];
			if ($onlyCheckedEMail){
				if ($subV[_c_fUserMok]===_c_ok){
					$resultV[$nKey]= $curVal;
				}
			}else{
				$resultV[$nKey]= $curVal;
			}
		}
		ksort($resultV);
		return $resultV;
	} // selectFriendlyVect
		
				
	/**
		[forumUsrMg /]
			Forum User Manager : the main function!
	*/
	function tg_forumusrmg(&$v,&$bd){
		$tagsFu= &$this->tagsFu;	
		$shrdCd= &$this->shrdCd;
		$xRgt= &$this->xRgt;
		
		$glob= &$this->glob;
		$textMenus= &$this->textMenus;	
		$tools= &$this->tools;
		$fls= &$this->fls;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		$rights= &$this->rights;
		$email= &$this->email;
		$captcha= &$this->captcha;
		$pubImUp= &$this->pubImUp;
		
				
		$fUrsSignedIn= $shrdCd->isSignedIn;
		$curLogUsrId= $shrdCd->fumLogUserId();
						
		$userId= $shrdCd->smartUserId();	// just to surf on the most probable forum user in case it's defined
		if ($userId===false){
			$shrdCd->getPostedUserIds($userId,$pseudo);
		}
		
		$urlCurPgAndUId= $tools->urlCurPg().$tools->addUrlVar(_c_fumUserId,$userId);
		
		// ---------
		$avatarPath= $shrdCd->avatPath($userId);
		$curAvatFN= $avatarPath.$shrdCd->getCurAvatar($userId);		// the original avatar
		$swapAvaFN= $avatarPath.$pubImUp->swapBufferNm($userId);		// a swap path-name for the two previous avatar.
		
		$this->saveImgWallStr();		
		
		$buff= '';
		$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);
		$pseudo= $userRec[_c_fUserPseudo];
				
		$stdSpc= $caps->span(_c_BrFlux,'fumUsrMgStd');	
		$buff.= $stdSpc;	
	
	
		$pgBack= $tools->gostVal(_c_fMotherPage, $dtb->lgCorrectPg(_c_permanDefPage) );
		$arCmd[_c_mothrPage]= _c_ko;
		$urlBack= $tools->urlGivenPage($pgBack,$arCmd);
		$buff.= $caps->linkImg($caps->imgSrc('backRed.png',_c_ok), $glob->sl('Back!','kbmj'),$urlBack, 'fAvatar');
		
		$buff.= $caps->lnImg($curAvatFN.$this->rndSffx(), $pseudo. $glob->sl('\'s Avatar','kbmh'), '', 'fAvatar');
		
		if ( ($shrdCd->correctlySignedIn() && $userId===$shrdCd->fumLogUserId()) || $rights->quickWMRight() ){
			$buff.= $caps->span($pseudo. $glob->sl('\'s User Manager ','kbmi'),'fumUsrMgTtl');
		}else{
			$buff.= $caps->span($pseudo. $glob->sl('\'s User Public Infos ','kbnc'),'fumUsrMgTtl');
		}
		
			
		$rootUrl= $tools->urlGivenPage('_4um_message_form');	// Got to define a url
		$shrdCd->getXCodeParams($xCodeIndx,$xCodeSup);
		$buff.= $shrdCd->loginDynLabel($rootUrl,$xCodeSup);
		
		
		/* ---------------------------
			Change user with a select
		*/
		$buff.= $stdSpc.$stdSpc;
		$buff.= $caps->span($glob->sl('Browse','kbby'),'fumUsrMgB');
		
		$fullUsrTbl= $dtb->subTable(_c_fsmplUsersTbl);		
		$resultV= $this->selectFriendlyVect($fullUsrTbl);					
		$comboUrl= $tools->urlCurPg();
		$js= $caps->jsFunctCallStr('onChange','forumUsrMg.changeUsr',1,0,$comboUrl); // formMM directly in the DTB user code !!
		
		$buff.= $caps->comboBox('selectUsrId',$userId,$resultV,$js,true);
		$buff.= $stdSpc;
		
		// display image wall
		$buff.= $pubImUp->frontWallDsplStr();		
		
		$menuCateg= $tools->getVal(_c_tMenCateg);
		
		
		// Vectorisation of the full menus, dfining here the Menu Binomes :
		$lPostMB= array( 'lPost' => $glob->sl('Posts','kbca'));
		$avatMB= array('avat' => $glob->sl('Avatar','kbcb'));
		$imgMB= array('img' => $glob->sl('Uploader','kbcc'));
		$imgWallMB= array('imgWall' => $glob->sl('Image wall','kbcd'));
		$postWallMB= array('postWall' => $glob->sl('Main Post','kbce'));
		$defMailMB= array('defMail' => $glob->sl('Used email','kbcf'));
		$intMailMB= array('intMail' => $glob->sl('Internal Mailer','kbcg'));
		$zoomMB= array('zoom' => $glob->sl('Zoom','kbch'));
		$chgPwMB= array('chgPw' => $glob->sl('Pw','kbci'));
		
		
		$onOwnAccount= $fUrsSignedIn && $curLogUsrId===$userId;
		if ( $onOwnAccount || $rights->wRights){
			$usrEMailIsValid= $userRec[_c_fUserMok]===_c_ok;
		
			// -----------------------------------------------------------------------------
			// Xml2 way of passing the forumUsrMg class !! Except for $this
			if ($xRgt->fUsrImgRght()){
				$strMenu= array($lPostMB, $avatMB, $imgMB, $imgWallMB, $postWallMB, $defMailMB, $intMailMB, $zoomMB, $chgPwMB);
			}else{
				$strMenu= array($lPostMB, $avatMB, $postWallMB, $defMailMB, $intMailMB, $chgPwMB);
			}
			
			$buff.= $textMenus->setMenusCoreMB($strMenu,$this,'baseUmMenu');
				
			$buff.= $stdSpc;
			if (!$onOwnAccount){
				$buff.= $stdSpc;
				$buff.= $caps->span($glob->el('Warning, you are accessing ','kmeb').$pseudo.$glob->el('\'s full blown account without being logged as ','kmec').$pseudo.$glob->el('! For example useful for...','kmed') ,'fumUsrMgWarn');
				$buff.= $stdSpc;	
			}
			
			switch ($menuCateg){
				case 'avat':
					$buff.= $this->changeAvatar($userId,$urlCurPgAndUId,$stdSpc);
				break;
				
				case 'img':
					if ($xRgt->fUsrImgRght()){
						$buff.= $this->manageImages();
					}
				break;
	
				case 'imgWall':
					if ($xRgt->fUsrImgRght()){
						$buff.= $this->imgWallStr();
					}
				break;
				
				case 'zoom':
					if ($xRgt->fUsrImgRght()){
						$buff.= $this->imgZoom();
					}
				break;
				
				case 'postWall':
					$buff.= $this->managePostWall();
				break;
				
				case 'defMail':
					$buff.= $this->manageDefEMail($userRec,$urlCurPgAndUId,$usrEMailIsValid,$stdSpc);
				break;
	
				case 'intMail':
					$buff.= $this->sendLocalMail($userRec,$urlCurPgAndUId,$usrEMailIsValid,$stdSpc);
				break;
				
				case 'chgPw':
					$buff.= $this->changePassword($userRec,$urlCurPgAndUId,$usrEMailIsValid);
				break;
	
				case 'lPost':
				default:
					$buff.= $this->messageList($userId,$stdSpc);
				break;
			} // switch
		}else{
			/* -------------------------------------------------------------------------
				Standard POST MESSAGES.
			*/
			$strMenu= array($lPostMB, $postWallMB,$zoomMB);
			$buff.= $textMenus->setMenusCoreMB($strMenu,$this,'baseUmMenu');
			
			switch ($menuCateg){
				case 'zoom':
					$buff.= $this->imgZoom();
				break;
	
				case 'postWall':
					$buff.= $this->managePostWall();
				break;
				
				case 'lPost':
				default:
					$buff.= $this->messageList($userId,$stdSpc);
				break;
			} // switch
		}
		
		return $buff;
	} // tg_forumusrmg
	
	
	/**
		Calculates the image wall dispplay string.
	*/
	function imgWallStr(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$shrdCd= &$this->shrdCd;
	
		$stdSpc= $caps->span(_c_BrFlux,'fumUsrMgStd');	
		$buff= '';
		
		$userId= $shrdCd->curErsatzLogUser();
		
		$urlCurPgAndUId= $this->usrMgBaseUrl($userId);
		$buff.= $caps->headForm($urlCurPgAndUId.'','imgWallForm');		
		
		$buff.= $caps->span($glob->sl('When you click in the check boxes of the Uploader ...','kbdb'),'fumUsrMgStd');	
		$buff.= _c_._c_;
			
		$cWallTxt= $tools->postVal('imgWallTxtWgt');
		if ($cWallTxt===false){
			$cWallTxt= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUsrImgWallTxt);
		}
		
		$buff.= $caps->textArea('imgWallTxtWgt',10,'w',$cWallTxt, $caps->matStyl('width:95%;').$caps->matCss('fumUsrMgStd'));
		
		$buff.= _c_._c_;		
		$buff.= $caps->onClickBut('fumImgWallBut',$glob->sl('Send','kaat'),'',$caps->matCss('pubImUpStdB'));
		
		$buff.= $stdSpc;
		$buff.= $caps->endForm();
		return $buff;
	} // imgWallStr

	
	/**
	*/
	function saveImgWallStr(){
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$shrdCd= &$this->shrdCd;
		
		$userId= $shrdCd->curErsatzLogUser();
		
		$cWallTxt= $tools->postVal('imgWallTxtWgt');
		if ($cWallTxt!==false){
			$dtb->setElem(_c_fsmplUsersTbl, _c_fUsrImgWallTxt,$cWallTxt, _c_fUserId,$userId);	// got a post
		}
	} // saveImgWallStr
	
	
	/**
	*/
	function managePostWall($postId=false){
		$shrdCd= &$this->shrdCd;	
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		$shrdCd= &$this->shrdCd;
		
		$userId= $shrdCd->smartUserId();
		$singlePostUnderPostList= $tools->getVal(_c_tMenSinglePost);
		
		$buff= '';
		if ($shrdCd->fumLogUserId()===$userId && $shrdCd->correctlySignedIn() && $singlePostUnderPostList===false){
			$stdSpc= $caps->span(_c_BrFlux,'fumUsrMgStd');	
			$buff.= $this->choseWallPost();
		}
		
		if ($postId===false){
			$postId= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUsrPostWallId);
		}
		
		$buff.= $shrdCd->freePost($postId);
		return $buff;
	} // managePostWall
	
	
	/**
	*/
	function manageImages(){
		$pubImUp= &$this->pubImUp;	
		return $pubImUp->pubImgMg();
	} // manageImages

	
	/**
		AVATAR CHANGING.
	*/
	function changeAvatar($userId,$urlCurPgAndUId,$stdSpc){
		$tagsFu= &$this->tagsFu;	
		$shrdCd= &$this->shrdCd;	
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$pubImUp= &$this->pubImUp;

		$avatarPath= $shrdCd->avatPath($userId);
		$curAvatFN= $avatarPath.$shrdCd->getCurAvatar($userId);		// the original avatar
		$swapAvaFN= $avatarPath.$pubImUp->swapBufferNm($userId);		// a swap path-name for the two previous avatar.
		$buffAvatFN= $avatarPath.$pubImUp->buffAvatarNm($userId);		// the newly created avatar proposed to the user
		
		$add= $this->menuCategUrlAdd();
				
		$buff= '';
		$fgcPN= $dtb->getGenVar('fumGenConditionsPN');
		
		/*
			--> if wishing to explain what an abstract avatar is ... explanation nit written
			$url= $tools->urlGivenPage($fgcPN).$tools->signet('avatar');
			$url.= $add;
			$aaExplicLn= $caps->hL($url,$glob->sl('abstract avatar','kbck'),'fumUsrMgB','_blank');
		*/
		$aaExplicLn= $caps->span($glob->sl('abstract avatar','kbck'),'fumUsrMgB','_blank');
		
		
		$url= $urlCurPgAndUId.$tools->addUrlVar('newAvatGen',_c_ok);
		$url.= $add;
		$askNewGenAvat= $caps->hL($url,$glob->sl('ask for a new random image','kbcm'),'fumUsrMgB');	
			
		$url= $urlCurPgAndUId.$tools->addUrlVar('swapAvat',_c_ok);
		$url.= $add;
		$swapAvat= $caps->hL($url,$glob->sl('swap it','kbco'),'fumUsrMgB');			
		$buff.= $caps->span($glob->sl('Your ','kbcj').$aaExplicLn.$glob->sl(' is displayed on the top left ...','kbcl').$askNewGenAvat.$glob->sl(' and ','kbcn').
			$swapAvat.$glob->sl(' with the actual avatar ...','kbcp'),'fumUsrMgStd');			
		$buff.= $stdSpc;	
		$buff.= $stdSpc;
		
		$newAvatGen= $tools->getVal('newAvatGen');
		if ($newAvatGen===_c_ok){
			// generate and display a new avatar
			$result= $shrdCd->createAvatar($tagsFu,$buffAvatFN);
		}
		
		if (file_exists ($buffAvatFN)){
			$buff.= $caps->lnImg($buffAvatFN.$this->rndSffx(), 'Proposed Avatar','','fAvatar');
		}
		
		$swapAvat= $tools->getVal('swapAvat');
		if ($swapAvat===_c_ok){
			$fls->swap($buffAvatFN,$curAvatFN,$swapAvaFN);
		}
		
		return $buff;
	} // changeAvatar
	
			
	/**
		EMail Sending..
	*/
	function sendLocalMail($userRec,$urlCurPgAndUId,$usrEMailIsValid,$stdSpc){			
		$tagsFu= &$this->tagsFu;	
		$glob= &$this->glob;	
		$shrdCd= &$this->shrdCd;	
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$caps= &$this->caps;
		$hPwC= &$this->hPwC;
		$captcha= &$this->captcha;
		$email= &$this->email;

			
		$userId= $userRec[_c_fUserId];
		$add= $this->menuCategUrlAdd();
		
		$buff= '';
		if ($usrEMailIsValid){
			$debriefingMess= '';
		
			// SEND THE EMAIL
			$curTitleVal= $tools->postVal('mailTitle');
			$ttlSz= strlen($curTitleVal);
			$gotPosted= $curTitleVal!==false;
			
			$curMailBodyVal= $tools->postVal('mailMText','');
			$bdSz= strlen($curMailBodyVal);
			
			// SIZE EMAIL
			$minTtlSz= $dtb->getGenVar('fumUMgMinTitleSz');
			$maxTtlSz= $dtb->getGenVar('fumUMgMaxTitleSz');
			$minBdSz= $dtb->getGenVar('fumUMgMinBodySz');
			$maxBdSz= $dtb->getGenVar('fumUMgMaxBodySz');
			$ttlSzOk= $tools->betwOrEqual($minTtlSz,$ttlSz,$maxTtlSz);							
			$bdSzOk= $tools->betwOrEqual($minBdSz,$bdSz,$maxBdSz);
			
			
			$captchaOk= $this->mngCaptAnswer($debriefingMess,$gotPosted);
			
			$eMailAcknowledge= false;
			if ($gotPosted){
				if ($ttlSzOk && $bdSzOk && $captchaOk){
					$selectedUserId= $tools->postVal('selectMailUsrId');
					$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$selectedUserId);
					$cryptedEmailTo= $userRec[_c_fUserMail];
					
					$mailSubject= $curTitleVal;
					$mailBody= $curMailBodyVal;
					
					$fumNm= $dtb->getGenVar('fumName');
					$titleFrom= 'Forum '.$fumNm;
					
					$emailFrom= $dtb->getGenVar('fumEMailFrom');
					$eMailAcknowledge= $shrdCd->sendEMailFCA($cryptedEmailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom);
					
					// #addAMailSavingFileHere
					if ( $dtb->getGenVar('eMailSaveForumExchg')===_c_ok ){
						// Manage the email copy
						$emCps= '';
						$emCps.= $glob->sl('EMail from : ','kbdr').$cryptedEmailTo._c_R;
						$emCps.= $titleFrom._c_R;
						$emCps.= $glob->sl('EMail To : ','kbds').$emailFrom._c_R;
						$emCps.= $glob->sl('Subject : ','kbdt').$mailSubject._c_R._c_R._c_R;
						$emCps.= $mailBody._c_R;						
						$dfn= _c_UsrMailFumStorP.$fls->timeStamp().$fls->safIdStr(substr($mailSubject,0,30));
						$fls->strToFile($dfn,$emCps);
					}
					
				}else{
					if (!$ttlSzOk){
						$debriefingMess.= $caps->span(_c_.$minTtlSz._c_ltEquSpc.$glob->sl('The title must stay inside these character limits','kbdu')._c_ltEquSpc.$maxTtlSz,'fumUsrMgWarn');
					}
					if (!$bdSzOk){
						$debriefingMess.= $caps->span(_c_.$minBdSz._c_ltEquSpc.$glob->sl('The mail body must stay inside these character limits','kbdv')._c_ltEquSpc.$maxBdSz,'fumUsrMgWarn');
					}
				}
			}
		
			// EMAIL FORM			
			$buff.= $caps->heaDiv(' border: 3px solid blue; padding:5px;');
			$buff.= $caps->headForm($urlCurPgAndUId.$add,'emailForm');
			
			$buff.= $caps->span($glob->sl('To send an email to any of the specified user :','kbdw'),'fumUsrMgTtl2');
			$buff.= $stdSpc;
			$buff.= $caps->span($glob->sl('Remarks : (1) only users who have had their email automatically checked','kbbv'),'fumUsrSmallPrint');
			$buff.= $stdSpc;
			$buff.= $stdSpc;
			
			$buff.= $caps->span($glob->sl('EMail to : ','kbds'),'fumUsrMgB');
			$fullUsrTbl= $dtb->subTable(_c_fsmplUsersTbl);		
			$resultV= $this->selectFriendlyVect($fullUsrTbl,true);	
			$buff.= $caps->comboBox('selectMailUsrId',$userId,$resultV,'',true);	// not Ids, but pseudos !!!!!
			
			if ($curTitleVal===false){
				$curTitleVal= '';
			}else if ($eMailAcknowledge===true){
				// The message was sent successfully (add a captcha later), to discourage spammer-members!
				$debriefingMess.= $caps->span(_c_Ns.$glob->sl('Congratulation, the message was sent successfully at : ','kbdx'),'fumUsrMgGood');
				$t= time();
				$h= date('H',$t);
				$i= date('i',$t);
				$s= date('s',$t);
				$debriefingMess.= $caps->span($h.':'.$i.':'.$s,'fumUsrMgGood');
			}
			
			$buff.= $stdSpc;
			$buff.= $captcha->completeCaptcha($userId,'pairToPairMail');
			$buff.= $caps->onClickBut('EMailBUt',$glob->sl('Send','kaat'),'',$caps->matCss('pubImUpStdB'));
			$buff.= $debriefingMess;
			
			$buff.= $stdSpc;
			$buff.= $caps->span($glob->sl('Title : ','kbdy'),'fumUsrMgB');
			
			// $buff.= $caps->	textBx('mailTitle',$curTitleVal,'w','fumUsrMgStd');
			$buff.= $caps->	textBox('mailTitle',$curTitleVal,'w', $caps->matStyl('width:98%').$caps->matCss('fumUsrMgStd') );
			
			$buff.= $stdSpc;
			
			$buff.= $caps->span($glob->sl('Message Body : ','kaaf'),'fumUsrMgB');
			$buff.= $caps->textArea('mailMText',5,'w',$curMailBodyVal, $caps->matStyl('width:98%').$caps->matCss('fumUsrMgStd') );
			$buff.= $caps->endForm();
			$buff.= $caps->enDiv();
			
			// End if ($usrEMailIsValid)
		}else{
			$buff.= $caps->span($glob->sl('To contact directly other users ...','kbdz'),'fumUsrMgBl');	
		}
			
		return $buff;
	} // sendLocalMail


	/**
		Default E-MAIL. ... change / validate it.
	*/
	function manageDefEMail(&$userRec,$urlCurPgAndUId,$usrEMailIsValid,$stdSpc){
		$tagsFu= &$this->tagsFu;	
		$shrdCd= &$this->shrdCd;	
		$glob= &$this->glob;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$caps= &$this->caps;
		$hPwC= &$this->hPwC;
		$assoc= &$this->assoc;
		$email= &$this->email;


		$userId= $userRec[_c_fUserId];
		$add= $this->menuCategUrlAdd();
		
		$buff= '';
		
		// Updates the new email only with the correct Email hash !! (only accept a new valid email address)
		$hashEC= $tools->getVal(_c_fumEmailChange);
		
		$hashStr= $assoc->get($userId,'newEMailHsh');
		if ($hashEC!==false && $hashEC===$hashStr){
			// Got a valid hash from an email link clicking, so can SAVE THE NEW EMAIL !!
			
			$seed= $dtb->getGenVar('fPolyCrypt');
		
			$newEMail= $assoc->get($userId,'newEMail');
			$newEMail= $hPwC->doCrypt($newEMail,$seed);
			
			$dtb->setElem(_c_fsmplUsersTbl,  _c_fUserMail,$newEMail,  _c_fUserId,$userId);
			$dtb->setElem(_c_fsmplUsersTbl,  _c_fUserMok,_c_ok,  _c_fUserId,$userId);	
			
			$this->delGenAssocEMl($userId);	
		}
		
		$debriefingMess= '';
		// DEALS WITH E-MAIL VERIFICATION (when a registred user asks for a change of email address)
		$newEMail= $tools->postVal('newEMail');
		if ($newEMail!==false){
			// The form was sent !!
			if ($tools->isValidEmail($newEMail)){

				// Checking the crypted version of the password
				$cryptedPw= $tools->postVal('checkPw');
				$checkPwHash= $assoc->get($userId,'checkPwHash');
				$cpw= $userRec[_c_fUserCpw];
				$serverCryptedRes= $hPwC->doCrypt($checkPwHash,$cpw);
				
				if ($cryptedPw===$serverCryptedRes){
					// Stores the new unverified email values
					$assoc->store($userId,'newEMail',$newEMail);
					
					// Prepares the email for email-verification.
					$emailTo= $newEMail;
								
					$fumName= $dtb->getGenVar('fumName');
					$mailSubject= $fumName.': '.$glob->sl('Email Verification','kbdk');
								
					$mailBody= _c_.$glob->sl('Please click','kbdl');
					$hash= $hPwC->newHashStr(20);
					$assoc->store($userId,'newEMailHsh',$hash);			
					
					$url= _c_siteUrlAccess.$urlCurPgAndUId.$tools->addUrlVar(_c_fumEmailChange,$hash);
					$url.= $add;
					$mailBody.= $caps->hL($url, $glob->sl(' this link ','kbdm'), 'fumUsrMgB');
					
					$mailBody.= $glob->sl('to confirm your new email address for the forum ','kbdn').$fumName;
					
					$titleFrom= $fumName;
					$emailFrom= $dtb->getGenVar('fumEMailFrom');			
					$email->sendEMail($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom);
					
					$debriefingMess.= $stdSpc;
					$debriefingMess.= $caps->span($glob->sl('Thank you, we sent an email...','kbdo'),'fumUsrMgCongrat');;
					$debriefingMess.= $stdSpc;
				}else{
					$debriefingMess.= $stdSpc;
					$debriefingMess.= $caps->span($glob->sl('The password is not valid!','kbdp'),'fumUsrMgWarn');
					$debriefingMess.= $stdSpc;
					
					$this->delGenAssocEMl($userId);	
				}
			}else{
				$debriefingMess.= $stdSpc;
				$debriefingMess.= $caps->span($glob->sl('Your new email address is not valid!','kbdq'),'fumUsrMgWarn');
				$debriefingMess.= $stdSpc;
				
				$this->delGenAssocEMl($userId);	
			}
		}

		$seed= $dtb->getGenVar('fPolyCrypt');	// global seed to crypt the emails!
		
		// !! Keep it : $cryptedEmail= $userRec[_c_fUserMail];	// user rec is already too old !!!!
		$cryptedEmail= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUserMail);
		$curEmail= $hPwC->doUnCrypt($cryptedEmail,$seed);	// does not check multibytes, but fine for emails!!		
		
		$buff.= $caps->heaDiv(' border: 3px solid blue; padding:5px;');
		$buff.= $caps->headForm($urlCurPgAndUId.$add,'newEmailForm');
		
		$buff.= $caps->span($glob->sl('A form to update your email if necessary :','kbde'),'fumUsrMgTtl2');
		$buff.= $stdSpc;
		$buff.= $stdSpc;
		$buff.= $caps->span($glob->sl('Please fill your password : ','kbdg'),'fumUsrMgB');
		$buff.= $caps->corePwWdg('checkPw','',12, $caps->matCss('fumUsrMgB'));
		$buff.= $stdSpc;
		
		$buff.= $debriefingMess;
		
		$buff.= $stdSpc;
		$buff.= $caps->span($glob->sl('Your actual E-Mail is ','kbdf').$caps->span($curEmail,'fumUsrMgB').', ','fumUsrMgStd');	
		if (!$usrEMailIsValid){
			$buff.= $caps->span('<i>('.$glob->sl('warning : you need a validated email to send messages to other members','kbdi').')</i> ','fumUsrMgWarn');
		}
	
		$buff.= $caps->span($glob->sl('you can change and/or validate it','kbdh'),'fumUsrMgStd');
		
		// EMAIL FORM
		$postedMail= $tools->postVal('newEMail','');	// just a filler to avoid rewriting in case of error
		$buff.= $caps->textBx('newEMail',$postedMail,30,'fumUsrMgStd');	
		$buff.= $stdSpc;
		
		$checkPwHash= $hPwC->consonStr(20);
		$assoc->store($userId,'checkPwHash',$checkPwHash);
		
		$js= $caps->jsSimpleFu('forumUsrMg.cryptGivenPwBox',2,0,'checkPw',$checkPwHash);	
		$buff.= $caps->onClickBut('newMailBut',$glob->sl('Send','kaat'),$js,$caps->matCss('pubImUpStdB'));
		$buff.= $stdSpc;
		$buff.= $stdSpc;
		$buff.= $caps->endForm();
		$buff.= $caps->enDiv();
		return $buff;
	} // manageDefEMail
	
	/**
		Delete the 3 email genAssoc related fields!
	*/
	function delGenAssocEMl($userId){
		$assoc= &$this->assoc;
		$assoc->deleteAll($userId,'newEMail');
		$assoc->deleteAll($userId,'newEMailHsh');
		$assoc->deleteAll($userId,'checkPwHash');	
	} // delGenAssocEMl
	
	
	/**
	*/
	function menuCategUrlAdd(){
		$tools= &$this->tools;
		$menCatg= $tools->getVal(_c_tMenCateg,'lPost');		
		return $tools->addUrlVar(_c_tMenCateg,$menCatg);
	} // menuCategUrlAdd


	/**
		Manages the captcha answer
			Input :
				$gotPosted : true if the concerned form was posted
			Output :
				$debriefingMess
				$captchaOk : returns true if the captcha test was successful
	*/
	function mngCaptAnswer(&$debriefingMess,$gotPosted){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$assoc= &$this->assoc;
		$captcha= &$this->captcha;

		// Check the validity of the couple $hashPosted and $assocIdx
		$captchaOk= false;
		if ($gotPosted){
			$hashPosted= $tools->postVal(_c_captHidHashNm);	
			$assocIdx= $tools->postVal(_c_captHidIdNm);		// index of the temporary row of the associative table
			$assoc->getInfos($curHash,$captId,$assocIdx);
			if ($curHash===$hashPosted){
				// Got the captcha hash right, so can test the answer
				$postedAnswer= $tools->postVal(_c_captchaTxtNm);
				$storedAnswer= $dtb->getElem($captcha->globCaptchTblNm, _c_CaptchaId,$captId,_c_CaptchaAnsw);
				if ($postedAnswer===$storedAnswer){
					$captchaOk= true;
				}else{
					$debriefingMess.= $caps->span($glob->sl('The captcha was given a wrong solution...','kmee'),'fumUsrMgWarn');
				}
			}else{
				$debriefingMess.= $caps->span($glob->sl('Captcha hashes do not match!','kmef'),'fumUsrMgWarn');
			}
			
			$assoc->delSpecicRow($assocIdx);	// delete old captcha assoc
		}
		return $captchaOk;
	} // mngCaptAnswer

			
	/**
		Url random suffix to suppress brower caching without bothering about subtle browser difference for
		image caching. Otherwise the diffrenetly genertated image end up stalling on a xth generation!
		$this->rndSffx()
	*/
	function rndSffx(){
		$hPwC= &$this->hPwC;
		return '?bid='.$hPwC->consonStr(8);
	} // rndSffx

		
	/**
		To indicate with the url the specific part od the table we have to display.
	*/
	function postChunkUrl($i){
		$shrdCd= &$this->shrdCd;	
		$tools= &$this->tools;
	
		$url= $tools->urlCurPg();
		$url.= $tools->addUrlVar(_c_geoTblChunkId,$i);
		
		$usrId= $shrdCd->smartUserId();
		$url.= $tools->addUrlVar(_c_fumUserId,$usrId);
		return $url;
	} // postChunkUrl
	

	/**
		Base UserManager Menu to pass it to textMenus::setMenus()
	*/
	function baseUmMenu(){
		$shrdCd= &$this->shrdCd;	
		$tools= &$this->tools;
	
		$url= $tools->urlCurPg();
		$usrId= $shrdCd->smartUserId();
		$url.= $tools->addUrlVar(_c_fumUserId,$usrId);
		return $url;
	} // baseUmMenu
	
	
	/**
		List of sent messages for the given user
	*/
	function messageList($userId,$stdSpc){
		$shrdCd= &$this->shrdCd;	
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		$geom= &$this->geomArray;
		
		
		$singlePost= $tools->getVal(_c_tMenSinglePost);
		if ($singlePost===false){
			$localSignedIn= $shrdCd->isSignedIn;	// true if the default forun user is signed in!!
			$bDspl= '';	
			$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);
			$pseudo= $userRec[_c_fUserPseudo];
			$bDspl.= $caps->span($glob->sl('List of ','kbbw').$pseudo.$glob->sl('\'s posts','kbbx').' (', 'fumUsrMgPostTtl');
			
			$condition= $dtb->condId($userId);
			$bDspl.= $geom->geomArrDisplay(_c_forumPostsTbl,$userId, $this,'postChunkUrl');
			
			$bDspl.= $caps->span(') :'._c_, 'fumUsrMgPostTtl');
			
			$cStr= $dtb->condStr(_c_fumFUserId,$userId);
			
			$chunkSz= $dtb->getGenVar('postIdsChunkLength');
			$chunkId= $tools->getVal(_c_geoTblChunkId,1);
			if ($chunkId!=='all'){
				$chunkId= ($chunkId-1)*$chunkSz;
			}
			
			$arCmd[_c_mothrPage]= _c_ko;
			$qObj= $dtb->limitedRowSet(_c_forumPostsTbl,$chunkId,$chunkSz,$cStr,'*',_c_fumDate,true);
			$next=false;
			while( $postRec= $dtb->fetchAry($qObj) ){
				$postId= $postRec[_c_fumPostId];
				$xIndx= $postRec[_c_fumXIndx];
				$ttl= $postRec[_c_fumMessTtl];
				$allowed= $postRec[_c_fumOkPost]===_c_ok || $rights->wRights || $localSignedIn;
				if ($allowed){
					if ($next){
						$bDspl.= $caps->span(' / ', 'fumUsrMgPostTtl');
					}
					
					$concernedPg= $postRec[_c_fumMotherId];
					$url= $shrdCd->generalLinkFromPR($xIndx,$postId,$concernedPg,$arCmd);
					
					$bDspl.= $caps->hL($url,$ttl,'fumUsrMgPost');
					
					$url= $this->baseUmMenu();
					$url.= $tools->addUrlVar(_c_tMenCateg,'lPost');
					$url.= $tools->addUrlVar(_c_tMenSinglePost,$postId);
					
					$bDspl.= $caps->hL($url,'+','fumUsrMgPost');
					$next= true;
				}
			}
			return $bDspl;
			
		}else{
			// $singlePost!==false  ---> === a post Id
			$postId= $tools->getVal(_c_tMenSinglePost);
			return $this->managePostWall($postId);
		}
	} // messageList

	
	/**
		Execute an eventual scheduled action and display the tasks still to be scheduled.
		schedActDspl
	*/
	function schedActDspl(){
		$tagsFu= &$this->tagsFu;	
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$shrdCd= &$this->shrdCd;
				
		$sched= $shrdCd->schedulerClass($this);
		
		if ($shrdCd->gotSchedAction()){
			$sched->fcExecutes();
		}else{
		}
		
		$buff= '';
		$buff.= $caps->span($glob->el('Forum Scheduler : a visualisation....','kbem'),'fumSchedTtl');
		$buff.= $sched->dsplActiveTbl($shrdCd);
		return $buff;
	} // schedActDspl
	
	
	/**
	*/
	function imgZoom(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$shrdCd= &$this->shrdCd;
		
		$userId= $shrdCd->curErsatzLogUser();
		
		$zmNm= $tools->getVal(_c_piuZmImgNm);
		$buff= '';
		if ($zmNm!==false){
			$curFl= $shrdCd->persoPath($userId).$zmNm;
			if (file_exists ($curFl)){
				$imSzV= getimagesize($curFl);	// ( $imSzV[0], $imSzV[1] ) -- (width, height)
				$buff.= $caps->heaDiv('width:95%; border: 0px solid red;');
				$buff.= $caps->heaDiv('width:'.$imSzV[0].'px; border: 0px solid blue; margin:auto;');
				$buff.= $caps->ttlImage($curFl,$zmNm,$zmNm,'frontWallBigImg');
				$buff.= $caps->enDiv();
				$buff.= $caps->enDiv();
			}else{
				$buff.= $caps->span($glob->sl('The file ','kbea')._c_._c_.$curFl._c_._c_.$glob->sl(' does not exist! Please load it again ...!','kbeb')._c_R, 'fumError');
			}
		}else{
			if ($shrdCd->coreSignedIn($shrdCd->fumLogUserId())){
				$buff.= $caps->span($glob->sl('This space display the larger version of the above small images ...','kbec'),'fumUsrMgBl');	
			}else{
				$buff.= $caps->span($glob->sl('This space displays a larger version of some above small images if available!','kmhr'),'fumUsrMgBl');	
			}
		}
		return $buff;
	} // imgZoom
	

	/**
	*/
	function changePassword(&$userRec,$urlCurPgAndUId,$usrEMailIsValid){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		$assoc= &$this->assoc;
		
		$userId= $userRec[_c_fUserId];
		$add= $this->menuCategUrlAdd();
		$stdSpc= $caps->span(_c_BrFlux,'fumUsrMgStd');	
		$minPwLength= $dtb->getGenVar('fumMinPwLength');
		
		$debriefingMess= '';
		// DEALS WITH E-MAIL VERIFICATION (when a registred user asks for a change of email address)
		$cryptedPw= $tools->postVal('currentPw');
		if ($cryptedPw!==false){
			// The form was sent !!

			// Checking the crypted version of the password
			$checkPwHash= $assoc->get($userId,'chgPwHash');
			$cpw= $userRec[_c_fUserCpw];
			$serverCryptedRes= $hPwC->doCrypt($checkPwHash,$cpw);
			$crptNewPwOne= $tools->postVal('newPwOne');
			$crptNewPwTwo= $tools->postVal('newPwTwo');
			
			if ($cryptedPw===$serverCryptedRes){
				if($crptNewPwOne===$crptNewPwTwo){
					/*
						The given pws are fine, so just need to uncrypt-update it!
						Remark : must crypt the new one with current $cpw (normally still secret and does not transit). 
						because  the hash transit, so can only be used as a data to be crypted, but if crypted with 
						new cpw we can't uncrypt it because new cpw is still not on the server.
					*/
					$newCpw= $hPwC->doUnCrypt($crptNewPwOne,$cpw);
					
					if (strlen($newCpw)<$minPwLength){
						$debriefingMess.= $caps->span($glob->sl('The new passwords is too short! You need at least ','kbed').$minPwLength.$glob->sl(' characters!','kbee'),'fumUsrMgWarn');
						$debriefingMess.= $stdSpc;
						$debriefingMess.= $stdSpc;
					}else{
						$dtb->setElem(_c_fsmplUsersTbl,  _c_fUserCpw,$newCpw,  _c_fUserId,$userId);
						$debriefingMess.= $caps->span($glob->sl('The password has been updated!','kbef'),'fumUsrMgCongrat');
						$debriefingMess.= $stdSpc;
						$debriefingMess.= $stdSpc;
					}
					
				}else{
					$debriefingMess.= $caps->span($glob->sl('The new passwords are not identical!','kbeg'),'fumUsrMgWarn');
					$debriefingMess.= $stdSpc;
					$debriefingMess.= $stdSpc;
				}
			}else{
				$debriefingMess.= $caps->span($glob->sl('The original password is not correct!','kbeh'),'fumUsrMgWarn');
				$debriefingMess.= $stdSpc;
				$debriefingMess.= $stdSpc;
			}
		}
	
		$buff= '';
		$buff.= $caps->heaDiv(' border: 3px solid blue; max-width:500px; width:95%; padding-left:1%; padding-right:1%; padding-top:5px; padding-bottom:5px;');
		$buff.= $caps->headForm($urlCurPgAndUId.$add,'newEmailForm');
		
		$buff.= $caps->span($glob->sl('A form to change your password!','kbei'),'fumUsrMgTtl2');
		$buff.= $stdSpc;
		$buff.= $stdSpc;
		$buff.= $debriefingMess;
				
		
		$buff.= $caps->span($glob->sl('Actual password : ','kbej'),'fumUsrMgB');
		$buff.= $caps->corePwWdg('currentPw','',12, $caps->matCss('fumUsrMgB'));
		$buff.= $stdSpc;
		$buff.= $stdSpc;
		
		$buff.= $caps->span($glob->sl('New password : ','kbek'),'fumUsrMgB');
		$buff.= $caps->corePwWdg('newPwOne','',12, $caps->matCss('fumUsrMgB'));
		$buff.= $stdSpc;
		
		$buff.= $caps->span($glob->sl('Repeat the new password : ','kbel'),'fumUsrMgB');
		$buff.= $caps->corePwWdg('newPwTwo','',12, $caps->matCss('fumUsrMgB'));
		$buff.= $stdSpc;
		
		
		$chgPwHash= $hPwC->consonStr(20);
		$assoc->store($userId,'chgPwHash',$chgPwHash);
		$js= $caps->jsSimpleFu('forumUsrMg.cryptThreePwBox',4,0,'currentPw','newPwOne','newPwTwo',$chgPwHash);	
		
		$buff.= $stdSpc;
		$buff.= $caps->onClickBut('newMailBut',$glob->sl('Send','kaat'),$js,$caps->matCss('pubImUpStdB'));
		$buff.= $stdSpc;
		$buff.= $stdSpc;
		$buff.= $caps->endForm();
		$buff.= $caps->enDiv();
		
		// $buff.= $caps->textarea('debugDisplay',15,102,'',$caps->matCss('fumUsrMgStd'));		
		return $buff;
	} // changePassword
	
	
	/**
		Calculates the image wall dispplay string.
	*/
	function choseWallPost(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$shrdCd= &$this->shrdCd;
	
		$stdSpc= $caps->span(_c_BrFlux,'fumUsrMgStd');	
		$userId= $shrdCd->curErsatzLogUser();
		$urlCurPgAndUId= $this->usrMgBaseUrl($userId);
		
		$condition= $dtb->condStr(_c_fumFUserId,$userId);	
		$resultV= $dtb->vectFields(_c_forumPostsTbl,$condition, _c_fumPostId, _c_fumMessTtl);
		
		$buff= '';
		if ($resultV!==false && $shrdCd->uIdLogWatch()){
			$buff.= $caps->headForm($urlCurPgAndUId.'','imgWallForm');		
			$buff.= $caps->span($glob->sl('You can chose a post for general display ...','kbdc'),'fumUsrMgStd');	
			$postId= $tools->postVal('selectWallPost'); // in fact for now just the id of the choosen post !!!
			if ($postId===false){
				$postId= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUsrPostWallId);
			}else{
				$dtb->setElem(_c_fsmplUsersTbl, _c_fUsrPostWallId,$postId, _c_fUserId,$userId);
			}
			
			$buff.= $caps->onClickBut( 'fumImgWallBut', $glob->sl('Send','kaat'),'',$caps->matCss('pubImUpStdB') );
			
			$buff.= $stdSpc;
			$buff.= $caps->span($glob->sl('Change to : ','kbdd'),'fumUsrMgB');
			krsort($resultV);
					
			$buff.= $caps->comboBox('selectWallPost',$postId,$resultV,'',true);
			$buff.= $stdSpc;
			$buff.= $stdSpc;
			
			$buff.= $caps->endForm();
		}
		return $buff;
	} // choseWallPost
		
	/**
		[dsplScheduler /]
	*/
	function tg_dsplscheduler(&$v,&$bd){
		$rights= &$this->rights;
	
		if ($rights->wRights){
			return $this->schedActDspl();
		}else{
			return '';
		}
	} // tg_dsplscheduler

} // forumUsrMg
?>
