<?php
/**
	File name : frameBuilder.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="frameBuilder" /]				[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	A class use to define Xpetal tags that allow to build a full website :
	Originally the tags were hand written into a large Xpetal file! Now most of the time the file is generated
	automatically with an installation form (the "_installer" page) and executed autonatically afterward.
	
	frameBuilder::coreCleanUp()
*/
class frameBuilder extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();
		
		$this->menuOverWrite= false;		// force overwriting in strategical places if frame-building one more time
		$this->languageCountor= true;
		$this->currentLanguage= _c_notALanguage;
		
		$this->tagsFu= &$tagsFu;
		$asa= &$tagsFu->asa;
		$this->asa= &$asa;
		$this->pRnd= &$asa->pRnd;
		
		$this->parser= &$tagsFu->parser;
		
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		$this->rMg= &$tagsFu->rMg;
		
		$this->wmRights= &$tagsFu->wmRights;
		
		$this->caps= &$tagsFu->caps;		// may suppress the extend
		$this->tools= &$tagsFu->tools;
		$tools= &$this->tools;
		
		
		$this->acc= &$tagsFu->acc;
		$acc= &$this->acc;
		
		$this->hPwC= &$tagsFu->hPwC;		
		
		$this->fls= &$tagsFu->fls;
		$fls= &$this->fls;
		
		$this->imgP= &$tagsFu->imgP;
		
		$this->mWdgt= $tagsFu->instExplitCentralCls('formMainWdgt');		
		$this->forumBar= $tagsFu->instExplitCentralCls('forumBar');
		
		
		$this->dtbR= &$tagsFu->dtb;		// the database we are reading from (the one we start with) ... just files
		$dtbR= &$this->dtbR;
		
		$this->addLgSffxToPgNm= true;
				
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('frameBuilder','debugDisplay',true);
		
		/**
			Data project/site related constant
		*/
		define('_c_MxIndexFN', 'indexMatrix.php');
		

		/**
			Actual definitions
		*/
		define('_c_virgGenNectDfn', _c_virginConnect.'cstGeneralNect.php');
		define('_c_virgDtbNectDfn', _c_virginConnect.'cstDtbNect.php');
		
		
		/**
			tg_cell() : [cell tbl="cellPge" id="_initTags" ] ... [/cell]
			
				tbl : concerned table.
				id : page name
				addlg : tp add a language tag relativeto the main language.
		*/
		define('_c_tgCell','cell');
		$tagsFu->attribVect[_c_tgCell]= array('tbl','id','addlg','lgsubst');		
		
				
		// tg_genvar();  [GenVar var="edt_infoY"] the value [/GenVar]
		define('_c_tgGenVar','genvar');
		$tagsFu->attribVect[_c_tgGenVar]= array('var');		
		
		
		define('_c_tgDb','changedb');
		$tagsFu->attribVect[_c_tgDb]= array('name');
		
		
		define('_c_tgNewDtb','newdtb');
		$tagsFu->attribVect[_c_tgNewDtb]= array('dtbname','datadir','version','urlstample','mainurl','dtbprodservnm',
		'kindurlsubacc', 'subdom', 'dtbexternusrname', 'dtbexternpw', 'softcrypkey', 'isinstaller', 
		'c','largeint','fixindex');
		
		
		// [dspBuilderR /]
		$tagsFu->attribVect['dspbuilderr']= array('vectfeed');
		
		
		// tg_delete()  [delete tbl="cellPge" id="a" /]
		define('_c_tgDel','delete');
		$tagsFu->attribVect[_c_tgDel]= array('tbl','id');
		
		// n tg_m(), Menu / SiteBuilder
		define('_c_tgMenGen','m');
		$tagsFu->attribVect[_c_tgMenGen]= array('lbl','pg','utf','down','c','go','redirect','lgcontid','contid','fold');		
		
			// tg_mbdef()
			define('_c_tgMbDef','mbdef');	// menu builder definition
			$tagsFu->attribVect[_c_tgMbDef]= array('top');	// top: name of the top page
		
			// tg_lgoff()  To switch off the language countor
			define('_c_tgLgOff','lgoff');
			$tagsFu->attribVect[_c_tgLgOff]= false;
		
			// tg_lgon()  To switch on the language countor
			define('_c_tgLgOn','lgon');
			$tagsFu->attribVect[_c_tgLgOn]= false;
			
			
			$tagsFu->attribVect['nopglgsuffix']= false;
			
		
		
		
		/**
			tg_bsetlang(), Menu / SiteBuilder
			[bsetlang lg="fr"]
		*/
		define('_c_tgBuilderSetLg','bsetlang');
		$tagsFu->attribVect[_c_tgBuilderSetLg]= array('lg');		
			
		/**
			tg_fillspoly() : Fills the polyglot table with the data of $this->globPageLangVect[..][.]
		*/					
		define('_c_tgFillsPoly','fillspoly');
		$tagsFu->attribVect[_c_tgFillsPoly]= false;		
	
		// tg_typemode() eg : [typeMode type="crypt" /]
		define('_c_tgTypemode','typemode');
		$tagsFu->attribVect[_c_tgTypemode]= array('type');		

		// tg_c()	[c lbl="MisterX" /]
		define('_c_tgMenCrypt','c');
		$tagsFu->attribVect[_c_tgMenCrypt]= array('lbl');
		
		// tg_editcell() :  [editcell lbl="memoEditWkPg" cellname="_edit-work-page"] content... [/editcell]
		define('_c_tgEditCell','editcell');
		$tagsFu->attribVect[_c_tgEditCell]= array('lbl','cellname','crypt');
		
		$tagsFu->attribVect['generaltopic']= array('name');
		
		
		/**
			tg_newrecord(... ) : Creates a new record insithe specified table, 
			with 2 fields (field & val) used for testing the record existance.
			
			[newrecord tbl="" field="" val="" a="" b="" c="" d="" e="" f="" 
				g="" h="" i="" j="" k="" l="" m="" n="" o="" p="" /]
				
			Starting from 'a' gives the full list of all elements.
		*/
		$tagsFu->attribVect['newrecord']= array('tbl','nbelem','field','val','a','b','c','d','e','f','g','h',
				'i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
				'a0','a1','a2','a3','a4','a5','a6','a7','a8','a9');

		$tagsFu->attribVect['changetablerec']= array('tbl','fields','sep');
		
		
		$tagsFu->attribVect['cpyrenpg']= array('orgid','trgid');	
	
		$crV= array('tbl','assfield','assval','rnd','condfield','condval','postedval');
		$tagsFu->attribVect['chgrecval']= $crV;
		$tagsFu->attribVect['obdchgrecval']= $crV;
		
		
		$tagsFu->attribVect['setpartialrandval']= array('tbl','assfield','pfxval','rndersatzt','sfx','rndsz','path','condfield','condval');
		
		
		$tagsFu->attribVect['deleterecord']= array('tbl','field','val');
			
		$tagsFu->attribVect['fbprint']= array('s');	
			
		$tagsFu->attribVect['genewuser']= array('usr');		
		
		
		$tagsFu->attribVect['copytablerec']= array('tbl','id');		
		$tagsFu->attribVect['copypagemen']= array('id','mastercpy');	// mastercpy --> master copy only
		$tagsFu->attribVect['copypage']= array('id');		
		$tagsFu->attribVect['fulltablecpy']= array('tbl','forbidid');	
		
		$tagsFu->attribVect['setlanguage']= array('set');
		
		
		$tagsFu->attribVect['langproduct']= array('listlg','lgsubst','lglblsubst');
		
		$tagsFu->attribVect['exeframebuilfu']= array('fu');	
		
		$tagsFu->attribVect['inithomepage']= false;	
		
		$tagsFu->attribVect['filesubstitute']= array('search','replace','dfn');
		
		
		$tagsFu->attribVect['installpolypages']= array('pfx','hdstyle','fr','en');
		
		$tagsFu->attribVect['setheaderforall']= array('name','lbl','hdstyle');
		
		$tagsFu->attribVect['chgttlimage']= array('name');
		
		$tagsFu->attribVect['setarianeimage']= array('subst','maxih');	
				
		
		$tagsFu->attribVect['setabicon']= array('name');			
		
		$tagsFu->attribVect['formatsmartphonemenu']= array('a','b','c','d','e');		
		
		
		$tagsFu->attribVect['cpypastemencss']= array('site');			
		$tagsFu->attribVect['cpypastegenimg']= array('site');			
		
		$tagsFu->attribVect['adaptcomplexgenvar']= false;
		
		
		$tagsFu->attribVect['chknectvalidity']= array('usernamevar','dbpwvar','servervar', 'dtbnamevar', 'quietsuccess');

		$tagsFu->attribVect['realutfstorage']= false;
		$tagsFu->attribVect['removelgspecpolyglotcss']= false;
		
		$tagsFu->attribVect['cleanup']= false;
		
	
		$this->firstPageName= false;	
		$this->installerWitness= false;	
		
		$this->asciiIdV= array();	
		
		$sortOfDistrib= $tools->postVal('sortOfDistrib');
		
		// Builder perspective
		$masterFlagDfnB= _c_prExportPath._c_usrStandardDirN.'/masterFlag.php';
		$gotMasterFlagFlB= file_exists($masterFlagDfnB);
		
		// Extraction perspective
		$masterFlagDfnE= './masterFlag.php';
		$gotMasterFlagFlE= file_exists($masterFlagDfnE);
		
		$this->masterDistribState= $sortOfDistrib==='MasterDistrib' || $gotMasterFlagFlB || $gotMasterFlagFlE;
		$fls->firstLevelFiles($firstLeV,'.');
		
		$this->zipDistibFlag= $tools->postVal('zipDistribName')!==false;
		
		$this->generalSurfLgList= 'en';
		
		$this->installer= false;	// instanciation later with tg_newdtb()
	} // frameBuilder		
	
	
	/**
		Loads tagsVect with all the tags used by this class.
	*/
	function tags(){
		return array('fbprint','typemode','nopglgsuffix','m','lgoff','lgon','mbdef','cell','genvar','changedb','newdtb',
			'dspbuilderr','delete','bsetlang','fillspoly','c','editcell','generaltopic', 'setlanguage', 
			'newrecord', 'changetablerec', 'cpyrenpg', 'chgrecval', 'obdchgrecval', 'setpartialrandval', 'deleterecord', 'genewuser', 'copytablerec', 'copypagemen', 'copypage','fulltablecpy',
			'langproduct','exeframebuilfu','inithomepage','filesubstitute','installpolypages',
			'setheaderforall','chgttlimage','setarianeimage','setabicon', 'chknectvalidity', 'removelgspecpolyglotcss',
			'formatsmartphonemenu','cpypastemencss','cpypastegenimg','adaptcomplexgenvar','realutfstorage','cleanup');
	} // tags
	

	/** ----------------------------------------------------------------------------------------------		
		Tag to :
			Create an empty database.
			Create and adapt the concerned files and diretories.
	*/
	function tg_newdtb(&$v,&$bd){
		$asa= &$this->asa;
		$tagsFu= &$this->tagsFu;
		$parser= &$this->parser;
		
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$acc= &$this->acc;
		$hPwC= &$this->hPwC;
		$fls= &$this->fls;
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		$mWdgt= &$this->mWdgt;
		$pRnd= &$this->pRnd;
				
		
		/**
			True if we build a distribution Master or standard !! So the a boolean image of the form Widget choice
			----> in case of a distrib we only Build the _c_coreInstallerDN
		*/
		$zipDistibFlag= $this->zipDistibFlag;
		

		$this->installer= $tagsFu->instExplitCentralCls('installer');
		$installer= &$this->installer;
		

		$vi= $tools->binLoads($v['version'],'');
		if ($fls->polyvalentIndex()){
			$usrDataDirN= $v['datadir'].$vi;	// the name of the user data directory
			$extIndex= 'extIndex-'.$usrDataDirN.'.php';
		}else{
			if ($zipDistibFlag){
				// building the zip distrib so building the fix folder belonging to the core installer itself
				$usrDataDirN= _c_coreInstallerDN;
				$extIndex= _c_fixInstIndex;
			}else{
				// Fix index for a normal lambda installation or a final master installation !!
				$usrDataDirN= _c_usrStandardDirN;
				$extIndex= _c_fixPhpIndex;
			}
		}
		
		if ( $usrDataDirN===_c_coreInstallerDN && file_exists(_c_ProjectsPath._c_coreInstallerDN) ){
			$fls->ultraRemoveDir(_c_ProjectsPath._c_coreInstallerDN);
		}
		
		
		
		/** ----------------------------------------------------------------------------------------------------
			Full separation for the 100% php version and for the only MySql
				$this->dtbR : a pointor copncerned with the original database
				$this->dtbW :a pointor copncerned with the database to build
		*/
		$kindDtb= $dtbR->getGenVar('kindDtbToInstall');
		switch ($kindDtb){
			case 'simulSql':
				include_once _c_DtbLibPath.'simulSql.php';
				
				if ($zipDistibFlag){
					$dtbAccessPath= _c_XportPhpDtb;
				}else{
					$dtbAccessPath= _c_ProjectsPath.$usrDataDirN.'/zCms/zPhpData/phpDtb/';
				}
				
				$aSqlW= new simulSql($asa,$dtbR,$dtbAccessPath);
			break;
			
			case 'aMySql':
			default:
				include_once _c_DtbLibPath.'aMySql.php';
				$dtbCmpl= null;
				$aSqlW= new aMySql($asa,$dtbCmpl);
			break;
		} // switch
		
		$this->dtbW= new localDB($asa,$aSqlW);	// For writing : database standard class
		$dtbW= &$this->dtbW;
		$tagsFu->dtbCmpl= &$dtbW;
		$dtbW->allSupPtAtOnce($asa);
		$glob->loadChgblDtb($dtbW);
		
		$this->curDatabNm= _c_UsrDbName;	// Current database name (to get infos from the currently runing mother database)
		$dtbName= $v['dtbname'].$vi;	// The New database name
		$this->newDatabNm= $dtbName;
		
		if ($v['isinstaller']===_c_ok){
			$this->installerWitness= true;	// installerCreation
		}
		
		$dtbServerNm= $v['dtbprodservnm'];
		$dtbExtUsrNn= $v['dtbexternusrname'];
		$dtbExtPw= $v['dtbexternpw'];
		$b= $dtbW->dbConnect($dtbServerNm,$dtbExtUsrNn,$dtbExtPw);
		$possibleConnection= true;
		if ($b===false){
			// $got= $dtbExtUsrNn.' | '.$dtbExtPw.' | '.$dtbServerNm;
			$got= $dtbExtUsrNn.' | **** | '.$dtbServerNm;
			
			$fmtGot= $caps->span($got,'forMnWdgtDataErr');	// formated connection param we got
	 		$errNect= $caps->span($glob->sl('Error with the mySql connection','kavo'),'forMnWdgtGenErr');
			$mWdgt->activeWdgtStr= $errNect.$fmtGot._c_._c_.$mWdgt->activeWdgtStr;			
			$mWdgt->serieBoolTest(false);	// force the failure of the main widgets
			$installer->imperfect();
			$possibleConnection= false;
		}
		
		$b= $dtbW->createDatabase($dtbName);
		if ($b===false){
			$b= $glob->sl('Could not create the database : ','kmhl').$dtbName._c_;
			$glob->userError($b);
			$mWdgt->serieBoolTest(false);	// force the failure of the main widgets
			$mWdgt->activeWdgtStr= $b._c_._c_.$mWdgt->activeWdgtStr;
			$installer->imperfect();
			$possibleConnection= false;
		}
		
		// Note : else in the installer case we don't need to do that because the situation is safe by design (core developper know they are not risking precious data)
		if ($possibleConnection){
			// got the connection
			$boolSelDb= $dtbW->selectDb($dtbName);	// Adapt the data base connexion. ($boolSelDb is symbolic, not many possibilities to be false because created just before)
			
			if (!$this->installerWitness){
				$glob->forbidSqlErrors();
				$allowInst= $this->coreAllowInstall($dtbW,$erase);
				if (!$allowInst){
					$parser->stopParser();
					// Note normally the following print never appears because it's stoppped before at the form level with [chkNectValidity ... /] also using  $this->coreAllowInstall(...)
					print($glob->sl('Just stopped the parser...time to sustain important modifications','kmhk')._c_);
					return '';	// symbolic false
				}
				
				if ($erase){
					$dtbW->truncateTable(_c_PolyCellPg);		
					$dtbW->truncateTable(_c_PolyCellPgM);		
					$dtbW->truncateTable(_c_GenVarTbl);		
				}
			}
			
		}else{
			print('$possibleConnection=false'._c_);
			return '';	// symbolic false
		}
		
		
		// Top index.php in standard production environment and another name in multi-sites test environment.
		if ($zipDistibFlag){
			$destPath= _c_XTaoxStallDataDir;
		}else{
			$destPath= _c_ProjectsPath.$usrDataDirN;	// The new directory of the current project (site)
		}
		
		$srcPath= _c_copyPaste._c_ProjMatrixFN;		// The matrix / chablon used as a model
		$fls->copyDirectories($srcPath,$destPath);	// Creates the new project directories
		
		// Got to replace erzatzTtlFromInstall inside styles.css
		$destStyleDfn= $destPath.'/styles.css';
		$cssStr= $fls->fileToStr($destStyleDfn);
		
		if ($installer->mainHeaderStyle===false){
			$installer->mainHeaderStyle= _c_rT.'font-family:Arial; font-style:normal; font-weight:bold; color:#840000;font-size:36px; text-decoration: none; background-color:white;';
		}
		$cssStr= str_replace('erzatzTtlFromInstall',$installer->mainHeaderStyle,$cssStr);
		$fls->strToFile($destStyleDfn,$cssStr);
		
		
		// add the current cache _c_curCachePath
		$curCacheDfn= _c_genCachePath.$usrDataDirN;
		$fls->wMkDir($curCacheDfn);
		
		$destPath.= '/';
		
		define('_c_destZCmsImplic', $destPath._c_localZCmsImplic);
		define('_c_destZCmsExplic', $destPath._c_localZCmsExplic);
		define('_c_destZCmsExplicC', _c_destZCmsExplic._c_plugCntrDN);	
		define('_c_destGeneralImages', $destPath.'images');	
		
		$destZcmsPth= $destPath._c_zCmsDirN.'/';;
		$destUdt= $destZcmsPth.'plugUsrData';
		
		// ---------------------------------------------------------------------------------------
		define('_c_destZPhpData', $destZcmsPth.'zPhpData/');
		define('_c_destZPhpDataNect', _c_destZPhpData.'connect/');
		
		
		define('_c_destZCmsPhpDtb', _c_destZPhpData.'phpDtb/');
		define('_c_destZCmsPhpDtbInfo', _c_destZCmsPhpDtb.'info/');
		
		
		/* Copy the image collection from the actual site image collection !
		*/		
		$srcZcmsImgPath= _c_zCms.'images';		
		$destZcmsImgPath= $destZcmsPth.'images';
		$fls->copyDirectories($srcZcmsImgPath,$destZcmsImgPath);
		
		/* Copy the plug user data from plugUsrDataVirgin
		*/		
		$srcUdt= _c_usrCopyPaste.'plugUsrData';		
		$fls->copyDirectories($srcUdt,$destUdt);
		
		
		$destInstallWS= $destPath.'usrCpyPaste';
		$fls->wMkDir($destInstallWS);
		$destInstall= $destInstallWS.'/';
		
		if ($this->masterDistribState){
			$fls->copyDirectories(_c_usrCopyPasteNS, $destInstallWS);
		}else{
			$this->fillUsrCpyPasteDir($destInstall,'plugUsrData');			
			$this->fillUsrCpyPasteDir($destInstall,'exportationSpecFls');			
			
			$destMmDir= $destPath.'zCms/plugUsrData/explicit/central/mm/';
			$fls->secUnlink($destMmDir.'factory.png');
			$fls->secUnlink($destMmDir.'packages.png');
			$fls->secUnlink($destMmDir.'triangle.png');
		}
				
		$this->destIcoPath= $destPath.'images/';
		$kCode= $v['largeint'];	
		$extStampleSite= $fls->domainName();		
		$extDtbUsrNm= $v['dtbexternusrname'];
		
		/**
			Data base Password uncrypting 1st to remove the javascript uncryption amd crypting
			just after for password "discrete" stprages. Rem : $sortOfInt is probably redondant !!
		*/
		$sortOfInt= $pRnd->smalLargeIntToExplicit($kCode);	// To identify what sort of integers are used
		$dtbPassword= $v['dtbexternpw'];
		
		// $dtbPassword is always clear because :
		// Static sheet are mainly for local use, except at installation, but it's only a dtb password that need an activated local application!
		$softCrypKy= $hPwC->consonStr(8);
		$extCrpPw= $hPwC->doCrypt($dtbPassword,$softCrypKy,$sortOfInt);
			
		
		$kindUrlSubAcc= $v['kindurlsubacc'];
		$dmnm= $fls->domainName().'/';
		
				
		// domCombi
		switch ($kindUrlSubAcc){
			case 'subDomain':
				$domCombi= $v['subdom'].$dmnm;	// may imply single domain restriction
			break;
			
			case 'subDir':
				$domCombi= _c_slashHttp.$dmnm.'/'.$v['subdom'].'/';
			break;
			
			case 'inBuiltSubDir':
				$domCombi= _c_siteUrlAccess;
			break;
			
			case 'topLevel':
			default:;
				$domCombi= _c_slashHttp.$dmnm.'/';
			break;
		} // switch
		
		
		$dtbProdServNm= $v['dtbprodservnm'];
		
			
		$searchV= array('forceToChgLargeInt', 'extToChgStampleSite', 'myDomainToChgName', 'domErztUrlAcc');		
		$replaceV= array($kCode, $extStampleSite, _c_homeSlash, $domCombi);
		
		
		
				
		// Substitution inside cstGeneralNect.php
		$nnInfStr= $fls->fileToStr(_c_virgGenNectDfn);
		$nnInfStr= str_replace($searchV,$replaceV,$nnInfStr);
		$genNctDfn= _c_destZPhpDataNect.'cstGeneralNect.php';
		$fls->secUnlink($genNctDfn);
		$fls->strToFile($genNctDfn,$nnInfStr);
		
		
		$searchV= array('extToChgDtbUsrNm', 'extCrpToChgPwName', 'softToChgCrypKey', 'installerToChgDtbName', 'dtbToChgProdServNm');		
		$replaceV= array($extDtbUsrNm, $extCrpPw, $softCrypKy, $dtbName, $dtbProdServNm);

		// Substitution inside cstDtbNect.php
		$nnInfStr= $fls->fileToStr(_c_virgDtbNectDfn);
		$nnInfStr= str_replace($searchV,$replaceV,$nnInfStr);
		$dtbNctDfn= _c_destZPhpDataNect.'cstDtbNect.php';
		$fls->secUnlink($dtbNctDfn);
		$fls->strToFile($dtbNctDfn,$nnInfStr);
		
		
		/**
			Copy the index
		*/
		$srcIdxPath= _c_cpyFullAsapBkp;
		
		if ($tools->postVal('sortOfDistrib')!==false){
			$origExtDfN= _c_exportSpecFls.'mdlInstallerIdx.php';
		}else{
			$origExtDfN= _c_exportSpecFls.'mdlMainIndex.php';
		}
		
		$extStr= $fls->fileToStr($origExtDfN);	// get the string content of the original/default index
		
		// Remark ; $extIndex is set correctly at the beginning of this method
		if ($zipDistibFlag){
			$destIdxPathExt= _c_XportTaoxInstallWS.$extIndex;
		}else{
			$destIdxPathExt= _c_homeSlash.$extIndex;
		}
		
		$searchV= array(_c_usrStandardDirN,_c_fixPhpIndex);
		$replaceV= array($usrDataDirN,$extIndex);
		
		$extStr= str_replace($searchV,$replaceV,$extStr);	// at least one replacement (installerToChgDtbName) !!! 
		$extStr= str_replace('mainErsatzDataDir',$usrDataDirN,$extStr);
		
		$fls->secUnlink($destIdxPathExt);
		$fls->strToFile($destIdxPathExt,$extStr);
		
		$this->mainFN= $extIndex;
		return '';	// symbolic true
	} // tg_newdtb


	/**
		Test if we are allowed to install the site and to ecrase parially an existing one during the installation.
	
		Input :
			$dtbW : localDB target onject
		Output :
			$erase : boolean true= ok to erase and false otherwise.(actually just the 3 main tables)
		>coreAllowInstall
	*/
	function coreAllowInstall(&$dtbW, &$erase){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$wmRights= &$this->wmRights;
		
		if ($this->installerWitness){
			return true;
		}
	
		$erase= false;
		if ($this->locFormWasPosted()){
			$repMin= !$wmRights->erroReportMax();
			$now= time();
			
			if ($repMin){
				error_reporting(NULL);	// don't want an error blur for our new user !!!!
			}
			
			$b= $glob->allowsSqlErrors;
			$glob->allowsSqlErrors= false;
			$iTm= $dtbW->getGenVar('firstInstallationTm');
			$glob->allowsSqlErrors= $b;	
			
			error_reporting(E_ALL);
			if ($iTm===false){
				return true; 	// still not created --> ok to install but don't need to erase!
			}
			
			if ($iTm==='fistSecuInstErsatzTm'){
				$iTm= _c_ok;	// master progr val so can keep installing with ersatzt init!
			}
			
			if ($repMin){
				error_reporting(NULL);	// don't want an error blur for our new user !!!!
			}
			$acceptTm= $dtbW->getGenVar('acceptFirstInstTm');
			error_reporting(E_ALL);
			if ($acceptTm===false){
				return false; 	// does not exist! Weird! --> Max security : do not install do not erase!
			}
			
			if ($acceptTm==='accptErzazFirstInstTm'){
				$iTm= _c_ko;	// master progr val so can keep installing with ersatzt init!
			}
			
			if ($iTm!==_c_ok && $acceptTm===_c_ok){
				$delta= $now-$iTm;
				if ($delta<1800){
					$erase= true;
					$allowInst= true;	// allows the installation and erasing because got there in time
				}else{
					$allowInst= false;	// do not allows installation/erasing
				}
			}else{
				$erase= true;
				$allowInst= true;	// allows the installation and erasing because superior rights!
			}
			
			return $allowInst;
		}
			
		return false;	// because not posted, can't install
	} // coreAllowInstall
	
	
	/**
		To forbid Ataox re-installation, when the last successful virgin installation was done more than 30 monutes ago!/]
	*/
	function installProtect(&$dtbW){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$mWdgt= &$this->mWdgt;
		
		if ($this->installerWitness){
			return true;
		}
		
		if ($this->locFormWasPosted()){
			$allowInst= $this->coreAllowInstall($dtbW,$erase);
			if ($allowInst){
				// may be the form was not sent but webmaster busy with it so in best case worth 30 more minutes-
				$now= time();
				$b= $glob->allowsSqlErrors;
				$glob->allowsSqlErrors= false;
				$dtbW->setGenVar('firstInstallationTm',$now);
				$glob->allowsSqlErrors= $b;	
			}
			
			if ($allowInst){
			}else{
				$mWdgt->serieBoolTest($allowInst);
				$mess= $glob->sl('Sorry the last full installation was','kaxf');
				$mWdgt->sentWdgtStr.= _c_.$caps->span($mess,'forMnWdgtGenErr');
				$mWdgt->activeWdgtStr.= _c_.$caps->span($mess,'forMnWdgtGenErr');
			}
			
			return $allowInst;
		}
	} // installProtect	
		
		
	/**
		Defines the new language set applyed to the site being built.
		[setLanguage set="fr, en" /]
	*/
	function tg_setlanguage(&$v,&$bd){
		$glob= &$this->glob;	
		$tools= &$this->tools;	
		$installer= &$this->installer;

		$set= $v['set'];
		$this->generalSurfLgList= $set;
	
		$vLg= $tools->trimStrToV($set);
		$this->generalLgVect= $vLg;	// surf languages vect
		
		$glob->gMasterLanguage= $vLg[0];
		
		// The builder target specific version of $glob->usedLangVect, so must have the language abrteviations as kesy!
		$this->usedLgVect= array_flip($vLg);
		
		if ($installer!==false){
			$installer->loadsLanguageVect(true);	// eventually reload it with the possibly changed $this->generalSurfLgList
		}
	} // tg_setlanguage
	

	/**
		[installPolyPages pfx="header" hdStyle="" /]
	*/
	function tg_installpolypages(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$installer= &$this->installer;
		$caps= &$this->caps;
		$dtbW= &$this->dtbW;
		
		$pfx= $v['pfx'];
		$vLg= $this->generalLgVect;
		reset($vLg);
		foreach ($vLg as $key=>$lg){
			$id= $tagsFu->curPolyPage($pfx,$lg);
			
			$mainStr= '[ePage name="'.$id.'" ttl="Show code" cls="efMbAdm"]*[/page]'._c_R._c_R._c_R;
			if ( array_key_exists($lg,$v) && $v[$lg]!==false ){
				$subject= $v[$lg];
				$subject= str_replace('#','"',$subject);
				$mainStr.= $caps->span(_c_R.$subject._c_R,'gecMainTtl');
			}else{
				$mainStr.= $caps->span(_c_R.$id._c_R,'gecMainTtl');	// dependant on prev. erzatzTtlFromInstall
			}
			
			$dtbW->createFullCell(_c_PolyCellPg,$id,$mainStr,'',$lg);
		}
	} // tg_installpolypages
	
		
	/**
		[setHeaderForAll name="h3aderForAll" /]
	*/
	function tg_setheaderforall(&$v,&$bd){
		$installer= &$this->installer;
		$caps= &$this->caps;
		$dtbW= &$this->dtbW;
		
		$name= $v['name'];
		$lbl= $v['lbl'];
		
		$mainStr= $caps->span(_c_R.$lbl._c_R,'gecMainTtl');
		$dtbW->createFullCell(_c_PolyCellPg,$name,$mainStr);
	} // tg_setheaderforall
			
		
	/**
	*/
	function isSSL(){
		if (array_key_exists('HTTPS',$_SERVER)){
			return !empty($_SERVER['HTTPS']) || $_SERVER['HTTPS']!=='off';
		}else{
			return false;
		}
	} // isSSL
		
			
	/**
		Fills the user copy paste directory with the specified directory.
		Input :
			$dirN : source and destination directory name
	*/
	function fillUsrCpyPasteDir($destInstall,$dirN){
		$fls= &$this->fls;
	
		$srcUdt= _c_usrCopyPaste.$dirN;		
		$destUdt= $destInstall.$dirN;
		
		$fls->wMkDir($destUdt);
		$fls->copyDirectories($srcUdt,$destUdt);
	} // fillUsrCpyPasteDir
	
	
	/**
		[dspBuilderR /] : Display the Results Link (just a clickable link to jump onto the result.) and last step of data modifications
	*/
	function tg_dspbuilderr(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;	
		$caps= &$this->caps;
		$fls= &$this->fls;
		$hPwC= &$this->hPwC;
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		$aSqlW= &$dtbW->aSql;
		$mWdgt= &$this->mWdgt;
		
		// Global data savng (before further splicings) if in 100% php mode
		if ($dtbR->getGenVar('kindDtbToInstall')==='simulSql'){	// current database mode for generation
			$aSqlW->updateData(true);	// Writes the 100% Php database !!!
			
			// Forces the 100% Dtb settings
			$srcDFN= _c_destZPhpDataNect. 'exmplAboveDtbPhp.php';
			$trgDFN= _c_destZPhpDataNect.'aboveDtb.php';
			$fls->unLnk($trgDFN);
			$fls->strToFile($trgDFN,$fls->fileToStr($srcDFN));	
		}
		
		// _c_destZPhpDataNect
		$zipDistibFlag= $this->zipDistibFlag;
		if (!$zipDistibFlag){
			// !! almost a twin of >writeCacheLocalConst() except the other does not write there _c_destZPhpDataNect
			// also could use $dtbR instead of $dtbW ... would need a few tests ... so keep it separated
			$cacheConstDfn= _c_destZPhpDataNect.'cacheConst.php';
			$flCacheStr= $fls->fileToStr($cacheConstDfn);
			
			$urlPgVar= $dtbW->getGenVar('urlPageVar');
			$pwBxRequest= $dtbW->getGenVar('pwBoxRequest');
			$defPg= $dtbW->getGenVar('permanentDefPage');
			$pwBoxGuestReq= $dtbW->getGenVar('pwBoxGuestReq');
			
			$sffx= $hPwC->consonStr(3);
			$sffx2= $hPwC->consonStr(3);
			$sffx3= $hPwC->consonStr(3);
			$searchV= array('pVarErsatzt', 'callPwErsatzt', 'defPgErsatzt', 'guestVarErsatzt','usesStatsErsatz', 
				'statsAvoidErsatz','rndIndexErsatz','uniqPfxErsatz','botScrErsatz','rndErsatzStatsSfx');
			$replaceV= array($urlPgVar, $pwBxRequest, $defPg, $pwBoxGuestReq,'ko','statsAvoid_'.$sffx2,'ok', 
				'uPfx_'.$sffx,'ok',$sffx3);	// 'defPgErsatzt' need to be adapted automatically in production if still having the defPgErsatzt value
			$cacheCstStr= str_replace($searchV,$replaceV,$flCacheStr);
			$fls->secUnlink($cacheConstDfn);
			$fls->strToFile($cacheConstDfn,$cacheCstStr);
		}
		
				
		$urlPageVar= $dtbW->getGenVar('urlPageVar');		
		$ar['forceIndex']= $this->mainFN;
		$ar['forceUnqStr']= $urlPageVar;
		$ar['justsrf']= _c_ok;
		
		$mainHomePage= $dtbW->getGenVar('mainHomePage');
		$url= $tools->urlGivenPage($mainHomePage,$ar);
		
		$congrat= _c_.$caps->hLink($url, $glob->sl('Congratulations, please click here!','katj'),$caps->target().$caps->matCss('installerTtlMH'));
		
		$congrat.= _c_.$caps->span($glob->sl('Running successfully the installation more than once','kavn'),'installerSmallSpec');
		
		$urlLog= $url.$tools->addUrlVar(_c_pwBoxUrlVar,_c_pwLogReqstVal);
		$val= $dtbW->getGenVar('forcedAccessUsrId');
		$urlLog.= $tools->addUrlVar('userId',$val);
		$logLink= _c_.$caps->hLink($urlLog, $glob->sl('You can click here to log in!','katm'),$caps->target().$caps->matCss('installerTtlMH'));

		$vectFeed= $v['vectfeed'];	// ok --> need to use a vector feedback in poll position !!
		
		
		$iSOM= $tools->postVal('installerSortOfMenus');
		if ($iSOM!==false){
			$dtbW->setGenVar('menuDefaultKind',$iSOM);
			$dtbW->setGenVar('menuForceKind',$iSOM);
		}
		
		
		/** --------------------------------------------------------------------
		*/
		if ($tools->postVal('zipDistribName')===false){
			// Possibly 2nd phase of a master distrib
			$selfMasterFlagDfN= './masterFlag.php';	// self becaue target the case where it's running form installer.php
			if (file_exists($selfMasterFlagDfN)){
				unlink($selfMasterFlagDfN);
			}
		}
		
		
		if ($vectFeed===_c_ok){
			$mWdgt->sentWdgtStr= $congrat._c_._c_.$logLink._c_._c_.$mWdgt->sentWdgtStr;
		}else{
			return 	$congrat;			
		}
	} // tg_dspbuilderr
	
	
	/** --------------------------------------------------
		Tools
	-----------------------------------------------------*/

	/**
		Returns the safe page name from the given page name or the given label.
	*/
	function safePgNmFromGpnOrGlbl($givenPg,$label=false){
	
		if ($givenPg!==false && $givenPg!==''){
			$str= $givenPg;
		}else{
			$str= $label;
		}
				 
		 return $this->fromLblToPgName($str);
	} // safePgNmFromGpnOrGlbl

	
	/**
		Returns true if we got to add a language suffix to every page names triggered by the calls to tg_m().
	*/
	function gotToAddLgSffxToPgN(){
		return $this->addLgSffxToPgNm;
	} // gotToAddLgSffxToPgN

	/**
		[noPgLgSuffix /] So the pages dont have a language suffix
	*/
	function tg_nopglgsuffix(&$v,&$bd){
		$this->addLgSffxToPgNm= false;
	} // tg_nopglgsuffix


	/**
	*/
	function fromLblToPgName($label, $fu='idChar', $admitHyph=true){
		$acc= &$this->acc;
		$fls= &$this->fls;
		$dtbR= &$this->dtbR;
		$installer= &$this->installer;
		
				
		$gotToAddLgSffx= $this->gotToAddLgSffxToPgN() && $this->currentLanguage!== _c_notALanguage;
		
		$label= $acc->fromHtmlToAccents($label); // to correct possible early insertion of html code.
		$label= $acc->toNoAccents($label);
		 
		$safeBdy= $fls->safeIdString($label, false, $admitHyph, $fu); // the length is tested outside
		if ($gotToAddLgSffx){
			$nbPostLg= $installer->nbPostedLg();
			if ($nbPostLg>1){
				$lgSffx= $this->currentLanguage;
				if ($fls->lastChar($safeBdy)!=='-'){
						$lgSffx= '-'.$lgSffx;
				}
			}else{
				$lgSffx= '';
			}
			$safeBdy= $safeBdy.$lgSffx;
		}
		
		
		if ($dtbR->getGenVar('builderSafeIdsLowerCases')===_c_ok){
			$safeBdy= strtolower($safeBdy);
		}
		
		return $safeBdy;
	} // fromLblToPgName

	
	/** --------------------------------------------------
		Tag Functions
	-----------------------------------------------------*/
	
	/**
		Menu builder definitions. Example : [mBDef top="currentTop" /]
		So the tag-routines following this tag can use the current top they are concerned with.
	*/
	function tg_mbdef(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		if ($v['top']!==false){
			$pn= $v['top'];
		}else{
			$pn= _c_topDefaultPg;
		}
		
		$tagsFu->bldTopPageName= $pn; // stores the builder top page name
	} // tg_mbdef
	
	
	/**
		Creates a cell, by default a page cell
			[cell tbl="cellPgeM"] id="_initTags"  ............  [/cell]
		---> does not creates any associated menu!
	*/
	function tg_cell(&$v,&$bd){
		$glob= &$this->glob;
		$dtbW= &$this->dtbW;
		$tools= &$this->tools;
		
		$tbl= $v['tbl'];
		$id= $v['id'];
		$lgSubst= $v['lgsubst'];
		if ($lgSubst!==false){
			// does the substitution ( [code] must have been activated inside the X code
			$replace= $this->lgSwitchParamStr($this->generalLgVect);
			$bd= str_replace($lgSubst,$replace,$bd);
		}
		
		if (  !$dtbW->recordExists($tbl, $dtbW->condId($id) )  ){
		
			if ($v['addlg']===_c_ok){
				$bd= $tools->sqrTag(_c_tgLang,false,$glob->gMasterLanguage)._c_R.$bd;
			}
			$dtbW->createDefCell($tbl,$id,$bd);
		}		
	} // tg_cell
	
	
	/**
		Build the language parameter string for the tag [lgSwitch ... /]
		--->  fr="FR" en="EN"
	*/
	function lgSwitchParamStr($lgV){
		$buff= '';
		reset($lgV);
		foreach ($lgV as $key=>$lg){
			$buff.= $lg.'="'.strtoupper($lg).'" ';
		}
		return $buff;
	} // lgSwitchParamStr
	
	
	
	/**
		Creates a general variable.
		[GenVar var="edt_infoY"] the value [/GenVar]
	*/
	function tg_genvar(&$v,&$bd){
		$dtbW= &$this->dtbW;
		$dtbW->newGenVar($v['var'],$bd);
	} // tg_genvar
	
	
	/**
		[changeDb name="zzz" /]
		Static DTB case : using $dtbR only works to go back to the original DTB ... so this tag
		should really be called returnOrigDtb !!!!!!!!  ok for now because it's what it does !!!
		
		A general case should test if the given name match the static or a dynam dtb 
		and chose the pointer accordingly!
	*/
	function tg_changedb(&$v,&$bd){
		$tools= &$this->tools;

		$name= $tools->binLoads($v['name'],_c_UsrDbName);
		if ($name===_c_UsrDbName){
			// Original Dtb so read pointer compulsory in flat dtb case.
			$dtbRW= &$this->dtbR;	// The only one that should work in dynamic and static DTB case! 
		}else{
			// Non original Dtb so in flat dtb case a real sql dtb is supposed.
			$dtbRW= &$this->dtbW;	
		}
		
		$dtbRW->selectDb($name);
	} // tg_changedb
	

	/**
		Delete a table record, for verification and tests.
	*/
	function tg_delete(&$v,&$bd){
		$activated= false;
		if ($activated){
			$dtbW= &$this->dtbW;
			$tbl= $v['tbl'];
			$id= $v['id'];
			$dtbW->delete($tbl,$id);		
		}else{
			return '[Delete ..] table is desactivated';
		}
	} // tg_delete


	/**
		[lgOff /]
	*/	
	function tg_lgoff(&$v,&$bd){
		$this->languageCountor= false;
	} // tg_lgoff

	/**
		[lgOn /]
	*/	
	function tg_lgon(&$v,&$bd){
		$this->languageCountor= true;
	} // tg_lgon


	/**
		'm' : Tag menu function : to create a web-site skeleton from a single xml string.
		Example :
			[m lbl="Programmer documentation" pg="progDoc" down="closed" c="This is the explcit content of the page"]
				[m lbl="Coding strategy" /]
				[m lbl="Database convention" /]	
			[/m]
			
		Warning : the page names must be inside the correct size span! ... So testing is done before generating the tags.
	*/
	function tg_m(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		$parser= &$this->parser;
		
		
		$currentLevel= $v['_level'];
		
		// Current level parameters
		$label= trim($v['lbl']);
		$pg= trim($v['pg']);
		
		
		$pageName= $this->safePgNmFromGpnOrGlbl($pg,$label);	
		
		if ($this->firstPageName===false && $currentLevel===2){
			$this->firstPageName= $pageName;
		}
			
		$redirect= $v['redirect'];
		if ($redirect!==false){
			$redirect= $this->safePgNmFromGpnOrGlbl($redirect);
		
			$valV= array($pageName,$redirect);
			$dtbW->newRecFromV(_c_pgRedirectTbl,$valV);
		}
		
		/**
			At the end of the scan $this->globPageLangVect gives all the sets of language related pages.
			Storage in the polyglot table need to be done with a specialized tag used at the end :
				- uses the page name ids of the master language for the polyglot Ids (need to scan it 1st).
				- separates page names with ";"
				- adds the [polyglot ... /] tag inflow (all calls identicals for same lg-familly of page) along the main algo (not at the end), so avoid insertion & tuples
		*/
		if ( isset($this->currentLanguage) ){
			if ($this->languageCountor ){
				$this->globPageLangVect[$this->currentLanguage][$this->curIndxLgPage]= $pageName;
				$this->curIndxLgPage++; // ready for the next page
			}
			$curLgTyp= $this->currentLanguage;
		}else{
			$curLgTyp= _c_pcTypAny;
		}
						
		if ($v['down']!==false){
			$dw= $v['down']; // easier access and local explicitness.
		}else{
			$dw= 'open'; // special default for tg_m (creation of site bud), open is best at 1st because buds are small.
		}
		
		// Grabing parent information
		if ($currentLevel>1){
			$paramParent= $parser->globVectParVal[$currentLevel];
			$tagsFu->checkAndNormalise(_c_tgMenGen,$paramParent,'tg_m'._c_dbSep.$pageName);
			
			// Assign the parrent page name. (can't use OrSfPageName() because the vector is not normalised (normalisation is done in this class only for the current tag parameter).
			if ( $paramParent['pg']!==false ){
				$parentPgName= $paramParent['pg'];
				// print('*$parentPgName='.$parentPgName._c_); // language extension is zapped !!!!
				
				
				if ($tools->postVal('expertMode')==='easy'){
					// probably can't use gotToAddLgSffxToPgN() because specific to a few places
					$sz= count($this->generalLgVect);
					if ($sz>=2){
						$parentPgName.= '-'.$this->currentLanguage;
					}
				}
					
				
				
			}else{
				$parentPgName= $this->fromLblToPgName($paramParent['lbl']);
			}
		}else{
			$parentPgName= false;
		}


		/** ---------------------
			Creates the CURRENT MENU if not already created	
		*/	
		if (  !$dtbW->recordExists(_c_PolyCellPgM, $dtbW->condId($pageName) )  ){
			$dtbW->createDefCell(_c_PolyCellPgM,$pageName);
		}
		
			
		// Adds the menu xml label.
		$curLbl= $dtbW->getCllStr($pageName,_c_PolyCellPgM);
		if ($this->menuOverWrite || !$tools->sIsInB('"'.$pageName.'"',$curLbl)){
			
			if ($v['go']==='stay'){
				$nVect1['pg']= '#';	// stack the drop menus !!!
			}else{
				$nVect1['pg']= $pageName;
			}
			
			$nVect1['fold']= $tools->binLoads($v['fold'],false);	// false --> ignore it, but ko --> use it
			
			$xmlLabel= $tools->buildSqrTag(_c_tgMenBut,$nVect1,$label);	// # # # # # # #
			$dtbW->chgPolyCell(_c_PolyCellPgM,$pageName,$xmlLabel);
		}
			
		/** 
			Adds the menu up tag before whatever info is already in there
		*/
		if ($parentPgName!==false){		
			$curNectStr= $dtbW->getCllStr($pageName,_c_PolyCellPgM,_c_pcNecStr);
			$nVect2['ref']= $parentPgName;
			
			if ($this->menuOverWrite || !$tools->sIsInB('"'.$parentPgName.'"',$curNectStr)){
				$curNectStr= $tools->buildSqrTag(_c_tgMenUp,$nVect2)._c_R.$curNectStr;
				$dtbW->chgPolyCell(_c_PolyCellPgM,$pageName,$curNectStr,_c_pcNecStr);
			}
		}
		
		/** ---------------------
			Access/Create ABOVE/PARENT MENU
		*/			
		if ($parentPgName!==false){
			if (  !$dtbW->recordExists( _c_PolyCellPgM, $dtbW->condId( $parentPgName ) )  ){
				$dtbW->createDefCell(_c_PolyCellPgM,$parentPgName);
			}
				
			/**
				[mTree .../]: Adds $pageName in only if not already done, so can run the algo many times without mess.
			*/
			$parentMenList= $dtbW->getCllStr($parentPgName,_c_PolyCellPgM,_c_pcNecStr);	// !!!!!!!!!!!!
			if ($this->menuOverWrite || !$tools->sIsInB('"'.$pageName.'"',$parentMenList)){
				$nVect3['pg']= $pageName;
				if ($dw==='open'){
					$nVect3['down']= 'open';
				}
				
				$parentMenList.= _c_R.$tools->buildSqrTag(_c_tgMenTree,$nVect3);
				$dtbW->chgPolyCell(_c_PolyCellPgM,$parentPgName,$parentMenList,_c_pcNecStr);	
			}
			
			// print('$parentPgName='.$parentPgName._c_);
			// print('$parentMenList='.$parentMenList._c_._c_._c_);
		} // else : on top menu, no parent tag.
			
					
		/** ------------------------------------------------------------------------------------
			Create and adapt the page
		*/
		if (  !$dtbW->recordExists(_c_PolyCellPg, $dtbW->condId($pageName))  ){
		
			if ($v['utf']===_c_ok){
				// One more line to _c_ascUtfTN
				
				$label= $this->urlSafeUtfStr($label);
				if ($dtbW->elementExists(_c_auiUtfId, $label, _c_ascUtfTN)){
					
					if ( array_key_exists($label,$this->asciiIdV) ){
						$curVIdx= $this->asciiIdV[$label];
						$curVIdx++;
						$this->asciiIdV[$label]= $curVIdx;					
					}else{						
						$this->asciiIdV[$label]= 2;
						$curVIdx= 2;						
					}

					$auV= array($pageName, $label.$curVIdx);
				}else{
					$auV= array($pageName,$label);
				}
				
				$dtbW->newRecFromV(_c_ascUtfTN,$auV);
			}
			
			$dtbW->createDefCell(_c_PolyCellPg,$pageName,'',$curLgTyp);
			
			$content= '';
			if (isset($tagsFu->bldTopPageName)){
				$nVect4['ref']= $tagsFu->bldTopPageName;	// builder top page name
				$content.= $tools->buildSqrTag(_c_tgUp,$nVect4)._c_R;
			}
			
			$metaLbl= $this->erasesSqrtTags($label);
			$content.= $tools->buildSqrTag(_c_tgTitle,false,$metaLbl)._c_R;
			$content.= $tools->buildSqrTag(_c_tgDescr,false,$metaLbl)._c_R;
			$content.= $tools->buildSqrTag(_c_tgKw,false,' ')._c_R;	// Empty when starting, much better than useless words
			
			if (isset($this->globCurTopic)){			
				$nVect5['name']= $this->globCurTopic;
				$content.= $tools->buildSqrTag('topic',$nVect5)._c_R;	// [topic name="sa" /]					
			}
			
			
			if ( isset($this->currentLanguage) ){
				$curLg= $this->currentLanguage;
			}else{
				$curLg= $glob->gMasterLanguage;
			}
			$content.= $tools->buildSqrTag(_c_tgLang,false,$curLg)._c_R._c_R;
			
									
			if ($v['c']===false){
				$content.= 'Page : '.$label;
			}else{
				$content.= $acc->removeTabs($v['c']);
				
				$lgContId= $v['lgcontid'];	// language dependant content Id
				if ($lgContId!==false){
					$lg= $this->currentLanguage;
					$theChosen= $glob->el('At building time, the chosen page did not exist','katb');
					
					// $sup= $glob->flexTrans($lg,$theChosen, $lgContId, false);
					$sup= $glob->getBestCodeTranslation($lgContId, $lg, $theChosen, false,true, _c_nL._c_nL);
					
					$content.= $sup;
				}
				
				$contId= $v['contid'];	// language independant content Id
				if ($contId!==false){
					$content.= $dtbR->getElem(_c_siteModelsTbl, _c_siteModelsId,$contId, _c_siteModelsText);
				}
			}
			$dtbW->chgPolyCell(_c_PolyCellPg,$pageName,$content);
		} // Create and adapt the page
				
	} // tg_m
	

	/**
		For a given language set the language to start at building time to memorize the pages in order 
		to obtain language page sets.
		[bSetLang lg="fr" /]
		Loading the current language vector is done within the [m ...] tag
	*/
	function tg_bsetlang(&$v,&$bd){
		$this->currentLanguage= $v['lg'];
		$this->curIndxLgPage= 0;
	} // tg_bsetlang

		
	/**
		Fills the polyglot table with the data of $this->globPageLangVect[language,IdPage]
		Called at the end of the frame building process, globPageLangVect[..] is fully loaded.
		[fillsPoly /]
	*/
	function tg_fillspoly(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		$glob= &$tagsFu->glob;	// to store some global variables
		
		
		$mstLg= $glob->gMasterLanguage;
		for($i=0; $i<$this->curIndxLgPage; $i++){
		
			reset($this->usedLgVect);
			foreach ($this->usedLgVect as $lang=>$bid){
				if ( array_key_exists($i,$this->globPageLangVect[$lang]) ){
					$curPageId= $this->globPageLangVect[$lang][$i];
					$paramV[$lang]= $curPageId;
				}
			}
			
			$taggedStr= $tagsFu->rebuildTagStr(_c_tgPolyglot,$paramV);
			reset($this->usedLgVect);
			foreach ($this->usedLgVect as $lang=>$bid){
				if (array_key_exists ($i,$this->globPageLangVect[$lang])){
					$curPageId= $this->globPageLangVect[$lang][$i];
					if ($dtbW->getCllStr($curPageId,_c_PolyglotTbl,_c_polyglotId)===false){				
						if ($lang!==$mstLg){
							// save a redirection (the master language page name)
							if (array_key_exists ($i,$this->globPageLangVect[$mstLg])){
								$curMstId= $this->globPageLangVect[$mstLg][$i];
								$dtbW->createPolyDefCell($curPageId,$curMstId);
							}
						}else{
							// save the whole bunch of parameters (the master language entry)
							$dtbW->createPolyDefCell($curPageId,$taggedStr);
						}
					}
				}
			}		
		} // loop accross pages
		return '';
	} // tg_fillspoly


	/**
		Sets the general type mode. [typeMode type="crypt" /]
	*/
	function tg_typemode(&$v,&$bd){
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
	} // tg_typemode


	/**
		Set the current topic for the next bloc of tags to scan.
		Example : [generalTopic name="sa" /]
	*/
	function tg_generaltopic(&$v,&$bd){
		$this->globCurTopic= $v['name'];
	} // tg_generaltopic



	/**
		Creates a new record inside the specified table, with 2 fields used for testing the record existance.
		Renark : would have been easier (programming and user side) to have one parameter to explode.
		!! Not used can easily build it again correctly !!
		
		[newrecord tbl="" nbelem=""  field="" val="" a="" b="" c="" d="" e="" f="" 
			g="" h="" i="" j="" k="" l="" m="" n="" o="" p="" /]
	*/
	function tg_newrecord(&$v,&$bd){
		$tools= &$this->tools;
		$dtbW= &$this->dtbW;
		
		$iEnd= $v['nbelem']+4;
		$subV= $tools->subArray($v,4,$iEnd);
		$dtbW->newElem($v['tbl'],$v['field'],$v['val'],$subV);	// add the whole bunch at once!
	} // tg_newrecord


	/**
		Copy a table record.
	*/
	function copyTableRec($tbl,$id, $pcType=false){
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		
		$curdtbnm= $this->curDatabNm;
		$dtbR->selectDb($curdtbnm);
		$valV= $dtbR->getElem($tbl,_c_genId,$id);
		if ($pcType!==false){
			$valV[_c_pcType]= $pcType;
		}
		
		if ($valV!==false){		
			$dtbW->selectDb($this->newDatabNm);		
			$dtbW->newRecord($tbl,$valV);
		}
	} // copyTableRec
	
	
	/**
		[cpyRenPg orgid="" trgid="" /]
	*/
	function tg_cpyrenpg(&$v,&$bd){
		$originId= $v['orgid'];
		$targetId= $v['trgid'];
		$this->copyRenameTableRec(_c_PolyCellPg,$originId,$targetId);
	} // tg_cpyrenpg
	
	
	/**
		Copy a table record.and give it another name
	*/
	function copyRenameTableRec($tbl,$origId,$targetId){
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		
		$curdtbnm= $this->curDatabNm;
		$dtbR->selectDb($curdtbnm);
		$valV= $dtbR->getElem($tbl,_c_genId,$origId);
		
		if ($valV!==false){	
			$valV[_c_pcId]= $targetId;	
			$dtbW->selectDb($this->newDatabNm);		
			$dtbW->newRecord($tbl,$valV);
		}
	} // copyTableRec
	

	/**
		Change a table record : need to give all he fields !!
		[changeTableRec tbl="" fields="" /]
	*/
	function tg_changetablerec($v,$bd){
		$tools= &$this->tools;
		$dtbW= &$this->dtbW;
		
		$tbl= $v['tbl'];
		$strFields= $v['fields'];
		$sep= $tools->binLoads($v['sep'],';');
		
		$dtbW->selectDb($this->newDatabNm);
		$dtbW->setFullRec($tbl,$strFields,$sep);
	} // tg_changetablerec
	
		
	/**
		[deleterecord tbl="usersTbl" val="xx" /]
	*/
	function tg_deleterecord(&$v,&$bd){
		$tools= &$this->tools;
		$dtbW= &$this->dtbW;
		
		$tbl= $v['tbl'];
		$field= $tools->binLoads($v['field'],_c_genId);
		$val= $v['val'];
		$dtbW->deleteTableRecord($tbl,$field,$val);
	} // tg_deleterecord
	
		
	/**
		Full table copy.
	*/
	function fullTableCpy(&$v){
		$tools= &$this->tools;
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		
		$tbl= $v['tbl'];
		
		$curdtbnm= $this->curDatabNm;
		$dtbR->selectDb($curdtbnm);
		
		$fullTbl= $dtbR->subTable($tbl);		// get in fact the full table because no restricting parameters given
		if ($fullTbl===false){
			print('Error in frameBuilder::fullTableCpy, $tbl='.$tbl._c_);
			return;
		}
		
		$forbidId= $v['forbidid'];	// Forbidden to copythese id value(s)
		if ($forbidId!==false){
			$forbVals= $tools->trimStrToV($forbidId);
		}else{
			$forbVals= array();
		}
		
		$dtbW->selectDb($this->newDatabNm);
		reset($fullTbl);
		foreach ($fullTbl as $k=>$row){
			$firstVal= current($row);	// the first val is also the Id value but not the first key value that is always "id"
			if (!in_array($firstVal,$forbVals)){
				$dtbW->newRecord($tbl,$row);
			}
		}
	} // fullTableCpy
	
	/**
		[fullTableCpy tbl="" /]
	*/
	function tg_fulltablecpy(&$v,&$bd){
		$this->fullTableCpy($v);
	} // tg_fulltablecpy
	
	
	/**
		[geNewUser usr="root" /]	: generate a new user inside the already declared table.
	
		An ersatz to tg_newuser() directly loads the sql code from corresponding fields 
		inside the running CMS! So fine tuning done later on! Remark : patial copy or
		straight gfeneration also posible.
		
		Strategy : just copy the interesting parts of the database, then eventually do chirurgical modifications.
	*/
	function tg_genewuser(&$v,&$bd){
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		
		$usr= $v['usr'];
		$curdtbnm= $this->curDatabNm;
		
		$dtbR->selectDb($curdtbnm);
		$valV= $dtbR->getElem(_c_UsersTbl,_c_userId,$usr);
		
		$dtbW->selectDb($this->newDatabNm);
		$dtbW->newRecord(_c_UsersTbl,$valV);
	} // tg_newuser

	/**
		From the active database : copy the specified record from the specified table 
	*/
	function tg_copytablerec(&$v,&$bd){
		$tbl= $v['tbl'];
		$id= $v['id'];	// record id !!
		$this->copyTableRec($tbl,$id);
	} // tg_copytablerec
	
	/**
		Copy the specified page and menu couple.
		Rem : If mastercpy is specified, we need a master state to do the copy!
	*/
	function tg_copypagemen(&$v,&$bd){
		$id= $v['id'];	// record id !!
		$masterCpy= $v['mastercpy'];
		if ($masterCpy===false || $this->masterDistribState){
			// n copyTableRec
			$this->copyTableRec(_c_PolyCellPg,$id,_c_pcTypAny);
			$this->copyTableRec(_c_PolyCellPgM,$id);
		}
	} // tg_copypagemen
	
	/**
		Copy the specified page!
	*/
	function tg_copypage(&$v,&$bd){
		$id= $v['id'];	// record id !!
		$this->copyTableRec(_c_PolyCellPg,$id);
	} // tg_copypage


	/**
		[fbPrint s="Hello Frame Builder" /]
	*/
	function tg_fbprint(&$v,&$bd){
		$s= $v['s'];
		print($s._c_);
	} // tg_fbprint


	/**
		[langProduct listLg="fr, en, de, it" lgSubst="ersLGasz"]  
		[/langProduct]  
		
		Multiply the coded paragraph abbiding a textBox given list of language short-hand, or
		directly with a given parameter.
	*/
	function tg_langproduct(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$caps= &$this->caps;
			
		$listLg= $v['listlg'];
		
		$lgSubst= $v['lgsubst'];		// Unique language substitutor that must be present in $bd
		$lgLblSubst= $v['lglblsubst'];	// Unique text label language substitutor that must be present in $bd
		
		if ($listLg===false){
			$lgVect= $this->generalLgVect;
		}else{
			$lgVect= $tools->trimStrToV($listLg);
		}
		
		$totLgBlock= '';
		reset($lgVect);
		foreach ($lgVect as $key=>$lg){
			$curLgBlock= $bd;
			$curLgBlock= str_replace($lgSubst,$lg,$curLgBlock);
			
			$lgLblStr= _c_._c_.$caps->span($lg,'genSuperTitle');	// define the language flag
			$curLgBlock= str_replace($lgLblSubst,$lgLblStr,$curLgBlock);
			$totLgBlock.= $curLgBlock._c_R._c_R._c_R;
		}
		
		return $tagsFu->expand($totLgBlock);
	} // tg_langproduct


	/**
		Loads the vector/array defined by tg_setlanguage() into the Dtb general variable "possibleSurfLang"
	*/
	function setPossibleSurfLang(){	
		$dtbW= &$this->dtbW;
		$dtbW->setGenVar('possibleSurfLang',$this->generalSurfLgList);
	} // setPossibleSurfLang
	
	
	/**
		[initHomePage /]
	*/
	function tg_inithomepage(&$v,&$bd){
		$dtbW= &$this->dtbW;
		$dtbW->setGenVar('permanentDefPage',$this->firstPageName);
		$dtbW->setGenVar('mainHomePage',$this->firstPageName);
		return '';
	} // tg_inithomepage
	
	
	/**
		Css file replace kernel
	*/
	function fileReplace($search,$replace,$dfn){
		$fls= &$this->fls;
		$fStr= $fls->fileToStr($dfn);
		$fStr= str_replace($search,$replace,$fStr);
		$fls->strToFile($dfn,$fStr);
	} // fileReplace


	/**
		Change the titje image
		[chgTtlImage imgNm"" /]
	*/
	function tg_chgttlimage(&$v,&$bd){
		$dtbW= &$this->dtbW;
		$imgNm= $v['name'];
		
		$urlImg= _c_destZCmsExplicC.'menus/img/'.$imgNm;
		$decoStr= 'background-image: url('.$urlImg.');'._c_R;
		$decoStr.= 'background-repeat: repeat-y;';
		$dtbW->setGenVar('decoForActiveMenus',$decoStr);
	} // tg_chgttlimage


	/**
		[setArianeImage /]
	*/
	function tg_setarianeimage(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$fBar= &$this->forumBar;
		$imgP= &$this->imgP;
		$dtbW= &$this->dtbW;
		
		// ---> We had to keep the original name of a main editor to use the image library straigh on! Look at imGallery::gallerytox2() for more infos
		$subst= $v['subst'];
		if ($subst===false){
			$arianeTT= $tools->postVal('mainStr');	// ariane Tracker Tag
		}else{
			$arianeTT= str_replace('#','"',$subst);
		}
		
		$attSz= strlen($arianeTT);
		
		$maxIH= $v['maxih']; // max image height
		if ($maxIH===false){
			$ftSzMO= $tools->postVal('ddMenuTxtFontSz')-1;
		}else{
			$ftSzMO= $maxIH;
		}
				
		if ($attSz>=_c_minXTagSz){
			$fBar->lastIconeDfn= false;
			$bid= $tagsFu->expand($arianeTT);
			if ($fBar->lastIconeDfn!==false){
				$destPF= _c_destZCmsExplicC.'menus/ulMenus/taox.png';
				$fls->secUnlink($destPF);
				$srcPF= $fBar->lastIconeDfn;
			
				if ($fls->extension($srcPF)!=='gif'){
					$imSzV= getimagesize($srcPF);
						
					if ($imSzV[1]>$ftSzMO){
						// should resize
						$imgP->resizeProc($srcPF,$destPF,150,$ftSzMO);
					}else{
						$fls->secureCopy($srcPF,$destPF);
					}
				}else{
					// Animated gif, can't resize
					$fls->secureCopy($srcPF,$destPF);
				}
			}
		}
	} // tg_setarianeimage


	/**
		[seTabIcon /]
	*/
	function tg_setabicon(&$v,&$bd){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ($this->installerWitness){
			return;	// actrually does not happend because the concerned file does not call that tag!!
		}
		
		$icoNm= $v['name'];
		if ($icoNm===false){
			$icoNm= $tools->postVal('tabsAndBmIcon');	// the icon name selector
		}
		
		if ($icoNm==='chooseForMe'){
			$vect= array('br', 'gb', 'gr', 'oy', 'ry', 'wn', 'wr', 'yb', 'py', 'heart', 'mandel', 'puzzle', 'run', 'smiley', 'star', 'velo', 'unicycle', 'squat', 'flame', 'excav', 'psi', 'cv');			
			$i= rand(0,20);
			$icoNm= $vect[$i].'.ico';
		}
		
		$icoModelDfn= _c_storedIcoPath.$icoNm;
		$icoTargetDfn= $this->destIcoPath.'logo.ico';
		
		$fls->secUnlink($icoTargetDfn);
		$fls->secureCopy($icoModelDfn,$icoTargetDfn);
	} // tg_setabicon
	

	/**
		$subject= str_replace($search,$replace,$subject);
		[fileSubstitute search="" replace="" dfn="" /]
	*/
	function tg_filesubstitute(&$v,&$bd){
		$search= $v['search'];
		$replace= $v['replace'];
		$dfn= $v['dfn'];
		$this->fileReplace($search,$replace,$dfn);
	} // tg_filesubstitute
	

	/**
		Adapt smartPhoneDiff.css and integrate it into the smartPhoneMen.css chablon! --> more precisely :
			smartPhoneMen.css = smartPhoneMen.css  + stdMenus/stdMenus.css + smartPhoneDiff.css
		[formatSmartPhoneMenu /]
	*/
	function tg_formatsmartphonemenu(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$fBar= &$this->forumBar;
		
		$menZPath= _c_destZCmsExplicC.'menus/';
		$sPhonePathFn= $menZPath._c_vertSmartPhMenName;
		
 		$sPhMenO= $fBar->persoToCssColor( $this->pstValSubst('ddMenBgColor2',$v['a']) );		// stdMenuOut background-color: #sPhMenO;		
		$sPhMenI= $fBar->persoToCssColor( $this->pstValSubst('ddMenBgColor4',$v['b']) );		// stdMenuIn background-color: #sPhMenI;
		$sPhHovMenO= $fBar->persoToCssColor( $this->pstValSubst('ddMenHovColor2',$v['c']) );	// stdMenuOut:hover  background-color: #sPhHovMenO;
		$sPhHovMenI= $fBar->persoToCssColor( $this->pstValSubst('ddMenBgColor4',$v['d']) );		// stdMenuIn:hover  background-color: #sPhHovMenI; 
		$leftBrdrColor= $fBar->persoToCssColor( $this->pstValSubst('ddMenuTxtColor',$v['e']) );	// #leftBrdrColor
		
		$search= array('sPhMenO','sPhMenI','sPhHovMenO','sPhHovMenI','leftBrdrColor');
		$replace= array($sPhMenO, $sPhMenI, $sPhHovMenO, $sPhHovMenI, $leftBrdrColor);		
		
		$smartPhoneCss= $fls->fileToStr($sPhonePathFn);
		$smartPhoneCss= str_replace($search,$replace,$smartPhoneCss);
		
		$fls->strToFile($sPhonePathFn,$smartPhoneCss);
	} // tg_formatsmartphonemenu
	

	/**
		[cpyPasteMenCss site="" /]
	*/
	function tg_cpypastemencss(&$v,&$bd){
		$fls= &$this->fls;
				
		$destDumpPath= _c_destZCmsExplicC.'menus';	// The real target !!
		$fls->removeDir($destDumpPath);
		
		$site= $v['site'];
		$srcPath= _c_usrCopyPaste.$site.'/menus';
		$fls->copyDirectories($srcPath,$destDumpPath);
	} // tg_cpypastemencss
	

	/**
		[removeLgSpecPolyglotCss /]
	*/
	function tg_removelgspecpolyglotcss(&$v,&$bd){
		$fls= &$this->fls;
		$pF= _c_destZCmsExplicC.'polyglot/polyglot.css';	// to remove! the specific flag switch used for standard form-installation
		$fls->secUnlink($pF);
	} // tg_removelgspecpolyglotcss
	

	/**
		[cpyPasteGenImg /]
	*/
	function tg_cpypastegenimg(&$v,&$bd){
		$fls= &$this->fls;
		
		$destDumpPath= _c_destGeneralImages;	// The real target !!
		
		$site= $v['site'];
		$srcPath= _c_usrCopyPaste.$site.'/images';
		$fls->copyDirectories($srcPath,$destDumpPath);
	} // tg_cpypastegenimg
	
		
	/**
		Post Val sibstitute! ... because nothing was posted in the case of the execution of a stand alone xm2 file.
		Input :
			$pstNm : posted name.
	*/
	function pstValSubst($pstNm,$substVal){	
		$tools= &$this->tools;
	
		/**
			In this class, it seems possible to use all false values as a cue for parametrable substitution.
		*/
		$pstVal= $tools->postVal($pstNm);
		if ($pstVal!==false){
			return $pstVal;
		}else{
			return $substVal;
		}
	} // pstValSubst


	/**
		Erases squared Tags (got an equivalent in JS : forumBar::erasesSqrtTg() )
	*/
	function erasesSqrtTags($str){
		$inTag= false;
		$stripped='';
		$sz= strlen($str);
		for ($i=0; $i<$sz; $i++){
			$cn= $str[$i];
			$delay= false;

			switch ($cn){
				case '[':
					$inTag= true;
				break;
				
				
				case ']':
					$inTag= false;
					$delay= true;
				break;							
			} // switch

			if (!$inTag && !$delay){
				$stripped.= $cn;
			}
		} // for
		
		return $stripped;
	} // erasesSqrtTags

	
	/**
		[adaptComplexGenvar /]
	*/
	function tg_adaptcomplexgenvar(&$v,&$bd){
		$fls= &$this->fls;
		$dtbW= &$this->dtbW;

		$dtbW->setGenVar('domainNoRefStats',$fls->domainName());
	} // tg_adaptcomplexgenvar
	
	
	
	/**
		A tag to checks the connection validity! when connection informations have been filled in the same form.
		[chkNectValidity userNameVar="installerExtDtbUsrNm" dbPwVar="dtbPassword" serverVar="installerDtbAccessUrl" /]
	*/
	function tg_chknectvalidity(&$v,&$bd){
		$asa= &$this->asa;
		$glob= &$this->glob;
		$acc= &$this->acc;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtbR= &$this->dtbR;
		$hPwC= &$this->hPwC;
		$rMg= &$this->rMg;
		$wmRights= &$this->wmRights;
		$mWdgt= &$this->mWdgt;
		$pRnd= &$this->pRnd;
		
		if (!($glob->cndtWrRghts===true && $rMg->quickWMRight())){
			$no= $glob->el('Sorry you do not have the rights to test this connection','kbbd');
			$mWdgt->sentWdgtStr.= $no;
			$mWdgt->activeWdgtStr.= $no;
			return false;
		}
			
		if ($this->installerWitness){
			return '';	// in fact never happens because not called, but make a point!
		}
		
		if ($tools->postVal('specDtbWdgt')==='curDTB'){
			// the specified database widget is the current database ... nothing to do !
			return '';	// fine already connected
		}
		
		$quiet= $v['quietsuccess']===_c_ok;
		if ( $this->locFormWasPosted() ){
			$repMin= !$wmRights->erroReportMax();
		
			// only simulSql case because difficult to open 2 Dtb in parallel! So just usewd where it's the most usefull, for newbie installation
		
			// Get the names of the Posting strings variables
			$userName= $tools->postVal($v['usernamevar']);
			$dtbPassword= $tools->postVal($v['dbpwvar']);
			$server= $tools->postVal($v['servervar']);
			$kCode= $tools->postVal('forceLargeInt');	// kCode for ok or ko code !!
			if ($kCode!==false){			
				// Block : incryptDtbPassWordGotATwin
				$sortOfInt= $pRnd->smalLargeIntToExplicit($kCode);	// To identify what sort of integers are used		
				if (!$rMg->forceEditRights){
					$topHshId= $tools->spcCookVal('ckTopHashId');	// real hash 20 chars
					$crptK= $dtbR->getElem(_c_topHashTbl, _c_topHashIdH,$topHshId, _c_topHashC2Pw);	// inside the actually runing database
					$dtbPassword= $hPwC->doUnCrypt($dtbPassword,$crptK,$sortOfInt);
				} // else : forced full debug, don't uses general hashes !!
			} // no password crypting
			
			include_once _c_DtbLibPath.'aMySql.php';
			$dtbCmpl= null;
			$aSql= new aMySql($asa,$dtbCmpl);
			
			if ($repMin){
				error_reporting(NULL);	// don't want an error blur for our new user !!!!
			}
			
			// Partial DTB connection (dtb name not specified) because it needs to work if the dtb does not exists!
			$boollNect= $aSql->sqlDbConnect($server, $userName, $dtbPassword,false);
			error_reporting(E_ALL);
			$mWdgt->serieBoolTest($boollNect!==false,'chkNectValidity::sql real_connect');	// "instanciates the error"

			// $got= $userName.' | '.$dtbPassword.' | '.$server;
			$got= $userName.' | **** | '.$server;
			if ($boollNect!==false){
				// SUCCESS
				if (!$quiet){
					$fmtGot= $caps->span($got,'userHelp');	// formated connection param we got
					$sStr= $caps->span($glob->sl('Successfull MySql connection...','kavp'),'userHelp');
					$mWdgt->sentWdgtStr.= _c_.$sStr.$fmtGot;	// appear when failing for another reason
					$mWdgt->activeWdgtStr.= _c_.$sStr.$fmtGot;
				}
			}else{
				$fmtGot= $caps->span($got,'forMnWdgtDataErr');	// formated connection param we got
				$mWdgt->sentWdgtStr.= _c_.$glob->sl('Error dtb connect...','kavo').$fmtGot;	// SHOULD NEVER HAPPEND !!!
				$mWdgt->activeWdgtStr.= _c_.$caps->span($glob->sl('Error with the mySql connection','kavo'),'forMnWdgtGenErr').$fmtGot;			
			}
			
			
			// Check the Database Creation
			if ($boollNect!==false){			
				$dtbName= $tools->postVal($v['dtbnamevar']);
				
				$accptIdx= $tools->postVal('mNmAcceptIndx');
				if ($accptIdx===_c_ok){
					$curIdx= $tools->postVal('installerMDirNmIdx');	// and also the index of the database!
					$dtbName.= $curIdx;
				}
				
				$dtbW= new localDB($asa,$aSql);

				if ($repMin){
					error_reporting(NULL);	// don't want an error blur for our new user !!!!
				}
				$boollCrea= $dtbW->createDatabase($dtbName);	// creates (if not exists) just the lightest shell, can call it many times in a row!
				error_reporting(E_ALL);
				
				
				$mWdgt->serieBoolTest($boollCrea!==false,'chkNectValidity::CREATE DATABASE IF NOT EXISTS');	// "instanciates the error"

				if ($boollCrea){
					$boollNect= $dtbW->dbConnect($server, $userName, $dtbPassword,$dtbName);	// ful connection
				
					if (!$quiet){
						$sStr= $caps->span($glob->sl('Successfull database creation...','kavq'),'userHelp');
						$mWdgt->sentWdgtStr.= _c_.$sStr;	// appear when failing for another reason
						$mWdgt->activeWdgtStr.= _c_.$sStr;
					}
					
					$byPsTm= $tools->postVal('byPassTime');
					if ($byPsTm!==_c_ok && $boollNect!==false && $boollCrea){			
						// test the time parameter
						$allowInstallation= $this->installProtect($dtbW);
						$mWdgt->serieBoolTest($allowInstallation);	// error message included
					}
					
				}else{
					$mWdgt->sentWdgtStr.= _c_.$glob->sl('Error dtb crea...','kavr');	// SHOULD NEVER HAPPEND !!!
					$mWdgt->activeWdgtStr.= _c_.$caps->span($glob->sl('Error with the database creation...','kavr'),'forMnWdgtGenErr');
				}
			}
			
			$aSql->close();
		}
	} // tg_chknectvalidity	
					
	
	/**
		[setPartialRandVal /]
		Set a given record value with a random part
		When a directory is concerned, should change it as well!!!!!!!
		pfxval : stable prefix for directories files.
	*/
	function tg_setpartialrandval(&$v,&$bd){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtbR= &$this->dtbR;
		$dtbW= &$this->dtbW;
		$hPwC= &$this->hPwC;
		

		
		$tbl= $tools->binLoads($v['tbl'],_c_GenVarTbl);
		$assField= $tools->binLoads($v['assfield'],_c_genVarStr);
		$rndsz= (int)$tools->binLoads($v['rndsz'],10);
		
		
		$rndErZ= $v['rndersatzt'];
		if ($rndErZ===false){
			$assVal= $v['pfxval'].$hPwC->consonStr($rndsz);		// + rnd str === the directory name OR the beginning of the file name.
		}else{
			$assVal= $v['pfxval'].$rndErZ;
		}
		
		$sfx= $v['sfx'];
		if ($sfx!==false){
			$assVal.= $sfx;
		}		
		
		$condField= $tools->binLoads($v['condfield'],_c_genId);
		$condVal= $v['condval'];
		
		// Manages the genVar record
		$dtbW->setElem($tbl,  $assField,$assVal,  $condField,$condVal);
		
		if ($sfx===false){
			// got to change a directory
			$localPath= $v['path'];
			switch ($localPath){
				case '..':
					// just create a new directory and leave the old one alone (others Ataox you installed may use it)
					$projErsatzArch= _c_ProjectsPath.$assVal;
					$dtbR->setGenVar('lastBuiltSecretArchDN',$assVal);
					$fls->wMkDir($projErsatzArch);
				break;
				
				case _c_zCmsDirN:
					if ( file_exists(_c_frmBuildDestPath) && !$this->masterDistribState ){
						$pathNS= _c_frmBuildDestPath._c_zCmsDirN;	// test
						
						if (!file_exists($pathNS)){
							$fls->wMkDir($pathNS);
						}
						$pathZ= $pathNS.'/';
						$oldVal= 'secret_ers_a_tztD'; // for now _c_zCmsDirN alwayss imply this value. For other values need bew param!
						$fls->secureRename($pathZ,$oldVal, $pathZ,$assVal);
					}
				break;
				
				default:;
			} // switch
		}	// do not bother writing files they get changed on the spot with the correct new name
	} // tg_setpartialrandval
	


	/**
		Change a given record value :
			[chgRecVal tbl="genVar" assField="str" assVal="ok" condVal="fumFreeId" /]
		
		Special simplification for the genVar table :
			[chgRecVal assVal="ok" condVal="fumFreeId" /]
	*/
	function tg_chgrecval(&$v,&$bd){
		$hPwC= &$this->hPwC;
		$tools= &$this->tools;
		$dtbW= &$this->dtbW;
		
		$tbl= $tools->binLoads($v['tbl'],_c_GenVarTbl);
		$assField= $tools->binLoads($v['assfield'],_c_genVarStr);
		
		$postedVal= $v['postedval'];
		if ($postedVal===false){
			$rnd= $v['rnd'];
			if ($rnd!==false){
				// assign a random string of size $rnd
				$assVal= $hPwC->consonStr((int)$rnd);
			}else{
				$assVal= $v['assval'];	// If not posted, need to be manually assigned inside the xm2 file
			}
		}else{
			$assVal= $tools->postVal($postedVal);	// No need for $tools->pstValSubst() because treated inside the if
		}
		
		$condField= $tools->binLoads($v['condfield'],_c_genId);
		$condVal= $v['condval'];
		
		$dtbW->setElem($tbl,  $assField,$assVal,  $condField,$condVal);
	} // tg_chgrecval
	
	
	/**
		Chages the specified record Only when Building the Distribution: Obd
		[ObdChgRecVal assVal="ok" condVal="fumFreeId" /]
	*/
	function tg_obdchgrecval(&$v,&$bd){
		$tools= &$this->tools;
		
		$sod= $tools->postVal('sortOfDistrib');
		if ($sod!==false){
			// We are buiding a distribution
			$this->tg_chgrecval($v,$bd);	// rare direct call of a tag function	
		}
	} // tg_obdchgrecval
	
	
	
		
	/**
	*/
	function setGVInstallTime(){	
		$glob= &$this->glob;
		$dtbW= &$this->dtbW;
		
		$b= $glob->allowsSqlErrors;
		$glob->allowsSqlErrors= false;
		$dtbW->setGenVar('firstInstallationTm',time());
		$glob->allowsSqlErrors= $b;
	} // setGVInstallTime
	
		
	/**
	*/
	function setGVAcceptITm(){	
		$dtbW= &$this->dtbW;
		$dtbW->setGenVar('acceptFirstInstTm',_c_ok);
	} // setGVAcceptITm
	
	
	/**
		Execute a function of this class given by name
		[exeFrameBuilFu fu="setPossibleSurfLang" /]
	*/
	function tg_exeframebuilfu(&$v,&$bd){
		$fu= $v['fu'];
		$this->$fu();
	} // tg_exeframebuilfu
	
	
	/**
		Returns true if the local form was posted.
	*/
	function locFormWasPosted(){	
		$mWdgt= &$this->mWdgt;
		return $mWdgt->theFormWasPosted();
	} // locFormWasPosted
	
	
	/**
		Makes sure that Utf string is as url safe as "possible".
		--> mb split + remove the &
	*/
	function urlSafeUtfStr($str){	
		$tools= &$this->tools;
		
		$newStr= '';
		$v= $tools->mbStrToAry($str,$sz);
		reset($v);
		foreach ($v as $key=>$val){
			if ( !$this->urlSignificantChar($val) ){
				$newStr.= $val;
			}
		}
		
		return $newStr;
	} // urlSafeUtfStr
	

	/**
		Returns true if $c a url significant character or a disturbing character!
	*/
	function urlSignificantChar($c){
		return $c==='&' || $c==='?' || $c==='=' || $c===_c_rT || $c===_c_nL || $c===_c_carRet; 
	} // urlSignificantChar	
	
	
	/**
		[cleanUp /]  Clean up after installation,form the installing site perspective, for now :
		Does not do anything because things have been treated at the source!
	*/
	function tg_cleanup(&$v,&$bd){
	} // tg_cleanup
		
} // frameBuilder
?>
