<?php
/**
	File name : imGallery.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	To disply a JS click sensitive gallery.
	
	[extPlugin name="imGallery" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	imGallery::gallerytox2()	
*/

include_once _c_toDeclPlugCntr.'imGallery/imGallCpml.php';

class imGallery extends imGallCpml{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct($tagsFu);	
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
	
		$glob->explCentralInclStanceJs('forumBar');
		$glob->addCssFile(_c_toDeclPlugExt.'imGallery/imGallery.css');
		$glob->explExternInclStanceJs('imGallery');
		
		// To reset writing box
		$glob->setGlbEndJsCode('kk.initCurrentDisplay("debugDisplay");'._c_R);
		
		/**
			Attributes :
				arean : area name.
				pathdir : path to the concerned image directory.
				dircateg : path starting from inside the code directory or inside the 'images'
						user directory (default)
				defaultlastdir : ok or ko
		*/
		$tagsFu->attribVect['gallerytox2']= array('targetareanm','pathdir','dircateg','strategy');
		
	} // construct


	/**
	*/
	function tags(){
		return array('gallerytox2');
	} // tags
	
		
	/**
		[galleryToX2 areaN="emoticonFiller" pathDir="thirdParty/images/parc/" dirCateg="code" /] : gallery to xml2.
		To be called inside a frame to display many clickable images used to JS build some xml2 tags
		inside a parent window holding an area! Calling is done with a javascriot button opening  page
		inside a frame.
		
		Step 1 : just build a standard gallery.
		Step 2 : add the javascript link to write into the parent window.
	*/
	function tg_gallerytox2(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
	
		$dirCateg= $tools->getVal('dircateg');
		if ($dirCateg===false){
			return '';
		}
	
		$finaldirdspl= $tools->getVal('finaldirdspl');		// how to display an eventual access directory in the final tag
		$fullPathDirOrig= $tools->getVal('fullPathDir');
		
		
		$noSlashFllPD= $this->getFinalNoSlashFlPD($fullPathDirOrig,$dirCateg);
				
		$imgPack= '';
		$i=0;
		$fullPathDir= $noSlashFllPD.'/';
		if ($noSlashFllPD!==false && is_dir($noSlashFllPD) && $fls->firstLevelFiles($dirF, $fullPathDir)){	// extracts $dirF (the file vector)
			sort($dirF);
			
			$iFrWidth= $tools->getVal(_c_UvGallIFrWidth);
			$imgTotW= 0;
			reset($dirF);
			foreach ($dirF as $key=>$curFile){			
				$fls->splitOnLastC($curFile,$fileBody,$ext,'.');
				$ext= strtolower($ext);
				if ($fls->imgOkToDspl($ext)){
					// We have a displayable image, so display it!
					
					$dFn= $fullPathDir.$curFile;
					$thumbDFn= $fullPathDir._c_thumbsDirN.'/'.$curFile;
					
					switch ($finaldirdspl){
						case 'ko':		// none default base and default end directory
							$curV['d']= false;
						break;

						
						case 'icon':
							$fls->splitOnLastC($fullPathDirOrig,$left,$lastDir,'/');
							$curV['d']= $lastDir;
						break;
						
						case 'statEmot':
						case 'dynEmot':	
							$curV['d']= false;
							$curV['n']= $curFile;
						break;
						
						case 'last':	// just the last directory because uses a default base
							$fls->splitOnLastC($fullPathDirOrig,$left,$lastDir,'/');
							$curV['d']= $lastDir;
						break;
 						
						case 'full':	// the full path, the icon could be anywhere (standard image)
							$curV['name']= $fullPathDirOrig.$curFile;
							$curV['alt']= '';
							$curV['cls']= 'imgLnStl';
						break;
						
						case 'fullZm':	// ---- zoom
							$curV['name']= $fullPathDirOrig.$curFile;
							$curV['s']= false;
							$curV['d']= false;
						break;
						
						case 'freeGall':	// ---- zoom from the free gallery
							$localDir= substr($fullPathDirOrig,_c_mainImgDfnSz);
							$curV['name']= $localDir.$curFile;
							$curV['s']= false;
							$curV['d']= false;
						break;
						
						default:;
					} // switch

					if ($finaldirdspl==='ko' || $finaldirdspl==='last'){
						if ($ext==='png'){
							$curV['s']= $fileBody;	// standard don't need the extension
						}else{
							$curV['s']= $curFile;	// $fileBody.'.'.$ext;
						}
					}
					
					/*
						Build the tags.
					*/
					switch ($finaldirdspl){
						case 'fullZm':
						case 'freeGall':
							$curBd= ' largeImageComment ';
							$curV['alt']= $fileBody;
							$curV['ttl']= $fileBody;
							$curV['cls']= 'galleryImg';
							$xmlStr= $tagsFu->rebuildTagStr('z', $curV,$curBd,true);
						break;
						
						// simple images
						case 'full':
							$xmlStr= $tagsFu->rebuildTagStr('i', $curV,'',true);
						break;
					
						
						// Static emoticon
						case 'statEmot':
							$xmlStr= $tagsFu->rebuildTagStr('emo', $curV,'',true);
						break;
						
						// Dynamoc emoticon
						case 'dynEmot':
							$xmlStr= $tagsFu->rebuildTagStr('dmo', $curV,'',true);
						break;
						
						
						case 'icon':
							$curV['s']= $curFile;	// $fileBody.'.'.$ext;
							$xmlStr= $tagsFu->rebuildTagStr('icon', $curV,'',true);
						break;
						
						// ic
						default:
							$xmlStr= $tagsFu->rebuildTagStr('ic', $curV,'',true);
						break;
					} // switch
					
					$xmlStr= str_replace('"',_c_fDblQuotSubst,$xmlStr);
					$js= $caps->jsFunctCallStr('onclick','forumBar.txtAActParent',3,0,'icon',_c_ok,$xmlStr);
					
					if (file_exists($thumbDFn) ){
						$curDFn= $thumbDFn;
					}else{
						$curDFn= $dFn;
					}
					
					$szImgV= getimagesize($curDFn);
					$imgW= $szImgV[0]+5;	// image width + margin
					
					$imgTotW= $imgTotW+$imgW;
					if ($imgTotW>=$iFrWidth-$imgW*1.5){
						$lineBr= _c_BrFlux;
						$imgTotW= $imgW;
					}else{
						$lineBr= '';
					}
					
					if ($curFile==='1Credits.png'){
						$fls->splitOnLastC($noSlashFllPD,$left,$lastDir);
						$url= $dtb->getGenVar('urlCredit_'.$lastDir);
						$imgPack.= $lineBr.$caps->linkImg($curDFn,'Credits',$url,'galleryImg','_blank')._c_R;
					}else{
						$imgPack.= $lineBr.$caps->ttlImage($curDFn,$fileBody,$fileBody, 'galleryImg','',$js)._c_R;
					}
				} // imgOkToDspl
			} // for
			
			$divWidth= $iFrWidth-10;
			if ($imgPack!==''){
			
				// $imgPack.= _c_BrFlux.$caps->textarea('debugDisplay',19,120,'');		// debug
				$imgPack.= _c_BrFlux.$caps->textarea('debugDisplay',19,'w','', $caps->matStyl('width:100%') );		// debug

				// return $caps->sDiv($imgPack,'width='.$divWidth.'px;  float:left; margin-left: 5px; margin-right: 5px; margin-top: 5px; border: 0px solid red;');
				return $caps->sDiv($imgPack,' width:99%; float:left; margin-left:0.5%; margin-right:0.5%; margin-top: 5px; border:0px solid red;');
			}else{
				return '';
			}
		}
		
		return '';
	} // tg_gallerytox2

		
	/**
	*/
	function tg_tmptag(&$v,&$bd){
		$caps= &$this->caps;
	
	} // tg_tmptag

		
	/**
		Template for standard methods.
	*/
	function templateStd(){
	
	
	} // templateStd
		
} // imGallery
?>
