<?php
/**
	File name : mmGallery.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="mmGallery" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Direct calls explicit central or external :
			$tagsFu->instExplitCentralCls('classN');
			$tagsFu->instExplitExternalCls('classN');
*/
class mmGallery extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->tagsFu= &$tagsFu;
		
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->hPwC= &$tagsFu->hPwC;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->imgP= &$tagsFu->imgP;
		$this->imgTags= &$tagsFu->imgTags;
		$this->parser= &$tagsFu->parser;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('mmGallery','debugDisplay',true);	
		define('_c_xmTwoGalleryFN', 'codeXm2.txt');
		
		$this->checkedFiles= array();		// an array of the checked files.	
		$this->checkedTxt= array();			// an array of the checked text boxes values.
		
		$this->globV= array();	
		$this->globBD= array();	
		
		$this->fniGlobV= array();	
		$this->fniGlobBD= array();	
		
		$this->fniToChckdTxt= array();		
		
		$this->safeKeepGoing= true;
		$this->incorrectLengthNb= 0;
		
		// Pseudo tag for information extraction when parsing codeXm2.txt to fill the gallery
		$tagsFu->attribVect['z']= array('name','stay','alt','ttl','supstl','target', 'stl','cls','url','justtxt','mode','trunkafter');
		
	} // construct


	/**
	*/
	function tags(){
		return array('z');
	} // tags
	
	
	
	
	/**
	*/
	function loadsMmMg(&$mmMg){
		$this->mmMg= &$mmMg;
		$this->mmBox= &$mmMg->mmBoxes;
		$this->mmTools= &$mmMg->mmTools;
	} // loadsMmMg


	/**
	*/
	function mmImposejpg($dfn){
		$fls= &$this->fls;
				
		$newDfn= $fls->imposejpg($dfn);
		
		$fls->splitOnLastC($dfn,$path,$fn,'/');
		
		$fhumbDfn= $path.'/'._c_thumbsDirN.'/'.$fn;
		if ( file_exists($fhumbDfn) ){
			$fls->imposejpg($fhumbDfn);
		}
		
		return $newDfn;
	} // mmImposejpg


	/**
		Set a file name indexed vector to a checked text string value.
	*/
	function setFniToChckdTxt(){
		$fls= &$this->fls;
		reset($this->checkedFiles);
		foreach ($this->checkedFiles as $key=>$fn){
			$this->fniToChckdTxt[ $fn ]= $this->checkedTxt[$key];
		}
	} // setFniToChckdTxt
		
	function giveChckdTxt($fn){
		if ( array_key_exists($fn,$this->fniToChckdTxt) ){
			return $this->fniToChckdTxt[$fn];
		}else{
			return false;
		}
	} // giveChckdTxt
	

	/**
		Build and Display the gallery xm2 file code.
		Algo ----> uses $this->checkedFiles and $this->checkedTxt
		
		Algo :
			[z name="forum/users/perso/xx/1.jpg" alt="1" ttl="1" cls="galleryImg"] largeImageComment [/z]
			
			- Extract all the z tags with a super-imposed z tag as a way to keep the in-text position and to add
			the new informations present inside the text boxes.
				- The supper-imposed z tag does the extraction reformating job and is "actualised" just 
				during the necessary parsing time.
			- Each time add a header message that only the z tags contents and their order is going to be used,
			outside tags and content is going to be lost.
			
			
		
		Note, the classical activation is done just before using the tag and desactivated after (replaced with
		the standard one)
			$tagsFu->attribVect['z']= array('name','alt','ttl','cls','p','target');
			$tagsFu->explicitTags[$tag]= $className;
			
			$tagsFu->rebuildTagStr($tag, &$v,$bd='',$bSlashExtrn=false)
	*/
	function xmCode(){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$parser= &$this->parser;
		$mmMg= &$this->mmMg;
		$mmBox= &$this->mmBox;
		$mmTools= &$this->mmTools;

		
		if ($glob->cndtWrRghts===false){
			return '';
		}
		
		if (!$this->safeKeepGoing){
			return '';	// Got a too long name
		}
		
		
		$modeSelectId= $tools->postVal('modeSelectId');
		if ($modeSelectId!==_c_mGalVisMode){
			return $caps->span(_c_.$glob->el('Error : the gallery mode must be set before','kblm')._c_,'userError')._c_BrFlux;
		}
		
		$xmDfn= $this->xmFileDfn();
		
		$path= $tools->getVal($tools->urlPathVar('1'));		// Bias column 1
		$pathSlh= $path.'/';
		
		$pathSz= strlen($path);
		$localImgPath= substr($path,_c_mainImgDfnSz);

		$rbldtTgBuff= '';
		$rbldtTgBuff.= '';
		$rbldtTgBuff.= '[rem][code]'._c_R;
		$rbldtTgBuff.= $glob->el('Many parts of this Xpetal (codeXm2.txt) file are changed automatically ...','kblf')._c_R;
		$rbldtTgBuff.= '[/code][/rem]'._c_R._c_R;
		
		$rbldtTgBuff.= _c_R;	
		$catW= $dtb->getGenVar('galCatWalk',_c_ko);
		if ($catW===_c_ok){			
			$rbldtTgBuff.= '[mobExpdShrkPlus /]'._c_R;
		}else{
			$rbldtTgBuff.= '[mobExpdShrk /]'._c_R;
		}		
		$rbldtTgBuff.= '[bf/]';
		$rbldtTgBuff.= _c_R;
		
		
		$rndPfx= $hPwC->consonStr(3);
		$agxRnd= $dtb->getGenVar('addGallXpetJsRndParam',_c_ko); // don't want it by default because hard to manipulate for newbies
		$rndType= $dtb->getGenVar('gallXpetJsRndType','png');
		if ($agxRnd===_c_ok){
			$rbldtTgBuff.= '[setZLocalPath name="'.$localImgPath.'" pfx="'.$rndPfx.'" maxText="ok" defbr="bg" jsvar="ok" rndtype="'.$rndType.'" /]'._c_R;
		}else{
			$rbldtTgBuff.= '[setZLocalPath name="'.$localImgPath.'" pfx="'.$rndPfx.'" maxText="ok" defbr="bg" /]'._c_R;
		}
		
		
		$iPL= 1;
		$imgPerLn= (int)$dtb->getGenVar('gallNbImagesPerLine');
		
		if (file_exists($xmDfn)){
			$xmStr= $fls->fileToStr($xmDfn);
			
			$imgTag= &$tagsFu->explicitTags['z'];
			$tagsFu->explicitTags['z']= 'mmGallery';		// so tg_z() is taken from this class !!!!!!!!!!!!!!!
			$parser->addrParseStdStr($xmStr);		// to load $this->globV that got the correct order
			$tagsFu->explicitTags['z']= 'imgTags';	// back to standard class for tg_z()
			
			$this->setFniToChckdTxt();
				
			/**
				Keep the vector order and add the new elements from the text boxes.
			*/
			reset($this->globV);
			foreach ($this->globV as $key=>$v){
				$bd= $this->globBD[$key];
				$fn= $v['name'];
				
				$chkTxt= $this->giveChckdTxt($fn);
				
				if ($chkTxt===false){
					return $caps->span(_c_.$glob->el('Error : a discrepancy ...','kblg')._c_,'userError')._c_BrFlux;
				}
				
				$fls->splitOnLastC($fn,$bodyFn,$ext,'.');
				$newFn= $fls->safeIdString($chkTxt);
				$newFnExt= $newFn.'.'.$ext;
				
				if ($newFn!==$bodyFn){
					$fls->secureRename($pathSlh,$fn,  $pathSlh,$newFnExt);
					
					// rename the old thumb
					$pathThumbs= $pathSlh._c_thumbsDirN.'/';
					$fls->secureRename($pathThumbs,$fn,  $pathThumbs,$newFnExt);
				}
			
				$v['name']= $newFnExt;
				if ( $tools->postVal(_c_autoDirFlRemover)===_c_ok ){
					// Only if the Ecr: box is checked
					$v['alt']= $chkTxt;
					$v['ttl']= $chkTxt;
				}
				
				$rbldtTgBuff.= $tagsFu->rebuildTagStr('z',$v,$bd)._c_R;
				if ($iPL<$imgPerLn){
					$iPL++;
				}else{
					$rbldtTgBuff.= '[bg/]'._c_R;
					$iPL= 1;
				}
			}
			$fls->secUnlink($xmDfn);
		}else{
			// File creation 1st time !
		
			// Build the file from $this->checkedFiles
			reset($this->checkedFiles);
			foreach ($this->checkedFiles as $key=>$fn){
				$chkTxt= $this->checkedTxt[$key];
				
				$newFn= $fls->safeIdString($chkTxt);
				$fls->splitOnLastC($fn,$bodyFn,$ext,'.');
				
				if ($newFn!==$bodyFn){
					$fls->secureRename($pathSlh,$fn,  $pathSlh, $newFn.'.'.$ext);
				}

				$v['name']= $newFn.'.'.$ext;
				
				// --> just too much bother with a huge xpetal input
				$v['alt']= false;	// $v['alt']= $chkTxt;
				$v['ttl']= false;	// $v['ttl']= $chkTxt;
				
				$bd= $chkTxt;
				$rbldtTgBuff.= $tagsFu->rebuildTagStr('z',$v,$bd)._c_R;
				if ($iPL<$imgPerLn){
					$iPL++;
				}else{
					$rbldtTgBuff.= '[bg/]'._c_R;
					$iPL= 1;
				}
			}
		}
		
		$rbldtTgBuff.= '[bg/]'._c_R;
		$rbldtTgBuff.= '[cancelImgSpSty /]'._c_R;
		
		$fls->strToFile($xmDfn,$rbldtTgBuff);	// save the XM2 file
		
		$txtEdtLn= $mmTools->callEditor($xmDfn,'mmGalLink',$glob->el('Click here to improve the generated file.','kblh'));
		$visGal= $mmTools->dsplXmSqrFileLn($xmDfn,'mmGalLink',$glob->el('Click here to visualise the gallery.','kbli'),'rocket.png');
		
		$curTA= $caps->textarea('zmXmToCpy','8','97',$rbldtTgBuff,'',false,false,'mmGalTA');
		return $caps->div($curTA,'mmGalDivTA')._c_.$txtEdtLn._c_._c_.$visGal._c_BrFlux;
	} // xmCode


	/**
		An imgTags::tg_z() substitute to extract each tag parameter and 
		build an in-order vector of $v[i] : $this->globV[]
		mmGallery::->globV ;  mmGallery::->globBD
	*/
	function tg_z(&$v,&$bd){
		array_push($this->globV,$v);
		array_push($this->globBD,$bd);
	} // tg_z
		
	/**
	*/
	function unsetGlobVBd(){
		$tools= &$this->tools;
		$tools->unsetArray($this->globV);
		$tools->unsetArray($this->globBD);
	} // unsetGlobVBd
	

		
	/**
		For now independant adaptation of image names.
	*/
	function mmGallAdaptNm($dfn){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$mmBox= &$this->mmBox;
		$imgTags= &$this->imgTags;
		
		
		$crrctL= $this->imgNameCorrectLength($dfn,$fn,$newBdFn);
		if (!$crrctL){
			return false;
		}

		$fls->splitOnLastC($fn,$bodyFn,$ext,'.');
		if ($newBdFn!==$bodyFn){
			$newFn= $newBdFn.'.'.$ext;
			$path= $tools->getVal($tools->urlPathVar('1'));		// Bias column 1
			$pathSlh= $path.'/';
			$fls->secureRename($pathSlh,$fn,  $pathSlh, $newFn);
			
			// Adapt the text file (rem open and close the file for each file name to change, but acceptable considering the low usage of this method & the programming easiness)
			// Solving that more optimally imply an loop addition to $this->xmCode() using the 2 instance array.
			$xDfn= $this->xmFileDfn();
			$xStr= $fls->fileToStr($xDfn);
			$xStr= str_replace('"'.$fn.'"', '"'.$newFn.'"', $xStr);
			$fls->strToFile($xDfn,$xStr);
		}
		
		return true;
	} // mmGallAdaptNm
	
	
	/**
		Using the gallery facillity style to freely adapt file names
	*/
	function renameGTB($dfn){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$mmBox= &$this->mmBox;
		
		
		$fls->splitOnLastC($dfn,$left,$fn,'/');
		$curTxtBxNm= $mmBox->taSafeNmForNewName($fn,'1');
		$chkTxt= trim($tools->postVal($curTxtBxNm));
		
		if ( strrpos($chkTxt,'.')!==false ){
			$glob->userError('These file names keep the same extension, please do not give one!','kmbpNoTrad');
			return false;
		}
		
		$newBdFn= $fls->safeIdString($chkTxt);
		
		$fls->splitOnLastC($fn,$bodyFn,$ext,'.');
		if ($newBdFn!==$bodyFn){
			$newFn= $newBdFn.'.'.$ext;
			$path= $tools->getVal($tools->urlPathVar('1'));		// Bias column 1
			$pathSlh= $path.'/';
			$fls->secureRename($pathSlh,$fn,  $pathSlh, $newFn);
		}
		
		return true;
	} // renameGTB	
		

	/**
		Check if the new given name is of correct length.
	*/
	function imgNameCorrectLength($dfn,&$fn,&$newBdFn){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$mmBox= &$this->mmBox;
		$imgTags= &$this->imgTags;
		
		$fls->splitOnLastC($dfn,$left,$fn,'/');
		$curTxtBxNm= $mmBox->taSafeNmForNewName($fn,'1');
		$chkTxt= trim($tools->postVal($curTxtBxNm));
		$newBdFn= $fls->safeIdString($chkTxt);
		$testNm= $imgTags->bigImgLabelKey($newBdFn);
		$testNmSz= strlen($testNm)+_c_galleryPfxMaxSz;
		if ($testNmSz>_c_idTextsKeySz){
			$fillStr= $tools->fillingStr('x',_c_galleryPfxMaxSz);
			
			$mess= '';
			$this->incorrectLengthNb++;
			if ($this->incorrectLengthNb===1){
				// general explanation
				$mess.= $glob->el('The following Id(s) is/are too long! Note : ','kbnr');
				$mess.= $fillStr;
				$mess.= $glob->el(' ... respective values displayed below ... :','kbns');
				$mess.= _c_;
			}
						
			$excd= $testNmSz-_c_idTextsKeySz;
			$perc= ceil(100*$excd/$testNmSz);
			
			$maxStr= substr($newBdFn,0,strlen($newBdFn)-$excd);
			
			$mess.= $caps->monoList($fillStr.$testNm.', '.$perc.'%, '.$excd.', '.$maxStr);
			$glob->userError($mess,false,false);
			return false;
		}
	
		return true;
	} // imgNameCorrectLength
	

	
	/**
		Give the path of the XM2 Code file
	*/
	function xmFileDfn(){
		$tools= &$this->tools;
		$mmBox= &$this->mmBox;

		$path= $tools->getVal($tools->urlPathVar('1'));		// Bias column 1
		return $path.'/'._c_xmTwoGalleryFN;
	} // xmFileDfn



	/**
	*/
	function mmGAllRSzLrg($dfn){
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$imgP= &$this->imgP;
		
		if ( is_file($dfn) && $fls->imageType($dfn) ){
			$q= $dtb->getGenVar('gallImgQuality');
			$imgP->resizeProc($dfn,$dfn,_c_gallLargeWidth,_c_gallLargeHeight,$q);
		}
	} // mmGAllRSzLrg


	/**
		Build the special thumbs, with special gallery size.
		Input :
			$dfn : original image DFN
	*/
	function mmGallThmbs($dfn){
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$imgP= &$this->imgP;
		
		$fls->splitOnLastC($dfn,$path,$fn,'/');
		if (file_exists($path.'/zzNoThumbsDir.txt')){
			return;
		}
		
		$thumbDFN= $fls->thumbFromOrig($dfn,$path,$fn);
		if ( is_file($thumbDFN) && $fls->imageType($thumbDFN) ){
			$fls->secUnlink($thumbDFN);
		}
			
		$curThumbPath= $fls->curThumbPath($dfn);
		if (!$fls->fileExist($curThumbPath)){
			$fls->wMkDir($curThumbPath);
		}
				
		$q= $dtb->getGenVar('gallImgQuality');
		$imgP->resizeProc($dfn,$thumbDFN,_c_gallThumbWidth,_c_gallThumbHeight,$q);
	} // mmGallThmbs
	
		

	/**
		Add or complete one more element to the current gallery Xm code :
			If an XM2 code is 
				- already present, keep the image order defined in the code.
				- not there : take the aphabetical order (== chrono with most cameras).
				- in need of a change for the order ---> does it inside the text processor.
	*/
	function mmGallXm($dfn){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$mmBox= &$this->mmBox;
		
		if ($fls->imageType($dfn)){
			$fls->splitOnLastC($dfn,$left,$fn);
			array_push($this->checkedFiles,$fn);
			$tbId= $mmBox->taSafeNmForNewName($fn,'1');
			$textBoxVal= $tools->postVal($tbId);
			array_push($this->checkedTxt,$textBoxVal);
		}
	} // mmGallXm

	

	/**
		Deal with the current image for a complete processing.
		
		xmCode() !!!
	*/
	function mmGallry($dfn){		
		$crrctL= $this->imgNameCorrectLength($dfn,$fn,$newBdFn);
		if (!$crrctL){
			$this->safeKeepGoing= false;	// just avoid to execute some codde  
			return false;
		}
		
		$dfn= $this->mmImposejpg($dfn);	
		$this->mmGAllRSzLrg($dfn);
		$this->mmGallThmbs($dfn);
		$this->mmGallXm($dfn);		// build the matching xm2 code.
		return true;
	} // mmGallry
	
	/**
		Deal with the current image for a complete processing.while keeping the original size (the name can be changed)
	*/
	function mmGallryKeep($dfn){
		$crrctL= $this->imgNameCorrectLength($dfn,$fn,$newBdFn);
		if (!$crrctL){
			$this->safeKeepGoing= false;	// just avoid to execute some codde  
			return false;
		}
		
		$dfn= $this->mmImposejpg($dfn);	
		$this->mmGallThmbs($dfn);
		$this->mmGallXm($dfn);		// build the matching xm2 code.
		return true;
	} // mmGallryKeep
	
	
	/**
	*/
	function mmGallRename($dfn){
		$tagsFu= &$this->tagsFu;
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$imgTags= &$this->imgTags;
		
		
		$fls->splitOnLastC($dfn,$path,$oldFullImgNm);
		
		$fls->splitOnLastC($path,$prevPaths,$mayBeThumbsDir);
		if ($mayBeThumbsDir===_c_thumbsDirN){
			$glob->userError('Image selection must be done outside the thumbs directory','kbol');
			return;
		}
		
		
		$fls->splitOnLastC($oldFullImgNm,$oldImgBd,$oldImgExt,'.');
		if (!$fls->imgOkToDspl($oldImgExt)){
			$glob->userError('The selected file has an unacceptable type!','kbon');
			return;
		}
		
		$pfx= $tools->postVal('extensionTB');
		if ($pfx===''){
			$glob->userError('gallery prefix need to be filled ..','kboi');
			return;
		}
		
		$newFullImgNm= $tools->postVal('newName');	// new image name
		if ($newFullImgNm===''){
			$glob->userError('The name of the new file is missing.','kbok');
			return;
		}
		
		if ( $tools->sIsInB('.',$newFullImgNm) ){
			// extension was given so extract it
			$fls->splitOnLastC($newFullImgNm,$newImgBd,$imgExt,'.');
			$newImgBd= $fls->safeIdString($newImgBd);
			$newFullImgNm= $newImgBd.'.'.$imgExt;
		}else{
			$newImgBd= $fls->safeIdString($newFullImgNm);
			$newFullImgNm= $newImgBd.'.'.$oldImgExt;
		}
		
		if ($newFullImgNm===$oldFullImgNm){
			$glob->userError('The name of the new file is equal to the old one!','kboo');
			return;
		}
		
		$oldImgBdV= $tools->mbStrToA($oldImgBd);
		$oldImgBdV[0]= strtoupper($oldImgBdV[0]);
		$oldCaptImgBd= $tools->arrayToStr($oldImgBdV);
		
		
		$newImgBdV= $tools->mbStrToA($newImgBd);
		$newImgBdV[0]= strtoupper($newImgBdV[0]);
		$newCaptImgBd= $tools->arrayToStr($newImgBdV);
		
		
		$zmKey= $imgTags->bigImgLabelKey($oldImgBd,$pfx);
		$newZmKey= $imgTags->bigImgLabelKey($newImgBd,$pfx);
		if (strlen($newZmKey)>_c_idTextsKeySz){
			$eMess= $glob->el('The index following this is too long ...','kbom');
			$eMess.= _c_idTextsKeySz;
			$glob->userError($eMess);
			return;
		}
		
		// Get the _c_idTextsTbl
		$idXPetalInfo= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$zmKey, _c_idTextTxt);
		
		if ($idXPetalInfo===false){
			$eMess= $glob->el('The idTexts table has no index called : ','kboj');
			$eMess.= $zmKey;
			$glob->userError($eMess);
			return;
		}
		
		// Parse it to extract the glob var of [zmOrigPg] ... $imgTags->zmOriginPg
		$tagsFu->expandX($idXPetalInfo,'',false);
		$pgName= $imgTags->zmOriginPg;
		
		
		// Adapt the page
		$pgInfo= $dtb->getElem(_c_PolyCellPg, _c_pcId,$pgName, _c_pcMainStr);
		
		$pgInfo= str_replace($oldFullImgNm,$newFullImgNm,$pgInfo);
		
		
		$oldTxtImgBd= str_replace('-', ' ', $oldImgBd);
		$oldCaptTxtImgBd= str_replace('-', ' ', $oldCaptImgBd);
		$newTxtImgBd= str_replace('-', ' ', $newCaptImgBd);
		
		$pgInfo= str_replace(']'.$oldImgBd.'[', ']'.$newTxtImgBd.'[', $pgInfo);
		$pgInfo= str_replace(']'.$oldTxtImgBd.'[', ']'.$newTxtImgBd.'[', $pgInfo);
		$pgInfo= str_replace(']'.$oldCaptTxtImgBd.'[', ']'.$newTxtImgBd.'[', $pgInfo);
		$dtb->setElem(_c_PolyCellPg, _c_pcMainStr,$pgInfo, _c_pcId,$pgName);
		
		// Adapt the _c_idTextsTbl
		$idXPetalInfo= str_replace($oldFullImgNm,$newFullImgNm,$idXPetalInfo);
		$idXPetalInfo= str_replace($oldImgBd,$newTxtImgBd,$idXPetalInfo);
		$idXPetalInfo= str_replace($oldTxtImgBd,$newTxtImgBd,$idXPetalInfo);
		$idXPetalInfo= str_replace($oldCaptTxtImgBd,$newTxtImgBd,$idXPetalInfo);
		
		
		$rec[_c_idTextKey]= $newZmKey;
		$rec[_c_idTextTxt]= $idXPetalInfo;
		$dtb->setElem(_c_idTextsTbl, _c_idTextTxt,$idXPetalInfo, _c_idTextKey,$newZmKey, $rec);
		
		// Remove old record
		$dtb->delTableRecord(_c_idTextsTbl,_c_idTextKey,$zmKey);
		
		// Rename old image
		$newDfn= $path.'/'.$newFullImgNm;
		rename($dfn,$newDfn);
		
		// Rename old thumb
		$oldThDfn= $fls->thumbFromOrig($dfn);
		$newThDfn= $fls->thumbFromOrig($newDfn);
		rename($oldThDfn,$newThDfn);
		
		// Adapt the list
		$lKey= $imgTags->listId();
		$listInfo= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$lKey, _c_idTextTxt);
		$listInfo= str_replace($oldFullImgNm,$newFullImgNm,$listInfo);
		$dtb->setElem(_c_idTextsTbl, _c_idTextTxt,$listInfo, _c_idTextKey,$lKey);

		
		// Adapt the % ponderation ... use surrounding char to avoid internal twins!!
		$wId= $imgTags->weightingId();
		$wInfo= $dtb->getElem(_c_idTextsTbl, _c_idTextKey,$wId, _c_idTextTxt);
		$wInfo= str_replace($oldImgBd,$newImgBd,$wInfo);
		$dtb->setElem(_c_idTextsTbl, _c_idTextTxt,$wInfo, _c_idTextKey,$wId);
	} // mmGallRename
		
} // mmGallery
?>