<?php
/**
	File name : mobility.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	A specialised class to solve physical mobility related concepts, up to now 
	(map / schweizmobil.ch, schedule / sbb.ch).
	[extPlugin name="mobility" /]				[_ r="PLUGIN DECLARATION"/]
*/
class mobility extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('mobility','debugDisplay',true);
		
		$tagsFu->attribVect['carterando']= array('img','alt','url','urlsffx','cls','target','follow');
		$tagsFu->attribVect['cffsched']= array('hikestart','hikeend','cls','lbl1','lbl2');
	} // construct


	/**
	*/
	function tags(){
		return array('carterando','cffsched');
	} // tags

	
	/**
		[carteRando urlSffx="X=603655&Y=163040&resolution=250" /]
	*/
	function tg_carterando(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		
		$img= $tools->binLoads($v['img'],'carte.png');
		$alt= $tools->binLoads( $v['alt'], $glob->sl('Switzerland Map','kbod') );
			
		$imgDFn= _c_mainImgDfn.$img;
		
		$url= $v['url'];
		if ($url===false){
			$urlsffx= $v['urlsffx'];
			$url= 'https://map.schweizmobil.ch/?lang=fr&bgLayer=pk&'.$urlsffx;
		}
		
		$cls= $tools->binLoads($v['cls'],'slImg');
		
		$target= $tools->binLoads($v['target'],'_blank');
		$follow= $tools->binLoads($v['follow'],_c_ko);
		
		return $caps->linkImg($imgDFn, $alt, $url, $cls, $target, $follow);
	} // tg_carterando
	
		
	/**
		cffsched
		[cffSched hikeStart="" hikeEnd="" /]
	*/
	function tg_cffsched(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		
		
		$hikeStart= $v['hikestart'];	// 1st Station name
		$urlStart= 'http://fahrplan.sbb.ch/bin/query.exe/f?start=1&Z='.$hikeStart;
		
		$hikeEnd= $v['hikeend'];	// Last station name
		$urlEnd= 'http://fahrplan.sbb.ch/bin/query.exe/f?start=1&S='.$hikeEnd;
		
		$cls= $tools->binLoads($v['cls'],'gecStandLn');
		
		
		$lbl= $tools->binLoads($v['lbl1'], $glob->sl('Start','kboe'));
		$startStr= $caps->hL($urlStart, $lbl, $cls. '', '_blank');
		
		
		$lbl= $tools->binLoads( $v['lbl2'], $glob->sl('Back','kbof') );
		$endStr= $caps->hL($urlEnd, $lbl, $cls. '', '_blank');
		
		$b= '';
		$b.= '';
		
		$b.= $caps->span($glob->sl('Schedule :','kbog'),'gecSubTtl');
		
		$s= '';
		$s.= $caps->elemLi($startStr);
		$s.= $caps->elemLi($endStr);
		$b.= $caps->topTagUL($s);
		
		return $b;
	} // tg_cffsched	
		
} // mobility
?>