/**
	File name : multiplicationTable.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**
*/
function multiplicationTable(){

	// Public global "Instance" Variables.
	// this.pubGV= 'PublicGlobalVariable';		// if init form Php the valuie disappear after 1st javascrit use!!
	
	
	// Public Methods "class functions" Interface.
	this.writeMultTbl= writeMultTbl;	
	this.chooseAlgo= chooseAlgo;	
	
	this.clearSet= clearSet;	
	
	this.write= write;
	this.writeLn= writeLn;
	this.clearWrite= clearWrite;


	// Private global "Instance" variable for the "class"
	var crLn= kk.crLn		// "\r\n";	often handy/shorter to have it locally.
	
	
	
	/* -----------------------------------------------------------------------
		Methods definitions
		multiplicationTable.writeMultTbl('partialTblHundred');
	*/
	function writeMultTbl(action){

		switch (action){
			case 'partialTblHundred':
				var sz= 99;
				var start= 11;
			break;
			
			case 'fullTblHundred':
				var sz= 100;
				var start= 2;
			break;
									
			default:
				alert('Error ');
		} // switch
		
		
		var bfRw= '';
		for (var i=start; i<sz; i++){	
			var bfLn= '';
			for (var j=start; j<sz; j++){
				
				var m=i*j;
				switch (action){
					case 'partialTblHundred':
						if ((m % 10) !== 0 && (m % 2) !== 0 ){
							bfLn+= oneTblCell(i,j,m);
						}
					break;
					
					case 'fullTblHundred':
						bfLn+= oneTblCell(i,j,m);
					break;
											
					default:
						alert('Error ');
				} // switch
			}
			bfRw+= '<tr>'+bfLn+'</tr>';
		}
		
		bfRw= localStorage.multiplicTblinfoTbl + '<table border="1">'+bfRw+'</table>';
		kk.setInnHtml(bfRw,'multipTblDiv');
	} // writeMultTbl

					
	/**
	*/
	function oneTblCell(i,j,m){
		var action= document.getElementById('multTblDspl').value;
		
		if (action==='display'){
			var dsplResult= '<div style="margin:auto; width:30px; border: 0px solid red;" ><span class="multiplResult">' + m + '</span></div>';
		}else{
			var dsplResult= '';
		}
	
		var content= '<span title="'+m+'" alt="'+m+'">' + i + '*' + j + '</span>';
	
		if (i===j){
			content= '<div class="multiplTCEqu">' + content + '</div>' + dsplResult;
		}else{
			content= '<div class="multiplTblCell">' + content +'</div>' + dsplResult;
		}
		return '<td class="multiplTblCell">' + content + '</td>';
	} // oneTblCell


	/**
	*/
	function chooseAlgo(){
		var list= document.getElementById('multTblMenu');
		var action= list.value;
	
		switch (action){
			case 'partialTblHundred':
				writeMultTbl(action);
			break;
			
			case 'fullTblHundred':
				writeMultTbl(action);
			break;
						
			case 'primeThousand':
				eratoDisplay(1000);
			break;
			
			
			
			case 'primeTenThousand':
				eratoDisplay(10000);
			break;
			
			case 'sieveItselfTenK':
				sieveErathosItself(10000, 'P', '.');
			break;
			
			
			case 'primeHundredThousand':
				eratoDisplay(100000);
			break;
			
			case 'sieveItselfHundrK':
				sieveErathosItself(100000, 'P', '.');
			break;
			
			
						
			case 'primeOneMeg':
				eratoDisplay(1000000);
			break;
						
			case 'primeTenMeg':
				eratoDisplay(10000000,true);
			break;
			
			
			
			
			case 'primeSpacesThousand':
				spaceAndfrequency(1000);
			break;
			
			case 'primeSpacesTenThousand':
				spaceAndfrequency(10000);
			break;
			
			case 'primeSpacesHundredThousand':
				spaceAndfrequency(100000);
			break;
			
			case 'primeSpacesMillion':
				spaceAndfrequency(1000000);
			break;
			
			case 'primeSpacesTenMillion':
				spaceAndfrequency(10000000);
			break;


			
			case 'PrimeSpaces10Ka':
				slabSpaceAndfrequency(10000, 0, 409);
			break;
			
			case 'PrimeSpaces10Kb':
				slabSpaceAndfrequency(10000, 410, 819);
			break;
			
			case 'PrimeSpaces10Kc':
				slabSpaceAndfrequency(10000, 820, 1229);
			break;
			
		
			
			case 'PrimeSpacesHundrThousand':
				slabSpaceAndfrequency(100000, 8593, 9592);
			break;
			
			case 'PrimeSpacesOneMeg':
				slabSpaceAndfrequency(1000000, 77498, 78498);
			break;
			
			case 'PrimeSpacesTenMeg':
				slabSpaceAndfrequency(10000000, 654580, 664579);
			break;

			
			
			default:
				alert('Error ');
		} // switch
	} // chooseAlgo


	/**
	*/
	function eratoDisplay(maxNb, onlyDsplLastTenK){
		var buff= '';
		var vect= eratostSieve(maxNb);
		var vectLen= vect.length;
		
		if (kk.isUndef(onlyDsplLastTenK)){
			var firstVectLim= 0;
		}else{
			var firstVectLim= vectLen-10000;
		}

		clearWrite('');
		kk.setInnHtml('','multipTblDiv');
		j=0;
		for (var i=firstVectLim; i<vectLen-1; i++){
			buff= buff + vect[i] + ', ';
		}
		
		buff= vectLen + ' Primes :' + crLn + buff + vect[i];
		
		if (maxNb===1000){
			buff= buff + crLn+crLn+crLn+coreSieveItself(maxNb, 'P','.')+crLn+crLn;
		}
		
		kk.setInnHtml(localStorage.multiplicTblPrimeInfo,'multipTblDiv');	
		writeLn(buff);	
	} // eratoDisplay


	/**
	*/
	function clearSet(){
		kk.setInnHtml('','multipTblDiv');
		clearWrite('');
	} // clearSet


	/**
		Input :
			maxNb : larger N number to calculate the set of prime numbers.
			
		Sieve of Eratosthenes : returns an object of prime number from 1 to maxNb.
	*/
	function eratostSieve(maxNb){
		var sieve= new Array();
		var prime= new Array();
				
		for (var i=1; i<=maxNb; i++){
			sieve[i]= true;	// all could be prime numbers
		}

		var sqrtMax= Math.ceil(Math.sqrt(maxNb)); 
		for (var stepper=2; stepper<=sqrtMax; stepper++){
			if (sieve[stepper]){
				var i=stepper+stepper;
				while (i<=maxNb){
					sieve[i]= false;	// not a prime
					i= i + stepper;
				}
			}
		}
				
		j= 0;
		for (var i=1; i<=maxNb; i++){
			if (sieve[i]){
				prime[j]= i;
				j++;
			}
		}
	
		return prime;
	} // eratostSieve


	/**
	*/
	function eratoSpaces(maxNb){
		var buff= '';
		var vect= eratostSieve(maxNb);
		var vectLen= vect.length;
				
		clearWrite('');
		kk.setInnHtml('','multipTblDiv');
		
		var largerSpace= 0;
		for (var i=0; i<vectLen-2; i++){
			var space= vect[i+1] - vect[i];
			if (space>largerSpace){
				largerSpace= space;
			}
			
			buff= buff + space + ', ';
		}
		
		space= vect[i+1] - vect[i];
		buff= buff + space;
		
		kk.setInnHtml(localStorage.multiplicTblPrimeSpcInfo,'multipTblDiv');	
		writeLn(localStorage.maxContigSpaces + largerSpace + crLn+crLn + buff);	
	} // eratoSpaces


	/**
		Input :
			maxNb : larger prime analysed
	*/
	function spaceAndfrequency(maxNb){
		var buff= '';
		var pt= eratoSpaceObj(maxNb);
		
		clearWrite('');
		kk.setInnHtml('','multipTblDiv');
		
		var i=0;
		var sz= pt.sizeV;
		for (i=0; i<sz-1; i++){
			buff= buff + pt.spaceV[i]+ ', ';
		}
		
		buff= buff + pt.spaceV[i];
				
		if (maxNb===1000){
			buff= buff + crLn+crLn+crLn+coreSieveItself(maxNb, 'P','.')+crLn+crLn;
		}
		
		buff= buff + crLn + crLn;
		buff= buff + 'Spaces frequency :' + crLn;
		
		for (var j in pt.frequV) {
			buff= buff + j + '=' + pt.frequV[j].freq+crLn;
		}
		
		
		pt.frequV.sort(frequSortFu);	// Sort relatively to the frequencies
		
		buff= buff + crLn + crLn;
		buff= buff + 'High frequency first (correctly sorted in some browser) :' + crLn;
		
		for (var j in pt.frequV) {
			buff= buff + 'Spaces: ' + pt.frequV[j].spc + ' with a frequency of: ' + pt.frequV[j].freq + crLn;
		}
		
		kk.setInnHtml(localStorage.multiplicTblPrimeSpcInfo,'multipTblDiv');	
		writeLn(localStorage.maxContigSpaces + pt.largerSpace + crLn+crLn + buff);			
	} // spaceAndfrequency

	/**
		Frequency SORT FUNCTION.
	*/
	function frequSortFu(a,b){
		return a.freq < b.freq;
	} // frequSortFu


	/**
		Input :
			maxNb : larger N number to calculate the set of prime numbers
			fStart : Start position INSIDE THE PRIME VECTOR to record the frequencies.
			fEnd :  End position iNSIDE THE PRIME VECTOR to record the frequencies.
			
		Sieve of Eratosthenes : returns an object concerning prime numbers between 1 and maxNb holding :
			pt.spaceV
			pt.frequV
			pt.largerSpace
	*/
	function eratoSpaceObj(maxNb, fStart,fEnd){
		var vect= eratostSieve(maxNb);	// vector of prime numbers to maxNb
		var vectLen= vect.length;


		if (kk.isUndef(fStart)){
			fStart= 0;
		}
		if (kk.isUndef(fEnd)){
			fEnd= vectLen-1;
		}

		
		var pt= new Object();
		pt.spaceV= new Array();	// space vector
		
		pt.frequV= new Array();	// space frequency vector
		
		pt.largerSpace= 0;
		pt.sizeV= fEnd;
		
		for (var i=fStart; i<fEnd; i++){
			var space= vect[i+1] - vect[i] -1;	// minus 1, so we get the number of spades and not the distance !!
			pt.spaceV[i]= space;
			
			if (space in pt.frequV){
				pt.frequV[space].freq+= 1;
			}else{
				pt.frequV[space]= new Object();
				pt.frequV[space].freq= 1;
				pt.frequV[space].spc= space;
			}
			
			if (space > pt.largerSpace){
				pt.largerSpace= space;
			}
		}
		
		pt.frequVSz= pt.frequV.length;
		return pt;
	} // eratoSpaceObj
	
	
	/**
		Input :
			maxNb : larger prime analysed
	*/
	function slabSpaceAndfrequency(maxNb, fStart,fEnd){
		var buff= '';
		var pt= eratoSpaceObj(maxNb, fStart,fEnd);
		
		
		clearWrite('');
		kk.setInnHtml('','multipTblDiv');
		
		var i=0;
		var sz= fEnd;
		
		// Print the Spaces
		for (i=fStart; i<fEnd-1; i++){
			buff= buff + pt.spaceV[i]+ ', ';
		}
		buff= buff + pt.spaceV[i];
		
		
		
		buff= buff + crLn + crLn;
		buff= buff + 'Spaces frequency :' + crLn;
		
		for (var j in pt.frequV) {
			buff= buff + j + '=' + pt.frequV[j].freq+crLn;
		}
		
		
		pt.frequV.sort(frequSortFu);	// Sort relativelly to the frequencies
		
		buff= buff + crLn + crLn;
		buff= buff + 'High frequency first (correctly sorted in some browser) :' + crLn;
		
		for (var j in pt.frequV) {
			buff= buff + 'Spaces: ' + pt.frequV[j].spc + ' with a frequency of: ' + pt.frequV[j].freq + crLn;
		}
		
		kk.setInnHtml(localStorage.multiplicTblPrimeSpcInfo,'multipTblDiv');	
		writeLn(localStorage.maxContigSpaces + pt.largerSpace + crLn+crLn + buff);			
	} // slabSpaceAndfrequency	
	
	
	/**
		Input :
			maxNb : larger N number to calculate the set of prime numbers.
			
		Sieve of Eratosthenes : just returns the boolean sieve.
	*/
	function eratostReturnSieve(maxNb){
		var sieve= new Array();
				
		for (var i=1; i<=maxNb; i++){
			sieve[i]= true;	// all could be prime numbers
		}

		var sqrtMax= Math.ceil(Math.sqrt(maxNb)); 
		for (var stepper=2; stepper<=sqrtMax; stepper++){
			if (sieve[stepper]){
				var i=stepper+stepper;
				while (i<=maxNb){
					sieve[i]= false;	// not a prime
					i= i + stepper;
				}
			}
		}
	
		return sieve;
	} // eratostReturnSieve


	/**
		sieveItself
	*/
	function sieveErathosItself(maxNb,charOn,charOff){	
		clearSet();
		var buff= coreSieveItself(maxNb,charOn,charOff);
		writeLn('The sieve of Eratosthenes itself = '+crLn+crLn + buff);
	} // sieveErathosItself
	
	/**
	*/
	function coreSieveItself (maxNb, charOn,charOff){	
		var sieve= eratostReturnSieve(maxNb);
		var sz= sieve.length;

		var nbColDspl= document.getElementById('nbColToDspl').value;
		var buff= '';
		
		var spliter= '';
		var col= 0;
		for (var i=1; i<sz; i++){
			col++;
			if (col>=nbColDspl){
				col= 0;
				spliter= crLn;
			}else{
				spliter= '';
			}
		
			if (sieve[i]){
				buff= buff + charOn + spliter;
			}else{
				buff= buff + charOff + spliter;
			}
		}
		
		return buff;
	} // coreSieveItself
	
	
	


	/* --------------------------------------------
		"Cloned" methods for usage easiness 
	*/
	function write(s){kk.write(s);}
	function writeLn(s){kk.writeLn(s);}
	function clearWrite(s){kk.clearWrite(s);}


	/**
	*/
	function chabl(){
	
	} // chabl

} // multiplicationTable
