<?php
/**
	File name : multiplicationTable.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="multiplicationTable" /]					[_ r="PLUGIN DECLARATION"/]
	[displayProdTable display="Plugin trial of : " /]		[_ r="A CALL TO tg_displayProdTable()"/]
	
*/
class multiplicationTable extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('multiplicationTable','debugDisplay',true);
		
		$tagsFu->attribVect['displayprodtable']= array('display');
	} // construct


	/**
	*/
	function tags(){
		return array('displayprodtable');
	} // tags

	
	/**
		The method used to test this plugin and call with 
			[displayProdTable display="Plugin trial of : " /]
	*/
	function tg_displayprodtable(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
				
		
		$attS= $caps->matCss('multipTblCombo');
		$vSelect= array();
		$vSelect['partialTblHundred']= 'Partial Table 0 to 100';
		$vSelect['fullTblHundred']= 'Full Table 0 to 100';
		$vSelect['primeThousand']= 'Display prime numbers 1 to 1000';
		
		$vSelect['primeTenThousand']= 'Display prime numbers 1 to 10000';
		$vSelect['sieveItselfTenK']= 'Sieve of Eratosthenes itself from 1 to 10000';
		
		
		$vSelect['primeHundredThousand']= 'Display prime numbers 1 to 100000';
		$vSelect['sieveItselfHundrK']= 'Sieve of Eratosthenes itself from 1 to 100000';
		
		
		$vSelect['primeOneMeg']= 'Display prime numbers 1 to 1 million';
		$vSelect['primeTenMeg']= 'Display prime numbers 1 to 10 million';
		
		
		
		$vSelect['primeSpacesThousand']= 'Distances between primes 1 to 1000';
		$vSelect['primeSpacesTenThousand']= 'Distances between primes 1 to 10000';
		$vSelect['primeSpacesHundredThousand']= 'Distances between primes 1 to 100000';
		$vSelect['primeSpacesMillion']= 'Distances between primes 1 to 1 million';
		$vSelect['primeSpacesTenMillion']= 'Distances between primes 1 to 10 millions';
		
		$vSelect['PrimeSpaces10Ka']= 'Primes 0 to 10K : Distances Frequ 1st Slab';
		$vSelect['PrimeSpaces10Kb']= 'Primes 0 to 10K : Distances Frequ middle Slab';
		$vSelect['PrimeSpaces10Kc']= 'Primes 0 to 10K : Distances Frequ last Slab';
		
		
		$vSelect['PrimeSpacesHundrThousand']= 'Primes 0 to 100K : Distances Frequ last Thin Slab';
		$vSelect['PrimeSpacesOneMeg']= 'Primes 0 to 1 million : Distances Frequ last Thin Slab';
		$vSelect['PrimeSpacesTenMeg']= 'Primes 0 to 10 million : Distances Frequ last Thin Slab';
		
		
		
		// $vSelect['factor']= 'Factorization of numbers from 1 to 10000 with minimal offset';
		$defSelect= 'partialTblHundred';
		$men= $caps->comboBox('multTblMenu',$defSelect,$vSelect,$attS,true);
		
		
		$vSelect= array();
		$vSelect['display']= 'Display Results!';
		$vSelect['noDisplay']= 'Don\'t display the Results!';
		$defSelect= 'noDisplay';
		$menDspl= $caps->comboBox('multTblDspl',$defSelect,$vSelect,$attS,true);
		
		

		$vSelect= $tools->customNumVect(2,109,1,true);
		$defSelect= '12';
		$dsplNbCol= $caps->comboBox('nbColToDspl',$defSelect,$vSelect,$attS,true);
		
		
		$display= $tools->binLoads($v['display'],'');
		$dspl= '<h1>'.$display.'Large multiplication tables and prime numbers trials :</h1>';
		$dspl.= '<a href="#" class="multipTblButFont" onClick="multiplicationTable.chooseAlgo()">Go </a>';
		$dspl.= _c_sT;
		$dspl.= $men;
		$dspl.= _c_sT;
		$dspl.= $menDspl;
		$dspl.= _c_sT . $caps->span('Sieve display nb Columns:','multiplTblTopMenu');
		$dspl.= $dsplNbCol;
		$dspl.= _c_sT;
		$dspl.= '<a href="#" class="multipTblButFont" onClick="multiplicationTable.clearSet()"> Clear </a>';
		$dspl.= _c_;				
		$dspl.= _c_.$caps->sDiv('', 'width:1200px; border:0px solid blue; padding:0px; margin:0px;','multipTblDiv');		
		
		
		$area= $caps->textarea('debugDisplay',19,110,'',$caps->matCss('multiplTblAreaFont'));
		
		$jsTop= 'localStorage.multiplicTblinfoTbl=\'<span class="multTblExplan">Remark : you can point at the operation and the result appears under the mouse cursor.</span>\';'._c_R;
		$glob->setGlobJsCode($jsTop);
		
		$jsTop= 'localStorage.multiplicTblPrimeInfo=\'<span class="multTblExplan">Remark : prime numbers are useful for mental calculation to avoid loosing time trying to divide them. Prime numbers are also very usefull in many situations, especially for encryption, and having some understanding of these can help to grasp a few more mathematical concepts and along the way help for mental calculation.</span>\';'._c_R;
		$glob->setGlobJsCode($jsTop);
		
		$jsTop= 'localStorage.multiplicTblPrimeSpcInfo=\'<span class="multTblExplan">Remark 1 : Distances between prime numbers follow an interesting distribution and are all even, otherwise the number following an odd Distances would be even itself, so not prime at all! Remark 2 : we display the number of spaces between prime number (distance-1) to be visually more coherent with the raw display of the Eratosthenes Sive itself.</span>\';'._c_R;
		$glob->setGlobJsCode($jsTop);
		
		
		$jsTop= 'localStorage.maxContigSpaces=\'Maximum number of contiguous spaces = \';'._c_R;
		$glob->setGlobJsCode($jsTop);
		
		
		
		
		
		$glob->setGlbEndJsCode('multiplicationTable.writeMultTbl(\'partialTblHundred\');');	
		
		return $caps->sDiv($dspl.$area._c_, 'width:1120px; border:0px solid red; padding:10px; margin:2px;');
	} // tg_displayProdTable
	
		
	/**
	*/
	function tg_tmptag(&$v,&$bd){
		$caps= &$this->caps;
	
	} // tg_tmptag

		
	/**
		Template for standard methods.
	*/
	function templateStd(){
	
	
	} // templateStd
		
} // multiplicationTable
?>
