/**
	File name : myFirstPlugin.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**
*/
function myFirstPlugin(){

	/* ---------------------------------------------------------------
		Public global "Instance" Variables.
	*/
	this.pubGV= 'Public Global Variable';
	
	
	/* ---------------------------------------------------------------
		Public Methods "class functions" Interface.
	*/
	this.writePGV= writePGV;
	this.writeLV= writeLV;
	this.squareNb= squareNb;
	this.writeThreeTimes= writeThreeTimes;
	
	
	
	this.write= write;
	this.writeLn= writeLn;
	this.clearWrite= clearWrite;


	/* ---------------------------------------------------------------
		Private global "Instance" variable for the "class"
	*/
	var crLn= kk.crLn		// "\r\n";	often handy/shorter to have it locally.
	var suffix= '!!!!';		// an integrated exmple of class global (instance) variable.
	
	var privGV= 'Private Global Variable';
	

	/* -----------------------------------------------------------------------
		Methods definitions
	*/
	
	/**
	*/
	function writePGV(){
		writeLn(privGV);	// writes the private local variable
	} // writePGV

	/**
	*/
	function writeLV(){
		var locV= 'Local Variable';
		writeLn(locV);
	} // writeLV
	
	
	 
	/**
		As a test : square a number and write it down (remark : not used, just a code exmple)
	*/
	function squareNb(n){
		writeLn(n*n);
	} // squareNb


	/**
		As a test : takes the given string and write it down 3 times.
	*/
	function writeThreeTimes(s){
		writeLn(s+s+s+suffix);
	} // writeThreeTimes




	/* --------------------------------------------
		"Cloned" methods for usage easiness 
	*/
	function write(s){kk.write(s);}
	function writeLn(s){kk.writeLn(s);}
	function clearWrite(s){kk.clearWrite(s);}



	/**
	*/
	function chabl(){
	
	} // chabl


} // myFirstPlugin
