<?php
/**
	File name : programmerTools.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	A few methods used from the file manager to change the php code of the checked files.

	Direct calls explicit external :
		>> $tagsFu->instExplitExternalCls('classN',false); // false to jump tags initialisation and any tag.
		
	Future improvments : 
		function updateContructorToPhpSeven() : if the class name is different from the fiel name base,
			this method does not do anything but a message! Finding the class name can be done 
			looking after the 1st word "class" appearing outside comments and before a space. 
			Need to take comments into account because the probability to find the word class inside
			the comments header is too high! Therefore it should probably be done along side with
			a program to remove comments ... usefulness of the latest being a bit doubtful (obfuscation
			being out for open source and speed advanteage of naked code being overrun bvy hardness of
			bugs recognition --> Last knowledge of the difference it would make.)
*/
class programmerTools extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
	} // construct

	
	/**
		Update a Contructor To a Php 7 style.
	
		Rem : does not consider the possibility of having the string class mainClass extends leafClass{ ...
		iniside a comment or a strin.g
	*/
	function updateContructorToPhpSeven($fullPath){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ($fls->gotPhpExt($fullPath)){
			$managesOk= true;	// optimistic init

			$fls->splitOnLastC($fullPath,$prfx,$fileName);
			$fls->splitOnLastC($fileName,$fn,$ext,'.');
			
			$fullStr= $fls->fileToStr($fullPath);
			
			$posClassWrd= stripos($fullStr,'class ');
			if ($posClassWrd===false){
				return;	// not a class so not concerned!
			}
			
			$gotConstruct= stripos($fullStr,'function __construct(');
			if ($gotConstruct!==false){
				print($fullPath.' Is supposed already done, got the string "function __construct("'._c_._c_);
				return;	// supposed already done !!
			}
			
			
			
			// Look for info inside "class mainClass extends leafClass{"
			$classStr= 'class '.$fn.' extends';
			$startClsStr= stripos($fullStr,$classStr);
			
			if ($startClsStr===false){
				// print('Did NOT Find the class name'._c_);
				$supposedConstructStr= 'function '.$fn.'(';
				if ($tools->sIsInB($supposedConstructStr,$fullStr)){
					$startClsStr= $supposedConstructStr;
				}else{
					if ($posClassWrd!==false && $fn!=='index'){
						// Got a class word but failed the full string so needs to be eye-balled
						print($fullPath._c_);
						print('Fails at level 1, did not find "'.$supposedConstructStr.'"');
						$managesOk= false;
					}
				}
				
				$specialTopCls= true;
			}else{
				$specialTopCls= false;
			}
			
						
			do {
			if ($startClsStr!==false){
			
				if (!$specialTopCls){
					$extendedClsStr= substr($fullStr, $startClsStr,300);
					$startNL= strpos($extendedClsStr,_c_nL);
					$strictClsStr= substr($extendedClsStr, 0,$startNL);
					
					$cStrSz= strlen($classStr);
					$leafClsNm= substr($strictClsStr,$cStrSz);
					$leafClsNm= $fls->safIdStr($leafClsNm, false, 200); // remove the { and cr|ln
					
					
					// Changes parent::leafClass()
					$search= 'parent::'.$leafClsNm.'(';
					$replace= 'parent::__construct(';
					$fullStr= str_replace($search,$replace,$fullStr,$count);
					if ($count===0){
						print($fullPath._c_);
						print('Fails at level 2, did not find any : '.$search);
						$managesOk= false; break;
					}
				}

				// Changes function mainClass(
				$search1= 'function '.$fn.'(';
				$replace= 'function __construct(';
				$fullStr= str_replace($search1,$replace,$fullStr,$count1);
				
				$search2= 'function '.$fn.' (';
				$replace= 'function __construct(';
				$fullStr= str_replace($search2,$replace,$fullStr,$count2);
				if ($count1===0 && $count2===0){
					print($fullPath._c_);
					print('Fails at level 3, did not find '.$search1.' and '.$search2);
					$managesOk= false; break;
				}
				
				
				// Changes the head comment (test the 2 possibilities)
				$search= _c_rT.'// constructor'._c_nL;
				$replace= '';
				$fullStr= str_replace($search,$replace,$fullStr);	// facultative do not need to count and act on it
				
				$search= _c_rT.'// constructor'._c_carRet;
				$replace= '';
				$fullStr= str_replace($search,$replace,$fullStr);	// facultative do not need to count and act on it
				
				// Changes constructor end comment				
				$search= _c_rT.'} // '.$fn._c_nL;
				$replace= _c_rT.'} // construct'._c_nL;
				$fullStr= str_replace($search,$replace,$fullStr);	// facultative do not need to count and act on it
				
				$search= _c_rT.'} // '.$fn._c_carRet;
				$replace= _c_rT.'} // construct'._c_carRet;
				$fullStr= str_replace($search,$replace,$fullStr);	// facultative do not need to count and act on it
				
				$fls->unLnk($fullPath);
				$fls->strToFile($fullPath,$fullStr);
			}
			} while (false);	// so we can break out of the main if !!!!!!

			if (!$managesOk){
				print($fullPath.' was not changed'._c_._c_);
			}
		}
	} // updateContructorToPhpSeven
	
	
	/**
	*/
	function rmCpySffxedFiles($fullPath){
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		if ($tools->sIsInB('-cpy',$fullPath)){
			$fls->secUnlink($fullPath);
		}
	} // rmCpySffxedFiles
			
} // programmerTools
?>
