/**
	File name : pubImUp.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/**
*/
function pubImUp(){

	// Public global "Instance" Variables.
	this.pubGV= 'PublicGlobalVariable';
	
	
	// Public Methods "class functions" Interface.
	this.adaptAction= adaptAction;	
	this.loadImageFile= loadImageFile;	
	
	this.write= write;
	this.writeLn= writeLn;
	this.clearWrite= clearWrite;


	// Private global "Instance" variable for the "class"
	var crLn= kk.crLn		// "\r\n";	often handy/shorter to have it locally.
	
	
	/* -----------------------------------------------------------------------
		Methods definitions
	*/

	/* --------------------------------------
	*/
	function adaptAction(comboId,action){
		var list= document.getElementById(comboId);
		list.value = action;
	}; // adaptAction
	
	
	/**
		Resizing the image before upload
		original Idea : http://stackoverflow.com/questions/17583984/possible-to-resize-an-image-client-side-on-an-html-form-before-upload
	*/
	
	oFReader = new FileReader(), rFilter = /^(?:image\/bmp|image\/cis\-cod|image\/gif|image\/ief|image\/jpeg|image\/jpeg|image\/jpeg|image\/pipeg|image\/png|image\/svg\+xml|image\/tiff|image\/x\-cmu\-raster|image\/x\-cmx|image\/x\-icon|image\/x\-portable\-anymap|image\/x\-portable\-bitmap|image\/x\-portable\-graymap|image\/x\-portable\-pixmap|image\/x\-rgb|image\/x\-xbitmap|image\/x\-xpixmap|image\/x\-xwindowdump)$/i;

	oFReader.onload =  function (oFREvent) {
		flRdOnload(oFREvent);
	}
	
	function flRdOnload(oFREvent){
		var img=new Image();
		img.onload= function(){
			stdImgOnLoad(img);
		}
		img.src= oFREvent.target.result;
	}; // flRdOnload


	function stdImgOnLoad(img){
		var canvas=document.createElement("canvas");
		var ctx=canvas.getContext("2d");
		
		var limWidth= document.getElementById("publctnImUpClientWidth").value;
		if (limWidth!=='noRed'){
			var limHeight= img.height * limWidth / img.width;
			scaleDownLinear(canvas, img.width,img.height, limWidth,limHeight);
		}
		
		ctx.drawImage(img,0,0,img.width,img.height,0,0,canvas.width,canvas.height);
		document.getElementById("uploadPreview").src = canvas.toDataURL("image/jpeg");
		
		var dsplWidth= 200;
		var dsplHeight= img.height * dsplWidth / img.width;
		document.getElementById("uploadPreview").width= dsplWidth;
		document.getElementById("uploadPreview").height= dsplHeight;
	} // stdImgOnLoad
	

	function loadImageFile() {
		if (document.getElementById("locBrowser").files.length === 0) { return; }
		var oFile = document.getElementById("locBrowser").files[0];
		if (!rFilter.test(oFile.type)) { alert("You must select a valid image file!"); return; }
		oFReader.readAsDataURL(oFile);
	} // loadImageFile

	/*
		End Resizing the image before upload
	**/
	
	
	/**
		Input :
			newImg= new Object(); or whatever object already having the same width,height properties.
			
		Output
			newImg.width
			newImg.height
	*/
	function scaleDownLinear(newImg, srcW,srcH, limWidth,limHeight){
		if (srcW<limWidth && srcH<limHeight){
			return false;	// already small enough ... copy it!
		}else{
			var dstW= limWidth;
			var dstH= Math.round(dstW*srcH/srcW);
			
			if (dstH > limHeight){
				// dstH is too big --> imposes the other side
				dstH= limHeight;
				dstW= Math.round(dstH*srcW/srcH);
			}
		
			newImg.width= dstW;
			newImg.height= dstH;
			return true;
		}
	} // scaleDownLinear


	/* --------------------------------------------
		"Cloned" methods for usage easiness 
	*/
	function write(s){kk.write(s);}
	function writeLn(s){kk.writeLn(s);}
	function clearWrite(s){kk.clearWrite(s);}


} // pubImUp
