<?php
/**
	File name : pubImUp.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	Public Image Uploader :  a class to allow forum users to publish images in a secure way.
	
	Security policy for untrusted users :
		(1) Image are uploaded inside the standard php-only-accessible-directory (check again this property) then
			image-processed into a secret directory.
		(2) Webmaster manual or scheduled automated transfer from the secret directory into the user directory.

	[extPlugin name="pubImUp" /]					[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
*/
class pubImUp extends oTop{
	
	// CONSTRUCTOR
	function __construct(&$tagsFu,&$imgP=false,&$fumSC=false){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->rMg= &$tagsFu->rMg;
		
		$this->aSql= &$tagsFu->aSql;
		$this->dtb= &$tagsFu->dtb;
		$dtb= &$tagsFu->dtb;
		
		$this->hPwC= &$tagsFu->hPwC;	
		
		if ($imgP===false){
			$this->imgP= &$tagsFu->imgP;
			$imgP= &$this->imgP;
			$this->directCall= true;	// only possible with a special page holding the xml2 tag.
		}else{
			$this->imgP= &$imgP;
			$this->directCall= false;
		}
		
		if ($fumSC===false){
			include _c_toDeclPlugExt.'forum/forumShareCd.php';
			$this->fumSC= new forumShareCd($tagsFu,$imgP);
			$fumSC= &$this->fumSC;
			
			// Just to define _c_tMenCateg !!! 
			include _c_toDeclPlugCntr.'textMenus/textMenus.php';
			$this->textMenus= new textMenus($tagsFu);
		}else{
			$this->fumSC= &$fumSC;
		}
		
		$this->xRgt= &$fumSC->xRgt;
		
		$glob->explCentralInclStanceJs('mm');		// got a test to avoid multi declarations.
		include _c_toDeclPlugCntr.'mm/mmBoxes.php';
		
		include _c_toDeclPlugCntr.'mm/mmTools.php';
		$this->mmTools= new mmTools($this,$tagsFu,$imgP);
		$mmTools= &$this->mmTools;

		$this->mmBoxes= new mmBoxes($tagsFu,$imgP,$mmTools);
		$tagsFu->coreSetexplCss('central/mm/','mm');
		
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('pubImUp','debugDisplay');	
		$tagsFu->attribVect['pubimgmg']= false;
		
		define('_c_piuSecretDir','secretDir');
		define('_c_piuAllowsAllImg','allowsImg');
		define('_c_piuZmImgNm','zmImgNm');
		
		$this->globAvatPict= $dtb->getGenVar('avatarChosenPict')===_c_ok;
		
		$glob->pubImUpsuplErrMess= '';
	} // construct


	/**
	*/
	function tags(){
		return array('pubimgmg');
	} // tags

		
	/**
		To visualise the directory of a specified forum user.
			- only one column
			- display images with names
			- boxes tp allow deletion
			- home file browser button
			
		[pubImgMg /]
	*/
	function tg_pubimgmg(&$v,&$bd){
		$caps= &$this->caps;
		return $this->pubImgMg($v,$bd);
	} // tg_pubimgmg
	
	
	/**
		Public Image Manager
	*/
	function pubImgMg(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$caps= &$this->caps;
		$fls= &$this->fls;
		$imgP= &$this->imgP;
		$dtb= &$this->dtb;
		$fumSC= &$this->fumSC;
		
		$secretDir= $tools->getVal(_c_piuSecretDir);
		if ($secretDir===false){
			return $this->manageFilesColumn();
		}else{
			$userId= $fumSC->curErsatzLogUser();
			$persoPath= $fumSC->persoPath($userId);
			$fls->firstLevelFiles($fileVect,$persoPath);
			sort($fileVect);
			
			$stdSpc= $caps->span(_c_,'pubImUpBr');	
			$buff= '';
			$buff.= $stdSpc;
			$url= $this->callSecreteDirUrl($userId,$secretDir);
			$url.= $tools->addUrlVar(_c_piuAllowsAllImg,_c_ok);
			
			$allowsImg= $tools->getVal(_c_piuAllowsAllImg);
			if ($allowsImg===_c_ok){
				$fumSC->usrImgTranfer($userId,$secretDir);
			}
			
			$buff.= $caps->hL($url,$glob->el('Click here to allows and transfer all the right column images...','kmdk'),'ln');
			$buff.= $stdSpc;	
			
			$buff.= $caps->heaDiv('width:840px; float:left; border:3px solid green;');
			$buff.= $this->fileColumn($fileVect,$persoPath);
			
			$secretPath= $persoPath.$secretDir.'/';
			$fls->firstLevelFiles($secrtFlVect,$secretPath);
			sort($secrtFlVect);
			
			$buff.= $this->fileColumn($secrtFlVect,$secretPath);
			$buff.= $caps->enDiv();
			return $buff;
		}
	} // pubImgMg
	
	
	/**
		Is triggered if a new image got in as well as a wrong type file, so we can have a look!
	*/
	function newImageIn($emailTo,$pseudo){
		$glob= &$this->glob;
		$fumSC= &$this->fumSC;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$dtb= &$this->dtb;
		$dtb= &$this->dtb;
		$fAlgo= &$this->fAlgo;
		
		$fumNm= $dtb->getGenVar('fumName');
		$mailSubject= $pseudo.' New image upload to allow!';
		
		$mailBody= _c_._c_;
		$urlCommandAr['justsrf']= _c_ok;	// to suppress the edit attribute !!
		
		$verifUrl= _c_siteUrlAccess;	// usrl for answer verification
		$link= $caps->hLink($verifUrl,$glob->el('Please login as a webmaster and allow the new image(s)...','kmdl'));	
		$mailBody.= $link._c_;
						
		$mailBody.= $tools->postVal(_c_fMessageBodyTxtArNm);
				
		$titleFrom= 'Forum ';	// Longer names tend to trigger the spam watcher !!!
		$emailFrom= $dtb->getGenVar('fumEMailFrom');
			
		$fumSC->sendEMailFCA($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom,false);
	} // newImageIn
	
	
	/**
		True for thumbs image extension/type
	*/
	function okUploadType($ext){
		$ext= strtolower($ext);		
		return $ext==='jpg' || $ext==='jpeg' || $ext==='png' || $ext==='gif';
	} // okUploadType

	
	/**
		Public Image Manager
	*/
	function manageFilesColumn(){
		$glob= &$this->glob;
		$aSql= &$this->aSql;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$rMg= &$this->rMg;
		$dtb= &$this->dtb;
		$hPwC= &$this->hPwC;
		$fumSC= &$this->fumSC;
		$imgP= &$this->imgP;
		$hPwC= &$this->hPwC;
		$xRgt= &$this->xRgt;
			

		$userId= $fumSC->curErsatzLogUser();
		$shortPersPath= $fumSC->persoPath($userId,true);
		$persoPath= $shortPersPath.'/';
		
		if (!is_dir($shortPersPath)){
			$fls->wMkDir($shortPersPath);	// creates the personal user dir on the fly, usefull here, so can get rid of it any time for full easy rebulit.
		}
		
		$userRec= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId);
		$pseudo= $userRec[_c_fUserPseudo];
		
		$fls->firstLevelFiles($fileVect,$persoPath);
		sort($fileVect);
	
		$errBuff= '';
		// Act on the actions
		$action= $tools->postVal('pubImUpSelect');
		if ($action!==false){
			switch ($action){
				case 'upload':
					$secretDir= $userRec[_c_fUsrSecretDir];
					$needHighSecu= !$xRgt->ownPostChgRght();
					if ($secretDir===_c_ko || $secretDir===''){
						// create and stores the secretDir name
						$secretDir= 'x'.$hPwC->consonStr(20);
						$dtb->setElem(_c_fsmplUsersTbl, _c_fUsrSecretDir,$secretDir, _c_fUserId,$userId);
					}
					
					$secrDFN= $persoPath.$secretDir;
					if (!is_dir($secrDFN)){
						$fls->wMkDir($secrDFN);
					}
					
					if ($needHighSecu && $fls->dirIsEmpty($secrDFN)){
						$sched= $fumSC->schedulerClass($this);
						
						$testStr= $dtb->condStr(_c_fumSchedUsrId,$userId);
						$cond2= $dtb->condStr(_c_fumSchedAction,_c_fumSchedActImg);
						$aSql->andCondition($testStr,$cond2);
							
						$alreadyGotEvent= $dtb->recordExists(_c_fumSchedTN,$testStr);
						if (!$alreadyGotEvent){
							// adds the current event (only once for many possible uploads)
							$sched->addTask(_c_ko,$userId,_c_fumSchedActImg);
							$dtb->setGenVar('fumSchedNexTm',$sched->taskTime());
						}
					
						// Send an email for a 1st uploading trial
						$emailTo= $dtb->getGenVar('fumMasterEMail');
						$this->newImageIn($emailTo,$pseudo);
					}
				
					$desWidth= $tools->postVal('pubImUpServerWidth');	
	
					// Full switch to avoid number injection.
					switch ($desWidth){
						case '900':
							$desWidth= 900;
						break;
						
						case '600':
							$desWidth= 600;
						break;
						
						case '400':
							$desWidth= 400;
						break;
						
						case '300':
							$desWidth= 300;
						break;
						
						case '200':
							$desWidth= 200;
						break;
						
						case '120':
							$desWidth= 120;
						break;
						
						case '80':
							$desWidth= 80;
						break;
						
						case 'avat':
							$desWidth= _c_fumAvatarSzX;
						break;
						
						case '5':
							$desWidth= 5;
						break;
						
						default:
							$desWidth= 120;
					} // switch
					
					$imgP->storesDesiredWidth($desWidth);
					$origName= $fls->origNameUpldFile();
					
					$maxSzUpload= $dtb->getGenVar('fumUMgUploadMaxSz');		// to set the limit on the server side!
					
					$maxWidth= $dtb->getGenVar('fumUMgImgMaxWidth');		// to set the limit on the server side!
					$maxHeight= $dtb->getGenVar('fumUMgImgMaxHeight');	
					$currentError= $_FILES[_c_locBrowsrDefNm]['error'];
					
					$curCombinedType = $_FILES[_c_locBrowsrDefNm]['type'];
					$fls->splitOnLastC($curCombinedType,$left,$curUpldType);	// ,'.'
					$okType= $this->okUploadType($curUpldType);
					
					if ($okType && $currentError===UPLOAD_ERR_OK){
						// The type is correct && No system error ---> Check other parameters
					
						$servTmpDFn= $_FILES[_c_locBrowsrDefNm]['tmp_name'];
						$imSzV= getimagesize($servTmpDFn);
						$upLdImgWidth= $imSzV[0];
						$upLdImgHeight= $imSzV[1];

						$curSzUpload = $_FILES[_c_locBrowsrDefNm]['size'];
						$tstSz= $curSzUpload<=$maxSzUpload;
						
						// Smaller or equal because it's the uper limit and all reduction possibilities are below!
						$tstW= $upLdImgWidth<=$maxWidth;
						$tstH= $upLdImgHeight<=$maxHeight;
						
						// greater but not equal because need a reduction action!
						$tstMinW= $upLdImgWidth > 5;
						$tstMinH= $upLdImgHeight > 5;
						
						// Test the requested image width
						$tstRequestedW= $upLdImgWidth > $desWidth;
					}else{
						$tstSz= false;
						$tstW= false;
						$tstH= false;
						$tstMinW= false;
						$tstMinH= false;
						$tstRequestedW= false;
					}
					
					$curErrStr= '';
					if ($currentError!==UPLOAD_ERR_OK){
						$curErrStr= $fls->uploadErrDealer($currentError);
					}
					
					if ( $okType && $tstSz && $tstRequestedW && $tstMinW && $tstMinH && $tstW && $tstH && $curErrStr===''){
						if ($needHighSecu){
							// Secret dir storage !!!
							$destPF= $secrDFN.'/'.$origName;
							
							$fls->saveUploadedImg($imgP,$destPF,_c_locBrowsrDefNm);
							
							
							// Present a gimmik image. waiting for approval message
							$fls->splitOnLastC($origName,$rootFN,$extFN,'.');
							$extFN= strtolower($extFN);
							
							$srcWaitPF= $fumSC->diversePath().'waitingForApprov.'.$extFN; // just the waiting gimmik thumbs
							$destWaitPF= $persoPath.$origName;
							$fls->secureCopy($srcWaitPF,$destWaitPF);
							
							// Thumbs
							$secrThbDir= $secrDFN.'/'._c_thumbsDirN;
							if (!is_dir($secrThbDir)){
								$fls->wMkDir($secrThbDir);
							}
										
							$modelFile= $destPF;		
							$secrThbDFN= $secrThbDir.'/'.$origName;
							$imgP->resizeProc($modelFile,$secrThbDFN, _c_thumbsHeight,_c_thumbsHeight);
							
							$errBuff.= $glob->pubImUpsuplErrMess;
						}else{
							if ($imgP!==null){							
								$destPF= $persoPath.$origName;
								$fls->saveUploadedImg($imgP,$destPF,_c_locBrowsrDefNm);
							}
						}	
					}else{
						$errBuff.= $glob->sl('Upload Error(s) : the image :','kmdm')._c_;
						
						if (!$okType){
							$errBuff.= $glob->sl('type needs to be : jpg, jpeg, png or gif! The current ','kmdn').$curUpldType._c_;
						}else{
							if (!$tstSz){
								$errBuff.= 'size must be <= than '. $maxSzUpload . $glob->sl(' bytes','kmdp')._c_;
							}
							
							if (!$tstMinW){
								$errBuff.= $glob->sl('minimum width must be >= than ','kmdo') . '5' .  $glob->sl(' pixels','kmdq')._c_;
							}
							
							if (!$tstMinH){
								$errBuff.= $glob->sl('minimum height must be >= than ','kmdr').'5'.$glob->sl(' pixels','kmdq')._c_;
							}
							
							if (!$tstW){
								$errBuff.= $glob->sl('maximum width must be <= than ','kmds') . $maxWidth . $glob->sl(' pixels','kmdq')._c_;
							}
							
							if (!$tstH){
								$errBuff.= $glob->sl('maximum height must be <= than ','kmdt').$maxHeight.$glob->sl(' pixels','kmdq')._c_;
							}
							
							if (!$tstRequestedW){
								$errBuff.= $glob->sl('the original image uploaded width (','kmdu').$upLdImgWidth.$glob->sl(') must be > than the requested server side width of ','kmdv') . $desWidth . $glob->sl(' pixels','kmdq')._c_;
							}
						}
						
						if ($curErrStr!==''){
							$errBuff.= $glob->sl('System error name : ','kmdw') . $curErrStr._c_;
						}
						
						$errBuff.= _c_BrFlux;
						$errBuff= $caps->span($errBuff,'fumError');
					}
				break;
				
			
				case 'avatChg':
					if ($this->globAvatPict){
						$this->changeAvatImg();
					}
				break;
			
				case 'frontWall':
				case 'rename':
				case 'delete':
					$this->buildActivCBVect($actiVect,$fileVect);	// Build a vector of the activated check boxes
					switch ($action){
						case 'frontWall':
							// add the checked image at the end of _c_fUsrImgWallTxt
							$this->addToFrontWall($actiVect);
						break;
						
						case 'rename':
							$this->chgCheckedFile($actiVect,$persoPath);
						break;
						
						case 'delete':
							$this->delCheckedFiles($actiVect,$persoPath);
						break;
					}
				break;
								
				default:;
			} // switch
		}
			
		$stdSpc= $caps->span(_c_,'pubImUpBr');
		$buff= '';
		
		
		$url= $tools->urlCurPg().$tools->addUrlVar(_c_fumUserId,$userId);
		$url.= $tools->addUrlVar(_c_tMenCateg,'img');
		
		$buff.= $caps->headForm($url,'emailForm');
		
		// A bit tough right now (would need something big at stake) for a full smart phone adaptation here for the forum users image uploader!
		$buff.= $caps->heaDiv('width:100%; float:left; border:3px solid blue;');
			
		$buff.= $this->fileColumn($fileVect,$persoPath);
		$buff.= $caps->heaDiv('width:59%; float:left; border:0px solid red;');
		
		$attS= $caps->matCss('pubImUpStdXB');
		$vSelect= array();
		$vSelect['upload']= $glob->sl('Upload','kbcu');
		$vSelect['frontWall']= $glob->sl('Add to the front Wall','kbcv');
		
		if ($this->globAvatPict){
			$vSelect['avatChg']= $glob->sl('Avatar Change','kbcw');
		}
		
		$vSelect['rename']=  $glob->sl('Rename','kbcx');
		$vSelect['delete']= $glob->sl('Delete','kbcy');
		if ($action!==false){
			$defSelect= $action;
		}else{
			$defSelect= 'upload';
		}
		
		$buff.= $stdSpc;	
		$buff.= $caps->span($glob->sl('Actions :','kbcq')._c_Ns,'pubImUpStdXB');
		$buff.= $caps->comboBox('pubImUpSelect',$defSelect,$vSelect,$attS,true);
		
		
		$reduce= $tools->postVal('pubImUpServerWidth');		
		$vReduce= array();
		$vReduce['900']= '900';
		$vReduce['600']= '600';
		$vReduce['400']= '400';
		$vReduce['300']= '300';
		$vReduce['200']= '200';
		$vReduce['120']= '120';
		$vReduce['80']= '80';
		$vReduce['avat']= $glob->sl('Avatar Size','kmdx');
		$vReduce['5']= '5';
		if ($reduce!==false){
			$defReduce= $reduce;
		}else{
			$defReduce= '400';
		}
		
		$attS= $caps->matCss('pubImUpStd');
		$buff.= $stdSpc;	
		$buff.= _c_BrFlux;
		$buff.= $caps->span($glob->sl('Server side image width :','kbcr'),'pubImUpStd');		
		$buff.= $caps->comboBox('pubImUpServerWidth',$defReduce,$vReduce,$attS,true);
		$buff.= $stdSpc;
		
		


		$pubImUpClientWidth= $tools->postVal('publctnImUpClientWidth');		
		$vClientWidth= array();
		$vClientWidth['1000']= '1000';
		$vClientWidth['600']= '600';
		$vClientWidth['400']= '400';
		$vClientWidth['300']= '300';
		$vClientWidth['200']= '200';
		$vClientWidth['120']= '120';
		$vClientWidth['80']= '80';
		$vClientWidth['noRed']= $glob->sl('No reduction before sending!','kmdy');	// no reduction
		
		if ($pubImUpClientWidth!==false){
			$pubImUpClientWidth= $reduce;
		}else{
			$pubImUpClientWidth= '600';
		}
		
		
		$buff.= $caps->span($glob->sl('Browser side image width :','kbcs'),'pubImUpStd');		
		$buff.= $caps->comboBox('publctnImUpClientWidth',$pubImUpClientWidth,$vClientWidth,$attS,true);
		$buff.= $stdSpc;
		
		$buff.= $stdSpc;	
		$buff.= $caps->span($glob->sl('Remark : the browser side width allow a direct reduction ...','kbct'),'pubImUpStd');		
		$buff.= $stdSpc;	
		
		$buff.= $this->imUpLocalBrowser(_c_locBrowsrDefNm);
		
		$buff.= $stdSpc;
			
		$buff.= $caps->heaDiv('width:98%; float:left; border:0px solid red; padding-left:1%; padding-right:1%; padding-top:20px; padding-bottom:5px;');
		$buff.= $caps->span($glob->sl('Change a file name to (no extension given)'._c_Ns,'kbcz'),'pubImUpStdB');
		
		$buff.= _c_BrFlux;	
		$buff.= $caps->textBox('newFileName','','10',$caps->matCss('pubImUpStd'));
		$buff.= $stdSpc;	
		
		$buff.= _c_BrFlux;	
		$buff.= $caps->onClickBut('pubImUpFormBut',$glob->sl('Send','kaat'),'',$caps->matCss('pubImUpSendBut'));
		$buff.= $stdSpc;
		$buff.= $caps->enDiv();
		
		$buff.= $stdSpc;
		
		$buff.= $caps->heaDiv('width:98%; float:left; border:0px solid red; padding-left:1%; padding-right:1%; padding-top:5px; padding-bottom:5px;');
		$buff.= $glob->sl('Simplest ways to upload an image','kaam');
		$buff.= $caps->enDiv();
		
		$buff.= $caps->enDiv();
		$buff.= $caps->enDiv();
		$buff.= $caps->endForm();
		
		if ($this->directCall || $rMg->wRights){
			$secretDir= $dtb->getElem(_c_fsmplUsersTbl,_c_fUserId,$userId,_c_fUsrSecretDir);
			
			$buff.= $stdSpc;	
			$buff.= $stdSpc;
				
			$url= $this->callSecreteDirUrl($userId,$secretDir);
			$buff.= $caps->hL($url,$glob->el('Visualize two columns ...','kmdz'),'ln','_blank');
			$buff.= $stdSpc;	
		}
		
		return $errBuff.$buff;
	} // manageFilesColumn
	
		
	/**
		Copy only the allowed characters
	*/
	function callSecreteDirUrl($userId,$secretDir){
		$tools= &$this->tools;
		$url= $tools->urlCurPg();
		$url.= $tools->addUrlVar(_c_fumUserId,$userId);
		$url.= $tools->addUrlVar(_c_tMenCateg,'img');
		$url.= $tools->addUrlVar(_c_piuSecretDir,$secretDir);
		return $url;
	}
	

	/**
	*/
	function fileColumn($fileVect,$curPath){
		$caps= &$this->caps;
		$fls= &$this->fls;
		$mmBoxes= &$this->mmBoxes;

		$mmBoxes->oneColumn();
		$stdSpc= $caps->span(_c_,'pubImUpBr');	// duplicated
		
		$buff= $caps->heaDiv('min-width:300px; width:38%; padding-left:1%; padding-right:1%; padding-top:5px; padding-bottom:5px; float:left; border:0px solid red;');
		$i= 0;
		$gotFLF= $fls->firstLevelFiles($fileVect,$curPath);	 // compute it again in case a consequent change was done above!
		if ($gotFLF){
			sort($fileVect);
			reset($fileVect);
			foreach ($fileVect as $key=>$fileName){
				$buff.= $stdSpc;
				$buff.= $mmBoxes->fileCheckBoxLine($szDsplImg, $curPath, $fileName, 'cbxNm','1',$i, _c_mImgVisMode);
				$i++;
			}
		}
		$buff.= $caps->enDiv();
		return $buff;
	} // fileColumn

	
	/**
	*/
	function imUpLocalBrowser($name){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		
		$jsUp= $caps->jsFunctCallStr('onmousedown','pubImUp.adaptAction',2,0,'pubImUpSelect','upload').' ';
		$jsUp.= $caps->jsFunctCallStr('onchange','pubImUp.loadImageFile');
		
		$maxSzUpload= $dtb->getGenVar('fumUMgUploadMaxSz');		// to set the limit on the client side (avoid wasting client time)
		$browserBar= $caps->maxUploadSize($maxSzUpload)._c_R;
		
		$browserBar.= $caps->localFileBrowser($name,'w',$caps->matCss('pubImUpLocBrws').$jsUp)._c_BrFlux;
		
		$browserBar.= $caps->ttlImage(_c_EditorImgPath.'collapse.png',$glob->sl('Resized image to drag-drop or save ...','kmea'),'#','sImg','uploadPreview',  '','','20');
		
		return $browserBar;
	} // imUpLocalBrowser
	
	
	/**
		Build the vector of the activated check boxes
	*/
	function buildActivCBVect(&$actiVect,$fileVect){
		$tools= &$this->tools;
		
		$i= 0;
		$j= 0;
		$actiVect= array();
		reset($fileVect);
		foreach ($fileVect as $key=>$fileName){
			$curCBName= 'cbxNm1_'.$i;
			$resCB= $tools->postVal($curCBName);
			if ($resCB!==false && $resCB!==_c_ko){
				$actiVect[$j]= $fileName;
				$j++;
			}
			$i++;
		}
	} // buildActivCBVect


	/**
		Add the selected image names to the field (_c_fUsrImgWallTxt) matching the image front wall
	*/
	function addToFrontWall(&$actiVect){
		$dtb= &$this->dtb;
		$fumSC= &$this->fumSC;

		$userId= $fumSC->curErsatzLogUser();
		
		$sffx= '';
		reset($actiVect);
		foreach ($actiVect as $key=>$fileName){
			$sffx.= $fileName._c_R;
		}
		$dtb->concatEnt(_c_fsmplUsersTbl, _c_fUsrImgWallTxt,_c_R.$sffx,  _c_fUserId,$userId);
	} // addToFrontWall
		

	/**
		Build the string for the image front wall display.
	*/
	function frontWallDsplStr(){
		$tools= &$this->tools;
		$caps= &$this->caps;
		$dtb= &$this->dtb;
		$fUsrMg= &$this->fUsrMg;	// forumUsrMg
		$fumSC= &$this->fumSC;
	
		$userId= $fumSC->curErsatzLogUser();
		$cWallTxt= $dtb->getElem(_c_fsmplUsersTbl, _c_fUserId,$userId, _c_fUsrImgWallTxt);
		
		$stdSpc= $caps->span(_c_BrFlux,'fumUsrMgStd');	
		
		$fileVect= $tools->trimStrToVect("\n",$cWallTxt);
		if ($fileVect===false){
			return $stdSpc;
		}
		
		$persPath= $fumSC->persoPath($userId)._c_thumbsDirN.'/';
		$bfImg= '';
		$bfImg.= $stdSpc;
		reset($fileVect);
		foreach ($fileVect as $key=>$fileName){
		
			// ------------------------------------------------------------------------------------
			// !!! Got to check that every $fileName used is present inside the personal directory!
			// ------------------------------------------------------------------------------------
		
			$curFl= $persPath.$fileName;
						
			$url= $fUsrMg->usrMgKernelUrl($userId);
			$url.= $tools->addUrlVar(_c_tMenCateg,'zoom');
			$url.= $tools->addUrlVar(_c_piuZmImgNm,$fileName);
			$bfImg.= $caps->lnImg($curFl,$fileName,$fileName,'frontWallImg','',$url);
		}
		$bfImg.= $stdSpc;
		return $bfImg;
	} // frontWallDsplStr


	/**
	*/
	function delCheckedFiles(&$actiVect,$avatPath){
		$fls= &$this->fls;
		
		reset($actiVect);
		foreach ($actiVect as $key=>$fileName){
			$fls->unLnk($avatPath.$fileName);
			$fls->unLnk($avatPath._c_thumbsDirN.'/'.$fileName);
		}
	} // delCheckedFiles
		
			
	/**
		Change the 1st one of the vector $actiVect
	*/
	function chgCheckedFile(&$actiVect,$avatPath){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$fumSC= &$this->fumSC;

		reset($actiVect);
		foreach ($actiVect as $key=>$fileName){
			$oldDFN= $avatPath.$fileName;
			$oldThumbDFN= $avatPath._c_thumbsDirN.'/'.$fileName;
			
			$fls->splitOnLastC($oldDFN,$leftPart,$extension,'.');
			$fls->splitOnLastC($leftPart,$curPath,$oldFN,'/');
			

			$newFileName= $tools->postVal('newFileName');
			$newFN= $fumSC->safeKamelStr($newFileName,20);
			
			$newDFN= $curPath.'/'.$newFN.'.'.$extension;
			$newThumbDFN= $curPath.'/'._c_thumbsDirN.'/'.$newFN.'.'.$extension;
			rename($oldDFN,$newDFN);
			rename($oldThumbDFN,$newThumbDFN);
			return;
		}
	} // chgCheckedFile
		
	
	/**
	*/
	function changeAvatImg(){
		$fumSC= &$this->fumSC;	
		$fls= &$this->fls;
		$imgP= &$this->imgP;

		$userId= $fumSC->curErsatzLogUser();
		$avatarPath= $fumSC->avatPath($userId);
		
		$curAvatFN= $avatarPath.$fumSC->getCurAvatar($userId);		// the original avatar

		$persoPath= $fumSC->persoPath($userId);
		
		$fls->firstLevelFiles($fileVect,$persoPath);
		
		sort($fileVect);
		$this->buildActivCBVect($actiVect,$fileVect);
		
		$fileName= $actiVect[0];
		$modelFile= $persoPath.$fileName;
				
		$fls->unLnk($curAvatFN);
		$imgP->resizeProc($modelFile,$curAvatFN, _c_fumAvatarSzX,_c_fumAvatarSzY);
	} // changeAvatImg
				
				
	/**
		Name of the buffer avatar. (_ should be forbidden for user names!!).
	*/
	function buffAvatarNm($userId){
		return $userId.'_buff.png';
	} // buffAvatarNm

	/**
		Name of the buffer avatar for swapping.
	*/
	function swapBufferNm($userId){
		return $userId.'_bfSwap.png';
	} // swapBufferNm
		
} // pubImUp
?>
