<?php
/**
	File name : seObfusc.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	A class to encrypt any string into some hexadecimal code, and then make it
	locally readable with Javascript. This can be used with the tag
	[robots]noindex, nofollow[/robots] when the whole page should not be indexed.
	The principle is that most spiders follow directives and those that do not are unlikely to
	bother with the whole Javascript processing. In case of highly sensitive information this
	is not enough, and visualisation through paswords and secure connexion must be implemented.
	
	Main tags for this class :
		[extPlugin name="seObfusc" /]				[_ r="PLUGIN DECLARATION"/]
		[phpCryptJsSolve k="ztgd" ]Text hard to index[/phpCryptJsSolve]
*/
class seObfusc extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->acc= &$tagsFu->acc;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->hPwC= &$tagsFu->hPwC;
		$this->mbCrypt= &$tagsFu->mbCrypt;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('seObfusc');
		
		$tagsFu->attribVect['phpcryptjssolve']= array('k','khx');
	} // construct


	/**
	*/
	function tags(){
		return array('phpcryptjssolve');
	} // tags

		
	/**
		Too obfuscate text for search engines.
		Test : [phpCryptJsSolve k="ztgd" ]Text hard to index[/phpCryptJsSolve]
		WARNING!!! Fails for special character on some version < php7 !! Because of Php 5 bug! Just make sure to use Php 7+
		See mbCrypt::utf8to16toHx()
	*/
	function tg_phpcryptjssolve(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$mbCrypt= &$this->mbCrypt;
		
		$ff= '';	// buffer
		
		$bd16Hx= $mbCrypt->utf8to16toHx($bd);
		$k16Hx= $mbCrypt->utf8to16toHx($v['k']);
		$bdC16Hx= $mbCrypt->cryptHxToHx($bd16Hx,$k16Hx);
		
		$ff.= 'kk.setInnHtml("","noJsSpanId");'._c_R;
		$ff.= 'var bdReadHx= xbCrypt.cryptHxToHx("'.$bdC16Hx.'","'.$k16Hx.'");'._c_R;
		$ff.= 'var bdRead= xbCrypt.hexDecode(bdReadHx);'._c_R;
		$ff.= 'document.write(bdRead);';
		
		$noJS= $caps->spanClId($glob->sl('	If you can read this message...','kbbl'),'gecSubTtl','noJsSpanId');
		return $noJS.$caps->jsTag($ff);
	} // tg_phpcryptjssolve

		
} // seObfusc
?>