<?php
/**
	File name : statsReader.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	[extPlugin name="statsReader" /]				[_ r="PLUGIN DECLARATION"/]
	[testPlug display="Plugin trial of : " /]		[_ r="A CALL TO tg_testplug()"/]
	
	Most important :
		[trafStats /]  : main tag.
		function setAllFreqEventVect() : number cruncher for all vectors and sort!
			function setFreqStatsEvent() : the little smart frequency algorithm.
		function scandir() : php standard.  (got a home version in filesMg.php)
		
		Key variable : $_SERVER[]	(only used in statsWriter.php)
		Critical parts : setFreqStatsEvent()::_c_sekiRef	;	$_SERVER['HTTP_REFERER']
*/
class statsReader extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();	
		$this->glob= &$tagsFu->glob;
		$this->caps= &$tagsFu->caps;
		$this->tools= &$tagsFu->tools;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->statsWr= &$tagsFu->statsWr;
		$this->cacheWr= &$tagsFu->cacheWr;
		$this->imgTags= $tagsFu->instExplitCentralCls('imgTags');
		
														
		// Includes a few default files, such as the current .js and .css files, for more infos, see the method tagsFu::includeSupFiles() in tagsFu.php
		$tagsFu->includeSupFiles('statsReader','debugDisplay',true);
		$tagsFu->attribVect['trafstats']= false;
		
		define('_c_largestYearEver', 9999);	// bug year 10'000
		define('_c_largestDayEver', 9999);
		
		define('_c_statsLatestDayPeepDFN', _c_curStatsPath.'tmpLatestDayPeep.php');
		
		// Smallest here means oldest too!
		$this->smallestDay= _c_largestDayEver; // so 1st comparison imply an assignment
		$this->smallestYear= _c_largestYearEver;
		
		// Largest also means most recent / youngest
		$this->largestDay= 0; // 0 so 1st comparison imply an assignment
		$this->largestYear= 0;
		$this->includedFileNb= 0;
		
		// Constants for the Stats Events Kind of Indxes --> seki
		define('_c_sekiMain','main');		
		define('_c_sekiRef','ref');		
		define('_c_sekiKw','kw');		
		define('_c_sekiDownload','download');		
		define('_c_sekiAgent','agent');		
	} // construct


	/**
	*/
	function tags(){
		return array('trafstats');
	} // tags
	
		
	/**
		[trafStats /] Display simple http/s traffic statistics.
	*/
	function tg_trafstats(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$cacheWr= &$this->cacheWr;
		$statsWr= &$this->statsWr;
		
		
		$s= array();	// "Initialisation" main statistics array
		$this->extremeStatFN();
		
		$buff= '';
		$buff.= '';
		
		$buff.= $caps->span( $glob->el('Web Traffic Statistics','kbmt'),'gecMainTtl' );
		$buff.= _c_BrFlux;
		
		$usesStats= $tools->getVal('urlUsesStats');
		if ($usesStats===false){
			// Display a button
			if (_c_localStatsUseIt===_c_ok){
				// Stats can be desactivated
				$img= $caps->lnImg(_c_EditorImgPath.'statsMinus.png','Disactivates the statistics');
				$url= $tools->urlCurPg().$tools->addUrlVar('urlUsesStats',_c_ko);
			}else{
				// Stats can be activated
				$img= $caps->lnImg(_c_EditorImgPath.'statsPlus.png','Activates the statistics');
				$url= $tools->urlCurPg().$tools->addUrlVar('urlUsesStats',_c_ok);
			}
			
			$buff.= $caps->hLink($url,$img).' ';
		}else{
			// Reify the action
			switch ($usesStats){
				case _c_ok:
					$cacheWr->writeCacheLocalConst(_c_ok);
				break;
				
				case _c_ko:
					$cacheWr->writeCacheLocalConst(_c_ko);
				break;
				
				default:;
			} // switch
		}
		
		
		$buff.= $caps->span( $glob->el('These statistics are calculated locally','kbms') );
		$buff.= _c_BrFlux;
		$buff.= _c_BrFlux;
		
		$formSent= $tools->postVal(_c_anyFormSentId);
		if ($formSent===_c_ok){
			$yStart= $tools->postVal('yStart');
			$dStart= $tools->postVal('dStart');
			$yEnd= $tools->postVal('yEnd');
			$dEnd= $tools->postVal('dEnd');
		}else{
			$yStart= $this->smallestYear;
			$dStart= $this->smallestDay;
			$yEnd= $this->largestYear;
			$dEnd= $this->largestDay;
		}
		
		/**
			Set on 1st available file
		*/
		$buff.= '(';
		$buff.= 'Start : ';
		$syV= $this->tenYearsFromNow();
		$startYears= $caps->cmbBox('yStart',$syV,$yStart);
		$buff.= $startYears;
		
		$buff.= ' ';
		$sdV= $this->yearMaxDays($yStart);
		$startDays= $caps->cmbBox('dStart',$sdV,$dStart,true);
		$buff.= $startDays;
		
		$buff.= ' ) .......... ( ';
		
		/**
			Set latest available file
		*/
		$buff.= ' End : ';
		$eyV= $this->tenYearsFromNow();
		$endYears= $caps->cmbBox('yEnd',$eyV,$yEnd);
		$buff.= $endYears;
		
		$buff.= ' ';
		$edV= $this->yearMaxDays($yEnd);
		$endDays= $caps->cmbBox('dEnd',$edV,$dEnd,true);
		$buff.= $endDays;	
		$buff.= ')';

		$buff.= _c_BrFlux;
		$buff.= _c_BrFlux;
		
		$statsAction= $tools->postVal('statsActionNm','standardStats');
		$actionV= array('standardStats'=>'Standard Stats', 'curDayStats'=>'Current Day Stats');
		$buff.= $caps->cmbBox('statsActionNm',$actionV,$statsAction,true);

		$buff.= _c_BrFlux;
		$buff.= _c_BrFlux;
		
		$chosenFilter= $tools->postVal('comboFilterNm','onlyAjaxMinList');
		
		$filterV= array(
			
			'onlyAjaxMinList'=>'Best Stats Without Listed "WebBots" : Ajax Capable Visitors Minus listed "bots"', 
			'onlyAjaxCapable'=>'Only Ajax Capable Visitors (webBots are probably excluded)', 
			'nonAjax'=>'Only WebBots : listing NON Ajax entities (probable webBots)',
			'all'=>'All : displays all stats available',
			
			's0'=>'The following choices need a manual specification of "webBots" to be useful :', 
				'botsIn'=>'Include listed-"webBots"', 
				'botsOut'=>'Exclude listed-"webBots"', 
				'onlyBots'=>'Only listed-"webBots"',
			'e0'=>'');
			
		
		$buff.= $caps->cmbBox('comboFilterNm',$filterV,$chosenFilter,true);
	
		$buff.= $caps->span( $glob->el('You can specify below the list of bots ...','kbmu') );
		$buff.= _c_BrFlux;
		
		$botMarkers= $tools->postVal('botMarkersTxbNm',$dtb->getGenVar('statsBotMarkers',''));
		$dtb->setGenVar('statsBotMarkers',$botMarkers); // set or create
		$buff.= $caps->txArea('botMarkersTxbNm','3','100',$botMarkers,'',_c_ok);
		$buff.= _c_BrFlux;
		 
		$buff.= $caps->submit('submitStats', ' Computes the Selected Interval with the selected parameters! ', $caps->matCss('gecStandLn') );
		
		$fUrl= $tools->urlCurPg();
		$buff= $caps->formCapsKernel($fUrl,'computeStatsNm',$buff);
		if (_c_localStatsUseIt!==_c_ok){
			$glob->userHelp($glob->el('Please allow ...','kblj')._c_cacheConstantsDfn. $glob->el('only programmer ...','kblk'));
			$buff.= _c_BrFlux;
			$buff.= _c_BrFlux;
			return $buff;
		}
		
		if ($formSent===_c_ok){
			switch ($statsAction){
				case 'standardStats':
					$gotAtLeastOneStatsFl= false;
					
					/**
						Elimination of early choices matching no file
					*/
					if ($yStart<=$this->smallestYear){
						$yStart=$this->smallestYear; // forces on existing 1st file year
						if ($dStart<$this->smallestDay){
							$dStart= $this->smallestDay;  // forces on existing 1st file day
						}
					}
					
					$expectedStartFN= $yStart.'-'.$dStart.'.php';
					$expectedEndFN= $yEnd.'-'.$dEnd.'.php';
					$gotFirstFN= false;
					$gotLastFN= false;
					
					if (!$fls->fileExist(_c_curStatsPathNS)){
						$glob->userHelp($glob->el('The stats directory does not exists, you can create it ...','kbnb'));
						$buff.= _c_BrFlux;
						$buff.= _c_BrFlux;
						return $buff;
					}
					
					$vectFN= scandir(_c_curStatsPathNS);
					reset($vectFN);
					foreach ($vectFN as $key=>$curFN){
						if ($fls->extension($curFN)==='php'){
							if ($curFN===$expectedStartFN){
								$gotFirstFN= true;					
							}
							
							$curDFN= _c_curStatsPath.$curFN;
							if ( $gotFirstFN && !$gotLastFN && file_exists($curDFN) && !is_dir($curDFN) ){
								// Got to do the analysis
								
								$this->includedFileNb++;
								
								$gotAtLeastOneStatsFl= true;
								include $curDFN;   
								
								if ($curFN===$expectedEndFN){
									$gotLastFN= true; // End of the analysis ... coild eject diectly form the loop or wait till it finish doing nothing				
								}
							}
						}
					} // foreach $vectFN
					
					if (!$gotAtLeastOneStatsFl){
						$buff.= _c_._c_;
						$buff.= $caps->span('The requested stats files do not exists!','gecSubTtl')._c_;
						return $buff;
					}
					// The statistics multi-dimentional vector is fully loaded
				break;
				
				
				case 'curDayStats':
					if (file_exists(_c_statsLatestDayPeepDFN)){
						$fls->strongUnlink(_c_statsLatestDayPeepDFN);
					}
					
					if (_c_localStatsUseIt===_c_ok){
						$curTxtStatsDFN= $statsWr->currentStatsDfN();
						if (file_exists($curTxtStatsDFN)){
							$this->includedFileNb= 1;
							
							$fls->secureCopy($curTxtStatsDFN,_c_statsLatestDayPeepDFN);
							include _c_statsLatestDayPeepDFN;
						}else{
							$buff.= _c_._c_;
							$buff.= $caps->span('Apparently stats have not been generated today!','gecSubTtl')._c_;
							return $buff;
						}
					}else{
						$buff.= _c_._c_;
						$buff.= $caps->span('Please set the constant cacheConst.php::_c_localStatsUseIt to "ok"','gecSubTtl')._c_;
						return $buff;
					}
				break;
				
				default:;
			} // switch
			
			$this->setAllFreqEventVect($buff,$s,$chosenFilter,$botMarkers);	// ### Loads all frequency vectors
		} // $formSent===_c_ok
		
		return $buff;
	} // tg_trafstats
	

	/**
		Loads all frequency vectors and build the buffer to be displayed! 
		The main inputed data being the multi-dimentional vector $s included from the directory _c_curStatsPath
	*/
	function setAllFreqEventVect(&$buff,&$s, $chosenFilter,$botMarkers){
		$glob= &$this->glob;		
		$tools= &$this->tools;		
	
		$vMain= array();
		$vRef= array();
		$vKw= array();
		$vDownload= array();
		$vAgent= array();
		
		reset($s);
		foreach ($s as $key=>$val){
			reset($s[$key]);
			
			if ($chosenFilter!=='botsIn'){
				$curAgent= $s[$key][_c_sekiAgent];
				$botsVect= $tools->trimStrToV($botMarkers);
				if ($botsVect!==false){
					$isABot= $tools->vectElemIsInB($botsVect,$curAgent);
				}else{
					$isABot= false;
				}
			}
			
			switch ($chosenFilter){
				case 'onlyAjaxCapable':
					if ( array_key_exists('notBot',$s[$key]) ){
						$this->setFreqStatsEvent($s,$key,  $vMain,$vRef,$vKw,$vDownload,$vAgent);
					}
				break;
				
				case 'onlyAjaxMinList':
					if ( array_key_exists('notBot',$s[$key]) && !$isABot ){
						$this->setFreqStatsEvent($s,$key,  $vMain,$vRef,$vKw,$vDownload,$vAgent);
					}
				break;
				
				case 'nonAjax':
					if ( !array_key_exists('notBot',$s[$key]) ){
						$this->setFreqStatsEvent($s,$key,  $vMain,$vRef,$vKw,$vDownload,$vAgent);
					}
				break;
				
				case 'all':
				case 'botsIn':
					// Standard case takes them all
					$this->setFreqStatsEvent($s,$key,  $vMain,$vRef,$vKw,$vDownload,$vAgent);
				break;
				
				case 'botsOut':
					if (!$isABot){
						$this->setFreqStatsEvent($s,$key,  $vMain,$vRef,$vKw,$vDownload,$vAgent);
					}
				break;
				
				case 'onlyBots':
					if ($isABot){
						$this->setFreqStatsEvent($s,$key,  $vMain,$vRef,$vKw,$vDownload,$vAgent);
					}
				break;
				
				default:;
			} // switch
			
		} // foreach ($s ...
		
		/**
			### Sorts and prepares the frequency vectors for output
		*/
		$this->addVectToBUffer($vMain,$buff,_c_sekiMain,'Page names or zoom access :');
		$this->addVectToBUffer($vRef,$buff,_c_sekiRef,'Referer :');
		
		// Probable searched words (!https --&gt; http does not transmit details in most cases. Possible work around with &lt;meta name="referrer" content="origin"&gt; ) :
		$this->addVectToBUffer($vKw,$buff,_c_sekiKw,$glob->el('Probable searched words ... ','kbno'));
		
		
		
		$this->addVectToBUffer($vDownload,$buff,_c_sekiDownload,'Local downloads');
		$this->addVectToBUffer($vAgent,$buff,_c_sekiAgent,'User agent :');
		return $buff;
	} // setAllFreqEventVect
				
				
	/**
		Computes the frequency of the (one) given stats event $s[$key]
		
		Output :
			&$vMain,&$vRef,&$vKw,&$vDownload,&$vAgent
				--> the loaded frequency vectors! If many more are coming will be time to group them differently
				(specialized array) ... was a monobloc function!!
				
		Critical part : setFreqStatsEvent()::_c_sekiRef
	*/
	function setFreqStatsEvent(&$s,$key,  &$vMain,&$vRef,&$vKw,&$vDownload,&$vAgent){
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
				
		foreach ($s[$key] as $ky=>$vl){
			switch ($ky){
				case _c_sekiMain:
					$this->manageFreqV($vMain,$vl);
				break;
				
				case _c_sekiRef:
					$shortRef= substr($vl,0,1000);
					if (!$this->urlIsDomainNm($shortRef,$dtb->getGenVar('domainNoRefStats'))){
						$this->manageFreqV($vRef,$shortRef);
					}
				break;
				
				case _c_sekiKw:
					$this->manageFreqV($vKw,$vl);
				break;
				
				case _c_sekiDownload:
					$this->manageFreqV($vDownload,$vl);
				break;
				
				case _c_sekiAgent:
					$shortAgent= substr($vl,0,100);
					$this->manageFreqV($vAgent,$shortAgent);
				break;
				
				default:;	// jump all others for now
			} // switch
		} // foreach ($s[$key] ...
				
	} // setFreqStatsEvent
	
	
	/**
		Remove the specified prefix if found, then returns true, otherwise does not change $mStr and returns false.
	*/
	function removePfx($px,&$mStr){
		$pos= stripos($mStr,$px);
		if ($pos===false){
			return false;
		}
		
		// got it
		$sz= strlen($px);
		$mStr= substr($mStr, $sz);
		return true;
	} // removePfx

	/**
		Simplify a url into a "canonical" form httpX:://[www.]theDomainName.xyz?blabla?lala...
		into theDomainName.xyz?blabla?lala...
	*/
	function canonUrl(&$url){
		$this->removePfx('http://',$url);
		$this->removePfx('https://',$url);
		$this->removePfx('www.',$url);	// in fact Apache does not seem to register this difference of access (at least in some cases)
	} // canonUrl

	/**
		Returns true if the given url is from the given domain list of names.
	*/
	function urlIsDomainNm($url,$domList){
		$tools= &$this->tools;

		$listV= $tools->trimStrToV($domList);
		$this->canonUrl($url);
		reset($listV);
		foreach ($listV as $key=>$dom){
			if ($tools->sIsPrefixB($dom,$url)===true){
				return true;
			}
		}
		return false;
	} // urlIsDomainNm
	
		
	/**
		When inputing a prefix in httpX, returns the other --> https --> http and http --> https
	*/
	function otherHttpDomAccess(){
		$tools= &$this->tools;
		
		$dom= _c_domAndUrlAccess;
		if ($tools->isPfxB(_c_slashHttps,$dom)){
			// secure https by default
			str_replace(_c_slashHttps,_c_slashHttp,$dom);
		}else{
			// standard http by default
			str_replace(_c_slashHttp,_c_slashHttps,$dom);
		}
		
		return $dom;
	} // otherHttpDomAccess
	
			
	/**
		Add the current array string to the passed buffer.
	*/
	function addVectToBUffer(&$v,&$buff, $categ, $title){
		$caps= &$this->caps;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$imgTags= &$this->imgTags;
				
		if (count($v)>1){
			asort($v);
			$v= array_reverse($v);
		}
		
		$freqSum= 0;
		$ff= '';
		$i= 0;
		reset($v);
		foreach ($v as $key=>$freq){
			$freqSum= $freqSum + $freq;
			switch ($categ){
				case _c_sekiMain:
					$fls->splitOnFirstC($key,$pfx,$pgZmN);
					switch ($pfx){
						case _c_urlPageVar:
							$url= $tools->urlGivenPage($pgZmN);
						break;
						
						case _c_idTextsZm:
							$url= $imgTags->minimalZmUrl($pgZmN);
						break;
						
						default:;
					} // switch
					$ff.= $caps->linkC($url,$key,'gecStandLn','_blank') .' : '.$freq._c_;
				break;
				
				case _c_sekiRef:
					$url= $key;
					$ff.= $caps->linkC($url,$key,'gecStandLn','_blank') .' : '.$freq._c_;
				break;
				
				default:;
					$ff.= $key . ' : '.$freq._c_;
			} // switch
			$i++;
		}
				
		$buff.= _c_._c_;
		$buff.= $caps->span($title,'gecSubTtl');
		
		$buff.= $caps->span(' (Got '.$freqSum.' hits on '.$i.' elements.');
		
		if ($this->includedFileNb !== 0){
			$buff.= $caps->span(' Daily average '. $freqSum/$this->includedFileNb .' hits.)')._c_;
		}
	
		$buff.= $ff;
	} // addVectToBUffer
	
							
	/**
		Management of a frequency vector!
	*/
	function manageFreqV(&$v,$k){
		if ($k==='' || $k===false){
			return false;
		}
		
		if (array_key_exists($k,$v)){
			$v[$k]++;
		}else{
			$v[$k]= 1;
		}
	} // manageFreqV
	
		
	/**
		Finds the extreme days and months available inside the stats directory, so we
		can set the combo boxes with these 4 values : $this->smallestYear, $this->smallestDay,
		$this->largestYear, $this->largestDay.
	*/
	function extremeStatFN(){
		$fls= &$this->fls;
		$fls->scanDir(_c_curStatsPathNS, $this,'extrmStatFN',true);
	} // extremeStatFN
	
		
	/**
		Returns a vector holding $n years from now.
		$this->tenYearsFromNow();
	*/
	function tenYearsFromNow($n=10){
		$y= (int)date('Y');
		$v= array();		
		for ($i=0; $i<$n; $i++){
			$v[$i]= $y;
			$y--;
		} // for
		return $v;
	} // tenYearsFromNow
	
		
	/**
		Vector holding the days of the longuest possible year. Applicable to any year for a human choice
		(impossinle days just won't make a match with thir file + up to the user to avoid 29th Feb --> 60th day
		=== 29 Feb or 1st of March, so ambiguity appear on day 366 ... even easier to avoid). 
		---> maximum number of days in a year as a vector.
		$this->yearMaxDays();
		
		Input : $year : the concerned year.
	*/
	function yearMaxDays($year){
		$oneDayS= 3600*24;
		$startTS= strtotime($year.'-01-01')+10; // start time in seconds on 1st January 00 o'clock + 10 seconds to be right inside the correct day slot
		$isLeapYear= date('L',$startTS)==='1';
		if ($isLeapYear){
			$daysNb= 366;
		}else{
			$daysNb= 365;
		}
		
		$v= array();
		for ($i=0; $i<$daysNb; $i++){
			$curTime= $startTS + $i*$oneDayS;
			$visibleCurDate= date('F-d (l)', $curTime);
			$v[$i]= '(F#'.$i.') '.$visibleCurDate;
		} // for
		return $v;
	} // yearMaxDays

		
	/**
		Called from extremeStatFN() to scan the current stats directory and extract the years and months 
		matching extreme (oldest. youngest) positions
			Loads : $this->smallestDay, $this->smallestYear, $this->largestDay, $this->largestYear
			Rem : need to depend on the file name exclusively because dates may have been changed by copying, editing etc.
	*/
	function extrmStatFN($fileNm){
		$fls= &$this->fls;
		
		$res= $fls->splitOnLastC($fileNm,$trunk,$ext,'.');
		if ($res){
			if ($ext!=='php'){
				return false;
			}
			$res= $fls->splitOnLastC($trunk,$curYear,$curDay,'-');
		}
		
		if ($res){
			if ($curYear<=$this->smallestYear){
				// smaller or equal need to check anyway
				if ($curYear<$this->smallestYear){
					// The year is really smaller --> erase previous day mark that does not make sense anymore
					$this->smallestDay= $curDay;
				}
				
				if ($curDay<=$this->smallestDay){
					$this->smallestDay= $curDay;
					$this->smallestYear= $curYear;
				}
			}
			
			// Symetrical of above assignations / tests
			if ($curYear>=$this->largestYear){
				if ($curYear>$this->largestYear){
					$this->largestDay= $curDay;
				}
				
				if ($curDay>=$this->largestDay){
					$this->largestDay= $curDay;
					$this->largestYear= $curYear;
				}
			}
		} // $res===true
	} // extrmStatFN
	
} // statsReader
?>