<?php
/**
	File name : admin.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	To deal with Administration flavored tags :
	admin / admTools / topAdmin : could examine some merging.					
*/
class admin extends oTop{
	
	function __construct(&$tagsFu){
		parent::__construct();
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$this->rights= &$tagsFu->rights;
		$this->topH= &$tagsFu->topH;
		$this->tools= &$tagsFu->tools;
		$this->caps= &$tagsFu->caps;
		$this->hPwC= &$tagsFu->hPwC;
		$this->dtb= &$tagsFu->dtb;
		
		
		$tagsFu->attribVect['logagain']= array('txt','cls','es');
		$tagsFu->attribVect['sepeditor']= false;
						
		
		/**
			To run an incremental back-up
		*/


		/* A debugging tag : Dissociates the general recovery (GR) system form the incremental savings (IS)
		   Not tested! Instead just fiddle with :  recovery::dissoGrIs() */
		$tagsFu->attribVect['dissogris']= array('dissoc');


		$this->lastPhpTabulaRasa= '';
		$tagsFu->attribVect['lastphptbr']= false;		
		
	} // construct


	/**
		[lastPhpTBR] phpinfo(); [/lastPhpTBR]
		Special tag to evaluate it after the print of the whole site ...
		And in fact instead the whole site, so if define, just does not print the whole site
		and execute that code.
	*/
	function tg_lastphptbr(&$v,&$bd){
		$this->lastPhpTabulaRasa.= $bd;
	} // tg_lastphptbr

	
	/**
		[logagain/]
	*/
	function tg_logagain(&$v,&$bd){
		$glob= &$this->glob;
		$caps= &$this->caps;

		$es= $v['es'];
		if ($es!==false){
			$bd= $glob->es($bd,$es);
		}

		$cls= $v['cls'];
		$var= _c_pwLogBoxReqst;
		$val= _c_pwLogReqstVal;
		$url= _c_IndexFN._c_Interog.$var.'='.$val;
		return $caps->linkC($url,$bd,$cls);
	} // tg_logagain
	
	
	
	/**
		A debug tag to stop recovering incremental backup when undoing / redoing through the eponyme buttons.
		Dissociates the general recovery (GR) system form the incremental savings (IS)
		[dissoGrIs dissoc="ok" /]  .. Does not work !!!!!!!!!!!
	*/
	function tg_dissogris(&$v,&$bd){
		$dtb= &$this->dtb;
		
		$diss= $v['dissoc'];
		
		if ($diss===_c_ok){
			$dtb->newGenVar(_c_debDissoGrIs,_c_ok,true);
		}else{
			$dtb->newGenVar(_c_debDissoGrIs,_c_ko,true);
		}
		
	} // tg_dissogris
	
	
	/**
		Password change for a given user. This function is built to be called by :
			form-Kernel::eform() ... so called by the tag [eform action="changePw" ...] ..... [/eform]
		Need to use the posted variables : oldPw and newPw crypted conventionaly
	*/
	function changePw(){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
		$topH= &$this->topH;
		$hPwC= &$this->hPwC;
		$dtb= &$this->dtb;
		$rights= &$this->rights;
		
		
		if ($glob->cndtWrRghts===false){
			$glob->setGuestDisplay($glob->el('Password modification!','kaug'));
			return '';
		}
		
		$userId= $rights->realTimeUserId();
		$storedCPw= $rights->getCryptedPw($userId);	
		$c2Pw= $topH->getDfcSessionKey();
		$c3yptOldPw= $tools->postVal('oldPw');
		$c3yptNewPw= $tools->postVal('newPw1');
		$c3Pw= $rights->realTimeC3PwCookVal();
		
		$c4Pw= $hPwC->doCrypt($c3Pw,$c2Pw);		
		$oldPw= $hPwC->doUnCrypt($c3yptOldPw,$c4Pw);
		$newPw= $hPwC->doUnCrypt($c3yptNewPw,$c4Pw);		
		$cPw= $hPwC->doCrypt($oldPw,$oldPw);	// to compare with the crypted password
		if ($cPw === $storedCPw){
			// Got correct old password --> got to crypt the new one for storage.
			$dtb->setGenVar('chgPwVisSmplSurf',_c_ok);
			$nC2Pw= $hPwC->doCrypt($newPw,$newPw);
			$rights->setCryptedPw($userId,$nC2Pw);
			$rights->unlogCleanUpCore();
		}else{
			$glob->userError('$storedCPw : '.$storedCPw.$glob->el(' does not match $cPw : ','kauh').$cPw);
		}
	} // changePw
	
} // admin

?>
