<?php
/**
	File name : editFile.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/
class editFile extends oTop{
	

	function __construct(&$tagsFu){
		parent::__construct();
		
		$this->tagsFu= &$tagsFu;
		$this->glob= &$tagsFu->glob;
		$glob= &$this->glob;
		
		$this->tools= &$tagsFu->tools;		
		$this->caps= &$tagsFu->caps;
		$this->fls= &$tagsFu->fls;
		$this->dtb= &$tagsFu->dtb;
		$this->wmRights= &$tagsFu->wmRights;
		
		$glob->addCssFile(_c_autoPlugins.'edit.css');
		
		// Warning : ONLY LOWER CASES must be used for the values of $tagsFu->attribVect[], even if end users can use mix cases.
		$tagsFu->attribVect['displayfile']= array('cls');
		
		define('_c_edtFileTxtArNm','editFile');	
	} // construct


	/**
		Display a file given by its file name.
		[displayFile /]
	*/
	function tg_displayfile(&$v,&$bd){
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		$dtb= &$this->dtb;
		$caps= &$this->caps;
		$wmR= &$this->wmRights;
		
		
		$errSffx= '';
		$cls= $v['cls'];
		if ($cls!==false){
			$cls= $caps->matCss($cls);
		}
		
		$fn= $tools->getVal('pluginName');		
		if ($fn!==false){		
			$dfn= _c_toDeclPlugExt.$fn.'/'.$fn.'.php';			
			if (!file_exists($dfn)){
				$dfn= _c_toDeclPlugCntr.$fn.'/'.$fn.'.php';
			}			
		}else{
			$dfn= $tools->getVal(_c_uVarEdtDFn);
			$fls->splitOnLastC($dfn,$left,$ext,'.');
			if ($ext==='php'){
				$errSffx.= _c_BrFlux._c_BrFlux.$caps->font($glob->el('Warning editing a php file...','kbap'),'ln');
				$errSffx.= _c_BrFlux._c_BrFlux;
			}
		}
						
		if ($dfn!==false){
			$hdF= $caps->hiddenWdg('hdFileName',$dfn)._c_R;
			$postedText= $tools->postVal(_c_edtFileTxtArNm);
			
			$maxFlSz= (int)$dtb->getGenVar('maximumEdtFileSize',6000);
			if ( $fls->kbFlSz($dfn)>$maxFlSz ){
				$errSffx.= _c_BrFlux._c_BrFlux.$caps->font($glob->el('The file is too large! Above 3Mb!','kaul'),'ln');
				$hdFlag= $caps->hiddenWdg('fileIsOk',_c_ko)._c_R;				
				
				$glob->userError($glob->el('Sorry the file is too large! Above 3Mb!','kaul'));	// double display!!!
				$str= '';
			}else{
				$hdFlag= $caps->hiddenWdg('fileIsOk',_c_ok)._c_R;
					
				if ($postedText===false){
				
					if ($wmR->globallyForbidPath($dfn)){
						$glob->setGuestDisplay($glob->el('Sorry, accessing ','kaui').$dfn.$glob->el(' is forbidden!','kauj'));
						return '';
					}
				
					$str= $fls->fileToStr($dfn);
				}else{
					$str= $postedText;
				}
			}
			
			if ($tools->wrapped()===_c_ok){
				$wrapStr= '';
			}else{
				$wrapStr= ' wrap="off"';
			}
			
			$js= 'clsInsrTag.setScrollBarPos(\''._c_edtFileTxtArNm.'\');';
			$glob->setGlbEndJsCode($js);
			
			$fls->splitOnLastC($dfn,$path,$file,'/');
			$mmUrl= $this->getNewUrl($path);
			$dsplLink= $caps->hL($mmUrl,$dfn,'lns');
			
			$str= str_replace('&',_c_realHtmlAmp,$str);
			return $hdF.$hdFlag.$dsplLink.$errSffx._c_R.$caps->textarea(_c_edtFileTxtArNm,25,118,$str,$wrapStr.$cls);			
		}else{
			$glob->userError($glob->el('No file given for the display below :','kaum'));
			return '';
		}
	} // tg_displayfile

	
	/**
	*/
	function getNewUrl($newPath){
		$tools= &$this->tools;
		$upv1= $tools->urlPathVar(1);	// n urlPathVar
		$upv2= $tools->urlPathVar(2);
		return $tools->urlGivenPage('_file-manager').$tools->addUrlVar($upv1,$newPath).$tools->addUrlVar($upv2,$newPath);
	} // getNewUrl


	/**
		Write to file : replace the concerned file with the content of the 'editFile' posted texarray.
	*/
	function writeToF(){	
		$glob= &$this->glob;
		$tools= &$this->tools;
		$fls= &$this->fls;
		
		$fName= $tools->postVal('hdFileName');	
		if (!$glob->cndtWrRghts){
			$glob->setGuestDisplay($glob->el('Write to the file ','kauk').$fName);
			return '';
		}
		
		$fileIsOk= $tools->postVal('fileIsOk');
		if ($fileIsOk===_c_ok){
			$gStr= $tools->postVal(_c_edtFileTxtArNm);
			$fls->strToFile($fName,$gStr);
		}
	} // writeToF


	/**
	*/
	function tg_myTagOne(&$v,&$bd){
		$tools= &$this->tools;
		$caps= &$this->caps;	
		$tagsFu= &$this->tagsFu;
		
		$aaa1= $v['aaa'];
		
	} // tg_myTagOne
	
} // editFile
?>