<?php
/**
	File name : initMultiTags.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Plugins stored inisde code/plugins/implicit : theses plugins are defined in all cases, therefore this class and relative
	should be as small as possible.
*/
class initMultiTags extends oTop{
	

	function __construct(){
		parent::__construct();
		
		$this->tagClass[_c_ko]= _c_ko;	// just a phoney initialisation so $this->tagClass can be used straight away as an array		
		
		/**
		*/		
		$this->curClass('topicMg');
		$this->setTgCl('topiclink');
		define('_c_tgTopic','topic');		
		$this->setTgCl(_c_tgTopic);
		
		$this->curClass('iframe');
		$this->setTgCl('iframe');
		$this->setTgCl('thumbsifr');
		$this->setTgCl('thumbsobj');
							
		
		$this->curClass('cssTransform');
		$this->setTgCl('rotelem');
		$this->setTgCl('vardiv');
		
		
		$this->curClass('smallVT');
		$this->setTgCl('vt');		
		$this->setTgCl('whiteinflate');		
				
		
		$this->curClass('mainCache');
		$this->setTgCl('privateModif');		
			
		$this->curClass('emailTag');
		$this->setTgCl('email');
			
		$this->curClass('subsTag');
		$this->setTgCl('menbutlabel');
		$this->setTgCl('mtreepg');
	
			
		$this->curClass('admin');
		$this->setTgCl('lastphptbr');
		$this->setTgCl('changePw');
		
		$this->setTgCl('logagain');
		$this->setTgCl('dissogris');
		$this->setTgCl('runincrtbl');
		
		$this->curClass('editFile');
		$this->setTgCl('displayfile');
		$this->setTgCl('writeToF');		
	} // construct
	
	
	/**
		Set the current class to be assigned inside setTgCl()
		!! Just used to save a bit of string space inside initMultiTags().
	*/
	function curClass($cl){
		$this->curClass= $cl;
	} // curClass


	/**
		Set up $this->tagClass[$tag] value and makes sure the tag is not already defined.
		
			Input :
				$tag : tag name.
				$cl : concerned class.
	*/
	function setTgCl($tag,$cl=false){
		if ($cl===false){
			$cl= $this->curClass;
		}
	
		if ($this->tagExists($tag)){
			$mess= 'There is a colision between : '.$cl.':tag:'.$tag.' and '.
						$this->tagClass[$tag].':tag:'.$tag;
			$this->topErr($mess);
		}else{
			$this->tagClass[$tag]= $cl;	// associates tag and class.
		}
	} // setTgCl

	
	/**
		Calls setTgCl() with a vector of tags. Fits usefullness to have it for all tags is to check
		that all tasg are unique.
	*/
	function setManyTgCl(&$keyV,$cl){
		reset($keyV);
		foreach ($keyV as $tag=>$val){
			$this->setTgCl($tag,$cl);
		}
	} // setManyTgCl


	/**
		initMultiTags::tagExists($tag)
	*/
	function tagExists($tag){
		return array_key_exists($tag,$this->tagClass);
	} // tagExists

	/**
	*/
	function chabl(){
	} // chabl

} // initMultiTags
?>
