<?php
/**
	File name : mainCache.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Bot implemented!

	General cache to :
		- Short circuit complicated operation to generate the pages (parsing).
		- Allow background work with only the cache being visible.


	Step by step strategy :
		* cache globally off (except for pages that got the tag [privateModifications /]) after the 1st modification, so if they don't bother to actualise it it's as simple as possible.
		* once the modifications have been done can manually activate the cache for speed (a message could recall the cache state).
		* with an active cache, can define the tag [privateModifications /] so the page can be change behind the scene.
			- will need a list of privately changed pages.
			- need a full cache update button
			
	Table definition : in localDB (_c_mainCacheTbl), because needs outside the scope of this class only defined here for
	[privateModif /] and may be a few more tags.
*/
class mainCache extends capsHtml{
	

	function __construct(&$tagsFu){
		parent::__construct($tagsFu->tools);	
		$this->tagsFu= &$tagsFu;
		$this->tools= &$tagsFu->tools;		
		
		
		// Warning : ONLY LOWER CASES must be used for the values of $tagsFu->attribVect[], even if end users can use mix cases.
		$tagsFu->attribVect['privateModif']= false;
		
	} // construct




	/**
		[privateModif /] : A tag to add to the page header when modifications need to be done privately.
	*/
	function tg_privateModif(&$v,&$bd){
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
		

		
	} // tg_privateModif


	/**
	*/
	function tg_myTagOne(&$v,&$bd){
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
		
		$aaa1= $v['aaa'];
		
	} // tg_myTagOne


	
} // mainCache

?>
