<?php
/**
	File name : subsTag.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Holds all the substitution tags. This is used to stick other functionalities on the tag,
	so it could do something completly different.
	
	Remark : the tg_ prefix on the substitute function is mainly conventional, because the strict
	substitute tag is unlikely to be used directly, but if really needed could.
	
	Warning for substitution of the tag through a standard parsing, the following functions must 
	surround the parsing instructions :
			$tagsFu->tagSubstitOn('menbut','menbutlabel');
			... parsing done here : $tagsFu->includeRec() ....
			$tagsFu->tagSubstitOff('menbut');
		
	When possible (page where the tag is not used) just overload it with the same name from another class. !!!
*/
class subsTag extends capsHtml{
	

	function __construct(&$tagsFu){
		parent::__construct($tagsFu->tools);	
		$this->tagsFu= &$tagsFu;
		$this->tools= &$tagsFu->tools;		
		
		
		// A substitute for mTree, the param list must be identical to the original.
		$tagsFu->attribVect['mtreepg']= array('pg','down','visible');
		
		// Substitute function for [menbut ... 
		$tagsFu->attribVect['menbutlabel']= array('pg','editonly','cls','in','out');
		
	} // construct


	/**
		A substitute function for the menubut tag [menbut pg="..."]...[/menbut]
	*/
	function tg_menbutlabel(&$v,&$label){		
		return $label;		
	} // tg_menbutlabel


	/**
		Replacement tag for [mTree ... /], uses it in editTools::changePageId()
		Get the pg param from mTree and update the corresponding page.
		Once the page tag-extracted by tg_mtreepg(), just does a string substitution with the ""
	*/
	function tg_mtreepg(&$v,&$bd){
		$tagsFu= &$this->tagsFu;
		$glob= &$tagsFu->glob;
		$dtb= &$tagsFu->dtb;
		
		$pg= $v['pg'];
		$nectStr= $dtb->getCllStr($pg,_c_PolyCellPgM,_c_pcNecStr);
		$nectStr= str_replace( _c_dblQ.$glob->oldPgInChgPgId._c_dblQ, _c_dblQ.$glob->newPgInChgPgId._c_dblQ, $nectStr);
		$dtb->chgPolyCell(_c_PolyCellPgM,$pg,$nectStr,_c_pcNecStr);
	} // tg_mtreepg
	
} // subsTag
?>
