<?php
/**
	File name : topicMg.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Topic Manager methods are TITLES that describe the topic of paragraph/pages or whatever information bloc we choose.
	A visual description that must be as clear as possible for the end user.
*/
class topicMg extends capsHtml{
	

	function __construct(&$tagsFu){
		parent::__construct($tagsFu->tools);	
		$this->tagsFu= &$tagsFu;
		$this->acc= &$tagsFu->acc;		
		$this->glob= &$tagsFu->glob;
		$this->tools= &$tagsFu->tools;		
				
		// [topicLink name="sa" link="test-one" quick="ok" label="Subjet A"] Facultative title of A[/topicLink]
		$tagsFu->attribVect['topiclink']= array('name','link','quick','label');
		
		// [topic name="sa" /]
		$tagsFu->attribVect[_c_tgTopic]= array('name');
	} // construct


	/**
		Manages the bloc titles.
		Call example : [topicLink name="sa" link="test-one" quick="ok" label="Subjet A"] Facultative title of A[/topicLink]
	*/
	function tg_topiclink(&$v,&$bd){
		$tools= &$this->tools;
		$acc= &$this->acc;
		$glob= &$this->glob;
		$tagsFu= &$this->tagsFu;
		
		$name= $v['name'];
		if ($v['quick']===_c_ok){
			$link= $v['link'];
		}else{
			$link= $acc->safeIdStr($v['link']);
		}
		
		$url= $tools->urlGivenPage($link);
		$smallVisLbl= $v['label'];
		
		if ($smallVisLbl===false){
			$smallVisLbl= $bd;
		}
		
		$largeVisLbl= $bd;
		if ($largeVisLbl===''){
			$largeVisLbl= $smallVisLbl;
		}
		
		if ( isset($glob->globCurrentTopic) && $glob->globCurrentTopic===$name ){
			$link= $this->linkC($url,$largeVisLbl,'menuInHz');
		}else{
			$link= $this->linkC($url,$smallVisLbl,'menuOutHz');		
		}
		
		return $link;
	} // tg_topiclink


	/**
		A page tag just used to indicate the current topic ON EACH PAGE by loading the global variable
		$glob->globCurrentTopic.
			Example : [topic name="sa" /]
	*/
	function tg_topic(&$v,&$bd){
		$glob= &$this->glob;
		$glob->globCurrentTopic= $v['name'];
	} // tg_topic


	/**
	*/
	function tg_chablon(&$v,&$bd){
		$tools= &$this->tools;
		$tagsFu= &$this->tagsFu;
		
		$aaa1= $v['aaa'];
		
	} // tg_chablon


	
} // topicMg

?>
