<?php
$r['id']='masterPwEncryptInfo';
$r['en']='This information concerns the page that opens when clicking on the edition buttons of the table named "pwKeeperTbl", special encryption widgets appear on the screen and allow a very secure encryption especially useful to store numerous passwords and access so typically used by webmasters. 
<br/><br/>
<b>How to use it</b>

<ul>
<li>Follow the chain of actions to decipher it : <b>hello | 12 | 3 | Bin | howAreYOU | Clic 1st Arrow | Clic Uncrypt</b> Specified in reading order, except for the Uncrypt button.</li>
</ul>

<b>Actions</b>
<ol>
<li> <b>hello</b> : the password top right box</li>
<li> <b>12</b> : to be selected inside the 1st column of numbers.</li>
<li> <b>3</b> : to be selected inside the 2nd column of numbers.</li>
<li> <b>Bin</b> : choose the Bin-ary button that impose a pattern along the binary code (start & spacer) that can be replaced automatically by the characters given inside the Spreading Text Box situated just below  "Fill Bin InvBin .." .</li>
<li>Fill the Spreading Text Box with <b>howAreYOU</b></li>
<li>Clic the <b>1st Arrow</b> to to spread "howAreYOU" to replace the "BG" sign.</li>
<li>Clic the <b>Uncrypt</b> button that finally decipher the encrypted message!</li>
</ol>


<br/><br/>
<b>Why is it very secure ?</b>
<ol>
<li>The password, the text filler and the grid (possibly filled by any means) give many more possibilities than a standard passwords. In fact just for the grid if we count 62 characters for a standard English context (lower and upper cases + digits), we have for a 7x7 grid 62^49 possibilities being exactly equal to 6717269695938351153752844676098676567447383489364657351063722635030465291132934136266752 env = 6.717269695938351e+87 (the 1st number was computed with the included string calculator). Of course real passwords are not likely to spread evenly on the possibility space and the generator of random numbers loops after a series roughly of the same order of magnitude that the size of the prime divisor used for the series (2147483647), but we use 7+1 encryption steps (+ 1 because the 1st independent password does the 1st encryption before using the grid) with a different password each time! Therefore we have about (2*10^9)^8 = 2.56e+74 and this is a huge number completely out of reach of any brute force approach.</li>
<li>As detailed above, we use 8 independent consecutive encryption steps</li>
<li>Each encryption step is seeded with a field unique random string that imply that each encryption random XOR string is unique between fields.</li>
<li>The encryption is only done locally in Javascript, so input do not travel on the Net</li>
<li>Secret code are not stored unvoluntary on the disk if the computer got enough memory (to avoid page faults) and the browser is reasonable.</li>
<li>The final encrypted string is expressed in hexadecimal, highly compatible with all coding systems and therefore storable on any computer or device without having to worry about character coding.</li>
</ol>

<br/><br/>
<b>What\'s the weaknesses?</b>
<ol>
<li>The encrypted code can wait around a long time without any problems, but like in most situations, things become insecure if an attacker has access to the host computer, therefore we\'ll say it\'s almost perfectly safe as long as the host computer isn\'t corrupted, therefore this first level of security is the most important step to take. Second point, if someone can crack the main CMS password they can access the code and therefore change it to email themselves the master password combination reinforcing the importance to protect our cms access code. Extreme case can also disconnect the file manager up to the next FTP manipulation.</li>

<li>Faulty human operation : you absolutely do not want to save the form when the text box result is expressed explicitly, because it would be written just like that on the disk!</li>
</ol>


.';
$r['langW']='Cette information concerne la page qui s\'ouvre quand on clique sur un des boutons de la table nomm&eacute;e "pwKeeperTbl", des bo&icirc;tes de cryptages sp&eacute;ciales apparaissent &agrave; l\'&eacute;cran et permettent un cryptage hyper s&eacute;curis&eacute; particuli&egrave;rement utile pour stocker des groupes de mots de passe etr d\'acc&egrave;s typiquement utilis&eacute;s par les webmasters.
<br/><br/>
<b>Comment utiliser l\'interface de stockage de mots de passe :</b>

<ul>
<li>Suivre cette cha&icirc;ne d\'actions : <b>hello | 12 | 3 | Bin | howAreYOU | Clic 1st Arrow | Clic Uncrypt</b> Sp&eacute;cifi&eacute;e en ordre de lecture, &agrave; part pour le bouton "Uncrypt".</li>
</ul>

<b>Actions</b>
<ol>
<li> <b>hello</b> : le mot de passe &agrave; renseigner dans la bo&icirc;te de texte en haut &agrave; droite.</li>
<li> <b>12</b> : &agrave; s&eacute;lectionner dans la premi&egrave;re colonne de nombres.</li>
<li> <b>3</b> : &agrave; s&eacute;lectionner dans la deuxi&egrave;me colonne de nombres.</li>
<li> <b>Bin</b> : choisir le bouton Bin-aire qui impose un motif en suivant le code binaire (d&eacute;part & &eacute;cart) qui peut &ecirc;tre remplac&eacute; automatiquement par les caract&egrave;res donn&eacute;s dans la Bo&icirc;te de Dispersion situ&eacute;e juste dessous "Fill Bin InvBin ..".</li>
<li>Remplir la Bo&icirc;te de Dispersion avec <b>howAreYOU</b></li>
<li>Cliquer la <b>Premi&egrave;re Fl&egrave;che</b> pour disperser "howAreYOU" en remplacement du signe sp&eacute;cifi&eacute; sous "BG"</li>
<li>Cliquer le bouton <b>Uncrypt</b> qui finalement d&eacute;crypte le message!</li>
</ol>


<br/><br/>
<b>Pourquoi c\'est tr&egrave;s s&ucirc;r ?</b>
<ol>
<li>Le mot de passe, et la grille (pouvant &ecirc;tre remplie par n\'importe quel moyen) donne beaucoup plus de possibilit&eacute;s qu\'un mot de passe standard. En fait juste pour la grille si l\'on compte 62 caract&egrave;res pour un contexte anglophone standard (fran&ccedil;ais sans accents ni c&eacute;dille) on arrive pour une grille de 7x7 &agrave; 62^49 possibilit&eacute;s ce qui est exactement &eacute;gal a  6717269695938351153752844676098676567447383489364657351063722635030465291132934136266752 env = 6.717269695938351e+87 (le 1er nombre a &eacute;t&eacute; calcul&eacute; avec le calculateur de cha&icirc;ne de caract&egrave;res). Bien s&ucirc;r les mots de passes r&eacute;el (correctement m&eacute;morisables et dactylographiables) ont peu de chance de se r&eacute;partir harmonieusement dans l\'espace des possibilit&eacute;s disponible et le g&eacute;n&eacute;rateur de nombre al&eacute;atoire boucle avec une s&eacute;rie ayant plus ou moins la taille du diviseur premier utilis&eacute; (2147483647). Consid&eacute;rant le fait que nous utilisons 7+1 &eacute;tapes de cryptage (+1 gr&acirc;ce au mot de passe ind&eacute;pendant utilis&eacute; en premier) nous obtenons (2*10^9)^8 = 2.56e+74 possibilit&eacute;s! Un &eacute;norme chiffre hors de port&eacute;e des calculateurs les plus rapides essayant la force brute.</li>

<li>Comme d&eacute;taill&eacute; ci-dessus 8 &eacute;tapes de cryptage sont utilis&eacute;es l\'une apr&egrave;s l\'autre.</li>
<li>Chaque &eacute;tape de cryptage est d&eacute;marr&eacute;e avec une graine al&eacute;atoire unique ce qui implique que chaque s&eacute;rie de XOR est unique sur l\'ensemble de la base, &agrave; moins d\'une extraordinaire co&iuml;ncidence ne pr&ecirc;tant pas le flanc &agrave; une attaque exploitant la redondance vu que &ccedil;a n\'arrive quasiment jamais personne ne va perdre du temps &agrave; essayer au cas o&ugrave;!</li>
<li>Le cryptage est uniquement effectu&eacute; localement en Javascript il s\'ensuit que les mots de passe ne passent jamais sur le r&eacute;seau.</li>
<li>Les codes secrets utilis&eacute;s ne sont pas stock&eacute;s explicitement sur le disque, il s\'ensuit que si l\'ordinateur a suffisamment de m&eacute;moire libre et le navigateur est raisonnable rien ne sera jamais &eacute;crit sur le disque.</li>
<li>La cha&icirc;ne sous son format crypt&eacute; est exprim&eacute;e en hexad&eacute;cimal, un format hyper compatible avec la grande majorit&eacute; des syst&egrave;mes.</li>
</ol>

<br/><br/>
<b>Quel sont les faiblesses ?</b>
<ol>
<li>Le code crypt&eacute; est tr&egrave;s s&eacute;curis&eacute; une fois stock&eacute;, mais la faiblesse appara&icirc;t si un attaquant a acc&egrave;s au programme utilis&eacute; et a la possibilit&eacute; de le modifier, d\'o&ugrave; l\'importance de prot&eacute;ger ses acc&egrave;s et d\'avoir un h&eacute;bergement s&ucirc;r.</li>
<li>L\'erreur humaine : il est capital de ne pas presser le bouton "Envoyer" quand le texte est &eacute;crit en clair dans la bo&icirc;te, sous peine de l\'&eacute;crire en clair sur le disque dur.</li>
</ol>


.';
$r['langX']='';
$r['langY']='';
$r['langZ']='';
$r['comment']='';

?>