<?php
/**
	File name : capsHtml.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


	Specific html manager for the independant unzipper.
*/
class capsHtml {
	

	function __construct(){
	} // construct
	
	function setMain(&$main){
		$this->main= &$main;
	} // setMain
	
	/**
		Format the whole Html code
	*/
	function formatAll($mainContent, $title, $eMailCase=false){
		$main= &$this->main;

		$b= '<?xml version="1.0" encoding="UTF-8" ?'._c_NdR;
		$b.= '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"'._c_NdR;				
		$b.= '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr"'._c_NdR;
		$b.= '<head>'._c_R;
		$b.= '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" '._c_NdR;	
		$b.= '<title>'.$title.'</title>'._c_R;
		
		$b.= $this->meta('robots','nofollow');
		$b.= $this->meta('generator','http://www.'._c_generatorDomNm);


		if ($eMailCase){
			$b.= $this->cssCaps($main->globDomCombi.'unzip/z.css');		// only usefull for the editor, could use a test!!!
		}else{
			// CSS files
			$b.= $this->cssCaps('./unzip/z.css');		// only usefull for the editor, could use a test!!!
			
			// JS files
			$b.= $this->script('./unzip/kk.js');	
			$b.= $this->script('./unzip/mbCrypt.js');	
			$b.= $this->script('./unzip/autoCrypt.js');	
		}
		
		$b.= $this->headerLink('shortcut icon','image/ico',_c_CodePath.'unzip.ico');	
		
		$jsBd= '';
		$jsBd.= $this->instanceJs('kk')._c_R;
		$jsBd.= $this->instanceJs('mbCrypt')._c_R;
		$jsBd.= $this->instanceJs('autoCrypt')._c_R;
		$b.= $this->jsTag($jsBd);
		$b.= '</head>'._c_R;
		
		$cssBd= $this->matCss('bodyStyle');
		$b.= '<body'.$cssBd.'>'._c_R;
		$b.= $mainContent._c_R;	
		$b.= '</body>'._c_R;
		$b.= '</html>'._c_R;
		
		return $b;
	} // formatAll
		
		
	
	/**
		Format the Class / Css Element for inclusion of the returned string in other function parameter.
	*/
	function matCss($e){
		if ($e===''){
			return '';
		}else{
			return ' class="'.$e.'"';
		}
	} // matCss
	
	
	function matTtl($t){
		return ' title="'.$t.'"';
	} // matTtl
	
		
	
	/**
		As above but with inline declared style. Could be useful with cms for adaptive rich fonts like for link clouds.
	*/
	function matStyl($e){
		if ($e===''){
			return '';
		}else{
			return ' style="'.$e.'"';
		}
	} // matStyl
	
	
	/**
	*/
	function cssCaps($pathCss,$fullUrlPrfx=''){
		if ($pathCss!==''){
			return $this->headerLink('stylesheet','text/css',$fullUrlPrfx.$pathCss);
		}
	} // cssCaps
	
	/**
		Insures that $val is compatible for html double quotes inclusion.
	*/
	function htmlDQuote($val){
		return str_replace('"','&quot;',$val);
	} // htmlDQuote
	
	
	
	/**
	*/
	function meta ($name,$val){
		return '<meta name="'.$name.'"  content="'.$val.'"'._c_NdR;
	} // meta
	
	/**
	*/
	function headerLink($rel,$type,$href){
		return '<link rel="'.$rel.'" type="'.$type.'" href="'.$href.'"'._c_NdR;
	} // headerLink	
		

	/**
	*/
	function span($str,$c='',$s='',$id='',$ttl='',$x=''){
		if ($c!=='') $c= $this->matCss($c);	
		if ($s!=='') $s= $this->matStyl($s);
		if ($x!=='') $s.= $x;
		
		if ($id!=='') $id= ' id="'.$id.'" name="'.$id.'"';
		if ($ttl!=='') $ttl= ' title="'.$ttl.'"';
		return '<span'.$c.$s.$id.$ttl.'>'.$str.'</span>';	
	} // span


	/**
		Basic hyperlink
	*/
	function hLink($url,$content,$attS='',$target=''){
		if ($target!==''){
			$target= ' target='.$target;
		}
		return '<a href="'.$url.'"'.$attS.$target.'>'.$content.'</a>';
	} // hLink
	
	
	/*
	*/
	function hL($url,$content,$cls='',$target=''){
		if ($cls!=='') $cls= $this->matCss($cls);
		return $this->hLink($url,$content,$cls,$target);
	} // hL
	
	
	/**
	*/
	function img($src,$alt,$cls='slImg',$sup=''){
		return '<img src="'.$src.'" alt="'.$alt.'" class="'.$cls.'"'.$sup._c_Nd;	
	} // img
	
	
	
		
	/* -------------------------------------------------------------------------------
	   -------------------------------------------------------------------------------
		FORMULAR METHODS
	*/
	
	function headForm($url,$name,$attS='',$method='POST',$enctype='multipart/form-data'){
		$glob= &$this->glob;		
		
		if ($method!==''){
			$method= ' method="'.$method.'"';
		}
			
		$b= '<form action="'.$url.'" name="'.$name.'" id="'.$name.'"'.$method.' enctype="'.$enctype.'"'.$attS.'>'._c_R;		
		$b.= $this->hiddenWdg(_c_anyFormSentId,_c_ok);
		return $b;
	} // headForm
	
	function endForm(){
		return '</form>'._c_R;
	} // endForm
	
	
	
	/* -------------------------------------------------------------
	*/
	function hiddenWdg($name,$val){
		return $this->input('hidden',$name,$this->htmlDQuote($val))._c_R;
	} // hiddenWdg		
		
	/**
		General call for different form widget.
	*/
	function input($type,$name,$val,$attS=''){
		return '<input type="'.$type.'" name="'.$name.'" id="'.$name.'" value="'.$val.'"'.$attS._c_Nd;
	} // input		
	
	
	
	/**
		Submit is conditional to the call of a javascript function.
			To use $this->jsSimpleFu()
	*/
	function onClickBut($name,$label='Send',$attS=''){
		return '<button name="'.$name.'" id="'.$name.'"'.$attS.'>'.$label.'</button>';
	} // onClickBut
	
	
	
	
		
	/**
		FORMULAR WIDGETS
	*/
		
	/**
		xHtml Text box
	*/
	function textBox($name,$val,$boxSize,$attS='',$lim='200'){
		return $this->input('text', $name, $this->htmlDQuote($val), ' size="' . $boxSize.'"'.$attS)._c_R;
	} // textBox	
	
	
		
	/* -------------------------------------------------------------
	*/
	function corePwWdg($name,$val,$boxSize,$attS='',$lim=20){
		return $this->input('password', $name,$this->htmlDQuote($val), ' size="' . $boxSize.'"'.$attS);
	} // corePwWdg		
		
	/**
	*/
	function passwordWdg($name,$val,$boxSize,$attS='',$lim=20){
		return $this->corePwWdg($name,$val,$boxSize,$attS,$lim);
	} // passwordWdg		
				
	
	
	
	
	
	/**
		Just for comboBox(...)
	*/	
	function selectIfEqual($a,$b){
		if ($a==$b){
			return ' selected';
		}else
			return '';
	} // selectIfEqual
	
	
	/**
		$lbl : is option Group Start. (s1)
	*/
	function isOGS($val){
		$topCls= &$this->topCls;
		$isOGS= $val[0]==='s' && $topCls->isSimpleNumber($val[1]);
		return $isOGS;
	} // isOGS
	
	/**
		$lbl : is option Group End.	(e1)
	*/
	function isOGE($val){
		$topCls= &$this->topCls;	
		return $val[0]==='e' && $topCls->isSimpleNumber($val[1]);
	} // isOGE
	
	/**
	*/
	function isOGSE($s){
		return $this->isOGS($s) || $this->isOGE($s);
	} // isOGSE
	
	
	/**
		Abrev : s(i)
	*/
	function oGroupStart($lbl){
		return '<optgroup label="'.$lbl.'">';
	} // oGroupStart
	
	/**
		Abrev : e(i)
	*/
	function oGroupEnd(){
		return '</optgroup>';
	} // oGroupEnd
	
	
	/**
		General combo Box.(see original class for comments)
	*/
	function comboBox($wName,$defVal,&$vSelect,$attS='',$biVal=false,$acceptOptGrp=false,$defRank=false){
		$b= _c_R.'<select name="'. $wName.'" id="'.$wName.'"'.$attS.'>'._c_R;
		reset($vSelect);
		$rank= 1;	// start at one so it's really an ordinal rank and easier for outsider to understand!
		foreach ($vSelect as $selectVal => $dsplStr){
			if ($biVal){
				$b.= $this->option($defVal,$selectVal,$dsplStr,$acceptOptGrp,$defRank,$rank);
			}else{
				$b.= $this->option($defVal,$dsplStr,$dsplStr,$acceptOptGrp,$defRank,$rank);
			}
			
			$rank++;
		}
		$b.= _c_R.'</select>'._c_R;
		return $b;
	} // comboBox
	
	/**
		To control one option of $this->comboBox (see original class for comments).		
	*/
	function option($defVal,$selectVal,$dsplStr,$acceptOptGrp,$defRank,$rank){
		if ($acceptOptGrp===true && $this->isOGSE($selectVal)){
			if ($this->isOGS($selectVal)){
				return $this->oGroupStart($dsplStr);
			}else{
				return $this->oGroupEnd();
			}
		}else{
			if ($defRank===false){
				$selectedStr= $this->selectIfEqual($defVal,$selectVal);
			}else{
				$selectedStr= $this->selectIfEqual($defRank,$rank);				
			}
		
			return '<option'.$selectedStr.' value="'.$selectVal.'">'.$dsplStr.'</option>'._c_R;
		}
	} // option
	

	/**
		List of parameters comPacted to an arRay
	*/
	function pactToRay($nbParam,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7=''){
		if ($nbParam===0){
			return '';
		}
		return array($a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7);
	} // pactToRay
	
	/**
	*/
	function formatJsVarOrConst(&$v,$i,$nbVar){
		if ($i<$nbVar){
			return $v[$i];	// variable case
		}else{
			$s= $this->bsOneQ($v[$i]);
			return '\''.$s.'\'';	// constant case
		}
	} // formatJsVarOrConst

	function bsOneQ($s){
		return str_replace ('\'', '\\\'', $s);	
	} // bsOneQ
	
	
	/**
	*/
	function jsOnclickFuCallStr($fuName,$nbParam=0,$nbVar=0,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7=''){
		return $this->jsFunctCallStr('onclick',$fuName,$nbParam,$nbVar,$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7);
	} // jsOnclickFuCallStr
	
	function jsFunctCallStr($event,$fuName,$nbParam=0,$nbVar=0,$a0='',$a1='',$a2='',$a3='',$a4='',$a5='',$a6='',$a7=''){
		if ($nbParam>0){
			$v= $this->pactToRay($nbParam,$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7);
			
			$pmStr= '';	// parameters string
			for($i=0;$i<$nbParam-1;$i++){
				$pmStr.= $this->formatJsVarOrConst($v,$i,$nbVar).',';
			}

			$pmStr.= $this->formatJsVarOrConst($v,$nbParam-1,$nbVar);
		}else{
			$pmStr= '';
		}
		
		$pmStr= '('.$pmStr.')';
		if ($event===''){
			return $fuName.$pmStr;				
		}else{
			return ' '.$event.'="'.$fuName.$pmStr.'"';		
		}
	} // jsFunctCallStr	
	
	
		
	/**
	*/
	function script($src){
		return '<script src="'.$src.'"></script>'._c_R;
	} // script		
	
	
	/**
	*/
	function instanceJs($jsFileN){
		return 'var '.$jsFileN.'= new '.$jsFileN.'();'._c_R;
	} // instanceJs
	
	/**
		Format an inline javascript instruction.
	*/
	function jsTag($body){	
		$b= _c_R.'<script>'._c_R;
		$b.= $body._c_R;		
		$b.= '</script>'._c_R;		
		return $b;	
	} // jsTag
	
	/**
	*/
	function txArea($name,$row,$col,$content='',$attS='',$wrap= '',$lim=5000, $cls=''){
		$totSup= $attS.$wrap;
		if ($cls!==''){
			$totSup.= $this->matCss($cls);
		}
		
		return '<textarea name="'.$name.'" id="'.$name.'" rows="'.$row.'" cols="'.$col.'"'.$totSup.'>'.$content.'</textarea>'._c_R;
	} // txArea
	

	

} // capsHtml
?>
