/**
	File name : kk.js
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt


*/

/*  
*/
function kk(){
	this.getString= getString;	
	this.writeBefore= writeBefore;
	this.currentDisplayPt= currentDisplayPt;
	this.initCurrentDisplay= initCurrentDisplay;
	this.write= write;
	this.writeLn= writeLn;
	this.writeNl= writeNl;		// as writeLn(), but writes ahead.
	this.clearWrite= clearWrite;
	
	var crLn= "\r\n";		// carriage return
	
	
	/**
		Local stores the Id of the current display.
	*/
	function isUndef(x){
	    return x===undefined;
	} // isUndef
	
	function isNotUndef(x){
	    return !isUndef(x);
	} // isNotUndef
	
	
	/* ---------------------------------------------
		Local stores the Id of the current display.
	*/
	function initCurrentDisplay(displayId){
		localStorage.currentDisplay= displayId;
	} // initCurrentDisplay
	
	/*
		Returns the pointor of the side extension screen.
	*/
	function currentDisplayPt(){
		return document.getElementById(localStorage.currentDisplay);
	} // currentDisplayPt
	
	
	/* ---------------------------------------------
		Get the current string.
	*/
	function getString(s){
		var d= currentDisplayPt();
		return d.value;
	} // getString
	

	/* ---------------------------------------------
		Writing methods 1st level.
	*/
	function write(s){
		var d= currentDisplayPt();
		if (d!==null){
			d.value+= s;
		}
	} // write
	
	function clearWrite(s){
		var d= currentDisplayPt();
		if (d!==null){
			d.value= s;
		}
	} // clearWrite
	
	function writeBefore(s){
		var d= currentDisplayPt();
		d.value= s + d.value;
	} // writeBefore


	/* ---------------------------------------------
		Writing methods 2nd level.
	*/
	function writeLn(s){
		if ( isUndef(s) ){
			write(crLn);
		}else{
			write(s+crLn);
		}
	} // writeLn

	function writeNl(s){
		writeBefore(s+crLn);
	} // writeNl	
	
} // kk
