<?php
/**
	File name : unzipMain.php
	Author of this file : Oscar Fawer until 2019-08-15
	Contact : www.ataox.org 
	Web sites : ataox.org / ataox.com / ataox.info
	Copyrights open source GPL, GNU General Public License V3 : see ./aMainDr/code/LICENSE.txt



	The main class to carry on the unzipping task with the upfating of the necessary key-values.
*/
class unzipMain{
	
	// Constructor
	function __construct(&$top){
		$this->top= &$top;
		$this->glot= &$top->glot;
		$this->caps= &$top->caps;
		$this->fls= &$top->fls;
		$this->mbCrpt= &$top->mbCrpt;
		
		define('_c_debugDisplayIsOn', false);
		define('_c_pwBoxReqInformPfx', '');	// test informative prefix to make sure we don't just use the old default "e"
		
		$this->activeTotUrl= 'Not initialised';
		$this->globDomCombi= 'Not initialised';

		if (file_exists('./masterFlag.php')){
			$this->gotMasterFlag= true;
		}else{
			$this->gotMasterFlag= false;
		}
		
		define('_c_testEMailContent', true);
	} // construct
	
	
	/**
	*/
	function getVal($key,$val=false){
		$glot= &$this->glot;
		return $glot->getVal($key,$val);
	} // getVal
	
	/**
	*/
	function postVal($key,$val=false){
		$glot= &$this->glot;
		return $glot->postVal($key,$val);
	} // postVal
	
	/**
	*/
	function gostVal($key,$val=false){
		$glot= &$this->glot;
		return $glot->gostVal($key,$val);
	} // gostVal
	
	
	function isSimpleNumber($c){
		return ($c>='0' && $c<='9');
	} // isSimpleNumber
	
	
	/**
		Binary (boolean, true/false) loads : get the 1st param if not false, otherwise take the second. Especially usefull
		for the standard vector of variable functions.
	*/
	function binLoads($a,$b){
		if ($a!==false){
			return $a;
		}else{
			return $b;
		}
	} // binLoads
	
	
	function pv(&$v,$marker='*pv '){
		if (is_array($v)){
			reset($v);
			foreach ($v as $key=>$val){
				if (is_object($val)){
					print($marker.'$key='.$key.' Object!'._c_);
				}else{
					print($marker.'$key='.$key.' $val='.$val.' b='.$this->b($val)._c_);
				}
			}
		}else{
			$this->pb($v);
		}
	} // pv	
	
	function b($b){
		if ($b===true){
			return 'true';
		}else if ($b===false){
			return 'false';
		}else{
			return 'Not a boolean : '.$b;
		}
	} // b	

	function pb($b,$mess='Boolean value= '){
		print( $mess.$this->b($b)._c_);
	} // pb	
	
	
	
	/* --------------------------------------------------------------------------------
		Email functions! Extracted from lib/email.php
	*/
	
	/**
	*/
	function buildHeader($titleFrom,$emailFrom){
		$headers  = 'MIME-Version: 1.0' . _c_R;
		$headers .= 'Content-type: text/html; charset=UTF-8' . _c_R;
		$headers .= 'From: '.$titleFrom.' <'.$emailFrom.'>' . _c_R;
		return $headers;
	} // buildHeader	

	/**
		Send an e-mail holding all the given parameters and manage the display of the information sent.
	*/
	function sendEMail($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom){
		$caps= &$this->caps;
		$fls= &$this->fls;

		
		$headers= $this->buildHeader($titleFrom,$emailFrom);
		$mailSubject='=?UTF-8?B?'.base64_encode($mailSubject).'?=';	// otherwise smtp complains about the subject !!
		$htmlCapsMailBody= $caps->formatAll($mailBody,$mailSubject,true);
		
		/**
			Debug tool : save the full Email parameters inside a file in /unzip/mailCopy.txt, si can see exactly what was sent independently
			from the ever expanding email modifications done by SMTPs and Co
		*/
		if (_c_testEMailContent){
			$dfn= './unzip/firstMailCopy.txt';
			$buff= '';
			$buff.= _c_R._c_R;
			$buff.= $headers;
			$buff.= _c_R._c_R;
			$buff.= $emailTo;
			$buff.= _c_R._c_R;
			$buff.= $mailSubject;
			$buff.= _c_R._c_R;
			$buff.= $htmlCapsMailBody;
			$fls->strToFile($dfn,$buff);
		}
		
		return mail($emailTo, $mailSubject, $htmlCapsMailBody, $headers);
	} // sendEMail
	

	/**
	*/
	function go(){
		$glot= &$this->glot;
		$caps= &$this->caps;
		$fls= &$this->fls;

		$gotMstrFlag= $this->gotMasterFlag;		
		
		$cssTB= $caps->matCss('zipTextBox');
		
		$mess= '';
		$mess.= $this->lgFlags()._c_;
		
		/**
			Temporary click part
		*/
		$ttlMess= $glot->sl('Fast unzipper ...','kaab');
		$mess.= $caps->span($ttlMess,'zipTitle');
		
		
		$ttlMess= $glot->sl('PLEASE NOTE that...','kaal');
		$mess.= $caps->span($ttlMess,'zipTitle2');
		
		
		if ($gotMstrFlag){
			$mess.= _c_._c_;
			$ttlMess= $glot->sl('You are about to install an Ataox Master Version ...','kabz');
			$mess.= $caps->span($ttlMess,'zipTitle');
		}
		
		
		
		$mess.= _c_._c_;
		$alert= $fls->alertSafeMode($message);
		if ($alert){
			$mess.= $caps->span($message,'zipError');			
			$dspl= $caps->formatAll($mess, $glot->sl('Fast Php zipper / unzipper','kaaz'));
			print($dspl);
			return '';
		}else{
			$mess.= $caps->span($message,'zipInfoFine');
		}
		
		$mess.= _c_;
		
		$wdgtId= 'jsPhpCrCpt';
		$clickMe= $glot->sl('Test full UTF8 browser-server...','kabt');
		$congratStr= $glot->sl('Congratulation ...','kabu');;
		$sorryStr= $glot->sl('Sorry...','kabv');
		$mess.= _c_;
		$mess.= $this->jsPhpCryptCompatible($wdgtId,$clickMe,$congratStr,$sorryStr,'Hello 人女 !!','tra人ala');
		
		
		
		$wdgtId= 'jsPhpCrCpt2';
		$clickMe= $glot->sl('Partial browser-server UTF-8  ...','kabw');
		$congratStr= $glot->sl('Congratulation...','kabx');;
		$sorryStr= $glot->sl('Sorry...','kaby');
		$mess.= _c_;
		$mess.= $this->jsPhpCryptCompatible($wdgtId,$clickMe,$congratStr,$sorryStr,'abcd1234','ef567')._c_;
		
		
		
		$ataPathIsNotWr= !$fls->isWritable(_c_ataoxPath);
		$actionMess= $this->zipDealer($successCurrentStep);
		
		
		/* --------------------------------------------------------------------------
			Formular part
		*/
		$mess.= _c_._c_;
		$mess.= $fls->getMess();
		$mess.= $actionMess;
		$mess.= _c_._c_;
		
		
		if (!$successCurrentStep){
			$url= './'._c_mainIdxName;
			$curLg= $this->getCurrentLg();
			$url.= $this->addFirstUrlVar(_c_lgUrlVar,$curLg);
			$mess.= $caps->headForm($url,'mainForm');
			$mess.= $glot->sl('Choose your actions : ','kaaa');
			
			/*
				fUnzipChgPw : unzip and TRY to update the login context.
				fZip : form triggered zip.
				fDisplay : Display the local directory..
			*/
			$defVal= 'fUnzipChgPw';
			$vSelect= array('fUnzipChgPw'=> $glot->sl('Unzip...','kaac'), 'fDisplay'=> $glot->sl('Display...','kaae'));
			
			$mess.= $caps->comboBox('mainAction',$defVal,$vSelect,$cssTB,true);
			
			$mess.= _c_._c_;
			
			
			if (!$gotMstrFlag){
				$mess.= $glot->sl('Url variable and value...','kaaf');

				$pwBxR= $fls->consonStr(5);
				$mess.= $caps->textBox('pwBoxRequest', $this->postVal('pwBoxRequest',$pwBxR) ,5,$cssTB);
				
				$pwBxVal= $fls->consonStr(5);
				$mess.= $caps->textBox('pwRequestVal', $this->postVal('pwRequestVal',$pwBxVal) ,5,$cssTB);
				
				$mess.= _c_._c_;
				
				// Ask user name and password (needs to be crypted on the server by the unzipped code 
				// itself, special method usable only once).		
				$mess.= $glot->sl('Create your Ataox user name : ','kaag');
				$mess.= $caps->textBox('userName', $this->postVal('userName',''), 10,$cssTB);
				$mess.= _c_;
				
				$mess.= $glot->sl('Create your password : ','kaah');
				$mess.= $caps->passwordWdg('passOne','',10,$cssTB);
				$mess.= $glot->sl(' please repeat it : ','kaai');
				$mess.= $caps->passwordWdg('passTwo','',10,$cssTB);
				$mess.= _c_._c_;
			}
			
			
			$mess.= $glot->sl('Sub-domain...','kabm');
			$mess.= _c_;
			$mess.= $caps->textBox('subDirDomain',$this->postVal('subDirDomain',''),45,$cssTB);
			
			
			$defLevel= $this->postVal('siteLevel','topLevel');
			$vSelect= array('topLevel'=> $glot->sl('top...','kabn'), 'subDomain'=> $glot->sl('subDom...','kabo'), 'subDir'=> $glot->sl('subDir...','kabp'));
			$mess.= $caps->comboBox('siteLevel',$defLevel,$vSelect,$cssTB,true);
			
			
			$mess.= _c_._c_;
			$mess.= $glot->sl('Please enter your E-Mail, to get a long term memory of the access link : ','kaaj');
			$mess.= _c_;
			$mess.= $caps->textBox('accessEMail',$this->postVal('accessEMail',''),60,$cssTB);
			$mess.= _c_;
			
			$mess.= _c_;
			
			$js= '';
			$lrgInt= $this->corePhpGotLrgeInt();
			$csSb= $caps->matCss('sendButton');
			if (!$gotMstrFlag){ $js= $caps->jsOnclickFuCallStr('autoCrypt.autCryptor',3,0,'passOne','passTwo',$lrgInt);}
			$mess.= $caps->onClickBut('onClickBut','<b>'.$glot->sl('Send...','kaak').'</b>',$csSb.$js);
			$mess.= _c_BrFlux._c_BrFlux._c_Ns;
			$mess.= $caps->endForm();
		}
		
		if (_c_debugDisplayIsOn){
			$mess.= _c_;
			$mess.= _c_;
			$mess.= $glot->sl('Debug Area Box ','noTransA');
			$mess.= _c_;
			$mess.= $caps->txArea('debugDisplay',19,120,'',$cssTB);
		}
		
		$dspl= $caps->formatAll($mess, $glot->sl('Fast Php zipper / unzipper','kaaz'));
		print($dspl);
	} // go
	
	/**
	*/
	function corePhpGotLrgeInt(){
		$kSmallInMax= 1000*2147483647;
		if (PHP_INT_MAX > $kSmallInMax){
			return _c_ok;
		}else{
			return _c_ko;
		}
	} // corePhpGotLrgeInt	

	
	/**
		Return the vector as list string.
	*/
	function vectorAsAList($v,$sep=', '){
		$buff= '';
		reset($v);
		foreach ($v as $key=>$val){
			$buff.= $val.$sep;
		}
		$sepSzNeg= 0-strlen($sep);
		return substr($buff,0,$sepSzNeg);
	} // vectorAsAList


	/**
		Personalizes the installer so we can log with a peronal password etc.
		
		(1) Update the content of 
			/projects/coreInstallerDN/zCms/zPhpData/phpDtb/genVar.php
			/projects/coreInstallerDN/zCms/zPhpData/phpDtb/usersTbl.php
		
		Input :
			$givenIndex ; the concerned index.
	*/
	function personInstaller(){
		$glot= &$this->glot;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		
		$givenIndex= 'installer.php';

		$gotMstrFlag= $this->gotMasterFlag;
		if ($gotMstrFlag){
			include './masterFlag.php';
		}		
		
		$domName= $fls->domainName();
				
		// Reception of auto-crypted passwords		
		$passOne= $this->postVal('passOne');
		
		$eInstallerProjPath= _c_ataoxPath.'projects/';
		$gotFiles= $fls->frstLvlDir($vProj,$eInstallerProjPath);
		if ($gotFiles!==true){
			$fls->addMess($glot->sl('Error : no directory...','kabq')._c_._c_);
			return false;
		}
		
		if (!in_array ('coreInstallerDN',$vProj)){
			$fls->addMess($glot->sl('Error : the project...','kabr')._c_._c_);
			return false;
		}
		
		
		$doNotDeleteDfN= $eInstallerProjPath.'doNotDelete.txt';
		$fls->strToFile($doNotDeleteDfN,'Ne pas effacer ce fichier! Do not delete this file! It\'s vital for the correct running of the main index.php! If you want to delete it anyway you must 1sr adapt the main index!');
		$fls->chgMode($doNotDeleteDfN, 0555);	// no writing!!
		
		
		$phpDataPath= _c_ataoxPath.'projects/coreInstallerDN/zCms/zPhpData/';	
		$phpDtbPath= $phpDataPath.'phpDtb/';	
		$phpGenVarDfn= $phpDtbPath.'genVar/';
		
		
		$emailTo= $this->postVal('accessEMail');
		$subDD= $this->postVal('subDirDomain','');
		
		
		$phpDtbNectPathg= $phpDataPath.'connect/';	
		
		if (!$gotMstrFlag){		// Else building a master distribution do not want to change the ersatzt keys
			$userName= $fls->safIdStr($this->postVal('userName'));
			$lcUsrName= strtolower($userName);		
		
			/** -----------------------------------------------------------------------------------------
				Modification of the genVar table. --> Set the origin Dtbm then transmit to the target!
			*/
			$this->globCurrentTblPath= $phpGenVarDfn;
			
			$pwBxRequest= $fls->safIdStr($this->postVal('pwBoxRequest'));
			$replace= _c_snglQ._c_pwBoxReqInformPfx.$pwBxRequest._c_snglQ;
			$this->updateTableFl('pwBoxRequest.php',  '\'e\'', $replace);
			
			
			$replace= _c_snglQ.$fls->safIdStr($this->postVal('pwRequestVal'))._c_snglQ;
			$this->updateTableFl('pwRequestVal.php',  '\'e\'', $replace);
			
			
			$curLg= $this->getCurrentLg();
			$this->updateTableFl('surfDefLanguage.php',  'ersatzSurfDefLanguage',$curLg);
			
			$this->updateTableFl('editionDefLanguage.php',  'ersatzEditionDefLanguage', $curLg);
			
			$this->updateTableFl('formAdminEmail.php', 'someone@example.org', $emailTo);
			
			
			/** 
				Just for the 100% php itself!
			*/
			$this->updateTableFl('firstInstallationTm.php',  'fistSecuInstErsatzTm', time());	// just for the 100%php itself
			
			$this->updateTableFl('acceptFirstInstTm.php',  'accptErzazFirstInstTm', 'ok');	// just for the 100%php itself
			
			// root matches _c_reservedUserId in main program
			$userName= $fls->safIdStr($this->postVal('userName'));
			
			// n updateTableFl
			$this->updateTableFl('forcedAccessUsrId.php',  _c_snglQ.'root'._c_snglQ,  _c_snglQ.$userName._c_snglQ);
			
			$this->updateTableFl('urlSubAccess.php',  'ersatzUrlSubAccess', $subDD);
			
			$defLevel= $this->postVal('siteLevel','topLevel');
			$this->updateTableFl('kindUrlSubAcc.php',  'ersatzKindOfUrlSubAccess', $defLevel);
			
			
			// Substitute the secret ersatzt information access and change the concerne directory names (they have been erastzeed at installer building time)
			$muDirN= 'secret_'.$fls->consonStr();	// a random new name
			$this->updateTableFl('mainUsrSecretDir.php',  'secret_ers_a_tztD', $muDirN);
			if (file_exists(_c_muSecretPathN)){
				rename(_c_muSecretPathN, _c_stallerZcmsPth.$muDirN);					// adapt the directory name
			}else{
				$fls->wMkDir(_c_stallerZcmsPth.$muDirN);
			}
			
			$muDirN= 'arch_'.$fls->consonStr();		// a random new name
			$this->updateTableFl('secretArchivDirN.php',  'arch_ers_a_tztD', $muDirN);
			if (file_exists(_c_achSecrtPathN)){
				rename(_c_achSecrtPathN, _c_projectPath.$muDirN);					// adapt the directory name
			}else{
				$fls->wMkDir(_c_projectPath.$muDirN);
			}
			
			$this->updateTableFl('secreLogDumpFN.php',  'dump_ers_a_tztT',  'dump_'.$fls->consonStr().'.txt');
			
			
			$this->updateTableFl('mainDirForStdAtaoxInstall.php',  'ersatztSuggestDirName',  'mainDataDir');	// Suggest the main directory user name when installing from a 100% php cms
			
			$this->updateTableFl('installerStamp.php',  'ersatztinstallerStamp',  'ok');	
			
			/** ----------------------------------------------------
				Modification of the translation table.: codeTrans
			*/
			$phpDtbCdTransDfn= $phpDtbPath.'codeTrans/';
			$this->globCurrentTblPath= $phpDtbCdTransDfn;
			
			$this->updateTableFl('xCodeFormalWebMail.php',  'someone@example.org',  $emailTo);
			$this->updateTableFl('xCodeWebMail.php',  'someone@example.org',  $emailTo);
			
			$this->updateTableFl('xCodeFormalWebMail.php',  'example.org',  $domName);
			$this->updateTableFl('xCodeWebMail.php',  'example.org',  $domName);

			
			/** ----------------------------------------
				Modification of the usersTbl table.
				Remark for crypting the password for the unzipper :
					just auto-crypting : avoids direct use, looks more serious uses a copy of the main js crypting code! 
			*/
			$phpDtbUsersTblDfn= $phpDtbPath.'usersTbl/';
			$this->globCurrentTblPath= $phpDtbUsersTblDfn;

			$ersatzIdDfn= $phpDtbUsersTblDfn.'ersatzid.php';
			$lcUNm= $lcUsrName.'.php';
			$userIdDfn= $phpDtbUsersTblDfn.$lcUNm;
			rename($ersatzIdDfn,$userIdDfn);
			
			$this->updateTableFl($lcUNm,'ersatzid',$lcUsrName);
			$this->updateTableFl($lcUNm,'ersatzId',$userName);
			$this->updateTableFl($lcUNm,'ersatzCpw',$passOne);
			$this->updateTableFl($lcUNm,'ersatzXRights','[cXRights chgRights="ok" techAccess="ko" ulnAccess="ko" wysiwygOn="ok" erroreportmax="ko" /]');
		}
				
		/** --------------------------------------------------------------------------------------------------------------
			Preparation and Adaptation of cstGeneralNect.php & cstDtbNect.php
			Rem : initially the 2 files should not be there, but early at building time they are necesseary for testing
			and removed later manually, so better be sure!
		*/
		$dstDtbNctDfn= $phpDtbNectPathg.'cstDtbNect.php';
		$fls->secUnlink($dstDtbNctDfn);
		$fls->copyFile(_c_virgDtbNectDfn,$dstDtbNctDfn);


		$dstGenNctDfn= $phpDtbNectPathg.'cstGeneralNect.php';
		
		$genNectStr= $fls->fileToStr(_c_virgGenNectDfn);

		$lrgInt= $this->corePhpGotLrgeInt();
		
		$siteLevel= $this->postVal('siteLevel');
		switch ($siteLevel){
			case 'subDomain':
				$domCombi= $subDD.$domName;
			break;
			
			case 'subDir':
				$domCombi= $domName.'/'.$subDD;
			break;
			
			case 'topLevel':
			default:;
				$domCombi= $domName;
			break;
		}
		
		/*
			Adds the generuc protocol (also works for https:// + don't ned)
				- Could add a button to ask if we have a real https but ost people would get it wrong and accuse the system :-)
				- Could duplicate the link --> similar problem as above
			Solution : for now, cautious people knowing what they are doing wil add the S by hand.
		*/
		$domCombi= 'http://'.$domCombi;
		$lastCharPos= strlen($domCombi)-1;
		
		$sSuffx= '/';
		if ($domCombi[$lastCharPos]==='/'){
			$sSuffx= '';	// to avoid a double end slash if given in the output
		}
		
		$domCombi.= $sSuffx;
		
		$searchV= array('forceToChgLargeInt', 'extToChgStampleSite', 'myDomainToChgName', 'domErztUrlAcc');
		$replaceV= array($lrgInt, $domName, './', $domCombi);
		$genNectStr= str_replace($searchV,$replaceV,$genNectStr);
		
		$fls->secUnlink($dstGenNctDfn);
		$fls->strToFile($dstGenNctDfn,$genNectStr);


		/* Send an email to access the freshly unzipped 100%-php-CMS
				Do not use the just unzipped code, becauise have constant conflict dependant of recent modificatons +
				would have to check that all the time!
		*/
		$mailSubject= $glot->sl('Access CMS installer','kaat');
		
		$mailBody= '';
		$mailBody.= '';
		
		$mailBody.= $caps->span($glot->sl('Welcome on the main installer','kaas'),'mailTtl');
		$mailBody.= _c_;
		
		if ($gotMstrFlag){
			include $phpGenVarDfn.'pwBoxRequest.php';
			$pwBoxRequest= $r['str'];
		
			include $phpGenVarDfn.'pwRequestVal.php';
			$pwRequestVal= $r['str'];
		
			include $phpGenVarDfn.'forcedAccessUsrId.php';
			$lcUsrName= $r['str'];
		}else{
			$pwBoxRequest= $fls->safIdStr($this->postVal('pwBoxRequest'));
			$pwRequestVal= $fls->safIdStr($this->postVal('pwRequestVal'));
		}
	
		$pwBoxRequest= _c_pwBoxReqInformPfx.$pwBoxRequest;
		$pwRequestVal= $pwRequestVal;
		$localBaseUrl= $givenIndex;
		$localUrl= $localBaseUrl.'?'.$pwBoxRequest.'='.$pwRequestVal.'&userId='.$lcUsrName.'&edtLang='.$glot->getCurrentLg().'&surfEdt=surf';
		
		$phpSelf= $_SERVER['PHP_SELF'];		// print('$phpSelf='.$phpSelf._c_);
		$fls->splitOnLastC($phpSelf,$subDirPath,$right)	;	
		if ($subDirPath!=='' && $subDirPath!==false &&  $subDirPath[0]==='/'){
			$subDirPath= substr($subDirPath,1);
		}else{
			$subDirPath= '';
		}
		
		$totUrl= $domCombi.$localUrl;	// Need to be at root level to work
		$this->activeTotUrl= $totUrl;	// activeTotUrl
		$this->globDomCombi= $domCombi;
		
		
		
		$cssMailLn= $caps->matCss('mailLink');
		$mailBody.= $caps->hLink($totUrl,$totUrl,$cssMailLn);
		
		$mailBody.= _c_;
		$mailBody.= _c_;
		$mailBody.= $caps->span($glot->sl('This is the future access to your new website login form...','kabk'),'mailTtl');
		$mailBody.= _c_;
		$totUrl= str_replace($givenIndex,'index.php',$totUrl);
		$mailBody.= $caps->hLink($totUrl,$totUrl,$cssMailLn);
	
		$surfUrl= $domCombi.$localBaseUrl;	// Need to be at root level to work

		$mailBody.= _c_;
		$mailBody.= _c_;
		$mailBody.= $caps->span($glot->sl('This is the future direct access to your new website...','kabl'),'mailTtl');
		$mailBody.= _c_;
		$surfUrl= str_replace($givenIndex,'index.php',$surfUrl);

		$mailBody.= $caps->hLink($surfUrl,$surfUrl,$cssMailLn);
		
		$titleFrom= $mailSubject;
		$emailFrom= 'noReplay@ataox.org';	// can't set it to $emailTo (the only user given address) because major smtp service realized they did not send it and treat it like fraud !!!
		
		$this->sendEMail($emailTo,$mailSubject,$mailBody, $titleFrom,$emailFrom);
		return true;
	} // personInstaller
	

	/**
		Deal with the unzipping action and the whoke form.
		Input :
			The form data
		Output :
			$successCurrentStep : true if the actions where successful, especially a correclty filled form for the installation
			Return an informative message.
	*/
	function zipDealer(&$successCurrentStep){
		$glot= &$this->glot;
		$caps= &$this->caps;
		$fls= &$this->fls;
		
		$successCurrentStep= false;
		$action= $this->postVal('mainAction');
		switch ($action){
			case 'fUnzipChgPw':
				$widgtMess= $this->widgtComoatibility();
				if ($widgtMess===''){
					// Unzip all files present in the current directory _c_flTchHomeSlsh
					if ( $fls->unzipFullDir(_c_flTchHomeSlsh,_c_flTchHomeSlsh) ){
						$successCurrentStep= $this->personInstaller();
						if ( $successCurrentStep ){	// we got a file to show a link to
							$url= $this->activeTotUrl;
							$content= $glot->sl('Congratulations, thank you to click here to install ...','kaax');
							$cls= 'zipLnTitle';
							$clickHere= $caps->hL($url,$content,$cls,'_blank');
							$fls->addMess($clickHere._c_._c_);
						}
					}else{
						$successCurrentStep= true;
						$fls->addMess($glot->sl('Unzipping was done, but Ataox files haven\'t been recognised!','kaay')._c_._c_);
					}
				}else{
					return $widgtMess;
				}
			break;
			
			case 'fDisplay':
				return $fls->currentDirDsplStr(_c_flTchHomeSlsh);
			break;
			
			default:
				return 'zipDealer::NoAction';
		} // switch
	} // zipDealer	
	

	/**
		Update a single 100% php Dtb file record.
	*/
	function updatePhpFlRecord($dfn, $search,$replace){
		$fls= &$this->fls;
		$subject= $fls->fileToStr($dfn);
		$subject= str_replace($search,$replace,$subject);
		$fls->strToFile($dfn,$subject);
	} // updatePhpFlRecord

	/**
		Update table & file : the table is specified by $this->globCurrentTblPath and 
		the record or file in this case by $fn.
	*/
	function updateTableFl($fn, $search,$replace){
		$fls= &$this->fls;
		$dfn= $this->globCurrentTblPath.$fn;
		$this->updatePhpFlRecord($dfn, $search,$replace);
	} // updateTableFl


	/**
		Test the widget compatibility with the expected standard strings.
	*/
	function widgtComoatibility(){
		$glot= &$this->glot;
		$caps= &$this->caps;
		$fls= &$this->fls;
	
		$gotMstrFlag= $this->gotMasterFlag;
		
		$errorStr= '';
		if (!$gotMstrFlag){
			$userName= $this->postVal('userName');
			if ($userName===false){
				return $glot->sl('No Actions','kabj');	// the form was not sent, so got no errors !!
			}
			
			$userNmSafe= $fls->safIdStr($userName);
			
			if (strlen($userNmSafe)<2){
				$errorStr.= $glot->sl('The user name need at least 2 characters ... : ','kaam').$userNmSafe._c_;
			}
		
			$passOne= $this->postVal('passOne');
			$passTwo= $this->postVal('passTwo');
			if (strlen($passOne)<6){
				$errorStr.= $glot->sl('The password need at least 6 characters!','kaan')._c_;
			}
			
			if ($passOne!==$passTwo){
				$errorStr.= $glot->sl('The 2 given paswords are not equal!','kaao')._c_;
			}else{
				/*
					Compatibility browser-server is not reasonably testable here because the given password
					is encrypted by itself and we have no way to decipher it to try a php encryption.
				*/
			}
			
			$pwBoxRequest= _c_pwBoxReqInformPfx.$fls->safIdStr($this->postVal('pwBoxRequest'));
			$pwRequestVal= $fls->safIdStr($this->postVal('pwRequestVal'));
					
			if (strlen($pwRequestVal)<1){
				$errorStr.= $glot->sl('The url login value need at least 1 character!','kaaq')._c_;
			}
			
			$userName= $fls->safIdStr($this->postVal('userName'));
			$lcUsrName= strtolower($userName);
			
			if ($lcUsrName===_c_guestUserId || $lcUsrName==='identification' || $lcUsrName==='ersatzid' || $lcUsrName==='idMark'){
				$errorStr.= $glot->sl('The user name can\'t...','kabs').$lcUsrName._c_;
			}
		}
	
		$eMail= $this->postVal('accessEMail');
		if (!$fls->isValidEmail($eMail)){
			$errorStr.= $glot->sl('The EMail is not valid!!','kaar')._c_;
		}
		
		if ($errorStr===''){
			return '';
		}else{
			return $caps->span($errorStr,'zipError');
		}
	} // widgtComoatibility
		

	/**
	*/
	function addFirstUrlVar($var,$val){
		return _c_Interog.$var.'='.$val;
	} // addFirstUrlVar
	
	
	/**
		.zipLgFlagsIn, .zipLgFlagsOut
	*/
	function lgFlags(){
		$caps= &$this->caps;
	
		$curLg= $this->getCurrentLg();
		
		$url= './'._c_mainIdxName;
		
		$buff= '';
		
		$logo= $caps->img(_c_CodePath.'ataox.png','Ataox','slImg');
		$sup= $caps->matCss('ataoxTitle');
		$sup.= $caps->matTtl('Ataox.org');
		$buff.= $caps->hLink('http://www.ataox.org',$logo.'Ataox.org Unzipper',$sup);
		
		
		
		$curFont= $this->lgFont($curLg,'en');
		$buff.= $caps->hL($url.$this->addFirstUrlVar(_c_lgUrlVar,'en'),'English',$curFont);
		
		$curFont= $this->lgFont($curLg,'fr');
		$buff.= $caps->hL($url.$this->addFirstUrlVar(_c_lgUrlVar,'fr'),'Français',$curFont);
		return $buff;
	} // lgFlags
	
	
	/**
		Chhoses the correct language font.
	*/
	function lgFont($curLg,$statLg){
		if ($curLg===$statLg){
			return 'zipLgFlagsIn';
		}else{
			return 'zipLgFlagsOut';
		}
	} // lgFont
	
	
	/**
	*/
	function getCurrentLg(){
		$glot= &$this->glot;
		return $glot->getCurrentLg();
	} // getCurrentLg

	
	/**
	*/
	function isSSL(){
		if (array_key_exists('HTTPS',$_SERVER)){
			return !empty($_SERVER['HTTPS']) || $_SERVER['HTTPS']!=='off';
		}else{
			return false;
		}
	} // isSSL
	
	
	function jsPhpCryptCompatible($wdgtId,$clickMe,$congratStr,$sorryStr,$infoStr,$keyStr){
		$glot= &$this->glot;
		$caps= &$this->caps;
		$crypt= &$this->mbCrpt;
		$buff= '';
		$buff.= _c_;
		$phpHxCrypt= $crypt->mbCrpt($infoStr,$keyStr);
		$js= $caps->jsFunctCallStr('onclick','mbCrypt.jsPhpCryptCompatible',6,0, $wdgtId,$congratStr,$sorryStr,$infoStr,$keyStr,$phpHxCrypt);
		$buff.= $caps->span($clickMe,'testCompatibility','',$wdgtId,'',$js);
		return $buff;
	} // jsPhpCryptCompatible
		
} // unzipMain
?>
